// WARNING: this file is autogenerated. Modify sources if changes required here.

#ifdef CM_GET_RESOURCE_STORAGE
static const char ResourceStorage[][1024] = {
"/*========================== begin_copyright_notice ============================\012\012Copyright (C) 2014-2021 Intel Corporation\012\012SPDX-License-Identifier: MIT\012\012============================= end_copyright_notice ===========================*/\012\012#if (__INCLUDE_LEVEL__ == 1)\012static_assert(0, \"CM:w:cm_atomic.h should not be included explicitly - only \"\012                 \"<cm/cm.h> is required\");\012#endif\012\012#ifndef _CLANG_CM_ATOMIC_\012#define _CLANG_CM_ATOMIC_\012\012#include \"cm_common.h\"\012#include \"cm_internal.h\"\012#include \"cm_traits.h\"\012#include \"cm_util.h\"\012\012namespace details {\012\012/// Checking Atomic ops with traits. By default, no error.\012template <typename T, CmAtomicOpType Op, int N> struct is_valid_atomic_op;\012\012#define _ATOMIC_CHECK(Name, Type)                                              \\\012  template <typename T, int N> struct is_valid_atomic_op<T, Name, N> {         \\\012    static void check() {                                                      \\\012      CM_STATIC_ERROR(                                                         \\\012   ",
"       (std::is_same<Type, typename std::remove_const<T>::type>::value),    \\\012          \"data type must be \" #Type \" for \" #Name);                           \\\012    }                                                                          \\\012  }                                                                            \\\012\012#define _ATOMIC_CHECK_TYPES(Name, Type1, Type2)                                \\\012  template <typename T, int N> struct is_valid_atomic_op<T, Name, N> {         \\\012    static void check() {                                                      \\\012      CM_STATIC_ERROR(                                                         \\\012          (std::is_same<Type1, typename std::remove_const<T>::type>::value ||  \\\012           std::is_same<Type2, typename std::remove_const<T>::type>::value),   \\\012          \"data type must be \" #Type1 \"or \" #Type2 \" for \" #Name);             \\\012    }                                                                          \\\012  }                                                   ",
"                         \\\012\012\012_ATOMIC_CHECK_TYPES(ATOMIC_ADD, uint, int);\012_ATOMIC_CHECK_TYPES(ATOMIC_SUB, uint, int);\012_ATOMIC_CHECK_TYPES(ATOMIC_INC, uint, int);\012_ATOMIC_CHECK_TYPES(ATOMIC_DEC, uint, int);\012_ATOMIC_CHECK_TYPES(ATOMIC_MIN, uint, int);\012_ATOMIC_CHECK_TYPES(ATOMIC_MAX, uint, int);\012_ATOMIC_CHECK_TYPES(ATOMIC_XCHG, uint, int);\012_ATOMIC_CHECK_TYPES(ATOMIC_CMPXCHG, uint, int);\012_ATOMIC_CHECK_TYPES(ATOMIC_AND, uint, int);\012_ATOMIC_CHECK_TYPES(ATOMIC_OR, uint, int);\012_ATOMIC_CHECK_TYPES(ATOMIC_XOR, uint, int);\012_ATOMIC_CHECK_TYPES(ATOMIC_MINSINT, uint, int);\012_ATOMIC_CHECK_TYPES(ATOMIC_MAXSINT, uint, int);\012_ATOMIC_CHECK(ATOMIC_FMAX, float);\012_ATOMIC_CHECK(ATOMIC_FMIN, float);\012_ATOMIC_CHECK(ATOMIC_FCMPWR, float);\012_ATOMIC_CHECK(ATOMIC_FADD, float);\012_ATOMIC_CHECK(ATOMIC_FSUB, float);\012_ATOMIC_CHECK_TYPES(ATOMIC_PREDEC, uint, int);\012\012#undef _ATOMIC_CHECK\012\012/// Do split initialization conditionally:\012///\012/// if (N2 >= 2 * N1) {\012///   v0 = v2.select<N1, 1>(0);\012///   v1 = v2.select<N1, 1>(N1);\012/// } else if (N2 > N1) {\012//",
"/   v0 = v2.select<N1, 1>(0);\012/// } else if (N2 == N1) {\012///   v0 = v2;\012/// } else {\012///   // do nothing.\012/// }\012///\012template <typename T, int N1, int N2>\012CM_NODEBUG CM_INLINE typename std::enable_if<N2 == N1, void>::type\012if_init_level0(vector_ref<T, N1> v0, vector<T, N2> v2) {\012  v0 = v2;\012}\012template <typename T, int N1, int N2>\012CM_NODEBUG CM_INLINE typename std::enable_if<N2 != N1, void>::type\012if_init_level0(vector_ref<T, N1> v0, vector<T, N2> v2) {}\012\012template <typename T, int N1, int N2>\012CM_NODEBUG CM_INLINE typename std::enable_if<(N2 > N1), void>::type\012if_init_level1(vector_ref<T, N1> v0, vector<T, N2> v2) {\012  v0 = v2.select<N1, 1>(0);\012}\012template <typename T, int N1, int N2>\012CM_NODEBUG CM_INLINE typename std::enable_if<!(N2 > N1), void>::type\012if_init_level1(vector_ref<T, N1> v0, vector<T, N2> v2) {\012  if_init_level0(v0, v2);\012}\012\012template <typename T, int N1, int N2>\012CM_NODEBUG CM_INLINE typename std::enable_if<(N2 >= 2 * N1), void>::type\012if_split_init(vector_ref<T, N1> v0, vector_ref<T, N1> v1, vector<T, N2> ",
"v2) {\012  v0 = v2.select<N1, 1>();\012  v1 = v2.select<N1, 1>(N1);\012}\012template <typename T, int N1, int N2>\012CM_NODEBUG CM_INLINE typename std::enable_if<!(N2 >= 2 * N1), void>::type\012if_split_init(vector_ref<T, N1> v0, vector_ref<T, N1> v1, vector<T, N2> v2) {\012  if_init_level1(v0, v2);\012}\012\012} // namespace details\012\012/// \\brief DWord atomic write.\012///\012/// \\param index surface index, which must correspond to a buffer.\012///\012/// \\param op the atomic operation kind. It must be a compile time constant.\012///\012/// \\param globalOffset zero based global offset to be added to \012/// the scattered addresses to the surface. This offset is in units of DWords.\012///\012/// \\param elementOffset zero based offset of each DWord (relative to the\012/// global offset) to be written. This offset is in units of DWords.\012///\012/// \\param src the source operands for the specified atomic operation.\012///   # For ATOMIC_CMPXCHG, N must be 16.\012///   # For ATOMIC_INC / ATOMIC_DEC, src is ignored.\012///   # For all other cases, N must be 8.\012\012///\012/// \\param v the data ",
"location to store the returned result, which correspond\012/// to the old surface data value.\012///\012template <typename T, int N>\012typename std::enable_if<details::is_fp_or_dword_type<T>::value, void>::type\012write(SurfaceIndex index, CmAtomicOpType op, uint globalOffset,\012      vector<uint, 8> elementOffset, vector<T, N> src, vector_ref<T, 8> ret)\012    CM_DEPRECATED(\"use 'write_atomic' instead!\");\012\012template <typename T, int N>\012typename std::enable_if<details::is_fp_or_dword_type<T>::value, void>::type\012write(SurfaceIndex index, CmAtomicOpType op, uint globalOffset,\012      vector<uint, 8> elementOffset, vector<T, N> src, const int null)\012    CM_DEPRECATED(\"use 'write_atomic' instead!\");\012\012template <typename T, int N>\012CM_NODEBUG CM_INLINE\012typename std::enable_if<details::is_fp_or_dword_type<T>::value, void>::type\012write(SurfaceIndex index, CmAtomicOpType op, uint globalOffset,\012      vector<uint, 8> elementOffset, vector<T, N> src, const int null) {\012  // Special case where we want to ignore the return value - this is indicated",
"\012  // by the return value being NULL (note we actually treat any scalar integer\012  // value as if it were NULL), and achieved by using a temp ret vector (which\012  // will be optimized away).\012  vector<T, 8> ret;\012  write(index, op, globalOffset, elementOffset, src, ret);\012}\012\012template <typename T, int N>\012CM_NODEBUG CM_INLINE\012typename std::enable_if<details::is_fp_or_dword_type<T>::value, void>::type\012write(SurfaceIndex index, CmAtomicOpType op, uint globalOffset,\012      vector<uint, 8> elementOffset, vector<T, N> src, vector_ref<T, 8> ret) {\012  vector<uint, 8> _Offset = globalOffset + elementOffset;\012  vector<T, 8> _Src0, _Src1;\012  vector<ushort, 8> mask = 1;\012\012#define _ATOMIC_WRITE(Op, Sz, Type)                                            \\\012  details::if_split_init(_Src0, _Src1, src);                                   \\\012  ret = details::__cm_intrinsic_impl_atomic_write<Op, Sz, Type>(               \\\012      mask, index, _Offset, _Src0, _Src1, ret)\012\012  switch (op) {\012  default:\012    break;\012  case ATOMIC_ADD:\012    _ATOMIC_WRITE(",
"ATOMIC_ADD, 8, uint);\012    break;\012  case ATOMIC_SUB:\012    _ATOMIC_WRITE(ATOMIC_SUB, 8, uint);\012    break;\012  case ATOMIC_INC:\012    ret = details::__cm_intrinsic_impl_atomic_write<ATOMIC_INC, 8, uint>(\012        mask, index, _Offset, _Src0, _Src1, ret);\012    break;\012  case ATOMIC_DEC:\012    ret = details::__cm_intrinsic_impl_atomic_write<ATOMIC_DEC, 8, uint>(\012        mask, index, _Offset, _Src0, _Src1, ret);\012    break;\012  case ATOMIC_PREDEC:\012    ret = details::__cm_intrinsic_impl_atomic_write<ATOMIC_DEC, 8, uint>(\012      mask, index, _Offset, _Src0, _Src1, ret) - 1;\012    break;\012  case ATOMIC_MIN:\012    _ATOMIC_WRITE(ATOMIC_MIN, 8, uint);\012    break;\012  case ATOMIC_MAX:\012    _ATOMIC_WRITE(ATOMIC_MAX, 8, uint);\012    break;\012  case ATOMIC_XCHG:\012    _ATOMIC_WRITE(ATOMIC_XCHG, 8, uint);\012    break;\012  case ATOMIC_CMPXCHG:\012    _ATOMIC_WRITE(ATOMIC_CMPXCHG, 8, uint);\012    break;\012  case ATOMIC_AND:\012    _ATOMIC_WRITE(ATOMIC_AND, 8, uint);\012    break;\012  case ATOMIC_OR:\012    _ATOMIC_WRITE(ATOMIC_OR, 8, uint);\012    break;\012  case ATOMIC_XOR:\012    _AT",
"OMIC_WRITE(ATOMIC_XOR, 8, uint);\012    break;\012  case ATOMIC_MINSINT:\012    _ATOMIC_WRITE(ATOMIC_MINSINT, 8, int);\012    break;\012  case ATOMIC_MAXSINT:\012    _ATOMIC_WRITE(ATOMIC_MAXSINT, 8, int);\012    break;\012  case ATOMIC_FMAX:\012    _ATOMIC_WRITE(ATOMIC_FMAX, 8, float);\012    break;\012  case ATOMIC_FMIN:\012    _ATOMIC_WRITE(ATOMIC_FMIN, 8, float);\012    break;\012  case ATOMIC_FCMPWR:\012    _ATOMIC_WRITE(ATOMIC_FCMPWR, 8, float);\012    break;\012  case ATOMIC_FADD:\012    _ATOMIC_WRITE(ATOMIC_FADD, 8, float);\012    break;\012  case ATOMIC_FSUB:\012    _ATOMIC_WRITE(ATOMIC_FSUB, 8, float);\012    break;\012  }\012\012#undef _ATOMIC_WRITE\012}\012\012/// \\brief DWord atomic write.\012///\012/// \\param op the atomic operation kind.\012///\012/// \\param index surface index, which must correspond to a buffer.\012///\012/// \\param elementOffset zero based offset of each DWord to be written. This\012/// offset is in units of DWords.\012///\012/// \\param src0 the first source operand for the specified atomic operation.\012///\012/// \\param src1 the second source operand for the specified atomic operation.\012///",
"\012/// \\param ret the data location to store the returned result, which corresponds\012/// to the old surface data value.\012///\012\012// has return value, one source\012template <CmAtomicOpType Op, typename T, int N>\012CM_NODEBUG CM_INLINE\012typename std::enable_if<\012    (Op != ATOMIC_CMPXCHG && Op!= ATOMIC_FCMPWR &&\012     Op != ATOMIC_INC && Op != ATOMIC_DEC && Op != ATOMIC_PREDEC) &&\012                              details::isPowerOf2(N, 32), void>::type\012write_atomic(SurfaceIndex index, vector<uint, N> elementOffset,\012             vector<T, N> src0, vector_ref<T, N> ret) {\012  // Perform remaining element type checking\012  details::is_valid_atomic_op<T, Op, N>::check();\012  vector<ushort, N> mask = 1;\012  vector<T, N> dummy;\012  vector_ref<uint, N> _Ret = ret.format<uint>();\012  _Ret = details::__cm_intrinsic_impl_atomic_write<Op, N, T>(\012      mask, index, elementOffset, src0, dummy, ret);\012}\012\012// mask, has return value, one source\012template <CmAtomicOpType Op, typename T, int N>\012CM_NODEBUG CM_INLINE\012typename std::enable_if<\012    (Op != ATOMIC_CM",
"PXCHG && Op!= ATOMIC_FCMPWR &&\012     Op != ATOMIC_INC && Op != ATOMIC_DEC && Op != ATOMIC_PREDEC) &&\012                              details::isPowerOf2(N, 32), void>::type\012write_atomic(vector<ushort, N> mask, SurfaceIndex index,\012             vector<uint, N> elementOffset, vector<T, N> src0,\012             vector_ref<T, N> ret) {\012  // Perform remaining element type checking\012  details::is_valid_atomic_op<T, Op, N>::check();\012  vector<T, N> dummy;\012  vector_ref<uint, N> _Ret = ret.format<uint>();\012  _Ret = details::__cm_intrinsic_impl_atomic_write<Op, N, T>(\012      mask, index, elementOffset, src0, dummy, ret);\012}\012\012// no return value, one source\012template <CmAtomicOpType Op, typename T, int N>\012CM_NODEBUG CM_INLINE\012typename std::enable_if<\012    (Op != ATOMIC_CMPXCHG && Op!= ATOMIC_FCMPWR &&\012     Op != ATOMIC_INC && Op != ATOMIC_DEC && Op != ATOMIC_PREDEC) &&\012                              details::isPowerOf2(N, 32), void>::type\012write_atomic(SurfaceIndex index, vector<uint, N> elementOffset,\012             vector<T, N> src0) {\012",
"  vector<T, N> dummy;\012  details::is_valid_atomic_op<T, Op, N>::check();\012  vector<ushort, N> mask = 1;\012  details::__cm_intrinsic_impl_atomic_write<Op, N, T>(\012      mask, index, elementOffset, src0, dummy, dummy);\012}\012\012// mask, no return value, one source\012template <CmAtomicOpType Op, typename T, int N>\012CM_NODEBUG CM_INLINE\012typename std::enable_if<\012    (Op != ATOMIC_CMPXCHG && Op!= ATOMIC_FCMPWR &&\012     Op != ATOMIC_INC && Op != ATOMIC_DEC && Op != ATOMIC_PREDEC) &&\012                              details::isPowerOf2(N, 32), void>::type\012write_atomic(vector<ushort, N> mask, SurfaceIndex index,\012             vector<uint, N> elementOffset, vector<T, N> src0) {\012  vector<T, N> dummy;\012  details::is_valid_atomic_op<T, Op, N>::check();\012  details::__cm_intrinsic_impl_atomic_write<Op, N, T>(\012      mask, index, elementOffset, src0, dummy, dummy);\012}\012\012// INC/DEC: return value\012template <CmAtomicOpType Op, typename T, int N>\012CM_NODEBUG CM_INLINE\012typename std::enable_if<(Op == ATOMIC_INC || Op == ATOMIC_DEC) &&\012                     ",
"       (details::is_dword_type<T>::value) &&\012                            details::isPowerOf2(N, 32), void>::type\012write_atomic(SurfaceIndex index, vector<uint, N> elementOffset,\012             vector_ref<T, N> ret) {\012  vector<uint, N> dummy;\012  vector_ref<uint, N> _Ret = ret.format<uint>();\012  vector<ushort, N> mask = 1;\012  _Ret = details::__cm_intrinsic_impl_atomic_write<Op, N, uint>(\012      mask, index, elementOffset, dummy, dummy, _Ret);\012}\012\012// PREDEC: return value\012template <CmAtomicOpType Op, typename T, int N>\012CM_NODEBUG CM_INLINE\012typename std::enable_if<(Op == ATOMIC_PREDEC) &&\012(details::is_dword_type<T>::value) &&\012details::isPowerOf2(N, 16), void>::type\012write_atomic(SurfaceIndex index, vector<uint, N> elementOffset,\012  vector_ref<T, N> ret) {\012  vector<uint, N> dummy;\012  vector_ref<uint, N> _Ret = ret.format<uint>();\012  vector<ushort, N> mask = 1;\012  _Ret = details::__cm_intrinsic_impl_atomic_write<ATOMIC_DEC, N, uint>(\012    mask, index, elementOffset, dummy, dummy, _Ret) - 1;\012}\012\012// INC/DEC: mask and return value\012te",
"mplate <CmAtomicOpType Op, typename T, int N>\012CM_NODEBUG CM_INLINE\012typename std::enable_if<(Op == ATOMIC_INC || Op == ATOMIC_DEC) &&\012                            (details::is_dword_type<T>::value) &&\012                            details::isPowerOf2(N, 32), void>::type\012write_atomic(vector<ushort, N> mask, SurfaceIndex index,\012             vector<uint, N> elementOffset, vector_ref<T, N> ret) {\012  vector<uint, N> dummy;\012  vector_ref<uint, N> _Ret = ret.format<uint>();\012  _Ret = details::__cm_intrinsic_impl_atomic_write<Op, N, uint>(\012      mask, index, elementOffset, dummy, dummy, _Ret);\012}\012\012// PREDEC: mask and return value\012template <CmAtomicOpType Op, typename T, int N>\012CM_NODEBUG CM_INLINE\012typename std::enable_if<(Op == ATOMIC_PREDEC) &&\012(details::is_dword_type<T>::value) &&\012details::isPowerOf2(N, 32), void>::type\012write_atomic(vector<ushort, N> mask, SurfaceIndex index,\012  vector<uint, N> elementOffset, vector_ref<T, N> ret) {\012  vector<uint, N> dummy;\012  vector_ref<uint, N> _Ret = ret.format<uint>();\012  _Ret = details::",
"__cm_intrinsic_impl_atomic_write<ATOMIC_DEC, N, uint>(\012    mask, index, elementOffset, dummy, dummy, _Ret) - 1;\012}\012\012// INC/DEC: no return value\012template <CmAtomicOpType Op, typename T, int N>\012CM_NODEBUG CM_INLINE\012typename std::enable_if<(Op == ATOMIC_INC || Op == ATOMIC_DEC) &&\012                            (details::is_dword_type<T>::value) &&\012                            details::isPowerOf2(N, 32), void>::type\012write_atomic(SurfaceIndex index, vector<uint, N> elementOffset) {\012  vector<T, N> dummy;\012  details::is_valid_atomic_op<T, Op, N>::check();\012  vector<ushort, N> mask = 1;\012  details::__cm_intrinsic_impl_atomic_write<Op, N, T>(\012      mask, index, elementOffset, dummy, dummy, dummy);\012}\012\012// PREDEC: no return value\012template <CmAtomicOpType Op, typename T, int N>\012CM_NODEBUG CM_INLINE\012typename std::enable_if<(Op == ATOMIC_PREDEC) &&\012(details::is_dword_type<T>::value) &&\012details::isPowerOf2(N, 16), void>::type\012write_atomic(SurfaceIndex index, vector<uint, N> elementOffset) {\012  vector<T, N> dummy;\012  details::is_valid",
"_atomic_op<T, Op, N>::check();\012  vector<ushort, N> mask = 1;\012  details::__cm_intrinsic_impl_atomic_write<ATOMIC_DEC, N, T>(\012    mask, index, elementOffset, dummy, dummy, dummy);\012}\012\012// INC/DEC: mask and no return value\012template <CmAtomicOpType Op, typename T, int N>\012CM_NODEBUG CM_INLINE\012typename std::enable_if<(Op == ATOMIC_INC || Op == ATOMIC_DEC) &&\012                            (details::is_dword_type<T>::value) &&\012                            details::isPowerOf2(N, 32),\012                        void>::type\012write_atomic(vector<ushort, N> mask, SurfaceIndex index,\012             vector<uint, N> elementOffset) {\012  vector<T, N> dummy;\012  details::is_valid_atomic_op<T, Op, N>::check();\012  details::__cm_intrinsic_impl_atomic_write<Op, N, T>(\012      mask, index, elementOffset, dummy, dummy, dummy);\012}\012\012// PREDEC: mask and no return value\012template <CmAtomicOpType Op, typename T, int N>\012CM_NODEBUG CM_INLINE\012typename std::enable_if<(Op == ATOMIC_PREDEC) &&\012(details::is_dword_type<T>::value) &&\012details::isPowerOf2(N, 16),\012void",
">::type\012write_atomic(vector<ushort, N> mask, SurfaceIndex index,\012  vector<uint, N> elementOffset) {\012  vector<T, N> dummy;\012  details::is_valid_atomic_op<T, Op, N>::check();\012  details::__cm_intrinsic_impl_atomic_write<ATOMIC_DEC, N, T>(\012    mask, index, elementOffset, dummy, dummy, dummy);\012}\012\012// CMPXCHG: return value\012template <CmAtomicOpType Op, typename T, int N>\012CM_NODEBUG CM_INLINE\012typename std::enable_if<\012    (Op == ATOMIC_CMPXCHG || Op == ATOMIC_FCMPWR) &&\012               (details::is_fp_or_dword_type<T>::value) &&\012                details::isPowerOf2(N, 32), void>::type\012write_atomic(SurfaceIndex index, vector<uint, N> elementOffset,\012             vector<T, N> src0, vector<T, N> src1, vector_ref<T, N> ret) {\012  vector_ref<T, N> _Ret = ret.format<T>();\012  vector<ushort, N> mask = 1;\012  _Ret = details::__cm_intrinsic_impl_atomic_write<Op, N, T>(\012      mask, index, elementOffset, src0, src1, _Ret);\012}\012\012// CMPXCHG: mask and return value\012template <CmAtomicOpType Op, typename T, int N>\012CM_NODEBUG CM_INLINE\012typename std",
"::enable_if<\012    (Op == ATOMIC_CMPXCHG || Op == ATOMIC_FCMPWR) &&\012               (details::is_fp_or_dword_type<T>::value) &&\012                details::isPowerOf2(N, 32), void>::type\012write_atomic(vector<ushort, N> mask, SurfaceIndex index,\012             vector<uint, N> elementOffset, vector<T, N> src0,\012             vector<T, N> src1, vector_ref<T, N> ret) {\012  vector_ref<T, N> _Ret = ret.format<uint>();\012  _Ret = details::__cm_intrinsic_impl_atomic_write<Op, N, T>(\012      mask, index, elementOffset, src0, src1, _Ret);\012}\012\012// CMPXCHG: no return value\012template <CmAtomicOpType Op, typename T, int N>\012CM_NODEBUG CM_INLINE\012typename std::enable_if<\012    (Op == ATOMIC_CMPXCHG || Op == ATOMIC_FCMPWR) &&\012               (details::is_fp_or_dword_type<T>::value) &&\012                details::isPowerOf2(N, 32), void>::type\012write_atomic(SurfaceIndex index, vector<uint, N> elementOffset,\012             vector<T, N> src0, vector<T, N> src1) {\012  vector<T, N> dummy;\012  write_atomic<Op, T>(index, elementOffset, src0, src1, dummy);\012}\012\012// CMPX",
"CHG: mask and no return value\012template <CmAtomicOpType Op, typename T, int N>\012CM_NODEBUG CM_INLINE\012typename std::enable_if<\012    (Op == ATOMIC_CMPXCHG || Op == ATOMIC_FCMPWR) &&\012               (details::is_fp_or_dword_type<T>::value) &&\012                details::isPowerOf2(N, 32), void>::type\012write_atomic(vector<ushort, N> mask, SurfaceIndex index,\012             vector<uint, N> elementOffset, vector<T, N> src0,\012             vector<T, N> src1) {\012  vector<T, N> dummy;\012  write_atomic<Op, T>(mask, index, elementOffset, src0, src1, dummy);\012}\012\012/// \\brief Typed atomic write\012///\012/// \\param Op template parameter Op determines the atomic operation to be\012/// performed\012///\012/// \\param mask (optional) predicate to specify on which channels to be performed.\012///\012/// \\param surfIndex surface index, which must correspond to a 1D, 2D or 3D\012/// surface.\012///\012/// \\param ret vector containing the values in memory before the atomic\012/// operation\012/// was performed\012///\012/// \\param u the x coordinates of the data elements to be read from s",
"urface,\012/// which must be in unit of pixels. The size N must be 8, 16, or 32. however,\012/// 16 and 32 may not be supported natively.   \012///\012/// \\param v (optional, default = 0) the y coordinates of the data elements to\012/// be read from non-1D surface types; ignored otherwise.\012///\012/// \\param r (optional, default = 0) the z coordinates of the data elements to\012/// be read from 3D surface types; ignored otherwise.\012///\012/// The compiler generates code for GenX hardware to perform scattered aomic\012/// write to the given offsets. Out-of-bound reads return zero, while\012/// out-of-bound writes are dropped.\012///\012\012#if defined(CM_GEN7_5) || defined(CM_GEN8) || defined(CM_GEN8_5)\012// Define a function to produce and error on unsupported architectures\012// If no CM_GENn is defined (and possibly only CM_GENX) then the function will\012// just appear to be unimplemented.\012#define write_typed_atomic(...)                                                \\\012  CM_STATIC_ERROR(0, \"write_typed_atomic is only supported for SKL+. Ensure \"  \\\012     ",
"                \"compile flags reflect this.\");\012\012#else\012\012// Typed atomic {u}.\012template <CmAtomicOpType Op, typename T, int N>\012CM_NODEBUG CM_INLINE\012typename std::enable_if<(Op == ATOMIC_INC || Op == ATOMIC_DEC) &&\012                            details::isPowerOf2(N, 32) &&\012                            details::is_dword_type<T>::value,\012                        void>::type\012write_typed_atomic(SurfaceIndex surfIndex, vector_ref<T, N> ret,\012                   vector<uint, N> u) {\012  vector<T, N> dummy;\012  vector<ushort, N> mask = 1;\012  ret = details::__cm_intrinsic_impl_atomic_write_typed<Op>(\012      mask, surfIndex, dummy.select_all(), dummy.select_all(), u);\012}\012\012template <CmAtomicOpType Op, typename T, int N>\012CM_NODEBUG CM_INLINE\012typename std::enable_if<(Op == ATOMIC_PREDEC) &&\012  details::isPowerOf2(N, 32) &&\012  details::is_dword_type<T>::value,\012  void>::type\012  write_typed_atomic(SurfaceIndex surfIndex, vector_ref<T, N> ret,\012    vector<uint, N> u) {\012  vector<T, N> dummy;\012  vector<ushort, N> mask = 1;\012  ret = details::__cm_in",
"trinsic_impl_atomic_write_typed<ATOMIC_DEC>(\012    mask, surfIndex, dummy.select_all(), dummy.select_all(), u) - 1;\012}\012\012\012// Predicated typed atomic {u}.\012template <CmAtomicOpType Op, typename T, int N>\012CM_NODEBUG CM_INLINE\012typename std::enable_if<(Op == ATOMIC_INC || Op == ATOMIC_DEC) &&\012                            details::isPowerOf2(N, 32) &&\012                            details::is_dword_type<T>::value,\012                        void>::type\012write_typed_atomic(vector<ushort, N> mask, SurfaceIndex surfIndex,\012                   vector_ref<T, N> ret, vector<uint, N> u) {\012  vector<T, N> dummy;\012  ret = details::__cm_intrinsic_impl_atomic_write_typed<Op>(\012      mask, surfIndex, dummy.select_all(), dummy.select_all(), u);\012}\012\012template <CmAtomicOpType Op, typename T, int N>\012CM_NODEBUG CM_INLINE\012typename std::enable_if<(Op == ATOMIC_PREDEC) &&\012  details::isPowerOf2(N, 32) &&\012  details::is_dword_type<T>::value,\012  void>::type\012  write_typed_atomic(vector<ushort, N> mask, SurfaceIndex surfIndex,\012    vector_ref<T, N> ret, vector",
"<uint, N> u) {\012  vector<T, N> dummy;\012  ret = details::__cm_intrinsic_impl_atomic_write_typed<ATOMIC_DEC>(\012    mask, surfIndex, dummy.select_all(), dummy.select_all(), u) - 1;\012}\012\012// Typed atomic {u, v}.\012template <CmAtomicOpType Op, typename T, int N>\012CM_NODEBUG CM_INLINE\012typename std::enable_if<(Op == ATOMIC_INC || Op == ATOMIC_DEC) &&\012                            details::isPowerOf2(N, 32) &&\012                            details::is_dword_type<T>::value,\012                        void>::type\012write_typed_atomic(SurfaceIndex surfIndex, vector_ref<T, N> ret,\012                   vector<uint, N> u, vector<uint, N> v) {\012  vector<T, N> dummy;\012  vector<ushort, N> mask = 1;\012  ret = details::__cm_intrinsic_impl_atomic_write_typed<Op>(\012      mask, surfIndex, dummy.select_all(), dummy.select_all(), u, v);\012}\012\012template <CmAtomicOpType Op, typename T, int N>\012CM_NODEBUG CM_INLINE\012typename std::enable_if<(Op == ATOMIC_PREDEC) &&\012  details::isPowerOf2(N, 32) &&\012  details::is_dword_type<T>::value,\012  void>::type\012  write_typed_atomic(",
"SurfaceIndex surfIndex, vector_ref<T, N> ret,\012    vector<uint, N> u, vector<uint, N> v) {\012  vector<T, N> dummy;\012  vector<ushort, N> mask = 1;\012  ret = details::__cm_intrinsic_impl_atomic_write_typed<ATOMIC_DEC>(\012    mask, surfIndex, dummy.select_all(), dummy.select_all(), u, v) - 1;\012}\012\012// Predicated typed atomic {u, v}.\012template <CmAtomicOpType Op, typename T, int N>\012CM_NODEBUG CM_INLINE\012typename std::enable_if<(Op == ATOMIC_INC || Op == ATOMIC_DEC) &&\012                            details::isPowerOf2(N, 32) &&\012                            details::is_dword_type<T>::value,\012                        void>::type\012write_typed_atomic(vector<ushort, N> mask, SurfaceIndex surfIndex,\012                   vector_ref<T, N> ret, vector<uint, N> u, vector<uint, N> v) {\012  vector<T, N> dummy;\012  ret = details::__cm_intrinsic_impl_atomic_write_typed<Op>(\012      mask, surfIndex, dummy.select_all(), dummy.select_all(), u, v);\012}\012\012template <CmAtomicOpType Op, typename T, int N>\012CM_NODEBUG CM_INLINE\012typename std::enable_if<(Op == ATOMIC_P",
"REDEC) &&\012  details::isPowerOf2(N, 32) &&\012  details::is_dword_type<T>::value,\012  void>::type\012  write_typed_atomic(vector<ushort, N> mask, SurfaceIndex surfIndex,\012    vector_ref<T, N> ret, vector<uint, N> u, vector<uint, N> v) {\012  vector<T, N> dummy;\012  ret = details::__cm_intrinsic_impl_atomic_write_typed<ATOMIC_DEC>(\012    mask, surfIndex, dummy.select_all(), dummy.select_all(), u, v) - 1;\012}\012\012// Typed atomic {u, v, r}.\012template <CmAtomicOpType Op, typename T, int N>\012CM_NODEBUG CM_INLINE\012typename std::enable_if<(Op == ATOMIC_INC || Op == ATOMIC_DEC) &&\012                            details::isPowerOf2(N, 32) &&\012                            details::is_dword_type<T>::value,\012                        void>::type\012write_typed_atomic(SurfaceIndex surfIndex, vector_ref<T, N> ret,\012                   vector<uint, N> u, vector<uint, N> v, vector<uint, N> r) {\012  vector<T, N> dummy;\012  vector<ushort, N> mask = 1;\012  ret = details::__cm_intrinsic_impl_atomic_write_typed<Op>(\012      mask, surfIndex, dummy.select_all(), dummy.select_a",
"ll(), u, v, r);\012}\012\012template <CmAtomicOpType Op, typename T, int N>\012CM_NODEBUG CM_INLINE\012typename std::enable_if<(Op == ATOMIC_PREDEC) &&\012  details::isPowerOf2(N, 32) &&\012  details::is_dword_type<T>::value,\012  void>::type\012  write_typed_atomic(SurfaceIndex surfIndex, vector_ref<T, N> ret,\012    vector<uint, N> u, vector<uint, N> v, vector<uint, N> r) {\012  vector<T, N> dummy;\012  vector<ushort, N> mask = 1;\012  ret = details::__cm_intrinsic_impl_atomic_write_typed<ATOMIC_DEC>(\012    mask, surfIndex, dummy.select_all(), dummy.select_all(), u, v, r) - 1;\012}\012\012// Predicated typed atomic {u, v, r}.\012template <CmAtomicOpType Op, typename T, int N>\012CM_NODEBUG CM_INLINE\012typename std::enable_if<(Op == ATOMIC_INC || Op == ATOMIC_DEC) &&\012                            details::isPowerOf2(N, 32) &&\012                            details::is_dword_type<T>::value,\012                        void>::type\012write_typed_atomic(vector<ushort, N> mask, SurfaceIndex surfIndex,\012                   vector_ref<T, N> ret, vector<uint, N> u, vector<uint, N> v,\012 ",
"                  vector<uint, N> r) {\012  vector<T, N> dummy;\012  ret = details::__cm_intrinsic_impl_atomic_write_typed<Op>(\012      mask, surfIndex, dummy.select_all(), dummy.select_all(), u, v, r);\012}\012\012template <CmAtomicOpType Op, typename T, int N>\012CM_NODEBUG CM_INLINE\012typename std::enable_if<(Op == ATOMIC_PREDEC) &&\012  details::isPowerOf2(N, 32) &&\012  details::is_dword_type<T>::value,\012  void>::type\012  write_typed_atomic(vector<ushort, N> mask, SurfaceIndex surfIndex,\012    vector_ref<T, N> ret, vector<uint, N> u, vector<uint, N> v,\012    vector<uint, N> r) {\012  vector<T, N> dummy;\012  ret = details::__cm_intrinsic_impl_atomic_write_typed<ATOMIC_DEC>(\012    mask, surfIndex, dummy.select_all(), dummy.select_all(), u, v, r) - 1;\012}\012\012// Typed atomic {u, v, r, lod}.\012template <CmAtomicOpType Op, typename T, int N>\012CM_NODEBUG CM_INLINE\012typename std::enable_if<(Op == ATOMIC_INC || Op == ATOMIC_DEC) &&\012                            details::isPowerOf2(N, 32) &&\012                            details::is_dword_type<T>::value,\012            ",
"            void>::type\012write_typed_atomic(SurfaceIndex surfIndex, vector_ref<T, N> ret,\012                   vector<uint, N> u, vector<uint, N> v, vector<uint, N> r,\012                   vector<uint, N> lod) {\012  vector<T, N> dummy;\012  vector<ushort, N> mask = 1;\012  ret = details::__cm_intrinsic_impl_atomic_write_typed<Op>(\012      mask, surfIndex, dummy.select_all(), dummy.select_all(), u, v, r, lod);\012}\012\012template <CmAtomicOpType Op, typename T, int N>\012CM_NODEBUG CM_INLINE\012typename std::enable_if<(Op == ATOMIC_PREDEC) &&\012  details::isPowerOf2(N, 32) &&\012  details::is_dword_type<T>::value,\012  void>::type\012  write_typed_atomic(SurfaceIndex surfIndex, vector_ref<T, N> ret,\012    vector<uint, N> u, vector<uint, N> v, vector<uint, N> r,\012    vector<uint, N> lod) {\012  vector<T, N> dummy;\012  vector<ushort, N> mask = 1;\012  ret = details::__cm_intrinsic_impl_atomic_write_typed<ATOMIC_DEC>(\012    mask, surfIndex, dummy.select_all(), dummy.select_all(), u, v, r, lod) - 1;\012}\012\012// Predicated typed atomic {u, v, r, lod}.\012template <CmAtomicOpT",
"ype Op, typename T, int N>\012CM_NODEBUG CM_INLINE\012typename std::enable_if<(Op == ATOMIC_INC || Op == ATOMIC_DEC) &&\012                            details::isPowerOf2(N, 32) &&\012                            details::is_dword_type<T>::value,\012                        void>::type\012write_typed_atomic(vector<ushort, N> mask, SurfaceIndex surfIndex,\012                   vector_ref<T, N> ret, vector<uint, N> u, vector<uint, N> v,\012                   vector<uint, N> r, vector<uint, N> lod) {\012  vector<T, N> dummy;\012  ret = details::__cm_intrinsic_impl_atomic_write_typed<Op>(\012      mask, surfIndex, dummy.select_all(), dummy.select_all(), u, v, r, lod);\012}\012\012template <CmAtomicOpType Op, typename T, int N>\012CM_NODEBUG CM_INLINE\012typename std::enable_if<(Op == ATOMIC_PREDEC) &&\012  details::isPowerOf2(N, 32) &&\012  details::is_dword_type<T>::value,\012  void>::type\012  write_typed_atomic(vector<ushort, N> mask, SurfaceIndex surfIndex,\012    vector_ref<T, N> ret, vector<uint, N> u, vector<uint, N> v,\012    vector<uint, N> r, vector<uint, N> lod) {\012  ve",
"ctor<T, N> dummy;\012  ret = details::__cm_intrinsic_impl_atomic_write_typed<ATOMIC_DEC>(\012    mask, surfIndex, dummy.select_all(), dummy.select_all(), u, v, r, lod) - 1;\012}\012\012// Typed atomic {u}.\012template <CmAtomicOpType Op, typename T, int N>\012CM_NODEBUG CM_INLINE\012typename std::enable_if<\012    (Op != ATOMIC_CMPXCHG && Op != ATOMIC_INC && Op != ATOMIC_DEC && Op != ATOMIC_PREDEC) &&\012        details::isPowerOf2(N, 32) && details::is_dword_type<T>::value,\012    void>::type\012write_typed_atomic(SurfaceIndex surfIndex, vector_ref<T, N> ret,\012                   vector<T, N> src0, vector<uint, N> u) {\012  vector<T, N> dummy;\012  vector<ushort, N> mask = 1;\012  ret = details::__cm_intrinsic_impl_atomic_write_typed<Op>(\012      mask, surfIndex, src0, dummy.select_all(), u);\012}\012\012// Predicated typed atomic {u}.\012template <CmAtomicOpType Op, typename T, int N>\012CM_NODEBUG CM_INLINE\012typename std::enable_if<\012    (Op != ATOMIC_CMPXCHG && Op != ATOMIC_INC && Op != ATOMIC_DEC && Op != ATOMIC_PREDEC) &&\012        details::isPowerOf2(N, 32) && details:",
":is_dword_type<T>::value,\012    void>::type\012write_typed_atomic(vector<ushort, N> mask, SurfaceIndex surfIndex,\012                   vector_ref<T, N> ret, vector<T, N> src0, vector<uint, N> u) {\012  vector<T, N> dummy;\012  ret = details::__cm_intrinsic_impl_atomic_write_typed<Op>(\012      mask, surfIndex, src0, dummy.select_all(), u);\012}\012\012// Typed atomic {u, v}.\012template <CmAtomicOpType Op, typename T, int N>\012CM_NODEBUG CM_INLINE\012typename std::enable_if<\012    (Op != ATOMIC_CMPXCHG && Op != ATOMIC_INC && Op != ATOMIC_DEC && Op != ATOMIC_PREDEC) &&\012        details::isPowerOf2(N, 32) && details::is_dword_type<T>::value,\012    void>::type\012write_typed_atomic(SurfaceIndex surfIndex, vector_ref<T, N> ret,\012                   vector<T, N> src0, vector<uint, N> u, vector<uint, N> v) {\012  vector<T, N> dummy;\012  vector<ushort, N> mask = 1;\012  ret = details::__cm_intrinsic_impl_atomic_write_typed<Op>(\012      mask, surfIndex, src0, dummy.select_all(), u, v);\012}\012\012// Predicated typed atomic {u, v}.\012template <CmAtomicOpType Op, typename T, int N",
">\012CM_NODEBUG CM_INLINE\012typename std::enable_if<\012    (Op != ATOMIC_CMPXCHG && Op != ATOMIC_INC && Op != ATOMIC_DEC && Op != ATOMIC_PREDEC) &&\012        details::isPowerOf2(N, 32) && details::is_dword_type<T>::value,\012    void>::type\012write_typed_atomic(vector<ushort, N> mask, SurfaceIndex surfIndex,\012                   vector_ref<T, N> ret, vector<T, N> src0, vector<uint, N> u,\012                   vector<uint, N> v) {\012  vector<T, N> dummy;\012  ret = details::__cm_intrinsic_impl_atomic_write_typed<Op>(\012      mask, surfIndex, src0, dummy.select_all(), u, v);\012}\012\012// Typed atomic {u, v, r}.\012template <CmAtomicOpType Op, typename T, int N>\012CM_NODEBUG CM_INLINE\012typename std::enable_if<\012    (Op != ATOMIC_CMPXCHG && Op != ATOMIC_INC && Op != ATOMIC_DEC && Op != ATOMIC_PREDEC) &&\012        details::isPowerOf2(N, 32) && details::is_dword_type<T>::value,\012    void>::type\012write_typed_atomic(SurfaceIndex surfIndex, vector_ref<T, N> ret,\012                   vector<T, N> src0, vector<uint, N> u, vector<uint, N> v,\012                   vecto",
"r<uint, N> r) {\012  vector<T, N> dummy;\012  vector<ushort, N> mask = 1;\012  ret = details::__cm_intrinsic_impl_atomic_write_typed<Op>(\012      mask, surfIndex, src0, dummy.select_all(), u, v, r);\012}\012\012// Predicated typed atomic {u, v, r}.\012template <CmAtomicOpType Op, typename T, int N>\012CM_NODEBUG CM_INLINE\012typename std::enable_if<\012    (Op != ATOMIC_CMPXCHG && Op != ATOMIC_INC && Op != ATOMIC_DEC && Op != ATOMIC_PREDEC) &&\012        details::isPowerOf2(N, 32) && details::is_dword_type<T>::value,\012    void>::type\012write_typed_atomic(vector<ushort, N> mask, SurfaceIndex surfIndex,\012                   vector_ref<T, N> ret, vector<T, N> src0, vector<uint, N> u,\012                   vector<uint, N> v, vector<uint, N> r) {\012  vector<T, N> dummy;\012  ret = details::__cm_intrinsic_impl_atomic_write_typed<Op>(\012      mask, surfIndex, src0, dummy.select_all(), u, v, r);\012}\012\012// Typed atomic {u, v, r, lod}.\012template <CmAtomicOpType Op, typename T, int N>\012CM_NODEBUG CM_INLINE\012typename std::enable_if<\012    (Op != ATOMIC_CMPXCHG && Op != ATOMIC_IN",
"C && Op != ATOMIC_DEC && Op != ATOMIC_PREDEC) &&\012        details::isPowerOf2(N, 32) && details::is_dword_type<T>::value,\012    void>::type\012write_typed_atomic(SurfaceIndex surfIndex, vector_ref<T, N> ret,\012                   vector<T, N> src0, vector<uint, N> u, vector<uint, N> v,\012                   vector<uint, N> r, vector<uint, N> lod) {\012  vector<T, N> dummy;\012  vector<ushort, N> mask = 1;\012  ret = details::__cm_intrinsic_impl_atomic_write_typed<Op>(\012      mask, surfIndex, src0, dummy.select_all(), u, v, r, lod);\012}\012\012// Predicated typed atomic {u, v, r, lod}.\012template <CmAtomicOpType Op, typename T, int N>\012CM_NODEBUG CM_INLINE\012typename std::enable_if<\012    (Op != ATOMIC_CMPXCHG && Op != ATOMIC_INC && Op != ATOMIC_DEC && Op != ATOMIC_PREDEC) &&\012        details::isPowerOf2(N, 32) && details::is_dword_type<T>::value,\012    void>::type\012write_typed_atomic(vector<ushort, N> mask, SurfaceIndex surfIndex,\012                   vector_ref<T, N> ret, vector<T, N> src0, vector<uint, N> u,\012                   vector<uint, N> v, vec",
"tor<uint, N> r, vector<uint, N> lod) {\012  vector<T, N> dummy;\012  ret = details::__cm_intrinsic_impl_atomic_write_typed<Op>(\012      mask, surfIndex, src0, dummy.select_all(), u, v, r, lod);\012}\012\012// Typed atomic {u}.\012template <CmAtomicOpType Op, typename T, int N>\012CM_NODEBUG CM_INLINE\012typename std::enable_if<(Op == ATOMIC_CMPXCHG) && details::isPowerOf2(N, 32) &&\012                            details::is_dword_type<T>::value,\012                        void>::type\012write_typed_atomic(SurfaceIndex surfIndex, vector_ref<T, N> ret,\012                   vector<T, N> src0, vector<T, N> src1, vector<uint, N> u) {\012  vector<ushort, N> mask = 1;\012  ret = details::__cm_intrinsic_impl_atomic_write_typed<Op>(mask, surfIndex,\012                                                            src0, src1, u);\012}\012\012// Predicated typed atomic {u}.\012template <CmAtomicOpType Op, typename T, int N>\012CM_NODEBUG CM_INLINE\012typename std::enable_if<(Op == ATOMIC_CMPXCHG) && details::isPowerOf2(N, 32) &&\012                            details::is_dword_type<T>::va",
"lue,\012                        void>::type\012write_typed_atomic(vector<ushort, N> mask, SurfaceIndex surfIndex,\012                   vector_ref<T, N> ret, vector<T, N> src0, vector<T, N> src1,\012                   vector<uint, N> u) {\012  ret = details::__cm_intrinsic_impl_atomic_write_typed<Op>(mask, surfIndex,\012                                                            src0, src1, u);\012}\012\012// Typed atomic {u, v}.\012template <CmAtomicOpType Op, typename T, int N>\012CM_NODEBUG CM_INLINE\012typename std::enable_if<(Op == ATOMIC_CMPXCHG) && details::isPowerOf2(N, 32) &&\012                            details::is_dword_type<T>::value,\012                        void>::type\012write_typed_atomic(SurfaceIndex surfIndex, vector_ref<T, N> ret,\012                   vector<T, N> src0, vector<T, N> src1, vector<uint, N> u,\012                   vector<uint, N> v) {\012  vector<ushort, N> mask = 1;\012  ret = details::__cm_intrinsic_impl_atomic_write_typed<Op>(mask, surfIndex,\012                                                            src0, src1, u, v);\012}\012\012",
"// Predicated typed atomic {u, v}.\012template <CmAtomicOpType Op, typename T, int N>\012CM_NODEBUG CM_INLINE\012typename std::enable_if<(Op == ATOMIC_CMPXCHG) && details::isPowerOf2(N, 32) &&\012                            details::is_dword_type<T>::value,\012                        void>::type\012write_typed_atomic(vector<ushort, N> mask, SurfaceIndex surfIndex,\012                   vector_ref<T, N> ret, vector<T, N> src0, vector<T, N> src1,\012                   vector<uint, N> u, vector<uint, N> v) {\012  ret = details::__cm_intrinsic_impl_atomic_write_typed<Op>(mask, surfIndex,\012                                                            src0, src1, u, v);\012}\012\012// Typed atomic {u, v, r}.\012template <CmAtomicOpType Op, typename T, int N>\012CM_NODEBUG CM_INLINE\012typename std::enable_if<(Op == ATOMIC_CMPXCHG) && details::isPowerOf2(N, 32) &&\012                            details::is_dword_type<T>::value,\012                        void>::type\012write_typed_atomic(SurfaceIndex surfIndex, vector_ref<T, N> ret,\012                   vector<T, N> src0, v",
"ector<T, N> src1, vector<uint, N> u,\012                   vector<uint, N> v, vector<uint, N> r) {\012  vector<ushort, N> mask = 1;\012  ret = details::__cm_intrinsic_impl_atomic_write_typed<Op>(\012      mask, surfIndex, src0, src1, u, v, r);\012}\012\012// Predicated typed atomic {u, v, r}.\012template <CmAtomicOpType Op, typename T, int N>\012CM_NODEBUG CM_INLINE\012typename std::enable_if<(Op == ATOMIC_CMPXCHG) && details::isPowerOf2(N, 32) &&\012                            details::is_dword_type<T>::value,\012                        void>::type\012write_typed_atomic(vector<ushort, N> mask, SurfaceIndex surfIndex,\012                   vector_ref<T, N> ret, vector<T, N> src0, vector<T, N> src1,\012                   vector<uint, N> u, vector<uint, N> v, vector<uint, N> r) {\012  ret = details::__cm_intrinsic_impl_atomic_write_typed<Op>(\012      mask, surfIndex, src0, src1, u, v, r);\012}\012\012// Typed atomic {u, v, r, lod}.\012template <CmAtomicOpType Op, typename T, int N>\012CM_NODEBUG CM_INLINE\012typename std::enable_if<(Op == ATOMIC_CMPXCHG) && details::isPowerOf2(",
"N, 32) &&\012                            details::is_dword_type<T>::value,\012                        void>::type\012write_typed_atomic(SurfaceIndex surfIndex, vector_ref<T, N> ret,\012                   vector<T, N> src0, vector<T, N> src1, vector<uint, N> u,\012                   vector<uint, N> v, vector<uint, N> r, vector<uint, N> lod) {\012  vector<ushort, N> mask = 1;\012  ret = details::__cm_intrinsic_impl_atomic_write_typed<Op>(\012      mask, surfIndex, src0, src1, u, v, r, lod);\012}\012\012// Predicated typed atomic {u, v, r, lod}.\012template <CmAtomicOpType Op, typename T, int N>\012CM_NODEBUG CM_INLINE\012typename std::enable_if<(Op == ATOMIC_CMPXCHG) && details::isPowerOf2(N, 32) &&\012                            details::is_dword_type<T>::value,\012                        void>::type\012write_typed_atomic(vector<ushort, N> mask, SurfaceIndex surfIndex,\012                   vector_ref<T, N> ret, vector<T, N> src0, vector<T, N> src1,\012                   vector<uint, N> u, vector<uint, N> v, vector<uint, N> r,\012                   vector<uint, N> lod)",
" {\012  ret = details::__cm_intrinsic_impl_atomic_write_typed<Op>(\012      mask, surfIndex, src0, src1, u, v, r, lod);\012}\012#endif\012\012#endif\012\000/*========================== begin_copyright_notice ============================\012\012Copyright (C) 2021 Intel Corporation\012\012SPDX-License-Identifier: MIT\012\012============================= end_copyright_notice ===========================*/\012\012#include \"cm_common.h\"\012\012/// CM_HAS_<Feature> maros\012/// ----------------------\012/// Check platform to support <Feature>.\012/// Return true if Feature is supported. \012//===----------------------------------------------------------------------===//\012\012#ifndef _CLANG_CM_HAS_INSTR_H_\012#define _CLANG_CM_HAS_INSTR_H_\012\012#ifndef CM_HAS_CONTROL\012 \012namespace CheckVersion {\012\012  // Use structure to create static_assert only on 2nd stage of\012  // substitution - when user tries to get blocked instruction.\012  template <bool checking>\012  struct VersionWrapper final {\012    static constexpr bool check = checking;\012  };\012\012  template <typename T>\012  CM_INLINE CM_NODEBUG void Check() {\012    ",
"CM_STATIC_ERROR(T::check, \"Not supported feature for this platform\");\012  }\012}\012\012#define CM_HAS_CONTROL(checking_statement) CheckVersion::Check<CheckVersion::VersionWrapper<checking_statement>>()\012\012//-----------------------------------------------\012//-----------------------------------------------\012\012#if (CM_GENX >= 1200) \012  #define CM_HAS_DP4A 1\012  #define CM_HAS_DP4A_CONTROL CM_HAS_CONTROL(true)\012#else\012  #define CM_HAS_DP4A_CONTROL CM_HAS_CONTROL(false)\012#endif\012#if (CM_GENX >= 1150) //>= ICLLP\012  #define CM_HAS_BIT_ROTATE 1\012  #define CM_HAS_BIT_ROTATE_CONTROL CM_HAS_CONTROL(true)\012#else\012  #define CM_HAS_BIT_ROTATE_CONTROL CM_HAS_CONTROL(false)\012#endif\012\012/// CM_HAS_<Feature>_CONTROL macors\012/// -------------------------------  \012/// Create static_assert if feature isn't supported for this platform.\012/// Otherwise, do nothing.\012/// \012/// CM_GENX value of platforms sets according to Frontend/InitPreprocessor.cpp.\012//===----------------------------------------------------------------------===//\012\012//BFN\012#if (CM_GENX >= 1270) //>= XEH",
"P_SDV\012  #define CM_HAS_BFN 1\012  #define CM_HAS_BFN_CONTROL CM_HAS_CONTROL(true)\012#else\012  #define CM_HAS_BFN_CONTROL CM_HAS_CONTROL(false)\012#endif\012\012\012//ACC_BF16 and ACC_HALF\012#if (CM_GENX >= 1280) //>= PVC\012  #define CM_HAS_DPAS_ACC_HALF 1\012  #define CM_HAS_DPAS_ACC_BF16 1\012  #define CM_HAS_DPAS_ACC_HALF_CONTROL CM_HAS_CONTROL(true)\012  #define CM_HAS_DPAS_ACC_BF16_CONTROL CM_HAS_CONTROL(true)\012#else\012  #define CM_HAS_DPAS_ACC_HALF_CONTROL CM_HAS_CONTROL(false)\012  #define CM_HAS_DPAS_ACC_BF16_CONTROL CM_HAS_CONTROL(false)\012#endif\012\012//BF16\012#if (CM_GENX >= 1200) //>= TGLLP\012  #define CM_HAS_BF16 1\012  #define CM_HAS_BF16_CONTROL CM_HAS_CONTROL(true)\012#else\012  #define CM_HAS_BF16_CONTROL CM_HAS_CONTROL(false)\012#endif\012\012//DPAS\012#if (CM_GENX >= 1270) //>= XEHP_SDV\012  #define CM_HAS_DPAS 1\012  #define CM_HAS_DPAS_CONTROL CM_HAS_CONTROL(true)\012#else\012  #define CM_HAS_DPAS_CONTROL CM_HAS_CONTROL(false)\012#endif\012\012\012//DPAS_ODD\012#if (CM_GENX >= 1270 && CM_GENX <= 1280) //>= XEHP_SDV && <= PVC\012  #define CM_HAS_DPAS_ODD 1\012  #define CM_HAS_DPAS_ODD_CONTRO",
"L CM_HAS_CONTROL(true)\012#else\012  #define CM_HAS_DPAS_ODD_CONTROL CM_HAS_CONTROL(false)\012#endif\012\012//DPASW\012#if (CM_GENX >= 1270) //>= XEHP_SDV\012  #define CM_HAS_DPASW 1\012  #define CM_HAS_DPASW_CONTROL CM_HAS_CONTROL(true)\012#else\012  #define CM_HAS_DPASW_CONTROL CM_HAS_CONTROL(false)\012#endif\012\012//Gateway event\012#if (CM_GENX >= 1150 && CM_GENX <= 1280) //>= ICLLP && <= PVC\012  #define CM_HAS_GATEWAY_EVENT\012  #define CM_HAS_GATEWAY_EVENT_CONTROL CM_HAS_CONTROL(true)\012#else\012  #define CM_HAS_GATEWAY_EVENT_CONTROL CM_HAS_CONTROL(false)\012#endif\012\012//IEEE\012#if (CM_GENX == 800  || /*BWD*/         \\\012     CM_GENX == 900  || /*SKL*/         \\\012     CM_GENX == 950  || /*KBL*/         \\\012     CM_GENX == 1150 || /*ICLLP*/       \\\012     CM_GENX == 1270 || /*XeHP_SDV*/    \\\012     CM_GENX == 1280    /*PVC*/         )\012  #define CM_HAS_IEEE_DIV_SQRT 1\012  #define CM_HAS_IEEE_DIV_SQRT_CONTROL CM_HAS_CONTROL(true)\012#else  //IEEE\012  #define CM_HAS_IEEE_DIV_SQRT_CONTROL CM_HAS_CONTROL(false)\012#endif //IEEE\012\012//LSC \012#if (CM_GENX >= 1271) //>= DG2\012  #define CM_HAS_LS",
"C 1\012  #define CM_HAS_LSC_CONTROL CM_HAS_CONTROL(true)\012#else\012  #define CM_HAS_LSC_CONTROL CM_HAS_CONTROL(false)\012#endif\012\012\012//LSC_UNTYPED_2D\012#if (CM_GENX >= 1280) //>= PVC\012  #define CM_HAS_LSC_UNTYPED_2D 1\012  #define CM_HAS_LSC_UNTYPED_2D_CONTROL CM_HAS_CONTROL(true)\012#else\012  #define CM_HAS_LSC_UNTYPED_2D_CONTROL CM_HAS_CONTROL(false)\012#endif\012\012// Sample unorm\012#if (CM_GENX < 1270) // < XEHP_SDV\012  #define CM_HAS_SAMPLE_UNORM 1\012  #define CM_HAS_SAMPLE_UNORM_CONTROL CM_HAS_CONTROL(true)\012#else\012  #define CM_HAS_SAMPLE_UNORM_CONTROL  CM_HAS_CONTROL(false)\012#endif\012\012\012//TF32\012#if ((CM_GENX == 1280 && CM_GENX_REVID >= 5) || CM_GENX > 1280) //>= PVCXT\012  #define CM_HAS_TF32 1\012  #define CM_HAS_TF32_CONTROL CM_HAS_CONTROL(true)\012#else\012  #define CM_HAS_TF32_CONTROL CM_HAS_CONTROL(false)\012#endif\012\012//BitRotate64\012#if (CM_GENX >= 1280) //>= PVC\012  #define CM_HAS_BIT_ROTATE_64BIT 1\012  #define CM_HAS_BIT_ROTATE_64BIT_CONTROL CM_HAS_CONTROL(true)\012#else\012  #define CM_HAS_BIT_ROTATE_64BIT_CONTROL CM_HAS_CONTROL(false)\012#endif\012\012#if (CM_GENX >= 1280) ",
"// >= PVC\012  #define CM_HAS_STOCHASTIC_ROUNDING 1\012  #define CM_HAS_STOCHASTIC_ROUNDING_CONTROL CM_HAS_CONTROL(true)\012#else\012  #define CM_HAS_STOCHASTIC_ROUNDING_CONTROL CM_HAS_CONTROL(false)\012#endif\012#if (CM_GENX <= 1280)\012  #define CM_HAS_LSC_LOAD_L1RI_L3CA_HINT 1\012#endif\012\012#else  // CM_HAS_CONTROL\012  CM_STATIC_ERROR(0, \"Redeclaration of CM_HAS_CONTROL! It's used for control version of features!\");\012#endif // CM_HAS_CONTROL\012\012#endif /* _CLANG_CM_HAS_INSTR_H_ */\012\000/*========================== begin_copyright_notice ============================\012\012Copyright (C) 2020-2021 Intel Corporation\012\012SPDX-License-Identifier: MIT\012\012============================= end_copyright_notice ===========================*/\012\012#if (__INCLUDE_LEVEL__ == 1)\012static_assert(0, \"CM:w:cm_bfn.h should not be included explicitly - only \"\012                 \"<cm/cm.h> is required\");\012#endif\012\012#ifndef _CLANG_CM_BFN_H_\012#define _CLANG_CM_BFN_H_\012\012#include \"cm_common.h\"\012#include \"cm_internal.h\"\012#include \"cm_has_instr.h\"\012\012/// \\brief BFNT -- boolean sources enum\012///\012/// T",
"his enum contains BFN_X, BFN_Y and BFN_Z elements\012/// corresponding to s0, s1, s2 in documentation\012///\012enum class BFNT : unsigned char {\012  X = 0xAA,\012  Y = 0xCC,\012  Z = 0xF0\012};\012\012constexpr BFNT BFN_X = BFNT::X;\012constexpr BFNT BFN_Y = BFNT::Y;\012constexpr BFNT BFN_Z = BFNT::Z;\012\012static constexpr BFNT operator~(BFNT x) {\012  unsigned char val = static_cast<unsigned char>(x);\012  unsigned char res = ~val;\012  return static_cast<BFNT>(res);\012}\012\012static constexpr BFNT operator|(BFNT x, BFNT y) {\012  unsigned char arg0 = static_cast<unsigned char>(x);\012  unsigned char arg1 = static_cast<unsigned char>(y);\012  unsigned char res = arg0 | arg1;\012  return static_cast<BFNT>(res);\012}\012\012static constexpr BFNT operator&(BFNT x, BFNT y) {\012  unsigned char arg0 = static_cast<unsigned char>(x);\012  unsigned char arg1 = static_cast<unsigned char>(y);\012  unsigned char res = arg0 & arg1;\012  return static_cast<BFNT>(res);\012}\012\012static constexpr BFNT operator^(BFNT x, BFNT y) {\012  unsigned char arg0 = static_cast<unsigned char>(x);\012  unsigned char arg1 = static_",
"cast<unsigned char>(y);\012  unsigned char res = arg0 ^ arg1;\012  return static_cast<BFNT>(res);\012}\012\012/// \\brief Boolean Function Calculation\012///\012/// @param BVAL Function index (from BFNT enum values)\012///\012/// @param s0 First boolean function arg\012///\012/// @param s1 Second boolean function arg\012///\012/// @param s2 Third boolean function arg\012///\012/// Example: d = cm_bfn<~BFN_X & ~BFN_Y & ~BFN_Z>(s0, s1, s2);\012///\012template <BFNT BVAL, typename T>\012typename std::enable_if<details::is_cm_scalar<T>::value, T>::type\012cm_bfn(T s0, T s1, T s2) {\012  CM_HAS_BFN_CONTROL; \012\012  return details::__cm_intrinsic_impl_bfn(s0, s1, s2, static_cast<unsigned char>(BVAL));\012}\012\012template <BFNT BVAL, typename T, int N>\012vector<T, N> cm_bfn(vector<T, N> s0, vector<T, N> s1, vector<T, N> s2) {\012  CM_HAS_BFN_CONTROL;\012\012  return details::__cm_intrinsic_impl_bfn(s0, s1, s2, static_cast<unsigned char>(BVAL));\012}\012\012#endif // _CLANG_CM_BFN_H_\012\012\000/*========================== begin_copyright_notice ============================\012\012Copyright (C) 2014-2021 Intel Corporation\012",
"\012SPDX-License-Identifier: MIT\012\012============================= end_copyright_notice ===========================*/\012\012#if (__INCLUDE_LEVEL__ == 1)\012static_assert(0, \"CM:w:cm_common.h should not be included explicitly - only \"\012                 \"<cm/cm.h> is required\");\012#endif\012\012#ifndef _CLANG_CM_COMMON_H_\012#define _CLANG_CM_COMMON_H_\012\012// Define MDF version\012#ifndef CM_1_0\012#define CM_1_0 100\012#endif\012#ifndef CM_2_0\012#define CM_2_0 200\012#endif\012#ifndef CM_2_1\012#define CM_2_1 201\012#endif\012#ifndef CM_2_2\012#define CM_2_2 202\012#endif\012#ifndef CM_2_3\012#define CM_2_3 203\012#endif\012#ifndef CM_2_4\012#define CM_2_4 204\012#endif\012#ifndef CM_3_0\012#define CM_3_0 300\012#endif\012#ifndef CM_4_0\012#define CM_4_0 400\012#endif\012#ifndef CM_5_0\012#define CM_5_0 500\012#endif\012#ifndef CM_6_0\012#define CM_6_0 600\012#endif\012#ifndef CM_7_0\012#define CM_7_0 700\012#endif\012\012#ifndef __INTEL_MDF\012#define __INTEL_MDF (CM_7_0 + 1)\012#endif\012\012#ifndef __INTEL_CM\012#define __INTEL_CM (CM_7_0 + 1)\012#endif\012\012// Typedefs\012typedef unsigned char uchar;\012typedef unsigned short ushort;\012typedef unsigned int uint;\012\012ty",
"pedef unsigned char U8;\012typedef unsigned short U16;\012typedef unsigned int U32;\012\012#ifndef __int8\012#define __int8 char\012#endif\012\012#ifndef __uint8\012#define __uint8 unsigned char\012#endif\012\012#ifndef __int16\012#define __int16 short\012#endif\012\012#ifndef __uint16\012#define __uint16 unsigned short\012#endif\012\012#ifndef __int32\012#define __int32 int\012#endif\012\012#ifndef __uint32\012#define __uint32 unsigned int\012#endif\012\012#ifndef __int64\012#define __int64 long long\012#endif\012\012#ifndef __uint64\012#define __uint64 unsigned long long\012#endif\012\012typedef __int8 int8_t;\012typedef __int16 int16_t;\012typedef __int32 int32_t;\012typedef __int64 int64_t;\012typedef __uint8 uint8_t;\012typedef __uint16 uint16_t;\012typedef __uint32 uint32_t;\012typedef __uint64 uint64_t;\012\012#if __SIZEOF_POINTER__ == 8\012typedef uint64_t uintptr_t;\012typedef int64_t ptrdiff_t;\012#elif __SIZEOF_POINTER__ == 4\012typedef uint32_t uintptr_t;\012typedef int32_t ptrdiff_t;\012#else\012#error improbably-sized pointers on this target\012#endif\012\012#ifdef CM_PTRSIZE\012#if CM_PTRSIZE == 32\012typedef uint32_t svmptr_t;\012#elif CM_PTRSIZE == 64\012typedef uin",
"t64_t svmptr_t;\012#else\012#error CM_PTRSIZE must be 32 or 64\012#endif\012#else\012typedef uintptr_t svmptr_t;\012#endif\012\012// Enums\012enum {\012  _GENX_NOSAT = 0,\012  _GENX_SAT\012};\012\012enum ChannelMaskType {\012  _CM_R_ENABLE = 1,\012  _CM_G_ENABLE = 2,\012  _CM_GR_ENABLE = 3,\012  _CM_B_ENABLE = 4,\012  _CM_BR_ENABLE = 5,\012  _CM_BG_ENABLE = 6,\012  _CM_BGR_ENABLE = 7,\012  _CM_A_ENABLE = 8,\012  _CM_AR_ENABLE = 9,\012  _CM_AG_ENABLE = 10,\012  _CM_AGR_ENABLE = 11,\012  _CM_AB_ENABLE = 12,\012  _CM_ABR_ENABLE = 13,\012  _CM_ABG_ENABLE = 14,\012  _CM_ABGR_ENABLE = 15\012};\012\012#define CM_R_ENABLE ChannelMaskType::_CM_R_ENABLE\012#define CM_G_ENABLE ChannelMaskType::_CM_G_ENABLE\012#define CM_GR_ENABLE ChannelMaskType::_CM_GR_ENABLE\012#define CM_B_ENABLE ChannelMaskType::_CM_B_ENABLE\012#define CM_BR_ENABLE ChannelMaskType::_CM_BR_ENABLE\012#define CM_BG_ENABLE ChannelMaskType::_CM_BG_ENABLE\012#define CM_BGR_ENABLE ChannelMaskType::_CM_BGR_ENABLE\012#define CM_A_ENABLE ChannelMaskType::_CM_A_ENABLE\012#define CM_AR_ENABLE ChannelMaskType::_CM_AR_ENABLE\012#define CM_AG_ENABLE ChannelMaskType::_CM_AG_ENABLE\012#def",
"ine CM_AGR_ENABLE ChannelMaskType::_CM_AGR_ENABLE\012#define CM_AB_ENABLE ChannelMaskType::_CM_AB_ENABLE\012#define CM_ABR_ENABLE ChannelMaskType::_CM_ABR_ENABLE\012#define CM_ABG_ENABLE ChannelMaskType::_CM_ABG_ENABLE\012#define CM_ABGR_ENABLE ChannelMaskType::_CM_ABGR_ENABLE\012\012enum class SLM_ChannelMaskType {\012  _SLM_R_ENABLE = 14,\012  _SLM_G_ENABLE = 13,\012  _SLM_GR_ENABLE = 12,\012  _SLM_B_ENABLE = 11,\012  _SLM_BR_ENABLE = 10,\012  _SLM_BG_ENABLE = 9,\012  _SLM_BGR_ENABLE = 8,\012  _SLM_A_ENABLE = 7,\012  _SLM_AR_ENABLE = 6,\012  _SLM_AG_ENABLE = 5,\012  _SLM_AGR_ENABLE = 4,\012  _SLM_AB_ENABLE = 3,\012  _SLM_ABR_ENABLE = 2,\012  _SLM_ABG_ENABLE = 1,\012  _SLM_ABGR_ENABLE = 0\012};\012\012#define SLM_R_ENABLE SLM_ChannelMaskType::_SLM_R_ENABLE\012#define SLM_G_ENABLE SLM_ChannelMaskType::_SLM_G_ENABLE\012#define SLM_GR_ENABLE SLM_ChannelMaskType::_SLM_GR_ENABLE\012#define SLM_B_ENABLE SLM_ChannelMaskType::_SLM_B_ENABLE\012#define SLM_BR_ENABLE SLM_ChannelMaskType::_SLM_BR_ENABLE\012#define SLM_BG_ENABLE SLM_ChannelMaskType::_SLM_BG_ENABLE\012#define SLM_BGR_ENABLE SLM_ChannelMaskType",
"::_SLM_BGR_ENABLE\012#define SLM_A_ENABLE SLM_ChannelMaskType::_SLM_A_ENABLE\012#define SLM_AR_ENABLE SLM_ChannelMaskType::_SLM_AR_ENABLE\012#define SLM_AG_ENABLE SLM_ChannelMaskType::_SLM_AG_ENABLE\012#define SLM_AGR_ENABLE SLM_ChannelMaskType::_SLM_AGR_ENABLE\012#define SLM_AB_ENABLE SLM_ChannelMaskType::_SLM_AB_ENABLE\012#define SLM_ABR_ENABLE SLM_ChannelMaskType::_SLM_ABR_ENABLE\012#define SLM_ABG_ENABLE SLM_ChannelMaskType::_SLM_ABG_ENABLE\012#define SLM_ABGR_ENABLE SLM_ChannelMaskType::_SLM_ABGR_ENABLE\012\012enum class CmBufferAttrib {\012  _GENX_NONE = 0,\012  _GENX_TOP_FIELD = 1,\012  _GENX_BOTTOM_FIELD = 2,\012  _GENX_DWALIGNED = 3,\012  _GENX_MODIFIED = 4,\012  _GENX_MODIFIED_TOP_FIELD = 5,\012  _GENX_MODIFIED_BOTTOM_FIELD = 6,\012  _GENX_MODIFIED_DWALIGNED = 7,\012  _GENX_CONSTANT = 8,\012  _GENX_CONSTANT_DWALIGNED = 9,\012  _GENX_NUM_BUFFER_ATTRIB = 10\012};\012\012#define GENX_NONE CmBufferAttrib::_GENX_NONE\012#define GENX_TOP_FIELD CmBufferAttrib::_GENX_TOP_FIELD\012#define GENX_BOTTOM_FIELD CmBufferAttrib::_GENX_BOTTOM_FIELD\012#define GENX_DWALIGNED CmBufferAttrib::_GENX",
"_DWALIGNED\012#define GENX_MODIFIED CmBufferAttrib::_GENX_MODIFIED\012#define GENX_MODIFIED_TOP_FIELD CmBufferAttrib::_GENX_MODIFIE_TOP_FIELDD\012#define GENX_MODIFIED_BOTTOM_FIELD CmBufferAttrib::_GENX_MODIFIED_BOTTOM_FIELD\012#define GENX_MODIFIED_DWALIGNED CmBufferAttrib::_GENX_MODIFIED_DWALIGNED\012#define GENX_CONSTANT CmBufferAttrib::_GENX_CONSTANT\012#define GENX_CONSTANT_DWALIGNED CmBufferAttrib::_GENX_CONSTANT_DWALIGNED\012#define GENX_NUM_BUFFER_ATTRIB CmBufferAttrib::_GENX_NUM_BUFFER_ATTRIB\012\012enum class CmSurfacePlaneIndex {\012  _GENX_SURFACE_Y_PLANE = 0,\012  _GENX_SURFACE_U_PLANE = 1,\012  _GENX_SURFACE_UV_PLANE = 1,\012  _GENX_SURFACE_V_PLANE = 2\012};\012\012#define GENX_SURFACE_Y_PLANE CmSurfacePlaneIndex::_GENX_SURFACE_Y_PLANE\012#define GENX_SURFACE_U_PLANE CmSurfacePlaneIndex::_GENX_SURFACE_U_PLANE\012#define GENX_SURFACE_UV_PLANE CmSurfacePlaneIndex::_GENX_SURFACE_UV_PLANE\012#define GENX_SURFACE_V_PLANE CmSurfacePlaneIndex::_GENX_SURFACE_V_PLANE\012\012enum class OutputFormatControl {\012  _CM_16_FULL = 0,\012  _CM_16_DOWN_SAMPLE = 1,\012  _CM_8_FULL = ",
"2,\012  _CM_8_DOWN_SAMPLE = 3\012};\012\012#define CM_16_FULL OutputFormatControl::_CM_16_FULL\012#define CM_16_DOWN_SAMPLE OutputFormatControl::_CM_16_DOWN_SAMPLE\012#define CM_8_FULL OutputFormatControl::_CM_8_FULL\012#define CM_8_DOWN_SAMPLE OutputFormatControl::_CM_8_DOWN_SAMPLE\012\012enum class AVSExecMode {\012  _CM_AVS_16x4 = 0,\012  _CM_AVS_8x4 = 1,\012  _CM_AVS_16x8 = 2,\012  _CM_AVS_4x4 = 3\012};\012\012#define CM_AVS_16x4 AVSExecMode::_CM_AVS_16x4\012#define CM_AVS_8x4 AVSExecMode::_CM_AVS_8x4\012#define CM_AVS_16x8 AVSExecMode::_CM_AVS_16x8\012#define CM_AVS_4x4 AVSExecMode::_CM_AVS_4x4\012\012enum class CONVExecMode {\012  _CM_CONV_16x4 = 0,\012  _CM_CONV_16x1 = 2,\012  _CM_CONV_1x1 = 3 // 1pixel convolve only\012};\012\012#define CM_CONV_16x4 CONVExecMode::_CM_CONV_16x4\012#define CM_CONV_16x1 CONVExecMode::_CM_CONV_16x1\012#define CM_CONV_1x1 CONVExecMode::_CM_CONV_1x1\012\012enum class EDExecMode {\012  _CM_ED_64x4 = 0,\012  _CM_ED_32x4 = 1,\012  _CM_ED_64x1 = 2,\012  _CM_ED_32x1 = 3\012};\012\012#define CM_ED_64x4 EDExecMode::_CM_ED_64x4\012#define CM_ED_32x4 EDExecMode::_CM_ED_32x4\012#define CM_ED_64x1 EDEx",
"ecMode::_CM_ED_64x1\012#define CM_ED_32x1 EDExecMode::_CM_ED_32x1\012\012enum class MMFExecMode {\012  _CM_MMF_16x4 = 0,\012  _CM_MMF_16x1 = 2,\012  _CM_MMF_1x1 = 3\012};\012\012#define CM_MMF_16x4 MMFExecMode::_CM_MMF_16x4\012#define CM_MMF_16x1 MMFExecMode::_CM_MMF_16x1\012#define CM_MMF_1x1 MMFExecMode::_CM_MMF_1x1\012\012enum class MMFEnableMode {\012  _CM_MINMAX_ENABLE = 0,\012  _CM_MAX_ENABLE = 1,\012  _CM_MIN_ENABLE = 2\012};\012\012#define CM_MINMAX_ENABLE MMFEnableMode::_CM_MINMAX_ENABLE\012#define CM_MAX_ENABLE MMFEnableMode::_CM_MAX_ENABLE\012#define CM_MIN_ENABLE MMFEnableMode::_CM_MIN_ENABLE\012\012enum class LBPCreationExecMode {\012  _CM_LBP_CREATION_5x5 = 0x2,\012  _CM_LBP_CREATION_3x3 = 0x1,\012  _CM_LBP_CREATION_BOTH = 0x0\012};\012\012#define CM_LBP_CREATION_5x5 LBPCreationExecMode::_CM_LBP_CREATION_5x5\012#define CM_LBP_CREATION_3x3 LBPCreationExecMode::_CM_LBP_CREATION_3x3\012#define CM_LBP_CREATION_BOTH LBPCreationExecMode::_CM_LBP_CREATION_BOTH\012\012enum class CM_FORMAT_SIZE {\012  _CM_HDC_FORMAT_16S = 0x0,\012  _CM_HDC_FORMAT_8U = 0x1\012};\012\012#define CM_HDC_FORMAT_16S CM_FORMAT_SIZE::_CM_HD",
"C_FORMAT_16S\012#define CM_HDC_FORMAT_8U CM_FORMAT_SIZE::_CM_HDC_FORMAT_8U\012\012\012enum class CmAtomicOpType {\012  _ATOMIC_ADD = 0x0,\012  _ATOMIC_SUB = 0x1,\012  _ATOMIC_INC = 0x2,\012  _ATOMIC_DEC = 0x3,\012  _ATOMIC_MIN = 0x4,\012  _ATOMIC_MAX = 0x5,\012  _ATOMIC_XCHG = 0x6,\012  _ATOMIC_CMPXCHG = 0x7,\012  _ATOMIC_AND = 0x8,\012  _ATOMIC_OR = 0x9,\012  _ATOMIC_XOR = 0xa,\012  _ATOMIC_MINSINT = 0xb,\012  _ATOMIC_MAXSINT = 0xc,\012  _ATOMIC_FMAX = 0x10,\012  _ATOMIC_FMIN = 0x11,\012  _ATOMIC_FCMPWR = 0x12,\012  _ATOMIC_FADD = 0x13,\012  _ATOMIC_FSUB = 0x14,\012  _ATOMIC_PREDEC = 0xff\012};\012\012#define ATOMIC_ADD CmAtomicOpType::_ATOMIC_ADD\012#define ATOMIC_SUB CmAtomicOpType::_ATOMIC_SUB\012#define ATOMIC_INC CmAtomicOpType::_ATOMIC_INC\012#define ATOMIC_DEC CmAtomicOpType::_ATOMIC_DEC\012#define ATOMIC_MIN CmAtomicOpType::_ATOMIC_MIN\012#define ATOMIC_MAX CmAtomicOpType::_ATOMIC_MAX\012#define ATOMIC_XCHG CmAtomicOpType::_ATOMIC_XCHG\012#define ATOMIC_CMPXCHG CmAtomicOpType::_ATOMIC_CMPXCHG\012#define ATOMIC_AND CmAtomicOpType::_ATOMIC_AND\012#define ATOMIC_OR CmAtomicOpType::_ATOMIC_OR\012#define ATOMIC",
"_XOR CmAtomicOpType::_ATOMIC_XOR\012#define ATOMIC_MINSINT CmAtomicOpType::_ATOMIC_MINSINT\012#define ATOMIC_MAXSINT CmAtomicOpType::_ATOMIC_MAXSINT\012#define ATOMIC_FMAX CmAtomicOpType::_ATOMIC_FMAX\012#define ATOMIC_FMIN CmAtomicOpType::_ATOMIC_FMIN\012#define ATOMIC_FCMPWR CmAtomicOpType::_ATOMIC_FCMPWR\012#define ATOMIC_FADD CmAtomicOpType::_ATOMIC_FADD\012#define ATOMIC_FSUB CmAtomicOpType::_ATOMIC_FSUB\012#define ATOMIC_PREDEC CmAtomicOpType::_ATOMIC_PREDEC\012\012enum class CM3DSampleOp : int {\012  _CM_3D_SAMPLE = 0,\012  _CM_3D_SAMPLE_B = 1,\012  _CM_3D_SAMPLE_L = 2,\012  _CM_3D_SAMPLE_C = 3,\012  _CM_3D_SAMPLE_D = 4,\012  _CM_3D_SAMPLE_B_C = 5,\012  _CM_3D_SAMPLE_L_C = 6,\012  _CM_3D_LOD = 9,\012  _CM_3D_SAMPLE_D_C = 20,\012  _CM_3D_SAMPLE_LZ = 24,\012  _CM_3D_SAMPLE_C_LZ = 25,\012  _CM_3D_SAMPLE_NULLMASK_ENABLE = 32,\012  _CM_3D_SAMPLE_CPS_LOD_COMP_ENABLE = 64\012};\012\012#pragma clang diagnostic push\012#pragma clang diagnostic ignored \"-Wc++1y-extensions\"\012\012inline constexpr CM3DSampleOp operator | (CM3DSampleOp lhs, CM3DSampleOp rhs) {\012  return static_cast<CM3DSampleOp>(stat",
"ic_cast<int>(lhs) | static_cast<int>(rhs));\012}\012\012inline constexpr CM3DSampleOp& operator |= (CM3DSampleOp &lhs, CM3DSampleOp rhs) {\012  lhs = static_cast<CM3DSampleOp>(static_cast<int>(lhs) | static_cast<int>(rhs));\012  return lhs;\012}\012\012#pragma clang diagnostic pop\012\012#define CM_3D_SAMPLE CM3DSampleOp::_CM_3D_SAMPLE\012#define CM_3D_SAMPLE_B CM3DSampleOp::_CM_3D_SAMPLE_B\012#define CM_3D_SAMPLE_L CM3DSampleOp::_CM_3D_SAMPLE_L\012#define CM_3D_SAMPLE_C CM3DSampleOp::_CM_3D_SAMPLE_C\012#define CM_3D_SAMPLE_D CM3DSampleOp::_CM_3D_SAMPLE_D\012#define CM_3D_SAMPLE_B_C CM3DSampleOp::_CM_3D_SAMPLE_B_C\012#define CM_3D_SAMPLE_L_C CM3DSampleOp::_CM_3D_SAMPLE_L_C\012#define CM_3D_LOD CM3DSampleOp::_CM_3D_LOD\012#define CM_3D_SAMPLE_D_C CM3DSampleOp::_CM_3D_SAMPLE_D_C\012#define CM_3D_SAMPLE_LZ CM3DSampleOp::_CM_3D_SAMPLE_LZ\012#define CM_3D_SAMPLE_C_LZ CM3DSampleOp::_CM_3D_SAMPLE_C_LZ\012#define CM_3D_SAMPLE_NULLMASK_ENABLE CM3DSampleOp::_CM_3D_SAMPLE_NULLMASK_ENABLE\012#define CM_3D_SAMPLE_CPS_LOD_COMP_ENABLE CM3DSampleOp::_CM_3D_SAMPLE_CPS_LOD_COMP_ENABLE\012\012enum ",
"class CM3DLoadOp : int {\012  _CM_3D_LOAD = 7,\012  _CM_3D_LOAD_LZ = 26,\012  _CM_3D_LOAD_2DMS_W = 28,\012  _CM_3D_LOAD_MCS = 29,\012  _CM_3D_LOAD_NULLMASK_ENABLE = 32\012};\012\012inline CM3DLoadOp operator | (CM3DLoadOp lhs, CM3DLoadOp rhs) {\012  return (CM3DLoadOp)(static_cast<int>(lhs) | static_cast<int>(rhs));\012}\012\012inline CM3DLoadOp& operator |= (CM3DLoadOp &lhs, CM3DLoadOp rhs) {\012  lhs = (CM3DLoadOp)(static_cast<int>(lhs) | static_cast<int>(rhs));\012  return lhs;\012}\012\012#define CM_3D_LOAD CM3DLoadOp::_CM_3D_LOAD\012#define CM_3D_LOAD_LZ CM3DLoadOp::_CM_3D_LOAD_LZ\012#define CM_3D_LOAD_2DMS_W CM3DLoadOp::_CM_3D_LOAD_2DMS_W\012#define CM_3D_LOAD_MCS CM3DLoadOp::_CM_3D_LOAD_MCS\012#define CM_3D_LOAD_NULLMASK_ENABLE CM3DLoadOp::_CM_3D_LOAD_NULLMASK_ENABLE\012\012enum CmFloatControl {\012  _CM_RTE = 0,      // Round to nearest or even\012  _CM_RTP = 1 << 4, // Round towards +ve inf\012  _CM_RTN = 2 << 4, // Round towards -ve inf\012  _CM_RTZ = 3 << 4, // Round towards zero\012\012  _CM_DENORM_FTZ      = 0,        // Denorm mode flush to zero\012  _CM_DENORM_D_ALLOW  = 1 << 6,   /",
"/ Denorm mode double allow\012  _CM_DENORM_F_ALLOW  = 1 << 7,   // Denorm mode float allow\012  _CM_DENORM_HF_ALLOW = 1 << 10,  // Denorm mode half allow\012\012  _CM_FLOAT_MODE_IEEE    = 0,     // Single precision float IEEE mode\012  _CM_FLOAT_MODE_ALT     = 1      // Single precision float ALT mode\012};\012\012#define CM_RTE CmFloatControl::_CM_RTE\012#define CM_RTP CmFloatControl::_CM_RTP\012#define CM_RTN CmFloatControl::_CM_RTN\012#define CM_RTZ CmFloatControl::_CM_RTZ\012\012#define CM_DENORM_FTZ       CmFloatControl::_CM_DENORM_FTZ\012#define CM_DENORM_D_ALLOW   CmFloatControl::_CM_DENORM_D_ALLOW\012#define CM_DENORM_F_ALLOW   CmFloatControl::_CM_DENORM_F_ALLOW\012#define CM_DENORM_HF_ALLOW  CmFloatControl::_CM_DENORM_HF_ALLOW\012#define CM_DENORM_ALLOW     (CmFloatControl::_CM_DENORM_D_ALLOW | CmFloatControl::_CM_DENORM_F_ALLOW | CmFloatControl::_CM_DENORM_HF_ALLOW)\012\012#define CM_FLOAT_MODE_IEEE  CmFloatControl::_CM_FLOAT_MODE_IEEE\012#define CM_FLOAT_MODE_ALT   CmFloatControl::_CM_FLOAT_MODE_ALT\012\012// dpas helpers\012enum class CmPrecisionType {\012  CM_Precisi",
"on_U1 = 0,      // unsigned 1 bit\012  CM_Precision_S1 = 1,      // signed 1 bit\012  CM_Precision_U2 = 2,      // unsigned 2 bits\012  CM_Precision_S2 = 3,      // signed 2 bits\012  CM_Precision_U4 = 4,      // unsigned 4 bits\012  CM_Precision_S4 = 5,      // signed 4 bits\012  CM_Precision_U8 = 6,      //unsigned 8 bits\012  CM_Precision_S8 = 7,      // signed 8 bits\012  CM_Precision_BF16 = 8,    // bfloat 16\012  CM_Precision_FP16 = 9,    // half float\012  CM_Precision_TF32 = 11,   // tensorfloat 32\012};\012\012#define CM_PRECISION_U1 CmPrecisionType::CM_Precision_U1\012#define CM_PRECISION_U2 CmPrecisionType::CM_Precision_U2\012#define CM_PRECISION_U4 CmPrecisionType::CM_Precision_U4\012#define CM_PRECISION_U8 CmPrecisionType::CM_Precision_U8\012#define CM_PRECISION_S1 CmPrecisionType::CM_Precision_S1\012#define CM_PRECISION_S2 CmPrecisionType::CM_Precision_S2\012#define CM_PRECISION_S4 CmPrecisionType::CM_Precision_S4\012#define CM_PRECISION_S8 CmPrecisionType::CM_Precision_S8\012#define CM_PRECISION_BF CmPrecisionType::CM_Precision_BF16\012#define CM_PRECISION_HF",
" CmPrecisionType::CM_Precision_FP16\012#define CM_PRECISION_TF32 CmPrecisionType::CM_Precision_TF32\012constexpr unsigned get_ops_per_channel(CmPrecisionType src1_precision,\012                                       CmPrecisionType src2_precision) {\012  if ((src1_precision == CM_PRECISION_U8) ||\012      (src1_precision == CM_PRECISION_S8)) {\012    if ((src2_precision == CM_PRECISION_U8) ||\012      (src2_precision == CM_PRECISION_S8) ||\012      (src2_precision == CM_PRECISION_U4) ||\012      (src2_precision == CM_PRECISION_S4) ||\012      (src2_precision == CM_PRECISION_U2) ||\012      (src2_precision == CM_PRECISION_S2)) {\012      return 4;\012    }\012  }\012  else if ((src1_precision == CM_PRECISION_U4) ||\012           (src1_precision == CM_PRECISION_S4) ||\012           (src1_precision == CM_PRECISION_U2) ||\012           (src1_precision == CM_PRECISION_S2)) {\012    if ((src2_precision == CM_PRECISION_U8) ||\012      (src2_precision == CM_PRECISION_S8)) {\012      return 4;\012    }\012    else if ((src2_precision == CM_PRECISION_U4) ||\012      (src2_precision == CM_P",
"RECISION_S4) ||\012      (src2_precision == CM_PRECISION_U2) ||\012      (src2_precision == CM_PRECISION_S2)) {\012      return 8;\012    }\012  }\012  else if ((src1_precision == CM_PRECISION_BF) &&\012           (src2_precision == CM_PRECISION_BF)) {\012    return 2;\012  }\012  else if ((src1_precision == CM_PRECISION_HF) &&\012           (src2_precision == CM_PRECISION_HF)) {\012    return 2;\012  }\012  else if ((src1_precision == CM_PRECISION_TF32) &&\012             (src2_precision == CM_PRECISION_TF32)) {\012    return 1;\012  }\012  return 0xFFFFFFFF;\012}\012\012constexpr unsigned get_precision_bits(CmPrecisionType src_precision) {\012  if (src_precision == CM_PRECISION_U8\012      || src_precision == CM_PRECISION_S8) {\012    return 8;\012  }\012  if (src_precision == CM_PRECISION_U4\012      || src_precision == CM_PRECISION_S4\012     ) {\012    return 4;\012  }\012  if (src_precision == CM_PRECISION_U2\012      || src_precision == CM_PRECISION_S2\012     ) {\012    return 2;\012  }\012  if (src_precision == CM_PRECISION_BF\012      || src_precision == CM_PRECISION_HF\012     ) {\012    return 16;\012  }\012  if (src_",
"precision == CM_PRECISION_TF32) {\012    return 32;\012  }\012  return 0;\012}\012\012// Macros\012#define NULL 0\012#define _GENX_MAIN_                     __declspec(genx_main)\012#define _GENX_                          __declspec(genx)\012#define _GENX_STACKCALL_                __declspec(genx_stackcall)\012#define _GENX_VOLATILE_                 __declspec(genx_volatile)\012#define _GENX_VOLATILE_BINDING_(Offset) __declspec(genx_volatile(Offset))\012#define _CM_BUILTIN_                    __declspec(cm_builtin)\012#define SAT _GENX_SAT\012\012// Global variable definition macro, emu mode only.\012#define __GLOBAL(V) V\012\012// SIMT entry function attribute\012#define _SIMT8_       __declspec(genx_SIMT(8))\012#define _SIMT16_      __declspec(genx_SIMT(16))\012#define _SIMT32_      __declspec(genx_SIMT(32))\012\012// Fast-composition kernel attribute\012#define _CM_CALLABLE_     __declspec(cm_callable)\012#define _CM_ENTRY_        __declspec(cm_entry)\012\012// Fast-composition argument attribute\012#define _CM_INPUT_        __declspec(cm_input)\012#define _CM_OUTPUT_       __declspec(cm_output",
")\012#define _CM_INPUT_OUTPUT_ __declspec(cm_input_output)\012#define _CM_OUTPUT_INPUT_ __declspec(cm_input_output)\012#define _CM_FIXED_        __declspec(cm_fixed)\012\012#define _GENX_ROUNDING_MODE_(x) __declspec(cm_float_control(x))\012#define _GENX_FLOAT_CONTROL_(x) __declspec(cm_float_control(x))\012\012// Mark a function with always_inline attribute\012#define __CM_ALWAYS_INLINE_INTERNAL inline __attribute__((always_inline))\012\012// Mark a function being deprecated.\012#define CM_DEPRECATED(Msg) __attribute__((deprecated(Msg)))\012// Mark a function being nodebug.\012#define CM_NODEBUG __attribute__((nodebug))\012// Mark a function being noinline\012#define CM_NOINLINE __attribute__((noinline))\012// Mark a function with inline attribute (CM-specific inline)\012#define CM_INLINE inline\012\012#ifdef __DISABLE_INLINING_ON_CM_LIBRARY_CALLS\012// TODO: probably CM library calls should have something like _CM_INLINE\012// instead of CM_INLINE, to separate internal defines from the ones used by\012// the client code.\012// Original CM_INLINE should be deprecated (excluded fro",
"m the spec).\012#undef CM_INLINE\012#define CM_INLINE\012#endif // __DISABLE_INLINING_ON_CM_LIBRARY_CALLS\012\012// Currently SPIRV adapter is unable to translate aggregate-related ops\012// properly, so we enforce always_inline for addc/subb\012#define __SPIRV_WRITER_INLINE_WA __CM_ALWAYS_INLINE_INTERNAL\012#ifdef __DISABLE_SPIRV_WRITER_INLINE_WA\012#undef __SPIRV_WRITER_INLINE_WA\012#define __SPIRV_WRITER_INLINE_WA CM_INLINE\012#endif // __DISABLE_SPIRV_WRITER_INLINE_WA\012\012// Currently CM print implementation requires it's library functions\012// to have always_inline attribute\012#define __CM_PRINT_INLINE_WA __CM_ALWAYS_INLINE_INTERNAL\012#ifdef __DISABLE_CM_PRINT_INLINE_WA\012#undef __CM_PRINT_INLINE_WA\012#define __CM_PRINT_INLINE_WA CM_INLINE\012#endif // __DISABLE_CM_PRINT_INLINE_WA\012\012// CM_STATIC_ERROR() and CM_STATIC_WARNING() are wrappers around the C++\012// static_assert mechanism that can be used to produce CM style diagnostics\012// rather than C++ style asserts. They should be used in preference to\012// static_assert within CM header files.\012#define CM_STA",
"TIC_ERROR(C, M) static_assert((C), \"CM:e:\" M)\012#define CM_STATIC_WARNING(C, M) static_assert((C), \"CM:w:\" M)\012\012// cm_label() is deprecated\012#define cm_label(...) CM_STATIC_WARNING(0, \"cm_label() is deprecated\")\012\012// L1 or L3 cache hint kinds.\012enum class CacheHint : uint8_t {\012  Default = 0,\012  Uncached = 1,\012  Cached = 2,\012  WriteBack = 3,\012  WriteThrough = 4,\012  Streaming = 5,\012  ReadInvalidate = 6\012};\012\012// Data size or format to read or store.\012enum class DataSize : uint8_t {\012  Default = 0,\012  U8 = 1,\012  U16 = 2,\012  U32 = 3,\012  U64 = 4,\012  U8U32 = 5,  // load 8b, zero extend to 32b; store the opposite\012  U16U32 = 6, // load 16b, zero extend to 32b; store the opposite\012  U16U32H = 7 // load 16b into high 16 of each 32b; store the high 16\012};\012\012// The number of elements to load per address (vector size)\012enum class VectorSize : uint8_t {\012  N0 = 0,\012  N1 = 1,  // 1 element\012  N2 = 2,  // 2 element\012  N3 = 3,  // 3 element\012  N4 = 4,  // 4 element\012  N8 = 5,  // 8 element\012  N16 = 6, // 16 element\012  N32 = 7, // 32 element\012  N64 = 8  // 64 e",
"lement\012};\012\012// LSC atomic op kind and encoding.\012enum class AtomicOp : uint8_t {\012  IINC = 0x08,\012  IDEC = 0x09,\012  LOAD = 0x0A,\012  STORE = 0x0B,\012  IADD = 0x0C,\012  ISUB = 0x0D,\012  SMIN = 0x0E,\012  SMAX = 0x0F,\012  UMIN = 0x10,\012  UMAX = 0x11,\012  ICAS = 0x12,\012  FADD = 0x13,\012  FSUB = 0x14,\012  FMIN = 0x15,\012  FMAX = 0x16,\012  FCAS = 0x17,\012  AND = 0x18,\012  OR = 0x19,\012  XOR = 0x1A\012};\012\012enum class LSC_SCOPE : uint8_t {\012  LSC_SCOPE_GROUP,\012  LSC_SCOPE_LOCAL,\012  LSC_SCOPE_TILE,\012  LSC_SCOPE_GPU,\012  LSC_SCOPE_GPUS,\012  LSC_SCOPE_SYSTEM,\012  LSC_SCOPE_SYSACQ\012};\012\012enum class LSC_FENCE_OP : uint8_t {\012  LSC_FENCE_OP_NONE,\012  LSC_FENCE_OP_EVICT,\012  LSC_FENCE_OP_INVALIDATE,\012  LSC_FENCE_OP_DISCARD,\012  LSC_FENCE_OP_CLEAN,\012  LSC_FENCE_OP_FLUSHL3\012};\012\012enum class LSC_SFID : uint8_t {\012  LSC_UGM,\012  LSC_UGML,\012  LSC_TGM,\012  LSC_SLM\012};\012\012#endif /* _CLANG_CM_COMMON_H_ */\012\000/*========================== begin_copyright_notice ============================\012\012Copyright (C) 2020-2021 Intel Corporation\012\012SPDX-License-Identifier: MIT\012\012============================= end_copyright_n",
"otice ===========================*/\012\012#if (__INCLUDE_LEVEL__ == 1)\012static_assert(0, \"CM:w:cm_cvt.h should not be included explicitly - only \"\012                 \"<cm/cm.h> is required\");\012#endif\012\012#ifndef _CLANG_CM_CVT_H_\012#define _CLANG_CM_CVT_H_\012\012#include \"cm_common.h\"\012#include \"cm_internal.h\"\012#include \"cm_traits.h\"\012#include \"cm_has_instr.h\"\012\012\012// float32 to tf32 convertion one direction\012template <typename T, typename T0, int N>\012CM_NODEBUG CM_INLINE vector<T, N> cm_tf32_cvt(vector<T0, N> src0) {\012  CM_STATIC_ERROR(\012      (std::is_same<int, typename std::remove_const<T>::type>::value &&\012       std::is_same<float, typename std::remove_const<T0>::type>::value),\012      \"Invalid type for cm_tf32_fp32_cvt: src->dst must be float->int\");\012  CM_HAS_TF32_CONTROL;\012\012  return details::__cm_intrinsic_impl_tf32_cvt<T>(src0);\012}\012\012template <typename T, typename T0, int N1, int N2>\012CM_NODEBUG CM_INLINE vector<T, N1 * N2>\012cm_tf32_cvt(matrix<T0, N1, N2> src) {\012  CM_HAS_TF32_CONTROL;\012\012  vector<T0, N1 *N2> _Src = src;\012  return cm_tf32_cvt",
"<T>(_Src);\012}\012\012template <typename T, typename T0>\012CM_NODEBUG CM_INLINE\012    typename std::enable_if<details::is_cm_scalar<T>::value &&\012                                details::is_cm_scalar<T0>::value,\012                            typename std::remove_const<T>::type>::type\012    cm_tf32_cvt(T0 src) {\012  CM_HAS_TF32_CONTROL;\012\012  vector<T0, 1> _Src = src;\012  vector<T, 1> _Result = cm_tf32_cvt<T>(_Src);\012  return _Result(0);\012}\012\012#endif // _CLANG_CM_CVT_H_\012\000/*========================== begin_copyright_notice ============================\012\012Copyright (C) 2014-2021 Intel Corporation\012\012SPDX-License-Identifier: MIT\012\012============================= end_copyright_notice ===========================*/\012\012#if (__INCLUDE_LEVEL__ == 1)\012static_assert(0, \"CM:w:cm_dataport.h should not be included explicitly - only \"\012                 \"<cm/cm.h> is required\");\012#endif\012\012#ifndef _CLANG_CM_DATAPORT_H_\012#define _CLANG_CM_DATAPORT_H_\012\012#include \"cm_util.h\"\012#include \"cm_internal.h\"\012\012typedef enum _CmFenceMask_ {\012  CM_GLOBAL_COHERENT_FENCE = 0x1,\012  CM_L3_F",
"LUSH_INSTRUCTIONS = 0x2,\012  CM_L3_FLUSH_TEXTURE_DATA = 0x4,\012  CM_L3_FLUSH_CONSTANT_DATA = 0x8,\012  CM_L3_FLUSH_RW_DATA = 0x10,\012  CM_LOCAL_BARRIER = 0x20,\012  CM_L1_FLUASH_RO_DATA = 0x40,\012  CM_SW_BARRIER = 0x80\012} CmFenceMask;\012\012#define MODIFIED(A) A, GENX_MODIFIED\012#define TOP_FIELD(A) A, GENX_TOP_FIELD\012#define BOTTOM_FIELD(A) A, GENX_BOTTOM_FIELD\012#define MODIFIED_TOP_FIELD(A) A, GENX_TOP_FIELD\012#define MODIFIED_BOTTOM_FIELD(A) A, GENX_BOTTOM_FIELD\012#define DWALIGNED(A) A, GENX_DWALIGNED\012#define MODIFIED_DWALIGNED(A) A, GENX_MODIFIED_DWALIGNED\012#define CONSTANT(A) A, GENX_CONSTANT\012#define CONSTANT_DWALIGNED(A) A, GENX_CONSTANT_DWALIGNED\012\012/// \\brief OWord block read.\012///\012/// @param idx Surface index, which must correspond to a buffer.\012///\012/// @param attr indicates the offset alignment and properties, one of ::GENX_NONE\012/// ::GENX_DWALIGNED ::GENX_MODIFIED_DWALIGNED ::GENX_CONSTANT_DWALIGNED.\012///\012/// @param offset zero based offset of the input buffer in bytes. Must be oword\012/// (i.e. 16 bytes) aligned unless one of the D",
"WALIGNED attributes is present.\012///\012/// @param output the data location to be read.\012///\012template <typename T, int N>\012CM_NODEBUG CM_INLINE void read(SurfaceIndex idx, CmBufferAttrib attr,\012                               int offset, vector_ref<T, N> output) {\012  constexpr unsigned _Sz = sizeof(T) * N;\012\012  if constexpr(_Sz < details::OWORD) {\012    constexpr unsigned _N = details::OWORD / sizeof(T);\012\012    // Choose implementation based on the buffer attribute. Since this attribute\012    // is not a compilation time constant, we cannot statically verify the\012    // requirement that attribute is either GENX_NONE or GENX_DWALIGNED. Leave\012    // this check to the emulation mode.\012    if (attr == GENX_DWALIGNED || attr == GENX_MODIFIED_DWALIGNED\012        || attr == GENX_CONSTANT_DWALIGNED) {\012      vector<T, _N> _Output =\012          details::__cm_intrinsic_impl_oword_read_dwaligned<T, _N>(idx, offset);\012      return details::if_assign(output, _Output);\012    }\012\012    // By default, no attribute.\012    vector<T, _N> _Output =\012        det",
"ails::__cm_intrinsic_impl_oword_read<T, _N>(idx, offset);\012    return details::if_assign(output, _Output);\012  }\012\012  // Check the data size.\012  CM_STATIC_ERROR(details::getNextPowerOf2(_Sz) <= 8 * details::OWORD,\012                  \"OWord block size must be at most 8\");\012\012  if constexpr(!details::isPowerOf2(_Sz)) {\012    constexpr unsigned _N = details::getNextPowerOf2(_Sz) / sizeof(T);\012\012    if (attr == GENX_DWALIGNED || attr == GENX_MODIFIED_DWALIGNED\012        || attr == GENX_CONSTANT_DWALIGNED) {\012      vector<T, _N> _Output =\012          details::__cm_intrinsic_impl_oword_read_dwaligned<T, _N>(idx, offset);\012      return details::if_assign(output, _Output);\012    }\012\012    // By default, no attribute.\012    vector<T, _N> _Output =\012        details::__cm_intrinsic_impl_oword_read<T, _N>(idx, offset);\012    return details::if_assign(output, _Output);\012  }\012\012  // No padding case.\012  if (attr == GENX_DWALIGNED || attr == GENX_MODIFIED_DWALIGNED\012      || attr == GENX_CONSTANT_DWALIGNED)\012    output =\012        details::__cm_intrinsic_impl_o",
"word_read_dwaligned<T, N>(idx, offset);\012  else\012    output = details::__cm_intrinsic_impl_oword_read<T, N>(idx, offset);\012}\012\012template <typename T, int N>\012CM_NODEBUG CM_INLINE void read(SurfaceIndex index, int X,\012                               vector_ref<T, N> src) {\012  read(index, GENX_NONE, X, src);\012}\012\012/// \\brief OWord block write.\012/// @param idx surface index, which must correspond to a buffer.\012///\012/// @param offset zero based offset of the input buffer in bytes.\012///\012/// @param src the data to be written. The size of vector can be only 1, 2, 4 or\012/// 8 owords.\012template <typename T, int N>\012CM_NODEBUG CM_INLINE void write(SurfaceIndex index, int offset,\012                                vector<T, N> src) {\012  constexpr unsigned Sz = N * sizeof(T);\012  CM_STATIC_ERROR(details::isPowerOf2(Sz) && Sz >= details::OWORD &&\012                      Sz <= 8 * details::OWORD,\012                  \"vector must be 1/2/4/8 OWords\");\012  details::__cm_intrinsic_impl_oword_write(index, offset, src);\012}\012\012/// \\brief HWord block read.\012/// @pa",
"ram idx surface index, which must correspond to a buffer.\012///\012/// @param offset zero based offset of the input buffer in bytes. Must be HWord aligned.\012///\012/// @param dst the data to be read. The size of vector can be only 1, 2, 4 or\012/// 8 HWords.\012template <int N>\012CM_NODEBUG CM_INLINE void cm_hword_read(SurfaceIndex index, uint offset,\012  vector_ref<uint, N> dst) {\012  vector<uint, 8> header = 0;\012  const uint exDesc = 0xa;\012  uint desc = cm_get_value(index);\012\012  constexpr unsigned Sz = sizeof(uint) * N;\012  CM_STATIC_ERROR(details::isPowerOf2(N) && Sz >= details::GRF &&\012    Sz <= 8 * details::GRF,\012    \"Data size must be 1/2/4/8 HWords\");\012\012  switch (N)\012  {\012  case 8:\012    desc |= (0x0 << 8);  // MESSAGE_SPECIFIC_CONTROL\012    break;\012  case 16:\012    desc |= (0x1 << 8);\012    break;\012  case 32:\012    desc |= (0x2 << 8);\012    break;\012  case 64:\012    desc |= (0x3 << 8);\012    break;\012  }\012\012  desc += 0x1 << 13;\012  desc += 0x1 << 14;\012  desc += 0x1 << 19;\012  desc += (N / 8) << 20;   // Response length\012  desc += 0x1 << 25;  // Msg length\012  head",
"er(2) = offset;\012\012  cm_send(dst.format<uint, 1, N>(), header.format<uint, 1, 8>(),\012    exDesc, desc, 0u);\012}\012\012/// \\brief HWord block write.\012/// @param idx surface index, which must correspond to a buffer.\012///\012/// @param offset zero based offset of the input buffer in bytes. Must be HWord aligned.\012///\012/// @param src the data to be written. The size of vector can be only 1, 2, 4 or\012/// 8 HWords.\012template <int N>\012CM_NODEBUG CM_INLINE void cm_hword_write(SurfaceIndex index, int offset,\012  vector<uint, N> src) {\012  vector<uint, 8> header = 0;\012  const uint exDesc = ((N / 8) << 6) + 0xa;\012  uint desc = cm_get_value(index);\012\012  constexpr unsigned Sz = sizeof(uint) * N;\012  CM_STATIC_ERROR(details::isPowerOf2(Sz) && Sz >= details::GRF &&\012    Sz <= 8 * details::GRF,\012    \"Data size must be 1/2/4/8 HWords\");\012\012  switch (N)\012  {\012  case 8:\012    desc |= (0x0 << 8);  // MESSAGE_SPECIFIC_CONTROL\012    break;\012  case 16:\012    desc |= (0x1 << 8);\012    break;\012  case 32:\012    desc |= (0x2 << 8);\012    break;\012  case 64:\012    desc |= (0x3 << 8);\012    b",
"reak;\012  }\012\012  desc += 0x1 << 13;\012  desc += 0x9 << 14;\012  desc += 0x1 << 19;\012  desc += 0x1 << 25;  // Msg length\012  header(2) = offset;\012\012  cm_sends(NULL, header.format<uint, 1, 8>(), src.format<uint, 1, N>(),\012    exDesc, desc, 0u);\012}\012\012/// \\brief QWord scattered read.\012/// @param idx surface index, which must correspond to a buffer.\012///\012/// @param offsets zero based offset for each elemet to be read.\012///\012/// @param data the data to be read. The size of vector can be only 8 or 16 QWords.\012template <typename T, uint C>\012CM_NODEBUG CM_INLINE\012typename std::enable_if<(sizeof(T) == 8) && ((C == 8) || (C == 16)),\012  void>::type\012cm_qword_scatter_read(SurfaceIndex idx, vector<uint, C> offsets, vector_ref<T, C> data)\012{\012  uint desc = cm_get_value(idx);\012  desc += (5 & 0x1F) << 14;\012  desc += (C / 8 - 1) << 8;\012  desc += (C / 4) << 20;\012  desc += (C / 8) << 25;\012  cm_send(data, offsets, 0xA, desc, 0u);\012}\012\012/// \\brief QWord scattered write.\012/// @param idx surface index, which must correspond to a buffer.\012///\012/// @param offsets zero base",
"d offset for each elemet to be written.\012///\012/// @param data the data to be written. The size of vector can be only 8 or 16 QWords.\012template <typename T, uint C>\012CM_NODEBUG CM_INLINE\012typename std::enable_if<(sizeof(T) == 8) && ((C == 8) || (C == 16)),\012  void>::type\012cm_qword_scatter_write(SurfaceIndex idx, vector<uint, C> offsets, vector_ref<T, C> data)\012{\012  uint desc = cm_get_value(idx);\012  desc += (13 & 0x1F) << 14;\012  desc += (C / 8 - 1) << 8;\012  desc += (C / 8) << 25;\012  cm_sends(NULL, offsets, data, (0xA | ((C / 4) << 6)), desc, 0u);\012}\012\012/// \\brief Media block read.\012///\012/// @param idx surface index, which must correspond to a 2D type surface.\012///\012/// @param attr attribute applied to the surface. Only ::GENX_TOP_FIELD,\012/// ::GENX_BOTTOM_FIELD and ::GENX_NONE are supported. ::GENX_TOP_FIELD\012/// indicates only the top field surface data are needed. ::BOTTOM_FIELD\012/// indicates only the bottom field surface data are needed.\012///\012/// @param X zero based X-coordinate of the left upper rectangle corner in\012/// bytes. For",
" regular surfaces, the X-offset must be pixel aligned. For\012/// surfaces with compact format (e.g., YUY2), this must be DWord (i.e. 4\012/// bytes) aligned.\012///\012/// @param Y zero based Y-coordinate of the left upper rectangle corner in rows.\012///\012/// @param output the data location to be read. the width of matrix m must be\012/// pixel aligned.\012///\012/// For out-of-bounds read, the address is clamped to the nearest edge of the\012/// surface, and the pixel in that position is returned. Out-of-bound behavior\012/// is undefined, however, if the surface width is not DWord-aligned.\012///\012\012#define MEDIA_READ_SWITCH(_Output, attr, _M)                                   \\\012  switch (attr) {                                                              \\\012  default:                                                                     \\\012    break;                                                                     \\\012  case GENX_NONE:                                                              \\\012    _Output = details::__cm_intrinsic_impl_m",
"edia_read<T, N, M, _M, GENX_NONE>( \\\012        idx, X, Y);                                                            \\\012    break;                                                                     \\\012  case GENX_TOP_FIELD:                                                         \\\012    _Output =                                                                  \\\012        details::__cm_intrinsic_impl_media_read<T, N, M, _M, GENX_TOP_FIELD>(  \\\012            idx, X, Y);                                                        \\\012    break;                                                                     \\\012  case GENX_BOTTOM_FIELD:                                                      \\\012    _Output = details::__cm_intrinsic_impl_media_read<                         \\\012        T, N, M, _M, GENX_BOTTOM_FIELD>(idx, X, Y);                            \\\012    break;                                                                     \\\012  case GENX_MODIFIED:                                                          \\\012    _Output =  ",
"                                                                \\\012        details::__cm_intrinsic_impl_media_read<T, N, M, _M, GENX_MODIFIED>(   \\\012            idx, X, Y);                                                        \\\012    break;                                                                     \\\012  }\012\012template <typename T, int N, int M>\012CM_NODEBUG CM_INLINE void read(SurfaceIndex idx, CmBufferAttrib attr, int X,\012                               int Y, matrix_ref<T, N, M> output) {\012\012  constexpr unsigned Width = M * sizeof(T);\012  constexpr unsigned RoundedWidth =\012      Width < 4 \? 4 : details::getNextPowerOf2(Width);\012  // Check the data sizes.\012  CM_STATIC_ERROR(RoundedWidth * N <= 256u,\012                  \"data does not fit into a single dataport transaction\");\012  CM_STATIC_ERROR(RoundedWidth <= 64u, \"valid block width is in range [1, 64]\");\012  CM_STATIC_ERROR(N <= 64u, \"valid block height is in range [1, 64]\");\012  if (Width != RoundedWidth) {\012    constexpr unsigned _M = RoundedWidth / sizeof(T);\012    matrix",
"<T, N, _M> _Output;\012    MEDIA_READ_SWITCH(_Output, attr, _M);\012    return details::if_assign(output, _Output.select<N, 1, M, 1>(0, 0));\012  }\012\012  // No padding.\012  MEDIA_READ_SWITCH(output, attr, M);\012}\012\012#undef MEDIA_READ_SWITCH\012\012template <typename T, int N, int M>\012CM_NODEBUG CM_INLINE void read(SurfaceIndex idx, int X, int Y,\012                               matrix_ref<T, N, M> output) {\012  read(idx, GENX_NONE, X, Y, output);\012}\012\012template <typename T, int N>\012CM_NODEBUG CM_INLINE void read(SurfaceIndex idx, int X, int Y,\012                               vector_ref<T, N> output) {\012  matrix_ref<T, 1, N> _Output = output.format<T, 1, N>();\012  read(idx, X, Y, _Output);\012}\012\012template <typename T, int N>\012CM_NODEBUG CM_INLINE void read(SurfaceIndex idx, CmBufferAttrib attr, int X,\012                               int Y, vector_ref<T, N> output) {\012  matrix_ref<T, 1, N> _Output = output.format<T, 1, N>();\012  read(idx, attr, X, Y, _Output);\012}\012\012/// \\brief Media block write\012///\012/// @param idx surface index, which must correspond to a 2D t",
"ype buffer.\012///\012/// @param attribute applied to the surface. Only ::GENX_TOP_FIELD,\012/// ::GENX_BOTTOM_FIELD and ::GENX_NONE are supported. ::GENX_TOP_FIELD\012/// indicates only the top field surface data are needed. ::BOTTOM_FIELD\012/// indicates only the bottom field surface data are needed.\012///\012/// @param X zero based X-coordinate of the left upper rectangle corner in\012/// bytes. For regular surfaces, the X-offset must be pixel aligned. For\012/// surfaces with compact format (e.g., YUY2), this must be DWord (i.e. 4\012/// bytes) aligned.\012///\012/// @param Y zero based Y-coordinate of the left upper rectangle corner in rows.\012///\012/// @param output the data to be written. The width of matrix must be DWord\012/// aligned.\012#define MEDIA_WRITE(attr)                                                      \\\012  details::__cm_intrinsic_impl_media_write<T, N, M, _M, attr>(idx, X, Y, _Src)\012\012template <typename T, int N, int M>\012CM_NODEBUG CM_INLINE void write(SurfaceIndex idx, CmBufferAttrib attr, int X,\012                                int",
" Y, matrix<T, N, M> src) {\012  constexpr unsigned Width = M * sizeof(T);\012  constexpr unsigned RoundedWidth =\012      Width < 4 \? 4 : details::getNextPowerOf2(Width);\012\012  // Check the data sizes.\012  CM_STATIC_ERROR(RoundedWidth * N <= 256u,\012                  \"data does not fit into a single dataport transaction\");\012  CM_STATIC_ERROR(RoundedWidth <= 64u, \"valid block width is in range [1, 64]\");\012  CM_STATIC_ERROR(N <= 64u, \"valid block height is in range [1, 64]\");\012\012  // Fix the register pitch alignment.\012  constexpr unsigned _M = RoundedWidth / sizeof(T);\012  matrix<T, N, _M> _Src;\012  _Src.select<N, 1, M, 1>() = src;\012\012  // Choose implementation based on the buffer attribute. Note that the real\012  // width will be also passed in due to pitch alignment fixing.\012  switch (attr) {\012  default:\012    break;\012  case GENX_NONE:\012    MEDIA_WRITE(GENX_NONE);\012    break;\012  case GENX_TOP_FIELD:\012    MEDIA_WRITE(GENX_TOP_FIELD);\012    break;\012  case GENX_BOTTOM_FIELD:\012    MEDIA_WRITE(GENX_BOTTOM_FIELD);\012    break;\012  }\012}\012#undef MEDIA_WRITE\012\012templ",
"ate <typename T, int N, int M>\012CM_NODEBUG CM_INLINE void write(SurfaceIndex idx, int X, int Y,\012                                matrix<T, N, M> src) {\012  write(idx, GENX_NONE, X, Y, src);\012}\012\012template <typename T, int N>\012CM_NODEBUG CM_INLINE void write(SurfaceIndex index, int X, int Y,\012                                vector<T, N> src) {\012  matrix<T, 1, N> _Src = src;\012  write(index, GENX_NONE, X, Y, _Src);\012}\012\012template <typename T, int N>\012CM_NODEBUG CM_INLINE void write(SurfaceIndex index, CmBufferAttrib attr, int X,\012                                int Y, vector<T, N> src) {\012  matrix<T, 1, N> _Src = src;\012  write(index, attr, X, Y, _Src);\012}\012\012template <typename T, int N, int M, int _M>\012CM_NODEBUG CM_INLINE void\012media_block_read_plane(SurfaceIndex idx, CmBufferAttrib attr,\012                       CmSurfacePlaneIndex plane, int X, int Y,\012                       matrix_ref<T, N, _M> _Output) {\012  if (plane == GENX_SURFACE_Y_PLANE) {\012    switch (attr) {\012    default:\012      break;\012    case GENX_NONE:\012      _Output = details::",
"__cm_intrinsic_impl_read_plane<\012          T, N, _M, GENX_NONE, GENX_SURFACE_Y_PLANE>(idx, X, Y);\012      break;\012    case GENX_TOP_FIELD:\012      _Output = details::__cm_intrinsic_impl_read_plane<\012          T, N, _M, GENX_TOP_FIELD, GENX_SURFACE_Y_PLANE>(idx, X, Y);\012      break;\012    case GENX_BOTTOM_FIELD:\012      _Output = details::__cm_intrinsic_impl_read_plane<\012          T, N, _M, GENX_BOTTOM_FIELD, GENX_SURFACE_Y_PLANE>(idx, X, Y);\012      break;\012    case GENX_MODIFIED:\012      _Output = details::__cm_intrinsic_impl_read_plane<\012          T, N, _M, GENX_MODIFIED, GENX_SURFACE_Y_PLANE>(idx, X, Y);\012      break;\012    } // switch\012  } else if ((plane == GENX_SURFACE_U_PLANE) ||\012             (plane == GENX_SURFACE_UV_PLANE)) {\012    switch (attr) {\012    default:\012      break;\012    case GENX_NONE:\012      _Output = details::__cm_intrinsic_impl_read_plane<\012          T, N, _M, GENX_NONE, GENX_SURFACE_U_PLANE>(idx, X, Y);\012      break;\012    case GENX_TOP_FIELD:\012      _Output = details::__cm_intrinsic_impl_read_plane<\012          T, N, _M,",
" GENX_TOP_FIELD, GENX_SURFACE_U_PLANE>(idx, X, Y);\012      break;\012    case GENX_BOTTOM_FIELD:\012      _Output = details::__cm_intrinsic_impl_read_plane<\012          T, N, _M, GENX_BOTTOM_FIELD, GENX_SURFACE_U_PLANE>(idx, X, Y);\012      break;\012    case GENX_MODIFIED:\012      _Output = details::__cm_intrinsic_impl_read_plane<\012          T, N, _M, GENX_MODIFIED, GENX_SURFACE_U_PLANE>(idx, X, Y);\012      break;\012    } // switch\012  } else if (plane == GENX_SURFACE_V_PLANE) {\012    switch (attr) {\012    default:\012      break;\012    case GENX_NONE:\012      _Output = details::__cm_intrinsic_impl_read_plane<\012          T, N, _M, GENX_NONE, GENX_SURFACE_V_PLANE>(idx, X, Y);\012      break;\012    case GENX_TOP_FIELD:\012      _Output = details::__cm_intrinsic_impl_read_plane<\012          T, N, _M, GENX_TOP_FIELD, GENX_SURFACE_V_PLANE>(idx, X, Y);\012      break;\012    case GENX_BOTTOM_FIELD:\012      _Output = details::__cm_intrinsic_impl_read_plane<\012          T, N, _M, GENX_BOTTOM_FIELD, GENX_SURFACE_V_PLANE>(idx, X, Y);\012      break;\012    case GENX_MODIFIED:\012   ",
"   _Output = details::__cm_intrinsic_impl_read_plane<\012          T, N, _M, GENX_MODIFIED, GENX_SURFACE_V_PLANE>(idx, X, Y);\012      break;\012    } // switch\012  }   // if\012}\012\012template <typename T, int N, int M>\012CM_NODEBUG CM_INLINE void read_plane(SurfaceIndex index, CmBufferAttrib attr,\012                                     CmSurfacePlaneIndex plane, int X, int Y,\012                                     matrix_ref<T, N, M> output) {\012  constexpr unsigned Width = M * sizeof(T);\012  if (Width < details::DWORD) {\012    constexpr unsigned _M = details::DWORD / sizeof(T);\012    matrix<T, N, _M> _Output;\012    media_block_read_plane<T, N, M, _M>(index, attr, plane, X, Y, _Output);\012    return details::if_assign(output, _Output);\012  }\012  if (!details::isPowerOf2(Width)) {\012    constexpr unsigned _M = details::getNextPowerOf2(Width) / sizeof(T);\012    matrix<T, N, _M> _Output;\012    media_block_read_plane<T, N, M, _M>(index, attr, plane, X, Y, _Output);\012    return details::if_assign(output, _Output);\012  }\012\012  // No padding.\012  media_block_read_pla",
"ne<T, N, M, M>(index, attr, plane, X, Y, output);\012};\012\012template <typename T, int N, int M>\012CM_NODEBUG CM_INLINE void read_plane(SurfaceIndex index,\012                                     CmSurfacePlaneIndex plane, int X, int Y,\012                                     matrix_ref<T, N, M> src) {\012  read_plane(index, GENX_NONE, plane, X, Y, src);\012};\012\012#define MEDIA_WRITE_PLANE(attr, plane)                                         \\\012  details::__cm_intrinsic_impl_write_plane<T, N, M, _M, attr, plane>(idx, X,   \\\012                                                                     Y, _Src)\012\012template <typename T, int N>\012CM_NODEBUG CM_INLINE void read_plane(SurfaceIndex idx,\012                                     CmSurfacePlaneIndex plane, int X, int Y,\012                                     vector_ref<T, N> output) {\012  matrix_ref<T, 1, N> _Output = output.format<T, 1, N>();\012  read_plane(idx, GENX_NONE, plane, X, Y, _Output);\012}\012\012template <typename T, int N>\012CM_NODEBUG CM_INLINE void read_plane(SurfaceIndex idx, CmBufferAttrib at",
"tr,\012                                     CmSurfacePlaneIndex plane, int X, int Y,\012                                     vector_ref<T, N> output) {\012  matrix_ref<T, 1, N> _Output = output.format<T, 1, N>();\012  read_plane(idx, attr, plane, X, Y, _Output);\012};\012\012#define MEDIA_WRITE_PLANE(attr, plane)                                         \\\012  details::__cm_intrinsic_impl_write_plane<T, N, M, _M, attr, plane>(idx, X,   \\\012                                                                     Y, _Src)\012\012template <typename T, int N, int M>\012CM_NODEBUG CM_INLINE void write_plane(SurfaceIndex idx, CmBufferAttrib attr,\012                                      CmSurfacePlaneIndex plane, int X, int Y,\012                                      matrix<T, N, M> src) {\012  constexpr unsigned Width = M * sizeof(T);\012  // Check the data alignment.\012  CM_STATIC_ERROR(Width % details::DWORD == 0,\012                  \"matrix block width must be DWord aligned\");\012  constexpr unsigned _M = details::getNextPowerOf2(Width) / sizeof(T);\012\012  // Check the dat",
"a sizes.\012  CM_STATIC_ERROR(_M * N * sizeof(T) <= 256u,\012                  \"data does not fit into a single dataport transaction\");\012  CM_STATIC_ERROR(_M <= 64u, \"valid block width is in range [1, 64]\");\012  CM_STATIC_ERROR(N <= 64u, \"valid block height is in range [1, 64]\");\012\012  // Fix the register pitch alignment.\012  matrix<T, N, _M> _Src;\012  _Src.select<N, 1, M, 1>() = src;\012\012  // Choose implementation based on the buffer attribute. Note that the real\012  // width will be also passed in due to pitch alignment fixing.\012  if (plane == GENX_SURFACE_Y_PLANE) {\012    switch (attr) {\012    default:\012      break;\012    case GENX_NONE:\012      MEDIA_WRITE_PLANE(GENX_NONE, GENX_SURFACE_Y_PLANE);\012      break;\012    case GENX_TOP_FIELD:\012      MEDIA_WRITE_PLANE(GENX_TOP_FIELD, GENX_SURFACE_Y_PLANE);\012      break;\012    case GENX_BOTTOM_FIELD:\012      MEDIA_WRITE_PLANE(GENX_BOTTOM_FIELD, GENX_SURFACE_Y_PLANE);\012      break;\012    } // switch\012  } else if ((plane == GENX_SURFACE_U_PLANE) ||\012             (plane == GENX_SURFACE_UV_PLANE)) {\012    switch (",
"attr) {\012    default:\012      break;\012    case GENX_NONE:\012      MEDIA_WRITE_PLANE(GENX_NONE, GENX_SURFACE_U_PLANE);\012      break;\012    case GENX_TOP_FIELD:\012      MEDIA_WRITE_PLANE(GENX_TOP_FIELD, GENX_SURFACE_U_PLANE);\012      break;\012    case GENX_BOTTOM_FIELD:\012      MEDIA_WRITE_PLANE(GENX_BOTTOM_FIELD, GENX_SURFACE_U_PLANE);\012      break;\012    } // switch\012  } else if (plane == GENX_SURFACE_V_PLANE) {\012    switch (attr) {\012    default:\012      break;\012    case GENX_NONE:\012      MEDIA_WRITE_PLANE(GENX_NONE, GENX_SURFACE_V_PLANE);\012      break;\012    case GENX_TOP_FIELD:\012      MEDIA_WRITE_PLANE(GENX_TOP_FIELD, GENX_SURFACE_V_PLANE);\012      break;\012    case GENX_BOTTOM_FIELD:\012      MEDIA_WRITE_PLANE(GENX_BOTTOM_FIELD, GENX_SURFACE_V_PLANE);\012      break;\012    } // switch\012  }   // if\012};\012#undef MEDIA_WRITE_PLANE\012\012template <typename T, int N, int M>\012CM_NODEBUG CM_INLINE void write_plane(SurfaceIndex index,\012                                      CmSurfacePlaneIndex plane, int X, int Y,\012                                      matrix<T, N, M> ",
"src) {\012  write_plane(index, GENX_NONE, plane, X, Y, src);\012};\012\012template <typename T, int N>\012CM_NODEBUG CM_INLINE void write_plane(SurfaceIndex index,\012                                      CmSurfacePlaneIndex plane, int X, int Y,\012                                      vector<T, N> src) {\012  matrix<T, 1, N> _Src = src;\012  write_plane(index, GENX_NONE, plane, X, Y, _Src);\012}\012\012template <typename T, int N>\012CM_NODEBUG CM_INLINE void write(SurfaceIndex index, CmBufferAttrib attr,\012                                CmSurfacePlaneIndex plane, int X, int Y,\012                                vector<T, N> src) {\012  matrix<T, 1, N> _Src = src;\012  write(index, attr, plane, X, Y, _Src);\012}\012\012/// \\brief Scaled scattered read.\012///\012/// \\param index surface index, which must correspond to a buffer.\012///\012/// \\param globalByteOffest zero based global offset of a set of scattered\012/// elements to be read from the surface. This offset is in bytes.\012///\012/// \\param elementByteOffset zero based offset of each element (relative to the\012/// global offset",
") to be read; ::N must be a power of 2 and at most 32. This\012/// offset is in bytes. Note 32 may not be hardware-native.\012///\012/// \\param ret the data location to store the return result.\012///\012/// ::T T can be either char, uchar, short, ushort, int, uint or float.\012///\012template <typename T, int N>\012CM_NODEBUG CM_INLINE\012typename std::enable_if<(sizeof(T) <= 4) && details::isPowerOf2(N, 32),\012                        void>::type\012read_scaled(SurfaceIndex index, uint globalByteOffest,\012            vector<uint, N> elementByteOffset, vector_ref<T, N> ret) {\012  if constexpr(sizeof(T) == 4)\012    ret = details::__cm_intrinsic_impl_scatter_read(\012        index, globalByteOffest, elementByteOffset, ret, T());\012  else {\012    typedef typename details::dword_type<T>::type T1;\012    vector<T1, N> _Ret;\012    // Data to read is a vector of dword type. The last dummy argument is\012    // to specify the element size.\012    ret = details::__cm_intrinsic_impl_scatter_read(\012        index, globalByteOffest, elementByteOffset, _Ret, T());\012  }\012}\012\012/// \\br",
"ief DWord scattered read.\012///\012/// \\param index surface index, which must correspond to a buffer.\012///\012/// \\param globalOffset zero based global offset of a set of scattered elements\012/// to be read from the surface. This offset is in units of elements.\012///\012/// \\param elementOffset zero based offset of each element (relative to the\012/// global offset) to be read; ::N must be a power of 2 and at most 32. This\012/// offset is in units of elements. 32 may not be hardware-native.\012///\012/// \\param ret the data location to store the return result.\012///\012/// ::T T can be either char, uchar, short, ushort, int, uint or float.\012///\012template <typename T, int N>\012CM_NODEBUG CM_INLINE\012typename std::enable_if<(sizeof(T) <= 4) && details::isPowerOf2(N, 32),\012                        void>::type\012read(SurfaceIndex index, uint globalOffset, vector<uint, N> elementOffset,\012     vector_ref<T, N> ret) {\012  globalOffset *= sizeof(T);\012  elementOffset *= sizeof(T);\012  read_scaled(index, globalOffset, elementOffset, ret);\012}\012\012// scattered read suppor",
"ts the CONSTANT and MODIFIED for surface attribute\012template <typename T, int N>\012CM_NODEBUG CM_INLINE\012typename std::enable_if<(sizeof(T) <= 4) && details::isPowerOf2(N, 32),\012                        void>::type\012read(SurfaceIndex index, CmBufferAttrib attr, uint globalOffset,\012     vector<uint, N> elementOffset, vector_ref<T, N> ret) {\012  if (attr == GENX_CONSTANT || attr == GENX_MODIFIED) {\012    read<T, N>(index, globalOffset, elementOffset, ret);\012  }\012}\012\012/// \\brief Scalar read.\012///\012/// \\param index surface index, which must correspond to a buffer.\012///\012/// \\param elementIndex zero based offset of the element.\012///        This offset is in units of elements.\012///\012/// ::T T can be any type <= 4 bytes\012///\012template<typename T>\012CM_NODEBUG CM_INLINE\012typename std::enable_if<(sizeof(T) <= 4), T>::type\012read(SurfaceIndex index, uint elementIndex) {\012  vector<T, 1> ret;\012  vector<uint, 1> offset = elementIndex * sizeof(T);\012\012  if constexpr(sizeof(T) == 4)\012    ret = details::__cm_intrinsic_impl_scatter_read(\012        index, 0, offse",
"t, ret, T());\012  else {\012    typedef typename details::dword_type<T>::type T1;\012    vector<T1, 1> _Ret;\012    // Data to read is a vector of dword type. The last dummy argument is\012    // to specify the element size.\012    ret = details::__cm_intrinsic_impl_scatter_read(\012        index, 0, offset, _Ret, T());\012  }\012\012  return ret(0);\012}\012\012/// \\brief Scaled scattered write.\012///\012/// \\param index surface index, which must correspond to a buffer.\012///\012/// \\param globalByteOffset zero based global offset of a set of scattered\012/// elements to be written to the surface. This offset is in units of bytes.\012///\012/// \\param elementByteOffset zero based offset of each element (relative to the\012/// global offset) to be written; ::N must be a power of 2 and at most 32. This\012/// offset is in units of bytes. 32 may not be hardware-native\012///\012/// \\param data the data to be written.\012///\012/// ::T T can be either char, uchar, short, ushort, int, uint or float.\012///\012/// Note: for any src < 4 bytes there is a cost to mov the value into a 4 byte\012/// t",
"ype (of which upper bytes are ignored)\012///\012template <typename T, int N>\012CM_NODEBUG CM_INLINE\012typename std::enable_if<(sizeof(T) <= 4) && details::isPowerOf2(N, 32),\012                        void>::type\012write_scaled(SurfaceIndex index, uint globalByteOffset,\012             vector<uint, N> elementByteOffset, vector<T, N> data) {\012  if constexpr(sizeof(T) == 4)\012    details::__cm_intrinsic_impl_scatter_write(index, globalByteOffset,\012                                               elementByteOffset, data, T());\012  else {\012    typedef typename details::dword_type<T>::type T1;\012    vector<T1, N> _Data = data;\012    // Data to write is a vector of dword type. The last dummy argument is\012    // to specify the element size.\012    details::__cm_intrinsic_impl_scatter_write(index, globalByteOffset,\012                                               elementByteOffset, _Data, T());\012  }\012}\012\012/// \\brief DWord scattered write.\012///\012/// \\param index surface index, which must correspond to a buffer.\012///\012/// \\param globalOffset zero based global of",
"fset of a set of scattered\012/// elements to be written to the surface. This offset is in units of elements.\012///\012/// \\param elementOffset zero based offset of each element (relative to the\012/// global offset) to be written; ::N must be a power of 2 and at most 32. This\012/// offset is in units of elements. 32 may not be hardware-native.\012///\012/// \\param data the data to be written.\012///\012/// ::T T can be either char, uchar, short, ushort, int, uint or float.\012///\012/// Note: for any src < 4 bytes there is a cost to mov the value into a 4 byte\012/// type (of which upper bytes are ignored)\012///\012template <typename T, int N>\012CM_NODEBUG CM_INLINE\012typename std::enable_if<(sizeof(T) <= 4) && details::isPowerOf2(N, 32),\012                        void>::type\012write(SurfaceIndex index, uint globalOffset, vector<uint, N> elementOffset,\012      vector<T, N> data) {\012  globalOffset *= sizeof(T);\012  elementOffset *= sizeof(T);\012  write_scaled(index, globalOffset, elementOffset, data);\012}\012\012/// \\brief Scalar dword write.\012///\012/// \\param index surfac",
"e index, which must correspond to a buffer.\012///\012/// \\param globaOffset zero based global offset of single element to be written\012/// to the surface. This offset is in units of elements.\012///\012/// \\param elementOffset zero based offset of the element (relative to the\012/// global offset) to be written. This offset is in units of elements.\012///\012/// \\param data the data to be written (in this case a scalar)\012///\012/// ::T T can be any type <= 4 bytes\012///\012/// Note: for any src < 4 bytes there is a cost to mov the value into a 4 byte\012/// type (of which upper bytes are ignored)\012///\012template <typename T>\012CM_NODEBUG CM_INLINE\012typename std::enable_if<(sizeof(T) <= 4) && details::is_cm_scalar<T>::value,\012                        void>::type\012write(SurfaceIndex index, uint globalOffset, uint elementOffset, T data) {\012  globalOffset *= sizeof(T);\012  elementOffset *= sizeof(T);\012  if constexpr(sizeof(T) == 4) {\012    vector<uint, 1> elementOffset_vec = elementOffset;\012    vector<T, 1> data_vec = data;\012    details::__cm_intrinsic_impl_scatt",
"er_write(index, globalOffset,\012                                               elementOffset_vec, data_vec, T());\012  } else {\012    typedef typename details::dword_type<T>::type T1;\012    vector<T1, 1> _Data = data;\012    // Data to write is a vector of dword type. The last dummy argument is\012    // to specify the element size.\012    vector<uint, 1> elementOffset_vec = elementOffset;\012    details::__cm_intrinsic_impl_scatter_write(index, globalOffset,\012                                               elementOffset_vec, _Data, T());\012  }\012}\012\012template <typename T>\012CM_NODEBUG CM_INLINE\012typename std::enable_if<(sizeof(T) <= 4) && details::is_cm_scalar<T>::value,\012                        void>::type\012write(SurfaceIndex index, uint elementOffset, T data) {\012  write<T>(index, 0, elementOffset, data);\012}\012\012/// \\brief Typed surface read.\012///\012/// \\param surfIndex surface index, which must correspond to a 1D, 2D or 3D\012/// surface.\012///\012/// \\param channelMask enabled channels. Must be a compile time constant.\012///\012/// \\param m the matrix to stor",
"e the return results. The type T must be of size\012/// of DWord (i.e., int, uint, or float). The size N1 is at least the number of\012/// enabled channels and N2 must be either 8, 16, or 32. 32 may not be native.\012///\012/// \\param u the x coordinates of the data elements to be read from surface,\012/// which\012/// must be in unit of pixels. The size N2 must be either 8, 16 or 32. 32 may\012/// not be hardware-native.\012///\012/// \\param v (optional, default = 0) the y coordinates of the data elements to\012/// be\012/// read from non-1D surface types; ignored otherwise.\012///\012/// \\param r (optional, default = 0) the z coordinates of the data elements to\012/// be read from 3D surface types; ignored otherwise.\012///\012/// The compiler generates code for GenX hardware to perform scattered read from\012/// the given offsets. The results are returned in ::m with each enabled channel\012/// returned in the next row of ::m. The enabled channels are returned in R, G,\012/// B, A order with no gap in ::m for disabled channels.\012///\012template <typename T, int N1, ",
"int N2>\012typename std::enable_if<\012    details::is_fp_or_dword_type<T>::value &&(N2 == 8 || N2 == 16 || N2 == 32)>::type\012read_typed(SurfaceIndex surfIndex, ChannelMaskType channelMask,\012           matrix_ref<T, N1, N2> m, vector<uint, N2> u, vector<uint, N2> v = 0,\012           vector<uint, N2> r = 0);\012\012template <typename T, int N>\012typename std::enable_if<\012    details::is_fp_or_dword_type<T>::value &&(N == 8 || N == 16 || N == 32)>::type\012read_typed(SurfaceIndex surfIndex, ChannelMaskType channelMask,\012           vector_ref<T, N> res, vector<uint, N> u, vector<uint, N> v = 0,\012           vector<uint, N> r = 0);\012\012/// \\brief Typed surface write.\012///\012/// \\param surfIndex surface index, which must correspond to a 1D, 2D or 3D\012/// surface.\012///\012/// \\param channelMask enabled channels. Must be a compile time constant.\012///\012/// \\param m the matrix that stores the data to be written. The type T must be\012/// of size of DWord (i.e., int, uint, or float). The size N1 is at least the\012/// number of enabled channels and N2 must be ei",
"ther 8, 16, or 32.\012/// 32 may not be hardware-native.\012///\012/// \\param u the x coordinates of the data elements to be read from surface,\012/// which must be in unit of pixels. The size N2 must be either 8 or 16.\012///\012/// \\param v (optional, default = 0) the y coordinates of the data elements to\012/// be read from non-1D surface types; ignored otherwise.\012///\012/// \\param r (optional, default = 0) the z coordinates of the data elements to\012/// be read from 3D surface types; ignored otherwise.\012///\012/// The compiler generates code for GenX hardware to perform scattered write to\012/// the given offsets. Only enabled channels are written to the surface.\012/// Out-of-bound reads return zero, while out-of-bound writes are dropped.\012///\012template <typename T, int N1, int N2>\012typename std::enable_if<\012    details::is_fp_or_dword_type<T>::value &&(N2 == 8 || N2 == 16 || N2 == 32)>::type\012write_typed(SurfaceIndex surfIndex, ChannelMaskType channelMask,\012            matrix<T, N1, N2> m, vector<uint, N2> u, vector<uint, N2> v = 0,\012           ",
" vector<uint, N2> r = 0);\012\012/// \\brief Untyped surface read.\012///\012/// \\param surfIndex surface index, which must correspond to a buffer.\012///\012/// \\param channelMask enabled channels. Must be a compile time constant.\012///\012/// \\param m the matrix that stores the data to be written. The type T must be\012/// of size of DWord (i.e., int, uint, or float). The size N1 is at least the\012/// number of enabled channels and N2 must be either 8, 16 or 32.\012/// 32 may not be hardware native.\012///\012/// \\param u the offsets of the date elements to be read from surface,\012/// which must be in unit of dwords. The size N2 must be either 8 or 16.\012///\012/// The compiler generates code for GenX hardware to perform scattered read from\012/// offsets given by ::u. The results are returned in ::m with each enabled\012/// channelreturned in the next row of ::m. The enabled channels are returned in\012/// R, G, B, A order with no gap in ::m for disabled channels.\012///\012template <typename T, int N1, int N2>\012typename std::enable_if<\012    details::is_fp_or_dword_t",
"ype<T>::value &&(N2 == 8 || N2 == 16 || N2 == 32)>::type\012read_untyped(SurfaceIndex surfIndex, ChannelMaskType channelMask,\012             matrix_ref<T, N1, N2> m, vector<uint, N2> u);\012\012/// \\brief Untyped surface write.\012///\012/// \\param surfIndex surface index, which must correspond to a buffer.\012///\012/// \\param channelMask enabled channels. Must be a compile time constant.\012///\012/// \\param m the matrix to store the return results. The type T must be of size\012/// of DWord (i.e., int, uint, or float). The size N1 is at least the number of\012/// enabled channels and N2 must be either 8, 16 or 32. 32 may not be native.\012///\012/// \\param u the offsets of the data elements to written surface, which must be\012/// in unit of DWords. The size N2 must be either 8, 16 or 32. 32 may not be native.\012///\012/// The compiler generates code for GenX hardware to perform scattered read from\012/// the given offsets. The results are returned in ::m with each enabled channel\012/// returned in the next row of ::m. The enabled channels are returned in R, ",
"G,\012/// B, A order with no gap in ::m for disabled channels.\012///\012template <typename T, int N1, int N2>\012typename std::enable_if<\012    details::is_fp_or_dword_type<T>::value &&(N2 == 8 || N2 == 16 || N2 == 32)>::type\012write_untyped(SurfaceIndex surfIndex, ChannelMaskType channelMask,\012              matrix<T, N1, N2> m, vector<uint, N2> u);\012\012/// \\brief Shared local memory read.\012///\012/// Read 8, 16, or 32 data elements (byte, word, or dword) from the SLM buffer\012/// ::slmBuffer at the element-offsets specified in ::vAddr, and write back into\012/// the vector ::vDst. 32-wide may not be hardware-native. \012///\012\012template <typename T, int N>\012CM_NODEBUG\012CM_INLINE typename std::enable_if<(N == 8 || N == 16 || N == 32) && (sizeof(T) == 4)>::type\012cm_slm_read_scaled(uint slmBuffer, vector<uint, N> vAddr, vector_ref<T, N> vDst) {\012  vDst = details::__cm_intrinsic_impl_slm_read<T, N, sizeof(T)>(slmBuffer,\012    vAddr, vDst);\012}\012\012template <typename T, int N>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012(N == 8 || N == 16 || N == 32) && (",
"sizeof(T) == 1 || sizeof(T) == 2)>::type\012cm_slm_read_scaled(uint slmBuffer, vector<uint, N> vAddr, vector_ref<T, N> vDst) {\012  typedef typename details::dword_type<T>::type T1;\012  vector<T1, N> _VDst = vDst;\012  vDst = details::__cm_intrinsic_impl_slm_read<T1, N, sizeof(T)>(slmBuffer,\012    vAddr, _VDst);\012}\012\012template <typename T, int N>\012CM_NODEBUG\012CM_INLINE typename std::enable_if<(N == 8 || N == 16 || N == 32) && (sizeof(T) == 4)>::type\012cm_slm_read_scaled(uint slmBuffer, vector<ushort, N> vAddr, vector_ref<T, N> vDst) {\012  vector<uint, N> _VAddr = vAddr;\012  cm_slm_read_scaled(slmBuffer, _VAddr, vDst);\012}\012\012template <typename T, int N>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012(N == 8 || N == 16 || N == 32) && (sizeof(T) == 1 || sizeof(T) == 2)>::type\012cm_slm_read_scaled(uint slmBuffer, vector<ushort, N> vAddr, vector_ref<T, N> vDst) {\012  vector<uint, N> _VAddr = vAddr;\012  cm_slm_read_scaled(slmBuffer, _VAddr, vDst);\012}\012\012template <typename T, int N>\012CM_NODEBUG\012CM_INLINE typename std::enable_if<(N == 8 || N == 16 || N =",
"= 32) && (sizeof(T) == 4)>::type\012cm_slm_read(uint slmBuffer, vector<uint, N> vAddr, vector_ref<T, N> vDst) {\012  vAddr = vAddr * sizeof(T);\012  vDst = details::__cm_intrinsic_impl_slm_read<T, N, sizeof(T)>(slmBuffer,\012                                                                vAddr, vDst);\012}\012\012template <typename T, int N>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012    (N == 8 || N == 16 || N == 32) && (sizeof(T) == 1 || sizeof(T) == 2)>::type\012cm_slm_read(uint slmBuffer, vector<uint, N> vAddr, vector_ref<T, N> vDst) {\012  typedef typename details::dword_type<T>::type T1;\012  vector<T1, N> _VDst = vDst;\012  vAddr = vAddr * sizeof(T);\012  vDst = details::__cm_intrinsic_impl_slm_read<T1, N, sizeof(T)>(slmBuffer,\012                                                                 vAddr, _VDst);\012}\012\012template <typename T, int N>\012CM_NODEBUG\012CM_INLINE typename std::enable_if<(N == 8 || N == 16 || N == 32) && (sizeof(T) == 4)>::type\012cm_slm_read(uint slmBuffer, vector<ushort, N> vAddr, vector_ref<T, N> vDst) {\012  vector<uint, N> _",
"VAddr = vAddr;\012  cm_slm_read(slmBuffer, _VAddr, vDst);\012}\012\012template <typename T, int N>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012    (N == 8 || N == 16 || N == 32) && (sizeof(T) == 1 || sizeof(T) == 2)>::type\012cm_slm_read(uint slmBuffer, vector<ushort, N> vAddr, vector_ref<T, N> vDst) {\012  vector<uint, N> _VAddr = vAddr;\012  cm_slm_read(slmBuffer, _VAddr, vDst);\012}\012\012/// \\brief Shared local memory write.\012///\012/// Write 8, 16 or 32 data elements (byte, word, or dword) given in the vector\012/// ::vSrc into the SLM buffer ::slmBuffer at the element-offsets specified in\012/// ::vAddr. Note that the addresses are in units of element size andd writes to\012/// overlapping addresses will have undefined write ordering. N = 8 or 16, and\012/// ::T could be of size byte, word or dword. 32 may not be hardware-native.\012///\012\012template <typename T, int N>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012(N == 8 || N == 16 || N == 32) && (sizeof(T) == 1 || sizeof(T) == 2)>::type\012cm_slm_write_scaled(uint slmBuffer, vector<uint, N> vAddr, vect",
"or<T, N> vSrc) {\012  typedef typename details::dword_type<T>::type T1;\012  vector<T1, N> _VSrc = vSrc;\012  details::__cm_intrinsic_impl_slm_write<T1, N, sizeof(T)>(slmBuffer, vAddr,\012    _VSrc);\012}\012\012template <typename T, int N>\012CM_NODEBUG\012CM_INLINE typename std::enable_if<(N == 8 || N == 16 || N ==32) && (sizeof(T) == 4)>::type\012cm_slm_write_scaled(uint slmBuffer, vector<uint, N> vAddr, vector<T, N> vSrc) {\012  details::__cm_intrinsic_impl_slm_write<T, N, sizeof(T)>(slmBuffer, vAddr,\012    vSrc);\012}\012\012template <typename T, int N>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012(N == 8 || N == 16 || N == 32) && (sizeof(T) == 1 || sizeof(T) == 2)>::type\012cm_slm_write_scaled(uint slmBuffer, vector<ushort, N> vAddr, vector<T, N> vSrc) {\012  vector<uint, N> _VAddr = vAddr;\012  cm_slm_write_scaled(slmBuffer, _VAddr, vSrc);\012}\012\012template <typename T, int N>\012CM_NODEBUG\012CM_INLINE typename std::enable_if<(N == 8 || N == 16 || N == 32) && (sizeof(T) == 4)>::type\012cm_slm_write_scaled(uint slmBuffer, vector<ushort, N> vAddr, vector<T, N> vSrc) {\012",
"  vector<uint, N> _VAddr = vAddr;\012  cm_slm_write_scaled(slmBuffer, _VAddr, vSrc);\012}\012\012template <typename T, int N>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012    (N == 8 || N == 16 || N == 32) && (sizeof(T) == 1 || sizeof(T) == 2)>::type\012cm_slm_write(uint slmBuffer, vector<uint, N> vAddr, vector<T, N> vSrc) {\012  typedef typename details::dword_type<T>::type T1;\012  vector<T1, N> _VSrc = vSrc;\012  vAddr = vAddr * sizeof(T);\012  details::__cm_intrinsic_impl_slm_write<T1, N, sizeof(T)>(slmBuffer, vAddr,\012                                                           _VSrc);\012}\012\012template <typename T, int N>\012CM_NODEBUG\012CM_INLINE typename std::enable_if<(N == 8 || N == 16 || N == 32) && (sizeof(T) == 4)>::type\012cm_slm_write(uint slmBuffer, vector<uint, N> vAddr, vector<T, N> vSrc) {\012  vAddr = vAddr * sizeof(T);\012  details::__cm_intrinsic_impl_slm_write<T, N, sizeof(T)>(slmBuffer, vAddr,\012                                                          vSrc);\012}\012\012template <typename T, int N>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012",
"    (N == 8 || N == 16 || N == 32) && (sizeof(T) == 1 || sizeof(T) == 2)>::type\012cm_slm_write(uint slmBuffer, vector<ushort, N> vAddr, vector<T, N> vSrc) {\012  vector<uint, N> _VAddr = vAddr;\012  cm_slm_write(slmBuffer, _VAddr, vSrc);\012}\012\012template <typename T, int N>\012CM_NODEBUG\012CM_INLINE typename std::enable_if<(N == 8 || N == 16 || N == 32) && (sizeof(T) == 4)>::type\012cm_slm_write(uint slmBuffer, vector<ushort, N> vAddr, vector<T, N> vSrc) {\012  vector<uint, N> _VAddr = vAddr;\012  cm_slm_write(slmBuffer, _VAddr, vSrc);\012}\012\012/// \\brief Shared local memmory read.\012///\012/// Read 8, 16, or 32 4-element vectors, say {R,G,B,A}, where each element is of size\012/// dword and is also referred to as a channel. The elements read from SLM are\012/// written back to the vector ::vDst and organized channel-wise, i.e. all R's\012/// followed by all G's, and so on. Address of each 4-element vector inside the\012/// SLM buffer 'slmBuffer' must be specified in ::vAddr. Note that the\012/// addresses are in units of element size. One or more channels in t",
"he\012/// 4-element vector could be masked, and ::vDst contains only the unmasked\012/// elements. Only the lower 4 bits of ::mask specify the elements masked. A '1'\012/// implies that the corresponding element of each vector will not be read from\012/// SLM. e.g. if mask = SLM_BR_ENABLE, ::vDst would contain\012/// B7B6B5B4B3B2B1B0\012/// R7R6R5R4R3R2R1R0\012/// where the data elements correspond to the 8 vectors\012/// (x B7 x R7), (x B6 x R6),... (x B0 x R0) read from SLM at the addresses\012/// specified in ::vAddr, where 'x' means the value is not read.\012///\012/// ::M must equal ::N * C where C is the number of channels enabled in ::mask.\012/// note: 32 may not hardware native.\012///\012template <typename T, int N, int M>\012typename std::enable_if<(N == 8 || N == 16 || N == 32) && (sizeof(T) == 4)>::type\012cm_slm_read4(uint slmBuffer, vector<uint, N> vAddr, vector_ref<T, M> vDst,\012             SLM_ChannelMaskType mask);\012\012template <typename T, int N, int M>\012CM_DEPRECATED(\012    \"please use 'cm_slm_read4' with 'uint' as the element offset type!\")\012 ",
"   CM_NODEBUG typename std::enable_if<\012        (N == 8 || N == 16 || N == 32) &&\012        (sizeof(T) == 4)>::type cm_slm_read4(uint slmBuffer,\012                                             vector<ushort, N> vAddr,\012                                             vector_ref<T, M> vDst,\012                                             SLM_ChannelMaskType mask);\012\012template <typename T, int N, int M>\012CM_DEPRECATED(\012    \"please use 'cm_slm_read4' with 'SLM_ChannelMaskType' as the mask type!\")\012    CM_NODEBUG typename std::enable_if<\012        (N == 8 || N == 16 || N == 32) &&\012        (sizeof(T) == 4)>::type cm_slm_read4(uint slmBuffer,\012                                             vector<uint, N> vAddr,\012                                             vector_ref<T, M> vDst, int mask);\012\012template <typename T, int N, int M>\012CM_DEPRECATED(\012    \"please use 'cm_slm_read4' with 'SLM_ChannelMaskType' as the mask type!\")\012    CM_NODEBUG typename std::enable_if<\012        (N == 8 || N == 16 || N == 32) &&\012        (sizeof(T) == 4)>::type cm_slm_r",
"ead4(uint slmBuffer,\012                                             vector<ushort, N> vAddr,\012                                             vector_ref<T, M> vDst, int mask);\012\012template <typename T, int N, int M>\012typename std::enable_if<(N == 8 || N == 16 || N == 32) && (sizeof(T) == 4)>::type\012cm_slm_read4_scaled(uint slmBuffer, vector<uint, N> vAddr, vector_ref<T, M> vDst,\012  SLM_ChannelMaskType mask);\012\012template <typename T, int N, int M>\012CM_DEPRECATED(\012  \"please use 'cm_slm_read4_scaled' with 'uint' as the element offset type!\")\012  CM_NODEBUG typename std::enable_if<\012  (N == 8 || N == 16 || N == 32) &&\012  (sizeof(T) == 4)>::type cm_slm_read4_scaled(uint slmBuffer,\012    vector<ushort, N> vAddr,\012    vector_ref<T, M> vDst,\012    SLM_ChannelMaskType mask);\012\012template <typename T, int N, int M>\012CM_DEPRECATED(\012  \"please use 'cm_slm_read4_scaled' with 'SLM_ChannelMaskType' as the mask type!\")\012  CM_NODEBUG typename std::enable_if<\012  (N == 8 || N == 16 || N == 32) &&\012  (sizeof(T) == 4)>::type cm_slm_read4_scaled(uint slmBuffer,\012",
"    vector<ushort, N> vAddr,\012    vector_ref<T, M> vDst, int mask);\012\012template <typename T, int N, int M>\012CM_DEPRECATED(\012  \"please use 'cm_slm_read4_scaled' with 'SLM_ChannelMaskType' as the mask type!\")\012  CM_NODEBUG typename std::enable_if<\012  (N == 8 || N == 16 || N == 32) &&\012  (sizeof(T) == 4)>::type cm_slm_read4_scaled(uint slmBuffer,\012    vector<uint, N> vAddr,\012    vector_ref<T, M> vDst, int mask);\012\012/// \\brief Share local memory write.\012///\012/// Write 8, 16, or 32 4-element vectors, say {R,G,B,A}, where each element is of\012/// size dword and is also referred to as a channel. The elements to be written\012/// must be in the vector ::vSrc and organized channel-wise, i.e. all R's\012/// followed by all G's, and so on. Address of each 4-element vector inside the\012/// SLM buffer ::slmBuffer must be specified in ::vAddr. Note that the\012/// addresses are in units of element size. One or more channels in the\012/// 4-element vector could be masked, and ::vSrc must contain only the unmasked\012/// or enabled elements. The argument ::",
"mask specifies the channels that are\012/// enabled. Only the enabled channels are written to SLM. E.g. if mask =\012/// SLM_BR_ENABLE (i.e. only R and B channels enabled), and vSrc is\012/// B7B6B5B4B3B2B1B0\012/// R7R6R5R4R3R2R1R0\012/// 8 vectors written to SLM are as\012/// (x B7 x R7), (x B6 x R6), ... (x B0 x R0)\012/// where 'x' means the value is not written.\012///\012/// M must equal N * C where C is the number of channels enabled in ::mask. T\012/// must be of size dword (int, uint, or float). ::mask specifies\012/// the channels that are enabled it has to be a compile-time constant of the\012/// enum type SLM_ChannelMaskType.\012template <typename T, int N, int M>\012typename std::enable_if<(N == 8 || N == 16 || N == 32) && (sizeof(T) == 4)>::type\012cm_slm_write4(uint slmBuffer, vector<uint, N> vAddr, vector<T, M> vSrc,\012              SLM_ChannelMaskType mask);\012\012template <typename T, int N, int M>\012CM_DEPRECATED(\012    \"please use 'cm_slm_write4' with 'uint' as the element offset type!\")\012    CM_NODEBUG typename std::enable_if<\012        (N == 8 |",
"| N == 16 || N == 32) &&\012        (sizeof(T) == 4)>::type cm_slm_write4(uint slmBuffer,\012                                              vector<ushort, N> vAddr,\012                                              vector<T, M> vSrc,\012                                              SLM_ChannelMaskType mask);\012\012template <typename T, int N, int M>\012CM_DEPRECATED(\012    \"please use 'cm_slm_write4' with 'SLM_ChannelMaskType' as the mask type!\")\012    CM_NODEBUG typename std::enable_if<\012        (N == 8 || N == 16 || N == 32) &&\012        (sizeof(T) == 4)>::type cm_slm_write4(uint slmBuffer,\012                                              vector<uint, N> vAddr,\012                                              vector<T, M> vSrc, int mask);\012\012template <typename T, int N, int M>\012CM_DEPRECATED(\012    \"please use 'cm_slm_write4' with 'SLM_ChannelMaskType' as the mask type!\")\012    CM_NODEBUG typename std::enable_if<\012        (N == 8 || N == 16 || N == 32) &&\012        (sizeof(T) == 4)>::type cm_slm_write4(uint slmBuffer,\012                                 ",
"             vector<ushort, N> vAddr,\012                                              vector<T, M> vSrc, int mask);\012\012template <typename T, int N, int M>\012typename std::enable_if<(N == 8 || N == 16 || N == 32) && (sizeof(T) == 4)>::type\012cm_slm_write4_scaled(uint slmBuffer, vector<uint, N> vAddr, vector<T, M> vSrc,\012  SLM_ChannelMaskType mask);\012\012template <typename T, int N, int M>\012CM_DEPRECATED(\012  \"please use 'cm_slm_write4_scaled' with 'uint' as the element offset type!\")\012  CM_NODEBUG typename std::enable_if<\012  (N == 8 || N == 16 || N == 32) &&\012  (sizeof(T) == 4)>::type cm_slm_write4_scaled(uint slmBuffer,\012    vector<ushort, N> vAddr,\012    vector<T, M> vSrc,\012    SLM_ChannelMaskType mask);\012\012template <typename T, int N, int M>\012CM_DEPRECATED(\012  \"please use 'cm_slm_write4_scaled' with 'SLM_ChannelMaskType' as the mask type!\")\012  CM_NODEBUG typename std::enable_if<\012  (N == 8 || N == 16 || N == 32) &&\012  (sizeof(T) == 4)>::type cm_slm_write4_scaled(uint slmBuffer,\012    vector<ushort, N> vAddr,\012    vector<T, M> vSrc, int mas",
"k);\012\012template <typename T, int N, int M>\012CM_DEPRECATED(\012  \"please use 'cm_slm_write4_scaled' with 'SLM_ChannelMaskType' as the mask type!\")\012  CM_NODEBUG typename std::enable_if<\012  (N == 8 || N == 16 || N == 32) &&\012  (sizeof(T) == 4)>::type cm_slm_write4_scaled(uint slmBuffer,\012    vector<uint, N> vAddr,\012    vector<T, M> vSrc, int mask);\012\012static const uint __cm_init_seq[8] = { 0, 1, 2, 3, 4, 5, 6, 7 };\012\012/// \\brief Shared local memory read.\012///\012/// Load ::size bytes from memory surface ::index starting at ::offset to the\012/// SLM buffer ::slmBuffer. ::size must be a multiple of 256.\012///\012template <typename T = void>\012CM_INLINE void cm_slm_load(uint slmBuffer, SurfaceIndex index, uint offset,\012                           uint size) {\012  vector<uint, 16> vOffset(__cm_init_seq);\012  vOffset.select<8, 1>(8) = vOffset.select<8, 1>(0) + 8;\012\012  uint numTotalBlocks = size / 256;\012  uint numGroups = cm_linear_local_size();\012  uint numBlocks = numTotalBlocks / numGroups;\012  uint numLeftOver = numTotalBlocks % numGroups;\012  numBlocks +",
"= (cm_linear_local_id() < numLeftOver) \? 1 : 0;\012\012  // We just need numBlocks and numGroups\012  uint elemSize = sizeof(float);\012  uint threadOffsetInSLM = cm_linear_local_id() * 256;\012  // in bytes\012  uint threadOffsetInMemory = offset + threadOffsetInSLM;\012  // in unit of elements\012  vector<uint, 16> vOffsets = (threadOffsetInSLM / elemSize) + vOffset * 4;\012\012  for (uint block = 0; block < numBlocks; block++) {\012    vector<uint, 32> row0; // 32 floats or 128 Bytes or 4 GRF-registers\012    vector<uint, 32> row1;\012    vector<uint, 64> rowTrans;\012    read(index, threadOffsetInMemory, row0);\012    read(index, threadOffsetInMemory + 128, row1);\012\012    // Transpose\012    rowTrans.select<8, 1>(0) = row0.select<8, 4>(0);\012    rowTrans.select<8, 1>(16) = row0.select<8, 4>(1);\012    rowTrans.select<8, 1>(32) = row0.select<8, 4>(2);\012    rowTrans.select<8, 1>(48) = row0.select<8, 4>(3);\012\012    rowTrans.select<8, 1>(8) = row1.select<8, 4>(0);\012    rowTrans.select<8, 1>(24) = row1.select<8, 4>(1);\012    rowTrans.select<8, 1>(40) = row1.select<8, 4>(2",
");\012    rowTrans.select<8, 1>(56) = row1.select<8, 4>(3);\012\012    cm_slm_write4(slmBuffer, vOffsets, rowTrans, SLM_ABGR_ENABLE);\012    threadOffsetInMemory += numGroups * 256;\012    vOffsets += numGroups * 64;\012  }\012\012#if CM_GENX > 900\012  cm_slm_fence(CM_GLOBAL_COHERENT_FENCE);\012#endif\012  cm_barrier();\012}\012\012/// cm_slm_atomic\012///\012/// This performs atomic read-modify-write operations on the destination\012/// locations addressed. The destination locations are given in ::vAddr and the\012/// desired atomic operation is specified as ::op. The value returned in ::vDst\012/// depends on the atomic operation. Whether the two optional sources, ::vSrc0\012/// and ::vSrc1, are needed also depends on the atomic operation.\012///\012/// * both vSrc0 and vSrc1 are required for ATOMIC_CMPXCHG\012/// * no source is required form ATOMIC_INC, ATOMIC_DEC, and ATOMIC_PREDEC\012/// * only vSrc0 is required for others\012/// * vDst is optionally be 0 which indicates no return value to be used.\012///\012/// Atomic operation ::op must be a compile-time constant.\012///\012template <ty",
"pename T, int N>\012typename std::enable_if<(N == 8 || N == 16 || N == 32) && sizeof(T) == 4, void>::type\012cm_slm_atomic(uint slmBuffer, CmAtomicOpType op, vector<ushort, N> vAddr,\012              vector_ref<T, N> vDst, vector<T, N> vSrc0, vector<T, N> vSrc1);\012\012template <typename T, int N>\012typename std::enable_if<(N == 8 || N == 16 || N == 32) && sizeof(T) == 4, void>::type\012cm_slm_atomic(uint slmBuffer, CmAtomicOpType op, vector<ushort, N> vAddr,\012              int dummy, vector<T, N> vSrc0, vector<T, N> vSrc1);\012\012template <typename T, int N>\012typename std::enable_if<(N == 8 || N == 16 || N == 32) && sizeof(T) == 4, void>::type\012cm_slm_atomic(uint slmBuffer, CmAtomicOpType op, vector<ushort, N> vAddr,\012              vector_ref<T, N> vDst);\012\012template <int N>\012typename std::enable_if<(N == 8 || N == 16 || N == 32), void>::type\012cm_slm_atomic(uint slmBuffer, CmAtomicOpType op, vector<ushort, N> vAddr,\012              int dummy);\012\012template <typename T, int N>\012typename std::enable_if<(N == 8 || N == 16 || N == 32) && sizeof(T) =",
"= 4, void>::type\012cm_slm_atomic(uint slmBuffer, CmAtomicOpType op, vector<ushort, N> vAddr,\012              vector_ref<T, N> vDst, vector<T, N> vSrc0);\012\012template <typename T, int N>\012typename std::enable_if<(N == 8 || N == 16 || N == 32) && sizeof(T) == 4, void>::type\012cm_slm_atomic(uint slmBuffer, CmAtomicOpType op, vector<ushort, N> vAddr,\012              int dummy, vector<T, N> vSrc0);\012\012/// \\brief SLM OWord block read.\012///\012/// @param slmBuffer, which must correspond to the slm buffer.\012///\012/// @param attr indicates the offset alignment and properties, one of ::GENX_NONE\012/// ::GENX_DWALIGNED ::GENX_MODIFIED_DWALIGNED ::GENX_CONSTANT_DWALIGNED.\012///\012/// @param offset zero based offset of the input buffer in bytes. Must be oword\012/// (i.e. 16 bytes) aligned unless one of the DWALIGNED attributes is present.\012///\012/// @param output the data location to be read.\012///\012template <typename T, int N>\012CM_NODEBUG CM_INLINE void cm_slm_block_read(uint slmBuffer, CmBufferAttrib attr,\012                                            int o",
"ffset,\012                                            vector_ref<T, N> output) {\012  constexpr unsigned _Sz = sizeof(T) * N;\012\012  if constexpr(_Sz < details::OWORD) {\012    constexpr unsigned _N = details::OWORD / sizeof(T);\012\012    // Choose implementation based on the buffer attribute. Since this attribute\012    // is not a compilation time constant, we cannot statically verify the\012    // requirement that attribute is either GENX_NONE or GENX_DWALIGNED. Leave\012    // this check to the emulation mode.\012    if (attr == GENX_DWALIGNED || attr == GENX_MODIFIED_DWALIGNED ||\012        attr == GENX_CONSTANT_DWALIGNED) {\012      vector<T, _N> _Output =\012          details::__cm_intrinsic_impl_slm_oword_read_dwaligned<T, _N>(\012              slmBuffer, offset);\012      return details::if_assign(output, _Output);\012    }\012\012    // By default, no attribute.\012    vector<T, _N> _Output =\012        details::__cm_intrinsic_impl_slm_oword_read<T, _N>(slmBuffer, offset);\012    return details::if_assign(output, _Output);\012  }\012\012  // Check the data size.\012  CM_ST",
"ATIC_ERROR(details::getNextPowerOf2(_Sz) <=\012                      details::getMaxNumOfOWordSLM() * details::OWORD,\012                  \"read must not exceed the maximal number of owords\");\012\012  if constexpr(!details::isPowerOf2(_Sz)) {\012    constexpr unsigned _N = details::getNextPowerOf2(_Sz) / sizeof(T);\012\012    if (attr == GENX_DWALIGNED || attr == GENX_MODIFIED_DWALIGNED\012        || attr == GENX_CONSTANT_DWALIGNED) {\012      vector<T, _N> _Output =\012          details::__cm_intrinsic_impl_slm_oword_read_dwaligned<T, _N>(slmBuffer, offset);\012      return details::if_assign(output, _Output);\012    }\012\012    // By default, no attribute.\012    vector<T, _N> _Output =\012        details::__cm_intrinsic_impl_slm_oword_read<T, _N>(slmBuffer, offset);\012    return details::if_assign(output, _Output);\012  }\012\012  // No padding case.\012  if (attr == GENX_DWALIGNED || attr == GENX_MODIFIED_DWALIGNED\012      || attr == GENX_CONSTANT_DWALIGNED)\012    output =\012        details::__cm_intrinsic_impl_slm_oword_read_dwaligned<T, N>(slmBuffer, offset);\012  else\012 ",
"   output = details::__cm_intrinsic_impl_slm_oword_read<T, N>(slmBuffer, offset);\012}\012\012template <typename T, int N>\012CM_NODEBUG CM_INLINE void cm_slm_block_read(uint slmBuffer, int X,\012                                            vector_ref<T, N> src) {\012  cm_slm_block_read(slmBuffer, GENX_NONE, X, src);\012}\012\012/// \\brief OWord block write.\012/// @param slmBuffer, index corresponds to the SLM buffer.\012///\012/// @param offset zero based offset of the input buffer in bytes.\012///\012/// @param src the data to be written. The size of vector can be only 1, 2, 4 or\012/// 8 owords.\012template <typename T, int N>\012CM_NODEBUG CM_INLINE void cm_slm_block_write(uint slmBuffer, int offset,\012                                vector<T, N> src) {\012  constexpr unsigned Sz = N * sizeof(T);\012  CM_STATIC_ERROR(details::isPowerOf2(Sz) && Sz >= details::OWORD &&\012                      Sz <= details::getMaxNumOfOWordSLM() * details::OWORD,\012                  \"vector must not exceed the maximal number of owords\");\012  details::__cm_intrinsic_impl_slm_oword_write(s",
"lmBuffer, offset, src);\012}\012\012#endif /* _CLANG_CM_DATAPORT_H_ */\012\000/*========================== begin_copyright_notice ============================\012\012Copyright (C) 2015-2021 Intel Corporation\012\012SPDX-License-Identifier: MIT\012\012============================= end_copyright_notice ===========================*/\012\012#if (__INCLUDE_LEVEL__ == 1)\012static_assert(0, \"CM:w:cm_gateway.h should not be included explicitly - only \"\012                 \"<cm/cm.h> is required\");\012#endif\012\012#ifndef _CLANG_CM_GATEWAY_H\012#define _CLANG_CM_GATEWAY_H\012\012#include \"cm_send.h\"\012#include \"cm_util.h\"\012\012\012// API for access to gateway hardware (e.g. thread sync monitors)\012\012typedef enum _SFID_GW {\012  SFID_GATEWAY = 0x03\012} SFID_GW;\012\012typedef enum _SubFuncID {\012  SUBID_RSVD_1 = 0x0,\012  SUBID_GW_SIGNAL_EVENT = 0x01,\012  SUBID_GW_MONITOR_EVENT = 0x02,\012  SUBID_GW_MONITOR_NO_EVENT = 0x03,\012  SUBID_GW_BARRIER = 0x04,\012  SUBID_RSVD_2 = 0x05,\012  SUBID_GW_WAIT_EVENT = 0x06,\012  SUBID_RSVD_3 = 0x07\012} SubFuncID;\012\012#ifndef CM_HAS_GATEWAY_EVENT\012\012#define signal_event(...)                   ",
"                                   \\\012  CM_STATIC_ERROR(0, \"Not supported feature for this platform\");\012#define monitor_event(...)                                                     \\\012  CM_STATIC_ERROR(0, \"Not supported feature for this platform\");\012#define monitor_no_event(...)                                                  \\\012  CM_STATIC_ERROR(0, \"Not supported feature for this platform\");\012#define wait_event(...)                                                        \\\012  CM_STATIC_ERROR(0, \"Not supported feature for this platform\");\012\012/// \\brief Wrapper function for cm_wait builtin\012///\012/// \\param mask 8 bit mask for which thread dependency to honour - if 1 then the\012/// dependency is ignored and the thread will not wait\012///\012/// This is actually a wrapper function for the call to the internal builtin\012/// (which will be overridden for later gen variants using the software\012/// scoreboard implementation)\012CM_INLINE void cm_wait(unsigned char mask = 0) { __cm_builtin_cm_wait(mask); }\012\012/// \\brief Wrapper function for",
" cm_signal - this is a no-op for < gen11\012///\012CM_INLINE void cm_signal() {}\012\012template <int NumDeps>\012CM_INLINE void cm_signal() {\012  constexpr unsigned N = details::getNextPowerOf2(NumDeps);\012  CM_STATIC_ERROR(N <= 8, \"the maximal number dependencies cannot exceed 8\");\012}\012\012#else // CM_HAS_GATEWAY_EVENT\012\012/// \\brief Hardware Thread Monitor signal event\012///\012/// \\param event_id 24 bit value for the event id (extra bits not checked)\012///\012/// Code is generated to perform the gateway operation \"signal event\" using the\012/// event_id passed in as the identifier. Only the bottom 24 bits are valid and\012/// any others are ignored\012///\012CM_INLINE void signal_event(unsigned int event_id) {\012  matrix<ushort, 1, 16> payload = 0;\012  unsigned msgLength = 1;\012  unsigned rspLength = 0;\012  uint msgDesc = (SUBID_GW_SIGNAL_EVENT & 0x7ffff) + (1 << 19) +\012                 ((rspLength & 0x1f) << 20) + ((msgLength & 0xf) << 25);\012  int dummy = 0;\012\012  payload.format<uint>()[0] = event_id;\012\012  cm_send(dummy, payload, SFID_GATEWAY, msgDesc, 0u /* sendc */",
");\012}\012\012/// \\brief Hardware Thread Monitor monitor_event event\012///\012/// \\param event_id 24 bit value for the event id (extra bits not checked)\012///\012/// Code is generated to perform the gateway operation \"monitor event\" using the\012/// event_id passed in as the identifier. Only the bottom 24 bits are valid and\012/// any others are ignored. Monitor event tells the hardware to include this\012/// thread in notification for changes to the specified event. (This is done\012/// through the wait call - wait with no monitor will cause immediate return\012/// with a value of 0)\012///\012CM_INLINE void monitor_event(unsigned int event_id) {\012  matrix<ushort, 1, 16> payload = 0;\012  unsigned msgLength = 1;\012  unsigned rspLength = 0;\012  uint msgDesc = (SUBID_GW_MONITOR_EVENT & 0x7ffff) + (1 << 19) +\012                 ((rspLength & 0x1f) << 20) + ((msgLength & 0xf) << 25);\012  int dummy = 0;\012\012  payload.format<uint>()[0] = event_id;\012\012  cm_send(dummy, payload, SFID_GATEWAY, msgDesc, 0u /* sendc */);\012}\012\012/// \\brief Hardware Thread Monitor monitor_no event",
"\012///\012///\012/// Code is generated to perform the gateway operation \"monitor no event\".\012/// This clears any events currently being monitored\012///\012\012CM_INLINE void monitor_no_event(void) {\012  matrix<ushort, 1, 16> payload = 0;\012  unsigned msgLength = 1;\012  unsigned rspLength = 0;\012  uint msgDesc = (SUBID_GW_MONITOR_NO_EVENT & 0x7ffff) + (1 << 19) +\012                 ((rspLength & 0x1f) << 20) + ((msgLength & 0xf) << 25);\012  int dummy = 0;\012  cm_send(dummy, payload, SFID_GATEWAY, msgDesc, 0u /* sendc */);\012}\012\012/// \\brief Hardware Thread Monitor wait event\012///\012/// \\param timer_value 10-bit value for the event id (should be compile time\012/// constant). A value of 0 causes an indefinite wait (i.e. no timeout)\012///\012/// Code is generated to perform the gateway operation \"wait\" using the\012/// timer_value passed in as the timeout. Only the bottom 10 bits are valid.\012/// Only one event may be monitored/waited on at a time\012///\012#if (CM_GENX >= 1270) // >= XeHP_SDV\012#define CM_WAIT_EVENT_SBARRIER\012#endif // >= XeHP_SDV\012\012#ifdef CM_WAIT_EVENT_S",
"BARRIER\012CM_INLINE void wait_event(unsigned short timer_value) {\012  matrix<ushort, 1, 16> payload = 0;\012  unsigned msgLength = 1;\012  unsigned rspLength = 0;\012  uint msgDesc = (SUBID_GW_WAIT_EVENT & 0x7ffff) + (1 << 19) +\012                 ((rspLength & 0x1f) << 20) + ((msgLength & 0xf) << 25);\012\012  payload.format<unsigned short>()[0] = timer_value;\012\012  cm_send(NULL, payload, SFID_GATEWAY, msgDesc, 0u /* sendc */);\012  cm_sbarrier(0);\012}\012#else // CM_WAIT_EVENT_SBARRIER\012CM_INLINE unsigned int wait_event(unsigned short timer_value) {\012  matrix<ushort, 1, 16> payload = 0;\012  matrix<ushort, 1, 16> response = 0;\012  unsigned msgLength = 1;\012  unsigned rspLength = 1;\012  uint msgDesc = (SUBID_GW_WAIT_EVENT & 0x7ffff) + (1 << 19) +\012    ((rspLength & 0x1f) << 20) + ((msgLength & 0xf) << 25);\012  int dummy = 0;\012\012  payload.format<unsigned short>()[0] = timer_value;\012\012  cm_send(response, payload, SFID_GATEWAY, msgDesc, 0u /* sendc */);\012  unsigned int lock = response.format<unsigned int>()[0];\012  __cm_builtin_dummy_mov(response.format<unsigned ",
"short>()[0]);\012\012  return lock;\012}\012#endif // CM_WAIT_EVENT_SBARRIER\012\012/// \\brief Wrapper function for cm_wait builtin\012///\012/// \\param mask 8 bit mask for which thread dependency to honour - if 1 then the\012/// dependency is ignored and the thread will not wait\012///\012/// This is actually a wrapper function for the call to the internal builtin\012/// (which will be overridden for later gen variants using the software\012/// scoreboard implementation)\012CM_INLINE void cm_wait(unsigned char mask = 0xff) {\012  SurfaceIndex BoardIdx = cm_scoreboard_bti();\012  matrix<uint, 1, 1> scoreboard_entry_value = 0;\012  int x1 = get_thread_origin_x();\012  int y1 = get_thread_origin_y();\012  int EventID = (y1 << 10) | x1;\012  monitor_event(EventID);\012  read(BoardIdx, x1 * 4, y1, scoreboard_entry_value); // offset is in bytes\012  while ((scoreboard_entry_value[0][0] & mask) != 0) {\012    wait_event(EventID);\012    read(BoardIdx, x1 * 4, y1, scoreboard_entry_value);\012  }\012\012  monitor_no_event();\012}\012\012/// \\brief Wrapper function for cm_signal - this is a no-op for < gen",
"11\012///\012CM_INLINE void cm_signal() {\012  int x1 = get_thread_origin_x();\012  int y1 = get_thread_origin_y();\012\012  SurfaceIndex BoardIdx = cm_scoreboard_bti();\012\012  vector<uchar, 8> Signals_InBytes;\012  Signals_InBytes.format<U32>()(0) = 0xF7FBFDFE;\012  Signals_InBytes.format<U32>()(1) = 0x7FBFDFEF;\012  vector<int, 8> Signals = Signals_InBytes;\012  vector<char, 16> depVec = cm_scoreboard_deltas();\012\012  // TODO: implement a runtime dependency count.\012  constexpr unsigned N = 8;\012  vector<uint, N> ThreadSpace_X = x1 - depVec.select<N, 1>(0);\012  vector<uint, N> ThreadSpace_Y = y1 - depVec.select<N, 1>(8);\012\012  vector<int, N> res;\012  write_typed_atomic<ATOMIC_AND>(BoardIdx, res, Signals.select<N, 1>(),\012                                 ThreadSpace_X,\012                                 ThreadSpace_Y); // for 2d atomic\012\012  #pragma unroll\012  for (unsigned i = 0; i < N; i++) {\012    unsigned EventID = (ThreadSpace_Y[i] << 10) | ThreadSpace_X[i];\012    signal_event(EventID);\012  }\012}\012\012/// This is more efficient than the one without specifing the maximal n",
"umber\012/// of depedencies.\012template <int NumDeps>\012CM_INLINE void cm_signal() {\012  constexpr unsigned N = details::getNextPowerOf2(NumDeps);\012  CM_STATIC_ERROR(N <= 8, \"the maximal number dependencies cannot exceed 8\");\012\012  int x1 = get_thread_origin_x();\012  int y1 = get_thread_origin_y();\012\012  SurfaceIndex BoardIdx = cm_scoreboard_bti();\012\012  vector<uchar, 8> Signals_InBytes;\012  Signals_InBytes.format<U32>()(0) = 0xF7FBFDFE;\012  Signals_InBytes.format<U32>()(1) = 0x7FBFDFEF;\012  vector<int, 8> Signals = Signals_InBytes;\012  vector<char, 16> depVec = cm_scoreboard_deltas();\012\012  vector<uint, N> ThreadSpace_X = x1 - depVec.select<N, 1>(0);\012  vector<uint, N> ThreadSpace_Y = y1 - depVec.select<N, 1>(8);\012\012  vector<int, N> res;\012  write_typed_atomic<ATOMIC_AND>(BoardIdx, res, Signals.select<N, 1>(),\012                                 ThreadSpace_X,\012                                 ThreadSpace_Y); // for 2d atomic\012\012  #pragma unroll\012  for (unsigned i = 0; i < N; i++) {\012    unsigned EventID = (ThreadSpace_Y[i] << 10) | ThreadSpace_X[i];\012 ",
"   signal_event(EventID);\012  }\012}\012#endif // CM_HAS_GATEWAY_EVENT\012\012template <typename T>\012CM_NODEBUG CM_INLINE\012typename std::enable_if<details::is_dword_type<T>::value,\012  void>::type\012cm_nbarrier_signal(\012  T barrierId,\012  T producerConsumerMode,\012  T numProducers,\012  T numConsumers)\012{\012  constexpr unsigned gateway = 3;\012  constexpr unsigned barrier = 4;\012\012  constexpr unsigned descriptor =\012    1 << 25 |  // Message length: 1 register\012    0 << 12 |  // Fence Data Ports: No fence\012    barrier;   // Barrier subfunction\012\012  vector<unsigned, 8> payload = 0;\012#ifndef CMRT_EMU\012  payload = cm_get_r0<unsigned>();\012#endif // CMRT_EMU\012\012  payload(2) =\012    (numConsumers & 0xff) << 24 |\012    (numProducers & 0xff) << 16 |\012    producerConsumerMode << 14 |\012    (barrierId & 0b11111) << 0;\012\012  cm_send(NULL, payload, gateway, descriptor, /* sendc = */ 0);\012}\012\012#endif /* _CLANG_CM_GATEWAY_H */\012\000/*========================== begin_copyright_notice ============================\012\012Copyright (C) 2014-2021 Intel Corporation\012\012SPDX-License-Identifier: MIT\012\012==",
"=========================== end_copyright_notice ===========================*/\012\012#ifndef _CLANG_CM_H_\012#define _CLANG_CM_H_\012\012#include \"cm_target.h\"\012#include \"cm_common.h\"\012#include \"cm_linear.h\"\012#include \"cm_send.h\"\012#include \"cm_atomic.h\"\012#include \"cm_dataport.h\"\012#include \"cm_has_instr.h\"\012#include \"cm_bfn.h\"\012#include \"cm_cvt.h\"\012#include \"cm_lsc.h\"\012#include \"cm_srnd.h\"\012#include \"cm_internal.h\"\012#include \"cm_sampler.h\"\012#include \"cm_traits.h\"\012#include \"cm_vme.h\"\012#include \"cm_gateway.h\"\012#include \"cm_svm.h\"\012#include \"cm_printf.h\"\012#include \"cm_mask.h\"\012#include \"cm_printfocl.h\"\012#include \"cm_spec_constant.h\"\012\012// cm_abs\012namespace details {\012\012template <typename T0, typename T1, int SZ>\012CM_NODEBUG CM_INLINE vector<T0, SZ>\012__cm_abs_common_internal(vector<T1, SZ> src0, int flag = _GENX_NOSAT) {\012  vector<T1, SZ> _Result =\012      std::is_unsigned<T1>::value \? src0 : __cm_intrinsic_impl_abs(src0);\012  if (flag != _GENX_SAT)\012    return _Result;\012\012  return __cm_intrinsic_impl_sat<T0>(_Result);\012}\012\012template <typename T0, typename T1, int",
" N1, int N2>\012CM_NODEBUG CM_INLINE vector<T0, N1 *N2>\012__cm_abs_common_internal(matrix<T1, N1, N2> src0, int flag = _GENX_NOSAT) {\012  vector<T1, N1 *N2> _Src0 = src0;\012  return __cm_abs_common_internal<T0>(_Src0, flag);\012}\012\012template <typename T0, typename T1>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012    details::is_cm_scalar<T0>::value &&details::is_cm_scalar<T1>::value,\012    typename std::remove_const<T0>::type>::type\012__cm_abs_common_internal(T1 src0, int flag = _GENX_NOSAT) {\012  typedef typename std::remove_const<T0>::type _T0;\012  typedef typename std::remove_const<T1>::type _T1;\012\012  vector<_T1, 1> _Src0 = src0;\012  vector<_T0, 1> _Result = __cm_abs_common_internal<_T0>(_Src0, flag);\012  return _Result(0);\012}\012}\012\012template <typename T0, typename T1, int SZ>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012    !std::is_same<typename std::remove_const<T0>::type,\012                  typename std::remove_const<T1>::type>::value,\012    vector<T0, SZ> >::type\012cm_abs(vector<T1, SZ> src0, int flag = _GENX_NOSAT) {\012  return details::",
"__cm_abs_common_internal<T0, T1, SZ>(src0, flag);\012}\012\012template <typename T0, typename T1, int N1, int N2>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012    !std::is_same<typename std::remove_const<T0>::type,\012                  typename std::remove_const<T1>::type>::value,\012    vector<T0, N1 *N2> >::type\012cm_abs(matrix<T1, N1, N2> src0, int flag = _GENX_NOSAT) {\012  return details::__cm_abs_common_internal<T0, T1, N1, N2>(src0, flag);\012}\012\012template <typename T0, typename T1>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012    !std::is_same<typename std::remove_const<T0>::type,\012                  typename std::remove_const<T1>::type>::value &&\012        details::is_cm_scalar<T0>::value && details::is_cm_scalar<T1>::value,\012    typename std::remove_const<T0>::type>::type\012cm_abs(T1 src0, int flag = _GENX_NOSAT) {\012  return details::__cm_abs_common_internal<T0, T1>(src0, flag);\012}\012\012template <typename T1, int SZ>\012CM_NODEBUG CM_INLINE vector<T1, SZ> cm_abs(vector<T1, SZ> src0,\012                                           int flag = _",
"GENX_NOSAT) {\012  return details::__cm_abs_common_internal<T1, T1, SZ>(src0, flag);\012}\012\012template <typename T1, int N1, int N2>\012CM_NODEBUG CM_INLINE vector<T1, N1 *N2> cm_abs(matrix<T1, N1, N2> src0,\012                                               int flag = _GENX_NOSAT) {\012  return details::__cm_abs_common_internal<T1, T1, N1, N2>(src0, flag);\012}\012\012template <typename T1>\012CM_NODEBUG\012CM_INLINE typename std::enable_if<details::is_cm_scalar<T1>::value,\012                                  typename std::remove_const<T1>::type>::type\012cm_abs(T1 src0, int flag = _GENX_NOSAT) {\012  return details::__cm_abs_common_internal<T1, T1>(src0, flag);\012}\012\012// cm_add\012template <typename T0, typename T1, int SZ, typename U>\012CM_NODEBUG CM_INLINE vector<T0, SZ> cm_add(vector<T1, SZ> src0, U src1,\012                                           int flag = _GENX_NOSAT) {\012  typedef typename details::computation_type<decltype(src0), U>::type\012  ComputationTy;\012  typename details::vector_type<ComputationTy>::type _Src0 = src0;\012  typename details::vector_typ",
"e<ComputationTy>::type _Src1 = src1;\012  return details::__cm_intrinsic_impl_add<T0>(_Src0, _Src1, flag);\012}\012\012template <typename T0, typename T1, int N1, int N2, typename U>\012CM_NODEBUG CM_INLINE vector<T0, N1 *N2> cm_add(matrix<T1, N1, N2> src0, U src1,\012                                               int flag = _GENX_NOSAT) {\012  vector<T1, N1 *N2> _Src0 = src0;\012  return cm_add<T0>(_Src0, src1, flag);\012}\012\012template <typename T0, typename T1, typename T2>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012    details::is_cm_scalar<T0>::value &&details::is_cm_scalar<T1>::value &&\012        details::is_cm_scalar<T2>::value,\012    typename std::remove_const<T0>::type>::type\012cm_add(T1 src0, T2 src1, int flag = _GENX_NOSAT) {\012  typedef typename details::computation_type<T1, T2>::type ComputationTy;\012  typename details::vector_type<ComputationTy>::type _Src0 = src0;\012  typename details::vector_type<ComputationTy>::type _Src1 = src1;\012  vector<T0, 1> _Result = cm_add<T0>(_Src0, _Src1, flag);\012  return _Result(0);\012}\012\012template <typename T0",
", typename T1, typename T2>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012    details::is_cm_scalar<T1>::value &&details::is_cm_vector<T2>::value,\012    decltype(cm_add<T0>(T2(), T1()))>::type\012cm_add(T1 src0, T2 src1, int flag = _GENX_NOSAT) {\012  return cm_add<T0>(src1, src0, flag);\012}\012\012// cm_addc\012template <int SZ>\012CM_NODEBUG __SPIRV_WRITER_INLINE_WA vector<unsigned, SZ>\012cm_addc(vector<unsigned, SZ> src0, vector<unsigned, SZ> src1,\012        vector_ref<unsigned, SZ> carry) {\012  return details::__cm_intrinsic_impl_addc(src0, src1, carry);\012}\012\012template <int SZ>\012CM_NODEBUG __SPIRV_WRITER_INLINE_WA vector<unsigned, SZ>\012cm_addc(vector<unsigned, SZ> src0, unsigned src1,\012        vector_ref<unsigned, SZ> carry) {\012  vector<unsigned, SZ> Src1 = src1;\012  return cm_addc(src0, Src1, carry);\012}\012\012template <int N1, int N2>\012CM_NODEBUG __SPIRV_WRITER_INLINE_WA matrix<unsigned, N1, N2>\012cm_addc(matrix<unsigned, N1, N2> src0, matrix<unsigned, N1, N2> src1,\012        matrix_ref<unsigned, N1, N2> carry) {\012  vector<unsigned, N1 *N2> Src0 = src0",
";\012  vector<unsigned, N1 *N2> Src1 = src1;\012  vector_ref<unsigned, N1 *N2> Carry = carry.format<unsigned>();\012  return cm_addc(Src0, Src1, Carry);\012}\012\012template <int N1, int N2>\012CM_NODEBUG __SPIRV_WRITER_INLINE_WA matrix<unsigned, N1, N2>\012cm_addc(matrix<unsigned, N1, N2> src0, unsigned src1,\012        matrix_ref<unsigned, N1, N2> carry) {\012  vector<unsigned, N1 *N2> Src0 = src0;\012  vector<unsigned, N1 *N2> Src1 = src1;\012  vector_ref<unsigned, N1 *N2> Carry = carry.format<unsigned>();\012  return cm_addc(Src0, Src1, Carry);\012}\012\012CM_NODEBUG __SPIRV_WRITER_INLINE_WA\012unsigned cm_addc(unsigned src0, unsigned src1, unsigned &carry) {\012  vector<unsigned, 1> Src0 = src0;\012  vector<unsigned, 1> Src1 = src1;\012  vector<unsigned, 1> Carry;\012  vector<unsigned, 1> Result = cm_addc(Src0, Src1, Carry);\012  carry = Carry(0);\012  return Result(0);\012}\012\012template <int SZ>\012CM_NODEBUG __SPIRV_WRITER_INLINE_WA vector<unsigned, SZ>\012cm_addc(unsigned src0, vector<unsigned, SZ> src1,\012        vector_ref<unsigned, SZ> carry) {\012  return cm_addc(src1, src0, carry)",
";\012}\012\012template <int N1, int N2>\012CM_NODEBUG __SPIRV_WRITER_INLINE_WA matrix<unsigned, N1, N2>\012cm_addc(unsigned src0, matrix<unsigned, N1, N2> src1,\012        matrix_ref<unsigned, N1, N2> carry) {\012  return cm_addc(src1, src0, carry);\012}\012\012// cm_subb\012template <int SZ>\012CM_NODEBUG __SPIRV_WRITER_INLINE_WA vector<unsigned, SZ>\012cm_subb(vector<unsigned, SZ> minuend, vector<unsigned, SZ> subtrahend,\012        vector_ref<unsigned, SZ> borrow) {\012  return details::__cm_intrinsic_impl_subb(minuend, subtrahend, borrow);\012}\012\012template <int SZ>\012CM_NODEBUG __SPIRV_WRITER_INLINE_WA vector<unsigned, SZ>\012cm_subb(vector<unsigned, SZ> minuend, unsigned subtrahend,\012        vector_ref<unsigned, SZ> borrow) {\012  vector<unsigned, SZ> Subtrahend = subtrahend;\012  return cm_subb(minuend, Subtrahend, borrow);\012}\012\012template <int N1, int N2>\012CM_NODEBUG __SPIRV_WRITER_INLINE_WA matrix<unsigned, N1, N2>\012cm_subb(matrix<unsigned, N1, N2> minuend, matrix<unsigned, N1, N2> subtrahend,\012        matrix_ref<unsigned, N1, N2> borrow) {\012  vector<unsigned, N1 *N2> M",
"inuend = minuend;\012  vector<unsigned, N1 *N2> Subtrahend = subtrahend;\012  vector_ref<unsigned, N1 *N2> Borrow = borrow.format<unsigned>();\012  return cm_subb(Minuend, Subtrahend, Borrow);\012}\012\012template <int N1, int N2>\012CM_NODEBUG __SPIRV_WRITER_INLINE_WA matrix<unsigned, N1, N2>\012cm_subb(matrix<unsigned, N1, N2> minuend, unsigned subtrahend,\012        matrix_ref<unsigned, N1, N2> borrow) {\012  vector<unsigned, N1 *N2> Minuend = minuend;\012  vector<unsigned, N1 *N2> Subtrahend = subtrahend;\012  vector_ref<unsigned, N1 *N2> Borrow = borrow.format<unsigned>();\012  return cm_subb(Minuend, Subtrahend, Borrow);\012}\012\012CM_NODEBUG __SPIRV_WRITER_INLINE_WA\012unsigned cm_subb(unsigned minuend, unsigned subtrahend, unsigned &borrow) {\012  vector<unsigned, 1> Minuend = minuend;\012  vector<unsigned, 1> Subtrahend = subtrahend;\012  vector<unsigned, 1> Borrow;\012  vector<unsigned, 1> Result = cm_subb(Minuend, Subtrahend, Borrow);\012  borrow = Borrow(0);\012  return Result(0);\012}\012\012template <int SZ>\012CM_NODEBUG __SPIRV_WRITER_INLINE_WA vector<unsigned, SZ>\012cm_sub",
"b(unsigned minuend, vector<unsigned, SZ> subtrahend,\012        vector_ref<unsigned, SZ> borrow) {\012  vector<unsigned, SZ> Minuend = minuend;\012  return cm_subb(Minuend, subtrahend, borrow);\012}\012\012template <int N1, int N2>\012CM_NODEBUG __SPIRV_WRITER_INLINE_WA matrix<unsigned, N1, N2>\012cm_subb(unsigned minuend, matrix<unsigned, N1, N2> subtrahend,\012        matrix_ref<unsigned, N1, N2> borrow) {\012  matrix<unsigned, N1, N2> Minuend = minuend;\012  return cm_subb(Minuend, subtrahend, borrow);\012}\012\012// cm_mul\012template <typename T0, typename T1, int SZ, typename U>\012CM_NODEBUG CM_INLINE vector<T0, SZ> cm_mul(vector<T1, SZ> src0, U src1,\012                                           int flag = _GENX_NOSAT) {\012  typedef typename details::computation_type<decltype(src0), U>::type\012  ComputationTy;\012  typename details::vector_type<ComputationTy>::type _Src0 = src0;\012  typename details::vector_type<ComputationTy>::type _Src1 = src1;\012  return details::__cm_intrinsic_impl_mul<T0>(_Src0, _Src1, flag);\012}\012\012template <typename T0, typename T1, int N1, i",
"nt N2, typename U>\012CM_NODEBUG CM_INLINE vector<T0, N1 *N2> cm_mul(matrix<T1, N1, N2> src0, U src1,\012                                               int flag = _GENX_NOSAT) {\012  vector<T1, N1 *N2> _Src0 = src0;\012  return cm_mul<T0>(_Src0, src1, flag);\012}\012\012template <typename T0, typename T1, typename T2>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012    details::is_cm_scalar<T0>::value &&details::is_cm_scalar<T1>::value &&\012        details::is_cm_scalar<T2>::value,\012    typename std::remove_const<T0>::type>::type\012cm_mul(T1 src0, T2 src1, int flag = _GENX_NOSAT) {\012  typedef typename details::computation_type<T1, T2>::type ComputationTy;\012  typename details::vector_type<ComputationTy>::type _Src0 = src0;\012  typename details::vector_type<ComputationTy>::type _Src1 = src1;\012  vector<T0, 1> _Result = cm_mul<T0>(_Src0, _Src1, flag);\012  return _Result(0);\012}\012\012template <typename T0, typename T1, typename T2>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012    details::is_cm_scalar<T1>::value &&details::is_cm_vector<T2>::value,\012    d",
"ecltype(cm_mul<T0>(T2(), T1()))>::type\012cm_mul(T1 src0, T2 src1, int flag = _GENX_NOSAT) {\012  return cm_mul<T0>(src1, src0, flag);\012}\012\012// cm_avg\012template <typename T0, typename T1, int SZ, typename U>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012    std::is_integral<T0>::value &&std::is_integral<T1>::value &&\012        std::is_integral<U>::value,\012    vector<T0, SZ> >::type\012cm_avg(vector<T1, SZ> src0, U src1, int flag = _GENX_NOSAT) {\012  typedef typename details::computation_type<decltype(src0), U>::type\012  ComputationTy;\012  typename details::vector_type<ComputationTy>::type _Src0 = src0;\012  typename details::vector_type<ComputationTy>::type _Src1 = src1;\012  return details::__cm_intrinsic_impl_avg<T0>(_Src0, _Src1, flag);\012}\012\012template <typename T0, typename T1, int N1, int N2, typename U>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012    std::is_integral<T0>::value &&std::is_integral<T1>::value &&\012        std::is_integral<U>::value,\012    vector<T0, N1 *N2> >::type\012cm_avg(matrix<T1, N1, N2> src0, U src1, int flag = _GENX_",
"NOSAT) {\012  vector<T1, N1 *N2> _Src0 = src0;\012  return cm_avg<T0>(_Src0, src1, flag);\012}\012\012template <typename T0, typename T1, typename T2>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012    details::is_cm_scalar<T0>::value &&details::is_cm_scalar<T1>::value &&\012        details::is_cm_scalar<T2>::value &&std::is_integral<T0>::value &&\012            std::is_integral<T1>::value &&std::is_integral<T2>::value,\012    typename std::remove_const<T0>::type>::type\012cm_avg(T1 src0, T2 src1, int flag = _GENX_NOSAT) {\012  typedef typename details::computation_type<T1, T2>::type ComputationTy;\012  typename details::vector_type<ComputationTy>::type _Src0 = src0;\012  typename details::vector_type<ComputationTy>::type _Src1 = src1;\012  vector<T0, 1> _Result = cm_avg<T0>(_Src0, _Src1, flag);\012  return _Result(0);\012}\012\012template <typename T0, typename T1, typename T2>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012    details::is_cm_scalar<T1>::value &&details::is_cm_vector<T2>::value &&\012        std::is_integral<T0>::value &&std::is_integral<T1>::val",
"ue &&\012            std::is_integral<T2>::value,\012    decltype(cm_avg<T0>(T2(), T1()))>::type\012cm_avg(T1 src0, T2 src1, int flag = _GENX_NOSAT) {\012  return cm_avg<T0>(src1, src0, flag);\012}\012\012// cm_shl\012template <typename T0, typename T1, int SZ, typename U>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012    std::is_integral<T0>::value &&std::is_integral<T1>::value &&\012        std::is_integral<U>::value,\012    vector<T0, SZ> >::type\012cm_shl(vector<T1, SZ> src0, U src1, int flag = _GENX_NOSAT) {\012  typedef typename details::computation_type<decltype(src0), U>::type\012  ComputationTy;\012  typename details::vector_type<ComputationTy>::type _Src0 = src0;\012  typename details::vector_type<ComputationTy>::type _Src1 = src1;\012  return details::__cm_intrinsic_impl_shl<T0>(_Src0, _Src1, flag);\012}\012\012template <typename T0, typename T1, int N1, int N2, typename U>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012    std::is_integral<T0>::value &&std::is_integral<T1>::value &&\012        std::is_integral<U>::value,\012    vector<T0, N1 *N2> >::type\012cm_sh",
"l(matrix<T1, N1, N2> src0, U src1, int flag = _GENX_NOSAT) {\012  vector<T1, N1 *N2> _Src0 = src0;\012  return cm_shl<T0>(_Src0, src1, flag);\012}\012\012template <typename T0, typename T1, typename T2>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012    details::is_cm_scalar<T0>::value &&details::is_cm_scalar<T1>::value &&\012        details::is_cm_scalar<T2>::value &&std::is_integral<T0>::value &&\012            std::is_integral<T1>::value &&std::is_integral<T2>::value,\012    typename std::remove_const<T0>::type>::type\012cm_shl(T1 src0, T2 src1, int flag = _GENX_NOSAT) {\012  typedef typename details::computation_type<T1, T2>::type ComputationTy;\012  typename details::vector_type<ComputationTy>::type _Src0 = src0;\012  typename details::vector_type<ComputationTy>::type _Src1 = src1;\012  vector<T0, 1> _Result = cm_shl<T0>(_Src0, _Src1, flag);\012  return _Result(0);\012}\012\012// cm_shr\012template <typename T0, typename T1, int SZ, typename U>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012    std::is_integral<T0>::value &&std::is_integral<T1>::value &&\012    ",
"    std::is_integral<U>::value,\012    vector<T0, SZ> >::type\012cm_shr(vector<T1, SZ> src0, U src1, int flag = _GENX_NOSAT) {\012  vector<T1, SZ> _Result = src0 >> src1;\012\012  if (flag != _GENX_SAT)\012    return _Result;\012\012  return details::__cm_intrinsic_impl_sat<T0>(_Result);\012}\012\012template <typename T0, typename T1, int N1, int N2, typename U>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012    std::is_integral<T0>::value &&std::is_integral<T1>::value &&\012        std::is_integral<U>::value,\012    vector<T0, N1 *N2> >::type\012cm_shr(matrix<T1, N1, N2> src0, U src1, int flag = _GENX_NOSAT) {\012  vector<T1, N1 *N2> _Src0 = src0;\012  return cm_shr<T0>(_Src0, src1, flag);\012}\012\012template <typename T0, typename T1, typename T2>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012    details::is_cm_scalar<T0>::value &&details::is_cm_scalar<T1>::value &&\012        details::is_cm_scalar<T2>::value &&std::is_integral<T0>::value &&\012            std::is_integral<T1>::value &&std::is_integral<T2>::value,\012    typename std::remove_const<T0>::type>::type\012cm_shr(",
"T1 src0, T2 src1, int flag = _GENX_NOSAT) {\012  typename details::vector_type<T1>::type _Src0 = src0;\012  typename details::vector_type<T2>::type _Src1 = src1;\012  vector<T0, 1> _Result = cm_shr<T0>(_Src0, _Src1, flag);\012  return _Result(0);\012}\012\012// cm_rol\012template <typename T0, typename T1, int SZ>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012    std::is_integral<T0>::value && std::is_integral<T1>::value,\012    vector<T0, SZ> >::type\012cm_rol(vector<T1, SZ> src0, vector<T1, SZ> src1) {\012  CM_HAS_BIT_ROTATE_CONTROL;\012  if constexpr (sizeof(T0) == sizeof(long long) || sizeof(T1) == sizeof(long long))\012    CM_HAS_BIT_ROTATE_64BIT_CONTROL;\012  return details::__cm_intrinsic_impl_rol<T0, T1, SZ>(src0, src1);\012}\012\012template <typename T0, typename T1, int SZ, typename U>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012    std::is_integral<T0>::value && std::is_integral<T1>::value &&\012        std::is_integral<U>::value,\012    vector<T0, SZ> >::type\012cm_rol(vector<T1, SZ> src0, U src1) {\012  typedef typename details::computation_type<decltype(s",
"rc0), U>::type\012  ComputationTy;\012  typename details::vector_type<ComputationTy>::type _Src0 = src0;\012  typename details::vector_type<ComputationTy>::type _Src1 = src1;\012  CM_HAS_BIT_ROTATE_CONTROL;\012  if constexpr (sizeof(T0) == sizeof(long long) || sizeof(T1) == sizeof(long long))\012    CM_HAS_BIT_ROTATE_64BIT_CONTROL;\012  return details::__cm_intrinsic_impl_rol<T0>(_Src0, _Src1);\012}\012\012template <typename T0, typename T1, int N1, int N2, typename U>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012    std::is_integral<T0>::value && std::is_integral<T1>::value &&\012        std::is_integral<U>::value,\012    vector<T0, N1 * N2> >::type\012cm_rol(matrix<T1, N1, N2> src0, U src1) {\012  vector<T1, N1 * N2> _Src0 = src0;\012  return cm_rol<T0>(_Src0, src1);\012}\012\012template <typename T0, typename T1, typename T2>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012    details::is_cm_scalar<T0>::value && details::is_cm_scalar<T1>::value &&\012        details::is_cm_scalar<T2>::value && std::is_integral<T0>::value &&\012            std::is_integral<T1>::value",
" && std::is_integral<T2>::value,\012    typename std::remove_const<T0>::type>::type\012cm_rol(T1 src0, T2 src1) {\012  typedef typename details::computation_type<T1, T2>::type ComputationTy;\012  typename details::vector_type<ComputationTy>::type _Src0 = src0;\012  typename details::vector_type<ComputationTy>::type _Src1 = src1;\012  vector<T0, 1> _Result = cm_rol<T0>(_Src0, _Src1);\012  return _Result(0);\012}\012\012// cm_ror\012template <typename T0, typename T1, int SZ>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012    std::is_integral<T0>::value && std::is_integral<T1>::value,\012    vector<T0, SZ> >::type\012cm_ror(vector<T1, SZ> src0, vector<T1, SZ> src1) {\012  CM_HAS_BIT_ROTATE_CONTROL;\012  if constexpr (sizeof(T0) == sizeof(long long) || sizeof(T1) == sizeof(long long))\012    CM_HAS_BIT_ROTATE_64BIT_CONTROL;\012  return details::__cm_intrinsic_impl_ror<T0, T1, SZ>(src0, src1);\012}\012\012template <typename T0, typename T1, int SZ, typename U>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012    std::is_integral<T0>::value && std::is_integral<T1>::value &&\012  ",
"      std::is_integral<U>::value,\012    vector<T0, SZ> >::type\012cm_ror(vector<T1, SZ> src0, U src1) {\012  typedef typename details::computation_type<decltype(src0), U>::type\012  ComputationTy;\012  typename details::vector_type<ComputationTy>::type _Src0 = src0;\012  typename details::vector_type<ComputationTy>::type _Src1 = src1;\012  CM_HAS_BIT_ROTATE_CONTROL;\012  if constexpr (sizeof(T0) == sizeof(long long) || sizeof(T1) == sizeof(long long))\012    CM_HAS_BIT_ROTATE_64BIT_CONTROL;\012  return details::__cm_intrinsic_impl_ror<T0>(_Src0, _Src1);\012}\012\012template <typename T0, typename T1, int N1, int N2, typename U>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012    std::is_integral<T0>::value && std::is_integral<T1>::value &&\012        std::is_integral<U>::value,\012    vector<T0, N1 * N2> >::type\012cm_ror(matrix<T1, N1, N2> src0, U src1) {\012  vector<T1, N1 * N2> _Src0 = src0;\012  return cm_ror<T0>(_Src0, src1);\012}\012\012template <typename T0, typename T1, typename T2>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012    details::is_cm_scalar<T0>::value",
" && details::is_cm_scalar<T1>::value &&\012        details::is_cm_scalar<T2>::value && std::is_integral<T0>::value &&\012            std::is_integral<T1>::value && std::is_integral<T2>::value,\012    typename std::remove_const<T0>::type>::type\012cm_ror(T1 src0, T2 src1) {\012  typedef typename details::computation_type<T1, T2>::type ComputationTy;\012  typename details::vector_type<ComputationTy>::type _Src0 = src0;\012  typename details::vector_type<ComputationTy>::type _Src1 = src1;\012  vector<T0, 1> _Result = cm_ror<T0>(_Src0, _Src1);\012  return _Result(0);\012}\012\012// cm_lsr\012template <typename T0, typename T1, int SZ, typename U>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012    std::is_integral<T0>::value &&std::is_integral<T1>::value &&\012        std::is_integral<U>::value,\012    vector<T0, SZ> >::type\012cm_lsr(vector<T1, SZ> src0, U src1, int flag = _GENX_NOSAT) {\012  typedef typename details::computation_type<T1, T1>::type _IntermedTy;\012  typedef typename details::make_unsigned<_IntermedTy>::type ComputationTy;\012  vector<ComputationTy, SZ> ",
"_Src0 = src0;\012  vector<ComputationTy, SZ> _Result = _Src0 >> src1;\012\012  if (flag != _GENX_SAT)\012    return _Result;\012\012  return details::__cm_intrinsic_impl_sat<T0>(_Result);\012}\012\012template <typename T0, typename T1, int N1, int N2, typename U>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012    std::is_integral<T0>::value &&std::is_integral<T1>::value &&\012        std::is_integral<U>::value,\012    vector<T0, N1 *N2> >::type\012cm_lsr(matrix<T1, N1, N2> src0, U src1, int flag = _GENX_NOSAT) {\012  vector<T1, N1 *N2> _Src0 = src0;\012  return cm_lsr<T0>(_Src0, src1, flag);\012}\012\012template <typename T0, typename T1, typename T2>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012    details::is_cm_scalar<T0>::value &&details::is_cm_scalar<T1>::value &&\012        details::is_cm_scalar<T2>::value &&std::is_integral<T0>::value &&\012            std::is_integral<T1>::value &&std::is_integral<T2>::value,\012    typename std::remove_const<T0>::type>::type\012cm_lsr(T1 src0, T2 src1, int flag = _GENX_NOSAT) {\012  typedef typename details::computation_type<T1, T2",
">::type ComputationTy;\012  typename details::vector_type<ComputationTy>::type _Src0 = src0;\012  typename details::vector_type<ComputationTy>::type _Src1 = src1;\012  vector<T0, 1> _Result = cm_lsr<T0>(_Src0, _Src1, flag);\012  return _Result(0);\012}\012\012template <typename T0, typename T1, typename T2>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012    details::is_cm_scalar<T1>::value &&details::is_cm_vector<T2>::value &&\012        std::is_integral<T0>::value &&std::is_integral<T1>::value &&\012            std::is_integral<T2>::value,\012    decltype(cm_lsr<T0>(T2(), T1()))>::type\012cm_lsr(T1 src0, T2 src1, int flag = _GENX_NOSAT) {\012  return cm_lsr<T0>(src1, src0, flag);\012}\012\012// cm_asr\012template <typename T0, typename T1, int SZ, typename U>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012    std::is_integral<T0>::value &&std::is_integral<T1>::value &&\012        std::is_integral<U>::value,\012    vector<T0, SZ> >::type\012cm_asr(vector<T1, SZ> src0, U src1, int flag = _GENX_NOSAT) {\012  typedef typename details::computation_type<T1, T1>::type _Interm",
"edTy;\012  typedef typename details::make_signed<_IntermedTy>::type ComputationTy;\012  vector<ComputationTy, SZ> _Src0 = src0;\012  vector<ComputationTy, SZ> _Result = _Src0 >> src1;\012\012  if (flag != _GENX_SAT)\012    return _Result;\012\012  return details::__cm_intrinsic_impl_sat<T0>(_Result);\012}\012\012template <typename T0, typename T1, int N1, int N2, typename U>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012    std::is_integral<T0>::value &&std::is_integral<T1>::value &&\012        std::is_integral<U>::value,\012    vector<T0, N1 *N2> >::type\012cm_asr(matrix<T1, N1, N2> src0, U src1, int flag = _GENX_NOSAT) {\012  vector<T1, N1 *N2> _Src0 = src0;\012  return cm_asr<T0>(_Src0, src1, flag);\012}\012\012template <typename T0, typename T1, typename T2>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012    details::is_cm_scalar<T0>::value &&details::is_cm_scalar<T1>::value &&\012        details::is_cm_scalar<T2>::value &&std::is_integral<T0>::value &&\012            std::is_integral<T1>::value &&std::is_integral<T2>::value,\012    typename std::remove_const<T0>::type>:",
":type\012cm_asr(T1 src0, T2 src1, int flag = _GENX_NOSAT) {\012  typedef typename details::computation_type<T1, T2>::type ComputationTy;\012  typename details::vector_type<ComputationTy>::type _Src0 = src0;\012  typename details::vector_type<ComputationTy>::type _Src1 = src1;\012  vector<T0, 1> _Result = cm_asr<T0>(_Src0, _Src1, flag);\012  return _Result(0);\012}\012\012template <typename T0, typename T1, typename T2>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012    details::is_cm_scalar<T1>::value &&details::is_cm_vector<T2>::value &&\012        std::is_integral<T0>::value &&std::is_integral<T1>::value &&\012            std::is_integral<T2>::value,\012    decltype(cm_asr<T0>(T2(), T1()))>::type\012cm_asr(T1 src0, T2 src1, int flag = _GENX_NOSAT) {\012  return cm_asr<T0>(src1, src0, flag);\012}\012\012// vector cm_imul\012template <typename T0, typename T, int SZ>\012CM_NODEBUG CM_INLINE\012    typename std::enable_if<details::is_dword_type<T0>::value &&\012                                details::is_dword_type<T>::value && SZ != 1,\012                            vector<T",
"0, SZ> >::type\012cm_imul(vector_ref<T, SZ> lo, vector<T, SZ> src0, vector<T, SZ> src1) {\012  return details::__cm_intrinsic_impl_imad(lo, src0, src1,\012                                           static_cast<vector<T, SZ> >(0));\012}\012\012// scalar cm_imul\012template <typename T0, typename T>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012    details::is_cm_scalar<T0>::value && details::is_dword_type<T0>::value &&\012        details::is_cm_scalar<T>::value && details::is_dword_type<T>::value,\012    T0>::type\012cm_imul(T &lo, T src0, T src1) {\012  return details::__cm_intrinsic_impl_imad(lo, src0, src1, static_cast<T>(0));\012}\012\012// cm_imul wrappers\012template <typename T0, typename T>\012CM_NODEBUG CM_INLINE\012    typename std::enable_if<details::is_dword_type<T0>::value &&\012                                details::is_dword_type<T>::value,\012                            vector<T0, 1> >::type\012cm_imul(vector_ref<T, 1> lo, vector<T, 1> src0, vector<T, 1> src1) {\012  T Src0 = src0(0);\012  T Src1 = src1(0);\012  T Lo;\012  T0 Res = cm_imul<T0>(Lo, Src0, Src1);\012  l",
"o(0) = Lo;\012  return Res;\012}\012\012template <typename T0, typename T1, typename U, int SZ>\012CM_NODEBUG CM_INLINE\012    typename std::enable_if<details::is_dword_type<T0>::value &&\012                                details::is_dword_type<T1>::value &&\012                                details::is_dword_type<U>::value,\012                            vector<T0, SZ> >::type\012cm_imul(vector_ref<T0, SZ> lo, vector<T1, SZ> src0, U src1) {\012  typedef typename details::computation_type<decltype(src0), U>::type\012  ComputationTy;\012  typename details::vector_type<ComputationTy>::type Src0 = src0;\012  typename details::vector_type<ComputationTy>::type Src1 = src1;\012  typename details::vector_ref_type<ComputationTy>::type Lo = lo;\012  return cm_imul<T0>(Lo, Src0, Src1);\012}\012\012template <typename T0, typename T1, typename U, int N1, int N2>\012CM_NODEBUG CM_INLINE vector<T0, N1 *N2>\012cm_imul(vector_ref<T0, N1 *N2> rmd, matrix<T1, N1, N2> src0, U src1) {\012  vector<T1, N1 *N2> _Src0 = src0;\012  return cm_imul(rmd, _Src0, src1);\012}\012\012template <typename T0, typename",
" T1, typename U, int N1, int N2>\012CM_NODEBUG CM_INLINE vector<T0, N1 *N2>\012cm_imul(matrix_ref<T0, N1, N2> rmd, matrix<T1, N1, N2> src0, U src1) {\012  vector_ref<T0, N1 *N2> _Rmd = rmd.format<T0>();\012  vector<T1, N1 *N2> _Src0 = src0;\012  return cm_imul(_Rmd, _Src0, src1);\012}\012\012template <typename T0, typename T1, typename U, int SZ>\012CM_NODEBUG CM_INLINE typename std::enable_if<details::is_cm_scalar<U>::value,\012                                             vector<T0, SZ> >::type\012cm_imul(vector_ref<T0, SZ> rmd, U src0, vector<T1, SZ> src1) {\012  return cm_imul(rmd, src1, src0);\012}\012\012template <typename T0, typename T1, typename U, int N1, int N2>\012CM_NODEBUG CM_INLINE typename std::enable_if<details::is_cm_scalar<U>::value,\012                                             vector<T0, N1 *N2> >::type\012cm_imul(vector_ref<T0, N1 *N2> rmd, U src0, matrix<T1, N1, N2> src1) {\012  return cm_imul(rmd, src1, src0);\012}\012\012template <typename T0, typename T, typename U>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012    details::is_cm_scalar<T>::value ",
"&&details::is_cm_scalar<U>::value &&\012        details::is_cm_scalar<T0>::value,\012    T0>::type\012cm_imul(vector_ref<T0, 1> rmd, T src0, U src1) {\012  vector<T, 1> _src0 = src0;\012  vector<U, 1> _src1 = src1;\012  vector<T0, 1> res = cm_imul(rmd, _src0.select_all(), _src1.select_all());\012  return res(0);\012}\012\012// cm_quot\012template <typename T, int SZ, typename U>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012    std::is_integral<T>::value &&std::is_integral<U>::value,\012    vector<T, SZ> >::type\012cm_quot(vector<T, SZ> src0, U src1) {\012  return src0 / src1;\012}\012\012template <typename T, int N1, int N2, typename U>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012    std::is_integral<T>::value &&std::is_integral<U>::value,\012    vector<T, N1 *N2> >::type\012cm_quot(matrix<T, N1, N2> src0, U src1) {\012  return src0 / src1;\012}\012\012template <typename T0, typename T1>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012    details::is_cm_scalar<T0>::value &&details::is_cm_scalar<T1>::value &&\012        std::is_integral<T0>::value &&std::is_integral<T1>::value,\012 ",
"   typename std::remove_const<T0>::type>::type\012cm_quot(T0 src0, T1 src1) {\012  return src0 / src1;\012}\012\012// cm_mod\012template <typename T, int SZ, typename U>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012    std::is_integral<T>::value &&std::is_integral<U>::value,\012    vector<T, SZ> >::type\012cm_mod(vector<T, SZ> src0, U src1) {\012  return src0 % src1;\012}\012\012template <typename T, int N1, int N2, typename U>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012    std::is_integral<T>::value &&std::is_integral<U>::value,\012    vector<T, N1 *N2> >::type\012cm_mod(matrix<T, N1, N2> src0, U src1) {\012  return src0 % src1;\012}\012\012template <typename T0, typename T1>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012    details::is_cm_scalar<T0>::value &&details::is_cm_scalar<T1>::value &&\012        std::is_integral<T0>::value &&std::is_integral<T1>::value,\012    typename std::remove_const<T0>::type>::type\012cm_mod(T0 src0, T1 src1) {\012  return src0 % src1;\012}\012\012// cm_div, compute quotient and remainder of division.\012template <typename T, int SZ, typename U>\012CM_",
"NODEBUG CM_INLINE typename std::enable_if<\012    std::is_integral<T>::value &&std::is_integral<U>::value,\012    vector<T, SZ> >::type\012cm_div(vector_ref<T, SZ> remainder, vector<T, SZ> src0, U src1) {\012  remainder = src0 % src1;\012  return src0 / src1;\012}\012\012template <typename T, int N1, int N2, typename U>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012    std::is_integral<T>::value &&std::is_integral<U>::value,\012    vector<T, N1 *N2> >::type\012cm_div(matrix_ref<T, N1, N2> remainder, matrix<T, N1, N2> src0, U src1) {\012  remainder = src0 % src1;\012  return src0 / src1;\012}\012\012template <typename T, int N1, int N2, typename U>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012    std::is_integral<T>::value &&std::is_integral<U>::value,\012    vector<T, N1 *N2> >::type\012cm_div(vector_ref<T, N1 *N2> remainder, matrix<T, N1, N2> src0, U src1) {\012  vector<T, N1 *N2> _Src0 = src0;\012  remainder = _Src0 % src1;\012  return _Src0 / src1;\012}\012\012template <typename T, int SZ, typename U>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012    std::is_integral<T>::v",
"alue &&std::is_integral<U>::value &&\012        details::is_cm_scalar<U>::value,\012    vector<T, SZ> >::type\012cm_div(vector_ref<T, SZ> remainder, U src0, vector<T, SZ> src1) {\012  remainder = src0 % src1;\012  return src0 / src1;\012}\012\012template <typename T, int N1, int N2, typename U>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012    std::is_integral<T>::value &&std::is_integral<U>::value &&\012        details::is_cm_scalar<U>::value,\012    vector<T, N1 *N2> >::type\012cm_div(matrix_ref<T, N1, N2> remainder, U src0, matrix<T, N1, N2> src1) {\012  remainder = src0 % src1;\012  return src0 / src1;\012}\012\012template <typename T, int N1, int N2, typename U>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012    std::is_integral<T>::value &&std::is_integral<U>::value &&\012        details::is_cm_scalar<U>::value,\012    vector<T, N1 *N2> >::type\012cm_div(vector_ref<T, N1 *N2> remainder, U src0, matrix<T, N1, N2> src1) {\012  vector<T, N1 *N2> _Src1 = src1;\012  remainder = src0 % _Src1;\012  return src0 / _Src1;\012}\012\012template <typename RT, typename T0, typename T1>\012CM_NO",
"DEBUG CM_INLINE typename std::enable_if<\012    details::is_cm_scalar<RT>::value &&details::is_cm_scalar<T0>::value &&\012        details::is_cm_scalar<T1>::value,\012    typename std::remove_const<RT>::type>::type\012cm_div(vector_ref<typename std::remove_const<RT>::type, 1> remainder, T0 src0,\012       T1 src1) {\012  remainder(0) = src0 % src1;\012  return src0 / src1;\012}\012\012// cm_min and cm_max\012//\012// Restriction:\012//\012// The source operands must be both of integer or both of floating-point type.\012//\012template <typename T0, typename T1, int SZ, typename U>\012CM_NODEBUG CM_INLINE vector<T0, SZ> cm_max(vector<T1, SZ> src0, U src1,\012                                           int flag = _GENX_NOSAT) {\012  typedef typename details::common_type<decltype(src0), U>::type CommonTy;\012  typename details::vector_type<CommonTy>::type _Src0 = src0;\012  typename details::vector_type<CommonTy>::type _Src1 = src1;\012  typename details::vector_type<CommonTy>::type _Result =\012      details::__cm_intrinsic_impl_max(_Src0, _Src1);\012\012  if (flag != _GENX_SAT)\012    ret",
"urn _Result;\012\012  return details::__cm_intrinsic_impl_sat<T0>(_Result);\012}\012\012template <typename T0, typename T1, int N1, int N2, typename U>\012CM_NODEBUG CM_INLINE vector<T0, N1 *N2> cm_max(matrix<T1, N1, N2> src0, U src1,\012                                               int flag = _GENX_NOSAT) {\012  vector<T1, N1 *N2> _Src0 = src0;\012  return cm_max<T0>(_Src0, src1, flag);\012}\012\012template <typename T0, typename T1, typename T2>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012    details::is_cm_scalar<T1>::value &&details::is_cm_vector<T2>::value,\012    decltype(cm_max<T0>(T2(), T1()))>::type\012cm_max(T1 src0, T2 src1, int flag = _GENX_NOSAT) {\012  return cm_max<T0>(src1, src0, flag);\012}\012\012template <typename T0, typename T1, typename T2>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012    details::is_cm_scalar<T0>::value &&details::is_cm_scalar<T1>::value &&\012        details::is_cm_scalar<T2>::value,\012    T0>::type\012cm_max(T1 src0, T2 src1, int flag = _GENX_NOSAT) {\012  vector<T1, 1> _Src0 = src0;\012  vector<T2, 1> _Src1 = src1;\012  vector<T0, 1",
"> _Result = cm_max<T0>(_Src0, _Src1, flag);\012  return _Result(0);\012}\012\012template <typename T0, typename T1, int SZ, typename U>\012CM_NODEBUG CM_INLINE vector<T0, SZ> cm_min(vector<T1, SZ> src0, U src1,\012                                           int flag = _GENX_NOSAT) {\012  typedef typename details::common_type<decltype(src0), U>::type CommonTy;\012  typename details::vector_type<CommonTy>::type _Src0 = src0;\012  typename details::vector_type<CommonTy>::type _Src1 = src1;\012  typename details::vector_type<CommonTy>::type _Result =\012      details::__cm_intrinsic_impl_min(_Src0, _Src1);\012\012  if (flag != _GENX_SAT)\012    return _Result;\012  return details::__cm_intrinsic_impl_sat<T0>(_Result);\012}\012\012template <typename T0, typename T1, int N1, int N2, typename U>\012CM_NODEBUG CM_INLINE vector<T0, N1 *N2> cm_min(matrix<T1, N1, N2> src0, U src1,\012                                               int flag = _GENX_NOSAT) {\012  vector<T1, N1 *N2> _Src0 = src0;\012  return cm_min<T0>(_Src0, src1, flag);\012}\012\012template <typename T0, typename T1, typename T2>",
"\012CM_NODEBUG CM_INLINE typename std::enable_if<\012    details::is_cm_scalar<T1>::value &&details::is_cm_vector<T2>::value,\012    decltype(cm_min<T0>(T2(), T1()))>::type\012cm_min(T1 src0, T2 src1, int flag = _GENX_NOSAT) {\012  return cm_min<T0>(src1, src0, flag);\012}\012\012template <typename T0, typename T1, typename T2>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012    details::is_cm_scalar<T0>::value &&details::is_cm_scalar<T1>::value &&\012        details::is_cm_scalar<T2>::value,\012    T0>::type\012cm_min(T1 src0, T2 src1, int flag = _GENX_NOSAT) {\012  vector<T1, 1> _Src0 = src0;\012  vector<T2, 1> _Src1 = src1;\012  vector<T0, 1> _Result = cm_min<T0>(_Src0, _Src1, flag);\012  return _Result(0);\012}\012\012// Dot product builtins\012#if defined(CM_GEN7_5) || defined(CM_GEN8) || defined(CM_GEN8_5) ||            \\\012    defined(CM_GEN9) || defined(CM_GEN9_5)\012template <typename T0, typename T1, int SZ, typename U>\012CM_NODEBUG CM_INLINE vector<T0, SZ> cm_dp2(vector<T1, SZ> src0, U src1,\012                                           int flag = _GENX_NOSAT) {\012  C",
"M_STATIC_ERROR(SZ % 4 == 0, \"result size is not a multiple of 4\");\012  vector<float, SZ> _Src0 = src0;\012  vector<float, SZ> _Src1 = src1;\012  vector<float, SZ> _Result = details::__cm_intrinsic_impl_dp2(_Src0, _Src1);\012  if (flag != _GENX_SAT)\012    return _Result;\012\012  return details::__cm_intrinsic_impl_sat<T0>(_Result);\012}\012template <typename T0, typename T1, int N1, int N2, typename U>\012CM_NODEBUG CM_INLINE vector<T0, N1 *N2> cm_dp2(matrix<T1, N1, N2> src0, U src1,\012                                               int flag = _GENX_NOSAT) {\012  vector<float, N1 *N2> _Src0 = src0;\012  return cm_dp2<T0>(_Src0, src1, flag);\012}\012\012template <typename T0, typename T1, int SZ, typename U>\012CM_NODEBUG CM_INLINE vector<T0, SZ> cm_dp3(vector<T1, SZ> src0, U src1,\012                                           int flag = _GENX_NOSAT) {\012  CM_STATIC_ERROR(SZ % 4 == 0, \"result size is not a multiple of 4\");\012  vector<float, SZ> _Src0 = src0;\012  vector<float, SZ> _Src1 = src1;\012  vector<float, SZ> _Result = details::__cm_intrinsic_impl_dp3(_Src0, _Src",
"1);\012  if (flag != _GENX_SAT)\012    return _Result;\012\012  return details::__cm_intrinsic_impl_sat<T0>(_Result);\012}\012template <typename T0, typename T1, int N1, int N2, typename U>\012CM_NODEBUG CM_INLINE vector<T0, N1 *N2> cm_dp3(matrix<T1, N1, N2> src0, U src1,\012                                               int flag = _GENX_NOSAT) {\012  vector<float, N1 *N2> _Src0 = src0;\012  return cm_dp3<T0>(_Src0, src1, flag);\012}\012\012template <typename T0, typename T1, int SZ, typename U>\012CM_NODEBUG CM_INLINE vector<T0, SZ> cm_dp4(vector<T1, SZ> src0, U src1,\012                                           int flag = _GENX_NOSAT) {\012  CM_STATIC_ERROR(SZ % 4 == 0, \"result size is not a multiple of 4\");\012  vector<float, SZ> _Src0 = src0;\012  vector<float, SZ> _Src1 = src1;\012  vector<float, SZ> _Result = details::__cm_intrinsic_impl_dp4(_Src0, _Src1);\012  if (flag != _GENX_SAT)\012    return _Result;\012\012  return details::__cm_intrinsic_impl_sat<T0>(_Result);\012}\012template <typename T0, typename T1, int N1, int N2, typename U>\012CM_NODEBUG CM_INLINE vector<T0, N1 *N",
"2> cm_dp4(matrix<T1, N1, N2> src0, U src1,\012                                               int flag = _GENX_NOSAT) {\012  vector<float, N1 *N2> _Src0 = src0;\012  return cm_dp4<T0>(_Src0, src1, flag);\012}\012\012template <typename T0, typename T1, typename U, int SZ>\012CM_NODEBUG CM_INLINE vector<T0, SZ> cm_dph(vector<T1, SZ> src0, U src1,\012                                           int flag = _GENX_NOSAT) {\012  CM_STATIC_ERROR(SZ % 4 == 0, \"result size is not a multiple of 4\");\012  vector<float, SZ> _Src0 = src0;\012  vector<float, SZ> _Src1 = src1;\012  vector<float, SZ> _Result = details::__cm_intrinsic_impl_dph(_Src0, _Src1);\012  if (flag != _GENX_SAT)\012    return _Result;\012\012  return details::__cm_intrinsic_impl_sat<T0>(_Result);\012}\012\012template <typename T0, typename T1, typename U, int N1, int N2>\012CM_NODEBUG CM_INLINE vector<T0, N1 *N2> cm_dph(matrix<T1, N1, N2> src0, U src1,\012                                               int flag = _GENX_NOSAT) {\012  vector<float, N1 *N2> _Src0 = src0;\012  return cm_dph<T0>(_Src0, src1, flag);\012}\012\012template <t",
"ypename RT, typename T1, typename T2, int SZ>\012CM_NODEBUG CM_INLINE vector<RT, SZ>\012cm_line(vector<T1, 4> src0, vector<T2, SZ> src1, int flag = _GENX_NOSAT) {\012  CM_STATIC_ERROR(SZ % 4 == 0, \"result size is not a multiple of 4\");\012\012  vector<float, 4> _Src0 = src0;\012  vector<float, SZ> _Src1 = src1;\012  vector<float, SZ> _Result = details::__cm_intrinsic_impl_line(_Src0, _Src1);\012\012  vector<RT, SZ> Result;\012  if (flag == _GENX_SAT)\012    Result = details::__cm_intrinsic_impl_sat<RT>(_Result);\012  else\012    Result = _Result;\012\012  return Result;\012}\012\012template <typename RT, typename T1, typename T2, int N1, int N2>\012CM_NODEBUG CM_INLINE vector<RT, N1 *N2>\012cm_line(vector<T1, 4> src0, matrix<T2, N1, N2> src1, int flag = _GENX_NOSAT) {\012  vector<T2, N1 *N2> _Src1 = src1;\012  return cm_line<RT>(src0, _Src1, flag);\012}\012\012template <typename RT, typename T1, typename T2, int N1, int N2>\012CM_NODEBUG CM_INLINE vector<RT, N1 *N2> cm_line(matrix<T1, 1, 4> src0,\012                                                matrix<T2, N1, N2> src1,\012                 ",
"                               int flag = _GENX_NOSAT) {\012  vector<T1, 4> _Src0 = src0;\012  vector<T2, N1 *N2> _Src1 = src1;\012  return cm_line<RT>(_Src0, _Src1, flag);\012}\012\012template <typename RT, typename T, int SZ>\012CM_NODEBUG CM_INLINE vector<RT, SZ>\012cm_line(float P, float Q, vector<T, SZ> src1, int flag = _GENX_NOSAT) {\012  vector<float, 4> _Src0 = P;\012  _Src0(3) = Q;\012  return cm_line<RT>(_Src0, src1, flag);\012}\012\012template <typename RT, typename T, int N1, int N2>\012CM_NODEBUG CM_INLINE vector<RT, N1 *N2>\012cm_line(float P, float Q, matrix<T, N1, N2> src1, int flag = _GENX_NOSAT) {\012  vector<T, N1 *N2> _Src1 = src1;\012  return cm_line<RT>(P, Q, _Src1, flag);\012}\012\012#else\012// The old implementation is to generate vISA IRs for dp2/dp3/dp4/dph/line.\012// Now We change to use direct mul/add, and hope to generate mad instructions\012// at the end, to still get the performance as good as HW solution.\012// We rely on \"pragma unroll\" to get better code.\012// The only input and return types for these APIs are floats.\012// In order to be able to use t",
"he old emu code, we keep the template argument\012// for the type, although the type \"T\" can only be float.\012// We use enable_if to force the float type only.\012// If the gen is not specified we warn the programmer that they are potentially\012// using a less efficient implementation if not on GEN10 or above.\012template <typename T0, typename T1, int SZ, typename U>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012    details::is_fp_or_dword_type<T1>::value &&std::is_floating_point<\012        T1>::value &&details::is_fp_or_dword_type<U>::value &&\012        std::is_floating_point<U>::value,\012    vector<T0, SZ> >::type\012cm_dp2(vector<T1, SZ> src0, U src1, int flag = _GENX_NOSAT) {\012  CM_STATIC_ERROR(SZ % 4 == 0, \"result size is not a multiple of 4\");\012#if !defined(CM_GENX)\012  CM_STATIC_WARNING(0, \"GEN not specified so cm_dp2() code may not be optimal\");\012#endif\012  vector<float, SZ> _Src1 = src1;\012  vector<float, SZ> _Result;\012#pragma unroll\012  for (int i = 0; i < SZ; i += 4) {\012    _Result.select<4,1>(i) = src0[i] * _Src1[i] + src0[i + 1] ",
"* _Src1[i + 1];\012  }\012  if (flag != _GENX_SAT)\012    return _Result;\012\012  return details::__cm_intrinsic_impl_sat<T1>(_Result);\012}\012\012template <typename T0, typename T1, int N1, int N2, typename U>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012    details::is_fp_or_dword_type<T1>::value &&std::is_floating_point<\012        T1>::value &&details::is_fp_or_dword_type<U>::value &&\012        std::is_floating_point<U>::value,\012    vector<T0, N1 *N2> >::type\012cm_dp2(matrix<T1, N1, N2> src0, U src1, int flag = _GENX_NOSAT) {\012  vector<float, N1 *N2> _Src0 = src0;\012  return cm_dp2<T0>(_Src0, src1, flag);\012}\012\012template <typename T0, typename T1, int SZ, typename U>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012    details::is_fp_or_dword_type<T1>::value &&std::is_floating_point<\012        T1>::value &&details::is_fp_or_dword_type<U>::value &&\012        std::is_floating_point<U>::value,\012    vector<T0, SZ> >::type\012cm_dp3(vector<T1, SZ> src0, U src1, int flag = _GENX_NOSAT) {\012  CM_STATIC_ERROR(SZ % 4 == 0, \"result size is not a multiple of 4\");\012",
"#if !defined(CM_GENX)\012  CM_STATIC_WARNING(0, \"GEN not specified so cm_dp3() code may not be optimal\");\012#endif\012  vector<float, SZ> _Src1 = src1;\012  vector<float, SZ> _Result;\012#pragma unroll\012  for (int i = 0; i < SZ; i += 4) {\012    _Result.select<4,1>(i) = src0[i] * _Src1[i] + src0[i + 1] * _Src1[i + 1] +\012        src0[i + 2] * _Src1[i + 2];\012  }\012  if (flag != _GENX_SAT)\012    return _Result;\012\012  return details::__cm_intrinsic_impl_sat<T1>(_Result);\012}\012\012template <typename T0, typename T1, int N1, int N2, typename U>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012    details::is_fp_or_dword_type<T1>::value &&std::is_floating_point<\012        T1>::value &&details::is_fp_or_dword_type<U>::value &&\012        std::is_floating_point<U>::value,\012    vector<T0, N1 *N2> >::type\012cm_dp3(matrix<T1, N1, N2> src0, U src1, int flag = _GENX_NOSAT) {\012  vector<T1, N1 *N2> _Src0 = src0;\012  return cm_dp3<T0>(_Src0, src1, flag);\012}\012\012template <typename T0, typename T1, int SZ, typename U>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012    details::i",
"s_fp_or_dword_type<T1>::value &&std::is_floating_point<\012        T1>::value &&details::is_fp_or_dword_type<U>::value &&\012        std::is_floating_point<U>::value,\012    vector<T0, SZ> >::type\012cm_dp4(vector<T1, SZ> src0, U src1, int flag = _GENX_NOSAT) {\012  CM_STATIC_ERROR(SZ % 4 == 0, \"result size is not a multiple of 4\");\012#if !defined(CM_GENX)\012  CM_STATIC_WARNING(0, \"GEN not specified so cm_dp4() code may not be optimal\");\012#endif\012  vector<T1, SZ> _Src1 = src1;\012  vector<float, SZ> _Result;\012#pragma unroll\012  for (int i = 0; i < SZ; i += 4) {\012    _Result.select<4,1>(i) = src0[i] * _Src1[i] + src0[i + 1] * _Src1[i + 1] +\012        src0[i + 2] * _Src1[i + 2] + src0[i + 3] * _Src1[i + 3];\012  }\012  if (flag != _GENX_SAT)\012    return _Result;\012\012  return details::__cm_intrinsic_impl_sat<T1>(_Result);\012}\012\012template <typename T0, typename T1, int N1, int N2, typename U>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012    details::is_fp_or_dword_type<T1>::value &&std::is_floating_point<\012        T1>::value &&details::is_fp_or_dword_type<",
"U>::value &&\012        std::is_floating_point<U>::value,\012    vector<T0, N1 *N2> >::type\012cm_dp4(matrix<T1, N1, N2> src0, U src1, int flag = _GENX_NOSAT) {\012  vector<T1, N1 *N2> _Src0 = src0;\012  return cm_dp4<T0>(_Src0, src1, flag);\012}\012\012template <typename T, typename U, int SZ>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012    details::is_fp_or_dword_type<T>::value &&std::is_floating_point<T>::value &&\012        details::is_fp_or_dword_type<U>::value &&\012            std::is_floating_point<U>::value,\012    vector<T, SZ> >::type\012cm_dph(vector<T, SZ> src0, U src1, int flag = _GENX_NOSAT) {\012  CM_STATIC_ERROR(SZ % 4 == 0, \"result size is not a multiple of 4\");\012#if !defined(CM_GENX)\012  CM_STATIC_WARNING(0, \"GEN not specified so cm_dph() code may not be optimal\");\012#endif\012  vector<float, SZ> _Src1 = src1;\012  vector<float, SZ> _Result;\012#pragma unroll\012  for (int i = 0; i < SZ; i += 4) {\012    _Result.select<4,1>(i) = src0[i] * _Src1[i] + src0[i + 1] * _Src1[i + 1] +\012        src0[i + 2] * _Src1[i + 2] + 1.0 * _Src1[i + 3];\012  }\012  if (fl",
"ag != _GENX_SAT)\012    return _Result;\012\012  return details::__cm_intrinsic_impl_sat<T>(_Result);\012}\012\012template <typename T, typename U, int N1, int N2>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012    details::is_fp_or_dword_type<T>::value &&std::is_floating_point<T>::value &&\012        details::is_fp_or_dword_type<U>::value &&\012            std::is_floating_point<U>::value,\012    vector<T, N1 *N2> >::type\012cm_dph(matrix<T, N1, N2> src0, U src1, int flag = _GENX_NOSAT) {\012  vector<T, N1 *N2> _Src0 = src0;\012  return cm_dph<T>(_Src0, src1, flag);\012}\012\012template <typename T, int SZ>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012    details::is_fp_or_dword_type<T>::value &&std::is_floating_point<T>::value,\012    vector<T, SZ> >::type\012cm_line(vector<T, 4> src0, vector<T, SZ> src1, int flag = _GENX_NOSAT) {\012  CM_STATIC_ERROR(SZ % 4 == 0, \"result size is not a multiple of 4\");\012#if !defined(CM_GENX)\012  CM_STATIC_WARNING(0, \"GEN not specified so cm_line() code may not be optimal\");\012#endif\012\012  vector<T, SZ> _Src1 = src1;\012  vector<T, SZ> _R",
"esult;\012#pragma unroll\012  for (int i = 0; i < SZ; i += 4) {\012    _Result.select<4,1>(i) = src0[0] * src1.select<4,1>(i) + src0[3];\012  }\012\012  if (flag == _GENX_SAT)\012    _Result = details::__cm_intrinsic_impl_sat<T>(_Result);\012\012  return _Result;\012}\012\012template <typename T, int N1, int N2>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012    details::is_fp_or_dword_type<T>::value &&std::is_floating_point<T>::value,\012    vector<T, N1 *N2> >::type\012cm_line(vector<T, 4> src0, matrix<T, N1, N2> src1, int flag = _GENX_NOSAT) {\012  vector<T, N1 *N2> _Src1 = src1;\012  return cm_line<T>(src0, _Src1, flag);\012}\012\012template <typename T, int SZ>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012    details::is_fp_or_dword_type<T>::value &&std::is_floating_point<T>::value,\012    vector<T, SZ> >::type\012cm_line(float P, float Q, vector<T, SZ> src1, int flag = _GENX_NOSAT) {\012  vector<T, 4> _Src0 = P;\012  _Src0(3) = Q;\012  return cm_line<T>(_Src0, src1, flag);\012}\012\012template <typename T, int N1, int N2>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012    details::is",
"_fp_or_dword_type<T>::value &&std::is_floating_point<T>::value,\012    vector<T, N1 *N2> >::type\012cm_line(float P, float Q, matrix<T, N1, N2> src1, int flag = _GENX_NOSAT) {\012  vector<T, N1 *N2> _Src1 = src1;\012  return cm_line<T>(P, Q, _Src1, flag);\012}\012\012#endif\012\012template <typename T, int SZ>\012CM_NODEBUG CM_INLINE vector<T, SZ> cm_frc(vector<T, SZ> src0) {\012  vector<float, SZ> _Src0 = src0;\012  return details::__cm_intrinsic_impl_frc(_Src0);\012}\012\012template <typename T, int N1, int N2>\012CM_NODEBUG CM_INLINE vector<T, N1 *N2> cm_frc(matrix<T, N1, N2> src0) {\012  vector<T, N1 *N2> _Src0 = src0;\012  return cm_frc<T>(_Src0);\012}\012\012template <typename T> CM_NODEBUG CM_INLINE T cm_frc(T src0) {\012  vector<T, 1> _Src0 = src0;\012  vector<T, 1> _Result = cm_frc<T>(_Src0);\012  return _Result(0);\012}\012\012// cm_lzd\012template <typename RT, typename T0, int SZ>\012CM_NODEBUG CM_INLINE vector<RT, SZ> cm_lzd(vector<T0, SZ> src0,\012                                           int flag = _GENX_NOSAT) {\012  CM_STATIC_ERROR(std::is_integral<T0>::value,\012                  \"cm_",
"lzd supports only integral data types!\");\012  using IntermType =\012      typename std::conditional<details::is_qword_type<T0>::value,\012                                unsigned long long, unsigned int>::type;\012  // Saturation parameter ignored\012  vector<IntermType, SZ> _Src0 = src0;\012  return details::__cm_intrinsic_impl_lzd<IntermType>(_Src0);\012}\012\012template <typename RT, typename T0, int N1, int N2>\012CM_NODEBUG CM_INLINE vector<RT, N1 *N2> cm_lzd(matrix<T0, N1, N2> src0,\012                                               int flag = _GENX_NOSAT) {\012  vector<T0, N1 *N2> _Src0 = src0;\012  return cm_lzd<RT>(_Src0, flag);\012}\012\012template <typename RT, typename T0>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012    details::is_cm_scalar<RT>::value &&details::is_cm_scalar<T0>::value,\012    typename std::remove_const<RT>::type>::type\012cm_lzd(T0 src0, int flag = _GENX_NOSAT) {\012  vector<T0, 1> _Src0 = src0;\012  vector<RT, 1> _Result = cm_lzd<RT>(_Src0);\012  return _Result(0);\012}\012\012//////////////////////////////////////////////////////////////////////",
"//////////\012// CM reduction intrinsics:\012//\012// cm_sum, cm_prod, cm_reduced_min and cm_reduced_max.\012////////////////////////////////////////////////////////////////////////////////\012template <typename T0, typename T1, int SZ>\012CM_NODEBUG CM_INLINE T0 cm_sum(vector<T1, SZ> src, int flag = _GENX_NOSAT) {\012  vector<T1, SZ> _PredSrc = details::__cm_intrinsic_impl_simdcf_predgen(src, 0);\012\012  if (flag != _GENX_SAT)\012    return details::__cm_intrinsic_impl_sum<T0>(_PredSrc);\012  return details::__cm_intrinsic_impl_sum_sat<T0>(_PredSrc);\012}\012template <typename T0, typename T1, int N1, int N2>\012CM_NODEBUG CM_INLINE T0 cm_sum(matrix<T1, N1, N2> src, int flag = _GENX_NOSAT) {\012  vector<T1, N1 *N2> _Src = src;\012  return cm_sum<T0>(_Src, flag);\012}\012\012template <typename T0, typename T1, int SZ>\012CM_NODEBUG CM_INLINE T0 cm_prod(vector<T1, SZ> src, int flag = _GENX_NOSAT) {\012  vector<T1, SZ> _PredSrc = details::__cm_intrinsic_impl_simdcf_predgen(src, 1);\012\012  if (flag != _GENX_SAT)\012    return details::__cm_intrinsic_impl_prod<T0>(_PredSrc);\012  ret",
"urn details::__cm_intrinsic_impl_prod_sat<T0>(_PredSrc);\012}\012template <typename T0, typename T1, int N1, int N2>\012CM_NODEBUG CM_INLINE T0\012cm_prod(matrix<T1, N1, N2> src, int flag = _GENX_NOSAT) {\012  vector<T1, N1 *N2> _Src = src;\012  return cm_prod<T0>(_Src, flag);\012}\012\012template <typename T0, typename T1, int SZ>\012CM_NODEBUG CM_INLINE T0\012cm_reduced_min(vector<T1, SZ> src, int flag = _GENX_NOSAT) {\012  vector<T1, SZ> _PredSrc = details::__cm_intrinsic_impl_simdcf_predmin(src);\012\012  T1 _Res = details::__cm_intrinsic_impl_reduced_min(_PredSrc);\012  if (flag != _GENX_SAT)\012    return _Res;\012\012  return details::__cm_intrinsic_impl_sat<T0>(_Res);\012}\012template <typename T0, typename T1, int N1, int N2>\012CM_NODEBUG CM_INLINE T0\012cm_reduced_min(matrix<T1, N1, N2> src, int flag = _GENX_NOSAT) {\012  vector<T1, N1 *N2> _Src = src;\012  return cm_reduced_min<T0>(_Src, flag);\012}\012\012template <typename T0, typename T1, int SZ>\012CM_NODEBUG CM_INLINE T0\012cm_reduced_max(vector<T1, SZ> src, int flag = _GENX_NOSAT) {\012  vector<T1, SZ> _PredSrc = details::__cm_in",
"trinsic_impl_simdcf_predmax(src);\012\012  T1 _Res = details::__cm_intrinsic_impl_reduced_max(_PredSrc);\012  if (flag != _GENX_SAT)\012    return _Res;\012\012  return details::__cm_intrinsic_impl_sat<T0>(_Res);\012}\012template <typename T0, typename T1, int N1, int N2>\012CM_NODEBUG CM_INLINE T0\012cm_reduced_max(matrix<T1, N1, N2> src, int flag = _GENX_NOSAT) {\012  vector<T1, N1 *N2> _Src = src;\012  return cm_reduced_max<T0>(_Src);\012}\012\012// cm_sad2\012template <typename T0, typename T1, int SZ, typename U>\012CM_NODEBUG CM_INLINE vector<T0, SZ> cm_sad2(vector<T1, SZ> src0, U src1,\012                                            int flag = _GENX_NOSAT) {\012  typedef typename details::byte_type<T1>::type _BT1;\012  vector<_BT1, SZ> _Src0 = src0;\012  vector<_BT1, SZ> _Src1 = src1;\012  return details::__cm_intrinsic_impl_sad2<T0, _BT1, SZ>(_Src0, _Src1);\012}\012\012template <typename T0, typename T1, int N1, int N2, typename U>\012CM_NODEBUG CM_INLINE vector<T0, N1 *N2> cm_sad2(matrix<T1, N1, N2> src0, U src1,\012                                                int flag = _GENX_",
"NOSAT) {\012  vector<T1, N1 *N2> _Src0 = src0;\012  return cm_sad2<T0>(_Src0, src1, flag);\012}\012\012template <typename T0, typename T1, typename T2>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012    details::is_cm_scalar<T0>::value &&details::is_cm_scalar<T1>::value &&\012        details::is_cm_scalar<T2>::value,\012    typename std::remove_const<T0>::type>::type\012cm_sad2(T1 src0, T2 src1, int flag = _GENX_NOSAT) {\012  typedef typename details::byte_type<T1>::type _BT1;\012  vector<_BT1, 1> _Src0 = src0;\012  vector<_BT1, 1> _Src1 = src1;\012  vector<T0, 1> _Result = cm_sad2<T0>(_Src0, _Src1, flag);\012  return _Result(0);\012}\012\012template <typename T0, typename T1, typename T2>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012    details::is_cm_scalar<T1>::value &&details::is_cm_vector<T2>::value,\012    decltype(cm_sad2<T0>(T2(), T1()))>::type\012cm_sad2(T1 src0, T2 src1, int flag = _GENX_NOSAT) {\012  return cm_sad2<T0>(src1, src0, flag);\012}\012\012// cm_sada2\012template <typename T0, typename T1, int SZ, typename U, typename V>\012CM_NODEBUG CM_INLINE typename std::",
"enable_if<\012    std::is_integral<T0>::value &&std::is_integral<T1>::value,\012    vector<T0, SZ> >::type\012cm_sada2(vector<T1, SZ> src0, U src1, V src2, int flag = _GENX_NOSAT) {\012  typedef typename details::byte_type<T1>::type _BT1;\012  typedef typename details::word_type<T0>::type _WT0;\012  CM_STATIC_ERROR(\012      std::is_integral<_BT1>::value && sizeof(_BT1) == sizeof(char) &&\012          std::is_integral<_WT0>::value && sizeof(_WT0) == sizeof(short),\012      \"operand conversion failed\");\012  vector<_BT1, SZ> _Src0 = src0;\012  vector<_BT1, SZ> _Src1 = src1;\012  vector<_WT0, SZ> _Src2 = src2;\012  return details::__cm_intrinsic_impl_sada2<T0>(_Src0, _Src1, _Src2, flag);\012}\012\012template <typename T0, typename T1, int N1, int N2, typename U, typename V>\012CM_NODEBUG CM_INLINE vector<T0, N1 *N2>\012cm_sada2(matrix<T1, N1, N2> src0, U src1, V src2, int flag = _GENX_NOSAT) {\012  vector<T1, N1 *N2> _Src0 = src0;\012  return cm_sada2<T0>(_Src0, src1, src2, flag);\012}\012\012template <typename T0, typename T1, typename T2, typename T3>\012CM_NODEBUG CM_INLINE type",
"name std::enable_if<\012    details::is_cm_scalar<T0>::value &&details::is_cm_scalar<T1>::value &&\012        details::is_cm_scalar<T2>::value &&details::is_cm_scalar<T3>::value,\012    typename std::remove_const<T0>::type>::type\012cm_sada2(T1 src0, T2 src1, T3 src2, int flag = _GENX_NOSAT) {\012  typedef typename details::byte_type<T1>::type _BT1;\012  typedef typename details::word_type<T0>::type _WT0;\012  CM_STATIC_ERROR(\012      std::is_integral<_BT1>::value && sizeof(_BT1) == sizeof(char) &&\012          std::is_integral<_WT0>::value && sizeof(_WT0) == sizeof(short),\012      \"operand conversion failed\");\012  vector<_BT1, 1> _Src0 = src0;\012  vector<_BT1, 1> _Src1 = src1;\012  vector<_WT0, 1> _Src2 = src2;\012  vector<_WT0, 1> _Result = cm_sada2<T0>(_Src0, _Src1, _Src2, flag);\012  return _Result(0);\012}\012\012template <typename T0, typename T1, typename T2, typename T3>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012    details::is_cm_scalar<T1>::value &&details::is_cm_vector<T2>::value,\012    decltype(cm_sada2<T0>(T2(), T1(), T3()))>::type\012cm_sada2(T1",
" src0, T2 src1, T3 src2, int flag = _GENX_NOSAT) {\012  return cm_sada2<T0>(src1, src0, src2, flag);\012}\012\012// cm_lrp\012#if defined(CM_GEN7_5) || defined(CM_GEN8) || defined(CM_GEN8_5) ||            \\\012    defined(CM_GEN9) || defined(CM_GEN9_5)\012\012template <int SZ, typename U, typename V>\012CM_NODEBUG CM_INLINE vector<float, SZ> cm_lrp(vector<float, SZ> src0, U src1,\012                                              V src2, int flag = _GENX_NOSAT) {\012  CM_STATIC_ERROR(SZ >= 4 && (SZ & 0x3) == 0,\012                  \"vector size must be a multiple of 4\");\012  vector<float, SZ> _Src1 = src1;\012  vector<float, SZ> _Src2 = src2;\012  vector<float, SZ> _Result =\012      details::__cm_intrinsic_impl_lrp<SZ>(src0, _Src1, _Src2);\012\012  if (flag != _GENX_SAT)\012    return _Result;\012\012  return details::__cm_intrinsic_impl_sat<float>(_Result);\012}\012\012#else\012\012// The old implementation is to generate vISA IRs for lrp.\012// Now We change to use direct mul/add, and hope to generate mad instructions\012// at the end, to still get the performance as good as HW solution. \012",
"// The only input and return types for these APIs are floats.\012// In order to be able to use the old emu code, we keep the template argument\012// for the type, although the type \"T\" can only be float.\012// We use enable_if to force the float type only.\012// If the gen is not specified we warn the programmer that they are potentially\012// using less efficient implementation.\012template <typename T, int SZ, typename U, typename V>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012    details::is_fp_or_dword_type<T>::value &&std::is_floating_point<T>::value &&\012        details::is_fp_or_dword_type<U>::value &&\012            std::is_floating_point<U>::value,\012    vector<T, SZ> >::type\012cm_lrp(vector<T, SZ> src0, U src1, V src2, int flag = _GENX_NOSAT) {\012#if !defined(CM_GENX)\012  CM_STATIC_WARNING(0, \"GEN not specified so cm_lrp() code may not be optimal\");\012#endif\012  vector<float, SZ> _Src1 = src1;\012  vector<float, SZ> _Src2 = src2;\012  vector<float, SZ> _Result;\012  _Result = _Src1 * src0 + _Src2 * (1.0f - src0);\012  if (flag != _GENX_SAT)\012  ",
"  return _Result;\012  return details::__cm_intrinsic_impl_sat<T>(_Result);\012}\012#endif\012\012template <int N1, int N2, typename U, typename V>\012CM_NODEBUG CM_INLINE vector<float, N1 *N2>\012cm_lrp(matrix<float, N1, N2> src0, U src1, V src2, int flag = _GENX_NOSAT) {\012  vector<float, N1 *N2> _Src0 = src0;\012  return cm_lrp(_Src0, src1, src2, flag);\012}\012\012// cm_pln\012template <int SZ>\012CM_NODEBUG CM_INLINE vector<float, SZ>\012cm_pln(vector<float, 4> src0, vector<float, SZ> src1, vector<float, SZ> src2,\012       int flag = _GENX_NOSAT) {\012  CM_STATIC_ERROR(SZ >= 8 && (SZ & 0x7) == 0,\012                  \"vector size must be a multiple of 8\");\012\012  // __cm_intrinsic_impl_pln() requires src1 and src2 to be combined into\012  // a single matrix, interleaving the values together in blocks of 8\012  // items (ie, a block of 8 from src1, then a block of 8 from src2, then\012  // the next block of 8 from src1, then the next block of 8 from src2,\012  // and so-on.)\012  matrix<float, (SZ >> 3), 16> _Src12;\012\012  _Src12.select<(SZ >> 3), 1, 8, 1>(0, 0) = src1.format<fl",
"oat, (SZ >> 3), 8>();\012  _Src12.select<(SZ >> 3), 1, 8, 1>(0, 8) = src2.format<float, (SZ >> 3), 8>();\012\012  vector<float, SZ> _Result =\012      details::__cm_intrinsic_impl_pln<SZ>(src0, _Src12.format<float>());\012\012  if (flag != _GENX_SAT)\012    return _Result;\012\012  return details::__cm_intrinsic_impl_sat<float>(_Result);\012}\012\012template <int N1, int N2>\012CM_NODEBUG CM_INLINE vector<float, N1 *N2>\012cm_pln(matrix<float, 1, 4> src0, matrix<float, N1, N2> src1,\012       matrix<float, N1, N2> src2, int flag = _GENX_NOSAT) {\012  vector<float, 4> _Src0 = src0;\012  vector<float, N1 *N2> _Src1 = src1;\012  vector<float, N1 *N2> _Src2 = src2;\012  return cm_pln(_Src0, _Src1, _Src2, flag);\012}\012\012// cm_bf_reverse\012template <typename T0, typename T1, int SZ>\012CM_NODEBUG CM_INLINE vector<T0, SZ> cm_bf_reverse(vector<T1, SZ> src0) {\012  vector<unsigned, SZ> _Src0 = src0;\012  return details::__cm_intrinsic_impl_bfrev<unsigned>(_Src0);\012}\012\012template <typename T0, typename T1, int N1, int N2>\012CM_NODEBUG CM_INLINE vector<T0, N1 *N2> cm_bf_reverse(matrix<T1, N1, N2> ",
"src0) {\012  vector<T1, N1 *N2> _Src0 = src0;\012  return cm_bf_reverse<T0>(_Src0);\012}\012\012template <typename T0, typename T1>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012    details::is_cm_scalar<T0>::value &&details::is_cm_scalar<T1>::value,\012    typename std::remove_const<T0>::type>::type\012cm_bf_reverse(T1 src0) {\012  vector<T1, 1> _Src0 = src0;\012  vector<T0, 1> _Result = cm_bf_reverse<T0>(_Src0);\012  return _Result(0);\012}\012\012// cm_bf_insert\012template <typename T0, typename T1, int SZ, typename U, typename V, typename W>\012CM_NODEBUG CM_INLINE typename std::enable_if<std::is_integral<T1>::value,\012                                             vector<T0, SZ> >::type\012cm_bf_insert(U src0, V src1, W src2, vector<T1, SZ> src3) {\012  typedef typename details::dword_type<T1>::type _DT1;\012  CM_STATIC_ERROR(std::is_integral<_DT1>::value && sizeof(_DT1) == sizeof(int),\012                  \"operand conversion failed\");\012  vector<_DT1, SZ> _Src0 = src0;\012  vector<_DT1, SZ> _Src1 = src1;\012  vector<_DT1, SZ> _Src2 = src2;\012  vector<_DT1, SZ> _Src3 = sr",
"c3;\012\012  return details::__cm_intrinsic_impl_bfins<_DT1>(_Src0, _Src1, _Src2, _Src3);\012}\012\012template <typename T0, typename T1, int N1, int N2, typename U, typename V,\012          typename W>\012CM_NODEBUG CM_INLINE vector<T0, N1 *N2> cm_bf_insert(U src0, V src1, W src2,\012                                                     matrix<T1, N1, N2> src3) {\012  vector<T1, N1 *N2> _Src3 = src3;\012  return cm_bf_insert<T0>(src0, src1, src2, _Src3);\012}\012\012template <typename T0, typename T1, typename T2, typename T3, typename T4>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012    details::is_cm_scalar<T0>::value &&details::is_cm_scalar<T4>::value,\012    typename std::remove_const<T0>::type>::type\012cm_bf_insert(T1 src0, T2 src1, T3 src2, T4 src3) {\012  vector<T4, 1> _Src3 = src3;\012  vector<T0, 1> _Result = cm_bf_insert<T0>(src0, src1, src2, _Src3);\012  return _Result(0);\012}\012\012// cm_bf_extract\012template <typename T0, typename T1, int SZ, typename U, typename V>\012CM_NODEBUG CM_INLINE typename std::enable_if<std::is_integral<T1>::value,\012                 ",
"                            vector<T0, SZ> >::type\012cm_bf_extract(U src0, V src1, vector<T1, SZ> src2) {\012  typedef typename details::dword_type<T1>::type _DT1;\012  CM_STATIC_ERROR(std::is_integral<_DT1>::value && sizeof(_DT1) == sizeof(int),\012                  \"operand conversion failed\");\012  vector<_DT1, SZ> _Src0 = src0;\012  vector<_DT1, SZ> _Src1 = src1;\012  vector<_DT1, SZ> _Src2 = src2;\012\012  return details::__cm_intrinsic_impl_bfext<_DT1>(_Src0, _Src1, _Src2);\012}\012\012template <typename T0, typename T1, int N1, int N2, typename U, typename V>\012CM_NODEBUG CM_INLINE vector<T0, N1 *N2> cm_bf_extract(U src0, V src1,\012                                                      matrix<T1, N1, N2> src2) {\012  vector<T1, N1 *N2> _Src2 = src2;\012  return cm_bf_extract<T0>(src0, src1, _Src2);\012}\012\012template <typename T0, typename T1, typename T2, typename T3>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012    details::is_cm_scalar<T0>::value &&details::is_cm_scalar<T3>::value,\012    typename std::remove_const<T0>::type>::type\012cm_bf_extract(T1 src0",
", T2 src1, T3 src2) {\012  vector<T3, 1> _Src2 = src2;\012  vector<T0, 1> _Result = cm_bf_extract<T0>(src0, src1, _Src2);\012  return _Result(0);\012}\012\012////////////////////////////////////////////////////////////////////////////////\012// CM arithmetic intrinsics:\012//\012// inv, log, exp, sqrt, rsqrt, sin, cos\012//\012// share the same requirements.\012//\012// template <int SZ>\012// vector<float, SZ>\012// CM_INLINE cm_inv(vector<float, SZ> src0, int flag = _GENX_NOSAT) {\012//   vector<float, SZ> _Result = details::__cm_intrinsic_impl_inv(src0);\012//   if (flag != _GENX_SAT)\012//     return _Result;\012//   return details::__cm_intrinsic_impl_sat<float>(_Result);\012// }\012//\012// template <int N1, int N2>\012// CM_NODEBUG CM_INLINE\012// vector<float, N1 * N2>\012// cm_inv(matrix<float, N1, N2> src0, int flag = _GENX_NOSAT) {\012//   vector<float, N1 * N2> _Src0 = src0;\012//   return cm_inv(_Src0, flag);\012// }\012//\012// CM_INLINE float cm_inv(float src0, int flag = _GENX_NOSAT) {\012//   vector<float, 1> _Src0 = src0;\012//   vector<float, 1> _Result = cm_inv(_Src0, flag);\012//   ret",
"urn _Result(0);\012// }\012//\012// we also make the scalar version template-based by adding\012// a \"typename T\". Since the type can only be float, we hack it\012// by defining T=void without instantiating it to be float.\012\012#define _CM_INTRINSIC_WITH_CONTROL_DEF(type, name, control)                    \\\012  template <int SZ>                                                            \\\012  CM_NODEBUG CM_INLINE                                                         \\\012  vector<type, SZ> cm_##name(vector<type, SZ> src0, int flag = _GENX_NOSAT) {  \\\012    vector<type, SZ> _Result = details::__cm_intrinsic_impl_##name(src0);      \\\012    control;                                                                   \\\012    if (flag != _GENX_SAT)                                                     \\\012      return _Result;                                                          \\\012    return details::__cm_intrinsic_impl_sat<type>(_Result);                    \\\012  }                                                                            \\\012  tem",
"plate <int N1, int N2>                                                    \\\012  CM_NODEBUG CM_INLINE vector<type, N1 *N2> cm_##name(                         \\\012      matrix<type, N1, N2> src0, int flag = _GENX_NOSAT) {                     \\\012    vector<type, N1 *N2> _Src0 = src0;                                         \\\012    return cm_##name(_Src0, flag);                                             \\\012  }                                                                            \\\012  template <typename T = void>                                                 \\\012  CM_NODEBUG CM_INLINE type cm_##name(type src0, int flag = _GENX_NOSAT) {     \\\012    vector<type, 1> _Src0 = src0;                                              \\\012    vector<type, 1> _Result = cm_##name(_Src0, flag);                          \\\012    return _Result(0);                                                         \\\012  }\012#define _CM_INTRINSIC_DEF(type, name) _CM_INTRINSIC_WITH_CONTROL_DEF(type, name, 0);\012\012_CM_INTRINSIC_DEF(half, inv)\012_CM_INTRINSIC_DEF(h",
"alf, log)\012_CM_INTRINSIC_DEF(half, exp)\012_CM_INTRINSIC_DEF(half, sqrt)\012_CM_INTRINSIC_DEF(half, rsqrt)\012_CM_INTRINSIC_DEF(half, sin)\012_CM_INTRINSIC_DEF(half, cos)\012\012_CM_INTRINSIC_DEF(float, inv)\012_CM_INTRINSIC_DEF(float, log)\012_CM_INTRINSIC_DEF(float, exp)\012_CM_INTRINSIC_DEF(float, sqrt)\012_CM_INTRINSIC_WITH_CONTROL_DEF(float, sqrt_ieee, CM_HAS_IEEE_DIV_SQRT_CONTROL)\012_CM_INTRINSIC_DEF(float, rsqrt)\012_CM_INTRINSIC_DEF(float, sin)\012_CM_INTRINSIC_DEF(float, cos)\012\012_CM_INTRINSIC_WITH_CONTROL_DEF(double, sqrt_ieee, CM_HAS_IEEE_DIV_SQRT_CONTROL)\012\012#undef _CM_INTRINSIC_DEF\012#undef _CM_INTRINSIC_WITH_CONTROL_DEF\012\012#define _CM_INTRINSIC_WITH_CONTROL_DEF(ftype, name, control)                   \\\012  template <int SZ, typename U>                                                \\\012  CM_NODEBUG CM_INLINE vector<ftype, SZ> cm_##name(                            \\\012      vector<ftype, SZ> src0, U src1, int flag = _GENX_NOSAT) {                \\\012    control;                                                                   \\\012    vector<ftype, SZ> ",
"_Src1 = src1;                                            \\\012    vector<ftype, SZ> _Result =                                                \\\012        details::__cm_intrinsic_impl_##name(src0, _Src1);                      \\\012    if (flag != _GENX_SAT)                                                     \\\012      return _Result;                                                          \\\012                                                                               \\\012    return details::__cm_intrinsic_impl_sat<ftype>(_Result);                   \\\012  }                                                                            \\\012  template <int N1, int N2, typename U>                                        \\\012  CM_NODEBUG CM_INLINE vector<ftype, N1 *N2> cm_##name(                        \\\012      matrix<ftype, N1, N2> src0, U src1, int flag = _GENX_NOSAT) {            \\\012    vector<ftype, N1 *N2> _Src0 = src0;                                        \\\012    vector<ftype, N1 *N2> _Src1 = src1;                                   ",
"     \\\012    return cm_##name(_Src0, _Src1, flag);                                      \\\012  }                                                                            \\\012  template <int SZ, typename U>                                                \\\012  CM_NODEBUG CM_INLINE typename std::enable_if<                                \\\012      details::is_cm_scalar<U>::value, vector<ftype, SZ> >::type               \\\012  cm_##name(U src0, vector<ftype, SZ> src1, int flag = _GENX_NOSAT) {          \\\012    vector<ftype, SZ> _Src0 = src0;                                            \\\012    return cm_##name(_Src0, src1, flag);                                       \\\012  }                                                                            \\\012  template <int N1, int N2, typename U>                                        \\\012  CM_NODEBUG CM_INLINE typename std::enable_if<                                \\\012      details::is_cm_scalar<U>::value, vector<ftype, N1 *N2> >::type           \\\012  cm_##name(U src0, matrix<ftype, N1, N2> src",
"1, int flag = _GENX_NOSAT) {      \\\012    vector<ftype, N1 *N2> _Src0 = src0;                                        \\\012    vector<ftype, N1 *N2> _Src1 = src1;                                        \\\012    return cm_##name(_Src0, _Src1, flag);                                      \\\012  }                                                                            \\\012  template <typename T = void>                                                 \\\012  CM_NODEBUG CM_INLINE ftype                                                   \\\012  cm_##name(ftype src0, ftype src1, int flag = _GENX_NOSAT) {                  \\\012    vector<ftype, 1> _Src0 = src0;                                             \\\012    vector<ftype, 1> _Src1 = src1;                                             \\\012    vector<ftype, 1> _Result = cm_##name(_Src0, _Src1, flag);                  \\\012    return _Result(0);                                                         \\\012  }\012#define _CM_INTRINSIC_DEF(ftype, name) _CM_INTRINSIC_WITH_CONTROL_DEF(ftype, name, 0)\012\012\012_CM_I",
"NTRINSIC_DEF(half, pow)\012_CM_INTRINSIC_DEF(float, pow)\012\012_CM_INTRINSIC_WITH_CONTROL_DEF(float, div_ieee, CM_HAS_IEEE_DIV_SQRT_CONTROL)\012_CM_INTRINSIC_WITH_CONTROL_DEF(double, div_ieee, CM_HAS_IEEE_DIV_SQRT_CONTROL)\012\012#undef _CM_INTRINSIC_DEF\012#undef _CM_INTRINSIC_WITH_CONTROL_DEF\012\012// cm_sincos\012template <int SZ, typename U>\012CM_NODEBUG CM_INLINE vector<float, SZ>\012cm_sincos(vector_ref<float, SZ> dstcos, U src0, int flag = _GENX_NOSAT) {\012  dstcos = cm_cos(src0, flag);\012  return cm_sin(src0, flag);\012}\012\012template <int N1, int N2, typename U>\012CM_NODEBUG CM_INLINE matrix<float, N1, N2>\012cm_sincos(matrix_ref<float, N1, N2> dstcos, U src0, int flag = _GENX_NOSAT) {\012  dstcos = cm_cos(src0, flag);\012  return cm_sin(src0, flag);\012}\012\012template <int SZ, typename U>\012CM_NODEBUG CM_INLINE vector<half, SZ>\012cm_sincos(vector_ref<half, SZ> dstcos, U src0, int flag = _GENX_NOSAT) {\012  dstcos = cm_cos(src0, flag);\012  return cm_sin(src0, flag);\012}\012\012template <int N1, int N2, typename U>\012CM_NODEBUG CM_INLINE matrix<half, N1, N2>\012cm_sincos(matrix_ref<h",
"alf, N1, N2> dstcos, U src0, int flag = _GENX_NOSAT) {\012  dstcos = cm_cos(src0, flag);\012  return cm_sin(src0, flag);\012}\012\012// cm_atan\012\012#define _CM_HDR_CONST_PI 3.1415926535897932384626433832795\012\012template <typename T, int SZ>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012    details::is_float_or_half<T>::value, vector<T, SZ> >::type\012cm_atan(vector<T, SZ> src0, int flag = _GENX_NOSAT) {\012  vector<T, SZ> _Src0 = cm_abs(src0);\012\012  vector<ushort, SZ> _Neg = src0 < T(0.0);\012  vector<ushort, SZ> _Gt1 = _Src0 > T(1.0);\012\012  _Src0.merge(cm_inv(_Src0), _Gt1);\012\012  vector<T, SZ> _Src0P2 = _Src0 * _Src0;\012  vector<T, SZ> _Src0P4 = _Src0P2 * _Src0P2;\012\012  vector<T, SZ> _Result =\012      (_Src0P4 * T(0.185696) + ((_Src0 * T(0.787997) + T(0.63693)) * _Src0P2) +\012       _Src0) /\012      (((((_Src0 * -T(0.000121387) + T(0.00202308)) * _Src0P2) +\012         (_Src0 * -T(0.0149145)) + T(0.182569)) *\012        _Src0P4) +\012       ((_Src0 * T(0.395889) + T(1.12158)) * _Src0P2) + (_Src0 * T(0.636918)) +\012       T(1.0));\012\012  _Result.merge(T(_CM_HDR_CONST_PI / ",
"2.0) - _Result, _Gt1);\012  _Result.merge(-_Result, _Neg);\012\012  if (flag != _GENX_SAT)\012    return _Result;\012\012  return details::__cm_intrinsic_impl_sat<T>(_Result);\012}\012\012template <typename T, int N1, int N2>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012    details::is_float_or_half<T>::value, vector<T, N1 *N2> >::type\012cm_atan(matrix<T, N1, N2> src0, int flag = _GENX_NOSAT) {\012  vector<T, N1 *N2> _Src0 = src0;\012  return cm_atan(_Src0, flag);\012}\012\012template <typename T>\012CM_NODEBUG\012CM_INLINE typename std::enable_if<details::is_float_or_half<T>::value, T>::type\012cm_atan(T src0, int flag = _GENX_NOSAT) {\012  vector<T, 1> _Src0 = src0;\012  vector<T, 1> _Result = cm_atan(_Src0, flag);\012  return _Result(0);\012}\012\012// cm_acos\012\012template <typename T, int SZ>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012    details::is_float_or_half<T>::value, vector<T, SZ> >::type\012cm_acos(vector<T, SZ> src0, int flag = _GENX_NOSAT) {\012  vector<T, SZ> _Src0 = cm_abs(src0);\012\012  vector<ushort, SZ> _Neg = src0 < T(0.0);\012  vector<ushort, SZ> _TooBig = _Src0 >= T(0.",
"999998);\012\012  // Replace oversized values to ensure no possibility of sqrt of\012  // a negative value later\012  _Src0.merge(T(0.0), _TooBig);\012\012  vector<T, SZ> _Src01m = T(1.0) - _Src0;\012\012  vector<T, SZ> _Src0P2 = _Src01m * _Src01m;\012  vector<T, SZ> _Src0P4 = _Src0P2 * _Src0P2;\012\012  vector<T, SZ> _Result =\012      (((_Src01m * T(0.015098965761299077) - T(0.005516443930088506)) *\012        _Src0P4) +\012       ((_Src01m * T(0.047654245891495528) + T(0.163910606547823220)) *\012        _Src0P2) +\012       _Src01m * T(2.000291665285952400) - T(0.000007239283986332)) *\012      cm_rsqrt(_Src01m * T(2.0));\012\012  _Result.merge(T(0.0), _TooBig);\012  _Result.merge(T(_CM_HDR_CONST_PI) - _Result, _Neg);\012\012  if (flag != _GENX_SAT)\012    return _Result;\012\012  return details::__cm_intrinsic_impl_sat<T>(_Result);\012}\012\012template <typename T, int N1, int N2>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012    details::is_float_or_half<T>::value, vector<T, N1 *N2> >::type\012cm_acos(matrix<T, N1, N2> src0, int flag = _GENX_NOSAT) {\012  vector<T, N1 *N2> _Src0 = src0;\012  re",
"turn cm_acos(_Src0, flag);\012}\012\012template <typename T>\012CM_NODEBUG\012CM_INLINE typename std::enable_if<details::is_float_or_half<T>::value, T>::type\012cm_acos(T src0, int flag = _GENX_NOSAT) {\012  vector<T, 1> _Src0 = src0;\012  vector<T, 1> _Result = cm_acos(_Src0, flag);\012  return _Result(0);\012}\012\012// cm_asin\012\012template <typename T, int SZ>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012    details::is_float_or_half<T>::value, vector<T, SZ> >::type\012cm_asin(vector<T, SZ> src0, int flag = _GENX_NOSAT) {\012  vector<ushort, SZ> _Neg = src0 < T(0.0);\012\012  vector<T, SZ> _Result = T(_CM_HDR_CONST_PI / 2.0) - cm_acos(cm_abs(src0));\012\012  _Result.merge(-_Result, _Neg);\012\012  if (flag != _GENX_SAT)\012    return _Result;\012\012  return details::__cm_intrinsic_impl_sat<T>(_Result);\012}\012\012template <typename T, int N1, int N2>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012    details::is_float_or_half<T>::value, vector<T, N1 *N2> >::type\012cm_asin(matrix<T, N1, N2> src0, int flag = _GENX_NOSAT) {\012  vector<T, N1 *N2> _Src0 = src0;\012  return cm_asin(_Src0, flag);\012",
"}\012\012template <typename T>\012CM_NODEBUG\012CM_INLINE typename std::enable_if<details::is_float_or_half<T>::value, T>::type\012cm_asin(T src0, int flag = _GENX_NOSAT) {\012  vector<T, 1> _Src0 = src0;\012  vector<T, 1> _Result = cm_asin(_Src0, flag);\012  return _Result(0);\012}\012\012////////////////////////////////////////////////////////////////////////////////\012// Rounding intrinsics.\012////////////////////////////////////////////////////////////////////////////////\012\012#define _CM_INTRINSIC_DEF(name)                                                \\\012  template <typename T, int SZ>                                                \\\012  CM_NODEBUG CM_INLINE                                                         \\\012  vector<T, SZ> cm_##name(vector<float, SZ> src0, int flag = _GENX_NOSAT) {    \\\012    vector<float, SZ> _Result = details::__cm_intrinsic_impl_##name(src0);     \\\012    if (flag != _GENX_SAT)                                                     \\\012      return _Result;                                                          \\\012    return d",
"etails::__cm_intrinsic_impl_sat<T>(_Result);                       \\\012  }                                                                            \\\012  template <typename T, int N1, int N2>                                        \\\012  CM_NODEBUG CM_INLINE vector<T, N1 *N2> cm_##name(matrix<float, N1, N2> src0, \\\012                                                   int flag = _GENX_NOSAT) {   \\\012    vector<float, N1 *N2> _Src0 = src0;                                        \\\012    return cm_##name<T>(_Src0, flag);                                          \\\012  }                                                                            \\\012  template <typename T>                                                        \\\012  CM_NODEBUG CM_INLINE T cm_##name(float src0, int flag = _GENX_NOSAT) {       \\\012    vector<float, 1> _Src0 = src0;                                             \\\012    vector<T, 1> _Result = cm_##name<T>(_Src0, flag);                          \\\012    return _Result(0);                                          ",
"               \\\012  }\012\012_CM_INTRINSIC_DEF(rndd)\012_CM_INTRINSIC_DEF(rndu)\012_CM_INTRINSIC_DEF(rnde)\012_CM_INTRINSIC_DEF(rndz)\012\012#undef _CM_INTRINSIC_DEF\012\012/// Count component-wise the total bits set in source operand.\012template <typename T, int N>\012CM_NODEBUG CM_INLINE\012typename std::enable_if<std::is_integral<T>::value, vector<uint, N> >::type\012cm_cbit(vector<T, N> src0) {\012  return details::__cm_intrinsic_impl_cbit(src0);\012}\012\012template <typename T, int N1, int N2>\012CM_NODEBUG CM_INLINE\012typename std::enable_if<std::is_integral<T>::value, vector<uint, N1 *N2> >::type\012cm_cbit(matrix<T, N1, N2> src) {\012  vector<T, N1 *N2> _Src = src;\012  return cm_cbit(_Src);\012}\012\012template <typename T>\012CM_NODEBUG CM_INLINE\012typename std::enable_if<std::is_integral<T>::value &&\012                        details::is_cm_scalar<T>::value, uint>::type\012cm_cbit(T src) {\012  vector<T, 1> _Src = src;\012  vector<uint, 1> _Result = cm_cbit(_Src);\012  return _Result(0);\012}\012\012/// Find component-wise the first bit from LSB side\012template <int N>\012CM_NODEBUG CM_INLINE\012vector<un",
"signed, N> cm_fbl(vector<unsigned, N> src) {\012  return details::__cm_intrinsic_impl_fbl(src);\012}\012\012template <int N1, int N2>\012CM_NODEBUG CM_INLINE\012vector<unsigned, N1 * N2>\012cm_fbl(matrix<unsigned, N1, N2> src) {\012  vector<unsigned, N1 * N2> _Src = src;\012  return cm_fbl(_Src);\012}\012\012template <typename T = void>\012CM_NODEBUG CM_INLINE\012unsigned cm_fbl(unsigned src) {\012  vector<unsigned, 1> _Src = src;\012  vector<unsigned, 1> _Result = cm_fbl(_Src);\012  return _Result(0);\012}\012\012/// Find component-wise the first bit from MSB side.\012template <int N>\012CM_NODEBUG CM_INLINE vector<int, N> cm_fbh(vector<int, N> src) {\012  return details::__cm_intrinsic_impl_sfbh(src);\012}\012\012template <int N>\012CM_NODEBUG CM_INLINE vector<unsigned int, N>\012cm_fbh(vector<unsigned int, N> src) {\012  return details::__cm_intrinsic_impl_ufbh(src);\012}\012\012template <typename T, int N1, int N2>\012CM_NODEBUG CM_INLINE typename std::enable_if<details::is_dword_type<T>::value,\012                                             vector<T, N1 *N2> >::type\012cm_fbh(matrix<T, N1, N2> src) {\012  vec",
"tor<T, N1 *N2> _Src = src;\012  return cm_fbh(_Src);\012}\012\012template <typename T>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012    details::is_dword_type<T>::value &&details::is_cm_scalar<T>::value, T>::type\012cm_fbh(T src) {\012  vector<T, 1> _Src = src;\012  vector<T, 1> _Result = cm_fbh(_Src);\012  return _Result(0);\012}\012\012template <typename T = void> vector<uint, 4> cm_rdtsc();\012\012//////////////////////////////////////////\012// Legacy f16 to f32 and vice versa\012//////////////////////////////////////////\012\012// Not really required for cmc as we support half types now\012// Provided for backward compatibility\012template <typename T, int N>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012    details::is_word_type<T>::value &&details::is_cm_scalar<T>::value,\012    vector<float, N> >::type\012cm_f16tof32(const vector<T, N> src) {\012  vector<float, N> _ret = src.format<half>();\012  return _ret;\012}\012\012template <typename T, int N1, int N2>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012    details::is_word_type<T>::value &&details::is_cm_scalar<T>::value,\012    ",
"matrix<float, N1, N2> >::type\012cm_f16tof32(const matrix<T, N1, N2> src) {\012  matrix<float, N1, N2> _ret = src.format<half>();\012  return _ret;\012}\012\012template <typename T, int N>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012    std::is_floating_point<T>::value &&details::is_cm_scalar<T>::value,\012    vector<ushort, N> >::type\012cm_f32tof16(const vector<T, N> src) {\012  vector<half, N> _ret = src;\012  return _ret.format<ushort>();\012}\012\012template <typename T, int N1, int N2>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012    std::is_floating_point<T>::value &&details::is_cm_scalar<T>::value,\012    matrix<ushort, N1, N2> >::type\012cm_f32tof16(const matrix<T, N1, N2> src) {\012  matrix<half, N1, N2> _ret = src;\012  return _ret.format<ushort>();\012}\012\012//////////////////////////////////////////\012// DPAS intrinsic begin\012//////////////////////////////////////////\012\012template <CmPrecisionType src1_precision, CmPrecisionType src2_precision,\012          int systolic_depth, int repeat_count, typename T,\012          typename T1, typename T2, int N, int N1, in",
"t N2>\012CM_NODEBUG CM_INLINE void cm_dpas_check_common() {\012\012  CM_HAS_DPAS_CONTROL;\012 \012  CM_STATIC_ERROR(details::is_dword_type<T1>::value,\012    \"Src1 must be DWORD type\");\012 \012  CM_STATIC_ERROR(details::is_dword_type<T2>::value,\012    \"Src2 must be DWORD type\");\012\012  CM_STATIC_ERROR((systolic_depth == 8) || (systolic_depth == 4),\012    \"systolic_depth must be 8 or 4\");\012\012  CM_STATIC_ERROR((repeat_count >= 1) && (repeat_count <= 8),\012                  \"repeat_count must be within 1 to 8\");\012#if !defined(CM_GENX)\012  CM_STATIC_WARNING(0, \"GEN not specified so cm_dpas() code may not be optimal\");\012  constexpr int DPAS_EXECUTION_SIZE = 8;\012#else // !defined(CM_GENX)\012  constexpr int DPAS_EXECUTION_SIZE = (CM_GENX >= 1280) \? 16 : 8;\012#endif // !defined(CM_GENX)\012\012  CM_STATIC_ERROR((N == DPAS_EXECUTION_SIZE * repeat_count),\012                  \"Unsupported execution size in dpas\");\012\012  //DPAS RepeatCount is restricted to event counts except 8x1\012  if constexpr (repeat_count > 1 && repeat_count % 2 == 1)\012    CM_HAS_DPAS_ODD_CONTROL;\012 \012  cons",
"texpr unsigned ops_per_channel = get_ops_per_channel(src1_precision,\012                                                           src2_precision);\012  CM_STATIC_ERROR(ops_per_channel != 0xFFFFFFFF,\012    \"invalid combination of Src1/Src2 precision\");\012  constexpr unsigned src1_precision_bits = get_precision_bits(src1_precision);\012  \012  CM_STATIC_ERROR(N1 == ((src1_precision_bits * systolic_depth * ops_per_channel * N) / (repeat_count * sizeof(T1) * 8)),\012    \"invalid size for Src1\");\012  \012  constexpr unsigned src2_precision_bits = get_precision_bits(src2_precision);\012  CM_STATIC_ERROR(N2 == ((src2_precision_bits * systolic_depth * ops_per_channel * repeat_count) / (sizeof(T2) * 8)),\012    \"invalid size for Src2\");\012}\012\012template <CmPrecisionType src1_precision, CmPrecisionType src2_precision,\012          typename T0, int systolic_depth, int repeat_count, typename T,\012          typename T1, typename T2, int N, int N1, int N2>\012CM_NODEBUG CM_INLINE void cm_dpas_check_types() {\012   \012  // INT ///////////////////////////////////////////",
"///////////////////////////\012  // types: dst, src0, src1, src2\012  // ud, d | ud, d | ub, b | ub, b\012  // ud, d | ud, d | u4, s4, u2, s2 | ub, b\012  // ud, d | ud, d | ub, b | u4, s4, u2, s2\012  // ud, d | ud, d | u4, s4, u2, s2 | u4, s4, u2, s2\012  constexpr bool check_int = \012      details::is_one_of_v<T0, unsigned int, int> &&\012      details::is_one_of_v<T, unsigned int, int> &&\012      details::is_one_of_enum_v<\012          CmPrecisionType, src1_precision, CmPrecisionType::CM_Precision_S8,\012          CmPrecisionType::CM_Precision_U8, CmPrecisionType::CM_Precision_U4,\012          CmPrecisionType::CM_Precision_S4, CmPrecisionType::CM_Precision_U2,\012          CmPrecisionType::CM_Precision_S2> &&\012      details::is_one_of_enum_v<\012          CmPrecisionType, src2_precision, CmPrecisionType::CM_Precision_S8,\012          CmPrecisionType::CM_Precision_U8, CmPrecisionType::CM_Precision_U4,\012          CmPrecisionType::CM_Precision_S4, CmPrecisionType::CM_Precision_U2,\012          CmPrecisionType::CM_Precision_S2>;\012  /////////////////////////",
"/////////////////////////////////////////////////////\012  // HF ////////////////////////////////////////////////////////////////////////\012  // f,hf | f, hf | hf | hf\012  constexpr bool check_hf = (\012      details::is_one_of_v<T0, float, half> &&\012      details::is_one_of_v<T, float, half> &&\012      details::is_one_of_enum_v<CmPrecisionType, src1_precision,\012                                CmPrecisionType::CM_Precision_FP16> &&\012      details::is_one_of_enum_v<CmPrecisionType, src2_precision,\012                                CmPrecisionType::CM_Precision_FP16>);\012  //////////////////////////////////////////////////////////////////////////////\012  // BF16 //////////////////////////////////////////////////////////////////////\012  // f, bf | f, bf | bf | bf \012  CM_HAS_BF16_CONTROL;\012  \012  constexpr bool check_bf16 = \012      details::is_one_of_v<T0, float, short> &&\012      details::is_one_of_v<T, float, short> &&\012      details::is_one_of_enum_v<CmPrecisionType, src1_precision,\012                                CmPrecisionType::CM_Precis",
"ion_BF16> &&\012      details::is_one_of_enum_v<CmPrecisionType, src2_precision,\012                                CmPrecisionType::CM_Precision_BF16>;\012\012  //////////////////////////////////////////////////////////////////////////////\012  // TF32 //////////////////////////////////////////////////////////////////////\012#ifdef CM_HAS_TF32\012  // f | f | tf32 | tf32\012  constexpr bool check_tf32 = \012      details::is_one_of_v<T0, float> && details::is_one_of_v<T, float> &&\012      details::is_one_of_enum_v<CmPrecisionType, src1_precision,\012                                CmPrecisionType::CM_Precision_TF32> &&\012      details::is_one_of_enum_v<CmPrecisionType, src2_precision,\012                                CmPrecisionType::CM_Precision_TF32>;\012#else  // CM_HAS_TF32\012  constexpr bool check_tf32 = false;\012#endif // CM_HAS_TF32\012  if constexpr (check_hf && (std::is_same<T0, half>::value || std::is_same<T, half>::value))\012    CM_HAS_DPAS_ACC_HALF_CONTROL;\012  if constexpr (check_bf16 && (std::is_same<T0, short>::value || std::is_same<T, short",
">::value))\012    CM_HAS_DPAS_ACC_BF16_CONTROL;\012\012  constexpr bool is_right = (check_int || check_hf || check_bf16 || check_tf32);\012\012\012  if (!is_right) {\012    CM_STATIC_WARNING(is_right, \"types: dst | src0 | src1(from template \"\012                             \"parameter) | src2(from template parameter)\");\012    CM_STATIC_WARNING(is_right, \"ud, d | ud, d | ub, b, u4, s4, u2, s2 | ub, b, u4, s4, u2, s2\");\012    CM_STATIC_WARNING(is_right, \"f, bf | f, bf | bf | bf\");\012    CM_STATIC_WARNING(is_right, \"f, hf | f, hf | hf | hf\");\012#if defined(CM_HAS_TF32)\012      CM_STATIC_WARNING(is_right, \"f | f | tf32 | tf32\");\012#endif // defined(CM_HAS_TF32)\012\012    CM_STATIC_ERROR(is_right, \"unsupported dpas type\");\012  }\012}\012\012template <CmPrecisionType src1_precision, CmPrecisionType src2_precision,\012          typename T0, int systolic_depth, int repeat_count, typename T,\012          typename T1, typename T2, int N, int N1, int N2>\012CM_NODEBUG CM_INLINE vector<T0, N>\012cm_dpas(vector<T, N> src0, vector<T1, N1> src1, vector<T2, N2> src2,\012        int flag = _",
"GENX_NOSAT) {\012  cm_dpas_check_common<src1_precision, src2_precision,\012                       systolic_depth, repeat_count, T,\012                       T1, T2, N, N1, N2>();\012\012  cm_dpas_check_types<src1_precision, src2_precision,\012                      T0, systolic_depth, repeat_count, T,\012                      T1, T2, N, N1, N2>();\012\012  vector<T, N> _Src0 = src0;\012  vector<T1, N1> _Src1 = src1;\012  vector<T2, N2> _Src2 = src2;\012  vector<T0, N> _Result =\012      details::__cm_intrinsic_impl_dpas<src1_precision, src2_precision,\012                                        systolic_depth, repeat_count, T0>(\012          _Src0, _Src1, _Src2);\012  if (flag != _GENX_SAT)\012    return _Result;\012\012  return details::__cm_intrinsic_impl_sat<T0>(_Result);\012}\012\012template <CmPrecisionType src1_precision, CmPrecisionType src2_precision,\012          int systolic_depth, int repeat_count, typename T, typename T1,\012          typename T2, int N, int N1, int N2>\012CM_NODEBUG CM_INLINE vector<T, N>\012cm_dpas(vector<T, N> src0, vector<T1, N1> src1, vector<T2, N2> src2",
",\012        int flag = _GENX_NOSAT) {\012  return cm_dpas<src1_precision, src2_precision, T, systolic_depth,\012                 repeat_count>(src0, src1, src2, flag);\012}\012\012template <CmPrecisionType src1_precision,\012  CmPrecisionType src2_precision,\012  int systolic_depth,\012  int repeat_count,\012  typename T, typename T1, typename T2,\012  int N, int N1, int N2>\012  CM_NODEBUG CM_INLINE vector<T, N>\012  cm_dpas(int dummy,\012    vector<T1, N1> src1,\012    vector<T2, N2> src2,\012    int flag = _GENX_NOSAT)\012{\012  cm_dpas_check_common<src1_precision, src2_precision,\012                       systolic_depth, repeat_count, T,\012                      T1, T2, N, N1, N2>();\012\012  CM_STATIC_ERROR(details::is_fp_or_dword_type<T>::value,\012    \"Dst and Src0 must be FP or DWORD type\");\012\012  vector<T1, N1> _Src1 = src1;\012  vector<T2, N2> _Src2 = src2;\012  vector<T, N> _Result = details::__cm_intrinsic_impl_dpas_nosrc0<src1_precision, src2_precision, systolic_depth, repeat_count, T, T1, T2, N>(NULL, _Src1, _Src2);\012  if (flag != _GENX_SAT)\012    return _Result;\012\012  return ",
"details::__cm_intrinsic_impl_sat<T>(_Result);\012}\012\012//////////////////////////////////////////\012// DPAS intrinsic end\012//////////////////////////////////////////\012\012//////////////////////////////////////////\012// DPASW intrinsic begin\012//////////////////////////////////////////\012template <CmPrecisionType src1_precision,\012          CmPrecisionType src2_precision,\012          int systolic_depth,\012          int repeat_count,\012          typename T, typename T1, typename T2,\012          int N, int N1, int N2>\012CM_NODEBUG CM_INLINE vector<T, N>\012cm_dpasw(vector<T, N> src0,\012    vector<T1, N1> src1,\012    vector<T2, N2> src2,\012    int flag = _GENX_NOSAT)\012{\012  CM_HAS_DPASW_CONTROL;\012\012  CM_STATIC_ERROR(details::is_fp_or_dword_type<T>::value,\012    \"Dst and Src0 must be FP or DWORD type\");\012\012  CM_STATIC_ERROR(details::is_dword_type<T1>::value,\012    \"Src1 must be DWORD type\");\012\012  CM_STATIC_ERROR(details::is_dword_type<T2>::value,\012    \"Src2 must be DWORD type\");\012\012  CM_STATIC_ERROR((N == 8 * repeat_count), \"Execution size must be 8\");\012\012  CM_STATIC_ERR",
"OR((systolic_depth == 8) || (systolic_depth == 4),\012    \"systolic_depth must be 8 or 4\");\012\012  CM_STATIC_ERROR((repeat_count >= 1) && (repeat_count <= 8),\012    \"repeat_count must be within 1 to 8\");\012\012  constexpr unsigned ops_per_channel = get_ops_per_channel(src1_precision, src2_precision);\012  CM_STATIC_ERROR(ops_per_channel != 0xFFFFFFFF,\012    \"invalid combination of Src1/Src2 precision\");\012\012  constexpr unsigned src1_precision_bits = get_precision_bits(src1_precision);\012  CM_STATIC_ERROR(N1 == ((src1_precision_bits * systolic_depth * ops_per_channel * N) / (repeat_count * sizeof(T1) * 8)),\012    \"invalid size for Src1\");\012\012  constexpr unsigned src2_precision_bits = get_precision_bits(src2_precision);\012  CM_STATIC_ERROR(N2 == ((src2_precision_bits * systolic_depth * ops_per_channel * ((repeat_count + 1)/2)) / (sizeof(T2) * 8)),\012    \"invalid size for Src2\");\012\012  vector<T, N> _Src0 = src0;\012  vector<T1, N1> _Src1 = src1;\012  vector<T2, N2> _Src2 = src2;\012  vector<T, N> _Result =\012      details::__cm_intrinsic_impl_dpasw<src1_pre",
"cision, src2_precision,\012                         systolic_depth, repeat_count, T>(_Src0, _Src1, _Src2);\012  if (flag != _GENX_SAT)\012    return _Result;\012\012  return details::__cm_intrinsic_impl_sat<T>(_Result);\012}\012\012template <CmPrecisionType src1_precision,\012  CmPrecisionType src2_precision,\012  int systolic_depth,\012  int repeat_count,\012  typename T, typename T1, typename T2,\012  int N, int N1, int N2>\012  CM_NODEBUG CM_INLINE vector<T, N>\012  cm_dpasw(int dummy,\012    vector<T1, N1> src1,\012    vector<T2, N2> src2,\012    int flag = _GENX_NOSAT)\012{\012  CM_HAS_DPASW_CONTROL;\012\012  CM_STATIC_ERROR(details::is_fp_or_dword_type<T>::value,\012    \"Dst and Src0 must be FP or DWORD type\");\012\012  CM_STATIC_ERROR(details::is_dword_type<T1>::value,\012    \"Src1 must be DWORD type\");\012\012  CM_STATIC_ERROR(details::is_dword_type<T2>::value,\012    \"Src2 must be DWORD type\");\012\012  CM_STATIC_ERROR(N == 8 * repeat_count,\012    \"Execution size must be 8\");\012  CM_STATIC_ERROR((systolic_depth == 8) || (systolic_depth == 4),\012    \"systolic_depth must be 8 or 4\");\012\012  CM_STATIC_ER",
"ROR((repeat_count >= 1) && (repeat_count <= 8),\012    \"repeat_count must be within 1 to 8\");\012\012  constexpr unsigned ops_per_channel = get_ops_per_channel(src1_precision, src2_precision);\012  CM_STATIC_ERROR(ops_per_channel != 0xFFFFFFFF,\012    \"invalid combination of Src1/Src2 precision\");\012\012  constexpr unsigned src1_precision_bits = get_precision_bits(src1_precision);\012  CM_STATIC_ERROR(N1 == ((src1_precision_bits * systolic_depth * ops_per_channel * N) / (repeat_count * sizeof(T1) * 8)),\012    \"invalid size for Src1\");\012\012  constexpr unsigned src2_precision_bits = get_precision_bits(src2_precision);\012  CM_STATIC_ERROR(N2 == ((src2_precision_bits * systolic_depth * ops_per_channel * ((repeat_count + 1) / 2)) / (sizeof(T2) * 8)),\012    \"invalid size for Src2\");\012\012  vector<T1, N1> _Src1 = src1;\012  vector<T2, N2> _Src2 = src2;\012  vector<T, N> _Result = details::__cm_intrinsic_impl_dpasw_nosrc0<src1_precision, src2_precision, systolic_depth, repeat_count, T, T1, T2, N>(NULL, _Src1, _Src2);\012  if (flag != _GENX_SAT)\012    return _Resu",
"lt;\012\012  return details::__cm_intrinsic_impl_sat<T>(_Result);\012}\012\012//////////////////////////////////////////\012// DPASW intrinsic end\012//////////////////////////////////////////\012\012#if (CM_HAS_BF16)\012\012//////////////////////////////////////////\012// bf_cvt intrinsic begin\012//////////////////////////////////////////\012\012template <typename T, typename T0, int N>\012CM_NODEBUG CM_INLINE\012vector<T, N>\012cm_bf_cvt(vector<T0, N> src0) {\012  CM_STATIC_ERROR(\012    (std::is_same<half, typename std::remove_const<T>::type>::value &&\012     std::is_same<float, typename std::remove_const<T0>::type>::value) ||\012    (std::is_same<float, typename std::remove_const<T>::type>::value &&\012     std::is_same<half, typename std::remove_const<T0>::type>::value),\012    \"Invalid type for cm_bf_cvt: src->dst must be half->float or float->half\");\012  return details::__cm_intrinsic_impl_bf_cvt<T>(src0);\012}\012\012template <typename T, typename T0, int N1, int N2>\012CM_NODEBUG CM_INLINE\012vector<T, N1*N2>\012cm_bf_cvt(matrix<T0, N1, N2> src) {\012  vector<T0, N1 *N2> _Src = src;\012  return",
" cm_bf_cvt<T>(_Src);\012}\012\012template <typename T, typename T0>\012CM_NODEBUG CM_INLINE\012typename std::enable_if<\012  details::is_cm_scalar<T>::value &&details::is_cm_scalar<T0>::value,\012  typename std::remove_const<T>::type>::type\012cm_bf_cvt(T0 src) {\012  vector<T0, 1> _Src = src;\012  vector<T, 1> _Result = cm_bf_cvt<T>(_Src);\012  return _Result(0);\012}\012//////////////////////////////////////////\012// bf_cvt intrinsic end\012//////////////////////////////////////////\012#endif // CM_HAS_BF16\012\012template <typename T1, typename T2, typename T3, typename T4, int N>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012    details::is_dword_type<T1>::value &&\012    details::is_dword_type<T2>::value &&\012    details::is_dword_type<T3>::value &&\012    details::is_dword_type<T4>::value,\012    vector<T1, N> >::type\012cm_dp4a(vector<T2, N> src0, vector<T3, N> src1, vector<T4, N> src2,\012        int flag = _GENX_NOSAT) {\012  CM_HAS_DP4A_CONTROL;\012\012  vector<T2, N> _Src0 = src0;\012  vector<T3, N> _Src1 = src1;\012  vector<T4, N> _Src2 = src2;\012  vector<T1, N> _Result =\012      deta",
"ils::__cm_intrinsic_impl_dp4a<T1>(_Src0, _Src1, _Src2, flag);\012  return _Result;\012}\012\012////////////////////////////////////////////////////////////////////////////////\012// SIMD control follow related macros.\012////////////////////////////////////////////////////////////////////////////////\012#ifndef _SIMD_CF_\012#define _SIMD_CF_\012\012// If-Else Statement\012#define SIMD_IF_BEGIN(...)                                                     \\\012  if (details::__cm_intrinsic_impl_simdcf_any((__VA_ARGS__), __FILE__,         \\\012                                              __LINE__)) {\012\012#define SIMD_ELSEIF(...)                                                       \\\012  }                                                                            \\\012  else if (details::__cm_intrinsic_impl_simdcf_any((__VA_ARGS__), __FILE__,    \\\012                                                   __LINE__)) {\012\012#define SIMD_ELSE                                                              \\\012  }                                                                    ",
"        \\\012  else {\012#define SIMD_IF_END }\012\012// Do-While Statement\012#define SIMD_DO_WHILE_BEGIN do {\012#define SIMD_DO_WHILE_END(...)                                                 \\\012  }                                                                            \\\012  while (details::__cm_intrinsic_impl_simdcf_any((__VA_ARGS__), __FILE__,      \\\012                                                 __LINE__))\012\012#define SIMD_BREAK break\012#define SIMD_CONTINUE continue\012\012#endif // _SIMD_CF_\012\012////////////////////////////////////////////////////////////////////////////////\012// Opimizations fence object.\012////////////////////////////////////////////////////////////////////////////////\012namespace cm {\012\012class CMOptimizationsFence final {\012public:\012  [[gnu::abi_tag(\"__cm_optfence_begin__\")]] CMOptimizationsFence();\012  [[gnu::abi_tag(\"__cm_optfence_end__\")]] ~CMOptimizationsFence();\012\012  CMOptimizationsFence(CMOptimizationsFence &) = delete;\012  CMOptimizationsFence &operator=(CMOptimizationsFence &) = delete;\012  CMOptimizationsFence(CMOptimiza",
"tionsFence &&) = delete;\012  CMOptimizationsFence &operator=(CMOptimizationsFence &&) = delete;\012\012  CMOptimizationsFence *operator&() = delete;\012};\012\012} // namespace cm\012\012#define _CM_OPTFENCE_GET_NAME_(pref, ID) pref##ID\012#define _CM_OPTFENCE_UNIQ_DECL_(ID)                                            \\\012  cm::CMOptimizationsFence _CM_OPTFENCE_GET_NAME_(__cm_optimizations_fence__, ID);\012#define CM_OPTIMIZATIONS_FENCE CM_STATIC_ERROR(sizeof(__func__) != 1, \"Fence must be used at function scope!\"); _CM_OPTFENCE_UNIQ_DECL_(__COUNTER__);\012\012#endif // _CLANG_CM_H_\012\000/*========================== begin_copyright_notice ============================\012\012Copyright (C) 2014-2021 Intel Corporation\012\012SPDX-License-Identifier: MIT\012\012============================= end_copyright_notice ===========================*/\012\012#if (__INCLUDE_LEVEL__ == 1)\012static_assert(0, \"CM:w:cm_internal.h should not be included explicitly - only \"\012                 \"<cm/cm.h> is required\");\012#endif\012\012#ifndef _CLANG_CM_INTERNAL_H_\012#define _CLANG_CM_INTERNAL_H_\012\012#include \"cm_",
"common.h\"\012#include \"cm_util.h\"\012\012namespace details {\012\012template <typename T0, typename T1, int SZ>\012vector<T0, SZ> __cm_intrinsic_impl_sat(vector<T1, SZ> src);\012\012template <typename T0, typename T1> T0 __cm_intrinsic_impl_sat(T1 src);\012\012template <typename T, int SZ>\012vector<T, SZ> __cm_intrinsic_impl_abs(vector<T, SZ> src0);\012\012template <typename T0, typename T1, int SZ>\012vector<T0, SZ> __cm_intrinsic_impl_add(vector<T1, SZ> src0, vector<T1, SZ> src1,\012                                       int flag);\012\012template <int SZ>\012vector<unsigned, SZ> __cm_intrinsic_impl_addc(vector<unsigned, SZ> src0,\012                                              vector<unsigned, SZ> src1,\012                                              vector_ref<unsigned, SZ> carry);\012\012template <int SZ>\012vector<unsigned, SZ> __cm_intrinsic_impl_subb(vector<unsigned, SZ> src0,\012                                              vector<unsigned, SZ> src1,\012                                              vector_ref<unsigned, SZ> borrow);\012\012template <typename T0, typename T1, in",
"t SZ>\012vector<T0, SZ> __cm_intrinsic_impl_mul(vector<T1, SZ> src0, vector<T1, SZ> src1,\012                                       int flag);\012\012template <typename T0, typename T1, int SZ>\012vector<T0, SZ> __cm_intrinsic_impl_avg(vector<T1, SZ> src0, vector<T1, SZ> src1,\012                                       int flag);\012\012template <typename T0, typename T1, int SZ>\012vector<T0, SZ> __cm_intrinsic_impl_shl(vector<T1, SZ> src0, vector<T1, SZ> src1,\012                                       int flag);\012\012template <typename T0, typename T1, int SZ>\012vector<T0, SZ> __cm_intrinsic_impl_rol(vector<T1, SZ> src0, vector<T1, SZ> src1);\012template <typename T0, typename T1, int SZ>\012vector<T0, SZ> __cm_intrinsic_impl_ror(vector<T1, SZ> src0, vector<T1, SZ> src1);\012\012template <typename T, int SZ>\012vector<T, SZ> __cm_intrinsic_impl_imad(vector_ref<T, SZ> lo, vector<T, SZ> src0,\012                                       vector<T, SZ> src1, vector<T, SZ> src2);\012template <typename T> T __cm_intrinsic_impl_imad(T &lo, T src0, T src1, T src2);\012\012template",
" <int SZ>\012vector<float, SZ> __cm_intrinsic_impl_dp2(vector<float, SZ> src0,\012                                          vector<float, SZ> src1);\012\012template <int SZ>\012vector<float, SZ> __cm_intrinsic_impl_dp3(vector<float, SZ> src0,\012                                          vector<float, SZ> src1);\012\012template <int SZ>\012vector<float, SZ> __cm_intrinsic_impl_dp4(vector<float, SZ> src0,\012                                          vector<float, SZ> src1);\012\012template <int SZ>\012vector<float, SZ> __cm_intrinsic_impl_dph(vector<float, SZ> src0,\012                                          vector<float, SZ> src1);\012\012template <int SZ>\012vector<float, SZ> __cm_intrinsic_impl_frc(vector<float, SZ> src0);\012\012template <int SZ>\012vector<float, SZ> __cm_intrinsic_impl_line(vector<float, 4> src0,\012                                           vector<float, SZ> src1);\012\012template <typename T, int SZ>\012vector<T, SZ> __cm_intrinsic_impl_max(vector<T, SZ> src0, vector<T, SZ> src1);\012\012template <typename T, int SZ>\012vector<T, SZ> __cm_intrinsic_impl_lzd(vector<",
"T, SZ> src0);\012\012template <typename T, int SZ>\012vector<T, SZ> __cm_intrinsic_impl_min(vector<T, SZ> src0, vector<T, SZ> src1);\012\012//sad2 has 8-bit inputs and 16-bit result, no need for saturation\012template <typename T0, typename T1, int SZ>\012vector<T0, SZ> __cm_intrinsic_impl_sad2(vector<T1, SZ> src0,\012                                        vector<T1, SZ> src1);\012\012template <typename T0, typename T1, int SZ>\012vector<T0, SZ> __cm_intrinsic_impl_sada2(vector<T1, SZ> src0,\012                                         vector<T1, SZ> src1,\012                                         vector<T0, SZ> src2, int flag);\012\012template <int SZ>\012vector<float, SZ> __cm_intrinsic_impl_lrp(vector<float, SZ> src0,\012                                          vector<float, SZ> src1,\012                                          vector<float, SZ> src2);\012\012template <int SZ>\012vector<float, SZ> __cm_intrinsic_impl_pln(vector<float, 4> src0,\012                                          vector<float, SZ * 2> src1);\012\012template <typename T0, typename T1, int SZ>\012vector",
"<T0, SZ> __cm_intrinsic_impl_bfrev(vector<T1, SZ> src0);\012\012template <typename T, int SZ>\012vector<unsigned int, SZ> __cm_intrinsic_impl_cbit(vector<T, SZ> src0);\012\012template <typename T0, int SZ>\012vector<T0, SZ>\012__cm_intrinsic_impl_bfins(vector<T0, SZ> src0, vector<T0, SZ> src1,\012                          vector<T0, SZ> src2, vector<T0, SZ> src3);\012\012template <typename T0, int SZ>\012vector<T0, SZ> __cm_intrinsic_impl_bfext(vector<T0, SZ> src0,\012                                         vector<T0, SZ> src1,\012                                         vector<T0, SZ> src2);\012\012template <int SZ>\012vector<uint, SZ> __cm_intrinsic_impl_fbl(vector<uint, SZ> src0);\012\012template <typename T0, int SZ>\012vector<int, SZ> __cm_intrinsic_impl_sfbh(vector<T0, SZ> src0);\012\012template <typename T0, int SZ>\012vector<uint, SZ> __cm_intrinsic_impl_ufbh(vector<T0, SZ> src0);\012\012template <typename T0, typename T1, int SZ>\012T0 __cm_intrinsic_impl_sum(vector<T1, SZ> src);\012template <typename T0, typename T1, int SZ>\012T0 __cm_intrinsic_impl_sum_sat(vector<T1, SZ> src)",
";\012template <typename T0, typename T1, int SZ>\012T0 __cm_intrinsic_impl_prod(vector<T1, SZ> src);\012template <typename T0, typename T1, int SZ>\012T0 __cm_intrinsic_impl_prod_sat(vector<T1, SZ> src);\012template <typename T, int SZ>\012T __cm_intrinsic_impl_reduced_min(vector<T, SZ> src);\012template <typename T, int SZ>\012T __cm_intrinsic_impl_reduced_max(vector<T, SZ> src);\012\012template <int SZ>\012vector<half, SZ> __cm_intrinsic_impl_inv(vector<half, SZ> src0);\012template <int SZ>\012vector<half, SZ> __cm_intrinsic_impl_log(vector<half, SZ> src0);\012template <int SZ>\012vector<half, SZ> __cm_intrinsic_impl_exp(vector<half, SZ> src0);\012template <int SZ>\012vector<half, SZ> __cm_intrinsic_impl_sqrt(vector<half, SZ> src0);\012template <int SZ>\012vector<half, SZ> __cm_intrinsic_impl_rsqrt(vector<half, SZ> src0);\012template <int SZ>\012vector<half, SZ> __cm_intrinsic_impl_sin(vector<half, SZ> src0);\012template <int SZ>\012vector<half, SZ> __cm_intrinsic_impl_cos(vector<half, SZ> src0);\012template <int SZ>\012vector<half, SZ> __cm_intrinsic_impl_pow(vector<half, SZ> src",
"0,\012                                         vector<half, SZ> src1);\012\012template <int SZ>\012vector<float, SZ> __cm_intrinsic_impl_inv(vector<float, SZ> src0);\012template <int SZ>\012vector<float, SZ> __cm_intrinsic_impl_log(vector<float, SZ> src0);\012template <int SZ>\012vector<float, SZ> __cm_intrinsic_impl_exp(vector<float, SZ> src0);\012template <int SZ>\012vector<float, SZ> __cm_intrinsic_impl_sqrt(vector<float, SZ> src0);\012template <int SZ>\012vector<float, SZ> __cm_intrinsic_impl_sqrt_ieee(vector<float, SZ> src0);\012template <int SZ>\012vector<float, SZ> __cm_intrinsic_impl_rsqrt(vector<float, SZ> src0);\012template <int SZ>\012vector<float, SZ> __cm_intrinsic_impl_sin(vector<float, SZ> src0);\012template <int SZ>\012vector<float, SZ> __cm_intrinsic_impl_cos(vector<float, SZ> src0);\012template <int SZ>\012vector<float, SZ> __cm_intrinsic_impl_pow(vector<float, SZ> src0,\012                                          vector<float, SZ> src1);\012template <int SZ>\012vector<float, SZ> __cm_intrinsic_impl_div_ieee(vector<float, SZ> src0,\012                          ",
"                     vector<float, SZ> src1);\012\012template <int SZ>\012vector<float, SZ> __cm_intrinsic_impl_rndd(vector<float, SZ> src0);\012template <int SZ>\012vector<float, SZ> __cm_intrinsic_impl_rndu(vector<float, SZ> src0);\012template <int SZ>\012vector<float, SZ> __cm_intrinsic_impl_rnde(vector<float, SZ> src0);\012template <int SZ>\012vector<float, SZ> __cm_intrinsic_impl_rndz(vector<float, SZ> src0);\012\012template <int SZ>\012vector<double, SZ> __cm_intrinsic_impl_sqrt_ieee(vector<double, SZ> src0);\012template <int SZ>\012vector<double, SZ> __cm_intrinsic_impl_div_ieee(vector<double, SZ> src0,\012                                                vector<double, SZ> src1);\012\012template <typename T, int SZ>\012vector<T, SZ> __cm_intrinsic_impl_oword_read(SurfaceIndex index, int offset);\012\012template <typename T, int SZ>\012vector<T, SZ> __cm_intrinsic_impl_oword_read_dwaligned(SurfaceIndex index,\012                                                       int offset);\012\012template <typename T, int SZ>\012void __cm_intrinsic_impl_oword_write(SurfaceIndex index, int",
" offset,\012                                     vector<T, SZ> src);\012\012template <typename T, int SZ>\012vector<T, SZ> __cm_intrinsic_impl_slm_oword_read(uint slmBuffer, int offset);\012\012template <typename T, int SZ>\012vector<T, SZ> __cm_intrinsic_impl_slm_oword_read_dwaligned(uint slmBuffer,\012                                                       int offset);\012\012template <typename T, int SZ>\012void __cm_intrinsic_impl_slm_oword_write(uint slmBuffer, int offset,\012                                     vector<T, SZ> src);\012\012template <typename T, int N, int M, int _M, CmBufferAttrib attr>\012matrix<T, N, _M> __cm_intrinsic_impl_media_read(SurfaceIndex index, int X,\012                                                int Y);\012\012template <typename T, int N, int M, int _M, CmBufferAttrib attr>\012void __cm_intrinsic_impl_media_write(SurfaceIndex index, int X, int Y,\012                                     matrix<T, N, _M> src);\012\012template <typename T, int N, int M, CmBufferAttrib attr,\012          CmSurfacePlaneIndex plane>\012matrix<T, N, M> __cm_intrinsi",
"c_impl_read_plane(SurfaceIndex index, int X,\012                                               int Y);\012\012template <typename T, int N, int M, int _M, CmBufferAttrib attr,\012          CmSurfacePlaneIndex plane>\012void __cm_intrinsic_impl_write_plane(SurfaceIndex index, int X, int Y,\012                                     matrix<T, N, _M> src);\012\012template <typename T, int N, ChannelMaskType Mask>\012matrix<T, N, 16>\012__cm_intrinsic_impl_sample16(SamplerIndex sampIndex, SurfaceIndex surfIndex,\012                             vector<float, 16> u, vector<float, 16> v,\012                             vector<float, 16> r);\012\012template <int N, ChannelMaskType Mask, OutputFormatControl Ofc>\012matrix<ushort, N, 32>\012__cm_intrinsic_impl_sample32(SamplerIndex sampIndex, SurfaceIndex surfIndex,\012                             float u, float v, float deltaU, float deltaV);\012\012template <typename T, int N, ChannelMaskType Mask>\012matrix<T, N, 16>\012__cm_intrinsic_impl_load16(SurfaceIndex surfIndex, vector<uint, 16> u,\012                           vector<uint, 16",
"> v, vector<uint, 16> r);\012\012template <CmAtomicOpType Op, int N, typename T>\012vector<T, N> __cm_intrinsic_impl_atomic_write(vector<ushort, N> mask,\012                                              SurfaceIndex index,\012                                              vector<uint, N> elementOffset,\012                                              vector<T, N> src0,\012                                              vector<T, N> src1,\012                                              vector<T, N> oldVal);\012\012template <CmAtomicOpType Op, typename T, int N, typename... Args>\012vector<T, N>\012__cm_intrinsic_impl_atomic_write_typed(vector<ushort, N> mask,\012                                       SurfaceIndex surfIndex,\012                                       vector<T, N> src0, vector<T, N> src1,\012                                       vector<uint, N> u, Args... args);\012\012template <typename T0, typename T1, int N>\012vector<T1, N> __cm_intrinsic_impl_scatter_read(SurfaceIndex index,\012                                               uint globalOffset,\012     ",
"                                          vector<uint, N> elementOffset,\012                                               vector<T1, N> oldVal, T0 dummy);\012\012template <typename T0, typename T1, int N>\012void __cm_intrinsic_impl_scatter_write(SurfaceIndex index, uint globalOffset,\012                                       vector<uint, N> elementOffset,\012                                       vector<T1, N> data, T0 dummy);\012\012// This is gather_scaled intrinsic and with surface index T0 and scale 0.\012template <typename T, int N, int NBlocks>\012vector<T, N> __cm_intrinsic_impl_slm_read(uint globalOffsetInBytes,\012                                          vector<uint, N> elementOffsetInBytes,\012                                          vector<T, N> data);\012\012// This is scatter_scaled intrinsic with surface index T0 and scale 0.\012template <typename T, int N, int NBlocks>\012void __cm_intrinsic_impl_slm_write(uint globalOffsetInBytes,\012                                   vector<uint, N> elementOffsetInBytes,\012                                  ",
" vector<T, N> data);\012\012// SVM support\012template <typename T, int SZ>\012vector<T, SZ> __cm_intrinsic_impl_svm_block_read(uint64_t addr);\012\012template <typename T, int SZ>\012vector<T, SZ> __cm_intrinsic_impl_svm_block_read_unaligned(uint64_t addr);\012\012template <typename T, int SZ>\012void __cm_intrinsic_impl_svm_block_write(uint64_t addr, vector<T, SZ> src);\012\012template <typename T, int N, int NumBlk>\012vector<T, N*NumBlk>\012__cm_intrinsic_impl_svm_scatter_read(vector<uint64_t, N> vAddr,\012                                     vector<T, N*NumBlk> oldVal);\012\012template <typename T, int N, int NumBlk>\012void __cm_intrinsic_impl_svm_scatter_write(vector<uint64_t, N> vAddr,\012                                           vector<T, N*NumBlk> src);\012\012template <CmAtomicOpType Op, typename T, int N>\012vector<T, N> __cm_intrinsic_impl_svm_atomic(vector<uint64_t, N> vAddr,\012                                            vector<T, N> oldVal);\012\012template <CmAtomicOpType Op, typename T, int N>\012vector<T, N> __cm_intrinsic_impl_svm_atomic(vector<uint64_t, N> vAddr,\012",
"                                            vector<T, N> src0,\012                                            vector<T, N> oldVal);\012\012template <CmAtomicOpType Op, typename T, int N>\012vector<T, N>\012__cm_intrinsic_impl_svm_atomic(vector<uint64_t, N> vAddr, vector<T, N> src0,\012                               vector<T, N> src1, vector<T, N> oldVal);\012\012template <typename T, int N>\012bool __cm_intrinsic_impl_simdfork_any(vector<T, N> t, const char *filename,\012                                      unsigned line);\012template <typename T, int R, int C>\012bool __cm_intrinsic_impl_simdfork_any(matrix<T, R, C> t, const char *filename,\012                                      unsigned line);\012\012template <typename T = void>\012bool __cm_intrinsic_impl_simdfork_any(int t, const char *filename, unsigned line);\012\012template <typename T, int N>\012bool __cm_intrinsic_impl_simdcf_any(vector<T, N> t, const char *filename,\012                                    unsigned line);\012template <typename T, int R, int C>\012bool __cm_intrinsic_impl_simdcf_any(matrix<T, R, C",
"> t, const char *filename,\012                                    unsigned line);\012\012template <typename T = void>\012bool __cm_intrinsic_impl_simdcf_any(int t, const char *filename, unsigned line);\012\012template <typename T0, typename T1, int N>\012vector<T0, N> __cm_intrinsic_impl_simdcf_predgen(vector<T0, N> arg0, T1 arg1);\012\012template <typename T0, int N>\012vector<T0, N> __cm_intrinsic_impl_simdcf_predmin(vector<T0, N> arg0);\012\012template <typename T0, int N>\012vector<T0, N> __cm_intrinsic_impl_simdcf_predmax(vector<T0, N> arg0);\012\012template <int N> uint __cm_intrinsic_impl_pack_mask(vector<ushort, N> src0);\012\012template <int N1, int N2>\012uint __cm_intrinsic_impl_pack_mask(matrix<ushort, N1, N2> src0);\012\012template <typename T, int N>\012vector<ushort, N> __cm_intrinsic_impl_unpack_mask(uint src0);\012\012// Dummy mov inserts a mov to a null location from the src0\012// Initial intended use is to allow for dependencies for results from wait_event\012// intrinsic call\012template <typename T> void __cm_intrinsic_impl_dummy_mov(T src0);\012\012// Predefined surfac",
"e support.\012SurfaceIndex __cm_intrinsic_impl_predefined_surface(unsigned id);\012\012template <typename T1, typename T2, typename T3, typename T4, int N>\012vector<T1, N> __cm_intrinsic_impl_dp4a(vector<T2, N> src0, vector<T3, N> src1, vector<T4, N> src2,\012                                       int flag);\012\012template <typename T>\012T __cm_intrinsic_impl_bfn(T s0, T s1, T s2, unsigned char bfval);\012\012template <CmPrecisionType src1_precision, CmPrecisionType src2_precision,\012          int systolic_depth, int repeat_count, typename T0, typename T,\012          typename T1, typename T2, int N, int N1, int N2>\012vector<T0, N> __cm_intrinsic_impl_dpas(vector<T, N> src0, vector<T1, N1> src1,\012                                       vector<T2, N2> src2);\012\012template <CmPrecisionType src1_precision, CmPrecisionType src2_precision,\012          int systolic_depth, int repeat_count,\012          typename T, typename T1, typename T2, int N, int N1, int N2>\012vector<T, N> __cm_intrinsic_impl_dpas_nosrc0(int dummy,\012                                          ",
"   vector<T1, N1> src1,\012                                             vector<T2, N2> src2);\012\012template <CmPrecisionType src1_precision, CmPrecisionType src2_precision,\012          int systolic_depth, int repeat_count,\012          typename T, typename T1, typename T2, int N, int N1, int N2>\012vector<T, N> __cm_intrinsic_impl_dpasw(vector<T, N> src0,\012                                       vector<T1, N1> src1,\012                                       vector<T2, N2> src2);\012\012template <CmPrecisionType src1_precision, CmPrecisionType src2_precision,\012          int systolic_depth, int repeat_count,\012          typename T, typename T1, typename T2,\012          int N, int N1, int N2>\012vector<T, N> __cm_intrinsic_impl_dpasw_nosrc0(int dummy,\012                                              vector<T1, N1> src1,\012                                              vector<T2, N2> src2);\012\012\012template <typename T0, int N, typename T1>\012vector<T0, N> __cm_intrinsic_impl_srnd(vector<T1, N> src1, vector<T1, N> src2);\012\012// -----------------------------------",
"-----------------------------------------\012//\012// Conversions to special types (BF, etc)\012//\012// ----------------------------------------------------------------------------\012template <typename T, typename T0, int N>\012vector<T, N> __cm_intrinsic_impl_bf_cvt(vector<T0, N> src0);\012\012\012template <typename T, typename T0, int N>\012vector<T, N> __cm_intrinsic_impl_tf32_cvt(vector<T0, N> src0);\012\012// ----------------------------------------------------------------------------\012//\012// LSC intrinsics\012//\012// ----------------------------------------------------------------------------\012\012template <DataSize DS, VectorSize VS, int ImmOffset, CacheHint L1H,\012          CacheHint L3H, int N>\012void __cm_intrinsic_impl_prefetch_bti(SurfaceIndex Idx, vector<uint, N> Offset,\012                                      vector<ushort, N> Pred);\012\012template <DataSize DS, VectorSize VS, int ImmOffset, CacheHint L1H, CacheHint L3H, int N>\012void __cm_intrinsic_impl_prefetch_flat(uint64_t Addr, vector<uint, N> Offset,\012                                       vector<",
"ushort, N> Pred);\012\012template <DataSize DS, VectorSize VS, int ImmOffset, CacheHint L1H,\012          CacheHint L3H>\012void __cm_intrinsic_impl_block_prefetch_bti(SurfaceIndex Idx, unsigned Offset);\012\012template <DataSize DS, VectorSize VS, int ImmOffset, CacheHint L1H,\012          CacheHint L3H>\012void __cm_intrinsic_impl_block_prefetch_flat(uint64_t Addr, unsigned Offset);\012\012template <typename RetTy, DataSize DS, VectorSize VS, int ImmOffset,\012          CacheHint L1H, CacheHint L3H, bool Transposed, int N>\012RetTy __cm_intrinsic_impl_load_bti(SurfaceIndex Idx, vector<uint, N> Offset,\012                                   vector<ushort, N> Pred);\012\012template <typename RetTy, DataSize DS, VectorSize VS, int ImmOffset,\012          CacheHint L1H, CacheHint L3H, bool Transposed, int N>\012RetTy __cm_intrinsic_impl_load_flat(uint64_t Addr, vector<uint, N> Offset,\012                                   vector<ushort, N> Pred);\012\012template <typename RetTy, DataSize DS, VectorSize VS, int ImmOffset,\012          CacheHint L1H, CacheHint L3H, bool Trans",
"posed, int N>\012RetTy __cm_intrinsic_impl_load4_bti(SurfaceIndex Idx, vector<uint, N> Offset,\012                                    vector<ushort, N> Pred,\012                                    ChannelMaskType mask);\012\012template <typename RetTy, DataSize DS, VectorSize VS, int ImmOffset,\012          CacheHint L1H, CacheHint L3H, bool Transposed, int N>\012RetTy __cm_intrinsic_impl_load4_flat(uint64_t Addr, vector<uint, N> Offset,\012                                     vector<ushort, N> Pred,\012                                     ChannelMaskType mask);\012\012template <typename RetTy, DataSize DS, VectorSize VS, int ImmOffset,\012          CacheHint L1H, CacheHint L3H, bool Transposed>\012RetTy __cm_intrinsic_impl_block_load_bti(SurfaceIndex Idx, unsigned Offset);\012\012template <typename RetTy, DataSize DS, VectorSize VS, int ImmOffset,\012          CacheHint L1H, CacheHint L3H, bool Transposed>\012RetTy __cm_intrinsic_impl_block_load_flat(uint64_t Addr, unsigned Offset);\012\012template <typename T, DataSize DS, VectorSize VS, int ImmOffset,\012          ",
"CacheHint L1H, CacheHint L3H, bool Transposed, int N>\012void __cm_intrinsic_impl_store_bti(\012    SurfaceIndex Idx, vector<uint, N> Offset,\012    vector<T, N * details::lsc_vector_size<VS>()> Data, vector<ushort, N> Pred);\012\012template <typename T, DataSize DS, VectorSize VS, int ImmOffset,\012          CacheHint L1H, CacheHint L3H, bool Transposed, int N>\012void __cm_intrinsic_impl_store_flat(\012    uint64_t Addr, vector<uint, N> Offset,\012    vector<T, N * details::lsc_vector_size<VS>()> Data, vector<ushort, N> Pred);\012\012template <typename T, DataSize DS, VectorSize VS, int ImmOffset, CacheHint L1H,\012          CacheHint L3H, bool Transposed, int N>\012void __cm_intrinsic_impl_store4_bti(\012    SurfaceIndex Idx, vector<uint, N> Offset,\012    vector<T, N * details::lsc_vector_size<VS>()> Data, vector<ushort, N> Pred,\012    ChannelMaskType mask);\012\012template <typename T, DataSize DS, VectorSize VS, int ImmOffset, CacheHint L1H,\012          CacheHint L3H, bool Transposed, int N>\012void __cm_intrinsic_impl_store4_flat(\012    uint64_t Addr, vector<ui",
"nt, N> Offset,\012    vector<T, N * details::lsc_vector_size<VS>()> Data, vector<ushort, N> Pred,\012    ChannelMaskType mask);\012\012template <typename T, DataSize DS, VectorSize VS, int ImmOffset, CacheHint L1H,\012          CacheHint L3H, bool Transposed>\012void __cm_intrinsic_impl_block_store_bti(\012    SurfaceIndex Idx, unsigned Offset,\012    vector<T, details::lsc_vector_size<VS>()> Data);\012\012template <typename T, DataSize DS, VectorSize VS, int ImmOffset, CacheHint L1H,\012          CacheHint L3H, bool Transposed>\012void __cm_intrinsic_impl_block_store_flat(\012    uint64_t Addr, unsigned Offset,\012    vector<T, details::lsc_vector_size<VS>()> Data);\012\012template <typename RetTy, DataSize DS, VectorSize VS, int ImmOffset,\012          bool Transposed, int N>\012RetTy __cm_intrinsic_impl_load_slm(vector<unsigned, N> Offset,\012                                   vector<ushort, N> Pred);\012\012template <typename RetTy, DataSize DS, VectorSize VS, int ImmOffset,\012          bool Transposed, int N>\012RetTy __cm_intrinsic_impl_load4_slm(vector<unsigned, N> Off",
"set,\012                                    vector<ushort, N> Pred,\012                                    ChannelMaskType mask);\012\012template <typename RetTy, DataSize DS, VectorSize VS, int ImmOffset,\012          bool Transposed>\012RetTy __cm_intrinsic_impl_block_load_slm(unsigned Offset);\012\012template <typename T, DataSize DS, VectorSize VS, int ImmOffset,\012          bool Transposed, int N>\012void __cm_intrinsic_impl_store_slm(\012    vector<unsigned, N> Offset,\012    vector<T, N * details::lsc_vector_size<VS>()> Data,\012    vector<ushort, N> Pred);\012\012template <typename T, DataSize DS, VectorSize VS, int ImmOffset,\012          bool Transposed, int N>\012void __cm_intrinsic_impl_store4_slm(\012    vector<unsigned, N> Offset,\012    vector<T, N * details::lsc_vector_size<VS>()> Data, vector<ushort, N> Pred,\012    ChannelMaskType mask);\012\012template <typename T, DataSize DS, VectorSize VS, int ImmOffset,\012          bool Transposed>\012void __cm_intrinsic_impl_block_store_slm(\012    unsigned Offset, vector<T, details::lsc_vector_size<VS>()> Data);\012\012template ",
"<typename T, int NBlocks, int Width, int Height, bool Transposed,\012          bool Transformed, CacheHint L1H, CacheHint L3H, int N>\012vector<T, N> __cm_intrinsic_impl_block_load2d_flat(uintptr_t BaseAddr,\012    unsigned SurfaceWidth, unsigned SurfaceHeight, unsigned SurfacePitch,\012    int X, int Y);\012\012template <typename T, int NBlocks, int Width, int Height, CacheHint L1H,\012          CacheHint L3H, int N>\012void __cm_intrinsic_impl_block_store2d_flat(uintptr_t BaseAddr,\012    unsigned SurfaceWidth, unsigned SurfaceHeight, unsigned SurfacePitch,\012    int X, int Y, vector<T, N> Data);\012\012template <typename T, int NBlocks, int Width, int Height, CacheHint L1H,\012          CacheHint L3H>\012void __cm_intrinsic_impl_block_prefetch2d_flat(uintptr_t BaseAddr,\012    unsigned SurfaceWidth, unsigned SurfaceHeight, unsigned SurfacePitch,\012    int X, int Y);\012\012\012template <AtomicOp Op, DataSize DS, VectorSize VS, bool Transposed,\012          CacheHint L1H, CacheHint L3H, typename RetTy, int N, typename... Args>\012RetTy __cm_intrinsic_impl_lsc_atomic_",
"bti(vector<ushort, N> Pred,\012                                         SurfaceIndex Idx,\012                                         vector<unsigned, N> Offset,\012                                         Args... args);\012\012template <AtomicOp Op, DataSize DS, VectorSize VS, bool Transposed,\012          CacheHint L1H, CacheHint L3H, typename RetTy, int N, typename... Args>\012RetTy __cm_intrinsic_impl_lsc_atomic_flat(vector<ushort, N> Pred,\012                                          uint64_t Addr,\012                                          vector<unsigned, N> Offset,\012                                          Args... args);\012\012template <AtomicOp Op, DataSize DS, VectorSize VS, bool Transposed,\012          CacheHint L1H, CacheHint L3H, typename RetTy, int N, typename... Args>\012RetTy __cm_intrinsic_impl_lsc_atomic_slm(vector<ushort, N> Pred,\012                                         vector<unsigned, N> Offset,\012                                         Args... args);\012\012template <LSC_SFID Sfid, LSC_FENCE_OP FenceOp, LSC_SCOPE Scope, int N>\012",
"void __cm_intrinsic_impl_lsc_fence(vector<ushort, N> Pred);\012\012template <typename T, int n> struct simd_type {\012  static constexpr int length = n;\012  using type = T __attribute__((ext_vector_type(n)));\012  using element_type = T;\012};\012\012template <int n> struct mask_type {\012  static constexpr int length = n;\012  using type = uint16_t __attribute__((ext_vector_type(n)));\012};\012\012template <int width, int stride, typename T, int n>\012typename simd_type<T, width>::type\012__cm_intrinsic_impl_rdregion(typename simd_type<T, n>::type in, int offset);\012\012template <int width, int stride, typename T, int n, int m>\012typename simd_type<T, n>::type\012__cm_intrinsic_impl_wrregion(typename simd_type<T, n>::type oldVal,\012                             typename simd_type<T, m>::type newVal, int offset,\012                             typename mask_type<n>::type mask = 1);\012\012template <typename T, int n>\012typename simd_type<T, n>::type\012__cm_intrinsic_impl_svm_read(typename simd_type<uint64_t, n>::type addrs,\012                             typename simd_type<T, n>:",
":type oldVal);\012\012template <typename T, int n>\012void __cm_intrinsic_impl_svm_write(typename simd_type<uint64_t, n>::type addrs,\012                                   typename simd_type<T, n>::type vals);\012\012} // namespace details\012\012\012#endif\012\000/*========================== begin_copyright_notice ============================\012\012Copyright (C) 2019-2021 Intel Corporation\012\012SPDX-License-Identifier: MIT\012\012============================= end_copyright_notice ===========================*/\012\012#ifndef _CLANG_CM_LIBRARY_\012#define _CLANG_CM_LIBRARY_\012\012#include \"cm_internal.h\"\012\012////////////////////////////////////////////////////////////////////////////////\012// Implement CM as a C++ library with minimum clang changes\012////////////////////////////////////////////////////////////////////////////////\012namespace experimental {\012\012/**\012 * The following code snippet illustrates the library based syntax for the CM\012 * language.\012 *\012\\code{.cpp}\012\012#include <cm/cm_library.h>\012\012using namespace experimental;\012\012__declspec(genx_main) void kernel_explicit_ref(int *p) {",
"\012  simd_vector<unsigned, 32> offsets(0, 1);\012  simd_vector<int, 32> v0;\012\012  v0 = load(p, offsets);\012\012  simd_vector_ref<int, 8, 1, decltype(v0)> r1 = v0.sel<8, 1>(0);  // r1 = v0[ 0: 8]\012  simd_vector_ref<int, 8, 1, decltype(v0)> r2 = v0.sel<8, 1>(8);  // r2 = v0[ 8:16]\012  simd_vector_ref<int, 8, 1, decltype(v0)> r3 = v0.sel<8, 1>(16); // r3 = v0[16:24]\012  simd_vector_ref<int, 8, 1, decltype(v0)> r4 = v0.sel<8, 1>(24); // r4 = v0[24:32]\012\012  simd_vector_ref<int, 4, 2, decltype(r1)> r10 = r1.sel<4, 2>();  // r10 = r1[0:8:2] = v0[ 0: 8:2]\012  simd_vector_ref<int, 4, 2, decltype(r2)> r20 = r2.sel<4, 2>();  // r20 = r2[0:8:2] = v0[ 8:16:2]\012  simd_vector_ref<int, 4, 2, decltype(r3)> r30 = r3.sel<4, 2>();  // r30 = r3[0:8:2] = v0[16:24:2]\012  simd_vector_ref<int, 4, 2, decltype(r4)> r40 = r4.sel<4, 2>();  // r40 = r4[0:8:2] = v0[24:32:2]\012\012  r10 += 199;\012  r20 += 299;\012  r30 += 399;\012  r40 += 499;\012\012  store(p, v0, offsets);\012}\012\012\\endcode\012*/\012\012/** simd_vector_ref forward declaration */\012template <typename T, int width, int stride, typena",
"me BaseTy>\012class simd_vector_ref;\012\012/**\012 * The vector class.\012 *\012 * This class is a wrapper class for llvm vector values. Additionaly this class\012 * supports region operations that map to GENX regions. The return type of a\012 * region select is a simd_vector_ref type. This by-ref vector models\012 * read-update-write semantics, which is the building block concept in the CM\012 * language.\012 */\012template <typename T, int n> class simd_vector {\012public:\012  /**\012   * The element type of this vector.\012   */\012  using element_type = T;\012\012  /**\012   * The vector type wrapper for llvm vector types.\012   */\012  using vector_type = typename details::simd_type<T, n>::type;\012\012  /**\012   * The number of elements in this vector.\012   */\012  static constexpr int length = n;\012\012  template <typename V, int width, int stride, typename U>\012  friend class simd_vector_ref;\012\012  /**\012   * Constructors.\012   */\012  inline simd_vector() { }\012  inline simd_vector(const simd_vector<T, n> &v) { m_data = v.m_data; }\012  inline simd_vector(const simd_vector<T, n> &&v) { m_data = v.",
"m_data; }\012  inline simd_vector(vector_type val) { m_data = val; }\012  inline CM_NODEBUG simd_vector(T val, T stride = T()) {\012    if (stride == T())\012      m_data = val;\012    else {\012      #pragma unroll\012      for (int i = 0; i < n; i++) {\012        m_data[i] = val;\012        val += stride;\012      }\012    }\012  }\012\012  /**\012   * Convert to another vector type.\012   */\012  template <typename U>\012  explicit inline operator simd_vector<U, n>() const {\012    return read();\012  }\012\012  template <typename U>\012  explicit inline operator typename details::simd_type<U, n>::type() const {\012    return read();\012  }\012\012  /**\012   * Assignment operators.\012   */\012  inline CM_NODEBUG simd_vector<T, n>& operator=(const simd_vector<T, n>& other) {\012    m_data = other.m_data;\012    return *this;\012  }\012\012  /**\012   * Returns the underlying vector value.\012   */\012  inline vector_type data() const { return m_data; }\012\012  /**\012   * Select a region of elements from a vector.\012   */\012  template <int width, int stride>\012  inline CM_NODEBUG simd_vector_ref<T, width, stride, simd_vector<T, n>",
">\012  sel(int offset = 0) {\012    simd_vector_ref<T, width, stride, simd_vector<T, n>> ref(*this, offset);\012    return ref;\012  }\012\012  /**\012   * Read a vector region.\012   */\012  template <int width, int stride>\012  inline CM_NODEBUG simd_vector<T, width> read(int offset) const {\012    using namespace details;\012    return __cm_intrinsic_impl_rdregion<width, stride, T, n>(data(), offset);\012  }\012\012  /**\012   * Read the entire region.\012   */\012  inline simd_vector<T, n> read() const { return *this; }\012\012  /**\012   * Update a vector region.\012   */\012  template <int width, int stride>\012  inline CM_NODEBUG simd_vector<T, n> &write(simd_vector<T, width> input,\012                                             int offset) {\012    m_data = details::__cm_intrinsic_impl_wrregion<width, stride, T, n, width>(\012        m_data, input.data(), offset);\012    return *this;\012  }\012\012  /**\012   * Update the entire region.\012   */\012  inline simd_vector<T, n> &write(simd_vector<T, n> input) {\012    m_data = input.data();\012    return *this;\012  }\012\012  /**\012   * Read a single element.\012   */\012  ",
"inline CM_NODEBUG T operator[](int index) const {\012    simd_vector<T, 1> val = read<1, 0>(index);\012    return val.data()[0];\012  }\012\012private:\012  /**\012   * The undderlying data for this vector.\012   */\012  vector_type m_data;\012};\012\012/**\012 * The vector reference class.\012 *\012 * This class represnts a region on a base object which could be a simd_vector\012 * or another vector reference.\012 */\012template <typename T, int width, int stride, typename BaseTy>\012class simd_vector_ref {\012public:\012  /**\012   * The element type of this vector.\012   */\012  using element_type = T;\012\012  /**\012   * The vector type wrapper for llvm vector types\012   */\012  using vector_type = typename details::simd_type<T, width>::type;\012\012  /**\012   * The type of this class\012   */\012  using type = simd_vector_ref<T, width, stride, BaseTy>;\012\012  /**\012   * The number of elements in this vector.\012   */\012  static constexpr int length = width;\012\012  template <typename U, int n> friend class simd_vector;\012\012  /**\012   * Constructors.\012   */\012  inline simd_vector_ref(BaseTy &base, int offset)\012      : m_base(b",
"ase), m_offset(offset) {}\012  inline simd_vector_ref(const type &other)\012      : m_base(other.m_base), m_offset(other.m_offset) {}\012  inline simd_vector_ref(type &&other)\012      : m_base(other.m_base), m_offset(other.m_offset) {}\012\012\012  type& operator=(type&& other) = delete;\012  type& operator=(const type& other) = delete;\012  type& operator=(type other) = delete;\012\012  /**\012   * Select a region of elements from a vector.\012   */\012  inline CM_NODEBUG simd_vector<T, width> read() const {\012    using namespace details;\012    auto base = m_base.read();\012    constexpr int n = BaseTy::length;\012    return __cm_intrinsic_impl_rdregion<width, stride, T, n>(base.data(),\012                                                             m_offset);\012  }\012\012  /**\012   * Update a vector region.\012   */\012  template <int stride1, typename BaseTy1>\012  inline CM_NODEBUG type &write(simd_vector_ref<T, width, stride1, BaseTy1> input) {\012    using namespace details;\012    simd_vector<T, width> inVec = input.read();\012    auto base = m_base.read();\012    constexpr int n = Ba",
"seTy::length;\012    auto merged = __cm_intrinsic_impl_wrregion<width, stride, T, n, width>(\012        base.data(), inVec.data(), m_offset);\012    m_base.write(merged);\012    return *this;\012  }\012\012  /**\012   * Update a vector region.\012   */\012  inline CM_NODEBUG type &write(simd_vector<T, width> input) {\012    using namespace details;\012    auto base = m_base.read();\012    constexpr int n = BaseTy::length;\012    auto merged = __cm_intrinsic_impl_wrregion<width, stride, T, n, width>(\012        base.data(), input.data(), m_offset);\012    m_base.write(merged);\012    return *this;\012  }\012\012  /**\012   * Assignment operators.\012   */\012  inline CM_NODEBUG type &operator=(T val) {\012    simd_vector<T, width> input = val;\012    write(input);\012    return *this;\012  }\012  inline CM_NODEBUG type& operator=(vector_type val) {\012    simd_vector<T, width> input = val;\012    write(input);\012    return *this;\012  }\012\012  inline CM_NODEBUG type& operator+=(simd_vector<T, width> val) {\012    simd_vector<T, width> base = read();\012    write(val.data() + base.data());\012    return *this;\012  }\012\012 ",
" inline CM_NODEBUG type& operator+=(T val) {\012    simd_vector<T, width> base = read();\012    write(simd_vector<T, width>(val).data() + base.data());\012    return *this;\012  }\012\012  inline CM_NODEBUG type &operator=(const simd_vector<T, width> &val) {\012    write(val);\012    return *this;\012  }\012\012  /**\012   * select a region of elements.\012   */\012  template <int width1, int stride1>\012  inline CM_NODEBUG simd_vector_ref<T, width1, stride1, type> sel(int offset = 0) {\012    simd_vector_ref<T, width1, stride1, type> ref(*this, offset);\012    return ref;\012  }\012\012private:\012  /**\012   * The refenence to the base object.\012   */\012  BaseTy &m_base;\012\012  /**\012   * The element offset of this reference object relative to the base object.\012   */\012  int m_offset;\012};\012\012template <typename U, typename T, int n>\012inline CM_NODEBUG simd_vector<U, n> convert(simd_vector<T, n> val) {\012  return __builtin_convertvector(val.data(),\012                                 typename details::simd_type<U, n>::type);\012}\012\012template <typename T, typename U, int n>\012CM_NODEBUG inline auto oper",
"ator+(simd_vector<T, n> lhs, simd_vector<U, n> rhs)\012    -> simd_vector<decltype(T() + U()), n> {\012  using R = decltype(T() + U());\012  simd_vector<R, n> lhs_ = convert<R>(lhs);\012  simd_vector<R, n> rhs_ = convert<R>(rhs);\012  return lhs_.data() + rhs_.data();\012}\012\012template <typename T, typename U, int n>\012CM_NODEBUG inline auto operator+(simd_vector<T, n> lhs, U rhs)\012    -> simd_vector<decltype(T() + U()), n> {\012  simd_vector<U, n> rhs_ = rhs;\012  return lhs + rhs_;\012}\012\012template <typename T, int n>\012static inline CM_NODEBUG simd_vector<T, n>\012load(T* p, simd_vector<unsigned, n> offsets) {\012  constexpr unsigned N = 8;\012  static_assert(n % N == 0, \"only multiple of 8 are supported.\");\012  simd_vector<T, n> result;\012\012  #pragma unroll\012  for (unsigned i = 0; i + N <= n; i += N) {\012    simd_vector_ref<unsigned, N, 1, decltype(offsets)> ref = offsets.template sel<N, 1>(i);\012    simd_vector<unsigned, N> offsets_i = ref.read();\012    simd_vector<uint64_t, N> addrs(reinterpret_cast<uint64_t>(p));\012    simd_vector<uint64_t, N> offsets_i1 = conv",
"ert<uint64_t>(offsets_i);\012    addrs = addrs + offsets_i1;\012    simd_vector<T, N> Undef;\012    result.template sel<N, 1>(i).write(\012        details::__cm_intrinsic_impl_svm_read<T, N>(addrs.data(),\012                                                    Undef.data()));\012  }\012  return result;\012}\012\012template <typename T, int n>\012static inline CM_NODEBUG void store(T* p, simd_vector<T, n> vals,\012                                    simd_vector<unsigned, n> offsets) {\012  constexpr unsigned N = 8;\012  static_assert(n % N == 0, \"only multiple of 8 are supported.\");\012  #pragma unroll\012  for (unsigned i = 0; i + N <= n; i += N) {\012    simd_vector<unsigned, N> offsets_i = offsets.template sel<N, 1>(i).read();\012    simd_vector<uint64_t, N> addrs(reinterpret_cast<uint64_t>(p));\012    simd_vector<uint64_t, N> offsets_i1 = convert<uint64_t>(offsets_i);\012    addrs = addrs + offsets_i1;\012    details::__cm_intrinsic_impl_svm_write<T, N>(\012        addrs.data(), vals.template sel<N, 1>(i).read().data());\012  }\012}\012\012} // namespace experimental\012\012#endif // _CLAN",
"G_CM_LIBRARY_\012\000/*========================== begin_copyright_notice ============================\012\012Copyright (C) 2015-2021 Intel Corporation\012\012SPDX-License-Identifier: MIT\012\012============================= end_copyright_notice ===========================*/\012\012#if (__INCLUDE_LEVEL__ == 1)\012static_assert(0, \"CM:w:cm_linear.h should not be included explicitly - only \"\012                 \"<cm/cm.h> is required\");\012#endif\012\012#ifndef _CLANG_CM_LINEAR_H_\012#define _CLANG_CM_LINEAR_H_\012\012////////////////////////////////////////////////////////////////////////////////\012// Size and group intrinsics\012// These use builtins underneath to calculate appropriate values\012//\012// Defined in a separate header like this as they are used extensively in other\012// headers and need to be defined early on in the header stack\012////////////////////////////////////////////////////////////////////////////////\012\012CM_INLINE uint cm_linear_local_id() {\012  return cm_local_size(0) * cm_local_size(1) * cm_local_id(2) +\012         cm_local_size(0) * cm_local_id(1) + cm_loca",
"l_id(0);\012}\012\012CM_INLINE uint cm_linear_local_size() {\012  return cm_local_size(0) * cm_local_size(1) * cm_local_size(2);\012}\012\012CM_INLINE uint cm_linear_group_id() {\012  return cm_group_count(0) * cm_group_count(1) * cm_group_id(2) +\012         cm_group_count(0) * cm_group_id(1) + cm_group_id(0);\012}\012\012CM_INLINE uint cm_linear_group_count() {\012  return cm_group_count(0) * cm_group_count(1) * cm_group_count(2);\012}\012\012CM_INLINE uint cm_linear_global_id() {\012  return cm_linear_group_id() * cm_linear_local_size() + cm_linear_local_id();\012}\012\012CM_INLINE uint cm_linear_global_size() {\012  return cm_linear_group_count() * cm_linear_local_size();\012}\012\012#endif // _CLANG_CM_LINEAR_H_\012\000/*========================== begin_copyright_notice ============================\012\012Copyright (C) 2019-2021 Intel Corporation\012\012SPDX-License-Identifier: MIT\012\012============================= end_copyright_notice ===========================*/\012\012#if (__INCLUDE_LEVEL__ == 1)\012static_assert(0, \"CM:w:cm_lsc.h should not be included explicitly - only \"\012                 \"<cm/cm.h>",
" is required\");\012#endif\012\012#ifndef _CLANG_CM_LSC_H_\012#define _CLANG_CM_LSC_H_\012\012#include \"cm_common.h\"\012#include \"cm_internal.h\"\012#include \"cm_has_instr.h\"\012\012#define CM_LSC_REPLICATE_MASK(VectorSize)                                      \\\012  __attribute__((genx_replicate_mask(details::lsc_vector_size<VectorSize>())))\012\012/// \\brief Data prefetch.\012///\012/// @param VS Vector size\012///\012/// @param DS Data size\012///\012/// @param L1H L1 cache hint\012///\012/// @param L3H L3 chache hint\012///\012/// @param N The number of channels (platform dependent)\012///\012/// @param Idx Surface index, which must correspond to a buffer.\012///\012/// @param Offset zero based offset of the input buffer in bytes.\012///\012/// @param Pred Predicate\012///\012template <VectorSize VS = VectorSize::N1, DataSize DS = DataSize::U32,\012          CacheHint L1H = CacheHint::Cached,\012          CacheHint L3H = CacheHint::Cached,\012          int N = details::lsc_default_simt()>\012CM_NODEBUG CM_INLINE void cm_prefetch(SurfaceIndex Idx,\012                                      vector<unsigned, N> Offset",
",\012                                      vector<ushort, N> Pred = 1) {\012  CM_HAS_LSC_CONTROL; \012\012  using namespace details;\012  CM_STATIC_ERROR(lsc_check_simt<N>(), \"unexpected number of channels\");\012  CM_STATIC_ERROR((lsc_check_cache_hint<LSCAction::Prefetch, L1H, L3H>()),\012                  \"unsupported cache hint\");\012  constexpr int ImmOffset = 0;\012  __cm_intrinsic_impl_prefetch_bti<DS, VS, ImmOffset, L1H, L3H, N>(Idx, Offset,\012                                                                   Pred);\012}\012\012/// flat-address prefetch\012template <VectorSize VS = VectorSize::N1, DataSize DS = DataSize::U32,\012          CacheHint L1H = CacheHint::Cached,\012          CacheHint L3H = CacheHint::Cached,\012          int N = details::lsc_default_simt()>\012CM_NODEBUG CM_INLINE void cm_ptr_prefetch(const unsigned *const Ptr,\012                                          vector<unsigned, N> Offset,\012                                          vector<ushort, N> Pred = 1) {\012  CM_HAS_LSC_CONTROL; \012\012  using namespace details;\012  CM_STATIC_ERROR(lsc_chec",
"k_simt<N>(), \"unexpected number of channels\");\012  CM_STATIC_ERROR((lsc_check_cache_hint<LSCAction::Prefetch, L1H, L3H>()),\012                  \"unsupported cache hint\");\012  constexpr int ImmOffset = 0;\012  uint64_t Addr = (uint64_t)Ptr;\012  __cm_intrinsic_impl_prefetch_flat<DS, VS, ImmOffset, L1H, L3H, N>(\012      Addr, Offset, Pred);\012}\012\012/// Surface-based Block prefetch.\012template <VectorSize VS, DataSize DS = DataSize::U32,\012          CacheHint L1H = CacheHint::Cached,\012          CacheHint L3H = CacheHint::Cached>\012CM_NODEBUG CM_INLINE void cm_prefetch(SurfaceIndex Idx, unsigned Offset) {\012  CM_HAS_LSC_CONTROL; \012\012  CM_STATIC_WARNING(details::always_false<decltype(VS)>(),\012                    \"Please use new interface with explicit NElts\");\012  CM_STATIC_ERROR(DS == DataSize::U32 || DS == DataSize::U64,\012                  \"Transposed prefetch can work only with U32 and U64 data sizes\");\012  CM_STATIC_ERROR(\012      (details::lsc_check_cache_hint<details::LSCAction::Prefetch, L1H, L3H>()),\012      \"unsupported cache hint\");\012  constexp",
"r int _ImmOffset = 0;\012  details::__cm_intrinsic_impl_block_prefetch_bti<DS, VS, _ImmOffset, L1H, L3H>(\012      Idx, Offset);\012}\012\012// Surface-based block prefetch, new interface\012template <int NElts, DataSize DS = DataSize::U32,\012          CacheHint L1H = CacheHint::Cached, CacheHint L3H = CacheHint::Cached>\012CM_NODEBUG CM_INLINE void cm_prefetch(SurfaceIndex Idx, unsigned Offset) {\012  CM_HAS_LSC_CONTROL; \012\012  CM_STATIC_ERROR(DS == DataSize::U32 || DS == DataSize::U64,\012                  \"Transposed prefetch can work only with U32 and U64 data sizes\");\012  CM_STATIC_ERROR(\012      (details::lsc_check_cache_hint<details::LSCAction::Prefetch, L1H, L3H>()),\012      \"unsupported cache hint\");\012  constexpr int _ImmOffset = 0;\012  constexpr VectorSize VS = details::lsc_vector_size<NElts>();\012  details::__cm_intrinsic_impl_block_prefetch_bti<DS, VS, _ImmOffset, L1H, L3H>(\012      Idx, Offset);\012}\012\012/// Flat-address Block prefetch.\012template <VectorSize VS, DataSize DS = DataSize::U32,\012          CacheHint L1H = CacheHint::Cached,\012          Ca",
"cheHint L3H = CacheHint::Cached>\012CM_NODEBUG CM_INLINE void cm_ptr_prefetch(const unsigned *const Ptr,\012                                          unsigned Offset) {\012  CM_HAS_LSC_CONTROL; \012\012  CM_STATIC_WARNING(details::always_false<decltype(VS)>(),\012                    \"Please use new interface with explicit NElts\");\012  CM_STATIC_ERROR(DS == DataSize::U32 || DS == DataSize::U64,\012                  \"Transposed prefetch can work only with U32 and U64 data sizes\");\012  CM_STATIC_ERROR(\012      (details::lsc_check_cache_hint<details::LSCAction::Prefetch, L1H, L3H>()),\012      \"unsupported cache hint\");\012  constexpr int _ImmOffset = 0;\012  uint64_t _Addr = (uint64_t)Ptr;\012  details::__cm_intrinsic_impl_block_prefetch_flat<DS, VS, _ImmOffset, L1H,\012                                                   L3H>(_Addr, Offset);\012}\012\012/// Flat-address Block prefetch, new interface\012template <int NElts, DataSize DS = DataSize::U32,\012          CacheHint L1H = CacheHint::Cached, CacheHint L3H = CacheHint::Cached>\012CM_NODEBUG CM_INLINE void cm_ptr_pre",
"fetch(const unsigned *const Ptr,\012                                          unsigned Offset) {\012  CM_HAS_LSC_CONTROL; \012\012  CM_STATIC_ERROR(DS == DataSize::U32 || DS == DataSize::U64,\012                  \"Transposed prefetch can work only with U32 and U64 data sizes\");\012  CM_STATIC_ERROR(\012      (details::lsc_check_cache_hint<details::LSCAction::Prefetch, L1H, L3H>()),\012      \"unsupported cache hint\");\012  constexpr int ImmOffset = 0;\012  constexpr VectorSize VS = details::lsc_vector_size<NElts>();\012  uint64_t Addr = (uint64_t)Ptr;\012  details::__cm_intrinsic_impl_block_prefetch_flat<DS, VS, ImmOffset, L1H,\012                                                   L3H>(Addr, Offset);\012}\012\012/// \\brief Data Read.\012///\012/// @param T The return element data type.\012///\012/// @param N The number of channels (platform dependent)\012///\012/// @param VS Vector size\012///\012/// @param DS Data size\012///\012/// @param L1H L1 cache hint\012///\012/// @param L3H L3 chache hint\012///\012/// @param Pred Predicate\012///\012/// @param Idx Surface index, which must correspond to a buffe",
"r.\012///\012/// @param Offset zero based offset of the input buffer in bytes.\012///\012/// BTI non-transposed load\012template <typename T, VectorSize VS = VectorSize::N1,\012          DataSize DS = DataSize::Default, CacheHint L1H = CacheHint::Default,\012          CacheHint L3H = CacheHint::Default,\012          int N = details::lsc_default_simt()>\012CM_NODEBUG CM_INLINE CM_LSC_REPLICATE_MASK(VS) auto cm_load(\012    SurfaceIndex Idx, vector<unsigned, N> Offset, vector<ushort, N> Pred = 1) {\012  CM_HAS_LSC_CONTROL; \012\012  using namespace details;\012  CM_STATIC_ERROR(lsc_check_simt<N>(), \"unexpected number of channels\");\012  CM_STATIC_ERROR((lsc_check_cache_hint<LSCAction::Load, L1H, L3H>()),\012                  \"unsupported cache hint\");\012  CM_HAS_LSC_NON_TRANSPOSE_MESSAGES_WITH_NON_DEFAULT_SIMT_CONTROL(N, VS);\012  using _MessTy = decltype(lsc_data_type_ext<T, N, VS>());\012  using _RetTy = decltype(lsc_data_type<T, N, VS>());\012  constexpr DataSize _DS = lsc_expand_ds(lsc_data_size<T, DS>());\012  constexpr int _ImmOffset = 0;\012  constexpr bool _Transpose",
"d = false;\012  auto _TmpRes =\012      __cm_intrinsic_impl_load_bti<_MessTy, _DS, VS, _ImmOffset, L1H, L3H,\012                                   _Transposed, N>(Idx, Offset, Pred);\012  return lsc_format_ret<T, _MessTy, _RetTy>(_TmpRes);\012}\012\012/// Flat-address non-transposed load\012template <typename T, VectorSize VS = VectorSize::N1,\012          DataSize DS = DataSize::Default, CacheHint L1H = CacheHint::Default,\012          CacheHint L3H = CacheHint::Default,\012          int N = details::lsc_default_simt()>\012CM_NODEBUG CM_INLINE auto cm_ptr_load(const T *const Ptr,\012                                      vector<unsigned, N> Offset,\012                                      vector<ushort, N> Pred = 1) {\012  CM_HAS_LSC_CONTROL; \012\012  using namespace details;\012  CM_STATIC_ERROR(lsc_check_simt<N>(), \"unexpected number of channels\");\012  CM_STATIC_ERROR((lsc_check_cache_hint<LSCAction::Load, L1H, L3H>()),\012                  \"unsupported cache hint\");\012  CM_HAS_LSC_NON_TRANSPOSE_MESSAGES_WITH_NON_DEFAULT_SIMT_CONTROL(N, VS);\012  using _MessTy = declty",
"pe(lsc_data_type_ext<T, N, VS>());\012  using _RetTy = decltype(lsc_data_type<T, N, VS>());\012  constexpr DataSize _DS = lsc_expand_ds(lsc_data_size<T, DS>());\012  constexpr int _ImmOffset = 0;\012  constexpr bool _Transposed = false;\012  uint64_t _Addr = (uint64_t)Ptr;\012  auto _TmpRes =\012      __cm_intrinsic_impl_load_flat<_MessTy, _DS, VS, _ImmOffset, L1H, L3H,\012                                    _Transposed, N>(_Addr, Offset, Pred);\012  return lsc_format_ret<T, _MessTy, _RetTy>(_TmpRes);\012}\012\012// Block-load with a SurfaceIndex\012template <typename T, VectorSize VS, DataSize DS = DataSize::Default,\012          CacheHint L1H = CacheHint::Default,\012          CacheHint L3H = CacheHint::Default>\012CM_NODEBUG CM_INLINE auto cm_load(SurfaceIndex Idx, unsigned Offset) {\012  CM_HAS_LSC_CONTROL; \012\012  CM_STATIC_WARNING(details::always_false<decltype(VS)>(),\012                    \"Please use new interface with explicit NElts\");\012  CM_STATIC_ERROR(\012      (details::lsc_check_cache_hint<details::LSCAction::Load, L1H, L3H>()),\012      \"unsupported cache h",
"int\");\012  using _RetTy = decltype(details::lsc_data_type<T, 1, VS>());\012  static_assert(VS != VectorSize::N0, \"invalid vector size\");\012  constexpr DataSize _DS = details::lsc_data_size<T, DS>();\012  CM_STATIC_ERROR(_DS == DataSize::U32 || _DS == DataSize::U64,\012                  \"Transposed load can work only with U32 and U64 data sizes\");\012  constexpr int _ImmOffset = 0;\012  constexpr bool _Transposed = true;\012  return details::__cm_intrinsic_impl_block_load_bti<\012      _RetTy, _DS, VS, _ImmOffset, L1H, L3H, _Transposed>(Idx, Offset);\012}\012\012// Block-load with a SurfaceIndex, new interface\012template <typename T, int NElts, DataSize DS = DataSize::Default,\012          CacheHint L1H = CacheHint::Default,\012          CacheHint L3H = CacheHint::Default>\012CM_NODEBUG CM_INLINE auto cm_load(SurfaceIndex Idx, unsigned Offset) {\012  CM_HAS_LSC_CONTROL;\012\012  CM_STATIC_ERROR(\012      (details::lsc_check_cache_hint<details::LSCAction::Load, L1H, L3H>()),\012      \"unsupported cache hint\");\012  constexpr VectorSize VS = details::lsc_vector_size<NElts>(",
");\012  using _RetTy = decltype(details::lsc_data_type<T, 1, VS>());\012  static_assert(VS != VectorSize::N0, \"invalid vector size\");\012  constexpr DataSize _DS = details::lsc_data_size<T, DS>();\012  CM_STATIC_ERROR(_DS == DataSize::U32 || _DS == DataSize::U64,\012                  \"Transposed load can work only with U32 and U64 data sizes\");\012  constexpr int _ImmOffset = 0;\012  constexpr bool _Transposed = true;\012  return details::__cm_intrinsic_impl_block_load_bti<\012      _RetTy, _DS, VS, _ImmOffset, L1H, L3H, _Transposed>(Idx, Offset);\012}\012\012// Block-load with a base-pointer to the buffer\012template <typename T, VectorSize VS, DataSize DS = DataSize::Default,\012          CacheHint L1H = CacheHint::Default,\012          CacheHint L3H = CacheHint::Default>\012CM_NODEBUG CM_INLINE auto cm_ptr_load(const T *const Ptr, unsigned Offset) {\012  CM_HAS_LSC_CONTROL;\012\012  CM_STATIC_ERROR(\012      (details::lsc_check_cache_hint<details::LSCAction::Load, L1H, L3H>()),\012      \"unsupported cache hint\");\012  CM_STATIC_WARNING(details::always_false<decltype(VS)>",
"(),\012                    \"Please use new interface with explicit NElts\");\012  using _RetTy = decltype(details::lsc_data_type<T, 1, VS>());\012  static_assert(VS != VectorSize::N0, \"invalid vector size\");\012  constexpr DataSize _DS = details::lsc_data_size<T, DS>();\012  CM_STATIC_ERROR(_DS == DataSize::U32 || _DS == DataSize::U64,\012                  \"Transposed load can work only with U32 and U64 data sizes\");\012  constexpr int _ImmOffset = 0;\012  constexpr bool _Transposed = true;\012  uint64_t _Addr = (uint64_t)Ptr;\012  return details::__cm_intrinsic_impl_block_load_flat<\012      _RetTy, _DS, VS, _ImmOffset, L1H, L3H, _Transposed>(_Addr, Offset);\012}\012// Block-load with a base-pointer to the buffer, new interface\012template <typename T, int NElts, DataSize DS = DataSize::Default,\012          CacheHint L1H = CacheHint::Default,\012          CacheHint L3H = CacheHint::Default>\012CM_NODEBUG CM_INLINE auto cm_ptr_load(const T *const Ptr, unsigned Offset) {\012  CM_HAS_LSC_CONTROL;\012\012  CM_STATIC_ERROR(\012      (details::lsc_check_cache_hint<details::LS",
"CAction::Load, L1H, L3H>()),\012      \"unsupported cache hint\");\012  constexpr VectorSize VS = details::lsc_vector_size<NElts>();\012  using _RetTy = decltype(details::lsc_data_type<T, 1, VS>());\012  static_assert(VS != VectorSize::N0, \"invalid vector size\");\012  constexpr DataSize _DS = details::lsc_data_size<T, DS>();\012  CM_STATIC_ERROR(_DS == DataSize::U32 || _DS == DataSize::U64,\012                  \"Transposed load can work only with U32 and U64 data sizes\");\012  constexpr int _ImmOffset = 0;\012  constexpr bool _Transposed = true;\012  uint64_t _Addr = (uint64_t)Ptr;\012  return details::__cm_intrinsic_impl_block_load_flat<\012      _RetTy, _DS, VS, _ImmOffset, L1H, L3H, _Transposed>(_Addr, Offset);\012}\012\012/// BTI non-transposed quad load\012///   * vector size is always 4 for quad so it is not specified\012///   * store is always transposed, so no block version\012template <typename T, ChannelMaskType Mask, DataSize DS = DataSize::Default,\012          CacheHint L1H = CacheHint::Default,\012          CacheHint L3H = CacheHint::Default,\012          int",
" N = details::lsc_default_simt()>\012CM_NODEBUG CM_INLINE auto cm_load4(SurfaceIndex Idx, vector<unsigned, N> Offset,\012                                   vector<ushort, N> Pred = 1) {\012  CM_HAS_LSC_CONTROL; \012  \012  using namespace details;\012  CM_STATIC_ERROR(lsc_check_simt<N>(), \"unexpected number of channels\");\012  CM_STATIC_ERROR((lsc_check_cache_hint<LSCAction::Load, L1H, L3H>()),\012                  \"unsupported cache hint\");\012  constexpr VectorSize _VS =\012      details::lsc_get_vector_size_from_channel_mask<Mask>();\012  CM_HAS_LSC_NON_TRANSPOSE_MESSAGES_WITH_NON_DEFAULT_SIMT_CONTROL(N, _VS);\012  using _MessTy = decltype(lsc_data_type_ext<T, N, _VS>());\012  using _RetTy = decltype(lsc_data_type<T, N, _VS>());\012  constexpr DataSize _DS = lsc_expand_ds(lsc_data_size<T, DS>());\012  constexpr int _ImmOffset = 0;\012  constexpr bool _Transposed = false;\012  auto _TmpRes =\012      __cm_intrinsic_impl_load4_bti<_MessTy, _DS, _VS, _ImmOffset,\012                                    L1H, L3H, _Transposed, N>(Idx, Offset, Pred,\012                    ",
"                                          Mask);\012  return lsc_format_ret<T, _MessTy, _RetTy>(_TmpRes);\012}\012\012/// Flat-address non-transposed quad load\012template <typename T, ChannelMaskType Mask, DataSize DS = DataSize::Default,\012          CacheHint L1H = CacheHint::Default,\012          CacheHint L3H = CacheHint::Default,\012          int N = details::lsc_default_simt()>\012CM_NODEBUG CM_INLINE auto cm_ptr_load4(const T *const Ptr,\012                                       vector<unsigned, N> Offset,\012                                       vector<ushort, N> Pred = 1) {\012  CM_HAS_LSC_CONTROL; \012  \012  using namespace details;\012  CM_STATIC_ERROR(lsc_check_simt<N>(), \"unexpected number of channels\");\012  CM_STATIC_ERROR((lsc_check_cache_hint<LSCAction::Load, L1H, L3H>()),\012                  \"unsupported cache hint\");\012  constexpr VectorSize _VS =\012      details::lsc_get_vector_size_from_channel_mask<Mask>();\012  CM_HAS_LSC_NON_TRANSPOSE_MESSAGES_WITH_NON_DEFAULT_SIMT_CONTROL(N, _VS);\012  using _MessTy = decltype(lsc_data_type_ext<T, N, _VS>()",
");\012  using _RetTy = decltype(lsc_data_type_ext<T, N, _VS>());\012  constexpr DataSize _DS = lsc_expand_ds(lsc_data_size<T, DS>());\012  constexpr int _ImmOffset = 0;\012  constexpr bool _Transposed = false;\012  uint64_t _Addr = (uint64_t)Ptr;\012  auto _TmpRes =\012      __cm_intrinsic_impl_load4_flat<_MessTy, _DS, _VS, _ImmOffset, L1H, L3H,\012                                     _Transposed, N>(_Addr, Offset, Pred, Mask);\012  return lsc_format_ret<T, _MessTy, _RetTy>(_TmpRes);\012}\012\012/// \\brief Data Write.\012///\012/// @param T The element data type.\012///\012/// @param N The number of channels (platform dependent)\012///\012/// @param NElts The number of element to store (for block store only)\012///\012/// @param VS Vector size\012///\012/// @param DS Data size\012///\012/// @param L1H L1 cache hint\012///\012/// @param L3H L3 chache hint\012///\012/// @param Pred Predicate\012///\012/// @param Idx Surface index, which must correspond to a buffer.\012///\012/// @param Offset zero based offset of the output buffer in bytes.\012///\012/// @param Data data to write.\012///\012template <typename T, Vect",
"orSize VS = VectorSize::N1,\012          DataSize DS = DataSize::Default, CacheHint L1H = CacheHint::Default,\012          CacheHint L3H = CacheHint::Default,\012          int N = details::lsc_default_simt()>\012CM_NODEBUG CM_INLINE void\012cm_store(SurfaceIndex Idx, vector<unsigned, N> Offset,\012         vector<T, N * details::lsc_vector_size<VS>()> Data,\012         vector<ushort, N> Pred = 1) {\012  CM_HAS_LSC_CONTROL; \012  \012  using namespace details;\012  CM_STATIC_ERROR(lsc_check_simt<N>(), \"unexpected number of channels\");\012  CM_STATIC_ERROR((lsc_check_cache_hint<LSCAction::Store, L1H, L3H>()),\012                  \"unsupported cache hint\");\012  CM_HAS_LSC_NON_TRANSPOSE_MESSAGES_WITH_NON_DEFAULT_SIMT_CONTROL(N, VS);\012  constexpr DataSize _DS = lsc_expand_ds(details::lsc_data_size<T, DS>());\012  constexpr int _ImmOffset = 0;\012  constexpr bool _Transposed = false;\012  using _StTy = decltype(lsc_data_type_ext<T, N, VS>());\012  using _CastTy = typename lsc_bitcast_type<T>::type;\012  _StTy _TmpData = Data.format<_CastTy>();\012  details::__cm_intrinsic_i",
"mpl_store_bti<typename lsc_expand_type<T>::type, _DS,\012                                         VS, _ImmOffset, L1H, L3H, _Transposed,\012                                         N>(Idx, Offset, _TmpData, Pred);\012}\012/// Flat-address store using a base-address to a buffer\012template <typename T, VectorSize VS = VectorSize::N1,\012          DataSize DS = DataSize::Default, CacheHint L1H = CacheHint::Default,\012          CacheHint L3H = CacheHint::Default,\012          int N = details::lsc_default_simt()>\012CM_NODEBUG CM_INLINE void\012cm_ptr_store(T *Ptr, vector<unsigned, N> Offset,\012             vector<T, N * details::lsc_vector_size<VS>()> Data,\012             vector<ushort, N> Pred = 1) {\012  CM_HAS_LSC_CONTROL; \012  \012  using namespace details;\012  CM_STATIC_ERROR(lsc_check_simt<N>(), \"unexpected number of channels\");\012  CM_STATIC_ERROR((lsc_check_cache_hint<LSCAction::Store, L1H, L3H>()),\012                  \"unsupported cache hint\");\012  CM_HAS_LSC_NON_TRANSPOSE_MESSAGES_WITH_NON_DEFAULT_SIMT_CONTROL(N, VS);\012  constexpr DataSize _DS = lsc_e",
"xpand_ds(details::lsc_data_size<T, DS>());\012  constexpr int _ImmOffset = 0;\012  constexpr bool _Transposed = false;\012  uint64_t _Addr = (uint64_t)Ptr;\012  using _StTy = decltype(lsc_data_type_ext<T, N, VS>());\012  using _CastTy = typename lsc_bitcast_type<T>::type;\012  _StTy _TmpData = Data.format<_CastTy>();\012  details::__cm_intrinsic_impl_store_flat<typename lsc_expand_type<T>::type,\012                                          _DS, VS, _ImmOffset, L1H, L3H,\012                                          _Transposed, N>(_Addr, Offset,\012                                                          _TmpData, Pred);\012}\012\012/// Quad version of BTI store:\012///   * vector size is always 4 for quad so it is not specified\012///   * store is always transposed, so no block version\012template <typename T, ChannelMaskType Mask, DataSize DS = DataSize::Default,\012          CacheHint L1H = CacheHint::Default,\012          CacheHint L3H = CacheHint::Default,\012          int N = details::lsc_default_simt()>\012CM_NODEBUG CM_INLINE void cm_store4(\012    SurfaceIndex I",
"dx, vector<unsigned, N> Offset,\012    vector<T, N * details::lsc_get_num_elements_from_channel_mask<Mask>()> Data,\012    vector<ushort, N> Pred = 1) {\012  CM_HAS_LSC_CONTROL; \012  \012  using namespace details;\012  CM_STATIC_ERROR(lsc_check_simt<N>(), \"unexpected number of channels\");\012  CM_STATIC_ERROR((lsc_check_cache_hint<LSCAction::Store, L1H, L3H>()),\012                  \"unsupported cache hint\");\012  constexpr VectorSize _VS =\012      details::lsc_get_vector_size_from_channel_mask<Mask>();\012  CM_HAS_LSC_NON_TRANSPOSE_MESSAGES_WITH_NON_DEFAULT_SIMT_CONTROL(N, _VS);\012  constexpr DataSize _DS = lsc_expand_ds(details::lsc_data_size<T, DS>());\012  constexpr int _ImmOffset = 0;\012  constexpr bool _Transposed = false;\012  using _StTy = decltype(lsc_data_type_ext<T, N, _VS>());\012  using _CastTy = typename lsc_bitcast_type<T>::type;\012  _StTy _TmpData = Data.format<_CastTy>();\012  details::__cm_intrinsic_impl_store4_bti<typename lsc_expand_type<T>::type,\012                                          _DS, _VS, _ImmOffset, L1H,\012                      ",
"                    L3H, _Transposed, N>(\012      Idx, Offset, _TmpData, Pred, Mask);\012}\012\012/// Quad version of flat store\012template <typename T, ChannelMaskType Mask, DataSize DS = DataSize::Default,\012          CacheHint L1H = CacheHint::Default,\012          CacheHint L3H = CacheHint::Default,\012          int N = details::lsc_default_simt()>\012CM_NODEBUG CM_INLINE void cm_ptr_store4(\012    T *Ptr, vector<unsigned, N> Offset,\012    vector<T, N * details::lsc_get_num_elements_from_channel_mask<Mask>()> Data,\012    vector<ushort, N> Pred = 1) {\012  CM_HAS_LSC_CONTROL; \012  \012  using namespace details;\012  CM_STATIC_ERROR(lsc_check_simt<N>(), \"unexpected number of channels\");\012  CM_STATIC_ERROR((lsc_check_cache_hint<LSCAction::Store, L1H, L3H>()),\012                  \"unsupported cache hint\");\012  constexpr VectorSize _VS =\012      details::lsc_get_vector_size_from_channel_mask<Mask>();\012  CM_HAS_LSC_NON_TRANSPOSE_MESSAGES_WITH_NON_DEFAULT_SIMT_CONTROL(N, _VS);\012  constexpr DataSize _DS = lsc_expand_ds(details::lsc_data_size<T, DS>());\012  constexp",
"r int _ImmOffset = 0;\012  constexpr bool _Transposed = false;\012  uint64_t _Addr = (uint64_t)Ptr;\012  using _StTy = decltype(lsc_data_type_ext<T, N, _VS>());\012  using _CastTy = typename lsc_bitcast_type<T>::type;\012  _StTy _TmpData = Data.format<_CastTy>();\012  details::__cm_intrinsic_impl_store4_flat<typename lsc_expand_type<T>::type,\012                                           _DS, _VS, _ImmOffset, L1H, L3H,\012                                           _Transposed, N>(\012      _Addr, Offset, _TmpData, Pred, Mask);\012}\012\012/// Block store with a SurfaceIndex.\012template <typename T, int NElts, DataSize DS = DataSize::Default,\012          CacheHint L1H = CacheHint::Default,\012          CacheHint L3H = CacheHint::Default>\012CM_NODEBUG CM_INLINE void cm_store(SurfaceIndex Idx, unsigned Offset,\012                                   vector<T, NElts> Data) {\012  CM_HAS_LSC_CONTROL; \012  \012  using namespace details;\012  CM_STATIC_ERROR((lsc_check_cache_hint<LSCAction::Store, L1H, L3H>()),\012                  \"unsupported cache hint\");\012  constexpr DataSize",
" _DS = lsc_data_size<T, DS>();\012  CM_STATIC_ERROR(_DS == DataSize::U32 || _DS == DataSize::U64,\012                  \"Transposed store can work only with U32 and U64 data sizes\");\012  constexpr VectorSize _VS = lsc_vector_size<NElts>();\012  static_assert(_VS != VectorSize::N0, \"invalid vector size\");\012  constexpr int _ImmOffset = 0;\012  constexpr bool _Transposed = true;\012  __cm_intrinsic_impl_block_store_bti<T, _DS, _VS, _ImmOffset, L1H, L3H,\012                                      _Transposed>(Idx, Offset, Data);\012}\012\012/// Block store with a base pointer.\012template <typename T, int NElts, DataSize DS = DataSize::Default,\012          CacheHint L1H = CacheHint::Default,\012          CacheHint L3H = CacheHint::Default>\012CM_NODEBUG CM_INLINE void cm_ptr_store(T *ptr, unsigned Offset,\012                                       vector<T, NElts> Data) {\012  CM_HAS_LSC_CONTROL; \012  \012  using namespace details;\012  CM_STATIC_ERROR((lsc_check_cache_hint<LSCAction::Store, L1H, L3H>()),\012                  \"unsupported cache hint\");\012  constexpr DataSize ",
"_DS = lsc_data_size<T, DS>();\012  CM_STATIC_ERROR(_DS == DataSize::U32 || _DS == DataSize::U64,\012                  \"Transposed store can work only with U32 and U64 data sizes\");\012  constexpr VectorSize _VS = lsc_vector_size<NElts>();\012  static_assert(_VS != VectorSize::N0, \"invalid vector size\");\012  constexpr int _ImmOffset = 0;\012  constexpr bool _Transposed = true;\012  uint64_t _Addr = (uint64_t)ptr;\012  __cm_intrinsic_impl_block_store_flat<T, _DS, _VS, _ImmOffset, L1H, L3H,\012                                       _Transposed>(_Addr, Offset, Data);\012}\012\012/// \\brief SLM Data Read.\012///\012/// @param T The return element data type.\012///\012/// @param N The number of channels (platform dependent)\012///\012/// @param VS Vector size\012///\012/// @param DS Data size\012///\012/// @param Pred Predicate\012///\012/// @param Offset zero based offset of the input SLM buffer in bytes.\012///\012\012// Non-transposed SLM load\012template <typename T, VectorSize VS = VectorSize::N1,\012          DataSize DS = DataSize::Default, int N = details::lsc_default_simt()>\012CM_NODEBUG CM_I",
"NLINE auto cm_load_slm(vector<unsigned, N> Offset,\012                                      vector<ushort, N> Pred = 1) {\012  CM_HAS_LSC_CONTROL; \012  \012  using namespace details;\012  CM_STATIC_ERROR(lsc_check_simt<N>(), \"unexpected number of channels\");\012  CM_HAS_LSC_NON_TRANSPOSE_MESSAGES_WITH_NON_DEFAULT_SIMT_CONTROL(N, VS);\012  using _MessTy = decltype(details::lsc_data_type_ext<T, N, VS>());\012  using _RetTy = decltype(lsc_data_type<T, N, VS>());\012  constexpr DataSize _DS = lsc_expand_ds(details::lsc_data_size<T, DS>());\012  constexpr int _ImmOffset = 0;\012  constexpr bool _Transposed = false;\012  auto _TmpRes =\012      details::__cm_intrinsic_impl_load_slm<_MessTy, _DS, VS, _ImmOffset,\012                                            _Transposed>(Offset, Pred);\012  return lsc_format_ret<T, _MessTy, _RetTy>(_TmpRes);\012}\012\012// Block-load with a base-pointer to the SLM\012template <typename T, VectorSize VS, DataSize DS = DataSize::Default>\012CM_NODEBUG CM_INLINE auto cm_load_slm(unsigned Offset) {\012  CM_HAS_LSC_CONTROL; \012  \012  CM_STATIC_WARNING(",
"details::always_false<decltype(VS)>(),\012                    \"Please use new interface with explicit NElts\");\012  using namespace details;\012  using _RetTy = decltype(lsc_data_type<T, 1, VS>());\012  static_assert(VS != VectorSize::N0, \"invalid vector size\");\012  constexpr DataSize _DS = lsc_data_size<T, DS>();\012  CM_STATIC_ERROR(_DS == DataSize::U32 || _DS == DataSize::U64,\012                  \"Transposed load can work only with U32 and U64 data sizes\");\012  constexpr int _ImmOffset = 0;\012  constexpr bool _Transposed = true;\012  return __cm_intrinsic_impl_block_load_slm<_RetTy, _DS, VS, _ImmOffset,\012                                            _Transposed>(Offset);\012}\012\012// Block-load with a base-pointer to the SLM, new interface\012template <typename T, int NElts, DataSize DS = DataSize::Default>\012CM_NODEBUG CM_INLINE auto cm_load_slm(unsigned Offset) {\012  CM_HAS_LSC_CONTROL; \012  \012  using namespace details;\012  constexpr VectorSize VS = details::lsc_vector_size<NElts>();\012  using _RetTy = decltype(lsc_data_type<T, 1, VS>());\012  static_asser",
"t(VS != VectorSize::N0, \"invalid vector size\");\012  constexpr DataSize _DS = lsc_data_size<T, DS>();\012  CM_STATIC_ERROR(_DS == DataSize::U32 || _DS == DataSize::U64,\012                  \"Transposed load can work only with U32 and U64 data sizes\");\012  constexpr int _ImmOffset = 0;\012  constexpr bool _Transposed = true;\012  return __cm_intrinsic_impl_block_load_slm<_RetTy, _DS, VS, _ImmOffset,\012                                            _Transposed>(Offset);\012}\012\012// Non-transposed SLM quad load\012template <typename T, ChannelMaskType Mask, DataSize DS = DataSize::Default,\012          int N = details::lsc_default_simt()>\012CM_NODEBUG CM_INLINE auto cm_load4_slm(vector<unsigned, N> Offset,\012                                       vector<ushort, N> Pred = 1) {\012  CM_HAS_LSC_CONTROL; \012\012  using namespace details;\012  CM_STATIC_ERROR(lsc_check_simt<N>(), \"unexpected number of channels\");\012  constexpr VectorSize _VS =\012      details::lsc_get_vector_size_from_channel_mask<Mask>();\012  CM_HAS_LSC_NON_TRANSPOSE_MESSAGES_WITH_NON_DEFAULT_SIMT_CONTR",
"OL(N, _VS);\012  using _MessTy = decltype(details::lsc_data_type_ext<T, N, _VS>());\012  using _RetTy = decltype(lsc_data_type<T, N, _VS>());\012  constexpr DataSize DS_ = lsc_expand_ds(details::lsc_data_size<T, DS>());\012  constexpr int ImmOffset = 0;\012  constexpr bool Transposed = false;\012  auto _TmpRes =\012      details::__cm_intrinsic_impl_load4_slm<_MessTy, DS_, _VS,\012                                             ImmOffset, Transposed>(Offset,\012                                                                    Pred, Mask);\012  auto _Formatted = _TmpRes.format<T>();\012  constexpr int stride = _Formatted.n_elems() / _TmpRes.n_elems();\012  _RetTy _Res = _Formatted.select<_TmpRes.n_elems(), stride>(0);\012  return _Res;\012}\012\012/// \\brief SLM Data Write.\012///\012/// @param T The element data type.\012///\012/// @param N The number of channels (platform dependent)\012///\012/// @param NElts The number of element to store (for block store only)\012///\012/// @param VS Vector size\012///\012/// @param DS Data size\012///\012/// @param Pred Predicate\012///\012/// @param Offset zer",
"o based offset of the output SLM buffer in bytes.\012///\012/// @param Data data to write.\012///\012template <typename T, VectorSize VS = VectorSize::N1,\012          DataSize DS = DataSize::Default, int N = details::lsc_default_simt()>\012CM_NODEBUG CM_INLINE void\012cm_store_slm(vector<unsigned, N> Offset,\012             vector<T, N * details::lsc_vector_size<VS>()> Data,\012             vector<ushort, N> Pred = 1) {\012  CM_HAS_LSC_CONTROL; \012  \012  CM_STATIC_WARNING(details::always_false<decltype(VS)>(),\012                    \"Please use new interface with explicit NElts\");\012  using namespace details;\012  CM_STATIC_ERROR(lsc_check_simt<N>(), \"unexpected number of channels\");\012  CM_HAS_LSC_NON_TRANSPOSE_MESSAGES_WITH_NON_DEFAULT_SIMT_CONTROL(N, VS);\012  constexpr DataSize _DS = lsc_expand_ds(details::lsc_data_size<T, DS>());\012  constexpr int _ImmOffset = 0;\012  constexpr bool _Transposed = false;\012  using _StTy = decltype(lsc_data_type_ext<T, N, VS>());\012  using _CastTy = typename lsc_bitcast_type<T>::type;\012  _StTy _TmpData = Data.format<_CastTy>();",
"\012  details::__cm_intrinsic_impl_store_slm<typename lsc_expand_type<T>::type, _DS,\012                                         VS, _ImmOffset, _Transposed, N>(\012      Offset, _TmpData, Pred);\012}\012\012// explicit NElts version\012template <typename T, int NElts, DataSize DS = DataSize::Default,\012          int N = details::lsc_default_simt()>\012CM_NODEBUG CM_INLINE void\012cm_store_slm(vector<unsigned, N> Offset,\012             vector<T, N * details::lsc_vector_size<NElts>()> Data,\012             vector<ushort, N> Pred = 1) {\012  CM_HAS_LSC_CONTROL; \012  \012  using namespace details;\012  CM_STATIC_ERROR(lsc_check_simt<N>(), \"unexpected number of channels\");\012  CM_HAS_LSC_NON_TRANSPOSE_MESSAGES_WITH_NON_DEFAULT_SIMT_CONTROL(\012      N, details::lsc_vector_size<NElts>());\012  constexpr DataSize DS_ = lsc_expand_ds(details::lsc_data_size<T, DS>());\012  constexpr int ImmOffset = 0;\012  constexpr bool Transposed = false;\012  constexpr VectorSize VS = details::lsc_vector_size<NElts>();\012  using _StTy = decltype(lsc_data_type_ext<T, N, VS>());\012  using _CastTy ",
"= typename lsc_bitcast_type<T>::type;\012  _StTy _TmpData = Data.format<_CastTy>();\012  details::__cm_intrinsic_impl_store_slm<typename lsc_expand_type<T>::type, DS_,\012                                         VS, ImmOffset, Transposed, N>(\012      Offset, _TmpData, Pred);\012}\012\012// Block version.\012template <typename T, int NElts, DataSize DS = DataSize::Default>\012CM_NODEBUG CM_INLINE void cm_store_slm(unsigned Offset, vector<T, NElts> Data) {\012  CM_HAS_LSC_CONTROL; \012  \012  constexpr DataSize _DS = details::lsc_data_size<T, DS>();\012  CM_STATIC_ERROR(_DS == DataSize::U32 || _DS == DataSize::U64,\012                  \"Transposed store can work only with U32 and U64 data sizes\");\012  constexpr VectorSize _VS = details::lsc_vector_size<NElts>();\012  static_assert(_VS != VectorSize::N0, \"invalid vector size\");\012  constexpr int _ImmOffset = 0;\012  constexpr bool _Transposed = true;\012  details::__cm_intrinsic_impl_block_store_slm<T, _DS, _VS, _ImmOffset,\012                                               _Transposed>(Offset, Data);\012}\012\012// Quad versio",
"n\012template <typename T, ChannelMaskType Mask, DataSize DS = DataSize::Default,\012          int N = details::lsc_default_simt()>\012CM_NODEBUG CM_INLINE void cm_store4_slm(\012    vector<unsigned, N> Offset,\012    vector<T, N * details::lsc_get_num_elements_from_channel_mask<Mask>()> Data,\012    vector<ushort, N> Pred = 1) {\012  CM_HAS_LSC_CONTROL; \012  \012  using namespace details;\012  CM_STATIC_ERROR(lsc_check_simt<N>(), \"unexpected number of channels\");\012  constexpr DataSize _DS = lsc_expand_ds(details::lsc_data_size<T, DS>());\012  constexpr VectorSize _VS =\012      details::lsc_get_vector_size_from_channel_mask<Mask>();\012  CM_HAS_LSC_NON_TRANSPOSE_MESSAGES_WITH_NON_DEFAULT_SIMT_CONTROL(N, _VS);\012  constexpr int _ImmOffset = 0;\012  constexpr bool _Transposed = false;\012  using _StTy = decltype(lsc_data_type_ext<T, N, _VS>());\012  using _CastTy = typename lsc_bitcast_type<T>::type;\012  _StTy _TmpData = Data.format<_CastTy>();\012  details::__cm_intrinsic_impl_store4_slm<typename lsc_expand_type<T>::type,\012                                         ",
" _DS, _VS, _ImmOffset, _Transposed, N>(\012      Offset, _TmpData, Pred, Mask);\012}\012\012// HW restrictions force data which is read to contain padding filled with\012// zeroes for 2d lsc loads. This function eliminates such padding. For details\012// see documentation for LSC_UNTYPED (LOAD_BLOCK2D).\012template <typename T, int NumElementsWithoutPad, int NumELementsWithPad,\012          int ElemsPerDword, int Height, int Width, int NumBlocks,\012          int GRFRowPitch, int GRFBlockPitch, bool Transposed, bool Transformed>\012CM_NODEBUG CM_INLINE vector<T, NumElementsWithoutPad>\012unpad_untyped_2d_lsc_load(vector<T, NumELementsWithPad> _PaddedV) {\012  CM_STATIC_ERROR(!Transposed || !Transformed,\012                  \"Transposed and transformed is not supported\");\012  CM_STATIC_ERROR(!Transposed || (Transposed && NumBlocks == 1),\012                  \"Transposed expected to be 1 block only\");\012  vector<T, NumElementsWithoutPad> _UnpaddedV = 0;\012\012#pragma unroll\012  for (unsigned i = 0; i < NumBlocks; i++) {\012\012    if constexpr (!Transposed && !Transfor",
"med) {\012#pragma unroll\012      for (unsigned j = 0; j < Height; j++) {\012        unsigned UnpaddedBlockNumElements = i * (Width * Height);\012        _UnpaddedV.select<Width, 1>(UnpaddedBlockNumElements + j * Width) =\012            _PaddedV.select<Width, 1>(i * GRFBlockPitch + j * GRFRowPitch);\012      }\012    }\012\012    else if constexpr (Transposed && !Transformed) {\012#pragma unroll\012      for (unsigned j = 0; j < Width; j++)\012        _UnpaddedV.select<Height, 1>(j * Height) =\012            _PaddedV.select<Height, 1>(j * GRFRowPitch);\012    }\012\012    else if constexpr (!Transposed && Transformed) {\012#pragma unroll\012      for (unsigned j = 0; j < Height; j += ElemsPerDword) {\012        unsigned UnpaddedBlockNumElements = i * (Width * Height);\012        _UnpaddedV.select<ElemsPerDword * Width, 1>(UnpaddedBlockNumElements +\012                                                    j * Width) =\012            _PaddedV.select<ElemsPerDword * Width, 1>(i * GRFBlockPitch +\012                                                      j * GRFRowPitch);\012      }\012    ",
"}\012  }\012\012  return _UnpaddedV;\012}\012\012/// \\brief 2D Block Read (flat)\012///\012/// @param T The element data type.\012///\012/// @param N The data size\012///\012/// @param Width The block width in number of elements\012///\012/// @param Height The block height\012///\012/// @param NBlks, The number of blocks\012///\012/// @param Transposed Is Transposed or not\012///\012/// @param Transformed apply VNNI transform or not\012///\012/// @param L1H L1 cache hint\012///\012/// @param L3H L3 chache hint\012///\012/// @param Ptr Surface base address\012///\012/// @param SurfaceWidth the surface width minus 1 in bytes\012///\012/// @param SurfaceHeight the surface height minus 1 in rows\012///\012/// @param SurfacePitch the surface pitch minus 1 in bytes\012///\012/// @param X zero based X-coordinate of the left upper rectangle corner in\012/// number of elements.\012///\012/// @param Y zero based Y-coordinate of the left upper rectangle corner in rows.\012///\012/// @param Data Data to store.\012///\012/// @return vector of type T and size N. Size is specified with padding.\012/// see details::getBlock2dDataSize for details\012te",
"mplate <typename T, int Width, int Height = 1, int NBlks = 1,\012          bool Transposed = false, bool Transformed = false,\012          CacheHint L1H = CacheHint::Default,\012          CacheHint L3H = CacheHint::Default,\012          int N = details::getBlock2dDataSize<T, NBlks, Height, Width,\012                                              Transposed, Transformed>()>\012CM_NODEBUG CM_INLINE vector<T, N>\012cm_ptr_load(T *Ptr, unsigned SurfaceWidth, unsigned SurfaceHeight,\012            unsigned SurfacePitch, int X, int Y) {\012  CM_HAS_LSC_UNTYPED_2D_CONTROL;\012\012  CM_STATIC_ERROR(!Transposed || !Transformed,\012                  \"Transposed and transformed is not supported\");\012  CM_STATIC_ERROR(!Transposed || (Transposed && NBlks == 1),\012                  \"Transposed expected to be 1 block only\");\012  using namespace details;\012  CM_STATIC_ERROR((lsc_check_cache_hint<LSCAction::Load, L1H, L3H>()),\012                  \"unsupported cache hint\");\012  uintptr_t Base = reinterpret_cast<uintptr_t>(Ptr);\012  // Calculate number of elements with padding\012",
"  constexpr int ElemsPerDword = 4 / sizeof(T);\012  constexpr int GRFRowSize = Transposed \? Height : Width;\012  constexpr int GRFRowPitch = details::getNextPowerOf2(GRFRowSize);\012  constexpr int GRFBlockSize = GRFRowPitch * (Transposed \? Width : Height);\012  constexpr int GRFBlockPitch =\012      details::roundUpNextMultiple(64 / sizeof(T), GRFBlockSize);\012  constexpr int ActualN = NBlks * GRFBlockPitch;\012\012  vector<T, ActualN> _ActualRet =\012      __cm_intrinsic_impl_block_load2d_flat<T, NBlks, Width, Height, Transposed,\012                                            Transformed, L1H, L3H, ActualN>(\012          Base, SurfaceWidth, SurfaceHeight, SurfacePitch, X, Y);\012\012  // If no padding is observed, then return as read\012  if constexpr (ActualN == N)\012    return _ActualRet;\012\012  return unpad_untyped_2d_lsc_load<T, N, ActualN, ElemsPerDword, Height, Width,\012                                   NBlks, GRFRowPitch, GRFBlockPitch,\012                                   Transposed, Transformed>(_ActualRet);\012}\012\012// convenient overload to not break ",
"legacy\012template <typename T, int Width, int Height = 1, int NBlks = 1,\012          bool Transposed = false, bool Transformed = false,\012          CacheHint L1H = CacheHint::Default,\012          CacheHint L3H = CacheHint::Default,\012          int N = details::getBlock2dDataSize<T, NBlks, Height, Width,\012                                              Transposed, Transformed>()>\012CM_NODEBUG CM_INLINE vector<T, N> cm_load(T *Ptr, unsigned SurfaceWidth,\012                                          unsigned SurfaceHeight,\012                                          unsigned SurfacePitch, int X, int Y) {\012  return cm_ptr_load<T, Width, Height, NBlks, Transposed, Transformed, L1H, L3H,\012                     N>(Ptr, SurfaceWidth, SurfaceHeight, SurfacePitch, X, Y);\012}\012\012/// \\brief 2D Block Prefetch (flat)\012template <typename T, int Width, int Height = 1, int NBlks = 1,\012          CacheHint L1H = CacheHint::Cached,\012          CacheHint L3H = CacheHint::Cached>\012CM_NODEBUG CM_INLINE void cm_ptr_prefetch(T *Ptr, unsigned SurfaceWidth,\012         ",
"                                 unsigned SurfaceHeight,\012                                          unsigned SurfacePitch, int X, int Y) {\012  CM_HAS_LSC_UNTYPED_2D_CONTROL;\012\012  using namespace details;\012  CM_STATIC_ERROR((lsc_check_cache_hint<LSCAction::Prefetch, L1H, L3H>()),\012                  \"unsupported cache hint\");\012  uintptr_t Base = reinterpret_cast<uintptr_t>(Ptr);\012  __cm_intrinsic_impl_block_prefetch2d_flat<T, NBlks, Width, Height, L1H, L3H>(\012      Base, SurfaceWidth, SurfaceHeight, SurfacePitch, X, Y);\012}\012\012/// convenient overload to not break legacy\012template <typename T, int Width, int Height = 1, int NBlks = 1,\012          CacheHint L1H = CacheHint::Cached,\012          CacheHint L3H = CacheHint::Cached>\012CM_NODEBUG CM_INLINE void cm_prefetch(T *Ptr, unsigned SurfaceWidth,\012                                      unsigned SurfaceHeight,\012                                      unsigned SurfacePitch, int X, int Y) {\012  return cm_ptr_prefetch<T, Width, Height, NBlks, L1H, L3H>(\012      Ptr, SurfaceWidth, SurfaceHeight, ",
"SurfacePitch, X, Y);\012}\012\012/// \\brief 2D Block Store (flat)\012template <typename T, int Width, int Height = 1,\012          CacheHint L1H = CacheHint::Default,\012          CacheHint L3H = CacheHint::Default,\012          int N = details::getBlock2dDataSize<T, 1 /*NBlks*/, Height, Width,\012                                              false /*Transposed*/,\012                                              false /*Transformed*/>()>\012CM_NODEBUG CM_INLINE void\012cm_ptr_store(T *Ptr, unsigned SurfaceWidth, unsigned SurfaceHeight,\012             unsigned SurfacePitch, int X, int Y, vector<T, N> Data) {\012  CM_HAS_LSC_UNTYPED_2D_CONTROL;\012\012  using namespace details;\012  CM_STATIC_ERROR((lsc_check_cache_hint<LSCAction::Store, L1H, L3H>()),\012                  \"unsupported cache hint\");\012  constexpr int NBlks = 1;\012  uintptr_t Base = reinterpret_cast<uintptr_t>(Ptr);\012  __cm_intrinsic_impl_block_store2d_flat<T, NBlks, Width, Height, L1H, L3H, N>(\012      Base, SurfaceWidth, SurfaceHeight, SurfacePitch, X, Y, Data);\012}\012\012/// convenient overload to not brea",
"k legacy\012template <typename T, int Width, int Height = 1,\012          CacheHint L1H = CacheHint::Default,\012          CacheHint L3H = CacheHint::Default,\012          int N = details::getBlock2dDataSize<T, 1 /*NBlks*/, Height, Width,\012                                              false /*Transposed*/,\012                                              false /*Transformed*/>()>\012CM_NODEBUG CM_INLINE void\012cm_store(T *Ptr, unsigned SurfaceWidth, unsigned SurfaceHeight,\012         unsigned SurfacePitch, int X, int Y, vector<T, N> Data) {\012  cm_ptr_store<T, Width, Height, L1H, L3H, N>(\012      Ptr, SurfaceWidth, SurfaceHeight, SurfacePitch, X, Y, Data);\012}\012\012\012/// \\brief LSC Atomic.\012///\012/// @param T The element data type.\012///\012/// @param VS Vector size\012///\012/// @param DS Data size\012///\012/// @param L1H L1 cache hint\012///\012/// @param L3H L3 chache hint\012///\012/// @param Pred Predicate\012///\012/// @param Idx Surface index, which must correspond to a buffer.\012///\012/// @param Offset zero based byte offset of the input buffer or SLM byte offset\012///\012templat",
"e <AtomicOp Op, typename T, VectorSize VS = VectorSize::N1,\012          DataSize DS = DataSize::Default, CacheHint L1H = CacheHint::Default,\012          CacheHint L3H = CacheHint::Default,\012          int N = details::lsc_default_simt()>\012CM_NODEBUG CM_INLINE auto cm_atomic(SurfaceIndex Idx,\012                                    vector<unsigned, N> Offset,\012                                    vector<ushort, N> Pred = 1) ->\012    typename std::enable_if<\012        details::lsc_atomic_nsrcs<Op>() == 0,\012        vector<T, N * details::lsc_vector_size<VS>()> >::type {\012  CM_HAS_LSC_CONTROL; \012\012  using namespace details;\012  CM_STATIC_ERROR(lsc_check_simt<N>(), \"unexpected number of channels\");\012  CM_STATIC_ERROR((lsc_check_cache_hint<LSCAction::Atomic, L1H, L3H>()),\012                  \"unsupported cache hint\");\012  constexpr DataSize _DS = lsc_expand_ds(lsc_data_size<T, DS>());\012  constexpr bool _Transposed = false;\012  using _IntRetTy = decltype(lsc_data_type_ext<T, N, VS>());\012  using _RetTy = decltype(lsc_data_type<T, N, VS>());\012  auto ",
"_TmpRes =\012      __cm_intrinsic_impl_lsc_atomic_bti<Op, _DS, VS, _Transposed, L1H, L3H,\012                                         _IntRetTy, N>(Pred, Idx, Offset);\012  return lsc_format_ret<T, _IntRetTy, _RetTy>(_TmpRes);\012}\012\012template <AtomicOp Op, typename T, VectorSize VS = VectorSize::N1,\012          DataSize DS = DataSize::Default, CacheHint L1H = CacheHint::Default,\012          CacheHint L3H = CacheHint::Default,\012          int N = details::lsc_default_simt()>\012CM_NODEBUG CM_INLINE auto\012cm_atomic(SurfaceIndex Idx, vector<unsigned, N> Offset,\012          vector<T, N * details::lsc_vector_size<VS>()> Src0,\012          vector<ushort, N> Pred = 1) ->\012    typename std::enable_if<details::lsc_atomic_nsrcs<Op>() == 1,\012                            decltype(Src0)>::type {\012  CM_HAS_LSC_CONTROL; \012\012  using namespace details;\012  CM_STATIC_ERROR(lsc_check_simt<N>(), \"unexpected number of channels\");\012  CM_STATIC_ERROR((lsc_check_cache_hint<LSCAction::Atomic, L1H, L3H>()),\012                  \"unsupported cache hint\");\012  CM_STATIC_ERROR(l",
"sc_check_atomic_src<T>(),\012                  \"unsupported type for lsc atomic source or dest arguments\");\012  constexpr DataSize _DS = lsc_expand_ds(lsc_data_size<T, DS>());\012  constexpr bool _Transposed = false;\012  using _IntRetTy = decltype(lsc_data_type_ext<T, N, VS>());\012  using _SrcTy = decltype(lsc_data_type_ext<T, N, VS>());\012  using _CastTy = typename lsc_bitcast_type<T>::type;\012  using _RetTy = decltype(lsc_data_type<T, N, VS>());\012  _SrcTy _TmpSrc0 = Src0.format<_CastTy>();\012  auto _TmpRes = __cm_intrinsic_impl_lsc_atomic_bti<Op, _DS, VS, _Transposed,\012                                                    L1H, L3H, _IntRetTy, N>(\012      Pred, Idx, Offset, _TmpSrc0);\012  return lsc_format_ret<T, _IntRetTy, _RetTy>(_TmpRes);\012}\012\012template <AtomicOp Op, typename T, VectorSize VS = VectorSize::N1,\012          DataSize DS = DataSize::Default, CacheHint L1H = CacheHint::Default,\012          CacheHint L3H = CacheHint::Default,\012          int N = details::lsc_default_simt()>\012CM_NODEBUG CM_INLINE auto\012cm_atomic(SurfaceIndex Idx, v",
"ector<unsigned, N> Offset,\012          vector<T, N * details::lsc_vector_size<VS>()> Src0,\012          vector<T, N * details::lsc_vector_size<VS>()> Src1,\012          vector<ushort, N> Pred = 1) ->\012    typename std::enable_if<details::lsc_atomic_nsrcs<Op>() == 2,\012                            decltype(Src0)>::type {\012  CM_HAS_LSC_CONTROL; \012\012  using namespace details;\012  CM_STATIC_ERROR(lsc_check_simt<N>(), \"unexpected number of channels\");\012  CM_STATIC_ERROR((lsc_check_cache_hint<LSCAction::Atomic, L1H, L3H>()),\012                  \"unsupported cache hint\");\012  CM_STATIC_ERROR(lsc_check_atomic_src<T>(),\012                  \"unsupported type for lsc atomic source or dest arguments\");\012  constexpr DataSize _DS = lsc_expand_ds(lsc_data_size<T, DS>());\012  using _IntRetTy = decltype(lsc_data_type_ext<T, N, VS>());\012  using _SrcTy = decltype(lsc_data_type_ext<T, N, VS>());\012  using _RetTy = decltype(lsc_data_type<T, N, VS>());\012  using _CastTy = typename lsc_bitcast_type<T>::type;\012  _SrcTy _TmpSrc0 = Src0.format<_CastTy>();\012  _SrcTy _T",
"mpSrc1 = Src1.format<_CastTy>();\012  constexpr bool _Transposed = false;\012  auto _TmpRes = __cm_intrinsic_impl_lsc_atomic_bti<Op, _DS, VS, _Transposed,\012                                                    L1H, L3H, _IntRetTy, N>(\012      Pred, Idx, Offset, _TmpSrc0, _TmpSrc1);\012  return lsc_format_ret<T, _IntRetTy, _RetTy>(_TmpRes);\012}\012\012// flat-address atomic\012template <AtomicOp Op, typename T, VectorSize VS = VectorSize::N1,\012          DataSize DS = DataSize::Default, CacheHint L1H = CacheHint::Default,\012          CacheHint L3H = CacheHint::Default,\012          int N = details::lsc_default_simt()>\012CM_NODEBUG CM_INLINE auto cm_ptr_atomic(T *Ptr, vector<unsigned, N> Offset,\012                                        vector<ushort, N> Pred = 1) ->\012    typename std::enable_if<\012        details::lsc_atomic_nsrcs<Op>() == 0,\012        vector<T, N * details::lsc_vector_size<VS>()> >::type {\012  CM_HAS_LSC_CONTROL; \012\012  using namespace details;\012  CM_STATIC_ERROR(lsc_check_simt<N>(), \"unexpected number of channels\");\012  CM_STATIC_ERROR((ls",
"c_check_cache_hint<LSCAction::Atomic, L1H, L3H>()),\012                  \"unsupported cache hint\");\012  constexpr DataSize _DS = lsc_expand_ds(lsc_data_size<T, DS>());\012  constexpr bool _Transposed = false;\012  uint64_t _Addr = (uint64_t)Ptr;\012  using _IntRetTy = decltype(lsc_data_type_ext<T, N, VS>());\012  using _RetTy = decltype(lsc_data_type<T, N, VS>());\012  auto _TmpRes =\012      __cm_intrinsic_impl_lsc_atomic_flat<Op, _DS, VS, _Transposed, L1H, L3H,\012                                          _IntRetTy, N>(Pred, _Addr, Offset);\012  return lsc_format_ret<T, _IntRetTy, _RetTy>(_TmpRes);\012}\012\012template <AtomicOp Op, typename T, VectorSize VS = VectorSize::N1,\012          DataSize DS = DataSize::Default, CacheHint L1H = CacheHint::Default,\012          CacheHint L3H = CacheHint::Default,\012          int N = details::lsc_default_simt()>\012CM_NODEBUG CM_INLINE auto\012cm_ptr_atomic(T *Ptr, vector<unsigned, N> Offset,\012              vector<T, N * details::lsc_vector_size<VS>()> Src0,\012              vector<ushort, N> Pred = 1) ->\012    typename std",
"::enable_if<details::lsc_atomic_nsrcs<Op>() == 1,\012                            decltype(Src0)>::type {\012  CM_HAS_LSC_CONTROL; \012\012  using namespace details;\012  CM_STATIC_ERROR(lsc_check_simt<N>(), \"unexpected number of channels\");\012  CM_STATIC_ERROR((lsc_check_cache_hint<LSCAction::Atomic, L1H, L3H>()),\012                  \"unsupported cache hint\");\012  CM_STATIC_ERROR(lsc_check_atomic_src<T>(),\012                  \"unsupported type for lsc atomic source or dest arguments\");\012  constexpr DataSize _DS = lsc_expand_ds(lsc_data_size<T, DS>());\012  constexpr bool _Transposed = false;\012  uint64_t _Addr = (uint64_t)Ptr;\012  using _IntRetTy = decltype(lsc_data_type_ext<T, N, VS>());\012  using _SrcTy = decltype(lsc_data_type_ext<T, N, VS>());\012  using _RetTy = decltype(lsc_data_type<T, N, VS>());\012  using _CastTy = typename lsc_bitcast_type<T>::type;\012  _SrcTy _TmpSrc0 = Src0.format<_CastTy>();\012  auto _TmpRes = __cm_intrinsic_impl_lsc_atomic_flat<Op, _DS, VS, _Transposed,\012                                                     L1H, L3H, _IntR",
"etTy, N>(\012      Pred, _Addr, Offset, _TmpSrc0);\012  return lsc_format_ret<T, _IntRetTy, _RetTy>(_TmpRes);\012}\012\012template <AtomicOp Op, typename T, VectorSize VS = VectorSize::N1,\012          DataSize DS = DataSize::Default, CacheHint L1H = CacheHint::Default,\012          CacheHint L3H = CacheHint::Default,\012          int N = details::lsc_default_simt()>\012CM_NODEBUG CM_INLINE auto\012cm_ptr_atomic(T *Ptr, vector<unsigned, N> Offset,\012              vector<T, N * details::lsc_vector_size<VS>()> Src0,\012              vector<T, N * details::lsc_vector_size<VS>()> Src1,\012              vector<ushort, N> Pred = 1) ->\012    typename std::enable_if<details::lsc_atomic_nsrcs<Op>() == 2,\012                            decltype(Src0)>::type {\012  CM_HAS_LSC_CONTROL; \012\012  using namespace details;\012  CM_STATIC_ERROR(lsc_check_simt<N>(), \"unexpected number of channels\");\012  CM_STATIC_ERROR((lsc_check_cache_hint<LSCAction::Atomic, L1H, L3H>()),\012                  \"unsupported cache hint\");\012  CM_STATIC_ERROR(lsc_check_atomic_src<T>(),\012                  \"u",
"nsupported type for lsc atomic source or dest arguments\");\012  constexpr DataSize _DS = lsc_expand_ds(lsc_data_size<T, DS>());\012  using _IntRetTy = decltype(lsc_data_type_ext<T, N, VS>());\012  using _SrcTy = decltype(lsc_data_type_ext<T, N, VS>());\012  using _RetTy = decltype(lsc_data_type<T, N, VS>());\012  using _CastTy = typename lsc_bitcast_type<T>::type;\012  _SrcTy _TmpSrc0 = Src0.format<_CastTy>();\012  _SrcTy _TmpSrc1 = Src1.format<_CastTy>();\012  constexpr bool _Transposed = false;\012  uint64_t _Addr = (uint64_t)Ptr;\012  auto _TmpRes = __cm_intrinsic_impl_lsc_atomic_flat<Op, _DS, VS, _Transposed,\012                                                     L1H, L3H, _IntRetTy, N>(\012      Pred, _Addr, Offset, _TmpSrc0, _TmpSrc1);\012  return lsc_format_ret<T, _IntRetTy, _RetTy>(_TmpRes);\012}\012\012template <AtomicOp Op, typename T, VectorSize VS = VectorSize::N1,\012          DataSize DS = DataSize::Default, CacheHint L1H = CacheHint::Default,\012          CacheHint L3H = CacheHint::Default,\012          int N = details::lsc_default_simt()>\012CM_NODEBU",
"G CM_INLINE auto cm_atomic_slm(vector<unsigned, N> Offset,\012                                        vector<ushort, N> Pred = 1) ->\012    typename std::enable_if<\012        details::lsc_atomic_nsrcs<Op>() == 0,\012        vector<T, N * details::lsc_vector_size<VS>()> >::type {\012  CM_HAS_LSC_CONTROL; \012\012  using namespace details;\012  CM_STATIC_ERROR(lsc_check_simt<N>(), \"unexpected number of channels\");\012  CM_STATIC_ERROR((lsc_check_cache_hint<LSCAction::Atomic, L1H, L3H>()),\012                  \"unsupported cache hint\");\012  constexpr DataSize _DS = lsc_expand_ds(lsc_data_size<T, DS>());\012  constexpr bool _Transposed = false;\012  using _IntRetTy = decltype(lsc_data_type_ext<T, N, VS>());\012  using _RetTy = decltype(lsc_data_type<T, N, VS>());\012  auto _TmpRes =\012      __cm_intrinsic_impl_lsc_atomic_slm<Op, _DS, VS, _Transposed, L1H, L3H,\012                                         _IntRetTy, N>(Pred, Offset);\012  return lsc_format_ret<T, _IntRetTy, _RetTy>(_TmpRes);\012}\012\012template <AtomicOp Op, typename T, VectorSize VS = VectorSize::N1,\012    ",
"      DataSize DS = DataSize::Default, CacheHint L1H = CacheHint::Default,\012          CacheHint L3H = CacheHint::Default,\012          int N = details::lsc_default_simt()>\012CM_NODEBUG CM_INLINE auto\012cm_atomic_slm(vector<unsigned, N> Offset,\012              vector<T, N * details::lsc_vector_size<VS>()> Src0,\012              vector<ushort, N> Pred = 1) ->\012    typename std::enable_if<details::lsc_atomic_nsrcs<Op>() == 1,\012                            decltype(Src0)>::type {\012  CM_HAS_LSC_CONTROL; \012\012  using namespace details;\012  CM_STATIC_ERROR(lsc_check_simt<N>(), \"unexpected number of channels\");\012  CM_STATIC_ERROR((lsc_check_cache_hint<LSCAction::Atomic, L1H, L3H>()),\012                  \"unsupported cache hint\");\012  CM_STATIC_ERROR(lsc_check_atomic_src<T>(),\012                  \"unsupported type for lsc atomic source or dest arguments\");\012  constexpr DataSize _DS = lsc_expand_ds(lsc_data_size<T, DS>());\012  constexpr bool _Transposed = false;\012  using _IntRetTy = decltype(lsc_data_type_ext<T, N, VS>());\012  using _SrcTy = decltype(ls",
"c_data_type_ext<T, N, VS>());\012  using _RetTy = decltype(lsc_data_type<T, N, VS>());\012  using _CastTy = typename lsc_bitcast_type<T>::type;\012  _SrcTy _TmpSrc0 = Src0.format<_CastTy>();\012  auto _TmpRes =\012      __cm_intrinsic_impl_lsc_atomic_slm<Op, _DS, VS, _Transposed, L1H, L3H,\012                                         _IntRetTy, N>(Pred, Offset, _TmpSrc0);\012  return lsc_format_ret<T, _IntRetTy, _RetTy>(_TmpRes);\012}\012\012template <AtomicOp Op, typename T, VectorSize VS = VectorSize::N1,\012          DataSize DS = DataSize::Default, CacheHint L1H = CacheHint::Default,\012          CacheHint L3H = CacheHint::Default,\012          int N = details::lsc_default_simt()>\012CM_NODEBUG CM_INLINE auto\012cm_atomic_slm(vector<unsigned, N> Offset,\012              vector<T, N * details::lsc_vector_size<VS>()> Src0,\012              vector<T, N * details::lsc_vector_size<VS>()> Src1,\012              vector<ushort, N> Pred = 1) ->\012    typename std::enable_if<details::lsc_atomic_nsrcs<Op>() == 2,\012                            decltype(Src0)>::type {\012  CM_HA",
"S_LSC_CONTROL; \012\012  using namespace details;\012  CM_STATIC_ERROR(lsc_check_simt<N>(), \"unexpected number of channels\");\012  CM_STATIC_ERROR((lsc_check_cache_hint<LSCAction::Atomic, L1H, L3H>()),\012                  \"unsupported cache hint\");\012  CM_STATIC_ERROR(lsc_check_atomic_src<T>(),\012                  \"unsupported type for lsc atomic source or dest arguments\");\012  constexpr DataSize _DS = lsc_expand_ds(lsc_data_size<T, DS>());\012  using _IntRetTy = decltype(lsc_data_type_ext<T, N, VS>());\012  using _SrcTy = decltype(lsc_data_type_ext<T, N, VS>());\012  using _RetTy = decltype(lsc_data_type<T, N, VS>());\012  using _CastTy = typename lsc_bitcast_type<T>::type;\012  _SrcTy _TmpSrc0 = Src0.format<_CastTy>();\012  _SrcTy _TmpSrc1 = Src1.format<_CastTy>();\012  constexpr bool _Transposed = false;\012  auto _TmpRes = __cm_intrinsic_impl_lsc_atomic_slm<Op, _DS, VS, _Transposed,\012                                                    L1H, L3H, _IntRetTy, N>(\012      Pred, Offset, _TmpSrc0, _TmpSrc1);\012  return lsc_format_ret<T, _IntRetTy, _RetTy>(_Tmp",
"Res);\012}\012\012///\012/// LSC Fence built-in\012///\012/// \\brief LSC Fence.\012///\012/// @param N The number of channels (platform dependent)\012///\012/// @param Sfid shaded funnction\012///\012/// @param FenceOp\012///\012/// @param Scope\012///\012template <LSC_SFID Sfid = LSC_SFID::LSC_UGM,\012          LSC_FENCE_OP FenceOp = LSC_FENCE_OP::LSC_FENCE_OP_NONE,\012          LSC_SCOPE Scope = LSC_SCOPE::LSC_SCOPE_GROUP,\012          int N = details::lsc_default_simt()>\012CM_NODEBUG CM_INLINE void cm_fence(vector<ushort, N> Pred = 1) {\012  CM_HAS_LSC_CONTROL;//control platform version\012\012  using namespace details;\012  CM_STATIC_ERROR(lsc_check_simt<N>(), \"unexpected number of channels\");\012  __cm_intrinsic_impl_lsc_fence<Sfid, FenceOp, Scope, N>(Pred);\012}\012\012\012#endif // _CLANG_CM_LSC_H_\012\000/*========================== begin_copyright_notice ============================\012\012Copyright (C) 2020-2021 Intel Corporation\012\012SPDX-License-Identifier: MIT\012\012============================= end_copyright_notice ===========================*/\012\012#ifndef CM_CM_MASK_H\012#define CM_CM_MASK_H\012\012#include \"cm",
"_traits.h\"\012#include \"cm_common.h\"\012#include \"cm_internal.h\"\012\012using MaskIntT = uint;\012using MaskVecElemT = ushort;\012template<int size>\012using MaskVecT = vector<MaskVecElemT, size>;\012\012namespace details {\012\012template<int size>\012constexpr int legal_mask_size() {\012  static_assert(size <= 32, \"wrong argument: size is too big\");\012  static_assert(size != 8 && size != 16 && size != 32,\012    \"wrong argument: initial size must be illegal\");\012\012  if (size < 8)\012    return 8;\012  if (size < 16)\012    return 16;\012  return 32;\012}\012\012} // namespace details\012\012template <int N>\012CM_NODEBUG CM_INLINE\012typename std::enable_if<(N == 8 || N == 16 || N == 32), MaskIntT>::type\012cm_pack_mask(MaskVecT<N> src0) {\012  return details::__cm_intrinsic_impl_pack_mask(src0);\012}\012\012template <int N1, int N2>\012CM_NODEBUG CM_INLINE\012typename std::enable_if<(N1 *N2 == 8 || N1 *N2 == 16 || N1 * N2 == 32), MaskIntT>::type\012cm_pack_mask(matrix<MaskVecElemT, N1, N2> src0) {\012  return details::__cm_intrinsic_impl_pack_mask(src0);\012}\012\012template <int N>\012CM_NODEBUG CM_INLINE\012typename std::en",
"able_if<(N != 8 && N != 16 && N < 32), MaskIntT>::type\012cm_pack_mask(MaskVecT<N> src0) {\012  MaskVecT<details::legal_mask_size<N>()> _src0 = 0;\012  _src0.template select<N, 1>() = src0.template format<MaskVecElemT>();\012  return cm_pack_mask(_src0);\012}\012\012template <int N1, int N2>\012CM_NODEBUG CM_INLINE\012typename std::enable_if<(N1 *N2 != 8 && N1 * N2 != 16 && N1 * N2 < 32), MaskIntT>::type\012cm_pack_mask(matrix<MaskVecElemT, N1, N2> src0) {\012  MaskVecT<details::legal_mask_size<N1 *N2>()> _src0 = 0;\012  _src0.template select<N1 *N2, 1>() = src0.template format<MaskVecElemT>();\012  return cm_pack_mask(_src0);\012}\012\012template <typename T, int N>\012CM_NODEBUG CM_INLINE\012typename std::enable_if<(N == 8 || N == 16 || N == 32), MaskVecT<N> >::type\012cm_unpack_mask(MaskIntT src0) {\012  return details::__cm_intrinsic_impl_unpack_mask<T, N>(src0);\012}\012\012template <typename T, int N>\012CM_NODEBUG CM_INLINE\012typename std::enable_if<(N != 8 && N != 16 && N < 32), MaskVecT<N> >::type\012cm_unpack_mask(MaskIntT src0) {\012  static_assert(N > 0);\012\012  auto legal_vec =\012",
"    details::__cm_intrinsic_impl_unpack_mask<T, details::legal_mask_size<N>()>(src0);\012  return legal_vec.select<N, 1>(0);\012}\012\012#endif // CM_CM_MASK_H\012\000/*========================== begin_copyright_notice ============================\012\012Copyright (C) 2015-2021 Intel Corporation\012\012SPDX-License-Identifier: MIT\012\012============================= end_copyright_notice ===========================*/\012\012#if (__INCLUDE_LEVEL__ == 1)\012static_assert(0, \"CM:w:cm_printf.h should not be included explicitly - only \"\012               \"<cm/cm.h> is required\");\012#endif\012\012#ifndef _CM_PRINTF_H_\012#define _CM_PRINTF_H_\012\012#include \"cm_common.h\"\012\012#ifndef __CM_OCL_RUNTIME\012#define printf(...) __cm_builtin_cm_printf(details::__cm_intrinsic_impl_predefined_surface(2), __VA_ARGS__)\012#define cm_printf(...) __cm_builtin_cm_printf(details::__cm_intrinsic_impl_predefined_surface(2), __VA_ARGS__)\012#endif\012\012#define fprintf(BTID, ...) __cm_builtin_cm_printf(BTID, __VA_ARGS__)\012#define cm_fprintf(BTID, ...) __cm_builtin_cm_printf(BTID, __VA_ARGS__)\012\012#define CMPHF_VEC_I",
"SZ  8\012#define CMPHF_VEC_BSZ  (CMPHF_VEC_ISZ * 4) \012#define CMPHF_STR_SZ 128\012\012namespace details {\012//\012// the following cmprint implementation is intended\012// to replace the hard-coded implementation we added in the clang \012// source code\012//\012enum CM_Printf_Object_Type {\012  CMPOT_Unknown = 0,\012  CMPOT_Matrix = 1,\012  CMPOT_Vector = 2,\012  CMPOT_Scalar = 3,\012  CMPOT_String = 4,\012  CMPOT_Format = 5\012};\012\012enum CM_Printf_Data_Type {\012  CMPDT_Char = 0,\012  CMPDT_Uchar = 1,\012  CMPDT_Float = 2,\012  CMPDT_Int = 3,\012  CMPDT_Uint = 4,\012  CMPDT_Short = 5,\012  CMPDT_Ushort = 6,\012  CMPDT_Qword = 7,\012  CMPDT_Uqword = 8,\012  CMPDT_Double = 9\012};\012\012enum CM_Printf_Header_Field {\012  CMPHF_ObjectTypeIndex = 0,\012  CMPHF_DataTypeIndex = 1,\012  CMPHF_DataLoValIndex = 6,\012  CMPHF_DataHiValIndex = 7\012};\012\012using DataElemT = unsigned;\012using OffsetT = DataElemT; // as offset is returned in data vector\012\012constexpr unsigned PRINT_SURF_IDX = 2;\012\012// base function\012template <typename T>\012CM_NODEBUG __CM_PRINT_INLINE_WA OffsetT _cm_pr_len(T value) {\012  OffsetT elem_len = 0;\012  if const",
"expr(details::is_cm_scalar<T>::value)\012     elem_len = CMPHF_VEC_BSZ;\012  return elem_len;\012}\012\012// recursive size-measure function\012template <typename T, typename... Targs>\012CM_NODEBUG __CM_PRINT_INLINE_WA OffsetT _cm_pr_len(T value, Targs... Fargs) {\012  OffsetT elem_len = 0;\012  if constexpr(details::is_cm_scalar<T>::value)\012     elem_len = CMPHF_VEC_BSZ;\012  else\012     CM_STATIC_ERROR(details::is_cm_scalar<T>::value, \"data-type not supported by cmprint\");\012  auto rem_len = _cm_pr_len(Fargs...);\012  return (elem_len + rem_len);\012}\012\012// NOTE: is used in ISPC print\012template <typename T>\012CM_NODEBUG __CM_PRINT_INLINE_WA void\012_cm_print_args_raw(SurfaceIndex BTI, OffsetT offset, DataElemT low,\012                   DataElemT high = 0) {\012  vector<DataElemT, CMPHF_VEC_ISZ> data_vec = 0;\012  data_vec(CMPHF_ObjectTypeIndex) = CMPOT_Scalar;\012  if constexpr(details::is_byte_type<T>::value) {\012    if constexpr(std::is_signed<T>::value)\012      data_vec(CMPHF_DataTypeIndex) = CMPDT_Char;\012    else\012      data_vec(CMPHF_DataTypeIndex) = CMPDT_Uchar;\012  ",
"  data_vec(CMPHF_DataLoValIndex) = low;\012  }\012  else if constexpr(details::is_word_type<T>::value) {\012    if constexpr(std::is_signed<T>::value)\012      data_vec(CMPHF_DataTypeIndex) = CMPDT_Short;\012    else\012      data_vec(CMPHF_DataTypeIndex) = CMPDT_Ushort;\012    data_vec(CMPHF_DataLoValIndex) = low;\012  }\012  else if constexpr(details::is_dword_type<T>::value) {\012    if constexpr(std::is_signed<T>::value)\012      data_vec(CMPHF_DataTypeIndex) = CMPDT_Int;\012    else\012      data_vec(CMPHF_DataTypeIndex) = CMPDT_Uint;\012    data_vec(CMPHF_DataLoValIndex) = low;\012  }\012  else if constexpr(details::is_qword_type<T>::value) {\012    if constexpr(std::is_signed<T>::value)\012      data_vec(CMPHF_DataTypeIndex) = CMPDT_Qword;\012    else\012      data_vec(CMPHF_DataTypeIndex) = CMPDT_Uqword;\012    data_vec(CMPHF_DataHiValIndex) = high;\012    data_vec(CMPHF_DataLoValIndex) = low;\012  }\012  else if constexpr(details::is_fp_type<T>::value) {\012    data_vec(CMPHF_DataTypeIndex) = CMPDT_Float;\012    data_vec(CMPHF_DataLoValIndex) = low;\012  }\012  else if constexpr(det",
"ails::is_df_type<T>::value) {\012    data_vec(CMPHF_DataTypeIndex) = CMPDT_Double;\012    data_vec(CMPHF_DataHiValIndex) = high;\012    data_vec(CMPHF_DataLoValIndex) = low;\012  }\012  write(BTI, offset, data_vec);\012}\012\012// recursive buffer-write function\012template <typename T>\012CM_NODEBUG __CM_PRINT_INLINE_WA void _cm_print_args(SurfaceIndex BTI,\012                                                    OffsetT offset, T value) {\012  vector<DataElemT, CMPHF_VEC_ISZ> data_vec = 0;\012  data_vec(CMPHF_ObjectTypeIndex) = CMPOT_Scalar;\012  if constexpr(details::is_byte_type<T>::value) {\012    if constexpr(std::is_signed<T>::value)\012      data_vec(CMPHF_DataTypeIndex) = CMPDT_Char;\012    else\012      data_vec(CMPHF_DataTypeIndex) = CMPDT_Uchar;\012    data_vec(CMPHF_DataLoValIndex) = (DataElemT)value;\012  }\012  else if constexpr(details::is_word_type<T>::value) {\012    if constexpr(std::is_signed<T>::value)\012      data_vec(CMPHF_DataTypeIndex) = CMPDT_Short;\012    else\012      data_vec(CMPHF_DataTypeIndex) = CMPDT_Ushort;\012    data_vec(CMPHF_DataLoValIndex) = (DataE",
"lemT)value;\012  }\012  else if constexpr(details::is_dword_type<T>::value) {\012    if constexpr(std::is_signed<T>::value)\012      data_vec(CMPHF_DataTypeIndex) = CMPDT_Int;\012    else\012      data_vec(CMPHF_DataTypeIndex) = CMPDT_Uint;\012    data_vec(CMPHF_DataLoValIndex) = (DataElemT)value;\012  }\012  else if constexpr(details::is_qword_type<T>::value) {\012    union {\012      long long ll;\012      unsigned long long ull;\012      DataElemT ui[2];\012    } data;\012    if constexpr(std::is_signed<T>::value) {\012      data_vec(CMPHF_DataTypeIndex) = CMPDT_Qword;\012      data.ll = value;\012    }\012    else {\012      data_vec(CMPHF_DataTypeIndex) = CMPDT_Uqword;\012      data.ull = value;\012    }\012        \012    data_vec(CMPHF_DataHiValIndex) = data.ui[1]; // FIXME: pure UB\012    data_vec(CMPHF_DataLoValIndex) = data.ui[0]; // FIXME: pure UB\012  }\012  else if constexpr(details::is_fp_type<T>::value) {\012    union {\012      float fp;\012      DataElemT ui;\012    } data;\012    data.fp = value;\012    data_vec(CMPHF_DataTypeIndex) = CMPDT_Float;\012    data_vec(CMPHF_DataLoValIndex) = data",
".ui; // FIXME: pure UB\012  }\012  else if constexpr(details::is_df_type<T>::value) {\012    union {\012      double df;\012      DataElemT ui[2];\012    } data;\012    data.df = value;\012    data_vec(CMPHF_DataTypeIndex) = CMPDT_Double;\012    data_vec(CMPHF_DataHiValIndex) = data.ui[1]; // FIXME: pure UB\012    data_vec(CMPHF_DataLoValIndex) = data.ui[0]; // FIXME: pure UB\012  }\012  write(BTI, offset, data_vec);\012}\012\012template <typename T, typename... Targs>\012CM_NODEBUG __CM_PRINT_INLINE_WA void\012_cm_print_args(SurfaceIndex BTI, OffsetT offset, T value, Targs... Fargs) {\012  _cm_print_args(BTI, offset, value);\012  offset += CMPHF_VEC_BSZ;\012  _cm_print_args(BTI, offset, Fargs...);\012}\012 \012const ushort _addr_init[8] = {0, 4, 8, 12, 16, 20, 24, 28};\012\012// NOTE: is used in ISPC print\012CM_NODEBUG __CM_PRINT_INLINE_WA OffsetT\012_cm_print_init_offset(SurfaceIndex BTI, OffsetT total_len) {\012  vector<DataElemT, CMPHF_VEC_ISZ> addrs(details::_addr_init);\012  vector<DataElemT, CMPHF_VEC_ISZ> in = 0;\012  in(0) = total_len;\012  vector<DataElemT, CMPHF_VEC_ISZ> out = 0;\012  write_",
"atomic<ATOMIC_ADD, DataElemT, CMPHF_VEC_ISZ>(BTI, addrs, in, out);\012  return out(0);\012}\012\012// stores format string\012// NOTE: is used in ISPC print\012template <int N>\012CM_NODEBUG __CM_PRINT_INLINE_WA void\012_cm_print_format(SurfaceIndex BTI, OffsetT offset, vector<char, N> str_vec) {\012  vector<DataElemT, CMPHF_VEC_ISZ> data_vec = 0;\012  data_vec(details::CMPHF_ObjectTypeIndex) = details::CMPOT_Format;\012  data_vec(details::CMPHF_DataTypeIndex) = details::CMPDT_Char;\012  data_vec(details::CMPHF_DataLoValIndex) = N;\012  write(BTI, offset, data_vec);\012  offset += CMPHF_VEC_BSZ;\012  write(BTI, offset, str_vec);\012}\012\012template <int N>\012CM_NODEBUG __CM_PRINT_INLINE_WA void\012_cm_print_format(SurfaceIndex BTI, OffsetT offset, const char (&format)[N]) {\012  vector<char, CMPHF_STR_SZ> str_vec = 0;\012#pragma unroll\012  for (int i = 0; i < N; ++i) {\012    str_vec(i) = format[i];\012  }\012  _cm_print_format(BTI, offset, str_vec);\012}\012\012} //details\012\012#ifndef __CM_OCL_RUNTIME\012template <int N>\012CM_NODEBUG __CM_PRINT_INLINE_WA typename std::enable_if<(N <= 128), void>::t",
"ype\012cmfprint(SurfaceIndex BTI, const char (&format)[N]) {\012  details::OffsetT total_len = CMPHF_VEC_BSZ + CMPHF_STR_SZ;\012\012  auto offset = details::_cm_print_init_offset(BTI, total_len);\012\012  // write-out the format string\012  details::_cm_print_format(BTI, offset, format);\012}\012\012template <int N>\012CM_NODEBUG __CM_PRINT_INLINE_WA typename std::enable_if<(N <= 128), int>::type\012cmprint(const char (&format)[N]) {\012  SurfaceIndex BTI = details::__cm_intrinsic_impl_predefined_surface(details::PRINT_SURF_IDX);\012  cmfprint(BTI, format);\012  return 0;\012}\012\012template <int N, typename T, typename... Targs>\012CM_NODEBUG __CM_PRINT_INLINE_WA typename std::enable_if<(N <= 128), void>::type\012cmfprint(SurfaceIndex BTI, const char (&format)[N], T value, Targs... Fargs) {\012  details::OffsetT total_len =\012      CMPHF_VEC_BSZ + CMPHF_STR_SZ + details::_cm_pr_len(value, Fargs...);\012\012  auto offset = details::_cm_print_init_offset(BTI, total_len);\012\012  // write-out the format string\012  details::_cm_print_format(BTI, offset, format);\012  offset += (CMPHF_STR_SZ",
" + CMPHF_VEC_BSZ);\012\012  // write-out arguments\012  details::_cm_print_args(BTI, offset, value, Fargs...);\012}\012\012template <unsigned N, typename T, typename... Targs>\012CM_NODEBUG __CM_PRINT_INLINE_WA typename std::enable_if<(N <= 128), int>::type\012cmprint(const char (&format)[N], T value, Targs... Fargs) {\012  SurfaceIndex BTI = details::__cm_intrinsic_impl_predefined_surface(details::PRINT_SURF_IDX);\012  cmfprint(BTI, format, value, Fargs...);\012  return 0;\012}\012\012#endif /* __CM_OCL_RUNTIME */\012#endif /* _CM_PRINTF_H_ */\012\000/*========================== begin_copyright_notice ============================\012\012Copyright (C) 2020-2021 Intel Corporation\012\012SPDX-License-Identifier: MIT\012\012============================= end_copyright_notice ===========================*/\012\012#if (__INCLUDE_LEVEL__ == 1)\012static_assert(0, \"CM:w:cm_printfocl.h should not be included explicitly - only \"\012               \"<cm/cm.h> is required\");\012#endif\012\012#ifndef _CM_PRINTFOCL_H_\012#define _CM_PRINTFOCL_H_\012\012#include \"cm_common.h\"\012\012#ifdef __CM_OCL_RUNTIME\012\012// Results into 'OpEx",
"tInst printf' instruction in SPIR-V.\012int __spirv_ocl_printf(const char *, ...);\012\012template <typename... Targs> __CM_PRINT_INLINE_WA auto printf(Targs... Fargs) {\012  return __spirv_ocl_printf(Fargs...);\012}\012\012template <typename... Targs>\012__CM_PRINT_INLINE_WA auto cm_printf(Targs... Fargs) {\012  return __spirv_ocl_printf(Fargs...);\012}\012\012template <typename... Targs> __CM_PRINT_INLINE_WA auto cmprint(Targs... Fargs) {\012  return __spirv_ocl_printf(Fargs...);\012}\012\012#endif // __CM_OCL_RUNTIME\012#endif // _CM_PRINTFOCL_H_\012\000/*========================== begin_copyright_notice ============================\012\012Copyright (C) 2014-2021 Intel Corporation\012\012SPDX-License-Identifier: MIT\012\012============================= end_copyright_notice ===========================*/\012\012#if (__INCLUDE_LEVEL__ == 1)\012static_assert(0, \"CM:w:cm_sampler.h should not be included explicitly - only \"\012                 \"<cm/cm.h> is required\");\012#endif\012\012#ifndef _CLANG_CM_SAMPLER_H_\012#define _CLANG_CM_SAMPLER_H_\012\012#include \"cm_common.h\"\012#include \"cm_traits.h\"\012\012// Prototype 3d ",
"sampler underlying functions here as used by others in the\012// header\012template <CM3DSampleOp Op, ChannelMaskType Ch, typename T, int N,\012          typename... Args>\012void cm_3d_sample(vector_ref<T, N> dst, ushort Aoffimmi,\012                  SamplerIndex sampIndex, SurfaceIndex surfIndex,\012                  Args... args);\012template <CM3DLoadOp Op, ChannelMaskType Ch, typename T, int N,\012          typename... Args>\012void cm_3d_load(vector_ref<T, N> dst, ushort Aofimmi, SurfaceIndex surfIndex,\012                Args... args);\012\012/// \\brief Sampler interface.\012///\012/// \\param m the matrix to store the return results, where N is at least the\012/// number of enabled channels. The element type T can be one of float, int, or\012/// unsigned int based on the format of the surface being sampled.\012///\012/// \\param nullmask a 1-word vector to store the null pixel mask result.\012/// Optional.\012///\012/// \\param channelMask enabled channels which must be a compile time constant.\012///\012/// \\param surfIndex an abstract handle that represents the surface",
" created by\012/// CM host runtime and must be passed through kernel function parameters. CM\012/// does not allow the explicit use of local / global variable or modification\012/// of such abstract data types in kernel functions, except used as function\012/// call argument.\012///\012/// \\param sampIndex the index into the sampler state table. This is an abstract\012/// handle that represents the sampler state created by CM host runtime and\012/// must be passed through kernel function parameters.CM does not allow the\012/// explicit use of local / global variable or modification of such abstract\012/// data types in kernel functions, except used as function call argument.\012///\012/// \\param u the normalized x coordinates of the texels to be sampled.\012///\012/// \\param v the normalized y coordinates for non-1D surface types; ignored\012/// otherwise.\012///\012/// \\param r the normalized z coordinates for any 3D surface types; ignored\012/// otherwise.\012///\012template <typename T, int N>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012    details::is_fp_or_dwor",
"d_type<T>::value, void>::type\012sample16(matrix_ref<T, N, 16> m, ChannelMaskType channelMask,\012         SurfaceIndex surfIndex, SamplerIndex sampIndex, vector<float, 16> u,\012         vector<float, 16> v = 0, vector<float, 16> r = 0) {\012#if !(defined(CM_GEN7_5) || defined(CM_GEN8))\012#define SAMPLE16(mask)                                                         \\\012  cm_3d_sample<CM_3D_SAMPLE, mask>(m.format<T>(), 0, sampIndex, surfIndex, u,  \\\012                                      v, r)\012#else\012#define SAMPLE16(mask)                                                         \\\012  m = details::__cm_intrinsic_impl_sample16<T, N, mask>(sampIndex, surfIndex,  \\\012                                                        u, v, r)\012#endif\012\012  switch (channelMask) {\012  default:\012    break;\012  case CM_R_ENABLE:\012    SAMPLE16(CM_R_ENABLE);\012    break;\012  case CM_G_ENABLE:\012    SAMPLE16(CM_G_ENABLE);\012    break;\012  case CM_GR_ENABLE:\012    SAMPLE16(CM_GR_ENABLE);\012    break;\012  case CM_B_ENABLE:\012    SAMPLE16(CM_B_ENABLE);\012    break;\012  case CM_BR_ENABLE",
":\012    SAMPLE16(CM_BR_ENABLE);\012    break;\012  case CM_BG_ENABLE:\012    SAMPLE16(CM_BG_ENABLE);\012    break;\012  case CM_BGR_ENABLE:\012    SAMPLE16(CM_BGR_ENABLE);\012    break;\012  case CM_A_ENABLE:\012    SAMPLE16(CM_A_ENABLE);\012    break;\012  case CM_AR_ENABLE:\012    SAMPLE16(CM_AR_ENABLE);\012    break;\012  case CM_AG_ENABLE:\012    SAMPLE16(CM_AG_ENABLE);\012    break;\012  case CM_AGR_ENABLE:\012    SAMPLE16(CM_AGR_ENABLE);\012    break;\012  case CM_AB_ENABLE:\012    SAMPLE16(CM_AB_ENABLE);\012    break;\012  case CM_ABR_ENABLE:\012    SAMPLE16(CM_ABR_ENABLE);\012    break;\012  case CM_ABG_ENABLE:\012    SAMPLE16(CM_ABG_ENABLE);\012    break;\012  case CM_ABGR_ENABLE:\012    SAMPLE16(CM_ABGR_ENABLE);\012    break;\012  }\012\012#undef SAMPLE16\012}\012\012#if !(defined(CM_GEN7_5) || defined(CM_GEN8))\012template <typename T, int N>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012    details::is_fp_or_dword_type<T>::value, void>::type\012sample16(matrix_ref<T, N, 16> m, vector_ref<short, 1> nullmask,\012         ChannelMaskType channelMask, SurfaceIndex surfIndex,\012         SamplerIndex sampIndex, vector<float,",
" 16> u, vector<float, 16> v = 0,\012         vector<float, 16> r = 0) {\012  vector<T, (N * 16 + (32 / sizeof(T)))> dst3d;\012\012#define SAMPLE16(mask)                                                         \\\012  cm_3d_sample<CM_3D_SAMPLE | CM_3D_SAMPLE_NULLMASK_ENABLE, mask>(             \\\012      dst3d, 0, sampIndex, surfIndex, u, v, r)\012\012  switch (channelMask) {\012  default:\012    break;\012  case CM_R_ENABLE:\012    SAMPLE16(CM_R_ENABLE);\012    break;\012  case CM_G_ENABLE:\012    SAMPLE16(CM_G_ENABLE);\012    break;\012  case CM_GR_ENABLE:\012    SAMPLE16(CM_GR_ENABLE);\012    break;\012  case CM_B_ENABLE:\012    SAMPLE16(CM_B_ENABLE);\012    break;\012  case CM_BR_ENABLE:\012    SAMPLE16(CM_BR_ENABLE);\012    break;\012  case CM_BG_ENABLE:\012    SAMPLE16(CM_BG_ENABLE);\012    break;\012  case CM_BGR_ENABLE:\012    SAMPLE16(CM_BGR_ENABLE);\012    break;\012  case CM_A_ENABLE:\012    SAMPLE16(CM_A_ENABLE);\012    break;\012  case CM_AR_ENABLE:\012    SAMPLE16(CM_AR_ENABLE);\012    break;\012  case CM_AG_ENABLE:\012    SAMPLE16(CM_AG_ENABLE);\012    break;\012  case CM_AGR_ENABLE:\012    SAMPLE16(CM_AGR_ENABLE);\012    ",
"break;\012  case CM_AB_ENABLE:\012    SAMPLE16(CM_AB_ENABLE);\012    break;\012  case CM_ABR_ENABLE:\012    SAMPLE16(CM_ABR_ENABLE);\012    break;\012  case CM_ABG_ENABLE:\012    SAMPLE16(CM_ABG_ENABLE);\012    break;\012  case CM_ABGR_ENABLE:\012    SAMPLE16(CM_ABGR_ENABLE);\012    break;\012  }\012\012  m = dst3d.select<N * 16, 1>(0).format<T, N, 16>();\012  nullmask = dst3d.select<1, 1>(N * 16).format<short>().select<1, 1>(0);\012\012#undef SAMPLE16\012}\012#endif\012\012/// \\brief Sampler interface.\012///\012/// \\param m the matrix to store the return results, where N is at least the\012/// number of enabled channels.\012///\012/// \\param channelMask enabled channels which must be a compile time constant.\012///\012/// \\param surfIndex an abstract handle that represents the surface created by\012/// CM host runtime and must be passed through kernel function parameters. CM\012/// does not allow the explicit use of local / global variable or modification\012/// of such abstract data types in kernel functions, except used as function\012/// call argument.\012///\012/// \\param sampIndex the index into the sampl",
"er state table. This is an abstract\012/// handle that represents the sampler state created by CM host runtime and\012/// must be passed through kernel function parameters.CM does not allow the\012/// explicit use of local / global variable or modification of such abstract\012/// data types in kernel functions, except used as function call argument.\012///\012/// \\param u the normalized x coordinate of pixel 0.\012///\012/// \\param v the normalized y coordinate of pixel 0.\012///\012/// \\param deltaU the difference in coordinates for adjacent pixels in the x\012/// direction.\012///\012/// \\param deltaV the difference in coordinates for adjacent pixels in the y\012/// direction.\012///\012/// \\param ofc output format control parameter. The following are valid values\012/// to use for this parameter:\012///\012/// - CM_16_FULL two bytes returned for each pixel.\012///\012/// - CM_16_DOWN_SAMPLE 16 bit chrominance downsampled. Like CM_16_FULL except\012///   only even pixels are returned for R and B channels.\012///\012/// - CM_8_FULL one byte returned for each pixel.\012///\012/// - CM_",
"8_DOWN_SAMPLE 8 but chrominance downsampled. Like CM_8_FULL but only\012///   even pixels are returned for R and B channels.\012///\012template <int N>\012CM_NODEBUG CM_INLINE void\012sample32(matrix_ref<ushort, N, 32> m, ChannelMaskType channelMask,\012         SurfaceIndex surfIndex, SamplerIndex sampIndex, float u, float v,\012         float deltaU, float deltaV, OutputFormatControl ofc = CM_16_FULL) {\012  CM_HAS_SAMPLE_UNORM_CONTROL;\012\012#define SAMPLE32(mask)                                                         \\\012  switch (ofc) {                                                               \\\012  default:                                                                     \\\012    break;                                                                     \\\012  case CM_16_FULL:                                                             \\\012    m = details::__cm_intrinsic_impl_sample32<N, mask, CM_16_FULL>(            \\\012        sampIndex, surfIndex, u, v, deltaU, deltaV);                           \\\012    break;                           ",
"                                          \\\012  case CM_16_DOWN_SAMPLE:                                                      \\\012    m = details::__cm_intrinsic_impl_sample32<N, mask, CM_16_DOWN_SAMPLE>(     \\\012        sampIndex, surfIndex, u, v, deltaU, deltaV);                           \\\012    break;                                                                     \\\012  case CM_8_FULL:                                                              \\\012    m = details::__cm_intrinsic_impl_sample32<N, mask, CM_8_FULL>(             \\\012        sampIndex, surfIndex, u, v, deltaU, deltaV);                           \\\012    break;                                                                     \\\012  case CM_8_DOWN_SAMPLE:                                                       \\\012    m = details::__cm_intrinsic_impl_sample32<N, mask, CM_8_DOWN_SAMPLE>(      \\\012        sampIndex, surfIndex, u, v, deltaU, deltaV);                           \\\012    break;                                                                     \\\012  }\012\012  s",
"witch (channelMask) {\012  default:\012    break;\012  case CM_R_ENABLE:\012    SAMPLE32(CM_R_ENABLE)\012    break;\012  case CM_G_ENABLE:\012    SAMPLE32(CM_G_ENABLE)\012    break;\012  case CM_GR_ENABLE:\012    SAMPLE32(CM_GR_ENABLE)\012    break;\012  case CM_B_ENABLE:\012    SAMPLE32(CM_B_ENABLE)\012    break;\012  case CM_BR_ENABLE:\012    SAMPLE32(CM_BR_ENABLE)\012    break;\012  case CM_BG_ENABLE:\012    SAMPLE32(CM_BG_ENABLE)\012    break;\012  case CM_BGR_ENABLE:\012    SAMPLE32(CM_BGR_ENABLE)\012    break;\012  case CM_A_ENABLE:\012    SAMPLE32(CM_A_ENABLE)\012    break;\012  case CM_AR_ENABLE:\012    SAMPLE32(CM_AR_ENABLE)\012    break;\012  case CM_AG_ENABLE:\012    SAMPLE32(CM_AG_ENABLE)\012    break;\012  case CM_AGR_ENABLE:\012    SAMPLE32(CM_AGR_ENABLE)\012    break;\012  case CM_AB_ENABLE:\012    SAMPLE32(CM_AB_ENABLE)\012    break;\012  case CM_ABR_ENABLE:\012    SAMPLE32(CM_ABR_ENABLE)\012    break;\012  case CM_ABG_ENABLE:\012    SAMPLE32(CM_ABG_ENABLE)\012    break;\012  case CM_ABGR_ENABLE:\012    SAMPLE32(CM_ABGR_ENABLE)\012    break;\012  }\012\012#undef SAMPLE32\012}\012\012template <typename T = void>\012CM_NODEBUG CM_INLINE void\012sample32(vec",
"tor_ref<ushort, 32> vec, ChannelMaskType channelMask,\012         SurfaceIndex surfIndex, SamplerIndex sampIndex, float u, float v,\012         float deltaU, float deltaV, OutputFormatControl ofc = CM_16_FULL) {\012  matrix_ref<ushort, 1, 32> _Src = vec.format<ushort, 1, 32>();\012  sample32(_Src, channelMask, surfIndex, sampIndex, u, v, deltaU, deltaV, ofc);\012}\012\012/// \\brief Sampler interface.\012///\012/// \\param m the matrix to store the return results, where N is at least the\012/// number of enabled channels.\012///\012/// \\param nullmask a 1-word vector to store the null pixel mask result.\012/// Optional.\012///\012/// \\param channelMask enabled channels which must be a compile time constant.\012///\012/// \\param surfIndex an abstract handle that represents the surface created by\012/// CM host runtime and must be passed through kernel function parameters. CM\012/// does not allow the explicit use of local / global variable or modification\012/// of such abstract data types in kernel functions, except used as function\012/// call argument.\012///\012/// \\param sam",
"pIndex the index into the sampler state table. This is an abstract\012/// handle that represents the sampler state created by CM host runtime and\012/// must be passed through kernel function parameters.CM does not allow the\012/// explicit use of local / global variable or modification of such abstract\012/// data types in kernel functions, except used as function call argument.\012///\012/// \\param u the unnormalized x coordinates of the texels to be sampled.\012///\012/// \\param v the unnormalized y coordinates for non-1D surface types; ignored\012/// otherwise.\012///\012/// \\param r the unnormalized z coordinates for any 3D surface types; ignored\012/// otherwise.\012///\012template <typename T, int N>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012    details::is_fp_or_dword_type<T>::value, void>::type\012load16(matrix_ref<T, N, 16> m, ChannelMaskType channelMask,\012       SurfaceIndex surfIndex, vector<uint, 16> u, vector<uint, 16> v = 0,\012       vector<uint, 16> r = 0) {\012#if !(defined(CM_GEN7_5) || defined(CM_GEN8))\012#define LOAD16(mask)             ",
"                                              \\\012  cm_3d_load<CM_3D_LOAD_LZ, mask>(m.format<T>(), 0, surfIndex, u, v, r)\012#else\012#define LOAD16(mask)                                                           \\\012  m = details::__cm_intrinsic_impl_load16<T, N, mask>(surfIndex, u, v, r)\012#endif\012\012  switch (channelMask) {\012  default:\012    break;\012  case CM_R_ENABLE:\012    LOAD16(CM_R_ENABLE);\012    break;\012  case CM_G_ENABLE:\012    LOAD16(CM_G_ENABLE);\012    break;\012  case CM_GR_ENABLE:\012    LOAD16(CM_GR_ENABLE);\012    break;\012  case CM_B_ENABLE:\012    LOAD16(CM_B_ENABLE);\012    break;\012  case CM_BR_ENABLE:\012    LOAD16(CM_BR_ENABLE);\012    break;\012  case CM_BG_ENABLE:\012    LOAD16(CM_BG_ENABLE);\012    break;\012  case CM_BGR_ENABLE:\012    LOAD16(CM_BGR_ENABLE);\012    break;\012  case CM_A_ENABLE:\012    LOAD16(CM_A_ENABLE);\012    break;\012  case CM_AR_ENABLE:\012    LOAD16(CM_AR_ENABLE);\012    break;\012  case CM_AG_ENABLE:\012    LOAD16(CM_AG_ENABLE);\012    break;\012  case CM_AGR_ENABLE:\012    LOAD16(CM_AGR_ENABLE);\012    break;\012  case CM_AB_ENABLE:\012    LOAD16(CM_AB_ENABLE);\012    bre",
"ak;\012  case CM_ABR_ENABLE:\012    LOAD16(CM_ABR_ENABLE);\012    break;\012  case CM_ABG_ENABLE:\012    LOAD16(CM_ABG_ENABLE);\012    break;\012  case CM_ABGR_ENABLE:\012    LOAD16(CM_ABGR_ENABLE);\012    break;\012  }\012\012#undef LOAD16\012}\012\012#if !(defined(CM_GEN7_5) || defined(CM_GEN8))\012template <typename T, int N>\012CM_NODEBUG CM_INLINE typename std::enable_if<\012    details::is_fp_or_dword_type<T>::value, void>::type\012load16(matrix_ref<T, N, 16> m, vector_ref<short, 1> nullmask,\012       ChannelMaskType channelMask, SurfaceIndex surfIndex, vector<uint, 16> u,\012       vector<uint, 16> v = 0, vector<uint, 16> r = 0) {\012  vector<T, (N * 16 + (32 / sizeof(T)))> dst3d;\012\012#define LOAD16(mask)                                                           \\\012  cm_3d_load<CM_3D_LOAD_LZ | CM_3D_LOAD_NULLMASK_ENABLE, mask>(                \\\012      dst3d, 0, surfIndex, u, v, r)\012\012  switch (channelMask) {\012  default:\012    break;\012  case CM_R_ENABLE:\012    LOAD16(CM_R_ENABLE);\012    break;\012  case CM_G_ENABLE:\012    LOAD16(CM_G_ENABLE);\012    break;\012  case CM_GR_ENABLE:\012    LOAD16(C",
"M_GR_ENABLE);\012    break;\012  case CM_B_ENABLE:\012    LOAD16(CM_B_ENABLE);\012    break;\012  case CM_BR_ENABLE:\012    LOAD16(CM_BR_ENABLE);\012    break;\012  case CM_BG_ENABLE:\012    LOAD16(CM_BG_ENABLE);\012    break;\012  case CM_BGR_ENABLE:\012    LOAD16(CM_BGR_ENABLE);\012    break;\012  case CM_A_ENABLE:\012    LOAD16(CM_A_ENABLE);\012    break;\012  case CM_AR_ENABLE:\012    LOAD16(CM_AR_ENABLE);\012    break;\012  case CM_AG_ENABLE:\012    LOAD16(CM_AG_ENABLE);\012    break;\012  case CM_AGR_ENABLE:\012    LOAD16(CM_AGR_ENABLE);\012    break;\012  case CM_AB_ENABLE:\012    LOAD16(CM_AB_ENABLE);\012    break;\012  case CM_ABR_ENABLE:\012    LOAD16(CM_ABR_ENABLE);\012    break;\012  case CM_ABG_ENABLE:\012    LOAD16(CM_ABG_ENABLE);\012    break;\012  case CM_ABGR_ENABLE:\012    LOAD16(CM_ABGR_ENABLE);\012    break;\012  }\012\012  m = dst3d.select<N * 16, 1>(0).format<T, N, 16>();\012  nullmask = dst3d.select<1, 1>(N * 16).format<short>().select<1, 1>(0);\012\012#undef LOAD16\012}\012#endif\012\012/// Adaptive Video Scaling (AVS)\012///\012/// \\param m the matrix to sture the return result. The results are returned in\012/// ::m with each enab",
"led channel stored in the next row. The actual data\012/// returned is determined by a combination of ::channelMask, ::outControl,\012/// ::execMode, as well as whether output shuffle is enabled in the sampler\012/// state. See the language specification for detailed description.\012///\012/// \\param channelMask Enabled channels, which must be a compile-time constant.\012///\012/// \\param surfIndex The surface index which must correspond to a 2D type\012/// surface that has a format with <= 10 bits per channel.\012///\012/// \\param sampIndex The index into the sampler state table.\012///\012/// \\param u The normalized x coordinat of pixel 0.\012///\012/// \\param v The normalized y coordinat of pixel 0.\012///\012/// \\param deltaU The difference in coordinates for adjacent pixels in the X\012/// direction.\012///\012/// \\param deltaV The difference in coordinates for adjacent pixels in the Y\012/// direction.\012///\012/// \\param u2d Defines the change in the delta U for adjacent pixels in the X\012/// direction.\012///\012/// \\param GroupID This field is valid and must be set for Ge",
"n7+, for all\012/// previous platforms this field is ignored. This parameter will be used to\012/// group messages for reorder for sample_8x8 messages. For all messages with\012/// the same Group ID they must have the following in common: Surface state,\012/// Sampler State, GRFID, M0, and M1 except for Block number.\012///\012/// \\param VerticalBlockNumber This field is valid and must be set for Gen7+,\012/// for all previous platforms this field is ignored. This field will specify\012/// the vertical block offset being sent for this sample_8x8 messages. This will\012/// be equal to the vertical pixel offset from the given address divided by 4.\012///\012/// \\param outControl An enumeration constant that specifies the output format\012/// for each pixel.\012///\012///\012/// \\param v2d Defines the change in the delta V for adjacent pixels in the Y\012/// direction. This parameter is for Gen8+ only, ignored for previous\012/// architectures.\012///\012/// \\param execMode An enumeration constant that determines the number of pixels\012/// to be returned.\012///\012/// \\param",
" IEFBypass This field enables EIF pass. Gen8 only.\012///\012template <typename T, int N, int M>\012void cm_avs_sampler(matrix_ref<T, N, M> m, ChannelMaskType channelMask,\012                    SurfaceIndex surfIndex, SamplerIndex samplerIndex, float u,\012                    float v, float deltaU, float deltaV, float u2d,\012                    int groupID = -1, int verticalBlockNumber = -1,\012                    OutputFormatControl outControl = CM_16_FULL, float v2d = 0,\012                    AVSExecMode execMode = CM_AVS_16x4, bool IEFBypass = false);\012\012/// 2d Convolve\012///\012/// \\param m the matrix to store the return result. The output is a matrix of\012/// 16-bit signed integers, in 4x16 matrix for CM_CONV_16x4 mode, or a 1x16\012/// matrix for CM_CONV_16x1 mode. The data is laid out in sequential pixel\012/// order.\012///\012/// \\param surfIndex the surface index, which must correspond to an 8-bit or\012/// 16-bit\012/// formatted 2D surface.\012///\012/// \\param sampIndex the sampler index\012///\012/// \\param u the normalized x co-ordinate of pixel 0.\012///\012",
"/// \\param v the normalized y co-ordinate of pixel 0.\012///\012/// \\param execMode the execution mode. Two modes are supported, 16x4 mode\012/// (CM_CONV_16x4, the default) and 16x1 mode (CM_CONV_16x1). ::execMode must\012/// be a compile-time constant and the type of ::m must correspond\012/// appropriately.\012///\012/// \\param big_kernel big kernel flag. Ignored on Gen8. On Gen9+ set to true\012/// when\012/// the kernel is larger than 15x15.\012///\012template <int N>\012void cm_va_2d_convolve(matrix_ref<short, N, 16> m, SurfaceIndex surfIndex,\012                       SamplerIndex sampIndex, float u, float v,\012                       CONVExecMode execMode = CM_CONV_16x4,\012                       bool big_kernel = false);\012\012/// Erode\012///\012/// \\param vect the matrix to store the return result. In 64x4 mode each value\012/// int the\012/// vector contains 32 values, N is 8. In 64x1 mode, each value in the vector\012/// contains\012/// 32 values, N is 2. In 32x4 mode each even value [0,6] in the vector contains\012/// 32 values, N is 8. In 32x1 mode each value in t",
"he vector contains 32 value,\012/// N is 1.\012///\012/// \\param surfIndex the surface index, which must correspond to a 32-bit\012/// formatted 2D\012/// surface.\012///\012/// \\param sampIndex the sampler index.\012///\012/// \\param u the normalized x co-ordinate of pixel 0.\012///\012/// \\param v the normalized y co-ordinate of pixel 0.\012///\012/// \\param execMode the execution mode. There are four modes, 64x4 (CM_ED_64x4,\012/// the default),\012/// 32x4 (CM_ED_32x4), 64x1 (CM_ED_64x1) and 32x1 (CM_ED_32x1). It is the\012/// responsibility of\012/// the user to ensure that the return value ::vect is the correct size for\012/// mode. ::execMode\012/// must be a compile-time constant.\012///\012template <int N>\012void cm_va_erode(vector_ref<uint, N> vect, SurfaceIndex surfIndex,\012                 SamplerIndex sampIndex, float u, float v,\012                 EDExecMode execMode = CM_ED_64x4);\012\012/// Dilate\012///\012/// \\param vect the matrix to store the return result. In 64x4 mode each value\012/// int the\012/// vector contains 32 values, N is 8. In 64x1 mode, each value in the vector",
"\012/// contains\012/// 32 values, N is 2. In 32x4 mode each even value [0,6] in the vector contains\012/// 32 values, N is 8. In 32x1 mode each value in the vector contains 32 value,\012/// N is 1.\012///\012/// \\param surfIndex the surface index, which must correspond to a 32-bit\012/// formatted 2D\012/// surface.\012///\012/// \\param sampIndex the sampler index.\012///\012/// \\param u the normalized x co-ordinate of pixel 0.\012///\012/// \\param v the normalized y co-ordinate of pixel 0.\012///\012/// \\param execMode the execution mode. There are four modes, 64x4 (CM_ED_64x4,\012/// the default),\012/// 32x4 (CM_ED_32x4), 64x1 (CM_ED_64x1) and 32x1 (CM_ED_32x1). It is the\012/// responsibility of\012/// the user to ensure that the return value ::vect is the correct size for\012/// mode. ::execMode\012/// must be a compile-time constant.\012///\012template <int N>\012void cm_va_dilate(vector_ref<uint, N> vect, SurfaceIndex surfIndex,\012                  SamplerIndex sampIndex, float u, float v,\012                  EDExecMode execMode = CM_ED_64x4);\012\012/// MinMax\012///\012/// \\param vect the",
" vector to store the return result. Pixel 0 max and min are\012/// stored\012/// in ::vect[0] and ::vect[1] respectively. The type of the vector needs to\012/// correspond\012/// to the input format, vector<uchar, 32> for 8-bit, vector<ushort, 16> for\012/// 16-bit.\012///\012/// \\param surfIndex the surface index, which must correspond to a 2D surface\012/// that has\012/// either an 8- or 16-bit format.\012///\012/// \\param u the normalized x-coordinate of pixel 0.\012///\012/// \\param v the normalized y-coordinate of pixel 0.\012///\012/// \\param mmfMode enable MinMax functionality. Valid values are\012/// CM_MINMAX_ENABLE (default),\012/// CM_MAX_ENABLE, or CM_MIN_ENABLE.\012///\012template <typename T, int N>\012void cm_va_min_max(vector_ref<T, N> vect, SurfaceIndex surfIndex, float u,\012                   float v, MMFEnableMode mmfMode = CM_MINMAX_ENABLE);\012\012/// MinMax Filter\012///\012/// \\param m the matrix to store the return result. The number of pixels per row\012/// depends\012/// on the surface format. It is the responsibility of the user to make sure a\012/// matrix\012/// o",
"f the correct size is passed in.\012///\012/// \\param surfIndex the surface index, which must correspond to a 2D surface\012/// that has\012/// either an 8- or 16-bit format.\012///\012/// \\param sampIndex the sampler index.\012///\012/// \\param u the normalized x-coordinate of pixel 0.\012///\012/// \\param v the normalized y-coordinate of pixel 0.\012///\012/// \\param cntrl specifies the output format, must be a compile-time constant.\012/// Valid values\012/// are CM_16_FULL (default) or CM_8_FULL.\012///\012/// \\param execMode specifies the execution mode, must be a compile-time\012/// constant. Value\012/// values are CM_MMF_16x4 (default), CM_MMF_16x1, or CM_MMF_1x1.\012///\012/// \\param mmfMode enable MinMax functionality. Valid values are\012/// CM_MINMAX_ENABLE (default),\012/// CM_MAX_ENABLE or CM_MIN_ENABLE.\012///\012template <typename T, int N, int M>\012void cm_va_min_max_filter(matrix_ref<T, N, M> m, SurfaceIndex surfIndex,\012                          SamplerIndex sampIndex, float u, float v,\012                          OutputFormatControl cntrl,\012                          ",
"MMFExecMode execMode = CM_MMF_16x4,\012                          MMFEnableMode mmfMode = CM_MINMAX_ENABLE);\012\012/// Boolean Centroid\012///\012/// \\param m the matrix to store the return result.\012///\012/// \\param surfIndex the surface index, which must correspond to a 2D surface\012///\012/// \\param u the normalized x-coordinate of pixel 0\012///\012/// \\param v the normalized y-coordinate of pixel 0\012///\012/// \\param vSize the vertical direction size control\012///\012/// \\param hSize the horizontal direction size control\012///\012template <typename T, int N, int M>\012void cm_va_boolean_centroid(matrix_ref<T, N, M> m, SurfaceIndex surfIndex,\012                            float u, float v, uchar vSize, uchar hSize);\012\012/// Centroid\012///\012/// \\param m the matrix to store the return result.\012///\012/// \\param surfIndex the surface index, which must correspond to a 2D surface\012///\012/// \\param u the normalized x-coordinate of pixel 0\012///\012/// \\param v the normalized y-coordinate of pixel 0\012///\012/// \\param vSize the vertical direction size control\012///\012template <typename",
" T, int N, int M>\012void cm_va_centroid(matrix_ref<T, N, M> m, SurfaceIndex surfIndex, float u,\012                    float v, uchar vSize);\012\012/// 1d Convolve\012///\012/// \\param m the matrix to store the return result, either matrix<short, 1, 16>\012/// for 16x1 mode or matrix<short, 4, 16> for 16x4 mode.\012///\012/// \\param surfIndex the surface index, which must correspond to a 2D surface\012/// that\012/// has either 8- or 16-bit format.\012///\012/// \\param sampIndex the sampler index.\012///\012/// \\param isHdirection the convolve direction. TRUE for horizontal, FALSE for\012/// vertical. Must be a compile-time constant.\012///\012/// \\param u the normalized x-coordinate of pixel 0.\012///\012/// \\param v the normalized y-coordinate of pixel 0.\012///\012/// \\param execMode the execution mode, either CM_CONV_16x4 (the default) or\012/// CM_CONV_16x1.\012template <int N, int M>\012void cm_va_1d_convolution(matrix_ref<short, N, M> m, SurfaceIndex surfIndex,\012                          SamplerIndex sampIndex, bool isHdirection, float u,\012                          float v, C",
"ONVExecMode execMode = CM_CONV_16x4);\012\012/// 1 Pixel Convolve\012///\012/// \\param m the matrix to store the return result. This must be matrix<short,\012/// 4, 16> for\012/// 16x4 mode, matrix<short, 1, 16> for 16x1 mode or matrix<short, 1, 1> for 1x1\012/// mode.\012///\012/// \\param surfIndex the surface index, which must correspond to a 2D surface\012/// with\012/// either 8- or 16-bit format.\012///\012/// \\param sampIndex the sampler index.\012///\012/// \\param u the normalized x-coordinate of pixel 0.\012///\012/// \\param v the normalized y-coordinate of pixel 0.\012///\012/// \\param exexMode the execution mode. Must be one of CM_CONV_16x4 (16x4 mode),\012/// CM_CONV_16x1\012/// (16x1 mode) or CM_CONV_1x1 (1x1 mode). This must be a compile-time constant.\012///\012/// \\param offsets the pixel offsets from the u,v address. A row contains 15\012/// pairs of x,y.\012/// This is not applicable for 1x1 mode, in which case the parameter should be\012/// omitted.\012template <int N, int M>\012void cm_va_1pixel_convolve(matrix_ref<short, N, M> m, SurfaceIndex surfIndex,\012                  ",
"         SamplerIndex sampIndex, float u, float v,\012                           CONVExecMode execMode);\012\012template <int N, int M, int ON, int OM>\012void cm_va_1pixel_convolve(matrix_ref<short, N, M> m, SurfaceIndex surfIndex,\012                           SamplerIndex sampIndex, float u, float v,\012                           CONVExecMode execMode,\012                           matrix<short, ON, OM> offsets);\012\012/// LBP Creation\012///\012/// \\param m the matrix to store the return result. This should have type\012/// matrix<uchar, 4, 16> for only 5x5 or only 3x3 modes, and output is laid out\012/// in\012/// sequential pixel order. For both 5x5 and 3x3 mode combined, it should have\012/// type\012/// matrix<uchar, 8, 16>, with the first 4 rows corresponding to the 3x3\012/// operation\012/// and the final four rows corresponding to the 5x5 operation.\012///\012/// \\param surfIndex the surface index, which must correspond to a 2D surface\012/// that\012/// has either 8- or 16-bit format.\012///\012/// \\param u the normalized x-coordinate of pixel 0.\012///\012/// \\param v th",
"e normalized y-coordinate of pixel 0.\012///\012/// \\param execMode the execution mode. This must be a compile-time constant and\012/// must be one of CM_LBP_CREATION_5x5, CM_LBP_CREATION_3x3 or\012/// CM_LBP_CREATION_BOTH.\012template <int N>\012void cm_va_lbp_creation(matrix_ref<uchar, N, 16> m, SurfaceIndex surfIndex,\012                        float u, float v, LBPCreationExecMode execMode);\012\012/// LBP Correlation\012///\012/// \\param m the matrix to store the return result. This should have type\012/// matrix<uchar, 4, 16>.\012///\012/// \\param surfIndex the surface index, which must correspond to a 2D surface\012/// with\012/// an 8- or 16-bit format.\012///\012/// \\param u the normalized x-coordinate of pixel 0.\012///\012/// \\param v the normalized y-coordinate of pixel 0.\012///\012/// \\param x_offset_disparity 16-bit signed offset for right image with respect\012/// to left image.\012template <int N>\012void cm_va_lbp_correlation(matrix_ref<uchar, N, 16> m, SurfaceIndex surfIndex,\012                           float u, float v, short x_offset_disparity);\012\012/// Correlation ",
"Search\012///\012/// \\param m the matrix to store the return result. Has type matrix<int, N, 8>\012/// for\012/// width less than 8, type matrix<int, N, 16> for width greater than 8. Data\012/// is laid out in sequential order. The number of rows depends on the height\012/// of the search region. Only valid rows are returned.\012///\012/// \\param surfIndex the surface index, which must correspond to a 2D surface\012/// with\012/// an 8- or 16-bit format/\012///\012/// \\param u normalized x co-ordinate of pixel 0.\012///\012/// \\param v normalized y co-ordinate of pixel 0.\012///\012/// \\param verticalOrigin normalized vertical origin of the reference image.\012///\012/// \\param horizontalOrigin normalized horizontal origin of the reference image.\012///\012/// \\param xDirectionSize x direction size of the source correlation. Valid\012/// range [1,8]\012///\012/// \\param yDirectionSize y direction size of the source correlation. Valid\012/// range [1,8]\012///\012/// \\param xDirectionSearchSize x direction search size. Valid range [3,16]\012///\012/// \\param yDirectionSearchSize y direction s",
"earch size. Valid range [3,16]\012template <int N, int M>\012void cm_va_correlation_search(matrix_ref<int, N, M> m, SurfaceIndex surfIndex,\012                              float u, float v, float verticalOrigin,\012                              float horizontalOrigin, uchar xDirectionSize,\012                              uchar yDirectionSize, uchar xDirectionSearchSize,\012                              uchar yDirectionSearchSize);\012\012/// Flood Fill\012///\012/// \\param v vector to store the return result, output format is 1bpp.\012///\012/// \\param Is8Connect TRUE 8-connect is used for floodfill, FALSE 4-connect is\012/// used.\012///\012/// \\param pixelMaskHDirection Pixel mask for the bottom adjacent pixels in the\012/// horizontal direction. Index [0,7] are for rows 0 to 7, index 8 is for row\012/// -1,\012/// index 9 is for row 8.\012///\012/// \\param pixelMaskVDirectionLeft Pixel mask of the adjacent pixels in vertical\012/// direction. Valid values are [0,1023].\012///\012/// \\param pixelMaskVDirectionRight Pixel mask of the adjacent pixels in\012/// vertical\012/// dire",
"ction. Valid values are [0,1023].\012///\012/// \\param loopCount Number of times FloodFill will be repeated on HW. Valid\012/// range\012/// is [1,16]\012void cm_va_flood_fill(vector_ref<ushort, 8> v, bool Is8Connect,\012                      vector<ushort, 10> pixelMaskHDirection,\012                      ushort pixelMaskVDirectionLeft,\012                      ushort pixelMaskVDirectionRight, ushort loopCount);\012\012/// HDC 2D Convolve\012///\012/// \\param surfIndex surface index, which must correspond to a 2D surface with\012/// either\012/// 8- or 16-bit format.\012///\012/// \\param sampIndex sampler index.\012///\012/// \\param u normalized x coordinate of pixel 0.\012///\012/// \\param v normalized y coordinate of pixel 0.\012///\012/// \\param big_kernel set to true when the kernel is larger than 15x15, must be\012/// a\012/// compile-time constant.\012///\012/// \\param size specifies the format of the output surface, must be a\012/// compile-time\012/// constant. Valid values are CM_HDC_FORMAT_16S or CM_HDC_FORMAT_8U.\012///\012/// \\param destIndex the index of the 2D surface where data wil",
"l be written.\012///\012/// \\param x_offset a byte offset into the output surface.\012///\012/// \\param y_offset a row offset into the output surface.\012///\012/// 16x4 pixels will be written to the output surface. Each pixel is clamped to\012/// unsigned char for 8-bit output surfaces.\012void cm_va_2d_convolve_hdc(SurfaceIndex surfIndex, SamplerIndex sampIndex,\012                           float u, float v, bool big_kernel,\012                           CM_FORMAT_SIZE size, SurfaceIndex destIndex,\012                           ushort x_offset, ushort y_offset);\012\012/// HDC Erode\012///\012/// \\param surfIndex the surface index, which must correspond to a 32-bit\012/// formatted 2D\012/// surface.\012///\012/// \\param sampIndex the sampler index.\012///\012/// \\param u the normalized x co-ordinate of pixel 0.\012///\012/// \\param v the normalized y co-ordinate of pixel 0.\012///\012/// \\param destIndex the surface index of the 2D surface where the data will be\012/// written.\012///\012/// \\param x_offset a byte offset into the output surface.\012///\012/// \\param y_offset a row offset into ",
"the output surface.\012void cm_va_erode_hdc(SurfaceIndex surfIndex, SamplerIndex sampIndex, float u,\012                     float v, SurfaceIndex destIndex, ushort x_offset,\012                     ushort y_offset);\012\012/// HDC Dilate\012///\012/// \\param surfIndex the surface index, which must correspond to a 32-bit\012/// formatted 2D\012/// surface.\012///\012/// \\param sampIndex the sampler index.\012///\012/// \\param u the normalized x co-ordinate of pixel 0.\012///\012/// \\param v the normalized y co-ordinate of pixel 0.\012///\012/// \\param destIndex the surface index of the 2D surface where the data will be\012/// written.\012///\012/// \\param x_offset a byte offset into the output surface.\012///\012/// \\param y_offset a row offset into the output surface.\012///\012void cm_va_dilate_hdc(SurfaceIndex surfIndex, SamplerIndex sampIndex, float u,\012                      float v, SurfaceIndex destIndex, ushort x_offset,\012                      ushort y_offset);\012\012/// HDC MinMax Filter\012///\012/// \\param surfIndex the surface index, which must correspond to a 2D surface\012/// that h",
"as\012/// either an 8- or 16-bit format.\012///\012/// \\param sampIndex the sampler index.\012///\012/// \\param u the normalized x-coordinate of pixel 0.\012///\012/// \\param v the normalized y-coordinate of pixel 0.\012///\012/// \\param mmfMode enable MinMax functionality. Valid values are CM_MAX_ENABLE\012/// or CM_MIN_ENABLE.\012///\012/// \\param size the format used for the output. Supported values are\012/// CM_HDC_FORMAT_16S and CM_HDC_FORMAT_8U.\012///\012/// \\param destIndex surface index of the 2D surface the data will be written\012/// to.\012///\012/// \\param x_offset a byte offset into the output surface.\012///\012/// \\param y_offset a row offset into the output surface.\012///\012void cm_va_min_max_filter_hdc(SurfaceIndex surfIndex, SamplerIndex sampIndex,\012                              float u, float v, MMFEnableMode mmfMode,\012                              CM_FORMAT_SIZE size, SurfaceIndex destIndex,\012                              ushort x_offset, ushort y_offset);\012\012/// HDC LBP Correlation\012///\012/// \\param surfIndex the surface index, which must correspond to a 2D",
" surface\012/// with\012/// an 8- or 16-bit format.\012///\012/// \\param u the normalized x-coordinate of pixel 0.\012///\012/// \\param v the normalized y-coordinate of pixel 0.\012///\012/// \\param x_offset_disparity 16-bit signed offset for right image with respect\012/// to left image.\012///\012/// \\param destIndex surface index of the 2D surface the data will be written\012/// to.\012///\012/// \\param x_offset a byte offset into the output surface.\012///\012/// \\param y_offset a row offset into the output surface.\012///\012void cm_va_lbp_correlation_hdc(SurfaceIndex surfIndex, float u, float v,\012                               short x_offset_disparity, SurfaceIndex destIndex,\012                               ushort x_offset, ushort y_offset);\012\012/// HDC LBP Creation\012///\012/// \\param surfIndex the surface index, which must correspond to a 2D surface\012/// that\012/// has either 8- or 16-bit format.\012///\012/// \\param u the normalized x-coordinate of pixel 0.\012///\012/// \\param v the normalized y-coordinate of pixel 0.\012///\012/// \\param execMode the execution mode. This must be a ",
"compile-time constant and\012/// must be either CM_LBP_CREATION_5x5 or CM_LBP_CREATION_3x3.\012///\012/// \\param destIndex surface index of the 2D surface the data will be written\012/// to.\012///\012/// \\param x_offset a byte offset into the output surface.\012///\012/// \\param y_offset a row offset into the output surface.\012///\012void cm_va_lbp_creation_hdc(SurfaceIndex surfIndex, float u, float v,\012                            LBPCreationExecMode execMode,\012                            SurfaceIndex destIndex, ushort x_offset,\012                            ushort y_offset);\012\012/// HDC 1 Pixel Convolve\012///\012/// \\param surfIndex the surface index, which must correspond to a 2D surface\012/// with\012/// either 8- or 16-bit format.\012///\012/// \\param sampIndex the sampler index.\012///\012/// \\param offsets the offsets of pixels from the U,V address.\012///\012/// \\param size specifies the format used for the output. Two formats are\012/// supported, CM_HDC_FORMAT_16S or CM_HDC_FORMAT_8U.\012///\012/// \\param destIndex surface index of the 2D surface the data will be written",
"\012/// to.\012///\012/// \\param x_offset a byte offset into the output surface.\012///\012/// \\param y_offset a row offset into the output surface.\012///\012void cm_va_1pixel_convolve_hdc(SurfaceIndex surfIndex, SamplerIndex sampIndex,\012                               float u, float v, matrix<short, 1, 32> offsets,\012                               CM_FORMAT_SIZE size, SurfaceIndex destIndex,\012                               ushort x_offset, ushort y_offset);\012\012/// HDC 1d Convolve\012///\012/// \\param surfIndex the surface index, which must correspond to a 2D surface\012/// that\012/// has either 8- or 16-bit format.\012///\012/// \\param sampIndex the sampler index.\012///\012/// \\param isHdirection the convolve direction. TRUE for horizontal, FALSE for\012/// vertical. Must be a compile-time constant.\012///\012/// \\param u the normalized x-coordinate of pixel 0.\012///\012/// \\param v the normalized y-coordinate of pixel 0.\012///\012/// \\param size the format used for the output. Supported values are\012/// CM_HDC_FORMAT_16S and CM_HDC_FORMAT_8U.\012///\012/// \\param destIndex surface ",
"index of the 2D surface the data will be written\012/// to.\012///\012/// \\param x_offset a byte offset into the output surface.\012///\012/// \\param y_offset a row offset into the output surface.\012///\012void cm_va_1d_convolution_hdc(SurfaceIndex surfIndex, SamplerIndex sampIndex,\012                              bool isHdirection, float u, float v,\012                              CM_FORMAT_SIZE size, SurfaceIndex destIndex,\012                              ushort x_offset, ushort y_offset);\012\012#endif // _CLANG_CM_SAMPLER_H_\012\000/*========================== begin_copyright_notice ============================\012\012Copyright (C) 2014-2021 Intel Corporation\012\012SPDX-License-Identifier: MIT\012\012============================= end_copyright_notice ===========================*/\012\012#if (__INCLUDE_LEVEL__ == 1)\012static_assert(0, \"CM:w:cm_send.h should not be included explicitly - only \"\012                 \"<cm/cm.h> is required\");\012#endif\012\012#ifndef _CLANG_CM_SEND_H_\012#define _CLANG_CM_SEND_H_\012\012#include \"cm_common.h\"\012#include \"cm_traits.h\"\012\012/// Access the thread paylo",
"ad register r0.\012template <typename T = void> vector<uint, 8> cm_get_r0();\012\012/// Access the thread status register sr0.\012template <typename T = void> vector<uint, 4> cm_get_sr0();\012\012template <typename T>\012typename std::enable_if<std::is_same<T, SurfaceIndex>::value ||\012                            std::is_same<T, SamplerIndex>::value ||\012                            std::is_same<T, VmeIndex>::value,\012                        uint>::type\012cm_get_value(T index);\012\012uint cm_unmask_begin();\012void cm_unmask_end(uint tmp);\012\012/// \\brief Raw send and split send.\012///\012/// @rspVar the matrix that stores the message response data.\012///\012/// @msgVar the matrix that stores the message payload data.\012///\012/// @msgVar2 the matrix that stores the second part of the message payload data\012/// in a split send (Gen9+).\012///\012/// @exDesc the extended message descriptor, which must be a compile time\012/// constant.\012///\012/// @msgDesc the message descriptor for the send.\012///\012/// @sendc the flag that indicates whether sendc should be used. It must be a\012/// com",
"pile time constant (0 indicates send should be used, while 1 means\012/// sendc).\012///\012template <typename T, int N1, typename U, int N2>\012typename std::enable_if<sizeof(T) * N1 % 32 == 0 &&\012                        sizeof(U) * N2 % 32 == 0>::type\012cm_send(vector_ref<T, N1> rspVar, vector<U, N2> msgVar, uint exDesc,\012        uint msgDesc, uint sendc);\012\012template <typename T, int N1, int N2, typename U, int N3, int N4>\012typename std::enable_if<sizeof(T) * N1 * N2 % 32 == 0 &&\012                        sizeof(U) * N3 * N4 % 32 == 0>::type\012cm_send(matrix_ref<T, N1, N2> rspVar, matrix<U, N3, N4> msgVar, uint exDesc,\012        uint msgDesc, uint sendc);\012\012template <typename T, int N>\012typename std::enable_if<sizeof(T) * N % 32 == 0>::type\012cm_send(int dummy, vector<T, N> msgVar, uint exDesc, uint msgDesc, uint sendc);\012\012template <typename T, int N1, int N2>\012typename std::enable_if<sizeof(T) * N1 * N2 % 32 == 0>::type\012cm_send(int dummy, matrix<T, N1, N2> msgVar, uint exDesc, uint msgDesc,\012        uint sendc);\012\012// Split send.\012template",
" <typename U1, int N1, typename U2, int N2, typename U3, int N3>\012typename std::enable_if<sizeof(U1) * N1 % 32 == 0 &&\012                        sizeof(U2) * N2 % 32 == 0 &&\012                        sizeof(U3) * N3 % 32 == 0>::type\012cm_sends(vector_ref<U1, N1> rspVar, vector<U2, N2> msgVar,\012         vector<U3, N3> msgVar2, uint exDesc, uint msgDesc, uint sendc);\012\012template <typename U1, int N1, int N2, typename U2, int N3, int N4, typename U3,\012          int N5, int N6>\012typename std::enable_if<sizeof(U1) * N1 * N2 % 32 == 0 &&\012                        sizeof(U2) * N3 * N4 % 32 == 0 &&\012                        sizeof(U3) * N5 * N6 % 32 == 0>::type\012cm_sends(matrix_ref<U1, N1, N2> rspVar, matrix<U2, N3, N4> msgVar,\012         matrix<U3, N5, N6> msgVar2, uint exDesc, uint msgDesc, uint sendc);\012\012template <typename U1, int N1, typename U2, int N2>\012typename std::enable_if<sizeof(U1) * N1 % 32 == 0 &&\012                        sizeof(U2) * N2 % 32 == 0>::type\012cm_sends(int dummy, vector<U1, N1> msgVar, vector<U2, N2> msgVar2, uint",
" exDesc,\012         uint msgDesc, uint sendc);\012\012template <typename U1, int N1, int N2, typename U2, int N3, int N4>\012typename std::enable_if<sizeof(U1) * N1 * N2 % 32 == 0 &&\012                        sizeof(U2) * N3 * N4 % 32 == 0>::type\012cm_sends(int dummy, matrix<U1, N1, N2> msgVar, matrix<U2, N3, N4> msgVar2,\012         uint exDesc, uint msgDesc, uint sendc);\012\012template <typename U1, int N1, typename U2, int N2,\012  typename U3, int N3, int N = 16>\012typename std::enable_if<sizeof(U1) * N1 % 32 == 0 &&\012  sizeof(U2) * N2 % 32 == 0 &&\012  sizeof(U3) * N3 % 32 == 0>::type\012  cm_raw_send(vector_ref<U1, N1> rspVar,\012    vector<U2, N2> msgVar,\012    vector<U3, N3> msgVar2,\012    uint exDesc, uint msgDesc,\012    uchar execSize,  uchar sfid,\012    uchar numSrc0, uchar numSrc1, uchar numDst,\012    uchar isEOT = 0, uchar isSendc = 0,\012    vector<ushort, N> mask = 1);\012\012template <typename U1, int N1, int N2, typename U2, int N3,\012  int N4, typename U3, int N5, int N6, int N = 16>\012typename std::enable_if<sizeof(U1) * N1 * N2 % 32 == 0 &&\012  sizeof",
"(U2) * N3 * N4 % 32 == 0 &&\012  sizeof(U3) * N5 * N6 % 32 == 0>::type\012  cm_raw_send(matrix_ref<U1, N1, N2> rspVar,\012    matrix<U2, N3, N4> msgVar,\012    matrix<U3, N5, N6> msgVar2,\012    uint exDesc, uint msgDesc,\012    uchar execSize, uchar sfid,\012    uchar numSrc0, uchar numSrc1, uchar numDst,\012    uchar isEOT = 0, uchar isSendc = 0,\012    vector<ushort, N> mask = 1);\012\012template <typename U2, int N2, typename U3, int N3, int N = 16>\012typename std::enable_if<sizeof(U2) * N2 % 32 == 0 &&\012  sizeof(U3) * N3 % 32 == 0>::type\012  cm_raw_send(\012    int dummyDst,\012    vector<U2, N2> msgVar,\012    vector<U3, N3> msgVar2,\012    uint exDesc, uint msgDesc,\012    uchar execSize, uchar sfid,\012    uchar numSrc0, uchar numSrc1, uchar numDst,\012    uchar isEOT = 0, uchar isSendc = 0,\012    vector<ushort, N> mask = 1);\012\012template <typename U2, int N3, int N4, typename U3,\012  int N5, int N6, int N = 16>\012typename std::enable_if<sizeof(U2) * N3 * N4 % 32 == 0 &&\012  sizeof(U3) * N5 * N6 % 32 == 0>::type\012  cm_raw_send(\012    int dummyDst,\012    matrix<U2, N3, N4> ms",
"gVar,\012    matrix<U3, N5, N6> msgVar2,\012    uint exDesc, uint msgDesc,\012    uchar execSize, uchar sfid,\012    uchar numSrc0, uchar numSrc1, uchar numDst,\012    uchar isEOT = 0, uchar isSendc = 0,\012    vector<ushort, N> mask = 1);\012\012template <typename U1, int N1, typename U2, int N2, int N = 16>\012typename std::enable_if<sizeof(U1) * N1 % 32 == 0 &&\012  sizeof(U2) * N2 % 32 == 0>::type\012  cm_raw_send(vector_ref<U1, N1> rspVar,\012    vector<U2, N2> msgVar,\012    int dummySrc1,\012    uint exDesc, uint msgDesc,\012    uchar execSize, uchar sfid,\012    uchar numSrc0, uchar numSrc1, uchar numDst,\012    uchar isEOT = 0, uchar isSendc = 0,\012    vector<ushort, N> mask = 1);\012\012template <typename U1, int N1, int N2, typename U2, int N3,\012  int N4, int N = 16>\012typename std::enable_if<sizeof(U1) * N1 * N2 % 32 == 0 &&\012  sizeof(U2) * N3 * N4 % 32 == 0>::type\012  cm_raw_send(matrix_ref<U1, N1, N2> rspVar,\012    matrix<U2, N3, N4> msgVar,\012    int dummySrc1,\012    uint exDesc, uint msgDesc,\012    uchar execSize, uchar sfid,\012    uchar numSrc0, uchar numSrc1, uchar",
" numDst,\012    uchar isEOT = 0, uchar isSendc = 0,\012    vector<ushort, N> mask = 1);\012\012template <typename U2, int N2, int N = 16>\012typename std::enable_if<sizeof(U2) * N2 % 32 == 0>::type\012  cm_raw_send(\012    int dummyDst,\012    vector<U2, N2> msgVar,\012    int dummySrc1,\012    uint exDesc, uint msgDesc,\012    uchar execSize, uchar sfid,\012    uchar numSrc0, uchar numSrc1, uchar numDst,\012    uchar isEOT = 0, uchar isSendc = 0,\012    vector<ushort, N> mask = 1);\012\012template <typename U2, int N3, int N4, int N = 16>\012typename std::enable_if<sizeof(U2) * N3 * N4 % 32 == 0>::type\012  cm_raw_send(\012    int dummyDst,\012    matrix<U2, N3, N4> msgVar,\012    int dummySrc1,\012    uint exDesc, uint msgDesc,\012    uchar execSize, uchar sfid,\012    uchar numSrc0, uchar numSrc1, uchar numDst,\012    uchar isEOT = 0, uchar isSendc = 0,\012    vector<ushort, N> mask = 1);\012\012#endif\012\000/*========================== begin_copyright_notice ============================\012\012Copyright (C) 2021 Intel Corporation\012\012SPDX-License-Identifier: MIT\012\012============================= end_copy",
"right_notice ===========================*/\012\012#if (__INCLUDE_LEVEL__ == 1)\012static_assert(\012    0, \"CM:w:cm_spec_constant.h should not be included explicitly - only \"\012       \"<cm/cm.h> is required\");\012#endif\012\012#ifndef _CLANG_CM_SPEC_CONSTANT_H_\012#define _CLANG_CM_SPEC_CONSTANT_H_\012\012// Transforms to OpSpecConstant in SPIR-V\012template <typename T> T __spirv_SpecConstant(uint32_t, T);\012\012/// \\brief Declare a new integer-type scalar specialization constant.\012///\012/// This version supports only integral types.\012///\012/// @param T Specialization constant type.\012///\012/// @param ID Specialization constant id.\012///\012/// @param DefaultValue The specialization constant value if it is not set by\012/// runtime.\012///\012template <typename T, uint32_t ID, T DefaultValue = T{0}>\012CM_NODEBUG CM_INLINE std::enable_if_t<\012    details::is_cm_scalar<T>::value && std::is_integral<T>::value, T>\012cm_spec_constant() {\012  return __spirv_SpecConstant(ID, DefaultValue);\012}\012\012/// \\brief Declare a new floating-point-type scalar specialization constant.\012///\012/// This vers",
"ion supports only floating-point types types. The default\012/// specialization constant value is always zero.\012///\012/// @param T Specialization constant type.\012///\012/// @param ID Specialization constant id.\012///\012template <typename T, uint32_t ID>\012CM_NODEBUG CM_INLINE std::enable_if_t<\012    details::is_cm_scalar<T>::value && std::is_floating_point<T>::value, T>\012cm_spec_constant() {\012  return __spirv_SpecConstant(ID, T{0});\012}\012\012#endif\012\000/*========================== begin_copyright_notice ============================\012\012Copyright (C) 2020-2021 Intel Corporation\012\012SPDX-License-Identifier: MIT\012\012============================= end_copyright_notice ===========================*/\012\012#if (__INCLUDE_LEVEL__ == 1)\012static_assert(0, \"CM:w:cm_srnd.h should not be included explicitly - only \"\012                 \"<cm/cm.h> is required\");\012#endif\012\012#ifndef _CLANG_CM_SRND_H_\012#define _CLANG_CM_SRND_H_\012\012#include \"cm_common.h\"\012#include \"cm_internal.h\"\012#include \"cm_has_instr.h\"\012\012template <typename T0, int N, typename T1>\012CM_NODEBUG CM_INLINE vector<T0, ",
"N> cm_srnd(vector<T1, N> src1,\012                                           vector<T1, N> src2) {\012  CM_HAS_STOCHASTIC_ROUNDING_CONTROL;\012\012  constexpr bool is_hf16_fp32 =\012      details::is_half_type<T0>::value && details::is_float_type<T1>::value;\012  CM_STATIC_ERROR(is_hf16_fp32, \"unsupported srnd type\");\012\012  {\012    vector<T1, N> _Src1 = src1;\012    vector<T1, N> _Src2 = src2;\012    return details::__cm_intrinsic_impl_srnd<T0, N, T1>(_Src1, _Src2);\012  }\012}\012\012#endif // _CLANG_CM_SRND_H_\012\000/*========================== begin_copyright_notice ============================\012\012Copyright (C) 2015-2021 Intel Corporation\012\012SPDX-License-Identifier: MIT\012\012============================= end_copyright_notice ===========================*/\012\012#if (__INCLUDE_LEVEL__ == 1)\012static_assert(0, \"CM:w:cm_svm.h should not be included explicitly - only \"\012                 \"<cm/cm.h> is required\");\012#endif\012\012#ifndef _CLANG_CM_SVM_H\012#define _CLANG_CM_SVM_H\012\012#include \"cm_common.h\"\012#include \"cm_internal.h\"\012\012namespace details {\012template <typename T0, int SZ>\012CM_NO",
"DEBUG CM_INLINE void cm_svm_block_read_impl(uintptr_t addr,\012                                                 vector_ref<T0, SZ> dst) {\012  constexpr unsigned _Sz = sizeof(T0) * SZ;\012  uint64_t _Addr = addr;\012\012  CM_STATIC_ERROR(_Sz >= details::OWORD, \"block size must be at least 1 oword\");\012  CM_STATIC_ERROR(_Sz % details::OWORD == 0,\012                  \"block size must be whole number of owords\");\012  CM_STATIC_ERROR(details::isPowerOf2(_Sz / details::OWORD),\012                  \"block must be 1, 2, 4 or 8 owords long\");\012  CM_STATIC_ERROR(_Sz <= 8 * details::OWORD,\012                  \"block size must be at most 8 owords\");\012  dst = details::__cm_intrinsic_impl_svm_block_read<T0, SZ>(_Addr);\012}\012\012template <typename T0, int SZ>\012CM_NODEBUG CM_INLINE void\012cm_svm_block_read_unaligned_impl(uintptr_t addr, vector_ref<T0, SZ> dst) {\012  constexpr unsigned _Sz = sizeof(T0) * SZ;\012  uint64_t _Addr = addr;\012\012  CM_STATIC_ERROR(_Sz >= details::OWORD, \"block size must be at least 1 oword\");\012  CM_STATIC_ERROR(_Sz % details::OWORD == 0,\012     ",
"             \"block size must be whole number of owords\");\012  CM_STATIC_ERROR(details::isPowerOf2(_Sz / details::OWORD),\012                  \"block must be 1, 2, 4 or 8 owords long\");\012  CM_STATIC_ERROR(_Sz <= 8 * details::OWORD,\012                  \"block size must be at most 8 owords\");\012  dst = details::__cm_intrinsic_impl_svm_block_read_unaligned<T0, SZ>(_Addr);\012}\012\012template <typename T0, int SZ>\012CM_NODEBUG CM_INLINE void cm_svm_block_write_impl(uintptr_t addr,\012                                                  vector<T0, SZ> src) {\012  constexpr unsigned _Sz = sizeof(T0) * SZ;\012  uint64_t _Addr = addr;\012\012  CM_STATIC_ERROR(_Sz >= details::OWORD, \"block size must be at least 1 oword\");\012  CM_STATIC_ERROR(_Sz % details::OWORD == 0,\012                  \"block size must be whole number of owords\");\012  CM_STATIC_ERROR(details::isPowerOf2(_Sz / details::OWORD),\012                  \"block must be 1, 2, 4 or 8 owords long\");\012  CM_STATIC_ERROR(_Sz <= 8 * details::OWORD,\012                  \"block size must be at most 8 owords\");\012\012  de",
"tails::__cm_intrinsic_impl_svm_block_write<T0>(_Addr, src);\012}\012\012} // namespace details\012\012// API for SVM block read and write\012\012// svmptr_t interface.\012template <typename T0, int SZ>\012CM_NODEBUG CM_INLINE void cm_svm_block_read(svmptr_t addr,\012                                            vector_ref<T0, SZ> dst) {\012  details::cm_svm_block_read_impl(uintptr_t(addr), dst);\012}\012\012template <typename T0, int N, int M>\012CM_NODEBUG CM_INLINE void cm_svm_block_read(svmptr_t addr,\012                                            matrix_ref<T0, N, M> dst) {\012  vector<T0, N * M> _Dst;\012  cm_svm_block_read(addr, _Dst);\012  dst = _Dst.format<T0, N, M>();\012}\012\012template <typename T0, int N>\012CM_NODEBUG CM_INLINE void cm_svm_block_read_unaligned(svmptr_t addr,\012                                                      vector_ref<T0, N> dst) {\012  details::cm_svm_block_read_unaligned_impl(uintptr_t(addr), dst);\012}\012\012template <typename T0, int N, int M>\012CM_NODEBUG CM_INLINE void\012cm_svm_block_read_unaligned(svmptr_t addr, matrix_ref<T0, N, M> dst) {\012  vector<T0,",
" N * M> _Dst;\012  cm_svm_block_read_unaligned(addr, _Dst);\012  dst = _Dst.format<T0, N, M>();\012}\012\012template <typename T0, int SZ>\012CM_NODEBUG CM_INLINE void cm_svm_block_write(svmptr_t addr,\012                                             vector<T0, SZ> src) {\012  details::cm_svm_block_write_impl(uintptr_t(addr), src);\012}\012\012template <typename T0, int N, int M>\012CM_NODEBUG CM_INLINE void cm_svm_block_write(svmptr_t addr,\012                                             matrix<T0, N, M> src) {\012  vector<T0, N * M> _Src = src;\012  cm_svm_block_write(addr, _Src);\012}\012\012// pointer interface.\012template <typename T0, int N>\012CM_NODEBUG CM_INLINE void cm_ptr_block_read(const T0 *const addr,\012                                            vector_ref<T0, N> dst) {\012  uintptr_t _Addr = reinterpret_cast<uintptr_t>(addr);\012  details::cm_svm_block_read_impl(_Addr, dst);\012}\012\012template <typename T0, int N, int M>\012CM_NODEBUG CM_INLINE void cm_ptr_block_read(const T0 *const addr,\012                                            matrix_ref<T0, N, M> dst) {\012  vector<T",
"0, N * M> _Dst;\012  cm_svm_block_read(addr, _Dst);\012  dst = _Dst.format<T0, N, M>();\012}\012\012template <typename T0, int N>\012CM_NODEBUG CM_INLINE void\012cm_ptr_block_read_unaligned(const T0 *const addr, vector_ref<T0, N> dst) {\012  uintptr_t _Addr = reinterpret_cast<uintptr_t>(addr);\012  details::cm_svm_block_read_unaligned_impl(_Addr, dst);\012}\012\012template <typename T0, int N, int M>\012CM_NODEBUG CM_INLINE void\012cm_ptr_block_read_unaligned(const T0 *const addr, matrix_ref<T0, N, M> dst) {\012  vector<T0, N * M> _Dst;\012  cm_svm_block_read_unaligned(addr, _Dst);\012  dst = _Dst.format<T0, N, M>();\012}\012\012template <typename T0, int SZ>\012CM_NODEBUG CM_INLINE void cm_ptr_block_write(T0 *const addr,\012                                             vector<T0, SZ> src) {\012  uintptr_t _Addr = reinterpret_cast<uintptr_t>(addr);\012  details::cm_svm_block_write_impl(_Addr, src);\012}\012\012template <typename T0, int N, int M>\012CM_NODEBUG CM_INLINE void cm_ptr_block_write(T0 *const addr,\012                                             matrix<T0, N, M> src) {\012  vector<T0, N ",
"* M> _Src = src;\012  cm_svm_block_write(addr, _Src);\012}\012\012namespace details {\012\012template <typename T0, int N>\012CM_NODEBUG CM_INLINE\012typename std::enable_if<details::isPowerOf2(N, 32), void>::type\012cm_svm_scatter_read_impl(vector<uintptr_t, N> vAddr, vector_ref<T0, N> dst) {\012  vector<uint64_t, N> _VAddr64(vAddr);\012  if constexpr(sizeof(T0) == 1) {\012    vector<T0, N*4> _Ret;\012    _Ret =\012      details::__cm_intrinsic_impl_svm_scatter_read<T0,N,4>(_VAddr64, _Ret);\012    dst = _Ret.select<N, 4>(0);\012  }\012  else if constexpr(sizeof(T0) == 2) {\012    vector<T0, N*2> _Ret;\012    _Ret =\012      details::__cm_intrinsic_impl_svm_scatter_read<T0,N,2>(_VAddr64, _Ret);\012    dst = _Ret.select<N, 2>(0);\012  }\012  else {\012    vector<T0, N> _Ret;\012    _Ret =\012      details::__cm_intrinsic_impl_svm_scatter_read<T0,N,1>(_VAddr64, _Ret);\012    dst = _Ret;\012  }\012}\012\012template <typename T0, int N>\012CM_NODEBUG CM_INLINE\012typename std::enable_if<details::isPowerOf2(N, 32), void>::type\012cm_svm_scatter_write_impl(vector<uintptr_t, N> vAddr, vector<T0, N> src) {\012  vector<u",
"int64_t, N> _VAddr64(vAddr);\012  if constexpr(sizeof(T0) == 1) {\012    vector<T0, N*4> _Data;\012    _Data.select<N, 4>(0) = src;\012    details::__cm_intrinsic_impl_svm_scatter_write<T0, N, 4>(_VAddr64, _Data);\012  }\012  else if constexpr(sizeof(T0) == 2) {\012    vector<T0, N*2> _Data;\012    _Data.select<N, 2>(0) = src;\012    details::__cm_intrinsic_impl_svm_scatter_write<T0, N, 2>(_VAddr64, _Data);\012  }\012  else\012    details::__cm_intrinsic_impl_svm_scatter_write<T0, N, 1>(_VAddr64, src);\012}\012\012} // namespace details\012\012// API for SVM scatter read and write\012\012// svmptr_t interface.\012template <typename T0, int N>\012CM_NODEBUG CM_INLINE void cm_svm_scatter_read(vector<svmptr_t, N> vAddr,\012                                              vector_ref<T0, N> dst) {\012  details::cm_svm_scatter_read_impl(vector<uintptr_t, N>(vAddr), dst);\012}\012\012template <typename T0, int N, int M>\012CM_NODEBUG CM_INLINE void cm_svm_scatter_read(matrix<svmptr_t, N, M> vAddr,\012                                              matrix_ref<T0, N, M> dst) {\012  vector<svmptr_t, N * M> _V",
"Addr = vAddr;\012  vector<T0, N * M> _Ret;\012  cm_svm_scatter_read(_VAddr, _Ret);\012  dst = _Ret.format<T0, N, M>();\012}\012\012template <typename T0, int N>\012CM_NODEBUG CM_INLINE void cm_svm_scatter_write(vector<svmptr_t, N> vAddr,\012                                               vector<T0, N> src) {\012  details::cm_svm_scatter_write_impl(vector<uintptr_t, N>(vAddr), src);\012}\012\012template <typename T0, int N, int M>\012CM_NODEBUG CM_INLINE void cm_svm_scatter_write(matrix<svmptr_t, N, M> vAddr,\012                                               matrix<T0, N, M> src) {\012  vector<svmptr_t, N * M> _VAddr = vAddr;\012  vector<T0, N * M> _Src = src;\012  cm_svm_scatter_write(_VAddr, _Src);\012}\012\012// pointer interface.\012template <typename T0, int N>\012CM_NODEBUG CM_INLINE void cm_ptr_scatter_read(const T0 * const p,\012                                              vector<ptrdiff_t, N> offset,\012                                              vector_ref<T0, N> dst) {\012  uintptr_t base = reinterpret_cast<uintptr_t>(p);\012  vector<uintptr_t, N> vAddr = base + offset;\012  d",
"etails::cm_svm_scatter_read_impl(vAddr, dst);\012}\012\012template <typename T0, int N, int M>\012CM_NODEBUG CM_INLINE void cm_ptr_scatter_read(const T0 * const p,\012                                              matrix<ptrdiff_t, N, M> offset,\012                                              matrix_ref<T0, N, M> dst) {\012  vector<ptrdiff_t, N * M> _Offset = offset;\012  vector<T0, N * M> _Ret;\012  cm_svm_scatter_read(p, _Offset, _Ret);\012  dst = _Ret.format<T0, N, M>();\012}\012\012template <typename T0, int N>\012CM_NODEBUG CM_INLINE void cm_ptr_scatter_write(T0 const *p,\012                                               vector<ptrdiff_t, N> offset,\012                                               vector<T0, N> src) {\012  uintptr_t base = reinterpret_cast<uintptr_t>(p);\012  vector<uintptr_t, N> vAddr = base + offset;\012  details::cm_svm_scatter_write_impl(vAddr, src);\012}\012\012template <typename T0, int N, int M>\012CM_NODEBUG CM_INLINE void cm_ptr_scatter_write(T0 *const p,\012                                               matrix<ptrdiff_t, N, M> offset,\012            ",
"                                   matrix<T0, N, M> src) {\012  vector<ptrdiff_t, N * M> _Offset = offset;\012  vector<T0, N * M> _Src = src;\012  cm_svm_scatter_write(p, _Offset, _Src);\012}\012\012/// \\brief ptr-base svm or stateless memmory read4.\012///\012/// Read 8, 16, or 32 4-element vectors, say {R,G,B,A}, where each element is\012/// of size dword also referred to as a channel. The elements read from mem are\012/// written back to the vector ::vDst and organized channel-wise, i.e. all R's\012/// followed by all G's, and so on. Offset of each 4-element vector \012/// must be specified in ::vOffset. Note that the offsets are byte-based.\012/// One or more channels in the 4-element vector could be masked, and\012/// ::vDst contains only the unmasked elements. Only the lower 4 bits of\012/// ::mask specify the elements masked. A '1' implies that the corresponding \012/// element of each vector will not be read from memory.\012/// e.g. if mask = BR_ENABLE, ::vDst would contain\012/// B7B6B5B4B3B2B1B0\012/// R7R6R5R4R3R2R1R0\012/// where the data elements correspo",
"nd to the 8 vectors\012/// (x B7 x R7), (x B6 x R6),... (x B0 x R0) read from memory at the offsets \012/// specified in ::vOffset, where 'x' means the value is not read.\012///\012/// ::M must equal ::N * C where C is the number of channels enabled in ::mask.\012/// note: 32 may not hardware native.\012///\012template <typename T, int N, int M>\012typename std::enable_if<(N == 8 || N == 16 || N == 32) && (sizeof(T) == 4)>::type\012cm_ptr_read4(const T* const ptr, vector<ptrdiff_t, N> vOffset,\012             vector_ref<T, M> vDst,\012             ChannelMaskType mask);\012\012/// \\brief pointer-based SVM or stateless memory write.\012///\012/// Write 8, 16, or 32 4-element vectors, say {R,G,B,A}, where each element is\012/// of size dword and is also referred to as a channel. The elements to be \012/// written must be in the vector ::vSrc and organized channel-wise,\012/// i.e. all R's followed by all G's, and so on. Offset of each 4-element \012/// vector must be specified in ::vOffset. Note that the offsets are in bytes.\012/// One or more channels in the 4-element",
" vector could be masked, and \012/// ::vSrc must contain only the unmasked or enabled elements. The argument\012/// ::mask specifies the channels that are enabled. Only the enabled channels\012/// are written to memory. E.g. if mask = BR_ENABLE\012/// (i.e. only R and B channels enabled), and vSrc is\012/// B7B6B5B4B3B2B1B0\012/// R7R6R5R4R3R2R1R0\012/// 8 vectors written to memory are as\012/// (x B7 x R7), (x B6 x R6), ... (x B0 x R0)\012/// where 'x' means the value is not written.\012///\012/// M must equal N * C where C is the number of channels enabled in ::mask. T\012/// must be of size dword (int, uint, or float). ::mask specifies\012/// the channels that are enabled it has to be a compile-time constant of the\012/// enum type ChannelMaskType.\012template <typename T, int N, int M>\012typename std::enable_if<(N == 8 || N == 16 || N == 32) && (sizeof(T) == 4)>::type\012cm_ptr_write4(T* ptr, vector<ptrdiff_t, N> vOffset, vector<T, M> vSrc,\012              ChannelMaskType mask);\012\012// svmptr_t interface\012template <typename T0, int SZ>\012void cm_svm_atomic(CmAto",
"micOpType op, vector<svmptr_t, SZ> vAddr,\012                   vector_ref<T0, SZ> dst, vector<T0, SZ> src0,\012                   vector<T0, SZ> src1);\012\012template <typename T0, int N, int M>\012void cm_svm_atomic(CmAtomicOpType op, matrix<svmptr_t, N, M> vAddr,\012                   matrix_ref<T0, N, M> dst, matrix<T0, N, M> src0,\012                   matrix<T0, N, M> src1);\012\012template <typename T0, int SZ>\012void cm_svm_atomic(CmAtomicOpType op, vector<svmptr_t, SZ> vAddr,\012                   vector_ref<T0, SZ> dst, vector<T0, SZ> src0);\012\012template <typename T0, int N, int M>\012void cm_svm_atomic(CmAtomicOpType op, matrix<svmptr_t, N, M> vAddr,\012                   matrix_ref<T0, N, M> dst, matrix<T0, N, M> src0);\012\012template <typename T0, int SZ>\012void cm_svm_atomic(CmAtomicOpType op, vector<svmptr_t, SZ> vAddr,\012                   vector_ref<T0, SZ> dst);\012\012template <typename T0, int N, int M>\012void cm_svm_atomic(CmAtomicOpType op, matrix<svmptr_t, N, M> vAddr,\012                   matrix_ref<T0, N, M> dst);\012\012namespace details {\012\012templa",
"te <CmAtomicOpType Op, typename T, int N, unsigned NumSrc>\012constexpr bool checkSVMAtomic() {\012  if constexpr (!details::isPowerOf2(N, 32)) {\012    CM_STATIC_ERROR((details::isPowerOf2(N, 32)),\012                    \"Execution size 1, 2, 4, 8, 16, 32 are supported\");\012    return false;\012  }\012\012  // No source operand.\012  if constexpr (Op == ATOMIC_INC || Op == ATOMIC_DEC) {\012    if constexpr (NumSrc != 0) {\012      CM_STATIC_ERROR(NumSrc == 0, \"No source operands are expected\");\012      return false;\012    }\012    if constexpr (details::is_type<T, uint16_t, uint32_t, uint64_t>()) {\012      CM_STATIC_ERROR((details::is_type<T, uint16_t, uint32_t, uint64_t>()),\012                      \"Type UW, UD or UQ is expected\");\012      return false;\012    }\012    return true;\012  }\012\012  // One source integer operand.\012  if constexpr (Op == ATOMIC_ADD || Op == ATOMIC_SUB || Op == ATOMIC_MIN ||\012                Op == ATOMIC_MAX || Op == ATOMIC_XCHG || Op == ATOMIC_AND ||\012                Op == ATOMIC_OR || Op == ATOMIC_XOR || Op == ATOMIC_MINSINT ||\012          ",
"      Op == ATOMIC_MAXSINT) {\012    if constexpr (NumSrc != 1) {\012      CM_STATIC_ERROR(NumSrc == 1, \"One source operand is expected\");\012      return false;\012    }\012    if constexpr ((Op != ATOMIC_MINSINT && Op != ATOMIC_MAXSINT) &&\012                  !details::is_type<T, uint16_t, uint32_t, uint64_t>()) {\012      CM_STATIC_ERROR((details::is_type<T, uint16_t, uint32_t, uint64_t>()),\012                      \"Type UW, UD or UQ is expected\");\012      return false;\012    }\012    if constexpr ((Op == ATOMIC_MINSINT || Op == ATOMIC_MAXSINT) &&\012                  !details::is_type<T, int16_t, int32_t, int64_t>()) {\012      CM_STATIC_ERROR((details::is_type<T, int16_t, int32_t, int64_t>()),\012                      \"Type W, D or Q is expected\");\012      return false;\012    }\012    return true;\012  }\012\012  // One source float operand.\012  if constexpr (Op == ATOMIC_FMAX || Op == ATOMIC_FMIN || Op == ATOMIC_FADD ||\012                Op == ATOMIC_FSUB) {\012    if constexpr (NumSrc != 1) {\012      CM_STATIC_ERROR(NumSrc == 1, \"One source operand is expected\");\012",
"      return false;\012    }\012    if constexpr (!details::is_type<T, float, half>()) {\012      CM_STATIC_ERROR((details::is_type<T, float, half>()),\012                      \"Type F or HF is expected\");\012      return false;\012    }\012    return true;\012  }\012\012  // Two scouce operands.\012  if constexpr (Op == ATOMIC_CMPXCHG || Op == ATOMIC_FCMPWR) {\012    if constexpr (NumSrc != 2) {\012      CM_STATIC_ERROR(NumSrc == 2, \"Two source operands are expected\");\012      return false;\012    }\012    if constexpr (Op == ATOMIC_CMPXCHG &&\012                  !details::is_type<T, uint16_t, uint32_t, uint64_t>()) {\012      CM_STATIC_ERROR((details::is_type<T, uint16_t, uint32_t, uint64_t>()),\012                      \"Type UW, UD or UQ is expected\");\012      return false;\012    }\012    if constexpr (Op == ATOMIC_FCMPWR && !details::is_type<T, float, half>()) {\012      CM_STATIC_ERROR((details::is_type<T, float, half>()),\012                      \"Type F or HF is expected\");\012      return false;\012    }\012    return true;\012  }\012\012  // Unsupported svm atomic Op.\012  return false;\012",
"}\012\012} // namespace details\012\012// pointer interface\012template <CmAtomicOpType Op, typename T, int N, typename U>\012CM_NODEBUG CM_INLINE\012typename std::enable_if<details::checkSVMAtomic<Op, T, N, 0>(), void>::type\012cm_ptr_atomic(T *const p, vector<U, N> offset, vector_ref<T, N> dst) {\012  uintptr_t base = reinterpret_cast<uintptr_t>(p);\012  vector<uintptr_t, N> vAddr = base + offset;\012  dst = details::__cm_intrinsic_impl_svm_atomic<Op, T, N>(vAddr, dst);\012}\012\012template <CmAtomicOpType Op, typename T, int N, int M, typename U>\012CM_NODEBUG CM_INLINE\012typename std::enable_if<details::checkSVMAtomic<Op, T, N * M, 0>(), void>::type\012cm_ptr_atomic(T *const p, matrix<U, N, M> offset, matrix_ref<T, N, M> dst) {\012  vector<U, N * M> _Offset = offset;\012  vector_ref<T, N * M> _Dst = dst.format<T>();\012  cm_svm_atomic<Op>(p, _Offset, _Dst);\012}\012\012template <CmAtomicOpType Op, typename T, int N, typename U>\012CM_NODEBUG CM_INLINE\012typename std::enable_if<details::checkSVMAtomic<Op, T, N, 1>(), void>::type\012cm_ptr_atomic(T *const p, vector<U, N> offset, ve",
"ctor_ref<T, N> dst,\012           vector<T, N> src0) {\012  uintptr_t base = reinterpret_cast<uintptr_t>(p);\012  vector<uintptr_t, N> vAddr = base + offset;\012  dst = details::__cm_intrinsic_impl_svm_atomic<Op, T, N>(vAddr, src0, dst);\012}\012\012template <CmAtomicOpType Op, typename T, int N, int M, typename U>\012CM_NODEBUG CM_INLINE\012typename std::enable_if<details::checkSVMAtomic<Op, T, N * M, 1>(), void>::type\012cm_ptr_atomic(T *const p, matrix<U, N, M> offset, matrix_ref<T, N, M> dst,\012           matrix<T, N, M> src0) {\012  vector<U, N * M> _Offset = offset;\012  vector_ref<T, N * M> _Dst = dst.format<T>();\012  vector<T, N * M> _Src0 = src0;\012  cm_svm_atomic<Op>(p, _Offset, _Dst, _Src0);\012}\012\012template <CmAtomicOpType Op, typename T, int N, typename U>\012CM_NODEBUG CM_INLINE\012typename std::enable_if<details::checkSVMAtomic<Op, T, N, 2>(), void>::type\012cm_ptr_atomic(T *const p, vector<U, N> offset, vector_ref<T, N> dst,\012           vector<T, N> src0, vector<T, N> src1) {\012  uintptr_t base = reinterpret_cast<uintptr_t>(p);\012  vector<uintptr_t, N> ",
"vAddr = base + offset;\012  dst = details::__cm_intrinsic_impl_svm_atomic<Op, T, N>(vAddr, src0, src1, dst);\012}\012\012template <CmAtomicOpType Op, typename T, int N, int M, typename U>\012CM_NODEBUG CM_INLINE\012typename std::enable_if<details::checkSVMAtomic<Op, T, N * M, 2>(), void>::type\012cm_ptr_atomic(T *const p, matrix<U, N, M> offset, matrix_ref<T, N, M> dst,\012           matrix<T, N, M> src0, matrix<T, N, M> src1) {\012  vector<U, N * M> _Offset = offset;\012  vector_ref<T, N * M> _Dst = dst.format<T>();\012  vector<T, N * M> _Src0 = src0;\012  vector<T, N * M> _Src1 = src1;\012  cm_svm_atomic<Op>(p, _Offset, _Dst, _Src0, _Src1);\012}\012\012// svmptr interface\012template <CmAtomicOpType Op, typename T, int N>\012CM_NODEBUG CM_INLINE\012typename std::enable_if<details::checkSVMAtomic<Op, T, N, 0>(), void>::type\012svm_atomic(vector<svmptr_t, N> vAddr, vector_ref<T, N> dst) {\012  dst = details::__cm_intrinsic_impl_svm_atomic<Op, T, N>(vAddr, dst);\012}\012\012template <CmAtomicOpType Op, typename T, int N, int M>\012CM_NODEBUG CM_INLINE\012typename std::enable_if<details:",
":checkSVMAtomic<Op, T, N * M, 0>(), void>::type\012svm_atomic(matrix<svmptr_t, N, M> vAddr, matrix_ref<T, N, M> dst) {\012  vector<svmptr_t, N * M> _VAddr = vAddr;\012  vector_ref<T, N * M> _Dst = dst.format<T>();\012  svm_atomic<Op, T, N * M>(_VAddr, _Dst);\012}\012\012template <CmAtomicOpType Op, typename T, int N>\012CM_NODEBUG CM_INLINE\012typename std::enable_if<details::checkSVMAtomic<Op, T, N, 1>(), void>::type\012svm_atomic(vector<svmptr_t, N> vAddr, vector_ref<T, N> dst, vector<T, N> src0) {\012  dst = details::__cm_intrinsic_impl_svm_atomic<Op, T, N>(vAddr, src0, dst);\012}\012\012template <CmAtomicOpType Op, typename T, int N, int M>\012CM_NODEBUG CM_INLINE\012typename std::enable_if<details::checkSVMAtomic<Op, T, N * M, 1>(), void>::type\012svm_atomic(matrix<svmptr_t, N, M> vAddr, matrix_ref<T, N, M> dst,\012           matrix<T, N, M> src0) {\012  vector<svmptr_t, N * M> _VAddr = vAddr;\012  vector_ref<T, N * M> _Dst = dst.format<T>();\012  vector<T, N * M> _Src0 = src0;\012  svm_atomic<Op, T, N * M>(_VAddr, _Dst, _Src0);\012}\012\012template <CmAtomicOpType Op, typename",
" T, int N>\012CM_NODEBUG CM_INLINE\012typename std::enable_if<details::checkSVMAtomic<Op, T, N, 2>(), void>::type\012svm_atomic(vector<svmptr_t, N> vAddr, vector_ref<T, N> dst, vector<T, N> src0,\012           vector<T, N> src1) {\012  dst = details::__cm_intrinsic_impl_svm_atomic<Op, T, N>(vAddr, src0, src1, dst);\012}\012\012template <CmAtomicOpType Op, typename T, int N, int M>\012CM_NODEBUG CM_INLINE\012typename std::enable_if<details::checkSVMAtomic<Op, T, N * M, 2>(), void>::type\012svm_atomic(matrix<svmptr_t, N, M> vAddr, matrix_ref<T, N, M> dst,\012           matrix<T, N, M> src0, matrix<T, N, M> src1) {\012  vector<svmptr_t, N * M> _VAddr = vAddr;\012  vector_ref<T, N * M> _Dst = dst.format<T>();\012  vector<T, N * M> _Src0 = src0;\012  vector<T, N * M> _Src1 = src1;\012  svm_atomic<Op, T, N * M>(_VAddr, _Dst, _Src0, _Src1);\012}\012\012#endif /* _CLANG_CM_SVM_H */\012\000/*========================== begin_copyright_notice ============================\012\012Copyright (C) 2016-2021 Intel Corporation\012\012SPDX-License-Identifier: MIT\012\012============================= end_copyrig",
"ht_notice ===========================*/\012\012#if (__INCLUDE_LEVEL__ == 1)\012static_assert(0, \"CM:w:cm_target.h should not be included explicitly - only \"\012                 \"<cm/cm.h> is required\");\012#endif //(__INCLUDE_LEVEL__ == 1)\012\012#ifndef _CLANG_CM_TARGET_H_\012#define _CLANG_CM_TARGET_H_\012\012#if (CM_GENX >= 900 && CM_GENX <= 1150)\012  #define CM_HAS_VA 1\012#endif //(CM_GENX >= 900 && CM_GENX <= 1150)\012\012#if (CM_GENX >= 900 && CM_GENX <= 1150)\012  #define CM_HAS_VA_PLUS 1\012#endif //(CM_GENX >= 900 && CM_GENX <= 1150)\012\012#if !(CM_GENX == 1280 && CM_GENX_REVID <= 2) //PVC\012#define CM_HAS_LSC_NON_TRANSPOSE_MESSAGES_WITH_NON_DEFAULT_SIMT\012#endif // !(CM_GENX == 1280 && CM_GENX_REVID <= 2)\012\012// On PVC non-transpose LSC messages have SIMD32 layout\012// So 16-channels non-transposed lsc messages with VectorSze != 1\012// aren't supported on PVC\012#if !defined(CM_HAS_LSC_NON_TRANSPOSE_MESSAGES_WITH_NON_DEFAULT_SIMT)\012#define CM_HAS_LSC_NON_TRANSPOSE_MESSAGES_WITH_NON_DEFAULT_SIMT_CONTROL(N, VS) \\\012  CM_STATIC_ERROR(                                   ",
"                          \\\012      N == details::lsc_default_simt() || VS == VectorSize::N1,                \\\012      \"unexpected number of channels for non-transpose lsc message\");\012#else\012#define CM_HAS_LSC_NON_TRANSPOSE_MESSAGES_WITH_NON_DEFAULT_SIMT_CONTROL(N, VS)\012#endif //!defined(CM_HAS_LSC_NON_TRANSPOSE_MESSAGES_WITH_NON_DEFAULT_SIMT)\012\012// Make Gen target specific warnings into errors\012#pragma clang diagnostic error \"-Wgen-target\"\012\012#endif /* _CLANG_CM_TARGET_H_ */\012\000/*========================== begin_copyright_notice ============================\012\012Copyright (C) 2020-2021 Intel Corporation\012\012SPDX-License-Identifier: MIT\012\012============================= end_copyright_notice ===========================*/\012\012#ifndef CM_CMTL_GLOBAL_H\012#define CM_CMTL_GLOBAL_H\012\012#include \"../cm_common.h\"\012\012namespace cmtl {\012namespace global {\012\012/* This function loads elements of c-array \\p global with offsets from \\p offset\012 * and returns loaded value in a vector.\012 *\012 * Arguments:\012 *  \\p global - pointer to first element of a global c-array of",
" T elements.\012 *  \\p offset - vector of offsets in number of elements.\012 *\012 * If \\p global doesn't point to a global c-array T[], behavior is undefined.\012 * If \\p global doesn't have element with provided offset, behavior is undefined.\012 *\012 * Usage example:\012 *  // in global scope\012 *  const int data[] = {42, 41, 40, 39, 38, 37, 36, 35};\012 *  const int offset_init[] = {0, 7, 3, 4};\012 *\012 *  // in a kernel\012 *  vector<int, 4> offset (offset_init);\012 *  vector<int, 4> result = global::load(data, offset);\012 *  // result == {42, 35, 39, 38}\012 * End of example.\012 */\012template<typename T, int Width, int N>\012CM_INLINE vector<T, Width> load(const T (&global)[N], vector<int, Width> offset) {\012  vector<T, Width> res;\012#pragma unroll\012  for (int i = 0; i < Width; ++i)\012    res[i] = global[offset(i)];\012  return res;\012}\012\012} // namespace global\012} // namespace cmtl\012\012#endif // CM_CMTL_GLOBAL_H\012\000/*========================== begin_copyright_notice ============================\012\012Copyright (C) 2014-2021 Intel Corporation\012\012SPDX-License-Identifier: MIT\012\012",
"============================= end_copyright_notice ===========================*/\012\012/* -----------------------------------------------------------------------------\012 *\012 *  Authors:              Somnath Ghosh, Dori Eldar, David Stuttard\012 *\012 *  Description:\012 *     A selection of template functions designed to provide optimized\012 *     functions for use in CM.\012 *     These functions use optimized code idioms that have been found to provide\012 *     the optimal performance on GenX for the desired functionality in much the\012 *     same way as intrinsic functions\012 * ---------------------------------------------------------------------------*/\012\012/* Make this file idempotent - use pragma and standard macro guards in case\012 * pragma not recognised */\012#pragma once\012#ifndef _CMTL_H_\012#define _CMTL_H_\012\012#include <cm/cm.h>\012\012#pragma clang diagnostic push\012#pragma clang diagnostic ignored \"-Wcm-bounds-check\"\012\012// Debug support\012#ifdef CMRT_EMU\012CM_INLINE void  cm_assert(bool x)\012{\012    assert(x);\012}\012#else\012#define cm_assert(x)\012#endif\012\012// All ",
"the CM template library (cmtl) is enclosed in the cmtl namespace\012namespace cmtl {\012/* ---------------------------------------------------------------------------*/\012/* ------------------------- API Definition\012 * -----------------------------------------------------*/\012/* ---------------------------------------------------------------------------*/\012\012/* ------------------------- I/O Routines\012 * -------------------------------------------------------*/\012\012// A read function with a fix for the border-duplication issue. This issue means\012// that when reading a matrix which extends beyond the surface boundary,\012// duplication-to-the-right doesn't work as expected for surfaces whose width\012// isn't d-word aligned (i.e., a multiple of 4). Vertical duplication (above and\012// below) and duplication-to-the-left do work as expected and are not handled by\012// this function.\012// This function is used internally and is not expected to be used by the end\012// user\012//\012// Parameters:\012//   MAT_TYPE:\012//      A type whose size is the same as ",
"the size of a single surface pixel.\012//      Example surface types and MAT_TYPE values:\012//          CM_SURFACE_FORMAT_A8:       char\012//          CM_SURFACE_FORMAT_V8U8:     short\012//          CM_SURFACE_FORMAT_A8R8G8B8: int\012//   buf_id:\012//      Surface index.\012//   x_pos_bytes:\012//      X coordinate of position from which to start reading surface, in\012//      *bytes*.\012//   y_pos_bytes:\012//      Y coordinate of position from which to start reading surface, in\012//      *bytes*.\012//   in:\012//      Matrix to fill with values from surface (or duplicated values when asked\012//      to read beyond the surface's edge).\012//   surface_width_pixels:\012//      Surface width in *pixels*. The surface width in bytes will be deduced\012//      by multiplying this with sizeof(SUFF_TYPE).\012template <typename MAT_TYPE, int R, int C>\012void _Read4Borders(SurfaceIndex buf_id, int x_pos_bytes, int y_pos_bytes,\012                   matrix_ref<MAT_TYPE, R, C> in, int surface_width_pixels);\012\012template <typename MAT_TYPE, int R, int C>\012void _Read4Borders(Su",
"rfaceIndex buf_id, int x_pos_bytes, int y_pos_bytes,\012                   matrix<MAT_TYPE, R, C> in, int surface_width_pixels);\012\012#ifndef INLINE_READ\012template <typename MAT_TYPE, int R, int C>\012void Boundaries(SurfaceIndex buf_id, int x_pos_bytes, int y_pos_bytes,\012                matrix_ref<MAT_TYPE, R, C> in, int surface_width_pixels,\012                int surface_width_bytes);\012#endif\012\012// Read a pixel block of size HEIGHT x WIDTH  from surface, all input are in\012// pixel sizes. HEIGHT and WIDTH can be any integer\012// Note: to enable efficient IO segmentation set the following define (default\012// is disabled due\012// to CM Compiler bug when using multiple select)\012//\012// #define IOBLOCK_ENABLE_MULTI_STRIDE\012//\012// Parameters:\012// h_pix_pos    - horizontal offset in pixel size\012// v_pix_pos    - vertical offset in pixel size\012// matrix_ref   - ref to output matrix\012// surfaceWidth - surface width  in pixel size, when set ReadBlock will properly\012// pixels across\012//                right hand side boundary, for non-dword aligned su",
"rfaces)\012template <typename T, int HEIGHT, int WIDTH>\012void ReadBlock(SurfaceIndex obuf, int h_pix_pos, int v_pix_pos,\012               matrix_ref<T, HEIGHT, WIDTH> block, uint surfaceWidth = 0);\012\012template <typename T, int HEIGHT, int WIDTH>\012void ReadBlock(SurfaceIndex obuf, CmBufferAttrib buf_attrib, int h_pos,\012               int v_pos, matrix_ref<T, HEIGHT, WIDTH> block,\012               uint surfaceWidth = 0);\012\012// Write a pixel block of size HEIGHT x WIDTH from surface, all inputs are in\012// pixel sizes. HEIGHT and WIDTH can be any integer\012// Note: to enable efficient IO segmentation set the following define (default\012// is disabled due to CM Compiler bug when using multiple select)\012//\012// #define IOBLOCK_ENABLE_MULTI_STRIDE\012//\012// Parameters:\012// h_pix_pos - horizontal offset in pixel size\012// v_pix_pos - vertical offset in pixel size\012template <typename T, int HEIGHT, int WIDTH>\012void WriteBlock(SurfaceIndex obuf, int h_pix_pos, int v_pix_pos,\012                matrix_ref<T, HEIGHT, WIDTH> block);\012\012/* Read a pixel vecto",
"r of size WIDTH from linear buffer, all inputs are in pixel\012   sizes. WIDTH can be any integer\012   h_pix_pos - horizontal offset in pixel size\012*/\012template <typename T, int WIDTH>\012void ReadLinear(SurfaceIndex ibuf, int pix_pos, vector_ref<T, WIDTH> block);\012\012/* Write a pixel vector of size WIDTH to linear buffer, all inputs are in pixel\012   sizes. WIDTH can be any integer\012   h_pix_pos - horizontal offset in pixel size\012*/\012template <typename T, int WIDTH>\012void WriteLinear(SurfaceIndex obuf, int pix_pos, vector_ref<T, WIDTH> block);\012\012/* ------------------------- Vectorization Routines\012 * ---------------------------------------------*/\012\012/* Creates a nighborhood matrix of a 2D Kernel, whereby for each pixel in src,\012   nighbor (i,j) is\012   located at row(_2D2_1D<KRNL_SZ>(i,j)) \"above it\".\012   Useful to ensure register alignment irrespective of pixel offset (since we\012   create copies for every offset),\012   src - matrix representing pixel line and rows above / below it that fit into\012   the kernel\012   dst - output matrix incl",
"uding vectorized kernel nighborhood.\012*/\012template <typename Tsrc, typename Tdst, uint KRNL_SZ, uint SIMD_SZ>\012void Vectorize2DKRNL(matrix_ref<Tsrc, KRNL_SZ, SIMD_SZ + KRNL_SZ - 1> src,\012                     matrix_ref<Tdst, KRNL_SZ *KRNL_SZ, SIMD_SZ> dst);\012\012/* updatea a single \"row\" into a vectorized kernel segment of KRNL_SZ rows\012   src - input vector for update\012   dstRow the row segment to update in dst\012*/\012template <typename Tsrc, typename Tdst, uint KRNL_SZ, uint SIMD_SZ>\012void Vectorize2DKRNLRow(vector_ref<Tsrc, SIMD_SZ + KRNL_SZ - 1> src,\012                        matrix_ref<Tdst, KRNL_SZ *KRNL_SZ, SIMD_SZ> dst,\012                        int dstRow);\012\012/* translates a matrix representation into vector represnetaiton, use when\012   accessing elements in a\012   vectorized kernel\012*/\012template <uint KRNL_SZ> int _2Dto1D(uint x, uint y);\012\012/* ------------------------- SLM Routines\012 * -------------------------------------------------------*/\012\012/* Dump content of SLM to memory\012   slmX - SLM handle\012   slmDebugSurface -  linear ",
"surface to dump to\012   size  - number of bytes to dump\012*/\012void DumpSLM(uint slmX, SurfaceIndex slmDebugSurface, uint size);\012\012// TODO add API description\012template <int N>\012void TransposeFromSLM(vector_ref<uint, N * 4> dst, vector_ref<uint, N * 4> src);\012\012// TODO add API description\012template <int N>\012void TransposeToSLM(vector_ref<uint, N * 4> dst, vector_ref<uint, N * 4> src);\012\012/* ------------------------- iselect Routines\012 * -------------------------------------------------------*/\012\012/* The following templates can be used to pack t2 \"small\" data elements into 1\012   \"large\" data element\012   useful when need to track multiple matrix/vectors through iselect. since\012   iselect is SIMD-1 for LHS\012   e.g. instead of:\012    vector<short, SZ> src1, src2;\012    matrix<short, SZ> dst1, dst2;\012    dst1.iselect(x,y) = src1;  //SZ SIMD-1 operation + 2 ops to calc x,y coord\012    dst2.iselect(x,y) = src2   //SZ SIMD-1 operation + 2 ops to calc x,y coord\012\012   use:\012    vector<short, SZ> src1, src2;\012    vector<uint, SZ> dst;\012    matrix<uint, ",
"SOME_SIZE, SZ> data;\012    Pack<short, uint, SZ>(src1,src2, src); // ~3-4 SIMD-SZ ops\012    dst.iselect<uint, SZ>(x,y) = src; //SZ SIMD-1 ops + 2 ops to cal x,y coord\012*/\012\012/* unpack 2 \"small elements\" from 1 larger element\012   Note: order of elements must match between Pack and Unpack calls\012   parameters:\012   dst1, dst2, packed elements\012   src - source element to retrieve the data from\012*/\012template <typename Tpackd, typename Tcompst, int WD>\012void Unpack(vector_ref<Tpackd, WD> dst1, vector_ref<Tpackd, WD> dst2,\012            vector_ref<Tcompst, WD> src);\012\012#define CMRT_LOC_FIRST 0\012#define CMRT_LOC_SECOND 1\012\012/* unpacks  a single \"small\" element from 1 larger element\012   Note: Use CMRT_LOC_FIRST/CMRT_LOC_SECOND defines to specify which element to\012   return\012   dst, packed elements\012   location: Use CMRT_LOC_FIRST/CMRT_LOC_SECOND to specify which element to\012   return\012   src - source element to retrieve the data from\012*/\012\012template <typename Tpackd, typename Tcompst, int WD>\012void UnpackSingle(vector_ref<Tpackd, WD> dst, int locat",
"ion,\012                  vector_ref<Tcompst, WD> src);\012\012/* pack 2 \"small\" elements to 1 larger element\012   Note: order of elements must match between Pack and Unpack calls\012   parameters:\012   src1, src2, elements to pack\012*/\012template <typename Tpackd, typename Tcompst, int WD>\012void Pack(vector_ref<Tpackd, WD> src1, vector_ref<Tpackd, WD> src2,\012          vector_ref<Tcompst, WD> dst);\012\012/* ------------------------- CachedStack Routines\012 * -------------------------------------------------------*/\012\012/* A multi-channel (SIMD) Stack object, Stack is stored in Linear surface, with\012   a GRF based Cache for top of stack elements\012   top of stack pointer can be different for different channels.\012   with current implement: Push() will update all channels, a masked Pop() is\012   used to conditionaly pop values from stack channels.\012   See the distance transform kernel in sample directory for a working example\012*/\012\012/* CachedStackInit - initializes a CachedStack Object with:\012   template params:\012   CACHESIZE: size in pixel of Stack cache",
"d stored in GRF, currently MUST be:\012   CACHESIZE *sizeof(T) % 128 == 0 (preferable for optimal IO)\012   T - type of elements stored in stack\012   W - number of channels (SIMD) for a single element on stack\012   function params:\012   context, context_ii - internaly used by CachedStack to maintain cache\012   pointers, caller must not modify this params.\012   MaxSize - maximum number of elements on stack for a single channel.\012   Caller must allocate the linaer surface with size >=\012   MaxSize*NumThreads*W*Sizeof(T)\012   Optimization note: MaxSize should be aligned to: ( CACHELINE / sizeof(T))\012   (CACHELINE = 64 bytes)\012*/\012template <typename T, int W, uint CACHESIZE>\012void CachedStackInit(matrix_ref<short, 3, W> context,\012                     matrix_ref<int, 2, W> context_ii, uint MaxSize);\012\012/* CachedStackTop - Returns the element from top of Stack, w/o removing from\012   stack:\012   function params:\012   surf - pointer to linear sruface used for stack\012   context, context_ii - internaly used by CachedStack to maintain cache\012   pointers,",
" caller must not modify this params.\012   stack - user allocated stack cache\012   element - returned top element\012*/\012template <typename T, int W, uint CACHESIZE>\012void CachedStackTop(SurfaceIndex surf, matrix_ref<short, 2, W> context,\012                    matrix_ref<int, 2, W> context_ii,\012                    matrix_ref<T, W, CACHESIZE> stack,\012                    vector_ref<T, W> element);\012\012/* CachedStackPop - Conditionaly Pop the top element form that stack based on\012   mask, for channels with a 0 mask\012   pixel element is returned to caller but not Poped (see CacheStackTop)\012   function params:\012   surf - pointer to linear sruface used for stack\012   context, context_ii - internaly used by CachedStack to maintain cache\012   pointers, caller must not modify this params.\012   stack - user allocated stack cache\012   element - returned top element for all channels.\012   mask:  a 0-1 mask indicating top elements to Pop() (mask = 1) vs elements to\012   Top() (mask = 0). Note: currently only a 0,1 mask is supported\012\012   Note: Caller must ",
"avoid Pop() over an empty channels, Caller can use the\012   CacheStackEmpty() to set the mask , e,g.\012   vector<short, W> isEmpty;\012   vector<short, W> appMask; CallerSetMask(mask);\012   CachedStackEmpty<...>(..., isEmpty);\012   mask *= (1-isEmpty);\012   CachedStackPop<..>(..., mask);\012*/\012template <typename T, int W, uint CACHESIZE>\012void CachedStackPop(SurfaceIndex surf, matrix_ref<short, 2, W> context,\012                    matrix_ref<int, 2, W> context_ii,\012                    matrix_ref<T, W, CACHESIZE> stack, vector_ref<T, W> element,\012                    vector_ref<short, W> mask);\012\012/* CachedStackPush - Push an element to top of Stack\012   function params:\012   surf - pointer to linear sruface used for stack\012   context, context_ii - internaly used by CachedStack to maintain cache\012   pointers, caller must not modify this params.\012   stack - user allocated stack cache\012   element - element to push.\012\012   Note: Caller must not  Push() over a full stack (top element at MaxSize -1)\012*/\012template <typename T, int W, uint CACHESIZE>\012vo",
"id CachedStackPush(SurfaceIndex surf, matrix_ref<short, 2, W> context,\012                     matrix_ref<int, 2, W> context_ii,\012                     matrix_ref<T, W, CACHESIZE> stack,\012                     vector_ref<T, W> element);\012\012template <int W>\012void CachedStackEmpty(matrix_ref<short, 2, W> context,\012                      matrix_ref<int, 2, W> context_ii,\012                      vector_ref<short, W> isEmpty);\012\012/* ---------------Cached Stack with multiple logical stacks Routines\012 * ----------------------------*/\012\012/* Combine multiple logical stack storage into a single stack object, for\012   efficient I/O and stack accounting\012   See DistanceTransform example for usage.\012   STACKCOUNT: template variable specifies the number of logical stack storage\012   to combine.\012   CACHESIZE: size in pixel of Stack cached stored in GRF, currently MUST be:\012   (CACHESIZE *sizeof(T)*STACKCOUNT) % 128 == 0 (preferable for optimal IO)\012   MaxSize - maximum number of elements on stack for a single channel.\012   Caller must allocate the lina",
"er surface with size >=\012   MaxSize*NumThreads*W*Sizeof(T)*STACKCOUNT\012   Optimization note: MaxSize should be aligned to: ( CACHELINE /\012   (sizeof(T)*STACKCOUNT)  (CACHELINE = 64 bytes)\012   All other function parameters and function behavior is identical with API\012   above.\012*/\012\012template <typename T, int W, uint CACHESIZE, uint STACKCOUNT>\012void CachedStackInit(matrix_ref<short, 2, W *STACKCOUNT> context,\012                     matrix_ref<int, 2, W> context_ii, uint MaxSize);\012\012template <typename T, int W, uint CACHESIZE, uint STACKCOUNT>\012void CachedStackTop(SurfaceIndex surf,\012                    matrix_ref<short, 2, W *STACKCOUNT> context,\012                    matrix_ref<int, 2, W> context_ii,\012                    matrix_ref<T, W, CACHESIZE *STACKCOUNT> stack,\012                    matrix_ref<T, STACKCOUNT, W> element);\012\012/* retrieve element only from the specified stack index */\012template <typename T, int W, uint CACHESIZE, uint STACKCOUNT>\012void CachedStackTop(SurfaceIndex surf,\012                    matrix_ref<short, 2, W",
" *STACKCOUNT> context,\012                    matrix_ref<int, 2, W> context_ii,\012                    matrix_ref<T, W, CACHESIZE *STACKCOUNT> stack,\012                    vector_ref<T, W> element, int index);\012\012template <typename T, int W, uint CACHESIZE, uint STACKCOUNT>\012void\012CachedStackPop(SurfaceIndex surf, matrix_ref<short, 2, W *STACKCOUNT> context,\012               matrix_ref<int, 2, W> context_ii,\012               matrix_ref<T, W, CACHESIZE *STACKCOUNT> stack,\012               matrix_ref<T, STACKCOUNT, W> element, vector_ref<short, W> mask);\012\012/* pop but don't return top elements */\012template <typename T, int W, uint CACHESIZE, uint STACKCOUNT>\012void CachedStackPop(SurfaceIndex surf,\012                    matrix_ref<short, 2, W *STACKCOUNT> context,\012                    matrix_ref<int, 2, W> context_ii,\012                    matrix_ref<T, W, CACHESIZE *STACKCOUNT> stack,\012                    vector_ref<short, W> mask);\012\012template <typename T, int W, uint CACHESIZE, uint STACKCOUNT>\012void CachedStackPush(SurfaceIndex surf,\012    ",
"                 matrix_ref<short, 2, W *STACKCOUNT> context,\012                     matrix_ref<int, 2, W> context_ii,\012                     matrix_ref<T, W, CACHESIZE *STACKCOUNT> stack,\012                     matrix_ref<T, STACKCOUNT, W> element);\012\012template <int W, uint STACKCOUNT>\012void CachedStackEmpty(matrix_ref<short, 2, W *STACKCOUNT> context,\012                      matrix_ref<int, 2, W> context_ii,\012                      vector_ref<short, W> isEmpty);\012\012/* ------------------------- Matrix transform Routines\012 * ------------------------------------------*/\012\012/* Symmetries */\012template <typename T, int H, int W>\012void MirrorVertical(matrix_ref<T, H, W> in, matrix_ref<T, H, W> out);\012template <typename T>\012void MirrorHorizontal_16x16(matrix_ref<T, 16, 16> in,\012                            matrix_ref<T, 16, 16> out);\012template <typename T>\012void Rotate90_16x16(matrix_ref<T, 16, 16> in, matrix_ref<T, 16, 16> out);\012template <typename T>\012void Rotate270_16x16(matrix_ref<T, 16, 16> in, matrix_ref<T, 16, 16> out);\012template <typen",
"ame T>\012void Rotate180_16x16(matrix_ref<T, 16, 16> in, matrix_ref<T, 16, 16> out);\012template <typename T>\012void Transpose_16x16(matrix_ref<T, 16, 16> in, matrix_ref<T, 16, 16> out);\012template <typename T>\012void ReverseTranspose_16x16(matrix_ref<T, 16, 16> in,\012                            matrix_ref<T, 16, 16> out);\012\012template <typename T>\012void Transpose_8x8(matrix_ref<T, 8, 8> in, matrix_ref<T, 8, 8> out);\012\012/* Generic Matrix mapping  routines. e.g. diagonals --> rows\012   the mapping vector provides the source for mapping for each pixel, for\012   function T(x) --> T(mapping(x)) = x\012   e.g. mapping for 2x2 90 deg clockwise turn:\012   mapping = { 2,0,3,1}\012*/\012template <typename T, int W>\012void Map(matrix_ref<T, W, W> in, matrix_ref<T, W, W> out,\012         vector_ref<ushort, W *W> mapping);\012\012/* ------------------------- Init / Assignment Routines\012 * ----------------------------------*/\012\012template <typename T, uint Size>\012CM_INLINE void cm_vector_assign(vector_ref<T, Size> v, int InitValue, int Step);\012\012/* Note: The following macro",
"s are not scoped in the cmtl namespace since they\012 * are macros! */\012#define cm_matrix(M, T, R, C, I, S)                                            \\\012  matrix<T, R, C> M(cmtl::__CM_init_array_0_7);                                \\\012  cmtl::__CM_vector_init<T, R *C, I, S>(M.format<T>());\012\012#define cm_vector(V, T, N, I, S)                                               \\\012  vector<T, N> V(cmtl::__CM_init_array_0_7);                                   \\\012  cmtl::__CM_vector_init<T, N, I, S>(V);\012\012/* ------------------------- Extended Math Routines\012 * ----------------------------------------------*/\012\012#define CM_CONST_E 2.71828f\012#define CM_CONST_PI 3.14159f\012#define CM_CONST_2PI 6.28318f\012\012#define CM_DBL_EPSILON                                                         \\\012  0.00001f /* smallest such that 1.0+CM_DBL_EPSILON != 1.0 */\012\012template <typename RT, int R, int C>\012CM_INLINE vector<RT, R *C> cm_floor(const matrix<float, R, C> src0,\012                                    const uint flags = 0) {\012  return cm_rndd<RT, R *C>(src0",
", flags);\012}\012template <typename RT, int R, int C>\012CM_INLINE vector<RT, R *C> cm_floor(const matrix_ref<float, R, C> src0,\012                                    const uint flags = 0) {\012  return cm_rndd<RT, R *C>(src0, flags);\012}\012\012template <typename RT, int SZ>\012CM_INLINE vector<RT, SZ> cm_floor(const vector<float, SZ> src0,\012                                  const uint flags = 0) {\012  return cm_rndd<RT, SZ>(src0, flags);\012}\012template <typename RT, int SZ>\012CM_INLINE vector<RT, SZ> cm_floor(const vector_ref<float, SZ> src0,\012                                  const uint flags = 0) {\012  return cm_rndd<RT, SZ>(src0, flags);\012}\012\012template <typename RT>\012CM_INLINE RT cm_floor(const float &src0, const uint flags = 0) {\012  return cm_rndd<RT, 1U>(src0, flags)(0);\012}\012\012template <typename RT, int R, int C>\012CM_INLINE vector<RT, R *C> cm_ceil(const matrix<float, R, C> src0,\012                                   const uint flags = 0) {\012  return cm_rndu<RT, R *C>(src0, flags);\012}\012template <typename RT, int R, int C>\012CM_INLINE vector<RT, R *C> cm_",
"ceil(const matrix_ref<float, R, C> src0,\012                                   const uint flags = 0) {\012  return cm_rndu<RT, R *C>(src0, flags);\012}\012\012template <typename RT, int SZ>\012CM_INLINE vector<RT, SZ> cm_ceil(const vector<float, SZ> src0,\012                                 const uint flags = 0) {\012  return cm_rndu<RT, SZ>(src0, flags);\012}\012template <typename RT, int SZ>\012CM_INLINE vector<RT, SZ> cm_ceil(const vector_ref<float, SZ> src0,\012                                 const uint flags = 0) {\012  return cm_rndu<RT, SZ>(src0, flags);\012}\012\012template <typename RT>\012CM_INLINE RT cm_ceil(const float &src0, const uint flags = 0) {\012  return cm_rndu<RT, 1U>(src0, flags);\012}\012\012/* cm_atan2_fast - a fast atan2 implementation */\012/* matrix input */\012template <int R, int C>\012matrix<float, R, C> cm_atan2_fast(matrix<float, R, C> y, matrix<float, R, C> x,\012                                  const uint flags = 0);\012/* Matrix_ref input */\012template <int R, int C>\012matrix<float, R, C> cm_atan2_fast(matrix_ref<float, R, C> y,\012                        ",
"          matrix_ref<float, R, C> x,\012                                  const uint flags = 0);\012/* vector input */\012template <int N>\012vector<float, N> cm_atan2_fast(vector<float, N> y, vector<float, N> x,\012                               const uint flags = 0);\012/* vector_ref input */\012template <int N>\012vector<float, N> cm_atan2_fast(vector_ref<float, N> y, vector_ref<float, N> x,\012                               const uint flags = 0);\012/* scalar input */\012template <typename T> float cm_atan2_fast(T y, T x, const uint flags = 0);\012\012/* cm_atan2 - atan2 implementation */\012/* For matrix input */\012template <int R, int C>\012matrix<float, R, C> cm_atan2(matrix<float, R, C> y, matrix<float, R, C> x,\012                             const uint flags = 0);\012/* matrix_ref input */\012template <int R, int C>\012matrix<float, R, C> cm_atan2(matrix_ref<float, R, C> y,\012                             matrix_ref<float, R, C> x, const uint flags = 0);\012/* For Vector input */\012template <int N>\012vector<float, N> cm_atan2(vector<float, N> y, vector<float, N> x,\012 ",
"                         const uint flags = 0);\012/* vector_ref input */\012template <int N>\012vector<float, N> cm_atan2(vector_ref<float, N> y, vector_ref<float, N> x,\012                          const uint flags = 0);\012/* scalar Input */\012template <typename T> float cm_atan2(T y, T x, const uint flags = 0);\012\012/* cm_fmod: */\012/* matrix input */\012template <int R, int C>\012matrix<float, R, C> cm_fmod(matrix<float, R, C> y, matrix<float, R, C> x,\012                            const uint flags = 0);\012/* matrix_ref input */\012template <int R, int C>\012matrix<float, R, C> cm_fmod(matrix_ref<float, R, C> y,\012                            matrix_ref<float, R, C> x, const uint flags = 0);\012/* vector input */\012template <int N>\012vector<float, N> cm_fmod(vector<float, N> y, vector<float, N> x,\012                         const uint flags = 0);\012/* vector_ref input */\012template <int N>\012vector<float, N> cm_fmod(vector_ref<float, N> y, vector_ref<float, N> x,\012                         const uint flags = 0);\012/* scalar Input */\012template <typename T> float cm_",
"fmod(T y, T x, const uint flags = 0);\012\012/* cm_sin_emu - EU emulation for sin(x) */\012/* For matrix input */\012template <int R, int C>\012matrix<float, R, C> cm_sin_emu(matrix<float, R, C> x, const uint flags = 0);\012/* matrix_ref input */\012template <int R, int C>\012matrix<float, R, C> cm_sin_emu(matrix_ref<float, R, C> x, const uint flags = 0);\012/* For Vector input */\012template <int N>\012vector<float, N> cm_sin_emu(vector<float, N> x, const uint flags = 0);\012/* vector_ref input */\012template <int N>\012vector<float, N> cm_sin_emu(vector_ref<float, N> x, const uint flags = 0);\012/* scalar Input */\012template <typename T> float cm_sin_emu(T x, const uint flags = 0);\012\012/* cm_cos_emu - EU emulation for cos(x) */\012/* For matrix input */\012template <int R, int C>\012matrix<float, R, C> cm_cos_emu(matrix<float, R, C> x, const uint flags = 0);\012/* matrix_ref input */\012template <int R, int C>\012matrix<float, R, C> cm_cos_emu(matrix_ref<float, R, C> x, const uint flags = 0);\012/* For Vector input */\012template <int N>\012vector<float, N> cm_cos_emu(vector<float, ",
"N> x, const uint flags = 0);\012/* vector_ref input */\012template <int N>\012vector<float, N> cm_cos_emu(vector_ref<float, N> x, const uint flags = 0);\012/* scalar Input */\012template <typename T> float cm_cos_emu(T x, const uint flags = 0);\012\012/* cm_tanh_cody_waite - Cody-Waite implementation for tanh(x) */\012/* float input */\012float cm_tanh_cody_waite(float x);\012/* vector input */\012template <int N>\012vector<float, N> cm_tanh_cody_waite(vector<float, N> x);\012/* matrix input */\012template <int R, int C>\012matrix<float, R, C> cm_tanh_cody_waite(matrix<float, R, C> x);\012/* cm_tanh - opencl like implementation for tanh(x) */\012/* float input */\012float cm_tanh(float x);\012/* vector input */\012template <int N>\012vector<float, N> cm_tanh(vector<float, N> x);\012/* matrix input */\012template <int R, int C>\012matrix<float, R, C> cm_tanh(matrix<float, R, C> x);\012\012\012/* ------------------------- Support Routines\012 * ---------------------------------------------------*/\012\012template <typename T, int SZ> void cm_assert_range(vector<T, SZ>, float, float);\012\012const ushort _",
"_CM_init_array_0_7[8] = { 0, 1, 2, 3, 4, 5, 6, 7 };\012template <uint RemSize, typename T, uint Size> struct __RemainderInit;\012template <typename T, uint Size, int InitValue, int Step>\012void __CM_vector_init(vector_ref<T, Size> v);\012\012/* ---------------------------------------------------------------------------*/\012/* ------------------------- Implementation\012 * -----------------------------------------------------*/\012/* ---------------------------------------------------------------------------*/\012\012/* ------------------------- Support functions / template functions\012 * -----------------------------*/\012/* All the following macros can be used in template instantiations so we have to\012   use macros\012   rather than template functions */\012#define _CMTL_PIXEL_REG(T) (32 / sizeof(T))\012#define _CMTL_PIXEL_STRIDE(STRIDE, TYPE) ((STRIDE) / sizeof(TYPE))\012#define _CMTL_SAFE_SIZE(SZ) ((SZ) \? (SZ) : 1)\012#define _CMTL_PIXEL_MOD(SIZE, TYPE) ((SIZE) % _CMTL_PIXEL_STRIDE(32, TYPE))\012#define _CMTL_PIXEL_DELTA(SIZE, TYPE) ((int)SIZE - _CMTL_PIXEL",
"_MOD(SIZE, TYPE))\012#define _CMTL_SAFE_PIXEL_MOD(SIZE, TYPE)                                       \\\012  (_CMTL_SAFE_SIZE(_CMTL_PIXEL_MOD(SIZE, TYPE)))\012#define _CMTL_SAFE_PIXEL_DELTA(SIZE, TYPE)                                     \\\012  (_CMTL_SAFE_SIZE(_CMTL_PIXEL_DELTA(SIZE, TYPE)))\012#define _CMTL_PIXEL_MOD_GT(SIZE, STRIDE, TYPE)                                 \\\012  (int)(_CMTL_PIXEL_MOD(SIZE, TYPE) > _CMTL_PIXEL_STRIDE(STRIDE, TYPE))\012#define _CMTL_PIXEL_MOD_LTE(SIZE, STRIDE, TYPE)                                \\\012  (int)(_CMTL_PIXEL_MOD(SIZE, TYPE) <= _CMTL_PIXEL_STRIDE(STRIDE, TYPE))\012#define _CMTL_ROWS_P_LINE(T, LENGTH)                                           \\\012  (((int)(LENGTH) + _CMTL_PIXEL_REG(T) - 1) / _CMTL_PIXEL_REG(T))\012\012/* ------------------------- I/O Routines\012 * -------------------------------------------------------*/\012const unsigned int IO_READ = 0;\012const unsigned int IO_WRITE = 1;\012\012/***************************** Implementation  *******************************/\012// Generates a mask of length SZ consist",
"ing of numZeros zeros followed by\012// (SZ-numZeros) ones.\012template <typename T, int SZ>\012CM_INLINE void vectorMaskFirstZerosThenOnes(vector_ref<T, SZ> v,\012                                            uint numZeros) {\012  v = 1;\012  const uint numFullZeroBlocks = numZeros >> 3;\012\012#if defined(__ICL) || defined(__CMC)\012#pragma unroll\012#endif\012  for (uint blockIdx = 0; blockIdx < numFullZeroBlocks; blockIdx++) {\012    v.template select<8, 1>(blockIdx * 8) = 0;\012  }\012\012#if defined(__ICL) || defined(__CMC)\012#pragma unroll\012#endif\012  for (uint remIdx = numFullZeroBlocks * 8; remIdx < numZeros; remIdx++) {\012    v(remIdx) = 0;\012  }\012}\012\012// A read function with a fix for the border-duplication issue. This issue means\012// that when reading a matrix which extends beyond the surface boundary,\012// duplication-to-the-right doesn't work as expected for surfaces whose width\012// isn't d-word aligned (i.e., a multiple of 4). Vertical duplication (above and\012// below) and duplication-to-the-left do work as expected and are not handled by\012// this function.\012",
"//\012// Parameters:\012//   MAT_TYPE:\012//      A type whose size is the same as the size of a single surface pixel.\012//      Example surface types and MAT_TYPE values:\012//          CM_SURFACE_FORMAT_A8:       char\012//          CM_SURFACE_FORMAT_V8U8:     short\012//          CM_SURFACE_FORMAT_A8R8G8B8: int\012//   buf_id:\012//      Surface index.\012//   x_pos_bytes:\012//      X coordinate of position from which to start reading surface, in\012//      *bytes*.\012//   y_pos_bytes:\012//      Y coordinate of position from which to start reading surface, in\012//      *bytes*.\012//   in:\012//      Matrix to fill with values from surface (or duplicated values when asked\012//      to read beyond the surface's edge).\012//   surface_width_pixels:\012//      Surface width in *pixels*. The surface width in bytes will be deduced\012//      by multiplying this with sizeof(SUFF_TYPE).\012template <typename MAT_TYPE, int R, int C>\012CM_INLINE void _Read4Borders(SurfaceIndex buf_id, int x_pos_bytes,\012                             int y_pos_bytes, matrix_ref<MAT_TYPE, R, C> in",
",\012                             int surface_width_pixels) {\012  // Compile-time check whether the fix is necessary; if not, we do a simple\012  // read and return. The compile-time check has been seperated from the\012  // run-time check in the hope that the compiler will just optimize this\012  // whole function away if it is unnecessary.\012  if (sizeof(MAT_TYPE) % 4 == 0) {\012    read(buf_id, x_pos_bytes, y_pos_bytes, in);\012    return;\012  }\012\012  // Calculate surface width in bytes.\012  const int surface_width_bytes = surface_width_pixels * (int)sizeof(MAT_TYPE);\012\012  // Run-time check whether the fix is necessary; if not, we do a simple read\012  // and return.\012  if (surface_width_bytes % 4 == 0 ||\012      x_pos_bytes + (int)(C * sizeof(MAT_TYPE)) <= surface_width_bytes) {\012    read(buf_id, x_pos_bytes, y_pos_bytes, in);\012    return;\012  }\012\012#ifndef INLINE_READ\012  Boundaries<MAT_TYPE>(buf_id, x_pos_bytes, y_pos_bytes, in,\012                       surface_width_pixels, surface_width_bytes);\012}\012\012template <typename MAT_TYPE, int R, int C>\012void Bou",
"ndaries(SurfaceIndex buf_id, int x_pos_bytes, int y_pos_bytes,\012                matrix_ref<MAT_TYPE, R, C> in, int surface_width_pixels,\012                int surface_width_bytes) {\012#endif\012\012  // Modify x_pos_bytes to guarantee that after read matrix will contain at\012  // least one valid column.\012  if (x_pos_bytes >= surface_width_bytes) {\012    x_pos_bytes = surface_width_bytes - sizeof(MAT_TYPE);\012  }\012\012  // Read from surface into a MAT_TYPE-matrix of same size as target matrix.\012  read(buf_id, x_pos_bytes, y_pos_bytes, in);\012\012  // Calculate the right-most column of the MAT_TYPE-matrix which contains\012  // good data. All columns to the right of this column will be set to equal\012  // it.\012  int last_good_column_index =\012      surface_width_pixels - x_pos_bytes / (int)sizeof(MAT_TYPE) - 1;\012\012  // Generate a mask vector whose first (last_good_column_index + 1) values\012  // are zero and whose remaining values are one.\012  vector<ushort, C> mask;\012  vectorMaskFirstZerosThenOnes(mask.template select<C, 1>(0),\012                        ",
"       (uint)last_good_column_index + 1);\012\012  // Going row by row, fix the MAT_TYPE-matrix.\012  vector<MAT_TYPE, C> filler;\012  for (int i = 0; i < R; i++) {\012    filler = in(i, last_good_column_index);\012    in.row(i).merge(filler, mask);\012  }\012}\012\012template <typename MAT_TYPE, int R, int C>\012CM_INLINE void _Read4Borders(SurfaceIndex buf_id, int x_pos_bytes,\012                             int y_pos_bytes, matrix<MAT_TYPE, R, C> in,\012                             int surface_width_pixels) {\012  _Read4Borders(buf_id, x_pos_bytes, y_pos_bytes, in.select_all(),\012                surface_width_pixels);\012}\012\012template <typename T, int HEIGHT, int WIDTH>\012CM_INLINE void\012_ReadWrapper(SurfaceIndex obuf, CmBufferAttrib buf_attrib, int h_pos, int v_pos,\012             matrix_ref<T, HEIGHT, WIDTH> block, uint surfaceWidth) {\012  if (buf_attrib == GENX_NUM_BUFFER_ATTRIB)\012    _Read4Borders(obuf, h_pos, v_pos, block, surfaceWidth);\012  if (buf_attrib != GENX_NUM_BUFFER_ATTRIB)\012    // read modified is not supported with replicate bounderies.\012    read(obu",
"f, buf_attrib, h_pos, v_pos, block);\012}\012\012/*\012  Block Width (bytes) Maximum Block Height (rows)\012  1-4                    64\012  5-8                    32\012  9-16                16\012  17-32                8\012  33-64 {BDW+}        4\012*/\012\012template <typename T, int HEIGHT, int WIDTH, uint OP_TYPE>\012CM_INLINE void _ioOp(SurfaceIndex iobuf, CmBufferAttrib buf_attrib, int h_pos,\012                     int v_pos, matrix_ref<T, HEIGHT, WIDTH> block,\012                     uint surfaceWidth) {\012  cm_assert(OP_TYPE == IO_READ || OP_TYPE == IO_WRITE);\012  if (OP_TYPE == IO_WRITE)\012    write(iobuf, h_pos, v_pos, block);\012  if (OP_TYPE == IO_READ)\012    _ReadWrapper(iobuf, buf_attrib, h_pos, v_pos, block, surfaceWidth);\012}\012\012template <typename T, int HEIGHT, int WIDTH, int H_STRIDE, int MAX_V_STRIDE,\012          int OP_TYPE>\012CM_INLINE void IoFixedStrideBlock(SurfaceIndex iobuf, CmBufferAttrib buf_attrib,\012                                  int h_pos, int v_pos,\012                                  matrix_ref<T, HEIGHT, WIDTH> block,\012                   ",
"               uint surfaceWidth) {\012  int vblock, hblock;\012  int h_pos_abs = sizeof(T) * h_pos;\012\012#if defined(__ICL) || defined(__CMC)\012#pragma unroll\012#endif\012  for (vblock = 0; vblock < (int)HEIGHT - (MAX_V_STRIDE - 1);\012       vblock += MAX_V_STRIDE) {\012#if defined(__ICL) || defined(__CMC)\012#pragma unroll\012#endif\012    for (hblock = 0; hblock < (int)WIDTH - (H_STRIDE - 1); hblock += H_STRIDE) {\012      _ioOp<T, MAX_V_STRIDE, H_STRIDE, OP_TYPE>(\012          iobuf, buf_attrib, sizeof(T) * hblock + h_pos_abs, v_pos + vblock,\012          block.template select<MAX_V_STRIDE, 1, H_STRIDE, 1>(vblock, hblock),\012          surfaceWidth);\012    }\012    if (WIDTH % H_STRIDE) {\012      _ioOp<T, MAX_V_STRIDE, _CMTL_SAFE_SIZE(WIDTH % H_STRIDE), OP_TYPE>(\012          iobuf, buf_attrib, sizeof(T) * hblock + h_pos_abs, v_pos + vblock,\012          block.template select<MAX_V_STRIDE, 1,\012                                _CMTL_SAFE_SIZE(WIDTH % H_STRIDE), 1>(vblock,\012                                                                      hblock),\012          sur",
"faceWidth);\012    }\012  }\012  if (HEIGHT % MAX_V_STRIDE) {\012#if defined(__ICL) || defined(__CMC)\012#pragma unroll\012#endif\012    for (hblock = 0; hblock < (int)WIDTH - (H_STRIDE - 1); hblock += H_STRIDE) {\012      _ioOp<T, _CMTL_SAFE_SIZE(HEIGHT % MAX_V_STRIDE), H_STRIDE, OP_TYPE>(\012          iobuf, buf_attrib, sizeof(T) * hblock + h_pos_abs, v_pos + vblock,\012          block.template select<_CMTL_SAFE_SIZE(HEIGHT % MAX_V_STRIDE), 1,\012                                H_STRIDE, 1>(vblock, hblock),\012          surfaceWidth);\012    }\012    if (WIDTH % H_STRIDE) {\012      _ioOp<T, _CMTL_SAFE_SIZE(HEIGHT % MAX_V_STRIDE),\012            _CMTL_SAFE_SIZE(WIDTH % H_STRIDE), OP_TYPE>(\012          iobuf, buf_attrib, sizeof(T) * hblock + h_pos_abs, v_pos + vblock,\012          block.template select<_CMTL_SAFE_SIZE(HEIGHT % MAX_V_STRIDE), 1,\012                                _CMTL_SAFE_SIZE(WIDTH % H_STRIDE), 1>(vblock,\012                                                                      hblock),\012          surfaceWidth);\012    }\012  }\012}\012\012// TODO add support for ",
"double\012// TODO support 64 byte stride for BDW +\012template <typename T, int HEIGHT, int WIDTH, int OP_TYPE>\012CM_INLINE void IoBlock(SurfaceIndex iobuf, CmBufferAttrib buf_attrib, int h_pos,\012                       int v_pos, matrix_ref<T, HEIGHT, WIDTH> block,\012                       uint surfaceWidth = 0) {\012  cm_assert(sizeof(T) <= 4);\012  if (_CMTL_PIXEL_DELTA(WIDTH, T) > 0) {\012    IoFixedStrideBlock<T, HEIGHT, _CMTL_SAFE_PIXEL_DELTA(WIDTH, T),\012                       _CMTL_PIXEL_STRIDE(32, T), 8, OP_TYPE>(\012        iobuf, buf_attrib, h_pos, v_pos,\012        block.template select<HEIGHT, 1, _CMTL_SAFE_PIXEL_DELTA(WIDTH, T), 1>(\012            0, 0),\012        surfaceWidth);\012    h_pos += _CMTL_PIXEL_DELTA(WIDTH, T);\012  }\012\012  // deal with left over\012  if (_CMTL_PIXEL_MOD_GT(WIDTH, 16, T)) {\012    IoFixedStrideBlock<T, HEIGHT, _CMTL_SAFE_PIXEL_MOD(WIDTH, T),\012                       _CMTL_PIXEL_STRIDE(32, T), 8, OP_TYPE>(\012        iobuf, buf_attrib, h_pos, v_pos,\012        block.template select<HEIGHT, 1, _CMTL_SAFE_PIXEL_MOD(WIDTH, T),",
" 1>(\012            0, _CMTL_PIXEL_DELTA(WIDTH, T)),\012        surfaceWidth);\012  }\012\012  if (_CMTL_PIXEL_MOD_GT(WIDTH, 8, T) && _CMTL_PIXEL_MOD_LTE(WIDTH, 16, T)) {\012    IoFixedStrideBlock<T, HEIGHT, _CMTL_SAFE_PIXEL_MOD(WIDTH, T),\012                       _CMTL_PIXEL_STRIDE(16, T), 16, OP_TYPE>(\012        iobuf, buf_attrib, h_pos, v_pos,\012        block.template select<HEIGHT, 1, _CMTL_SAFE_PIXEL_MOD(WIDTH, T), 1>(\012            0, _CMTL_PIXEL_DELTA(WIDTH, T)),\012        surfaceWidth);\012  }\012\012  if (_CMTL_PIXEL_MOD_GT(WIDTH, 4, T) && _CMTL_PIXEL_MOD_LTE(WIDTH, 8, T)) {\012    IoFixedStrideBlock<T, HEIGHT, _CMTL_SAFE_PIXEL_MOD(WIDTH, T),\012                       _CMTL_PIXEL_STRIDE(8, T), 32, OP_TYPE>(\012        iobuf, buf_attrib, h_pos, v_pos,\012        block.template select<HEIGHT, 1, _CMTL_SAFE_PIXEL_MOD(WIDTH, T), 1>(\012            0, _CMTL_PIXEL_DELTA(WIDTH, T)),\012        surfaceWidth);\012  }\012\012  if (_CMTL_PIXEL_MOD_GT(WIDTH, 0, T) && _CMTL_PIXEL_MOD_LTE(WIDTH, 4, T)) {\012    IoFixedStrideBlock<T, HEIGHT, _CMTL_SAFE_PIXEL_MOD(WIDTH, T),\012       ",
"                _CMTL_PIXEL_STRIDE(4, T), 64, OP_TYPE>(\012        iobuf, buf_attrib, h_pos, v_pos,\012        block.template select<HEIGHT, 1, _CMTL_SAFE_PIXEL_MOD(WIDTH, T), 1>(\012            0, _CMTL_PIXEL_DELTA(WIDTH, T)),\012        surfaceWidth);\012  }\012}\012\012template <typename T, int HEIGHT, int WIDTH>\012CM_INLINE void ReadBlock(SurfaceIndex iobuf, int h_pos, int v_pos,\012                         matrix_ref<T, HEIGHT, WIDTH> block,\012                         uint surfaceWidth) {\012  IoBlock<T, HEIGHT, WIDTH, IO_READ>(iobuf, GENX_NUM_BUFFER_ATTRIB, h_pos,\012                                     v_pos, block, surfaceWidth);\012}\012\012template <typename T, int HEIGHT, int WIDTH>\012CM_INLINE void\012ReadBlock(SurfaceIndex iobuf, CmBufferAttrib buf_attrib, int h_pos, int v_pos,\012          matrix_ref<T, HEIGHT, WIDTH> block, uint surfaceWidth) {\012  cm_assert(buf_attrib != GENX_NUM_BUFFER_ATTRIB);\012  IoBlock<T, HEIGHT, WIDTH, IO_READ>(iobuf, buf_attrib, h_pos, v_pos, block,\012                                     surfaceWidth);\012}\012\012template <typename T, i",
"nt HEIGHT, int WIDTH>\012CM_INLINE void WriteBlock(SurfaceIndex iobuf, int h_pos, int v_pos,\012                          matrix_ref<T, HEIGHT, WIDTH> block) {\012  IoBlock<T, HEIGHT, WIDTH, IO_WRITE>(iobuf, GENX_NUM_BUFFER_ATTRIB, h_pos,\012                                      v_pos, block);\012}\012\012template <typename T, int WIDTH, uint OP_TYPE>\012CM_INLINE void _ioLinearOp(SurfaceIndex iobuf, int h_pos,\012                           vector_ref<T, WIDTH> block) {\012  // cm_assert(OP_TYPE == IO_READ || OP_TYPE == IO_WRITE);\012  if (OP_TYPE == IO_WRITE)\012    write(iobuf, h_pos, block);\012  if (OP_TYPE == IO_READ)\012    read(MODIFIED(iobuf), h_pos, block); // TODO : need to understand behavior\012                                         // of MODIFED flag and when/how to use\012                                         // it...\012}\012\012#define _CMTL_MAXIOLINEAR(TYPE) (128 / sizeof(TYPE))\012\012template <typename T, int WIDTH, uint PIX_STRD, uint OP_TYPE>\012CM_INLINE void IOLinear(SurfaceIndex iobuf, int pix_pos,\012                        vector_ref<T, WIDTH> bl",
"ock) {\012  int hblock;\012  int h_pos_abs = sizeof(T) * pix_pos;\012\012  if constexpr (WIDTH >= PIX_STRD) {\012#if defined(__ICL) || defined(__CMC)\012#pragma unroll\012#endif\012    for (hblock = 0; hblock < (int)WIDTH - (PIX_STRD - 1); hblock += PIX_STRD) {\012      _ioLinearOp<T, PIX_STRD, OP_TYPE>(\012          iobuf, sizeof(T) * hblock + h_pos_abs,\012          block.template select<PIX_STRD, 1>(hblock));\012    }\012  }\012  if constexpr (WIDTH % PIX_STRD != 0) {\012    _ioLinearOp<T, _CMTL_SAFE_SIZE(WIDTH % PIX_STRD), OP_TYPE>(\012        iobuf, sizeof(T) * hblock + h_pos_abs,\012        block.template select<_CMTL_SAFE_SIZE(WIDTH % PIX_STRD), 1>(hblock));\012  }\012}\012\012template <typename T, int WIDTH>\012CM_INLINE void WriteLinear(SurfaceIndex obuf, int pix_pos,\012                           vector_ref<T, WIDTH> block) {\012  IOLinear<T, WIDTH, _CMTL_MAXIOLINEAR(T), IO_WRITE>(obuf, pix_pos, block);\012}\012\012template <typename T, int WIDTH>\012CM_INLINE void ReadLinear(SurfaceIndex ibuf, int pix_pos,\012                          vector_ref<T, WIDTH> block) {\012  IOLinear<T, WIDTH",
", _CMTL_MAXIOLINEAR(T), IO_READ>(ibuf, pix_pos, block);\012}\012\012/* ------------------------- Vectorization Routines\012 * -------------------------------------------------------*/\012template <uint KRNL_SZ> CM_INLINE int _2Dto1D(int x, int y) {\012  return x * KRNL_SZ + y;\012}\012\012template <typename Tsrc, typename Tdst, uint KRNL_SZ, uint SIMD_SZ>\012CM_INLINE void\012Vectorize2DKRNLRow(vector_ref<Tsrc, SIMD_SZ + KRNL_SZ - 1> src,\012                   matrix_ref<Tdst, KRNL_SZ *KRNL_SZ, SIMD_SZ> dst,\012                   int dstRow) {\012  cm_assert(KRNL_SZ % 2 == 1);\012  cm_assert(dstRow < KRNL_SZ * KRNL_SZ);\012  int radius = KRNL_SZ / 2;\012  int anchor = KRNL_SZ / 2;\012#if defined(__ICL) || defined(__CMC)\012#pragma unroll\012#endif\012  for (int clmn = -radius; clmn < radius + 1; clmn++) {\012    dst.row(_2Dto1D<KRNL_SZ>(dstRow, clmn + anchor)) =\012        src.template select<SIMD_SZ, 1>(clmn + anchor);\012  }\012}\012\012template <typename Tsrc, typename Tdst, uint KRNL_SZ, uint SIMD_SZ, int OFFSET>\012CM_INLINE void glue_vector(vector_ref<Tsrc, SIMD_SZ> src_1,\012            ",
"               vector_ref<Tsrc, KRNL_SZ - 1> src_2,\012                           vector_ref<Tdst, SIMD_SZ> dst) {\012  dst.template select<SIMD_SZ - OFFSET, 1>(0) =\012      src_1.template select<SIMD_SZ - OFFSET, 1>(OFFSET);\012  dst.template select<OFFSET, 1>(SIMD_SZ - OFFSET) =\012      src_2.template select<OFFSET, 1>(0);\012}\012\012template <typename Tsrc, typename Tdst, uint KRNL_SZ, uint SIMD_SZ>\012CM_INLINE void\012Vectorize2DKRNLRow(/*vector_ref<Tsrc, SIMD_SZ> src,\012                          vector_ref<Tsrc, KRNL_SZ -1> src_2,*/\012                   matrix_ref<Tsrc,\012                              _CMTL_ROWS_P_LINE(Tsrc, SIMD_SZ + KRNL_SZ - 1),\012                              _CMTL_PIXEL_REG(Tsrc)> src,\012                   matrix_ref<Tdst, KRNL_SZ *KRNL_SZ, SIMD_SZ> dst,\012                   int dstRow) {\012  cm_assert(KRNL_SZ % 2 == 1);\012  cm_assert(dstRow < (int)KRNL_SZ * KRNL_SZ);\012  cm_assert(SIMD_SZ % 8 == 0);\012  int radius = KRNL_SZ / 2;\012  int anchor = KRNL_SZ / 2;\012\012#if defined(__ICL) || defined(__CMC)\012#pragma unroll\012#endif\012  for (int ",
"clmn = -radius; clmn < radius + 1; clmn++) {\012    // vector<Tsrc, SIMD_SZ + KRNL_SZ -1> glue;\012    vector<Tsrc, _CMTL_ROWS_P_LINE(Tsrc, SIMD_SZ + KRNL_SZ -\012                                             1) *_CMTL_PIXEL_REG(Tsrc)> glue =\012        src;\012\012    dst.row(_2Dto1D<KRNL_SZ>(dstRow, clmn + anchor)) =\012        glue.template select<SIMD_SZ, 1>(clmn + anchor);\012\012    /* not working yet, limited to 3x3\012    int clmn = -1; //glue_vector<Tsrc, Tdst, KRNL_SZ, SIMD_SZ,0>(src, src_2,\012        dst.row(_2Dto1D<KRNL_SZ>(dstRow, clmn + anchor)) = src;\012\012    clmn = 0; glue_vector<Tsrc, Tdst, KRNL_SZ, SIMD_SZ,1>(src, src_2,\012        dst.row(_2Dto1D<KRNL_SZ>(dstRow, clmn + anchor)));\012\012    clmn = 1; glue_vector<Tsrc, Tdst, KRNL_SZ, SIMD_SZ,2>(src, src_2,\012        dst.row(_2Dto1D<KRNL_SZ>(dstRow, clmn + anchor)));\012    */\012  }\012}\012\012template <typename Tsrc, typename Tdst, uint KRNL_SZ, uint SIMD_SZ>\012CM_INLINE void\012Vectorize2DKRNL(matrix_ref<Tsrc, KRNL_SZ, SIMD_SZ + KRNL_SZ - 1> src,\012                matrix_ref<Tdst, KRNL_SZ *KRNL_SZ, SIMD_S",
"Z> dst) {\012  cm_assert(KRNL_SZ % 2 == 1);\012\012  int radius = KRNL_SZ / 2;\012  int anchor = KRNL_SZ / 2;\012\012#if defined(__ICL) || defined(__CMC)\012#pragma unroll\012#endif\012  for (int row = -radius; row < radius + 1; row++) {\012\012#if defined(__ICL) || defined(__CMC)\012#pragma unroll\012#endif\012    for (int clmn = -radius; clmn < radius + 1; clmn++) {\012      dst.row(_2Dto1D<KRNL_SZ>(row + anchor, clmn + anchor)) =\012          src.template select<1, 1, SIMD_SZ, 1>(row + anchor, clmn + anchor);\012    }\012  }\012}\012\012template <typename Tsrc, typename Tdst, uint ROWS, uint KRNL_SZ, uint SIMD_SZ>\012CM_INLINE void Vectorize2DKRNLRow(vector_ref<Tsrc, SIMD_SZ + KRNL_SZ - 1> src,\012                                  matrix_ref<Tdst, ROWS *KRNL_SZ, SIMD_SZ> dst,\012                                  int dstRow) {\012  cm_assert(KRNL_SZ % 2 == 1);\012  cm_assert(dstRow < ROWS * KRNL_SZ);\012  int radius = KRNL_SZ / 2;\012  int anchor = KRNL_SZ / 2;\012\012#if defined(__ICL) || defined(__CMC)\012#pragma unroll\012#endif\012  for (int clmn = -radius; clmn < radius + 1; clmn++) {\012    dst.row(_2",
"Dto1D<KRNL_SZ>(dstRow, clmn + anchor)) =\012        src.template select<SIMD_SZ, 1>(clmn + anchor);\012  }\012}\012\012template <typename T, uint ROWS, uint KRNL_SZ, uint SIMD_SZ>\012CM_INLINE void Vectorize2DKRNLRow(vector_ref<T, SIMD_SZ + KRNL_SZ - 1> src,\012                                  matrix_ref<T, ROWS *KRNL_SZ, SIMD_SZ> dst,\012                                  int dstRow) {\012  Vectorize2DKRNLRow<T, T, ROWS, KRNL_SZ, SIMD_SZ>(src, dst, dstRow);\012}\012\012/* ------------------------- SLM Routines\012 * -------------------------------------------------------*/\012\012// Addresses are in units of element size. The offset indicate a write location\012// of 16 bytes.\012static const ushort init_slm_offsets[] = { 0, 1, 2,  3,  4,  5,  6,  7,\012                                           8, 9, 10, 11, 12, 13, 14, 15 };\012\012// data read from SLM using the cm_slm_read4 is organized per channel:\012// i.e. RGBARGBARGBA ... data in SLM is returned as\012// RRR ... GGG ... BB ... AAA ...\012template <int N>\012CM_INLINE void TransposeFromSLM(vector_ref<uint, N * 4> dst,\012  ",
"                              vector_ref<uint, N * 4> src) {\012  cm_assert(N == 8 || N == 16);\012\012#if defined(__ICL) || defined(__CMC)\012#pragma unroll\012#endif\012  for (int i = 0; i < 4; i++)\012    dst.template select<N, 4>(i) = src.template select<N, 1>(i * N);\012}\012\012// data write to SLM using the cm_slm_write4 should be organized per channel:\012// i.e. RGBARGBARGBA ... data should be written to SLM as\012// RRR ... GGG ... BB ... AAA ...\012template <int N>\012CM_INLINE void TransposeToSLM(vector_ref<uint, N * 4> dst,\012                              vector_ref<uint, N * 4> src) {\012  cm_assert(N == 8 || N == 16);\012\012#if defined(__ICL) || defined(__CMC)\012#pragma unroll\012#endif\012  for (int i = 0; i < 4; i++)\012    dst.template select<N, 1>(N *i) = src.template select<N, 4>(i);\012}\012\012CM_INLINE void DumpSLM(uint slmX, SurfaceIndex slmDebugSurface, uint size) {\012  vector<uint, 16> slm_addresses(init_slm_offsets);\012  vector<uint, 64> io_data;\012  vector<uint, 64> dst;\012  vector<uchar, 256> toOuputSurface;\012\012  slm_addresses *= 4;\012\012  int i;\012  for (i = 0; i < ",
"size; i += 256) {\012    cm_slm_read4(slmX, slm_addresses, io_data, SLM_ABGR_ENABLE);\012    TransposeFromSLM<16>(dst, io_data);\012    toOuputSurface = dst.format<uchar>();\012\012    write(slmDebugSurface, i, toOuputSurface.select<128, 1>(0));\012    write(slmDebugSurface, i + 128, toOuputSurface.select<128, 1>(128));\012\012    slm_addresses += 64;\012  }\012}\012\012/* ------------------------- iselect Routines\012 * -------------------------------------------------------*/\012template <typename Tpackd, typename Tcompst, int WD>\012CM_INLINE void Pack(vector_ref<Tpackd, WD> src1, vector_ref<Tpackd, WD> src2,\012                    vector_ref<double, WD> dst) {\012  vector<Tpackd, WD * 2> temp;\012\012  temp.template select<WD, 2>(0) = src1;\012  temp.template select<WD, 2>(1) = src2;\012  dst = temp.template format<double>();\012}\012\012template <typename T, uint SIMD_SZ>\012CM_INLINE void _Unpack_double(vector_ref<T, SIMD_SZ> dst1,\012                              vector_ref<T, SIMD_SZ> dst2,\012                              vector_ref<double, SIMD_SZ> src) {\012  vector<T, SIMD_SZ * 2",
"> temp = src.template format<T>();\012  dst1 = temp.template select<SIMD_SZ, 2>(0);\012  dst2 = temp.template select<SIMD_SZ, 2>(1);\012}\012\012template <typename Tpackd, typename TUpackd, typename Tcompst,\012          typename TUcompst, int WD>\012CM_INLINE void _Pack(vector_ref<Tpackd, WD> src1, vector_ref<Tpackd, WD> src2,\012                     vector_ref<Tcompst, WD> dst) {\012  vector<TUpackd, WD> usrc1 = src1.template format<TUpackd, WD, 1>();\012  vector<TUpackd, WD> usrc2 = src2.template format<TUpackd, WD, 1>();\012\012  vector<TUcompst, WD> udst = (usrc2 << (sizeof(Tpackd) * 8)) | usrc1;\012  dst = udst.template format<Tcompst, WD, 1>();\012}\012\012template <typename Tpackd, typename Tcompst, int WD>\012CM_INLINE void Unpack(vector_ref<Tpackd, WD> dst1, vector_ref<Tpackd, WD> dst2,\012                      vector_ref<Tcompst, WD> src) {\012  cm_assert(sizeof(Tpackd) * 2 <= sizeof(Tcompst));\012\012  vector<Tpackd, WD * 2> src_cast = src.template format<Tpackd, WD * 2, 1>();\012  dst1 = src_cast.template select<WD, 2>(CMRT_LOC_FIRST); // LSB ordered\012  dst2 = s",
"rc_cast.template select<WD, 2>(CMRT_LOC_SECOND);\012}\012\012template <typename Tpackd, typename Tcompst, int WD>\012CM_INLINE void UnpackSingle(vector_ref<Tpackd, WD> dst, int location,\012                            vector_ref<Tcompst, WD> src) {\012  cm_assert(location == CMRT_LOC_FIRST || location == CMRT_LOC_SECOND);\012  vector<Tpackd, WD * 2> src_cast = src.template format<Tpackd, WD * 2, 1>();\012  dst = src_cast.template select<WD, 2>(location);\012}\012\012template <typename Tpackd, typename Tcompst, int WD>\012CM_INLINE void Pack(vector_ref<Tpackd, WD> src1, vector_ref<Tpackd, WD> src2,\012                    vector_ref<Tcompst, WD> dst) {\012  cm_assert(sizeof(Tpackd) * 2 <= sizeof(Tcompst));\012\012  if ((sizeof(Tpackd) == 1) && sizeof(Tcompst) == 2)\012    _Pack<Tpackd, uchar, Tcompst, ushort, WD>(src1, src2, dst);\012  if ((sizeof(Tpackd) == 1) && sizeof(Tcompst) == 4)\012    _Pack<Tpackd, uchar, Tcompst, uint, WD>(src1, src2, dst);\012  if ((sizeof(Tpackd) == 2) && sizeof(Tcompst) == 4)\012    _Pack<Tpackd, ushort, Tcompst, uint, WD>(src1, src2, dst);\012}\012\012",
"/* ------------------------- CachedStack Routines\012 * ---------------------------------------------------*/\012#define _CMTL_CSTK_K 0\012#define _CMTL_CSTK_CHNL 1\012\012#define _CMTL_CNTXT_SIZE 2, W *STACKCOUNT\012#define _CMTL_CNTXT_SIZE_1 (2, W)\012#define _CMTL_STACK_SIZE W, CACHESIZE *STACKCOUNT\012\012#define _CMTL_CNTX_II_OFFSET_DYNAMIC 0\012#define _CMTL_CNTX_II_OFFSET_INITIAL 1\012\012#define _CMTL_CSTK_DECIPHER_CONTEXT(cntxt)                                     \\\012  vector_ref<short, W> k = cntxt.row(_CMTL_CSTK_K).template select<W, 1>(0);   \\\012  vector_ref<short, W *STACKCOUNT> chnls_ = cntxt.row(_CMTL_CSTK_CHNL);        \\\012  vector_ref<short, W *STACKCOUNT> k_dup = cntxt.row(_CMTL_CSTK_K);\012\012#define _CMTL_NUM_IO(T) ((CACHESIZE *STACKCOUNT) / _CMTL_MAXIOLINEAR(T))\012\012template <typename T, int W, uint CACHESIZE, uint STACKCOUNT>\012CM_INLINE void\012_CSTK_setOffsets(matrix_ref<short, _CMTL_CNTXT_SIZE> context,\012                 vector_ref<int, W> surf_pos,\012                 matrix_ref<int, _CMTL_NUM_IO(T), W> surf_offset) {\012  cm_assert((CACHESIZE",
" * STACKCOUNT) % _CMTL_MAXIOLINEAR(T) == 0);\012  _CMTL_CSTK_DECIPHER_CONTEXT(context);\012  surf_offset.row(0) = surf_pos;\012\012#if defined(__ICL) || defined(__CMC)\012#pragma unroll\012#endif\012  for (int offset = 1; offset < (int)_CMTL_NUM_IO(T); offset++) {\012    surf_offset.row(offset) =\012        surf_offset.row(offset - 1) + _CMTL_MAXIOLINEAR(T) * sizeof(T);\012  }\012}\012\012template <int W, uint STACKCOUNT>\012CM_INLINE void _CSTKAssert(matrix_ref<short, _CMTL_CNTXT_SIZE> context,\012                           matrix_ref<int, 2, W> context_ii) {\012  vector<short, W> empty;\012  CachedStackEmpty<W, STACKCOUNT>(context, context_ii, empty);\012  cm_assert(empty.any() == false);\012  // TODO add check for full stack\012}\012\012template <typename T, int W, uint CACHESIZE, uint STACKCOUNT>\012CM_INLINE void\012_CSTKWriteBuffers(SurfaceIndex surf,\012                  matrix_ref<short, _CMTL_CNTXT_SIZE> context,\012                  matrix_ref<int, 2, W> context_ii,\012                  matrix_ref<T, _CMTL_STACK_SIZE> stack) {\012  _CMTL_CSTK_DECIPHER_CONTEXT(context);\012  vector_ref",
"<int, W> surf_pos = context_ii.row(_CMTL_CNTX_II_OFFSET_DYNAMIC);\012  matrix<int, _CMTL_NUM_IO(T), W> surf_offset;\012\012  _CSTK_setOffsets<T, W, CACHESIZE, STACKCOUNT>(context, surf_pos, surf_offset);\012\012#if defined(__ICL) || defined(__CMC)\012#pragma unroll\012#endif\012  for (int chnl = 0; chnl < W; chnl++) {\012    if (k(chnl) == CACHESIZE) {\012#if defined(__ICL) || defined(__CMC)\012#pragma unroll\012#endif\012      for (int s = 0; s < (int)_CMTL_NUM_IO(T); s++) {\012        vector_ref<T, _CMTL_MAXIOLINEAR(T)> temp =\012            stack.row(chnl).template select<_CMTL_MAXIOLINEAR(T), 1>(\012                s * _CMTL_MAXIOLINEAR(T));\012        write(surf, surf_offset(s, chnl), temp);\012      }\012    }\012  }\012\012  surf_pos.merge(surf_pos + CACHESIZE * STACKCOUNT * sizeof(T),\012                 (k == CACHESIZE));\012  k.merge(0, k == CACHESIZE);\012}\012\012template <typename T, int W, uint CACHESIZE, uint STACKCOUNT>\012CM_INLINE void _CSTKReadBuffers(SurfaceIndex surf,\012                                matrix_ref<short, _CMTL_CNTXT_SIZE> context,\012                           ",
"     matrix_ref<int, 2, W> context_ii,\012                                matrix_ref<T, _CMTL_STACK_SIZE> stack) {\012  _CMTL_CSTK_DECIPHER_CONTEXT(context);\012  vector_ref<int, W> surf_pos = context_ii.row(_CMTL_CNTX_II_OFFSET_DYNAMIC);\012\012  surf_pos.merge(surf_pos - CACHESIZE * STACKCOUNT * sizeof(T), k == -1);\012\012  matrix<int, _CMTL_NUM_IO(T), W> surf_offset;\012  _CSTK_setOffsets<T, W, CACHESIZE, STACKCOUNT>(context, surf_pos, surf_offset);\012\012#if defined(__ICL) || defined(__CMC)\012#pragma unroll\012#endif\012  for (int chnl = 0; chnl < W; chnl++) {\012    if (k(chnl) == -1) {\012#if defined(__ICL) || defined(__CMC)\012#pragma unroll\012#endif\012      for (int s = 0; s < (int)_CMTL_NUM_IO(T); s++) {\012        vector_ref<T, _CMTL_MAXIOLINEAR(T)> temp =\012            stack.row(chnl).template select<_CMTL_MAXIOLINEAR(T), 1>(\012                s * _CMTL_MAXIOLINEAR(T));\012        read(MODIFIED(surf), surf_offset(s, chnl), temp);\012      }\012    }\012  }\012  k.merge(CACHESIZE - 1, k == -1);\012  _CSTKAssert<W, STACKCOUNT>(context, context_ii);\012}\012\012const static int _CST",
"K_c_channels[16] = { 0, 1, 2,  3,  4,  5,  6,  7,\012                                          8, 9, 10, 11, 12, 13, 14, 15 };\012\012template <typename T, int W, uint CACHESIZE, uint STACKCOUNT>\012CM_INLINE void CachedStackInit(matrix_ref<short, _CMTL_CNTXT_SIZE> context,\012                               matrix_ref<int, 2, W> context_ii, uint MaxSize) {\012  _CMTL_CSTK_DECIPHER_CONTEXT(context);\012\012  cm_assert(STACKCOUNT > 0);\012\012  vector<short, 16> _chnls(_CSTK_c_channels);\012\012#if defined(__ICL) || defined(__CMC)\012#pragma unroll\012#endif\012  for (int s = 0; s < (int)STACKCOUNT; s++) {\012    chnls_.template select<W, 1>(s *W) = _chnls.template select<W, 1>(0);\012  }\012\012  k = -1;\012\012  ushort x_pos = get_thread_origin_x() * W;\012\012  context_ii.row(_CMTL_CNTX_II_OFFSET_DYNAMIC) =\012      (x_pos + _chnls.template select<W, 1>(0)) * MaxSize * STACKCOUNT *\012      sizeof(T);\012\012  context_ii.row(_CMTL_CNTX_II_OFFSET_INITIAL) =\012      context_ii.row(_CMTL_CNTX_II_OFFSET_DYNAMIC);\012}\012\012template <typename T, int W, uint CACHESIZE, uint STACKCOUNT>\012CM_INLINE void C",
"achedStackTop(SurfaceIndex surf,\012                              matrix_ref<short, _CMTL_CNTXT_SIZE> context,\012                              matrix_ref<int, 2, W> context_ii,\012                              matrix_ref<T, _CMTL_STACK_SIZE> stack,\012                              matrix_ref<T, STACKCOUNT, W> element) {\012  _CMTL_CSTK_DECIPHER_CONTEXT(context);\012  cm_assert_range<short, W>(k, 0, CACHESIZE - 1);\012\012#if defined(__ICL) || defined(__CMC)\012#pragma unroll\012#endif\012  for (int s = W; s < (int)W * STACKCOUNT; s += W) {\012    k_dup.template select<W, 1>(s) =\012        k_dup.template select<W, 1>(s - W) + CACHESIZE;\012  }\012\012  element = stack.iselect(chnls_, k_dup);\012}\012\012template <typename T, int W, uint CACHESIZE, uint STACKCOUNT>\012CM_INLINE void CachedStackTop(SurfaceIndex surf,\012                              matrix_ref<short, _CMTL_CNTXT_SIZE> context,\012                              matrix_ref<int, 2, W> context_ii,\012                              matrix_ref<T, _CMTL_STACK_SIZE> stack,\012                              vector_ref<T, W> e",
"lement, int index) {\012  _CMTL_CSTK_DECIPHER_CONTEXT(context);\012  cm_assert_range<short, W>(k, 0, CACHESIZE - 1);\012\012  int s = index * W;\012  { k_dup.template select<W, 1>(s) = k + CACHESIZE * index; }\012\012  element = stack.iselect(chnls_.template select<W, 1>(0),\012                          k_dup.template select<W, 1>(s));\012}\012\012template <typename T, int W, uint CACHESIZE, uint STACKCOUNT>\012CM_INLINE void CachedStackPop(SurfaceIndex surf,\012                              matrix_ref<short, _CMTL_CNTXT_SIZE> context,\012                              matrix_ref<int, 2, W> context_ii,\012                              matrix_ref<T, _CMTL_STACK_SIZE> stack,\012                              vector_ref<short, W> mask) {\012  _CMTL_CSTK_DECIPHER_CONTEXT(context);\012\012  cm_assert_range<short, W>(k, 0, CACHESIZE - 1);\012  cm_assert_range<short, W>(mask, 0, 1);\012\012  k -= mask;\012  _CSTKAssert<W, STACKCOUNT>(context, context_ii);\012  vector<short, W> isStartOfCache = k + 1;\012\012  if (isStartOfCache.all() == false) {\012    _CSTKReadBuffers<T, W, CACHESIZE, STACKCOUNT>",
"(surf, context, context_ii,\012                                                  stack);\012  }\012}\012\012template <typename T, int W, uint CACHESIZE, uint STACKCOUNT>\012CM_INLINE void CachedStackPop(SurfaceIndex surf,\012                              matrix_ref<short, _CMTL_CNTXT_SIZE> context,\012                              matrix_ref<int, 2, W> context_ii,\012                              matrix_ref<T, _CMTL_STACK_SIZE> stack,\012                              matrix_ref<T, STACKCOUNT, W> element,\012                              vector_ref<short, W> mask) {\012  CachedStackTop<T, W, CACHESIZE, STACKCOUNT>(surf, context, context_ii, stack,\012                                              element);\012  CachedStackPop<T, W, CACHESIZE, STACKCOUNT>(surf, context, context_ii, stack,\012                                              mask);\012}\012\012template <typename T, int W, uint CACHESIZE, uint STACKCOUNT>\012CM_INLINE void CachedStackPush(SurfaceIndex surf,\012                               matrix_ref<short, _CMTL_CNTXT_SIZE> context,\012                         ",
"      matrix_ref<int, 2, W> context_ii,\012                               matrix_ref<T, _CMTL_STACK_SIZE> stack,\012                               matrix_ref<T, STACKCOUNT, W> element) {\012  _CMTL_CSTK_DECIPHER_CONTEXT(context);\012\012  k += 1;\012  cm_assert_range<short, W>(k, 0, CACHESIZE);\012\012  vector<short, W> endOfcache = k - CACHESIZE;\012  if (endOfcache.all() == false) {\012    _CSTKWriteBuffers<T, W, CACHESIZE, STACKCOUNT>(surf, context, context_ii,\012                                                   stack);\012  }\012  vector<short, W *STACKCOUNT> k_sat;\012\012#if defined(__ICL) || defined(__CMC)\012#pragma unroll\012#endif\012  for (int s = 0; s < (int)STACKCOUNT; s++) {\012    k_sat.template select<W, 1>(s *W) =\012        k_dup.template select<W, 1>(0) + CACHESIZE * s;\012  }\012\012  stack.iselect(chnls_, k_sat) = element;\012}\012\012template <int W, uint STACKCOUNT>\012CM_INLINE void CachedStackEmpty(matrix_ref<short, _CMTL_CNTXT_SIZE> context,\012                                matrix_ref<int, 2, W> context_ii,\012                                vector_ref<short, W> is",
"Empty) {\012  _CMTL_CSTK_DECIPHER_CONTEXT(context);\012  vector_ref<int, W> surf_pos = context_ii.row(_CMTL_CNTX_II_OFFSET_DYNAMIC);\012  vector_ref<int, W> surf_initial_pos =\012      context_ii.row(_CMTL_CNTX_II_OFFSET_INITIAL);\012\012  isEmpty = (((surf_pos + k) - surf_initial_pos) < 0);\012}\012\012template <typename T, int W, uint CACHESIZE>\012CM_INLINE void CachedStackInit(matrix_ref<short, 2, W> context,\012                               matrix_ref<int, 2, W> context_ii, uint MaxSize) {\012  CachedStackInit<T, W, CACHESIZE, 1>(context, context_ii, MaxSize);\012}\012\012template <typename T, int W, uint CACHESIZE>\012CM_INLINE void\012CachedStackTop(SurfaceIndex surf, matrix_ref<short, 2, W> context,\012               matrix_ref<int, 2, W> context_ii,\012               matrix_ref<T, W, CACHESIZE> stack, vector_ref<T, W> element) {\012  CachedStackTop<T, W, CACHESIZE, 1>(surf, context, context_ii, stack, element);\012}\012\012template <typename T, int W, uint CACHESIZE>\012CM_INLINE void\012CachedStackPush(SurfaceIndex surf, matrix_ref<short, 2, W> context,\012                ma",
"trix_ref<int, 2, W> context_ii,\012                matrix_ref<T, W, CACHESIZE> stack, vector_ref<T, W> element) {\012  CachedStackPush<T, W, CACHESIZE, 1>(surf, context, context_ii, stack,\012                                      element);\012}\012\012template <typename T, int W, uint CACHESIZE>\012CM_INLINE void\012CachedStackPop(SurfaceIndex surf, matrix_ref<short, 2, W> context,\012               matrix_ref<int, 2, W> context_ii,\012               matrix_ref<T, W, CACHESIZE> stack, vector_ref<T, W> element,\012               vector_ref<short, W> mask) {\012  CachedStackPop<T, W, CACHESIZE, 1>(surf, context, context_ii, stack, element,\012                                     mask);\012}\012\012template <int W>\012CM_INLINE void CachedStackEmpty(matrix_ref<short, 2, W> context,\012                                matrix_ref<int, 2, W> context_ii,\012                                vector_ref<short, W> isEmpty) {\012  CachedStackEmpty<W, 1>(context, context_ii, isEmpty);\012}\012\012/* ------------------------- Matrix transform Routines\012 * --------------------------------------",
"--------*/\012template <typename T, int H, int W>\012CM_INLINE void MirrorVertical(matrix_ref<T, H, W> in, matrix_ref<T, H, W> out) {\012#if defined(__ICL) || defined(__CMC)\012#pragma unroll\012#endif\012  for (int i = 0; i < (int)H; i++) {\012    out.row(i) = in.row(H - i);\012  }\012}\012\012template <typename T>\012CM_INLINE void mirror_horizontal_16x16(matrix_ref<uchar, 16, 16> in,\012                                       matrix_ref<uchar, 16, 16> out) {\012  matrix_ref<uchar, 8, 32> in_temp = in.format<uchar, 8, 32>();\012  matrix_ref<uint, 8, 8> in_temp2 = in_temp.format<uint, 8, 8>();\012  matrix<uint, 8, 8> out_temp;\012\012  matrix_ref<uchar, 8, 32> out_temp1 = out.format<uchar, 8, 32>();\012  matrix_ref<uchar, 8, 32> out_temp2 = out_temp.format<uchar, 8, 32>();\012// matrix_ref <uint, 8, 8> out_temp = out_temp1.format<uint, 8, 8>();;\012\012#if defined(__ICL) || defined(__CMC)\012#pragma unroll\012#endif\012  for (int i = 0; i < 8; i++) {\012    out_temp.row(i).template select<4, 2>(0).merge(\012        in_temp2.row(i).replicate<2, 4, 2, 0>(1),\012        in_temp2.row(i).replicat",
"e<2, 4, 2, 0>(3), 0xAAAA);\012    out_temp.row(i).template select<4, 2>(1).merge(\012        in_temp2.row(i).replicate<2, 4, 2, 0>(0),\012        in_temp2.row(i).replicate<2, 4, 2, 0>(2), 0xAAAA);\012  }\012\012#if defined(__ICL) || defined(__CMC)\012#pragma unroll\012#endif\012  for (int i = 0; i < 8; i++) {\012    out_temp1.row(i).template select<16, 2>(0).merge(\012        out_temp2.row(i).replicate<8, 4, 2, 0>(1),\012        out_temp2.row(i).replicate<8, 4, 2, 0>(3), 0xAAAA);\012    out_temp1.row(i).template select<16, 2>(1).merge(\012        out_temp2.row(i).replicate<8, 4, 2, 0>(0),\012        out_temp2.row(i).replicate<8, 4, 2, 0>(2), 0xAAAA);\012  }\012}\012\012template <typename T>\012CM_INLINE void MirrorHorizontal_16x16(matrix_ref<T, 16, 16> in,\012                                      matrix_ref<T, 16, 16> out) {\012  matrix<T, 16, 16> out_temp;\012  Rotate270_16x16<T>(in, out_temp);\012  Transpose_16x16<T>(out_temp, out);\012}\012\012template <typename T>\012CM_INLINE void Rotate90_16x16(matrix_ref<T, 16, 16> in,\012                              matrix_ref<T, 16, 16> out) {\012  matri",
"x<T, 16, 16> out_temp;\012  MirrorVertical<T, 16, 16>(in, out_temp);\012  Transpose_16x16<T>(out_temp, out);\012}\012\012template <typename T>\012CM_INLINE void Rotate270_16x16(matrix_ref<T, 16, 16> in,\012                               matrix_ref<T, 16, 16> out) {\012  matrix<T, 16, 16> bBuf;\012  // transpose + v_mirror\012  bBuf.row(0) = in.template select<4, 1, 4, 4>(0, 0);   // 0,4,8,c\012  bBuf.row(1) = in.template select<4, 1, 4, 4>(4, 0);   // 0,4,8,c\012  bBuf.row(2) = in.template select<4, 1, 4, 4>(8, 0);   // 0,4,8,c\012  bBuf.row(3) = in.template select<4, 1, 4, 4>(12, 0);  // 0,4,8,c\012  bBuf.row(4) = in.template select<4, 1, 4, 4>(0, 1);   // 1,5,9,d\012  bBuf.row(5) = in.template select<4, 1, 4, 4>(4, 1);   // 1,5,9,d\012  bBuf.row(6) = in.template select<4, 1, 4, 4>(8, 1);   // 1,5,9,d\012  bBuf.row(7) = in.template select<4, 1, 4, 4>(12, 1);  // 1,5,9,d\012  bBuf.row(8) = in.template select<4, 1, 4, 4>(0, 2);   // 2,6,a,e\012  bBuf.row(9) = in.template select<4, 1, 4, 4>(4, 2);   // 2,6,a,e\012  bBuf.row(10) = in.template select<4, 1, 4, 4>(8, 2);  /",
"/ 2,6,a,e\012  bBuf.row(11) = in.template select<4, 1, 4, 4>(12, 2); // 2,6,a,e\012  bBuf.row(12) = in.template select<4, 1, 4, 4>(0, 3);  // 3,7,b,f\012  bBuf.row(13) = in.template select<4, 1, 4, 4>(4, 3);  // 3,7,b,f\012  bBuf.row(14) = in.template select<4, 1, 4, 4>(8, 3);  // 3,7,b,f\012  bBuf.row(15) = in.template select<4, 1, 4, 4>(12, 3); // 3,7,b,f\012\012  out.row(15) = bBuf.template select<4, 1, 4, 4>(0, 0);  // 0\012  out.row(14) = bBuf.template select<4, 1, 4, 4>(4, 0);  // 1\012  out.row(13) = bBuf.template select<4, 1, 4, 4>(8, 0);  // 2\012  out.row(12) = bBuf.template select<4, 1, 4, 4>(12, 0); // 3\012  out.row(11) = bBuf.template select<4, 1, 4, 4>(0, 1);  // 4\012  out.row(10) = bBuf.template select<4, 1, 4, 4>(4, 1);  // 5\012  out.row(9) = bBuf.template select<4, 1, 4, 4>(8, 1);   // 6\012  out.row(8) = bBuf.template select<4, 1, 4, 4>(12, 1);  // 7\012  out.row(7) = bBuf.template select<4, 1, 4, 4>(0, 2);   // 8\012  out.row(6) = bBuf.template select<4, 1, 4, 4>(4, 2);   // 9\012  out.row(5) = bBuf.template select<4, 1, 4, 4>(8, 2);   /",
"/ a\012  out.row(4) = bBuf.template select<4, 1, 4, 4>(12, 2);  // b\012  out.row(3) = bBuf.template select<4, 1, 4, 4>(0, 3);   // c\012  out.row(2) = bBuf.template select<4, 1, 4, 4>(4, 3);   // d\012  out.row(1) = bBuf.template select<4, 1, 4, 4>(8, 3);   // e\012  out.row(0) = bBuf.template select<4, 1, 4, 4>(12, 3);  // f\012}\012\012template <typename T>\012CM_INLINE void Rotate180_16x16(matrix_ref<T, 16, 16> in,\012                               matrix_ref<T, 16, 16> out) {\012  matrix<T, 16, 16> out_temp;\012  Rotate270_16x16<T>(in, out_temp);\012  Rotate270_16x16<T>(out_temp, out);\012}\012\012template <typename T>\012CM_INLINE void Transpose_16x16(matrix_ref<T, 16, 16> in,\012                               matrix_ref<T, 16, 16> out) {\012  matrix<T, 16, 16> bBuf;\012  bBuf.row(0) = in.template select<4, 1, 4, 4>(0, 0);   // 0,4,8,c\012  bBuf.row(1) = in.template select<4, 1, 4, 4>(4, 0);   // 0,4,8,c\012  bBuf.row(2) = in.template select<4, 1, 4, 4>(8, 0);   // 0,4,8,c\012  bBuf.row(3) = in.template select<4, 1, 4, 4>(12, 0);  // 0,4,8,c\012  bBuf.row(4) = in.template s",
"elect<4, 1, 4, 4>(0, 1);   // 1,5,9,d\012  bBuf.row(5) = in.template select<4, 1, 4, 4>(4, 1);   // 1,5,9,d\012  bBuf.row(6) = in.template select<4, 1, 4, 4>(8, 1);   // 1,5,9,d\012  bBuf.row(7) = in.template select<4, 1, 4, 4>(12, 1);  // 1,5,9,d\012  bBuf.row(8) = in.template select<4, 1, 4, 4>(0, 2);   // 2,6,a,e\012  bBuf.row(9) = in.template select<4, 1, 4, 4>(4, 2);   // 2,6,a,e\012  bBuf.row(10) = in.template select<4, 1, 4, 4>(8, 2);  // 2,6,a,e\012  bBuf.row(11) = in.template select<4, 1, 4, 4>(12, 2); // 2,6,a,e\012  bBuf.row(12) = in.template select<4, 1, 4, 4>(0, 3);  // 3,7,b,f\012  bBuf.row(13) = in.template select<4, 1, 4, 4>(4, 3);  // 3,7,b,f\012  bBuf.row(14) = in.template select<4, 1, 4, 4>(8, 3);  // 3,7,b,f\012  bBuf.row(15) = in.template select<4, 1, 4, 4>(12, 3); // 3,7,b,f\012\012  out.row(0) = bBuf.template select<4, 1, 4, 4>(0, 0);   // 0\012  out.row(1) = bBuf.template select<4, 1, 4, 4>(4, 0);   // 1\012  out.row(2) = bBuf.template select<4, 1, 4, 4>(8, 0);   // 2\012  out.row(3) = bBuf.template select<4, 1, 4, 4>(12, 0);  // 3\012",
"  out.row(4) = bBuf.template select<4, 1, 4, 4>(0, 1);   // 4\012  out.row(5) = bBuf.template select<4, 1, 4, 4>(4, 1);   // 5\012  out.row(6) = bBuf.template select<4, 1, 4, 4>(8, 1);   // 6\012  out.row(7) = bBuf.template select<4, 1, 4, 4>(12, 1);  // 7\012  out.row(8) = bBuf.template select<4, 1, 4, 4>(0, 2);   // 8\012  out.row(9) = bBuf.template select<4, 1, 4, 4>(4, 2);   // 9\012  out.row(10) = bBuf.template select<4, 1, 4, 4>(8, 2);  // a\012  out.row(11) = bBuf.template select<4, 1, 4, 4>(12, 2); // b\012  out.row(12) = bBuf.template select<4, 1, 4, 4>(0, 3);  // c\012  out.row(13) = bBuf.template select<4, 1, 4, 4>(4, 3);  // d\012  out.row(14) = bBuf.template select<4, 1, 4, 4>(8, 3);  // e\012  out.row(15) = bBuf.template select<4, 1, 4, 4>(12, 3); // f\012}\012\012template <typename T>\012CM_INLINE void Transpose_8x8(matrix_ref<T, 8, 8> in, matrix_ref<T, 8, 8> out) {\012  matrix<T, 8, 8> temp;\012  temp.row(0) = in.template select<2, 1, 4, 2>(0, 0);\012  temp.row(1) = in.template select<2, 1, 4, 2>(2, 0);\012  temp.row(2) = in.template select<2, 1, 4,",
" 2>(4, 0);\012  temp.row(3) = in.template select<2, 1, 4, 2>(6, 0);\012  temp.row(4) = in.template select<2, 1, 4, 2>(0, 1);\012  temp.row(5) = in.template select<2, 1, 4, 2>(2, 1);\012  temp.row(6) = in.template select<2, 1, 4, 2>(4, 1);\012  temp.row(7) = in.template select<2, 1, 4, 2>(6, 1);\012\012  out.row(0) = temp.template select<4, 1, 2, 4>(0, 0);\012  out.row(2) = temp.template select<4, 1, 2, 4>(0, 1);\012  out.row(4) = temp.template select<4, 1, 2, 4>(0, 2);\012  out.row(6) = temp.template select<4, 1, 2, 4>(0, 3);\012  out.row(1) = temp.template select<4, 1, 2, 4>(4, 0);\012  out.row(3) = temp.template select<4, 1, 2, 4>(4, 1);\012  out.row(5) = temp.template select<4, 1, 2, 4>(4, 2);\012  out.row(7) = temp.template select<4, 1, 2, 4>(4, 3);\012}\012\012template <typename T>\012CM_INLINE void ReverseTranspose_16x16(matrix_ref<T, 16, 16> in,\012                                      matrix_ref<T, 16, 16> out) {\012  matrix<T, 16, 16> out_temp;\012  MirrorVertical<T, 16, 16>(in, out_temp);\012  Rotate270_16x16<T>(out_temp, out);\012}\012\012template <typename T, int W>\012CM_I",
"NLINE void Map(matrix_ref<T, W, W> in, matrix_ref<T, W, W> out,\012                   vector_ref<ushort, W *W> mapping) {\012  out = in.template format<T>().iselect(mapping);\012}\012\012/* ------------------------- Assignment Routines\012 * ----------------------------------------------------*/\012template <typename T, uint Size>\012CM_INLINE void cm_vector_assign(vector_ref<T, Size> v, int InitValue,\012                                int Step) {\012  T nextInitValue;\012  vector<T, 8> initVec(__CM_init_array_0_7);\012\012  v.template select<8, 1>(0) = initVec * Step;\012  v.template select<8, 1>(0) += InitValue;\012  nextInitValue = 8 * Step;\012\012  enum {\012    Size8x = (Size / 8) * 8\012  };\012\012#if defined(__ICL) || defined(__CMC)\012#pragma unroll\012#endif\012  for (int i = 0; i < (Size8x - 8); i += 8) {\012    v.template select<8, 1>(i + 8) = v.template select<8, 1>(i) + nextInitValue;\012  }\012\012  // Remainder elements\012  __RemainderInit<(Size - Size8x), T, Size> rInit;\012  rInit.__CM_remainder_init(v, nextInitValue);\012}\012\012/* ------------------------- Extended Math Routines\012 * ",
"-------------------------------------------------*/\012\012template <int R, int C>\012CM_INLINE matrix<float, R, C>\012cm_atan2_fast(matrix<float, R, C> y, matrix<float, R, C> x, const uint flags) {\012  vector<float, R *C> a0;\012  vector<float, R *C> a1;\012  matrix<float, R, C> atan2;\012\012  vector<unsigned short, R *C> mask = (y >= 0);\012  a0.merge(CM_CONST_PI * 0.5, CM_CONST_PI * 1.5, mask);\012  a1.merge(0, CM_CONST_PI * 2, mask);\012\012  a1.merge(CM_CONST_PI, x < 0);\012\012  matrix<float, R, C> xy = x * y;\012  matrix<float, R, C> x2 = x * x;\012  matrix<float, R, C> y2 = y * y;\012\012  a0 -= (xy / (y2 + 0.28f * x2 + CM_DBL_EPSILON));\012  a1 += (xy / (x2 + 0.28f * y2 + CM_DBL_EPSILON));\012\012  atan2.merge(a1, a0, y2 <= x2);\012  if (flags & SAT)\012    atan2 = matrix<float, R, C>(atan2, SAT);\012  return atan2;\012}\012\012template <int R, int C>\012CM_INLINE matrix<float, R, C> cm_atan2_fast(matrix_ref<float, R, C> y,\012                                            matrix_ref<float, R, C> x,\012                                            const uint flags) {\012  vector<float, R *C> a0;\012 ",
" vector<float, R *C> a1;\012  matrix<float, R, C> atan2;\012\012  vector<unsigned short, R *C> mask = (y >= 0);\012  a0.merge(CM_CONST_PI * 0.5, CM_CONST_PI * 1.5, mask);\012  a1.merge(0, CM_CONST_PI * 2, mask);\012\012  a1.merge(CM_CONST_PI, x < 0);\012\012  matrix<float, R, C> xy = x * y;\012  matrix<float, R, C> x2 = x * x;\012  matrix<float, R, C> y2 = y * y;\012\012  a0 -= (xy / (y2 + 0.28f * x2 + CM_DBL_EPSILON));\012  a1 += (xy / (x2 + 0.28f * y2 + CM_DBL_EPSILON));\012\012  atan2.merge(a1, a0, y2 <= x2);\012  if (flags & SAT)\012    atan2 = matrix<float, R, C>(atan2, SAT);\012  return atan2;\012}\012\012// For vector input\012template <int N>\012CM_INLINE vector<float, N> cm_atan2_fast(vector<float, N> y, vector<float, N> x,\012                                         const uint flags) {\012  vector<float, N> a0;\012  vector<float, N> a1;\012  vector<float, N> atan2;\012\012  vector<unsigned short, N> mask = (y >= 0.0f);\012  a0.merge(CM_CONST_PI * 0.5f, CM_CONST_PI * 1.5f, mask);\012  a1.merge(0, CM_CONST_PI * 2.0f, mask);\012\012  a1.merge(CM_CONST_PI, x < 0.0f);\012\012  vector<float, N> xy = x * y;\012  ve",
"ctor<float, N> x2 = x * x;\012  vector<float, N> y2 = y * y;\012\012  a0 -= (xy / (y2 + 0.28f * x2 + CM_DBL_EPSILON));\012  a1 += (xy / (x2 + 0.28f * y2 + CM_DBL_EPSILON));\012\012  atan2.merge(a1, a0, y2 <= x2);\012  if (flags & SAT)\012    atan2 = vector<float, N>(atan2, SAT);\012  return atan2;\012}\012\012// For vector_ref input\012template <int N>\012CM_INLINE vector<float, N> cm_atan2_fast(vector_ref<float, N> y,\012                                         vector_ref<float, N> x,\012                                         const uint flags) {\012  vector<float, N> a0;\012  vector<float, N> a1;\012  vector<float, N> atan2;\012\012  vector<unsigned short, N> mask = (y >= 0.0f);\012  a0.merge(CM_CONST_PI * 0.5f, CM_CONST_PI * 1.5f, mask);\012  a1.merge(0, CM_CONST_PI * 2.0f, mask);\012\012  a1.merge(CM_CONST_PI, x < 0.0f);\012\012  vector<float, N> xy = x * y;\012  vector<float, N> x2 = x * x;\012  vector<float, N> y2 = y * y;\012\012  a0 -= (xy / (y2 + 0.28f * x2 + CM_DBL_EPSILON));\012  a1 += (xy / (x2 + 0.28f * y2 + CM_DBL_EPSILON));\012\012  atan2.merge(a1, a0, y2 <= x2);\012  if (flags & SAT)\012    atan2 =",
" vector<float, N>(atan2, SAT);\012  return atan2;\012}\012\012//   For Scalar Input\012template <> CM_INLINE float cm_atan2_fast(float y, float x, const uint flags) {\012  vector<float, 1> vy = y;\012  vector<float, 1> vx = x;\012  vector<float, 1> atan2 =\012      cm_atan2_fast(vy.select_all(), vx.select_all(), flags);\012  return atan2(0);\012}\012\012// cm_atan2\012// For matrix input\012template <int R, int C>\012CM_INLINE matrix<float, R, C>\012cm_atan2(matrix<float, R, C> y, matrix<float, R, C> x, const uint flags) {\012  vector<float, R *C> v_distance;\012  vector<float, R *C> v_y0;\012  matrix<float, R, C> atan2;\012  vector<unsigned short, R *C> mask;\012\012  mask = (x < 0);\012  v_y0.merge(CM_CONST_PI, 0, mask);\012  v_distance = cm_sqrt(x * x + y * y);\012  mask = (cm_abs<float>(y - 0.0f) < 0.000001f);\012  atan2.merge(v_y0, (2 * cm_atan((v_distance - x) / y)), mask);\012  if (flags & SAT)\012    atan2 = matrix<float, R, C>(atan2, SAT);\012\012  return atan2;\012}\012\012// For matrix ref input\012template <int R, int C>\012CM_INLINE matrix<float, R, C> cm_atan2(matrix_ref<float, R, C> y,\012              ",
"                         matrix_ref<float, R, C> x,\012                                       const uint flags) {\012  vector<float, R *C> v_distance;\012  vector<float, R *C> v_y0;\012  matrix<float, R, C> atan2;\012  vector<unsigned short, R *C> mask;\012\012  mask = (x < 0);\012  v_y0.merge(CM_CONST_PI, 0, mask);\012  v_distance = cm_sqrt(x * x + y * y);\012  mask = (cm_abs<float>(y - 0.0f) < 0.000001f);\012  atan2.merge(v_y0, (2 * cm_atan((v_distance - x) / y)), mask);\012  if (flags & SAT)\012    atan2 = matrix<float, R, C>(atan2, SAT);\012\012  return atan2;\012}\012\012// For Vector input\012template <int N>\012CM_INLINE vector<float, N> cm_atan2(vector<float, N> y, vector<float, N> x,\012                                    const uint flags) {\012  vector<float, N> v_distance;\012  vector<float, N> v_y0;\012  vector<float, N> atan2;\012  vector<unsigned short, N> mask;\012\012  mask = (x < 0);\012  v_y0.merge(CM_CONST_PI, 0, mask);\012  v_distance = cm_sqrt(x * x + y * y);\012  mask = (cm_abs<float>(y - 0.0f) < 0.000001f);\012  atan2.merge(v_y0, (2 * cm_atan((v_distance - x) / y)), mask);\012  if",
" (flags & SAT)\012    atan2 = vector<float, N>(atan2, SAT);\012\012  return atan2;\012}\012\012// For Vector ref input\012template <int N>\012CM_INLINE vector<float, N> cm_atan2(vector_ref<float, N> y,\012                                    vector_ref<float, N> x, const uint flags) {\012  vector<float, N> v_distance;\012  vector<float, N> v_y0;\012  vector<float, N> atan2;\012  vector<unsigned short, N> mask;\012\012  mask = (x < 0);\012  v_y0.merge(CM_CONST_PI, 0, mask);\012  v_distance = cm_sqrt(x * x + y * y);\012  mask = (cm_abs<float>(y - 0.0f) < 0.000001f);\012  atan2.merge(v_y0, (2 * cm_atan((v_distance - x) / y)), mask);\012  if (flags & SAT)\012    atan2 = vector<float, N>(atan2, SAT);\012\012  return atan2;\012}\012\012// For Scalar Input\012template <> CM_INLINE float cm_atan2(float y, float x, const uint flags) {\012  float v_distance;\012  float v_y0;\012  vector<float, 1> atan2;\012  unsigned short mask;\012\012  mask = (x < 0);\012  v_y0 = mask \? CM_CONST_PI : 0;\012  v_distance = cm_sqrt<float>(x * x + y * y);\012  mask = (cm_abs<float>(y - 0.0f) < 0.000001f);\012  atan2.merge(v_y0, (2 * cm_atan((v_dis",
"tance - x) / y)), mask);\012  if (flags & SAT)\012    atan2 = vector<float, 1>(atan2, SAT);\012\012  return atan2(0);\012}\012\012// cm_fmod:\012// For matrix input\012template <int R, int C>\012CM_INLINE matrix<float, R, C> cm_fmod(matrix<float, R, C> y,\012                                      matrix<float, R, C> x, const uint flags) {\012  vector<int, R *C> v_quot;\012  matrix<float, R, C> fmod;\012\012  v_quot = vector<int, R *C>(y / x);\012  fmod = y - x * matrix<float, R, C>(v_quot);\012  if (flags & SAT)\012    fmod = matrix<float, R, C>(fmod, SAT);\012\012  return fmod;\012}\012\012// For matrix ref input\012template <int R, int C>\012CM_INLINE matrix<float, R, C> cm_fmod(matrix_ref<float, R, C> y,\012                                      matrix_ref<float, R, C> x,\012                                      const uint flags) {\012  vector<int, R *C> v_quot;\012  matrix<float, R, C> fmod;\012\012  v_quot = vector<int, R *C>(y / x);\012  fmod = y - x * matrix<float, R, C>(v_quot);\012  if (flags & SAT)\012    fmod = matrix<float, R, C>(fmod, SAT);\012\012  return fmod;\012}\012\012// For Vector input\012template <int N>\012CM",
"_INLINE vector<float, N> cm_fmod(vector<float, N> y, vector<float, N> x,\012                                   const uint flags) {\012  vector<int, N> v_quot;\012  vector<float, N> fmod;\012\012  v_quot = vector<int, N>(y / x);\012  fmod = y - x * vector<float, N>(v_quot);\012  if (flags & SAT)\012    fmod = vector<float, N>(fmod, SAT);\012\012  return fmod;\012}\012\012// For Vector ref input\012template <int N>\012CM_INLINE vector<float, N> cm_fmod(vector_ref<float, N> y,\012                                   vector_ref<float, N> x, const uint flags) {\012  vector<int, N> v_quot;\012  vector<float, N> fmod;\012\012  v_quot = vector<int, N>(y / x);\012  fmod = y - x * vector<float, N>(v_quot);\012  if (flags & SAT)\012    fmod = vector<float, N>(fmod, SAT);\012\012  return fmod;\012}\012\012//     For Scalar Input\012template <> CM_INLINE float cm_fmod(float y, float x, const uint flags) {\012  int v_quot;\012  vector<float, 1> fmod;\012\012  v_quot = (int)y / x;\012  fmod(0) = y - x * v_quot;\012  if (flags & SAT)\012    fmod = vector<float, 1>(fmod, SAT);\012\012  return fmod(0);\012}\012\012#define CMPI\011\011\0113.14159265f\012\012// cm_s",
"in_emu - EU emulation for sin(x)\012\012// For matrix input\012template <int R, int C>\012CM_INLINE matrix<float, R, C> cm_sin_emu(matrix<float, R, C> x, const uint flags) {\012  matrix<float, R, C> x1;\012  matrix<float, R, C> x2;\012  matrix<float, R, C> t3;\012\012  matrix<float, R, C> sign;\012  matrix<float, R, C> fTrig;\012  matrix <float, R, C> TwoPI(6.2831853f);\012\012  x = cm_fmod(x, TwoPI);\012\012  // 1st quadrant: sin(x) = sin(x)\012  // 2nd quadrant: sin(x) = sin(PI-x)\012  // 3rd quadrant: sin(x) = -sin(x-PI)\012  // 4th quadrant: sin(x) = -sin(2*PI-x)\012  x1.merge(CMPI -x, x- CMPI, (x <= CMPI));\012  x1.merge(x, (x <= CMPI*0.5f));\012  x1.merge(2* CMPI -x, (x > CMPI*1.5f));\012\012  sign.merge(-1, 1, (x > CMPI));\012\012  // Sine Taylor series\012  x2 = x1 * x1;\012  t3 = x2 * x1 * 0.1666667f;\011// 1/6 = 0.1666667f\012\012  //t5 = t3 * x2/20;\012  //t7 = t5 * x2/42;\012  //t9 = t7 * x2/72;\012  //t11 = t9 * x2/110;\012  //fTrig = x1 - t3 + t5 - t7 + t9 - t11;\012\012  // Optimized:\012  //fTrig = x - t3 + t5 - t7 + t9 - t11;\012  //fTrig = x - t3 + (x2/20 * t3) - (x2/42 * x2/20 * t3) + (x2/72 * x2/42 * ",
"x2/20 * t3) - (x2/110 * x2/72 * x2/42 * x2/20 * t3);\012  //fTrig = x + t3*(-1 + x2/20 - x2/42 * x2/20 + x2/72 * x2/42 * x2/20 - x2/110 * x2/72 * x2/42 * x2/20);\012  //fTrig = x + t3*(-1 + x2/20 * (1 - x2/42 + x2/72 * x2/42 - x2/110 * x2/72 * x2/42));\012  //fTrig = x + t3*(-1 + x2/20 * (1 + x2/42 * (-1 + x2/72 - x2/110 * x2/72)));\012  //fTrig = x + t3*(-1 + x2/20 * (1 + x2/42 * (-1 + x2/72 *(1 - x2/110))));\012  // 1/20 = 0.05f\012  // 1/42 = 0.0238095f\012  // 1/72 = 0.0138889f\012  // 1/110 = 0.0090909f\012  fTrig = x1 + t3 * (-1 + x2*0.05f * (1 + x2*0.0238095f * (-1 + x2*0.0138889f * (1 - x2*0.0090909f))));\012  fTrig *= sign;\012\012  if (flags & SAT)\012    fTrig = matrix<float, R, C>(fTrig, SAT);\012\012  return fTrig;\012}\012\012// matrix_ref input\012template <int R, int C>\012CM_INLINE matrix<float, R, C> cm_sin_emu(matrix_ref<float, R, C> x, const uint flags) {\012  matrix<float, R, C> x1;\012  matrix<float, R, C> x2;\012  matrix<float, R, C> t3;\012\012  matrix<float, R, C> sign;\012  matrix<float, R, C> fTrig;\012  matrix<float, R, C> TwoPI(6.2831853f);\012\012  x = cm_fmod(x, T",
"woPI);\012\012  x1.merge(CMPI -x, x- CMPI, (x <= CMPI));\012  x1.merge(x, (x <= CMPI*0.5f));\012  x1.merge(2* CMPI -x, (x > CMPI*1.5f));\012\012  sign.merge(-1, 1, (x > CMPI));\012\012  x2 = x1 * x1;\012  t3 = x2 * x1 * 0.1666667f;\012\012  fTrig = x1 + t3 * (-1 + x2*0.05f * (1 + x2*0.0238095f * (-1 + x2*0.0138889f * (1 - x2*0.0090909f))));\012  fTrig *= sign;\012\012  if (flags & SAT)\012    fTrig = matrix<float, R, C>(fTrig, SAT);\012\012  return fTrig;\012}\012\012// For Vector input\012template <int N>\012CM_INLINE vector<float, N> cm_sin_emu(vector<float, N> x, const uint flags) {\012  vector<float, N> x1;\012  vector<float, N> x2;\012  vector<float, N> t3;\012\012  vector<float, N> sign;\012  vector<float, N> fTrig;\012  vector<float, N> TwoPI(6.2831853f);\012\012  x = cm_fmod(x, TwoPI);\012\012  x1.merge(CMPI - x, x - CMPI, (x <= CMPI));\012  x1.merge(x, (x <= CMPI*0.5f));\012  x1.merge(2 * CMPI - x, (x > CMPI*1.5f));\012\012  sign.merge(-1, 1, (x > CMPI));\012\012  x2 = x1 * x1;\012  t3 = x2 * x1 * 0.1666667f;\012\012  fTrig = x1 + t3 * (-1 + x2*0.05f * (1 + x2*0.0238095f * (-1 + x2*0.0138889f * (1 - x2*0.0090909f))));\012  fTr",
"ig *= sign;\012\012  if (flags & SAT)\012    fTrig = vector<float, N>(fTrig, SAT);\012\012  return fTrig;\012}\012\012// vector_ref input\012template <int N>\012CM_INLINE  vector<float, N> cm_sin_emu(vector_ref<float, N> x, const uint flags) {\012  vector<float, N> x1;\012  vector<float, N> x2;\012  vector<float, N> t3;\012\012  vector<float, N> sign;\012  vector<float, N> fTrig;\012  vector<float, N> TwoPI(6.2831853f);\012\012  x = cm_fmod(x, TwoPI);\012\012  x1.merge(CMPI - x, x - CMPI, (x <= CMPI));\012  x1.merge(x, (x <= CMPI*0.5f));\012  x1.merge(2 * CMPI - x, (x > CMPI*1.5f));\012\012  sign.merge(-1, 1, (x > CMPI));\012\012  x2 = x1 * x1;\012  t3 = x2 * x1 * 0.1666667f;\012\012  fTrig = x1 + t3 * (-1 + x2*0.05f * (1 + x2*0.0238095f * (-1 + x2*0.0138889f * (1 - x2*0.0090909f))));\012  fTrig *= sign;\012\012  if (flags & SAT)\012    fTrig = vector<float, N>(fTrig, SAT);\012\012  return fTrig;\012}\012\012// scalar Input\012template <typename T>\012CM_INLINE float cm_sin_emu(T x, const uint flags) {\012  vector<float, 1> x1;\012  vector<float, 1> x2;\012  vector<float, 1> t3;\012\012  vector<float, 1> sign;\012  vector<float, 1> fTrig;\012  float ",
"TwoPI = CMPI*2.0f;\012\012  x = cm_fmod(x, TwoPI);\012\012  x1.merge(CMPI - x, x - CMPI, (x <= CMPI));\012  x1.merge(x, (x <= CMPI*0.5f));\012  x1.merge(2 * CMPI - x, (x > CMPI*1.5f));\012\012  sign.merge(-1, 1, (x > CMPI));\012\012  x2 = x1 * x1;\012  t3 = x2 * x1 * 0.1666667f;\012\012  fTrig = x1 + t3 * (-1 + x2*0.05f * (1 + x2*0.0238095f * (-1 + x2*0.0138889f * (1 - x2*0.0090909f))));\012  fTrig *= sign;\012\012  if (flags & SAT)\012    fTrig = vector<float, 1>(fTrig, SAT);\012\012  return fTrig(0);\012}\012\012// cm_cos_emu - EU emulation for sin(x)\012\012// For matrix input\012template <int R, int C>\012CM_INLINE matrix<float, R, C> cm_cos_emu(matrix<float, R, C> x, const uint flags) {\012  matrix<float, R, C> x1;\012  matrix<float, R, C> x2;\012  matrix<float, R, C> t2;\012  matrix<float, R, C> t3;\012\012  matrix<float, R, C> sign;\012  matrix<float, R, C> fTrig;\012  matrix <float, R, C> TwoPI(6.2831853f);\012\012  x = cmtl::cm_fmod(x, TwoPI);\012\012  // Use 1st quadrant sin(x) to derive cos(x) of all 4 quadrants.\012  // 1st quadrant: cos(x) = sin(PI/2-x)\012  // 2nd quadrant: cos(x) = -sin(x-PI/2)\012  // 3rd quadrant",
": cos(x) = -sin(PI*3/2-x)\012  // 4th quadrant: cos(x) = sin(x-PI*3/2)\012  x1.merge(x - CMPI*0.5f, CMPI*1.5f - x, (x <= CMPI));\012  x1.merge(CMPI*0.5f - x, (x <= CMPI*0.5f));\012  x1.merge(x - CMPI*1.5f, (x > CMPI*1.5f));\012\012  sign.merge(1, -1, ((x < CMPI*0.5f) | (x >= CMPI*1.5f)));\012\012  // Sine Taylor series\012  x2 = x1 * x1;\012  t3 = x2 * x1 * 0.1666667f;\011// 1/6 = 0.1666667f\012  fTrig = x1 + t3 * (-1 + x2*0.05f * (1 + x2*0.0238095f * (-1 + x2*0.0138889f * (1 - x2*0.0090909f))));\012  fTrig *= sign;\012\012  if (flags & SAT)\012    fTrig = matrix<float, R, C>(fTrig, SAT);\012\012  return fTrig;\012}\012\012// matrix_ref input\012template <int R, int C>\012CM_INLINE matrix<float, R, C> cm_cos_emu(matrix_ref<float, R, C> x, const uint flags) {\012  matrix<float, R, C> x1;\012  matrix<float, R, C> x2;\012  matrix<float, R, C> t2;\012  matrix<float, R, C> t3;\012\012  matrix<float, R, C> sign;\012  matrix<float, R, C> fTrig;\012  matrix <float, R, C> TwoPI(6.2831853f);\012\012  x = cmtl::cm_fmod(x, TwoPI);\012\012  x1.merge(x - CMPI*0.5f, CMPI*1.5f - x, (x <= CMPI));\012  x1.merge(CMPI*0.5f - x, (x <= ",
"CMPI*0.5f));\012  x1.merge(x - CMPI*1.5f, (x > CMPI*1.5f));\012\012  sign.merge(1, -1, ((x < CMPI*0.5f) | (x >= CMPI*1.5f)));\012\012  x2 = x1 * x1;\012  t3 = x2 * x1 * 0.1666667f;\012  fTrig = x1 + t3 * (-1 + x2*0.05f * (1 + x2*0.0238095f * (-1 + x2*0.0138889f * (1 - x2*0.0090909f))));\012  fTrig *= sign;\012\012  if (flags & SAT)\012    fTrig = matrix<float, R, C>(fTrig, SAT);\012\012  return fTrig;\012}\012\012// For Vector input\012template <int N>\012CM_INLINE vector<float, N> cm_cos_emu(vector<float, N> x, const uint flags) {\012  vector<float, N> x1;\012  vector<float, N> x2;\012  vector<float, N> t2;\012  vector<float, N> t3;\012\012  vector<float, N> sign;\012  vector<float, N> fTrig;\012  vector<float, N> TwoPI(6.2831853f);\012\012  x = cmtl::cm_fmod(x, TwoPI);\012\012  x1.merge(x - CMPI*0.5f, CMPI*1.5f - x, (x <= CMPI));\012  x1.merge(CMPI*0.5f - x, (x <= CMPI*0.5f));\012  x1.merge(x - CMPI*1.5f, (x > CMPI*1.5f));\012\012  sign.merge(1, -1, ((x < CMPI*0.5f) | (x >= CMPI*1.5f)));\012\012  x2 = x1 * x1;\012  t3 = x2 * x1 * 0.1666667f;\012  fTrig = x1 + t3 * (-1 + x2*0.05f * (1 + x2*0.0238095f * (-1 + x2*0.013888",
"9f * (1 - x2*0.0090909f))));\012  fTrig *= sign;\012\012  if (flags & SAT)\012    fTrig = vector<float, N>(fTrig, SAT);\012\012  return fTrig;\012}\012\012// vector_ref input\012template <int N>\012CM_INLINE  vector<float, N> cm_cos_emu(vector_ref<float, N> x, const uint flags) {\012  vector<float, N> x1;\012  vector<float, N> x2;\012  vector<float, N> t3;\012\012  vector<float, N> sign;\012  vector<float, N> fTrig;\012  vector<float, N> TwoPI(6.2831853f);\012\012  x = cmtl::cm_fmod(x, TwoPI);\012\012  x1.merge(x - CMPI*0.5f, CMPI*1.5f - x, (x <= CMPI));\012  x1.merge(CMPI*0.5f - x, (x <= CMPI*0.5f));\012  x1.merge(x - CMPI*1.5f, (x > CMPI*1.5f));\012\012  sign.merge(1, -1, ((x < CMPI*0.5f) | (x >= CMPI*1.5f)));\012\012  x2 = x1 * x1;\012  t3 = x2 * x1 * 0.1666667f;\012  fTrig = x1 + t3 * (-1 + x2*0.05f * (1 + x2*0.0238095f * (-1 + x2*0.0138889f * (1 - x2*0.0090909f))));\012  fTrig *= sign;\012\012  if (flags & SAT)\012    fTrig = vector<float, N>(fTrig, SAT);\012\012  return fTrig;\012}\012\012// scalar Input\012template <typename T>\012CM_INLINE float cm_cos_emu(T x, const uint flags) {\012  vector<float, 1> x1;\012  vector<float, 1>",
" x2;\012  vector<float, 1> t3;\012\012  vector<float, 1> sign;\012  vector<float, 1> fTrig;\012  float TwoPI = CMPI*2.0f;\012\012  x = cmtl::cm_fmod(x, TwoPI);\012\012  x1.merge(x - CMPI*0.5f, CMPI*1.5f - x, (x <= CMPI));\012  x1.merge(CMPI*0.5f - x, (x <= CMPI*0.5f));\012  x1.merge(x - CMPI*1.5f, (x > CMPI*1.5f));\012\012  sign.merge(1, -1, ((x < CMPI*0.5f) | (x >= CMPI*1.5f)));\012\012  x2 = x1 * x1;\012  t3 = x2 * x1 * 0.1666667f;\012  fTrig = x1 + t3 * (-1 + x2*0.05f * (1 + x2*0.0238095f * (-1 + x2*0.0138889f * (1 - x2*0.0090909f))));\012  fTrig *= sign;\012\012  if (flags & SAT)\012    fTrig = vector<float, 1>(fTrig, SAT);\012\012  return fTrig(0);\012}\012\012namespace detail\012{\012\012template <int N>\012CM_INLINE vector<float, N> cm_tanh_cody_waite_impl(vector<float, N> x)\012{\012/*\012 *      0           x_small             x_medium            x_large\012 *  |   x   | rational polynomial | 1 - 2/(1 + exp(2*x)) |  1\012 *\012 * rational polynomial for single precision = x + x * (g * (p(1) * g + p(0)) / (g + q(0))\012 * g = x^2\012 * p0 = -0.82377 28127 E+00\012 * p1 = -0.38310 10665 E-02\012 * q0 = 0.24713 19654 E+0",
"1\012 * q1 = 1.00000 00000 E+00\012 *\012 */\012\012  constexpr float p0 = -0.8237728127E+00f;\012  constexpr float p1 = -0.3831010665E-02f;\012  constexpr float q0 = 0.2471319654E+01f;\012  constexpr float q1 = 1.0000000000E+00f;\012  constexpr float xsmall =  4.22863966691620432990E-04f;\012  constexpr float xmedium = 0.54930614433405484570f;\012  constexpr float xlarge =  8.66433975699931636772f;\012  constexpr float log2E = 1.442695f; // same as cm_log(e)\012\012  using RT = vector<float, N>;\012\012  RT absX = cm_abs(x);\012  RT g = absX * absX;\012\012  RT sign;\012  sign.merge(-1.f, 1.f, x < 0.f);\012\012  auto isLarge = absX > xlarge;\012  auto minor = !isLarge;\012  auto isGtMed = minor & (absX > xmedium);\012  auto isGtSmall = (absX > xsmall) & (absX <= xmedium);\012\012  RT res;\012  res.merge(sign, x, isLarge);\012  res.merge((1.f - 2.f / (1.f + cm_exp(2.0f * absX * log2E))) * sign, isGtMed);\012  res.merge((absX + absX * g * (g * p1 + p0) / (g + q0)) * sign, isGtSmall);\012\012  return res;\012}\012\012template <int N>\012CM_INLINE vector<float, N> cm_tanh_impl(vector<float, N> x)\012{\012/*\012 *      0       ",
"                x_small                          x_large\012 * |    x    |  ( exp(x) - exp(-x) ) / ( exp(x) + exp(-x) )  |      1\012 *\012 */\012\012  constexpr float xsmall = 0.000045f; // same as exp(-10.0f)\012  constexpr float xlarge = 88.f;\012  constexpr float log2E = 1.442695f; // same as cm_log(e)\012\012  using RT = vector<float, N>;\012\012  RT absX = cm_abs(x);\012\012  RT sign;\012  sign.merge(-1.f, 1.f, x < 0.f);\012\012  auto isLarge = absX > xlarge;\012\012  RT res;\012  res.merge(sign, x, isLarge);\012\012  RT exp;\012  exp = cm_exp(2.f * log2E * absX);\012\012  res.merge( ((exp - 1.f)/(exp + 1.f)) * sign, (absX > xsmall) & !isLarge);\012\012  return res;\012}\012} // namespace detail\012\012\012/* cm_tanh_cody_waite - Cody-Waite implementation for tanh(x) */\012/* float input */\012CM_INLINE float cm_tanh_cody_waite(float x)\012{\012  return detail::cm_tanh_cody_waite_impl(vector<float, 1>(x))[0];\012}\012/* vector input */\012template <int N>\012CM_INLINE vector<float, N> cm_tanh_cody_waite(vector<float, N> x)\012{\012  return detail::cm_tanh_cody_waite_impl(x);\012}\012/* matrix input */\012template <int R, int C>\012CM_I",
"NLINE matrix<float, R, C> cm_tanh_cody_waite(matrix<float, R, C> x)\012{\012  return detail::cm_tanh_cody_waite_impl(vector<float, R * C>(x));\012}\012/* cm_tanh - opencl like implementation for tanh(x) */\012/* float input */\012CM_INLINE float cm_tanh(float x)\012{\012  return detail::cm_tanh_impl(vector<float, 1>(x))(0);\012}\012/* vector input */\012template <int N>\012CM_INLINE vector<float, N> cm_tanh(vector<float, N> x)\012{\012  return detail::cm_tanh_impl(x);\012}\012/* matrix input */\012template <int R, int C>\012CM_INLINE matrix<float, R, C> cm_tanh(matrix<float, R, C> x)\012{\012  return detail::cm_tanh_impl(vector<float, R * C>(x));\012}\012\012/* ------------------------- Support Routines\012 * -------------------------------------------------------*/\012\012template <typename T, int SZ>\012CM_INLINE void cm_assert_range(vector<T, SZ> tst, float min_val,\012                               float max_val) {\012#ifdef CMRT_EMU\012  T min = cm_reduced_min<T, T, SZ>(tst);\012  T max = cm_reduced_max<T, T, SZ>(tst);\012  cm_assert(min >= min_val && max <= max_val);\012#endif\012}\012\012template <uint RemSi",
"ze, typename T, uint Size> struct __RemainderInit {\012  enum {\012    Size8x = (Size / 8) * 8\012  };\012  CM_INLINE void __CM_remainder_init(vector_ref<T, Size> v, int Value) {\012    v.template select<(RemSize), 1>(Size8x) =\012        v.template select<(RemSize), 1>(Size8x - 8) + Value;\012  }\012};\012\012template <typename T, uint Size> struct __RemainderInit<0, T, Size> {\012  CM_INLINE void __CM_remainder_init(vector_ref<T, Size> v, int Value) {};\012};\012\012template <typename T, uint Size, int InitValue, int Step>\012CM_INLINE void __CM_vector_init(vector_ref<T, Size> v) {\012  T nextInitValue;\012  v.template select<8, 1>(0) *= Step;\012  v.template select<8, 1>(0) += InitValue;\012  nextInitValue = 8 * Step;\012\012  enum {\012    Size8x = (Size / 8) * 8\012  };\012\012#if defined(__ICL) || defined(__CMC)\012#pragma unroll\012#endif\012  for (int i = 0; i < (Size8x - 8); i += 8) {\012    v.template select<8, 1>(i + 8) = v.template select<8, 1>(i) + nextInitValue;\012  }\012\012  // Remainder elements\012  __RemainderInit<(Size - Size8x), T, Size> rInit;\012  rInit.__CM_remainder_init(v, nextInitV",
"alue);\012}\012};\012\012#pragma clang diagnostic pop\012\012/* Close idempotent guard */\012#endif /* _CMTL_H_ */\012\000/*========================== begin_copyright_notice ============================\012\012Copyright (C) 2020-2021 Intel Corporation\012\012SPDX-License-Identifier: MIT\012\012============================= end_copyright_notice ===========================*/\012\012#ifndef CM_CMTL_HINT_H\012#define CM_CMTL_HINT_H\012\012#include \"../cm_common.h\"\012\012/* fpclass_tag - tag class, it is meant to hint cm template library functions\012 * which class of floating point their arguments can be. For many functions\012 * this information can help to choose more efficient algorithm (e.g. it will\012 * allow to exclude certain checks).\012 *\012 * There are 5 following floating point classes: nan, infinite, subnormal,\012 * zero, normal.\012 *\012 * The user himself shouldn't create fpclass_tag object by direct\012 * call of its constructor. One should use predefined tags from\012 * fplclass_tag_def, and get all other tags by combining predefined ones with\012 * bitwise or \"|\", and \"&\", inversion \"~\" o",
"perations.\012 * fpclass_tag_def provide basis of 5 basic floating point classes. Besides it\012 * has 2 additional useful tags: special - for nan or infinity special values,\012 * general - for all possible floating point values.\012 *\012 * Example:\012 *  auto zero_subn = fpclass_tag_def::zero | fpclass_tag_def::subnormal;\012 *  auto zero_norm = ~fpclass_tag_def::special & ~fpclass_tag_def::subnormal;\012 *  vector<float, 16> argf = .....;\012 *  vector<double, 7> argb = .....;\012 *\012 *  // user hints foo that all elements of arg is either zero or subnormal\012 *  // values, e.g. surrounding code is by design works only with small values.\012 *  vector<float, 16> resf = math::foo(argf, zero_subn);\012 *  // user hints bar that all elements of arg are not special and not\012 *  // subnormal values, which means that they are either normal or zero\012 *  // values.\012 *  vector<double, 7> resb = math::bar(argb, zero_norm);\012 *\012 * Tags can be equality compared. Also there is special method \"has\", that\012 * takes another tag as an argument and returns whether",
" the argument is\012 * fully included in the tag.\012 *\012 * ______________________________________________\012 * Information for CM template library developers\012 *\012 * Functions should take tag by value. Though the class is encoded in the type\012 * of the tag, and user can work only with types, working with objects of\012 * the tag is more convenient.\012 *\012 * Nevertheless inside the template function analysis of the tag must be\012 * compile time, so there are several utils to make it convenient for\012 * the library developers too.\012 *\012 * Each operation with tag object doubled with operation with tag type.\012 *\012 * Example:\012 *  template<typename TagT, typename OtherTagT>\012 *  void foo(TagT tag, OtherTagT other_tag) {\012 *    static_assert(is_fpclass_tag_v<TagT>, \"wrong tag\");\012 *\012 *    auto not_tag = ~tag;\012 *    using not_tag_t = TagT::not_t;\012 *\012 *    auto or_tag = tag | other_tag;\012 *    using or_tag_t = or_t<TagT, OtherTagT>\012 *\012 *    auto and_tag = tag & other_tag;\012 *    using and_tag_t = and_t<TagT, OtherTagT>\012 *\012 *    bool has_tag = tag.",
"has(other_tag);\012 *    bool has_tag_cexpr = TagT::template has_v<OtherTagT>;\012 *\012 *    bool eq_tag = (tag == other_tag);\012 *    bool eq_tag_cexpr = equal_v<TagT, OtherTagT>;\012 *  }\012 *\012 * Default tags from fpclass_tag_def are doubled with default types of those\012 * tags: nan_t, infinity_t, etc.\012 *\012 * It is recommended to deduce full tag type and adding static_assert, like in\012 * the example above. Do not write something like this:\012 *  template<unsigned fpclass>\012 *  void bar(fpclass_tag<fpclass> tag) {\012 *    // some explicit work with fpclass\012 *    .....\012 *\012 * Functors that work with tag types are intentionally made to take the tag\012 * type as a whole, thus fpclass_tag's template parameter meaning can be\012 * changed internally in hint's implementation.\012 * Don't use this template parameter directly, externally there's no meaning\012 * in it.\012 */\012\012namespace cmtl {\012namespace hint {\012\012namespace detail {\012enum : unsigned {\012  nan       = 1u,\012  infinite  = 1u << 1,\012  subnormal = 1u << 2,\012  zero      = 1u << 3,\012  normal    = 1u << ",
"4,\012  general   = nan | infinite | subnormal | zero | normal\012};\012} // namespace detail\012\012template<unsigned fpclass>\012class fpclass_tag : public std::integral_constant<unsigned, fpclass> {\012  static_assert(fpclass <= detail::general,\012      \"invalid floating point class tag\");\012\012  template<typename RHS>\012  struct has_impl;\012\012  template<unsigned rhs>\012  struct has_impl<fpclass_tag<rhs>> {\012    static constexpr bool value = ((fpclass & rhs) == rhs);\012  };\012\012\012public:\012\012  CM_INLINE constexpr fpclass_tag() {}\012\012  using not_t = fpclass_tag<~fpclass & detail::general>;\012\012  // is RHS fully included in *this\012  template<typename RHS>\012  static constexpr bool has_v = has_impl<RHS>::value;\012\012  CM_INLINE constexpr not_t operator~() const {\012    return {};\012  }\012\012  template<unsigned rhs>\012  CM_INLINE constexpr bool has(fpclass_tag<rhs>) const {\012    return has_v<fpclass_tag<rhs>>;\012  }\012};\012\012namespace detail {\012\012template<typename LHS, typename RHS>\012struct or_impl;\012\012template<unsigned lhs, unsigned rhs>\012struct or_impl<fpclass_tag<lhs>, fpclass_tag<rhs>",
"> {\012  using type = fpclass_tag<lhs | rhs>;\012};\012\012template<typename LHS, typename RHS>\012struct and_impl;\012\012template<unsigned lhs, unsigned rhs>\012struct and_impl<fpclass_tag<lhs>, fpclass_tag<rhs>> {\012  using type = fpclass_tag<lhs & rhs>;\012};\012\012template<typename LHS, typename RHS>\012struct equal_impl;\012\012template<unsigned lhs, unsigned rhs>\012struct equal_impl<fpclass_tag<lhs>, fpclass_tag<rhs>> {\012  static constexpr bool value = (lhs == rhs);\012};\012\012} // namespace detail\012\012template<typename LHS, typename RHS>\012using or_t = typename detail::or_impl<LHS, RHS>::type;\012\012template<typename LHS, typename RHS>\012using and_t = typename detail::and_impl<LHS, RHS>::type;\012\012template<typename LHS, typename RHS>\012CM_INLINE constexpr bool equal_v = detail::equal_impl<LHS, RHS>::value;\012\012template<unsigned lhs, unsigned rhs>\012CM_INLINE constexpr bool operator==(fpclass_tag<lhs>,\012                                    fpclass_tag<rhs>) {\012  return equal_v<fpclass_tag<lhs>, fpclass_tag<rhs>>;\012}\012\012template<unsigned lhs, unsigned rhs>\012CM_INLINE constexpr bool o",
"perator!=(fpclass_tag<lhs> lhs_v,\012                                    fpclass_tag<rhs> rhs_v) {\012  return !(lhs_v == rhs_v);\012}\012\012template<unsigned lhs, unsigned rhs>\012CM_INLINE constexpr auto operator|(fpclass_tag<lhs>, fpclass_tag<rhs>) {\012  return or_t<fpclass_tag<lhs>, fpclass_tag<rhs>>{};\012}\012\012template<unsigned lhs, unsigned rhs>\012CM_INLINE constexpr auto operator&(fpclass_tag<lhs>, fpclass_tag<rhs>) {\012  return and_t<fpclass_tag<lhs>, fpclass_tag<rhs>>{};\012}\012\012struct fpclass_tag_def {\012  // none must not be provided as a tag, thus there's only none_t type for\012  // library developers and no none tag object.\012  using none_t      = fpclass_tag<0>;\012  using nan_t       = fpclass_tag<detail::nan>;\012  using infinite_t  = fpclass_tag<detail::infinite>;\012  using subnormal_t = fpclass_tag<detail::subnormal>;\012  using zero_t      = fpclass_tag<detail::zero>;\012  using normal_t    = fpclass_tag<detail::normal>;\012  using general_t   = fpclass_tag<detail::general>;\012\012  static constexpr nan_t        nan{};\012  static constexpr infinite_t  ",
" infinite{};\012  static constexpr subnormal_t  subnormal{};\012  static constexpr zero_t       zero{};\012  static constexpr normal_t     normal{};\012  static constexpr general_t    general{};\012\012  using special_t = or_t<nan_t, infinite_t>;\012  static constexpr special_t special{};\012};\012\012template<typename T>\012struct is_fpclass_tag : std::false_type {};\012\012template<unsigned fpclass_internal>\012struct is_fpclass_tag<fpclass_tag<fpclass_internal>> : std::true_type {};\012\012template<typename T>\012CM_INLINE constexpr bool is_fpclass_tag_v = is_fpclass_tag<T>::value;\012\012} // namespace hint\012} // namespace cmtl\012#endif // CM_CMTL_HINT_H\012\000/*========================== begin_copyright_notice ============================\012\012Copyright (C) 2020-2021 Intel Corporation\012\012SPDX-License-Identifier: MIT\012\012============================= end_copyright_notice ===========================*/\012\012#ifndef CM_CMTL_MASK_H\012#define CM_CMTL_MASK_H\012\012#include \"../cm_mask.h\"\012\012namespace cmtl {\012\012template<int size>\012class Mask final {\012  // Bits [size, sizeof(mask)) must be 0,\012  // all ",
"methods must preserve this invariant.\012  MaskIntT mask = 0;\012\012  // to avoid static_cast and literals\012  static constexpr MaskIntT one = 1;\012  static constexpr MaskIntT zero = 0;\012  static constexpr int mask_bit_size = sizeof(MaskIntT) * 8;\012  static_assert(size <= mask_bit_size, \"too big mask size\");\012\012  CM_INLINE Mask(MaskIntT in) : mask(in) {}\012\012  CM_INLINE void set(MaskVecT<size> in) {\012    mask = cm_pack_mask(in);\012  }\012\012public:\012  static constexpr MaskIntT full =\012    size == mask_bit_size \? ~zero : (one << size) - one;\012\012  CM_INLINE Mask(MaskVecT<size> in) {\012    set(in);\012  }\012\012  CM_INLINE Mask(bool in) : mask(in \? full : zero) {}\012\012  CM_INLINE MaskIntT get() const { return mask; }\012\012  CM_INLINE MaskVecT<size> get_vector() const {\012    // really result will always have ushort type\012    // as T parameter doesn't affect a thing\012    return cm_unpack_mask<MaskVecElemT, size>(mask);\012  }\012\012  template<typename T>\012  CM_INLINE vector<T, size> get_vector() const {\012    // really result will always have ushort type\012    // as T paramete",
"r doesn't affect a thing\012    auto ushort_res = cm_unpack_mask<T, size>(mask);\012    vector<T, size> res = ushort_res;\012    return res;\012  }\012\012  CM_INLINE operator MaskIntT () const { return get(); }\012\012  CM_INLINE bool is_all() const { return mask == full; }\012  CM_INLINE bool is_any() const { return mask; }\012  CM_INLINE int count() const { return cm_cbit(mask); }\012\012  CM_INLINE Mask &operator&=(Mask rhs) {\012    mask &= rhs.mask;\012    return *this;\012  }\012\012  CM_INLINE Mask &operator|=(Mask rhs) {\012    mask |= rhs.mask;\012    return *this;\012  }\012\012  CM_INLINE Mask &operator^=(Mask rhs) {\012    mask ^= rhs.mask;\012    return *this;\012  }\012\012  CM_INLINE Mask operator~() {\012    return (~mask) & full;\012  }\012\012  CM_INLINE friend bool operator==(Mask lhs, Mask rhs) {\012    return lhs.mask == rhs.mask;\012  }\012};\012\012template<int size>\012Mask(MaskVecT<size>) -> Mask<size>;\012\012template<int size>\012CM_INLINE bool operator!=(Mask<size> lhs, Mask<size> rhs) {\012  return !(lhs == rhs);\012}\012\012template<int size>\012CM_INLINE Mask<size> operator&(Mask<size> lhs, Mask<size> rhs) {\012 ",
" return lhs &= rhs;\012}\012\012template<int size>\012CM_INLINE Mask<size> operator|(Mask<size> lhs, Mask<size> rhs) {\012  return lhs |= rhs;\012}\012\012template<int size>\012CM_INLINE Mask<size> operator^(Mask<size> lhs, Mask<size> rhs) {\012  return lhs ^= rhs;\012}\012\012} // namespace cmtl\012#endif // CM_CMTL_MASK_H\012\000/*========================== begin_copyright_notice ============================\012\012Copyright (C) 2020-2021 Intel Corporation\012\012SPDX-License-Identifier: MIT\012\012============================= end_copyright_notice ===========================*/\012\012#ifndef CM_CMTL_MATH_CLAMP_H\012#define CM_CMTL_MATH_CLAMP_H\012\012#include \"../mask.h\"\012#include \"../../cm_traits.h\"\012#include \"../../cm_common.h\"\012\012namespace cmtl {\012namespace math {\012\012/* clamp: clamps the provided argument arg with boundaries [lo, hi]\012 *\012 * For each element of provided arguments: if the argument element is greater\012 * than the higher bound, higher bound is returned, otherwise if the argument\012 * element is less than the lower bound, the lower bound is returned,\012 * otherwise the argument eleme",
"nt is returned unchanged.\012 * One can consider this function as a saturation of the argument with the\012 * provided boundaries.\012 *\012 * low bound (lo) must be less or equal to high bound (hi), otherwise result\012 * is unspecified.\012 *\012 * T must be either integral or floating point value. But for floating point\012 * values arguments cannot have NaNs, if so result is unspecified.\012 */\012template<typename T, int width>\012CM_INLINE vector<T, width>\012clamp(vector<T, width> arg, vector<T, width> lo, vector<T, width> hi) {\012  arg = cm_min<T>(arg, hi);\012  arg = cm_max<T>(arg, lo);\012  return arg;\012}\012\012template<typename T, int width>\012CM_INLINE vector<T, width>\012clamp(vector<T, width> arg, T lo, T hi) {\012  vector<T, width> vec_lo = lo;\012  vector<T, width> vec_hi = hi;\012  return clamp(arg, vec_lo, vec_hi);\012}\012\012template<typename T, int width, int hight>\012CM_INLINE matrix<T, hight, width>\012clamp(matrix<T, hight, width> arg,\012      matrix<T, hight, width> lo,\012      matrix<T, hight, width> hi) {\012  vector<T, width * hight> vec_arg = arg.format<T>();\012  ve",
"ctor<T, width * hight> vec_lo = lo.format<T>();\012  vector<T, width * hight> vec_hi = hi.format<T>();\012  return clamp(vec_arg, vec_lo, vec_hi);\012}\012\012template<typename T, int width, int hight>\012CM_INLINE matrix<T, hight, width>\012clamp(matrix<T, hight, width> arg, T lo, T hi) {\012  matrix<T, hight, width> mtx_lo = lo;\012  matrix<T, hight, width> mtx_hi = hi;\012  return clamp(arg, mtx_lo, mtx_hi);\012}\012\012template<typename T>\012CM_INLINE T clamp(T arg, T lo, T hi) {\012  vector<T, 1> vec_arg = arg;\012  vector<T, 1> vec_lo = lo;\012  vector<T, 1> vec_hi = hi;\012  vector<T, 1> vec_res = clamp(vec_arg, vec_lo, vec_hi);\012  return vec_res[0];\012}\012\012} // namespace math\012} // namespace cmtl\012#endif // CM_CMTL_MATH_CLAMP_H\012\000/*========================== begin_copyright_notice ============================\012\012Copyright (C) 2020-2021 Intel Corporation\012\012SPDX-License-Identifier: MIT\012\012============================= end_copyright_notice ===========================*/\012\012#ifndef CM_CMTL_MATH_EXP_H\012#define CM_CMTL_MATH_EXP_H\012\012#include \"exp_impl.h\"\012\012#include \"../../cm_tra",
"its.h\"\012#include \"../../cm_common.h\"\012\012namespace cmtl {\012namespace math {\012\012/* exp: Computes e (Euler's number, 2.7182818...) raised to the given\012 *      power \\p arg.\012 *\012 * If overflow occurs,      +inf is returned.\012 * If underflow occurs,     +0.0 is returned.\012 * If the argument is +inf, +inf is returned.\012 * if the argument is -inf, +0.0 is returned.\012 * If the argument is NaN,   NaN is returned.\012 *\012 * exp supports floating point class hints - hint::fpclass_tag (for more\012 * information look at cmtl/hint.h header). If no hint is provided the most\012 * common case is considered.\012 */\012template<typename FloatT, int width,\012         typename FPClassTag = hint::fpclass_tag_def::general_t>\012CM_INLINE vector<FloatT, width>\012exp(vector<FloatT, width> arg,\012    FPClassTag = hint::fpclass_tag_def::general) {\012  exp_detail::arg_type_check<FloatT, FPClassTag>();\012  return exp_detail::exp_impl<FPClassTag>(arg);\012}\012\012template<typename FloatT, int width, int hight,\012         typename FPClassTag = hint::fpclass_tag_def::general_t>\012CM_INLINE",
" matrix<FloatT, hight, width>\012exp(matrix<FloatT, hight, width> arg,\012    FPClassTag tag = hint::fpclass_tag_def::general) {\012  exp_detail::arg_type_check<FloatT, FPClassTag>();\012  vector<FloatT, width * hight> vec_arg = arg.format<FloatT>();\012  return exp(vec_arg, tag);\012}\012\012template<typename FloatT,\012         typename FPClassTag = hint::fpclass_tag_def::general_t,\012         std::enable_if_t<std::is_floating_point<FloatT>::value, int> = 0>\012CM_INLINE FloatT\012exp(FloatT arg,\012    FPClassTag tag = hint::fpclass_tag_def::general) {\012  exp_detail::arg_type_check<FloatT, FPClassTag>();\012  vector<FloatT, 1> vec_arg = arg;\012  vector<FloatT, 1> vec_exp = exp(vec_arg, tag);\012  return vec_exp[0];\012}\012\012} // namespace math\012} // namespace cmtl\012#endif // CM_CMTL_MATH_EXP_H\012\000/*========================== begin_copyright_notice ============================\012\012Copyright (C) 2020-2021 Intel Corporation\012\012SPDX-License-Identifier: MIT\012\012============================= end_copyright_notice ===========================*/\012\012#ifndef  CM_CMTL_MATH_EXP_IMPL_H\012",
"#define  CM_CMTL_MATH_EXP_IMPL_H\012\012#include \"../../cm_traits.h\"\012#include \"../../cm_common.h\"\012#include \"../numbers.h\"\012#include \"../hint.h\"\012#include \"float.h\"\012\012namespace cmtl {\012namespace math {\012namespace exp_detail {\012\012template<typename FloatT, typename FPClassTag>\012CM_INLINE void arg_type_check() {\012  static_assert(std::is_floating_point<FloatT>::value,\012      \"expected floating point value as argument\");\012  static_assert(hint::is_fpclass_tag_v<FPClassTag>,\012      \"wrong tag is provided, hint::fpclass_tag was expected\");\012  static_assert(!hint::equal_v<FPClassTag, hint::fpclass_tag_def::none_t>,\012      \"tag must specify at least some floating point class\");\012}\012\012// ln2_hi + ln2_lo = ln(2)\012// Meant for Cody Waite range reduction\012// ln2_hi is taken so the product ln2_hi * rough_overflow is representable\012// as double precisely.\012// ln(2) = 0.b17217f7d1cf79abc9e3b39803f2f6af40f343267298b62d8a0d175b8baafa\012constexpr double ln2_hi = 0x0.b17217f7d1p0;\012constexpr double ln2_lo = 0x0.0000000000cf79abc9e3b398p0;\012\012// minmax polynomal ",
"approximation of exp(x) over the range\012// [-ln(2)/2, ln(2)/2]. Got with Remez algorithm.\012constexpr int poly_order = 12;\012constexpr double poly_coef_init[poly_order] = {\012  1.0,\012  1.0,\012  5.000000000000018389e-01,\012  1.666666666666672403e-01,\012  4.166666666648806972e-02,\012  8.333333333299448800e-03,\012  1.388888895232078842e-03,\012  1.984126992839627458e-04,\012  2.480148547660227862e-05,\012  2.755720899040766077e-06,\012  2.763264154737745042e-07,\012  2.511970386342627276e-08\012};\012\012\012// exp for double overflows when arg is greater than 1023 * ln(2) ~ 709\012// The algorithm can handle up to 2 * 1023 * ln(2) argument, so we can cut off\012// rough.\012constexpr double rough_overflow = 800.0;\012// Without denormals underflow happens under -1022 * ln(2) ~ -708, with\012// denormals -1074 * ln(2) ~ 744, again there's no problem to take a bit more.\012constexpr double rough_underflow = -800.0;\012\012// Represents arg as:\012// arg = two_power * ln(2) + remainder\012//\012// remainder is returned, two_power is stored in \\p two_power_out\012// two_power must be representa",
"ble as int.\012//\012// Cody and Waite reduction algorithm is used.\012template<int width>\012CM_INLINE vector<double, width>\012reduce_range(vector<double, width> arg,\012             vector_ref<int, width> two_power_out) {\012  vector<int, width> two_power = round_fast<int>(arg * numbers::inv_ln2);\012  vector<double, width> remainder_hi = arg - two_power * ln2_hi;\012  vector<double, width> remainder_lo = -two_power * ln2_lo;\012\012  two_power_out = two_power;\012  return remainder_hi + remainder_lo;\012}\012\012template<typename FloatT, typename IntT, int width>\012CM_INLINE vector<FloatT, width>\012exp2_unsafe(vector<IntT, width> arg) {\012  static_assert(std::is_floating_point<FloatT>::value,\012      \"expected floating point value as argument\");\012  static_assert(std::is_integral<IntT>::value,\012      \"expected integral value as argument\");\012  using UInt = typename detail::FloatDescr<FloatT>::SameSizeUInt;\012  vector<UInt, width> two_power = arg + detail::FloatDescr<FloatT>::Exp::Bias;\012  two_power <<= detail::FloatDescr<FloatT>::Exp::Offset;\012  return two_power.for",
"mat<FloatT>();\012}\012\012// exp only for reduced range [-ln(2)/2, ln(2)/2].\012// Polynomal approximation is used.\012template<int width>\012CM_INLINE vector<double, width> exp_reduced(vector<double, width> r) {\012  vector<double, poly_order> poly_coef(poly_coef_init);\012  vector<double, width> poly_val = poly_coef[poly_order - 1];\012#pragma unroll\012  for (int i = poly_order - 2; i >= 0; --i)\012    poly_val = poly_val * r + poly_coef[i];\012\012  return poly_val;\012}\012\012// original arg = k * ln(2) + r\012// Based on precalculated exp(r) and provided k calculates exp(arg).\012//\012// k is split in sum first + second.\012// If k was passed to exp2_unsafe, it could result in overflow (result of\012// exp2_unsafe is unspecified, not inf), but first and second are two times\012// smaller, so it is safe to pass them to exp2_unsafe.\012// If k is meant to cause overflow, its OK because overflow will happen in\012// float arithmetic and result in inf, which is correct.\012// Similarly underflow and denormal result cases are covered.\012template<int width>\012CM_INLINE vector<double,",
" width> unfold_exp(vector<double, width> exp_r,\012                                           vector<int, width> k) {\012  vector<int, width> first = k / 2;\012  vector<int, width> second = k - first;\012\012  vector<double, width> two_to_first = exp2_unsafe<double>(first);\012  vector<double, width> two_to_second = exp2_unsafe<double>(second);\012  return exp_r * two_to_first * two_to_second;\012}\012\012// Calculates exponent. Argument range must be less then [-1400, 1400] (no need\012// here in precise bounds, as obviously smaller range will be provided).\012template<int width>\012CM_INLINE vector<double, width> exp_numeric(vector<double, width> arg) {\012  vector<int, width> k;\012  vector<double, width> r = reduce_range(arg, k.select_all());\012\012  vector<double, width> exp_r = exp_reduced(r);\012\012  return unfold_exp(exp_r, k);\012}\012\012// TODO: move to numeric_limits when there is numeric_limits\012template<typename FloatT>\012CM_INLINE FloatT quiet_NaN() {\012  using UInt = typename detail::FloatDescr<FloatT>::SameSizeUInt;\012  vector<UInt, 1> uint_nan = ~0;\012  vector<Fl",
"oatT, 1> nan = uint_nan.format<FloatT>();\012  return nan[0];\012}\012\012template<typename FPClassTag, int width>\012CM_INLINE vector<double, width> exp_impl(vector<double, width> arg) {\012  Mask<width> is_nan(false);\012  if constexpr (FPClassTag::template has_v<hint::fpclass_tag_def::nan_t>) {\012    is_nan = isnan(arg);\012    arg.merge(0.0, is_nan.get());\012  }\012\012  arg = clamp(arg, rough_underflow, rough_overflow);\012  vector<double, width> exp = exp_numeric(arg);\012\012  if constexpr (FPClassTag::template has_v<hint::fpclass_tag_def::nan_t>)\012    exp.merge(quiet_NaN<double>(), is_nan.get());\012  return exp;\012}\012\012} // namespace exp_detail\012} // namespace math\012} // namespace cmtl\012#endif //  CM_CMTL_MATH_EXP_IMPL_H\012\000/*========================== begin_copyright_notice ============================\012\012Copyright (C) 2020-2021 Intel Corporation\012\012SPDX-License-Identifier: MIT\012\012============================= end_copyright_notice ===========================*/\012\012#ifndef  CM_CMTL_MATH_IMPL_FLOAT_H\012#define  CM_CMTL_MATH_IMPL_FLOAT_H\012\012#include \"../mask.h\"\012#include",
" \"../../cm_util.h\"\012\012namespace cmtl {\012namespace math {\012namespace detail {\012\012template<typename T>\012struct FloatDescrImpl;\012\012template<>\012struct FloatDescrImpl<float> {\012  using SameSizeSInt = int32_t;\012  using SameSizeUInt = uint32_t;\012  static constexpr int BitSize = 32;\012  // the minimal number, being multiplied by which subnorm becomes normal\012  // pow(2, 23) should be enough, but glibc uses pow(2, 25)\012  // and they probaly know what they do\012  static constexpr float Normalizer = 3.3554432000e+07; // pow(2, 25)\012  static constexpr int LogNormalizer = 25;\012  struct Frac {\012    static constexpr int BitSize = 23;\012  };\012  struct Exp {\012    static constexpr int BitSize = 8;\012    static constexpr int Bias = 127;\012  };\012};\012\012template<>\012struct FloatDescrImpl<double> {\012  using SameSizeSInt = int64_t;\012  using SameSizeUInt = uint64_t;\012  static constexpr int BitSize = 64;\012  static constexpr float Normalizer = 1.80143985094819840000e+16; // pow(2, 54)\012  static constexpr int LogNormalizer = 54;\012  struct Frac {\012    static constexpr int BitSiz",
"e = 52;\012  };\012  struct Exp {\012    static constexpr int BitSize = 11;\012    static constexpr int Bias = 1023;\012  };\012};\012\012template<typename FloatT>\012struct FloatDescr {\012  using SameSizeSInt = typename FloatDescrImpl<FloatT>::SameSizeSInt;\012  using SameSizeUInt = typename FloatDescrImpl<FloatT>::SameSizeUInt;\012  static constexpr int BitSize = FloatDescrImpl<FloatT>::BitSize;\012  static constexpr FloatT Normalizer = FloatDescrImpl<FloatT>::Normalizer;\012  static constexpr int LogNormalizer = FloatDescrImpl<FloatT>::LogNormalizer;\012  // to avoid writing to much static_cast\012  static constexpr SameSizeUInt One = 1;\012  struct Frac {\012    static constexpr int BitSize = FloatDescrImpl<FloatT>::Frac::BitSize;\012    static constexpr int Offset = 0;\012    static constexpr SameSizeUInt Mask = ((One << BitSize) - One) << Offset;\012  };\012  struct Exp {\012    static constexpr int BitSize = FloatDescrImpl<FloatT>::Exp::BitSize;\012    static constexpr int Offset = Frac::BitSize;\012    static constexpr int Bias = FloatDescrImpl<FloatT>::Exp::Bias;\012    stati",
"c constexpr SameSizeUInt MaxUVal = (One << BitSize) - One;\012    static constexpr SameSizeUInt MinUVal = 0;\012    static constexpr SameSizeSInt MaxSVal =\012      static_cast<SameSizeSInt>(MaxUVal) - Bias;\012    static constexpr SameSizeSInt MinSVal = -Bias;\012    static constexpr SameSizeUInt Mask = MaxUVal << Offset;\012  };\012  struct Sign {\012    static constexpr int BitSize = 1;\012    static constexpr int Offset = Frac::BitSize + Exp::BitSize;\012    static constexpr SameSizeUInt Mask = One << Offset;\012  };\012  SameSizeUInt PosInfUInt = Exp::Mask;\012  SameSizeUInt NegInfUInt = Exp::Mask + Sign::Mask;\012};\012\012/* returns the value of exp in float as it is stored\012 * returns int in range [0, 1 << Exp::BitSize)\012 */\012template <typename FloatT, int width>\012CM_INLINE vector<int, width> get_biased_exp(vector<FloatT, width> arg) {\012  static_assert(std::is_floating_point<FloatT>::value,\012      \"expected floating point value as argument\");\012\012  using UInt = typename FloatDescr<FloatT>::SameSizeUInt;\012  vector<UInt, width> uarg = arg.format<UInt>();\012  vec",
"tor<unsigned, width> dword_arg;\012  int exp_offset = FloatDescr<FloatT>::Exp::Offset;\012  int exp_width = FloatDescr<FloatT>::Exp::BitSize;\012  if constexpr (sizeof(UInt) > sizeof(unsigned)) {\012    dword_arg = details::read_region<width, 2>(uarg.format<unsigned>(), 1);\012    exp_offset -= 32;\012  } else\012    dword_arg = uarg;\012\012  return cm_bf_extract<int>(exp_width, exp_offset, dword_arg);\012}\012\012/* returns signed exponent according to IEEE representation\012 * arg = 1.xxxxxxxx * 2^exp   <- this exponent\012 */\012template<typename FloatT, int Width>\012CM_INLINE vector<int, Width>\012get_exp(vector<FloatT, Width> arg) {\012  static_assert(std::is_floating_point<FloatT>::value,\012      \"expected floating point value as argument\");\012\012  vector<int, Width> exp = get_biased_exp(arg);\012  exp -= FloatDescr<FloatT>::Exp::Bias;\012\012  return exp;\012}\012\012/* returns the value of fraction in float as it is stored\012 * returns int in range [0, 1 << Fract::BitSize)\012 */\012template<typename FloatT, int Width>\012CM_INLINE vector<typename FloatDescr<FloatT>::SameSizeSInt, Width",
">\012get_frac(vector<FloatT, Width> arg) {\012  static_assert(std::is_floating_point<FloatT>::value,\012      \"expected floating point value as argument\");\012\012  using SSUInt = typename FloatDescr<FloatT>::SameSizeUInt;\012  vector<SSUInt, Width> frac;\012\012  frac = arg.format<SSUInt>() & FloatDescr<FloatT>::Frac::Mask;\012  frac >>= FloatDescr<FloatT>::Frac::Offset;\012\012  return frac;\012}\012\012/* sets exponent in floating number\012 * arg = 1.xxxxxxxx * 2^exp   <- this exponent\012 *\012 * \\p arg - old value\012 * \\p new_exp - new exponent to be set,\012 *              each element must be in range [Exp::MinSVal, Exp::MaxSVal]\012 *\012 */\012template<typename IntT, typename FloatT, int width>\012CM_INLINE vector<FloatT, width>\012set_exp(vector<FloatT, width> arg, vector<IntT, width> new_exp) {\012  static_assert(std::is_floating_point<FloatT>::value,\012      \"expected floating point value as argument\");\012  static_assert(std::is_integral<IntT>::value,\012      \"expected integral value as argument\");\012\012  using UInt = typename FloatDescr<FloatT>::SameSizeUInt;\012  vector<unsigned,",
" width> biased_exp = new_exp + FloatDescr<FloatT>::Exp::Bias;\012\012  vector<UInt, width> uarg = arg.format<UInt>();\012  vector<unsigned, width> dword_arg;\012  int exp_offset = FloatDescr<FloatT>::Exp::Offset;\012  int exp_width = FloatDescr<FloatT>::Exp::BitSize;\012  if constexpr (sizeof(UInt) > sizeof(unsigned)) {\012    dword_arg = details::read_region<width, 2>(uarg.format<unsigned>(), 1);\012    exp_offset -= 32;\012  } else\012    dword_arg = uarg;\012\012  vector<unsigned, width> dword_res =\012    cm_bf_insert<unsigned>(exp_width, exp_offset, biased_exp, dword_arg);\012  if constexpr (sizeof(UInt) > sizeof(unsigned))\012    details::write_region<2>(uarg.format<unsigned>(), dword_res, 1);\012  else\012    uarg = dword_res;\012  return uarg.format<FloatT>();\012}\012\012template<typename IntT, typename FloatT, int Width>\012CM_INLINE vector<FloatT, Width>\012set_exp(vector<FloatT, Width> arg, IntT new_exp) {\012  static_assert(std::is_floating_point<FloatT>::value,\012      \"expected floating point value as argument\");\012  static_assert(std::is_integral<IntT>::value,\012      \"",
"expected integral value as argument\");\012\012  vector<IntT, Width> vec_exp = new_exp;\012  return set_exp(arg, vec_exp);\012}\012\012/*   \\exp|        |       |              |\012 *    \\  |    0   |   ~0  |     other    |\012 * frac\\ |        |       |              |\012 * _____\\|________|_______|______________|\012 *       |        |       |              |\012 *   0   |  zero  |  inf  | (power of 2) |\012 * ______|________|_______|--normalized--|\012 *       |        |       |              |\012 * other |  subn  |  nan  |              |\012 * ______|________|_______|______________|\012 *\012 * the concrete class of float is easy to define\012 * using the following 3 basis functions:\012 * 1) is_zero_or_subn             (exp  ==  0)\012 * 2) is_inf_or_nan               (exp  == ~0)\012 * 3) is_zero_or_inf_or_pow2norm  (frac ==  0)\012 */\012\012template<typename FloatT, int width>\012CM_INLINE Mask<width>\012is_zero_or_subn(vector<FloatT, width> arg) {\012  static_assert(std::is_floating_point<FloatT>::value,\012      \"expected floating point value as argument\");\012  auto exp = detail::get_bi",
"ased_exp(arg);\012  // max exp bit size is 11 for double\012  auto exp_lo = exp.format<int16_t>().select<width, 2>(0);\012  return Mask<width>(exp_lo == 0);\012}\012\012template<typename FloatT, int Width>\012CM_INLINE Mask<Width>\012is_inf_or_nan(vector<FloatT, Width> arg) {\012  static_assert(std::is_floating_point<FloatT>::value,\012      \"expected floating point value as argument\");\012  auto exp = detail::get_biased_exp(arg);\012  return Mask<Width>(exp == FloatDescr<FloatT>::Exp::MaxUVal);\012}\012\012template<typename FloatT, int Width>\012CM_INLINE Mask<Width>\012is_zero_or_inf_or_pow2norm(vector<FloatT, Width> arg) {\012  static_assert(std::is_floating_point<FloatT>::value,\012      \"expected floating point value as argument\");\012  auto frac = detail::get_frac(arg);\012  return Mask<Width>(frac == 0);\012}\012\012} // namespace detail\012} // namespace math\012} // namespace cmtl\012#endif //  CM_CMTL_MATH_IMPL_FLOAT_H\012\000/*========================== begin_copyright_notice ============================\012\012Copyright (C) 2020-2021 Intel Corporation\012\012SPDX-License-Identifier: MIT\012\012======",
"======================= end_copyright_notice ===========================*/\012\012#ifndef CM_CMTL_MATH_FPCLASSIFY_H\012#define CM_CMTL_MATH_FPCLASSIFY_H\012\012#include \"float.h\"\012#include \"../mask.h\"\012\012/* This header provides functions for floating point values classification.\012 *\012 * Functions:\012 *    isnormal\012 *    isnan\012 *    isinf\012 *    issubnormal\012 *    fpclassify\012 */\012\012namespace cmtl {\012namespace math {\012\012// vector analog to std::isnormal\012template<typename FloatT, int Width>\012CM_INLINE Mask<Width>\012isnormal(vector<FloatT, Width> arg) {\012  static_assert(std::is_floating_point<FloatT>::value,\012      \"expected floating point value as argument\");\012  return ~detail::is_zero_or_subn(arg) &\012         ~detail::is_inf_or_nan(arg);\012}\012\012// vector analog to std::isnan\012template<typename FloatT, int width>\012CM_INLINE Mask<width>\012isnan(vector<FloatT, width> arg) {\012  static_assert(std::is_floating_point<FloatT>::value,\012      \"expected floating point value as argument\");\012  constexpr auto upper = detail::FloatDescr<FloatT>::One <<\012    (detail::FloatD",
"escr<FloatT>::BitSize - 1);\012  constexpr auto positive_mask = upper - 1u;\012  constexpr auto lower = detail::FloatDescr<FloatT>::Exp::Mask;\012  using UInt = typename detail::FloatDescr<FloatT>::SameSizeUInt;\012\012  vector<UInt, width> uarg = arg.format<UInt>();\012  // zero sign bit\012  uarg &= positive_mask;\012  return Mask<width>(uarg > lower);\012}\012\012// vector analog to std::isinf\012template<typename FloatT, int Width>\012CM_INLINE Mask<Width>\012isinf(vector<FloatT, Width> arg) {\012  static_assert(std::is_floating_point<FloatT>::value,\012      \"expected floating point value as argument\");\012  return detail::is_inf_or_nan(arg) &\012         detail::is_zero_or_inf_or_pow2norm(arg);\012}\012\012// returns wether elements of \\p arg denormalized\012template<typename FloatT, int Width>\012CM_INLINE Mask<Width>\012issubnormal(vector<FloatT, Width> arg) {\012  static_assert(std::is_floating_point<FloatT>::value,\012      \"expected floating point value as argument\");\012  return detail::is_zero_or_subn(arg) &\012         ~detail::is_zero_or_inf_or_pow2norm(arg);\012}\012\012/* if normal c",
"ase is excluded, float class can be easily defined only by\012 * exp and frac equality to 0\012 *                     exp == 0 | frac == 0  */\012enum {            //            |\012  fp_nan = 0,     //          0 | 0\012  fp_infinite,    //          0 | 1\012  fp_subnormal,   //          1 | 0\012  fp_zero,        //          1 | 1\012  fp_normal       //          x | x\012};\012\012/* vector analog to std::fpclassify\012 *\012 * returns vector of fp_infinite, fp_nan, fp_normal,\012 *                   fp_subnormal, fp_zero\012 */\012template<typename FloatT, int Width>\012CM_INLINE vector<int, Width>\012fpclassify(vector<FloatT, Width> arg) {\012  static_assert(std::is_floating_point<FloatT>::value,\012      \"expected floating point value as argument\");\012\012  vector<ushort, Width> is_null_exp =\012    detail::is_zero_or_subn(arg).get_vector();\012  vector<ushort, Width> is_null_frac =\012    detail::is_zero_or_inf_or_pow2norm(arg).get_vector();\012  vector<ushort, Width> fpclass =\012    (is_null_exp << 1) + is_null_frac;\012  MaskIntT is_normal = isnormal(arg);\012  fpclass.merge(fp_norm",
"al, is_normal);\012  return fpclass;\012}\012\012} // namespace math\012} // namespace cmtl\012#endif // CM_CMTL_MATH_FPCLASSIFY_H\012\000/*========================== begin_copyright_notice ============================\012\012Copyright (C) 2020-2021 Intel Corporation\012\012SPDX-License-Identifier: MIT\012\012============================= end_copyright_notice ===========================*/\012\012#ifndef CM_CMTL_MATH_FREXP_H\012#define CM_CMTL_MATH_FREXP_H\012\012#include \"frexp_impl.h\"\012\012#include \"../../cm_traits.h\"\012#include \"../../cm_common.h\"\012\012namespace cmtl {\012namespace math {\012\012/* frexp - analog to std::frexp. It decomposes every elemet of the given vector\012 * into normalized fraction and exponent.\012 *\012 * Return: vector of fractions.\012 * Vector of exponents is returned through \\p exp.\012 *\012 * If arg elem is +/-0.0, it is returned unmodified, 0 is stored in exp.\012 * If arg elem is inf or nan, it is returned unmodified, unspecified value\012 * is stored in exp.\012 * Otherwise fraction is in the range (-1, 0.5] U [0.5, 1) and corresponding\012 * exponent is stored in exp.\012 *\012 * NO",
"TE: concept of normalization differs in C std library from IEEE\012 * C lib: sign * 0.xxxxxxxxxxx * 2^exp\012 * IEEE : sign * 1.xxxxxxxxxxx * 2^exp\012 *\012 * frexp supports floating point class hints - hint::fpclass_tag (for more\012 * information look at cmtl/hint.h header). If no hint is provided the most\012 * common case is considered.\012 *\012 * If the user cannot guarantee with a hint, that arg doesn't have subnormal\012 * values, width must be power of 2, greater than one and less than or equal\012 * to 32.\012 * If IntT capacity isn't enough to store exponent, behavior is undefined.\012 */\012template<typename FloatT, typename IntT, int width,\012         typename FPClassTag = hint::fpclass_tag_def::general_t>\012CM_INLINE vector<FloatT, width>\012frexp(vector<FloatT, width> arg, vector_ref<IntT, width> exp,\012      FPClassTag = hint::fpclass_tag_def::general) {\012  detail::frexp_arg_type_check<FloatT, IntT, FPClassTag>();\012\012  return detail::frexp_impl<FPClassTag>(arg, exp);\012}\012\012template<typename FloatT, typename IntT, int width, int hight,\012         t",
"ypename FPClassTag = hint::fpclass_tag_def::general_t>\012CM_INLINE matrix<FloatT, hight, width>\012frexp(matrix<FloatT, hight, width> arg, matrix_ref<IntT, hight, width> exp,\012      FPClassTag tag = hint::fpclass_tag_def::general) {\012  detail::frexp_arg_type_check<FloatT, IntT, FPClassTag>();\012\012  vector<FloatT, width * hight> vec_arg = arg.format<FloatT>();\012  return frexp(vec_arg, exp.format<IntT>(), tag);\012}\012\012\012template<typename FloatT, typename IntT,\012         typename FPClassTag = hint::fpclass_tag_def::general_t,\012         std::enable_if_t<std::is_floating_point<FloatT>::value, int> = 0,\012         std::enable_if_t<std::is_integral<IntT>::value, int> = 0>\012CM_INLINE FloatT frexp(FloatT arg, IntT &exp,\012                       FPClassTag tag = hint::fpclass_tag_def::general) {\012  detail::frexp_arg_type_check<FloatT, IntT, FPClassTag>();\012\012  // FIXME: implement separate algorithm for scalar case\012  vector<FloatT, 2> vec_arg = arg;\012  vector<IntT, 2> vec_exp;\012  vector<FloatT, 2> vec_res = frexp(vec_arg, vec_exp.select_all(), tag",
");\012  exp = vec_exp(0);\012  return vec_res(0);\012}\012\012\012} // namespace math\012} // namespace cmtl\012#endif // CM_CMTL_MATH_FREXP_H\012\000/*========================== begin_copyright_notice ============================\012\012Copyright (C) 2020-2021 Intel Corporation\012\012SPDX-License-Identifier: MIT\012\012============================= end_copyright_notice ===========================*/\012\012#ifndef  CM_CMTL_MATH_IMPL_FREXP_H\012#define  CM_CMTL_MATH_IMPL_FREXP_H\012\012#include \"../../cm_traits.h\"\012#include \"../../cm_common.h\"\012#include \"../hint.h\"\012#include \"fpclassify.h\"\012#include \"float.h\"\012#include \"utils.h\"\012\012namespace cmtl {\012namespace math {\012namespace detail {\012\012template<typename FloatT, typename IntT>\012CM_INLINE void frexp_arg_type_check() {\012  static_assert(std::is_floating_point<FloatT>::value,\012      \"expected floating point value as argument\");\012  static_assert(std::is_integral<IntT>::value,\012      \"expected integral value as argument\");\012}\012\012template<typename FloatT, typename IntT, typename FPClassTag>\012CM_INLINE void frexp_arg_type_check() {\012  frexp_arg_ty",
"pe_check<FloatT, IntT>();\012  static_assert(hint::is_fpclass_tag_v<FPClassTag>,\012      \"wrong tag is provided, hint::fpclass_tag was expected\");\012  static_assert(!hint::equal_v<FPClassTag, hint::fpclass_tag_def::none_t>,\012      \"tag must specify at least some floating point class\");\012}\012\012/* here normalization is in terms of C std library\012 * sign * 0.1xxxxxxxx * 2^exp\012 *\012 * returns float in range (-1, -0.5] U [0.5, 1)\012 * If element of arg is not normal,\012 * corresponding returned element is unspecified.\012 */\012template<typename FloatT, int width>\012CM_INLINE vector<FloatT, width>\012get_normalized_fract(vector<FloatT, width> arg) {\012  static_assert(std::is_floating_point<FloatT>::value,\012      \"expected floating point value as argument\");\012  return set_exp(arg, -1);\012}\012\012/* this function doesn't rewrite \\p exp, but adds to it\012 * when \\p exp is originaly zeroed we get frexp for normals\012 */\012template<typename FloatT, typename IntT, int width>\012CM_INLINE vector<FloatT, width>\012frexp_normal_exp_delta(vector<FloatT, width> arg,\012          ",
"             vector_ref<IntT, width> exp) {\012  frexp_arg_type_check<FloatT, IntT>();\012\012  exp += get_exp(arg) + 1;\012  return get_normalized_fract(arg);\012}\012\012/* frexp only for normalized values\012 * When income is not normilized, returned\012 * and stored in \\p exp values are unspecified.\012 */\012template<typename FloatT, typename IntT, int width>\012CM_INLINE vector<FloatT, width>\012frexp_normal(vector<FloatT, width> arg,\012             vector_ref<IntT, width> exp) {\012  frexp_arg_type_check<FloatT, IntT>();\012\012  exp = 0;\012  return frexp_normal_exp_delta(arg, exp);\012}\012\012// frexp for normal and subnormal values.\012// For other values result is uncpecified.\012template<typename FPClassTag, typename FloatT, typename IntT, int width>\012CM_INLINE vector<FloatT, width>\012frexp_subn_normal(vector<FloatT, width> arg,\012                  vector_ref<IntT, width> exp) {\012  frexp_arg_type_check<FloatT, IntT, FPClassTag>();\012  static_assert(detail::is_pow2(width) && width > 1 &&\012      width <= 32, \"width must be power of 2, greater than one \"\012      \"and less than",
" or equal to 32.\");\012\012  exp = 0;\012  // really issubnormal is enough, but is_zero_or_subn is faster\012  // to calculate and zero must be fixed at the end anyway\012#ifdef SIMD_CF_IS_FIXED\012  SIMD_IF_BEGIN (is_zero_or_subn(arg).get_vector()) {\012    arg *= FloatDescr<FloatT>::Normalizer;\012    exp = -FloatDescr<FloatT>::LogNormalizer;\012  } SIMD_IF_END;\012#else\012  auto normalized_arg = arg * FloatDescr<FloatT>::Normalizer;\012  auto normalized_exp = -FloatDescr<FloatT>::LogNormalizer;\012  Mask<width> to_normalize = is_zero_or_subn(arg);\012  arg.merge(normalized_arg, to_normalize.get());\012  exp.merge(normalized_exp, to_normalize.get());\012#endif\012  arg = frexp_normal_exp_delta(arg, exp);\012\012  return arg;\012}\012\012// frexp for all classes of floats\012template<typename FPClassTag, typename FloatT, typename IntT, int width>\012CM_INLINE vector<FloatT, width>\012frexp_general(vector<FloatT, width> arg,\012              vector_ref<IntT, width> exp) {\012  frexp_arg_type_check<FloatT, IntT, FPClassTag>();\012  using namespace hint;\012\012  const auto orig_arg = arg;\012  if con",
"stexpr (FPClassTag::template has_v<fpclass_tag_def::subnormal_t>)\012    arg = frexp_subn_normal<FPClassTag>(arg, exp);\012  else\012    arg = frexp_normal(arg, exp);\012\012  // need to fix exp if arg had zero\012  if constexpr (FPClassTag::template has_v<hint::fpclass_tag_def::zero_t>)\012    exp.merge(0, orig_arg == 0.0);\012\012  // for zero, inf, nan the original argument must be returned\012  if constexpr (FPClassTag::template has_v<or_t<fpclass_tag_def::special_t,\012                                       fpclass_tag_def::zero_t>>) {\012    auto is_inf_nan_zero = is_inf_or_nan(orig_arg) |\012                           Mask<width>(orig_arg == 0.0);\012    arg.merge(orig_arg, is_inf_nan_zero.get());\012  }\012  return arg;\012}\012\012template<typename FPClassTag, typename FloatT, typename IntT, int width>\012CM_INLINE vector<FloatT, width>\012frexp_impl(vector<FloatT, width> arg,\012           vector_ref<IntT, width> exp) {\012  frexp_arg_type_check<FloatT, IntT, FPClassTag>();\012  using namespace hint;\012\012  if constexpr (equal_v<FPClassTag, fpclass_tag_def::normal_t>)\012    r",
"eturn frexp_normal(arg, exp);\012\012  if constexpr (equal_v<FPClassTag, fpclass_tag_def::zero_t>) {\012    exp = 0;\012    return arg;\012  }\012\012  if constexpr (equal_v<FPClassTag, fpclass_tag_def::special_t>)\012    return arg;\012\012  vector<int16_t, width> internal_exp;\012  auto frac = frexp_general<FPClassTag>(arg, internal_exp);\012  exp = internal_exp;\012  return frac;\012}\012\012} // namespace detail\012} // namespace math\012} // namespace cmtl\012#endif //  CM_CMTL_MATH_IMPL_FREXP_H\012\000/*========================== begin_copyright_notice ============================\012\012Copyright (C) 2020-2021 Intel Corporation\012\012SPDX-License-Identifier: MIT\012\012============================= end_copyright_notice ===========================*/\012\012#ifndef  CM_CMTL_MATH_H\012#define  CM_CMTL_MATH_H\012\012#include \"math/frexp.h\"\012#include \"math/fpclassify.h\"\012#include \"math/round.h\"\012#include \"math/clamp.h\"\012#include \"math/exp.h\"\012#include \"math/log.h\"\012\012\012#endif // CM_CMTL_MATH_H\012\000/*========================== begin_copyright_notice ============================\012\012Copyright (C) 2020-2021 Intel Cor",
"poration\012\012SPDX-License-Identifier: MIT\012\012============================= end_copyright_notice ===========================*/\012\012#ifndef CM_CMTL_MATH_LOG_H\012#define CM_CMTL_MATH_LOG_H\012\012#include \"log_impl.h\"\012\012#include \"../../cm_traits.h\"\012#include \"../../cm_common.h\"\012\012namespace cmtl {\012namespace math {\012\012/* log: Computes the natural logarithm of \\p arg.\012 *\012 * If the argument is +/-0.0,  -inf is returned.\012 * if the argument is +inf,    +inf is returned.\012 * If the argument is negative, NaN is returned.\012 * If the argument is NaN,      NaN is returned.\012 *\012 * log supports floating point class hints - hint::fpclass_tag (for more\012 * information look at cmtl/hint.h header). If no hint is provided the most\012 * common case is considered.\012 */\012template<typename FloatT, int width,\012         typename FPClassTag = hint::fpclass_tag_def::general_t>\012CM_INLINE vector<FloatT, width>\012log(vector<FloatT, width> arg,\012    FPClassTag = hint::fpclass_tag_def::general) {\012  static_assert(std::is_floating_point<FloatT>::value,\012      \"expected floating",
" point value as argument\");\012  return log_detail::log_impl<FPClassTag>(arg);\012}\012\012template<typename FloatT, int width, int hight,\012         typename FPClassTag = hint::fpclass_tag_def::general_t>\012CM_INLINE matrix<FloatT, hight, width>\012log(matrix<FloatT, hight, width> arg,\012    FPClassTag tag = hint::fpclass_tag_def::general) {\012  static_assert(std::is_floating_point<FloatT>::value,\012      \"expected floating point value as argument\");\012  vector<FloatT, width * hight> vec_arg = arg.format<FloatT>();\012  return log(vec_arg, tag);\012}\012\012template<typename FloatT,\012         typename FPClassTag = hint::fpclass_tag_def::general_t,\012         std::enable_if_t<std::is_floating_point<FloatT>::value, int> = 0>\012CM_INLINE FloatT log(FloatT arg,\012    FPClassTag tag = hint::fpclass_tag_def::general) {\012  static_assert(std::is_floating_point<FloatT>::value,\012      \"expected floating point value as argument\");\012  vector<FloatT, 2> vec_arg = arg;\012  vector<FloatT, 2> vec_log = log(vec_arg, tag);\012  return vec_log[0];\012}\012\012} // namespace math\012} // name",
"space cmtl\012#endif // CM_CMTL_MATH_LOG_H\012\012\000/*========================== begin_copyright_notice ============================\012\012Copyright (C) 2020-2021 Intel Corporation\012\012SPDX-License-Identifier: MIT\012\012============================= end_copyright_notice ===========================*/\012\012#ifndef  CM_CMTL_MATH_LOG_IMPL_H\012#define  CM_CMTL_MATH_LOG_IMPL_H\012\012#include \"../../cm_traits.h\"\012#include \"../../cm_common.h\"\012#include \"../numbers.h\"\012#include \"../hint.h\"\012#include \"float.h\"\012#include \"frexp.h\"\012#include \"fpclassify.h\"\012\012// The implementation is based on the algorithm discussed in\012// The Mathematical-Function Computation Handbook\012// by Nelson H.F. Beebe. Certain changes were made to optimize\012// the algorithm for vector computations.\012\012namespace cmtl {\012namespace math {\012namespace log_detail {\012\012// ln2_hi + ln2_lo = ln(2)\012// Meant for Cody Waite result unfolding.\012// ln2_hi is taken so the product\012// ln2_hi * FloatDescr<double>::Exp::MaxSVal is representable\012// as double precisely.\012// ln(2) = 0.b17217f7d1cf79abc9e3b39803f2f6af40f",
"343267298b62d8a0d175b8baafa\012constexpr double ln2_hi = 0x0.b17217f7d1p0;\012constexpr double ln2_lo = 0x0.0000000000cf79abc9e3b398p0;\012\012constexpr int poly_order = 8;\012constexpr double poly_coef_init[poly_order] = {\012  8.333333333333333307726e-02,\012  1.250000000000027737181e-02,\012  2.232142857093574000534e-03,\012  4.340277811119014760447e-04,\012  8.877829843859590969703e-05,\012  1.878203829749719357775e-05,\012  4.049261716236508114464e-06,\012  9.985449030888993932992e-07\012};\012\012// Represents arg as r * 2^k, where r belongs [sqrt(2)/2, sqrt(2))\012template<typename FPClassTag, int width>\012CM_INLINE vector<double, width> reduce_range(vector<double, width> arg,\012                                             vector_ref<int16_t, width> k) {\012  // NaN, -inf must have been handled before.\012  // Zero and +inf can come, result of frexp is unspecified,\012  // but its OK as in this case the output must be fixed anyway.\012  vector<double, width> r = frexp(arg, k,\012                                  FPClassTag{} &\012                                    (hint::f",
"pclass_tag_def::normal |\012                                     hint::fpclass_tag_def::subnormal));\012  // r is in the range [0.5, 1) after frexp\012  // putting r in the range [sqrt(2)/2, sqrt(2))\012#ifdef SIMD_CF_IS_FIXED\012  SIMD_IF_BEGIN (r < numbers::inv_sqrt2) {\012    r *= 2.0;\012    k -= 1;\012  } SIMD_IF_END;\012#else\012  auto r_shifted = r * 2.0;\012  auto k_shifted = k - 1;\012  auto to_shift = r < numbers::inv_sqrt2;\012  r.merge(r_shifted, to_shift);\012  k.merge(k_shifted, to_shift);\012#endif\012  return r;\012}\012\012// changes variable to 2 * (orig - 1) / (orig + 1)\012template<int width>\012CM_INLINE vector<double, width> change_variable(vector<double, width> orig) {\012  vector<double, width> nom = orig - 1.0;\012  vector<double, width> denom = 0.5 * orig + 0.5;\012  return nom / denom;\012}\012\012// Calculates polynomial.\012template<int width>\012CM_INLINE vector<double, width> calc_poly(vector<double, width> g) {\012  vector<double, poly_order> poly_coef(poly_coef_init);\012  vector<double, width> poly_val = poly_coef[poly_order - 1];\012#pragma unroll\012  for (int i = poly_o",
"rder - 2; i >= 0; --i)\012    poly_val = poly_val * g + poly_coef[i];\012\012  return poly_val;\012}\012\012// Computes log on reduced range.\012// log is represented as:\012// log(r) = z + z^3 * F(z^2), where z = z(r) - new variable\012// F(g) is defined with polynomial approximation.\012template<int width>\012CM_INLINE vector<double, width> log_reduced(vector<double, width> r) {\012  vector<double, width> z = change_variable(r);\012  vector<double, width> g = z * z;\012  vector<double, width> poly = calc_poly(g);\012  return z + z * g * poly;\012}\012\012// Based on the computed log for reduced domain calculates log for the\012// original arg.\012// arg = r * 2 ^ k\012template<int width>\012CM_INLINE vector<double, width> log_unfold(vector<double, width> log_r,\012                                           vector<int16_t, width> k) {\012  return (log_r + k * ln2_lo) + k * ln2_hi;\012}\012\012// Calculates logarithm for numeric values.\012// For all arguments out of range (0.0, +inf) result is unspecified.\012template<typename FPClassTag, int width>\012CM_INLINE vector<double, width> log_numeric(",
"vector<double, width> arg) {\012  vector<int16_t, width> k;\012  vector<double, width> r = reduce_range<FPClassTag>(arg, k);\012  vector<double, width> log_r = log_reduced(r);\012  return log_unfold(log_r, k);\012}\012\012// TODO: move to numeric_limits when there is numeric_limits\012template<typename FloatT>\012CM_INLINE FloatT quiet_NaN() {\012  using UInt = typename detail::FloatDescr<FloatT>::SameSizeUInt;\012  vector<UInt, 1> uint_nan = ~0;\012  vector<FloatT, 1> nan = uint_nan.format<FloatT>();\012  return nan[0];\012}\012\012// TODO: move to numeric_limits when there is numeric_limits\012template<typename FloatT>\012CM_INLINE FloatT infinity() {\012  using UInt = typename detail::FloatDescr<FloatT>::SameSizeUInt;\012  vector<UInt, 1> uint_inf = detail::FloatDescr<FloatT>::Exp::Mask;\012  vector<FloatT, 1> inf = uint_inf.format<FloatT>();\012  return inf[0];\012}\012\012// Fixes result for NaN, inf, zero, negative input.\012// New fixed result is returned.\012template<typename FPClassTag, int width>\012CM_INLINE vector<double, width> fix_corner(vector<double, width> arg,\012             ",
"                              vector<double, width> res) {\012  Mask<width> is_nan_res(arg < 0.0);\012  if constexpr (FPClassTag::template has_v<hint::fpclass_tag_def::nan_t>)\012    is_nan_res |= isnan(arg);\012  res.merge(quiet_NaN<double>(), is_nan_res.get());\012\012  if constexpr (FPClassTag::template has_v<hint::fpclass_tag_def::infinite_t>) {\012    res.merge(infinity<double>(), arg == infinity<double>());\012  }\012\012  if constexpr (FPClassTag::template has_v<hint::fpclass_tag_def::zero_t>)\012    res.merge(-infinity<double>(), arg == 0.0);\012  return res;\012}\012\012template<typename FPClassTag, int width>\012CM_INLINE vector<double, width> log_impl(vector<double, width> arg) {\012  vector<double, width> res = log_numeric<FPClassTag>(arg);\012  return fix_corner<FPClassTag>(arg, res);\012}\012\012} // namespace log_detail\012} // namespace math\012} // namespace cmtl\012#endif //  CM_CMTL_MATH_LOG_IMPL_H\012\000/*========================== begin_copyright_notice ============================\012\012Copyright (C) 2020-2021 Intel Corporation\012\012SPDX-License-Identifier: MIT\012\012=========",
"==================== end_copyright_notice ===========================*/\012\012#ifndef CM_CMTL_MATH_ROUND_H\012#define CM_CMTL_MATH_ROUND_H\012\012#include \"../mask.h\"\012#include \"../../cm_traits.h\"\012#include \"../../cm_common.h\"\012\012namespace cmtl {\012namespace math {\012\012/* round_fast<integral>: rounds argument to the nearest integer.\012 * It's an analog to lround/llround in C standard library.\012 * The function is inaccurate for some range of arguments, though it faster\012 * than general algorithm that considers those cases (more info below).\012 *\012 * Argument is scalar, vector or matrix of floating point type.\012 * Correspondingly scalar, vector or matrix of provided integer type\012 * is returned.\012 *\012 * Example of usage:\012 *    vector<double, 16> fvec = .....;\012 *    vector<int, 16> ivec = cmtl::math::round_fast<int>(fvec);\012 *\012 *\012 * If argument value is out of range of provided integer type,\012 * behavior is undefined.\012 *\012 * When the argument 2^frac_bit_size <= arg < 2^(frac_bit_size + 1)\012 * e.g. for float 2^23 <= arg < 2^24, rounding mode can effe",
"ct the result.\012 * The result will be the real result +/- 1.\012 */\012\012namespace detail_round_fast {\012template<typename FloatT, typename IntT>\012void arg_type_check() {\012  static_assert(std::is_floating_point<FloatT>::value,\012      \"expected floating point value as argument\");\012  static_assert(std::is_integral<IntT>::value,\012      \"expected integral value as template parameter\");\012}\012} // namespace detail\012\012template<typename IntT, typename FloatT, int width>\012CM_INLINE vector<IntT, width> round_fast(vector<FloatT, width> arg) {\012  detail_round_fast::arg_type_check<FloatT, IntT>();\012\012  Mask<width> is_negative(arg < 0.0);\012  vector<FloatT, width> delta = 0.5;\012  vector<FloatT, width> delta_for_neg = -0.5;\012  delta.merge(delta_for_neg, is_negative.get());\012  return arg + delta;\012}\012\012template<typename IntT, typename FloatT, int width, int hight>\012CM_INLINE matrix<IntT, hight, width>\012round_fast(matrix<FloatT, hight, width> arg) {\012  detail_round_fast::arg_type_check<FloatT, IntT>();\012\012  vector<FloatT, width * hight> vec_arg = arg.format<Floa",
"tT>();\012  return round_fast<IntT>(vec_arg);\012}\012\012template<typename IntT, typename FloatT,\012    std::enable_if_t<std::is_floating_point<FloatT>::value, int> = 0,\012    std::enable_if_t<std::is_integral<IntT>::value, int> = 0>\012CM_INLINE IntT round_fast(FloatT arg) {\012  detail_round_fast::arg_type_check<FloatT, IntT>();\012  return arg + (arg < 0.0 \? -0.5 : 0.5);\012}\012\012} // namespace math\012} // namespace cmtl\012#endif // CM_CMTL_MATH_ROUND_H\012\000/*========================== begin_copyright_notice ============================\012\012Copyright (C) 2020-2021 Intel Corporation\012\012SPDX-License-Identifier: MIT\012\012============================= end_copyright_notice ===========================*/\012\012#ifndef  CM_CMTL_MATH_IMPL_UTILS_H\012#define  CM_CMTL_MATH_IMPL_UTILS_H\012\012namespace cmtl {\012namespace math {\012namespace detail {\012\012// is_pow2: checks whether var is power of 2\012// Works for integral types.\012template<typename T>\012constexpr bool is_pow2(T var) {\012  static_assert(std::is_integral<T>::value,\012      \"wrong argument: must be integral\");\012  if (var <= 0)\012    ",
"return false;\012  return !(var & (var - 1));\012}\012\012} // namespace detail\012} // namespace math\012} // namespace cmtl\012#endif //  CM_CMTL_MATH_IMPL_UTILS_H\012\000/*========================== begin_copyright_notice ============================\012\012Copyright (C) 2020-2021 Intel Corporation\012\012SPDX-License-Identifier: MIT\012\012============================= end_copyright_notice ===========================*/\012\012#ifndef  CM_CMTL_NUMBERS_H\012#define  CM_CMTL_NUMBERS_H\012\012#include \"../cm_traits.h\"\012\012/* cm/cmtl/numbers.h is a library with predefined numeric constans.\012 * It is an analog of <numbers> in C++20 standard library.\012 */\012\012namespace cmtl {\012namespace numbers {\012\012namespace detail {\012template<typename T>\012using enable_if_floating_t = std::enable_if_t<std::is_floating_point<T>::value, T>;\012} // namespace detail\012\012// e\012template<typename FloatT>\012CM_INLINE constexpr FloatT e_v\012  = detail::enable_if_floating_t<FloatT>(2.718281828459045235360287471352662498L);\012\012// log_2(e)\012template<typename FloatT>\012CM_INLINE constexpr FloatT log2e_v\012  = detail::enable_if_f",
"loating_t<FloatT>(1.442695040888963407359924681001892137L);\012\012// log_10(e)\012template<typename FloatT>\012CM_INLINE constexpr FloatT log10e_v\012  = detail::enable_if_floating_t<FloatT>(0.434294481903251827651128918916605082L);\012\012// pi\012template<typename FloatT>\012CM_INLINE constexpr FloatT pi_v\012  = detail::enable_if_floating_t<FloatT>(3.141592653589793238462643383279502884L);\012\012// 1/pi\012template<typename FloatT>\012CM_INLINE constexpr FloatT inv_pi_v\012  = detail::enable_if_floating_t<FloatT>(0.318309886183790671537767526745028724L);\012\012// 1/sqrt(pi)\012template<typename FloatT>\012CM_INLINE constexpr FloatT inv_sqrtpi_v\012  = detail::enable_if_floating_t<FloatT>(0.564189583547756286948079451560772586L);\012\012// ln(2)\012template<typename FloatT>\012CM_INLINE constexpr FloatT ln2_v\012  = detail::enable_if_floating_t<FloatT>(0.693147180559945309417232121458176568L);\012\012// ln(10)\012template<typename FloatT>\012CM_INLINE constexpr FloatT ln10_v\012  = detail::enable_if_floating_t<FloatT>(2.302585092994045684017991454684364208L);\012\012// sqrt(2)\012template<typename Flo",
"atT>\012CM_INLINE constexpr FloatT sqrt2_v\012  = detail::enable_if_floating_t<FloatT>(1.414213562373095048801688724209698079L);\012\012// sqrt(3)\012template<typename FloatT>\012CM_INLINE constexpr FloatT sqrt3_v\012  = detail::enable_if_floating_t<FloatT>(1.732050807568877293527446341505872367L);\012\012// 1/sqrt(2)\012template<typename FloatT>\012CM_INLINE constexpr FloatT inv_sqrt2_v\012  = detail::enable_if_floating_t<FloatT>(0.707106781186547524400844362104849039L);\012\012// 1/sqrt(3)\012template<typename FloatT>\012CM_INLINE constexpr FloatT inv_sqrt3_v\012  = detail::enable_if_floating_t<FloatT>(0.577350269189625764509148780501957456L);\012\012// The Euler-Mascheroni constant\012template<typename FloatT>\012CM_INLINE constexpr FloatT egamma_v\012  = detail::enable_if_floating_t<FloatT>(0.577215664901532860606512090082402431L);\012\012// The golden ratio, (1+sqrt(5))/2\012template<typename FloatT>\012CM_INLINE constexpr FloatT phi_v\012  = detail::enable_if_floating_t<FloatT>(1.618033988749894848204586834365638118L);\012\012// 1/ln(2) = ln(e)/ln(2) = log_2(e)\012template<typename FloatT>\012C",
"M_INLINE constexpr FloatT inv_ln2_v = log2e_v<FloatT>;\012\012CM_INLINE constexpr double e = e_v<double>;\012CM_INLINE constexpr double log2e = log2e_v<double>;\012CM_INLINE constexpr double log10e = log10e_v<double>;\012CM_INLINE constexpr double pi = pi_v<double>;\012CM_INLINE constexpr double inv_pi = inv_pi_v<double>;\012CM_INLINE constexpr double inv_sqrtpi = inv_sqrtpi_v<double>;\012CM_INLINE constexpr double ln2 = ln2_v<double>;\012CM_INLINE constexpr double ln10 = ln10_v<double>;\012CM_INLINE constexpr double sqrt2 = sqrt2_v<double>;\012CM_INLINE constexpr double sqrt3 = sqrt3_v<double>;\012CM_INLINE constexpr double inv_sqrt2 = inv_sqrt2_v<double>;\012CM_INLINE constexpr double inv_sqrt3 = inv_sqrt3_v<double>;\012CM_INLINE constexpr double egamma = egamma_v<double>;\012CM_INLINE constexpr double phi = phi_v<double>;\012CM_INLINE constexpr double inv_ln2 = inv_ln2_v<double>;\012\012} // namespace numbers\012} // namespace cmtl\012#endif // CM_CMTL_NUMBERS_H\012\000/*========================== begin_copyright_notice ============================\012\012Copyright (C) 2014-20",
"21 Intel Corporation\012\012SPDX-License-Identifier: MIT\012\012============================= end_copyright_notice ===========================*/\012\012#if (__INCLUDE_LEVEL__ == 1)\012static_assert(0, \"CM:w:cm_traits.h should not be included explicitly - only \"\012                 \"<cm/cm.h> is required\");\012#endif\012\012#ifndef _CLANG_CM_TRAITS_H_\012#define _CLANG_CM_TRAITS_H_\012\012namespace std {\012\012template<bool B, typename T, typename F>\012struct conditional { using type = T; };\012\012template<typename T, typename F>\012struct conditional<false, T, F> { using type = F; };\012\012template <bool, typename T = void> struct enable_if {};\012template <typename T> struct enable_if<true, T> {\012  typedef T type;\012};\012\012template <bool b, typename T = void>\012using enable_if_t = typename enable_if<b, T>::type;\012\012template <typename T, T v> struct integral_constant {\012  typedef T value_type;\012  static const value_type value = v;\012  typedef integral_constant<T, v> type;\012  operator value_type() { return value; }\012};\012\012typedef integral_constant<bool, true> true_type;\012typedef integral_cons",
"tant<bool, false> false_type;\012\012template <typename T, typename U> struct is_same : public false_type {};\012template <typename T> struct is_same<T, T> : public true_type {};\012\012template <typename T> struct remove_const {\012  typedef T type;\012};\012template <typename T> struct remove_const<const T> {\012  typedef T type;\012};\012\012template <typename T> struct is_integral_impl : false_type {};\012template <> struct is_integral_impl<bool> : true_type {};\012template <> struct is_integral_impl<char> : true_type {};\012template <> struct is_integral_impl<signed char> : true_type {};\012template <> struct is_integral_impl<unsigned char> : true_type {};\012template <> struct is_integral_impl<short> : true_type {};\012template <> struct is_integral_impl<unsigned short> : true_type {};\012template <> struct is_integral_impl<int> : true_type {};\012template <> struct is_integral_impl<unsigned int> : true_type {};\012template <> struct is_integral_impl<long> : true_type {};\012template <> struct is_integral_impl<unsigned long> : true_type {};\012template <> struct is_integ",
"ral_impl<long long> : true_type {};\012template <> struct is_integral_impl<unsigned long long> : true_type {};\012\012template <typename T>\012struct is_integral : is_integral_impl<typename std::remove_const<T>::type> {};\012\012template <typename T>\012struct is_signed\012    : integral_constant<bool, is_integral<T>::value && (T(-1) < T(0))> {};\012\012template <typename T>\012struct is_unsigned\012    : integral_constant<bool, is_integral<T>::value && (T(-1) > T(0))> {};\012\012template <typename T> struct is_long_long_impl : false_type {};\012template <> struct is_long_long_impl<unsigned long long> : true_type {};\012template <> struct is_long_long_impl<long long> : true_type {};\012\012template <typename T> struct is_long_long : is_long_long_impl<T> {};\012\012template <typename T>\012struct is_floating_point\012    : integral_constant<\012          bool,\012          std::is_same<half,  typename std::remove_const<T>::type>::value ||\012          std::is_same<float,  typename std::remove_const<T>::type>::value ||\012          std::is_same<double, typename std::remove_const<T>::type",
">::value> {};\012\012template<typename T> struct is_pointer_impl : false_type {};\012template<typename T> struct is_pointer_impl<T*> : true_type {};\012\012template<typename T>\012struct is_pointer : is_pointer_impl<typename std::remove_const<T>::type> {};\012\012// Extends to cm vector/matrix types.\012template <typename T, int N> struct is_floating_point<vector<T, N> > {\012  static const bool value = is_floating_point<T>::value;\012};\012\012template <typename T, int N> struct is_floating_point<vector_ref<T, N> > {\012  static const bool value = is_floating_point<T>::value;\012};\012\012template <typename T, int N1, int N2>\012struct is_floating_point<matrix<T, N1, N2> > {\012  static const bool value = is_floating_point<T>::value;\012};\012\012template <typename T, int N1, int N2>\012struct is_floating_point<matrix_ref<T, N1, N2> > {\012  static const bool value = is_floating_point<T>::value;\012};\012\012template <typename T, int N> struct is_integral<vector<T, N> > {\012  static const bool value = is_integral<T>::value;\012};\012\012template <typename T, int N> struct is_integral<vector_ref<T, ",
"N> > {\012  static const bool value = is_integral<T>::value;\012};\012\012template <typename T, int N1, int N2> struct is_integral<matrix<T, N1, N2> > {\012  static const bool value = is_integral<T>::value;\012};\012\012template <typename T, int N1, int N2>\012struct is_integral<matrix_ref<T, N1, N2> > {\012  static const bool value = is_integral<T>::value;\012};\012\012template< typename T > struct remove_reference { typedef T type; };\012template< typename T > struct remove_reference<T&> { typedef T type; };\012template< typename T > struct remove_reference<T&&> { typedef T type; };\012\012template<typename T>\012using remove_reference_t = typename remove_reference<T>::type;\012\012template <typename T> T&& forward(remove_reference_t<T>& arg) noexcept;\012template <typename T> T&& forward(remove_reference_t<T>&& arg) noexcept;\012\012template< typename T > using remove_reference_t = typename remove_reference<T>::type;\012\012template <typename T>\012CM_INLINE T&& forward(remove_reference_t<T>& t) noexcept\012{\012  return static_cast<T&&>(t);\012}\012\012template <typename T>\012CM_INLINE T&& forward(",
"remove_reference_t<T>&& t) noexcept\012{\012  return static_cast<T&&>(t);\012}\012\012} // namespace std\012\012namespace details {\012\012template <typename T> struct is_cm_vector {\012  static const bool value = false;\012};\012\012template <typename T, int N> struct is_cm_vector<vector<T, N> > {\012  static const bool value = true;\012};\012\012template <typename T, int N> struct is_cm_vector<vector_ref<T, N> > {\012  static const bool value = true;\012};\012\012template <typename T, int N1, int N2> struct is_cm_vector<matrix<T, N1, N2> > {\012  static const bool value = true;\012};\012\012template <typename T, int N1, int N2>\012struct is_cm_vector<matrix_ref<T, N1, N2> > {\012  static const bool value = true;\012};\012\012template <typename T>\012struct is_cm_scalar\012    : std::integral_constant<\012          bool,\012          std::is_same<float, typename std::remove_const<T>::type>::value ||\012              std::is_same<double,\012                           typename std::remove_const<T>::type>::value ||\012              std::is_same<half,\012                           typename std::remove_const<T>::type>::value",
" ||\012              std::is_same<char, typename std::remove_const<T>::type>::value ||\012              std::is_same<signed char,\012                           typename std::remove_const<T>::type>::value ||\012              std::is_same<unsigned char,\012                           typename std::remove_const<T>::type>::value ||\012              std::is_same<short, typename std::remove_const<T>::type>::value ||\012              std::is_same<unsigned short,\012                           typename std::remove_const<T>::type>::value ||\012              std::is_same<int, typename std::remove_const<T>::type>::value ||\012              std::is_same<unsigned int,\012                           typename std::remove_const<T>::type>::value ||\012              std::is_same<long, typename std::remove_const<T>::type>::value ||\012              std::is_same<unsigned long,\012                           typename std::remove_const<T>::type>::value ||\012              std::is_same<long long,\012                           typename std::remove_const<T>::type>::value ||\012          ",
"    std::is_same<unsigned long long,\012                           typename std::remove_const<T>::type>::value> {};\012\012template <typename T>\012struct is_dword_type\012    : std::integral_constant<\012          bool, std::is_same<int, typename std::remove_const<T>::type>::value ||\012                    std::is_same<unsigned int, typename std::remove_const<\012                                                   T>::type>::value> {};\012\012template <typename T, int N> struct is_dword_type<vector<T, N> > {\012  static const bool value = is_dword_type<T>::value;\012};\012\012template <typename T, int N> struct is_dword_type<vector_ref<T, N> > {\012  static const bool value = is_dword_type<T>::value;\012};\012\012template <typename T, int N1, int N2> struct is_dword_type<matrix<T, N1, N2> > {\012  static const bool value = is_dword_type<T>::value;\012};\012\012template <typename T, int N1, int N2>\012struct is_dword_type<matrix_ref<T, N1, N2> > {\012  static const bool value = is_dword_type<T>::value;\012};\012\012template <typename T>\012struct is_word_type\012    : std::integral_constant<\012   ",
"       bool,\012          std::is_same<short, typename std::remove_const<T>::type>::value ||\012              std::is_same<unsigned short,\012                           typename std::remove_const<T>::type>::value> {};\012\012template <typename T, int N> struct is_word_type<vector<T, N> > {\012  static const bool value = is_word_type<T>::value;\012};\012\012template <typename T, int N> struct is_word_type<vector_ref<T, N> > {\012  static const bool value = is_word_type<T>::value;\012};\012\012template <typename T, int N1, int N2> struct is_word_type<matrix<T, N1, N2> > {\012  static const bool value = is_word_type<T>::value;\012};\012\012template <typename T, int N1, int N2>\012struct is_word_type<matrix_ref<T, N1, N2> > {\012  static const bool value = is_word_type<T>::value;\012};\012\012template <typename T>\012struct is_byte_type\012    : std::integral_constant<\012          bool,\012          std::is_same<char, typename std::remove_const<T>::type>::value ||\012              std::is_same<unsigned char,\012                           typename std::remove_const<T>::type>::value> {};\012\012templat",
"e <typename T, int N> struct is_byte_type<vector<T, N> > {\012  static const bool value = is_byte_type<T>::value;\012};\012\012template <typename T, int N> struct is_byte_type<vector_ref<T, N> > {\012  static const bool value = is_byte_type<T>::value;\012};\012\012template <typename T, int N1, int N2> struct is_byte_type<matrix<T, N1, N2> > {\012  static const bool value = is_byte_type<T>::value;\012};\012\012template <typename T, int N1, int N2>\012struct is_byte_type<matrix_ref<T, N1, N2> > {\012  static const bool value = is_byte_type<T>::value;\012};\012\012template <typename T>\012struct is_fp_type\012    : std::integral_constant<\012          bool,\012          std::is_same<float, typename std::remove_const<T>::type>::value> {};\012\012template <typename T>\012struct is_df_type\012    : std::integral_constant<\012          bool,\012          std::is_same<double, typename std::remove_const<T>::type>::value> {};\012\012template <typename T>\012struct is_fp_or_dword_type\012    : std::integral_constant<\012          bool,\012          std::is_same<float, typename std::remove_const<T>::type>::value ||\012  ",
"            std::is_same<int, typename std::remove_const<T>::type>::value ||\012              std::is_same<unsigned int,\012                           typename std::remove_const<T>::type>::value> {};\012\012template <typename T>\012struct is_qword_type\012    : std::integral_constant<\012          bool, std::is_same<long long, typename std::remove_const<T>::type>::value ||\012          std::is_same<unsigned long long, typename std::remove_const<T>::type>::value> {};\012\012template <typename T, int N> struct is_qword_type<vector<T, N> > {\012  static const bool value = is_qword_type<T>::value;\012};\012\012template <typename T, int N> struct is_qword_type<vector_ref<T, N> > {\012  static const bool value = is_qword_type<T>::value;\012};\012\012template <typename T, int N1, int N2> struct is_qword_type<matrix<T, N1, N2> > {\012  static const bool value = is_qword_type<T>::value;\012};\012\012template <typename T, int N1, int N2>\012struct is_qword_type<matrix_ref<T, N1, N2> > {\012  static const bool value = is_qword_type<T>::value;\012};\012\012// Extends to cm vector/matrix types.\012templa",
"te <typename T, int N> struct is_fp_or_dword_type<vector<T, N> > {\012  static const bool value = is_fp_or_dword_type<T>::value;\012};\012\012template <typename T, int N> struct is_fp_or_dword_type<vector_ref<T, N> > {\012  static const bool value = is_fp_or_dword_type<T>::value;\012};\012\012template <typename T, int N1, int N2>\012struct is_fp_or_dword_type<matrix<T, N1, N2> > {\012  static const bool value = is_fp_or_dword_type<T>::value;\012};\012\012template <typename T, int N1, int N2>\012struct is_fp_or_dword_type<matrix_ref<T, N1, N2> > {\012  static const bool value = is_fp_or_dword_type<T>::value;\012};\012\012\012template <typename T>\012struct is_half_type\012    : std::integral_constant<bool,\012                            std::is_same<half,\012                                typename std::remove_const<T>::type>::value> {\012};\012template <typename T>\012struct is_char_type\012    : std::integral_constant<\012          bool,\012          std::is_same<char, typename std::remove_const<T>::type>::value> {};\012template <typename T>\012struct is_float_type\012    : std::integral_constant<\012    ",
"      bool,\012          std::is_same<float, typename std::remove_const<T>::type>::value> {};\012template <typename T>\012struct is_short_type\012    : std::integral_constant<\012          bool,\012          std::is_same<short, typename std::remove_const<T>::type>::value> {};\012\012template <typename T>\012struct is_float_or_half\012    : std::integral_constant<\012          bool,\012          std::is_same<half, typename std::remove_const<T>::type>::value ||\012              std::is_same<float, typename std::remove_const<T>::type>::value> {\012};\012\012// compile-time checks if first template parameter is equal for any other\012template <typename...> struct is_one_of {\012  static constexpr bool value = false;\012};\012\012template <typename Checked, typename First, typename... Other>\012struct is_one_of<Checked, First, Other...> {\012  static constexpr bool value =\012      std::is_same<typename std::remove_const<Checked>::type,\012                   typename std::remove_const<First>::type>::value ||\012      is_one_of<Checked, Other...>::value;\012};\012template <typename Checked, typena",
"me... T>\012inline constexpr bool is_one_of_v = is_one_of<Checked, T...>::value;\012\012// compile-time checks if compile-time known  element of enum class is equal for\012// any other compile-time known elements of enum\012template <typename enumClass, enumClass... E> struct is_one_of_enum {\012  static constexpr bool value = false;\012};\012\012template <typename enumClass, enumClass Checked, enumClass First,\012          enumClass... Else>\012struct is_one_of_enum<enumClass, Checked, First, Else...> {\012  static constexpr bool value =\012      (Checked == First) || is_one_of_enum<enumClass, Checked, Else...>::value;\012};\012template <typename enumClass, enumClass... T>\012inline constexpr bool is_one_of_enum_v = is_one_of_enum<enumClass, T...>::value;\012\012// Extends to cm vector/matrix types.\012template <typename T, int N> struct is_float_or_half<vector<T, N> > {\012  static const bool value = is_float_or_half<T>::value;\012};\012\012template <typename T, int N> struct is_float_or_half<vector_ref<T, N> > {\012  static const bool value = is_float_or_half<T>::value;\012};\012\012te",
"mplate <typename T, int N1, int N2>\012struct is_float_or_half<matrix<T, N1, N2> > {\012  static const bool value = is_float_or_half<T>::value;\012};\012\012template <typename T, int N1, int N2>\012struct is_float_or_half<matrix_ref<T, N1, N2> > {\012  static const bool value = is_float_or_half<T>::value;\012};\012\012template <typename T> struct dword_type {\012  typedef T type;\012};\012template <> struct dword_type<char> {\012  typedef int type;\012};\012template <> struct dword_type<short> {\012  typedef int type;\012};\012template <> struct dword_type<uchar> {\012  typedef uint type;\012};\012template <> struct dword_type<ushort> {\012  typedef uint type;\012};\012\012template <typename T> struct byte_type {\012  typedef T type;\012};\012template <> struct byte_type<short> {\012  typedef char type;\012};\012template <> struct byte_type<int> {\012  typedef char type;\012};\012template <> struct byte_type<ushort> {\012  typedef uchar type;\012};\012template <> struct byte_type<uint> {\012  typedef uchar type;\012};\012\012template <typename T> struct word_type {\012  typedef T type;\012};\012template <> struct word_type<char> {\012  typedef ",
"short type;\012};\012template <> struct word_type<int> {\012  typedef short type;\012};\012template <> struct word_type<uchar> {\012  typedef ushort type;\012};\012template <> struct word_type<uint> {\012  typedef ushort type;\012};\012\012/// make_signed / make_unsigned - similar to the STL class template of the same name\012template <typename T> struct make_signed {\012  typedef T type;\012};\012template <> struct make_signed<unsigned long long> {\012  typedef long long type;\012};\012template <> struct make_signed<unsigned int> {\012  typedef int type;\012};\012template <> struct make_signed<unsigned short> {\012  typedef short type;\012};\012template <> struct make_signed<unsigned char> {\012  typedef char type;\012};\012\012template <typename T> struct make_unsigned {\012  typedef T type;\012};\012template <> struct make_unsigned<long long> {\012  typedef unsigned long long type;\012};\012template <> struct make_unsigned<int> {\012  typedef unsigned int type;\012};\012template <> struct make_unsigned<short> {\012  typedef unsigned short type;\012};\012template <> struct make_unsigned<char> {\012  typedef unsigned char type;\012};\012",
"\012/// Transorms input type to a non-_ref type (matrix_ref->matrix, vector_ref->vector)\012template <typename T> struct remove_ref { using type = T; };\012template <typename T, int N> struct remove_ref<vector_ref<T, N> > {\012  using type = vector<T, N>;\012};\012template <typename T, int N, int M> struct remove_ref<matrix_ref<T, N, M> > {\012  using type = matrix<T, N, M>;\012};\012template <typename T> using remove_ref_t = typename remove_ref<T>::type;\012\012/// Convert types into vector_ref types\012template <typename T> struct vector_ref_type { typedef vector_ref<T, 1> type; };\012template <typename T, int N> struct vector_ref_type<vector<T, N> > {\012  typedef vector_ref<T, N> type;\012};\012template <typename T, int N> struct vector_ref_type<vector_ref<T, N> > {\012  typedef vector_ref<T, N> type;\012};\012template <typename T, int N, int M> struct vector_ref_type<matrix<T, N, M> > {\012  typedef vector_ref<T, N * M> type;\012};\012template <typename T, int N, int M>\012struct vector_ref_type<matrix_ref<T, N, M> > {\012  typedef vector_ref<T, N * M> type;\012};\012template <typ",
"ename T> struct vector_ref_type<T &> {\012  typedef typename vector_ref_type<T>::type type;\012};\012template <typename T> struct vector_ref_type<T &&> {\012  typedef typename vector_ref_type<T>::type type;\012};\012template <typename T> struct vector_ref_type<const T> {\012  typedef typename vector_ref_type<T>::type type;\012};\012\012/// Convert types into vector types\012template <typename T> struct vector_type {\012  typedef vector<T, 1> type;\012};\012template <typename T, int N> struct vector_type<vector<T, N> > {\012  typedef vector<T, N> type;\012};\012template <typename T, int N> struct vector_type<vector_ref<T, N> > {\012  typedef vector<T, N> type;\012};\012template <typename T, int N, int M> struct vector_type<matrix<T, N, M> > {\012  typedef vector<T, N *M> type;\012};\012template <typename T, int N, int M> struct vector_type<matrix_ref<T, N, M> > {\012  typedef vector<T, N *M> type;\012};\012template <typename T> struct vector_type<T &> {\012  typedef typename vector_type<T>::type type;\012};\012template <typename T> struct vector_type<T &&> {\012  typedef typename vector_type<T>::ty",
"pe type;\012};\012template <typename T> struct vector_type<const T> {\012  typedef typename vector_type<T>::type type;\012};\012\012/// Get the computation type.\012template <typename T1, typename T2> struct computation_type {\012  // Currently only arithmetic operations are needed.\012  typedef decltype(T1() + T2()) type;\012};\012\012// Get the common type.\012template <typename T1, typename T2> struct common_type {\012  typedef decltype(true \? T1() : T2()) type;\012};\012\012// Base case for checking if a type U is one of the types.\012template <typename U> constexpr bool is_type() { return false; }\012\012template <typename U, typename T, typename... Ts> constexpr bool is_type() {\012  using _U = typename std::remove_const<U>::type;\012  using _T = typename std::remove_const<T>::type;\012  return std::is_same<_U, _T>::value || is_type<_U, Ts...>();\012}\012\012template <typename T> constexpr bool check_when_instantiated(bool check) {\012  return check;\012}\012\012} // details\012\012#endif // _CLANG_CM_TRAITS_H_\012\000/*========================== begin_copyright_notice ============================\012\012Copy",
"right (C) 2014-2021 Intel Corporation\012\012SPDX-License-Identifier: MIT\012\012============================= end_copyright_notice ===========================*/\012\012#if (__INCLUDE_LEVEL__ == 1)\012static_assert(0, \"CM:w:cm_util.h should not be included explicitly - only \"\012                 \"<cm/cm.h> is required\");\012#endif\012\012#ifndef _CLANG_CM_UTIL_H_\012#define _CLANG_CM_UTIL_H_\012\012#include \"cm_traits.h\"\012#include \"cm_common.h\"\012\012namespace details {\012\012/// Constant in number of bytes.\012enum {\012  BYTE = 1,\012  WORD = 2,\012  DWORD = 4,\012  QWORD = 8,\012  OWORD = 16,\012  GRF = 32\012};\012\012/// Round up N to be multiple of M\012static constexpr unsigned int roundUpNextMultiple(unsigned int N,\012                                                  unsigned int M) {\012  return ((N + M - 1) / M) * M;\012}\012\012/// Compute the next power of 2 at compile time.\012static constexpr unsigned int getNextPowerOf2(unsigned int n,\012                                              unsigned int k = 1) {\012  return (k >= n) \? k : getNextPowerOf2(n, k * 2);\012}\012\012/// Check if a given 32 bit positive int",
"eger is a power of 2 at compile time.\012static inline constexpr bool isPowerOf2(unsigned int n) {\012  return (n & (n - 1)) == 0;\012}\012\012static inline constexpr bool isPowerOf2(unsigned int n, unsigned int limit) {\012  return (n & (n - 1)) == 0 && n <= limit;\012}\012\012/// Do the assignment conditionally. This is to avoid template instantiation\012/// errors for unreachable branches. For example, the following code will fail\012/// to instantiate, for any integer pair (N1, N2). This is because although\012/// true/false-branch cannot be executed, both branches need fully\012/// instantitated, resulting out-of-bound errors during compilation.\012///\012/// \\code\012/// template <int N1, int N2>\012/// void foo(vector<float, N1> v1, vector<float, N2> v2) {\012///   if (N1 < N2)\012///     v1 = v2.select<N1, 1>();\012///   else\012///     v2 = v2.select<N2, 1>();\012/// }\012/// \\code\012template <typename T, int N1, int N2>\012CM_NODEBUG CM_INLINE typename std::enable_if<(N1 <= N2), void>::type\012if_assign(vector_ref<T, N1> v1, vector<T, N2> v2) {\012  v1 = v2.select<N1, 1>();\012}\012\012",
"template <typename T, int N1, int N2>\012CM_NODEBUG CM_INLINE typename std::enable_if<(N1 > N2), void>::type\012if_assign(vector_ref<T, N1> v1, vector<T, N2> v2) {}\012\012template <typename T, int N, int M1, int M2>\012CM_NODEBUG CM_INLINE typename std::enable_if<(M1 <= M2), void>::type\012if_assign(matrix_ref<T, N, M1> m1, matrix<T, N, M2> m2) {\012  m1 = m2.select<N, 1, M1, 1>();\012}\012\012template <typename T, int N, int M1, int M2>\012CM_NODEBUG CM_INLINE typename std::enable_if<(M1 > M2), void>::type\012if_assign(matrix_ref<T, N, M1> m1, matrix<T, N, M2> m2) {}\012\012// Wrapper around vector select method.\012// Unlike select this fucntion ignores stride when width is 1,\012// so it is easier to use in generic code.\012// The functionality of select is reduced to only reading the region.\012template<int width, int stride, typename T, int size>\012CM_NODEBUG CM_INLINE vector<T, width>\012read_region(vector<T, size> vec, int offset) {\012  static_assert(width > 0 && width < size, \"invalid width\");\012  static_assert(stride > 0 && (width - 1) * stride < size,\012      \"i",
"nvalid invalid stride\");\012  vector<T, width> selection;\012  if constexpr (width == 1)\012    selection = vec[offset];\012  else\012    selection = vec.select<width, stride>(offset);\012  return selection;\012}\012\012// Wrapper around vector select method.\012// Unlike select this fucntion ignores stride when width is 1,\012// so it is easier to use in generic code.\012// The functionality of select is reduced to only writing the region.\012template<int stride, typename T, int size, int width>\012CM_NODEBUG CM_INLINE void\012write_region(vector_ref<T, size> vec, vector<T, width> insertion, int offset) {\012  static_assert(stride > 0 && (width - 1) * stride < size,\012      \"invalid invalid stride\");\012  if constexpr (width == 1)\012    vec[offset] = insertion[0];\012  else\012    vec.select<width, stride>(offset) = insertion;\012}\012\012static inline constexpr unsigned getMaxNumOfOWordSLM() {\012#if defined(CM_GEN12) || defined(CM_GEN12_2) || defined(CM_XEHP) || defined(CM_XEHPC) \\\012 || defined(CM_XEHPG)\012  return 16;\012#else\012  return 8;\012#endif\012}\012\012// to emit warnings, dependent on ",
"if function actually called\012template <typename T = void>\012constexpr bool always_false() {\012  return false;\012}\012\012template <VectorSize VS> constexpr unsigned lsc_vector_size() {\012  constexpr unsigned NElts[] = {0, 1, 2, 3, 4, 8, 16, 32, 64};\012  return NElts[static_cast<unsigned>(VS)];\012}\012\012template <unsigned N> constexpr VectorSize lsc_vector_size() {\012  switch (N) {\012  case 1:\012    return VectorSize::N1;\012  case 2:\012    return VectorSize::N2;\012  case 3:\012    return VectorSize::N3;\012  case 4:\012    return VectorSize::N4;\012  case 8:\012    return VectorSize::N8;\012  case 16:\012    return VectorSize::N16;\012  case 32:\012    return VectorSize::N32;\012  case 64:\012    return VectorSize::N64;\012  default:\012    break;\012  }\012  return VectorSize::N0;\012}\012\012template <typename T, DataSize DS> constexpr DataSize lsc_data_size() {\012  if constexpr (DS != DataSize::Default)\012    return DS;\012  else if constexpr (sizeof(T) == 1)\012    return DataSize::U8;\012  else if constexpr (sizeof(T) == 2)\012    return DataSize::U16;\012  else if constexpr (sizeof(T) == 4)\012    return DataSize",
"::U32;\012  else if constexpr (sizeof(T) == 8)\012    return DataSize::U64;\012  else if constexpr (DS == DataSize::Default)\012    static_assert(DS != DataSize::Default && \"unsupported data type\");\012  return DS;\012}\012\012template <typename T, int N, VectorSize VS> \012CM_INLINE auto lsc_data_type_ext() {\012  constexpr unsigned NumElts = lsc_vector_size<VS>() * N;\012  static_assert(NumElts > 0 && \"unexpected number of elements\");\012  if constexpr (sizeof(T) < 4)\012    return vector<uint32_t, NumElts>();\012  else\012    return vector<T, NumElts>();\012}\012\012template <typename T, int N, VectorSize VS> \012CM_INLINE auto lsc_data_type() {\012  constexpr unsigned NumElts = lsc_vector_size<VS>() * N;\012  static_assert(NumElts > 0 && \"unexpected number of elements\");\012  return vector<T, NumElts>();\012}\012// U8 and U16 types  are not supported\012// use U8U32 and U16U32 instead\012constexpr DataSize lsc_expand_ds(DataSize ds) {\012  if (ds == DataSize::U8)\012    return DataSize::U8U32;\012  if (ds == DataSize::U16)\012    return DataSize::U16U32;\012  return ds;\012}\012\012template <typename T> s",
"truct lsc_expand_type {\012  typedef typename std::conditional<sizeof(T) < 4, uint32_t, T>::type type;\012};\012\012// fp has to be bitcsted to uint before zextention\012template <typename T> struct lsc_bitcast_type {\012private:\012  typedef typename std::conditional<sizeof(T) == 2, uint16_t, T>::type _type1;\012  typedef typename std::conditional<sizeof(T) == 1, uint8_t, T>::type _type2;\012\012public:\012  typedef\012      typename std::conditional<sizeof(_type2) == 1, _type2, _type1>::type type;\012};\012// format U8U32 and U16U32 back to U8 and U16\012template <typename T, typename From, typename To>  \012CM_INLINE To lsc_format_ret(From from) {\012  auto _Formatted = from.format<T>();\012  constexpr int stride = _Formatted.n_elems() / from.n_elems();\012  To _Res = _Formatted.select<from.n_elems(), stride>(0);\012  return _Res;\012};\012\012template <AtomicOp Op> constexpr int lsc_atomic_nsrcs() {\012  switch (Op) {\012  case AtomicOp::IINC:\012  case AtomicOp::IDEC:\012  case AtomicOp::LOAD:\012    return 0;\012  case AtomicOp::STORE:\012  case AtomicOp::IADD:\012  case AtomicOp::ISUB:\012  case ",
"AtomicOp::SMIN:\012  case AtomicOp::SMAX:\012  case AtomicOp::UMIN:\012  case AtomicOp::UMAX:\012  case AtomicOp::FSUB:\012  case AtomicOp::FMIN:\012  case AtomicOp::FMAX:\012  case AtomicOp::FADD:\012  case AtomicOp::AND:\012  case AtomicOp::OR:\012  case AtomicOp::XOR:\012    return 1;\012  case AtomicOp::ICAS:\012  case AtomicOp::FCAS:\012    return 2;\012  default:\012    break;\012  }\012  return 0;\012}\012\012// Compute the data size for 2d block load or store.\012template <typename T, int NBlocks, int Height, int Width, bool Transposed,\012          bool Transformed>\012constexpr int getBlock2dDataSize() {\012  if (Transformed)\012    return roundUpNextMultiple(Height, 4 / sizeof(T)) * getNextPowerOf2(Width) *\012           NBlocks;\012  return Width * Height * NBlocks;\012}\012\012constexpr int getRoundedWidthFor2dTypedLSC(int Width) {\012  return Width < 4 \? 4 : details::getNextPowerOf2(Width);\012}\012\012// Return the default SIMT width.\012template <typename T = void> constexpr int lsc_default_simt() {\012#if CM_GENX >= 1280\012  return 32; // SIMD32: PVC and later\012#else // CM_GENX < 1280\012  return 16; // SIM",
"D16: DG2\012#endif // CM_GENX >= 1280\012}\012\012// Check for valid SIMT width.\012template <int N>\012constexpr bool lsc_check_simt() {\012#if CM_GENX >= 1280\012  return ((N == 32) || (N == 16)); // SIMD32: PVC\012#else // CM_GENX < 1280\012  return ((N == 16) || (N == 8)); // SIMD16: DG2\012#endif // CM_GENX >= 1280\012}\012\012// Check for valid type for atomic source and dest arguments\012template <typename T>\012constexpr bool lsc_check_atomic_src() {\012  // 8-bit atomics are unsupported\012  return sizeof(T) >= 2;\012}\012\012template <CacheHint mHint> class CacheHintWrap {\012  template <CacheHint...> class is_one_of_t;\012  template <CacheHint Last>\012  struct is_one_of_t<Last>\012      : std::conditional<Last == mHint, std::true_type, std::false_type>::type {\012  };\012  template <CacheHint Head, CacheHint... Tail>\012  struct is_one_of_t<Head, Tail...>\012      : std::conditional<Head == mHint, std::true_type,\012                         is_one_of_t<Tail...>>::type {};\012\012public:\012  constexpr operator CacheHint() const { return mHint; }\012  template <CacheHint... Hints> constexpr bool is",
"_one_of() const {\012    return is_one_of_t<Hints...>::value;\012  }\012};\012\012constexpr bool are_both(CacheHint First, CacheHint Second, CacheHint Val) {\012  return First == Val && Second == Val;\012}\012\012enum class LSCAction {\012  Prefetch,\012  Load,\012  Store,\012  Atomic\012};\012\012template <LSCAction Act, CacheHint L1, CacheHint L3>\012constexpr bool lsc_check_cache_hint() {\012  constexpr auto L1H = CacheHintWrap<L1>{};\012  constexpr auto L3H = CacheHintWrap<L3>{};\012  switch (Act) {\012  case LSCAction::Prefetch:\012    return L1H.is_one_of<CacheHint::Cached, CacheHint::Uncached, CacheHint::Streaming>() &&\012           L3H.is_one_of<CacheHint::Cached, CacheHint::Uncached>() &&\012           !are_both(L1H, L3H, CacheHint::Uncached);\012  case LSCAction::Load:\012    return are_both(L1H, L3H, CacheHint::Default) ||\012           (L1H.is_one_of<CacheHint::Uncached, CacheHint::Cached,\012                          CacheHint::Streaming>() &&\012            L3H.is_one_of<CacheHint::Uncached, CacheHint::Cached>()) ||\012           (L1H == CacheHint::ReadInvalidate && L3H == CacheHint",
"::Cached);\012  case LSCAction::Store:\012    return are_both(L1H, L3H, CacheHint::Default) ||\012           are_both(L1H, L3H, CacheHint::WriteBack) ||\012           (L1H.is_one_of<CacheHint::Uncached, CacheHint::WriteThrough,\012                          CacheHint::Streaming>() &&\012            L3H.is_one_of<CacheHint::Uncached, CacheHint::WriteBack>());\012\012  case LSCAction::Atomic:\012    return are_both(L1H, L3H, CacheHint::Default) ||\012           (L1H == CacheHint::Uncached &&\012            L3H.is_one_of<CacheHint::Uncached, CacheHint::WriteBack>());\012  }\012}\012\012template <ChannelMaskType Mask>\012constexpr VectorSize lsc_get_vector_size_from_channel_mask() {\012  switch (Mask) {\012  case ChannelMaskType::_CM_R_ENABLE:\012  case ChannelMaskType::_CM_G_ENABLE:\012  case ChannelMaskType::_CM_B_ENABLE:\012  case ChannelMaskType::_CM_A_ENABLE:\012    return VectorSize::N1;\012  case ChannelMaskType::_CM_GR_ENABLE:\012  case ChannelMaskType::_CM_BR_ENABLE:\012  case ChannelMaskType::_CM_BG_ENABLE:\012  case ChannelMaskType::_CM_AR_ENABLE:\012  case ChannelMaskType::_CM_AG_E",
"NABLE:\012  case ChannelMaskType::_CM_AB_ENABLE:\012    return VectorSize::N2;\012  case ChannelMaskType::_CM_BGR_ENABLE:\012  case ChannelMaskType::_CM_AGR_ENABLE:\012  case ChannelMaskType::_CM_ABR_ENABLE:\012  case ChannelMaskType::_CM_ABG_ENABLE:\012    return VectorSize::N3;\012  case ChannelMaskType::_CM_ABGR_ENABLE:\012    return VectorSize::N4;\012  default:\012    break;\012  }\012  return VectorSize::N0;\012}\012\012template <ChannelMaskType Mask>\012constexpr unsigned lsc_get_num_elements_from_channel_mask() {\012  constexpr auto _VS = lsc_get_vector_size_from_channel_mask<Mask>();\012  return lsc_vector_size<_VS>();\012}\012\012} // namespace details\012\012#endif /*_CLANG_CM_UTIL_H_ */\012\000/*========================== begin_copyright_notice ============================\012\012Copyright (C) 2015-2021 Intel Corporation\012\012SPDX-License-Identifier: MIT\012\012============================= end_copyright_notice ===========================*/\012\012#if (__INCLUDE_LEVEL__ == 1)\012static_assert(0, \"CM:w:cm_vme.h should not be included explicitly - only \"\012                 \"<cm/cm.h> is required\");\012#en",
"dif\012\012#ifndef _CLANG_CM_VME_H_\012#define _CLANG_CM_VME_H_\012\012\012#if defined(CM_GEN7_5)\012#include \"gen7_5_vme.h\"\012#elif defined(CM_GEN8) || defined(CM_GEN8_5)\012#include \"gen8_vme.h\"\012#elif defined(CM_GEN9) || defined(CM_GEN9_5)\012#include \"gen9_vme.h\"\012#elif defined(CM_GEN10)\012#include \"gen10_vme.h\"\012#elif defined(CM_GEN11)\012#include \"gen11_vme.h\"\012#elif defined(CM_GEN12)\012#include \"gen12_vme.h\"\012#else\012#endif\012\012#endif /* _CLANG_CM_VME_H_ */\012\000/*========================== begin_copyright_notice ============================\012\012Copyright (C) 2020-2021 Intel Corporation\012\012SPDX-License-Identifier: MIT\012\012============================= end_copyright_notice ===========================*/\012\012// this file is added to make the old compiler happy when the include path\012// is renamed \012 \012#ifndef CM_VS2013_H\012#define CM_VS2013_H\012\012#if _MSC_VER >= 1800\012// Workaround for VS2013 type traits  - these are not supported by icl\012// so we force them all to false here to allow them to appear without\012// compiler errors being generated.\012// Note: They should not be used",
" as they are not actually implemented!\012#define __is_nothrow_assignable(X,...) (false)\012#define __is_nothrow_constructible(X,...) (false)\012#define __is_nothrow_destructible(X,...) (false)\012#define __is_constructible(X,...) (false)\012#define __is_destructible(X,...) (false)\012#define __is_trivially_assignable(X,...) (false)\012#define __is_trivially_constructible(X,...) (false)\012#endif\012\012#endif /* CM_VS2013_H */\012\000/*========================== begin_copyright_notice ============================\012\012Copyright (C) 2015-2021 Intel Corporation\012\012SPDX-License-Identifier: MIT\012\012============================= end_copyright_notice ===========================*/\012\012#if (__INCLUDE_LEVEL__ == 1)\012static_assert(0, \"CM:w:gen10_vme.h should not be included explicitly - only \"\012                 \"<cm/cm.h> is required\");\012#endif\012\012#ifndef _CLANG_gen10_VME_H_\012#define _CLANG_gen10_VME_H_\012\012#include \"cm_send.h\"\012#include \"cm_util.h\"\012#include \"gen9_vme.h\" // Included to obtain legacy functionality\012\012typedef enum _VMEMsgTypeHEVC_ {\012  __VME_HEVC_SIC_MSG = 0,\012  _",
"_VME_HEVC_IME_MSG = 1,\012  __VME_HEVC_FBR_MSG = 2,\012  __VME_HEVC_HPM_MSG = 3,\012  __VME_HEVC_SRM_MSG = 4,\012  __VME_HEVC_RPM_MSG = 5,\012} __VMEMsgTypeHEVC;\012\012// Gen10 HEVC-specific functions\012\012// Macros for forming descriptor values for cm_send() and cm_sends()\012// The macros use a functional style - they take a descriptor value and any\012// required additional parameters and return an appropriate new descriptor\012// value\012\012// Set number of inputs (0..15)\012#define SEND_SET_Descriptor_Num_Inputs(v, i) ((v) | (((i) & 0xf) << 25))\012// Set number of inputs (0..31) in Extended Descriptor\012#define SEND_SET_Descriptor_Num_InputsExt(v, i) ((v) | (((i) & 0x1f) << 6))\012// Set number of outputs (0..31)\012#define SEND_SET_Descriptor_Num_Outputs(v, o) ((v) | (((o) & 0x1f) << 20))\012#define SEND_SET_Descriptor_Header_Present(v) ((v) | (1 << 19))\012#define SEND_SET_Descriptor_HEVC_Mode(v) ((v) | (1 << 18))\012#define SEND_SET_Descriptor_StreamIn_Enabled(v) ((v) | (1 << 16))\012// Set function, valid values in __VMEMsgTypeHEVC\012#define SEND_SET_Descriptor_F",
"unction(v, f) ((v) | (((f) & 0x7) << 8))\012\012// Create a descriptor value from a surface index (0..255)\012#define SEND_INIT_Descriptor_Surface(s) (cm_get_value(s) & 0xff)\012\012template <int N>\012CM_INLINE void\012run_vme_fbr(matrix<uchar, 4, 32> UNIInput, matrix<uchar, 4, 32> FBRInput,\012            SurfaceIndex curSurfIndex, uchar FBRMbMode, uchar FBRSubMbShape,\012            uchar FBRSubPredMode, matrix_ref<uchar, N, 32> FBROutput) {\012  matrix<uint, 8, 8> src = 0;\012  // mov(96)    VX(0, 0)<1>, UNIInput\012  src.format<uint>().select<32, 1>(0) =\012      UNIInput.format<uint>().select<32, 1>(0);\012  // mov  (128)   VX(3,0)<1>,  FBRInput\012  src.format<uint>().select<32, 1>(32) =\012      FBRInput.format<uint>().select<32, 1>(0);\012  // mov  (1)     VX(2,20)<1>, FBRMbMode\012  src.format<uchar, 8, 32>()(2, 20) = FBRMbMode;\012  // mov  (1)     VX(2,21)<1>, FBRSubMbShape\012  src.format<uchar, 8, 32>()(2, 21) = FBRSubMbShape;\012  //  mov  (1)     VX(2,22)<1>, FBRSubPredMode\012  src.format<uchar, 8, 32>()(2, 22) = FBRSubPredMode;\012\012  unsigned fCtrl = 0x3 << 1",
"3;\012  unsigned rspLength = N; // used to be 7 in previous platforms\012  unsigned msglength = 8;\012  uint Descriptor = (fCtrl & 0x7FFFF) + (1 << 19) + ((rspLength & 0x1f) << 20) +\012                    ((msglength & 0xF) << 25);\012\012  Descriptor = cm_get_value(curSurfIndex) + Descriptor;\012  cm_send(FBROutput.format<ushort, N, 16>(), src.format<ushort, 8, 16>(),\012          __SFID_CRE, Descriptor, 0u);\012}\012\012template <int N>\012CM_INLINE void\012run_vme_sic(matrix<uchar, 4, 32> UNIInput, matrix<uchar, 4, 32> SICInput,\012            SurfaceIndex curSurfIndex, matrix_ref<uchar, N, 32> UNIOutput) {\012  matrix<uint, 8, 8> src = 0;\012  // mov  (96)    VX(0,0)<1>,  UNIInput\012  src.format<uint>().select<32, 1>(0) =\012      UNIInput.format<uint>().select<32, 1>(0);\012  // mov  (128)   VX(3,0)<1>,  SICInput\012  src.format<uint>().select<32, 1>(32) =\012      SICInput.format<uint>().select<32, 1>(0);\012  unsigned fCtrl = 0x1 << 13;\012  unsigned rspLength = N; // used to be 7 in the previous platforms\012  unsigned msgLength = 8;\012  uint Descriptor = (fCtrl & 0x7FFFF",
") + (1 << 19) + ((rspLength & 0x1f) << 20) +\012                    ((msgLength & 0xF) << 25);\012\012  Descriptor = cm_get_value(curSurfIndex) + Descriptor;\012  cm_send(UNIOutput.format<ushort, N, 16>(), src.format<ushort, 8, 16>(),\012          __SFID_CRE, Descriptor, 0u);\012}\012\012template <int N>\012CM_INLINE void\012run_vme_idm(matrix<uchar, 4, 32> UNIInput, matrix<uchar, 1, 32> IDMInput,\012            SurfaceIndex curSurfIndex, matrix_ref<uchar, N, 32> IDMOutput) {\012  matrix<uint, 5, 8> src = 0;\012  // mov(96)    VX(0, 0)<1>, UNIInput\012  src.format<uint>().select<32, 1>(0) =\012      UNIInput.format<uint>().select<32, 1>(0);\012  // mov  (128)   VX(3,0)<1>,  IDMInput\012  src.format<uint>().select<8, 1>(32) = IDMInput.format<uint>().select<8, 1>(0);\012\012  unsigned fCtrl = 0;\012  unsigned rspLength = N; // used to 16 in the previous platforms\012  unsigned msglength = 5;\012  uint Descriptor = (fCtrl & 0x7FFFF) + (1 << 19) + ((rspLength & 0x1f) << 20) +\012                    ((msglength & 0xF) << 25);\012\012  Descriptor = cm_get_value(curSurfIndex) + Descriptor;",
"\012  cm_send(IDMOutput.format<ushort, N, 16>(), src.format<ushort, 5, 16>(),\012          __SFID_VME, Descriptor, 0u);\012}\012\012// Gen10 HEVC VME support\012\012#define selrows(r) select<r, 1, 32, 1>(0, 0).format<ushort, r, 16>()\012\012template <typename Dummy = void>\012CM_INLINE void cm_vme_hevc_ime(/*const*/ matrix<uchar, 5, 32> IMEInput,\012                               /*const*/ matrix<uchar, 10, 32> StreamInput,\012                               int LengthStreamInput, SurfaceIndex curSurfIndex,\012                               matrix_ref<uchar, 12, 32> StreamOutput) {\012  U32 Descriptor = SEND_INIT_Descriptor_Surface(curSurfIndex);\012\012  Descriptor = SEND_SET_Descriptor_Num_Inputs(Descriptor, IMEInput.n_rows());\012  Descriptor = SEND_SET_Descriptor_Header_Present(Descriptor);\012  Descriptor = SEND_SET_Descriptor_HEVC_Mode(Descriptor);\012  Descriptor = SEND_SET_Descriptor_Function(Descriptor, __VME_HEVC_IME_MSG);\012  Descriptor =\012      SEND_SET_Descriptor_Num_Outputs(Descriptor, StreamOutput.n_rows());\012\012  if (LengthStreamInput == 10) {\012    Descript",
"or = SEND_SET_Descriptor_StreamIn_Enabled(Descriptor);\012    U32 ExDescriptor =\012        SEND_SET_Descriptor_Num_InputsExt(__SFID_VME, StreamInput.n_rows());\012\012    cm_sends(StreamOutput.selrows(12), IMEInput.selrows(5),\012             StreamInput.selrows(10), ExDescriptor, Descriptor, 0);\012  } else\012    cm_send(StreamOutput.selrows(12), IMEInput.selrows(5), __SFID_VME,\012            Descriptor, 0);\012}\012\012template <typename Dummy = void>\012CM_INLINE void cm_vme_hevc_sic(/*const*/ matrix<uchar, 5, 32> SICInput,\012                               /*const*/ matrix<uchar, 8, 32> NPInput,\012                               int LengthNP, SurfaceIndex curSurfIndex,\012                               matrix_ref<uchar, 22, 32> SICOutput) {\012  U32 Descriptor = SEND_INIT_Descriptor_Surface(curSurfIndex);\012\012  Descriptor = SEND_SET_Descriptor_Num_Inputs(Descriptor, SICInput.n_rows());\012  Descriptor = SEND_SET_Descriptor_Header_Present(Descriptor);\012  Descriptor = SEND_SET_Descriptor_HEVC_Mode(Descriptor);\012  Descriptor = SEND_SET_Descriptor_Function(Desc",
"riptor, __VME_HEVC_SIC_MSG);\012\012  if (LengthNP > 0) {\012    Descriptor =\012        SEND_SET_Descriptor_Num_Outputs(Descriptor, SICOutput.n_rows());\012    U32 ExDescriptor = SEND_SET_Descriptor_Num_InputsExt(__SFID_CRE, LengthNP);\012\012    cm_sends(SICOutput.selrows(22), SICInput.selrows(5), NPInput.selrows(8),\012             ExDescriptor, Descriptor, 0);\012  } else {\012    Descriptor = SEND_SET_Descriptor_Num_Outputs(Descriptor, 2);\012\012    cm_send(SICOutput.selrows(2), SICInput.selrows(5), __SFID_CRE, Descriptor,\012            0);\012  }\012}\012\012template <typename Dummy = void>\012CM_INLINE void cm_vme_hevc_sc(/*const*/ matrix<uchar, 5, 32> SICInput,\012                              SurfaceIndex curSurfIndex,\012                              matrix_ref<uchar, 2, 32> SICOutput) {\012  U32 Descriptor = SEND_INIT_Descriptor_Surface(curSurfIndex);\012\012  Descriptor = SEND_SET_Descriptor_Num_Inputs(Descriptor, SICInput.n_rows());\012  Descriptor = SEND_SET_Descriptor_Header_Present(Descriptor);\012  Descriptor = SEND_SET_Descriptor_HEVC_Mode(Descriptor);\012  Descript",
"or = SEND_SET_Descriptor_Function(Descriptor, __VME_HEVC_SIC_MSG);\012  Descriptor = SEND_SET_Descriptor_Num_Outputs(Descriptor, SICOutput.n_rows());\012\012  cm_send(SICOutput.selrows(2), SICInput.selrows(5), __SFID_CRE, Descriptor, 0);\012}\012\012template <typename Dummy = void>\012CM_INLINE void\012cm_vme_hevc_hpm_u(/*const*/ matrix<uchar, 12, 32> HPMInput,\012                  /*const*/ matrix<uchar, 10, 32> StreamInputInter,\012                  SurfaceIndex curSurfIndex,\012                  matrix_ref<uchar, 23, 32> HPMOutput) {\012  U32 Descriptor = SEND_INIT_Descriptor_Surface(curSurfIndex);\012  U32 ExDescriptor =\012      SEND_SET_Descriptor_Num_InputsExt(__SFID_CRE, StreamInputInter.n_rows());\012\012  Descriptor = SEND_SET_Descriptor_Num_Inputs(Descriptor, HPMInput.n_rows());\012  Descriptor = SEND_SET_Descriptor_Header_Present(Descriptor);\012  Descriptor = SEND_SET_Descriptor_HEVC_Mode(Descriptor);\012  Descriptor = SEND_SET_Descriptor_Function(Descriptor, __VME_HEVC_HPM_MSG);\012  Descriptor = SEND_SET_Descriptor_Num_Outputs(Descriptor, HPMOutput.n_ro",
"ws());\012\012  cm_sends(HPMOutput.selrows(23), HPMInput.selrows(12),\012           StreamInputInter.selrows(10), ExDescriptor, Descriptor, 0);\012}\012\012template <typename Dummy = void>\012CM_INLINE void\012cm_vme_hevc_hpm_b(/*const*/ matrix<uchar, 12, 32> HPMInput,\012                  /*const*/ matrix<uchar, 20, 32> StreamInputInter,\012                  int LengthStreamInputInter, SurfaceIndex curSurfIndex,\012                  matrix_ref<uchar, 23, 32> HPMOutput) {\012  U32 Descriptor = SEND_INIT_Descriptor_Surface(curSurfIndex);\012  U32 ExDescriptor =\012      SEND_SET_Descriptor_Num_InputsExt(__SFID_CRE, LengthStreamInputInter);\012\012  Descriptor = SEND_SET_Descriptor_Num_Inputs(Descriptor, HPMInput.n_rows());\012  Descriptor = SEND_SET_Descriptor_Header_Present(Descriptor);\012  Descriptor = SEND_SET_Descriptor_HEVC_Mode(Descriptor);\012  Descriptor = SEND_SET_Descriptor_Function(Descriptor, __VME_HEVC_HPM_MSG);\012  Descriptor = SEND_SET_Descriptor_Num_Outputs(Descriptor, HPMOutput.n_rows());\012\012  cm_sends(HPMOutput.selrows(23), HPMInput.selrows(12),\012     ",
"      StreamInputInter.selrows(20), ExDescriptor, Descriptor, 0);\012}\012\012template <typename Dummy = void>\012CM_INLINE void cm_vme_hevc_fbr(/*const*/ matrix<uchar, 3, 32> UNIInput,\012                               /*const*/ matrix<uchar, 16, 32> CUInput,\012                               int ValidCULength, SurfaceIndex curSurfIndex,\012                               matrix_ref<uchar, 18, 32> FBROutput) {\012  U32 Descriptor = SEND_INIT_Descriptor_Surface(curSurfIndex);\012  U32 ExDescriptor =\012      SEND_SET_Descriptor_Num_InputsExt(__SFID_CRE, ValidCULength);\012\012  Descriptor = SEND_SET_Descriptor_Num_Inputs(Descriptor, UNIInput.n_rows());\012  Descriptor = SEND_SET_Descriptor_Header_Present(Descriptor);\012  Descriptor = SEND_SET_Descriptor_HEVC_Mode(Descriptor);\012  Descriptor = SEND_SET_Descriptor_Function(Descriptor, __VME_HEVC_FBR_MSG);\012  Descriptor = SEND_SET_Descriptor_Num_Outputs(Descriptor, 2 + ValidCULength);\012\012  cm_sends(FBROutput.selrows(18), UNIInput.selrows(3), CUInput.selrows(16),\012           ExDescriptor, Descriptor, 0);\012}\012\012te",
"mplate <typename Dummy = void>\012CM_INLINE void cm_vme_hevc_rpm(/*const*/ matrix<uchar, 7, 32> UNIInput,\012                               /*const*/ matrix<uchar, 16, 32> CUInput,\012                               int ValidCULength, SurfaceIndex curSurfIndex,\012                               matrix_ref<uchar, 8, 32> RPMOutput) {\012  U32 Descriptor = SEND_INIT_Descriptor_Surface(curSurfIndex);\012  U32 ExDescriptor =\012      SEND_SET_Descriptor_Num_InputsExt(__SFID_CRE, ValidCULength);\012\012  Descriptor = SEND_SET_Descriptor_Num_Inputs(Descriptor, UNIInput.n_rows());\012  Descriptor = SEND_SET_Descriptor_Header_Present(Descriptor);\012  Descriptor = SEND_SET_Descriptor_HEVC_Mode(Descriptor);\012  Descriptor = SEND_SET_Descriptor_Function(Descriptor, __VME_HEVC_RPM_MSG);\012  Descriptor = SEND_SET_Descriptor_Num_Outputs(Descriptor, RPMOutput.n_rows());\012\012  cm_sends(RPMOutput.selrows(8), UNIInput.selrows(7), CUInput.selrows(16),\012           ExDescriptor, Descriptor, 0);\012}\012\012template <typename Dummy = void>\012CM_INLINE void cm_vme_hevc_srm(/*const*/ ",
"matrix<uchar, 8, 32> UNIInput,\012                               /*const*/ matrix<uchar, 16, 32> CUInput,\012                               int ValidCULength, SurfaceIndex curSurfIndex,\012                               matrix_ref<uchar, 18, 32> SRMOutput) {\012  U32 Descriptor = SEND_INIT_Descriptor_Surface(curSurfIndex);\012  U32 ExDescriptor =\012      SEND_SET_Descriptor_Num_InputsExt(__SFID_CRE, ValidCULength);\012\012  Descriptor = SEND_SET_Descriptor_Num_Inputs(Descriptor, UNIInput.n_rows());\012  Descriptor = SEND_SET_Descriptor_Header_Present(Descriptor);\012  Descriptor = SEND_SET_Descriptor_HEVC_Mode(Descriptor);\012  Descriptor = SEND_SET_Descriptor_Function(Descriptor, __VME_HEVC_SRM_MSG);\012  Descriptor = SEND_SET_Descriptor_Num_Outputs(Descriptor, 2 + ValidCULength);\012\012  cm_sends(SRMOutput.selrows(18), UNIInput.selrows(8), CUInput.selrows(16),\012           ExDescriptor, Descriptor, 0);\012}\012\012#endif /* _CLANG_gen10_VME_H_ */\012\000/*========================== begin_copyright_notice ============================\012\012Copyright (C) 2015-2021 Intel",
" Corporation\012\012SPDX-License-Identifier: MIT\012\012============================= end_copyright_notice ===========================*/\012\012#if (__INCLUDE_LEVEL__ == 1)\012static_assert(0, \"CM:w:gen11_vme.h should not be included explicitly - only \"\012                 \"<cm/cm.h> is required\");\012#endif\012\012#ifndef _CLANG_gen11_VME_H_\012#define _CLANG_gen11_VME_H_\012\012#include \"cm_send.h\"\012#include \"cm_util.h\"\012#include \"gen9_vme.h\" // Included to obtain legacy functionality\012\012typedef enum _VMEMsgTypeHEVC_ {\012  __VME_HEVC_SKIP_RDE_MSG = 0,\012  __VME_HEVC_IME_MSG = 1,\012  __VME_HEVC_INTER_RDE_MSG = 2,\012  __VME_HEVC_INTRA_RDE_MSG = 3,\012  __VME_HEVC_FME_MESH_MSG = 4,\012} __VMEMsgTypeHEVC;\012\012// Gen11 HEVC-specific functions\012\012// Macros for forming descriptor values for cm_send() and cm_sends()\012// The macros use a functional style - they take a descriptor value and any\012// required additional parameters and return an appropriate new descriptor\012// value\012\012// Set number of inputs (0..15)\012#define SEND_SET_Descriptor_Num_Inputs(v, i) ((v) | (((i) & 0xf) << 25))\012/",
"/ Set number of inputs (0..31) in Extended Descriptor\012#define SEND_SET_Descriptor_Num_InputsExt(v, i) ((v) | (((i) & 0x1f) << 6))\012// Set number of outputs (0..31)\012#define SEND_SET_Descriptor_Num_Outputs(v, o) ((v) | (((o) & 0x1f) << 20))\012#define SEND_SET_Descriptor_Header_Present(v) ((v) | (1 << 19))\012#define SEND_SET_Descriptor_HEVC_Mode(v) ((v) | (1 << 18))\012#define SEND_SET_Descriptor_StreamIn_Enabled(v) ((v) | (1 << 16))\012// Set function, valid values in __VMEMsgTypeHEVC\012#define SEND_SET_Descriptor_Function(v, f) ((v) | (((f) & 0x7) << 8))\012\012// Create a descriptor value from a surface index (0..255)\012#define SEND_INIT_Descriptor_Surface(s) (cm_get_value(s) & 0xff)\012\012template <int N>\012CM_INLINE void\012run_vme_fbr(matrix<uchar, 4, 32> UNIInput, matrix<uchar, 4, 32> FBRInput,\012            SurfaceIndex curSurfIndex, uchar FBRMbMode, uchar FBRSubMbShape,\012            uchar FBRSubPredMode, matrix_ref<uchar, N, 32> FBROutput) {\012  matrix<uint, 8, 8> src = 0;\012  // mov(96)    VX(0, 0)<1>, UNIInput\012  src.format<uint>().select<",
"32, 1>(0) =\012      UNIInput.format<uint>().select<32, 1>(0);\012  // mov  (128)   VX(3,0)<1>,  FBRInput\012  src.format<uint>().select<32, 1>(32) =\012      FBRInput.format<uint>().select<32, 1>(0);\012  // mov  (1)     VX(2,20)<1>, FBRMbMode\012  src.format<uchar, 8, 32>()(2, 20) = FBRMbMode;\012  // mov  (1)     VX(2,21)<1>, FBRSubMbShape\012  src.format<uchar, 8, 32>()(2, 21) = FBRSubMbShape;\012  //  mov  (1)     VX(2,22)<1>, FBRSubPredMode\012  src.format<uchar, 8, 32>()(2, 22) = FBRSubPredMode;\012\012  unsigned fCtrl = 0x3 << 13;\012  unsigned rspLength = N; // used to be 7 in previous platforms\012  unsigned msglength = 8;\012  uint Descriptor = (fCtrl & 0x7FFFF) + (1 << 19) + ((rspLength & 0x1f) << 20) +\012                    ((msglength & 0xF) << 25);\012\012  Descriptor = cm_get_value(curSurfIndex) + Descriptor;\012  cm_send(FBROutput.format<ushort, N, 16>(), src.format<ushort, 8, 16>(),\012          __SFID_CRE, Descriptor, 0u);\012}\012\012template <int N>\012CM_INLINE void\012run_vme_sic(matrix<uchar, 4, 32> UNIInput, matrix<uchar, 4, 32> SICInput,\012            Surfac",
"eIndex curSurfIndex, matrix_ref<uchar, N, 32> UNIOutput) {\012  matrix<uint, 8, 8> src = 0;\012  // mov  (96)    VX(0,0)<1>,  UNIInput\012  src.format<uint>().select<32, 1>(0) =\012      UNIInput.format<uint>().select<32, 1>(0);\012  // mov  (128)   VX(3,0)<1>,  SICInput\012  src.format<uint>().select<32, 1>(32) =\012      SICInput.format<uint>().select<32, 1>(0);\012  unsigned fCtrl = 0x1 << 13;\012  unsigned rspLength = N; // used to be 7 in the previous platforms\012  unsigned msgLength = 8;\012  uint Descriptor = (fCtrl & 0x7FFFF) + (1 << 19) + ((rspLength & 0x1f) << 20) +\012                    ((msgLength & 0xF) << 25);\012\012  Descriptor = cm_get_value(curSurfIndex) + Descriptor;\012  cm_send(UNIOutput.format<ushort, N, 16>(), src.format<ushort, 8, 16>(),\012          __SFID_CRE, Descriptor, 0u);\012}\012\012template <int N>\012CM_INLINE void\012run_vme_idm(matrix<uchar, 4, 32> UNIInput,\012            SurfaceIndex curSurfIndex, matrix_ref<uchar, N, 32> IDMOutput) {\012  unsigned fCtrl = 0;\012  unsigned rspLength = N; // used to 16 in the previous platforms\012  unsigned ms",
"glength = 4;\012  uint Descriptor = (fCtrl & 0x7FFFF) + (1 << 19) + ((rspLength & 0x1f) << 20) +\012                    ((msglength & 0xF) << 25);\012\012  Descriptor = cm_get_value(curSurfIndex) + Descriptor;\012  cm_send(IDMOutput.format<ushort, N, 16>(), UNIInput.format<ushort, 4, 16>(),\012          __SFID_VME, Descriptor, 0u);\012}\012\012// Gen11 HEVC VME support\012\012#define selrows(r) select<r, 1, 32, 1>(0, 0).format<ushort, r, 16>()\012\012template <typename Dummy = void>\012CM_INLINE void\012cm_vme_hevc_skip_rde_implicit(/*const*/ matrix_ref<uchar, 10, 32> RDEInput,\012                              SurfaceIndex curSurfIndex,\012                              matrix_ref<uchar, 4, 32> RDEOutput) {\012  U32 Descriptor = SEND_INIT_Descriptor_Surface(curSurfIndex);\012\012  Descriptor = SEND_SET_Descriptor_Num_Inputs(Descriptor, RDEInput.n_rows());\012  Descriptor = SEND_SET_Descriptor_Header_Present(Descriptor);\012  Descriptor = SEND_SET_Descriptor_HEVC_Mode(Descriptor);\012  Descriptor =\012      SEND_SET_Descriptor_Function(Descriptor, __VME_HEVC_SKIP_RDE_MSG);\012  Descri",
"ptor = SEND_SET_Descriptor_Num_Outputs(Descriptor, RDEOutput.n_rows());\012\012  cm_send(RDEOutput.selrows(4), RDEInput.selrows(10), __SFID_CRE, Descriptor,\012          0);\012}\012\012template <typename Dummy = void>\012CM_INLINE void\012cm_vme_hevc_skip_rde_explicit(/*const*/ matrix_ref<uchar, 6, 32> RDEInput,\012                              SurfaceIndex curSurfIndex,\012                              matrix_ref<uchar, 12, 32> RDEOutput) {\012  U32 Descriptor = SEND_INIT_Descriptor_Surface(curSurfIndex);\012\012  Descriptor = SEND_SET_Descriptor_Num_Inputs(Descriptor, RDEInput.n_rows());\012  Descriptor = SEND_SET_Descriptor_Header_Present(Descriptor);\012  Descriptor = SEND_SET_Descriptor_HEVC_Mode(Descriptor);\012  Descriptor =\012      SEND_SET_Descriptor_Function(Descriptor, __VME_HEVC_SKIP_RDE_MSG);\012  Descriptor = SEND_SET_Descriptor_Num_Outputs(Descriptor, RDEOutput.n_rows());\012\012  cm_send(RDEOutput.selrows(12), RDEInput.selrows(6), __SFID_CRE, Descriptor,\012          0);\012}\012\012template <typename Dummy = void>\012CM_INLINE void cm_vme_hevc_ime(/*const*/ matrix",
"_ref<uchar, 5, 32> IMEInput,\012                               /*const*/ matrix_ref<uchar, 10, 32> StreamInput,\012                               int LengthStreamInput, SurfaceIndex curSurfIndex,\012                               matrix_ref<uchar, 11, 32> StreamOutput) {\012  U32 Descriptor = SEND_INIT_Descriptor_Surface(curSurfIndex);\012\012  Descriptor = SEND_SET_Descriptor_Num_Inputs(Descriptor, IMEInput.n_rows());\012  Descriptor = SEND_SET_Descriptor_Header_Present(Descriptor);\012  Descriptor = SEND_SET_Descriptor_HEVC_Mode(Descriptor);\012  Descriptor = SEND_SET_Descriptor_Function(Descriptor, __VME_HEVC_IME_MSG);\012  Descriptor =\012      SEND_SET_Descriptor_Num_Outputs(Descriptor, StreamOutput.n_rows());\012\012  if (LengthStreamInput == 10) {\012    Descriptor = SEND_SET_Descriptor_StreamIn_Enabled(Descriptor);\012    U32 ExDescriptor =\012        SEND_SET_Descriptor_Num_InputsExt(__SFID_VME, StreamInput.n_rows());\012\012    cm_sends(StreamOutput.selrows(11), IMEInput.selrows(5),\012             StreamInput.selrows(10), ExDescriptor, Descriptor, 0);\012  ",
"} else\012    cm_send(StreamOutput.selrows(11), IMEInput.selrows(5), __SFID_VME,\012            Descriptor, 0);\012}\012\012template <typename Dummy = void>\012CM_INLINE void\012cm_vme_hevc_inter_rde_implicit(/*const*/ matrix_ref<uchar, 10, 32> RDEInput,\012                               SurfaceIndex curSurfIndex,\012                               matrix_ref<uchar, 4, 32> RDEOutput) {\012  U32 Descriptor = SEND_INIT_Descriptor_Surface(curSurfIndex);\012\012  Descriptor = SEND_SET_Descriptor_Num_Inputs(Descriptor, RDEInput.n_rows());\012  Descriptor = SEND_SET_Descriptor_Header_Present(Descriptor);\012  Descriptor = SEND_SET_Descriptor_HEVC_Mode(Descriptor);\012  Descriptor =\012      SEND_SET_Descriptor_Function(Descriptor, __VME_HEVC_INTER_RDE_MSG);\012  Descriptor = SEND_SET_Descriptor_Num_Outputs(Descriptor, RDEOutput.n_rows());\012\012  cm_send(RDEOutput.selrows(4), RDEInput.selrows(10), __SFID_CRE, Descriptor,\012          0);\012}\012\012template <typename Dummy = void>\012CM_INLINE void\012cm_vme_hevc_inter_rde_explicit(/*const*/ matrix_ref<uchar, 5, 32> RDEInput,\012           ",
"                    SurfaceIndex curSurfIndex,\012                               matrix_ref<uchar, 4, 32> RDEOutput) {\012  U32 Descriptor = SEND_INIT_Descriptor_Surface(curSurfIndex);\012\012  Descriptor = SEND_SET_Descriptor_Num_Inputs(Descriptor, RDEInput.n_rows());\012  Descriptor = SEND_SET_Descriptor_Header_Present(Descriptor);\012  Descriptor = SEND_SET_Descriptor_HEVC_Mode(Descriptor);\012  Descriptor =\012      SEND_SET_Descriptor_Function(Descriptor, __VME_HEVC_INTER_RDE_MSG);\012  Descriptor = SEND_SET_Descriptor_Num_Outputs(Descriptor, RDEOutput.n_rows());\012\012  cm_send(RDEOutput.selrows(4), RDEInput.selrows(5), __SFID_CRE, Descriptor, 0);\012}\012\012template <typename Dummy = void>\012CM_INLINE void\012cm_vme_hevc_intra_rde(/*const*/ matrix_ref<uchar, 14, 32> RDEInput,\012                      int LengthLCNPInput, SurfaceIndex curSurfIndex,\012                      matrix_ref<uchar, 4, 32> RDEOutput) {\012  U32 Descriptor = SEND_INIT_Descriptor_Surface(curSurfIndex);\012\012  Descriptor = SEND_SET_Descriptor_Num_Inputs(Descriptor, 4 + LengthLCNPInput);\012 ",
" Descriptor = SEND_SET_Descriptor_Header_Present(Descriptor);\012  Descriptor = SEND_SET_Descriptor_HEVC_Mode(Descriptor);\012  Descriptor =\012      SEND_SET_Descriptor_Function(Descriptor, __VME_HEVC_INTRA_RDE_MSG);\012  Descriptor = SEND_SET_Descriptor_Num_Outputs(Descriptor, RDEOutput.n_rows());\012\012  cm_send(RDEOutput.selrows(4), RDEInput.selrows(14), __SFID_CRE, Descriptor,\012          0);\012}\012\012template <typename Dummy = void>\012CM_INLINE void cm_vme_hevc_fme_mesh(/*const*/ matrix_ref<uchar, 4, 32> FMEInput,\012                                    SurfaceIndex curSurfIndex,\012                                    matrix_ref<uchar, 3, 32> FMEOutput) {\012  U32 Descriptor = SEND_INIT_Descriptor_Surface(curSurfIndex);\012\012  Descriptor = SEND_SET_Descriptor_Num_Inputs(Descriptor, FMEInput.n_rows());\012  Descriptor = SEND_SET_Descriptor_Header_Present(Descriptor);\012  Descriptor = SEND_SET_Descriptor_HEVC_Mode(Descriptor);\012  Descriptor =\012      SEND_SET_Descriptor_Function(Descriptor, __VME_HEVC_FME_MESH_MSG);\012  Descriptor = SEND_SET_Descriptor_Nu",
"m_Outputs(Descriptor, FMEOutput.n_rows());\012\012  cm_send(FMEOutput.selrows(3), FMEInput.selrows(4), __SFID_CRE, Descriptor, 0);\012}\012\012#endif /* _CLANG_gen11_VME_H_ */\012\000/*========================== begin_copyright_notice ============================\012\012Copyright (C) 2019-2021 Intel Corporation\012\012SPDX-License-Identifier: MIT\012\012============================= end_copyright_notice ===========================*/\012\012#if (__INCLUDE_LEVEL__ == 1)\012static_assert(0, \"CM:w:gen12_vme.h should not be included explicitly - only \"\012                 \"<cm/cm.h> is required\");\012#endif\012\012#ifndef _CLANG_gen12_VME_H_\012#define _CLANG_gen12_VME_H_\012\012#include \"cm_send.h\"\012#include \"cm_util.h\"\012#include \"gen9_vme.h\" // Included to obtain legacy functionality\012\012typedef enum _VMEMsgTypeHEVC_ {\012  __VME_HEVC_SKIP_RDE_MSG = 0,\012  __VME_HEVC_IME_MSG = 1,\012  __VME_HEVC_INTER_RDE_MSG = 2,\012  __VME_HEVC_INTRA_RDE_MSG = 3,\012  __VME_HEVC_FME_MESH_MSG = 4,\012  __VME_HEVC_MACRO_MSG = 5,\012} __VMEMsgTypeHEVC;\012\012// XEHP HEVC-specific functions\012\012// Macros for forming descriptor val",
"ues for cm_send() and cm_sends()\012// The macros use a functional style - they take a descriptor value and any\012// required additional parameters and return an appropriate new descriptor\012// value\012\012// Set number of inputs (0..15)\012#define SEND_SET_Descriptor_Num_Inputs(v, i) ((v) | (((i) & 0xf) << 25))\012// Set number of inputs (0..31) in Extended Descriptor\012#define SEND_SET_Descriptor_Num_InputsExt(v, i) ((v) | (((i) & 0x1f) << 6))\012// Set number of outputs (0..31)\012#define SEND_SET_Descriptor_Num_Outputs(v, o) ((v) | (((o) & 0x1f) << 20))\012#define SEND_SET_Descriptor_Header_Present(v) ((v) | (1 << 19))\012#define SEND_SET_Descriptor_HEVC_Mode(v) ((v) | (1 << 18))\012#define SEND_SET_Descriptor_StreamIn_Enabled(v) ((v) | (1 << 16))\012// Set function, valid values in __VMEMsgTypeHEVC\012#define SEND_SET_Descriptor_Function(v, f) ((v) | (((f) & 0x7) << 8))\012\012// Create a descriptor value from a surface index (0..255)\012#define SEND_INIT_Descriptor_Surface(s) (cm_get_value(s) & 0xff)\012\012template <int N>\012CM_INLINE void\012run_vme_fbr(matrix<",
"uchar, 4, 32> UNIInput, matrix<uchar, 4, 32> FBRInput,\012            SurfaceIndex curSurfIndex, uchar FBRMbMode, uchar FBRSubMbShape,\012            uchar FBRSubPredMode, matrix_ref<uchar, N, 32> FBROutput) {\012  matrix<uint, 8, 8> src = 0;\012  // mov(96)    VX(0, 0)<1>, UNIInput\012  src.format<uint>().select<32, 1>(0) =\012      UNIInput.format<uint>().select<32, 1>(0);\012  // mov  (128)   VX(3,0)<1>,  FBRInput\012  src.format<uint>().select<32, 1>(32) =\012      FBRInput.format<uint>().select<32, 1>(0);\012  // mov  (1)     VX(2,20)<1>, FBRMbMode\012  src.format<uchar, 8, 32>()(2, 20) = FBRMbMode;\012  // mov  (1)     VX(2,21)<1>, FBRSubMbShape\012  src.format<uchar, 8, 32>()(2, 21) = FBRSubMbShape;\012  //  mov  (1)     VX(2,22)<1>, FBRSubPredMode\012  src.format<uchar, 8, 32>()(2, 22) = FBRSubPredMode;\012\012  unsigned fCtrl = 0x3 << 13;\012  unsigned rspLength = N; // used to be 7 in previous platforms\012  unsigned msglength = 8;\012  uint Descriptor = (fCtrl & 0x7FFFF) + (1 << 19) + ((rspLength & 0x1f) << 20) +\012                    ((msglength & 0xF) << 25",
");\012\012  Descriptor = cm_get_value(curSurfIndex) + Descriptor;\012  cm_send(FBROutput.format<ushort, N, 16>(), src.format<ushort, 8, 16>(),\012          __SFID_CRE, Descriptor, 0u);\012}\012\012template <int N>\012CM_INLINE void\012run_vme_sic(matrix<uchar, 4, 32> UNIInput, matrix<uchar, 4, 32> SICInput,\012            SurfaceIndex curSurfIndex, matrix_ref<uchar, N, 32> UNIOutput) {\012  matrix<uint, 8, 8> src = 0;\012  // mov  (96)    VX(0,0)<1>,  UNIInput\012  src.format<uint>().select<32, 1>(0) =\012      UNIInput.format<uint>().select<32, 1>(0);\012  // mov  (128)   VX(3,0)<1>,  SICInput\012  src.format<uint>().select<32, 1>(32) =\012      SICInput.format<uint>().select<32, 1>(0);\012  unsigned fCtrl = 0x1 << 13;\012  unsigned rspLength = N; // used to be 7 in the previous platforms\012  unsigned msgLength = 8;\012  uint Descriptor = (fCtrl & 0x7FFFF) + (1 << 19) + ((rspLength & 0x1f) << 20) +\012                    ((msgLength & 0xF) << 25);\012\012  Descriptor = cm_get_value(curSurfIndex) + Descriptor;\012  cm_send(UNIOutput.format<ushort, N, 16>(), src.format<ushort, 8, 16",
">(),\012          __SFID_CRE, Descriptor, 0u);\012}\012\012template <int N>\012CM_INLINE void\012run_vme_idm(matrix<uchar, 4, 32> UNIInput,\012            SurfaceIndex curSurfIndex, matrix_ref<uchar, N, 32> IDMOutput) {\012  unsigned fCtrl = 0;\012  unsigned rspLength = N; // used to 16 in the previous platforms\012  unsigned msglength = 4;\012  uint Descriptor = (fCtrl & 0x7FFFF) + (1 << 19) + ((rspLength & 0x1f) << 20) +\012                    ((msglength & 0xF) << 25);\012\012  Descriptor = cm_get_value(curSurfIndex) + Descriptor;\012  cm_send(IDMOutput.format<ushort, N, 16>(), UNIInput.format<ushort, 4, 16>(),\012          __SFID_VME, Descriptor, 0u);\012}\012\012// Gen12 HEVC VME support\012\012#define selrows(r) select<r, 1, 32, 1>(0, 0).format<ushort, r, 16>()\012\012/////////////////////////////////////////////////////////////////////////////////////\012\012//skip_rde_implicit\012// rdeoutput = 4 (Common HEVC interface to Gen11 and XeHP)\012template <typename Dummy = void> CM_INLINE void\012cm_vme_hevc_skip_rde_implicit(/*const*/ matrix_ref<uchar, 10, 32> RDEInput, SurfaceIndex curSu",
"rfIndex,\012    matrix_ref<uchar, 4, 32> RDEOutput)\012{\012    U32 Descriptor = SEND_INIT_Descriptor_Surface(curSurfIndex);\012\012    Descriptor = SEND_SET_Descriptor_Num_Inputs(Descriptor, RDEInput.n_rows());\012    Descriptor = SEND_SET_Descriptor_Header_Present(Descriptor);\012    Descriptor = SEND_SET_Descriptor_HEVC_Mode(Descriptor);\012    Descriptor = SEND_SET_Descriptor_Function(Descriptor, __VME_HEVC_SKIP_RDE_MSG);\012    Descriptor = SEND_SET_Descriptor_Num_Outputs(Descriptor, RDEOutput.n_rows());\012\012    cm_send(RDEOutput.selrows(4), RDEInput.selrows(10), __SFID_CRE, Descriptor, 0);\012}\012\012\012// rdeoutput = 5\012template <typename Dummy = void> CM_INLINE void\012cm_vme_hevc_skip_rde_implicit(/*const*/ matrix_ref<uchar, 10, 32> RDEInput, SurfaceIndex curSurfIndex,\012    matrix_ref<uchar, 5, 32> RDEOutput)\012{\012    U32 Descriptor = SEND_INIT_Descriptor_Surface(curSurfIndex);\012\012    Descriptor = SEND_SET_Descriptor_Num_Inputs(Descriptor, RDEInput.n_rows());\012    Descriptor = SEND_SET_Descriptor_Header_Present(Descriptor);\012    Descriptor = SEND_SET_",
"Descriptor_HEVC_Mode(Descriptor);\012    Descriptor = SEND_SET_Descriptor_Function(Descriptor, __VME_HEVC_SKIP_RDE_MSG);\012    Descriptor = SEND_SET_Descriptor_Num_Outputs(Descriptor, RDEOutput.n_rows());\012\012    cm_send(RDEOutput.selrows(5), RDEInput.selrows(10), __SFID_CRE, Descriptor, 0);\012}\012\012// rdeoutput = 6\012template <typename Dummy = void> CM_INLINE void\012cm_vme_hevc_skip_rde_implicit(/*const*/ matrix_ref<uchar, 10, 32> RDEInput, SurfaceIndex curSurfIndex,\012    matrix_ref<uchar, 6, 32> RDEOutput)\012{\012    U32 Descriptor = SEND_INIT_Descriptor_Surface(curSurfIndex);\012\012    Descriptor = SEND_SET_Descriptor_Num_Inputs(Descriptor, RDEInput.n_rows());\012    Descriptor = SEND_SET_Descriptor_Header_Present(Descriptor);\012    Descriptor = SEND_SET_Descriptor_HEVC_Mode(Descriptor);\012    Descriptor = SEND_SET_Descriptor_Function(Descriptor, __VME_HEVC_SKIP_RDE_MSG);\012    Descriptor = SEND_SET_Descriptor_Num_Outputs(Descriptor, RDEOutput.n_rows());\012\012    cm_send(RDEOutput.selrows(6), RDEInput.selrows(10), __SFID_CRE, Descriptor, 0);\012}\012\012/",
"/ rdeoutput = 7\012template <typename Dummy = void> CM_INLINE void\012cm_vme_hevc_skip_rde_implicit(/*const*/ matrix_ref<uchar, 10, 32> RDEInput, SurfaceIndex curSurfIndex,\012    matrix_ref<uchar, 7, 32> RDEOutput)\012{\012    U32 Descriptor = SEND_INIT_Descriptor_Surface(curSurfIndex);\012\012    Descriptor = SEND_SET_Descriptor_Num_Inputs(Descriptor, RDEInput.n_rows());\012    Descriptor = SEND_SET_Descriptor_Header_Present(Descriptor);\012    Descriptor = SEND_SET_Descriptor_HEVC_Mode(Descriptor);\012    Descriptor = SEND_SET_Descriptor_Function(Descriptor, __VME_HEVC_SKIP_RDE_MSG);\012    Descriptor = SEND_SET_Descriptor_Num_Outputs(Descriptor, RDEOutput.n_rows());\012\012    cm_send(RDEOutput.selrows(7), RDEInput.selrows(10), __SFID_CRE, Descriptor, 0);\012}\012\012\012/////////////////////////////////////////////////////////////////////////////////////\012\012\012//skip_rde_explicit\012\012// rdeoutput = 4\012template <typename Dummy = void> CM_INLINE void\012cm_vme_hevc_skip_rde_explicit(/*const*/ matrix_ref<uchar, 6, 32> RDEInput,\012    SurfaceIndex curSurfIndex, matrix_re",
"f<uchar, 4, 32> RDEOutput)\012{\012    U32 Descriptor = SEND_INIT_Descriptor_Surface(curSurfIndex);\012\012    Descriptor = SEND_SET_Descriptor_Num_Inputs(Descriptor, RDEInput.n_rows());\012    Descriptor = SEND_SET_Descriptor_Header_Present(Descriptor);\012    Descriptor = SEND_SET_Descriptor_HEVC_Mode(Descriptor);\012    Descriptor = SEND_SET_Descriptor_Function(Descriptor, __VME_HEVC_SKIP_RDE_MSG);\012    Descriptor = SEND_SET_Descriptor_Num_Outputs(Descriptor, RDEOutput.n_rows());\012\012    cm_send(RDEOutput.selrows(4), RDEInput.selrows(6), __SFID_CRE, Descriptor, 0);\012}\012\012// rdeoutput = 5\012template <typename Dummy = void> CM_INLINE void\012cm_vme_hevc_skip_rde_explicit(/*const*/ matrix_ref<uchar, 6, 32> RDEInput,\012    SurfaceIndex curSurfIndex, matrix_ref<uchar, 5, 32> RDEOutput)\012{\012    U32 Descriptor = SEND_INIT_Descriptor_Surface(curSurfIndex);\012\012    Descriptor = SEND_SET_Descriptor_Num_Inputs(Descriptor, RDEInput.n_rows());\012    Descriptor = SEND_SET_Descriptor_Header_Present(Descriptor);\012    Descriptor = SEND_SET_Descriptor_HEVC_Mode(Desc",
"riptor);\012    Descriptor = SEND_SET_Descriptor_Function(Descriptor, __VME_HEVC_SKIP_RDE_MSG);\012    Descriptor = SEND_SET_Descriptor_Num_Outputs(Descriptor, RDEOutput.n_rows());\012\012    cm_send(RDEOutput.selrows(5), RDEInput.selrows(6), __SFID_CRE, Descriptor, 0);\012}\012\012// rdeoutput = 6\012template <typename Dummy = void> CM_INLINE void\012cm_vme_hevc_skip_rde_explicit(/*const*/ matrix_ref<uchar, 6, 32> RDEInput,\012    SurfaceIndex curSurfIndex, matrix_ref<uchar, 6, 32> RDEOutput)\012{\012    U32 Descriptor = SEND_INIT_Descriptor_Surface(curSurfIndex);\012\012    Descriptor = SEND_SET_Descriptor_Num_Inputs(Descriptor, RDEInput.n_rows());\012    Descriptor = SEND_SET_Descriptor_Header_Present(Descriptor);\012    Descriptor = SEND_SET_Descriptor_HEVC_Mode(Descriptor);\012    Descriptor = SEND_SET_Descriptor_Function(Descriptor, __VME_HEVC_SKIP_RDE_MSG);\012    Descriptor = SEND_SET_Descriptor_Num_Outputs(Descriptor, RDEOutput.n_rows());\012\012    cm_send(RDEOutput.selrows(6), RDEInput.selrows(6), __SFID_CRE, Descriptor, 0);\012}\012\012// rdeoutput = 7\012template <ty",
"pename Dummy = void> CM_INLINE void\012cm_vme_hevc_skip_rde_explicit(/*const*/ matrix_ref<uchar, 6, 32> RDEInput,\012    SurfaceIndex curSurfIndex, matrix_ref<uchar, 7, 32> RDEOutput)\012{\012    U32 Descriptor = SEND_INIT_Descriptor_Surface(curSurfIndex);\012\012    Descriptor = SEND_SET_Descriptor_Num_Inputs(Descriptor, RDEInput.n_rows());\012    Descriptor = SEND_SET_Descriptor_Header_Present(Descriptor);\012    Descriptor = SEND_SET_Descriptor_HEVC_Mode(Descriptor);\012    Descriptor = SEND_SET_Descriptor_Function(Descriptor, __VME_HEVC_SKIP_RDE_MSG);\012    Descriptor = SEND_SET_Descriptor_Num_Outputs(Descriptor, RDEOutput.n_rows());\012\012    cm_send(RDEOutput.selrows(7), RDEInput.selrows(6), __SFID_CRE, Descriptor, 0);\012}\012\012// rdeoutput = 12 (Common HEVC interface to Gen11 and XEHP)\012template <typename Dummy = void> CM_INLINE void\012cm_vme_hevc_skip_rde_explicit(/*const*/ matrix_ref<uchar, 6, 32> RDEInput,\012    SurfaceIndex curSurfIndex, matrix_ref<uchar, 12, 32> RDEOutput)\012{\012    U32 Descriptor = SEND_INIT_Descriptor_Surface(curSurfIndex);\012\012 ",
"   Descriptor = SEND_SET_Descriptor_Num_Inputs(Descriptor, RDEInput.n_rows());\012    Descriptor = SEND_SET_Descriptor_Header_Present(Descriptor);\012    Descriptor = SEND_SET_Descriptor_HEVC_Mode(Descriptor);\012    Descriptor = SEND_SET_Descriptor_Function(Descriptor, __VME_HEVC_SKIP_RDE_MSG);\012    Descriptor = SEND_SET_Descriptor_Num_Outputs(Descriptor, RDEOutput.n_rows());\012\012    cm_send(RDEOutput.selrows(12), RDEInput.selrows(6), __SFID_CRE, Descriptor, 0);\012}\012\012\012/////////////////////////////////////////////////////////////////////////////////////\012\012\012//hevc_ime (Common HEVC interface to Gen11 and XEHP)\012template <typename Dummy = void> CM_INLINE void\012cm_vme_hevc_ime(/*const*/ matrix_ref<uchar, 5, 32> IMEInput, /*const*/ matrix_ref<uchar, 10, 32> StreamInput,\012    int LengthStreamInput, SurfaceIndex curSurfIndex, matrix_ref<uchar, 11, 32> StreamOutput)\012{\012    U32 Descriptor = SEND_INIT_Descriptor_Surface(curSurfIndex);\012\012    Descriptor = SEND_SET_Descriptor_Num_Inputs(Descriptor, IMEInput.n_rows());\012    Descriptor = SEND_SE",
"T_Descriptor_Header_Present(Descriptor);\012    Descriptor = SEND_SET_Descriptor_HEVC_Mode(Descriptor);\012    Descriptor = SEND_SET_Descriptor_Function(Descriptor, __VME_HEVC_IME_MSG);\012    Descriptor = SEND_SET_Descriptor_Num_Outputs(Descriptor, StreamOutput.n_rows());\012\012    if (LengthStreamInput == 10) {\012        Descriptor = SEND_SET_Descriptor_StreamIn_Enabled(Descriptor);\012        U32 ExDescriptor = SEND_SET_Descriptor_Num_InputsExt(__SFID_VME, StreamInput.n_rows());\012\012        cm_sends(StreamOutput.selrows(11), IMEInput.selrows(5), StreamInput.selrows(10), ExDescriptor, Descriptor, 0);\012    }\012    else\012        cm_send(StreamOutput.selrows(11), IMEInput.selrows(5), __SFID_VME, Descriptor, 0);\012}\012\012\012/////////////////////////////////////////////////////////////////////////////////////\012\012//Inter_rde_implicit\012// rdeoutput = 4 (Common HEVC interface to Gen11 and XEHP)\012template <typename Dummy = void> CM_INLINE void\012cm_vme_hevc_inter_rde_implicit(/*const*/ matrix_ref<uchar, 10, 32> RDEInput,\012    SurfaceIndex curSurfIndex, mat",
"rix_ref<uchar, 4, 32> RDEOutput)\012{\012    U32 Descriptor = SEND_INIT_Descriptor_Surface(curSurfIndex);\012\012    Descriptor = SEND_SET_Descriptor_Num_Inputs(Descriptor, RDEInput.n_rows());\012    Descriptor = SEND_SET_Descriptor_Header_Present(Descriptor);\012    Descriptor = SEND_SET_Descriptor_HEVC_Mode(Descriptor);\012    Descriptor = SEND_SET_Descriptor_Function(Descriptor, __VME_HEVC_INTER_RDE_MSG);\012    Descriptor = SEND_SET_Descriptor_Num_Outputs(Descriptor, RDEOutput.n_rows());\012\012    cm_send(RDEOutput.selrows(4), RDEInput.selrows(10), __SFID_CRE, Descriptor, 0);\012}\012\012// rdeoutput = 5\012template <typename Dummy = void> CM_INLINE void\012cm_vme_hevc_inter_rde_implicit(/*const*/ matrix_ref<uchar, 10, 32> RDEInput,\012    SurfaceIndex curSurfIndex, matrix_ref<uchar, 5, 32> RDEOutput)\012{\012    U32 Descriptor = SEND_INIT_Descriptor_Surface(curSurfIndex);\012\012    Descriptor = SEND_SET_Descriptor_Num_Inputs(Descriptor, RDEInput.n_rows());\012    Descriptor = SEND_SET_Descriptor_Header_Present(Descriptor);\012    Descriptor = SEND_SET_Descriptor_HEVC",
"_Mode(Descriptor);\012    Descriptor = SEND_SET_Descriptor_Function(Descriptor, __VME_HEVC_INTER_RDE_MSG);\012    Descriptor = SEND_SET_Descriptor_Num_Outputs(Descriptor, RDEOutput.n_rows());\012\012    cm_send(RDEOutput.selrows(5), RDEInput.selrows(10), __SFID_CRE, Descriptor, 0);\012}\012\012\012// rdeoutput = 6\012template <typename Dummy = void> CM_INLINE void\012cm_vme_hevc_inter_rde_implicit(/*const*/ matrix_ref<uchar, 10, 32> RDEInput,\012    SurfaceIndex curSurfIndex, matrix_ref<uchar, 6, 32> RDEOutput)\012{\012    U32 Descriptor = SEND_INIT_Descriptor_Surface(curSurfIndex);\012\012    Descriptor = SEND_SET_Descriptor_Num_Inputs(Descriptor, RDEInput.n_rows());\012    Descriptor = SEND_SET_Descriptor_Header_Present(Descriptor);\012    Descriptor = SEND_SET_Descriptor_HEVC_Mode(Descriptor);\012    Descriptor = SEND_SET_Descriptor_Function(Descriptor, __VME_HEVC_INTER_RDE_MSG);\012    Descriptor = SEND_SET_Descriptor_Num_Outputs(Descriptor, RDEOutput.n_rows());\012\012    cm_send(RDEOutput.selrows(6), RDEInput.selrows(10), __SFID_CRE, Descriptor, 0);\012}\012\012\012// rdeoutpu",
"t = 7\012template <typename Dummy = void> CM_INLINE void\012cm_vme_hevc_inter_rde_implicit(/*const*/ matrix_ref<uchar, 10, 32> RDEInput,\012    SurfaceIndex curSurfIndex, matrix_ref<uchar, 7, 32> RDEOutput)\012{\012    U32 Descriptor = SEND_INIT_Descriptor_Surface(curSurfIndex);\012\012    Descriptor = SEND_SET_Descriptor_Num_Inputs(Descriptor, RDEInput.n_rows());\012    Descriptor = SEND_SET_Descriptor_Header_Present(Descriptor);\012    Descriptor = SEND_SET_Descriptor_HEVC_Mode(Descriptor);\012    Descriptor = SEND_SET_Descriptor_Function(Descriptor, __VME_HEVC_INTER_RDE_MSG);\012    Descriptor = SEND_SET_Descriptor_Num_Outputs(Descriptor, RDEOutput.n_rows());\012\012    cm_send(RDEOutput.selrows(7), RDEInput.selrows(10), __SFID_CRE, Descriptor, 0);\012}\012\012\012/////////////////////////////////////////////////////////////////////////////////////\012\012\012//Inter_rde_explicit\012// rdeoutput = 4 (Common HEVC interface to Gen11 and XEHP)\012template <typename Dummy = void> CM_INLINE void\012cm_vme_hevc_inter_rde_explicit(/*const*/ matrix_ref<uchar, 5, 32> RDEInput,\012    S",
"urfaceIndex curSurfIndex, matrix_ref<uchar, 4, 32> RDEOutput)\012{\012    U32 Descriptor = SEND_INIT_Descriptor_Surface(curSurfIndex);\012\012    Descriptor = SEND_SET_Descriptor_Num_Inputs(Descriptor, RDEInput.n_rows());\012    Descriptor = SEND_SET_Descriptor_Header_Present(Descriptor);\012    Descriptor = SEND_SET_Descriptor_HEVC_Mode(Descriptor);\012    Descriptor = SEND_SET_Descriptor_Function(Descriptor, __VME_HEVC_INTER_RDE_MSG);\012    Descriptor = SEND_SET_Descriptor_Num_Outputs(Descriptor, RDEOutput.n_rows());\012\012    cm_send(RDEOutput.selrows(4), RDEInput.selrows(5), __SFID_CRE, Descriptor, 0);\012}\012\012\012// rdeoutput = 5\012template <typename Dummy = void> CM_INLINE void\012cm_vme_hevc_inter_rde_explicit(/*const*/ matrix_ref<uchar, 5, 32> RDEInput,\012    SurfaceIndex curSurfIndex, matrix_ref<uchar, 5, 32> RDEOutput)\012{\012    U32 Descriptor = SEND_INIT_Descriptor_Surface(curSurfIndex);\012\012    Descriptor = SEND_SET_Descriptor_Num_Inputs(Descriptor, RDEInput.n_rows());\012    Descriptor = SEND_SET_Descriptor_Header_Present(Descriptor);\012    Descripto",
"r = SEND_SET_Descriptor_HEVC_Mode(Descriptor);\012    Descriptor = SEND_SET_Descriptor_Function(Descriptor, __VME_HEVC_INTER_RDE_MSG);\012    Descriptor = SEND_SET_Descriptor_Num_Outputs(Descriptor, RDEOutput.n_rows());\012\012    cm_send(RDEOutput.selrows(5), RDEInput.selrows(5), __SFID_CRE, Descriptor, 0);\012}\012\012\012// rdeoutput = 6\012template <typename Dummy = void> CM_INLINE void\012cm_vme_hevc_inter_rde_explicit(/*const*/ matrix_ref<uchar, 5, 32> RDEInput,\012    SurfaceIndex curSurfIndex, matrix_ref<uchar, 6, 32> RDEOutput)\012{\012    U32 Descriptor = SEND_INIT_Descriptor_Surface(curSurfIndex);\012\012    Descriptor = SEND_SET_Descriptor_Num_Inputs(Descriptor, RDEInput.n_rows());\012    Descriptor = SEND_SET_Descriptor_Header_Present(Descriptor);\012    Descriptor = SEND_SET_Descriptor_HEVC_Mode(Descriptor);\012    Descriptor = SEND_SET_Descriptor_Function(Descriptor, __VME_HEVC_INTER_RDE_MSG);\012    Descriptor = SEND_SET_Descriptor_Num_Outputs(Descriptor, RDEOutput.n_rows());\012\012    cm_send(RDEOutput.selrows(6), RDEInput.selrows(5), __SFID_CRE, Descri",
"ptor, 0);\012}\012\012\012// rdeoutput = 7\012template <typename Dummy = void> CM_INLINE void\012cm_vme_hevc_inter_rde_explicit(/*const*/ matrix_ref<uchar, 5, 32> RDEInput,\012    SurfaceIndex curSurfIndex, matrix_ref<uchar, 7, 32> RDEOutput)\012{\012    U32 Descriptor = SEND_INIT_Descriptor_Surface(curSurfIndex);\012\012    Descriptor = SEND_SET_Descriptor_Num_Inputs(Descriptor, RDEInput.n_rows());\012    Descriptor = SEND_SET_Descriptor_Header_Present(Descriptor);\012    Descriptor = SEND_SET_Descriptor_HEVC_Mode(Descriptor);\012    Descriptor = SEND_SET_Descriptor_Function(Descriptor, __VME_HEVC_INTER_RDE_MSG);\012    Descriptor = SEND_SET_Descriptor_Num_Outputs(Descriptor, RDEOutput.n_rows());\012\012    cm_send(RDEOutput.selrows(7), RDEInput.selrows(5), __SFID_CRE, Descriptor, 0);\012}\012\012\012/////////////////////////////////////////////////////////////////////////////////////\012\012\012//Intra_rde\012//rdeoutput = 4 (Common HEVC interface to Gen11 and XEHP)\012template <typename Dummy = void> CM_INLINE void\012cm_vme_hevc_intra_rde(/*const*/ matrix_ref<uchar, 14, 32> RDEInput, ",
"int LengthLCNPInput,\012    SurfaceIndex curSurfIndex, matrix_ref<uchar, 4, 32> RDEOutput)\012{\012    U32 Descriptor = SEND_INIT_Descriptor_Surface(curSurfIndex);\012\012    Descriptor = SEND_SET_Descriptor_Num_Inputs(Descriptor, 4 + LengthLCNPInput);\012    Descriptor = SEND_SET_Descriptor_Header_Present(Descriptor);\012    Descriptor = SEND_SET_Descriptor_HEVC_Mode(Descriptor);\012    Descriptor = SEND_SET_Descriptor_Function(Descriptor, __VME_HEVC_INTRA_RDE_MSG);\012    Descriptor = SEND_SET_Descriptor_Num_Outputs(Descriptor, RDEOutput.n_rows());\012\012    cm_send(RDEOutput.selrows(4), RDEInput.selrows(14), __SFID_CRE, Descriptor, 0);\012}\012\012\012//rdeoutput = 5\012template <typename Dummy = void> CM_INLINE void\012cm_vme_hevc_intra_rde(/*const*/ matrix_ref<uchar, 14, 32> RDEInput, int LengthLCNPInput,\012    SurfaceIndex curSurfIndex, matrix_ref<uchar, 5, 32> RDEOutput)\012{\012    U32 Descriptor = SEND_INIT_Descriptor_Surface(curSurfIndex);\012\012    Descriptor = SEND_SET_Descriptor_Num_Inputs(Descriptor, 4 + LengthLCNPInput);\012    Descriptor = SEND_SET_Descripto",
"r_Header_Present(Descriptor);\012    Descriptor = SEND_SET_Descriptor_HEVC_Mode(Descriptor);\012    Descriptor = SEND_SET_Descriptor_Function(Descriptor, __VME_HEVC_INTRA_RDE_MSG);\012    Descriptor = SEND_SET_Descriptor_Num_Outputs(Descriptor, RDEOutput.n_rows());\012\012    cm_send(RDEOutput.selrows(5), RDEInput.selrows(14), __SFID_CRE, Descriptor, 0);\012}\012\012\012//rdeoutput = 6\012template <typename Dummy = void> CM_INLINE void\012cm_vme_hevc_intra_rde(/*const*/ matrix_ref<uchar, 14, 32> RDEInput, int LengthLCNPInput,\012    SurfaceIndex curSurfIndex, matrix_ref<uchar, 6, 32> RDEOutput)\012{\012    U32 Descriptor = SEND_INIT_Descriptor_Surface(curSurfIndex);\012\012    Descriptor = SEND_SET_Descriptor_Num_Inputs(Descriptor, 4 + LengthLCNPInput);\012    Descriptor = SEND_SET_Descriptor_Header_Present(Descriptor);\012    Descriptor = SEND_SET_Descriptor_HEVC_Mode(Descriptor);\012    Descriptor = SEND_SET_Descriptor_Function(Descriptor, __VME_HEVC_INTRA_RDE_MSG);\012    Descriptor = SEND_SET_Descriptor_Num_Outputs(Descriptor, RDEOutput.n_rows());\012\012    cm_send(RDE",
"Output.selrows(6), RDEInput.selrows(14), __SFID_CRE, Descriptor, 0);\012}\012\012\012//rdeoutput = 7\012template <typename Dummy = void> CM_INLINE void\012cm_vme_hevc_intra_rde(/*const*/ matrix_ref<uchar, 14, 32> RDEInput, int LengthLCNPInput,\012    SurfaceIndex curSurfIndex, matrix_ref<uchar, 7, 32> RDEOutput)\012{\012    U32 Descriptor = SEND_INIT_Descriptor_Surface(curSurfIndex);\012\012    Descriptor = SEND_SET_Descriptor_Num_Inputs(Descriptor, 4 + LengthLCNPInput);\012    Descriptor = SEND_SET_Descriptor_Header_Present(Descriptor);\012    Descriptor = SEND_SET_Descriptor_HEVC_Mode(Descriptor);\012    Descriptor = SEND_SET_Descriptor_Function(Descriptor, __VME_HEVC_INTRA_RDE_MSG);\012    Descriptor = SEND_SET_Descriptor_Num_Outputs(Descriptor, RDEOutput.n_rows());\012\012    cm_send(RDEOutput.selrows(7), RDEInput.selrows(14), __SFID_CRE, Descriptor, 0);\012}\012\012/////////////////////////////////////////////////////////////////////////////////////\012\012\012template <typename Dummy = void> // (Common HEVC interface to Gen11 and XEHP)\012CM_INLINE void cm_vme_hevc_fme_mesh",
"(/*const*/ matrix_ref<uchar, 4, 32> FMEInput,\012                                    SurfaceIndex curSurfIndex,\012                                    matrix_ref<uchar, 3, 32> FMEOutput) {\012  U32 Descriptor = SEND_INIT_Descriptor_Surface(curSurfIndex);\012\012  Descriptor = SEND_SET_Descriptor_Num_Inputs(Descriptor, FMEInput.n_rows());\012  Descriptor = SEND_SET_Descriptor_Header_Present(Descriptor);\012  Descriptor = SEND_SET_Descriptor_HEVC_Mode(Descriptor);\012  Descriptor =\012      SEND_SET_Descriptor_Function(Descriptor, __VME_HEVC_FME_MESH_MSG);\012  Descriptor = SEND_SET_Descriptor_Num_Outputs(Descriptor, FMEOutput.n_rows());\012\012  cm_send(FMEOutput.selrows(3), FMEInput.selrows(4), __SFID_CRE, Descriptor, 0);\012}\012\012\012/////////////////////////////////////////////////////////////////////////////////////\012\012\012\012//CRE 32x32\012//420\012//rdeouput = 4\012template <typename Dummy = void> CM_INLINE void\012cm_vme_hevc_cre32x32(/*const*/ matrix_ref<uchar, 18, 32> RDEInput,\012    SurfaceIndex curSurfIndex, matrix_ref<uchar, 4, 32> RDEOutput)\012{\012    U32 Descriptor",
" = SEND_INIT_Descriptor_Surface(curSurfIndex);\012\012    matrix<uchar, 10, 32>  RDEInput_src0 = RDEInput.select<10, 1, 32, 1>(0, 0);\012    matrix<uchar, 8, 32>  RDEInput_src1 = RDEInput.select<8, 1, 32, 1>(10, 0);\012\012    Descriptor = SEND_SET_Descriptor_Num_Inputs(Descriptor, RDEInput_src0.n_rows());\012    Descriptor = SEND_SET_Descriptor_Header_Present(Descriptor);\012    Descriptor = SEND_SET_Descriptor_HEVC_Mode(Descriptor);\012    Descriptor = SEND_SET_Descriptor_Function(Descriptor, __VME_HEVC_MACRO_MSG);\012    Descriptor = SEND_SET_Descriptor_Num_Outputs(Descriptor, RDEOutput.n_rows());\012\012    U32 ExDescriptor = SEND_SET_Descriptor_Num_InputsExt(__SFID_CRE, RDEInput_src1.n_rows());\012\012    cm_sends(RDEOutput.selrows(4), RDEInput_src0.selrows(10), RDEInput_src1.selrows(8), ExDescriptor, Descriptor, 0);\012}\012\012//rdeouput = 6\012template <typename Dummy = void> CM_INLINE void\012cm_vme_hevc_cre32x32(/*const*/ matrix_ref<uchar, 18, 32> RDEInput,\012    SurfaceIndex curSurfIndex, matrix_ref<uchar, 6, 32> RDEOutput)\012{\012    U32 Descriptor = SEND_I",
"NIT_Descriptor_Surface(curSurfIndex);\012\012    matrix<uchar, 10, 32>  RDEInput_src0 = RDEInput.select<10, 1, 32, 1>(0, 0);\012    matrix<uchar, 8, 32>  RDEInput_src1 = RDEInput.select<8, 1, 32, 1>(10, 0);\012\012    Descriptor = SEND_SET_Descriptor_Num_Inputs(Descriptor, RDEInput_src0.n_rows());\012    Descriptor = SEND_SET_Descriptor_Header_Present(Descriptor);\012    Descriptor = SEND_SET_Descriptor_HEVC_Mode(Descriptor);\012    Descriptor = SEND_SET_Descriptor_Function(Descriptor, __VME_HEVC_MACRO_MSG);\012    Descriptor = SEND_SET_Descriptor_Num_Outputs(Descriptor, RDEOutput.n_rows());\012\012    U32 ExDescriptor = SEND_SET_Descriptor_Num_InputsExt(__SFID_CRE, RDEInput_src1.n_rows());\012\012    cm_sends(RDEOutput.selrows(6), RDEInput_src0.selrows(10), RDEInput_src1.selrows(8), ExDescriptor, Descriptor, 0);\012}\012\012//422\012//rdeouput = 4\012template <typename Dummy = void> CM_INLINE void\012cm_vme_hevc_cre32x32(/*const*/ matrix_ref<uchar, 20, 32> RDEInput,\012    SurfaceIndex curSurfIndex, matrix_ref<uchar, 4, 32> RDEOutput)\012{\012    U32 Descriptor = SEND_INIT",
"_Descriptor_Surface(curSurfIndex);\012\012    matrix<uchar, 10, 32>  RDEInput_src0 = RDEInput.select<10, 1, 32, 1>(0, 0);\012    matrix<uchar, 10, 32>  RDEInput_src1 = RDEInput.select<10, 1, 32, 1>(10, 0);\012\012    Descriptor = SEND_SET_Descriptor_Num_Inputs(Descriptor, RDEInput_src0.n_rows());\012    Descriptor = SEND_SET_Descriptor_Header_Present(Descriptor);\012    Descriptor = SEND_SET_Descriptor_HEVC_Mode(Descriptor);\012    Descriptor = SEND_SET_Descriptor_Function(Descriptor, __VME_HEVC_MACRO_MSG);\012    Descriptor = SEND_SET_Descriptor_Num_Outputs(Descriptor, RDEOutput.n_rows());\012\012    U32 ExDescriptor = SEND_SET_Descriptor_Num_InputsExt(__SFID_CRE, RDEInput_src1.n_rows());\012\012    cm_sends(RDEOutput.selrows(4), RDEInput_src0.selrows(10), RDEInput_src1.selrows(10), ExDescriptor, Descriptor, 0);\012}\012\012//rdeouput = 7\012template <typename Dummy = void> CM_INLINE void\012cm_vme_hevc_cre32x32(/*const*/ matrix_ref<uchar, 20, 32> RDEInput,\012    SurfaceIndex curSurfIndex, matrix_ref<uchar, 7, 32> RDEOutput)\012{\012    U32 Descriptor = SEND_INIT_Descr",
"iptor_Surface(curSurfIndex);\012\012    matrix<uchar, 10, 32>  RDEInput_src0 = RDEInput.select<10, 1, 32, 1>(0, 0);\012    matrix<uchar, 10, 32>  RDEInput_src1 = RDEInput.select<10, 1, 32, 1>(10, 0);\012\012    Descriptor = SEND_SET_Descriptor_Num_Inputs(Descriptor, RDEInput_src0.n_rows());\012    Descriptor = SEND_SET_Descriptor_Header_Present(Descriptor);\012    Descriptor = SEND_SET_Descriptor_HEVC_Mode(Descriptor);\012    Descriptor = SEND_SET_Descriptor_Function(Descriptor, __VME_HEVC_MACRO_MSG);\012    Descriptor = SEND_SET_Descriptor_Num_Outputs(Descriptor, RDEOutput.n_rows());\012\012    U32 ExDescriptor = SEND_SET_Descriptor_Num_InputsExt(__SFID_CRE, RDEInput_src1.n_rows());\012\012    cm_sends(RDEOutput.selrows(7), RDEInput_src0.selrows(10), RDEInput_src1.selrows(10), ExDescriptor, Descriptor, 0);\012}\012\012\012//CRE 32x32 (intra only)\012//420\012//rdeouput = 4\012template <typename Dummy = void> CM_INLINE void\012cm_vme_hevc_cre32x32_intra_only(/*const*/ matrix_ref<uchar, 11, 32> RDEInput,\012    SurfaceIndex curSurfIndex, matrix_ref<uchar, 4, 32> RDEOutput)\012{",
"\012    U32 Descriptor = SEND_INIT_Descriptor_Surface(curSurfIndex);\012\012    Descriptor = SEND_SET_Descriptor_Num_Inputs(Descriptor, RDEInput.n_rows());\012    Descriptor = SEND_SET_Descriptor_Header_Present(Descriptor);\012    Descriptor = SEND_SET_Descriptor_HEVC_Mode(Descriptor);\012    Descriptor = SEND_SET_Descriptor_Function(Descriptor, __VME_HEVC_MACRO_MSG);\012    Descriptor = SEND_SET_Descriptor_Num_Outputs(Descriptor, RDEOutput.n_rows());\012\012    cm_send(RDEOutput.selrows(4), RDEInput.selrows(11), __SFID_CRE, Descriptor, 0);\012}\012\012//rdeouput = 6\012template <typename Dummy = void> CM_INLINE void\012cm_vme_hevc_cre32x32_intra_only(/*const*/ matrix_ref<uchar, 11, 32> RDEInput,\012    SurfaceIndex curSurfIndex, matrix_ref<uchar, 6, 32> RDEOutput)\012{\012    U32 Descriptor = SEND_INIT_Descriptor_Surface(curSurfIndex);\012\012    Descriptor = SEND_SET_Descriptor_Num_Inputs(Descriptor, RDEInput.n_rows());\012    Descriptor = SEND_SET_Descriptor_Header_Present(Descriptor);\012    Descriptor = SEND_SET_Descriptor_HEVC_Mode(Descriptor);\012    Descriptor = SEN",
"D_SET_Descriptor_Function(Descriptor, __VME_HEVC_MACRO_MSG);\012    Descriptor = SEND_SET_Descriptor_Num_Outputs(Descriptor, RDEOutput.n_rows());\012\012    cm_send(RDEOutput.selrows(6), RDEInput.selrows(11), __SFID_CRE, Descriptor, 0);\012}\012\012//422\012//rdeouput = 4\012template <typename Dummy = void> CM_INLINE void\012cm_vme_hevc_cre32x32_intra_only(/*const*/ matrix_ref<uchar, 13, 32> RDEInput,\012    SurfaceIndex curSurfIndex, matrix_ref<uchar, 4, 32> RDEOutput)\012{\012    U32 Descriptor = SEND_INIT_Descriptor_Surface(curSurfIndex);\012\012    Descriptor = SEND_SET_Descriptor_Num_Inputs(Descriptor, RDEInput.n_rows());\012    Descriptor = SEND_SET_Descriptor_Header_Present(Descriptor);\012    Descriptor = SEND_SET_Descriptor_HEVC_Mode(Descriptor);\012    Descriptor = SEND_SET_Descriptor_Function(Descriptor, __VME_HEVC_MACRO_MSG);\012    Descriptor = SEND_SET_Descriptor_Num_Outputs(Descriptor, RDEOutput.n_rows());\012\012    cm_send(RDEOutput.selrows(4), RDEInput.selrows(13), __SFID_CRE, Descriptor, 0);\012}\012\012//rdeouput = 7\012template <typename Dummy = void> CM_INLI",
"NE void\012cm_vme_hevc_cre32x32_intra_only(/*const*/ matrix_ref<uchar, 13, 32> RDEInput,\012    SurfaceIndex curSurfIndex, matrix_ref<uchar, 7, 32> RDEOutput)\012{\012    U32 Descriptor = SEND_INIT_Descriptor_Surface(curSurfIndex);\012\012    Descriptor = SEND_SET_Descriptor_Num_Inputs(Descriptor, RDEInput.n_rows());\012    Descriptor = SEND_SET_Descriptor_Header_Present(Descriptor);\012    Descriptor = SEND_SET_Descriptor_HEVC_Mode(Descriptor);\012    Descriptor = SEND_SET_Descriptor_Function(Descriptor, __VME_HEVC_MACRO_MSG);\012    Descriptor = SEND_SET_Descriptor_Num_Outputs(Descriptor, RDEOutput.n_rows());\012\012    cm_send(RDEOutput.selrows(7), RDEInput.selrows(13), __SFID_CRE, Descriptor, 0);\012}\012\012\012//CRE 16x16\012//420\012//rdeouput = 3\012template <typename Dummy = void> CM_INLINE void\012cm_vme_hevc_cre16x16(/*const*/ matrix_ref<uchar, 14, 32> RDEInput,\012    SurfaceIndex curSurfIndex, matrix_ref<uchar, 3, 32> RDEOutput)\012{\012    U32 Descriptor = SEND_INIT_Descriptor_Surface(curSurfIndex);\012\012    matrix<uchar, 10, 32>  RDEInput_src0 = RDEInput.select<10, ",
"1, 32, 1>(0, 0);\012    matrix<uchar, 4, 32>  RDEInput_src1 = RDEInput.select<4, 1, 32, 1>(10, 0);\012\012    Descriptor = SEND_SET_Descriptor_Num_Inputs(Descriptor, RDEInput_src0.n_rows());\012    Descriptor = SEND_SET_Descriptor_Header_Present(Descriptor);\012    Descriptor = SEND_SET_Descriptor_HEVC_Mode(Descriptor);\012    Descriptor = SEND_SET_Descriptor_Function(Descriptor, __VME_HEVC_MACRO_MSG);\012    Descriptor = SEND_SET_Descriptor_Num_Outputs(Descriptor, RDEOutput.n_rows());\012\012    U32 ExDescriptor = SEND_SET_Descriptor_Num_InputsExt(__SFID_CRE, RDEInput_src1.n_rows());\012\012    cm_sends(RDEOutput.selrows(3), RDEInput_src0.selrows(10), RDEInput_src1.selrows(4), ExDescriptor, Descriptor, 0);\012}\012\012//rdeouput = 4\012template <typename Dummy = void> CM_INLINE void\012cm_vme_hevc_cre16x16(/*const*/ matrix_ref<uchar, 14, 32> RDEInput,\012    SurfaceIndex curSurfIndex, matrix_ref<uchar, 4, 32> RDEOutput)\012{\012    U32 Descriptor = SEND_INIT_Descriptor_Surface(curSurfIndex);\012\012    matrix<uchar, 10, 32>  RDEInput_src0 = RDEInput.select<10, 1, 32, 1>",
"(0, 0);\012    matrix<uchar, 4, 32>  RDEInput_src1 = RDEInput.select<4, 1, 32, 1>(10, 0);\012\012    Descriptor = SEND_SET_Descriptor_Num_Inputs(Descriptor, RDEInput_src0.n_rows());\012    Descriptor = SEND_SET_Descriptor_Header_Present(Descriptor);\012    Descriptor = SEND_SET_Descriptor_HEVC_Mode(Descriptor);\012    Descriptor = SEND_SET_Descriptor_Function(Descriptor, __VME_HEVC_MACRO_MSG);\012    Descriptor = SEND_SET_Descriptor_Num_Outputs(Descriptor, RDEOutput.n_rows());\012\012    U32 ExDescriptor = SEND_SET_Descriptor_Num_InputsExt(__SFID_CRE, RDEInput_src1.n_rows());\012\012    cm_sends(RDEOutput.selrows(4), RDEInput_src0.selrows(10), RDEInput_src1.selrows(4), ExDescriptor, Descriptor, 0);\012}\012\012\012//rdeouput = 6\012template <typename Dummy = void> CM_INLINE void\012cm_vme_hevc_cre16x16(/*const*/ matrix_ref<uchar, 14, 32> RDEInput,\012    SurfaceIndex curSurfIndex, matrix_ref<uchar, 6, 32> RDEOutput)\012{\012    U32 Descriptor = SEND_INIT_Descriptor_Surface(curSurfIndex);\012\012    matrix<uchar, 10, 32>  RDEInput_src0 = RDEInput.select<10, 1, 32, 1>(0, 0);\012",
"    matrix<uchar, 4, 32>  RDEInput_src1 = RDEInput.select<4, 1, 32, 1>(10, 0);\012\012    Descriptor = SEND_SET_Descriptor_Num_Inputs(Descriptor, RDEInput_src0.n_rows());\012    Descriptor = SEND_SET_Descriptor_Header_Present(Descriptor);\012    Descriptor = SEND_SET_Descriptor_HEVC_Mode(Descriptor);\012    Descriptor = SEND_SET_Descriptor_Function(Descriptor, __VME_HEVC_MACRO_MSG);\012    Descriptor = SEND_SET_Descriptor_Num_Outputs(Descriptor, RDEOutput.n_rows());\012\012    U32 ExDescriptor = SEND_SET_Descriptor_Num_InputsExt(__SFID_CRE, RDEInput_src1.n_rows());\012\012    cm_sends(RDEOutput.selrows(6), RDEInput_src0.selrows(10), RDEInput_src1.selrows(4), ExDescriptor, Descriptor, 0);\012}\012\012//rdeouput = 7\012template <typename Dummy = void> CM_INLINE void\012cm_vme_hevc_cre16x16(/*const*/ matrix_ref<uchar, 14, 32> RDEInput,\012    SurfaceIndex curSurfIndex, matrix_ref<uchar, 7, 32> RDEOutput)\012{\012    U32 Descriptor = SEND_INIT_Descriptor_Surface(curSurfIndex);\012\012    matrix<uchar, 10, 32>  RDEInput_src0 = RDEInput.select<10, 1, 32, 1>(0, 0);\012    matri",
"x<uchar, 4, 32>  RDEInput_src1 = RDEInput.select<4, 1, 32, 1>(10, 0);\012\012    Descriptor = SEND_SET_Descriptor_Num_Inputs(Descriptor, RDEInput_src0.n_rows());\012    Descriptor = SEND_SET_Descriptor_Header_Present(Descriptor);\012    Descriptor = SEND_SET_Descriptor_HEVC_Mode(Descriptor);\012    Descriptor = SEND_SET_Descriptor_Function(Descriptor, __VME_HEVC_MACRO_MSG);\012    Descriptor = SEND_SET_Descriptor_Num_Outputs(Descriptor, RDEOutput.n_rows());\012\012    U32 ExDescriptor = SEND_SET_Descriptor_Num_InputsExt(__SFID_CRE, RDEInput_src1.n_rows());\012\012    cm_sends(RDEOutput.selrows(7), RDEInput_src0.selrows(10), RDEInput_src1.selrows(4), ExDescriptor, Descriptor, 0);\012}\012\012//422\012//rdeouput = 3\012template <typename Dummy = void> CM_INLINE void\012cm_vme_hevc_cre16x16(/*const*/ matrix_ref<uchar, 15, 32> RDEInput,\012    SurfaceIndex curSurfIndex, matrix_ref<uchar, 3, 32> RDEOutput)\012{\012    U32 Descriptor = SEND_INIT_Descriptor_Surface(curSurfIndex);\012\012    matrix<uchar, 10, 32>  RDEInput_src0 = RDEInput.select<10, 1, 32, 1>(0, 0);\012    matrix<u",
"char, 5, 32>  RDEInput_src1 = RDEInput.select<5, 1, 32, 1>(10, 0);\012\012    Descriptor = SEND_SET_Descriptor_Num_Inputs(Descriptor, RDEInput_src0.n_rows());\012    Descriptor = SEND_SET_Descriptor_Header_Present(Descriptor);\012    Descriptor = SEND_SET_Descriptor_HEVC_Mode(Descriptor);\012    Descriptor = SEND_SET_Descriptor_Function(Descriptor, __VME_HEVC_MACRO_MSG);\012    Descriptor = SEND_SET_Descriptor_Num_Outputs(Descriptor, RDEOutput.n_rows());\012\012    U32 ExDescriptor = SEND_SET_Descriptor_Num_InputsExt(__SFID_CRE, RDEInput_src1.n_rows());\012\012    cm_sends(RDEOutput.selrows(3), RDEInput_src0.selrows(10), RDEInput_src1.selrows(5), ExDescriptor, Descriptor, 0);\012}\012\012//rdeouput = 5\012template <typename Dummy = void> CM_INLINE void\012cm_vme_hevc_cre16x16(/*const*/ matrix_ref<uchar, 15, 32> RDEInput,\012    SurfaceIndex curSurfIndex, matrix_ref<uchar, 5, 32> RDEOutput)\012{\012    U32 Descriptor = SEND_INIT_Descriptor_Surface(curSurfIndex);\012\012    matrix<uchar, 10, 32>  RDEInput_src0 = RDEInput.select<10, 1, 32, 1>(0, 0);\012    matrix<uchar, 5, ",
"32>  RDEInput_src1 = RDEInput.select<5, 1, 32, 1>(10, 0);\012\012    Descriptor = SEND_SET_Descriptor_Num_Inputs(Descriptor, RDEInput_src0.n_rows());\012    Descriptor = SEND_SET_Descriptor_Header_Present(Descriptor);\012    Descriptor = SEND_SET_Descriptor_HEVC_Mode(Descriptor);\012    Descriptor = SEND_SET_Descriptor_Function(Descriptor, __VME_HEVC_MACRO_MSG);\012    Descriptor = SEND_SET_Descriptor_Num_Outputs(Descriptor, RDEOutput.n_rows());\012\012    U32 ExDescriptor = SEND_SET_Descriptor_Num_InputsExt(__SFID_CRE, RDEInput_src1.n_rows());\012\012    cm_sends(RDEOutput.selrows(5), RDEInput_src0.selrows(10), RDEInput_src1.selrows(5), ExDescriptor, Descriptor, 0);\012}\012\012\012//rdeouput = 6\012template <typename Dummy = void> CM_INLINE void\012cm_vme_hevc_cre16x16(/*const*/ matrix_ref<uchar, 15, 32> RDEInput,\012    SurfaceIndex curSurfIndex, matrix_ref<uchar, 6, 32> RDEOutput)\012{\012    U32 Descriptor = SEND_INIT_Descriptor_Surface(curSurfIndex);\012\012    matrix<uchar, 10, 32>  RDEInput_src0 = RDEInput.select<10, 1, 32, 1>(0, 0);\012    matrix<uchar, 5, 32>  RDE",
"Input_src1 = RDEInput.select<5, 1, 32, 1>(10, 0);\012\012    Descriptor = SEND_SET_Descriptor_Num_Inputs(Descriptor, RDEInput_src0.n_rows());\012    Descriptor = SEND_SET_Descriptor_Header_Present(Descriptor);\012    Descriptor = SEND_SET_Descriptor_HEVC_Mode(Descriptor);\012    Descriptor = SEND_SET_Descriptor_Function(Descriptor, __VME_HEVC_MACRO_MSG);\012    Descriptor = SEND_SET_Descriptor_Num_Outputs(Descriptor, RDEOutput.n_rows());\012\012    U32 ExDescriptor = SEND_SET_Descriptor_Num_InputsExt(__SFID_CRE, RDEInput_src1.n_rows());\012\012    cm_sends(RDEOutput.selrows(6), RDEInput_src0.selrows(10), RDEInput_src1.selrows(5), ExDescriptor, Descriptor, 0);\012}\012\012\012//rdeouput = 8\012template <typename Dummy = void> CM_INLINE void\012cm_vme_hevc_cre16x16(/*const*/ matrix_ref<uchar, 15, 32> RDEInput,\012    SurfaceIndex curSurfIndex, matrix_ref<uchar, 8, 32> RDEOutput)\012{\012    U32 Descriptor = SEND_INIT_Descriptor_Surface(curSurfIndex);\012\012    matrix<uchar, 10, 32>  RDEInput_src0 = RDEInput.select<10, 1, 32, 1>(0, 0);\012    matrix<uchar, 5, 32>  RDEInput_sr",
"c1 = RDEInput.select<5, 1, 32, 1>(10, 0);\012\012    Descriptor = SEND_SET_Descriptor_Num_Inputs(Descriptor, RDEInput_src0.n_rows());\012    Descriptor = SEND_SET_Descriptor_Header_Present(Descriptor);\012    Descriptor = SEND_SET_Descriptor_HEVC_Mode(Descriptor);\012    Descriptor = SEND_SET_Descriptor_Function(Descriptor, __VME_HEVC_MACRO_MSG);\012    Descriptor = SEND_SET_Descriptor_Num_Outputs(Descriptor, RDEOutput.n_rows());\012\012    U32 ExDescriptor = SEND_SET_Descriptor_Num_InputsExt(__SFID_CRE, RDEInput_src1.n_rows());\012\012    cm_sends(RDEOutput.selrows(8), RDEInput_src0.selrows(10), RDEInput_src1.selrows(5), ExDescriptor, Descriptor, 0);\012}\012\012\012//CRE 16x16 (intra only)\012//420\012//rdeouput = 3\012template <typename Dummy = void> CM_INLINE void\012cm_vme_hevc_cre16x16_intra_only(/*const*/ matrix_ref<uchar, 7, 32> RDEInput,\012    SurfaceIndex curSurfIndex, matrix_ref<uchar, 3, 32> RDEOutput)\012{\012    U32 Descriptor = SEND_INIT_Descriptor_Surface(curSurfIndex);\012\012    Descriptor = SEND_SET_Descriptor_Num_Inputs(Descriptor, 7);\012    Descriptor = SEN",
"D_SET_Descriptor_Header_Present(Descriptor);\012    Descriptor = SEND_SET_Descriptor_HEVC_Mode(Descriptor);\012    Descriptor = SEND_SET_Descriptor_Function(Descriptor, __VME_HEVC_MACRO_MSG);\012    Descriptor = SEND_SET_Descriptor_Num_Outputs(Descriptor, RDEOutput.n_rows());\012\012    cm_send(RDEOutput.selrows(3), RDEInput.selrows(7), __SFID_CRE, Descriptor, 0);\012}\012\012\012//rdeouput = 4\012template <typename Dummy = void> CM_INLINE void\012cm_vme_hevc_cre16x16_intra_only(/*const*/ matrix_ref<uchar, 7, 32> RDEInput,\012    SurfaceIndex curSurfIndex, matrix_ref<uchar, 4, 32> RDEOutput)\012{\012    U32 Descriptor = SEND_INIT_Descriptor_Surface(curSurfIndex);\012\012    Descriptor = SEND_SET_Descriptor_Num_Inputs(Descriptor, 7);\012    Descriptor = SEND_SET_Descriptor_Header_Present(Descriptor);\012    Descriptor = SEND_SET_Descriptor_HEVC_Mode(Descriptor);\012    Descriptor = SEND_SET_Descriptor_Function(Descriptor, __VME_HEVC_MACRO_MSG);\012    Descriptor = SEND_SET_Descriptor_Num_Outputs(Descriptor, RDEOutput.n_rows());\012\012    cm_send(RDEOutput.selrows(4), RDEInp",
"ut.selrows(7), __SFID_CRE, Descriptor, 0);\012}\012\012\012//rdeouput = 6\012template <typename Dummy = void> CM_INLINE void\012cm_vme_hevc_cre16x16_intra_only(/*const*/ matrix_ref<uchar, 7, 32> RDEInput,\012    SurfaceIndex curSurfIndex, matrix_ref<uchar, 6, 32> RDEOutput)\012{\012    U32 Descriptor = SEND_INIT_Descriptor_Surface(curSurfIndex);\012\012    Descriptor = SEND_SET_Descriptor_Num_Inputs(Descriptor, 7);\012    Descriptor = SEND_SET_Descriptor_Header_Present(Descriptor);\012    Descriptor = SEND_SET_Descriptor_HEVC_Mode(Descriptor);\012    Descriptor = SEND_SET_Descriptor_Function(Descriptor, __VME_HEVC_MACRO_MSG);\012    Descriptor = SEND_SET_Descriptor_Num_Outputs(Descriptor, RDEOutput.n_rows());\012\012    cm_send(RDEOutput.selrows(6), RDEInput.selrows(7), __SFID_CRE, Descriptor, 0);\012}\012\012//rdeouput = 7\012template <typename Dummy = void> CM_INLINE void\012cm_vme_hevc_cre16x16_intra_only(/*const*/ matrix_ref<uchar, 7, 32> RDEInput,\012    SurfaceIndex curSurfIndex, matrix_ref<uchar, 7, 32> RDEOutput)\012{\012    U32 Descriptor = SEND_INIT_Descriptor_Surface(curS",
"urfIndex);\012\012    Descriptor = SEND_SET_Descriptor_Num_Inputs(Descriptor, 7);\012    Descriptor = SEND_SET_Descriptor_Header_Present(Descriptor);\012    Descriptor = SEND_SET_Descriptor_HEVC_Mode(Descriptor);\012    Descriptor = SEND_SET_Descriptor_Function(Descriptor, __VME_HEVC_MACRO_MSG);\012    Descriptor = SEND_SET_Descriptor_Num_Outputs(Descriptor, RDEOutput.n_rows());\012\012    cm_send(RDEOutput.selrows(7), RDEInput.selrows(7), __SFID_CRE, Descriptor, 0);\012}\012\012//422\012//rdeouput = 3\012template <typename Dummy = void> CM_INLINE void\012cm_vme_hevc_cre16x16_intra_only(/*const*/ matrix_ref<uchar, 8, 32> RDEInput,\012    SurfaceIndex curSurfIndex, matrix_ref<uchar, 3, 32> RDEOutput)\012{\012    U32 Descriptor = SEND_INIT_Descriptor_Surface(curSurfIndex);\012\012    Descriptor = SEND_SET_Descriptor_Num_Inputs(Descriptor, 8);\012    Descriptor = SEND_SET_Descriptor_Header_Present(Descriptor);\012    Descriptor = SEND_SET_Descriptor_HEVC_Mode(Descriptor);\012    Descriptor = SEND_SET_Descriptor_Function(Descriptor, __VME_HEVC_MACRO_MSG);\012    Descriptor = SEND_",
"SET_Descriptor_Num_Outputs(Descriptor, RDEOutput.n_rows());\012\012    cm_send(RDEOutput.selrows(3), RDEInput.selrows(8), __SFID_CRE, Descriptor, 0);\012}\012\012//rdeouput = 5\012template <typename Dummy = void> CM_INLINE void\012cm_vme_hevc_cre16x16_intra_only(/*const*/ matrix_ref<uchar, 8, 32> RDEInput,\012    SurfaceIndex curSurfIndex, matrix_ref<uchar, 5, 32> RDEOutput)\012{\012    U32 Descriptor = SEND_INIT_Descriptor_Surface(curSurfIndex);\012\012    Descriptor = SEND_SET_Descriptor_Num_Inputs(Descriptor, 8);\012    Descriptor = SEND_SET_Descriptor_Header_Present(Descriptor);\012    Descriptor = SEND_SET_Descriptor_HEVC_Mode(Descriptor);\012    Descriptor = SEND_SET_Descriptor_Function(Descriptor, __VME_HEVC_MACRO_MSG);\012    Descriptor = SEND_SET_Descriptor_Num_Outputs(Descriptor, RDEOutput.n_rows());\012\012    cm_send(RDEOutput.selrows(5), RDEInput.selrows(8), __SFID_CRE, Descriptor, 0);\012}\012\012//rdeouput = 6\012template <typename Dummy = void> CM_INLINE void\012cm_vme_hevc_cre16x16_intra_only(/*const*/ matrix_ref<uchar, 8, 32> RDEInput,\012    SurfaceIndex curSur",
"fIndex, matrix_ref<uchar, 6, 32> RDEOutput)\012{\012    U32 Descriptor = SEND_INIT_Descriptor_Surface(curSurfIndex);\012\012    Descriptor = SEND_SET_Descriptor_Num_Inputs(Descriptor, 8);\012    Descriptor = SEND_SET_Descriptor_Header_Present(Descriptor);\012    Descriptor = SEND_SET_Descriptor_HEVC_Mode(Descriptor);\012    Descriptor = SEND_SET_Descriptor_Function(Descriptor, __VME_HEVC_MACRO_MSG);\012    Descriptor = SEND_SET_Descriptor_Num_Outputs(Descriptor, RDEOutput.n_rows());\012\012    cm_send(RDEOutput.selrows(6), RDEInput.selrows(8), __SFID_CRE, Descriptor, 0);\012}\012\012//rdeouput = 8\012template <typename Dummy = void> CM_INLINE void\012cm_vme_hevc_cre16x16_intra_only(/*const*/ matrix_ref<uchar, 8, 32> RDEInput,\012    SurfaceIndex curSurfIndex, matrix_ref<uchar, 8, 32> RDEOutput)\012{\012    U32 Descriptor = SEND_INIT_Descriptor_Surface(curSurfIndex);\012\012    Descriptor = SEND_SET_Descriptor_Num_Inputs(Descriptor, 8);\012    Descriptor = SEND_SET_Descriptor_Header_Present(Descriptor);\012    Descriptor = SEND_SET_Descriptor_HEVC_Mode(Descriptor);\012    Descr",
"iptor = SEND_SET_Descriptor_Function(Descriptor, __VME_HEVC_MACRO_MSG);\012    Descriptor = SEND_SET_Descriptor_Num_Outputs(Descriptor, RDEOutput.n_rows());\012\012    cm_send(RDEOutput.selrows(8), RDEInput.selrows(8), __SFID_CRE, Descriptor, 0);\012}\012\012\012#endif /* _CLANG_gen12_VME_H_ */\012\000/*========================== begin_copyright_notice ============================\012\012Copyright (C) 2015-2021 Intel Corporation\012\012SPDX-License-Identifier: MIT\012\012============================= end_copyright_notice ===========================*/\012\012#if (__INCLUDE_LEVEL__ == 1)\012static_assert(0, \"CM:w:gen7_5_vme.h should not be included explicitly - only \"\012                 \"<cm/cm.h> is required\");\012#endif\012\012#ifndef _CLANG_gen7_5_VME_H_\012#define _CLANG_gen7_5_VME_H_\012\012#include \"cm_send.h\"\012#include \"cm_util.h\"\012\012#define __SFID_VME 8\012#define __SFID_CRE 13\012\012// Select one element from the input payload\012#ifdef VME_Input_S1\012#undef VME_Input_S1\012#endif\012#define VME_Input_S1(p, t, r, c) p.row(r).format<t>().select<1, 1>(c)\012\012#ifdef VME_Input_G1\012#undef VME_Input_G1\012#en",
"dif\012#define VME_Input_G1(p, t, r, c) p.row(r).format<t>().select<1, 1>(c)(0)\012\012// Select one element from the output result\012#ifdef VME_Output_S1\012#undef VME_Output_S1\012#endif\012#define VME_Output_S1(p, t, r, c) p.row(r).format<t>().select<1, 1>(c)(0)\012\012#define S13_2TOS16(value)                                                      \\\012  (((value >> 2) & 0x1fff) | (((value >> 15) & 0x1) << 15))\012#define S16TOS13_2(value)                                                      \\\012  (((value & 0x1fff) << 2) | (((value >> 15) & 0x1) << 15))\012\012// Input\012\012// SET methods\012\012// Format = S15\012#define VME_SET_UNIInput_Ref0X(p, v) (VME_Input_S1(p, ushort, 0, 0) = v)\012#define VME_SET_UNIInput_Ref0Y(p, v) (VME_Input_S1(p, ushort, 0, 1) = v)\012\012// Format = S15\012#define VME_SET_UNIInput_Ref1X(p, v) (VME_Input_S1(p, ushort, 0, 2) = v)\012#define VME_SET_UNIInput_Ref1Y(p, v) (VME_Input_S1(p, ushort, 0, 3) = v)\012\012// Format = U16\012#define VME_SET_UNIInput_SrcX(p, v) (VME_Input_S1(p, ushort, 0, 4) = v)\012\012// Format = U16\012#define VME_SET_UNIInput_SrcY(p, v) (",
"VME_Input_S1(p, ushort, 0, 5) = v)\012\012// Set - FieldBased\012// Clear - FrameBased\012#define VME_SET_UNIInput_SrcAccess(p) (VME_Input_S1(p, uchar, 0, 12) |= 0x40)\012#define VME_CLEAR_UNIInput_SrcAccess(p) (VME_Input_S1(p, uchar, 0, 12) &= 0xBF)\012\012// Set - FieldBased\012// Clear - FrameBased\012#define VME_SET_UNIInput_RefAccess(p) (VME_Input_S1(p, uchar, 0, 12) |= 0x80)\012#define VME_CLEAR_UNIInput_RefAccess(p) (VME_Input_S1(p, uchar, 0, 12) &= 0x7F)\012\012// Set - different paths\012// Clear - same path\012#define VME_SET_UNIInput_DualSearchPath(p)                                     \\\012  (VME_Input_S1(p, uchar, 0, 13) |= 0x08)\012#define VME_CLEAR_UNIInput_DualSearchPath(p)                                   \\\012  (VME_Input_S1(p, uchar, 0, 13) &= 0xF7)\012\012// #define INT_MODE 0x0\012// #define HALF_PEL_MODE 0x1\012// #define QUARTER_PEL_MODE 0x3\012#define VME_SET_UNIInput_SubPelMode(p, v)                                      \\\012  (VME_Input_S1(p, uchar, 0, 13) =                                             \\\012       VME_Input_S1(p, uchar, 0, 13) & 0xCF | ",
"(v << 4))\012\012// Set - 4MVP\012// Clear - 1MVP\012#define VME_SET_UNIInput_SkipModeType(p) (VME_Input_S1(p, uchar, 0, 13) |= 0x40)\012#define VME_CLEAR_UNIInput_SkipModeType(p)                                     \\\012  (VME_Input_S1(p, uchar, 0, 13) &= 0xBF)\012\012// Set - Chroma mode\012// Clear - Luma mode\012#define VME_SET_UNIInput_InterChromaMode(p)                                    \\\012  (VME_Input_S1(p, uchar, 0, 14) |= 0x1)\012#define VME_CLEAR_UNIInput_InterChromaMode(p)                                  \\\012  (VME_Input_S1(p, uchar, 0, 14) &= 0xFE)\012\012#define VME_SET_UNIInput_FTEnable(p) (VME_Input_S1(p, uchar, 0, 14) |= 0x2)\012#define VME_CLEAR_UNIInput_FTEnable(p) (VME_Input_S1(p, uchar, 0, 14) &= 0xFD)\012\012#define VME_SET_UNIInput_BMEDisableFBR(p) (VME_Input_S1(p, uchar, 0, 14) |= 0x4)\012#define VME_CLEAR_UNIInput_BMEDisableFBR(p)                                    \\\012  (VME_Input_S1(p, uchar, 0, 14) &= 0xFB)\012\012// v is a 7-bit mask with the following definition:\012// xxxxxx1 : 16x16 sub-macroblock disabled\012// xxxxx1x : 2x(16x8) sub-macroblo",
"ck within 16x16 disabled\012// xxxx1xx : 2x(8x16) sub-macroblock within 16x16 disabled\012// xxx1xxx : 1x(8x8) sub-partition for 4x(8x8) within 16x16 disabled\012// xx1xxxx : 2x(8x4) sub-partition for 4x(8x8) within 16x16 disabled\012// x1xxxxx : 2x(4x8) sub-partition for 4x(8x8) within 16x16 disabled\012// 1xxxxxx : 4x(4x4) sub-partition for 4x(8x8) within 16x16 disabled\012#define VME_SET_UNIInput_SubMbPartMask(p, v) (VME_Input_S1(p, uchar, 0, 15) = v)\012\012// The value must be a multiple of 4. Range = [20, 64]\012#define VME_SET_UNIInput_RefW(p, v) (VME_Input_S1(p, uchar, 0, 22) = v)\012\012// The value must be a multiple of 4. Range = [20, 64]\012#define VME_SET_UNIInput_RefH(p, v) (VME_Input_S1(p, uchar, 0, 23) = v)\012\012#define VME_SET_UNIInput_SkipModeEn(p) (VME_Input_S1(p, uchar, 1, 0) |= 0x1)\012#define VME_CLEAR_UNIInput_SkipModeEn(p) (VME_Input_S1(p, uchar, 1, 0) &= 0xFE)\012\012#define VME_SET_UNIInput_AdaptiveEn(p) (VME_Input_S1(p, uchar, 1, 0) |= 0x2)\012#define VME_CLEAR_UNIInput_AdaptiveEn(p) (VME_Input_S1(p, uchar, 1, 0) &= 0xFD)\012\012#define VM",
"E_SET_UNIInput_EarlyImeSuccessEn(p)                                  \\\012  (VME_Input_S1(p, uchar, 1, 0) |= 0x20)\012#define VME_CLEAR_UNIInput_EarlyImeSuccessEn(p)                                \\\012  (VME_Input_S1(p, uchar, 1, 0) &= 0xDF)\012\012#define VME_SET_UNIInput_T8x8FlagForInterEn(p)                                 \\\012  (VME_Input_S1(p, uchar, 1, 0) |= 0x80)\012#define VME_CLEAR_UNIInput_T8x8FlagForInterEn(p)                               \\\012  (VME_Input_S1(p, uchar, 1, 0) &= 0x7F)\012\012#define VME_SET_UNIInput_EarlyImeStop(p, v) (VME_Input_S1(p, uchar, 1, 3) = v)\012\012#define VME_SET_UNIInput_MaxNumMVs(p, v) (VME_Input_S1(p, uchar, 1, 4) = v)\012\012// Format = U6, Valid Values: [16, 21, 32, 43, 48]\012#define VME_SET_UNIInput_BiWeight(p, v) (VME_Input_S1(p, uchar, 1, 6) = v)\012\012// Format = U8, Valid range [1,63]\012#define VME_SET_UNIInput_LenSP(p, v) (VME_Input_S1(p, uchar, 1, 8) = v)\012\012// Format = U8, Valid range [1,63]\012#define VME_SET_UNIInput_MaxNumSU(p, v) (VME_Input_S1(p, uchar, 1, 9) = v)\012\012// Format = U4\012#define VME_SET_UNIInput_S",
"tartCenter0(p, StartCenter0X, StartCenter0Y)         \\\012  (VME_Input_S1(p, uchar, 1, 10) = StartCenter0X | (StartCenter0Y << 4))\012\012// Format = U4\012#define VME_SET_UNIInput_StartCenter1(p, StartCenter1X, StartCenter1Y)         \\\012  (VME_Input_S1(p, uchar, 1, 11) = StartCenter1X | (StartCenter1Y << 4))\012\012// Format = S13.2, Valid range [-2048.00 to 2047.75]\012// Note: The parameter should be specified as unsigned type. CM does not have\012// native type support for S13.2, etc.\012//       These are treated as unsigned data and programmer must ensure the\012//       proper encoding as per HW format requirement.\012#define VME_SET_UNIInput_CostCenter0(p, CostCenter0X, CostCenter0Y)            \\\012  (VME_Input_S1(p, uint, 1, 4) = CostCenter0X | (CostCenter0Y << 16))\012\012// Format = S13.2, Valid range [-2048.00 to 2047.75]\012#define VME_SET_UNIInput_CostCenter1(p, CostCenter1X, CostCenter1Y)            \\\012  (VME_Input_S1(p, uint, 1, 5) = CostCenter1X | (CostCenter1Y << 16))\012\012// Format = U4\012#define VME_SET_UNIInput_Blk0RefID(p, FwdBlk0RefID, B",
"wdBlk0RefID)              \\\012  (VME_Input_S1(p, uchar, 1, 24) = FwdBlk0RefID | (BwdBlk0RefID << 4))\012\012// Format = U4\012#define VME_SET_UNIInput_Blk1RefID(p, FwdBlk1RefID, BwdBlk1RefID)              \\\012  (VME_Input_S1(p, uchar, 1, 25) = FwdBlk1RefID | (BwdBlk1RefID << 4))\012\012// Format = U4\012#define VME_SET_UNIInput_Blk2RefID(p, FwdBlk2RefID, BwdBlk2RefID)              \\\012  (VME_Input_S1(p, uchar, 1, 26) = FwdBlk2RefID | (BwdBlk2RefID << 4))\012\012// Format = U4\012#define VME_SET_UNIInput_Blk3RefID(p, FwdBlk3RefID, BwdBlk3RefID)              \\\012  (VME_Input_S1(p, uchar, 1, 27) = FwdBlk3RefID | (BwdBlk3RefID << 4))\012\012#define VME_SET_UNIInput_IntraFlags(p, v) (VME_Input_S1(p, uchar, 1, 28) = v)\012\012// v is a 8-bit mask with the following definition:\012// Bit-7    Reserved : MBZ (for IntraPredAvailFlagF - F (pixel[-1,7]\012// available\012// for MbAff)\012// Bit-6    Reserved : MBZ (for IntraPredAvailFlagA/E - A (left neighbor top\012// half for MbAff)\012// Bit-5    IntraPredAvailFlagE/A - A (Left neighbor or Left bottom half)\012// Bit-4    IntraPredAv",
"ailFlagB - B (Upper neighbor)\012// Bit-3    IntraPredAvailFlagC - C (Upper left neighbor)\012// Bit-2    IntraPredAvailFlagD - D (Upper right neighbor)\012// Bit-1:0  Reserved: MBZ (ChromaIntraPredMode)\012#define VME_SET_UNIInput_MbIntraStruct(p, v) (VME_Input_S1(p, uchar, 1, 29) = v)\012\012#define VME_SET_UNIInput_SrcFieldPolarity(p)                                   \\\012  (VME_Input_S1(p, uchar, 1, 30) |= 0x08)\012#define VME_CLEAR_UNIInput_SrcFieldPolarity(p)                                 \\\012  (VME_Input_S1(p, uchar, 1, 30) &= 0xF7)\012\012// v is a 8-bit mask with the following definition:\012// xxxx xxx1: Ref0 Skip Center 0 is enabled [corresponds to M2.0]\012// xxxx xx1x: Ref1 Skip Center 0 is enabled [corresponds to M2.1]\012// xxxx x1xx: Ref0 Skip Center 1 is enabled [corresponds to M2.2]\012// xxxx 1xxx: Ref1 Skip Center 1 is enabled [corresponds to M2.3]\012// xxx1 xxxx: Ref0 Skip Center 2 is enabled [corresponds to M2.4]\012// xx1x xxxx: Ref1 Skip Center 2 is enabled [corresponds to M2.5]\012// x1xx xxxx: Ref0 Skip Center 3 is enabled [corresp",
"onds to M2.6]\012// 1xxx xxxx: Ref1 Skip Center 3 is enabled [corresponds to M2.7]\012#define VME_SET_UNIInput_SkipCenterMask(p, v)                                  \\\012  (VME_Input_S1(p, uchar, 1, 31) = v)\012\012// NOTE: replace v with U4U4 type with\012// (shift_count, shift_val) and set the value as (shift_val | (shift_count <<\012// 4))\012\012// Format = U4U4 (encoded value must fit in 12-bits)\012#define VME_SET_UNIInput_Mode0Cost(p, v) (VME_Input_S1(p, uchar, 2, 0) = v)\012#define VME_SET_UNIInput_Mode1Cost(p, v) (VME_Input_S1(p, uchar, 2, 1) = v)\012#define VME_SET_UNIInput_Mode2Cost(p, v) (VME_Input_S1(p, uchar, 2, 2) = v)\012#define VME_SET_UNIInput_Mode3Cost(p, v) (VME_Input_S1(p, uchar, 2, 3) = v)\012#define VME_SET_UNIInput_Mode4Cost(p, v) (VME_Input_S1(p, uchar, 2, 4) = v)\012#define VME_SET_UNIInput_Mode5Cost(p, v) (VME_Input_S1(p, uchar, 2, 5) = v)\012#define VME_SET_UNIInput_Mode6Cost(p, v) (VME_Input_S1(p, uchar, 2, 6) = v)\012#define VME_SET_UNIInput_Mode7Cost(p, v) (VME_Input_S1(p, uchar, 2, 7) = v)\012#define VME_SET_UNIInput_Mode8Cost(p, ",
"v) (VME_Input_S1(p, uchar, 2, 8) = v)\012#define VME_SET_UNIInput_Mode9Cost(p, v) (VME_Input_S1(p, uchar, 2, 9) = v)\012\012// Format = U4U4 (encoded value must fit in 12-bits)\012#define VME_SET_UNIInput_RefIDCost(p, v) (VME_Input_S1(p, uchar, 2, 10) = v)\012\012// Format = U4U4 (encoded value must fit in 12-bits)\012#define VME_SET_UNIInput_ChromaIntraModeCost(p, v)                             \\\012  (VME_Input_S1(p, uchar, 2, 11) = v)\012\012// Format = U4U4 (encoded value must fit in 10-bits)\012#define VME_SET_UNIInput_MV0Cost(p, v) (VME_Input_S1(p, uchar, 2, 12) = v)\012#define VME_SET_UNIInput_MV1Cost(p, v) (VME_Input_S1(p, uchar, 2, 13) = v)\012#define VME_SET_UNIInput_MV2Cost(p, v) (VME_Input_S1(p, uchar, 2, 14) = v)\012#define VME_SET_UNIInput_MV3Cost(p, v) (VME_Input_S1(p, uchar, 2, 15) = v)\012#define VME_SET_UNIInput_MV4Cost(p, v) (VME_Input_S1(p, uchar, 2, 16) = v)\012#define VME_SET_UNIInput_MV5Cost(p, v) (VME_Input_S1(p, uchar, 2, 17) = v)\012#define VME_SET_UNIInput_MV6Cost(p, v) (VME_Input_S1(p, uchar, 2, 18) = v)\012#define VME_SET_UNIInput_MV",
"7Cost(p, v) (VME_Input_S1(p, uchar, 2, 19) = v)\012\012// Format = U8\012#define VME_SET_UNIInput_FBRMbModeInput(p, v)                                  \\\012  (VME_Input_S1(p, uchar, 2, 20) = v)\012\012// Format = U8\012#define VME_SET_UNIInput_FBRSubMBShapeInput(p, v)                              \\\012  (VME_Input_S1(p, uchar, 2, 21) = v)\012\012// Format = U8\012#define VME_SET_UNIInput_FBRSubPredModeInput(p, v)                             \\\012  (VME_Input_S1(p, uchar, 2, 22) = v)\012\012// Format = U16\012#define VME_SET_UNIInput_SICFwdTCoeffThreshold0(p, v)                          \\\012  (VME_Input_S1(p, ushort, 2, 12) = v)\012// Format = U8\012#define VME_SET_UNIInput_SICFwdTCoeffThreshold1(p, v)                          \\\012  (VME_Input_S1(p, uchar, 2, 26) = v)\012#define VME_SET_UNIInput_SICFwdTCoeffThreshold2(p, v)                          \\\012  (VME_Input_S1(p, uchar, 2, 27) = v)\012#define VME_SET_UNIInput_SICFwdTCoeffThreshold3(p, v)                          \\\012  (VME_Input_S1(p, uchar, 2, 28) = v)\012#define VME_SET_UNIInput_SICFwdTCoeffThreshold4(p, v)         ",
"                 \\\012  (VME_Input_S1(p, uchar, 2, 29) = v)\012#define VME_SET_UNIInput_SICFwdTCoeffThreshold5(p, v)                          \\\012  (VME_Input_S1(p, uchar, 2, 30) = v)\012#define VME_SET_UNIInput_SICFwdTCoeffThreshold6(p, v)                          \\\012  (VME_Input_S1(p, uchar, 2, 31) = v)\012\012// Format = U8, with the following definition:\012// [7:4] (Y) - specifies relative Y distance to the next SU from previous SU in\012// units of SU\012// [3:0] (X) - specifies relative X distance to the next SU from previous SU in\012// units of SU\012// Format = U8, with the following definition:\012// [7:4] (Y) - specifies relative Y distance to the next SU from previous SU in\012// units of SU\012// [3:0] (X) - specifies relative X distance to the next SU from previous SU in\012// units of SU\012#define VME_SET_IMEInput_IMESearchPathDelta0(p, v)                             \\\012  (VME_Input_G1(p, uchar, 0, 0) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta1(p, v)                             \\\012  (VME_Input_G1(p, uchar, 0, 1) = v)\012#define VME_SET_IM",
"EInput_IMESearchPathDelta2(p, v)                             \\\012  (VME_Input_G1(p, uchar, 0, 2) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta3(p, v)                             \\\012  (VME_Input_G1(p, uchar, 0, 3) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta4(p, v)                             \\\012  (VME_Input_G1(p, uchar, 0, 4) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta5(p, v)                             \\\012  (VME_Input_G1(p, uchar, 0, 5) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta6(p, v)                             \\\012  (VME_Input_G1(p, uchar, 0, 6) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta7(p, v)                             \\\012  (VME_Input_G1(p, uchar, 0, 7) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta8(p, v)                             \\\012  (VME_Input_G1(p, uchar, 0, 8) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta9(p, v)                             \\\012  (VME_Input_G1(p, uchar, 0, 9) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta10(p, v)                            \\\012  (VME_Input_G1(p",
", uchar, 0, 10) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta11(p, v)                            \\\012  (VME_Input_G1(p, uchar, 0, 11) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta12(p, v)                            \\\012  (VME_Input_G1(p, uchar, 0, 12) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta13(p, v)                            \\\012  (VME_Input_G1(p, uchar, 0, 13) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta14(p, v)                            \\\012  (VME_Input_G1(p, uchar, 0, 14) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta15(p, v)                            \\\012  (VME_Input_G1(p, uchar, 0, 15) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta16(p, v)                            \\\012  (VME_Input_G1(p, uchar, 0, 16) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta17(p, v)                            \\\012  (VME_Input_G1(p, uchar, 0, 17) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta18(p, v)                            \\\012  (VME_Input_G1(p, uchar, 0, 18) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta19(p, v)",
"                            \\\012  (VME_Input_G1(p, uchar, 0, 19) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta20(p, v)                            \\\012  (VME_Input_G1(p, uchar, 0, 20) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta21(p, v)                            \\\012  (VME_Input_G1(p, uchar, 0, 21) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta22(p, v)                            \\\012  (VME_Input_G1(p, uchar, 0, 22) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta23(p, v)                            \\\012  (VME_Input_G1(p, uchar, 0, 23) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta24(p, v)                            \\\012  (VME_Input_G1(p, uchar, 0, 24) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta25(p, v)                            \\\012  (VME_Input_G1(p, uchar, 0, 25) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta26(p, v)                            \\\012  (VME_Input_G1(p, uchar, 0, 26) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta27(p, v)                            \\\012  (VME_Input_G1(p, uchar, 0, 27) = v)\012#def",
"ine VME_SET_IMEInput_IMESearchPathDelta28(p, v)                            \\\012  (VME_Input_G1(p, uchar, 0, 28) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta29(p, v)                            \\\012  (VME_Input_G1(p, uchar, 0, 29) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta30(p, v)                            \\\012  (VME_Input_G1(p, uchar, 0, 30) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta31(p, v)                            \\\012  (VME_Input_G1(p, uchar, 0, 31) = v)\012\012#define VME_SET_IMEInput_IMESearchPathDelta32(p, v)                            \\\012  (VME_Input_G1(p, uchar, 1, 0) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta33(p, v)                            \\\012  (VME_Input_G1(p, uchar, 1, 1) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta34(p, v)                            \\\012  (VME_Input_G1(p, uchar, 1, 2) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta35(p, v)                            \\\012  (VME_Input_G1(p, uchar, 1, 3) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta36(p, v)                            ",
"\\\012  (VME_Input_G1(p, uchar, 1, 4) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta37(p, v)                            \\\012  (VME_Input_G1(p, uchar, 1, 5) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta38(p, v)                            \\\012  (VME_Input_G1(p, uchar, 1, 6) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta39(p, v)                            \\\012  (VME_Input_G1(p, uchar, 1, 7) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta40(p, v)                            \\\012  (VME_Input_G1(p, uchar, 1, 8) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta41(p, v)                            \\\012  (VME_Input_G1(p, uchar, 1, 9) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta42(p, v)                            \\\012  (VME_Input_G1(p, uchar, 1, 10) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta43(p, v)                            \\\012  (VME_Input_G1(p, uchar, 1, 11) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta44(p, v)                            \\\012  (VME_Input_G1(p, uchar, 1, 12) = v)\012#define VME_SET_IMEInput_IMESearchPath",
"Delta45(p, v)                            \\\012  (VME_Input_G1(p, uchar, 1, 13) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta46(p, v)                            \\\012  (VME_Input_G1(p, uchar, 1, 14) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta47(p, v)                            \\\012  (VME_Input_G1(p, uchar, 1, 15) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta48(p, v)                            \\\012  (VME_Input_G1(p, uchar, 1, 16) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta49(p, v)                            \\\012  (VME_Input_G1(p, uchar, 1, 17) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta50(p, v)                            \\\012  (VME_Input_G1(p, uchar, 1, 18) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta51(p, v)                            \\\012  (VME_Input_G1(p, uchar, 1, 19) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta52(p, v)                            \\\012  (VME_Input_G1(p, uchar, 1, 20) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta53(p, v)                            \\\012  (VME_Input_G1(p, uchar, 1, ",
"21) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta54(p, v)                            \\\012  (VME_Input_G1(p, uchar, 1, 22) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta55(p, v)                            \\\012  (VME_Input_G1(p, uchar, 1, 23) = v)\012\012// Format = U16\012#define VME_SET_IMEInput_Rec0_16x8_0Distortion(p, v)                           \\\012  (VME_Input_S1(p, ushort, 2, 0) = v)\012#define VME_SET_IMEInput_Rec0_16x8_1Distortion(p, v)                           \\\012  (VME_Input_S1(p, ushort, 2, 1) = v)\012#define VME_SET_IMEInput_Rec0_8x16_0Distortion(p, v)                           \\\012  (VME_Input_S1(p, ushort, 2, 2) = v)\012#define VME_SET_IMEInput_Rec0_8x16_1Distortion(p, v)                           \\\012  (VME_Input_S1(p, ushort, 2, 3) = v)\012#define VME_SET_IMEInput_Rec0_8x8_0Distortion(p, v)                            \\\012  (VME_Input_S1(p, ushort, 2, 4) = v)\012#define VME_SET_IMEInput_Rec0_8x8_1Distortion(p, v)                            \\\012  (VME_Input_S1(p, ushort, 2, 5) = v)\012#define VME_SET_IMEInput_Rec0_8x8_2Distortion(",
"p, v)                            \\\012  (VME_Input_S1(p, ushort, 2, 6) = v)\012#define VME_SET_IMEInput_Rec0_8x8_3Distortion(p, v)                            \\\012  (VME_Input_S1(p, ushort, 2, 7) = v)\012#define VME_SET_IMEInput_Rec0_16x16_Distortion(p, v)                           \\\012  (VME_Input_S1(p, ushort, 2, 8) = v)\012\012// Format = U4\012#define VME_SET_UNIInput_Rec0_16x16_RefID(p, v)                                \\\012  (VME_Input_S1(p, uchar, 2, 18) = v)\012\012// Format = S13.2\012#define VME_SET_IMEInput_Rec0_16x16_X(p, v) (VME_Input_S1(p, ushort, 2, 10) = v)\012#define VME_SET_IMEInput_Rec0_16x16_Y(p, v) (VME_Input_S1(p, ushort, 2, 11) = v)\012\012// Format = U4\012#define VME_SET_IMEInput_Rec0_16x8_0RefID(p, v)                                \\\012  (VME_Input_S1(p, uchar, 2, 24) = VME_Input_S1(p, uchar, 2, 24) & 0xF0 | v)\012#define VME_SET_IMEInput_Rec0_16x8_1RefID(p, v)                                \\\012  (VME_Input_S1(p, uchar, 2, 24) =                                             \\\012       VME_Input_S1(p, uchar, 2, 24) & 0x0F | (v << 4))\012#defi",
"ne VME_SET_IMEInput_Rec0_8x16_0RefID(p, v)                                \\\012  (VME_Input_S1(p, uchar, 2, 25) = VME_Input_S1(p, uchar, 2, 25) & 0xF0 | v)\012#define VME_SET_IMEInput_Rec0_8x16_1RefID(p, v)                                \\\012  (VME_Input_S1(p, uchar, 2, 25) =                                             \\\012       VME_Input_S1(p, uchar, 2, 25) & 0x0F | (v << 4))\012#define VME_SET_IMEInput_Rec0_8x8_0RefID(p, v)                                 \\\012  (VME_Input_S1(p, uchar, 2, 26) = VME_Input_S1(p, uchar, 2, 26) & 0xF0 | v)\012#define VME_SET_IMEInput_Rec0_8x8_1RefID(p, v)                                 \\\012  (VME_Input_S1(p, uchar, 2, 26) =                                             \\\012       VME_Input_S1(p, uchar, 2, 26) & 0x0F | (v << 4))\012#define VME_SET_IMEInput_Rec0_8x8_2RefID(p, v)                                 \\\012  (VME_Input_S1(p, uchar, 2, 27) = VME_Input_S1(p, uchar, 2, 27) & 0xF0 | v)\012#define VME_SET_IMEInput_Rec0_8x8_3RefID(p, v)                                 \\\012  (VME_Input_S1(p, uchar, 2, 27) =    ",
"                                         \\\012       VME_Input_S1(p, uchar, 2, 27) & 0x0F | (v << 4))\012\012// Format = S13.2\012#define VME_SET_IMEInput_Rec0_16x8_0X(p, v) (VME_Input_S1(p, ushort, 3, 0) = v)\012#define VME_SET_IMEInput_Rec0_16x8_0Y(p, v) (VME_Input_S1(p, ushort, 3, 1) = v)\012#define VME_SET_IMEInput_Rec0_16x8_1X(p, v) (VME_Input_S1(p, ushort, 3, 2) = v)\012#define VME_SET_IMEInput_Rec0_16x8_1Y(p, v) (VME_Input_S1(p, ushort, 3, 3) = v)\012#define VME_SET_IMEInput_Rec0_8x16_0X(p, v) (VME_Input_S1(p, ushort, 3, 4) = v)\012#define VME_SET_IMEInput_Rec0_8x16_0Y(p, v) (VME_Input_S1(p, ushort, 3, 5) = v)\012#define VME_SET_IMEInput_Rec0_8x16_1X(p, v) (VME_Input_S1(p, ushort, 3, 6) = v)\012#define VME_SET_IMEInput_Rec0_8x16_1Y(p, v) (VME_Input_S1(p, ushort, 3, 7) = v)\012#define VME_SET_IMEInput_Rec0_8x8_0X(p, v) (VME_Input_S1(p, ushort, 3, 8) = v)\012#define VME_SET_IMEInput_Rec0_8x8_0Y(p, v) (VME_Input_S1(p, ushort, 3, 9) = v)\012#define VME_SET_IMEInput_Rec0_8x8_1X(p, v) (VME_Input_S1(p, ushort, 3, 10) = v)\012#define VME_SET_IMEInput_Rec",
"0_8x8_1Y(p, v) (VME_Input_S1(p, ushort, 3, 11) = v)\012#define VME_SET_IMEInput_Rec0_8x8_2X(p, v) (VME_Input_S1(p, ushort, 3, 12) = v)\012#define VME_SET_IMEInput_Rec0_8x8_2Y(p, v) (VME_Input_S1(p, ushort, 3, 13) = v)\012#define VME_SET_IMEInput_Rec0_8x8_3X(p, v) (VME_Input_S1(p, ushort, 3, 14) = v)\012#define VME_SET_IMEInput_Rec0_8x8_3Y(p, v) (VME_Input_S1(p, ushort, 3, 15) = v)\012\012// Format = U16\012#define VME_SET_IMEInput_Rec1_16x8_0Distortion(p, v)                           \\\012  (VME_Input_S1(p, ushort, 4, 0) = v)\012#define VME_SET_IMEInput_Rec1_16x8_1Distortion(p, v)                           \\\012  (VME_Input_S1(p, ushort, 4, 1) = v)\012#define VME_SET_IMEInput_Rec1_8x16_0Distortion(p, v)                           \\\012  (VME_Input_S1(p, ushort, 4, 2) = v)\012#define VME_SET_IMEInput_Rec1_8x16_1Distortion(p, v)                           \\\012  (VME_Input_S1(p, ushort, 4, 3) = v)\012#define VME_SET_IMEInput_Rec1_8x8_0Distortion(p, v)                            \\\012  (VME_Input_S1(p, ushort, 4, 4) = v)\012#define VME_SET_IMEInput_Rec1_8x8_1Disto",
"rtion(p, v)                            \\\012  (VME_Input_S1(p, ushort, 4, 5) = v)\012#define VME_SET_IMEInput_Rec1_8x8_2Distortion(p, v)                            \\\012  (VME_Input_S1(p, ushort, 4, 6) = v)\012#define VME_SET_IMEInput_Rec1_8x8_3Distortion(p, v)                            \\\012  (VME_Input_S1(p, ushort, 4, 7) = v)\012#define VME_SET_IMEInput_Rec1_16x16_Distortion(p, v)                           \\\012  (VME_Input_S1(p, ushort, 4, 8) = v)\012\012// Format = U4\012#define VME_SET_UNIInput_Rec1_16x16_RefID(p, v)                                \\\012  (VME_Input_S1(p, uchar, 4, 18) = v)\012\012// Format = S13.2\012#define VME_SET_IMEInput_Rec1_16x16_X(p, v) (VME_Input_S1(p, ushort, 4, 10) = v)\012#define VME_SET_IMEInput_Rec1_16x16_Y(p, v) (VME_Input_S1(p, ushort, 4, 11) = v)\012\012// Format = U4\012#define VME_SET_IMEInput_Rec1_16x8_0RefID(p, v)                                \\\012  (VME_Input_S1(p, uchar, 4, 24) = VME_Input_S1(p, uchar, 4, 24) & 0xF0 | v)\012#define VME_SET_IMEInput_Rec1_16x8_1RefID(p, v)                                \\\012  (VME_Input_S1(p",
", uchar, 4, 24) =                                             \\\012       VME_Input_S1(p, uchar, 4, 24) & 0x0F | (v << 4))\012#define VME_SET_IMEInput_Rec1_8x16_0RefID(p, v)                                \\\012  (VME_Input_S1(p, uchar, 4, 25) = VME_Input_S1(p, uchar, 4, 25) & 0xF0 | v)\012#define VME_SET_IMEInput_Rec1_8x16_1RefID(p, v)                                \\\012  (VME_Input_S1(p, uchar, 4, 25) =                                             \\\012       VME_Input_S1(p, uchar, 4, 25) & 0x0F | (v << 4))\012#define VME_SET_IMEInput_Rec1_8x8_0RefID(p, v)                                 \\\012  (VME_Input_S1(p, uchar, 4, 26) = VME_Input_S1(p, uchar, 4, 26) & 0xF0 | v)\012#define VME_SET_IMEInput_Rec1_8x8_1RefID(p, v)                                 \\\012  (VME_Input_S1(p, uchar, 4, 26) =                                             \\\012       VME_Input_S1(p, uchar, 4, 26) & 0x0F | (v << 4))\012#define VME_SET_IMEInput_Rec1_8x8_2RefID(p, v)                                 \\\012  (VME_Input_S1(p, uchar, 4, 27) = VME_Input_S1(p, uchar, 4, 27) & 0xF0",
" | v)\012#define VME_SET_IMEInput_Rec1_8x8_3RefID(p, v)                                 \\\012  (VME_Input_S1(p, uchar, 4, 27) =                                             \\\012       VME_Input_S1(p, uchar, 4, 27) & 0x0F | (v << 4))\012\012// Format = S13.2\012#define VME_SET_IMEInput_Rec1_16x8_0X(p, v) (VME_Input_S1(p, ushort, 5, 0) = v)\012#define VME_SET_IMEInput_Rec1_16x8_0Y(p, v) (VME_Input_S1(p, ushort, 5, 1) = v)\012#define VME_SET_IMEInput_Rec1_16x8_1X(p, v) (VME_Input_S1(p, ushort, 5, 2) = v)\012#define VME_SET_IMEInput_Rec1_16x8_1Y(p, v) (VME_Input_S1(p, ushort, 5, 3) = v)\012#define VME_SET_IMEInput_Rec1_8x16_0X(p, v) (VME_Input_S1(p, ushort, 5, 4) = v)\012#define VME_SET_IMEInput_Rec1_8x16_0Y(p, v) (VME_Input_S1(p, ushort, 5, 5) = v)\012#define VME_SET_IMEInput_Rec1_8x16_1X(p, v) (VME_Input_S1(p, ushort, 5, 6) = v)\012#define VME_SET_IMEInput_Rec1_8x16_1Y(p, v) (VME_Input_S1(p, ushort, 5, 7) = v)\012#define VME_SET_IMEInput_Rec1_8x8_0X(p, v) (VME_Input_S1(p, ushort, 5, 8) = v)\012#define VME_SET_IMEInput_Rec1_8x8_0Y(p, v) (VME_Input_S1(p, us",
"hort, 5, 9) = v)\012#define VME_SET_IMEInput_Rec1_8x8_1X(p, v) (VME_Input_S1(p, ushort, 5, 10) = v)\012#define VME_SET_IMEInput_Rec1_8x8_1Y(p, v) (VME_Input_S1(p, ushort, 5, 11) = v)\012#define VME_SET_IMEInput_Rec1_8x8_2X(p, v) (VME_Input_S1(p, ushort, 5, 12) = v)\012#define VME_SET_IMEInput_Rec1_8x8_2Y(p, v) (VME_Input_S1(p, ushort, 5, 13) = v)\012#define VME_SET_IMEInput_Rec1_8x8_3X(p, v) (VME_Input_S1(p, ushort, 5, 14) = v)\012#define VME_SET_IMEInput_Rec1_8x8_3Y(p, v) (VME_Input_S1(p, ushort, 5, 15) = v)\012\012// Format = S13.2, Valid Range: [-2048.00 to 2047.75]\012// For chroma skip: Format = S12.3, Hardware Range: [-1024.000 to 1023.875]\012#define VME_SET_SICInput_Ref0SkipCenter0DeltaXY(p, DeltaX, DeltaY)             \\\012  (VME_Input_S1(p, uint, 0, 0) = DeltaX | (DeltaY << 16))\012#define VME_SET_SICInput_Ref1SkipCenter0DeltaXY(p, DeltaX, DeltaY)             \\\012  (VME_Input_S1(p, uint, 0, 1) = DeltaX | (DeltaY << 16))\012#define VME_SET_SICInput_Ref0SkipCenter1DeltaXY(p, DeltaX, DeltaY)             \\\012  (VME_Input_S1(p, uint, 0, 2) = Delt",
"aX | (DeltaY << 16))\012#define VME_SET_SICInput_Ref1SkipCenter1DeltaXY(p, DeltaX, DeltaY)             \\\012  (VME_Input_S1(p, uint, 0, 3) = DeltaX | (DeltaY << 16))\012#define VME_SET_SICInput_Ref0SkipCenter2DeltaXY(p, DeltaX, DeltaY)             \\\012  (VME_Input_S1(p, uint, 0, 4) = DeltaX | (DeltaY << 16))\012#define VME_SET_SICInput_Ref1SkipCenter2DeltaXY(p, DeltaX, DeltaY)             \\\012  (VME_Input_S1(p, uint, 0, 5) = DeltaX | (DeltaY << 16))\012#define VME_SET_SICInput_Ref0SkipCenter3DeltaXY(p, DeltaX, DeltaY)             \\\012  (VME_Input_S1(p, uint, 0, 6) = DeltaX | (DeltaY << 16))\012#define VME_SET_SICInput_Ref1SkipCenter3DeltaXY(p, DeltaX, DeltaY)             \\\012  (VME_Input_S1(p, uint, 0, 7) = DeltaX | (DeltaY << 16))\012\012// 2-bit field with the following definition\012// 00: Luma + Chroma enabled\012// 01: Luma only\012// 1X: Intra disabled\012#define VME_SET_SICInput_IntraComputeType(p, v)                                \\\012  (VME_Input_S1(p, uchar, 1, 5) = v)\012\012#define VME_SET_SICInput_CornerNeighborPixel0(p, v)                        ",
"    \\\012  (VME_Input_S1(p, uchar, 1, 7) = v)\012\012// NOTE: combine into one vector assignment\012#define VME_SET_SICInput_NeighborPixelLum0(p, v)                               \\\012  (VME_Input_S1(p, uchar, 1, 8) = v)\012#define VME_SET_SICInput_NeighborPixelLum1(p, v)                               \\\012  (VME_Input_S1(p, uchar, 1, 9) = v)\012#define VME_SET_SICInput_NeighborPixelLum2(p, v)                               \\\012  (VME_Input_S1(p, uchar, 1, 10) = v)\012#define VME_SET_SICInput_NeighborPixelLum3(p, v)                               \\\012  (VME_Input_S1(p, uchar, 1, 11) = v)\012#define VME_SET_SICInput_NeighborPixelLum4(p, v)                               \\\012  (VME_Input_S1(p, uchar, 1, 12) = v)\012#define VME_SET_SICInput_NeighborPixelLum5(p, v)                               \\\012  (VME_Input_S1(p, uchar, 1, 13) = v)\012#define VME_SET_SICInput_NeighborPixelLum6(p, v)                               \\\012  (VME_Input_S1(p, uchar, 1, 14) = v)\012#define VME_SET_SICInput_NeighborPixelLum7(p, v)                               \\\012  (VME_Input_S1(p, uchar",
", 1, 15) = v)\012#define VME_SET_SICInput_NeighborPixelLum8(p, v)                               \\\012  (VME_Input_S1(p, uchar, 1, 16) = v)\012#define VME_SET_SICInput_NeighborPixelLum9(p, v)                               \\\012  (VME_Input_S1(p, uchar, 1, 17) = v)\012#define VME_SET_SICInput_NeighborPixelLum10(p, v)                              \\\012  (VME_Input_S1(p, uchar, 1, 18) = v)\012#define VME_SET_SICInput_NeighborPixelLum11(p, v)                              \\\012  (VME_Input_S1(p, uchar, 1, 19) = v)\012#define VME_SET_SICInput_NeighborPixelLum12(p, v)                              \\\012  (VME_Input_S1(p, uchar, 1, 20) = v)\012#define VME_SET_SICInput_NeighborPixelLum13(p, v)                              \\\012  (VME_Input_S1(p, uchar, 1, 21) = v)\012#define VME_SET_SICInput_NeighborPixelLum14(p, v)                              \\\012  (VME_Input_S1(p, uchar, 1, 22) = v)\012#define VME_SET_SICInput_NeighborPixelLum15(p, v)                              \\\012  (VME_Input_S1(p, uchar, 1, 23) = v)\012#define VME_SET_SICInput_NeighborPixelLum16(p, v)         ",
"                     \\\012  (VME_Input_S1(p, uchar, 1, 24) = v)\012#define VME_SET_SICInput_NeighborPixelLum17(p, v)                              \\\012  (VME_Input_S1(p, uchar, 1, 25) = v)\012#define VME_SET_SICInput_NeighborPixelLum18(p, v)                              \\\012  (VME_Input_S1(p, uchar, 1, 26) = v)\012#define VME_SET_SICInput_NeighborPixelLum19(p, v)                              \\\012  (VME_Input_S1(p, uchar, 1, 27) = v)\012#define VME_SET_SICInput_NeighborPixelLum20(p, v)                              \\\012  (VME_Input_S1(p, uchar, 1, 28) = v)\012#define VME_SET_SICInput_NeighborPixelLum21(p, v)                              \\\012  (VME_Input_S1(p, uchar, 1, 29) = v)\012#define VME_SET_SICInput_NeighborPixelLum22(p, v)                              \\\012  (VME_Input_S1(p, uchar, 1, 30) = v)\012#define VME_SET_SICInput_NeighborPixelLum23(p, v)                              \\\012  (VME_Input_S1(p, uchar, 1, 31) = v)\012#define VME_SET_SICInput_NeighborPixelLum24(p, v)                              \\\012  (VME_Input_S1(p, uchar, 2, 0) = v)\012#define VME_",
"SET_SICInput_NeighborPixelLum25(p, v)                              \\\012  (VME_Input_S1(p, uchar, 2, 1) = v)\012#define VME_SET_SICInput_NeighborPixelLum26(p, v)                              \\\012  (VME_Input_S1(p, uchar, 2, 2) = v)\012#define VME_SET_SICInput_NeighborPixelLum27(p, v)                              \\\012  (VME_Input_S1(p, uchar, 2, 3) = v)\012#define VME_SET_SICInput_NeighborPixelLum28(p, v)                              \\\012  (VME_Input_S1(p, uchar, 2, 4) = v)\012#define VME_SET_SICInput_NeighborPixelLum29(p, v)                              \\\012  (VME_Input_S1(p, uchar, 2, 5) = v)\012#define VME_SET_SICInput_NeighborPixelLum30(p, v)                              \\\012  (VME_Input_S1(p, uchar, 2, 6) = v)\012#define VME_SET_SICInput_NeighborPixelLum31(p, v)                              \\\012  (VME_Input_S1(p, uchar, 2, 7) = v)\012#define VME_SET_SICInput_NeighborPixelLum32(p, v)                              \\\012  (VME_Input_S1(p, uchar, 2, 8) = v)\012#define VME_SET_SICInput_NeighborPixelLum33(p, v)                              \\\012  (VME_Inpu",
"t_S1(p, uchar, 2, 9) = v)\012#define VME_SET_SICInput_NeighborPixelLum34(p, v)                              \\\012  (VME_Input_S1(p, uchar, 2, 10) = v)\012#define VME_SET_SICInput_NeighborPixelLum35(p, v)                              \\\012  (VME_Input_S1(p, uchar, 2, 11) = v)\012#define VME_SET_SICInput_NeighborPixelLum36(p, v)                              \\\012  (VME_Input_S1(p, uchar, 2, 12) = v)\012#define VME_SET_SICInput_NeighborPixelLum37(p, v)                              \\\012  (VME_Input_S1(p, uchar, 2, 13) = v)\012#define VME_SET_SICInput_NeighborPixelLum38(p, v)                              \\\012  (VME_Input_S1(p, uchar, 2, 14) = v)\012\012#define VME_SET_SICInput_CornerNeighborPixel1(p, v)                            \\\012  (VME_Input_S1(p, uchar, 2, 15) = v)\012\012// Format = U4\012#define VME_SET_SICInput_IntraMxMPredModeA5(p, v)                              \\\012  (VME_Input_S1(p, uchar, 2, 16) = VME_Input_S1(p, uchar, 2, 16) & 0xF0 | v)\012#define VME_SET_SICInput_IntraMxMPredModeA7(p, v)                              \\\012  (VME_Input_S1(p, uchar, 2,",
" 16) =                                             \\\012       VME_Input_S1(p, uchar, 2, 16) & 0x0F | (v << 4))\012#define VME_SET_SICInput_IntraMxMPredModeA13(p, v)                             \\\012  (VME_Input_S1(p, uchar, 2, 17) = VME_Input_S1(p, uchar, 2, 17) & 0xF0 | v)\012#define VME_SET_SICInput_IntraMxMPredModeA15(p, v)                             \\\012  (VME_Input_S1(p, uchar, 2, 17) =                                             \\\012       VME_Input_S1(p, uchar, 2, 17) & 0x0F | (v << 4))\012#define VME_SET_SICInput_IntraMxMPredModeB10(p, v)                             \\\012  (VME_Input_S1(p, uchar, 2, 18) = VME_Input_S1(p, uchar, 2, 18) & 0xF0 | v)\012#define VME_SET_SICInput_IntraMxMPredModeB11(p, v)                             \\\012  (VME_Input_S1(p, uchar, 2, 18) =                                             \\\012       VME_Input_S1(p, uchar, 2, 18) & 0x0F | (v << 4))\012#define VME_SET_SICInput_IntraMxMPredModeB14(p, v)                             \\\012  (VME_Input_S1(p, uchar, 2, 19) = VME_Input_S1(p, uchar, 2, 19) & 0xF0 | v)\012#defi",
"ne VME_SET_SICInput_IntraMxMPredModeB15(p, v)                             \\\012  (VME_Input_S1(p, uchar, 2, 19) =                                             \\\012       VME_Input_S1(p, uchar, 2, 19) & 0x0F | (v << 4))\012\012// Format = U8 pair\012#define VME_SET_SICInput_CornerNeighborPixelChroma(p, v)                       \\\012  (VME_Input_S1(p, ushort, 2, 10) = v)\012\012#if 0\012// Format = U4U4\012#define VME_SET_SICInput_PenaltyIntra4x4NonDC(p, v)                            \\\012  (VME_Input_S1(p, uchar, 2, 28) = v)\012// Format = U2\012#define VME_SET_SICInput_ScaleFactorIntra8x8NonDC(p, v)                        \\\012  (VME_Input_S1(p, uchar, 2, 29) = VME_Input_S1(p, uchar, 2, 29) & 0xFC | v)\012// Format = U2\012#define VME_SET_SICInput_ScaleFactorIntra16x16NonDC(p, v)                      \\\012  (VME_Input_S1(p, uchar, 2, 29) =                                             \\\012       VME_Input_S1(p, uchar, 2, 29) & 0xF3 | (v << 2))\012#else\012// Format = U8\012#define VME_SET_SICInput_PenaltyIntra4x4NonDC(p, v)                            \\\012  (VME_Input_G1(p, ",
"uchar, 2, 30) = v)\012// Format = U8\012#define VME_SET_SICInput_PenaltyIntra8x8NonDC(p, v)                            \\\012  (VME_Input_G1(p, uchar, 2, 29) = v)\012// Format = U8\012#define VME_SET_SICInput_PenaltyIntra16x16NonDC(p, v)                          \\\012  (VME_Input_G1(p, uchar, 2, 28) = v)\012#endif\012\012#define VME_SET_SICInput_NeighborPixelChroma0(p, v)                            \\\012  (VME_Input_G1(p, uchar, 3, 0) = v)\012#define VME_SET_SICInput_NeighborPixelChroma1(p, v)                            \\\012  (VME_Input_G1(p, uchar, 3, 1) = v)\012#define VME_SET_SICInput_NeighborPixelChroma2(p, v)                            \\\012  (VME_Input_G1(p, uchar, 3, 2) = v)\012#define VME_SET_SICInput_NeighborPixelChroma3(p, v)                            \\\012  (VME_Input_G1(p, uchar, 3, 3) = v)\012\012#define VME_SET_SICInput_NeighborPixelChroma4(p, v)                            \\\012  (VME_Input_G1(p, uchar, 3, 4) = v)\012#define VME_SET_SICInput_NeighborPixelChroma5(p, v)                            \\\012  (VME_Input_G1(p, uchar, 3, 5) = v)\012#define VME_SET_SICI",
"nput_NeighborPixelChroma6(p, v)                            \\\012  (VME_Input_G1(p, uchar, 3, 6) = v)\012#define VME_SET_SICInput_NeighborPixelChroma7(p, v)                            \\\012  (VME_Input_G1(p, uchar, 3, 7) = v)\012\012#define VME_SET_SICInput_NeighborPixelChroma8(p, v)                            \\\012  (VME_Input_G1(p, uchar, 3, 8) = v)\012#define VME_SET_SICInput_NeighborPixelChroma9(p, v)                            \\\012  (VME_Input_G1(p, uchar, 3, 9) = v)\012#define VME_SET_SICInput_NeighborPixelChroma10(p, v)                           \\\012  (VME_Input_G1(p, uchar, 3, 10) = v)\012#define VME_SET_SICInput_NeighborPixelChroma11(p, v)                           \\\012  (VME_Input_G1(p, uchar, 3, 11) = v)\012\012#define VME_SET_SICInput_NeighborPixelChroma12(p, v)                           \\\012  (VME_Input_G1(p, uchar, 3, 12) = v)\012#define VME_SET_SICInput_NeighborPixelChroma13(p, v)                           \\\012  (VME_Input_G1(p, uchar, 3, 13) = v)\012#define VME_SET_SICInput_NeighborPixelChroma14(p, v)                           \\\012  (VME_Input_",
"G1(p, uchar, 3, 14) = v)\012#define VME_SET_SICInput_NeighborPixelChroma15(p, v)                           \\\012  (VME_Input_G1(p, uchar, 3, 15) = v)\012\012#define VME_SET_SICInput_NeighborPixelChroma16(p, v)                           \\\012  (VME_Input_G1(p, uchar, 3, 16) = v)\012#define VME_SET_SICInput_NeighborPixelChroma17(p, v)                           \\\012  (VME_Input_G1(p, uchar, 3, 17) = v)\012#define VME_SET_SICInput_NeighborPixelChroma18(p, v)                           \\\012  (VME_Input_G1(p, uchar, 3, 18) = v)\012#define VME_SET_SICInput_NeighborPixelChroma19(p, v)                           \\\012  (VME_Input_G1(p, uchar, 3, 19) = v)\012\012#define VME_SET_SICInput_NeighborPixelChroma20(p, v)                           \\\012  (VME_Input_G1(p, uchar, 3, 20) = v)\012#define VME_SET_SICInput_NeighborPixelChroma21(p, v)                           \\\012  (VME_Input_G1(p, uchar, 3, 21) = v)\012#define VME_SET_SICInput_NeighborPixelChroma22(p, v)                           \\\012  (VME_Input_G1(p, uchar, 3, 22) = v)\012#define VME_SET_SICInput_NeighborPixelChroma2",
"3(p, v)                           \\\012  (VME_Input_G1(p, uchar, 3, 23) = v)\012\012#define VME_SET_SICInput_NeighborPixelChroma24(p, v)                           \\\012  (VME_Input_G1(p, uchar, 3, 24) = v)\012#define VME_SET_SICInput_NeighborPixelChroma25(p, v)                           \\\012  (VME_Input_G1(p, uchar, 3, 25) = v)\012#define VME_SET_SICInput_NeighborPixelChroma26(p, v)                           \\\012  (VME_Input_G1(p, uchar, 3, 26) = v)\012#define VME_SET_SICInput_NeighborPixelChroma27(p, v)                           \\\012  (VME_Input_G1(p, uchar, 3, 27) = v)\012\012#define VME_SET_SICInput_NeighborPixelChroma28(p, v)                           \\\012  (VME_Input_G1(p, uchar, 3, 28) = v)\012#define VME_SET_SICInput_NeighborPixelChroma29(p, v)                           \\\012  (VME_Input_G1(p, uchar, 3, 29) = v)\012#define VME_SET_SICInput_NeighborPixelChroma30(p, v)                           \\\012  (VME_Input_G1(p, uchar, 3, 30) = v)\012#define VME_SET_SICInput_NeighborPixelChroma31(p, v)                           \\\012  (VME_Input_G1(p, uchar, 3, 31) =",
" v)\012\012#define VME_SET_FBRInput_Ref0SubBlockX0(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 0, 0) = v)\012#define VME_SET_FBRInput_Ref0SubBlockY0(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 0, 1) = v)\012#define VME_SET_FBRInput_Ref1SubBlockX0(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 0, 2) = v)\012#define VME_SET_FBRInput_Ref1SubBlockY0(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 0, 3) = v)\012\012#define VME_SET_FBRInput_Ref0SubBlockX1(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 0, 4) = v)\012#define VME_SET_FBRInput_Ref0SubBlockY1(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 0, 5) = v)\012#define VME_SET_FBRInput_Ref1SubBlockX1(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 0, 6) = v)\012#define VME_SET_FBRInput_Ref1SubBlockY1(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 0, 7) = v)\012\012#define VME_SET_FBRInput_Ref0SubBlockX2(p, v)                    ",
"              \\\012  (VME_Input_S1(p, ushort, 0, 8) = v)\012#define VME_SET_FBRInput_Ref0SubBlockY2(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 0, 9) = v)\012#define VME_SET_FBRInput_Ref1SubBlockX2(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 0, 10) = v)\012#define VME_SET_FBRInput_Ref1SubBlockY2(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 0, 11) = v)\012\012#define VME_SET_FBRInput_Ref0SubBlockX3(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 0, 12) = v)\012#define VME_SET_FBRInput_Ref0SubBlockY3(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 0, 13) = v)\012#define VME_SET_FBRInput_Ref1SubBlockX3(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 0, 14) = v)\012#define VME_SET_FBRInput_Ref1SubBlockY3(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 0, 15) = v)\012\012#define VME_SET_FBRInput_Ref0SubBlockX4(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 1, 0) = v)\012#define VM",
"E_SET_FBRInput_Ref0SubBlockY4(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 1, 1) = v)\012#define VME_SET_FBRInput_Ref1SubBlockX4(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 1, 2) = v)\012#define VME_SET_FBRInput_Ref1SubBlockY4(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 1, 3) = v)\012\012#define VME_SET_FBRInput_Ref0SubBlockX5(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 1, 4) = v)\012#define VME_SET_FBRInput_Ref0SubBlockY5(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 1, 5) = v)\012#define VME_SET_FBRInput_Ref1SubBlockX5(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 1, 6) = v)\012#define VME_SET_FBRInput_Ref1SubBlockY5(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 1, 7) = v)\012\012#define VME_SET_FBRInput_Ref0SubBlockX6(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 1, 8) = v)\012#define VME_SET_FBRInput_Ref0SubBlockY6(p, v)                                  \\",
"\012  (VME_Input_S1(p, ushort, 1, 9) = v)\012#define VME_SET_FBRInput_Ref1SubBlockX6(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 1, 10) = v)\012#define VME_SET_FBRInput_Ref1SubBlockY6(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 1, 11) = v)\012\012#define VME_SET_FBRInput_Ref0SubBlockX7(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 1, 12) = v)\012#define VME_SET_FBRInput_Ref0SubBlockY7(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 1, 13) = v)\012#define VME_SET_FBRInput_Ref1SubBlockX7(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 1, 14) = v)\012#define VME_SET_FBRInput_Ref1SubBlockY7(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 1, 15) = v)\012\012#define VME_SET_FBRInput_Ref0SubBlockX8(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 2, 0) = v)\012#define VME_SET_FBRInput_Ref0SubBlockY8(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 2, 1) = v)\012#define VME_SET_FBRInput_",
"Ref1SubBlockX8(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 2, 2) = v)\012#define VME_SET_FBRInput_Ref1SubBlockY8(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 2, 3) = v)\012\012#define VME_SET_FBRInput_Ref0SubBlockX9(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 2, 4) = v)\012#define VME_SET_FBRInput_Ref0SubBlockY9(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 2, 5) = v)\012#define VME_SET_FBRInput_Ref1SubBlockX9(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 2, 6) = v)\012#define VME_SET_FBRInput_Ref1SubBlockY9(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 2, 7) = v)\012\012#define VME_SET_FBRInput_Ref0SubBlockX10(p, v)                                 \\\012  (VME_Input_S1(p, ushort, 2, 8) = v)\012#define VME_SET_FBRInput_Ref0SubBlockY10(p, v)                                 \\\012  (VME_Input_S1(p, ushort, 2, 9) = v)\012#define VME_SET_FBRInput_Ref1SubBlockX10(p, v)                                 \\\012  (VME_Input_S",
"1(p, ushort, 2, 10) = v)\012#define VME_SET_FBRInput_Ref1SubBlockY10(p, v)                                 \\\012  (VME_Input_S1(p, ushort, 2, 11) = v)\012\012#define VME_SET_FBRInput_Ref0SubBlockX11(p, v)                                 \\\012  (VME_Input_S1(p, ushort, 2, 12) = v)\012#define VME_SET_FBRInput_Ref0SubBlockY11(p, v)                                 \\\012  (VME_Input_S1(p, ushort, 2, 13) = v)\012#define VME_SET_FBRInput_Ref1SubBlockX11(p, v)                                 \\\012  (VME_Input_S1(p, ushort, 2, 14) = v)\012#define VME_SET_FBRInput_Ref1SubBlockY11(p, v)                                 \\\012  (VME_Input_S1(p, ushort, 2, 15) = v)\012\012#define VME_SET_FBRInput_Ref0SubBlockX12(p, v)                                 \\\012  (VME_Input_S1(p, ushort, 3, 0) = v)\012#define VME_SET_FBRInput_Ref0SubBlockY12(p, v)                                 \\\012  (VME_Input_S1(p, ushort, 3, 1) = v)\012#define VME_SET_FBRInput_Ref1SubBlockX12(p, v)                                 \\\012  (VME_Input_S1(p, ushort, 3, 2) = v)\012#define VME_SET_FBRInput_Ref1SubBlockY12",
"(p, v)                                 \\\012  (VME_Input_S1(p, ushort, 3, 3) = v)\012\012#define VME_SET_FBRInput_Ref0SubBlockX13(p, v)                                 \\\012  (VME_Input_S1(p, ushort, 3, 4) = v)\012#define VME_SET_FBRInput_Ref0SubBlockY13(p, v)                                 \\\012  (VME_Input_S1(p, ushort, 3, 5) = v)\012#define VME_SET_FBRInput_Ref1SubBlockX13(p, v)                                 \\\012  (VME_Input_S1(p, ushort, 3, 6) = v)\012#define VME_SET_FBRInput_Ref1SubBlockY13(p, v)                                 \\\012  (VME_Input_S1(p, ushort, 3, 7) = v)\012\012#define VME_SET_FBRInput_Ref0SubBlockX14(p, v)                                 \\\012  (VME_Input_S1(p, ushort, 3, 8) = v)\012#define VME_SET_FBRInput_Ref0SubBlockY14(p, v)                                 \\\012  (VME_Input_S1(p, ushort, 3, 9) = v)\012#define VME_SET_FBRInput_Ref1SubBlockX14(p, v)                                 \\\012  (VME_Input_S1(p, ushort, 3, 10) = v)\012#define VME_SET_FBRInput_Ref1SubBlockY14(p, v)                                 \\\012  (VME_Input_S1(p, ushort, 3",
", 11) = v)\012\012#define VME_SET_FBRInput_Ref0SubBlockX15(p, v)                                 \\\012  (VME_Input_S1(p, ushort, 3, 12) = v)\012#define VME_SET_FBRInput_Ref0SubBlockY15(p, v)                                 \\\012  (VME_Input_S1(p, ushort, 3, 13) = v)\012#define VME_SET_FBRInput_Ref1SubBlockX15(p, v)                                 \\\012  (VME_Input_S1(p, ushort, 3, 14) = v)\012#define VME_SET_FBRInput_Ref1SubBlockY15(p, v)                                 \\\012  (VME_Input_S1(p, ushort, 3, 15) = v)\012\012// GET methods\012\012// Format = I16\012#define VME_GET_UNIInput_Ref0X(p) (VME_Input_G1(p, ushort, 0, 0))\012#define VME_GET_UNIInput_Ref0Y(p) (VME_Input_G1(p, ushort, 0, 1))\012#define VME_GET_UNIInput_Ref1X(p) (VME_Input_G1(p, ushort, 0, 2))\012#define VME_GET_UNIInput_Ref1Y(p) (VME_Input_G1(p, ushort, 0, 3))\012\012// Format = U16\012#define VME_GET_UNIInput_SrcX(p) (VME_Input_G1(p, ushort, 0, 4))\012\012// Format = U16\012#define VME_GET_UNIInput_SrcY(p) (VME_Input_G1(p, ushort, 0, 5))\012\012// Format = U8\012#define VME_GET_UNIInput_SrcType(p) (VME_Input_G1(p, uc",
"har, 0, 12))\012\012// Format = U8\012#define VME_GET_UNIInput_VmeModes(p) (VME_Input_G1(p, uchar, 0, 13))\012\012// Format = U8\012#define VME_GET_UNIInput_SadType(p) (VME_Input_G1(p, uchar, 0, 14))\012\012// Format = U8\012#define VME_GET_UNIInput_ShapeMask(p) (VME_Input_G1(p, uchar, 0, 15))\012\012// The value must be a multiple of 4. Range = [20, 64]\012#define VME_GET_UNIInput_RefW(p) (VME_Input_G1(p, uchar, 0, 22))\012\012// The value must be a multiple of 4. Range = [20, 64]\012#define VME_GET_UNIInput_RefH(p) (VME_Input_G1(p, uchar, 0, 23))\012\012// Format = U8\012#define VME_GET_UNIInput_VmeFlags(p) (VME_Input_G1(p, uchar, 1, 0))\012\012// Format = U8\012#define VME_GET_UNIInput_EarlyImeStop(p) (VME_Input_G1(p, uchar, 1, 3))\012\012// Format = U8\012#define VME_GET_UNIInput_MaxNumMVs(p) (VME_Input_G1(p, uchar, 1, 4))\012\012// Format = U6, Valid Values: [16, 21, 32, 43, 48]\012#define VME_GET_UNIInput_BiWeight(p) (VME_Input_G1(p, uchar, 1, 6))\012\012// Format = U8\012#define VME_GET_UNIInput_BiDirMask(p)                                          \\\012  ((VME_Input_G1(p, uchar, 1, 7) & 0x10)",
" \? 1 : 0)\012\012// Format = U8, Valid range [1,63]\012#define VME_GET_UNIInput_LenSP(p) (VME_Input_G1(p, uchar, 1, 8))\012\012// Format = U8, Valid range [1,63]\012#define VME_GET_UNIInput_MaxNumSU(p) (VME_Input_G1(p, uchar, 1, 9))\012\012// Format = U8\012#define VME_GET_UNIInput_StartCenter0(p) (VME_Input_G1(p, uchar, 1, 10))\012\012// Format = U8\012#define VME_GET_UNIInput_StartCenter1(p) (VME_Input_G1(p, uchar, 1, 11))\012\012// Format = U8\012#define VME_GET_UNIInput_WeightedSADCtrl0_3(p) (VME_Input_G1(p, uchar, 1, 12))\012#define VME_GET_UNIInput_WeightedSADCtrl4_7(p) (VME_Input_G1(p, uchar, 1, 13))\012#define VME_GET_UNIInput_WeightedSADCtrl8_11(p) (VME_Input_G1(p, uchar, 1, 14))\012#define VME_GET_UNIInput_WeightedSADCtrl12_15(p) (VME_Input_G1(p, uchar, 1, 15))\012\012// Format = S13.2, Valid range [-2048.00 to 2047.75]\012#define VME_GET_UNIInput_CostCenter0_X(p) (VME_Input_G1(p, ushort, 1, 8))\012#define VME_GET_UNIInput_CostCenter0_Y(p) (VME_Input_G1(p, ushort, 1, 9))\012#define VME_GET_UNIInput_CostCenter1_X(p) (VME_Input_G1(p, ushort, 1, 10))\012#define VME_GET_UNI",
"Input_CostCenter1_Y(p) (VME_Input_G1(p, ushort, 1, 11))\012\012// Format = U8\012#define VME_GET_UNIInput_Blk0RefID(p) (VME_Input_G1(p, uchar, 1, 24))\012#define VME_GET_UNIInput_Blk1RefID(p) (VME_Input_G1(p, uchar, 1, 25))\012#define VME_GET_UNIInput_Blk2RefID(p) (VME_Input_G1(p, uchar, 1, 26))\012#define VME_GET_UNIInput_Blk3RefID(p) (VME_Input_G1(p, uchar, 1, 27))\012\012// Format = U8\012#define VME_GET_UNIInput_IntraFlags(p) (VME_Input_G1(p, uchar, 1, 28))\012\012#define VME_GET_UNIInput_MbIntraStruct(p) (VME_Input_G1(p, uchar, 1, 29))\012\012// Format = U8\012#define VME_GET_UNIInput_MvFlags(p) (VME_Input_G1(p, uchar, 1, 30))\012\012// v is a 8-bit mask with the following definition:\012// xxxx xxx1: Ref0 Skip Center 0 is enabled [corresponds to M2.0]\012// xxxx xx1x: Ref1 Skip Center 0 is enabled [corresponds to M2.1]\012// xxxx x1xx: Ref0 Skip Center 1 is enabled [corresponds to M2.2]\012// xxxx 1xxx: Ref1 Skip Center 1 is enabled [corresponds to M2.3]\012// xxx1 xxxx: Ref0 Skip Center 2 is enabled [corresponds to M2.4]\012// xx1x xxxx: Ref1 Skip Center 2 is enabled",
" [corresponds to M2.5]\012// x1xx xxxx: Ref0 Skip Center 3 is enabled [corresponds to M2.6]\012// 1xxx xxxx: Ref1 Skip Center 3 is enabled [corresponds to M2.7]\012#define VME_GET_UNIInput_SkipCenterMask(p) (VME_Input_G1(p, uchar, 1, 31))\012\012// NOTE: replace v with U4U4 type with\012// (shift_count, shift_val) and set the value as (shift_val | (shift_count <<\012// 4))\012\012// Format = U4U4 (encoded value must fit in 12-bits)\012#define VME_GET_UNIInput_Mode0Cost(p) (VME_Input_G1(p, uchar, 2, 0))\012#define VME_GET_UNIInput_Mode1Cost(p) (VME_Input_G1(p, uchar, 2, 1))\012#define VME_GET_UNIInput_Mode2Cost(p) (VME_Input_G1(p, uchar, 2, 2))\012#define VME_GET_UNIInput_Mode3Cost(p) (VME_Input_G1(p, uchar, 2, 3))\012#define VME_GET_UNIInput_Mode4Cost(p) (VME_Input_G1(p, uchar, 2, 4))\012#define VME_GET_UNIInput_Mode5Cost(p) (VME_Input_G1(p, uchar, 2, 5))\012#define VME_GET_UNIInput_Mode6Cost(p) (VME_Input_G1(p, uchar, 2, 6))\012#define VME_GET_UNIInput_Mode7Cost(p) (VME_Input_G1(p, uchar, 2, 7))\012#define VME_GET_UNIInput_Mode8Cost(p) (VME_Input_G1(p, uchar, 2",
", 8))\012#define VME_GET_UNIInput_Mode9Cost(p) (VME_Input_G1(p, uchar, 2, 9))\012\012// Format = U4U4 (encoded value must fit in 12-bits)\012#define VME_GET_UNIInput_RefIDCost(p) (VME_Input_G1(p, uchar, 2, 10))\012\012// Format = U4U4 (encoded value must fit in 12-bits)\012#define VME_GET_UNIInput_ChromaIntraModeCost(p) (VME_Input_G1(p, uchar, 2, 11))\012\012// Format = U4U4 (encoded value must fit in 10-bits)\012#define VME_GET_UNIInput_MV0Cost(p) (VME_Input_G1(p, uchar, 2, 12))\012#define VME_GET_UNIInput_MV1Cost(p) (VME_Input_G1(p, uchar, 2, 13))\012#define VME_GET_UNIInput_MV2Cost(p) (VME_Input_G1(p, uchar, 2, 14))\012#define VME_GET_UNIInput_MV3Cost(p) (VME_Input_G1(p, uchar, 2, 15))\012#define VME_GET_UNIInput_MV4Cost(p) (VME_Input_G1(p, uchar, 2, 16))\012#define VME_GET_UNIInput_MV5Cost(p) (VME_Input_G1(p, uchar, 2, 17))\012#define VME_GET_UNIInput_MV6Cost(p) (VME_Input_G1(p, uchar, 2, 18))\012#define VME_GET_UNIInput_MV7Cost(p) (VME_Input_G1(p, uchar, 2, 19))\012\012// Format = U8\012#define VME_GET_UNIInput_FBRMbModeInput(p) (VME_Input_G1(p, uchar, 2, 20) & 0",
"x3)\012\012// Format = U8\012#define VME_GET_UNIInput_FBRSubMBShapeInput(p) (VME_Input_G1(p, uchar, 2, 21))\012\012// Format = U8\012#define VME_GET_UNIInput_FBRSubPredModeInput(p) (VME_Input_G1(p, uchar, 2, 22))\012\012// Format = U16\012#define VME_GET_UNIInput_SICFwdTCoeffThreshold0(p)                             \\\012  (VME_Input_G1(p, ushort, 2, 12))\012// Format = U8\012#define VME_GET_UNIInput_SICFwdTCoeffThreshold1(p)                             \\\012  (VME_Input_G1(p, uchar, 2, 26))\012#define VME_GET_UNIInput_SICFwdTCoeffThreshold2(p)                             \\\012  (VME_Input_G1(p, uchar, 2, 27))\012#define VME_GET_UNIInput_SICFwdTCoeffThreshold3(p)                             \\\012  (VME_Input_G1(p, uchar, 2, 28))\012#define VME_GET_UNIInput_SICFwdTCoeffThreshold4(p)                             \\\012  (VME_Input_G1(p, uchar, 2, 29))\012#define VME_GET_UNIInput_SICFwdTCoeffThreshold5(p)                             \\\012  (VME_Input_G1(p, uchar, 2, 30))\012#define VME_GET_UNIInput_SICFwdTCoeffThreshold6(p)                             \\\012  (VME_Input_G1(p, uchar,",
" 2, 31))\012\012// Format = U8, with the following definition:\012// [7:4] (Y) - specifies relative Y distance to the next SU from previous SU in\012// units of SU\012// [3:0] (X) - specifies relative X distance to the next SU from previous SU in\012// units of SU\012#define VME_GET_IMEInput_IMESearchPathDelta0(p) (VME_Input_G1(p, uchar, 0, 0))\012#define VME_GET_IMEInput_IMESearchPathDelta1(p) (VME_Input_G1(p, uchar, 0, 1))\012#define VME_GET_IMEInput_IMESearchPathDelta2(p) (VME_Input_G1(p, uchar, 0, 2))\012#define VME_GET_IMEInput_IMESearchPathDelta3(p) (VME_Input_G1(p, uchar, 0, 3))\012#define VME_GET_IMEInput_IMESearchPathDelta4(p) (VME_Input_G1(p, uchar, 0, 4))\012#define VME_GET_IMEInput_IMESearchPathDelta5(p) (VME_Input_G1(p, uchar, 0, 5))\012#define VME_GET_IMEInput_IMESearchPathDelta6(p) (VME_Input_G1(p, uchar, 0, 6))\012#define VME_GET_IMEInput_IMESearchPathDelta7(p) (VME_Input_G1(p, uchar, 0, 7))\012#define VME_GET_IMEInput_IMESearchPathDelta8(p) (VME_Input_G1(p, uchar, 0, 8))\012#define VME_GET_IMEInput_IMESearchPathDelta9(p) (VME_Input_G1(p, u",
"char, 0, 9))\012#define VME_GET_IMEInput_IMESearchPathDelta10(p) (VME_Input_G1(p, uchar, 0, 10))\012#define VME_GET_IMEInput_IMESearchPathDelta11(p) (VME_Input_G1(p, uchar, 0, 11))\012#define VME_GET_IMEInput_IMESearchPathDelta12(p) (VME_Input_G1(p, uchar, 0, 12))\012#define VME_GET_IMEInput_IMESearchPathDelta13(p) (VME_Input_G1(p, uchar, 0, 13))\012#define VME_GET_IMEInput_IMESearchPathDelta14(p) (VME_Input_G1(p, uchar, 0, 14))\012#define VME_GET_IMEInput_IMESearchPathDelta15(p) (VME_Input_G1(p, uchar, 0, 15))\012#define VME_GET_IMEInput_IMESearchPathDelta16(p) (VME_Input_G1(p, uchar, 0, 16))\012#define VME_GET_IMEInput_IMESearchPathDelta17(p) (VME_Input_G1(p, uchar, 0, 17))\012#define VME_GET_IMEInput_IMESearchPathDelta18(p) (VME_Input_G1(p, uchar, 0, 18))\012#define VME_GET_IMEInput_IMESearchPathDelta19(p) (VME_Input_G1(p, uchar, 0, 19))\012#define VME_GET_IMEInput_IMESearchPathDelta20(p) (VME_Input_G1(p, uchar, 0, 20))\012#define VME_GET_IMEInput_IMESearchPathDelta21(p) (VME_Input_G1(p, uchar, 0, 21))\012#define VME_GET_IMEInput_IMESearchPathD",
"elta22(p) (VME_Input_G1(p, uchar, 0, 22))\012#define VME_GET_IMEInput_IMESearchPathDelta23(p) (VME_Input_G1(p, uchar, 0, 23))\012#define VME_GET_IMEInput_IMESearchPathDelta24(p) (VME_Input_G1(p, uchar, 0, 24))\012#define VME_GET_IMEInput_IMESearchPathDelta25(p) (VME_Input_G1(p, uchar, 0, 25))\012#define VME_GET_IMEInput_IMESearchPathDelta26(p) (VME_Input_G1(p, uchar, 0, 26))\012#define VME_GET_IMEInput_IMESearchPathDelta27(p) (VME_Input_G1(p, uchar, 0, 27))\012#define VME_GET_IMEInput_IMESearchPathDelta28(p) (VME_Input_G1(p, uchar, 0, 28))\012#define VME_GET_IMEInput_IMESearchPathDelta29(p) (VME_Input_G1(p, uchar, 0, 29))\012#define VME_GET_IMEInput_IMESearchPathDelta30(p) (VME_Input_G1(p, uchar, 0, 30))\012#define VME_GET_IMEInput_IMESearchPathDelta31(p) (VME_Input_G1(p, uchar, 0, 31))\012\012#define VME_GET_IMEInput_IMESearchPathDelta32(p) (VME_Input_G1(p, uchar, 1, 0))\012#define VME_GET_IMEInput_IMESearchPathDelta33(p) (VME_Input_G1(p, uchar, 1, 1))\012#define VME_GET_IMEInput_IMESearchPathDelta34(p) (VME_Input_G1(p, uchar, 1, 2))\012#define VME_",
"GET_IMEInput_IMESearchPathDelta35(p) (VME_Input_G1(p, uchar, 1, 3))\012#define VME_GET_IMEInput_IMESearchPathDelta36(p) (VME_Input_G1(p, uchar, 1, 4))\012#define VME_GET_IMEInput_IMESearchPathDelta37(p) (VME_Input_G1(p, uchar, 1, 5))\012#define VME_GET_IMEInput_IMESearchPathDelta38(p) (VME_Input_G1(p, uchar, 1, 6))\012#define VME_GET_IMEInput_IMESearchPathDelta39(p) (VME_Input_G1(p, uchar, 1, 7))\012#define VME_GET_IMEInput_IMESearchPathDelta40(p) (VME_Input_G1(p, uchar, 1, 8))\012#define VME_GET_IMEInput_IMESearchPathDelta41(p) (VME_Input_G1(p, uchar, 1, 9))\012#define VME_GET_IMEInput_IMESearchPathDelta42(p) (VME_Input_G1(p, uchar, 1, 10))\012#define VME_GET_IMEInput_IMESearchPathDelta43(p) (VME_Input_G1(p, uchar, 1, 11))\012#define VME_GET_IMEInput_IMESearchPathDelta44(p) (VME_Input_G1(p, uchar, 1, 12))\012#define VME_GET_IMEInput_IMESearchPathDelta45(p) (VME_Input_G1(p, uchar, 1, 13))\012#define VME_GET_IMEInput_IMESearchPathDelta46(p) (VME_Input_G1(p, uchar, 1, 14))\012#define VME_GET_IMEInput_IMESearchPathDelta47(p) (VME_Input_G1(p, uchar",
", 1, 15))\012#define VME_GET_IMEInput_IMESearchPathDelta48(p) (VME_Input_G1(p, uchar, 1, 16))\012#define VME_GET_IMEInput_IMESearchPathDelta49(p) (VME_Input_G1(p, uchar, 1, 17))\012#define VME_GET_IMEInput_IMESearchPathDelta50(p) (VME_Input_G1(p, uchar, 1, 18))\012#define VME_GET_IMEInput_IMESearchPathDelta51(p) (VME_Input_G1(p, uchar, 1, 19))\012#define VME_GET_IMEInput_IMESearchPathDelta52(p) (VME_Input_G1(p, uchar, 1, 20))\012#define VME_GET_IMEInput_IMESearchPathDelta53(p) (VME_Input_G1(p, uchar, 1, 21))\012#define VME_GET_IMEInput_IMESearchPathDelta54(p) (VME_Input_G1(p, uchar, 1, 22))\012#define VME_GET_IMEInput_IMESearchPathDelta55(p) (VME_Input_G1(p, uchar, 1, 23))\012\012// Format = U16\012#define VME_GET_IMEInput_Rec0_16x8_0Distortion(p)                              \\\012  (VME_Input_G1(p, ushort, 2, 0))\012#define VME_GET_IMEInput_Rec0_16x8_1Distortion(p)                              \\\012  (VME_Input_G1(p, ushort, 2, 1))\012#define VME_GET_IMEInput_Rec0_8x16_0Distortion(p)                              \\\012  (VME_Input_G1(p, ushort, 2, 2))\012#def",
"ine VME_GET_IMEInput_Rec0_8x16_1Distortion(p)                              \\\012  (VME_Input_G1(p, ushort, 2, 3))\012#define VME_GET_IMEInput_Rec0_8x8_0Distortion(p) (VME_Input_G1(p, ushort, 2, 4))\012#define VME_GET_IMEInput_Rec0_8x8_1Distortion(p) (VME_Input_G1(p, ushort, 2, 5))\012#define VME_GET_IMEInput_Rec0_8x8_2Distortion(p) (VME_Input_G1(p, ushort, 2, 6))\012#define VME_GET_IMEInput_Rec0_8x8_3Distortion(p) (VME_Input_G1(p, ushort, 2, 7))\012#define VME_GET_IMEInput_Rec0_16x16_Distortion(p)                              \\\012  (VME_Input_G1(p, ushort, 2, 8))\012\012// Format = U4\012#define VME_GET_UNIInput_Rec0_16x16_RefID(p)                                   \\\012  (VME_Input_G1(p, uchar, 2, 18) & 0x0F)\012\012// Format = S13.2\012#define VME_GET_IMEInput_Rec0_16x16_X(p) (VME_Input_G1(p, ushort, 2, 10))\012#define VME_GET_IMEInput_Rec0_16x16_Y(p) (VME_Input_G1(p, ushort, 2, 11))\012\012// Format = U4\012#define VME_GET_IMEInput_Rec0_16x8_0to1RefID(p) (VME_Input_G1(p, uchar, 2, 24))\012#define VME_GET_IMEInput_Rec0_8x16_0to1RefID(p) (VME_Input_G1(p, uchar, 2",
", 25))\012#define VME_GET_IMEInput_Rec0_8x8_0to1RefID(p) (VME_Input_G1(p, uchar, 2, 26))\012#define VME_GET_IMEInput_Rec0_8x8_2to3RefID(p) (VME_Input_G1(p, uchar, 2, 27))\012\012// Format = S13.2\012#define VME_GET_IMEInput_Rec0_16x8_0X(p) (VME_Input_G1(p, ushort, 3, 0))\012#define VME_GET_IMEInput_Rec0_16x8_0Y(p) (VME_Input_G1(p, ushort, 3, 1))\012#define VME_GET_IMEInput_Rec0_16x8_1X(p) (VME_Input_G1(p, ushort, 3, 2))\012#define VME_GET_IMEInput_Rec0_16x8_1Y(p) (VME_Input_G1(p, ushort, 3, 3))\012#define VME_GET_IMEInput_Rec0_8x16_0X(p) (VME_Input_G1(p, ushort, 3, 4))\012#define VME_GET_IMEInput_Rec0_8x16_0Y(p) (VME_Input_G1(p, ushort, 3, 5))\012#define VME_GET_IMEInput_Rec0_8x16_1X(p) (VME_Input_G1(p, ushort, 3, 6))\012#define VME_GET_IMEInput_Rec0_8x16_1Y(p) (VME_Input_G1(p, ushort, 3, 7))\012#define VME_GET_IMEInput_Rec0_8x8_0X(p) (VME_Input_G1(p, ushort, 3, 8))\012#define VME_GET_IMEInput_Rec0_8x8_0Y(p) (VME_Input_G1(p, ushort, 3, 9))\012#define VME_GET_IMEInput_Rec0_8x8_1X(p) (VME_Input_G1(p, ushort, 3, 10))\012#define VME_GET_IMEInput_Rec0_8x8_1Y(p)",
" (VME_Input_G1(p, ushort, 3, 11))\012#define VME_GET_IMEInput_Rec0_8x8_2X(p) (VME_Input_G1(p, ushort, 3, 12))\012#define VME_GET_IMEInput_Rec0_8x8_2Y(p) (VME_Input_G1(p, ushort, 3, 13))\012#define VME_GET_IMEInput_Rec0_8x8_3X(p) (VME_Input_G1(p, ushort, 3, 14))\012#define VME_GET_IMEInput_Rec0_8x8_3Y(p) (VME_Input_G1(p, ushort, 3, 15))\012\012// Format = U16\012#define VME_GET_IMEInput_Rec1_16x8_0Distortion(p)                              \\\012  (VME_Input_G1(p, ushort, 4, 0))\012#define VME_GET_IMEInput_Rec1_16x8_1Distortion(p)                              \\\012  (VME_Input_G1(p, ushort, 4, 1))\012#define VME_GET_IMEInput_Rec1_8x16_0Distortion(p)                              \\\012  (VME_Input_G1(p, ushort, 4, 2))\012#define VME_GET_IMEInput_Rec1_8x16_1Distortion(p)                              \\\012  (VME_Input_G1(p, ushort, 4, 3))\012#define VME_GET_IMEInput_Rec1_8x8_0Distortion(p) (VME_Input_G1(p, ushort, 4, 4))\012#define VME_GET_IMEInput_Rec1_8x8_1Distortion(p) (VME_Input_G1(p, ushort, 4, 5))\012#define VME_GET_IMEInput_Rec1_8x8_2Distortion(p) (VME_Input",
"_G1(p, ushort, 4, 6))\012#define VME_GET_IMEInput_Rec1_8x8_3Distortion(p) (VME_Input_G1(p, ushort, 4, 7))\012#define VME_GET_IMEInput_Rec1_16x16_Distortion(p)                              \\\012  (VME_Input_G1(p, ushort, 4, 8))\012\012// Format = U4\012#define VME_GET_UNIInput_Rec1_16x16_RefID(p) (VME_Input_G1(p, uchar, 4, 18))\012\012// Format = S13.2\012#define VME_GET_IMEInput_Rec1_16x16_X(p) (VME_Input_G1(p, ushort, 4, 10))\012#define VME_GET_IMEInput_Rec1_16x16_Y(p) (VME_Input_G1(p, ushort, 4, 11))\012\012// Format = U4\012#define VME_GET_IMEInput_Rec1_16x8_0to1RefID(p) (VME_Input_G1(p, uchar, 4, 24))\012#define VME_GET_IMEInput_Rec1_8x16_0to1RefID(p) (VME_Input_G1(p, uchar, 4, 25))\012#define VME_GET_IMEInput_Rec1_8x8_0to1RefID(p) (VME_Input_G1(p, uchar, 4, 26))\012#define VME_GET_IMEInput_Rec1_8x8_2to3RefID(p) (VME_Input_G1(p, uchar, 4, 27))\012\012// Format = S13.2\012#define VME_GET_IMEInput_Rec1_16x8_0X(p) (VME_Input_G1(p, ushort, 5, 0))\012#define VME_GET_IMEInput_Rec1_16x8_0Y(p) (VME_Input_G1(p, ushort, 5, 1))\012#define VME_GET_IMEInput_Rec1_16x8_1X(p) (VME_I",
"nput_G1(p, ushort, 5, 2))\012#define VME_GET_IMEInput_Rec1_16x8_1Y(p) (VME_Input_G1(p, ushort, 5, 3))\012#define VME_GET_IMEInput_Rec1_8x16_0X(p) (VME_Input_G1(p, ushort, 5, 4))\012#define VME_GET_IMEInput_Rec1_8x16_0Y(p) (VME_Input_G1(p, ushort, 5, 5))\012#define VME_GET_IMEInput_Rec1_8x16_1X(p) (VME_Input_G1(p, ushort, 5, 6))\012#define VME_GET_IMEInput_Rec1_8x16_1Y(p) (VME_Input_G1(p, ushort, 5, 7))\012#define VME_GET_IMEInput_Rec1_8x8_0X(p) (VME_Input_G1(p, ushort, 5, 8))\012#define VME_GET_IMEInput_Rec1_8x8_0Y(p) (VME_Input_G1(p, ushort, 5, 9))\012#define VME_GET_IMEInput_Rec1_8x8_1X(p) (VME_Input_G1(p, ushort, 5, 10))\012#define VME_GET_IMEInput_Rec1_8x8_1Y(p) (VME_Input_G1(p, ushort, 5, 11))\012#define VME_GET_IMEInput_Rec1_8x8_2X(p) (VME_Input_G1(p, ushort, 5, 12))\012#define VME_GET_IMEInput_Rec1_8x8_2Y(p) (VME_Input_G1(p, ushort, 5, 13))\012#define VME_GET_IMEInput_Rec1_8x8_3X(p) (VME_Input_G1(p, ushort, 5, 14))\012#define VME_GET_IMEInput_Rec1_8x8_3Y(p) (VME_Input_G1(p, ushort, 5, 15))\012\012// Format = S13.2, Valid Range: [-2048.00 to 2047.",
"75]\012// For chroma skip: Format = S12.3, Hardware Range: [-1024.000 to 1023.875]\012#define VME_GET_SICInput_Ref0SkipCenter0DeltaX(p)                              \\\012  (VME_Input_G1(p, ushort, 0, 0))\012#define VME_GET_SICInput_Ref0SkipCenter0DeltaY(p)                              \\\012  (VME_Input_G1(p, ushort, 0, 1))\012\012#define VME_GET_SICInput_Ref1SkipCenter0DeltaX(p)                              \\\012  (VME_Input_G1(p, ushort, 0, 2))\012#define VME_GET_SICInput_Ref1SkipCenter0DeltaY(p)                              \\\012  (VME_Input_G1(p, ushort, 0, 3))\012\012#define VME_GET_SICInput_Ref0SkipCenter1DeltaX(p)                              \\\012  (VME_Input_G1(p, ushort, 0, 4))\012#define VME_GET_SICInput_Ref0SkipCenter1DeltaY(p)                              \\\012  (VME_Input_G1(p, ushort, 0, 5))\012\012#define VME_GET_SICInput_Ref1SkipCenter1DeltaX(p)                              \\\012  (VME_Input_G1(p, ushort, 0, 6))\012#define VME_GET_SICInput_Ref1SkipCenter1DeltaY(p)                              \\\012  (VME_Input_G1(p, ushort, 0, 7))\012\012#define VME_GET_SICI",
"nput_Ref0SkipCenter2DeltaX(p)                              \\\012  (VME_Input_G1(p, ushort, 0, 8))\012#define VME_GET_SICInput_Ref0SkipCenter2DeltaY(p)                              \\\012  (VME_Input_G1(p, ushort, 0, 9))\012\012#define VME_GET_SICInput_Ref1SkipCenter2DeltaX(p)                              \\\012  (VME_Input_G1(p, ushort, 0, 10))\012#define VME_GET_SICInput_Ref1SkipCenter2DeltaY(p)                              \\\012  (VME_Input_G1(p, ushort, 0, 11))\012\012#define VME_GET_SICInput_Ref0SkipCenter3DeltaX(p)                              \\\012  (VME_Input_G1(p, ushort, 0, 12))\012#define VME_GET_SICInput_Ref0SkipCenter3DeltaY(p)                              \\\012  (VME_Input_G1(p, ushort, 0, 13))\012\012#define VME_GET_SICInput_Ref1SkipCenter3DeltaX(p)                              \\\012  (VME_Input_G1(p, ushort, 0, 14))\012#define VME_GET_SICInput_Ref1SkipCenter3DeltaY(p)                              \\\012  (VME_Input_G1(p, ushort, 0, 15))\012\012#define VME_GET_SICInput_Intra4x4ModeMask(p) (VME_Input_G1(p, uchar, 1, 0))\012\012#define VME_GET_SICInput_Intra8x8Mode",
"Mask(p) (VME_Input_G1(p, uchar, 1, 2))\012\012#define VME_GET_SICInput_IntraModeMask(p) (VME_Input_G1(p, uchar, 1, 4))\012\012// 2-bit field with the following definition\012// 00: Luma + Chroma enabled\012// 01: Luma only\012// 1X: Intra disabled\012#define VME_GET_SICInput_IntraComputeType(p)                                   \\\012  (VME_Input_G1(p, uchar, 1, 5) & 0x3)\012\012#define VME_GET_SICInput_CornerNeighborPixel0(p) (VME_Input_G1(p, uchar, 1, 7))\012\012#define VME_GET_SICInput_NeighborPixelLum0(p) (VME_Input_G1(p, uchar, 1, 8))\012#define VME_GET_SICInput_NeighborPixelLum1(p) (VME_Input_G1(p, uchar, 1, 9))\012#define VME_GET_SICInput_NeighborPixelLum2(p) (VME_Input_G1(p, uchar, 1, 10))\012#define VME_GET_SICInput_NeighborPixelLum3(p) (VME_Input_G1(p, uchar, 1, 11))\012#define VME_GET_SICInput_NeighborPixelLum4(p) (VME_Input_G1(p, uchar, 1, 12))\012#define VME_GET_SICInput_NeighborPixelLum5(p) (VME_Input_G1(p, uchar, 1, 13))\012#define VME_GET_SICInput_NeighborPixelLum6(p) (VME_Input_G1(p, uchar, 1, 14))\012#define VME_GET_SICInput_NeighborPixelLum7(p) (VME_",
"Input_G1(p, uchar, 1, 15))\012#define VME_GET_SICInput_NeighborPixelLum8(p) (VME_Input_G1(p, uchar, 1, 16))\012#define VME_GET_SICInput_NeighborPixelLum9(p) (VME_Input_G1(p, uchar, 1, 17))\012#define VME_GET_SICInput_NeighborPixelLum10(p) (VME_Input_G1(p, uchar, 1, 18))\012#define VME_GET_SICInput_NeighborPixelLum11(p) (VME_Input_G1(p, uchar, 1, 19))\012#define VME_GET_SICInput_NeighborPixelLum12(p) (VME_Input_G1(p, uchar, 1, 20))\012#define VME_GET_SICInput_NeighborPixelLum13(p) (VME_Input_G1(p, uchar, 1, 21))\012#define VME_GET_SICInput_NeighborPixelLum14(p) (VME_Input_G1(p, uchar, 1, 22))\012#define VME_GET_SICInput_NeighborPixelLum15(p) (VME_Input_G1(p, uchar, 1, 23))\012#define VME_GET_SICInput_NeighborPixelLum16(p) (VME_Input_G1(p, uchar, 1, 24))\012#define VME_GET_SICInput_NeighborPixelLum17(p) (VME_Input_G1(p, uchar, 1, 25))\012#define VME_GET_SICInput_NeighborPixelLum18(p) (VME_Input_G1(p, uchar, 1, 26))\012#define VME_GET_SICInput_NeighborPixelLum19(p) (VME_Input_G1(p, uchar, 1, 27))\012#define VME_GET_SICInput_NeighborPixelLum20(p) (VME",
"_Input_G1(p, uchar, 1, 28))\012#define VME_GET_SICInput_NeighborPixelLum21(p) (VME_Input_G1(p, uchar, 1, 29))\012#define VME_GET_SICInput_NeighborPixelLum22(p) (VME_Input_G1(p, uchar, 1, 30))\012#define VME_GET_SICInput_NeighborPixelLum23(p) (VME_Input_G1(p, uchar, 1, 31))\012#define VME_GET_SICInput_NeighborPixelLum24(p) (VME_Input_G1(p, uchar, 2, 0))\012#define VME_GET_SICInput_NeighborPixelLum25(p) (VME_Input_G1(p, uchar, 2, 1))\012#define VME_GET_SICInput_NeighborPixelLum26(p) (VME_Input_G1(p, uchar, 2, 2))\012#define VME_GET_SICInput_NeighborPixelLum27(p) (VME_Input_G1(p, uchar, 2, 3))\012#define VME_GET_SICInput_NeighborPixelLum28(p) (VME_Input_G1(p, uchar, 2, 4))\012#define VME_GET_SICInput_NeighborPixelLum29(p) (VME_Input_G1(p, uchar, 2, 5))\012#define VME_GET_SICInput_NeighborPixelLum30(p) (VME_Input_G1(p, uchar, 2, 6))\012#define VME_GET_SICInput_NeighborPixelLum31(p) (VME_Input_G1(p, uchar, 2, 7))\012#define VME_GET_SICInput_NeighborPixelLum32(p) (VME_Input_G1(p, uchar, 2, 8))\012#define VME_GET_SICInput_NeighborPixelLum33(p) (VME_Input",
"_G1(p, uchar, 2, 9))\012#define VME_GET_SICInput_NeighborPixelLum34(p) (VME_Input_G1(p, uchar, 2, 10))\012#define VME_GET_SICInput_NeighborPixelLum35(p) (VME_Input_G1(p, uchar, 2, 11))\012#define VME_GET_SICInput_NeighborPixelLum36(p) (VME_Input_G1(p, uchar, 2, 12))\012#define VME_GET_SICInput_NeighborPixelLum37(p) (VME_Input_G1(p, uchar, 2, 13))\012#define VME_GET_SICInput_NeighborPixelLum38(p) (VME_Input_G1(p, uchar, 2, 14))\012\012#define VME_GET_SICInput_CornerNeighborPixel1(p) (VME_Input_G1(p, uchar, 2, 15))\012\012#define VME_GET_SICInput_LeftModes(p) (VME_Input_G1(p, ushort, 2, 8))\012\012#define VME_GET_SICInput_TopModes(p) (VME_Input_G1(p, ushort, 2, 9))\012\012// Format = U8 pair\012#define VME_GET_SICInput_CornerNeighborPixelChroma(p)                          \\\012  (VME_Input_G1(p, ushort, 2, 10))\012\012#if 0\012// Format = U4U4\012#define VME_GET_SICInput_PenaltyIntra4x4NonDC(p) (VME_Input_G1(p, uchar, 2, 28))\012// Format = U2\012#define VME_GET_SICInput_ScaleFactorIntra8x8NonDC(p)                           \\\012  (VME_Input_G1(p, uchar, 2, 29) & 0x3)\012// Form",
"at = U2\012#define VME_GET_SICInput_ScaleFactorIntra16x16NonDC(p)                         \\\012  ((VME_Input_G1(p, uchar, 2, 29) & 0xC) >> 2)\012#else\012// Format = U8\012#define VME_GET_SICInput_PenaltyIntra4x4NonDC(p) (VME_Input_G1(p, uchar, 2, 30))\012// Format = U8\012#define VME_GET_SICInput_PenaltyIntra8x8NonDC(p) (VME_Input_G1(p, uchar, 2, 29))\012// Format = U8\012#define VME_GET_SICInput_PenaltyIntra16x16NonDC(p)                             \\\012  (VME_Input_G1(p, uchar, 2, 28))\012#endif\012\012#define VME_GET_SICInput_NeighborPixelChroma0(p) (VME_Input_G1(p, uchar, 3, 0))\012#define VME_GET_SICInput_NeighborPixelChroma1(p) (VME_Input_G1(p, uchar, 3, 1))\012#define VME_GET_SICInput_NeighborPixelChroma2(p) (VME_Input_G1(p, uchar, 3, 2))\012#define VME_GET_SICInput_NeighborPixelChroma3(p) (VME_Input_G1(p, uchar, 3, 3))\012\012#define VME_GET_SICInput_NeighborPixelChroma4(p) (VME_Input_G1(p, uchar, 3, 4))\012#define VME_GET_SICInput_NeighborPixelChroma5(p) (VME_Input_G1(p, uchar, 3, 5))\012#define VME_GET_SICInput_NeighborPixelChroma6(p) (VME_Input_G1(p, uchar",
", 3, 6))\012#define VME_GET_SICInput_NeighborPixelChroma7(p) (VME_Input_G1(p, uchar, 3, 7))\012\012#define VME_GET_SICInput_NeighborPixelChroma8(p) (VME_Input_G1(p, uchar, 3, 8))\012#define VME_GET_SICInput_NeighborPixelChroma9(p) (VME_Input_G1(p, uchar, 3, 9))\012#define VME_GET_SICInput_NeighborPixelChroma10(p)                              \\\012  (VME_Input_G1(p, uchar, 3, 10))\012#define VME_GET_SICInput_NeighborPixelChroma11(p)                              \\\012  (VME_Input_G1(p, uchar, 3, 11))\012\012#define VME_GET_SICInput_NeighborPixelChroma12(p)                              \\\012  (VME_Input_G1(p, uchar, 3, 12))\012#define VME_GET_SICInput_NeighborPixelChroma13(p)                              \\\012  (VME_Input_G1(p, uchar, 3, 13))\012#define VME_GET_SICInput_NeighborPixelChroma14(p)                              \\\012  (VME_Input_G1(p, uchar, 3, 14))\012#define VME_GET_SICInput_NeighborPixelChroma15(p)                              \\\012  (VME_Input_G1(p, uchar, 3, 15))\012\012#define VME_GET_SICInput_NeighborPixelChroma16(p)                              \\\012 ",
" (VME_Input_G1(p, uchar, 3, 16))\012#define VME_GET_SICInput_NeighborPixelChroma17(p)                              \\\012  (VME_Input_G1(p, uchar, 3, 17))\012#define VME_GET_SICInput_NeighborPixelChroma18(p)                              \\\012  (VME_Input_G1(p, uchar, 3, 18))\012#define VME_GET_SICInput_NeighborPixelChroma19(p)                              \\\012  (VME_Input_G1(p, uchar, 3, 19))\012\012#define VME_GET_SICInput_NeighborPixelChroma20(p)                              \\\012  (VME_Input_G1(p, uchar, 3, 20))\012#define VME_GET_SICInput_NeighborPixelChroma21(p)                              \\\012  (VME_Input_G1(p, uchar, 3, 21))\012#define VME_GET_SICInput_NeighborPixelChroma22(p)                              \\\012  (VME_Input_G1(p, uchar, 3, 22))\012#define VME_GET_SICInput_NeighborPixelChroma23(p)                              \\\012  (VME_Input_G1(p, uchar, 3, 23))\012\012#define VME_GET_SICInput_NeighborPixelChroma24(p)                              \\\012  (VME_Input_G1(p, uchar, 3, 24))\012#define VME_GET_SICInput_NeighborPixelChroma25(p)                    ",
"          \\\012  (VME_Input_G1(p, uchar, 3, 25))\012#define VME_GET_SICInput_NeighborPixelChroma26(p)                              \\\012  (VME_Input_G1(p, uchar, 3, 26))\012#define VME_GET_SICInput_NeighborPixelChroma27(p)                              \\\012  (VME_Input_G1(p, uchar, 3, 27))\012\012#define VME_GET_SICInput_NeighborPixelChroma28(p)                              \\\012  (VME_Input_G1(p, uchar, 3, 28))\012#define VME_GET_SICInput_NeighborPixelChroma29(p)                              \\\012  (VME_Input_G1(p, uchar, 3, 29))\012#define VME_GET_SICInput_NeighborPixelChroma30(p)                              \\\012  (VME_Input_G1(p, uchar, 3, 30))\012#define VME_GET_SICInput_NeighborPixelChroma31(p)                              \\\012  (VME_Input_G1(p, uchar, 3, 31))\012\012#define VME_GET_FBRInput_Ref0SubBlockX0(p) (VME_Input_G1(p, ushort, 0, 0))\012#define VME_GET_FBRInput_Ref0SubBlockY0(p) (VME_Input_G1(p, ushort, 0, 1))\012#define VME_GET_FBRInput_Ref1SubBlockX0(p) (VME_Input_G1(p, ushort, 0, 2))\012#define VME_GET_FBRInput_Ref1SubBlockY0(p) (VME_Input_G1(p, u",
"short, 0, 3))\012\012#define VME_GET_FBRInput_Ref0SubBlockX1(p) (VME_Input_G1(p, ushort, 0, 4))\012#define VME_GET_FBRInput_Ref0SubBlockY1(p) (VME_Input_G1(p, ushort, 0, 5))\012#define VME_GET_FBRInput_Ref1SubBlockX1(p) (VME_Input_G1(p, ushort, 0, 6))\012#define VME_GET_FBRInput_Ref1SubBlockY1(p) (VME_Input_G1(p, ushort, 0, 7))\012\012#define VME_GET_FBRInput_Ref0SubBlockX2(p) (VME_Input_G1(p, ushort, 0, 8))\012#define VME_GET_FBRInput_Ref0SubBlockY2(p) (VME_Input_G1(p, ushort, 0, 9))\012#define VME_GET_FBRInput_Ref1SubBlockX2(p) (VME_Input_G1(p, ushort, 0, 10))\012#define VME_GET_FBRInput_Ref1SubBlockY2(p) (VME_Input_G1(p, ushort, 0, 11))\012\012#define VME_GET_FBRInput_Ref0SubBlockX3(p) (VME_Input_G1(p, ushort, 0, 12))\012#define VME_GET_FBRInput_Ref0SubBlockY3(p) (VME_Input_G1(p, ushort, 0, 13))\012#define VME_GET_FBRInput_Ref1SubBlockX3(p) (VME_Input_G1(p, ushort, 0, 14))\012#define VME_GET_FBRInput_Ref1SubBlockY3(p) (VME_Input_G1(p, ushort, 0, 15))\012\012#define VME_GET_FBRInput_Ref0SubBlockX4(p) (VME_Input_G1(p, ushort, 1, 0))\012#define VME_GET_FBRInput_",
"Ref0SubBlockY4(p) (VME_Input_G1(p, ushort, 1, 1))\012#define VME_GET_FBRInput_Ref1SubBlockX4(p) (VME_Input_G1(p, ushort, 1, 2))\012#define VME_GET_FBRInput_Ref1SubBlockY4(p) (VME_Input_G1(p, ushort, 1, 3))\012\012#define VME_GET_FBRInput_Ref0SubBlockX5(p) (VME_Input_G1(p, ushort, 1, 4))\012#define VME_GET_FBRInput_Ref0SubBlockY5(p) (VME_Input_G1(p, ushort, 1, 5))\012#define VME_GET_FBRInput_Ref1SubBlockX5(p) (VME_Input_G1(p, ushort, 1, 6))\012#define VME_GET_FBRInput_Ref1SubBlockY5(p) (VME_Input_G1(p, ushort, 1, 7))\012\012#define VME_GET_FBRInput_Ref0SubBlockX6(p) (VME_Input_G1(p, ushort, 1, 8))\012#define VME_GET_FBRInput_Ref0SubBlockY6(p) (VME_Input_G1(p, ushort, 1, 9))\012#define VME_GET_FBRInput_Ref1SubBlockX6(p) (VME_Input_G1(p, ushort, 1, 10))\012#define VME_GET_FBRInput_Ref1SubBlockY6(p) (VME_Input_G1(p, ushort, 1, 11))\012\012#define VME_GET_FBRInput_Ref0SubBlockX7(p) (VME_Input_G1(p, ushort, 1, 12))\012#define VME_GET_FBRInput_Ref0SubBlockY7(p) (VME_Input_G1(p, ushort, 1, 13))\012#define VME_GET_FBRInput_Ref1SubBlockX7(p) (VME_Input_G1(p, ushort,",
" 1, 14))\012#define VME_GET_FBRInput_Ref1SubBlockY7(p) (VME_Input_G1(p, ushort, 1, 15))\012\012#define VME_GET_FBRInput_Ref0SubBlockX8(p) (VME_Input_G1(p, ushort, 2, 0))\012#define VME_GET_FBRInput_Ref0SubBlockY8(p) (VME_Input_G1(p, ushort, 2, 1))\012#define VME_GET_FBRInput_Ref1SubBlockX8(p) (VME_Input_G1(p, ushort, 2, 2))\012#define VME_GET_FBRInput_Ref1SubBlockY8(p) (VME_Input_G1(p, ushort, 2, 3))\012\012#define VME_GET_FBRInput_Ref0SubBlockX9(p) (VME_Input_G1(p, ushort, 2, 4))\012#define VME_GET_FBRInput_Ref0SubBlockY9(p) (VME_Input_G1(p, ushort, 2, 5))\012#define VME_GET_FBRInput_Ref1SubBlockX9(p) (VME_Input_G1(p, ushort, 2, 6))\012#define VME_GET_FBRInput_Ref1SubBlockY9(p) (VME_Input_G1(p, ushort, 2, 7))\012\012#define VME_GET_FBRInput_Ref0SubBlockX10(p) (VME_Input_G1(p, ushort, 2, 8))\012#define VME_GET_FBRInput_Ref0SubBlockY10(p) (VME_Input_G1(p, ushort, 2, 9))\012#define VME_GET_FBRInput_Ref1SubBlockX10(p) (VME_Input_G1(p, ushort, 2, 10))\012#define VME_GET_FBRInput_Ref1SubBlockY10(p) (VME_Input_G1(p, ushort, 2, 11))\012\012#define VME_GET_FBRInput_Ref0",
"SubBlockX11(p) (VME_Input_G1(p, ushort, 2, 12))\012#define VME_GET_FBRInput_Ref0SubBlockY11(p) (VME_Input_G1(p, ushort, 2, 13))\012#define VME_GET_FBRInput_Ref1SubBlockX11(p) (VME_Input_G1(p, ushort, 2, 14))\012#define VME_GET_FBRInput_Ref1SubBlockY11(p) (VME_Input_G1(p, ushort, 2, 15))\012\012#define VME_GET_FBRInput_Ref0SubBlockX12(p) (VME_Input_G1(p, ushort, 3, 0))\012#define VME_GET_FBRInput_Ref0SubBlockY12(p) (VME_Input_G1(p, ushort, 3, 1))\012#define VME_GET_FBRInput_Ref1SubBlockX12(p) (VME_Input_G1(p, ushort, 3, 2))\012#define VME_GET_FBRInput_Ref1SubBlockY12(p) (VME_Input_G1(p, ushort, 3, 3))\012\012#define VME_GET_FBRInput_Ref0SubBlockX13(p) (VME_Input_G1(p, ushort, 3, 4))\012#define VME_GET_FBRInput_Ref0SubBlockY13(p) (VME_Input_G1(p, ushort, 3, 5))\012#define VME_GET_FBRInput_Ref1SubBlockX13(p) (VME_Input_G1(p, ushort, 3, 6))\012#define VME_GET_FBRInput_Ref1SubBlockY13(p) (VME_Input_G1(p, ushort, 3, 7))\012\012#define VME_GET_FBRInput_Ref0SubBlockX14(p) (VME_Input_G1(p, ushort, 3, 8))\012#define VME_GET_FBRInput_Ref0SubBlockY14(p) (VME_Input_G1(",
"p, ushort, 3, 9))\012#define VME_GET_FBRInput_Ref1SubBlockX14(p) (VME_Input_G1(p, ushort, 3, 10))\012#define VME_GET_FBRInput_Ref1SubBlockY14(p) (VME_Input_G1(p, ushort, 3, 11))\012\012#define VME_GET_FBRInput_Ref0SubBlockX15(p) (VME_Input_G1(p, ushort, 3, 12))\012#define VME_GET_FBRInput_Ref0SubBlockY15(p) (VME_Input_G1(p, ushort, 3, 13))\012#define VME_GET_FBRInput_Ref1SubBlockX15(p) (VME_Input_G1(p, ushort, 3, 14))\012#define VME_GET_FBRInput_Ref1SubBlockY15(p) (VME_Input_G1(p, ushort, 3, 15))\012\012// Output\012\012#define MODE_INTER_16X16 0x00\012#define MODE_INTER_16X8 0x01\012#define MODE_INTER_8X16 0x02\012#define MODE_INTER_8X8 0x03\012#define MODE_INTER_MINOR 0x03\012#define VME_GET_UNIOutput_InterMbMode(p, v)                                    \\\012  (v = VME_Output_S1(p, uchar, 0, 0) & 0x3)\012\012#define MODE_INTRA_16X16 0x00\012#define MODE_INTRA_8X8 0x10\012#define MODE_INTRA_4X4 0x20\012#define MODE_INTRA_PCM 0x30\012#define VME_GET_UNIOutput_IntraMbMode(p, v)                                    \\\012  (v = VME_Output_S1(p, uchar, 0, 0) & 0x30)\012\012#define MODE_FIELD",
"_MB_POLARITY 0x80\012#define VME_GET_UNIOutput_FieldMbPolarityFlag(p, v)                            \\\012  (v = VME_Output_S1(p, uchar, 0, 0) & 0x80)\012\012#define VME_GET_UNIOutput_InterMbType(p, v)                                    \\\012  (v = VME_Output_S1(p, uchar, 0, 1) & 0x1F)\012\012#define VME_GET_UNIOutput_FieldMbFlag(p, v)                                    \\\012  (v = VME_Output_S1(p, uchar, 0, 1) & 0x40)\012\012#define VME_GET_UNIOutput_IntraMbType(p, v)                                    \\\012  (v = VME_Output_S1(p, uchar, 0, 2) & 0x1F)\012\012#define VME_GET_UNIOutput_IntraMbType(p, v)                                    \\\012  (v = VME_Output_S1(p, uchar, 0, 2) & 0x1F)\012\012#define VME_GET_UNIOutput_MvQuantity(p, v)                                     \\\012  (v = VME_Output_S1(p, uchar, 0, 3) & 0x1F)\012\012// Format = U16\012#define VME_GET_UNIOutput_BestInterDistortion(p, v)                            \\\012  (v = VME_Output_S1(p, ushort, 0, 4))\012\012// Format = U16\012#define VME_GET_UNIOutput_SkipRawDistortion(p, v)                              \\\012  (v = VME",
"_Output_S1(p, ushort, 0, 5))\012\012// Format = U16\012#define VME_GET_UNIOutput_BestIntraDistortion(p, v)                            \\\012  (v = VME_Output_S1(p, ushort, 0, 6))\012\012// Format = U16\012#define VME_GET_UNIOutput_BestChromaIntraDistortion(p, v)                      \\\012  (v = VME_Output_S1(p, ushort, 0, 7))\012\012#define VME_GET_UNIOutput_LumaIntraPredMode0(p, v)                             \\\012  (v = VME_Output_S1(p, ushort, 0, 8))\012#define VME_GET_UNIOutput_LumaIntraPredMode1(p, v)                             \\\012  (v = VME_Output_S1(p, ushort, 0, 9))\012#define VME_GET_UNIOutput_LumaIntraPredMode2(p, v)                             \\\012  (v = VME_Output_S1(p, ushort, 0, 10))\012#define VME_GET_UNIOutput_LumaIntraPredMode3(p, v)                             \\\012  (v = VME_Output_S1(p, ushort, 0, 11))\012\012// 8-bit field with the following definition:\012// 7    Reserved : MBZ (for IntraPredAvailFlagF - F (pixel[-1,7] available for\012// MbAff)\012// 6    Reserved : MBZ (for IntraPredAvailFlagA/E - A (left neighbor top half\012// for MbAff)\012// 5    In",
"traPredAvailFlagE/A - A (Left neighbor or Left bottom half)\012// 4    IntraPredAvailFlagB - B (Upper neighbor)\012// 3    IntraPredAvailFlagC - C (Upper left neighbor)\012// 2    IntraPredAvailFlagD - D (Upper right neighbor)\012// 1:0  ChromaIntraPredMode\012#define VME_GET_UNIOutput_MbIntraStruct(p, v)                                  \\\012  (v = VME_Output_S1(p, uchar, 0, 24))\012\012// 8-bit field with the following definition:\012// Bits [1:0]: SubMbShape[0]\012// Bits [3:2]: SubMbShape[1]\012// Bits [5:4]: SubMbShape[2]\012// Bits [7:6]: SubMbShape[3]\012#define VME_GET_UNIOutput_SubMbShape(p, v) (v = VME_Output_S1(p, uchar, 0, 25))\012\012// 8-bit field with the following definition:\012// Bits [1:0]: SubMbPredMode[0]\012// Bits [3:2]: SubMbPredMode[1]\012// Bits [5:4]: SubMbPredMode[2]\012// Bits [7:6]: SubMbPredMode[3]\012#define VME_GET_UNIOutput_SubMbPredMode(p, v)                                  \\\012  (v = VME_Output_S1(p, uchar, 0, 26))\012\012// v is a 4x16 short type matrix that stores the motion vectors as follows:\012// MVa[0].x, MVa[0].y, MVb[0].x, MVb[0].x\012/",
"/ MVa[1].x, MVa[1].y, MVb[1].x, MVb[1].x\012// ...\012// MVa[15].x, MVa[15].y, MVb[15].x, MVb[15].x\012#define VME_GET_UNIOutput_Mvs(p, v)                                            \\\012  (v = p.format<short, 7, 32 / sizeof(short)>().select<4, 1, 16, 1>(1, 0))\012\012// v is a 1x16 short type matrix that stores the inter distortions as follows:\012// InterDistortion[0], InterDistortion[1], ..., InterDistortion[15]\012#define VME_GET_UNIOutput_InterDistortion(p, v)                                \\\012  (v = p.format<short, 7, 32 / sizeof(short)>().select<1, 1, 16, 1>(5, 0))\012\012// Format = U4\012#define VME_GET_UNIOutput_FwdBlk0RefID(p, v)                                   \\\012  (v = VME_Output_S1(p, uchar, 6, 0) & 0xF)\012#define VME_GET_UNIOutput_BwdBlk0RefID(p, v)                                   \\\012  (v = (VME_Output_S1(p, uchar, 6, 0) >> 4) & 0xF)\012#define VME_GET_UNIOutput_FwdBlk1RefID(p, v)                                   \\\012  (v = VME_Output_S1(p, uchar, 6, 1) & 0xF)\012#define VME_GET_UNIOutput_BwdBlk1RefID(p, v)                            ",
"       \\\012  (v = (VME_Output_S1(p, uchar, 6, 1) >> 4) & 0xF)\012#define VME_GET_UNIOutput_FwdBlk2RefID(p, v)                                   \\\012  (v = VME_Output_S1(p, uchar, 6, 2) & 0xF)\012#define VME_GET_UNIOutput_BwdBlk2RefID(p, v)                                   \\\012  (v = (VME_Output_S1(p, uchar, 6, 2) >> 4) & 0xF)\012#define VME_GET_UNIOutput_FwdBlk3RefID(p, v)                                   \\\012  (v = VME_Output_S1(p, uchar, 6, 3) & 0xF)\012#define VME_GET_UNIOutput_BwdBlk3RefID(p, v)                                   \\\012  (v = (VME_Output_S1(p, uchar, 6, 3) >> 4) & 0xF)\012\012#define VME_GET_UNIOutput_Blk0LumaNZC(p, v) (v = VME_Output_S1(p, uchar, 6, 4))\012#define VME_GET_UNIOutput_Blk1LumaNZC(p, v) (v = VME_Output_S1(p, uchar, 6, 5))\012#define VME_GET_UNIOutput_Blk2LumaNZC(p, v) (v = VME_Output_S1(p, uchar, 6, 6))\012#define VME_GET_UNIOutput_Blk3LumaNZC(p, v) (v = VME_Output_S1(p, uchar, 6, 7))\012\012// Format = U8\012#define VME_GET_UNIOutput_Blk0ChromaCbNZC(p, v)                                \\\012  (v = VME_Output_S1(p, uchar, 6",
", 16))\012#define VME_GET_UNIOutput_Blk0ChromaCrNZC(p, v)                                \\\012  (v = VME_Output_S1(p, uchar, 6, 17))\012\012#define MODE_INTER_16X16 0x00\012#define MODE_INTER_16X8 0x01\012#define MODE_INTER_8X16 0x02\012#define MODE_INTER_8X8 0x03\012#define MODE_INTER_MINOR 0x03\012#define VME_GET_IMEOutput_InterMbMode(p, v)                                    \\\012  (v = VME_Output_S1(p, uchar, 0, 0) & 0x3)\012\012#define MODE_INTRA_16X16 0x00\012#define MODE_INTRA_8X8 0x10\012#define MODE_INTRA_4X4 0x20\012#define MODE_INTRA_PCM 0x30\012#define VME_GET_IMEOutput_IntraMbMode(p, v)                                    \\\012  (v = VME_Output_S1(p, uchar, 0, 0) & 0x30)\012\012#define MODE_FIELD_MB_POLARITY 0x80\012#define VME_GET_IMEOutput_FieldMbPolarityFlag(p, v)                            \\\012  (v = VME_Output_S1(p, uchar, 0, 0) & 0x80)\012\012#define VME_GET_IMEOutput_InterMbType(p, v)                                    \\\012  (v = VME_Output_S1(p, uchar, 0, 1) & 0x1F)\012\012#define VME_GET_IMEOutput_FieldMbFlag(p, v)                                    \\\012  (v = VME_O",
"utput_S1(p, uchar, 0, 1) & 0x40)\012\012#define VME_GET_IMEOutput_IntraMbType(p, v)                                    \\\012  (v = VME_Output_S1(p, uchar, 0, 2) & 0x1F)\012\012#define VME_GET_IMEOutput_IntraMbType(p, v)                                    \\\012  (v = VME_Output_S1(p, uchar, 0, 2) & 0x1F)\012\012#define VME_GET_IMEOutput_MvQuantity(p, v)                                     \\\012  (v = VME_Output_S1(p, uchar, 0, 3) & 0x1F)\012\012// Format = U16\012#define VME_GET_IMEOutput_BestInterDistortion(p, v)                            \\\012  (v = VME_Output_S1(p, ushort, 0, 4))\012\012// Format = U16\012#define VME_GET_IMEOutput_SkipRawDistortion(p, v)                              \\\012  (v = VME_Output_S1(p, ushort, 0, 5))\012\012// Format = U16\012#define VME_GET_IMEOutput_BestIntraDistortion(p, v)                            \\\012  (v = VME_Output_S1(p, ushort, 0, 6))\012\012// Format = U16\012#define VME_GET_IMEOutput_BestChromaIntraDistortion(p, v)                      \\\012  (v = VME_Output_S1(p, ushort, 0, 7))\012\012#define VME_GET_IMEOutput_LumaIntraPredMode0(p, v)           ",
"                  \\\012  (v = VME_Output_S1(p, ushort, 0, 8))\012#define VME_GET_IMEOutput_LumaIntraPredMode1(p, v)                             \\\012  (v = VME_Output_S1(p, ushort, 0, 9))\012#define VME_GET_IMEOutput_LumaIntraPredMode2(p, v)                             \\\012  (v = VME_Output_S1(p, ushort, 0, 10))\012#define VME_GET_IMEOutput_LumaIntraPredMode3(p, v)                             \\\012  (v = VME_Output_S1(p, ushort, 0, 11))\012\012// 8-bit field with the following definition:\012// 7    Reserved : MBZ (for IntraPredAvailFlagF - F (pixel[-1,7] available for\012// MbAff)\012// 6    Reserved : MBZ (for IntraPredAvailFlagA/E - A (left neighbor top half\012// for MbAff)\012// 5    IntraPredAvailFlagE/A - A (Left neighbor or Left bottom half)\012// 4    IntraPredAvailFlagB - B (Upper neighbor)\012// 3    IntraPredAvailFlagC - C (Upper left neighbor)\012// 2    IntraPredAvailFlagD - D (Upper right neighbor)\012// 1:0  ChromaIntraPredMode\012#define VME_GET_IMEOutput_MbIntraStruct(p, v)                                  \\\012  (v = VME_Output_S1(p, uchar, 0, 24))",
"\012\012// 8-bit field with the following definition:\012// Bits [1:0]: SubMbShape[0]\012// Bits [3:2]: SubMbShape[1]\012// Bits [5:4]: SubMbShape[2]\012// Bits [7:6]: SubMbShape[3]\012#define VME_GET_IMEOutput_SubMbShape(p, v) (v = VME_Output_S1(p, uchar, 0, 25))\012\012// 8-bit field with the following definition:\012// Bits [1:0]: SubMbPredMode[0]\012// Bits [3:2]: SubMbPredMode[1]\012// Bits [5:4]: SubMbPredMode[2]\012// Bits [7:6]: SubMbPredMode[3]\012#define VME_GET_IMEOutput_SubMbPredMode(p, v)                                  \\\012  (v = VME_Output_S1(p, uchar, 0, 26))\012\012// v is a 4x16 short type matrix that stores the motion vectors as follows:\012// MVa[0].x, MVa[0].y, MVb[0].x, MVb[0].x\012// MVa[1].x, MVa[1].y, MVb[1].x, MVb[1].x\012// ...\012// MVa[15].x, MVa[15].y, MVb[15].x, MVb[15].x\012#define VME_GET_IMEOutput_Mvs(p, v)                                            \\\012  (v = p.format<short, 7, 32 / sizeof(short)>().select<4, 1, 16, 1>(1, 0))\012\012// v is a 1x16 short type matrix that stores the inter distortions as follows:\012// InterDistortion[0], InterDistort",
"ion[1], ..., InterDistortion[15]\012#define VME_GET_IMEOutput_InterDistortion(p, v)                                \\\012  (v = p.format<short, 7, 32 / sizeof(short)>().select<1, 1, 16, 1>(5, 0))\012\012// Format = U4\012#define VME_GET_IMEOutput_FwdBlk0RefID(p, v)                                   \\\012  (v = VME_Output_S1(p, uchar, 6, 0) & 0xF)\012#define VME_GET_IMEOutput_BwdBlk0RefID(p, v)                                   \\\012  (v = (VME_Output_S1(p, uchar, 6, 0) >> 4) & 0xF)\012#define VME_GET_IMEOutput_FwdBlk1RefID(p, v)                                   \\\012  (v = VME_Output_S1(p, uchar, 6, 1) & 0xF)\012#define VME_GET_IMEOutput_BwdBlk1RefID(p, v)                                   \\\012  (v = (VME_Output_S1(p, uchar, 6, 1) >> 4) & 0xF)\012#define VME_GET_IMEOutput_FwdBlk2RefID(p, v)                                   \\\012  (v = VME_Output_S1(p, uchar, 6, 2) & 0xF)\012#define VME_GET_IMEOutput_BwdBlk2RefID(p, v)                                   \\\012  (v = (VME_Output_S1(p, uchar, 6, 2) >> 4) & 0xF)\012#define VME_GET_IMEOutput_FwdBlk3RefID(p, v)    ",
"                               \\\012  (v = VME_Output_S1(p, uchar, 6, 3) & 0xF)\012#define VME_GET_IMEOutput_BwdBlk3RefID(p, v)                                   \\\012  (v = (VME_Output_S1(p, uchar, 6, 3) >> 4) & 0xF)\012\012#define VME_GET_IMEOutput_Blk0LumaNZC(p, v) (v = VME_Output_S1(p, uchar, 6, 4))\012#define VME_GET_IMEOutput_Blk1LumaNZC(p, v) (v = VME_Output_S1(p, uchar, 6, 5))\012#define VME_GET_IMEOutput_Blk2LumaNZC(p, v) (v = VME_Output_S1(p, uchar, 6, 6))\012#define VME_GET_IMEOutput_Blk3LumaNZC(p, v) (v = VME_Output_S1(p, uchar, 6, 7))\012\012// Format = U8\012#define VME_GET_IMEOutput_Blk0ChromaCbNZC(p, v)                                \\\012  (v = VME_Output_S1(p, uchar, 6, 16))\012#define VME_GET_IMEOutput_Blk0ChromaCrNZC(p, v)                                \\\012  (v = VME_Output_S1(p, uchar, 6, 17))\012\012// Format = U16\012#define VME_GET_IMEOutput_Rec0_16x8_0Distortion(p, v)                          \\\012  (v = VME_Output_S1(p, ushort, 7, 0))\012#define VME_GET_IMEOutput_Rec0_16x8_1Distortion(p, v)                          \\\012  (v = VME_Output_S1",
"(p, ushort, 7, 1))\012#define VME_GET_IMEOutput_Rec0_8x16_0Distortion(p, v)                          \\\012  (v = VME_Output_S1(p, ushort, 7, 2))\012#define VME_GET_IMEOutput_Rec0_8x16_1Distortion(p, v)                          \\\012  (v = VME_Output_S1(p, ushort, 7, 3))\012#define VME_GET_IMEOutput_Rec0_8x8_0Distortion(p, v)                           \\\012  (v = VME_Output_S1(p, ushort, 7, 4))\012#define VME_GET_IMEOutput_Rec0_8x8_1Distortion(p, v)                           \\\012  (v = VME_Output_S1(p, ushort, 7, 5))\012#define VME_GET_IMEOutput_Rec0_8x8_2Distortion(p, v)                           \\\012  (v = VME_Output_S1(p, ushort, 7, 6))\012#define VME_GET_IMEOutput_Rec0_8x8_3Distortion(p, v)                           \\\012  (v = VME_Output_S1(p, ushort, 7, 7))\012#define VME_GET_IMEOutput_Rec0_16x16_Distortion(p, v)                          \\\012  (v = VME_Output_S1(p, ushort, 7, 8))\012\012// Format = U4\012#define VME_GET_IMEOutput_Rec0_16x16_RefID(p, v)                               \\\012  (v = VME_Output_S1(p, uchar, 7, 18))\012\012// Format = U16\012#define VME_",
"GET_IMEOutput_Rec0_16x16_X(p, v)                                   \\\012  (v = VME_Output_S1(p, ushort, 7, 10))\012#define VME_GET_IMEOutput_Rec0_16x16_Y(p, v)                                   \\\012  (v = VME_Output_S1(p, ushort, 7, 11))\012\012// Format = U4\012#define VME_GET_IMEOutput_Rec0_16x8_0RefID(p, v)                               \\\012  (v = VME_Output_S1(p, uchar, 7, 24) & 0xF)\012#define VME_GET_IMEOutput_Rec0_16x8_1RefID(p, v)                               \\\012  (v = (VME_Output_S1(p, uchar, 7, 24) & 0xF0) >> 4)\012#define VME_GET_IMEOutput_Rec0_8x16_0RefID(p, v)                               \\\012  (v = VME_Output_S1(p, uchar, 7, 25) & 0xF)\012#define VME_GET_IMEOutput_Rec0_8x16_1RefID(p, v)                               \\\012  (v = (VME_Output_S1(p, uchar, 7, 25) & 0xF0) >> 4)\012#define VME_GET_IMEOutput_Rec0_8x8_0RefID(p, v)                                \\\012  (v = VME_Output_S1(p, uchar, 7, 26) & 0xF)\012#define VME_GET_IMEOutput_Rec0_8x8_1RefID(p, v)                                \\\012  (v = (VME_Output_S1(p, uchar, 7, 26) & 0xF0) >> 4",
")\012#define VME_GET_IMEOutput_Rec0_8x8_2RefID(p, v)                                \\\012  (v = VME_Output_S1(p, uchar, 7, 27) & 0xF)\012#define VME_GET_IMEOutput_Rec0_8x8_3RefID(p, v)                                \\\012  (v = (VME_Output_S1(p, uchar, 7, 27) & 0xF0) >> 4)\012\012// Format = U16\012#define VME_GET_IMEOutput_Rec0_16x8_0X(p, v)                                   \\\012  (v = VME_Output_S1(p, ushort, 8, 0))\012#define VME_GET_IMEOutput_Rec0_16x8_0Y(p, v)                                   \\\012  (v = VME_Output_S1(p, ushort, 8, 1))\012#define VME_GET_IMEOutput_Rec0_16x8_1X(p, v)                                   \\\012  (v = VME_Output_S1(p, ushort, 8, 2))\012#define VME_GET_IMEOutput_Rec0_16x8_1Y(p, v)                                   \\\012  (v = VME_Output_S1(p, ushort, 8, 3))\012#define VME_GET_IMEOutput_Rec0_8x16_0X(p, v)                                   \\\012  (v = VME_Output_S1(p, ushort, 8, 4))\012#define VME_GET_IMEOutput_Rec0_8x16_0Y(p, v)                                   \\\012  (v = VME_Output_S1(p, ushort, 8, 5))\012#define VME_GET_IMEOutput",
"_Rec0_8x16_1X(p, v)                                   \\\012  (v = VME_Output_S1(p, ushort, 8, 6))\012#define VME_GET_IMEOutput_Rec0_8x16_1Y(p, v)                                   \\\012  (v = VME_Output_S1(p, ushort, 8, 7))\012#define VME_GET_IMEOutput_Rec0_8x8_0X(p, v) (v = VME_Output_S1(p, ushort, 8, 8))\012#define VME_GET_IMEOutput_Rec0_8x8_0Y(p, v) (v = VME_Output_S1(p, ushort, 8, 9))\012#define VME_GET_IMEOutput_Rec0_8x8_1X(p, v)                                    \\\012  (v = VME_Output_S1(p, ushort, 8, 10))\012#define VME_GET_IMEOutput_Rec0_8x8_1Y(p, v)                                    \\\012  (v = VME_Output_S1(p, ushort, 8, 11))\012#define VME_GET_IMEOutput_Rec0_8x8_2X(p, v)                                    \\\012  (v = VME_Output_S1(p, ushort, 8, 12))\012#define VME_GET_IMEOutput_Rec0_8x8_2Y(p, v)                                    \\\012  (v = VME_Output_S1(p, ushort, 8, 13))\012#define VME_GET_IMEOutput_Rec0_8x8_3X(p, v)                                    \\\012  (v = VME_Output_S1(p, ushort, 8, 14))\012#define VME_GET_IMEOutput_Rec0_8x8_3Y(p, v",
")                                    \\\012  (v = VME_Output_S1(p, ushort, 8, 15))\012\012// Format = U16\012#define VME_GET_IMEOutput_Rec1_16x8_0Distortion(p, v)                          \\\012  (v = VME_Output_S1(p, ushort, 9, 0))\012#define VME_GET_IMEOutput_Rec1_16x8_1Distortion(p, v)                          \\\012  (v = VME_Output_S1(p, ushort, 9, 1))\012#define VME_GET_IMEOutput_Rec1_8x16_0Distortion(p, v)                          \\\012  (v = VME_Output_S1(p, ushort, 9, 2))\012#define VME_GET_IMEOutput_Rec1_8x16_1Distortion(p, v)                          \\\012  (v = VME_Output_S1(p, ushort, 9, 3))\012#define VME_GET_IMEOutput_Rec1_8x8_0Distortion(p, v)                           \\\012  (v = VME_Output_S1(p, ushort, 9, 4))\012#define VME_GET_IMEOutput_Rec1_8x8_1Distortion(p, v)                           \\\012  (v = VME_Output_S1(p, ushort, 9, 5))\012#define VME_GET_IMEOutput_Rec1_8x8_2Distortion(p, v)                           \\\012  (v = VME_Output_S1(p, ushort, 9, 6))\012#define VME_GET_IMEOutput_Rec1_8x8_3Distortion(p, v)                           \\\012  (v = ",
"VME_Output_S1(p, ushort, 9, 7))\012#define VME_GET_IMEOutput_Rec1_16x16_Distortion(p, v)                          \\\012  (v = VME_Output_S1(p, ushort, 9, 8))\012\012// Format = U4\012#define VME_GET_IMEOutput_Rec1_16x16_RefID(p, v)                               \\\012  (v = VME_Output_S1(p, uchar, 9, 18))\012\012// Format = U16\012#define VME_GET_IMEOutput_Rec1_16x16_X(p, v)                                   \\\012  (v = VME_Output_S1(p, ushort, 9, 10))\012#define VME_GET_IMEOutput_Rec1_16x16_Y(p, v)                                   \\\012  (v = VME_Output_S1(p, ushort, 9, 11))\012\012// Format = U4\012#define VME_GET_IMEOutput_Rec1_16x8_0RefID(p, v)                               \\\012  (v = VME_Output_S1(p, uchar, 9, 24) & 0xF)\012#define VME_GET_IMEOutput_Rec1_16x8_1RefID(p, v)                               \\\012  (v = (VME_Output_S1(p, uchar, 9, 24) & 0xF0) >> 4)\012#define VME_GET_IMEOutput_Rec1_8x16_0RefID(p, v)                               \\\012  (v = VME_Output_S1(p, uchar, 9, 25) & 0xF)\012#define VME_GET_IMEOutput_Rec1_8x16_1RefID(p, v)                           ",
"    \\\012  (v = (VME_Output_S1(p, uchar, 9, 25) & 0xF0) >> 4)\012#define VME_GET_IMEOutput_Rec1_8x8_0RefID(p, v)                                \\\012  (v = VME_Output_S1(p, uchar, 9, 26) & 0xF)\012#define VME_GET_IMEOutput_Rec1_8x8_1RefID(p, v)                                \\\012  (v = (VME_Output_S1(p, uchar, 9, 26) & 0xF0) >> 4)\012#define VME_GET_IMEOutput_Rec1_8x8_2RefID(p, v)                                \\\012  (v = VME_Output_S1(p, uchar, 9, 27) & 0xF)\012#define VME_GET_IMEOutput_Rec1_8x8_3RefID(p, v)                                \\\012  (v = (VME_Output_S1(p, uchar, 9, 27) & 0xF0) >> 4)\012\012// Format = U16\012#define VME_GET_IMEOutput_Rec1_16x8_0X(p, v)                                   \\\012  (v = VME_Output_S1(p, ushort, 10, 0))\012#define VME_GET_IMEOutput_Rec1_16x8_0Y(p, v)                                   \\\012  (v = VME_Output_S1(p, ushort, 10, 1))\012#define VME_GET_IMEOutput_Rec1_16x8_1X(p, v)                                   \\\012  (v = VME_Output_S1(p, ushort, 10, 2))\012#define VME_GET_IMEOutput_Rec1_16x8_1Y(p, v)                     ",
"              \\\012  (v = VME_Output_S1(p, ushort, 10, 3))\012#define VME_GET_IMEOutput_Rec1_8x16_0X(p, v)                                   \\\012  (v = VME_Output_S1(p, ushort, 10, 4))\012#define VME_GET_IMEOutput_Rec1_8x16_0Y(p, v)                                   \\\012  (v = VME_Output_S1(p, ushort, 10, 5))\012#define VME_GET_IMEOutput_Rec1_8x16_1X(p, v)                                   \\\012  (v = VME_Output_S1(p, ushort, 10, 6))\012#define VME_GET_IMEOutput_Rec1_8x16_1Y(p, v)                                   \\\012  (v = VME_Output_S1(p, ushort, 10, 7))\012#define VME_GET_IMEOutput_Rec1_8x8_0X(p, v)                                    \\\012  (v = VME_Output_S1(p, ushort, 10, 8))\012#define VME_GET_IMEOutput_Rec1_8x8_0Y(p, v)                                    \\\012  (v = VME_Output_S1(p, ushort, 10, 9))\012#define VME_GET_IMEOutput_Rec1_8x8_1X(p, v)                                    \\\012  (v = VME_Output_S1(p, ushort, 10, 10))\012#define VME_GET_IMEOutput_Rec1_8x8_1Y(p, v)                                    \\\012  (v = VME_Output_S1(p, ushort, 10, 11)",
")\012#define VME_GET_IMEOutput_Rec1_8x8_2X(p, v)                                    \\\012  (v = VME_Output_S1(p, ushort, 10, 12))\012#define VME_GET_IMEOutput_Rec1_8x8_2Y(p, v)                                    \\\012  (v = VME_Output_S1(p, ushort, 10, 13))\012#define VME_GET_IMEOutput_Rec1_8x8_3X(p, v)                                    \\\012  (v = VME_Output_S1(p, ushort, 10, 14))\012#define VME_GET_IMEOutput_Rec1_8x8_3Y(p, v)                                    \\\012  (v = VME_Output_S1(p, ushort, 10, 15))\012\012// Run VME APIs\012\012typedef enum _VMEStreamMode_ {\012  VME_STREAM_DISABLE = 0,\012  VME_STREAM_OUT = 1,\012  VME_STREAM_IN = 2,\012  VME_STREAM_IN_OUT = 3\012} VMEStreamMode;\012\012typedef enum _VMESearchCtrl_ {\012  VME_SEARCH_SINGLE_REF_SINGLE_REC_SINGLE_START = 0,\012  VME_SEARCH_SINGLE_REF_SINGLE_REC_DUAL_START = 1,\012  VME_SEARCH_SINGLE_REF_DUAL_REC = 3,\012  VME_SEARCH_DUAL_REF_DUAL_REC = 7\012} VMESearchCtrl;\012\012typedef enum _VMEMsgType_ {\012  VME_SIC_MSG = 0,\012  VME_FBR_MSG = 1,\012  VME_IME_MSG = 2\012} VMEMsgType;\012\012// Set the default values for VME input payload\012\012",
"#define INIT_VME_UNIINPUT(p)                                                   \\\012  { /* M0 */                                                                   \\\012    VME_Input_S1(p, uint, 0, 0) = 0x00000000;                                  \\\012    VME_Input_S1(p, uint, 0, 1) = 0x00000000;                                  \\\012    VME_Input_S1(p, uint, 0, 2) = 0x00000000;                                  \\\012    VME_Input_S1(p, uint, 0, 3) = 0x00A80000;                                  \\\012    VME_Input_S1(p, uint, 0, 4) = 0x00000000;                                  \\\012    VME_Input_S1(p, uint, 0, 5) = 0x00000000;                                  \\\012    VME_Input_S1(p, uint, 0, 6) = 0x00000000;                                  \\\012    VME_Input_S1(p, uint, 0, 7) = 0x00000000;                                  \\\012    /* M1 */                                                                   \\\012    VME_Input_S1(p, uint, 1, 0) = 0x00000000;                                  \\\012    VME_Input_S1(p, uint, 1, 1) = 0x00000008;       ",
"                           \\\012    VME_Input_S1(p, uint, 1, 2) = 0x00000000;                                  \\\012    VME_Input_S1(p, uint, 1, 3) = 0x00000000;                                  \\\012    VME_Input_S1(p, uint, 1, 4) = 0x00000000;                                  \\\012    VME_Input_S1(p, uint, 1, 5) = 0x00000000;                                  \\\012    VME_Input_S1(p, uint, 1, 6) = 0x00000000;                                  \\\012    VME_Input_S1(p, uint, 1, 7) = 0x00400060;                                  \\\012    /* M2 */                                                                   \\\012    VME_Input_S1(p, uint, 2, 0) = 0x00000000;                                  \\\012    VME_Input_S1(p, uint, 2, 1) = 0x00000000;                                  \\\012    VME_Input_S1(p, uint, 2, 2) = 0x00000000;                                  \\\012    VME_Input_S1(p, uint, 2, 3) = 0x00000000;                                  \\\012    VME_Input_S1(p, uint, 2, 4) = 0x00000000;                                  \\\012    VME_Input_S1(p, uin",
"t, 2, 5) = 0x00000000;                                  \\\012    VME_Input_S1(p, uint, 2, 6) = 0x00000000;                                  \\\012    VME_Input_S1(p, uint, 2, 7) = 0x00000000;                                  \\\012  }\012\012#define INIT_VME_IMEINPUT(p)                                                   \\\012  { p = 0; }\012\012#define INIT_VME_SICINPUT(p)                                                   \\\012  { p = 0; }\012\012#define INIT_VME_FBRINPUT(p)                                                   \\\012  { p = 0; }\012\012#define RESET_VME_UNIINPUT(p)                                                  \\\012  { p.format<uint, 3, 8>() = 0; }\012\012#define RESET_VME_IMEINPUT(p, sz)                                              \\\012  { p.format<uint, sz, 8>() = 0; }\012\012#define RESET_VME_SICINPUT(p)                                                  \\\012  { p.format<uint, 4, 8>() = 0; }\012\012#define RESET_VME_FBRINPUT(p)                                                  \\\012  { p.format<uint, 4, 8>() = 0; }\012\012// Structure describes a send message descriptor.",
" Only expose\012// several data fields; others are unnamed.\012// struct MsgDescLayout {\012//  unsigned funcCtrl : 19;     // Function control (bit 0:18)\012//  unsigned headerPresent : 1; // Header present (bit 19)\012//  unsigned rspLength : 5;     // Response length (bit 20:24)\012//  unsigned msgLength : 4;     // Message length (bit 25:28)\012//  unsigned unnamed : 3;       // Unexposed data (bit 29:31)\012//};\012\012static CM_INLINE constexpr unsigned\012getVMEInputSize(unsigned size, VMEStreamMode mode, VMESearchCtrl ctrl) {\012  return (mode != VME_STREAM_IN && mode != VME_STREAM_IN_OUT)\012             \? size + 2\012             : (ctrl == VME_SEARCH_DUAL_REF_DUAL_REC) \? (size + 6) : (size + 4);\012}\012\012template <VMEStreamMode streamMode, VMESearchCtrl searchCtrl, int N1, int N2>\012CM_INLINE void\012_run_vme_ime_impl(matrix<uchar, 3, 32> UNIInput, matrix<uchar, N1, 32> IMEInput,\012                  SurfaceIndex curSurfIndex, vector<short, 2> ref0,\012                  vector<short, 2> ref1, vector<ushort, 4> costCenter,\012                  matrix_ref<uchar",
", N2, 32> IMEOutput) {\012  // HSW: 3; otherwise 4 to invoke below function\012  constexpr unsigned inputSize = getVMEInputSize(3, streamMode, searchCtrl);\012  constexpr unsigned remaining = (inputSize - 3) * 8;\012  matrix<uint, inputSize, 8> src = 0;\012  // mov  (24)    VX(0,0)<1>,  UNIInput\012  src.format<uint>().select<24, 1>(0) =\012      UNIInput.format<uint>().select<24, 1>(0);\012  // mov  (16)   VX(3,0)<1>,  IMEInput\012  src.format<uint>().select<remaining, 1>(24) =\012      IMEInput.format<uint>().select<remaining, 1>(0);\012  // and  (1)     VX(0,13)<1>, VX(0,13):ub, 0xF8\012  src.format<uchar>()(13) &= 0xF8;\012  // or   (1)     VX(0,13)<1>, VX(0,13):ub, searchCtrl\012  src.format<uchar>()(13) |= (unsigned)searchCtrl;\012  // mov  (2)     VA(0,0)<1>,  ref0\012  // since ref0 is converted from UW to UD, move it as 1 UD\012  src(0, 0) = ref0.format<uint>()(0);\012  // mov  (2)     VA(0,2)<1>,  ref1\012  // since ref1 is converted from UW to UD, move it as 1 UD\012  src(0, 1) = ref1.format<uint>()(0);\012  // mov  (4)     VA(1,8)<1>,  costCenter\012  src.select",
"<1, 1, 2, 1>(1, 4) = costCenter.format<uint>().select<2, 1>(0);\012\012  unsigned fCtrl = 0;        // Bit 7-0 of message descriptor\012  fCtrl += 0x2 << 13;        // Bit 14-13 of message descriptor\012  fCtrl += streamMode << 15; // Bit 16-15 of message descriptor\012\012  unsigned rspLength = 288 / 32;\012  if ((streamMode != VME_STREAM_OUT) && (streamMode != VME_STREAM_IN_OUT)) {\012    rspLength = 224 / 32;\012  } else if (searchCtrl == VME_SEARCH_DUAL_REF_DUAL_REC) {\012    rspLength = 352 / 32;\012  }\012\012  // Function control (bit 0:18)\012  // Header present   (bit 19)\012  // Response length  (bit 20:24)\012  // Message length   (bit 25:28)\012  uint Descriptor = (fCtrl & 0x7FFFF) + (1 << 19) + ((rspLength & 0x1f) << 20) +\012                    ((inputSize & 0xF) << 25);\012\012  Descriptor = cm_get_value(curSurfIndex) + Descriptor;\012  /*Implementing VME based on cm_send() for gen7_5\012    template <int N1, int N2>\012    void cm_send(matrix_ref<ushort, N1, 16> IMEOutput, matrix<ushort, inputSize,\012    16>src, uint exDesc, uint msgDesc, uint sendc);*/\012  cm_send",
"(IMEOutput.format<ushort, N2, 16>(),\012          src.format<ushort, inputSize, 16>(), __SFID_VME, Descriptor, 0u);\012}\012\012template <int N1, int N2>\012CM_NODEBUG CM_INLINE void\012run_vme_ime(matrix<uchar, 3, 32> UNIInput, matrix<uchar, N1, 32> IMEInput,\012            VMEStreamMode streamMode, VMESearchCtrl searchCtrl,\012            SurfaceIndex curSurfIndex, vector<short, 2> ref0,\012            vector<short, 2> ref1, vector<ushort, 4> costCenter,\012            matrix_ref<uchar, N2, 32> IMEOutput) {\012#define VME_IME(mode, ctrl)                                                    \\\012  _run_vme_ime_impl<mode, ctrl>(UNIInput, IMEInput, curSurfIndex, ref0, ref1,  \\\012                                costCenter, IMEOutput)\012  if (N1 == 2 && N2 == 7) {\012    if (streamMode == VME_STREAM_DISABLE) {\012      if (searchCtrl == VME_SEARCH_SINGLE_REF_SINGLE_REC_SINGLE_START)\012        VME_IME(VME_STREAM_DISABLE,\012                VME_SEARCH_SINGLE_REF_SINGLE_REC_SINGLE_START);\012      if (searchCtrl == VME_SEARCH_SINGLE_REF_SINGLE_REC_DUAL_START)\012        VM",
"E_IME(VME_STREAM_DISABLE,\012                VME_SEARCH_SINGLE_REF_SINGLE_REC_DUAL_START);\012      if (searchCtrl == VME_SEARCH_SINGLE_REF_DUAL_REC)\012        VME_IME(VME_STREAM_DISABLE, VME_SEARCH_SINGLE_REF_DUAL_REC);\012      if (searchCtrl == VME_SEARCH_DUAL_REF_DUAL_REC)\012        VME_IME(VME_STREAM_DISABLE, VME_SEARCH_DUAL_REF_DUAL_REC);\012    }\012  } else if (N1 == 2 && N2 == 9) {\012    if (streamMode == VME_STREAM_OUT) {\012      // searchCtrl != VME_SEARCH_DUAL_REF_DUAL_REC\012      if (searchCtrl == VME_SEARCH_SINGLE_REF_SINGLE_REC_SINGLE_START)\012        VME_IME(VME_STREAM_OUT, VME_SEARCH_SINGLE_REF_SINGLE_REC_SINGLE_START);\012      if (searchCtrl == VME_SEARCH_SINGLE_REF_SINGLE_REC_DUAL_START)\012        VME_IME(VME_STREAM_OUT, VME_SEARCH_SINGLE_REF_SINGLE_REC_DUAL_START);\012      if (searchCtrl == VME_SEARCH_SINGLE_REF_DUAL_REC)\012        VME_IME(VME_STREAM_OUT, VME_SEARCH_SINGLE_REF_DUAL_REC);\012    }\012  } else if (N1 == 2 && N2 == 11) {\012    if (streamMode == VME_STREAM_OUT &&\012        searchCtrl == VME_SEARCH_DUAL_REF_DUAL_REC) {\012  ",
"    VME_IME(VME_STREAM_OUT, VME_SEARCH_DUAL_REF_DUAL_REC);\012    }\012  } else if (N1 == 4 && N2 == 7) {\012    if (streamMode == VME_STREAM_IN) {\012      // searchCtrl != VME_SEARCH_DUAL_REF_DUAL_REC\012      if (searchCtrl == VME_SEARCH_SINGLE_REF_SINGLE_REC_SINGLE_START)\012        VME_IME(VME_STREAM_IN, VME_SEARCH_SINGLE_REF_SINGLE_REC_SINGLE_START);\012      if (searchCtrl == VME_SEARCH_SINGLE_REF_SINGLE_REC_DUAL_START)\012        VME_IME(VME_STREAM_IN, VME_SEARCH_SINGLE_REF_SINGLE_REC_DUAL_START);\012      if (searchCtrl == VME_SEARCH_SINGLE_REF_DUAL_REC)\012        VME_IME(VME_STREAM_IN, VME_SEARCH_SINGLE_REF_DUAL_REC);\012    }\012  } else if (N1 == 4 && N2 == 9) {\012    if (streamMode == VME_STREAM_IN_OUT) {\012      // searchCtrl != VME_SEARCH_DUAL_REF_DUAL_REC\012      if (searchCtrl == VME_SEARCH_SINGLE_REF_SINGLE_REC_SINGLE_START)\012        VME_IME(VME_STREAM_IN_OUT,\012                VME_SEARCH_SINGLE_REF_SINGLE_REC_SINGLE_START);\012      if (searchCtrl == VME_SEARCH_SINGLE_REF_SINGLE_REC_DUAL_START)\012        VME_IME(VME_STREAM_IN_OUT, VME_SEA",
"RCH_SINGLE_REF_SINGLE_REC_DUAL_START);\012      if (searchCtrl == VME_SEARCH_SINGLE_REF_DUAL_REC)\012        VME_IME(VME_STREAM_IN_OUT, VME_SEARCH_SINGLE_REF_DUAL_REC);\012    }\012  } else if (N1 == 6 && N2 == 7) {\012    if (streamMode == VME_STREAM_IN &&\012        searchCtrl == VME_SEARCH_DUAL_REF_DUAL_REC) {\012      VME_IME(VME_STREAM_IN, VME_SEARCH_DUAL_REF_DUAL_REC);\012    }\012  } else if (N1 == 6 && N2 == 11) {\012    if (streamMode == VME_STREAM_IN_OUT &&\012        searchCtrl == VME_SEARCH_DUAL_REF_DUAL_REC) {\012      VME_IME(VME_STREAM_IN_OUT, VME_SEARCH_DUAL_REF_DUAL_REC);\012    }\012  }\012}\012\012template <typename Dummy = void>\012CM_INLINE void\012run_vme_fbr(matrix<uchar, 3, 32> UNIInput, matrix<uchar, 4, 32> FBRInput,\012            SurfaceIndex curSurfIndex, uchar FBRMbMode, uchar FBRSubMbShape,\012            uchar FBRSubPredMode, matrix_ref<uchar, 7, 32> FBROutput) {\012  matrix<uint, 7, 8> src = 0;\012  // mov(96)    VX(0, 0)<1>, UNIInput\012  src.format<uint>().select<24, 1>(0) =\012      UNIInput.format<uint>().select<24, 1>(0);\012  // mov  (128)   VX(3,0",
")<1>,  FBRInput\012  src.format<uint>().select<32, 1>(24) =\012      FBRInput.format<uint>().select<32, 1>(0);\012  // mov  (1)     VX(2,20)<1>, FBRMbMode\012  src.format<uchar, 7, 32>()(2, 20) = FBRMbMode;\012  // mov  (1)     VX(2,21)<1>, FBRSubMbShape\012  src.format<uchar, 7, 32>()(2, 21) = FBRSubMbShape;\012  //  mov  (1)     VX(2,22)<1>, FBRSubPredMode\012  src.format<uchar, 7, 32>()(2, 22) = FBRSubPredMode;\012\012  unsigned fCtrl = 0x3 << 13;\012  unsigned rspLength = 7;\012  unsigned msglength = 7;\012  uint Descriptor = (fCtrl & 0x7FFFF) + (1 << 19) + ((rspLength & 0x1f) << 20) +\012                    ((msglength & 0xF) << 25);\012\012  Descriptor = cm_get_value(curSurfIndex) + Descriptor;\012  cm_send(FBROutput.format<ushort, 7, 16>(), src.format<ushort, 7, 16>(),\012          __SFID_CRE, Descriptor, 0u);\012}\012\012template <typename Dummy = void>\012CM_INLINE void\012run_vme_sic(matrix<uchar, 3, 32> UNIInput, matrix<uchar, 4, 32> SICInput,\012            SurfaceIndex curSurfIndex, matrix_ref<uchar, 7, 32> UNIOutput) {\012  matrix<uint, 7, 8> src = 0;\012  // mov  (96)   ",
" VX(0,0)<1>,  UNIInput\012  src.format<uint>().select<24, 1>(0) =\012      UNIInput.format<uint>().select<24, 1>(0);\012  // mov  (128)   VX(3,0)<1>,  SICInput\012  src.format<uint>().select<32, 1>(24) =\012      SICInput.format<uint>().select<32, 1>(0);\012  unsigned fCtrl = 0x1 << 13;\012  unsigned rspLength = 7;\012  unsigned msgLength = 7;\012  uint Descriptor = (fCtrl & 0x7FFFF) + (1 << 19) + ((rspLength & 0x1f) << 20) +\012                    ((msgLength & 0xF) << 25);\012\012  Descriptor = cm_get_value(curSurfIndex) + Descriptor;\012  cm_send(UNIOutput.format<ushort, 7, 16>(), src.format<ushort, 7, 16>(),\012          __SFID_CRE, Descriptor, 0u);\012}\012\012#endif /* _CLANG_gen7_5_VME_H_ */\012\000/*========================== begin_copyright_notice ============================\012\012Copyright (C) 2015-2021 Intel Corporation\012\012SPDX-License-Identifier: MIT\012\012============================= end_copyright_notice ===========================*/\012\012#if (__INCLUDE_LEVEL__ == 1)\012static_assert(0, \"CM:w:gen8_vme.h should not be included explicitly - only \"\012                 \"<cm/c",
"m.h> is required\");\012#endif\012\012#ifndef _CLANG_gen8_VME_H_\012#define _CLANG_gen8_VME_H_\012\012#include \"cm_send.h\"\012#include \"cm_util.h\"\012\012#define __SFID_VME 8\012#define __SFID_CRE 13\012\012#define S13_2TOS16(value)                                                      \\\012  (((value >> 2) & 0x1fff) | (((value >> 15) & 0x1) << 15))\012#define S16TOS13_2(value)                                                      \\\012  (((value & 0x1fff) << 2) | (((value >> 15) & 0x1) << 15))\012\012// Select one element from the input payload\012#ifdef VME_Input_S1\012#undef VME_Input_S1\012#endif\012#define VME_Input_S1(p, t, r, c) p.row(r).format<t>().select<1, 1>(c)\012\012#ifdef VME_Input_G1\012#undef VME_Input_G1\012#endif\012#define VME_Input_G1(p, t, r, c) p.row(r).format<t>().select<1, 1>(c)(0)\012\012// Select one element from the output result\012#ifdef VME_Output_S1\012#undef VME_Output_S1\012#endif\012#define VME_Output_S1(p, t, r, c) p.row(r).format<t>().select<1, 1>(c)(0)\012\012// Input\012\012// SET methods\012\012// Format = S15\012#define VME_SET_UNIInput_Ref0X(p, v) (VME_Input_S1(p, ushort, 0, 0) = v)\012#de",
"fine VME_SET_UNIInput_Ref0Y(p, v) (VME_Input_S1(p, ushort, 0, 1) = v)\012\012// Format = S15\012#define VME_SET_UNIInput_Ref1X(p, v) (VME_Input_S1(p, ushort, 0, 2) = v)\012#define VME_SET_UNIInput_Ref1Y(p, v) (VME_Input_S1(p, ushort, 0, 3) = v)\012\012// Format = U16\012#define VME_SET_UNIInput_SrcX(p, v) (VME_Input_S1(p, ushort, 0, 4) = v)\012\012// Format = U16\012#define VME_SET_UNIInput_SrcY(p, v) (VME_Input_S1(p, ushort, 0, 5) = v)\012\012// Set - FieldBased\012// Clear - FrameBased\012#define VME_SET_UNIInput_SrcAccess(p) (VME_Input_S1(p, uchar, 0, 12) |= 0x40)\012#define VME_CLEAR_UNIInput_SrcAccess(p) (VME_Input_S1(p, uchar, 0, 12) &= 0xBF)\012\012// Set - FieldBased\012// Clear - FrameBased\012#define VME_SET_UNIInput_RefAccess(p) (VME_Input_S1(p, uchar, 0, 12) |= 0x80)\012#define VME_CLEAR_UNIInput_RefAccess(p) (VME_Input_S1(p, uchar, 0, 12) &= 0x7F)\012\012// Set - different paths\012// Clear - same path\012#define VME_SET_UNIInput_DualSearchPath(p)                                     \\\012  (VME_Input_S1(p, uchar, 0, 13) |= 0x08)\012#define VME_CLEAR_UNIInput_DualSearchPath",
"(p)                                   \\\012  (VME_Input_S1(p, uchar, 0, 13) &= 0xF7)\012\012// #define INT_MODE 0x0\012// #define HALF_PEL_MODE 0x1\012// #define QUARTER_PEL_MODE 0x3\012#define VME_SET_UNIInput_SubPelMode(p, v)                                      \\\012  (VME_Input_S1(p, uchar, 0, 13) =                                             \\\012       VME_Input_S1(p, uchar, 0, 13) & 0xCF | (v << 4))\012\012// Set - 4MVP\012// Clear - 1MVP\012#define VME_SET_UNIInput_SkipModeType(p) (VME_Input_S1(p, uchar, 0, 13) |= 0x40)\012#define VME_CLEAR_UNIInput_SkipModeType(p)                                     \\\012  (VME_Input_S1(p, uchar, 0, 13) &= 0xBF)\012\012#define VME_SET_UNIInput_DisableFieldCacheAllocation(p)                        \\\012  (VME_Input_S1(p, uchar, 0, 13) |= 0x80)\012#define VME_CLEAR_UNIInput_DisableFieldCacheAllocation(p)                      \\\012  (VME_Input_S1(p, uchar, 0, 13) &= 0x7F)\012\012// Set - Chroma mode\012// Clear - Luma mode\012#define VME_SET_UNIInput_InterChromaMode(p)                                    \\\012  (VME_Input_S1(p, uchar, 0, 14)",
" |= 0x1)\012#define VME_CLEAR_UNIInput_InterChromaMode(p)                                  \\\012  (VME_Input_S1(p, uchar, 0, 14) &= 0xFE)\012\012#define VME_SET_UNIInput_FTEnable(p) (VME_Input_S1(p, uchar, 0, 14) |= 0x2)\012#define VME_CLEAR_UNIInput_FTEnable(p) (VME_Input_S1(p, uchar, 0, 14) &= 0xFD)\012\012#define VME_SET_UNIInput_BMEDisableFBR(p) (VME_Input_S1(p, uchar, 0, 14) |= 0x4)\012#define VME_CLEAR_UNIInput_BMEDisableFBR(p)                                    \\\012  (VME_Input_S1(p, uchar, 0, 14) &= 0xFB)\012\012// v is a 7-bit mask with the following definition:\012// xxxxxx1 : 16x16 sub-macroblock disabled\012// xxxxx1x : 2x(16x8) sub-macroblock within 16x16 disabled\012// xxxx1xx : 2x(8x16) sub-macroblock within 16x16 disabled\012// xxx1xxx : 1x(8x8) sub-partition for 4x(8x8) within 16x16 disabled\012// xx1xxxx : 2x(8x4) sub-partition for 4x(8x8) within 16x16 disabled\012// x1xxxxx : 2x(4x8) sub-partition for 4x(8x8) within 16x16 disabled\012// 1xxxxxx : 4x(4x4) sub-partition for 4x(8x8) within 16x16 disabled\012#define VME_SET_UNIInput_SubMbPartMask(p,",
" v) (VME_Input_S1(p, uchar, 0, 15) = v)\012\012// The value must be a multiple of 4. Range = [20, 64]\012#define VME_SET_UNIInput_RefW(p, v) (VME_Input_S1(p, uchar, 0, 22) = v)\012\012// The value must be a multiple of 4. Range = [20, 64]\012#define VME_SET_UNIInput_RefH(p, v) (VME_Input_S1(p, uchar, 0, 23) = v)\012\012#define VME_SET_UNIInput_SkipModeEn(p) (VME_Input_S1(p, uchar, 1, 0) |= 0x1)\012#define VME_CLEAR_UNIInput_SkipModeEn(p) (VME_Input_S1(p, uchar, 1, 0) &= 0xFE)\012\012#define VME_SET_UNIInput_AdaptiveEn(p) (VME_Input_S1(p, uchar, 1, 0) |= 0x2)\012#define VME_CLEAR_UNIInput_AdaptiveEn(p) (VME_Input_S1(p, uchar, 1, 0) &= 0xFD)\012\012#define VME_SET_UNIInput_EarlyImeSuccessEn(p)                                  \\\012  (VME_Input_S1(p, uchar, 1, 0) |= 0x20)\012#define VME_CLEAR_UNIInput_EarlyImeSuccessEn(p)                                \\\012  (VME_Input_S1(p, uchar, 1, 0) &= 0xDF)\012\012#define VME_SET_UNIInput_T8x8FlagForInterEn(p)                                 \\\012  (VME_Input_S1(p, uchar, 1, 0) |= 0x80)\012#define VME_CLEAR_UNIInput_T8x8FlagForInterE",
"n(p)                               \\\012  (VME_Input_S1(p, uchar, 1, 0) &= 0x7F)\012\012#define VME_SET_UNIInput_EarlyImeStop(p, v) (VME_Input_S1(p, uchar, 1, 3) = v)\012\012#define VME_SET_UNIInput_MaxNumMVs(p, v) (VME_Input_S1(p, uchar, 1, 4) = v)\012\012#define VME_SET_UNIInput_Ref0Polarity(p, v)                                    \\\012  (VME_Input_S1(p, uchar, 1, 5) = VME_Input_S1(p, uchar, 1, 5) & 0xF0 | v)\012#define VME_SET_UNIInput_Ref1Polarity(p, v)                                    \\\012  (VME_Input_S1(p, uchar, 1, 5) =                                              \\\012       VME_Input_S1(p, uchar, 1, 5) & 0x0F | (v << 4))\012\012// Format = U6, Valid Values: [16, 21, 32, 43, 48]\012#define VME_SET_UNIInput_BiWeight(p, v) (VME_Input_S1(p, uchar, 1, 6) = v)\012\012#define VME_SET_UNIInput_RefPixelBiasEnable(p)                                 \\\012  (VME_Input_S1(p, uchar, 1, 7) |= 0x20)\012#define VME_CLEAR_UNIInput_RefPixelBiasEnable(p)                               \\\012  (VME_Input_S1(p, uchar, 1, 7) &= 0xDF)\012\012#define VME_SET_UNIInput_UniMixDisable(p) ",
"(VME_Input_S1(p, uchar, 1, 7) |= 0x10)\012#define VME_CLEAR_UNIInput_UniMixDisable(p)                                    \\\012  (VME_Input_S1(p, uchar, 1, 7) &= 0xEF)\012\012// Format = U8, Valid range [1,63]\012#define VME_SET_UNIInput_LenSP(p, v) (VME_Input_S1(p, uchar, 1, 8) = v)\012\012// Format = U8, Valid range [1,63]\012#define VME_SET_UNIInput_MaxNumSU(p, v) (VME_Input_S1(p, uchar, 1, 9) = v)\012\012// Format = U4\012#define VME_SET_UNIInput_StartCenter0(p, StartCenter0X, StartCenter0Y)         \\\012  (VME_Input_S1(p, uchar, 1, 10) = StartCenter0X | (StartCenter0Y << 4))\012\012// Format = U4\012#define VME_SET_UNIInput_StartCenter1(p, StartCenter1X, StartCenter1Y)         \\\012  (VME_Input_S1(p, uchar, 1, 11) = StartCenter1X | (StartCenter1Y << 4))\012\012// Format = U8\012#define VME_SET_UNIInput_WeightedSADCtrl0_3(p, v)                              \\\012  (VME_Input_S1(p, uchar, 1, 12) = v)\012#define VME_SET_UNIInput_WeightedSADCtrl4_7(p, v)                              \\\012  (VME_Input_S1(p, uchar, 1, 13) = v)\012#define VME_SET_UNIInput_WeightedSADCtrl8_11(p, v)",
"                             \\\012  (VME_Input_S1(p, uchar, 1, 14) = v)\012#define VME_SET_UNIInput_WeightedSADCtrl12_15(p, v)                            \\\012  (VME_Input_S1(p, uchar, 1, 15) = v)\012\012// Format = U4\012#define VME_SET_UNIInput_Blk0RefID(p, FwdBlk0RefID, BwdBlk0RefID)              \\\012  (VME_Input_S1(p, uchar, 1, 24) = FwdBlk0RefID | (BwdBlk0RefID << 4))\012\012// Format = U4\012#define VME_SET_UNIInput_Blk1RefID(p, FwdBlk1RefID, BwdBlk1RefID)              \\\012  (VME_Input_S1(p, uchar, 1, 25) = FwdBlk1RefID | (BwdBlk1RefID << 4))\012\012// Format = U4\012#define VME_SET_UNIInput_Blk2RefID(p, FwdBlk2RefID, BwdBlk2RefID)              \\\012  (VME_Input_S1(p, uchar, 1, 26) = FwdBlk2RefID | (BwdBlk2RefID << 4))\012\012// Format = U4\012#define VME_SET_UNIInput_Blk3RefID(p, FwdBlk3RefID, BwdBlk3RefID)              \\\012  (VME_Input_S1(p, uchar, 1, 27) = FwdBlk3RefID | (BwdBlk3RefID << 4))\012\012#define VME_SET_UNIInput_IntraFlags(p, v) (VME_Input_S1(p, uchar, 1, 28) = v)\012\012// v is a 8-bit mask with the following definition:\012// Bit-7    Reserved : MBZ (for ",
"IntraPredAvailFlagF - F (pixel[-1,7]\012// available\012// for MbAff)\012// Bit-6    Reserved : MBZ (for IntraPredAvailFlagA/E - A (left neighbor top\012// half for MbAff)\012// Bit-5    IntraPredAvailFlagE/A - A (Left neighbor or Left bottom half)\012// Bit-4    IntraPredAvailFlagB - B (Upper neighbor)\012// Bit-3    IntraPredAvailFlagC - C (Upper left neighbor)\012// Bit-2    IntraPredAvailFlagD - D (Upper right neighbor)\012// Bit-1:0  Reserved: MBZ (ChromaIntraPredMode)\012#define VME_SET_UNIInput_MbIntraStruct(p, v) (VME_Input_S1(p, uchar, 1, 29) = v)\012\012// v is a 2-bit value:\012// 00: qpel [Qpel difference between MV and cost center: eff cost range 0-15pel]\012// 01: hpel [Hpel difference between MV and cost center: eff cost range 0-31pel]\012// 10: pel  [Pel  difference between MV and cost center: eff cost range 0-63pel]\012// 11: 2pel [2Pel difference between MV and cost center: eff cost range\012// 0-127pel]\012#define VME_SET_UNIInput_MVCostScaleFactor(p, v)                               \\\012  (VME_Input_S1(p, uchar, 1, 30) = VME_Input_S1(p, uchar, ",
"1, 30) & 0xFC | v)\012\012#define VME_SET_UNIInput_SrcFieldPolarity(p)                                   \\\012  (VME_Input_S1(p, uchar, 1, 30) |= 0x08)\012#define VME_CLEAR_UNIInput_SrcFieldPolarity(p)                                 \\\012  (VME_Input_S1(p, uchar, 1, 30) &= 0xF7)\012\012#define VME_SET_UNIInput_BilinearEnable(p)                                     \\\012  (VME_Input_S1(p, uchar, 1, 30) |= 0x04)\012#define VME_CLEAR_UNIInput_BilinearEnable(p)                                   \\\012  (VME_Input_S1(p, uchar, 1, 30) &= 0xFB)\012\012#define VME_SET_UNIInput_WeightedSADHAAR(p)                                    \\\012  (VME_Input_S1(p, uchar, 1, 30) |= 0x10)\012#define VME_CLEAR_UNIInput_WeightedSADHAAR(p)                                  \\\012  (VME_Input_S1(p, uchar, 1, 30) &= 0xEF)\012\012#define VME_SET_UNIInput_AConlyHAAR(p) (VME_Input_S1(p, uchar, 1, 30) |= 0x20)\012#define VME_CLEAR_UNIInput_AConlyHAAR(p) (VME_Input_S1(p, uchar, 1, 30) &= 0xDF)\012\012#define VME_SET_UNIInput_RefIDCostMode(p)                                      \\\012  (VME_Input_S1(p, uc",
"har, 1, 30) |= 0x40)\012#define VME_CLEAR_UNIInput_RefIDCostMode(p)                                    \\\012  (VME_Input_S1(p, uchar, 1, 30) &= 0xBF)\012\012#define VME_SET_UNIInput_IDMShapeMode(p) (VME_Input_S1(p, uchar, 1, 30) |= 0x80)\012#define VME_CLEAR_UNIInput_IDMShapeMode(p)                                     \\\012  (VME_Input_S1(p, uchar, 1, 30) &= 0x7F)\012\012// v is a 8-bit mask with the following definition:\012// xxxx xxx1: Ref0 Skip Center 0 is enabled [corresponds to M2.0]\012// xxxx xx1x: Ref1 Skip Center 0 is enabled [corresponds to M2.1]\012// xxxx x1xx: Ref0 Skip Center 1 is enabled [corresponds to M2.2]\012// xxxx 1xxx: Ref1 Skip Center 1 is enabled [corresponds to M2.3]\012// xxx1 xxxx: Ref0 Skip Center 2 is enabled [corresponds to M2.4]\012// xx1x xxxx: Ref1 Skip Center 2 is enabled [corresponds to M2.5]\012// x1xx xxxx: Ref0 Skip Center 3 is enabled [corresponds to M2.6]\012// 1xxx xxxx: Ref1 Skip Center 3 is enabled [corresponds to M2.7]\012#define VME_SET_UNIInput_SkipCenterMask(p, v)                                  \\\012  (VME_Input_",
"S1(p, uchar, 1, 31) = v)\012\012// NOTE: replace v with U4U4 type with\012// (shift_count, shift_val) and set the value as (shift_val | (shift_count <<\012// 4))\012\012// Format = U4U4 (encoded value must fit in 12-bits)\012#define VME_SET_UNIInput_Mode0Cost(p, v) (VME_Input_S1(p, uchar, 2, 0) = v)\012#define VME_SET_UNIInput_Mode1Cost(p, v) (VME_Input_S1(p, uchar, 2, 1) = v)\012#define VME_SET_UNIInput_Mode2Cost(p, v) (VME_Input_S1(p, uchar, 2, 2) = v)\012#define VME_SET_UNIInput_Mode3Cost(p, v) (VME_Input_S1(p, uchar, 2, 3) = v)\012#define VME_SET_UNIInput_Mode4Cost(p, v) (VME_Input_S1(p, uchar, 2, 4) = v)\012#define VME_SET_UNIInput_Mode5Cost(p, v) (VME_Input_S1(p, uchar, 2, 5) = v)\012#define VME_SET_UNIInput_Mode6Cost(p, v) (VME_Input_S1(p, uchar, 2, 6) = v)\012#define VME_SET_UNIInput_Mode7Cost(p, v) (VME_Input_S1(p, uchar, 2, 7) = v)\012#define VME_SET_UNIInput_Mode8Cost(p, v) (VME_Input_S1(p, uchar, 2, 8) = v)\012#define VME_SET_UNIInput_Mode9Cost(p, v) (VME_Input_S1(p, uchar, 2, 9) = v)\012\012// Format = U4U4 (encoded value must fit in 12-bits)\012#defin",
"e VME_SET_UNIInput_RefIDCost(p, v) (VME_Input_S1(p, uchar, 2, 10) = v)\012\012// Format = U4U4 (encoded value must fit in 12-bits)\012#define VME_SET_UNIInput_ChromaIntraModeCost(p, v)                             \\\012  (VME_Input_S1(p, uchar, 2, 11) = v)\012\012// Format = U4U4 (encoded value must fit in 10-bits)\012#define VME_SET_UNIInput_MV0Cost(p, v) (VME_Input_S1(p, uchar, 2, 12) = v)\012#define VME_SET_UNIInput_MV1Cost(p, v) (VME_Input_S1(p, uchar, 2, 13) = v)\012#define VME_SET_UNIInput_MV2Cost(p, v) (VME_Input_S1(p, uchar, 2, 14) = v)\012#define VME_SET_UNIInput_MV3Cost(p, v) (VME_Input_S1(p, uchar, 2, 15) = v)\012#define VME_SET_UNIInput_MV4Cost(p, v) (VME_Input_S1(p, uchar, 2, 16) = v)\012#define VME_SET_UNIInput_MV5Cost(p, v) (VME_Input_S1(p, uchar, 2, 17) = v)\012#define VME_SET_UNIInput_MV6Cost(p, v) (VME_Input_S1(p, uchar, 2, 18) = v)\012#define VME_SET_UNIInput_MV7Cost(p, v) (VME_Input_S1(p, uchar, 2, 19) = v)\012\012// Format = U8\012#define VME_SET_UNIInput_FBRMbModeInput(p, v)                                  \\\012  (VME_Input_S1(p, uchar, 2, ",
"20) = v)\012\012// Format = U8\012#define VME_SET_UNIInput_FBRSubMBShapeInput(p, v)                              \\\012  (VME_Input_S1(p, uchar, 2, 21) = v)\012\012// Format = U8\012#define VME_SET_UNIInput_FBRSubPredModeInput(p, v)                             \\\012  (VME_Input_S1(p, uchar, 2, 22) = v)\012\012// Format = U16\012#define VME_SET_UNIInput_SICFwdTCoeffThreshold0(p, v)                          \\\012  (VME_Input_S1(p, ushort, 2, 12) = v)\012// Format = U8\012#define VME_SET_UNIInput_SICFwdTCoeffThreshold1(p, v)                          \\\012  (VME_Input_S1(p, uchar, 2, 26) = v)\012#define VME_SET_UNIInput_SICFwdTCoeffThreshold2(p, v)                          \\\012  (VME_Input_S1(p, uchar, 2, 27) = v)\012#define VME_SET_UNIInput_SICFwdTCoeffThreshold3(p, v)                          \\\012  (VME_Input_S1(p, uchar, 2, 28) = v)\012#define VME_SET_UNIInput_SICFwdTCoeffThreshold4(p, v)                          \\\012  (VME_Input_S1(p, uchar, 2, 29) = v)\012#define VME_SET_UNIInput_SICFwdTCoeffThreshold5(p, v)                          \\\012  (VME_Input_S1(p, uchar, 2, 30) = v",
")\012#define VME_SET_UNIInput_SICFwdTCoeffThreshold6(p, v)                          \\\012  (VME_Input_S1(p, uchar, 2, 31) = v)\012\012// Format = S13.2, DletaX Valid Range: [-2048.00 to 2047.75], DletaY Valid\012// Range: [-512.00 to 511.75]\012#define VME_SET_UNIInput_FWDCostCenter0(p, DeltaX, DeltaY)                     \\\012  (VME_Input_S1(p, uint, 3, 0) = DeltaX | (DeltaY << 16))\012#define VME_SET_UNIInput_BWDCostCenter0(p, DeltaX, DeltaY)                     \\\012  (VME_Input_S1(p, uint, 3, 1) = DeltaX | (DeltaY << 16))\012#define VME_SET_UNIInput_FWDCostCenter1(p, DeltaX, DeltaY)                     \\\012  (VME_Input_S1(p, uint, 3, 2) = DeltaX | (DeltaY << 16))\012#define VME_SET_UNIInput_BWDCostCenter1(p, DeltaX, DeltaY)                     \\\012  (VME_Input_S1(p, uint, 3, 3) = DeltaX | (DeltaY << 16))\012#define VME_SET_UNIInput_FWDCostCenter2(p, DeltaX, DeltaY)                     \\\012  (VME_Input_S1(p, uint, 3, 4) = DeltaX | (DeltaY << 16))\012#define VME_SET_UNIInput_BWDCostCenter2(p, DeltaX, DeltaY)                     \\\012  (VME_Input_S1(p, ui",
"nt, 3, 5) = DeltaX | (DeltaY << 16))\012#define VME_SET_UNIInput_FWDCostCenter3(p, DeltaX, DeltaY)                     \\\012  (VME_Input_S1(p, uint, 3, 6) = DeltaX | (DeltaY << 16))\012#define VME_SET_UNIInput_BWDCostCenter3(p, DeltaX, DeltaY)                     \\\012  (VME_Input_S1(p, uint, 3, 7) = DeltaX | (DeltaY << 16))\012\012// Format = U8, with the following definition:\012// [7:4] (Y) - specifies relative Y distance to the next SU from previous SU in\012// units of SU\012// [3:0] (X) - specifies relative X distance to the next SU from previous SU in\012// units of SU\012// Format = U8, with the following definition:\012// [7:4] (Y) - specifies relative Y distance to the next SU from previous SU in\012// units of SU\012// [3:0] (X) - specifies relative X distance to the next SU from previous SU in\012// units of SU\012#define VME_SET_IMEInput_IMESearchPathDelta0(p, v)                             \\\012  (VME_Input_G1(p, uchar, 0, 0) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta1(p, v)                             \\\012  (VME_Input_G1(p, uchar, 0, 1) = v",
")\012#define VME_SET_IMEInput_IMESearchPathDelta2(p, v)                             \\\012  (VME_Input_G1(p, uchar, 0, 2) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta3(p, v)                             \\\012  (VME_Input_G1(p, uchar, 0, 3) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta4(p, v)                             \\\012  (VME_Input_G1(p, uchar, 0, 4) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta5(p, v)                             \\\012  (VME_Input_G1(p, uchar, 0, 5) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta6(p, v)                             \\\012  (VME_Input_G1(p, uchar, 0, 6) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta7(p, v)                             \\\012  (VME_Input_G1(p, uchar, 0, 7) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta8(p, v)                             \\\012  (VME_Input_G1(p, uchar, 0, 8) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta9(p, v)                             \\\012  (VME_Input_G1(p, uchar, 0, 9) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta10(p, v)                           ",
" \\\012  (VME_Input_G1(p, uchar, 0, 10) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta11(p, v)                            \\\012  (VME_Input_G1(p, uchar, 0, 11) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta12(p, v)                            \\\012  (VME_Input_G1(p, uchar, 0, 12) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta13(p, v)                            \\\012  (VME_Input_G1(p, uchar, 0, 13) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta14(p, v)                            \\\012  (VME_Input_G1(p, uchar, 0, 14) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta15(p, v)                            \\\012  (VME_Input_G1(p, uchar, 0, 15) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta16(p, v)                            \\\012  (VME_Input_G1(p, uchar, 0, 16) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta17(p, v)                            \\\012  (VME_Input_G1(p, uchar, 0, 17) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta18(p, v)                            \\\012  (VME_Input_G1(p, uchar, 0, 18) = v)\012#define VME_SET_IMEInput_IMESea",
"rchPathDelta19(p, v)                            \\\012  (VME_Input_G1(p, uchar, 0, 19) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta20(p, v)                            \\\012  (VME_Input_G1(p, uchar, 0, 20) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta21(p, v)                            \\\012  (VME_Input_G1(p, uchar, 0, 21) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta22(p, v)                            \\\012  (VME_Input_G1(p, uchar, 0, 22) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta23(p, v)                            \\\012  (VME_Input_G1(p, uchar, 0, 23) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta24(p, v)                            \\\012  (VME_Input_G1(p, uchar, 0, 24) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta25(p, v)                            \\\012  (VME_Input_G1(p, uchar, 0, 25) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta26(p, v)                            \\\012  (VME_Input_G1(p, uchar, 0, 26) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta27(p, v)                            \\\012  (VME_Input_G1(p, uch",
"ar, 0, 27) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta28(p, v)                            \\\012  (VME_Input_G1(p, uchar, 0, 28) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta29(p, v)                            \\\012  (VME_Input_G1(p, uchar, 0, 29) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta30(p, v)                            \\\012  (VME_Input_G1(p, uchar, 0, 30) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta31(p, v)                            \\\012  (VME_Input_G1(p, uchar, 0, 31) = v)\012\012#define VME_SET_IMEInput_IMESearchPathDelta32(p, v)                            \\\012  (VME_Input_G1(p, uchar, 1, 0) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta33(p, v)                            \\\012  (VME_Input_G1(p, uchar, 1, 1) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta34(p, v)                            \\\012  (VME_Input_G1(p, uchar, 1, 2) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta35(p, v)                            \\\012  (VME_Input_G1(p, uchar, 1, 3) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta36(p, v)        ",
"                    \\\012  (VME_Input_G1(p, uchar, 1, 4) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta37(p, v)                            \\\012  (VME_Input_G1(p, uchar, 1, 5) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta38(p, v)                            \\\012  (VME_Input_G1(p, uchar, 1, 6) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta39(p, v)                            \\\012  (VME_Input_G1(p, uchar, 1, 7) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta40(p, v)                            \\\012  (VME_Input_G1(p, uchar, 1, 8) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta41(p, v)                            \\\012  (VME_Input_G1(p, uchar, 1, 9) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta42(p, v)                            \\\012  (VME_Input_G1(p, uchar, 1, 10) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta43(p, v)                            \\\012  (VME_Input_G1(p, uchar, 1, 11) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta44(p, v)                            \\\012  (VME_Input_G1(p, uchar, 1, 12) = v)\012#define VME_SET_IM",
"EInput_IMESearchPathDelta45(p, v)                            \\\012  (VME_Input_G1(p, uchar, 1, 13) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta46(p, v)                            \\\012  (VME_Input_G1(p, uchar, 1, 14) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta47(p, v)                            \\\012  (VME_Input_G1(p, uchar, 1, 15) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta48(p, v)                            \\\012  (VME_Input_G1(p, uchar, 1, 16) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta49(p, v)                            \\\012  (VME_Input_G1(p, uchar, 1, 17) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta50(p, v)                            \\\012  (VME_Input_G1(p, uchar, 1, 18) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta51(p, v)                            \\\012  (VME_Input_G1(p, uchar, 1, 19) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta52(p, v)                            \\\012  (VME_Input_G1(p, uchar, 1, 20) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta53(p, v)                            \\\012  (VME_In",
"put_G1(p, uchar, 1, 21) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta54(p, v)                            \\\012  (VME_Input_G1(p, uchar, 1, 22) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta55(p, v)                            \\\012  (VME_Input_G1(p, uchar, 1, 23) = v)\012\012// Format = U16\012#define VME_SET_IMEInput_Rec0_16x8_0Distortion(p, v)                           \\\012  (VME_Input_S1(p, ushort, 2, 0) = v)\012#define VME_SET_IMEInput_Rec0_16x8_1Distortion(p, v)                           \\\012  (VME_Input_S1(p, ushort, 2, 1) = v)\012#define VME_SET_IMEInput_Rec0_8x16_0Distortion(p, v)                           \\\012  (VME_Input_S1(p, ushort, 2, 2) = v)\012#define VME_SET_IMEInput_Rec0_8x16_1Distortion(p, v)                           \\\012  (VME_Input_S1(p, ushort, 2, 3) = v)\012#define VME_SET_IMEInput_Rec0_8x8_0Distortion(p, v)                            \\\012  (VME_Input_S1(p, ushort, 2, 4) = v)\012#define VME_SET_IMEInput_Rec0_8x8_1Distortion(p, v)                            \\\012  (VME_Input_S1(p, ushort, 2, 5) = v)\012#define VME_SET_IMEInput_R",
"ec0_8x8_2Distortion(p, v)                            \\\012  (VME_Input_S1(p, ushort, 2, 6) = v)\012#define VME_SET_IMEInput_Rec0_8x8_3Distortion(p, v)                            \\\012  (VME_Input_S1(p, ushort, 2, 7) = v)\012#define VME_SET_IMEInput_Rec0_16x16_Distortion(p, v)                           \\\012  (VME_Input_S1(p, ushort, 2, 8) = v)\012\012// Format = U4\012#define VME_SET_IMEInput_Rec0_16x16_RefID(p, v)                                \\\012  (VME_Input_S1(p, uchar, 2, 18) = v)\012\012// Format = S13.2\012#define VME_SET_IMEInput_Rec0_16x16_X(p, v) (VME_Input_S1(p, ushort, 2, 10) = v)\012#define VME_SET_IMEInput_Rec0_16x16_Y(p, v) (VME_Input_S1(p, ushort, 2, 11) = v)\012\012// Format = U4\012#define VME_SET_IMEInput_Rec0_16x8_0RefID(p, v)                                \\\012  (VME_Input_S1(p, uchar, 2, 24) = VME_Input_S1(p, uchar, 2, 24) & 0xF0 | v)\012#define VME_SET_IMEInput_Rec0_16x8_1RefID(p, v)                                \\\012  (VME_Input_S1(p, uchar, 2, 24) =                                             \\\012       VME_Input_S1(p, uchar, 2, 24) & 0x",
"0F | (v << 4))\012#define VME_SET_IMEInput_Rec0_8x16_0RefID(p, v)                                \\\012  (VME_Input_S1(p, uchar, 2, 25) = VME_Input_S1(p, uchar, 2, 25) & 0xF0 | v)\012#define VME_SET_IMEInput_Rec0_8x16_1RefID(p, v)                                \\\012  (VME_Input_S1(p, uchar, 2, 25) =                                             \\\012       VME_Input_S1(p, uchar, 2, 25) & 0x0F | (v << 4))\012#define VME_SET_IMEInput_Rec0_8x8_0RefID(p, v)                                 \\\012  (VME_Input_S1(p, uchar, 2, 26) = VME_Input_S1(p, uchar, 2, 26) & 0xF0 | v)\012#define VME_SET_IMEInput_Rec0_8x8_1RefID(p, v)                                 \\\012  (VME_Input_S1(p, uchar, 2, 26) =                                             \\\012       VME_Input_S1(p, uchar, 2, 26) & 0x0F | (v << 4))\012#define VME_SET_IMEInput_Rec0_8x8_2RefID(p, v)                                 \\\012  (VME_Input_S1(p, uchar, 2, 27) = VME_Input_S1(p, uchar, 2, 27) & 0xF0 | v)\012#define VME_SET_IMEInput_Rec0_8x8_3RefID(p, v)                                 \\\012  (VME_Input_S1(p,",
" uchar, 2, 27) =                                             \\\012       VME_Input_S1(p, uchar, 2, 27) & 0x0F | (v << 4))\012\012// Format = S13.2\012#define VME_SET_IMEInput_Rec0_16x8_0X(p, v) (VME_Input_S1(p, ushort, 3, 0) = v)\012#define VME_SET_IMEInput_Rec0_16x8_0Y(p, v) (VME_Input_S1(p, ushort, 3, 1) = v)\012#define VME_SET_IMEInput_Rec0_16x8_1X(p, v) (VME_Input_S1(p, ushort, 3, 2) = v)\012#define VME_SET_IMEInput_Rec0_16x8_1Y(p, v) (VME_Input_S1(p, ushort, 3, 3) = v)\012#define VME_SET_IMEInput_Rec0_8x16_0X(p, v) (VME_Input_S1(p, ushort, 3, 4) = v)\012#define VME_SET_IMEInput_Rec0_8x16_0Y(p, v) (VME_Input_S1(p, ushort, 3, 5) = v)\012#define VME_SET_IMEInput_Rec0_8x16_1X(p, v) (VME_Input_S1(p, ushort, 3, 6) = v)\012#define VME_SET_IMEInput_Rec0_8x16_1Y(p, v) (VME_Input_S1(p, ushort, 3, 7) = v)\012#define VME_SET_IMEInput_Rec0_8x8_0X(p, v) (VME_Input_S1(p, ushort, 3, 8) = v)\012#define VME_SET_IMEInput_Rec0_8x8_0Y(p, v) (VME_Input_S1(p, ushort, 3, 9) = v)\012#define VME_SET_IMEInput_Rec0_8x8_1X(p, v) (VME_Input_S1(p, ushort, 3, 10) = v)\012#define ",
"VME_SET_IMEInput_Rec0_8x8_1Y(p, v) (VME_Input_S1(p, ushort, 3, 11) = v)\012#define VME_SET_IMEInput_Rec0_8x8_2X(p, v) (VME_Input_S1(p, ushort, 3, 12) = v)\012#define VME_SET_IMEInput_Rec0_8x8_2Y(p, v) (VME_Input_S1(p, ushort, 3, 13) = v)\012#define VME_SET_IMEInput_Rec0_8x8_3X(p, v) (VME_Input_S1(p, ushort, 3, 14) = v)\012#define VME_SET_IMEInput_Rec0_8x8_3Y(p, v) (VME_Input_S1(p, ushort, 3, 15) = v)\012\012// Format = U16\012#define VME_SET_IMEInput_Rec1_16x8_0Distortion(p, v)                           \\\012  (VME_Input_S1(p, ushort, 4, 0) = v)\012#define VME_SET_IMEInput_Rec1_16x8_1Distortion(p, v)                           \\\012  (VME_Input_S1(p, ushort, 4, 1) = v)\012#define VME_SET_IMEInput_Rec1_8x16_0Distortion(p, v)                           \\\012  (VME_Input_S1(p, ushort, 4, 2) = v)\012#define VME_SET_IMEInput_Rec1_8x16_1Distortion(p, v)                           \\\012  (VME_Input_S1(p, ushort, 4, 3) = v)\012#define VME_SET_IMEInput_Rec1_8x8_0Distortion(p, v)                            \\\012  (VME_Input_S1(p, ushort, 4, 4) = v)\012#define VME_SET_IMEI",
"nput_Rec1_8x8_1Distortion(p, v)                            \\\012  (VME_Input_S1(p, ushort, 4, 5) = v)\012#define VME_SET_IMEInput_Rec1_8x8_2Distortion(p, v)                            \\\012  (VME_Input_S1(p, ushort, 4, 6) = v)\012#define VME_SET_IMEInput_Rec1_8x8_3Distortion(p, v)                            \\\012  (VME_Input_S1(p, ushort, 4, 7) = v)\012#define VME_SET_IMEInput_Rec1_16x16_Distortion(p, v)                           \\\012  (VME_Input_S1(p, ushort, 4, 8) = v)\012\012// Format = U4\012#define VME_SET_IMEInput_Rec1_16x16_RefID(p, v)                                \\\012  (VME_Input_S1(p, uchar, 4, 18) = v)\012\012// Format = S13.2\012#define VME_SET_IMEInput_Rec1_16x16_X(p, v) (VME_Input_S1(p, ushort, 4, 10) = v)\012#define VME_SET_IMEInput_Rec1_16x16_Y(p, v) (VME_Input_S1(p, ushort, 4, 11) = v)\012\012// Format = U4\012#define VME_SET_IMEInput_Rec1_16x8_0RefID(p, v)                                \\\012  (VME_Input_S1(p, uchar, 4, 24) = VME_Input_S1(p, uchar, 4, 24) & 0xF0 | v)\012#define VME_SET_IMEInput_Rec1_16x8_1RefID(p, v)                               ",
" \\\012  (VME_Input_S1(p, uchar, 4, 24) =                                             \\\012       VME_Input_S1(p, uchar, 4, 24) & 0x0F | (v << 4))\012#define VME_SET_IMEInput_Rec1_8x16_0RefID(p, v)                                \\\012  (VME_Input_S1(p, uchar, 4, 25) = VME_Input_S1(p, uchar, 4, 25) & 0xF0 | v)\012#define VME_SET_IMEInput_Rec1_8x16_1RefID(p, v)                                \\\012  (VME_Input_S1(p, uchar, 4, 25) =                                             \\\012       VME_Input_S1(p, uchar, 4, 25) & 0x0F | (v << 4))\012#define VME_SET_IMEInput_Rec1_8x8_0RefID(p, v)                                 \\\012  (VME_Input_S1(p, uchar, 4, 26) = VME_Input_S1(p, uchar, 4, 26) & 0xF0 | v)\012#define VME_SET_IMEInput_Rec1_8x8_1RefID(p, v)                                 \\\012  (VME_Input_S1(p, uchar, 4, 26) =                                             \\\012       VME_Input_S1(p, uchar, 4, 26) & 0x0F | (v << 4))\012#define VME_SET_IMEInput_Rec1_8x8_2RefID(p, v)                                 \\\012  (VME_Input_S1(p, uchar, 4, 27) = VME_Input_S1(p, ",
"uchar, 4, 27) & 0xF0 | v)\012#define VME_SET_IMEInput_Rec1_8x8_3RefID(p, v)                                 \\\012  (VME_Input_S1(p, uchar, 4, 27) =                                             \\\012       VME_Input_S1(p, uchar, 4, 27) & 0x0F | (v << 4))\012\012// Format = S13.2\012#define VME_SET_IMEInput_Rec1_16x8_0X(p, v) (VME_Input_S1(p, ushort, 5, 0) = v)\012#define VME_SET_IMEInput_Rec1_16x8_0Y(p, v) (VME_Input_S1(p, ushort, 5, 1) = v)\012#define VME_SET_IMEInput_Rec1_16x8_1X(p, v) (VME_Input_S1(p, ushort, 5, 2) = v)\012#define VME_SET_IMEInput_Rec1_16x8_1Y(p, v) (VME_Input_S1(p, ushort, 5, 3) = v)\012#define VME_SET_IMEInput_Rec1_8x16_0X(p, v) (VME_Input_S1(p, ushort, 5, 4) = v)\012#define VME_SET_IMEInput_Rec1_8x16_0Y(p, v) (VME_Input_S1(p, ushort, 5, 5) = v)\012#define VME_SET_IMEInput_Rec1_8x16_1X(p, v) (VME_Input_S1(p, ushort, 5, 6) = v)\012#define VME_SET_IMEInput_Rec1_8x16_1Y(p, v) (VME_Input_S1(p, ushort, 5, 7) = v)\012#define VME_SET_IMEInput_Rec1_8x8_0X(p, v) (VME_Input_S1(p, ushort, 5, 8) = v)\012#define VME_SET_IMEInput_Rec1_8x8_0Y(p, v)",
" (VME_Input_S1(p, ushort, 5, 9) = v)\012#define VME_SET_IMEInput_Rec1_8x8_1X(p, v) (VME_Input_S1(p, ushort, 5, 10) = v)\012#define VME_SET_IMEInput_Rec1_8x8_1Y(p, v) (VME_Input_S1(p, ushort, 5, 11) = v)\012#define VME_SET_IMEInput_Rec1_8x8_2X(p, v) (VME_Input_S1(p, ushort, 5, 12) = v)\012#define VME_SET_IMEInput_Rec1_8x8_2Y(p, v) (VME_Input_S1(p, ushort, 5, 13) = v)\012#define VME_SET_IMEInput_Rec1_8x8_3X(p, v) (VME_Input_S1(p, ushort, 5, 14) = v)\012#define VME_SET_IMEInput_Rec1_8x8_3Y(p, v) (VME_Input_S1(p, ushort, 5, 15) = v)\012\012// Format = S13.2, Valid Range: [-2048.00 to 2047.75]\012// For chroma skip: Format = S12.3, Hardware Range: [-1024.000 to 1023.875]\012#define VME_SET_SICInput_Ref0SkipCenter0DeltaXY(p, DeltaX, DeltaY)             \\\012  (VME_Input_S1(p, uint, 0, 0) = DeltaX | (DeltaY << 16))\012#define VME_SET_SICInput_Ref1SkipCenter0DeltaXY(p, DeltaX, DeltaY)             \\\012  (VME_Input_S1(p, uint, 0, 1) = DeltaX | (DeltaY << 16))\012#define VME_SET_SICInput_Ref0SkipCenter1DeltaXY(p, DeltaX, DeltaY)             \\\012  (VME_Input_S1(p",
", uint, 0, 2) = DeltaX | (DeltaY << 16))\012#define VME_SET_SICInput_Ref1SkipCenter1DeltaXY(p, DeltaX, DeltaY)             \\\012  (VME_Input_S1(p, uint, 0, 3) = DeltaX | (DeltaY << 16))\012#define VME_SET_SICInput_Ref0SkipCenter2DeltaXY(p, DeltaX, DeltaY)             \\\012  (VME_Input_S1(p, uint, 0, 4) = DeltaX | (DeltaY << 16))\012#define VME_SET_SICInput_Ref1SkipCenter2DeltaXY(p, DeltaX, DeltaY)             \\\012  (VME_Input_S1(p, uint, 0, 5) = DeltaX | (DeltaY << 16))\012#define VME_SET_SICInput_Ref0SkipCenter3DeltaXY(p, DeltaX, DeltaY)             \\\012  (VME_Input_S1(p, uint, 0, 6) = DeltaX | (DeltaY << 16))\012#define VME_SET_SICInput_Ref1SkipCenter3DeltaXY(p, DeltaX, DeltaY)             \\\012  (VME_Input_S1(p, uint, 0, 7) = DeltaX | (DeltaY << 16))\012\012// 2-bit field with the following definition\012// 00: Luma + Chroma enabled\012// 01: Luma only\012// 1X: Intra disabled\012#define VME_SET_SICInput_IntraComputeType(p, v)                                \\\012  (VME_Input_S1(p, uchar, 1, 5) = v)\012\012#define VME_SET_SICInput_CornerNeighborPixel0(p, v)    ",
"                        \\\012  (VME_Input_S1(p, uchar, 1, 7) = v)\012\012// NOTE: combine into one vector assignment\012#define VME_SET_SICInput_NeighborPixelLum0(p, v)                               \\\012  (VME_Input_S1(p, uchar, 1, 8) = v)\012#define VME_SET_SICInput_NeighborPixelLum1(p, v)                               \\\012  (VME_Input_S1(p, uchar, 1, 9) = v)\012#define VME_SET_SICInput_NeighborPixelLum2(p, v)                               \\\012  (VME_Input_S1(p, uchar, 1, 10) = v)\012#define VME_SET_SICInput_NeighborPixelLum3(p, v)                               \\\012  (VME_Input_S1(p, uchar, 1, 11) = v)\012#define VME_SET_SICInput_NeighborPixelLum4(p, v)                               \\\012  (VME_Input_S1(p, uchar, 1, 12) = v)\012#define VME_SET_SICInput_NeighborPixelLum5(p, v)                               \\\012  (VME_Input_S1(p, uchar, 1, 13) = v)\012#define VME_SET_SICInput_NeighborPixelLum6(p, v)                               \\\012  (VME_Input_S1(p, uchar, 1, 14) = v)\012#define VME_SET_SICInput_NeighborPixelLum7(p, v)                               \\\012  (V",
"ME_Input_S1(p, uchar, 1, 15) = v)\012#define VME_SET_SICInput_NeighborPixelLum8(p, v)                               \\\012  (VME_Input_S1(p, uchar, 1, 16) = v)\012#define VME_SET_SICInput_NeighborPixelLum9(p, v)                               \\\012  (VME_Input_S1(p, uchar, 1, 17) = v)\012#define VME_SET_SICInput_NeighborPixelLum10(p, v)                              \\\012  (VME_Input_S1(p, uchar, 1, 18) = v)\012#define VME_SET_SICInput_NeighborPixelLum11(p, v)                              \\\012  (VME_Input_S1(p, uchar, 1, 19) = v)\012#define VME_SET_SICInput_NeighborPixelLum12(p, v)                              \\\012  (VME_Input_S1(p, uchar, 1, 20) = v)\012#define VME_SET_SICInput_NeighborPixelLum13(p, v)                              \\\012  (VME_Input_S1(p, uchar, 1, 21) = v)\012#define VME_SET_SICInput_NeighborPixelLum14(p, v)                              \\\012  (VME_Input_S1(p, uchar, 1, 22) = v)\012#define VME_SET_SICInput_NeighborPixelLum15(p, v)                              \\\012  (VME_Input_S1(p, uchar, 1, 23) = v)\012#define VME_SET_SICInput_NeighborPixel",
"Lum16(p, v)                              \\\012  (VME_Input_S1(p, uchar, 1, 24) = v)\012#define VME_SET_SICInput_NeighborPixelLum17(p, v)                              \\\012  (VME_Input_S1(p, uchar, 1, 25) = v)\012#define VME_SET_SICInput_NeighborPixelLum18(p, v)                              \\\012  (VME_Input_S1(p, uchar, 1, 26) = v)\012#define VME_SET_SICInput_NeighborPixelLum19(p, v)                              \\\012  (VME_Input_S1(p, uchar, 1, 27) = v)\012#define VME_SET_SICInput_NeighborPixelLum20(p, v)                              \\\012  (VME_Input_S1(p, uchar, 1, 28) = v)\012#define VME_SET_SICInput_NeighborPixelLum21(p, v)                              \\\012  (VME_Input_S1(p, uchar, 1, 29) = v)\012#define VME_SET_SICInput_NeighborPixelLum22(p, v)                              \\\012  (VME_Input_S1(p, uchar, 1, 30) = v)\012#define VME_SET_SICInput_NeighborPixelLum23(p, v)                              \\\012  (VME_Input_S1(p, uchar, 1, 31) = v)\012#define VME_SET_SICInput_NeighborPixelLum24(p, v)                              \\\012  (VME_Input_S1(p, uchar, 2, ",
"0) = v)\012#define VME_SET_SICInput_NeighborPixelLum25(p, v)                              \\\012  (VME_Input_S1(p, uchar, 2, 1) = v)\012#define VME_SET_SICInput_NeighborPixelLum26(p, v)                              \\\012  (VME_Input_S1(p, uchar, 2, 2) = v)\012#define VME_SET_SICInput_NeighborPixelLum27(p, v)                              \\\012  (VME_Input_S1(p, uchar, 2, 3) = v)\012#define VME_SET_SICInput_NeighborPixelLum28(p, v)                              \\\012  (VME_Input_S1(p, uchar, 2, 4) = v)\012#define VME_SET_SICInput_NeighborPixelLum29(p, v)                              \\\012  (VME_Input_S1(p, uchar, 2, 5) = v)\012#define VME_SET_SICInput_NeighborPixelLum30(p, v)                              \\\012  (VME_Input_S1(p, uchar, 2, 6) = v)\012#define VME_SET_SICInput_NeighborPixelLum31(p, v)                              \\\012  (VME_Input_S1(p, uchar, 2, 7) = v)\012#define VME_SET_SICInput_NeighborPixelLum32(p, v)                              \\\012  (VME_Input_S1(p, uchar, 2, 8) = v)\012#define VME_SET_SICInput_NeighborPixelLum33(p, v)                       ",
"       \\\012  (VME_Input_S1(p, uchar, 2, 9) = v)\012#define VME_SET_SICInput_NeighborPixelLum34(p, v)                              \\\012  (VME_Input_S1(p, uchar, 2, 10) = v)\012#define VME_SET_SICInput_NeighborPixelLum35(p, v)                              \\\012  (VME_Input_S1(p, uchar, 2, 11) = v)\012#define VME_SET_SICInput_NeighborPixelLum36(p, v)                              \\\012  (VME_Input_S1(p, uchar, 2, 12) = v)\012#define VME_SET_SICInput_NeighborPixelLum37(p, v)                              \\\012  (VME_Input_S1(p, uchar, 2, 13) = v)\012#define VME_SET_SICInput_NeighborPixelLum38(p, v)                              \\\012  (VME_Input_S1(p, uchar, 2, 14) = v)\012\012#define VME_SET_SICInput_CornerNeighborPixel1(p, v)                            \\\012  (VME_Input_S1(p, uchar, 2, 15) = v)\012\012// Format = U4\012#define VME_SET_SICInput_IntraMxMPredModeA5(p, v)                              \\\012  (VME_Input_S1(p, uchar, 2, 16) = VME_Input_S1(p, uchar, 2, 16) & 0xF0 | v)\012#define VME_SET_SICInput_IntraMxMPredModeA7(p, v)                              \\\012  (VME_I",
"nput_S1(p, uchar, 2, 16) =                                             \\\012       VME_Input_S1(p, uchar, 2, 16) & 0x0F | (v << 4))\012#define VME_SET_SICInput_IntraMxMPredModeA13(p, v)                             \\\012  (VME_Input_S1(p, uchar, 2, 17) = VME_Input_S1(p, uchar, 2, 17) & 0xF0 | v)\012#define VME_SET_SICInput_IntraMxMPredModeA15(p, v)                             \\\012  (VME_Input_S1(p, uchar, 2, 17) =                                             \\\012       VME_Input_S1(p, uchar, 2, 17) & 0x0F | (v << 4))\012#define VME_SET_SICInput_IntraMxMPredModeB10(p, v)                             \\\012  (VME_Input_S1(p, uchar, 2, 18) = VME_Input_S1(p, uchar, 2, 18) & 0xF0 | v)\012#define VME_SET_SICInput_IntraMxMPredModeB11(p, v)                             \\\012  (VME_Input_S1(p, uchar, 2, 18) =                                             \\\012       VME_Input_S1(p, uchar, 2, 18) & 0x0F | (v << 4))\012#define VME_SET_SICInput_IntraMxMPredModeB14(p, v)                             \\\012  (VME_Input_S1(p, uchar, 2, 19) = VME_Input_S1(p, uchar, 2, 1",
"9) & 0xF0 | v)\012#define VME_SET_SICInput_IntraMxMPredModeB15(p, v)                             \\\012  (VME_Input_S1(p, uchar, 2, 19) =                                             \\\012       VME_Input_S1(p, uchar, 2, 19) & 0x0F | (v << 4))\012\012// Format = U8 pair\012#define VME_SET_SICInput_CornerNeighborPixelChroma(p, v)                       \\\012  (VME_Input_S1(p, ushort, 2, 10) = v)\012\012#if 0\012// Format = U4U4\012#define VME_SET_SICInput_PenaltyIntra4x4NonDC(p, v)                            \\\012  (VME_Input_S1(p, uchar, 2, 28) = v)\012// Format = U2\012#define VME_SET_SICInput_ScaleFactorIntra8x8NonDC(p, v)                        \\\012  (VME_Input_S1(p, uchar, 2, 29) = VME_Input_S1(p, uchar, 2, 29) & 0xFC | v)\012// Format = U2\012#define VME_SET_SICInput_ScaleFactorIntra16x16NonDC(p, v)                      \\\012  (VME_Input_S1(p, uchar, 2, 29) =                                             \\\012       VME_Input_S1(p, uchar, 2, 29) & 0xF3 | (v << 2))\012#else\012// Format = U8\012#define VME_SET_SICInput_PenaltyIntra4x4NonDC(p, v)                            \\",
"\012  (VME_Input_G1(p, uchar, 2, 30) = v)\012// Format = U8\012#define VME_SET_SICInput_PenaltyIntra8x8NonDC(p, v)                            \\\012  (VME_Input_G1(p, uchar, 2, 29) = v)\012// Format = U8\012#define VME_SET_SICInput_PenaltyIntra16x16NonDC(p, v)                          \\\012  (VME_Input_G1(p, uchar, 2, 28) = v)\012#endif\012\012#define VME_SET_SICInput_NeighborPixelChroma0(p, v)                            \\\012  (VME_Input_G1(p, uchar, 3, 0) = v)\012#define VME_SET_SICInput_NeighborPixelChroma1(p, v)                            \\\012  (VME_Input_G1(p, uchar, 3, 1) = v)\012#define VME_SET_SICInput_NeighborPixelChroma2(p, v)                            \\\012  (VME_Input_G1(p, uchar, 3, 2) = v)\012#define VME_SET_SICInput_NeighborPixelChroma3(p, v)                            \\\012  (VME_Input_G1(p, uchar, 3, 3) = v)\012\012#define VME_SET_SICInput_NeighborPixelChroma4(p, v)                            \\\012  (VME_Input_G1(p, uchar, 3, 4) = v)\012#define VME_SET_SICInput_NeighborPixelChroma5(p, v)                            \\\012  (VME_Input_G1(p, uchar, 3, 5) = v)\012",
"#define VME_SET_SICInput_NeighborPixelChroma6(p, v)                            \\\012  (VME_Input_G1(p, uchar, 3, 6) = v)\012#define VME_SET_SICInput_NeighborPixelChroma7(p, v)                            \\\012  (VME_Input_G1(p, uchar, 3, 7) = v)\012\012#define VME_SET_SICInput_NeighborPixelChroma8(p, v)                            \\\012  (VME_Input_G1(p, uchar, 3, 8) = v)\012#define VME_SET_SICInput_NeighborPixelChroma9(p, v)                            \\\012  (VME_Input_G1(p, uchar, 3, 9) = v)\012#define VME_SET_SICInput_NeighborPixelChroma10(p, v)                           \\\012  (VME_Input_G1(p, uchar, 3, 10) = v)\012#define VME_SET_SICInput_NeighborPixelChroma11(p, v)                           \\\012  (VME_Input_G1(p, uchar, 3, 11) = v)\012\012#define VME_SET_SICInput_NeighborPixelChroma12(p, v)                           \\\012  (VME_Input_G1(p, uchar, 3, 12) = v)\012#define VME_SET_SICInput_NeighborPixelChroma13(p, v)                           \\\012  (VME_Input_G1(p, uchar, 3, 13) = v)\012#define VME_SET_SICInput_NeighborPixelChroma14(p, v)                      ",
"     \\\012  (VME_Input_G1(p, uchar, 3, 14) = v)\012#define VME_SET_SICInput_NeighborPixelChroma15(p, v)                           \\\012  (VME_Input_G1(p, uchar, 3, 15) = v)\012\012#define VME_SET_SICInput_NeighborPixelChroma16(p, v)                           \\\012  (VME_Input_G1(p, uchar, 3, 16) = v)\012#define VME_SET_SICInput_NeighborPixelChroma17(p, v)                           \\\012  (VME_Input_G1(p, uchar, 3, 17) = v)\012#define VME_SET_SICInput_NeighborPixelChroma18(p, v)                           \\\012  (VME_Input_G1(p, uchar, 3, 18) = v)\012#define VME_SET_SICInput_NeighborPixelChroma19(p, v)                           \\\012  (VME_Input_G1(p, uchar, 3, 19) = v)\012\012#define VME_SET_SICInput_NeighborPixelChroma20(p, v)                           \\\012  (VME_Input_G1(p, uchar, 3, 20) = v)\012#define VME_SET_SICInput_NeighborPixelChroma21(p, v)                           \\\012  (VME_Input_G1(p, uchar, 3, 21) = v)\012#define VME_SET_SICInput_NeighborPixelChroma22(p, v)                           \\\012  (VME_Input_G1(p, uchar, 3, 22) = v)\012#define VME_SET_SICInput_",
"NeighborPixelChroma23(p, v)                           \\\012  (VME_Input_G1(p, uchar, 3, 23) = v)\012\012#define VME_SET_SICInput_NeighborPixelChroma24(p, v)                           \\\012  (VME_Input_G1(p, uchar, 3, 24) = v)\012#define VME_SET_SICInput_NeighborPixelChroma25(p, v)                           \\\012  (VME_Input_G1(p, uchar, 3, 25) = v)\012#define VME_SET_SICInput_NeighborPixelChroma26(p, v)                           \\\012  (VME_Input_G1(p, uchar, 3, 26) = v)\012#define VME_SET_SICInput_NeighborPixelChroma27(p, v)                           \\\012  (VME_Input_G1(p, uchar, 3, 27) = v)\012\012#define VME_SET_SICInput_NeighborPixelChroma28(p, v)                           \\\012  (VME_Input_G1(p, uchar, 3, 28) = v)\012#define VME_SET_SICInput_NeighborPixelChroma29(p, v)                           \\\012  (VME_Input_G1(p, uchar, 3, 29) = v)\012#define VME_SET_SICInput_NeighborPixelChroma30(p, v)                           \\\012  (VME_Input_G1(p, uchar, 3, 30) = v)\012#define VME_SET_SICInput_NeighborPixelChroma31(p, v)                           \\\012  (VME_Input_G",
"1(p, uchar, 3, 31) = v)\012\012#define VME_SET_FBRInput_Ref0SubBlockX0(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 0, 0) = v)\012#define VME_SET_FBRInput_Ref0SubBlockY0(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 0, 1) = v)\012#define VME_SET_FBRInput_Ref1SubBlockX0(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 0, 2) = v)\012#define VME_SET_FBRInput_Ref1SubBlockY0(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 0, 3) = v)\012\012#define VME_SET_FBRInput_Ref0SubBlockX1(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 0, 4) = v)\012#define VME_SET_FBRInput_Ref0SubBlockY1(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 0, 5) = v)\012#define VME_SET_FBRInput_Ref1SubBlockX1(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 0, 6) = v)\012#define VME_SET_FBRInput_Ref1SubBlockY1(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 0, 7) = v)\012\012#define VME_SET_FBRInput_Ref0SubBlockX2(p, v)",
"                                  \\\012  (VME_Input_S1(p, ushort, 0, 8) = v)\012#define VME_SET_FBRInput_Ref0SubBlockY2(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 0, 9) = v)\012#define VME_SET_FBRInput_Ref1SubBlockX2(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 0, 10) = v)\012#define VME_SET_FBRInput_Ref1SubBlockY2(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 0, 11) = v)\012\012#define VME_SET_FBRInput_Ref0SubBlockX3(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 0, 12) = v)\012#define VME_SET_FBRInput_Ref0SubBlockY3(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 0, 13) = v)\012#define VME_SET_FBRInput_Ref1SubBlockX3(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 0, 14) = v)\012#define VME_SET_FBRInput_Ref1SubBlockY3(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 0, 15) = v)\012\012#define VME_SET_FBRInput_Ref0SubBlockX4(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 1",
", 0) = v)\012#define VME_SET_FBRInput_Ref0SubBlockY4(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 1, 1) = v)\012#define VME_SET_FBRInput_Ref1SubBlockX4(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 1, 2) = v)\012#define VME_SET_FBRInput_Ref1SubBlockY4(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 1, 3) = v)\012\012#define VME_SET_FBRInput_Ref0SubBlockX5(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 1, 4) = v)\012#define VME_SET_FBRInput_Ref0SubBlockY5(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 1, 5) = v)\012#define VME_SET_FBRInput_Ref1SubBlockX5(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 1, 6) = v)\012#define VME_SET_FBRInput_Ref1SubBlockY5(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 1, 7) = v)\012\012#define VME_SET_FBRInput_Ref0SubBlockX6(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 1, 8) = v)\012#define VME_SET_FBRInput_Ref0SubBlockY6(p, v)               ",
"                   \\\012  (VME_Input_S1(p, ushort, 1, 9) = v)\012#define VME_SET_FBRInput_Ref1SubBlockX6(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 1, 10) = v)\012#define VME_SET_FBRInput_Ref1SubBlockY6(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 1, 11) = v)\012\012#define VME_SET_FBRInput_Ref0SubBlockX7(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 1, 12) = v)\012#define VME_SET_FBRInput_Ref0SubBlockY7(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 1, 13) = v)\012#define VME_SET_FBRInput_Ref1SubBlockX7(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 1, 14) = v)\012#define VME_SET_FBRInput_Ref1SubBlockY7(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 1, 15) = v)\012\012#define VME_SET_FBRInput_Ref0SubBlockX8(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 2, 0) = v)\012#define VME_SET_FBRInput_Ref0SubBlockY8(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 2, 1) = v)\012#defi",
"ne VME_SET_FBRInput_Ref1SubBlockX8(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 2, 2) = v)\012#define VME_SET_FBRInput_Ref1SubBlockY8(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 2, 3) = v)\012\012#define VME_SET_FBRInput_Ref0SubBlockX9(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 2, 4) = v)\012#define VME_SET_FBRInput_Ref0SubBlockY9(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 2, 5) = v)\012#define VME_SET_FBRInput_Ref1SubBlockX9(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 2, 6) = v)\012#define VME_SET_FBRInput_Ref1SubBlockY9(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 2, 7) = v)\012\012#define VME_SET_FBRInput_Ref0SubBlockX10(p, v)                                 \\\012  (VME_Input_S1(p, ushort, 2, 8) = v)\012#define VME_SET_FBRInput_Ref0SubBlockY10(p, v)                                 \\\012  (VME_Input_S1(p, ushort, 2, 9) = v)\012#define VME_SET_FBRInput_Ref1SubBlockX10(p, v)                             ",
"    \\\012  (VME_Input_S1(p, ushort, 2, 10) = v)\012#define VME_SET_FBRInput_Ref1SubBlockY10(p, v)                                 \\\012  (VME_Input_S1(p, ushort, 2, 11) = v)\012\012#define VME_SET_FBRInput_Ref0SubBlockX11(p, v)                                 \\\012  (VME_Input_S1(p, ushort, 2, 12) = v)\012#define VME_SET_FBRInput_Ref0SubBlockY11(p, v)                                 \\\012  (VME_Input_S1(p, ushort, 2, 13) = v)\012#define VME_SET_FBRInput_Ref1SubBlockX11(p, v)                                 \\\012  (VME_Input_S1(p, ushort, 2, 14) = v)\012#define VME_SET_FBRInput_Ref1SubBlockY11(p, v)                                 \\\012  (VME_Input_S1(p, ushort, 2, 15) = v)\012\012#define VME_SET_FBRInput_Ref0SubBlockX12(p, v)                                 \\\012  (VME_Input_S1(p, ushort, 3, 0) = v)\012#define VME_SET_FBRInput_Ref0SubBlockY12(p, v)                                 \\\012  (VME_Input_S1(p, ushort, 3, 1) = v)\012#define VME_SET_FBRInput_Ref1SubBlockX12(p, v)                                 \\\012  (VME_Input_S1(p, ushort, 3, 2) = v)\012#define VME_SET_FBRI",
"nput_Ref1SubBlockY12(p, v)                                 \\\012  (VME_Input_S1(p, ushort, 3, 3) = v)\012\012#define VME_SET_FBRInput_Ref0SubBlockX13(p, v)                                 \\\012  (VME_Input_S1(p, ushort, 3, 4) = v)\012#define VME_SET_FBRInput_Ref0SubBlockY13(p, v)                                 \\\012  (VME_Input_S1(p, ushort, 3, 5) = v)\012#define VME_SET_FBRInput_Ref1SubBlockX13(p, v)                                 \\\012  (VME_Input_S1(p, ushort, 3, 6) = v)\012#define VME_SET_FBRInput_Ref1SubBlockY13(p, v)                                 \\\012  (VME_Input_S1(p, ushort, 3, 7) = v)\012\012#define VME_SET_FBRInput_Ref0SubBlockX14(p, v)                                 \\\012  (VME_Input_S1(p, ushort, 3, 8) = v)\012#define VME_SET_FBRInput_Ref0SubBlockY14(p, v)                                 \\\012  (VME_Input_S1(p, ushort, 3, 9) = v)\012#define VME_SET_FBRInput_Ref1SubBlockX14(p, v)                                 \\\012  (VME_Input_S1(p, ushort, 3, 10) = v)\012#define VME_SET_FBRInput_Ref1SubBlockY14(p, v)                                 \\\012  (VME_I",
"nput_S1(p, ushort, 3, 11) = v)\012\012#define VME_SET_FBRInput_Ref0SubBlockX15(p, v)                                 \\\012  (VME_Input_S1(p, ushort, 3, 12) = v)\012#define VME_SET_FBRInput_Ref0SubBlockY15(p, v)                                 \\\012  (VME_Input_S1(p, ushort, 3, 13) = v)\012#define VME_SET_FBRInput_Ref1SubBlockX15(p, v)                                 \\\012  (VME_Input_S1(p, ushort, 3, 14) = v)\012#define VME_SET_FBRInput_Ref1SubBlockY15(p, v)                                 \\\012  (VME_Input_S1(p, ushort, 3, 15) = v)\012\012#define VME_SET_IDMInput_SrcMBPixelMaskRow0(p, v)                              \\\012  (VME_Input_S1(p, ushort, 0, 0) = v)\012#define VME_SET_IDMInput_SrcMBPixelMaskRow1(p, v)                              \\\012  (VME_Input_S1(p, ushort, 0, 1) = v)\012#define VME_SET_IDMInput_SrcMBPixelMaskRow2(p, v)                              \\\012  (VME_Input_S1(p, ushort, 0, 2) = v)\012#define VME_SET_IDMInput_SrcMBPixelMaskRow3(p, v)                              \\\012  (VME_Input_S1(p, ushort, 0, 3) = v)\012#define VME_SET_IDMInput_SrcMBPixel",
"MaskRow4(p, v)                              \\\012  (VME_Input_S1(p, ushort, 0, 4) = v)\012#define VME_SET_IDMInput_SrcMBPixelMaskRow5(p, v)                              \\\012  (VME_Input_S1(p, ushort, 0, 5) = v)\012#define VME_SET_IDMInput_SrcMBPixelMaskRow6(p, v)                              \\\012  (VME_Input_S1(p, ushort, 0, 6) = v)\012#define VME_SET_IDMInput_SrcMBPixelMaskRow7(p, v)                              \\\012  (VME_Input_S1(p, ushort, 0, 7) = v)\012#define VME_SET_IDMInput_SrcMBPixelMaskRow8(p, v)                              \\\012  (VME_Input_S1(p, ushort, 0, 8) = v)\012#define VME_SET_IDMInput_SrcMBPixelMaskRow9(p, v)                              \\\012  (VME_Input_S1(p, ushort, 0, 9) = v)\012#define VME_SET_IDMInput_SrcMBPixelMaskRow10(p, v)                             \\\012  (VME_Input_S1(p, ushort, 0, 10) = v)\012#define VME_SET_IDMInput_SrcMBPixelMaskRow11(p, v)                             \\\012  (VME_Input_S1(p, ushort, 0, 11) = v)\012#define VME_SET_IDMInput_SrcMBPixelMaskRow12(p, v)                             \\\012  (VME_Input_S1(p, ushor",
"t, 0, 12) = v)\012#define VME_SET_IDMInput_SrcMBPixelMaskRow13(p, v)                             \\\012  (VME_Input_S1(p, ushort, 0, 13) = v)\012#define VME_SET_IDMInput_SrcMBPixelMaskRow14(p, v)                             \\\012  (VME_Input_S1(p, ushort, 0, 14) = v)\012#define VME_SET_IDMInput_SrcMBPixelMaskRow15(p, v)                             \\\012  (VME_Input_S1(p, ushort, 0, 15) = v)\012\012// GET methods\012\012// Format = I16\012#define VME_GET_UNIInput_Ref0X(p) (VME_Input_G1(p, ushort, 0, 0))\012#define VME_GET_UNIInput_Ref0Y(p) (VME_Input_G1(p, ushort, 0, 1))\012#define VME_GET_UNIInput_Ref1X(p) (VME_Input_G1(p, ushort, 0, 2))\012#define VME_GET_UNIInput_Ref1Y(p) (VME_Input_G1(p, ushort, 0, 3))\012\012// Format = U16\012#define VME_GET_UNIInput_SrcX(p) (VME_Input_G1(p, ushort, 0, 4))\012\012// Format = U16\012#define VME_GET_UNIInput_SrcY(p) (VME_Input_G1(p, ushort, 0, 5))\012\012// Format = U8\012#define VME_GET_UNIInput_SrcType(p) (VME_Input_G1(p, uchar, 0, 12))\012\012// Format = U8\012#define VME_GET_UNIInput_VmeModes(p) (VME_Input_G1(p, uchar, 0, 13))\012\012// Format = U8\012#de",
"fine VME_GET_UNIInput_SadType(p) (VME_Input_G1(p, uchar, 0, 14))\012\012// Format = U8\012#define VME_GET_UNIInput_ShapeMask(p) (VME_Input_G1(p, uchar, 0, 15))\012\012// The value must be a multiple of 4. Range = [20, 64]\012#define VME_GET_UNIInput_RefW(p) (VME_Input_G1(p, uchar, 0, 22))\012\012// The value must be a multiple of 4. Range = [20, 64]\012#define VME_GET_UNIInput_RefH(p) (VME_Input_G1(p, uchar, 0, 23))\012\012// Format = U8\012#define VME_GET_UNIInput_VmeFlags(p) (VME_Input_G1(p, uchar, 1, 0))\012\012// Format = U8\012#define VME_GET_UNIInput_EarlyImeStop(p) (VME_Input_G1(p, uchar, 1, 3))\012\012// Format = U8\012#define VME_GET_UNIInput_MaxNumMVs(p) (VME_Input_G1(p, uchar, 1, 4))\012\012#define VME_GET_UNIInput_Ref0Polarity(p) (VME_Input_G1(p, uchar, 1, 5) & 0x0F)\012#define VME_GET_UNIInput_Ref1Polarity(p) (VME_Input_G1(p, uchar, 1, 5) >> 4)\012\012// Format = U6, Valid Values: [16, 21, 32, 43, 48]\012#define VME_GET_UNIInput_BiWeight(p) (VME_Input_G1(p, uchar, 1, 6))\012\012#define VME_GET_UNIInput_RefPixelBiasEnable(p)                                 \\\012  ((VME_Input_G",
"1(p, uchar, 1, 7) & 0x20) \? 1 : 0)\012\012#define VME_GET_UNIInput_UniMixDisable(p)                                      \\\012  ((VME_Input_G1(p, uchar, 1, 7) & 0x10) \? 1 : 0)\012\012// Format = U8\012// #define VME_GET_UNIInput_BiDirMask(p) ((VME_Input_G1(p, uchar, 1, 7) & 0x10)\012// \? 1 : 0)\012\012// Format = U8, Valid range [1,63]\012#define VME_GET_UNIInput_LenSP(p) (VME_Input_G1(p, uchar, 1, 8))\012\012// Format = U8, Valid range [1,63]\012#define VME_GET_UNIInput_MaxNumSU(p) (VME_Input_G1(p, uchar, 1, 9))\012\012// Format = U8\012#define VME_GET_UNIInput_StartCenter0(p) (VME_Input_G1(p, uchar, 1, 10))\012\012// Format = U8\012#define VME_GET_UNIInput_StartCenter1(p) (VME_Input_G1(p, uchar, 1, 11))\012\012// Format = U8\012#define VME_GET_UNIInput_WeightedSADCtrl0_3(p) (VME_Input_G1(p, uchar, 1, 12))\012#define VME_GET_UNIInput_WeightedSADCtrl4_7(p) (VME_Input_G1(p, uchar, 1, 13))\012#define VME_GET_UNIInput_WeightedSADCtrl8_11(p) (VME_Input_G1(p, uchar, 1, 14))\012#define VME_GET_UNIInput_WeightedSADCtrl12_15(p) (VME_Input_G1(p, uchar, 1, 15))\012\012// Format = U8\012#define VME_GET",
"_UNIInput_Blk0RefID(p) (VME_Input_G1(p, uchar, 1, 24))\012#define VME_GET_UNIInput_Blk1RefID(p) (VME_Input_G1(p, uchar, 1, 25))\012#define VME_GET_UNIInput_Blk2RefID(p) (VME_Input_G1(p, uchar, 1, 26))\012#define VME_GET_UNIInput_Blk3RefID(p) (VME_Input_G1(p, uchar, 1, 27))\012\012// Format = U8\012#define VME_GET_UNIInput_IntraFlags(p) (VME_Input_G1(p, uchar, 1, 28))\012\012// v is a 8-bit mask with the following definition:\012// Bit-7    Reserved : MBZ (for IntraPredAvailFlagF - F (pixel[-1,7]\012// available\012// for MbAff)\012// Bit-6    Reserved : MBZ (for IntraPredAvailFlagA/E - A (left neighbor top\012// half for MbAff)\012// Bit-5    IntraPredAvailFlagE/A - A (Left neighbor or Left bottom half)\012// Bit-4    IntraPredAvailFlagB - B (Upper neighbor)\012// Bit-3    IntraPredAvailFlagC - C (Upper left neighbor)\012// Bit-2    IntraPredAvailFlagD - D (Upper right neighbor)\012// Bit-1:0  Reserved: MBZ (ChromaIntraPredMode)\012#define VME_GET_UNIInput_MbIntraStruct(p) (VME_Input_G1(p, uchar, 1, 29))\012\012// Format = U8\012#define VME_GET_UNIInput_MvFlags(p) (VME_Inpu",
"t_G1(p, uchar, 1, 30))\012\012// v is a 8-bit mask with the following definition:\012// xxxx xxx1: Ref0 Skip Center 0 is enabled [corresponds to M2.0]\012// xxxx xx1x: Ref1 Skip Center 0 is enabled [corresponds to M2.1]\012// xxxx x1xx: Ref0 Skip Center 1 is enabled [corresponds to M2.2]\012// xxxx 1xxx: Ref1 Skip Center 1 is enabled [corresponds to M2.3]\012// xxx1 xxxx: Ref0 Skip Center 2 is enabled [corresponds to M2.4]\012// xx1x xxxx: Ref1 Skip Center 2 is enabled [corresponds to M2.5]\012// x1xx xxxx: Ref0 Skip Center 3 is enabled [corresponds to M2.6]\012// 1xxx xxxx: Ref1 Skip Center 3 is enabled [corresponds to M2.7]\012#define VME_GET_UNIInput_SkipCenterMask(p) (VME_Input_G1(p, uchar, 1, 31))\012\012// NOTE: replace v with U4U4 type with\012// (shift_count, shift_val) and set the value as (shift_val | (shift_count <<\012// 4))\012\012// Format = U4U4 (encoded value must fit in 12-bits)\012#define VME_GET_UNIInput_Mode0Cost(p) (VME_Input_G1(p, uchar, 2, 0))\012#define VME_GET_UNIInput_Mode1Cost(p) (VME_Input_G1(p, uchar, 2, 1))\012#define VME_GET_UNIInput_Mod",
"e2Cost(p) (VME_Input_G1(p, uchar, 2, 2))\012#define VME_GET_UNIInput_Mode3Cost(p) (VME_Input_G1(p, uchar, 2, 3))\012#define VME_GET_UNIInput_Mode4Cost(p) (VME_Input_G1(p, uchar, 2, 4))\012#define VME_GET_UNIInput_Mode5Cost(p) (VME_Input_G1(p, uchar, 2, 5))\012#define VME_GET_UNIInput_Mode6Cost(p) (VME_Input_G1(p, uchar, 2, 6))\012#define VME_GET_UNIInput_Mode7Cost(p) (VME_Input_G1(p, uchar, 2, 7))\012#define VME_GET_UNIInput_Mode8Cost(p) (VME_Input_G1(p, uchar, 2, 8))\012#define VME_GET_UNIInput_Mode9Cost(p) (VME_Input_G1(p, uchar, 2, 9))\012\012// Format = U4U4 (encoded value must fit in 12-bits)\012#define VME_GET_UNIInput_RefIDCost(p) (VME_Input_G1(p, uchar, 2, 10))\012\012// Format = U4U4 (encoded value must fit in 12-bits)\012#define VME_GET_UNIInput_ChromaIntraModeCost(p) (VME_Input_G1(p, uchar, 2, 11))\012\012// Format = U4U4 (encoded value must fit in 10-bits)\012#define VME_GET_UNIInput_MV0Cost(p) (VME_Input_G1(p, uchar, 2, 12))\012#define VME_GET_UNIInput_MV1Cost(p) (VME_Input_G1(p, uchar, 2, 13))\012#define VME_GET_UNIInput_MV2Cost(p) (VME_Input_G1(p,",
" uchar, 2, 14))\012#define VME_GET_UNIInput_MV3Cost(p) (VME_Input_G1(p, uchar, 2, 15))\012#define VME_GET_UNIInput_MV4Cost(p) (VME_Input_G1(p, uchar, 2, 16))\012#define VME_GET_UNIInput_MV5Cost(p) (VME_Input_G1(p, uchar, 2, 17))\012#define VME_GET_UNIInput_MV6Cost(p) (VME_Input_G1(p, uchar, 2, 18))\012#define VME_GET_UNIInput_MV7Cost(p) (VME_Input_G1(p, uchar, 2, 19))\012\012// Format = U8\012#define VME_GET_UNIInput_FBRMbModeInput(p) (VME_Input_G1(p, uchar, 2, 20) & 0x3)\012\012// Format = U8\012#define VME_GET_UNIInput_FBRSubMBShapeInput(p) (VME_Input_G1(p, uchar, 2, 21))\012\012// Format = U8\012#define VME_GET_UNIInput_FBRSubPredModeInput(p) (VME_Input_G1(p, uchar, 2, 22))\012\012// Format = U16\012#define VME_GET_UNIInput_SICFwdTCoeffThreshold0(p)                             \\\012  (VME_Input_G1(p, ushort, 2, 12))\012// Format = U8\012#define VME_GET_UNIInput_SICFwdTCoeffThreshold1(p)                             \\\012  (VME_Input_G1(p, uchar, 2, 26))\012#define VME_GET_UNIInput_SICFwdTCoeffThreshold2(p)                             \\\012  (VME_Input_G1(p, uchar, 2, 27))\012#d",
"efine VME_GET_UNIInput_SICFwdTCoeffThreshold3(p)                             \\\012  (VME_Input_G1(p, uchar, 2, 28))\012#define VME_GET_UNIInput_SICFwdTCoeffThreshold4(p)                             \\\012  (VME_Input_G1(p, uchar, 2, 29))\012#define VME_GET_UNIInput_SICFwdTCoeffThreshold5(p)                             \\\012  (VME_Input_G1(p, uchar, 2, 30))\012#define VME_GET_UNIInput_SICFwdTCoeffThreshold6(p)                             \\\012  (VME_Input_G1(p, uchar, 2, 31))\012\012// Return DeltaX in the lower 16 bit and DeltaY in the higher 16 bits\012// Format = S13.2, DletaX Valid Range: [-2048.00 to 2047.75], DletaY Valid\012// Range: [-512.00 to 511.75]\012#define VME_GET_UNIInput_FWDCostCenter0_X(p) (VME_Input_G1(p, ushort, 3, 0))\012#define VME_GET_UNIInput_FWDCostCenter0_Y(p) (VME_Input_G1(p, ushort, 3, 1))\012#define VME_GET_UNIInput_BWDCostCenter0_X(p) (VME_Input_G1(p, ushort, 3, 2))\012#define VME_GET_UNIInput_BWDCostCenter0_Y(p) (VME_Input_G1(p, ushort, 3, 3))\012#define VME_GET_UNIInput_FWDCostCenter1_X(p) (VME_Input_G1(p, ushort, 3, 4))\012#defi",
"ne VME_GET_UNIInput_FWDCostCenter1_Y(p) (VME_Input_G1(p, ushort, 3, 5))\012#define VME_GET_UNIInput_BWDCostCenter1_X(p) (VME_Input_G1(p, ushort, 3, 6))\012#define VME_GET_UNIInput_BWDCostCenter1_Y(p) (VME_Input_G1(p, ushort, 3, 7))\012#define VME_GET_UNIInput_FWDCostCenter2_X(p) (VME_Input_G1(p, ushort, 3, 8))\012#define VME_GET_UNIInput_FWDCostCenter2_Y(p) (VME_Input_G1(p, ushort, 3, 9))\012#define VME_GET_UNIInput_BWDCostCenter2_X(p) (VME_Input_G1(p, ushort, 3, 10))\012#define VME_GET_UNIInput_BWDCostCenter2_Y(p) (VME_Input_G1(p, ushort, 3, 11))\012#define VME_GET_UNIInput_FWDCostCenter3_X(p) (VME_Input_G1(p, ushort, 3, 12))\012#define VME_GET_UNIInput_FWDCostCenter3_Y(p) (VME_Input_G1(p, ushort, 3, 13))\012#define VME_GET_UNIInput_BWDCostCenter3_X(p) (VME_Input_G1(p, ushort, 3, 14))\012#define VME_GET_UNIInput_BWDCostCenter3_Y(p) (VME_Input_G1(p, ushort, 3, 15))\012\012// Format = U8, with the following definition:\012// [7:4] (Y) - specifies relative Y distance to the next SU from previous SU in\012// units of SU\012// [3:0] (X) - specifies relative",
" X distance to the next SU from previous SU in\012// units of SU\012#define VME_GET_IMEInput_IMESearchPathDelta0(p) (VME_Input_G1(p, uchar, 0, 0))\012#define VME_GET_IMEInput_IMESearchPathDelta1(p) (VME_Input_G1(p, uchar, 0, 1))\012#define VME_GET_IMEInput_IMESearchPathDelta2(p) (VME_Input_G1(p, uchar, 0, 2))\012#define VME_GET_IMEInput_IMESearchPathDelta3(p) (VME_Input_G1(p, uchar, 0, 3))\012#define VME_GET_IMEInput_IMESearchPathDelta4(p) (VME_Input_G1(p, uchar, 0, 4))\012#define VME_GET_IMEInput_IMESearchPathDelta5(p) (VME_Input_G1(p, uchar, 0, 5))\012#define VME_GET_IMEInput_IMESearchPathDelta6(p) (VME_Input_G1(p, uchar, 0, 6))\012#define VME_GET_IMEInput_IMESearchPathDelta7(p) (VME_Input_G1(p, uchar, 0, 7))\012#define VME_GET_IMEInput_IMESearchPathDelta8(p) (VME_Input_G1(p, uchar, 0, 8))\012#define VME_GET_IMEInput_IMESearchPathDelta9(p) (VME_Input_G1(p, uchar, 0, 9))\012#define VME_GET_IMEInput_IMESearchPathDelta10(p) (VME_Input_G1(p, uchar, 0, 10))\012#define VME_GET_IMEInput_IMESearchPathDelta11(p) (VME_Input_G1(p, uchar, 0, 11))\012#define VM",
"E_GET_IMEInput_IMESearchPathDelta12(p) (VME_Input_G1(p, uchar, 0, 12))\012#define VME_GET_IMEInput_IMESearchPathDelta13(p) (VME_Input_G1(p, uchar, 0, 13))\012#define VME_GET_IMEInput_IMESearchPathDelta14(p) (VME_Input_G1(p, uchar, 0, 14))\012#define VME_GET_IMEInput_IMESearchPathDelta15(p) (VME_Input_G1(p, uchar, 0, 15))\012#define VME_GET_IMEInput_IMESearchPathDelta16(p) (VME_Input_G1(p, uchar, 0, 16))\012#define VME_GET_IMEInput_IMESearchPathDelta17(p) (VME_Input_G1(p, uchar, 0, 17))\012#define VME_GET_IMEInput_IMESearchPathDelta18(p) (VME_Input_G1(p, uchar, 0, 18))\012#define VME_GET_IMEInput_IMESearchPathDelta19(p) (VME_Input_G1(p, uchar, 0, 19))\012#define VME_GET_IMEInput_IMESearchPathDelta20(p) (VME_Input_G1(p, uchar, 0, 20))\012#define VME_GET_IMEInput_IMESearchPathDelta21(p) (VME_Input_G1(p, uchar, 0, 21))\012#define VME_GET_IMEInput_IMESearchPathDelta22(p) (VME_Input_G1(p, uchar, 0, 22))\012#define VME_GET_IMEInput_IMESearchPathDelta23(p) (VME_Input_G1(p, uchar, 0, 23))\012#define VME_GET_IMEInput_IMESearchPathDelta24(p) (VME_Input_G1",
"(p, uchar, 0, 24))\012#define VME_GET_IMEInput_IMESearchPathDelta25(p) (VME_Input_G1(p, uchar, 0, 25))\012#define VME_GET_IMEInput_IMESearchPathDelta26(p) (VME_Input_G1(p, uchar, 0, 26))\012#define VME_GET_IMEInput_IMESearchPathDelta27(p) (VME_Input_G1(p, uchar, 0, 27))\012#define VME_GET_IMEInput_IMESearchPathDelta28(p) (VME_Input_G1(p, uchar, 0, 28))\012#define VME_GET_IMEInput_IMESearchPathDelta29(p) (VME_Input_G1(p, uchar, 0, 29))\012#define VME_GET_IMEInput_IMESearchPathDelta30(p) (VME_Input_G1(p, uchar, 0, 30))\012#define VME_GET_IMEInput_IMESearchPathDelta31(p) (VME_Input_G1(p, uchar, 0, 31))\012\012#define VME_GET_IMEInput_IMESearchPathDelta32(p) (VME_Input_G1(p, uchar, 1, 0))\012#define VME_GET_IMEInput_IMESearchPathDelta33(p) (VME_Input_G1(p, uchar, 1, 1))\012#define VME_GET_IMEInput_IMESearchPathDelta34(p) (VME_Input_G1(p, uchar, 1, 2))\012#define VME_GET_IMEInput_IMESearchPathDelta35(p) (VME_Input_G1(p, uchar, 1, 3))\012#define VME_GET_IMEInput_IMESearchPathDelta36(p) (VME_Input_G1(p, uchar, 1, 4))\012#define VME_GET_IMEInput_IMESearchPat",
"hDelta37(p) (VME_Input_G1(p, uchar, 1, 5))\012#define VME_GET_IMEInput_IMESearchPathDelta38(p) (VME_Input_G1(p, uchar, 1, 6))\012#define VME_GET_IMEInput_IMESearchPathDelta39(p) (VME_Input_G1(p, uchar, 1, 7))\012#define VME_GET_IMEInput_IMESearchPathDelta40(p) (VME_Input_G1(p, uchar, 1, 8))\012#define VME_GET_IMEInput_IMESearchPathDelta41(p) (VME_Input_G1(p, uchar, 1, 9))\012#define VME_GET_IMEInput_IMESearchPathDelta42(p) (VME_Input_G1(p, uchar, 1, 10))\012#define VME_GET_IMEInput_IMESearchPathDelta43(p) (VME_Input_G1(p, uchar, 1, 11))\012#define VME_GET_IMEInput_IMESearchPathDelta44(p) (VME_Input_G1(p, uchar, 1, 12))\012#define VME_GET_IMEInput_IMESearchPathDelta45(p) (VME_Input_G1(p, uchar, 1, 13))\012#define VME_GET_IMEInput_IMESearchPathDelta46(p) (VME_Input_G1(p, uchar, 1, 14))\012#define VME_GET_IMEInput_IMESearchPathDelta47(p) (VME_Input_G1(p, uchar, 1, 15))\012#define VME_GET_IMEInput_IMESearchPathDelta48(p) (VME_Input_G1(p, uchar, 1, 16))\012#define VME_GET_IMEInput_IMESearchPathDelta49(p) (VME_Input_G1(p, uchar, 1, 17))\012#define VME_G",
"ET_IMEInput_IMESearchPathDelta50(p) (VME_Input_G1(p, uchar, 1, 18))\012#define VME_GET_IMEInput_IMESearchPathDelta51(p) (VME_Input_G1(p, uchar, 1, 19))\012#define VME_GET_IMEInput_IMESearchPathDelta52(p) (VME_Input_G1(p, uchar, 1, 20))\012#define VME_GET_IMEInput_IMESearchPathDelta53(p) (VME_Input_G1(p, uchar, 1, 21))\012#define VME_GET_IMEInput_IMESearchPathDelta54(p) (VME_Input_G1(p, uchar, 1, 22))\012#define VME_GET_IMEInput_IMESearchPathDelta55(p) (VME_Input_G1(p, uchar, 1, 23))\012\012// Format = U16\012#define VME_GET_IMEInput_Rec0_16x8_0Distortion(p)                              \\\012  (VME_Input_G1(p, ushort, 2, 0))\012#define VME_GET_IMEInput_Rec0_16x8_1Distortion(p)                              \\\012  (VME_Input_G1(p, ushort, 2, 1))\012#define VME_GET_IMEInput_Rec0_8x16_0Distortion(p)                              \\\012  (VME_Input_G1(p, ushort, 2, 2))\012#define VME_GET_IMEInput_Rec0_8x16_1Distortion(p)                              \\\012  (VME_Input_G1(p, ushort, 2, 3))\012#define VME_GET_IMEInput_Rec0_8x8_0Distortion(p) (VME_Input_G1(p, ushort, ",
"2, 4))\012#define VME_GET_IMEInput_Rec0_8x8_1Distortion(p) (VME_Input_G1(p, ushort, 2, 5))\012#define VME_GET_IMEInput_Rec0_8x8_2Distortion(p) (VME_Input_G1(p, ushort, 2, 6))\012#define VME_GET_IMEInput_Rec0_8x8_3Distortion(p) (VME_Input_G1(p, ushort, 2, 7))\012#define VME_GET_IMEInput_Rec0_16x16_Distortion(p)                              \\\012  (VME_Input_G1(p, ushort, 2, 8))\012\012// Format = U4\012#define VME_GET_UNIInput_Rec0_16x16_RefID(p)                                   \\\012  (VME_Input_G1(p, uchar, 2, 18) & 0x0F)\012\012// Format = S13.2\012#define VME_GET_IMEInput_Rec0_16x16_X(p) (VME_Input_G1(p, ushort, 2, 10))\012#define VME_GET_IMEInput_Rec0_16x16_Y(p) (VME_Input_G1(p, ushort, 2, 11))\012\012// Format = U4\012#define VME_GET_IMEInput_Rec0_16x8_0to1RefID(p) (VME_Input_G1(p, uchar, 2, 24))\012#define VME_GET_IMEInput_Rec0_8x16_0to1RefID(p) (VME_Input_G1(p, uchar, 2, 25))\012#define VME_GET_IMEInput_Rec0_8x8_0to1RefID(p) (VME_Input_G1(p, uchar, 2, 26))\012#define VME_GET_IMEInput_Rec0_8x8_2to3RefID(p) (VME_Input_G1(p, uchar, 2, 27))\012\012// Format = S13.2\012#",
"define VME_GET_IMEInput_Rec0_16x8_0X(p) (VME_Input_G1(p, ushort, 3, 0))\012#define VME_GET_IMEInput_Rec0_16x8_0Y(p) (VME_Input_G1(p, ushort, 3, 1))\012#define VME_GET_IMEInput_Rec0_16x8_1X(p) (VME_Input_G1(p, ushort, 3, 2))\012#define VME_GET_IMEInput_Rec0_16x8_1Y(p) (VME_Input_G1(p, ushort, 3, 3))\012#define VME_GET_IMEInput_Rec0_8x16_0X(p) (VME_Input_G1(p, ushort, 3, 4))\012#define VME_GET_IMEInput_Rec0_8x16_0Y(p) (VME_Input_G1(p, ushort, 3, 5))\012#define VME_GET_IMEInput_Rec0_8x16_1X(p) (VME_Input_G1(p, ushort, 3, 6))\012#define VME_GET_IMEInput_Rec0_8x16_1Y(p) (VME_Input_G1(p, ushort, 3, 7))\012#define VME_GET_IMEInput_Rec0_8x8_0X(p) (VME_Input_G1(p, ushort, 3, 8))\012#define VME_GET_IMEInput_Rec0_8x8_0Y(p) (VME_Input_G1(p, ushort, 3, 9))\012#define VME_GET_IMEInput_Rec0_8x8_1X(p) (VME_Input_G1(p, ushort, 3, 10))\012#define VME_GET_IMEInput_Rec0_8x8_1Y(p) (VME_Input_G1(p, ushort, 3, 11))\012#define VME_GET_IMEInput_Rec0_8x8_2X(p) (VME_Input_G1(p, ushort, 3, 12))\012#define VME_GET_IMEInput_Rec0_8x8_2Y(p) (VME_Input_G1(p, ushort, 3, 13))\012#defi",
"ne VME_GET_IMEInput_Rec0_8x8_3X(p) (VME_Input_G1(p, ushort, 3, 14))\012#define VME_GET_IMEInput_Rec0_8x8_3Y(p) (VME_Input_G1(p, ushort, 3, 15))\012\012// Format = U16\012#define VME_GET_IMEInput_Rec1_16x8_0Distortion(p)                              \\\012  (VME_Input_G1(p, ushort, 4, 0))\012#define VME_GET_IMEInput_Rec1_16x8_1Distortion(p)                              \\\012  (VME_Input_G1(p, ushort, 4, 1))\012#define VME_GET_IMEInput_Rec1_8x16_0Distortion(p)                              \\\012  (VME_Input_G1(p, ushort, 4, 2))\012#define VME_GET_IMEInput_Rec1_8x16_1Distortion(p)                              \\\012  (VME_Input_G1(p, ushort, 4, 3))\012#define VME_GET_IMEInput_Rec1_8x8_0Distortion(p) (VME_Input_G1(p, ushort, 4, 4))\012#define VME_GET_IMEInput_Rec1_8x8_1Distortion(p) (VME_Input_G1(p, ushort, 4, 5))\012#define VME_GET_IMEInput_Rec1_8x8_2Distortion(p) (VME_Input_G1(p, ushort, 4, 6))\012#define VME_GET_IMEInput_Rec1_8x8_3Distortion(p) (VME_Input_G1(p, ushort, 4, 7))\012#define VME_GET_IMEInput_Rec1_16x16_Distortion(p)                              \\\012 ",
" (VME_Input_G1(p, ushort, 4, 8))\012\012// Format = U4\012#define VME_GET_UNIInput_Rec1_16x16_RefID(p) (VME_Input_G1(p, uchar, 4, 18))\012\012// Format = S13.2\012#define VME_GET_IMEInput_Rec1_16x16_X(p) (VME_Input_G1(p, ushort, 4, 10))\012#define VME_GET_IMEInput_Rec1_16x16_Y(p) (VME_Input_G1(p, ushort, 4, 11))\012\012// Format = U4\012#define VME_GET_IMEInput_Rec1_16x8_0to1RefID(p) (VME_Input_G1(p, uchar, 4, 24))\012#define VME_GET_IMEInput_Rec1_8x16_0to1RefID(p) (VME_Input_G1(p, uchar, 4, 25))\012#define VME_GET_IMEInput_Rec1_8x8_0to1RefID(p) (VME_Input_G1(p, uchar, 4, 26))\012#define VME_GET_IMEInput_Rec1_8x8_2to3RefID(p) (VME_Input_G1(p, uchar, 4, 27))\012\012// Format = S13.2\012#define VME_GET_IMEInput_Rec1_16x8_0X(p) (VME_Input_G1(p, ushort, 5, 0))\012#define VME_GET_IMEInput_Rec1_16x8_0Y(p) (VME_Input_G1(p, ushort, 5, 1))\012#define VME_GET_IMEInput_Rec1_16x8_1X(p) (VME_Input_G1(p, ushort, 5, 2))\012#define VME_GET_IMEInput_Rec1_16x8_1Y(p) (VME_Input_G1(p, ushort, 5, 3))\012#define VME_GET_IMEInput_Rec1_8x16_0X(p) (VME_Input_G1(p, ushort, 5, 4))\012#define VME_G",
"ET_IMEInput_Rec1_8x16_0Y(p) (VME_Input_G1(p, ushort, 5, 5))\012#define VME_GET_IMEInput_Rec1_8x16_1X(p) (VME_Input_G1(p, ushort, 5, 6))\012#define VME_GET_IMEInput_Rec1_8x16_1Y(p) (VME_Input_G1(p, ushort, 5, 7))\012#define VME_GET_IMEInput_Rec1_8x8_0X(p) (VME_Input_G1(p, ushort, 5, 8))\012#define VME_GET_IMEInput_Rec1_8x8_0Y(p) (VME_Input_G1(p, ushort, 5, 9))\012#define VME_GET_IMEInput_Rec1_8x8_1X(p) (VME_Input_G1(p, ushort, 5, 10))\012#define VME_GET_IMEInput_Rec1_8x8_1Y(p) (VME_Input_G1(p, ushort, 5, 11))\012#define VME_GET_IMEInput_Rec1_8x8_2X(p) (VME_Input_G1(p, ushort, 5, 12))\012#define VME_GET_IMEInput_Rec1_8x8_2Y(p) (VME_Input_G1(p, ushort, 5, 13))\012#define VME_GET_IMEInput_Rec1_8x8_3X(p) (VME_Input_G1(p, ushort, 5, 14))\012#define VME_GET_IMEInput_Rec1_8x8_3Y(p) (VME_Input_G1(p, ushort, 5, 15))\012\012// Format = S13.2, Valid Range: [-2048.00 to 2047.75]\012// For chroma skip: Format = S12.3, Hardware Range: [-1024.000 to 1023.875]\012#define VME_GET_SICInput_Ref0SkipCenter0DeltaX(p)                              \\\012  (VME_Input_G1(p, ushor",
"t, 0, 0))\012#define VME_GET_SICInput_Ref0SkipCenter0DeltaY(p)                              \\\012  (VME_Input_G1(p, ushort, 0, 1))\012\012#define VME_GET_SICInput_Ref1SkipCenter0DeltaX(p)                              \\\012  (VME_Input_G1(p, ushort, 0, 2))\012#define VME_GET_SICInput_Ref1SkipCenter0DeltaY(p)                              \\\012  (VME_Input_G1(p, ushort, 0, 3))\012\012#define VME_GET_SICInput_Ref0SkipCenter1DeltaX(p)                              \\\012  (VME_Input_G1(p, ushort, 0, 4))\012#define VME_GET_SICInput_Ref0SkipCenter1DeltaY(p)                              \\\012  (VME_Input_G1(p, ushort, 0, 5))\012\012#define VME_GET_SICInput_Ref1SkipCenter1DeltaX(p)                              \\\012  (VME_Input_G1(p, ushort, 0, 6))\012#define VME_GET_SICInput_Ref1SkipCenter1DeltaY(p)                              \\\012  (VME_Input_G1(p, ushort, 0, 7))\012\012#define VME_GET_SICInput_Ref0SkipCenter2DeltaX(p)                              \\\012  (VME_Input_G1(p, ushort, 0, 8))\012#define VME_GET_SICInput_Ref0SkipCenter2DeltaY(p)                              \\\012  (VME_In",
"put_G1(p, ushort, 0, 9))\012\012#define VME_GET_SICInput_Ref1SkipCenter2DeltaX(p)                              \\\012  (VME_Input_G1(p, ushort, 0, 10))\012#define VME_GET_SICInput_Ref1SkipCenter2DeltaY(p)                              \\\012  (VME_Input_G1(p, ushort, 0, 11))\012\012#define VME_GET_SICInput_Ref0SkipCenter3DeltaX(p)                              \\\012  (VME_Input_G1(p, ushort, 0, 12))\012#define VME_GET_SICInput_Ref0SkipCenter3DeltaY(p)                              \\\012  (VME_Input_G1(p, ushort, 0, 13))\012\012#define VME_GET_SICInput_Ref1SkipCenter3DeltaX(p)                              \\\012  (VME_Input_G1(p, ushort, 0, 14))\012#define VME_GET_SICInput_Ref1SkipCenter3DeltaY(p)                              \\\012  (VME_Input_G1(p, ushort, 0, 15))\012\012#define VME_GET_SICInput_Intra4x4ModeMask(p) (VME_Input_G1(p, uchar, 1, 0))\012\012#define VME_GET_SICInput_Intra8x8ModeMask(p) (VME_Input_G1(p, uchar, 1, 2))\012\012#define VME_GET_SICInput_IntraModeMask(p) (VME_Input_G1(p, uchar, 1, 4))\012\012// 2-bit field with the following definition\012// 00: Luma + Chroma enabl",
"ed\012// 01: Luma only\012// 1X: Intra disabled\012#define VME_GET_SICInput_IntraComputeType(p)                                   \\\012  (VME_Input_G1(p, uchar, 1, 5) & 0x3)\012\012#define VME_GET_SICInput_CornerNeighborPixel0(p) (VME_Input_G1(p, uchar, 1, 7))\012\012#define VME_GET_SICInput_NeighborPixelLum0(p) (VME_Input_G1(p, uchar, 1, 8))\012#define VME_GET_SICInput_NeighborPixelLum1(p) (VME_Input_G1(p, uchar, 1, 9))\012#define VME_GET_SICInput_NeighborPixelLum2(p) (VME_Input_G1(p, uchar, 1, 10))\012#define VME_GET_SICInput_NeighborPixelLum3(p) (VME_Input_G1(p, uchar, 1, 11))\012#define VME_GET_SICInput_NeighborPixelLum4(p) (VME_Input_G1(p, uchar, 1, 12))\012#define VME_GET_SICInput_NeighborPixelLum5(p) (VME_Input_G1(p, uchar, 1, 13))\012#define VME_GET_SICInput_NeighborPixelLum6(p) (VME_Input_G1(p, uchar, 1, 14))\012#define VME_GET_SICInput_NeighborPixelLum7(p) (VME_Input_G1(p, uchar, 1, 15))\012#define VME_GET_SICInput_NeighborPixelLum8(p) (VME_Input_G1(p, uchar, 1, 16))\012#define VME_GET_SICInput_NeighborPixelLum9(p) (VME_Input_G1(p, uchar, 1, 17))\012#d",
"efine VME_GET_SICInput_NeighborPixelLum10(p) (VME_Input_G1(p, uchar, 1, 18))\012#define VME_GET_SICInput_NeighborPixelLum11(p) (VME_Input_G1(p, uchar, 1, 19))\012#define VME_GET_SICInput_NeighborPixelLum12(p) (VME_Input_G1(p, uchar, 1, 20))\012#define VME_GET_SICInput_NeighborPixelLum13(p) (VME_Input_G1(p, uchar, 1, 21))\012#define VME_GET_SICInput_NeighborPixelLum14(p) (VME_Input_G1(p, uchar, 1, 22))\012#define VME_GET_SICInput_NeighborPixelLum15(p) (VME_Input_G1(p, uchar, 1, 23))\012#define VME_GET_SICInput_NeighborPixelLum16(p) (VME_Input_G1(p, uchar, 1, 24))\012#define VME_GET_SICInput_NeighborPixelLum17(p) (VME_Input_G1(p, uchar, 1, 25))\012#define VME_GET_SICInput_NeighborPixelLum18(p) (VME_Input_G1(p, uchar, 1, 26))\012#define VME_GET_SICInput_NeighborPixelLum19(p) (VME_Input_G1(p, uchar, 1, 27))\012#define VME_GET_SICInput_NeighborPixelLum20(p) (VME_Input_G1(p, uchar, 1, 28))\012#define VME_GET_SICInput_NeighborPixelLum21(p) (VME_Input_G1(p, uchar, 1, 29))\012#define VME_GET_SICInput_NeighborPixelLum22(p) (VME_Input_G1(p, uchar, 1, 30))",
"\012#define VME_GET_SICInput_NeighborPixelLum23(p) (VME_Input_G1(p, uchar, 1, 31))\012#define VME_GET_SICInput_NeighborPixelLum24(p) (VME_Input_G1(p, uchar, 2, 0))\012#define VME_GET_SICInput_NeighborPixelLum25(p) (VME_Input_G1(p, uchar, 2, 1))\012#define VME_GET_SICInput_NeighborPixelLum26(p) (VME_Input_G1(p, uchar, 2, 2))\012#define VME_GET_SICInput_NeighborPixelLum27(p) (VME_Input_G1(p, uchar, 2, 3))\012#define VME_GET_SICInput_NeighborPixelLum28(p) (VME_Input_G1(p, uchar, 2, 4))\012#define VME_GET_SICInput_NeighborPixelLum29(p) (VME_Input_G1(p, uchar, 2, 5))\012#define VME_GET_SICInput_NeighborPixelLum30(p) (VME_Input_G1(p, uchar, 2, 6))\012#define VME_GET_SICInput_NeighborPixelLum31(p) (VME_Input_G1(p, uchar, 2, 7))\012#define VME_GET_SICInput_NeighborPixelLum32(p) (VME_Input_G1(p, uchar, 2, 8))\012#define VME_GET_SICInput_NeighborPixelLum33(p) (VME_Input_G1(p, uchar, 2, 9))\012#define VME_GET_SICInput_NeighborPixelLum34(p) (VME_Input_G1(p, uchar, 2, 10))\012#define VME_GET_SICInput_NeighborPixelLum35(p) (VME_Input_G1(p, uchar, 2, 11))\012#defin",
"e VME_GET_SICInput_NeighborPixelLum36(p) (VME_Input_G1(p, uchar, 2, 12))\012#define VME_GET_SICInput_NeighborPixelLum37(p) (VME_Input_G1(p, uchar, 2, 13))\012#define VME_GET_SICInput_NeighborPixelLum38(p) (VME_Input_G1(p, uchar, 2, 14))\012\012#define VME_GET_SICInput_CornerNeighborPixel1(p) (VME_Input_G1(p, uchar, 2, 15))\012\012#define VME_GET_SICInput_LeftModes(p) (VME_Input_G1(p, ushort, 2, 8))\012\012#define VME_GET_SICInput_TopModes(p) (VME_Input_G1(p, ushort, 2, 9))\012\012// Format = U8 pair\012#define VME_GET_SICInput_CornerNeighborPixelChroma(p)                          \\\012  (VME_Input_G1(p, ushort, 2, 10))\012\012#if 0\012// Format = U4U4\012#define VME_GET_SICInput_PenaltyIntra4x4NonDC(p) (VME_Input_G1(p, uchar, 2, 28))\012// Format = U2\012#define VME_GET_SICInput_ScaleFactorIntra8x8NonDC(p)                           \\\012  (VME_Input_G1(p, uchar, 2, 29) & 0x3)\012// Format = U2\012#define VME_GET_SICInput_ScaleFactorIntra16x16NonDC(p)                         \\\012  ((VME_Input_G1(p, uchar, 2, 29) & 0xC) >> 2)\012#else\012// Format = U8\012#define VME_GET_SICInput_Pen",
"altyIntra4x4NonDC(p) (VME_Input_G1(p, uchar, 2, 30))\012// Format = U8\012#define VME_GET_SICInput_PenaltyIntra8x8NonDC(p) (VME_Input_G1(p, uchar, 2, 29))\012// Format = U8\012#define VME_GET_SICInput_PenaltyIntra16x16NonDC(p)                             \\\012  (VME_Input_G1(p, uchar, 2, 28))\012#endif\012\012#define VME_GET_SICInput_NeighborPixelChroma0(p) (VME_Input_G1(p, uchar, 3, 0))\012#define VME_GET_SICInput_NeighborPixelChroma1(p) (VME_Input_G1(p, uchar, 3, 1))\012#define VME_GET_SICInput_NeighborPixelChroma2(p) (VME_Input_G1(p, uchar, 3, 2))\012#define VME_GET_SICInput_NeighborPixelChroma3(p) (VME_Input_G1(p, uchar, 3, 3))\012\012#define VME_GET_SICInput_NeighborPixelChroma4(p) (VME_Input_G1(p, uchar, 3, 4))\012#define VME_GET_SICInput_NeighborPixelChroma5(p) (VME_Input_G1(p, uchar, 3, 5))\012#define VME_GET_SICInput_NeighborPixelChroma6(p) (VME_Input_G1(p, uchar, 3, 6))\012#define VME_GET_SICInput_NeighborPixelChroma7(p) (VME_Input_G1(p, uchar, 3, 7))\012\012#define VME_GET_SICInput_NeighborPixelChroma8(p) (VME_Input_G1(p, uchar, 3, 8))\012#define VME_GET",
"_SICInput_NeighborPixelChroma9(p) (VME_Input_G1(p, uchar, 3, 9))\012#define VME_GET_SICInput_NeighborPixelChroma10(p)                              \\\012  (VME_Input_G1(p, uchar, 3, 10))\012#define VME_GET_SICInput_NeighborPixelChroma11(p)                              \\\012  (VME_Input_G1(p, uchar, 3, 11))\012\012#define VME_GET_SICInput_NeighborPixelChroma12(p)                              \\\012  (VME_Input_G1(p, uchar, 3, 12))\012#define VME_GET_SICInput_NeighborPixelChroma13(p)                              \\\012  (VME_Input_G1(p, uchar, 3, 13))\012#define VME_GET_SICInput_NeighborPixelChroma14(p)                              \\\012  (VME_Input_G1(p, uchar, 3, 14))\012#define VME_GET_SICInput_NeighborPixelChroma15(p)                              \\\012  (VME_Input_G1(p, uchar, 3, 15))\012\012#define VME_GET_SICInput_NeighborPixelChroma16(p)                              \\\012  (VME_Input_G1(p, uchar, 3, 16))\012#define VME_GET_SICInput_NeighborPixelChroma17(p)                              \\\012  (VME_Input_G1(p, uchar, 3, 17))\012#define VME_GET_SICInput_NeighborPixe",
"lChroma18(p)                              \\\012  (VME_Input_G1(p, uchar, 3, 18))\012#define VME_GET_SICInput_NeighborPixelChroma19(p)                              \\\012  (VME_Input_G1(p, uchar, 3, 19))\012\012#define VME_GET_SICInput_NeighborPixelChroma20(p)                              \\\012  (VME_Input_G1(p, uchar, 3, 20))\012#define VME_GET_SICInput_NeighborPixelChroma21(p)                              \\\012  (VME_Input_G1(p, uchar, 3, 21))\012#define VME_GET_SICInput_NeighborPixelChroma22(p)                              \\\012  (VME_Input_G1(p, uchar, 3, 22))\012#define VME_GET_SICInput_NeighborPixelChroma23(p)                              \\\012  (VME_Input_G1(p, uchar, 3, 23))\012\012#define VME_GET_SICInput_NeighborPixelChroma24(p)                              \\\012  (VME_Input_G1(p, uchar, 3, 24))\012#define VME_GET_SICInput_NeighborPixelChroma25(p)                              \\\012  (VME_Input_G1(p, uchar, 3, 25))\012#define VME_GET_SICInput_NeighborPixelChroma26(p)                              \\\012  (VME_Input_G1(p, uchar, 3, 26))\012#define VME_GET_SICInput",
"_NeighborPixelChroma27(p)                              \\\012  (VME_Input_G1(p, uchar, 3, 27))\012\012#define VME_GET_SICInput_NeighborPixelChroma28(p)                              \\\012  (VME_Input_G1(p, uchar, 3, 28))\012#define VME_GET_SICInput_NeighborPixelChroma29(p)                              \\\012  (VME_Input_G1(p, uchar, 3, 29))\012#define VME_GET_SICInput_NeighborPixelChroma30(p)                              \\\012  (VME_Input_G1(p, uchar, 3, 30))\012#define VME_GET_SICInput_NeighborPixelChroma31(p)                              \\\012  (VME_Input_G1(p, uchar, 3, 31))\012\012#define VME_GET_FBRInput_Ref0SubBlockX0(p) (VME_Input_G1(p, ushort, 0, 0))\012#define VME_GET_FBRInput_Ref0SubBlockY0(p) (VME_Input_G1(p, ushort, 0, 1))\012#define VME_GET_FBRInput_Ref1SubBlockX0(p) (VME_Input_G1(p, ushort, 0, 2))\012#define VME_GET_FBRInput_Ref1SubBlockY0(p) (VME_Input_G1(p, ushort, 0, 3))\012\012#define VME_GET_FBRInput_Ref0SubBlockX1(p) (VME_Input_G1(p, ushort, 0, 4))\012#define VME_GET_FBRInput_Ref0SubBlockY1(p) (VME_Input_G1(p, ushort, 0, 5))\012#define VME_GET_FBRI",
"nput_Ref1SubBlockX1(p) (VME_Input_G1(p, ushort, 0, 6))\012#define VME_GET_FBRInput_Ref1SubBlockY1(p) (VME_Input_G1(p, ushort, 0, 7))\012\012#define VME_GET_FBRInput_Ref0SubBlockX2(p) (VME_Input_G1(p, ushort, 0, 8))\012#define VME_GET_FBRInput_Ref0SubBlockY2(p) (VME_Input_G1(p, ushort, 0, 9))\012#define VME_GET_FBRInput_Ref1SubBlockX2(p) (VME_Input_G1(p, ushort, 0, 10))\012#define VME_GET_FBRInput_Ref1SubBlockY2(p) (VME_Input_G1(p, ushort, 0, 11))\012\012#define VME_GET_FBRInput_Ref0SubBlockX3(p) (VME_Input_G1(p, ushort, 0, 12))\012#define VME_GET_FBRInput_Ref0SubBlockY3(p) (VME_Input_G1(p, ushort, 0, 13))\012#define VME_GET_FBRInput_Ref1SubBlockX3(p) (VME_Input_G1(p, ushort, 0, 14))\012#define VME_GET_FBRInput_Ref1SubBlockY3(p) (VME_Input_G1(p, ushort, 0, 15))\012\012#define VME_GET_FBRInput_Ref0SubBlockX4(p) (VME_Input_G1(p, ushort, 1, 0))\012#define VME_GET_FBRInput_Ref0SubBlockY4(p) (VME_Input_G1(p, ushort, 1, 1))\012#define VME_GET_FBRInput_Ref1SubBlockX4(p) (VME_Input_G1(p, ushort, 1, 2))\012#define VME_GET_FBRInput_Ref1SubBlockY4(p) (VME_Input_G1(p, ",
"ushort, 1, 3))\012\012#define VME_GET_FBRInput_Ref0SubBlockX5(p) (VME_Input_G1(p, ushort, 1, 4))\012#define VME_GET_FBRInput_Ref0SubBlockY5(p) (VME_Input_G1(p, ushort, 1, 5))\012#define VME_GET_FBRInput_Ref1SubBlockX5(p) (VME_Input_G1(p, ushort, 1, 6))\012#define VME_GET_FBRInput_Ref1SubBlockY5(p) (VME_Input_G1(p, ushort, 1, 7))\012\012#define VME_GET_FBRInput_Ref0SubBlockX6(p) (VME_Input_G1(p, ushort, 1, 8))\012#define VME_GET_FBRInput_Ref0SubBlockY6(p) (VME_Input_G1(p, ushort, 1, 9))\012#define VME_GET_FBRInput_Ref1SubBlockX6(p) (VME_Input_G1(p, ushort, 1, 10))\012#define VME_GET_FBRInput_Ref1SubBlockY6(p) (VME_Input_G1(p, ushort, 1, 11))\012\012#define VME_GET_FBRInput_Ref0SubBlockX7(p) (VME_Input_G1(p, ushort, 1, 12))\012#define VME_GET_FBRInput_Ref0SubBlockY7(p) (VME_Input_G1(p, ushort, 1, 13))\012#define VME_GET_FBRInput_Ref1SubBlockX7(p) (VME_Input_G1(p, ushort, 1, 14))\012#define VME_GET_FBRInput_Ref1SubBlockY7(p) (VME_Input_G1(p, ushort, 1, 15))\012\012#define VME_GET_FBRInput_Ref0SubBlockX8(p) (VME_Input_G1(p, ushort, 2, 0))\012#define VME_GET_FBRInput",
"_Ref0SubBlockY8(p) (VME_Input_G1(p, ushort, 2, 1))\012#define VME_GET_FBRInput_Ref1SubBlockX8(p) (VME_Input_G1(p, ushort, 2, 2))\012#define VME_GET_FBRInput_Ref1SubBlockY8(p) (VME_Input_G1(p, ushort, 2, 3))\012\012#define VME_GET_FBRInput_Ref0SubBlockX9(p) (VME_Input_G1(p, ushort, 2, 4))\012#define VME_GET_FBRInput_Ref0SubBlockY9(p) (VME_Input_G1(p, ushort, 2, 5))\012#define VME_GET_FBRInput_Ref1SubBlockX9(p) (VME_Input_G1(p, ushort, 2, 6))\012#define VME_GET_FBRInput_Ref1SubBlockY9(p) (VME_Input_G1(p, ushort, 2, 7))\012\012#define VME_GET_FBRInput_Ref0SubBlockX10(p) (VME_Input_G1(p, ushort, 2, 8))\012#define VME_GET_FBRInput_Ref0SubBlockY10(p) (VME_Input_G1(p, ushort, 2, 9))\012#define VME_GET_FBRInput_Ref1SubBlockX10(p) (VME_Input_G1(p, ushort, 2, 10))\012#define VME_GET_FBRInput_Ref1SubBlockY10(p) (VME_Input_G1(p, ushort, 2, 11))\012\012#define VME_GET_FBRInput_Ref0SubBlockX11(p) (VME_Input_G1(p, ushort, 2, 12))\012#define VME_GET_FBRInput_Ref0SubBlockY11(p) (VME_Input_G1(p, ushort, 2, 13))\012#define VME_GET_FBRInput_Ref1SubBlockX11(p) (VME_Input_G1(p,",
" ushort, 2, 14))\012#define VME_GET_FBRInput_Ref1SubBlockY11(p) (VME_Input_G1(p, ushort, 2, 15))\012\012#define VME_GET_FBRInput_Ref0SubBlockX12(p) (VME_Input_G1(p, ushort, 3, 0))\012#define VME_GET_FBRInput_Ref0SubBlockY12(p) (VME_Input_G1(p, ushort, 3, 1))\012#define VME_GET_FBRInput_Ref1SubBlockX12(p) (VME_Input_G1(p, ushort, 3, 2))\012#define VME_GET_FBRInput_Ref1SubBlockY12(p) (VME_Input_G1(p, ushort, 3, 3))\012\012#define VME_GET_FBRInput_Ref0SubBlockX13(p) (VME_Input_G1(p, ushort, 3, 4))\012#define VME_GET_FBRInput_Ref0SubBlockY13(p) (VME_Input_G1(p, ushort, 3, 5))\012#define VME_GET_FBRInput_Ref1SubBlockX13(p) (VME_Input_G1(p, ushort, 3, 6))\012#define VME_GET_FBRInput_Ref1SubBlockY13(p) (VME_Input_G1(p, ushort, 3, 7))\012\012#define VME_GET_FBRInput_Ref0SubBlockX14(p) (VME_Input_G1(p, ushort, 3, 8))\012#define VME_GET_FBRInput_Ref0SubBlockY14(p) (VME_Input_G1(p, ushort, 3, 9))\012#define VME_GET_FBRInput_Ref1SubBlockX14(p) (VME_Input_G1(p, ushort, 3, 10))\012#define VME_GET_FBRInput_Ref1SubBlockY14(p) (VME_Input_G1(p, ushort, 3, 11))\012\012#define VME_",
"GET_FBRInput_Ref0SubBlockX15(p) (VME_Input_G1(p, ushort, 3, 12))\012#define VME_GET_FBRInput_Ref0SubBlockY15(p) (VME_Input_G1(p, ushort, 3, 13))\012#define VME_GET_FBRInput_Ref1SubBlockX15(p) (VME_Input_G1(p, ushort, 3, 14))\012#define VME_GET_FBRInput_Ref1SubBlockY15(p) (VME_Input_G1(p, ushort, 3, 15))\012\012#define VME_GET_IDMInput_SrcMBPixelMaskRow0(p) (VME_Input_G1(p, ushort, 0, 0))\012#define VME_GET_IDMInput_SrcMBPixelMaskRow1(p) (VME_Input_G1(p, ushort, 0, 1))\012#define VME_GET_IDMInput_SrcMBPixelMaskRow2(p) (VME_Input_G1(p, ushort, 0, 2))\012#define VME_GET_IDMInput_SrcMBPixelMaskRow3(p) (VME_Input_G1(p, ushort, 0, 3))\012#define VME_GET_IDMInput_SrcMBPixelMaskRow4(p) (VME_Input_G1(p, ushort, 0, 4))\012#define VME_GET_IDMInput_SrcMBPixelMaskRow5(p) (VME_Input_G1(p, ushort, 0, 5))\012#define VME_GET_IDMInput_SrcMBPixelMaskRow6(p) (VME_Input_G1(p, ushort, 0, 6))\012#define VME_GET_IDMInput_SrcMBPixelMaskRow7(p) (VME_Input_G1(p, ushort, 0, 7))\012#define VME_GET_IDMInput_SrcMBPixelMaskRow8(p) (VME_Input_G1(p, ushort, 0, 8))\012#define VME_GET_",
"IDMInput_SrcMBPixelMaskRow9(p) (VME_Input_G1(p, ushort, 0, 9))\012#define VME_GET_IDMInput_SrcMBPixelMaskRow10(p) (VME_Input_G1(p, ushort, 0, 10))\012#define VME_GET_IDMInput_SrcMBPixelMaskRow11(p) (VME_Input_G1(p, ushort, 0, 11))\012#define VME_GET_IDMInput_SrcMBPixelMaskRow12(p) (VME_Input_G1(p, ushort, 0, 12))\012#define VME_GET_IDMInput_SrcMBPixelMaskRow13(p) (VME_Input_G1(p, ushort, 0, 13))\012#define VME_GET_IDMInput_SrcMBPixelMaskRow14(p) (VME_Input_G1(p, ushort, 0, 14))\012#define VME_GET_IDMInput_SrcMBPixelMaskRow15(p) (VME_Input_G1(p, ushort, 0, 15))\012\012// Output\012\012#define MODE_INTER_16X16 0x00\012#define MODE_INTER_16X8 0x01\012#define MODE_INTER_8X16 0x02\012#define MODE_INTER_8X8 0x03\012#define MODE_INTER_MINOR 0x03\012#define VME_GET_UNIOutput_InterMbMode(p, v)                                    \\\012  (v = VME_Output_S1(p, uchar, 0, 0) & 0x3)\012\012#define MODE_INTRA_16X16 0x00\012#define MODE_INTRA_8X8 0x10\012#define MODE_INTRA_4X4 0x20\012#define MODE_INTRA_PCM 0x30\012#define VME_GET_UNIOutput_IntraMbMode(p, v)                                  ",
"  \\\012  (v = VME_Output_S1(p, uchar, 0, 0) & 0x30)\012\012#define MODE_FIELD_MB_POLARITY 0x80\012#define VME_GET_UNIOutput_FieldMbPolarityFlag(p, v)                            \\\012  (v = VME_Output_S1(p, uchar, 0, 0) & 0x80)\012\012#define VME_GET_UNIOutput_InterMbType(p, v)                                    \\\012  (v = VME_Output_S1(p, uchar, 0, 1) & 0x1F)\012\012#define VME_GET_UNIOutput_FieldMbFlag(p, v)                                    \\\012  (v = VME_Output_S1(p, uchar, 0, 1) & 0x40)\012\012#define VME_GET_UNIOutput_IntraMbType(p, v)                                    \\\012  (v = VME_Output_S1(p, uchar, 0, 2) & 0x1F)\012\012#define VME_GET_UNIOutput_IntraMbType(p, v)                                    \\\012  (v = VME_Output_S1(p, uchar, 0, 2) & 0x1F)\012\012#define VME_GET_UNIOutput_MvQuantity(p, v)                                     \\\012  (v = VME_Output_S1(p, uchar, 0, 3) & 0x1F)\012\012// Format = U16\012#define VME_GET_UNIOutput_BestInterDistortion(p, v)                            \\\012  (v = VME_Output_S1(p, ushort, 0, 4))\012\012// Format = U16\012#define VME_GET_UNIOutp",
"ut_SkipRawDistortion(p, v)                              \\\012  (v = VME_Output_S1(p, ushort, 0, 5))\012\012// Format = U16\012#define VME_GET_UNIOutput_BestIntraDistortion(p, v)                            \\\012  (v = VME_Output_S1(p, ushort, 0, 6))\012\012// Format = U16\012#define VME_GET_UNIOutput_BestChromaIntraDistortion(p, v)                      \\\012  (v = VME_Output_S1(p, ushort, 0, 7))\012\012#define VME_GET_UNIOutput_LumaIntraPredMode0(p, v)                             \\\012  (v = VME_Output_S1(p, ushort, 0, 8))\012#define VME_GET_UNIOutput_LumaIntraPredMode1(p, v)                             \\\012  (v = VME_Output_S1(p, ushort, 0, 9))\012#define VME_GET_UNIOutput_LumaIntraPredMode2(p, v)                             \\\012  (v = VME_Output_S1(p, ushort, 0, 10))\012#define VME_GET_UNIOutput_LumaIntraPredMode3(p, v)                             \\\012  (v = VME_Output_S1(p, ushort, 0, 11))\012\012// 8-bit field with the following definition:\012// 7    Reserved : MBZ (for IntraPredAvailFlagF - F (pixel[-1,7] available for\012// MbAff)\012// 6    Reserved : MBZ (for IntraP",
"redAvailFlagA/E - A (left neighbor top half\012// for MbAff)\012// 5    IntraPredAvailFlagE/A - A (Left neighbor or Left bottom half)\012// 4    IntraPredAvailFlagB - B (Upper neighbor)\012// 3    IntraPredAvailFlagC - C (Upper left neighbor)\012// 2    IntraPredAvailFlagD - D (Upper right neighbor)\012// 1:0  ChromaIntraPredMode\012#define VME_GET_UNIOutput_MbIntraStruct(p, v)                                  \\\012  (v = VME_Output_S1(p, uchar, 0, 24))\012\012// 8-bit field with the following definition:\012// Bits [1:0]: SubMbShape[0]\012// Bits [3:2]: SubMbShape[1]\012// Bits [5:4]: SubMbShape[2]\012// Bits [7:6]: SubMbShape[3]\012#define VME_GET_UNIOutput_SubMbShape(p, v) (v = VME_Output_S1(p, uchar, 0, 25))\012\012// 8-bit field with the following definition:\012// Bits [1:0]: SubMbPredMode[0]\012// Bits [3:2]: SubMbPredMode[1]\012// Bits [5:4]: SubMbPredMode[2]\012// Bits [7:6]: SubMbPredMode[3]\012#define VME_GET_UNIOutput_SubMbPredMode(p, v)                                  \\\012  (v = VME_Output_S1(p, uchar, 0, 26))\012\012// v is a 4x16 short type matrix that stores the mo",
"tion vectors as follows:\012// MVa[0].x, MVa[0].y, MVb[0].x, MVb[0].x\012// MVa[1].x, MVa[1].y, MVb[1].x, MVb[1].x\012// ...\012// MVa[15].x, MVa[15].y, MVb[15].x, MVb[15].x\012#define VME_GET_UNIOutput_Mvs(p, v)                                            \\\012  (v = p.format<short, 7, 32 / sizeof(short)>().select<4, 1, 16, 1>(1, 0))\012\012// v is a 1x16 short type matrix that stores the inter distortions as follows:\012// InterDistortion[0], InterDistortion[1], ..., InterDistortion[15]\012#define VME_GET_UNIOutput_InterDistortion(p, v)                                \\\012  (v = p.format<short, 7, 32 / sizeof(short)>().select<1, 1, 16, 1>(5, 0))\012\012// Format = U4\012#define VME_GET_UNIOutput_FwdBlk0RefID(p, v)                                   \\\012  (v = VME_Output_S1(p, uchar, 6, 0) & 0xF)\012#define VME_GET_UNIOutput_BwdBlk0RefID(p, v)                                   \\\012  (v = (VME_Output_S1(p, uchar, 6, 0) >> 4) & 0xF)\012#define VME_GET_UNIOutput_FwdBlk1RefID(p, v)                                   \\\012  (v = VME_Output_S1(p, uchar, 6, 1) & 0xF)\012#def",
"ine VME_GET_UNIOutput_BwdBlk1RefID(p, v)                                   \\\012  (v = (VME_Output_S1(p, uchar, 6, 1) >> 4) & 0xF)\012#define VME_GET_UNIOutput_FwdBlk2RefID(p, v)                                   \\\012  (v = VME_Output_S1(p, uchar, 6, 2) & 0xF)\012#define VME_GET_UNIOutput_BwdBlk2RefID(p, v)                                   \\\012  (v = (VME_Output_S1(p, uchar, 6, 2) >> 4) & 0xF)\012#define VME_GET_UNIOutput_FwdBlk3RefID(p, v)                                   \\\012  (v = VME_Output_S1(p, uchar, 6, 3) & 0xF)\012#define VME_GET_UNIOutput_BwdBlk3RefID(p, v)                                   \\\012  (v = (VME_Output_S1(p, uchar, 6, 3) >> 4) & 0xF)\012\012#define VME_GET_UNIOutput_Blk0LumaNZC(p, v) (v = VME_Output_S1(p, uchar, 6, 4))\012#define VME_GET_UNIOutput_Blk1LumaNZC(p, v) (v = VME_Output_S1(p, uchar, 6, 5))\012#define VME_GET_UNIOutput_Blk2LumaNZC(p, v) (v = VME_Output_S1(p, uchar, 6, 6))\012#define VME_GET_UNIOutput_Blk3LumaNZC(p, v) (v = VME_Output_S1(p, uchar, 6, 7))\012\012// Format = U8\012#define VME_GET_UNIOutput_Blk0ChromaCbNZC(p, ",
"v)                                \\\012  (v = VME_Output_S1(p, uchar, 6, 16))\012#define VME_GET_UNIOutput_Blk0ChromaCrNZC(p, v)                                \\\012  (v = VME_Output_S1(p, uchar, 6, 17))\012\012#define VME_GET_UNIOutput_SumInterDistL0(p, v)                                 \\\012  (v = VME_Output_S1(p, uint, 6, 6) & 0x3FFFFFF)\012#define VME_GET_UNIOutput_SumInterDistL1(p, v)                                 \\\012  (v = VME_Output_S1(p, ushort, 6, 9) +                                        \\\012       ((VME_Output_S1(p, ushort, 0, 3) & 0x3FF) << 16))\012\012#define VME_GET_UNIOutput_MaxRef0InterDist(p, v)                               \\\012  (v = VME_Output_S1(p, ushort, 6, 14))\012#define VME_GET_UNIOutput_MaxRef1InterDist(p, v)                               \\\012  (v = VME_Output_S1(p, ushort, 6, 15))\012\012#define MODE_INTER_16X16 0x00\012#define MODE_INTER_16X8 0x01\012#define MODE_INTER_8X16 0x02\012#define MODE_INTER_8X8 0x03\012#define MODE_INTER_MINOR 0x03\012#define VME_GET_IMEOutput_InterMbMode(p, v)                                    \\\012  (v = V",
"ME_Output_S1(p, uchar, 0, 0) & 0x3)\012\012#define MODE_INTRA_16X16 0x00\012#define MODE_INTRA_8X8 0x10\012#define MODE_INTRA_4X4 0x20\012#define MODE_INTRA_PCM 0x30\012#define VME_GET_IMEOutput_IntraMbMode(p, v)                                    \\\012  (v = VME_Output_S1(p, uchar, 0, 0) & 0x30)\012\012#define MODE_FIELD_MB_POLARITY 0x80\012#define VME_GET_IMEOutput_FieldMbPolarityFlag(p, v)                            \\\012  (v = VME_Output_S1(p, uchar, 0, 0) & 0x80)\012\012#define VME_GET_IMEOutput_InterMbType(p, v)                                    \\\012  (v = VME_Output_S1(p, uchar, 0, 1) & 0x1F)\012\012#define VME_GET_IMEOutput_FieldMbFlag(p, v)                                    \\\012  (v = VME_Output_S1(p, uchar, 0, 1) & 0x40)\012\012#define VME_GET_IMEOutput_IntraMbType(p, v)                                    \\\012  (v = VME_Output_S1(p, uchar, 0, 2) & 0x1F)\012\012#define VME_GET_IMEOutput_IntraMbType(p, v)                                    \\\012  (v = VME_Output_S1(p, uchar, 0, 2) & 0x1F)\012\012#define VME_GET_IMEOutput_MvQuantity(p, v)                                 ",
"    \\\012  (v = VME_Output_S1(p, uchar, 0, 3) & 0x1F)\012\012// Format = U16\012#define VME_GET_IMEOutput_BestInterDistortion(p, v)                            \\\012  (v = VME_Output_S1(p, ushort, 0, 4))\012\012// Format = U16\012#define VME_GET_IMEOutput_SkipRawDistortion(p, v)                              \\\012  (v = VME_Output_S1(p, ushort, 0, 5))\012\012// Format = U16\012#define VME_GET_IMEOutput_BestIntraDistortion(p, v)                            \\\012  (v = VME_Output_S1(p, ushort, 0, 6))\012\012// Format = U16\012#define VME_GET_IMEOutput_BestChromaIntraDistortion(p, v)                      \\\012  (v = VME_Output_S1(p, ushort, 0, 7))\012\012#define VME_GET_IMEOutput_LumaIntraPredMode0(p, v)                             \\\012  (v = VME_Output_S1(p, ushort, 0, 8))\012#define VME_GET_IMEOutput_LumaIntraPredMode1(p, v)                             \\\012  (v = VME_Output_S1(p, ushort, 0, 9))\012#define VME_GET_IMEOutput_LumaIntraPredMode2(p, v)                             \\\012  (v = VME_Output_S1(p, ushort, 0, 10))\012#define VME_GET_IMEOutput_LumaIntraPredMode3(p, v)             ",
"                \\\012  (v = VME_Output_S1(p, ushort, 0, 11))\012\012// 8-bit field with the following definition:\012// 7    Reserved : MBZ (for IntraPredAvailFlagF - F (pixel[-1,7] available for\012// MbAff)\012// 6    Reserved : MBZ (for IntraPredAvailFlagA/E - A (left neighbor top half\012// for MbAff)\012// 5    IntraPredAvailFlagE/A - A (Left neighbor or Left bottom half)\012// 4    IntraPredAvailFlagB - B (Upper neighbor)\012// 3    IntraPredAvailFlagC - C (Upper left neighbor)\012// 2    IntraPredAvailFlagD - D (Upper right neighbor)\012// 1:0  ChromaIntraPredMode\012#define VME_GET_IMEOutput_MbIntraStruct(p, v)                                  \\\012  (v = VME_Output_S1(p, uchar, 0, 24))\012\012// 8-bit field with the following definition:\012// Bits [1:0]: SubMbShape[0]\012// Bits [3:2]: SubMbShape[1]\012// Bits [5:4]: SubMbShape[2]\012// Bits [7:6]: SubMbShape[3]\012#define VME_GET_IMEOutput_SubMbShape(p, v) (v = VME_Output_S1(p, uchar, 0, 25))\012\012// 8-bit field with the following definition:\012// Bits [1:0]: SubMbPredMode[0]\012// Bits [3:2]: SubMbPredMode[1]\012// Bits ",
"[5:4]: SubMbPredMode[2]\012// Bits [7:6]: SubMbPredMode[3]\012#define VME_GET_IMEOutput_SubMbPredMode(p, v)                                  \\\012  (v = VME_Output_S1(p, uchar, 0, 26))\012\012// v is a 4x16 short type matrix that stores the motion vectors as follows:\012// MVa[0].x, MVa[0].y, MVb[0].x, MVb[0].x\012// MVa[1].x, MVa[1].y, MVb[1].x, MVb[1].x\012// ...\012// MVa[15].x, MVa[15].y, MVb[15].x, MVb[15].x\012#define VME_GET_IMEOutput_Mvs(p, v)                                            \\\012  (v = p.format<short, 7, 32 / sizeof(short)>().select<4, 1, 16, 1>(1, 0))\012\012// v is a 1x16 short type matrix that stores the inter distortions as follows:\012// InterDistortion[0], InterDistortion[1], ..., InterDistortion[15]\012#define VME_GET_IMEOutput_InterDistortion(p, v)                                \\\012  (v = p.format<short, 7, 32 / sizeof(short)>().select<1, 1, 16, 1>(5, 0))\012\012// Format = U4\012#define VME_GET_IMEOutput_FwdBlk0RefID(p, v)                                   \\\012  (v = VME_Output_S1(p, uchar, 6, 0) & 0xF)\012#define VME_GET_IMEOutput_BwdBlk0",
"RefID(p, v)                                   \\\012  (v = (VME_Output_S1(p, uchar, 6, 0) >> 4) & 0xF)\012#define VME_GET_IMEOutput_FwdBlk1RefID(p, v)                                   \\\012  (v = VME_Output_S1(p, uchar, 6, 1) & 0xF)\012#define VME_GET_IMEOutput_BwdBlk1RefID(p, v)                                   \\\012  (v = (VME_Output_S1(p, uchar, 6, 1) >> 4) & 0xF)\012#define VME_GET_IMEOutput_FwdBlk2RefID(p, v)                                   \\\012  (v = VME_Output_S1(p, uchar, 6, 2) & 0xF)\012#define VME_GET_IMEOutput_BwdBlk2RefID(p, v)                                   \\\012  (v = (VME_Output_S1(p, uchar, 6, 2) >> 4) & 0xF)\012#define VME_GET_IMEOutput_FwdBlk3RefID(p, v)                                   \\\012  (v = VME_Output_S1(p, uchar, 6, 3) & 0xF)\012#define VME_GET_IMEOutput_BwdBlk3RefID(p, v)                                   \\\012  (v = (VME_Output_S1(p, uchar, 6, 3) >> 4) & 0xF)\012\012#define VME_GET_IMEOutput_Blk0LumaNZC(p, v) (v = VME_Output_S1(p, uchar, 6, 4))\012#define VME_GET_IMEOutput_Blk1LumaNZC(p, v) (v = VME_Output_S1(p, uchar, ",
"6, 5))\012#define VME_GET_IMEOutput_Blk2LumaNZC(p, v) (v = VME_Output_S1(p, uchar, 6, 6))\012#define VME_GET_IMEOutput_Blk3LumaNZC(p, v) (v = VME_Output_S1(p, uchar, 6, 7))\012\012// Format = U8\012#define VME_GET_IMEOutput_Blk0ChromaCbNZC(p, v)                                \\\012  (v = VME_Output_S1(p, uchar, 6, 16))\012#define VME_GET_IMEOutput_Blk0ChromaCrNZC(p, v)                                \\\012  (v = VME_Output_S1(p, uchar, 6, 17))\012\012// Format = U16\012#define VME_GET_IMEOutput_Rec0_16x8_0Distortion(p, v)                          \\\012  (v = VME_Output_S1(p, ushort, 7, 0))\012#define VME_GET_IMEOutput_Rec0_16x8_1Distortion(p, v)                          \\\012  (v = VME_Output_S1(p, ushort, 7, 1))\012#define VME_GET_IMEOutput_Rec0_8x16_0Distortion(p, v)                          \\\012  (v = VME_Output_S1(p, ushort, 7, 2))\012#define VME_GET_IMEOutput_Rec0_8x16_1Distortion(p, v)                          \\\012  (v = VME_Output_S1(p, ushort, 7, 3))\012#define VME_GET_IMEOutput_Rec0_8x8_0Distortion(p, v)                           \\\012  (v = VME_Output_S1(p,",
" ushort, 7, 4))\012#define VME_GET_IMEOutput_Rec0_8x8_1Distortion(p, v)                           \\\012  (v = VME_Output_S1(p, ushort, 7, 5))\012#define VME_GET_IMEOutput_Rec0_8x8_2Distortion(p, v)                           \\\012  (v = VME_Output_S1(p, ushort, 7, 6))\012#define VME_GET_IMEOutput_Rec0_8x8_3Distortion(p, v)                           \\\012  (v = VME_Output_S1(p, ushort, 7, 7))\012#define VME_GET_IMEOutput_Rec0_16x16_Distortion(p, v)                          \\\012  (v = VME_Output_S1(p, ushort, 7, 8))\012\012// Format = U4\012#define VME_GET_IMEOutput_Rec0_16x16_RefID(p, v)                               \\\012  (v = VME_Output_S1(p, uchar, 7, 18))\012\012// Format = U16\012#define VME_GET_IMEOutput_Rec0_16x16_X(p, v)                                   \\\012  (v = VME_Output_S1(p, ushort, 7, 10))\012#define VME_GET_IMEOutput_Rec0_16x16_Y(p, v)                                   \\\012  (v = VME_Output_S1(p, ushort, 7, 11))\012\012// Format = U4\012#define VME_GET_IMEOutput_Rec0_16x8_0RefID(p, v)                               \\\012  (v = VME_Output_S1(p, uchar, 7, 24",
") & 0xF)\012#define VME_GET_IMEOutput_Rec0_16x8_1RefID(p, v)                               \\\012  (v = (VME_Output_S1(p, uchar, 7, 24) & 0xF0) >> 4)\012#define VME_GET_IMEOutput_Rec0_8x16_0RefID(p, v)                               \\\012  (v = VME_Output_S1(p, uchar, 7, 25) & 0xF)\012#define VME_GET_IMEOutput_Rec0_8x16_1RefID(p, v)                               \\\012  (v = (VME_Output_S1(p, uchar, 7, 25) & 0xF0) >> 4)\012#define VME_GET_IMEOutput_Rec0_8x8_0RefID(p, v)                                \\\012  (v = VME_Output_S1(p, uchar, 7, 26) & 0xF)\012#define VME_GET_IMEOutput_Rec0_8x8_1RefID(p, v)                                \\\012  (v = (VME_Output_S1(p, uchar, 7, 26) & 0xF0) >> 4)\012#define VME_GET_IMEOutput_Rec0_8x8_2RefID(p, v)                                \\\012  (v = VME_Output_S1(p, uchar, 7, 27) & 0xF)\012#define VME_GET_IMEOutput_Rec0_8x8_3RefID(p, v)                                \\\012  (v = (VME_Output_S1(p, uchar, 7, 27) & 0xF0) >> 4)\012\012// Format = U16\012#define VME_GET_IMEOutput_Rec0_16x8_0X(p, v)                                   \\\012  (",
"v = VME_Output_S1(p, ushort, 8, 0))\012#define VME_GET_IMEOutput_Rec0_16x8_0Y(p, v)                                   \\\012  (v = VME_Output_S1(p, ushort, 8, 1))\012#define VME_GET_IMEOutput_Rec0_16x8_1X(p, v)                                   \\\012  (v = VME_Output_S1(p, ushort, 8, 2))\012#define VME_GET_IMEOutput_Rec0_16x8_1Y(p, v)                                   \\\012  (v = VME_Output_S1(p, ushort, 8, 3))\012#define VME_GET_IMEOutput_Rec0_8x16_0X(p, v)                                   \\\012  (v = VME_Output_S1(p, ushort, 8, 4))\012#define VME_GET_IMEOutput_Rec0_8x16_0Y(p, v)                                   \\\012  (v = VME_Output_S1(p, ushort, 8, 5))\012#define VME_GET_IMEOutput_Rec0_8x16_1X(p, v)                                   \\\012  (v = VME_Output_S1(p, ushort, 8, 6))\012#define VME_GET_IMEOutput_Rec0_8x16_1Y(p, v)                                   \\\012  (v = VME_Output_S1(p, ushort, 8, 7))\012#define VME_GET_IMEOutput_Rec0_8x8_0X(p, v) (v = VME_Output_S1(p, ushort, 8, 8))\012#define VME_GET_IMEOutput_Rec0_8x8_0Y(p, v) (v = VME_Output_S1(p, u",
"short, 8, 9))\012#define VME_GET_IMEOutput_Rec0_8x8_1X(p, v)                                    \\\012  (v = VME_Output_S1(p, ushort, 8, 10))\012#define VME_GET_IMEOutput_Rec0_8x8_1Y(p, v)                                    \\\012  (v = VME_Output_S1(p, ushort, 8, 11))\012#define VME_GET_IMEOutput_Rec0_8x8_2X(p, v)                                    \\\012  (v = VME_Output_S1(p, ushort, 8, 12))\012#define VME_GET_IMEOutput_Rec0_8x8_2Y(p, v)                                    \\\012  (v = VME_Output_S1(p, ushort, 8, 13))\012#define VME_GET_IMEOutput_Rec0_8x8_3X(p, v)                                    \\\012  (v = VME_Output_S1(p, ushort, 8, 14))\012#define VME_GET_IMEOutput_Rec0_8x8_3Y(p, v)                                    \\\012  (v = VME_Output_S1(p, ushort, 8, 15))\012\012// Format = U16\012#define VME_GET_IMEOutput_Rec1_16x8_0Distortion(p, v)                          \\\012  (v = VME_Output_S1(p, ushort, 9, 0))\012#define VME_GET_IMEOutput_Rec1_16x8_1Distortion(p, v)                          \\\012  (v = VME_Output_S1(p, ushort, 9, 1))\012#define VME_GET_IMEOutput_R",
"ec1_8x16_0Distortion(p, v)                          \\\012  (v = VME_Output_S1(p, ushort, 9, 2))\012#define VME_GET_IMEOutput_Rec1_8x16_1Distortion(p, v)                          \\\012  (v = VME_Output_S1(p, ushort, 9, 3))\012#define VME_GET_IMEOutput_Rec1_8x8_0Distortion(p, v)                           \\\012  (v = VME_Output_S1(p, ushort, 9, 4))\012#define VME_GET_IMEOutput_Rec1_8x8_1Distortion(p, v)                           \\\012  (v = VME_Output_S1(p, ushort, 9, 5))\012#define VME_GET_IMEOutput_Rec1_8x8_2Distortion(p, v)                           \\\012  (v = VME_Output_S1(p, ushort, 9, 6))\012#define VME_GET_IMEOutput_Rec1_8x8_3Distortion(p, v)                           \\\012  (v = VME_Output_S1(p, ushort, 9, 7))\012#define VME_GET_IMEOutput_Rec1_16x16_Distortion(p, v)                          \\\012  (v = VME_Output_S1(p, ushort, 9, 8))\012\012// Format = U4\012#define VME_GET_IMEOutput_Rec1_16x16_RefID(p, v)                               \\\012  (v = VME_Output_S1(p, uchar, 9, 18))\012\012// Format = U16\012#define VME_GET_IMEOutput_Rec1_16x16_X(p, v)              ",
"                     \\\012  (v = VME_Output_S1(p, ushort, 9, 10))\012#define VME_GET_IMEOutput_Rec1_16x16_Y(p, v)                                   \\\012  (v = VME_Output_S1(p, ushort, 9, 11))\012\012// Format = U4\012#define VME_GET_IMEOutput_Rec1_16x8_0RefID(p, v)                               \\\012  (v = VME_Output_S1(p, uchar, 9, 24) & 0xF)\012#define VME_GET_IMEOutput_Rec1_16x8_1RefID(p, v)                               \\\012  (v = (VME_Output_S1(p, uchar, 9, 24) & 0xF0) >> 4)\012#define VME_GET_IMEOutput_Rec1_8x16_0RefID(p, v)                               \\\012  (v = VME_Output_S1(p, uchar, 9, 25) & 0xF)\012#define VME_GET_IMEOutput_Rec1_8x16_1RefID(p, v)                               \\\012  (v = (VME_Output_S1(p, uchar, 9, 25) & 0xF0) >> 4)\012#define VME_GET_IMEOutput_Rec1_8x8_0RefID(p, v)                                \\\012  (v = VME_Output_S1(p, uchar, 9, 26) & 0xF)\012#define VME_GET_IMEOutput_Rec1_8x8_1RefID(p, v)                                \\\012  (v = (VME_Output_S1(p, uchar, 9, 26) & 0xF0) >> 4)\012#define VME_GET_IMEOutput_Rec1_8x8_2RefID(p,",
" v)                                \\\012  (v = VME_Output_S1(p, uchar, 9, 27) & 0xF)\012#define VME_GET_IMEOutput_Rec1_8x8_3RefID(p, v)                                \\\012  (v = (VME_Output_S1(p, uchar, 9, 27) & 0xF0) >> 4)\012\012// Format = U16\012#define VME_GET_IMEOutput_Rec1_16x8_0X(p, v)                                   \\\012  (v = VME_Output_S1(p, ushort, 10, 0))\012#define VME_GET_IMEOutput_Rec1_16x8_0Y(p, v)                                   \\\012  (v = VME_Output_S1(p, ushort, 10, 1))\012#define VME_GET_IMEOutput_Rec1_16x8_1X(p, v)                                   \\\012  (v = VME_Output_S1(p, ushort, 10, 2))\012#define VME_GET_IMEOutput_Rec1_16x8_1Y(p, v)                                   \\\012  (v = VME_Output_S1(p, ushort, 10, 3))\012#define VME_GET_IMEOutput_Rec1_8x16_0X(p, v)                                   \\\012  (v = VME_Output_S1(p, ushort, 10, 4))\012#define VME_GET_IMEOutput_Rec1_8x16_0Y(p, v)                                   \\\012  (v = VME_Output_S1(p, ushort, 10, 5))\012#define VME_GET_IMEOutput_Rec1_8x16_1X(p, v)                     ",
"              \\\012  (v = VME_Output_S1(p, ushort, 10, 6))\012#define VME_GET_IMEOutput_Rec1_8x16_1Y(p, v)                                   \\\012  (v = VME_Output_S1(p, ushort, 10, 7))\012#define VME_GET_IMEOutput_Rec1_8x8_0X(p, v)                                    \\\012  (v = VME_Output_S1(p, ushort, 10, 8))\012#define VME_GET_IMEOutput_Rec1_8x8_0Y(p, v)                                    \\\012  (v = VME_Output_S1(p, ushort, 10, 9))\012#define VME_GET_IMEOutput_Rec1_8x8_1X(p, v)                                    \\\012  (v = VME_Output_S1(p, ushort, 10, 10))\012#define VME_GET_IMEOutput_Rec1_8x8_1Y(p, v)                                    \\\012  (v = VME_Output_S1(p, ushort, 10, 11))\012#define VME_GET_IMEOutput_Rec1_8x8_2X(p, v)                                    \\\012  (v = VME_Output_S1(p, ushort, 10, 12))\012#define VME_GET_IMEOutput_Rec1_8x8_2Y(p, v)                                    \\\012  (v = VME_Output_S1(p, ushort, 10, 13))\012#define VME_GET_IMEOutput_Rec1_8x8_3X(p, v)                                    \\\012  (v = VME_Output_S1(p, ushort, 10, ",
"14))\012#define VME_GET_IMEOutput_Rec1_8x8_3Y(p, v)                                    \\\012  (v = VME_Output_S1(p, ushort, 10, 15))\012\012#define VME_GET_IDMOutput_DistortionMeshBlock0_SearchPoint0(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 0, 0))\012#define VME_GET_IDMOutput_DistortionMeshBlock0_SearchPoint1(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 0, 1))\012#define VME_GET_IDMOutput_DistortionMeshBlock0_SearchPoshort(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 0, 2))\012#define VME_GET_IDMOutput_DistortionMeshBlock0_SearchPoint3(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 0, 3))\012#define VME_GET_IDMOutput_DistortionMeshBlock0_SearchPoint4(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 0, 4))\012#define VME_GET_IDMOutput_DistortionMeshBlock0_SearchPoint5(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 0, 5))\012#define VME_GET_IDMOutput_DistortionMeshBlock0_SearchPoint6(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 0, 6))\012#define VME_GET_IDMOutput_DistortionMeshBlock0_SearchPoi",
"nt7(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 0, 7))\012#define VME_GET_IDMOutput_DistortionMeshBlock0_SearchPoint8(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 0, 8))\012#define VME_GET_IDMOutput_DistortionMeshBlock0_SearchPoint9(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 0, 9))\012#define VME_GET_IDMOutput_DistortionMeshBlock0_SearchPoint10(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 0, 10))\012#define VME_GET_IDMOutput_DistortionMeshBlock0_SearchPoint11(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 0, 11))\012#define VME_GET_IDMOutput_DistortionMeshBlock0_SearchPoint12(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 0, 12))\012#define VME_GET_IDMOutput_DistortionMeshBlock0_SearchPoint13(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 0, 13))\012#define VME_GET_IDMOutput_DistortionMeshBlock0_SearchPoint14(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 0, 14))\012#define VME_GET_IDMOutput_DistortionMeshBlock0_SearchPoint15(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 0,",
" 15))\012\012#define VME_GET_IDMOutput_DistortionMeshBlock1_SearchPoint0(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 1, 0))\012#define VME_GET_IDMOutput_DistortionMeshBlock1_SearchPoint1(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 1, 1))\012#define VME_GET_IDMOutput_DistortionMeshBlock1_SearchPoshort(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 1, 2))\012#define VME_GET_IDMOutput_DistortionMeshBlock1_SearchPoint3(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 1, 3))\012#define VME_GET_IDMOutput_DistortionMeshBlock1_SearchPoint4(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 1, 4))\012#define VME_GET_IDMOutput_DistortionMeshBlock1_SearchPoint5(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 1, 5))\012#define VME_GET_IDMOutput_DistortionMeshBlock1_SearchPoint6(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 1, 6))\012#define VME_GET_IDMOutput_DistortionMeshBlock1_SearchPoint7(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 1, 7))\012#define VME_GET_IDMOutput_DistortionMeshBlock1_SearchPoin",
"t8(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 1, 8))\012#define VME_GET_IDMOutput_DistortionMeshBlock1_SearchPoint9(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 1, 9))\012#define VME_GET_IDMOutput_DistortionMeshBlock1_SearchPoint10(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 1, 10))\012#define VME_GET_IDMOutput_DistortionMeshBlock1_SearchPoint11(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 1, 11))\012#define VME_GET_IDMOutput_DistortionMeshBlock1_SearchPoint12(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 1, 12))\012#define VME_GET_IDMOutput_DistortionMeshBlock1_SearchPoint13(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 1, 13))\012#define VME_GET_IDMOutput_DistortionMeshBlock1_SearchPoint14(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 1, 14))\012#define VME_GET_IDMOutput_DistortionMeshBlock1_SearchPoint15(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 1, 15))\012\012#define VME_GET_IDMOutput_DistortionMeshBlock2_SearchPoint0(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 2",
", 0))\012#define VME_GET_IDMOutput_DistortionMeshBlock2_SearchPoint1(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 2, 1))\012#define VME_GET_IDMOutput_DistortionMeshBlock2_SearchPoshort(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 2, 2))\012#define VME_GET_IDMOutput_DistortionMeshBlock2_SearchPoint3(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 2, 3))\012#define VME_GET_IDMOutput_DistortionMeshBlock2_SearchPoint4(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 2, 4))\012#define VME_GET_IDMOutput_DistortionMeshBlock2_SearchPoint5(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 2, 5))\012#define VME_GET_IDMOutput_DistortionMeshBlock2_SearchPoint6(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 2, 6))\012#define VME_GET_IDMOutput_DistortionMeshBlock2_SearchPoint7(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 2, 7))\012#define VME_GET_IDMOutput_DistortionMeshBlock2_SearchPoint8(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 2, 8))\012#define VME_GET_IDMOutput_DistortionMeshBlock2_SearchPoint",
"9(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 2, 9))\012#define VME_GET_IDMOutput_DistortionMeshBlock2_SearchPoint10(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 2, 10))\012#define VME_GET_IDMOutput_DistortionMeshBlock2_SearchPoint11(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 2, 11))\012#define VME_GET_IDMOutput_DistortionMeshBlock2_SearchPoint12(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 2, 12))\012#define VME_GET_IDMOutput_DistortionMeshBlock2_SearchPoint13(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 2, 13))\012#define VME_GET_IDMOutput_DistortionMeshBlock2_SearchPoint14(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 2, 14))\012#define VME_GET_IDMOutput_DistortionMeshBlock2_SearchPoint15(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 2, 15))\012\012#define VME_GET_IDMOutput_DistortionMeshBlock3_SearchPoint0(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 3, 0))\012#define VME_GET_IDMOutput_DistortionMeshBlock3_SearchPoint1(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 3,",
" 1))\012#define VME_GET_IDMOutput_DistortionMeshBlock3_SearchPoshort(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 3, 2))\012#define VME_GET_IDMOutput_DistortionMeshBlock3_SearchPoint3(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 3, 3))\012#define VME_GET_IDMOutput_DistortionMeshBlock3_SearchPoint4(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 3, 4))\012#define VME_GET_IDMOutput_DistortionMeshBlock3_SearchPoint5(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 3, 5))\012#define VME_GET_IDMOutput_DistortionMeshBlock3_SearchPoint6(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 3, 6))\012#define VME_GET_IDMOutput_DistortionMeshBlock3_SearchPoint7(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 3, 7))\012#define VME_GET_IDMOutput_DistortionMeshBlock3_SearchPoint8(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 3, 8))\012#define VME_GET_IDMOutput_DistortionMeshBlock3_SearchPoint9(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 3, 9))\012#define VME_GET_IDMOutput_DistortionMeshBlock3_SearchPoint1",
"0(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 3, 10))\012#define VME_GET_IDMOutput_DistortionMeshBlock3_SearchPoint11(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 3, 11))\012#define VME_GET_IDMOutput_DistortionMeshBlock3_SearchPoint12(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 3, 12))\012#define VME_GET_IDMOutput_DistortionMeshBlock3_SearchPoint13(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 3, 13))\012#define VME_GET_IDMOutput_DistortionMeshBlock3_SearchPoint14(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 3, 14))\012#define VME_GET_IDMOutput_DistortionMeshBlock3_SearchPoint15(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 3, 15))\012\012#define VME_GET_IDMOutput_DistortionMeshBlock4_SearchPoint0(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 4, 0))\012#define VME_GET_IDMOutput_DistortionMeshBlock4_SearchPoint1(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 4, 1))\012#define VME_GET_IDMOutput_DistortionMeshBlock4_SearchPoshort(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 4, ",
"2))\012#define VME_GET_IDMOutput_DistortionMeshBlock4_SearchPoint3(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 4, 3))\012#define VME_GET_IDMOutput_DistortionMeshBlock4_SearchPoint4(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 4, 4))\012#define VME_GET_IDMOutput_DistortionMeshBlock4_SearchPoint5(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 4, 5))\012#define VME_GET_IDMOutput_DistortionMeshBlock4_SearchPoint6(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 4, 6))\012#define VME_GET_IDMOutput_DistortionMeshBlock4_SearchPoint7(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 4, 7))\012#define VME_GET_IDMOutput_DistortionMeshBlock4_SearchPoint8(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 4, 8))\012#define VME_GET_IDMOutput_DistortionMeshBlock4_SearchPoint9(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 4, 9))\012#define VME_GET_IDMOutput_DistortionMeshBlock4_SearchPoint10(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 4, 10))\012#define VME_GET_IDMOutput_DistortionMeshBlock4_SearchPoint1",
"1(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 4, 11))\012#define VME_GET_IDMOutput_DistortionMeshBlock4_SearchPoint12(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 4, 12))\012#define VME_GET_IDMOutput_DistortionMeshBlock4_SearchPoint13(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 4, 13))\012#define VME_GET_IDMOutput_DistortionMeshBlock4_SearchPoint14(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 4, 14))\012#define VME_GET_IDMOutput_DistortionMeshBlock4_SearchPoint15(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 4, 15))\012\012#define VME_GET_IDMOutput_DistortionMeshBlock5_SearchPoint0(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 5, 0))\012#define VME_GET_IDMOutput_DistortionMeshBlock5_SearchPoint1(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 5, 1))\012#define VME_GET_IDMOutput_DistortionMeshBlock5_SearchPoshort(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 5, 2))\012#define VME_GET_IDMOutput_DistortionMeshBlock5_SearchPoint3(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 5, 3",
"))\012#define VME_GET_IDMOutput_DistortionMeshBlock5_SearchPoint4(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 5, 4))\012#define VME_GET_IDMOutput_DistortionMeshBlock5_SearchPoint5(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 5, 5))\012#define VME_GET_IDMOutput_DistortionMeshBlock5_SearchPoint6(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 5, 6))\012#define VME_GET_IDMOutput_DistortionMeshBlock5_SearchPoint7(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 5, 7))\012#define VME_GET_IDMOutput_DistortionMeshBlock5_SearchPoint8(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 5, 8))\012#define VME_GET_IDMOutput_DistortionMeshBlock5_SearchPoint9(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 5, 9))\012#define VME_GET_IDMOutput_DistortionMeshBlock5_SearchPoint10(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 5, 10))\012#define VME_GET_IDMOutput_DistortionMeshBlock5_SearchPoint11(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 5, 11))\012#define VME_GET_IDMOutput_DistortionMeshBlock5_SearchPoint1",
"2(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 5, 12))\012#define VME_GET_IDMOutput_DistortionMeshBlock5_SearchPoint13(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 5, 13))\012#define VME_GET_IDMOutput_DistortionMeshBlock5_SearchPoint14(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 5, 14))\012#define VME_GET_IDMOutput_DistortionMeshBlock5_SearchPoint15(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 5, 15))\012\012#define VME_GET_IDMOutput_DistortionMeshBlock6_SearchPoint0(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 6, 0))\012#define VME_GET_IDMOutput_DistortionMeshBlock6_SearchPoint1(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 6, 1))\012#define VME_GET_IDMOutput_DistortionMeshBlock6_SearchPoshort(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 6, 2))\012#define VME_GET_IDMOutput_DistortionMeshBlock6_SearchPoint3(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 6, 3))\012#define VME_GET_IDMOutput_DistortionMeshBlock6_SearchPoint4(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 6, 4)",
")\012#define VME_GET_IDMOutput_DistortionMeshBlock6_SearchPoint5(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 6, 5))\012#define VME_GET_IDMOutput_DistortionMeshBlock6_SearchPoint6(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 6, 6))\012#define VME_GET_IDMOutput_DistortionMeshBlock6_SearchPoint7(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 6, 7))\012#define VME_GET_IDMOutput_DistortionMeshBlock6_SearchPoint8(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 6, 8))\012#define VME_GET_IDMOutput_DistortionMeshBlock6_SearchPoint9(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 6, 9))\012#define VME_GET_IDMOutput_DistortionMeshBlock6_SearchPoint10(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 6, 10))\012#define VME_GET_IDMOutput_DistortionMeshBlock6_SearchPoint11(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 6, 11))\012#define VME_GET_IDMOutput_DistortionMeshBlock6_SearchPoint12(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 6, 12))\012#define VME_GET_IDMOutput_DistortionMeshBlock6_SearchPoint1",
"3(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 6, 13))\012#define VME_GET_IDMOutput_DistortionMeshBlock6_SearchPoint14(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 6, 14))\012#define VME_GET_IDMOutput_DistortionMeshBlock6_SearchPoint15(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 6, 15))\012\012#define VME_GET_IDMOutput_DistortionMeshBlock7_SearchPoint0(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 7, 0))\012#define VME_GET_IDMOutput_DistortionMeshBlock7_SearchPoint1(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 7, 1))\012#define VME_GET_IDMOutput_DistortionMeshBlock7_SearchPoshort(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 7, 2))\012#define VME_GET_IDMOutput_DistortionMeshBlock7_SearchPoint3(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 7, 3))\012#define VME_GET_IDMOutput_DistortionMeshBlock7_SearchPoint4(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 7, 4))\012#define VME_GET_IDMOutput_DistortionMeshBlock7_SearchPoint5(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 7, 5))",
"\012#define VME_GET_IDMOutput_DistortionMeshBlock7_SearchPoint6(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 7, 6))\012#define VME_GET_IDMOutput_DistortionMeshBlock7_SearchPoint7(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 7, 7))\012#define VME_GET_IDMOutput_DistortionMeshBlock7_SearchPoint8(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 7, 8))\012#define VME_GET_IDMOutput_DistortionMeshBlock7_SearchPoint9(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 7, 9))\012#define VME_GET_IDMOutput_DistortionMeshBlock7_SearchPoint10(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 7, 10))\012#define VME_GET_IDMOutput_DistortionMeshBlock7_SearchPoint11(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 7, 11))\012#define VME_GET_IDMOutput_DistortionMeshBlock7_SearchPoint12(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 7, 12))\012#define VME_GET_IDMOutput_DistortionMeshBlock7_SearchPoint13(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 7, 13))\012#define VME_GET_IDMOutput_DistortionMeshBlock7_SearchPoint1",
"4(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 7, 14))\012#define VME_GET_IDMOutput_DistortionMeshBlock7_SearchPoint15(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 7, 15))\012\012#define VME_GET_IDMOutput_DistortionMeshBlock8_SearchPoint0(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 8, 0))\012#define VME_GET_IDMOutput_DistortionMeshBlock8_SearchPoint1(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 8, 1))\012#define VME_GET_IDMOutput_DistortionMeshBlock8_SearchPoshort(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 8, 2))\012#define VME_GET_IDMOutput_DistortionMeshBlock8_SearchPoint3(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 8, 3))\012#define VME_GET_IDMOutput_DistortionMeshBlock8_SearchPoint4(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 8, 4))\012#define VME_GET_IDMOutput_DistortionMeshBlock8_SearchPoint5(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 8, 5))\012#define VME_GET_IDMOutput_DistortionMeshBlock8_SearchPoint6(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 8, 6))\012",
"#define VME_GET_IDMOutput_DistortionMeshBlock8_SearchPoint7(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 8, 7))\012#define VME_GET_IDMOutput_DistortionMeshBlock8_SearchPoint8(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 8, 8))\012#define VME_GET_IDMOutput_DistortionMeshBlock8_SearchPoint9(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 8, 9))\012#define VME_GET_IDMOutput_DistortionMeshBlock8_SearchPoint10(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 8, 10))\012#define VME_GET_IDMOutput_DistortionMeshBlock8_SearchPoint11(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 8, 11))\012#define VME_GET_IDMOutput_DistortionMeshBlock8_SearchPoint12(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 8, 12))\012#define VME_GET_IDMOutput_DistortionMeshBlock8_SearchPoint13(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 8, 13))\012#define VME_GET_IDMOutput_DistortionMeshBlock8_SearchPoint14(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 8, 14))\012#define VME_GET_IDMOutput_DistortionMeshBlock8_SearchPoint1",
"5(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 8, 15))\012\012#define VME_GET_IDMOutput_DistortionMeshBlock9_SearchPoint0(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 9, 0))\012#define VME_GET_IDMOutput_DistortionMeshBlock9_SearchPoint1(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 9, 1))\012#define VME_GET_IDMOutput_DistortionMeshBlock9_SearchPoshort(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 9, 2))\012#define VME_GET_IDMOutput_DistortionMeshBlock9_SearchPoint3(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 9, 3))\012#define VME_GET_IDMOutput_DistortionMeshBlock9_SearchPoint4(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 9, 4))\012#define VME_GET_IDMOutput_DistortionMeshBlock9_SearchPoint5(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 9, 5))\012#define VME_GET_IDMOutput_DistortionMeshBlock9_SearchPoint6(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 9, 6))\012#define VME_GET_IDMOutput_DistortionMeshBlock9_SearchPoint7(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 9, 7))\012#",
"define VME_GET_IDMOutput_DistortionMeshBlock9_SearchPoint8(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 9, 8))\012#define VME_GET_IDMOutput_DistortionMeshBlock9_SearchPoint9(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 9, 9))\012#define VME_GET_IDMOutput_DistortionMeshBlock9_SearchPoint10(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 9, 10))\012#define VME_GET_IDMOutput_DistortionMeshBlock9_SearchPoint11(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 9, 11))\012#define VME_GET_IDMOutput_DistortionMeshBlock9_SearchPoint12(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 9, 12))\012#define VME_GET_IDMOutput_DistortionMeshBlock9_SearchPoint13(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 9, 13))\012#define VME_GET_IDMOutput_DistortionMeshBlock9_SearchPoint14(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 9, 14))\012#define VME_GET_IDMOutput_DistortionMeshBlock9_SearchPoint15(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 9, 15))\012\012#define VME_GET_IDMOutput_DistortionMeshBlock10_SearchPoin",
"t0(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 10, 0))\012#define VME_GET_IDMOutput_DistortionMeshBlock10_SearchPoint1(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 10, 1))\012#define VME_GET_IDMOutput_DistortionMeshBlock10_SearchPoshort(p, v)            \\\012  (v = VME_Output_S1(p, ushort, 10, 2))\012#define VME_GET_IDMOutput_DistortionMeshBlock10_SearchPoint3(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 10, 3))\012#define VME_GET_IDMOutput_DistortionMeshBlock10_SearchPoint4(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 10, 4))\012#define VME_GET_IDMOutput_DistortionMeshBlock10_SearchPoint5(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 10, 5))\012#define VME_GET_IDMOutput_DistortionMeshBlock10_SearchPoint6(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 10, 6))\012#define VME_GET_IDMOutput_DistortionMeshBlock10_SearchPoint7(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 10, 7))\012#define VME_GET_IDMOutput_DistortionMeshBlock10_SearchPoint8(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 1",
"0, 8))\012#define VME_GET_IDMOutput_DistortionMeshBlock10_SearchPoint9(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 10, 9))\012#define VME_GET_IDMOutput_DistortionMeshBlock10_SearchPoint10(p, v)            \\\012  (v = VME_Output_S1(p, ushort, 10, 10))\012#define VME_GET_IDMOutput_DistortionMeshBlock10_SearchPoint11(p, v)            \\\012  (v = VME_Output_S1(p, ushort, 10, 11))\012#define VME_GET_IDMOutput_DistortionMeshBlock10_SearchPoint12(p, v)            \\\012  (v = VME_Output_S1(p, ushort, 10, 12))\012#define VME_GET_IDMOutput_DistortionMeshBlock10_SearchPoint13(p, v)            \\\012  (v = VME_Output_S1(p, ushort, 10, 13))\012#define VME_GET_IDMOutput_DistortionMeshBlock10_SearchPoint14(p, v)            \\\012  (v = VME_Output_S1(p, ushort, 10, 14))\012#define VME_GET_IDMOutput_DistortionMeshBlock10_SearchPoint15(p, v)            \\\012  (v = VME_Output_S1(p, ushort, 10, 15))\012\012#define VME_GET_IDMOutput_DistortionMeshBlock11_SearchPoint0(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 11, 0))\012#define VME_GET_IDMOutput_DistortionMeshBl",
"ock11_SearchPoint1(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 11, 1))\012#define VME_GET_IDMOutput_DistortionMeshBlock11_SearchPoshort(p, v)            \\\012  (v = VME_Output_S1(p, ushort, 11, 2))\012#define VME_GET_IDMOutput_DistortionMeshBlock11_SearchPoint3(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 11, 3))\012#define VME_GET_IDMOutput_DistortionMeshBlock11_SearchPoint4(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 11, 4))\012#define VME_GET_IDMOutput_DistortionMeshBlock11_SearchPoint5(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 11, 5))\012#define VME_GET_IDMOutput_DistortionMeshBlock11_SearchPoint6(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 11, 6))\012#define VME_GET_IDMOutput_DistortionMeshBlock11_SearchPoint7(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 11, 7))\012#define VME_GET_IDMOutput_DistortionMeshBlock11_SearchPoint8(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 11, 8))\012#define VME_GET_IDMOutput_DistortionMeshBlock11_SearchPoint9(p, v)             \\\012  (v = VME_Output",
"_S1(p, ushort, 11, 9))\012#define VME_GET_IDMOutput_DistortionMeshBlock11_SearchPoint10(p, v)            \\\012  (v = VME_Output_S1(p, ushort, 11, 10))\012#define VME_GET_IDMOutput_DistortionMeshBlock11_SearchPoint11(p, v)            \\\012  (v = VME_Output_S1(p, ushort, 11, 11))\012#define VME_GET_IDMOutput_DistortionMeshBlock11_SearchPoint12(p, v)            \\\012  (v = VME_Output_S1(p, ushort, 11, 12))\012#define VME_GET_IDMOutput_DistortionMeshBlock11_SearchPoint13(p, v)            \\\012  (v = VME_Output_S1(p, ushort, 11, 13))\012#define VME_GET_IDMOutput_DistortionMeshBlock11_SearchPoint14(p, v)            \\\012  (v = VME_Output_S1(p, ushort, 11, 14))\012#define VME_GET_IDMOutput_DistortionMeshBlock11_SearchPoint15(p, v)            \\\012  (v = VME_Output_S1(p, ushort, 11, 15))\012\012#define VME_GET_IDMOutput_DistortionMeshBlock12_SearchPoint0(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 12, 0))\012#define VME_GET_IDMOutput_DistortionMeshBlock12_SearchPoint1(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 12, 1))\012#define VME_GET_IDMOutput_",
"DistortionMeshBlock12_SearchPoshort(p, v)            \\\012  (v = VME_Output_S1(p, ushort, 12, 2))\012#define VME_GET_IDMOutput_DistortionMeshBlock12_SearchPoint3(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 12, 3))\012#define VME_GET_IDMOutput_DistortionMeshBlock12_SearchPoint4(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 12, 4))\012#define VME_GET_IDMOutput_DistortionMeshBlock12_SearchPoint5(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 12, 5))\012#define VME_GET_IDMOutput_DistortionMeshBlock12_SearchPoint6(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 12, 6))\012#define VME_GET_IDMOutput_DistortionMeshBlock12_SearchPoint7(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 12, 7))\012#define VME_GET_IDMOutput_DistortionMeshBlock12_SearchPoint8(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 12, 8))\012#define VME_GET_IDMOutput_DistortionMeshBlock12_SearchPoint9(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 12, 9))\012#define VME_GET_IDMOutput_DistortionMeshBlock12_SearchPoint10(p, v)            \\\012 ",
" (v = VME_Output_S1(p, ushort, 12, 10))\012#define VME_GET_IDMOutput_DistortionMeshBlock12_SearchPoint11(p, v)            \\\012  (v = VME_Output_S1(p, ushort, 12, 11))\012#define VME_GET_IDMOutput_DistortionMeshBlock12_SearchPoint12(p, v)            \\\012  (v = VME_Output_S1(p, ushort, 12, 12))\012#define VME_GET_IDMOutput_DistortionMeshBlock12_SearchPoint13(p, v)            \\\012  (v = VME_Output_S1(p, ushort, 12, 13))\012#define VME_GET_IDMOutput_DistortionMeshBlock12_SearchPoint14(p, v)            \\\012  (v = VME_Output_S1(p, ushort, 12, 14))\012#define VME_GET_IDMOutput_DistortionMeshBlock12_SearchPoint15(p, v)            \\\012  (v = VME_Output_S1(p, ushort, 12, 15))\012\012#define VME_GET_IDMOutput_DistortionMeshBlock13_SearchPoint0(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 13, 0))\012#define VME_GET_IDMOutput_DistortionMeshBlock13_SearchPoint1(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 13, 1))\012#define VME_GET_IDMOutput_DistortionMeshBlock13_SearchPoshort(p, v)            \\\012  (v = VME_Output_S1(p, ushort, 13, 2))\012#define VM",
"E_GET_IDMOutput_DistortionMeshBlock13_SearchPoint3(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 13, 3))\012#define VME_GET_IDMOutput_DistortionMeshBlock13_SearchPoint4(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 13, 4))\012#define VME_GET_IDMOutput_DistortionMeshBlock13_SearchPoint5(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 13, 5))\012#define VME_GET_IDMOutput_DistortionMeshBlock13_SearchPoint6(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 13, 6))\012#define VME_GET_IDMOutput_DistortionMeshBlock13_SearchPoint7(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 13, 7))\012#define VME_GET_IDMOutput_DistortionMeshBlock13_SearchPoint8(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 13, 8))\012#define VME_GET_IDMOutput_DistortionMeshBlock13_SearchPoint9(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 13, 9))\012#define VME_GET_IDMOutput_DistortionMeshBlock13_SearchPoint10(p, v)            \\\012  (v = VME_Output_S1(p, ushort, 13, 10))\012#define VME_GET_IDMOutput_DistortionMeshBlock13_SearchPoint11(p, ",
"v)            \\\012  (v = VME_Output_S1(p, ushort, 13, 11))\012#define VME_GET_IDMOutput_DistortionMeshBlock13_SearchPoint12(p, v)            \\\012  (v = VME_Output_S1(p, ushort, 13, 12))\012#define VME_GET_IDMOutput_DistortionMeshBlock13_SearchPoint13(p, v)            \\\012  (v = VME_Output_S1(p, ushort, 13, 13))\012#define VME_GET_IDMOutput_DistortionMeshBlock13_SearchPoint14(p, v)            \\\012  (v = VME_Output_S1(p, ushort, 13, 14))\012#define VME_GET_IDMOutput_DistortionMeshBlock13_SearchPoint15(p, v)            \\\012  (v = VME_Output_S1(p, ushort, 13, 15))\012\012#define VME_GET_IDMOutput_DistortionMeshBlock14_SearchPoint0(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 14, 0))\012#define VME_GET_IDMOutput_DistortionMeshBlock14_SearchPoint1(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 14, 1))\012#define VME_GET_IDMOutput_DistortionMeshBlock14_SearchPoshort(p, v)            \\\012  (v = VME_Output_S1(p, ushort, 14, 2))\012#define VME_GET_IDMOutput_DistortionMeshBlock14_SearchPoint3(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 14",
", 3))\012#define VME_GET_IDMOutput_DistortionMeshBlock14_SearchPoint4(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 14, 4))\012#define VME_GET_IDMOutput_DistortionMeshBlock14_SearchPoint5(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 14, 5))\012#define VME_GET_IDMOutput_DistortionMeshBlock14_SearchPoint6(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 14, 6))\012#define VME_GET_IDMOutput_DistortionMeshBlock14_SearchPoint7(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 14, 7))\012#define VME_GET_IDMOutput_DistortionMeshBlock14_SearchPoint8(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 14, 8))\012#define VME_GET_IDMOutput_DistortionMeshBlock14_SearchPoint9(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 14, 9))\012#define VME_GET_IDMOutput_DistortionMeshBlock14_SearchPoint10(p, v)            \\\012  (v = VME_Output_S1(p, ushort, 14, 10))\012#define VME_GET_IDMOutput_DistortionMeshBlock14_SearchPoint11(p, v)            \\\012  (v = VME_Output_S1(p, ushort, 14, 11))\012#define VME_GET_IDMOutput_DistortionMeshBlock14_",
"SearchPoint12(p, v)            \\\012  (v = VME_Output_S1(p, ushort, 14, 12))\012#define VME_GET_IDMOutput_DistortionMeshBlock14_SearchPoint13(p, v)            \\\012  (v = VME_Output_S1(p, ushort, 14, 13))\012#define VME_GET_IDMOutput_DistortionMeshBlock14_SearchPoint14(p, v)            \\\012  (v = VME_Output_S1(p, ushort, 14, 14))\012#define VME_GET_IDMOutput_DistortionMeshBlock14_SearchPoint15(p, v)            \\\012  (v = VME_Output_S1(p, ushort, 14, 15))\012\012#define VME_GET_IDMOutput_DistortionMeshBlock15_SearchPoint0(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 15, 0))\012#define VME_GET_IDMOutput_DistortionMeshBlock15_SearchPoint1(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 15, 1))\012#define VME_GET_IDMOutput_DistortionMeshBlock15_SearchPoshort(p, v)            \\\012  (v = VME_Output_S1(p, ushort, 15, 2))\012#define VME_GET_IDMOutput_DistortionMeshBlock15_SearchPoint3(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 15, 3))\012#define VME_GET_IDMOutput_DistortionMeshBlock15_SearchPoint4(p, v)             \\\012  (v = VME_Output_",
"S1(p, ushort, 15, 4))\012#define VME_GET_IDMOutput_DistortionMeshBlock15_SearchPoint5(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 15, 5))\012#define VME_GET_IDMOutput_DistortionMeshBlock15_SearchPoint6(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 15, 6))\012#define VME_GET_IDMOutput_DistortionMeshBlock15_SearchPoint7(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 15, 7))\012#define VME_GET_IDMOutput_DistortionMeshBlock15_SearchPoint8(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 15, 8))\012#define VME_GET_IDMOutput_DistortionMeshBlock15_SearchPoint9(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 15, 9))\012#define VME_GET_IDMOutput_DistortionMeshBlock15_SearchPoint10(p, v)            \\\012  (v = VME_Output_S1(p, ushort, 15, 10))\012#define VME_GET_IDMOutput_DistortionMeshBlock15_SearchPoint11(p, v)            \\\012  (v = VME_Output_S1(p, ushort, 15, 11))\012#define VME_GET_IDMOutput_DistortionMeshBlock15_SearchPoint12(p, v)            \\\012  (v = VME_Output_S1(p, ushort, 15, 12))\012#define VME_GET_IDMOutput_Disto",
"rtionMeshBlock15_SearchPoint13(p, v)            \\\012  (v = VME_Output_S1(p, ushort, 15, 13))\012#define VME_GET_IDMOutput_DistortionMeshBlock15_SearchPoint14(p, v)            \\\012  (v = VME_Output_S1(p, ushort, 15, 14))\012#define VME_GET_IDMOutput_DistortionMeshBlock15_SearchPoint15(p, v)            \\\012  (v = VME_Output_S1(p, ushort, 15, 15))\012\012// Set the default values for VME input payload\012\012#define INIT_VME_UNIINPUT(p)                                                   \\\012  { /* M0 */                                                                   \\\012    VME_Input_S1(p, uint, 0, 0) = 0x00000000;                                 \\\012    VME_Input_S1(p, uint, 0, 1) = 0x00000000;                                 \\\012    VME_Input_S1(p, uint, 0, 2) = 0x00000000;                                 \\\012    VME_Input_S1(p, uint, 0, 3) = 0x00A80000;                                 \\\012    VME_Input_S1(p, uint, 0, 4) = 0x00000000;                                 \\\012    VME_Input_S1(p, uint, 0, 5) = 0x00000000;                                ",
" \\\012    VME_Input_S1(p, uint, 0, 6) = 0x00000000;                                 \\\012    VME_Input_S1(p, uint, 0, 7) = 0x00000000;                                 \\\012    /* M1 */                                                                   \\\012    VME_Input_S1(p, uint, 1, 0) = 0x00000000;                                 \\\012    VME_Input_S1(p, uint, 1, 1) = 0x00000008;                                 \\\012    VME_Input_S1(p, uint, 1, 2) = 0x00000000;                                 \\\012    VME_Input_S1(p, uint, 1, 3) = 0x00000000;                                 \\\012    VME_Input_S1(p, uint, 1, 4) = 0x00000000;                                 \\\012    VME_Input_S1(p, uint, 1, 5) = 0x00000000;                                 \\\012    VME_Input_S1(p, uint, 1, 6) = 0x00000000;                                 \\\012    VME_Input_S1(p, uint, 1, 7) = 0x00400060;                                 \\\012    /* M2 */                                                                   \\\012    VME_Input_S1(p, uint, 2, 0) = 0x00000000;              ",
"                   \\\012    VME_Input_S1(p, uint, 2, 1) = 0x00000000;                                 \\\012    VME_Input_S1(p, uint, 2, 2) = 0x00000000;                                 \\\012    VME_Input_S1(p, uint, 2, 3) = 0x00000000;                                 \\\012    VME_Input_S1(p, uint, 2, 4) = 0x00000000;                                 \\\012    VME_Input_S1(p, uint, 2, 5) = 0x00000000;                                 \\\012    VME_Input_S1(p, uint, 2, 6) = 0x00000000;                                 \\\012    VME_Input_S1(p, uint, 2, 7) = 0x00000000;                                 \\\012    /* M3 */                                                                   \\\012    VME_Input_S1(p, uint, 3, 0) = 0x00000000;                                 \\\012    VME_Input_S1(p, uint, 3, 1) = 0x00000000;                                 \\\012    VME_Input_S1(p, uint, 3, 2) = 0x00000000;                                 \\\012    VME_Input_S1(p, uint, 3, 3) = 0x00000000;                                 \\\012    VME_Input_S1(p, uint, 3, 4) = 0x000000",
"00;                                 \\\012    VME_Input_S1(p, uint, 3, 5) = 0x00000000;                                 \\\012    VME_Input_S1(p, uint, 3, 6) = 0x00000000;                                 \\\012    VME_Input_S1(p, uint, 3, 7) = 0x00000000;                                 \\\012  }\012\012// TBD: set different default values for each payload field\012#define INIT_VME_IMEINPUT(p)                                                   \\\012  { p = 0; }\012\012#define INIT_VME_SICINPUT(p)                                                   \\\012  { p = 0; }\012\012#define INIT_VME_FBRINPUT(p)                                                   \\\012  { p = 0; }\012\012#define INIT_VME_IDMINPUT(p)                                                   \\\012  { p = 0; }\012\012#define RESET_VME_UNIINPUT(p)                                                  \\\012  { p.format<uint, 4, 8>() = 0; }\012\012#define RESET_VME_IMEINPUT(p, sz)                                              \\\012  { p.format<uint, sz, 8>() = 0; }\012\012#define RESET_VME_SICINPUT(p)                                       ",
"           \\\012  { p.format<uint, 4, 8>() = 0; }\012\012#define RESET_VME_FBRINPUT(p)                                                  \\\012  { p.format<uint, 4, 8>() = 0; }\012\012#define RESET_VME_IDMINPUT(p)                                                  \\\012  { p.format<uint, 1, 8>() = 0; }\012\012// Run VME APIs\012\012typedef enum _VMEStreamMode_ {\012  VME_STREAM_DISABLE = 0,\012  VME_STREAM_OUT = 1,\012  VME_STREAM_IN = 2,\012  VME_STREAM_IN_OUT = 3\012} VMEStreamMode;\012\012typedef enum _VMESearchCtrl_ {\012  VME_SEARCH_SINGLE_REF_SINGLE_REC_SINGLE_START = 0,\012  VME_SEARCH_SINGLE_REF_SINGLE_REC_DUAL_START = 1,\012  VME_SEARCH_SINGLE_REF_DUAL_REC = 3,\012  VME_SEARCH_DUAL_REF_DUAL_REC = 7\012} VMESearchCtrl;\012\012typedef enum _VMEMsgType_ {\012  VME_SIC_MSG = 0,\012  VME_FBR_MSG = 1,\012  VME_IME_MSG = 2,\012  VME_IDM_MSG = 3\012} VMEMsgType;\012\012static CM_INLINE constexpr unsigned\012getVMEInputSize(unsigned size, VMEStreamMode mode, VMESearchCtrl ctrl) {\012  return (mode != VME_STREAM_IN && mode != VME_STREAM_IN_OUT)\012             \? size + 2\012             : (ctrl == VME_SEARCH_DUAL_REF_DU",
"AL_REC) \? (size + 6) : (size + 4);\012}\012\012template <VMEStreamMode streamMode, VMESearchCtrl searchCtrl, int N1, int N2>\012CM_INLINE void\012_run_vme_ime_impl(matrix<uchar, 4, 32> UNIInput, matrix<uchar, N1, 32> IMEInput,\012                  SurfaceIndex curSurfIndex, vector<short, 2> ref0,\012                  vector<short, 2> ref1, vector<ushort, 16> costCenter,\012                  matrix_ref<uchar, N2, 32> IMEOutput) {\012  // HSW: 3; otherwise 4 to invoke below function\012  constexpr unsigned inputSize = getVMEInputSize(4, streamMode, searchCtrl);\012  constexpr unsigned remaining = (inputSize - 4) * 8;\012  matrix<uint, inputSize, 8> src = 0;\012  // mov  (24)    VX(0,0)<1>,  UNIInput\012  src.format<uint>().select<32, 1>(0) =\012      UNIInput.format<uint>().select<32, 1>(0);\012  // mov  (16)   VX(3,0)<1>,  IMEInput\012  src.format<uint>().select<remaining, 1>(32) =\012      IMEInput.format<uint>().select<remaining, 1>(0);\012  // and  (1)     VX(0,13)<1>, VX(0,13):ub, 0xF8\012  src.format<uchar>()(13) &= 0xF8;\012  // or   (1)     VX(0,13)<1>, VX(0,13):ub",
", searchCtrl\012  src.format<uchar>()(13) |= (unsigned)searchCtrl;\012  // mov  (2)     VA(0,0)<1>,  ref0\012  // since ref0 is converted from UW to UD, move it as 1 UD\012  src(0, 0) = ref0.format<uint>()(0);\012  // mov  (2)     VA(0,2)<1>,  ref1\012  // since ref1 is converted from UW to UD, move it as 1 UD\012  src(0, 1) = ref1.format<uint>()(0);\012  // mov  (8)     VA(3,0)<1>,  costCenter\012  src.select<1, 1, 8, 1>(3, 0) = costCenter.format<uint>().select<8, 1>(0);\012\012  unsigned fCtrl = 0;        // Bit 7-0 of message descriptor\012  fCtrl += 0x2 << 13;        // Bit 14-13 of message descriptor\012  fCtrl += streamMode << 15; // Bit 16-15 of message descriptor\012\012  unsigned rspLength = 288 / 32;\012  if ((streamMode != VME_STREAM_OUT) && (streamMode != VME_STREAM_IN_OUT)) {\012    rspLength = 224 / 32;\012  } else if (searchCtrl == VME_SEARCH_DUAL_REF_DUAL_REC) {\012    rspLength = 352 / 32;\012  }\012\012  // Function control (bit 0:18)\012  // Header present   (bit 19)\012  // Response length  (bit 20:24)\012  // Message length   (bit 25:28)\012  uint Descriptor = (fCt",
"rl & 0x7FFFF) + (1 << 19) + ((rspLength & 0x1f) << 20) +\012                    ((inputSize & 0xF) << 25);\012\012  Descriptor = cm_get_value(curSurfIndex) + Descriptor;\012  /*Implementing VME based on cm_send() for gen7_5\012    template <int N1, int N2>\012    void cm_send(matrix_ref<ushort, N1, 16> IMEOutput, matrix<ushort, inputSize,\012    16>src, uint exDesc, uint msgDesc, uint sendc);*/\012  cm_send(IMEOutput.format<ushort, N2, 16>(),\012          src.format<ushort, inputSize, 16>(), __SFID_VME, Descriptor, 0u);\012}\012\012template <int N1, int N2>\012CM_NODEBUG CM_INLINE void\012run_vme_ime(matrix<uchar, 4, 32> UNIInput, matrix<uchar, N1, 32> IMEInput,\012            VMEStreamMode streamMode, VMESearchCtrl searchCtrl,\012            SurfaceIndex curSurfIndex, vector<short, 2> ref0,\012            vector<short, 2> ref1, vector<ushort, 16> costCenter,\012            matrix_ref<uchar, N2, 32> IMEOutput) {\012#define VME_IME(mode, ctrl)                                                    \\\012  _run_vme_ime_impl<mode, ctrl>(UNIInput, IMEInput, curSurfIndex, ref0,",
" ref1,  \\\012                                costCenter, IMEOutput)\012  if (N1 == 2 && N2 == 7) {\012    if (streamMode == VME_STREAM_DISABLE) {\012      if (searchCtrl == VME_SEARCH_SINGLE_REF_SINGLE_REC_SINGLE_START)\012        VME_IME(VME_STREAM_DISABLE,\012                VME_SEARCH_SINGLE_REF_SINGLE_REC_SINGLE_START);\012      if (searchCtrl == VME_SEARCH_SINGLE_REF_SINGLE_REC_DUAL_START)\012        VME_IME(VME_STREAM_DISABLE,\012                VME_SEARCH_SINGLE_REF_SINGLE_REC_DUAL_START);\012      if (searchCtrl == VME_SEARCH_SINGLE_REF_DUAL_REC)\012        VME_IME(VME_STREAM_DISABLE, VME_SEARCH_SINGLE_REF_DUAL_REC);\012      if (searchCtrl == VME_SEARCH_DUAL_REF_DUAL_REC)\012        VME_IME(VME_STREAM_DISABLE, VME_SEARCH_DUAL_REF_DUAL_REC);\012    }\012  } else if (N1 == 2 && N2 == 9) {\012    if (streamMode == VME_STREAM_OUT) {\012      // searchCtrl != VME_SEARCH_DUAL_REF_DUAL_REC\012      if (searchCtrl == VME_SEARCH_SINGLE_REF_SINGLE_REC_SINGLE_START) {\012        VME_IME(VME_STREAM_OUT, VME_SEARCH_SINGLE_REF_SINGLE_REC_SINGLE_START);\012      }\012      if ",
"(searchCtrl == VME_SEARCH_SINGLE_REF_SINGLE_REC_DUAL_START) {\012        VME_IME(VME_STREAM_OUT, VME_SEARCH_SINGLE_REF_SINGLE_REC_DUAL_START);\012      }\012      if (searchCtrl == VME_SEARCH_SINGLE_REF_DUAL_REC) {\012        VME_IME(VME_STREAM_OUT, VME_SEARCH_SINGLE_REF_DUAL_REC);\012      }\012    }\012  } else if (N1 == 2 && N2 == 11) {\012    if (streamMode == VME_STREAM_OUT &&\012        searchCtrl == VME_SEARCH_DUAL_REF_DUAL_REC) {\012      VME_IME(VME_STREAM_OUT, VME_SEARCH_DUAL_REF_DUAL_REC);\012    }\012  } else if (N1 == 4 && N2 == 7) {\012    if (streamMode == VME_STREAM_IN) {\012      // searchCtrl != VME_SEARCH_DUAL_REF_DUAL_REC\012      if (searchCtrl == VME_SEARCH_SINGLE_REF_SINGLE_REC_SINGLE_START) {\012        VME_IME(VME_STREAM_IN, VME_SEARCH_SINGLE_REF_SINGLE_REC_SINGLE_START);\012      }\012      if (searchCtrl == VME_SEARCH_SINGLE_REF_SINGLE_REC_DUAL_START) {\012        VME_IME(VME_STREAM_IN, VME_SEARCH_SINGLE_REF_SINGLE_REC_DUAL_START);\012      }\012      if (searchCtrl == VME_SEARCH_SINGLE_REF_DUAL_REC) {\012        VME_IME(VME_STREAM_IN, VME_SEARCH_",
"SINGLE_REF_DUAL_REC);\012      }\012    }\012  } else if (N1 == 4 && N2 == 9) {\012    if (streamMode == VME_STREAM_IN_OUT) {\012      // searchCtrl != VME_SEARCH_DUAL_REF_DUAL_REC\012      if (searchCtrl == VME_SEARCH_SINGLE_REF_SINGLE_REC_SINGLE_START) {\012        VME_IME(VME_STREAM_IN_OUT,\012                VME_SEARCH_SINGLE_REF_SINGLE_REC_SINGLE_START);\012      }\012      if (searchCtrl == VME_SEARCH_SINGLE_REF_SINGLE_REC_DUAL_START) {\012        VME_IME(VME_STREAM_IN_OUT, VME_SEARCH_SINGLE_REF_SINGLE_REC_DUAL_START);\012      }\012      if (searchCtrl == VME_SEARCH_SINGLE_REF_DUAL_REC) {\012        VME_IME(VME_STREAM_IN_OUT, VME_SEARCH_SINGLE_REF_DUAL_REC);\012      }\012    }\012  } else if (N1 == 6 && N2 == 7) {\012    if (streamMode == VME_STREAM_IN &&\012        searchCtrl == VME_SEARCH_DUAL_REF_DUAL_REC) {\012      VME_IME(VME_STREAM_IN, VME_SEARCH_DUAL_REF_DUAL_REC);\012    }\012  } else if (N1 == 6 && N2 == 11) {\012    if (streamMode == VME_STREAM_IN_OUT &&\012        searchCtrl == VME_SEARCH_DUAL_REF_DUAL_REC) {\012      VME_IME(VME_STREAM_IN_OUT, VME_SEARCH_DUAL_RE",
"F_DUAL_REC);\012    }\012  }\012}\012\012template <typename Dummy = void>\012CM_INLINE void\012run_vme_fbr(matrix<uchar, 4, 32> UNIInput, matrix<uchar, 4, 32> FBRInput,\012            SurfaceIndex curSurfIndex, uchar FBRMbMode, uchar FBRSubMbShape,\012            uchar FBRSubPredMode, matrix_ref<uchar, 7, 32> FBROutput) {\012  matrix<uint, 8, 8> src = 0;\012  // mov(96)    VX(0, 0)<1>, UNIInput\012  src.format<uint>().select<32, 1>(0) =\012      UNIInput.format<uint>().select<32, 1>(0);\012  // mov  (128)   VX(3,0)<1>,  FBRInput\012  src.format<uint>().select<32, 1>(32) =\012      FBRInput.format<uint>().select<32, 1>(0);\012  // mov  (1)     VX(2,20)<1>, FBRMbMode\012  src.format<uchar, 8, 32>()(2, 20) = FBRMbMode;\012  // mov  (1)     VX(2,21)<1>, FBRSubMbShape\012  src.format<uchar, 8, 32>()(2, 21) = FBRSubMbShape;\012  //  mov  (1)     VX(2,22)<1>, FBRSubPredMode\012  src.format<uchar, 8, 32>()(2, 22) = FBRSubPredMode;\012\012  unsigned fCtrl = 0x3 << 13;\012  unsigned rspLength = 7;\012  unsigned msglength = 8;\012  uint Descriptor = (fCtrl & 0x7FFFF) + (1 << 19) + ((rspLength & 0x1f",
") << 20) +\012                    ((msglength & 0xF) << 25);\012\012  Descriptor = cm_get_value(curSurfIndex) + Descriptor;\012  cm_send(FBROutput.format<ushort, 7, 16>(), src.format<ushort, 8, 16>(),\012          __SFID_CRE, Descriptor, 0u);\012}\012\012template <typename Dummy = void>\012CM_INLINE void\012run_vme_sic(matrix<uchar, 4, 32> UNIInput, matrix<uchar, 4, 32> SICInput,\012            SurfaceIndex curSurfIndex, matrix_ref<uchar, 7, 32> UNIOutput) {\012  matrix<uint, 8, 8> src = 0;\012  // mov  (96)    VX(0,0)<1>,  UNIInput\012  src.format<uint>().select<32, 1>(0) =\012      UNIInput.format<uint>().select<32, 1>(0);\012  // mov  (128)   VX(3,0)<1>,  SICInput\012  src.format<uint>().select<32, 1>(32) =\012      SICInput.format<uint>().select<32, 1>(0);\012  unsigned fCtrl = 0x1 << 13;\012  unsigned rspLength = 7;\012  unsigned msgLength = 8;\012  uint Descriptor = (fCtrl & 0x7FFFF) + (1 << 19) + ((rspLength & 0x1f) << 20) +\012                    ((msgLength & 0xF) << 25);\012\012  Descriptor = cm_get_value(curSurfIndex) + Descriptor;\012  cm_send(UNIOutput.format<ushort, 7, 16",
">(), src.format<ushort, 8, 16>(),\012          __SFID_CRE, Descriptor, 0u);\012}\012\012template <typename Dummy = void>\012CM_INLINE void\012run_vme_idm(matrix<uchar, 4, 32> UNIInput, matrix<uchar, 1, 32> IDMInput,\012            SurfaceIndex curSurfIndex, matrix_ref<uchar, 16, 32> IDMOutput) {\012  matrix<uint, 5, 8> src = 0;\012  // mov(96)    VX(0, 0)<1>, UNIInput\012  src.format<uint>().select<32, 1>(0) =\012      UNIInput.format<uint>().select<32, 1>(0);\012  // mov  (128)   VX(3,0)<1>,  IDMInput\012  src.format<uint>().select<8, 1>(32) = IDMInput.format<uint>().select<8, 1>(0);\012\012  unsigned fCtrl = 0;\012  unsigned rspLength = 16;\012  unsigned msglength = 5;\012  uint Descriptor = (fCtrl & 0x7FFFF) + (1 << 19) + ((rspLength & 0x1f) << 20) +\012                    ((msglength & 0xF) << 25);\012\012  Descriptor = cm_get_value(curSurfIndex) + Descriptor;\012  cm_send(IDMOutput.format<ushort, 16, 16>(), src.format<ushort, 5, 16>(),\012          __SFID_VME, Descriptor, 0u);\012}\012\012#endif /* _CLANG_gen8_VME_H_ */\012\000/*========================== begin_copyright_notice ========",
"====================\012\012Copyright (C) 2015-2021 Intel Corporation\012\012SPDX-License-Identifier: MIT\012\012============================= end_copyright_notice ===========================*/\012\012#if (__INCLUDE_LEVEL__ == 1)\012static_assert(0, \"CM:w:gen9_vme.h should not be included explicitly - only \"\012                 \"<cm/cm.h> is required\");\012#endif\012\012#ifndef _CLANG_gen9_VME_H_\012#define _CLANG_gen9_VME_H_\012\012#include \"cm_send.h\"\012#include \"cm_util.h\"\012\012#define __SFID_VME 8\012#define __SFID_CRE 13\012\012#define S13_2TOS16(value)                                                      \\\012  (((value >> 2) & 0x1fff) | (((value >> 15) & 0x1) << 15))\012#define S16TOS13_2(value)                                                      \\\012  (((value & 0x1fff) << 2) | (((value >> 15) & 0x1) << 15))\012\012// Select one element from the input payload\012#ifdef VME_Input_S1\012#undef VME_Input_S1\012#endif\012#define VME_Input_S1(p, t, r, c) p.row(r).format<t>().select<1, 1>(c)\012\012#ifdef VME_Input_G1\012#undef VME_Input_G1\012#endif\012#define VME_Input_G1(p, t, r, c) p.row(r).format<t>().s",
"elect<1, 1>(c)(0)\012\012// Select one element from the output result\012#ifdef VME_Output_S1\012#undef VME_Output_S1\012#endif\012#define VME_Output_S1(p, t, r, c) p.row(r).format<t>().select<1, 1>(c)(0)\012\012// Input\012\012// SET methods\012\012// Format = S15\012#define VME_SET_UNIInput_Ref0X(p, v) (VME_Input_S1(p, ushort, 0, 0) = v)\012#define VME_SET_UNIInput_Ref0Y(p, v) (VME_Input_S1(p, ushort, 0, 1) = v)\012\012// Format = S15\012#define VME_SET_UNIInput_Ref1X(p, v) (VME_Input_S1(p, ushort, 0, 2) = v)\012#define VME_SET_UNIInput_Ref1Y(p, v) (VME_Input_S1(p, ushort, 0, 3) = v)\012\012// Format = U16\012#define VME_SET_UNIInput_SrcX(p, v) (VME_Input_S1(p, ushort, 0, 4) = v)\012\012// Format = U16\012#define VME_SET_UNIInput_SrcY(p, v) (VME_Input_S1(p, ushort, 0, 5) = v)\012\012// Set - FieldBased\012// Clear - FrameBased\012#define VME_SET_UNIInput_SrcAccess(p) (VME_Input_S1(p, uchar, 0, 12) |= 0x40)\012#define VME_CLEAR_UNIInput_SrcAccess(p) (VME_Input_S1(p, uchar, 0, 12) &= 0xBF)\012\012// Set - FieldBased\012// Clear - FrameBased\012#define VME_SET_UNIInput_RefAccess(p) (VME_Input_S1(p, uchar, 0",
", 12) |= 0x80)\012#define VME_CLEAR_UNIInput_RefAccess(p) (VME_Input_S1(p, uchar, 0, 12) &= 0x7F)\012\012// Set - different paths\012// Clear - same path\012#define VME_SET_UNIInput_DualSearchPath(p)                                     \\\012  (VME_Input_S1(p, uchar, 0, 13) |= 0x08)\012#define VME_CLEAR_UNIInput_DualSearchPath(p)                                   \\\012  (VME_Input_S1(p, uchar, 0, 13) &= 0xF7)\012\012// #define INT_MODE 0x0\012// #define HALF_PEL_MODE 0x1\012// #define QUARTER_PEL_MODE 0x3\012#define VME_SET_UNIInput_SubPelMode(p, v)                                      \\\012  (VME_Input_S1(p, uchar, 0, 13) =                                             \\\012       VME_Input_S1(p, uchar, 0, 13) & 0xCF | (v << 4))\012\012// Set - 4MVP\012// Clear - 1MVP\012#define VME_SET_UNIInput_SkipModeType(p) (VME_Input_S1(p, uchar, 0, 13) |= 0x40)\012#define VME_CLEAR_UNIInput_SkipModeType(p)                                     \\\012  (VME_Input_S1(p, uchar, 0, 13) &= 0xBF)\012\012#define VME_SET_UNIInput_DisableFieldCacheAllocation(p)                        \\\012  (VME_Input_S1",
"(p, uchar, 0, 13) |= 0x80)\012#define VME_CLEAR_UNIInput_DisableFieldCacheAllocation(p)                      \\\012  (VME_Input_S1(p, uchar, 0, 13) &= 0x7F)\012\012// Set - Chroma mode\012// Clear - Luma mode\012#define VME_SET_UNIInput_InterChromaMode(p)                                    \\\012  (VME_Input_S1(p, uchar, 0, 14) |= 0x1)\012#define VME_CLEAR_UNIInput_InterChromaMode(p)                                  \\\012  (VME_Input_S1(p, uchar, 0, 14) &= 0xFE)\012\012#define VME_SET_UNIInput_FTEnable(p) (VME_Input_S1(p, uchar, 0, 14) |= 0x2)\012#define VME_CLEAR_UNIInput_FTEnable(p) (VME_Input_S1(p, uchar, 0, 14) &= 0xFD)\012\012#define VME_SET_UNIInput_BMEDisableFBR(p) (VME_Input_S1(p, uchar, 0, 14) |= 0x4)\012#define VME_CLEAR_UNIInput_BMEDisableFBR(p)                                    \\\012  (VME_Input_S1(p, uchar, 0, 14) &= 0xFB)\012\012// v is a 7-bit mask with the following definition:\012// xxxxxx1 : 16x16 sub-macroblock disabled\012// xxxxx1x : 2x(16x8) sub-macroblock within 16x16 disabled\012// xxxx1xx : 2x(8x16) sub-macroblock within 16x16 disabled\012// xxx1xxx ",
": 1x(8x8) sub-partition for 4x(8x8) within 16x16 disabled\012// xx1xxxx : 2x(8x4) sub-partition for 4x(8x8) within 16x16 disabled\012// x1xxxxx : 2x(4x8) sub-partition for 4x(8x8) within 16x16 disabled\012// 1xxxxxx : 4x(4x4) sub-partition for 4x(8x8) within 16x16 disabled\012#define VME_SET_UNIInput_SubMbPartMask(p, v) (VME_Input_S1(p, uchar, 0, 15) = v)\012\012// The value must be a multiple of 4. Range = [20, 64]\012#define VME_SET_UNIInput_RefW(p, v) (VME_Input_S1(p, uchar, 0, 22) = v)\012\012// The value must be a multiple of 4. Range = [20, 64]\012#define VME_SET_UNIInput_RefH(p, v) (VME_Input_S1(p, uchar, 0, 23) = v)\012\012#define VME_SET_UNIInput_SkipModeEn(p) (VME_Input_S1(p, uchar, 1, 0) |= 0x1)\012#define VME_CLEAR_UNIInput_SkipModeEn(p) (VME_Input_S1(p, uchar, 1, 0) &= 0xFE)\012\012#define VME_SET_UNIInput_AdaptiveEn(p) (VME_Input_S1(p, uchar, 1, 0) |= 0x2)\012#define VME_CLEAR_UNIInput_AdaptiveEn(p) (VME_Input_S1(p, uchar, 1, 0) &= 0xFD)\012\012#define VME_SET_UNIInput_EarlyImeSuccessEn(p)                                  \\\012  (VME_Input_S1(p, uchar",
", 1, 0) |= 0x20)\012#define VME_CLEAR_UNIInput_EarlyImeSuccessEn(p)                                \\\012  (VME_Input_S1(p, uchar, 1, 0) &= 0xDF)\012\012#define VME_SET_UNIInput_T8x8FlagForInterEn(p)                                 \\\012  (VME_Input_S1(p, uchar, 1, 0) |= 0x80)\012#define VME_CLEAR_UNIInput_T8x8FlagForInterEn(p)                               \\\012  (VME_Input_S1(p, uchar, 1, 0) &= 0x7F)\012\012// SKL+\012#define VME_SET_UNIInput_RefPixelOffset(p, v) (VME_Input_S1(p, uchar, 1, 1) = v)\012\012#define VME_SET_UNIInput_EarlyImeStop(p, v) (VME_Input_S1(p, uchar, 1, 3) = v)\012\012#define VME_SET_UNIInput_MaxNumMVs(p, v) (VME_Input_S1(p, uchar, 1, 4) = v)\012\012#define VME_SET_UNIInput_Ref0Polarity(p, v)                                    \\\012  (VME_Input_S1(p, uchar, 1, 5) = VME_Input_S1(p, uchar, 1, 5) & 0xF0 | v)\012#define VME_SET_UNIInput_Ref1Polarity(p, v)                                    \\\012  (VME_Input_S1(p, uchar, 1, 5) =                                              \\\012       VME_Input_S1(p, uchar, 1, 5) & 0x0F | (v << 4))\012\012// SKL+\012\012// Format",
" = U6, Valid Values: [16, 21, 32, 43, 48]\012// #define VME_SET_UNIInput_BiWeight(p, v) (VME_Input_S1(p, uchar, 1, 6) = v)\012#define VME_SET_UNIInput_BiWeight(p, v)                                        \\\012  (VME_Input_S1(p, uchar, 1, 6) = VME_Input_S1(p, uchar, 1, 6) & 0xC0 | v)\012\012// Format = U2\012#define VME_SET_UNIInput_Fixed7x7Weights(p, v)                                 \\\012  (VME_Input_S1(p, uchar, 1, 6) =                                              \\\012       VME_Input_S1(p, uchar, 1, 6) & 0x3F | (v << 6))\012\012// Format = U2\012#define VME_SET_UNIInput_RefPixelShift(p, v)                                   \\\012  (VME_Input_S1(p, uchar, 1, 7) = VME_Input_S1(p, uchar, 1, 7) & 0xF0 | v)\012\012// #define VME_SET_UNIInput_RefPixelBiasEnable(p) (VME_Input_S1(p, uchar, 1, 7)\012// |= 0x20)\012// #define VME_CLEAR_UNIInput_RefPixelBiasEnable(p) (VME_Input_S1(p, uchar, 1,\012// 7) &= 0xDF)\012\012#define VME_SET_UNIInput_UniMixDisable(p) (VME_Input_S1(p, uchar, 1, 7) |= 0x10)\012#define VME_CLEAR_UNIInput_UniMixDisable(p)                               ",
"     \\\012  (VME_Input_S1(p, uchar, 1, 7) &= 0xEF)\012\012#define VME_SET_UNIInput_IDMShapeMode1(p) (VME_Input_S1(p, uchar, 1, 7) |= 0x40)\012#define VME_CLEAR_UNIInput_IDMShapeMode1(p)                                    \\\012  (VME_Input_S1(p, uchar, 1, 7) &= 0xBF)\012\012#define VME_SET_UNIInput_IDMShapeMode2(p) (VME_Input_S1(p, uchar, 1, 7) |= 0x80)\012#define VME_CLEAR_UNIInput_IDMShapeMode2(p)                                    \\\012  (VME_Input_S1(p, uchar, 1, 7) &= 0x7F)\012\012// Format = U8, Valid range [1,63]\012#define VME_SET_UNIInput_LenSP(p, v) (VME_Input_S1(p, uchar, 1, 8) = v)\012\012// Format = U8, Valid range [1,63]\012#define VME_SET_UNIInput_MaxNumSU(p, v) (VME_Input_S1(p, uchar, 1, 9) = v)\012\012// Format = U4\012#define VME_SET_UNIInput_StartCenter0(p, StartCenter0X, StartCenter0Y)         \\\012  (VME_Input_S1(p, uchar, 1, 10) = StartCenter0X | (StartCenter0Y << 4))\012\012// Format = U4\012#define VME_SET_UNIInput_StartCenter1(p, StartCenter1X, StartCenter1Y)         \\\012  (VME_Input_S1(p, uchar, 1, 11) = StartCenter1X | (StartCenter1Y << 4))\012\012// Forma",
"t = U8\012#define VME_SET_UNIInput_WeightedSADCtrl0_3(p, v)                              \\\012  (VME_Input_S1(p, uchar, 1, 12) = v)\012#define VME_SET_UNIInput_WeightedSADCtrl4_7(p, v)                              \\\012  (VME_Input_S1(p, uchar, 1, 13) = v)\012#define VME_SET_UNIInput_WeightedSADCtrl8_11(p, v)                             \\\012  (VME_Input_S1(p, uchar, 1, 14) = v)\012#define VME_SET_UNIInput_WeightedSADCtrl12_15(p, v)                            \\\012  (VME_Input_S1(p, uchar, 1, 15) = v)\012\012// Format = U4\012#define VME_SET_UNIInput_Blk0RefID(p, FwdBlk0RefID, BwdBlk0RefID)              \\\012  (VME_Input_S1(p, uchar, 1, 24) = FwdBlk0RefID | (BwdBlk0RefID << 4))\012\012// Format = U4\012#define VME_SET_UNIInput_Blk1RefID(p, FwdBlk1RefID, BwdBlk1RefID)              \\\012  (VME_Input_S1(p, uchar, 1, 25) = FwdBlk1RefID | (BwdBlk1RefID << 4))\012\012// Format = U4\012#define VME_SET_UNIInput_Blk2RefID(p, FwdBlk2RefID, BwdBlk2RefID)              \\\012  (VME_Input_S1(p, uchar, 1, 26) = FwdBlk2RefID | (BwdBlk2RefID << 4))\012\012// Format = U4\012#define VME_SET_UNIIn",
"put_Blk3RefID(p, FwdBlk3RefID, BwdBlk3RefID)              \\\012  (VME_Input_S1(p, uchar, 1, 27) = FwdBlk3RefID | (BwdBlk3RefID << 4))\012\012#define VME_SET_UNIInput_IntraFlags(p, v) (VME_Input_S1(p, uchar, 1, 28) = v)\012\012// v is a 8-bit mask with the following definition:\012// Bit-7    Reserved : MBZ (for IntraPredAvailFlagF - F (pixel[-1,7]\012// available\012// for MbAff)\012// Bit-6    Reserved : MBZ (for IntraPredAvailFlagA/E - A (left neighbor top\012// half for MbAff)\012// Bit-5    IntraPredAvailFlagE/A - A (Left neighbor or Left bottom half)\012// Bit-4    IntraPredAvailFlagB - B (Upper neighbor)\012// Bit-3    IntraPredAvailFlagC - C (Upper left neighbor)\012// Bit-2    IntraPredAvailFlagD - D (Upper right neighbor)\012// Bit-1:0  Reserved: MBZ (ChromaIntraPredMode)\012#define VME_SET_UNIInput_MbIntraStruct(p, v) (VME_Input_S1(p, uchar, 1, 29) = v)\012\012// v is a 2-bit value:\012// 00: qpel [Qpel difference between MV and cost center: eff cost range 0-15pel]\012// 01: hpel [Hpel difference between MV and cost center: eff cost range 0-31pel]\012// 10: pel",
"  [Pel  difference between MV and cost center: eff cost range 0-63pel]\012// 11: 2pel [2Pel difference between MV and cost center: eff cost range\012// 0-127pel]\012#define VME_SET_UNIInput_MVCostScaleFactor(p, v)                               \\\012  (VME_Input_S1(p, uchar, 1, 30) = VME_Input_S1(p, uchar, 1, 30) & 0xFC | v)\012\012#define VME_SET_UNIInput_SrcFieldPolarity(p)                                   \\\012  (VME_Input_S1(p, uchar, 1, 30) |= 0x08)\012#define VME_CLEAR_UNIInput_SrcFieldPolarity(p)                                 \\\012  (VME_Input_S1(p, uchar, 1, 30) &= 0xF7)\012\012#define VME_SET_UNIInput_BilinearEnable(p)                                     \\\012  (VME_Input_S1(p, uchar, 1, 30) |= 0x04)\012#define VME_CLEAR_UNIInput_BilinearEnable(p)                                   \\\012  (VME_Input_S1(p, uchar, 1, 30) &= 0xFB)\012\012#define VME_SET_UNIInput_WeightedSADHAAR(p)                                    \\\012  (VME_Input_S1(p, uchar, 1, 30) |= 0x10)\012#define VME_CLEAR_UNIInput_WeightedSADHAAR(p)                                  \\\012  (VME_Inpu",
"t_S1(p, uchar, 1, 30) &= 0xEF)\012\012#define VME_SET_UNIInput_AConlyHAAR(p) (VME_Input_S1(p, uchar, 1, 30) |= 0x20)\012#define VME_CLEAR_UNIInput_AConlyHAAR(p) (VME_Input_S1(p, uchar, 1, 30) &= 0xDF)\012\012#define VME_SET_UNIInput_RefIDCostMode(p)                                      \\\012  (VME_Input_S1(p, uchar, 1, 30) |= 0x40)\012#define VME_CLEAR_UNIInput_RefIDCostMode(p)                                    \\\012  (VME_Input_S1(p, uchar, 1, 30) &= 0xBF)\012\012#define VME_SET_UNIInput_IDMShapeMode(p) (VME_Input_S1(p, uchar, 1, 30) |= 0x80)\012#define VME_CLEAR_UNIInput_IDMShapeMode(p)                                     \\\012  (VME_Input_S1(p, uchar, 1, 30) &= 0x7F)\012\012// v is a 8-bit mask with the following definition:\012// xxxx xxx1: Ref0 Skip Center 0 is enabled [corresponds to M2.0]\012// xxxx xx1x: Ref1 Skip Center 0 is enabled [corresponds to M2.1]\012// xxxx x1xx: Ref0 Skip Center 1 is enabled [corresponds to M2.2]\012// xxxx 1xxx: Ref1 Skip Center 1 is enabled [corresponds to M2.3]\012// xxx1 xxxx: Ref0 Skip Center 2 is enabled [corresponds to M2.",
"4]\012// xx1x xxxx: Ref1 Skip Center 2 is enabled [corresponds to M2.5]\012// x1xx xxxx: Ref0 Skip Center 3 is enabled [corresponds to M2.6]\012// 1xxx xxxx: Ref1 Skip Center 3 is enabled [corresponds to M2.7]\012#define VME_SET_UNIInput_SkipCenterMask(p, v)                                  \\\012  (VME_Input_S1(p, uchar, 1, 31) = v)\012\012// NOTE: replace v with U4U4 type with\012// (shift_count, shift_val) and set the value as (shift_val | (shift_count <<\012// 4))\012\012// Format = U4U4 (encoded value must fit in 12-bits)\012#define VME_SET_UNIInput_Mode0Cost(p, v) (VME_Input_S1(p, uchar, 2, 0) = v)\012#define VME_SET_UNIInput_Mode1Cost(p, v) (VME_Input_S1(p, uchar, 2, 1) = v)\012#define VME_SET_UNIInput_Mode2Cost(p, v) (VME_Input_S1(p, uchar, 2, 2) = v)\012#define VME_SET_UNIInput_Mode3Cost(p, v) (VME_Input_S1(p, uchar, 2, 3) = v)\012#define VME_SET_UNIInput_Mode4Cost(p, v) (VME_Input_S1(p, uchar, 2, 4) = v)\012#define VME_SET_UNIInput_Mode5Cost(p, v) (VME_Input_S1(p, uchar, 2, 5) = v)\012#define VME_SET_UNIInput_Mode6Cost(p, v) (VME_Input_S1(p, uchar, 2, 6",
") = v)\012#define VME_SET_UNIInput_Mode7Cost(p, v) (VME_Input_S1(p, uchar, 2, 7) = v)\012#define VME_SET_UNIInput_Mode8Cost(p, v) (VME_Input_S1(p, uchar, 2, 8) = v)\012#define VME_SET_UNIInput_Mode9Cost(p, v) (VME_Input_S1(p, uchar, 2, 9) = v)\012\012// Format = U4U4 (encoded value must fit in 12-bits)\012#define VME_SET_UNIInput_RefIDCost(p, v) (VME_Input_S1(p, uchar, 2, 10) = v)\012\012// Format = U4U4 (encoded value must fit in 12-bits)\012#define VME_SET_UNIInput_ChromaIntraModeCost(p, v)                             \\\012  (VME_Input_S1(p, uchar, 2, 11) = v)\012\012// Format = U4U4 (encoded value must fit in 10-bits)\012#define VME_SET_UNIInput_MV0Cost(p, v) (VME_Input_S1(p, uchar, 2, 12) = v)\012#define VME_SET_UNIInput_MV1Cost(p, v) (VME_Input_S1(p, uchar, 2, 13) = v)\012#define VME_SET_UNIInput_MV2Cost(p, v) (VME_Input_S1(p, uchar, 2, 14) = v)\012#define VME_SET_UNIInput_MV3Cost(p, v) (VME_Input_S1(p, uchar, 2, 15) = v)\012#define VME_SET_UNIInput_MV4Cost(p, v) (VME_Input_S1(p, uchar, 2, 16) = v)\012#define VME_SET_UNIInput_MV5Cost(p, v) (VME_Input_S1(p, ",
"uchar, 2, 17) = v)\012#define VME_SET_UNIInput_MV6Cost(p, v) (VME_Input_S1(p, uchar, 2, 18) = v)\012#define VME_SET_UNIInput_MV7Cost(p, v) (VME_Input_S1(p, uchar, 2, 19) = v)\012\012// Format = U8\012#define VME_SET_UNIInput_FBRMbModeInput(p, v)                                  \\\012  (VME_Input_S1(p, uchar, 2, 20) = v)\012\012// Format = U8\012#define VME_SET_UNIInput_FBRSubMBShapeInput(p, v)                              \\\012  (VME_Input_S1(p, uchar, 2, 21) = v)\012\012// Format = U8\012#define VME_SET_UNIInput_FBRSubPredModeInput(p, v)                             \\\012  (VME_Input_S1(p, uchar, 2, 22) = v)\012\012// Format = U16\012#define VME_SET_UNIInput_SICFwdTCoeffThreshold0(p, v)                          \\\012  (VME_Input_S1(p, ushort, 2, 12) = v)\012// Format = U8\012#define VME_SET_UNIInput_SICFwdTCoeffThreshold1(p, v)                          \\\012  (VME_Input_S1(p, uchar, 2, 26) = v)\012#define VME_SET_UNIInput_SICFwdTCoeffThreshold2(p, v)                          \\\012  (VME_Input_S1(p, uchar, 2, 27) = v)\012#define VME_SET_UNIInput_SICFwdTCoeffThreshold3(p, v)       ",
"                   \\\012  (VME_Input_S1(p, uchar, 2, 28) = v)\012#define VME_SET_UNIInput_SICFwdTCoeffThreshold4(p, v)                          \\\012  (VME_Input_S1(p, uchar, 2, 29) = v)\012#define VME_SET_UNIInput_SICFwdTCoeffThreshold5(p, v)                          \\\012  (VME_Input_S1(p, uchar, 2, 30) = v)\012#define VME_SET_UNIInput_SICFwdTCoeffThreshold6(p, v)                          \\\012  (VME_Input_S1(p, uchar, 2, 31) = v)\012\012// Format = S13.2, DletaX Valid Range: [-2048.00 to 2047.75], DletaY Valid\012// Range: [-512.00 to 511.75]\012#define VME_SET_UNIInput_FWDCostCenter0(p, DeltaX, DeltaY)                     \\\012  (VME_Input_S1(p, uint, 3, 0) = DeltaX | (DeltaY << 16))\012#define VME_SET_UNIInput_BWDCostCenter0(p, DeltaX, DeltaY)                     \\\012  (VME_Input_S1(p, uint, 3, 1) = DeltaX | (DeltaY << 16))\012#define VME_SET_UNIInput_FWDCostCenter1(p, DeltaX, DeltaY)                     \\\012  (VME_Input_S1(p, uint, 3, 2) = DeltaX | (DeltaY << 16))\012#define VME_SET_UNIInput_BWDCostCenter1(p, DeltaX, DeltaY)                     \\\012  (V",
"ME_Input_S1(p, uint, 3, 3) = DeltaX | (DeltaY << 16))\012#define VME_SET_UNIInput_FWDCostCenter2(p, DeltaX, DeltaY)                     \\\012  (VME_Input_S1(p, uint, 3, 4) = DeltaX | (DeltaY << 16))\012#define VME_SET_UNIInput_BWDCostCenter2(p, DeltaX, DeltaY)                     \\\012  (VME_Input_S1(p, uint, 3, 5) = DeltaX | (DeltaY << 16))\012#define VME_SET_UNIInput_FWDCostCenter3(p, DeltaX, DeltaY)                     \\\012  (VME_Input_S1(p, uint, 3, 6) = DeltaX | (DeltaY << 16))\012#define VME_SET_UNIInput_BWDCostCenter3(p, DeltaX, DeltaY)                     \\\012  (VME_Input_S1(p, uint, 3, 7) = DeltaX | (DeltaY << 16))\012\012// Format = U8, with the following definition:\012// [7:4] (Y) - specifies relative Y distance to the next SU from previous SU in\012// units of SU\012// [3:0] (X) - specifies relative X distance to the next SU from previous SU in\012// units of SU\012// Format = U8, with the following definition:\012// [7:4] (Y) - specifies relative Y distance to the next SU from previous SU in\012// units of SU\012// [3:0] (X) - specifies relative ",
"X distance to the next SU from previous SU in\012// units of SU\012#define VME_SET_IMEInput_IMESearchPathDelta0(p, v)                             \\\012  (VME_Input_G1(p, uchar, 0, 0) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta1(p, v)                             \\\012  (VME_Input_G1(p, uchar, 0, 1) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta2(p, v)                             \\\012  (VME_Input_G1(p, uchar, 0, 2) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta3(p, v)                             \\\012  (VME_Input_G1(p, uchar, 0, 3) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta4(p, v)                             \\\012  (VME_Input_G1(p, uchar, 0, 4) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta5(p, v)                             \\\012  (VME_Input_G1(p, uchar, 0, 5) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta6(p, v)                             \\\012  (VME_Input_G1(p, uchar, 0, 6) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta7(p, v)                             \\\012  (VME_Input_G1(p, uchar, 0, 7) = v)\012#define VME_SET_IME",
"Input_IMESearchPathDelta8(p, v)                             \\\012  (VME_Input_G1(p, uchar, 0, 8) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta9(p, v)                             \\\012  (VME_Input_G1(p, uchar, 0, 9) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta10(p, v)                            \\\012  (VME_Input_G1(p, uchar, 0, 10) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta11(p, v)                            \\\012  (VME_Input_G1(p, uchar, 0, 11) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta12(p, v)                            \\\012  (VME_Input_G1(p, uchar, 0, 12) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta13(p, v)                            \\\012  (VME_Input_G1(p, uchar, 0, 13) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta14(p, v)                            \\\012  (VME_Input_G1(p, uchar, 0, 14) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta15(p, v)                            \\\012  (VME_Input_G1(p, uchar, 0, 15) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta16(p, v)                            \\\012  (VME_Input",
"_G1(p, uchar, 0, 16) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta17(p, v)                            \\\012  (VME_Input_G1(p, uchar, 0, 17) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta18(p, v)                            \\\012  (VME_Input_G1(p, uchar, 0, 18) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta19(p, v)                            \\\012  (VME_Input_G1(p, uchar, 0, 19) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta20(p, v)                            \\\012  (VME_Input_G1(p, uchar, 0, 20) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta21(p, v)                            \\\012  (VME_Input_G1(p, uchar, 0, 21) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta22(p, v)                            \\\012  (VME_Input_G1(p, uchar, 0, 22) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta23(p, v)                            \\\012  (VME_Input_G1(p, uchar, 0, 23) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta24(p, v)                            \\\012  (VME_Input_G1(p, uchar, 0, 24) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta25(",
"p, v)                            \\\012  (VME_Input_G1(p, uchar, 0, 25) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta26(p, v)                            \\\012  (VME_Input_G1(p, uchar, 0, 26) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta27(p, v)                            \\\012  (VME_Input_G1(p, uchar, 0, 27) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta28(p, v)                            \\\012  (VME_Input_G1(p, uchar, 0, 28) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta29(p, v)                            \\\012  (VME_Input_G1(p, uchar, 0, 29) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta30(p, v)                            \\\012  (VME_Input_G1(p, uchar, 0, 30) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta31(p, v)                            \\\012  (VME_Input_G1(p, uchar, 0, 31) = v)\012\012#define VME_SET_IMEInput_IMESearchPathDelta32(p, v)                            \\\012  (VME_Input_G1(p, uchar, 1, 0) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta33(p, v)                            \\\012  (VME_Input_G1(p, uchar, 1, 1) = v)\012",
"#define VME_SET_IMEInput_IMESearchPathDelta34(p, v)                            \\\012  (VME_Input_G1(p, uchar, 1, 2) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta35(p, v)                            \\\012  (VME_Input_G1(p, uchar, 1, 3) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta36(p, v)                            \\\012  (VME_Input_G1(p, uchar, 1, 4) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta37(p, v)                            \\\012  (VME_Input_G1(p, uchar, 1, 5) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta38(p, v)                            \\\012  (VME_Input_G1(p, uchar, 1, 6) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta39(p, v)                            \\\012  (VME_Input_G1(p, uchar, 1, 7) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta40(p, v)                            \\\012  (VME_Input_G1(p, uchar, 1, 8) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta41(p, v)                            \\\012  (VME_Input_G1(p, uchar, 1, 9) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta42(p, v)                            \\",
"\012  (VME_Input_G1(p, uchar, 1, 10) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta43(p, v)                            \\\012  (VME_Input_G1(p, uchar, 1, 11) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta44(p, v)                            \\\012  (VME_Input_G1(p, uchar, 1, 12) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta45(p, v)                            \\\012  (VME_Input_G1(p, uchar, 1, 13) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta46(p, v)                            \\\012  (VME_Input_G1(p, uchar, 1, 14) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta47(p, v)                            \\\012  (VME_Input_G1(p, uchar, 1, 15) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta48(p, v)                            \\\012  (VME_Input_G1(p, uchar, 1, 16) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta49(p, v)                            \\\012  (VME_Input_G1(p, uchar, 1, 17) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta50(p, v)                            \\\012  (VME_Input_G1(p, uchar, 1, 18) = v)\012#define VME_SET_IMEInput_IMESearc",
"hPathDelta51(p, v)                            \\\012  (VME_Input_G1(p, uchar, 1, 19) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta52(p, v)                            \\\012  (VME_Input_G1(p, uchar, 1, 20) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta53(p, v)                            \\\012  (VME_Input_G1(p, uchar, 1, 21) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta54(p, v)                            \\\012  (VME_Input_G1(p, uchar, 1, 22) = v)\012#define VME_SET_IMEInput_IMESearchPathDelta55(p, v)                            \\\012  (VME_Input_G1(p, uchar, 1, 23) = v)\012\012// Format = U16\012#define VME_SET_IMEInput_Rec0_16x8_0Distortion(p, v)                           \\\012  (VME_Input_S1(p, ushort, 2, 0) = v)\012#define VME_SET_IMEInput_Rec0_16x8_1Distortion(p, v)                           \\\012  (VME_Input_S1(p, ushort, 2, 1) = v)\012#define VME_SET_IMEInput_Rec0_8x16_0Distortion(p, v)                           \\\012  (VME_Input_S1(p, ushort, 2, 2) = v)\012#define VME_SET_IMEInput_Rec0_8x16_1Distortion(p, v)                           \\\012  (VME_",
"Input_S1(p, ushort, 2, 3) = v)\012#define VME_SET_IMEInput_Rec0_8x8_0Distortion(p, v)                            \\\012  (VME_Input_S1(p, ushort, 2, 4) = v)\012#define VME_SET_IMEInput_Rec0_8x8_1Distortion(p, v)                            \\\012  (VME_Input_S1(p, ushort, 2, 5) = v)\012#define VME_SET_IMEInput_Rec0_8x8_2Distortion(p, v)                            \\\012  (VME_Input_S1(p, ushort, 2, 6) = v)\012#define VME_SET_IMEInput_Rec0_8x8_3Distortion(p, v)                            \\\012  (VME_Input_S1(p, ushort, 2, 7) = v)\012#define VME_SET_IMEInput_Rec0_16x16_Distortion(p, v)                           \\\012  (VME_Input_S1(p, ushort, 2, 8) = v)\012\012// Format = U4\012#define VME_SET_IMEInput_Rec0_16x16_RefID(p, v)                                \\\012  (VME_Input_S1(p, uchar, 2, 18) = v)\012\012// Format = S13.2\012#define VME_SET_IMEInput_Rec0_16x16_X(p, v) (VME_Input_S1(p, ushort, 2, 10) = v)\012#define VME_SET_IMEInput_Rec0_16x16_Y(p, v) (VME_Input_S1(p, ushort, 2, 11) = v)\012\012// Format = U4\012#define VME_SET_IMEInput_Rec0_16x8_0RefID(p, v)                   ",
"             \\\012  (VME_Input_S1(p, uchar, 2, 24) = VME_Input_S1(p, uchar, 2, 24) & 0xF0 | v)\012#define VME_SET_IMEInput_Rec0_16x8_1RefID(p, v)                                \\\012  (VME_Input_S1(p, uchar, 2, 24) =                                             \\\012       VME_Input_S1(p, uchar, 2, 24) & 0x0F | (v << 4))\012#define VME_SET_IMEInput_Rec0_8x16_0RefID(p, v)                                \\\012  (VME_Input_S1(p, uchar, 2, 25) = VME_Input_S1(p, uchar, 2, 25) & 0xF0 | v)\012#define VME_SET_IMEInput_Rec0_8x16_1RefID(p, v)                                \\\012  (VME_Input_S1(p, uchar, 2, 25) =                                             \\\012       VME_Input_S1(p, uchar, 2, 25) & 0x0F | (v << 4))\012#define VME_SET_IMEInput_Rec0_8x8_0RefID(p, v)                                 \\\012  (VME_Input_S1(p, uchar, 2, 26) = VME_Input_S1(p, uchar, 2, 26) & 0xF0 | v)\012#define VME_SET_IMEInput_Rec0_8x8_1RefID(p, v)                                 \\\012  (VME_Input_S1(p, uchar, 2, 26) =                                             \\\012       VME_Input_S",
"1(p, uchar, 2, 26) & 0x0F | (v << 4))\012#define VME_SET_IMEInput_Rec0_8x8_2RefID(p, v)                                 \\\012  (VME_Input_S1(p, uchar, 2, 27) = VME_Input_S1(p, uchar, 2, 27) & 0xF0 | v)\012#define VME_SET_IMEInput_Rec0_8x8_3RefID(p, v)                                 \\\012  (VME_Input_S1(p, uchar, 2, 27) =                                             \\\012       VME_Input_S1(p, uchar, 2, 27) & 0x0F | (v << 4))\012\012// Format = S13.2\012#define VME_SET_IMEInput_Rec0_16x8_0X(p, v) (VME_Input_S1(p, ushort, 3, 0) = v)\012#define VME_SET_IMEInput_Rec0_16x8_0Y(p, v) (VME_Input_S1(p, ushort, 3, 1) = v)\012#define VME_SET_IMEInput_Rec0_16x8_1X(p, v) (VME_Input_S1(p, ushort, 3, 2) = v)\012#define VME_SET_IMEInput_Rec0_16x8_1Y(p, v) (VME_Input_S1(p, ushort, 3, 3) = v)\012#define VME_SET_IMEInput_Rec0_8x16_0X(p, v) (VME_Input_S1(p, ushort, 3, 4) = v)\012#define VME_SET_IMEInput_Rec0_8x16_0Y(p, v) (VME_Input_S1(p, ushort, 3, 5) = v)\012#define VME_SET_IMEInput_Rec0_8x16_1X(p, v) (VME_Input_S1(p, ushort, 3, 6) = v)\012#define VME_SET_IMEInput_Rec0_8",
"x16_1Y(p, v) (VME_Input_S1(p, ushort, 3, 7) = v)\012#define VME_SET_IMEInput_Rec0_8x8_0X(p, v) (VME_Input_S1(p, ushort, 3, 8) = v)\012#define VME_SET_IMEInput_Rec0_8x8_0Y(p, v) (VME_Input_S1(p, ushort, 3, 9) = v)\012#define VME_SET_IMEInput_Rec0_8x8_1X(p, v) (VME_Input_S1(p, ushort, 3, 10) = v)\012#define VME_SET_IMEInput_Rec0_8x8_1Y(p, v) (VME_Input_S1(p, ushort, 3, 11) = v)\012#define VME_SET_IMEInput_Rec0_8x8_2X(p, v) (VME_Input_S1(p, ushort, 3, 12) = v)\012#define VME_SET_IMEInput_Rec0_8x8_2Y(p, v) (VME_Input_S1(p, ushort, 3, 13) = v)\012#define VME_SET_IMEInput_Rec0_8x8_3X(p, v) (VME_Input_S1(p, ushort, 3, 14) = v)\012#define VME_SET_IMEInput_Rec0_8x8_3Y(p, v) (VME_Input_S1(p, ushort, 3, 15) = v)\012\012// Format = U16\012#define VME_SET_IMEInput_Rec1_16x8_0Distortion(p, v)                           \\\012  (VME_Input_S1(p, ushort, 4, 0) = v)\012#define VME_SET_IMEInput_Rec1_16x8_1Distortion(p, v)                           \\\012  (VME_Input_S1(p, ushort, 4, 1) = v)\012#define VME_SET_IMEInput_Rec1_8x16_0Distortion(p, v)                           \\\012 ",
" (VME_Input_S1(p, ushort, 4, 2) = v)\012#define VME_SET_IMEInput_Rec1_8x16_1Distortion(p, v)                           \\\012  (VME_Input_S1(p, ushort, 4, 3) = v)\012#define VME_SET_IMEInput_Rec1_8x8_0Distortion(p, v)                            \\\012  (VME_Input_S1(p, ushort, 4, 4) = v)\012#define VME_SET_IMEInput_Rec1_8x8_1Distortion(p, v)                            \\\012  (VME_Input_S1(p, ushort, 4, 5) = v)\012#define VME_SET_IMEInput_Rec1_8x8_2Distortion(p, v)                            \\\012  (VME_Input_S1(p, ushort, 4, 6) = v)\012#define VME_SET_IMEInput_Rec1_8x8_3Distortion(p, v)                            \\\012  (VME_Input_S1(p, ushort, 4, 7) = v)\012#define VME_SET_IMEInput_Rec1_16x16_Distortion(p, v)                           \\\012  (VME_Input_S1(p, ushort, 4, 8) = v)\012\012// Format = U4\012#define VME_SET_IMEInput_Rec1_16x16_RefID(p, v)                                \\\012  (VME_Input_S1(p, uchar, 4, 18) = v)\012\012// Format = S13.2\012#define VME_SET_IMEInput_Rec1_16x16_X(p, v) (VME_Input_S1(p, ushort, 4, 10) = v)\012#define VME_SET_IMEInput_Rec1_16x16_Y(",
"p, v) (VME_Input_S1(p, ushort, 4, 11) = v)\012\012// Format = U4\012#define VME_SET_IMEInput_Rec1_16x8_0RefID(p, v)                                \\\012  (VME_Input_S1(p, uchar, 4, 24) = VME_Input_S1(p, uchar, 4, 24) & 0xF0 | v)\012#define VME_SET_IMEInput_Rec1_16x8_1RefID(p, v)                                \\\012  (VME_Input_S1(p, uchar, 4, 24) =                                             \\\012       VME_Input_S1(p, uchar, 4, 24) & 0x0F | (v << 4))\012#define VME_SET_IMEInput_Rec1_8x16_0RefID(p, v)                                \\\012  (VME_Input_S1(p, uchar, 4, 25) = VME_Input_S1(p, uchar, 4, 25) & 0xF0 | v)\012#define VME_SET_IMEInput_Rec1_8x16_1RefID(p, v)                                \\\012  (VME_Input_S1(p, uchar, 4, 25) =                                             \\\012       VME_Input_S1(p, uchar, 4, 25) & 0x0F | (v << 4))\012#define VME_SET_IMEInput_Rec1_8x8_0RefID(p, v)                                 \\\012  (VME_Input_S1(p, uchar, 4, 26) = VME_Input_S1(p, uchar, 4, 26) & 0xF0 | v)\012#define VME_SET_IMEInput_Rec1_8x8_1RefID(p, v)         ",
"                        \\\012  (VME_Input_S1(p, uchar, 4, 26) =                                             \\\012       VME_Input_S1(p, uchar, 4, 26) & 0x0F | (v << 4))\012#define VME_SET_IMEInput_Rec1_8x8_2RefID(p, v)                                 \\\012  (VME_Input_S1(p, uchar, 4, 27) = VME_Input_S1(p, uchar, 4, 27) & 0xF0 | v)\012#define VME_SET_IMEInput_Rec1_8x8_3RefID(p, v)                                 \\\012  (VME_Input_S1(p, uchar, 4, 27) =                                             \\\012       VME_Input_S1(p, uchar, 4, 27) & 0x0F | (v << 4))\012\012// Format = S13.2\012#define VME_SET_IMEInput_Rec1_16x8_0X(p, v) (VME_Input_S1(p, ushort, 5, 0) = v)\012#define VME_SET_IMEInput_Rec1_16x8_0Y(p, v) (VME_Input_S1(p, ushort, 5, 1) = v)\012#define VME_SET_IMEInput_Rec1_16x8_1X(p, v) (VME_Input_S1(p, ushort, 5, 2) = v)\012#define VME_SET_IMEInput_Rec1_16x8_1Y(p, v) (VME_Input_S1(p, ushort, 5, 3) = v)\012#define VME_SET_IMEInput_Rec1_8x16_0X(p, v) (VME_Input_S1(p, ushort, 5, 4) = v)\012#define VME_SET_IMEInput_Rec1_8x16_0Y(p, v) (VME_Input_S1(p, ushor",
"t, 5, 5) = v)\012#define VME_SET_IMEInput_Rec1_8x16_1X(p, v) (VME_Input_S1(p, ushort, 5, 6) = v)\012#define VME_SET_IMEInput_Rec1_8x16_1Y(p, v) (VME_Input_S1(p, ushort, 5, 7) = v)\012#define VME_SET_IMEInput_Rec1_8x8_0X(p, v) (VME_Input_S1(p, ushort, 5, 8) = v)\012#define VME_SET_IMEInput_Rec1_8x8_0Y(p, v) (VME_Input_S1(p, ushort, 5, 9) = v)\012#define VME_SET_IMEInput_Rec1_8x8_1X(p, v) (VME_Input_S1(p, ushort, 5, 10) = v)\012#define VME_SET_IMEInput_Rec1_8x8_1Y(p, v) (VME_Input_S1(p, ushort, 5, 11) = v)\012#define VME_SET_IMEInput_Rec1_8x8_2X(p, v) (VME_Input_S1(p, ushort, 5, 12) = v)\012#define VME_SET_IMEInput_Rec1_8x8_2Y(p, v) (VME_Input_S1(p, ushort, 5, 13) = v)\012#define VME_SET_IMEInput_Rec1_8x8_3X(p, v) (VME_Input_S1(p, ushort, 5, 14) = v)\012#define VME_SET_IMEInput_Rec1_8x8_3Y(p, v) (VME_Input_S1(p, ushort, 5, 15) = v)\012\012// Format = S13.2, Valid Range: [-2048.00 to 2047.75]\012// For chroma skip: Format = S12.3, Hardware Range: [-1024.000 to 1023.875]\012#define VME_SET_SICInput_Ref0SkipCenter0DeltaXY(p, DeltaX, DeltaY)             \\\012",
"  (VME_Input_S1(p, uint, 0, 0) = DeltaX | (DeltaY << 16))\012#define VME_SET_SICInput_Ref1SkipCenter0DeltaXY(p, DeltaX, DeltaY)             \\\012  (VME_Input_S1(p, uint, 0, 1) = DeltaX | (DeltaY << 16))\012#define VME_SET_SICInput_Ref0SkipCenter1DeltaXY(p, DeltaX, DeltaY)             \\\012  (VME_Input_S1(p, uint, 0, 2) = DeltaX | (DeltaY << 16))\012#define VME_SET_SICInput_Ref1SkipCenter1DeltaXY(p, DeltaX, DeltaY)             \\\012  (VME_Input_S1(p, uint, 0, 3) = DeltaX | (DeltaY << 16))\012#define VME_SET_SICInput_Ref0SkipCenter2DeltaXY(p, DeltaX, DeltaY)             \\\012  (VME_Input_S1(p, uint, 0, 4) = DeltaX | (DeltaY << 16))\012#define VME_SET_SICInput_Ref1SkipCenter2DeltaXY(p, DeltaX, DeltaY)             \\\012  (VME_Input_S1(p, uint, 0, 5) = DeltaX | (DeltaY << 16))\012#define VME_SET_SICInput_Ref0SkipCenter3DeltaXY(p, DeltaX, DeltaY)             \\\012  (VME_Input_S1(p, uint, 0, 6) = DeltaX | (DeltaY << 16))\012#define VME_SET_SICInput_Ref1SkipCenter3DeltaXY(p, DeltaX, DeltaY)             \\\012  (VME_Input_S1(p, uint, 0, 7) = DeltaX | (DeltaY <",
"< 16))\012\012// 2-bit field with the following definition\012// 00: Luma + Chroma enabled\012// 01: Luma only\012// 1X: Intra disabled\012#define VME_SET_SICInput_IntraComputeType(p, v)                                \\\012  (VME_Input_S1(p, uchar, 1, 5) = v)\012\012#define VME_SET_SICInput_CornerNeighborPixel0(p, v)                            \\\012  (VME_Input_S1(p, uchar, 1, 7) = v)\012\012// NOTE: combine into one vector assignment\012#define VME_SET_SICInput_NeighborPixelLum0(p, v)                               \\\012  (VME_Input_S1(p, uchar, 1, 8) = v)\012#define VME_SET_SICInput_NeighborPixelLum1(p, v)                               \\\012  (VME_Input_S1(p, uchar, 1, 9) = v)\012#define VME_SET_SICInput_NeighborPixelLum2(p, v)                               \\\012  (VME_Input_S1(p, uchar, 1, 10) = v)\012#define VME_SET_SICInput_NeighborPixelLum3(p, v)                               \\\012  (VME_Input_S1(p, uchar, 1, 11) = v)\012#define VME_SET_SICInput_NeighborPixelLum4(p, v)                               \\\012  (VME_Input_S1(p, uchar, 1, 12) = v)\012#define VME_SET_SICInput_Nei",
"ghborPixelLum5(p, v)                               \\\012  (VME_Input_S1(p, uchar, 1, 13) = v)\012#define VME_SET_SICInput_NeighborPixelLum6(p, v)                               \\\012  (VME_Input_S1(p, uchar, 1, 14) = v)\012#define VME_SET_SICInput_NeighborPixelLum7(p, v)                               \\\012  (VME_Input_S1(p, uchar, 1, 15) = v)\012#define VME_SET_SICInput_NeighborPixelLum8(p, v)                               \\\012  (VME_Input_S1(p, uchar, 1, 16) = v)\012#define VME_SET_SICInput_NeighborPixelLum9(p, v)                               \\\012  (VME_Input_S1(p, uchar, 1, 17) = v)\012#define VME_SET_SICInput_NeighborPixelLum10(p, v)                              \\\012  (VME_Input_S1(p, uchar, 1, 18) = v)\012#define VME_SET_SICInput_NeighborPixelLum11(p, v)                              \\\012  (VME_Input_S1(p, uchar, 1, 19) = v)\012#define VME_SET_SICInput_NeighborPixelLum12(p, v)                              \\\012  (VME_Input_S1(p, uchar, 1, 20) = v)\012#define VME_SET_SICInput_NeighborPixelLum13(p, v)                              \\\012  (VME_Input_S1(p, ",
"uchar, 1, 21) = v)\012#define VME_SET_SICInput_NeighborPixelLum14(p, v)                              \\\012  (VME_Input_S1(p, uchar, 1, 22) = v)\012#define VME_SET_SICInput_NeighborPixelLum15(p, v)                              \\\012  (VME_Input_S1(p, uchar, 1, 23) = v)\012#define VME_SET_SICInput_NeighborPixelLum16(p, v)                              \\\012  (VME_Input_S1(p, uchar, 1, 24) = v)\012#define VME_SET_SICInput_NeighborPixelLum17(p, v)                              \\\012  (VME_Input_S1(p, uchar, 1, 25) = v)\012#define VME_SET_SICInput_NeighborPixelLum18(p, v)                              \\\012  (VME_Input_S1(p, uchar, 1, 26) = v)\012#define VME_SET_SICInput_NeighborPixelLum19(p, v)                              \\\012  (VME_Input_S1(p, uchar, 1, 27) = v)\012#define VME_SET_SICInput_NeighborPixelLum20(p, v)                              \\\012  (VME_Input_S1(p, uchar, 1, 28) = v)\012#define VME_SET_SICInput_NeighborPixelLum21(p, v)                              \\\012  (VME_Input_S1(p, uchar, 1, 29) = v)\012#define VME_SET_SICInput_NeighborPixelLum22(p, v)    ",
"                          \\\012  (VME_Input_S1(p, uchar, 1, 30) = v)\012#define VME_SET_SICInput_NeighborPixelLum23(p, v)                              \\\012  (VME_Input_S1(p, uchar, 1, 31) = v)\012#define VME_SET_SICInput_NeighborPixelLum24(p, v)                              \\\012  (VME_Input_S1(p, uchar, 2, 0) = v)\012#define VME_SET_SICInput_NeighborPixelLum25(p, v)                              \\\012  (VME_Input_S1(p, uchar, 2, 1) = v)\012#define VME_SET_SICInput_NeighborPixelLum26(p, v)                              \\\012  (VME_Input_S1(p, uchar, 2, 2) = v)\012#define VME_SET_SICInput_NeighborPixelLum27(p, v)                              \\\012  (VME_Input_S1(p, uchar, 2, 3) = v)\012#define VME_SET_SICInput_NeighborPixelLum28(p, v)                              \\\012  (VME_Input_S1(p, uchar, 2, 4) = v)\012#define VME_SET_SICInput_NeighborPixelLum29(p, v)                              \\\012  (VME_Input_S1(p, uchar, 2, 5) = v)\012#define VME_SET_SICInput_NeighborPixelLum30(p, v)                              \\\012  (VME_Input_S1(p, uchar, 2, 6) = v)\012#define VME_S",
"ET_SICInput_NeighborPixelLum31(p, v)                              \\\012  (VME_Input_S1(p, uchar, 2, 7) = v)\012#define VME_SET_SICInput_NeighborPixelLum32(p, v)                              \\\012  (VME_Input_S1(p, uchar, 2, 8) = v)\012#define VME_SET_SICInput_NeighborPixelLum33(p, v)                              \\\012  (VME_Input_S1(p, uchar, 2, 9) = v)\012#define VME_SET_SICInput_NeighborPixelLum34(p, v)                              \\\012  (VME_Input_S1(p, uchar, 2, 10) = v)\012#define VME_SET_SICInput_NeighborPixelLum35(p, v)                              \\\012  (VME_Input_S1(p, uchar, 2, 11) = v)\012#define VME_SET_SICInput_NeighborPixelLum36(p, v)                              \\\012  (VME_Input_S1(p, uchar, 2, 12) = v)\012#define VME_SET_SICInput_NeighborPixelLum37(p, v)                              \\\012  (VME_Input_S1(p, uchar, 2, 13) = v)\012#define VME_SET_SICInput_NeighborPixelLum38(p, v)                              \\\012  (VME_Input_S1(p, uchar, 2, 14) = v)\012\012#define VME_SET_SICInput_CornerNeighborPixel1(p, v)                            \\\012  (VME",
"_Input_S1(p, uchar, 2, 15) = v)\012\012// Format = U4\012#define VME_SET_SICInput_IntraMxMPredModeA5(p, v)                              \\\012  (VME_Input_S1(p, uchar, 2, 16) = VME_Input_S1(p, uchar, 2, 16) & 0xF0 | v)\012#define VME_SET_SICInput_IntraMxMPredModeA7(p, v)                              \\\012  (VME_Input_S1(p, uchar, 2, 16) =                                             \\\012       VME_Input_S1(p, uchar, 2, 16) & 0x0F | (v << 4))\012#define VME_SET_SICInput_IntraMxMPredModeA13(p, v)                             \\\012  (VME_Input_S1(p, uchar, 2, 17) = VME_Input_S1(p, uchar, 2, 17) & 0xF0 | v)\012#define VME_SET_SICInput_IntraMxMPredModeA15(p, v)                             \\\012  (VME_Input_S1(p, uchar, 2, 17) =                                             \\\012       VME_Input_S1(p, uchar, 2, 17) & 0x0F | (v << 4))\012#define VME_SET_SICInput_IntraMxMPredModeB10(p, v)                             \\\012  (VME_Input_S1(p, uchar, 2, 18) = VME_Input_S1(p, uchar, 2, 18) & 0xF0 | v)\012#define VME_SET_SICInput_IntraMxMPredModeB11(p, v)                ",
"             \\\012  (VME_Input_S1(p, uchar, 2, 18) =                                             \\\012       VME_Input_S1(p, uchar, 2, 18) & 0x0F | (v << 4))\012#define VME_SET_SICInput_IntraMxMPredModeB14(p, v)                             \\\012  (VME_Input_S1(p, uchar, 2, 19) = VME_Input_S1(p, uchar, 2, 19) & 0xF0 | v)\012#define VME_SET_SICInput_IntraMxMPredModeB15(p, v)                             \\\012  (VME_Input_S1(p, uchar, 2, 19) =                                             \\\012       VME_Input_S1(p, uchar, 2, 19) & 0x0F | (v << 4))\012\012// Format = U8 pair\012#define VME_SET_SICInput_CornerNeighborPixelChroma(p, v)                       \\\012  (VME_Input_S1(p, ushort, 2, 10) = v)\012\012#if 0\012// Format = U4U4\012#define VME_SET_SICInput_PenaltyIntra4x4NonDC(p, v)                            \\\012  (VME_Input_S1(p, uchar, 2, 28) = v)\012// Format = U2\012#define VME_SET_SICInput_ScaleFactorIntra8x8NonDC(p, v)                        \\\012  (VME_Input_S1(p, uchar, 2, 29) = VME_Input_S1(p, uchar, 2, 29) & 0xFC | v)\012// Format = U2\012#define VME_SET_SICInput",
"_ScaleFactorIntra16x16NonDC(p, v)                      \\\012  (VME_Input_S1(p, uchar, 2, 29) =                                             \\\012       VME_Input_S1(p, uchar, 2, 29) & 0xF3 | (v << 2))\012#else\012// Format = U8\012#define VME_SET_SICInput_PenaltyIntra4x4NonDC(p, v)                            \\\012  (VME_Input_G1(p, uchar, 2, 30) = v)\012// Format = U8\012#define VME_SET_SICInput_PenaltyIntra8x8NonDC(p, v)                            \\\012  (VME_Input_G1(p, uchar, 2, 29) = v)\012// Format = U8\012#define VME_SET_SICInput_PenaltyIntra16x16NonDC(p, v)                          \\\012  (VME_Input_G1(p, uchar, 2, 28) = v)\012#endif\012\012#define VME_SET_SICInput_NeighborPixelChroma0(p, v)                            \\\012  (VME_Input_G1(p, uchar, 3, 0) = v)\012#define VME_SET_SICInput_NeighborPixelChroma1(p, v)                            \\\012  (VME_Input_G1(p, uchar, 3, 1) = v)\012#define VME_SET_SICInput_NeighborPixelChroma2(p, v)                            \\\012  (VME_Input_G1(p, uchar, 3, 2) = v)\012#define VME_SET_SICInput_NeighborPixelChroma3(p, v)         ",
"                   \\\012  (VME_Input_G1(p, uchar, 3, 3) = v)\012\012#define VME_SET_SICInput_NeighborPixelChroma4(p, v)                            \\\012  (VME_Input_G1(p, uchar, 3, 4) = v)\012#define VME_SET_SICInput_NeighborPixelChroma5(p, v)                            \\\012  (VME_Input_G1(p, uchar, 3, 5) = v)\012#define VME_SET_SICInput_NeighborPixelChroma6(p, v)                            \\\012  (VME_Input_G1(p, uchar, 3, 6) = v)\012#define VME_SET_SICInput_NeighborPixelChroma7(p, v)                            \\\012  (VME_Input_G1(p, uchar, 3, 7) = v)\012\012#define VME_SET_SICInput_NeighborPixelChroma8(p, v)                            \\\012  (VME_Input_G1(p, uchar, 3, 8) = v)\012#define VME_SET_SICInput_NeighborPixelChroma9(p, v)                            \\\012  (VME_Input_G1(p, uchar, 3, 9) = v)\012#define VME_SET_SICInput_NeighborPixelChroma10(p, v)                           \\\012  (VME_Input_G1(p, uchar, 3, 10) = v)\012#define VME_SET_SICInput_NeighborPixelChroma11(p, v)                           \\\012  (VME_Input_G1(p, uchar, 3, 11) = v)\012\012#define VME_SET_S",
"ICInput_NeighborPixelChroma12(p, v)                           \\\012  (VME_Input_G1(p, uchar, 3, 12) = v)\012#define VME_SET_SICInput_NeighborPixelChroma13(p, v)                           \\\012  (VME_Input_G1(p, uchar, 3, 13) = v)\012#define VME_SET_SICInput_NeighborPixelChroma14(p, v)                           \\\012  (VME_Input_G1(p, uchar, 3, 14) = v)\012#define VME_SET_SICInput_NeighborPixelChroma15(p, v)                           \\\012  (VME_Input_G1(p, uchar, 3, 15) = v)\012\012#define VME_SET_SICInput_NeighborPixelChroma16(p, v)                           \\\012  (VME_Input_G1(p, uchar, 3, 16) = v)\012#define VME_SET_SICInput_NeighborPixelChroma17(p, v)                           \\\012  (VME_Input_G1(p, uchar, 3, 17) = v)\012#define VME_SET_SICInput_NeighborPixelChroma18(p, v)                           \\\012  (VME_Input_G1(p, uchar, 3, 18) = v)\012#define VME_SET_SICInput_NeighborPixelChroma19(p, v)                           \\\012  (VME_Input_G1(p, uchar, 3, 19) = v)\012\012#define VME_SET_SICInput_NeighborPixelChroma20(p, v)                           \\\012  (VME",
"_Input_G1(p, uchar, 3, 20) = v)\012#define VME_SET_SICInput_NeighborPixelChroma21(p, v)                           \\\012  (VME_Input_G1(p, uchar, 3, 21) = v)\012#define VME_SET_SICInput_NeighborPixelChroma22(p, v)                           \\\012  (VME_Input_G1(p, uchar, 3, 22) = v)\012#define VME_SET_SICInput_NeighborPixelChroma23(p, v)                           \\\012  (VME_Input_G1(p, uchar, 3, 23) = v)\012\012#define VME_SET_SICInput_NeighborPixelChroma24(p, v)                           \\\012  (VME_Input_G1(p, uchar, 3, 24) = v)\012#define VME_SET_SICInput_NeighborPixelChroma25(p, v)                           \\\012  (VME_Input_G1(p, uchar, 3, 25) = v)\012#define VME_SET_SICInput_NeighborPixelChroma26(p, v)                           \\\012  (VME_Input_G1(p, uchar, 3, 26) = v)\012#define VME_SET_SICInput_NeighborPixelChroma27(p, v)                           \\\012  (VME_Input_G1(p, uchar, 3, 27) = v)\012\012#define VME_SET_SICInput_NeighborPixelChroma28(p, v)                           \\\012  (VME_Input_G1(p, uchar, 3, 28) = v)\012#define VME_SET_SICInput_NeighborPixel",
"Chroma29(p, v)                           \\\012  (VME_Input_G1(p, uchar, 3, 29) = v)\012#define VME_SET_SICInput_NeighborPixelChroma30(p, v)                           \\\012  (VME_Input_G1(p, uchar, 3, 30) = v)\012#define VME_SET_SICInput_NeighborPixelChroma31(p, v)                           \\\012  (VME_Input_G1(p, uchar, 3, 31) = v)\012\012#define VME_SET_FBRInput_Ref0SubBlockX0(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 0, 0) = v)\012#define VME_SET_FBRInput_Ref0SubBlockY0(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 0, 1) = v)\012#define VME_SET_FBRInput_Ref1SubBlockX0(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 0, 2) = v)\012#define VME_SET_FBRInput_Ref1SubBlockY0(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 0, 3) = v)\012\012#define VME_SET_FBRInput_Ref0SubBlockX1(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 0, 4) = v)\012#define VME_SET_FBRInput_Ref0SubBlockY1(p, v)                                  \\\012  (VME_Input_S1(p, ushort, ",
"0, 5) = v)\012#define VME_SET_FBRInput_Ref1SubBlockX1(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 0, 6) = v)\012#define VME_SET_FBRInput_Ref1SubBlockY1(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 0, 7) = v)\012\012#define VME_SET_FBRInput_Ref0SubBlockX2(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 0, 8) = v)\012#define VME_SET_FBRInput_Ref0SubBlockY2(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 0, 9) = v)\012#define VME_SET_FBRInput_Ref1SubBlockX2(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 0, 10) = v)\012#define VME_SET_FBRInput_Ref1SubBlockY2(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 0, 11) = v)\012\012#define VME_SET_FBRInput_Ref0SubBlockX3(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 0, 12) = v)\012#define VME_SET_FBRInput_Ref0SubBlockY3(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 0, 13) = v)\012#define VME_SET_FBRInput_Ref1SubBlockX3(p, v)          ",
"                        \\\012  (VME_Input_S1(p, ushort, 0, 14) = v)\012#define VME_SET_FBRInput_Ref1SubBlockY3(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 0, 15) = v)\012\012#define VME_SET_FBRInput_Ref0SubBlockX4(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 1, 0) = v)\012#define VME_SET_FBRInput_Ref0SubBlockY4(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 1, 1) = v)\012#define VME_SET_FBRInput_Ref1SubBlockX4(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 1, 2) = v)\012#define VME_SET_FBRInput_Ref1SubBlockY4(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 1, 3) = v)\012\012#define VME_SET_FBRInput_Ref0SubBlockX5(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 1, 4) = v)\012#define VME_SET_FBRInput_Ref0SubBlockY5(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 1, 5) = v)\012#define VME_SET_FBRInput_Ref1SubBlockX5(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 1, 6) = v)\012#def",
"ine VME_SET_FBRInput_Ref1SubBlockY5(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 1, 7) = v)\012\012#define VME_SET_FBRInput_Ref0SubBlockX6(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 1, 8) = v)\012#define VME_SET_FBRInput_Ref0SubBlockY6(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 1, 9) = v)\012#define VME_SET_FBRInput_Ref1SubBlockX6(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 1, 10) = v)\012#define VME_SET_FBRInput_Ref1SubBlockY6(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 1, 11) = v)\012\012#define VME_SET_FBRInput_Ref0SubBlockX7(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 1, 12) = v)\012#define VME_SET_FBRInput_Ref0SubBlockY7(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 1, 13) = v)\012#define VME_SET_FBRInput_Ref1SubBlockX7(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 1, 14) = v)\012#define VME_SET_FBRInput_Ref1SubBlockY7(p, v)                        ",
"          \\\012  (VME_Input_S1(p, ushort, 1, 15) = v)\012\012#define VME_SET_FBRInput_Ref0SubBlockX8(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 2, 0) = v)\012#define VME_SET_FBRInput_Ref0SubBlockY8(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 2, 1) = v)\012#define VME_SET_FBRInput_Ref1SubBlockX8(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 2, 2) = v)\012#define VME_SET_FBRInput_Ref1SubBlockY8(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 2, 3) = v)\012\012#define VME_SET_FBRInput_Ref0SubBlockX9(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 2, 4) = v)\012#define VME_SET_FBRInput_Ref0SubBlockY9(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 2, 5) = v)\012#define VME_SET_FBRInput_Ref1SubBlockX9(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 2, 6) = v)\012#define VME_SET_FBRInput_Ref1SubBlockY9(p, v)                                  \\\012  (VME_Input_S1(p, ushort, 2, 7) = v)\012\012#define VME_SET_FB",
"RInput_Ref0SubBlockX10(p, v)                                 \\\012  (VME_Input_S1(p, ushort, 2, 8) = v)\012#define VME_SET_FBRInput_Ref0SubBlockY10(p, v)                                 \\\012  (VME_Input_S1(p, ushort, 2, 9) = v)\012#define VME_SET_FBRInput_Ref1SubBlockX10(p, v)                                 \\\012  (VME_Input_S1(p, ushort, 2, 10) = v)\012#define VME_SET_FBRInput_Ref1SubBlockY10(p, v)                                 \\\012  (VME_Input_S1(p, ushort, 2, 11) = v)\012\012#define VME_SET_FBRInput_Ref0SubBlockX11(p, v)                                 \\\012  (VME_Input_S1(p, ushort, 2, 12) = v)\012#define VME_SET_FBRInput_Ref0SubBlockY11(p, v)                                 \\\012  (VME_Input_S1(p, ushort, 2, 13) = v)\012#define VME_SET_FBRInput_Ref1SubBlockX11(p, v)                                 \\\012  (VME_Input_S1(p, ushort, 2, 14) = v)\012#define VME_SET_FBRInput_Ref1SubBlockY11(p, v)                                 \\\012  (VME_Input_S1(p, ushort, 2, 15) = v)\012\012#define VME_SET_FBRInput_Ref0SubBlockX12(p, v)                                 \\\012 ",
" (VME_Input_S1(p, ushort, 3, 0) = v)\012#define VME_SET_FBRInput_Ref0SubBlockY12(p, v)                                 \\\012  (VME_Input_S1(p, ushort, 3, 1) = v)\012#define VME_SET_FBRInput_Ref1SubBlockX12(p, v)                                 \\\012  (VME_Input_S1(p, ushort, 3, 2) = v)\012#define VME_SET_FBRInput_Ref1SubBlockY12(p, v)                                 \\\012  (VME_Input_S1(p, ushort, 3, 3) = v)\012\012#define VME_SET_FBRInput_Ref0SubBlockX13(p, v)                                 \\\012  (VME_Input_S1(p, ushort, 3, 4) = v)\012#define VME_SET_FBRInput_Ref0SubBlockY13(p, v)                                 \\\012  (VME_Input_S1(p, ushort, 3, 5) = v)\012#define VME_SET_FBRInput_Ref1SubBlockX13(p, v)                                 \\\012  (VME_Input_S1(p, ushort, 3, 6) = v)\012#define VME_SET_FBRInput_Ref1SubBlockY13(p, v)                                 \\\012  (VME_Input_S1(p, ushort, 3, 7) = v)\012\012#define VME_SET_FBRInput_Ref0SubBlockX14(p, v)                                 \\\012  (VME_Input_S1(p, ushort, 3, 8) = v)\012#define VME_SET_FBRInput_Ref0SubB",
"lockY14(p, v)                                 \\\012  (VME_Input_S1(p, ushort, 3, 9) = v)\012#define VME_SET_FBRInput_Ref1SubBlockX14(p, v)                                 \\\012  (VME_Input_S1(p, ushort, 3, 10) = v)\012#define VME_SET_FBRInput_Ref1SubBlockY14(p, v)                                 \\\012  (VME_Input_S1(p, ushort, 3, 11) = v)\012\012#define VME_SET_FBRInput_Ref0SubBlockX15(p, v)                                 \\\012  (VME_Input_S1(p, ushort, 3, 12) = v)\012#define VME_SET_FBRInput_Ref0SubBlockY15(p, v)                                 \\\012  (VME_Input_S1(p, ushort, 3, 13) = v)\012#define VME_SET_FBRInput_Ref1SubBlockX15(p, v)                                 \\\012  (VME_Input_S1(p, ushort, 3, 14) = v)\012#define VME_SET_FBRInput_Ref1SubBlockY15(p, v)                                 \\\012  (VME_Input_S1(p, ushort, 3, 15) = v)\012\012#define VME_SET_IDMInput_SrcMBPixelMaskRow0(p, v)                              \\\012  (VME_Input_S1(p, ushort, 0, 0) = v)\012#define VME_SET_IDMInput_SrcMBPixelMaskRow1(p, v)                              \\\012  (VME_Input_S1(",
"p, ushort, 0, 1) = v)\012#define VME_SET_IDMInput_SrcMBPixelMaskRow2(p, v)                              \\\012  (VME_Input_S1(p, ushort, 0, 2) = v)\012#define VME_SET_IDMInput_SrcMBPixelMaskRow3(p, v)                              \\\012  (VME_Input_S1(p, ushort, 0, 3) = v)\012#define VME_SET_IDMInput_SrcMBPixelMaskRow4(p, v)                              \\\012  (VME_Input_S1(p, ushort, 0, 4) = v)\012#define VME_SET_IDMInput_SrcMBPixelMaskRow5(p, v)                              \\\012  (VME_Input_S1(p, ushort, 0, 5) = v)\012#define VME_SET_IDMInput_SrcMBPixelMaskRow6(p, v)                              \\\012  (VME_Input_S1(p, ushort, 0, 6) = v)\012#define VME_SET_IDMInput_SrcMBPixelMaskRow7(p, v)                              \\\012  (VME_Input_S1(p, ushort, 0, 7) = v)\012#define VME_SET_IDMInput_SrcMBPixelMaskRow8(p, v)                              \\\012  (VME_Input_S1(p, ushort, 0, 8) = v)\012#define VME_SET_IDMInput_SrcMBPixelMaskRow9(p, v)                              \\\012  (VME_Input_S1(p, ushort, 0, 9) = v)\012#define VME_SET_IDMInput_SrcMBPixelMaskRow10(p, v)",
"                             \\\012  (VME_Input_S1(p, ushort, 0, 10) = v)\012#define VME_SET_IDMInput_SrcMBPixelMaskRow11(p, v)                             \\\012  (VME_Input_S1(p, ushort, 0, 11) = v)\012#define VME_SET_IDMInput_SrcMBPixelMaskRow12(p, v)                             \\\012  (VME_Input_S1(p, ushort, 0, 12) = v)\012#define VME_SET_IDMInput_SrcMBPixelMaskRow13(p, v)                             \\\012  (VME_Input_S1(p, ushort, 0, 13) = v)\012#define VME_SET_IDMInput_SrcMBPixelMaskRow14(p, v)                             \\\012  (VME_Input_S1(p, ushort, 0, 14) = v)\012#define VME_SET_IDMInput_SrcMBPixelMaskRow15(p, v)                             \\\012  (VME_Input_S1(p, ushort, 0, 15) = v)\012\012// GET methods\012\012// Format = I16\012#define VME_GET_UNIInput_Ref0X(p) (VME_Input_G1(p, ushort, 0, 0))\012#define VME_GET_UNIInput_Ref0Y(p) (VME_Input_G1(p, ushort, 0, 1))\012#define VME_GET_UNIInput_Ref1X(p) (VME_Input_G1(p, ushort, 0, 2))\012#define VME_GET_UNIInput_Ref1Y(p) (VME_Input_G1(p, ushort, 0, 3))\012\012// Format = U16\012#define VME_GET_UNIInput_SrcX(p) (VME_In",
"put_G1(p, ushort, 0, 4))\012\012// Format = U16\012#define VME_GET_UNIInput_SrcY(p) (VME_Input_G1(p, ushort, 0, 5))\012\012// Format = U8\012#define VME_GET_UNIInput_SrcType(p) (VME_Input_G1(p, uchar, 0, 12))\012\012// Format = U8\012#define VME_GET_UNIInput_VmeModes(p) (VME_Input_G1(p, uchar, 0, 13))\012\012// Format = U8\012#define VME_GET_UNIInput_SadType(p) (VME_Input_G1(p, uchar, 0, 14))\012\012// Format = U8\012#define VME_GET_UNIInput_ShapeMask(p) (VME_Input_G1(p, uchar, 0, 15))\012\012// The value must be a multiple of 4. Range = [20, 64]\012#define VME_GET_UNIInput_RefW(p) (VME_Input_G1(p, uchar, 0, 22))\012\012// The value must be a multiple of 4. Range = [20, 64]\012#define VME_GET_UNIInput_RefH(p) (VME_Input_G1(p, uchar, 0, 23))\012\012// Format = U8\012#define VME_GET_UNIInput_VmeFlags(p) (VME_Input_G1(p, uchar, 1, 0))\012\012// SKL+\012// Format = S8\012#define VME_GET_UNIInput_RefPixelOffset(p) (VME_Input_G1(p, uchar, 1, 1))\012\012// Format = U8\012#define VME_GET_UNIInput_EarlyImeStop(p) (VME_Input_G1(p, uchar, 1, 3))\012\012// Format = U8\012#define VME_GET_UNIInput_MaxNumMVs(p) (VME_Input_G",
"1(p, uchar, 1, 4))\012\012#define VME_GET_UNIInput_Ref0Polarity(p) (VME_Input_G1(p, uchar, 1, 5) & 0x0F)\012#define VME_GET_UNIInput_Ref1Polarity(p) (VME_Input_G1(p, uchar, 1, 5) >> 4)\012\012// SKL+\012\012// Format = U6, Valid Values: [16, 21, 32, 43, 48]\012// #define VME_GET_UNIInput_BiWeight(p) (VME_Input_G1(p, uchar, 1, 6))\012#define VME_GET_UNIInput_BiWeight(p) (VME_Input_G1(p, uchar, 1, 6) & 0x3F)\012\012#define VME_GET_UNIInput_Fixed7x7Weights(p)                                    \\\012  ((VME_Input_G1(p, uchar, 1, 6) & 0xC0) >> 6)\012\012#define VME_GET_UNIInput_RefPixelShift(p) (VME_Input_G1(p, uchar, 1, 7) & 0x0F)\012\012// #define VME_GET_UNIInput_RefPixelBiasEnable(p) ((VME_Input_G1(p, uchar, 1, 7)\012// & 0x20) \? 1 : 0)\012\012#define VME_GET_UNIInput_UniMixDisable(p)                                      \\\012  ((VME_Input_G1(p, uchar, 1, 7) & 0x10) \? 1 : 0)\012\012#define VME_GET_UNIInput_IDMShapeMode1(p)                                      \\\012  ((VME_Input_G1(p, uchar, 1, 7) & 0x40) \? 1 : 0)\012\012#define VME_GET_UNIInput_IDMShapeMode2(p)                       ",
"               \\\012  ((VME_Input_G1(p, uchar, 1, 7) & 0x80) \? 1 : 0)\012\012// Format = U8\012// #define VME_GET_UNIInput_BiDirMask(p) ((VME_Input_G1(p, uchar, 1, 7) & 0x10)\012// \? 1 : 0)\012\012// Format = U8, Valid range [1,63]\012#define VME_GET_UNIInput_LenSP(p) (VME_Input_G1(p, uchar, 1, 8))\012\012// Format = U8, Valid range [1,63]\012#define VME_GET_UNIInput_MaxNumSU(p) (VME_Input_G1(p, uchar, 1, 9))\012\012// Format = U8\012#define VME_GET_UNIInput_StartCenter0(p) (VME_Input_G1(p, uchar, 1, 10))\012\012// Format = U8\012#define VME_GET_UNIInput_StartCenter1(p) (VME_Input_G1(p, uchar, 1, 11))\012\012// Format = U8\012#define VME_GET_UNIInput_WeightedSADCtrl0_3(p) (VME_Input_G1(p, uchar, 1, 12))\012#define VME_GET_UNIInput_WeightedSADCtrl4_7(p) (VME_Input_G1(p, uchar, 1, 13))\012#define VME_GET_UNIInput_WeightedSADCtrl8_11(p) (VME_Input_G1(p, uchar, 1, 14))\012#define VME_GET_UNIInput_WeightedSADCtrl12_15(p) (VME_Input_G1(p, uchar, 1, 15))\012\012// Format = U8\012#define VME_GET_UNIInput_Blk0RefID(p) (VME_Input_G1(p, uchar, 1, 24))\012#define VME_GET_UNIInput_Blk1RefID(p) (VME_In",
"put_G1(p, uchar, 1, 25))\012#define VME_GET_UNIInput_Blk2RefID(p) (VME_Input_G1(p, uchar, 1, 26))\012#define VME_GET_UNIInput_Blk3RefID(p) (VME_Input_G1(p, uchar, 1, 27))\012\012// Format = U8\012#define VME_GET_UNIInput_IntraFlags(p) (VME_Input_G1(p, uchar, 1, 28))\012\012// v is a 8-bit mask with the following definition:\012// Bit-7    Reserved : MBZ (for IntraPredAvailFlagF - F (pixel[-1,7]\012// available\012// for MbAff)\012// Bit-6    Reserved : MBZ (for IntraPredAvailFlagA/E - A (left neighbor top\012// half for MbAff)\012// Bit-5    IntraPredAvailFlagE/A - A (Left neighbor or Left bottom half)\012// Bit-4    IntraPredAvailFlagB - B (Upper neighbor)\012// Bit-3    IntraPredAvailFlagC - C (Upper left neighbor)\012// Bit-2    IntraPredAvailFlagD - D (Upper right neighbor)\012// Bit-1:0  Reserved: MBZ (ChromaIntraPredMode)\012#define VME_GET_UNIInput_MbIntraStruct(p) (VME_Input_G1(p, uchar, 1, 29))\012\012// Format = U8\012#define VME_GET_UNIInput_MvFlags(p) (VME_Input_G1(p, uchar, 1, 30))\012\012// v is a 8-bit mask with the following definition:\012// xxxx xxx1: Ref0 Skip ",
"Center 0 is enabled [corresponds to M2.0]\012// xxxx xx1x: Ref1 Skip Center 0 is enabled [corresponds to M2.1]\012// xxxx x1xx: Ref0 Skip Center 1 is enabled [corresponds to M2.2]\012// xxxx 1xxx: Ref1 Skip Center 1 is enabled [corresponds to M2.3]\012// xxx1 xxxx: Ref0 Skip Center 2 is enabled [corresponds to M2.4]\012// xx1x xxxx: Ref1 Skip Center 2 is enabled [corresponds to M2.5]\012// x1xx xxxx: Ref0 Skip Center 3 is enabled [corresponds to M2.6]\012// 1xxx xxxx: Ref1 Skip Center 3 is enabled [corresponds to M2.7]\012#define VME_GET_UNIInput_SkipCenterMask(p) (VME_Input_G1(p, uchar, 1, 31))\012\012// NOTE: replace v with U4U4 type with\012// (shift_count, shift_val) and set the value as (shift_val | (shift_count <<\012// 4))\012\012// Format = U4U4 (encoded value must fit in 12-bits)\012#define VME_GET_UNIInput_Mode0Cost(p) (VME_Input_G1(p, uchar, 2, 0))\012#define VME_GET_UNIInput_Mode1Cost(p) (VME_Input_G1(p, uchar, 2, 1))\012#define VME_GET_UNIInput_Mode2Cost(p) (VME_Input_G1(p, uchar, 2, 2))\012#define VME_GET_UNIInput_Mode3Cost(p) (VME_Input_G1(p, ucha",
"r, 2, 3))\012#define VME_GET_UNIInput_Mode4Cost(p) (VME_Input_G1(p, uchar, 2, 4))\012#define VME_GET_UNIInput_Mode5Cost(p) (VME_Input_G1(p, uchar, 2, 5))\012#define VME_GET_UNIInput_Mode6Cost(p) (VME_Input_G1(p, uchar, 2, 6))\012#define VME_GET_UNIInput_Mode7Cost(p) (VME_Input_G1(p, uchar, 2, 7))\012#define VME_GET_UNIInput_Mode8Cost(p) (VME_Input_G1(p, uchar, 2, 8))\012#define VME_GET_UNIInput_Mode9Cost(p) (VME_Input_G1(p, uchar, 2, 9))\012\012// Format = U4U4 (encoded value must fit in 12-bits)\012#define VME_GET_UNIInput_RefIDCost(p) (VME_Input_G1(p, uchar, 2, 10))\012\012// Format = U4U4 (encoded value must fit in 12-bits)\012#define VME_GET_UNIInput_ChromaIntraModeCost(p) (VME_Input_G1(p, uchar, 2, 11))\012\012// Format = U4U4 (encoded value must fit in 10-bits)\012#define VME_GET_UNIInput_MV0Cost(p) (VME_Input_G1(p, uchar, 2, 12))\012#define VME_GET_UNIInput_MV1Cost(p) (VME_Input_G1(p, uchar, 2, 13))\012#define VME_GET_UNIInput_MV2Cost(p) (VME_Input_G1(p, uchar, 2, 14))\012#define VME_GET_UNIInput_MV3Cost(p) (VME_Input_G1(p, uchar, 2, 15))\012#define VME_GET_",
"UNIInput_MV4Cost(p) (VME_Input_G1(p, uchar, 2, 16))\012#define VME_GET_UNIInput_MV5Cost(p) (VME_Input_G1(p, uchar, 2, 17))\012#define VME_GET_UNIInput_MV6Cost(p) (VME_Input_G1(p, uchar, 2, 18))\012#define VME_GET_UNIInput_MV7Cost(p) (VME_Input_G1(p, uchar, 2, 19))\012\012// Format = U8\012#define VME_GET_UNIInput_FBRMbModeInput(p) (VME_Input_G1(p, uchar, 2, 20) & 0x3)\012\012// Format = U8\012#define VME_GET_UNIInput_FBRSubMBShapeInput(p) (VME_Input_G1(p, uchar, 2, 21))\012\012// Format = U8\012#define VME_GET_UNIInput_FBRSubPredModeInput(p) (VME_Input_G1(p, uchar, 2, 22))\012\012// Format = U16\012#define VME_GET_UNIInput_SICFwdTCoeffThreshold0(p)                             \\\012  (VME_Input_G1(p, ushort, 2, 12))\012// Format = U8\012#define VME_GET_UNIInput_SICFwdTCoeffThreshold1(p)                             \\\012  (VME_Input_G1(p, uchar, 2, 26))\012#define VME_GET_UNIInput_SICFwdTCoeffThreshold2(p)                             \\\012  (VME_Input_G1(p, uchar, 2, 27))\012#define VME_GET_UNIInput_SICFwdTCoeffThreshold3(p)                             \\\012  (VME_Input_G1(p, uc",
"har, 2, 28))\012#define VME_GET_UNIInput_SICFwdTCoeffThreshold4(p)                             \\\012  (VME_Input_G1(p, uchar, 2, 29))\012#define VME_GET_UNIInput_SICFwdTCoeffThreshold5(p)                             \\\012  (VME_Input_G1(p, uchar, 2, 30))\012#define VME_GET_UNIInput_SICFwdTCoeffThreshold6(p)                             \\\012  (VME_Input_G1(p, uchar, 2, 31))\012\012// Return DeltaX in the lower 16 bit and DeltaY in the higher 16 bits\012// Format = S13.2, DletaX Valid Range: [-2048.00 to 2047.75], DletaY Valid\012// Range: [-512.00 to 511.75]\012#define VME_GET_UNIInput_FWDCostCenter0_X(p) (VME_Input_G1(p, ushort, 3, 0))\012#define VME_GET_UNIInput_FWDCostCenter0_Y(p) (VME_Input_G1(p, ushort, 3, 1))\012#define VME_GET_UNIInput_BWDCostCenter0_X(p) (VME_Input_G1(p, ushort, 3, 2))\012#define VME_GET_UNIInput_BWDCostCenter0_Y(p) (VME_Input_G1(p, ushort, 3, 3))\012#define VME_GET_UNIInput_FWDCostCenter1_X(p) (VME_Input_G1(p, ushort, 3, 4))\012#define VME_GET_UNIInput_FWDCostCenter1_Y(p) (VME_Input_G1(p, ushort, 3, 5))\012#define VME_GET_UNIInput_BWD",
"CostCenter1_X(p) (VME_Input_G1(p, ushort, 3, 6))\012#define VME_GET_UNIInput_BWDCostCenter1_Y(p) (VME_Input_G1(p, ushort, 3, 7))\012#define VME_GET_UNIInput_FWDCostCenter2_X(p) (VME_Input_G1(p, ushort, 3, 8))\012#define VME_GET_UNIInput_FWDCostCenter2_Y(p) (VME_Input_G1(p, ushort, 3, 9))\012#define VME_GET_UNIInput_BWDCostCenter2_X(p) (VME_Input_G1(p, ushort, 3, 10))\012#define VME_GET_UNIInput_BWDCostCenter2_Y(p) (VME_Input_G1(p, ushort, 3, 11))\012#define VME_GET_UNIInput_FWDCostCenter3_X(p) (VME_Input_G1(p, ushort, 3, 12))\012#define VME_GET_UNIInput_FWDCostCenter3_Y(p) (VME_Input_G1(p, ushort, 3, 13))\012#define VME_GET_UNIInput_BWDCostCenter3_X(p) (VME_Input_G1(p, ushort, 3, 14))\012#define VME_GET_UNIInput_BWDCostCenter3_Y(p) (VME_Input_G1(p, ushort, 3, 15))\012\012// Format = U8, with the following definition:\012// [7:4] (Y) - specifies relative Y distance to the next SU from previous SU in\012// units of SU\012// [3:0] (X) - specifies relative X distance to the next SU from previous SU in\012// units of SU\012#define VME_GET_IMEInput_IMESearchPath",
"Delta0(p) (VME_Input_G1(p, uchar, 0, 0))\012#define VME_GET_IMEInput_IMESearchPathDelta1(p) (VME_Input_G1(p, uchar, 0, 1))\012#define VME_GET_IMEInput_IMESearchPathDelta2(p) (VME_Input_G1(p, uchar, 0, 2))\012#define VME_GET_IMEInput_IMESearchPathDelta3(p) (VME_Input_G1(p, uchar, 0, 3))\012#define VME_GET_IMEInput_IMESearchPathDelta4(p) (VME_Input_G1(p, uchar, 0, 4))\012#define VME_GET_IMEInput_IMESearchPathDelta5(p) (VME_Input_G1(p, uchar, 0, 5))\012#define VME_GET_IMEInput_IMESearchPathDelta6(p) (VME_Input_G1(p, uchar, 0, 6))\012#define VME_GET_IMEInput_IMESearchPathDelta7(p) (VME_Input_G1(p, uchar, 0, 7))\012#define VME_GET_IMEInput_IMESearchPathDelta8(p) (VME_Input_G1(p, uchar, 0, 8))\012#define VME_GET_IMEInput_IMESearchPathDelta9(p) (VME_Input_G1(p, uchar, 0, 9))\012#define VME_GET_IMEInput_IMESearchPathDelta10(p) (VME_Input_G1(p, uchar, 0, 10))\012#define VME_GET_IMEInput_IMESearchPathDelta11(p) (VME_Input_G1(p, uchar, 0, 11))\012#define VME_GET_IMEInput_IMESearchPathDelta12(p) (VME_Input_G1(p, uchar, 0, 12))\012#define VME_GET_IMEInput_IMES",
"earchPathDelta13(p) (VME_Input_G1(p, uchar, 0, 13))\012#define VME_GET_IMEInput_IMESearchPathDelta14(p) (VME_Input_G1(p, uchar, 0, 14))\012#define VME_GET_IMEInput_IMESearchPathDelta15(p) (VME_Input_G1(p, uchar, 0, 15))\012#define VME_GET_IMEInput_IMESearchPathDelta16(p) (VME_Input_G1(p, uchar, 0, 16))\012#define VME_GET_IMEInput_IMESearchPathDelta17(p) (VME_Input_G1(p, uchar, 0, 17))\012#define VME_GET_IMEInput_IMESearchPathDelta18(p) (VME_Input_G1(p, uchar, 0, 18))\012#define VME_GET_IMEInput_IMESearchPathDelta19(p) (VME_Input_G1(p, uchar, 0, 19))\012#define VME_GET_IMEInput_IMESearchPathDelta20(p) (VME_Input_G1(p, uchar, 0, 20))\012#define VME_GET_IMEInput_IMESearchPathDelta21(p) (VME_Input_G1(p, uchar, 0, 21))\012#define VME_GET_IMEInput_IMESearchPathDelta22(p) (VME_Input_G1(p, uchar, 0, 22))\012#define VME_GET_IMEInput_IMESearchPathDelta23(p) (VME_Input_G1(p, uchar, 0, 23))\012#define VME_GET_IMEInput_IMESearchPathDelta24(p) (VME_Input_G1(p, uchar, 0, 24))\012#define VME_GET_IMEInput_IMESearchPathDelta25(p) (VME_Input_G1(p, uchar, 0, 25))\012",
"#define VME_GET_IMEInput_IMESearchPathDelta26(p) (VME_Input_G1(p, uchar, 0, 26))\012#define VME_GET_IMEInput_IMESearchPathDelta27(p) (VME_Input_G1(p, uchar, 0, 27))\012#define VME_GET_IMEInput_IMESearchPathDelta28(p) (VME_Input_G1(p, uchar, 0, 28))\012#define VME_GET_IMEInput_IMESearchPathDelta29(p) (VME_Input_G1(p, uchar, 0, 29))\012#define VME_GET_IMEInput_IMESearchPathDelta30(p) (VME_Input_G1(p, uchar, 0, 30))\012#define VME_GET_IMEInput_IMESearchPathDelta31(p) (VME_Input_G1(p, uchar, 0, 31))\012\012#define VME_GET_IMEInput_IMESearchPathDelta32(p) (VME_Input_G1(p, uchar, 1, 0))\012#define VME_GET_IMEInput_IMESearchPathDelta33(p) (VME_Input_G1(p, uchar, 1, 1))\012#define VME_GET_IMEInput_IMESearchPathDelta34(p) (VME_Input_G1(p, uchar, 1, 2))\012#define VME_GET_IMEInput_IMESearchPathDelta35(p) (VME_Input_G1(p, uchar, 1, 3))\012#define VME_GET_IMEInput_IMESearchPathDelta36(p) (VME_Input_G1(p, uchar, 1, 4))\012#define VME_GET_IMEInput_IMESearchPathDelta37(p) (VME_Input_G1(p, uchar, 1, 5))\012#define VME_GET_IMEInput_IMESearchPathDelta38(p) (VME_Inp",
"ut_G1(p, uchar, 1, 6))\012#define VME_GET_IMEInput_IMESearchPathDelta39(p) (VME_Input_G1(p, uchar, 1, 7))\012#define VME_GET_IMEInput_IMESearchPathDelta40(p) (VME_Input_G1(p, uchar, 1, 8))\012#define VME_GET_IMEInput_IMESearchPathDelta41(p) (VME_Input_G1(p, uchar, 1, 9))\012#define VME_GET_IMEInput_IMESearchPathDelta42(p) (VME_Input_G1(p, uchar, 1, 10))\012#define VME_GET_IMEInput_IMESearchPathDelta43(p) (VME_Input_G1(p, uchar, 1, 11))\012#define VME_GET_IMEInput_IMESearchPathDelta44(p) (VME_Input_G1(p, uchar, 1, 12))\012#define VME_GET_IMEInput_IMESearchPathDelta45(p) (VME_Input_G1(p, uchar, 1, 13))\012#define VME_GET_IMEInput_IMESearchPathDelta46(p) (VME_Input_G1(p, uchar, 1, 14))\012#define VME_GET_IMEInput_IMESearchPathDelta47(p) (VME_Input_G1(p, uchar, 1, 15))\012#define VME_GET_IMEInput_IMESearchPathDelta48(p) (VME_Input_G1(p, uchar, 1, 16))\012#define VME_GET_IMEInput_IMESearchPathDelta49(p) (VME_Input_G1(p, uchar, 1, 17))\012#define VME_GET_IMEInput_IMESearchPathDelta50(p) (VME_Input_G1(p, uchar, 1, 18))\012#define VME_GET_IMEInput_IMESear",
"chPathDelta51(p) (VME_Input_G1(p, uchar, 1, 19))\012#define VME_GET_IMEInput_IMESearchPathDelta52(p) (VME_Input_G1(p, uchar, 1, 20))\012#define VME_GET_IMEInput_IMESearchPathDelta53(p) (VME_Input_G1(p, uchar, 1, 21))\012#define VME_GET_IMEInput_IMESearchPathDelta54(p) (VME_Input_G1(p, uchar, 1, 22))\012#define VME_GET_IMEInput_IMESearchPathDelta55(p) (VME_Input_G1(p, uchar, 1, 23))\012\012// Format = U16\012#define VME_GET_IMEInput_Rec0_16x8_0Distortion(p)                              \\\012  (VME_Input_G1(p, ushort, 2, 0))\012#define VME_GET_IMEInput_Rec0_16x8_1Distortion(p)                              \\\012  (VME_Input_G1(p, ushort, 2, 1))\012#define VME_GET_IMEInput_Rec0_8x16_0Distortion(p)                              \\\012  (VME_Input_G1(p, ushort, 2, 2))\012#define VME_GET_IMEInput_Rec0_8x16_1Distortion(p)                              \\\012  (VME_Input_G1(p, ushort, 2, 3))\012#define VME_GET_IMEInput_Rec0_8x8_0Distortion(p) (VME_Input_G1(p, ushort, 2, 4))\012#define VME_GET_IMEInput_Rec0_8x8_1Distortion(p) (VME_Input_G1(p, ushort, 2, 5))\012#define VME_",
"GET_IMEInput_Rec0_8x8_2Distortion(p) (VME_Input_G1(p, ushort, 2, 6))\012#define VME_GET_IMEInput_Rec0_8x8_3Distortion(p) (VME_Input_G1(p, ushort, 2, 7))\012#define VME_GET_IMEInput_Rec0_16x16_Distortion(p)                              \\\012  (VME_Input_G1(p, ushort, 2, 8))\012\012// Format = U4\012#define VME_GET_UNIInput_Rec0_16x16_RefID(p)                                   \\\012  (VME_Input_G1(p, uchar, 2, 18) & 0x0F)\012\012// Format = S13.2\012#define VME_GET_IMEInput_Rec0_16x16_X(p) (VME_Input_G1(p, ushort, 2, 10))\012#define VME_GET_IMEInput_Rec0_16x16_Y(p) (VME_Input_G1(p, ushort, 2, 11))\012\012// Format = U4\012#define VME_GET_IMEInput_Rec0_16x8_0to1RefID(p) (VME_Input_G1(p, uchar, 2, 24))\012#define VME_GET_IMEInput_Rec0_8x16_0to1RefID(p) (VME_Input_G1(p, uchar, 2, 25))\012#define VME_GET_IMEInput_Rec0_8x8_0to1RefID(p) (VME_Input_G1(p, uchar, 2, 26))\012#define VME_GET_IMEInput_Rec0_8x8_2to3RefID(p) (VME_Input_G1(p, uchar, 2, 27))\012\012// Format = S13.2\012#define VME_GET_IMEInput_Rec0_16x8_0X(p) (VME_Input_G1(p, ushort, 3, 0))\012#define VME_GET_IMEInput_Rec",
"0_16x8_0Y(p) (VME_Input_G1(p, ushort, 3, 1))\012#define VME_GET_IMEInput_Rec0_16x8_1X(p) (VME_Input_G1(p, ushort, 3, 2))\012#define VME_GET_IMEInput_Rec0_16x8_1Y(p) (VME_Input_G1(p, ushort, 3, 3))\012#define VME_GET_IMEInput_Rec0_8x16_0X(p) (VME_Input_G1(p, ushort, 3, 4))\012#define VME_GET_IMEInput_Rec0_8x16_0Y(p) (VME_Input_G1(p, ushort, 3, 5))\012#define VME_GET_IMEInput_Rec0_8x16_1X(p) (VME_Input_G1(p, ushort, 3, 6))\012#define VME_GET_IMEInput_Rec0_8x16_1Y(p) (VME_Input_G1(p, ushort, 3, 7))\012#define VME_GET_IMEInput_Rec0_8x8_0X(p) (VME_Input_G1(p, ushort, 3, 8))\012#define VME_GET_IMEInput_Rec0_8x8_0Y(p) (VME_Input_G1(p, ushort, 3, 9))\012#define VME_GET_IMEInput_Rec0_8x8_1X(p) (VME_Input_G1(p, ushort, 3, 10))\012#define VME_GET_IMEInput_Rec0_8x8_1Y(p) (VME_Input_G1(p, ushort, 3, 11))\012#define VME_GET_IMEInput_Rec0_8x8_2X(p) (VME_Input_G1(p, ushort, 3, 12))\012#define VME_GET_IMEInput_Rec0_8x8_2Y(p) (VME_Input_G1(p, ushort, 3, 13))\012#define VME_GET_IMEInput_Rec0_8x8_3X(p) (VME_Input_G1(p, ushort, 3, 14))\012#define VME_GET_IMEInput_Rec0_8x",
"8_3Y(p) (VME_Input_G1(p, ushort, 3, 15))\012\012// Format = U16\012#define VME_GET_IMEInput_Rec1_16x8_0Distortion(p)                              \\\012  (VME_Input_G1(p, ushort, 4, 0))\012#define VME_GET_IMEInput_Rec1_16x8_1Distortion(p)                              \\\012  (VME_Input_G1(p, ushort, 4, 1))\012#define VME_GET_IMEInput_Rec1_8x16_0Distortion(p)                              \\\012  (VME_Input_G1(p, ushort, 4, 2))\012#define VME_GET_IMEInput_Rec1_8x16_1Distortion(p)                              \\\012  (VME_Input_G1(p, ushort, 4, 3))\012#define VME_GET_IMEInput_Rec1_8x8_0Distortion(p) (VME_Input_G1(p, ushort, 4, 4))\012#define VME_GET_IMEInput_Rec1_8x8_1Distortion(p) (VME_Input_G1(p, ushort, 4, 5))\012#define VME_GET_IMEInput_Rec1_8x8_2Distortion(p) (VME_Input_G1(p, ushort, 4, 6))\012#define VME_GET_IMEInput_Rec1_8x8_3Distortion(p) (VME_Input_G1(p, ushort, 4, 7))\012#define VME_GET_IMEInput_Rec1_16x16_Distortion(p)                              \\\012  (VME_Input_G1(p, ushort, 4, 8))\012\012// Format = U4\012#define VME_GET_UNIInput_Rec1_16x16_RefID(p) (VME_I",
"nput_G1(p, uchar, 4, 18))\012\012// Format = S13.2\012#define VME_GET_IMEInput_Rec1_16x16_X(p) (VME_Input_G1(p, ushort, 4, 10))\012#define VME_GET_IMEInput_Rec1_16x16_Y(p) (VME_Input_G1(p, ushort, 4, 11))\012\012// Format = U4\012#define VME_GET_IMEInput_Rec1_16x8_0to1RefID(p) (VME_Input_G1(p, uchar, 4, 24))\012#define VME_GET_IMEInput_Rec1_8x16_0to1RefID(p) (VME_Input_G1(p, uchar, 4, 25))\012#define VME_GET_IMEInput_Rec1_8x8_0to1RefID(p) (VME_Input_G1(p, uchar, 4, 26))\012#define VME_GET_IMEInput_Rec1_8x8_2to3RefID(p) (VME_Input_G1(p, uchar, 4, 27))\012\012// Format = S13.2\012#define VME_GET_IMEInput_Rec1_16x8_0X(p) (VME_Input_G1(p, ushort, 5, 0))\012#define VME_GET_IMEInput_Rec1_16x8_0Y(p) (VME_Input_G1(p, ushort, 5, 1))\012#define VME_GET_IMEInput_Rec1_16x8_1X(p) (VME_Input_G1(p, ushort, 5, 2))\012#define VME_GET_IMEInput_Rec1_16x8_1Y(p) (VME_Input_G1(p, ushort, 5, 3))\012#define VME_GET_IMEInput_Rec1_8x16_0X(p) (VME_Input_G1(p, ushort, 5, 4))\012#define VME_GET_IMEInput_Rec1_8x16_0Y(p) (VME_Input_G1(p, ushort, 5, 5))\012#define VME_GET_IMEInput_Rec1_8x16_1X(p)",
" (VME_Input_G1(p, ushort, 5, 6))\012#define VME_GET_IMEInput_Rec1_8x16_1Y(p) (VME_Input_G1(p, ushort, 5, 7))\012#define VME_GET_IMEInput_Rec1_8x8_0X(p) (VME_Input_G1(p, ushort, 5, 8))\012#define VME_GET_IMEInput_Rec1_8x8_0Y(p) (VME_Input_G1(p, ushort, 5, 9))\012#define VME_GET_IMEInput_Rec1_8x8_1X(p) (VME_Input_G1(p, ushort, 5, 10))\012#define VME_GET_IMEInput_Rec1_8x8_1Y(p) (VME_Input_G1(p, ushort, 5, 11))\012#define VME_GET_IMEInput_Rec1_8x8_2X(p) (VME_Input_G1(p, ushort, 5, 12))\012#define VME_GET_IMEInput_Rec1_8x8_2Y(p) (VME_Input_G1(p, ushort, 5, 13))\012#define VME_GET_IMEInput_Rec1_8x8_3X(p) (VME_Input_G1(p, ushort, 5, 14))\012#define VME_GET_IMEInput_Rec1_8x8_3Y(p) (VME_Input_G1(p, ushort, 5, 15))\012\012// Format = S13.2, Valid Range: [-2048.00 to 2047.75]\012// For chroma skip: Format = S12.3, Hardware Range: [-1024.000 to 1023.875]\012#define VME_GET_SICInput_Ref0SkipCenter0DeltaX(p)                              \\\012  (VME_Input_G1(p, ushort, 0, 0))\012#define VME_GET_SICInput_Ref0SkipCenter0DeltaY(p)                              \\\012  (VME_In",
"put_G1(p, ushort, 0, 1))\012\012#define VME_GET_SICInput_Ref1SkipCenter0DeltaX(p)                              \\\012  (VME_Input_G1(p, ushort, 0, 2))\012#define VME_GET_SICInput_Ref1SkipCenter0DeltaY(p)                              \\\012  (VME_Input_G1(p, ushort, 0, 3))\012\012#define VME_GET_SICInput_Ref0SkipCenter1DeltaX(p)                              \\\012  (VME_Input_G1(p, ushort, 0, 4))\012#define VME_GET_SICInput_Ref0SkipCenter1DeltaY(p)                              \\\012  (VME_Input_G1(p, ushort, 0, 5))\012\012#define VME_GET_SICInput_Ref1SkipCenter1DeltaX(p)                              \\\012  (VME_Input_G1(p, ushort, 0, 6))\012#define VME_GET_SICInput_Ref1SkipCenter1DeltaY(p)                              \\\012  (VME_Input_G1(p, ushort, 0, 7))\012\012#define VME_GET_SICInput_Ref0SkipCenter2DeltaX(p)                              \\\012  (VME_Input_G1(p, ushort, 0, 8))\012#define VME_GET_SICInput_Ref0SkipCenter2DeltaY(p)                              \\\012  (VME_Input_G1(p, ushort, 0, 9))\012\012#define VME_GET_SICInput_Ref1SkipCenter2DeltaX(p)                         ",
"     \\\012  (VME_Input_G1(p, ushort, 0, 10))\012#define VME_GET_SICInput_Ref1SkipCenter2DeltaY(p)                              \\\012  (VME_Input_G1(p, ushort, 0, 11))\012\012#define VME_GET_SICInput_Ref0SkipCenter3DeltaX(p)                              \\\012  (VME_Input_G1(p, ushort, 0, 12))\012#define VME_GET_SICInput_Ref0SkipCenter3DeltaY(p)                              \\\012  (VME_Input_G1(p, ushort, 0, 13))\012\012#define VME_GET_SICInput_Ref1SkipCenter3DeltaX(p)                              \\\012  (VME_Input_G1(p, ushort, 0, 14))\012#define VME_GET_SICInput_Ref1SkipCenter3DeltaY(p)                              \\\012  (VME_Input_G1(p, ushort, 0, 15))\012\012#define VME_GET_SICInput_Intra4x4ModeMask(p) (VME_Input_G1(p, uchar, 1, 0))\012\012#define VME_GET_SICInput_Intra8x8ModeMask(p) (VME_Input_G1(p, uchar, 1, 2))\012\012#define VME_GET_SICInput_IntraModeMask(p) (VME_Input_G1(p, uchar, 1, 4))\012\012// 2-bit field with the following definition\012// 00: Luma + Chroma enabled\012// 01: Luma only\012// 1X: Intra disabled\012#define VME_GET_SICInput_IntraComputeType(p)              ",
"                     \\\012  (VME_Input_G1(p, uchar, 1, 5) & 0x3)\012\012#define VME_GET_SICInput_CornerNeighborPixel0(p) (VME_Input_G1(p, uchar, 1, 7))\012\012#define VME_GET_SICInput_NeighborPixelLum0(p) (VME_Input_G1(p, uchar, 1, 8))\012#define VME_GET_SICInput_NeighborPixelLum1(p) (VME_Input_G1(p, uchar, 1, 9))\012#define VME_GET_SICInput_NeighborPixelLum2(p) (VME_Input_G1(p, uchar, 1, 10))\012#define VME_GET_SICInput_NeighborPixelLum3(p) (VME_Input_G1(p, uchar, 1, 11))\012#define VME_GET_SICInput_NeighborPixelLum4(p) (VME_Input_G1(p, uchar, 1, 12))\012#define VME_GET_SICInput_NeighborPixelLum5(p) (VME_Input_G1(p, uchar, 1, 13))\012#define VME_GET_SICInput_NeighborPixelLum6(p) (VME_Input_G1(p, uchar, 1, 14))\012#define VME_GET_SICInput_NeighborPixelLum7(p) (VME_Input_G1(p, uchar, 1, 15))\012#define VME_GET_SICInput_NeighborPixelLum8(p) (VME_Input_G1(p, uchar, 1, 16))\012#define VME_GET_SICInput_NeighborPixelLum9(p) (VME_Input_G1(p, uchar, 1, 17))\012#define VME_GET_SICInput_NeighborPixelLum10(p) (VME_Input_G1(p, uchar, 1, 18))\012#define VME_GET_SICInpu",
"t_NeighborPixelLum11(p) (VME_Input_G1(p, uchar, 1, 19))\012#define VME_GET_SICInput_NeighborPixelLum12(p) (VME_Input_G1(p, uchar, 1, 20))\012#define VME_GET_SICInput_NeighborPixelLum13(p) (VME_Input_G1(p, uchar, 1, 21))\012#define VME_GET_SICInput_NeighborPixelLum14(p) (VME_Input_G1(p, uchar, 1, 22))\012#define VME_GET_SICInput_NeighborPixelLum15(p) (VME_Input_G1(p, uchar, 1, 23))\012#define VME_GET_SICInput_NeighborPixelLum16(p) (VME_Input_G1(p, uchar, 1, 24))\012#define VME_GET_SICInput_NeighborPixelLum17(p) (VME_Input_G1(p, uchar, 1, 25))\012#define VME_GET_SICInput_NeighborPixelLum18(p) (VME_Input_G1(p, uchar, 1, 26))\012#define VME_GET_SICInput_NeighborPixelLum19(p) (VME_Input_G1(p, uchar, 1, 27))\012#define VME_GET_SICInput_NeighborPixelLum20(p) (VME_Input_G1(p, uchar, 1, 28))\012#define VME_GET_SICInput_NeighborPixelLum21(p) (VME_Input_G1(p, uchar, 1, 29))\012#define VME_GET_SICInput_NeighborPixelLum22(p) (VME_Input_G1(p, uchar, 1, 30))\012#define VME_GET_SICInput_NeighborPixelLum23(p) (VME_Input_G1(p, uchar, 1, 31))\012#define VME_GET_SICI",
"nput_NeighborPixelLum24(p) (VME_Input_G1(p, uchar, 2, 0))\012#define VME_GET_SICInput_NeighborPixelLum25(p) (VME_Input_G1(p, uchar, 2, 1))\012#define VME_GET_SICInput_NeighborPixelLum26(p) (VME_Input_G1(p, uchar, 2, 2))\012#define VME_GET_SICInput_NeighborPixelLum27(p) (VME_Input_G1(p, uchar, 2, 3))\012#define VME_GET_SICInput_NeighborPixelLum28(p) (VME_Input_G1(p, uchar, 2, 4))\012#define VME_GET_SICInput_NeighborPixelLum29(p) (VME_Input_G1(p, uchar, 2, 5))\012#define VME_GET_SICInput_NeighborPixelLum30(p) (VME_Input_G1(p, uchar, 2, 6))\012#define VME_GET_SICInput_NeighborPixelLum31(p) (VME_Input_G1(p, uchar, 2, 7))\012#define VME_GET_SICInput_NeighborPixelLum32(p) (VME_Input_G1(p, uchar, 2, 8))\012#define VME_GET_SICInput_NeighborPixelLum33(p) (VME_Input_G1(p, uchar, 2, 9))\012#define VME_GET_SICInput_NeighborPixelLum34(p) (VME_Input_G1(p, uchar, 2, 10))\012#define VME_GET_SICInput_NeighborPixelLum35(p) (VME_Input_G1(p, uchar, 2, 11))\012#define VME_GET_SICInput_NeighborPixelLum36(p) (VME_Input_G1(p, uchar, 2, 12))\012#define VME_GET_SICInput_Ne",
"ighborPixelLum37(p) (VME_Input_G1(p, uchar, 2, 13))\012#define VME_GET_SICInput_NeighborPixelLum38(p) (VME_Input_G1(p, uchar, 2, 14))\012\012#define VME_GET_SICInput_CornerNeighborPixel1(p) (VME_Input_G1(p, uchar, 2, 15))\012\012#define VME_GET_SICInput_LeftModes(p) (VME_Input_G1(p, ushort, 2, 8))\012\012#define VME_GET_SICInput_TopModes(p) (VME_Input_G1(p, ushort, 2, 9))\012\012// Format = U8 pair\012#define VME_GET_SICInput_CornerNeighborPixelChroma(p)                          \\\012  (VME_Input_G1(p, ushort, 2, 10))\012\012#if 0\012// Format = U4U4\012#define VME_GET_SICInput_PenaltyIntra4x4NonDC(p) (VME_Input_G1(p, uchar, 2, 28))\012// Format = U2\012#define VME_GET_SICInput_ScaleFactorIntra8x8NonDC(p)                           \\\012  (VME_Input_G1(p, uchar, 2, 29) & 0x3)\012// Format = U2\012#define VME_GET_SICInput_ScaleFactorIntra16x16NonDC(p)                         \\\012  ((VME_Input_G1(p, uchar, 2, 29) & 0xC) >> 2)\012#else\012// Format = U8\012#define VME_GET_SICInput_PenaltyIntra4x4NonDC(p) (VME_Input_G1(p, uchar, 2, 30))\012// Format = U8\012#define VME_GET_SICInput_Penalty",
"Intra8x8NonDC(p) (VME_Input_G1(p, uchar, 2, 29))\012// Format = U8\012#define VME_GET_SICInput_PenaltyIntra16x16NonDC(p)                             \\\012  (VME_Input_G1(p, uchar, 2, 28))\012#endif\012\012#define VME_GET_SICInput_NeighborPixelChroma0(p) (VME_Input_G1(p, uchar, 3, 0))\012#define VME_GET_SICInput_NeighborPixelChroma1(p) (VME_Input_G1(p, uchar, 3, 1))\012#define VME_GET_SICInput_NeighborPixelChroma2(p) (VME_Input_G1(p, uchar, 3, 2))\012#define VME_GET_SICInput_NeighborPixelChroma3(p) (VME_Input_G1(p, uchar, 3, 3))\012\012#define VME_GET_SICInput_NeighborPixelChroma4(p) (VME_Input_G1(p, uchar, 3, 4))\012#define VME_GET_SICInput_NeighborPixelChroma5(p) (VME_Input_G1(p, uchar, 3, 5))\012#define VME_GET_SICInput_NeighborPixelChroma6(p) (VME_Input_G1(p, uchar, 3, 6))\012#define VME_GET_SICInput_NeighborPixelChroma7(p) (VME_Input_G1(p, uchar, 3, 7))\012\012#define VME_GET_SICInput_NeighborPixelChroma8(p) (VME_Input_G1(p, uchar, 3, 8))\012#define VME_GET_SICInput_NeighborPixelChroma9(p) (VME_Input_G1(p, uchar, 3, 9))\012#define VME_GET_SICInput_NeighborPi",
"xelChroma10(p)                              \\\012  (VME_Input_G1(p, uchar, 3, 10))\012#define VME_GET_SICInput_NeighborPixelChroma11(p)                              \\\012  (VME_Input_G1(p, uchar, 3, 11))\012\012#define VME_GET_SICInput_NeighborPixelChroma12(p)                              \\\012  (VME_Input_G1(p, uchar, 3, 12))\012#define VME_GET_SICInput_NeighborPixelChroma13(p)                              \\\012  (VME_Input_G1(p, uchar, 3, 13))\012#define VME_GET_SICInput_NeighborPixelChroma14(p)                              \\\012  (VME_Input_G1(p, uchar, 3, 14))\012#define VME_GET_SICInput_NeighborPixelChroma15(p)                              \\\012  (VME_Input_G1(p, uchar, 3, 15))\012\012#define VME_GET_SICInput_NeighborPixelChroma16(p)                              \\\012  (VME_Input_G1(p, uchar, 3, 16))\012#define VME_GET_SICInput_NeighborPixelChroma17(p)                              \\\012  (VME_Input_G1(p, uchar, 3, 17))\012#define VME_GET_SICInput_NeighborPixelChroma18(p)                              \\\012  (VME_Input_G1(p, uchar, 3, 18))\012#define VME_GET_SICInp",
"ut_NeighborPixelChroma19(p)                              \\\012  (VME_Input_G1(p, uchar, 3, 19))\012\012#define VME_GET_SICInput_NeighborPixelChroma20(p)                              \\\012  (VME_Input_G1(p, uchar, 3, 20))\012#define VME_GET_SICInput_NeighborPixelChroma21(p)                              \\\012  (VME_Input_G1(p, uchar, 3, 21))\012#define VME_GET_SICInput_NeighborPixelChroma22(p)                              \\\012  (VME_Input_G1(p, uchar, 3, 22))\012#define VME_GET_SICInput_NeighborPixelChroma23(p)                              \\\012  (VME_Input_G1(p, uchar, 3, 23))\012\012#define VME_GET_SICInput_NeighborPixelChroma24(p)                              \\\012  (VME_Input_G1(p, uchar, 3, 24))\012#define VME_GET_SICInput_NeighborPixelChroma25(p)                              \\\012  (VME_Input_G1(p, uchar, 3, 25))\012#define VME_GET_SICInput_NeighborPixelChroma26(p)                              \\\012  (VME_Input_G1(p, uchar, 3, 26))\012#define VME_GET_SICInput_NeighborPixelChroma27(p)                              \\\012  (VME_Input_G1(p, uchar, 3, 27))\012\012#define ",
"VME_GET_SICInput_NeighborPixelChroma28(p)                              \\\012  (VME_Input_G1(p, uchar, 3, 28))\012#define VME_GET_SICInput_NeighborPixelChroma29(p)                              \\\012  (VME_Input_G1(p, uchar, 3, 29))\012#define VME_GET_SICInput_NeighborPixelChroma30(p)                              \\\012  (VME_Input_G1(p, uchar, 3, 30))\012#define VME_GET_SICInput_NeighborPixelChroma31(p)                              \\\012  (VME_Input_G1(p, uchar, 3, 31))\012\012#define VME_GET_FBRInput_Ref0SubBlockX0(p) (VME_Input_G1(p, ushort, 0, 0))\012#define VME_GET_FBRInput_Ref0SubBlockY0(p) (VME_Input_G1(p, ushort, 0, 1))\012#define VME_GET_FBRInput_Ref1SubBlockX0(p) (VME_Input_G1(p, ushort, 0, 2))\012#define VME_GET_FBRInput_Ref1SubBlockY0(p) (VME_Input_G1(p, ushort, 0, 3))\012\012#define VME_GET_FBRInput_Ref0SubBlockX1(p) (VME_Input_G1(p, ushort, 0, 4))\012#define VME_GET_FBRInput_Ref0SubBlockY1(p) (VME_Input_G1(p, ushort, 0, 5))\012#define VME_GET_FBRInput_Ref1SubBlockX1(p) (VME_Input_G1(p, ushort, 0, 6))\012#define VME_GET_FBRInput_Ref1SubBlockY1(p) (V",
"ME_Input_G1(p, ushort, 0, 7))\012\012#define VME_GET_FBRInput_Ref0SubBlockX2(p) (VME_Input_G1(p, ushort, 0, 8))\012#define VME_GET_FBRInput_Ref0SubBlockY2(p) (VME_Input_G1(p, ushort, 0, 9))\012#define VME_GET_FBRInput_Ref1SubBlockX2(p) (VME_Input_G1(p, ushort, 0, 10))\012#define VME_GET_FBRInput_Ref1SubBlockY2(p) (VME_Input_G1(p, ushort, 0, 11))\012\012#define VME_GET_FBRInput_Ref0SubBlockX3(p) (VME_Input_G1(p, ushort, 0, 12))\012#define VME_GET_FBRInput_Ref0SubBlockY3(p) (VME_Input_G1(p, ushort, 0, 13))\012#define VME_GET_FBRInput_Ref1SubBlockX3(p) (VME_Input_G1(p, ushort, 0, 14))\012#define VME_GET_FBRInput_Ref1SubBlockY3(p) (VME_Input_G1(p, ushort, 0, 15))\012\012#define VME_GET_FBRInput_Ref0SubBlockX4(p) (VME_Input_G1(p, ushort, 1, 0))\012#define VME_GET_FBRInput_Ref0SubBlockY4(p) (VME_Input_G1(p, ushort, 1, 1))\012#define VME_GET_FBRInput_Ref1SubBlockX4(p) (VME_Input_G1(p, ushort, 1, 2))\012#define VME_GET_FBRInput_Ref1SubBlockY4(p) (VME_Input_G1(p, ushort, 1, 3))\012\012#define VME_GET_FBRInput_Ref0SubBlockX5(p) (VME_Input_G1(p, ushort, 1, 4))\012#define V",
"ME_GET_FBRInput_Ref0SubBlockY5(p) (VME_Input_G1(p, ushort, 1, 5))\012#define VME_GET_FBRInput_Ref1SubBlockX5(p) (VME_Input_G1(p, ushort, 1, 6))\012#define VME_GET_FBRInput_Ref1SubBlockY5(p) (VME_Input_G1(p, ushort, 1, 7))\012\012#define VME_GET_FBRInput_Ref0SubBlockX6(p) (VME_Input_G1(p, ushort, 1, 8))\012#define VME_GET_FBRInput_Ref0SubBlockY6(p) (VME_Input_G1(p, ushort, 1, 9))\012#define VME_GET_FBRInput_Ref1SubBlockX6(p) (VME_Input_G1(p, ushort, 1, 10))\012#define VME_GET_FBRInput_Ref1SubBlockY6(p) (VME_Input_G1(p, ushort, 1, 11))\012\012#define VME_GET_FBRInput_Ref0SubBlockX7(p) (VME_Input_G1(p, ushort, 1, 12))\012#define VME_GET_FBRInput_Ref0SubBlockY7(p) (VME_Input_G1(p, ushort, 1, 13))\012#define VME_GET_FBRInput_Ref1SubBlockX7(p) (VME_Input_G1(p, ushort, 1, 14))\012#define VME_GET_FBRInput_Ref1SubBlockY7(p) (VME_Input_G1(p, ushort, 1, 15))\012\012#define VME_GET_FBRInput_Ref0SubBlockX8(p) (VME_Input_G1(p, ushort, 2, 0))\012#define VME_GET_FBRInput_Ref0SubBlockY8(p) (VME_Input_G1(p, ushort, 2, 1))\012#define VME_GET_FBRInput_Ref1SubBlockX8(p) (VME_I",
"nput_G1(p, ushort, 2, 2))\012#define VME_GET_FBRInput_Ref1SubBlockY8(p) (VME_Input_G1(p, ushort, 2, 3))\012\012#define VME_GET_FBRInput_Ref0SubBlockX9(p) (VME_Input_G1(p, ushort, 2, 4))\012#define VME_GET_FBRInput_Ref0SubBlockY9(p) (VME_Input_G1(p, ushort, 2, 5))\012#define VME_GET_FBRInput_Ref1SubBlockX9(p) (VME_Input_G1(p, ushort, 2, 6))\012#define VME_GET_FBRInput_Ref1SubBlockY9(p) (VME_Input_G1(p, ushort, 2, 7))\012\012#define VME_GET_FBRInput_Ref0SubBlockX10(p) (VME_Input_G1(p, ushort, 2, 8))\012#define VME_GET_FBRInput_Ref0SubBlockY10(p) (VME_Input_G1(p, ushort, 2, 9))\012#define VME_GET_FBRInput_Ref1SubBlockX10(p) (VME_Input_G1(p, ushort, 2, 10))\012#define VME_GET_FBRInput_Ref1SubBlockY10(p) (VME_Input_G1(p, ushort, 2, 11))\012\012#define VME_GET_FBRInput_Ref0SubBlockX11(p) (VME_Input_G1(p, ushort, 2, 12))\012#define VME_GET_FBRInput_Ref0SubBlockY11(p) (VME_Input_G1(p, ushort, 2, 13))\012#define VME_GET_FBRInput_Ref1SubBlockX11(p) (VME_Input_G1(p, ushort, 2, 14))\012#define VME_GET_FBRInput_Ref1SubBlockY11(p) (VME_Input_G1(p, ushort, 2, 15))\012\012#defi",
"ne VME_GET_FBRInput_Ref0SubBlockX12(p) (VME_Input_G1(p, ushort, 3, 0))\012#define VME_GET_FBRInput_Ref0SubBlockY12(p) (VME_Input_G1(p, ushort, 3, 1))\012#define VME_GET_FBRInput_Ref1SubBlockX12(p) (VME_Input_G1(p, ushort, 3, 2))\012#define VME_GET_FBRInput_Ref1SubBlockY12(p) (VME_Input_G1(p, ushort, 3, 3))\012\012#define VME_GET_FBRInput_Ref0SubBlockX13(p) (VME_Input_G1(p, ushort, 3, 4))\012#define VME_GET_FBRInput_Ref0SubBlockY13(p) (VME_Input_G1(p, ushort, 3, 5))\012#define VME_GET_FBRInput_Ref1SubBlockX13(p) (VME_Input_G1(p, ushort, 3, 6))\012#define VME_GET_FBRInput_Ref1SubBlockY13(p) (VME_Input_G1(p, ushort, 3, 7))\012\012#define VME_GET_FBRInput_Ref0SubBlockX14(p) (VME_Input_G1(p, ushort, 3, 8))\012#define VME_GET_FBRInput_Ref0SubBlockY14(p) (VME_Input_G1(p, ushort, 3, 9))\012#define VME_GET_FBRInput_Ref1SubBlockX14(p) (VME_Input_G1(p, ushort, 3, 10))\012#define VME_GET_FBRInput_Ref1SubBlockY14(p) (VME_Input_G1(p, ushort, 3, 11))\012\012#define VME_GET_FBRInput_Ref0SubBlockX15(p) (VME_Input_G1(p, ushort, 3, 12))\012#define VME_GET_FBRInput_Ref0SubBlo",
"ckY15(p) (VME_Input_G1(p, ushort, 3, 13))\012#define VME_GET_FBRInput_Ref1SubBlockX15(p) (VME_Input_G1(p, ushort, 3, 14))\012#define VME_GET_FBRInput_Ref1SubBlockY15(p) (VME_Input_G1(p, ushort, 3, 15))\012\012#define VME_GET_IDMInput_SrcMBPixelMaskRow0(p) (VME_Input_G1(p, ushort, 0, 0))\012#define VME_GET_IDMInput_SrcMBPixelMaskRow1(p) (VME_Input_G1(p, ushort, 0, 1))\012#define VME_GET_IDMInput_SrcMBPixelMaskRow2(p) (VME_Input_G1(p, ushort, 0, 2))\012#define VME_GET_IDMInput_SrcMBPixelMaskRow3(p) (VME_Input_G1(p, ushort, 0, 3))\012#define VME_GET_IDMInput_SrcMBPixelMaskRow4(p) (VME_Input_G1(p, ushort, 0, 4))\012#define VME_GET_IDMInput_SrcMBPixelMaskRow5(p) (VME_Input_G1(p, ushort, 0, 5))\012#define VME_GET_IDMInput_SrcMBPixelMaskRow6(p) (VME_Input_G1(p, ushort, 0, 6))\012#define VME_GET_IDMInput_SrcMBPixelMaskRow7(p) (VME_Input_G1(p, ushort, 0, 7))\012#define VME_GET_IDMInput_SrcMBPixelMaskRow8(p) (VME_Input_G1(p, ushort, 0, 8))\012#define VME_GET_IDMInput_SrcMBPixelMaskRow9(p) (VME_Input_G1(p, ushort, 0, 9))\012#define VME_GET_IDMInput_SrcMBPixelMa",
"skRow10(p) (VME_Input_G1(p, ushort, 0, 10))\012#define VME_GET_IDMInput_SrcMBPixelMaskRow11(p) (VME_Input_G1(p, ushort, 0, 11))\012#define VME_GET_IDMInput_SrcMBPixelMaskRow12(p) (VME_Input_G1(p, ushort, 0, 12))\012#define VME_GET_IDMInput_SrcMBPixelMaskRow13(p) (VME_Input_G1(p, ushort, 0, 13))\012#define VME_GET_IDMInput_SrcMBPixelMaskRow14(p) (VME_Input_G1(p, ushort, 0, 14))\012#define VME_GET_IDMInput_SrcMBPixelMaskRow15(p) (VME_Input_G1(p, ushort, 0, 15))\012\012// Output\012\012#define MODE_INTER_16X16 0x00\012#define MODE_INTER_16X8 0x01\012#define MODE_INTER_8X16 0x02\012#define MODE_INTER_8X8 0x03\012#define MODE_INTER_MINOR 0x03\012#define VME_GET_UNIOutput_InterMbMode(p, v)                                    \\\012  (v = VME_Output_S1(p, uchar, 0, 0) & 0x3)\012\012#define MODE_INTRA_16X16 0x00\012#define MODE_INTRA_8X8 0x10\012#define MODE_INTRA_4X4 0x20\012#define MODE_INTRA_PCM 0x30\012#define VME_GET_UNIOutput_IntraMbMode(p, v)                                    \\\012  (v = VME_Output_S1(p, uchar, 0, 0) & 0x30)\012\012#define MODE_FIELD_MB_POLARITY 0x80\012#define VME_GE",
"T_UNIOutput_FieldMbPolarityFlag(p, v)                            \\\012  (v = VME_Output_S1(p, uchar, 0, 0) & 0x80)\012\012#define VME_GET_UNIOutput_InterMbType(p, v)                                    \\\012  (v = VME_Output_S1(p, uchar, 0, 1) & 0x1F)\012\012#define VME_GET_UNIOutput_FieldMbFlag(p, v)                                    \\\012  (v = VME_Output_S1(p, uchar, 0, 1) & 0x40)\012\012#define VME_GET_UNIOutput_IntraMbType(p, v)                                    \\\012  (v = VME_Output_S1(p, uchar, 0, 2) & 0x1F)\012\012#define VME_GET_UNIOutput_IntraMbType(p, v)                                    \\\012  (v = VME_Output_S1(p, uchar, 0, 2) & 0x1F)\012\012#define VME_GET_UNIOutput_MvQuantity(p, v)                                     \\\012  (v = VME_Output_S1(p, uchar, 0, 3) & 0x1F)\012\012// SKL+\012#define VME_GET_UNIOutput_StreamOutOnlyLocal(p, v)                             \\\012  (v = (VME_Output_S1(p, uchar, 0, 3) & 0x20) >> 5)\012\012#define VME_GET_UNIOutput_MinHasLocal(p, v)                                    \\\012  (v = (VME_Output_S1(p, uchar, 0, 3) & 0x40) >> 6)\012\012",
"#define VME_GET_UNIOutput_StreamOutHasNoLocal(p, v)                            \\\012  (v = (VME_Output_S1(p, uchar, 0, 3) & 0x80) >> 7)\012\012// Format = U16\012#define VME_GET_UNIOutput_BestInterDistortion(p, v)                            \\\012  (v = VME_Output_S1(p, ushort, 0, 4))\012\012// Format = U16\012#define VME_GET_UNIOutput_SkipRawDistortion(p, v)                              \\\012  (v = VME_Output_S1(p, ushort, 0, 5))\012\012// Format = U16\012#define VME_GET_UNIOutput_BestIntraDistortion(p, v)                            \\\012  (v = VME_Output_S1(p, ushort, 0, 6))\012\012// Format = U16\012#define VME_GET_UNIOutput_BestChromaIntraDistortion(p, v)                      \\\012  (v = VME_Output_S1(p, ushort, 0, 7))\012\012#define VME_GET_UNIOutput_LumaIntraPredMode0(p, v)                             \\\012  (v = VME_Output_S1(p, ushort, 0, 8))\012#define VME_GET_UNIOutput_LumaIntraPredMode1(p, v)                             \\\012  (v = VME_Output_S1(p, ushort, 0, 9))\012#define VME_GET_UNIOutput_LumaIntraPredMode2(p, v)                             \\\012  (v = VME_Output_S1(",
"p, ushort, 0, 10))\012#define VME_GET_UNIOutput_LumaIntraPredMode3(p, v)                             \\\012  (v = VME_Output_S1(p, ushort, 0, 11))\012\012// 8-bit field with the following definition:\012// 7    Reserved : MBZ (for IntraPredAvailFlagF - F (pixel[-1,7] available for\012// MbAff)\012// 6    Reserved : MBZ (for IntraPredAvailFlagA/E - A (left neighbor top half\012// for MbAff)\012// 5    IntraPredAvailFlagE/A - A (Left neighbor or Left bottom half)\012// 4    IntraPredAvailFlagB - B (Upper neighbor)\012// 3    IntraPredAvailFlagC - C (Upper left neighbor)\012// 2    IntraPredAvailFlagD - D (Upper right neighbor)\012// 1:0  ChromaIntraPredMode\012#define VME_GET_UNIOutput_MbIntraStruct(p, v)                                  \\\012  (v = VME_Output_S1(p, uchar, 0, 24))\012\012// 8-bit field with the following definition:\012// Bits [1:0]: SubMbShape[0]\012// Bits [3:2]: SubMbShape[1]\012// Bits [5:4]: SubMbShape[2]\012// Bits [7:6]: SubMbShape[3]\012#define VME_GET_UNIOutput_SubMbShape(p, v) (v = VME_Output_S1(p, uchar, 0, 25))\012\012// 8-bit field with the following de",
"finition:\012// Bits [1:0]: SubMbPredMode[0]\012// Bits [3:2]: SubMbPredMode[1]\012// Bits [5:4]: SubMbPredMode[2]\012// Bits [7:6]: SubMbPredMode[3]\012#define VME_GET_UNIOutput_SubMbPredMode(p, v)                                  \\\012  (v = VME_Output_S1(p, uchar, 0, 26))\012\012// v is a 4x16 short type matrix that stores the motion vectors as follows:\012// MVa[0].x, MVa[0].y, MVb[0].x, MVb[0].x\012// MVa[1].x, MVa[1].y, MVb[1].x, MVb[1].x\012// ...\012// MVa[15].x, MVa[15].y, MVb[15].x, MVb[15].x\012#define VME_GET_UNIOutput_Mvs(p, v)                                            \\\012  (v = p.format<short, 7, 32 / sizeof(short)>().select<4, 1, 16, 1>(1, 0))\012\012// v is a 1x16 short type matrix that stores the inter distortions as follows:\012// InterDistortion[0], InterDistortion[1], ..., InterDistortion[15]\012#define VME_GET_UNIOutput_InterDistortion(p, v)                                \\\012  (v = p.format<short, 7, 32 / sizeof(short)>().select<1, 1, 16, 1>(5, 0))\012\012// Format = U4\012#define VME_GET_UNIOutput_FwdBlk0RefID(p, v)                                ",
"   \\\012  (v = VME_Output_S1(p, uchar, 6, 0) & 0xF)\012#define VME_GET_UNIOutput_BwdBlk0RefID(p, v)                                   \\\012  (v = (VME_Output_S1(p, uchar, 6, 0) >> 4) & 0xF)\012#define VME_GET_UNIOutput_FwdBlk1RefID(p, v)                                   \\\012  (v = VME_Output_S1(p, uchar, 6, 1) & 0xF)\012#define VME_GET_UNIOutput_BwdBlk1RefID(p, v)                                   \\\012  (v = (VME_Output_S1(p, uchar, 6, 1) >> 4) & 0xF)\012#define VME_GET_UNIOutput_FwdBlk2RefID(p, v)                                   \\\012  (v = VME_Output_S1(p, uchar, 6, 2) & 0xF)\012#define VME_GET_UNIOutput_BwdBlk2RefID(p, v)                                   \\\012  (v = (VME_Output_S1(p, uchar, 6, 2) >> 4) & 0xF)\012#define VME_GET_UNIOutput_FwdBlk3RefID(p, v)                                   \\\012  (v = VME_Output_S1(p, uchar, 6, 3) & 0xF)\012#define VME_GET_UNIOutput_BwdBlk3RefID(p, v)                                   \\\012  (v = (VME_Output_S1(p, uchar, 6, 3) >> 4) & 0xF)\012\012#define VME_GET_UNIOutput_Blk0LumaNZC(p, v) (v = VME_Output_S1(p, uchar",
", 6, 4))\012#define VME_GET_UNIOutput_Blk1LumaNZC(p, v) (v = VME_Output_S1(p, uchar, 6, 5))\012#define VME_GET_UNIOutput_Blk2LumaNZC(p, v) (v = VME_Output_S1(p, uchar, 6, 6))\012#define VME_GET_UNIOutput_Blk3LumaNZC(p, v) (v = VME_Output_S1(p, uchar, 6, 7))\012\012// Format = U8\012#define VME_GET_UNIOutput_Blk0ChromaCbNZC(p, v)                                \\\012  (v = VME_Output_S1(p, uchar, 6, 16))\012#define VME_GET_UNIOutput_Blk0ChromaCrNZC(p, v)                                \\\012  (v = VME_Output_S1(p, uchar, 6, 17))\012\012#define VME_GET_UNIOutput_SumInterDistL0(p, v)                                 \\\012  (v = VME_Output_S1(p, uint, 6, 6) & 0x3FFFFFF)\012#define VME_GET_UNIOutput_SumInterDistL1(p, v)                                 \\\012  (v = VME_Output_S1(p, ushort, 6, 9) +                                        \\\012       ((VME_Output_S1(p, ushort, 0, 3) & 0x3FF) << 16))\012\012#define VME_GET_UNIOutput_MaxRef0InterDist(p, v)                               \\\012  (v = VME_Output_S1(p, ushort, 6, 14))\012#define VME_GET_UNIOutput_MaxRef1InterDist(p, v",
")                               \\\012  (v = VME_Output_S1(p, ushort, 6, 15))\012\012#define MODE_INTER_16X16 0x00\012#define MODE_INTER_16X8 0x01\012#define MODE_INTER_8X16 0x02\012#define MODE_INTER_8X8 0x03\012#define MODE_INTER_MINOR 0x03\012#define VME_GET_IMEOutput_InterMbMode(p, v)                                    \\\012  (v = VME_Output_S1(p, uchar, 0, 0) & 0x3)\012\012#define MODE_INTRA_16X16 0x00\012#define MODE_INTRA_8X8 0x10\012#define MODE_INTRA_4X4 0x20\012#define MODE_INTRA_PCM 0x30\012#define VME_GET_IMEOutput_IntraMbMode(p, v)                                    \\\012  (v = VME_Output_S1(p, uchar, 0, 0) & 0x30)\012\012#define MODE_FIELD_MB_POLARITY 0x80\012#define VME_GET_IMEOutput_FieldMbPolarityFlag(p, v)                            \\\012  (v = VME_Output_S1(p, uchar, 0, 0) & 0x80)\012\012#define VME_GET_IMEOutput_InterMbType(p, v)                                    \\\012  (v = VME_Output_S1(p, uchar, 0, 1) & 0x1F)\012\012#define VME_GET_IMEOutput_FieldMbFlag(p, v)                                    \\\012  (v = VME_Output_S1(p, uchar, 0, 1) & 0x40)\012\012#define VME_GET_IME",
"Output_IntraMbType(p, v)                                    \\\012  (v = VME_Output_S1(p, uchar, 0, 2) & 0x1F)\012\012#define VME_GET_IMEOutput_IntraMbType(p, v)                                    \\\012  (v = VME_Output_S1(p, uchar, 0, 2) & 0x1F)\012\012#define VME_GET_IMEOutput_MvQuantity(p, v)                                     \\\012  (v = VME_Output_S1(p, uchar, 0, 3) & 0x1F)\012\012// SKL+\012#define VME_GET_IMEOutput_StreamOutOnlyLocal(p, v)                             \\\012  (v = (VME_Output_S1(p, uchar, 0, 3) & 0x20) >> 5)\012\012#define VME_GET_IMEOutput_MinHasLocal(p, v)                                    \\\012  (v = (VME_Output_S1(p, uchar, 0, 3) & 0x40) >> 6)\012\012#define VME_GET_IMEOutput_StreamOutHasNoLocal(p, v)                            \\\012  (v = (VME_Output_S1(p, uchar, 0, 3) & 0x80) >> 7)\012\012// Format = U16\012#define VME_GET_IMEOutput_BestInterDistortion(p, v)                            \\\012  (v = VME_Output_S1(p, ushort, 0, 4))\012\012// Format = U16\012#define VME_GET_IMEOutput_SkipRawDistortion(p, v)                              \\\012  (v = VME_Output_",
"S1(p, ushort, 0, 5))\012\012// Format = U16\012#define VME_GET_IMEOutput_BestIntraDistortion(p, v)                            \\\012  (v = VME_Output_S1(p, ushort, 0, 6))\012\012// Format = U16\012#define VME_GET_IMEOutput_BestChromaIntraDistortion(p, v)                      \\\012  (v = VME_Output_S1(p, ushort, 0, 7))\012\012#define VME_GET_IMEOutput_LumaIntraPredMode0(p, v)                             \\\012  (v = VME_Output_S1(p, ushort, 0, 8))\012#define VME_GET_IMEOutput_LumaIntraPredMode1(p, v)                             \\\012  (v = VME_Output_S1(p, ushort, 0, 9))\012#define VME_GET_IMEOutput_LumaIntraPredMode2(p, v)                             \\\012  (v = VME_Output_S1(p, ushort, 0, 10))\012#define VME_GET_IMEOutput_LumaIntraPredMode3(p, v)                             \\\012  (v = VME_Output_S1(p, ushort, 0, 11))\012\012// 8-bit field with the following definition:\012// 7    Reserved : MBZ (for IntraPredAvailFlagF - F (pixel[-1,7] available for\012// MbAff)\012// 6    Reserved : MBZ (for IntraPredAvailFlagA/E - A (left neighbor top half\012// for MbAff)\012// 5    IntraPredA",
"vailFlagE/A - A (Left neighbor or Left bottom half)\012// 4    IntraPredAvailFlagB - B (Upper neighbor)\012// 3    IntraPredAvailFlagC - C (Upper left neighbor)\012// 2    IntraPredAvailFlagD - D (Upper right neighbor)\012// 1:0  ChromaIntraPredMode\012#define VME_GET_IMEOutput_MbIntraStruct(p, v)                                  \\\012  (v = VME_Output_S1(p, uchar, 0, 24))\012\012// 8-bit field with the following definition:\012// Bits [1:0]: SubMbShape[0]\012// Bits [3:2]: SubMbShape[1]\012// Bits [5:4]: SubMbShape[2]\012// Bits [7:6]: SubMbShape[3]\012#define VME_GET_IMEOutput_SubMbShape(p, v) (v = VME_Output_S1(p, uchar, 0, 25))\012\012// 8-bit field with the following definition:\012// Bits [1:0]: SubMbPredMode[0]\012// Bits [3:2]: SubMbPredMode[1]\012// Bits [5:4]: SubMbPredMode[2]\012// Bits [7:6]: SubMbPredMode[3]\012#define VME_GET_IMEOutput_SubMbPredMode(p, v)                                  \\\012  (v = VME_Output_S1(p, uchar, 0, 26))\012\012// v is a 4x16 short type matrix that stores the motion vectors as follows:\012// MVa[0].x, MVa[0].y, MVb[0].x, MVb[0].x\012// MVa[1]",
".x, MVa[1].y, MVb[1].x, MVb[1].x\012// ...\012// MVa[15].x, MVa[15].y, MVb[15].x, MVb[15].x\012#define VME_GET_IMEOutput_Mvs(p, v)                                            \\\012  (v = p.format<short, 7, 32 / sizeof(short)>().select<4, 1, 16, 1>(1, 0))\012\012// v is a 1x16 short type matrix that stores the inter distortions as follows:\012// InterDistortion[0], InterDistortion[1], ..., InterDistortion[15]\012#define VME_GET_IMEOutput_InterDistortion(p, v)                                \\\012  (v = p.format<short, 7, 32 / sizeof(short)>().select<1, 1, 16, 1>(5, 0))\012\012// Format = U4\012#define VME_GET_IMEOutput_FwdBlk0RefID(p, v)                                   \\\012  (v = VME_Output_S1(p, uchar, 6, 0) & 0xF)\012#define VME_GET_IMEOutput_BwdBlk0RefID(p, v)                                   \\\012  (v = (VME_Output_S1(p, uchar, 6, 0) >> 4) & 0xF)\012#define VME_GET_IMEOutput_FwdBlk1RefID(p, v)                                   \\\012  (v = VME_Output_S1(p, uchar, 6, 1) & 0xF)\012#define VME_GET_IMEOutput_BwdBlk1RefID(p, v)                                   \\",
"\012  (v = (VME_Output_S1(p, uchar, 6, 1) >> 4) & 0xF)\012#define VME_GET_IMEOutput_FwdBlk2RefID(p, v)                                   \\\012  (v = VME_Output_S1(p, uchar, 6, 2) & 0xF)\012#define VME_GET_IMEOutput_BwdBlk2RefID(p, v)                                   \\\012  (v = (VME_Output_S1(p, uchar, 6, 2) >> 4) & 0xF)\012#define VME_GET_IMEOutput_FwdBlk3RefID(p, v)                                   \\\012  (v = VME_Output_S1(p, uchar, 6, 3) & 0xF)\012#define VME_GET_IMEOutput_BwdBlk3RefID(p, v)                                   \\\012  (v = (VME_Output_S1(p, uchar, 6, 3) >> 4) & 0xF)\012\012#define VME_GET_IMEOutput_Blk0LumaNZC(p, v) (v = VME_Output_S1(p, uchar, 6, 4))\012#define VME_GET_IMEOutput_Blk1LumaNZC(p, v) (v = VME_Output_S1(p, uchar, 6, 5))\012#define VME_GET_IMEOutput_Blk2LumaNZC(p, v) (v = VME_Output_S1(p, uchar, 6, 6))\012#define VME_GET_IMEOutput_Blk3LumaNZC(p, v) (v = VME_Output_S1(p, uchar, 6, 7))\012\012// Format = U8\012#define VME_GET_IMEOutput_Blk0ChromaCbNZC(p, v)                                \\\012  (v = VME_Output_S1(p, uchar, 6, 16))\012#",
"define VME_GET_IMEOutput_Blk0ChromaCrNZC(p, v)                                \\\012  (v = VME_Output_S1(p, uchar, 6, 17))\012\012// Format = U16\012#define VME_GET_IMEOutput_Rec0_16x8_0Distortion(p, v)                          \\\012  (v = VME_Output_S1(p, ushort, 7, 0))\012#define VME_GET_IMEOutput_Rec0_16x8_1Distortion(p, v)                          \\\012  (v = VME_Output_S1(p, ushort, 7, 1))\012#define VME_GET_IMEOutput_Rec0_8x16_0Distortion(p, v)                          \\\012  (v = VME_Output_S1(p, ushort, 7, 2))\012#define VME_GET_IMEOutput_Rec0_8x16_1Distortion(p, v)                          \\\012  (v = VME_Output_S1(p, ushort, 7, 3))\012#define VME_GET_IMEOutput_Rec0_8x8_0Distortion(p, v)                           \\\012  (v = VME_Output_S1(p, ushort, 7, 4))\012#define VME_GET_IMEOutput_Rec0_8x8_1Distortion(p, v)                           \\\012  (v = VME_Output_S1(p, ushort, 7, 5))\012#define VME_GET_IMEOutput_Rec0_8x8_2Distortion(p, v)                           \\\012  (v = VME_Output_S1(p, ushort, 7, 6))\012#define VME_GET_IMEOutput_Rec0_8x8_3Distortion(p",
", v)                           \\\012  (v = VME_Output_S1(p, ushort, 7, 7))\012#define VME_GET_IMEOutput_Rec0_16x16_Distortion(p, v)                          \\\012  (v = VME_Output_S1(p, ushort, 7, 8))\012\012// Format = U4\012#define VME_GET_IMEOutput_Rec0_16x16_RefID(p, v)                               \\\012  (v = VME_Output_S1(p, uchar, 7, 18))\012\012// Format = U16\012#define VME_GET_IMEOutput_Rec0_16x16_X(p, v)                                   \\\012  (v = VME_Output_S1(p, ushort, 7, 10))\012#define VME_GET_IMEOutput_Rec0_16x16_Y(p, v)                                   \\\012  (v = VME_Output_S1(p, ushort, 7, 11))\012\012// Format = U4\012#define VME_GET_IMEOutput_Rec0_16x8_0RefID(p, v)                               \\\012  (v = VME_Output_S1(p, uchar, 7, 24) & 0xF)\012#define VME_GET_IMEOutput_Rec0_16x8_1RefID(p, v)                               \\\012  (v = (VME_Output_S1(p, uchar, 7, 24) & 0xF0) >> 4)\012#define VME_GET_IMEOutput_Rec0_8x16_0RefID(p, v)                               \\\012  (v = VME_Output_S1(p, uchar, 7, 25) & 0xF)\012#define VME_GET_IMEOutput_Rec0_8x16",
"_1RefID(p, v)                               \\\012  (v = (VME_Output_S1(p, uchar, 7, 25) & 0xF0) >> 4)\012#define VME_GET_IMEOutput_Rec0_8x8_0RefID(p, v)                                \\\012  (v = VME_Output_S1(p, uchar, 7, 26) & 0xF)\012#define VME_GET_IMEOutput_Rec0_8x8_1RefID(p, v)                                \\\012  (v = (VME_Output_S1(p, uchar, 7, 26) & 0xF0) >> 4)\012#define VME_GET_IMEOutput_Rec0_8x8_2RefID(p, v)                                \\\012  (v = VME_Output_S1(p, uchar, 7, 27) & 0xF)\012#define VME_GET_IMEOutput_Rec0_8x8_3RefID(p, v)                                \\\012  (v = (VME_Output_S1(p, uchar, 7, 27) & 0xF0) >> 4)\012\012// Format = U16\012#define VME_GET_IMEOutput_Rec0_16x8_0X(p, v)                                   \\\012  (v = VME_Output_S1(p, ushort, 8, 0))\012#define VME_GET_IMEOutput_Rec0_16x8_0Y(p, v)                                   \\\012  (v = VME_Output_S1(p, ushort, 8, 1))\012#define VME_GET_IMEOutput_Rec0_16x8_1X(p, v)                                   \\\012  (v = VME_Output_S1(p, ushort, 8, 2))\012#define VME_GET_IMEOutput_Re",
"c0_16x8_1Y(p, v)                                   \\\012  (v = VME_Output_S1(p, ushort, 8, 3))\012#define VME_GET_IMEOutput_Rec0_8x16_0X(p, v)                                   \\\012  (v = VME_Output_S1(p, ushort, 8, 4))\012#define VME_GET_IMEOutput_Rec0_8x16_0Y(p, v)                                   \\\012  (v = VME_Output_S1(p, ushort, 8, 5))\012#define VME_GET_IMEOutput_Rec0_8x16_1X(p, v)                                   \\\012  (v = VME_Output_S1(p, ushort, 8, 6))\012#define VME_GET_IMEOutput_Rec0_8x16_1Y(p, v)                                   \\\012  (v = VME_Output_S1(p, ushort, 8, 7))\012#define VME_GET_IMEOutput_Rec0_8x8_0X(p, v) (v = VME_Output_S1(p, ushort, 8, 8))\012#define VME_GET_IMEOutput_Rec0_8x8_0Y(p, v) (v = VME_Output_S1(p, ushort, 8, 9))\012#define VME_GET_IMEOutput_Rec0_8x8_1X(p, v)                                    \\\012  (v = VME_Output_S1(p, ushort, 8, 10))\012#define VME_GET_IMEOutput_Rec0_8x8_1Y(p, v)                                    \\\012  (v = VME_Output_S1(p, ushort, 8, 11))\012#define VME_GET_IMEOutput_Rec0_8x8_2X(p, v)     ",
"                               \\\012  (v = VME_Output_S1(p, ushort, 8, 12))\012#define VME_GET_IMEOutput_Rec0_8x8_2Y(p, v)                                    \\\012  (v = VME_Output_S1(p, ushort, 8, 13))\012#define VME_GET_IMEOutput_Rec0_8x8_3X(p, v)                                    \\\012  (v = VME_Output_S1(p, ushort, 8, 14))\012#define VME_GET_IMEOutput_Rec0_8x8_3Y(p, v)                                    \\\012  (v = VME_Output_S1(p, ushort, 8, 15))\012\012// Format = U16\012#define VME_GET_IMEOutput_Rec1_16x8_0Distortion(p, v)                          \\\012  (v = VME_Output_S1(p, ushort, 9, 0))\012#define VME_GET_IMEOutput_Rec1_16x8_1Distortion(p, v)                          \\\012  (v = VME_Output_S1(p, ushort, 9, 1))\012#define VME_GET_IMEOutput_Rec1_8x16_0Distortion(p, v)                          \\\012  (v = VME_Output_S1(p, ushort, 9, 2))\012#define VME_GET_IMEOutput_Rec1_8x16_1Distortion(p, v)                          \\\012  (v = VME_Output_S1(p, ushort, 9, 3))\012#define VME_GET_IMEOutput_Rec1_8x8_0Distortion(p, v)                           \\\012  (v = VME",
"_Output_S1(p, ushort, 9, 4))\012#define VME_GET_IMEOutput_Rec1_8x8_1Distortion(p, v)                           \\\012  (v = VME_Output_S1(p, ushort, 9, 5))\012#define VME_GET_IMEOutput_Rec1_8x8_2Distortion(p, v)                           \\\012  (v = VME_Output_S1(p, ushort, 9, 6))\012#define VME_GET_IMEOutput_Rec1_8x8_3Distortion(p, v)                           \\\012  (v = VME_Output_S1(p, ushort, 9, 7))\012#define VME_GET_IMEOutput_Rec1_16x16_Distortion(p, v)                          \\\012  (v = VME_Output_S1(p, ushort, 9, 8))\012\012// Format = U4\012#define VME_GET_IMEOutput_Rec1_16x16_RefID(p, v)                               \\\012  (v = VME_Output_S1(p, uchar, 9, 18))\012\012// Format = U16\012#define VME_GET_IMEOutput_Rec1_16x16_X(p, v)                                   \\\012  (v = VME_Output_S1(p, ushort, 9, 10))\012#define VME_GET_IMEOutput_Rec1_16x16_Y(p, v)                                   \\\012  (v = VME_Output_S1(p, ushort, 9, 11))\012\012// Format = U4\012#define VME_GET_IMEOutput_Rec1_16x8_0RefID(p, v)                               \\\012  (v = VME_Output_S1(p,",
" uchar, 9, 24) & 0xF)\012#define VME_GET_IMEOutput_Rec1_16x8_1RefID(p, v)                               \\\012  (v = (VME_Output_S1(p, uchar, 9, 24) & 0xF0) >> 4)\012#define VME_GET_IMEOutput_Rec1_8x16_0RefID(p, v)                               \\\012  (v = VME_Output_S1(p, uchar, 9, 25) & 0xF)\012#define VME_GET_IMEOutput_Rec1_8x16_1RefID(p, v)                               \\\012  (v = (VME_Output_S1(p, uchar, 9, 25) & 0xF0) >> 4)\012#define VME_GET_IMEOutput_Rec1_8x8_0RefID(p, v)                                \\\012  (v = VME_Output_S1(p, uchar, 9, 26) & 0xF)\012#define VME_GET_IMEOutput_Rec1_8x8_1RefID(p, v)                                \\\012  (v = (VME_Output_S1(p, uchar, 9, 26) & 0xF0) >> 4)\012#define VME_GET_IMEOutput_Rec1_8x8_2RefID(p, v)                                \\\012  (v = VME_Output_S1(p, uchar, 9, 27) & 0xF)\012#define VME_GET_IMEOutput_Rec1_8x8_3RefID(p, v)                                \\\012  (v = (VME_Output_S1(p, uchar, 9, 27) & 0xF0) >> 4)\012\012// Format = U16\012#define VME_GET_IMEOutput_Rec1_16x8_0X(p, v)                           ",
"        \\\012  (v = VME_Output_S1(p, ushort, 10, 0))\012#define VME_GET_IMEOutput_Rec1_16x8_0Y(p, v)                                   \\\012  (v = VME_Output_S1(p, ushort, 10, 1))\012#define VME_GET_IMEOutput_Rec1_16x8_1X(p, v)                                   \\\012  (v = VME_Output_S1(p, ushort, 10, 2))\012#define VME_GET_IMEOutput_Rec1_16x8_1Y(p, v)                                   \\\012  (v = VME_Output_S1(p, ushort, 10, 3))\012#define VME_GET_IMEOutput_Rec1_8x16_0X(p, v)                                   \\\012  (v = VME_Output_S1(p, ushort, 10, 4))\012#define VME_GET_IMEOutput_Rec1_8x16_0Y(p, v)                                   \\\012  (v = VME_Output_S1(p, ushort, 10, 5))\012#define VME_GET_IMEOutput_Rec1_8x16_1X(p, v)                                   \\\012  (v = VME_Output_S1(p, ushort, 10, 6))\012#define VME_GET_IMEOutput_Rec1_8x16_1Y(p, v)                                   \\\012  (v = VME_Output_S1(p, ushort, 10, 7))\012#define VME_GET_IMEOutput_Rec1_8x8_0X(p, v)                                    \\\012  (v = VME_Output_S1(p, ushort, 10, 8))\012#defin",
"e VME_GET_IMEOutput_Rec1_8x8_0Y(p, v)                                    \\\012  (v = VME_Output_S1(p, ushort, 10, 9))\012#define VME_GET_IMEOutput_Rec1_8x8_1X(p, v)                                    \\\012  (v = VME_Output_S1(p, ushort, 10, 10))\012#define VME_GET_IMEOutput_Rec1_8x8_1Y(p, v)                                    \\\012  (v = VME_Output_S1(p, ushort, 10, 11))\012#define VME_GET_IMEOutput_Rec1_8x8_2X(p, v)                                    \\\012  (v = VME_Output_S1(p, ushort, 10, 12))\012#define VME_GET_IMEOutput_Rec1_8x8_2Y(p, v)                                    \\\012  (v = VME_Output_S1(p, ushort, 10, 13))\012#define VME_GET_IMEOutput_Rec1_8x8_3X(p, v)                                    \\\012  (v = VME_Output_S1(p, ushort, 10, 14))\012#define VME_GET_IMEOutput_Rec1_8x8_3Y(p, v)                                    \\\012  (v = VME_Output_S1(p, ushort, 10, 15))\012\012#define VME_GET_IDMOutput_DistortionMeshBlock0_SearchPoint0(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 0, 0))\012#define VME_GET_IDMOutput_DistortionMeshBlock0_SearchPoi",
"nt1(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 0, 1))\012#define VME_GET_IDMOutput_DistortionMeshBlock0_SearchPoshort(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 0, 2))\012#define VME_GET_IDMOutput_DistortionMeshBlock0_SearchPoint3(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 0, 3))\012#define VME_GET_IDMOutput_DistortionMeshBlock0_SearchPoint4(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 0, 4))\012#define VME_GET_IDMOutput_DistortionMeshBlock0_SearchPoint5(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 0, 5))\012#define VME_GET_IDMOutput_DistortionMeshBlock0_SearchPoint6(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 0, 6))\012#define VME_GET_IDMOutput_DistortionMeshBlock0_SearchPoint7(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 0, 7))\012#define VME_GET_IDMOutput_DistortionMeshBlock0_SearchPoint8(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 0, 8))\012#define VME_GET_IDMOutput_DistortionMeshBlock0_SearchPoint9(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 0, 9))\012",
"#define VME_GET_IDMOutput_DistortionMeshBlock0_SearchPoint10(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 0, 10))\012#define VME_GET_IDMOutput_DistortionMeshBlock0_SearchPoint11(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 0, 11))\012#define VME_GET_IDMOutput_DistortionMeshBlock0_SearchPoint12(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 0, 12))\012#define VME_GET_IDMOutput_DistortionMeshBlock0_SearchPoint13(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 0, 13))\012#define VME_GET_IDMOutput_DistortionMeshBlock0_SearchPoint14(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 0, 14))\012#define VME_GET_IDMOutput_DistortionMeshBlock0_SearchPoint15(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 0, 15))\012\012#define VME_GET_IDMOutput_DistortionMeshBlock1_SearchPoint0(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 1, 0))\012#define VME_GET_IDMOutput_DistortionMeshBlock1_SearchPoint1(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 1, 1))\012#define VME_GET_IDMOutput_DistortionMeshBlock1_SearchPosh",
"ort(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 1, 2))\012#define VME_GET_IDMOutput_DistortionMeshBlock1_SearchPoint3(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 1, 3))\012#define VME_GET_IDMOutput_DistortionMeshBlock1_SearchPoint4(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 1, 4))\012#define VME_GET_IDMOutput_DistortionMeshBlock1_SearchPoint5(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 1, 5))\012#define VME_GET_IDMOutput_DistortionMeshBlock1_SearchPoint6(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 1, 6))\012#define VME_GET_IDMOutput_DistortionMeshBlock1_SearchPoint7(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 1, 7))\012#define VME_GET_IDMOutput_DistortionMeshBlock1_SearchPoint8(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 1, 8))\012#define VME_GET_IDMOutput_DistortionMeshBlock1_SearchPoint9(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 1, 9))\012#define VME_GET_IDMOutput_DistortionMeshBlock1_SearchPoint10(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 1, 10))\012",
"#define VME_GET_IDMOutput_DistortionMeshBlock1_SearchPoint11(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 1, 11))\012#define VME_GET_IDMOutput_DistortionMeshBlock1_SearchPoint12(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 1, 12))\012#define VME_GET_IDMOutput_DistortionMeshBlock1_SearchPoint13(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 1, 13))\012#define VME_GET_IDMOutput_DistortionMeshBlock1_SearchPoint14(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 1, 14))\012#define VME_GET_IDMOutput_DistortionMeshBlock1_SearchPoint15(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 1, 15))\012\012#define VME_GET_IDMOutput_DistortionMeshBlock2_SearchPoint0(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 2, 0))\012#define VME_GET_IDMOutput_DistortionMeshBlock2_SearchPoint1(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 2, 1))\012#define VME_GET_IDMOutput_DistortionMeshBlock2_SearchPoshort(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 2, 2))\012#define VME_GET_IDMOutput_DistortionMeshBlock2_SearchPoint",
"3(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 2, 3))\012#define VME_GET_IDMOutput_DistortionMeshBlock2_SearchPoint4(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 2, 4))\012#define VME_GET_IDMOutput_DistortionMeshBlock2_SearchPoint5(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 2, 5))\012#define VME_GET_IDMOutput_DistortionMeshBlock2_SearchPoint6(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 2, 6))\012#define VME_GET_IDMOutput_DistortionMeshBlock2_SearchPoint7(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 2, 7))\012#define VME_GET_IDMOutput_DistortionMeshBlock2_SearchPoint8(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 2, 8))\012#define VME_GET_IDMOutput_DistortionMeshBlock2_SearchPoint9(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 2, 9))\012#define VME_GET_IDMOutput_DistortionMeshBlock2_SearchPoint10(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 2, 10))\012#define VME_GET_IDMOutput_DistortionMeshBlock2_SearchPoint11(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 2, 11))\012",
"#define VME_GET_IDMOutput_DistortionMeshBlock2_SearchPoint12(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 2, 12))\012#define VME_GET_IDMOutput_DistortionMeshBlock2_SearchPoint13(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 2, 13))\012#define VME_GET_IDMOutput_DistortionMeshBlock2_SearchPoint14(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 2, 14))\012#define VME_GET_IDMOutput_DistortionMeshBlock2_SearchPoint15(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 2, 15))\012\012#define VME_GET_IDMOutput_DistortionMeshBlock3_SearchPoint0(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 3, 0))\012#define VME_GET_IDMOutput_DistortionMeshBlock3_SearchPoint1(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 3, 1))\012#define VME_GET_IDMOutput_DistortionMeshBlock3_SearchPoshort(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 3, 2))\012#define VME_GET_IDMOutput_DistortionMeshBlock3_SearchPoint3(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 3, 3))\012#define VME_GET_IDMOutput_DistortionMeshBlock3_SearchPoint4",
"(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 3, 4))\012#define VME_GET_IDMOutput_DistortionMeshBlock3_SearchPoint5(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 3, 5))\012#define VME_GET_IDMOutput_DistortionMeshBlock3_SearchPoint6(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 3, 6))\012#define VME_GET_IDMOutput_DistortionMeshBlock3_SearchPoint7(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 3, 7))\012#define VME_GET_IDMOutput_DistortionMeshBlock3_SearchPoint8(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 3, 8))\012#define VME_GET_IDMOutput_DistortionMeshBlock3_SearchPoint9(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 3, 9))\012#define VME_GET_IDMOutput_DistortionMeshBlock3_SearchPoint10(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 3, 10))\012#define VME_GET_IDMOutput_DistortionMeshBlock3_SearchPoint11(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 3, 11))\012#define VME_GET_IDMOutput_DistortionMeshBlock3_SearchPoint12(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 3, 12))\012",
"#define VME_GET_IDMOutput_DistortionMeshBlock3_SearchPoint13(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 3, 13))\012#define VME_GET_IDMOutput_DistortionMeshBlock3_SearchPoint14(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 3, 14))\012#define VME_GET_IDMOutput_DistortionMeshBlock3_SearchPoint15(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 3, 15))\012\012#define VME_GET_IDMOutput_DistortionMeshBlock4_SearchPoint0(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 4, 0))\012#define VME_GET_IDMOutput_DistortionMeshBlock4_SearchPoint1(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 4, 1))\012#define VME_GET_IDMOutput_DistortionMeshBlock4_SearchPoshort(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 4, 2))\012#define VME_GET_IDMOutput_DistortionMeshBlock4_SearchPoint3(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 4, 3))\012#define VME_GET_IDMOutput_DistortionMeshBlock4_SearchPoint4(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 4, 4))\012#define VME_GET_IDMOutput_DistortionMeshBlock4_SearchPoint5(",
"p, v)              \\\012  (v = VME_Output_S1(p, ushort, 4, 5))\012#define VME_GET_IDMOutput_DistortionMeshBlock4_SearchPoint6(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 4, 6))\012#define VME_GET_IDMOutput_DistortionMeshBlock4_SearchPoint7(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 4, 7))\012#define VME_GET_IDMOutput_DistortionMeshBlock4_SearchPoint8(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 4, 8))\012#define VME_GET_IDMOutput_DistortionMeshBlock4_SearchPoint9(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 4, 9))\012#define VME_GET_IDMOutput_DistortionMeshBlock4_SearchPoint10(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 4, 10))\012#define VME_GET_IDMOutput_DistortionMeshBlock4_SearchPoint11(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 4, 11))\012#define VME_GET_IDMOutput_DistortionMeshBlock4_SearchPoint12(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 4, 12))\012#define VME_GET_IDMOutput_DistortionMeshBlock4_SearchPoint13(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 4, 13))\012",
"#define VME_GET_IDMOutput_DistortionMeshBlock4_SearchPoint14(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 4, 14))\012#define VME_GET_IDMOutput_DistortionMeshBlock4_SearchPoint15(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 4, 15))\012\012#define VME_GET_IDMOutput_DistortionMeshBlock5_SearchPoint0(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 5, 0))\012#define VME_GET_IDMOutput_DistortionMeshBlock5_SearchPoint1(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 5, 1))\012#define VME_GET_IDMOutput_DistortionMeshBlock5_SearchPoshort(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 5, 2))\012#define VME_GET_IDMOutput_DistortionMeshBlock5_SearchPoint3(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 5, 3))\012#define VME_GET_IDMOutput_DistortionMeshBlock5_SearchPoint4(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 5, 4))\012#define VME_GET_IDMOutput_DistortionMeshBlock5_SearchPoint5(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 5, 5))\012#define VME_GET_IDMOutput_DistortionMeshBlock5_SearchPoint6(p",
", v)              \\\012  (v = VME_Output_S1(p, ushort, 5, 6))\012#define VME_GET_IDMOutput_DistortionMeshBlock5_SearchPoint7(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 5, 7))\012#define VME_GET_IDMOutput_DistortionMeshBlock5_SearchPoint8(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 5, 8))\012#define VME_GET_IDMOutput_DistortionMeshBlock5_SearchPoint9(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 5, 9))\012#define VME_GET_IDMOutput_DistortionMeshBlock5_SearchPoint10(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 5, 10))\012#define VME_GET_IDMOutput_DistortionMeshBlock5_SearchPoint11(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 5, 11))\012#define VME_GET_IDMOutput_DistortionMeshBlock5_SearchPoint12(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 5, 12))\012#define VME_GET_IDMOutput_DistortionMeshBlock5_SearchPoint13(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 5, 13))\012#define VME_GET_IDMOutput_DistortionMeshBlock5_SearchPoint14(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 5, 14))\012",
"#define VME_GET_IDMOutput_DistortionMeshBlock5_SearchPoint15(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 5, 15))\012\012#define VME_GET_IDMOutput_DistortionMeshBlock6_SearchPoint0(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 6, 0))\012#define VME_GET_IDMOutput_DistortionMeshBlock6_SearchPoint1(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 6, 1))\012#define VME_GET_IDMOutput_DistortionMeshBlock6_SearchPoshort(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 6, 2))\012#define VME_GET_IDMOutput_DistortionMeshBlock6_SearchPoint3(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 6, 3))\012#define VME_GET_IDMOutput_DistortionMeshBlock6_SearchPoint4(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 6, 4))\012#define VME_GET_IDMOutput_DistortionMeshBlock6_SearchPoint5(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 6, 5))\012#define VME_GET_IDMOutput_DistortionMeshBlock6_SearchPoint6(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 6, 6))\012#define VME_GET_IDMOutput_DistortionMeshBlock6_SearchPoint7(p,",
" v)              \\\012  (v = VME_Output_S1(p, ushort, 6, 7))\012#define VME_GET_IDMOutput_DistortionMeshBlock6_SearchPoint8(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 6, 8))\012#define VME_GET_IDMOutput_DistortionMeshBlock6_SearchPoint9(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 6, 9))\012#define VME_GET_IDMOutput_DistortionMeshBlock6_SearchPoint10(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 6, 10))\012#define VME_GET_IDMOutput_DistortionMeshBlock6_SearchPoint11(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 6, 11))\012#define VME_GET_IDMOutput_DistortionMeshBlock6_SearchPoint12(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 6, 12))\012#define VME_GET_IDMOutput_DistortionMeshBlock6_SearchPoint13(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 6, 13))\012#define VME_GET_IDMOutput_DistortionMeshBlock6_SearchPoint14(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 6, 14))\012#define VME_GET_IDMOutput_DistortionMeshBlock6_SearchPoint15(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 6, 15))\012",
"\012#define VME_GET_IDMOutput_DistortionMeshBlock7_SearchPoint0(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 7, 0))\012#define VME_GET_IDMOutput_DistortionMeshBlock7_SearchPoint1(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 7, 1))\012#define VME_GET_IDMOutput_DistortionMeshBlock7_SearchPoshort(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 7, 2))\012#define VME_GET_IDMOutput_DistortionMeshBlock7_SearchPoint3(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 7, 3))\012#define VME_GET_IDMOutput_DistortionMeshBlock7_SearchPoint4(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 7, 4))\012#define VME_GET_IDMOutput_DistortionMeshBlock7_SearchPoint5(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 7, 5))\012#define VME_GET_IDMOutput_DistortionMeshBlock7_SearchPoint6(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 7, 6))\012#define VME_GET_IDMOutput_DistortionMeshBlock7_SearchPoint7(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 7, 7))\012#define VME_GET_IDMOutput_DistortionMeshBlock7_SearchPoint8(p, ",
"v)              \\\012  (v = VME_Output_S1(p, ushort, 7, 8))\012#define VME_GET_IDMOutput_DistortionMeshBlock7_SearchPoint9(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 7, 9))\012#define VME_GET_IDMOutput_DistortionMeshBlock7_SearchPoint10(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 7, 10))\012#define VME_GET_IDMOutput_DistortionMeshBlock7_SearchPoint11(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 7, 11))\012#define VME_GET_IDMOutput_DistortionMeshBlock7_SearchPoint12(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 7, 12))\012#define VME_GET_IDMOutput_DistortionMeshBlock7_SearchPoint13(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 7, 13))\012#define VME_GET_IDMOutput_DistortionMeshBlock7_SearchPoint14(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 7, 14))\012#define VME_GET_IDMOutput_DistortionMeshBlock7_SearchPoint15(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 7, 15))\012\012#define VME_GET_IDMOutput_DistortionMeshBlock8_SearchPoint0(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 8, 0))\012",
"#define VME_GET_IDMOutput_DistortionMeshBlock8_SearchPoint1(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 8, 1))\012#define VME_GET_IDMOutput_DistortionMeshBlock8_SearchPoshort(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 8, 2))\012#define VME_GET_IDMOutput_DistortionMeshBlock8_SearchPoint3(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 8, 3))\012#define VME_GET_IDMOutput_DistortionMeshBlock8_SearchPoint4(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 8, 4))\012#define VME_GET_IDMOutput_DistortionMeshBlock8_SearchPoint5(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 8, 5))\012#define VME_GET_IDMOutput_DistortionMeshBlock8_SearchPoint6(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 8, 6))\012#define VME_GET_IDMOutput_DistortionMeshBlock8_SearchPoint7(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 8, 7))\012#define VME_GET_IDMOutput_DistortionMeshBlock8_SearchPoint8(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 8, 8))\012#define VME_GET_IDMOutput_DistortionMeshBlock8_SearchPoint9(p, v",
")              \\\012  (v = VME_Output_S1(p, ushort, 8, 9))\012#define VME_GET_IDMOutput_DistortionMeshBlock8_SearchPoint10(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 8, 10))\012#define VME_GET_IDMOutput_DistortionMeshBlock8_SearchPoint11(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 8, 11))\012#define VME_GET_IDMOutput_DistortionMeshBlock8_SearchPoint12(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 8, 12))\012#define VME_GET_IDMOutput_DistortionMeshBlock8_SearchPoint13(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 8, 13))\012#define VME_GET_IDMOutput_DistortionMeshBlock8_SearchPoint14(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 8, 14))\012#define VME_GET_IDMOutput_DistortionMeshBlock8_SearchPoint15(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 8, 15))\012\012#define VME_GET_IDMOutput_DistortionMeshBlock9_SearchPoint0(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 9, 0))\012#define VME_GET_IDMOutput_DistortionMeshBlock9_SearchPoint1(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 9, 1))\012#",
"define VME_GET_IDMOutput_DistortionMeshBlock9_SearchPoshort(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 9, 2))\012#define VME_GET_IDMOutput_DistortionMeshBlock9_SearchPoint3(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 9, 3))\012#define VME_GET_IDMOutput_DistortionMeshBlock9_SearchPoint4(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 9, 4))\012#define VME_GET_IDMOutput_DistortionMeshBlock9_SearchPoint5(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 9, 5))\012#define VME_GET_IDMOutput_DistortionMeshBlock9_SearchPoint6(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 9, 6))\012#define VME_GET_IDMOutput_DistortionMeshBlock9_SearchPoint7(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 9, 7))\012#define VME_GET_IDMOutput_DistortionMeshBlock9_SearchPoint8(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 9, 8))\012#define VME_GET_IDMOutput_DistortionMeshBlock9_SearchPoint9(p, v)              \\\012  (v = VME_Output_S1(p, ushort, 9, 9))\012#define VME_GET_IDMOutput_DistortionMeshBlock9_SearchPoint10(p, v",
")             \\\012  (v = VME_Output_S1(p, ushort, 9, 10))\012#define VME_GET_IDMOutput_DistortionMeshBlock9_SearchPoint11(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 9, 11))\012#define VME_GET_IDMOutput_DistortionMeshBlock9_SearchPoint12(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 9, 12))\012#define VME_GET_IDMOutput_DistortionMeshBlock9_SearchPoint13(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 9, 13))\012#define VME_GET_IDMOutput_DistortionMeshBlock9_SearchPoint14(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 9, 14))\012#define VME_GET_IDMOutput_DistortionMeshBlock9_SearchPoint15(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 9, 15))\012\012#define VME_GET_IDMOutput_DistortionMeshBlock10_SearchPoint0(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 10, 0))\012#define VME_GET_IDMOutput_DistortionMeshBlock10_SearchPoint1(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 10, 1))\012#define VME_GET_IDMOutput_DistortionMeshBlock10_SearchPoshort(p, v)            \\\012  (v = VME_Output_S1(p, ushort, 10, 2))",
"\012#define VME_GET_IDMOutput_DistortionMeshBlock10_SearchPoint3(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 10, 3))\012#define VME_GET_IDMOutput_DistortionMeshBlock10_SearchPoint4(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 10, 4))\012#define VME_GET_IDMOutput_DistortionMeshBlock10_SearchPoint5(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 10, 5))\012#define VME_GET_IDMOutput_DistortionMeshBlock10_SearchPoint6(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 10, 6))\012#define VME_GET_IDMOutput_DistortionMeshBlock10_SearchPoint7(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 10, 7))\012#define VME_GET_IDMOutput_DistortionMeshBlock10_SearchPoint8(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 10, 8))\012#define VME_GET_IDMOutput_DistortionMeshBlock10_SearchPoint9(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 10, 9))\012#define VME_GET_IDMOutput_DistortionMeshBlock10_SearchPoint10(p, v)            \\\012  (v = VME_Output_S1(p, ushort, 10, 10))\012#define VME_GET_IDMOutput_DistortionMeshBlock10_Search",
"Point11(p, v)            \\\012  (v = VME_Output_S1(p, ushort, 10, 11))\012#define VME_GET_IDMOutput_DistortionMeshBlock10_SearchPoint12(p, v)            \\\012  (v = VME_Output_S1(p, ushort, 10, 12))\012#define VME_GET_IDMOutput_DistortionMeshBlock10_SearchPoint13(p, v)            \\\012  (v = VME_Output_S1(p, ushort, 10, 13))\012#define VME_GET_IDMOutput_DistortionMeshBlock10_SearchPoint14(p, v)            \\\012  (v = VME_Output_S1(p, ushort, 10, 14))\012#define VME_GET_IDMOutput_DistortionMeshBlock10_SearchPoint15(p, v)            \\\012  (v = VME_Output_S1(p, ushort, 10, 15))\012\012#define VME_GET_IDMOutput_DistortionMeshBlock11_SearchPoint0(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 11, 0))\012#define VME_GET_IDMOutput_DistortionMeshBlock11_SearchPoint1(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 11, 1))\012#define VME_GET_IDMOutput_DistortionMeshBlock11_SearchPoshort(p, v)            \\\012  (v = VME_Output_S1(p, ushort, 11, 2))\012#define VME_GET_IDMOutput_DistortionMeshBlock11_SearchPoint3(p, v)             \\\012  (v = VME_Output_S1(p,",
" ushort, 11, 3))\012#define VME_GET_IDMOutput_DistortionMeshBlock11_SearchPoint4(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 11, 4))\012#define VME_GET_IDMOutput_DistortionMeshBlock11_SearchPoint5(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 11, 5))\012#define VME_GET_IDMOutput_DistortionMeshBlock11_SearchPoint6(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 11, 6))\012#define VME_GET_IDMOutput_DistortionMeshBlock11_SearchPoint7(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 11, 7))\012#define VME_GET_IDMOutput_DistortionMeshBlock11_SearchPoint8(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 11, 8))\012#define VME_GET_IDMOutput_DistortionMeshBlock11_SearchPoint9(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 11, 9))\012#define VME_GET_IDMOutput_DistortionMeshBlock11_SearchPoint10(p, v)            \\\012  (v = VME_Output_S1(p, ushort, 11, 10))\012#define VME_GET_IDMOutput_DistortionMeshBlock11_SearchPoint11(p, v)            \\\012  (v = VME_Output_S1(p, ushort, 11, 11))\012#define VME_GET_IDMOutput_DistortionM",
"eshBlock11_SearchPoint12(p, v)            \\\012  (v = VME_Output_S1(p, ushort, 11, 12))\012#define VME_GET_IDMOutput_DistortionMeshBlock11_SearchPoint13(p, v)            \\\012  (v = VME_Output_S1(p, ushort, 11, 13))\012#define VME_GET_IDMOutput_DistortionMeshBlock11_SearchPoint14(p, v)            \\\012  (v = VME_Output_S1(p, ushort, 11, 14))\012#define VME_GET_IDMOutput_DistortionMeshBlock11_SearchPoint15(p, v)            \\\012  (v = VME_Output_S1(p, ushort, 11, 15))\012\012#define VME_GET_IDMOutput_DistortionMeshBlock12_SearchPoint0(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 12, 0))\012#define VME_GET_IDMOutput_DistortionMeshBlock12_SearchPoint1(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 12, 1))\012#define VME_GET_IDMOutput_DistortionMeshBlock12_SearchPoshort(p, v)            \\\012  (v = VME_Output_S1(p, ushort, 12, 2))\012#define VME_GET_IDMOutput_DistortionMeshBlock12_SearchPoint3(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 12, 3))\012#define VME_GET_IDMOutput_DistortionMeshBlock12_SearchPoint4(p, v)             \\\012  (v = ",
"VME_Output_S1(p, ushort, 12, 4))\012#define VME_GET_IDMOutput_DistortionMeshBlock12_SearchPoint5(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 12, 5))\012#define VME_GET_IDMOutput_DistortionMeshBlock12_SearchPoint6(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 12, 6))\012#define VME_GET_IDMOutput_DistortionMeshBlock12_SearchPoint7(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 12, 7))\012#define VME_GET_IDMOutput_DistortionMeshBlock12_SearchPoint8(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 12, 8))\012#define VME_GET_IDMOutput_DistortionMeshBlock12_SearchPoint9(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 12, 9))\012#define VME_GET_IDMOutput_DistortionMeshBlock12_SearchPoint10(p, v)            \\\012  (v = VME_Output_S1(p, ushort, 12, 10))\012#define VME_GET_IDMOutput_DistortionMeshBlock12_SearchPoint11(p, v)            \\\012  (v = VME_Output_S1(p, ushort, 12, 11))\012#define VME_GET_IDMOutput_DistortionMeshBlock12_SearchPoint12(p, v)            \\\012  (v = VME_Output_S1(p, ushort, 12, 12))\012#define VME_GET_IDMO",
"utput_DistortionMeshBlock12_SearchPoint13(p, v)            \\\012  (v = VME_Output_S1(p, ushort, 12, 13))\012#define VME_GET_IDMOutput_DistortionMeshBlock12_SearchPoint14(p, v)            \\\012  (v = VME_Output_S1(p, ushort, 12, 14))\012#define VME_GET_IDMOutput_DistortionMeshBlock12_SearchPoint15(p, v)            \\\012  (v = VME_Output_S1(p, ushort, 12, 15))\012\012#define VME_GET_IDMOutput_DistortionMeshBlock13_SearchPoint0(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 13, 0))\012#define VME_GET_IDMOutput_DistortionMeshBlock13_SearchPoint1(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 13, 1))\012#define VME_GET_IDMOutput_DistortionMeshBlock13_SearchPoshort(p, v)            \\\012  (v = VME_Output_S1(p, ushort, 13, 2))\012#define VME_GET_IDMOutput_DistortionMeshBlock13_SearchPoint3(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 13, 3))\012#define VME_GET_IDMOutput_DistortionMeshBlock13_SearchPoint4(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 13, 4))\012#define VME_GET_IDMOutput_DistortionMeshBlock13_SearchPoint5(p, v)      ",
"       \\\012  (v = VME_Output_S1(p, ushort, 13, 5))\012#define VME_GET_IDMOutput_DistortionMeshBlock13_SearchPoint6(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 13, 6))\012#define VME_GET_IDMOutput_DistortionMeshBlock13_SearchPoint7(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 13, 7))\012#define VME_GET_IDMOutput_DistortionMeshBlock13_SearchPoint8(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 13, 8))\012#define VME_GET_IDMOutput_DistortionMeshBlock13_SearchPoint9(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 13, 9))\012#define VME_GET_IDMOutput_DistortionMeshBlock13_SearchPoint10(p, v)            \\\012  (v = VME_Output_S1(p, ushort, 13, 10))\012#define VME_GET_IDMOutput_DistortionMeshBlock13_SearchPoint11(p, v)            \\\012  (v = VME_Output_S1(p, ushort, 13, 11))\012#define VME_GET_IDMOutput_DistortionMeshBlock13_SearchPoint12(p, v)            \\\012  (v = VME_Output_S1(p, ushort, 13, 12))\012#define VME_GET_IDMOutput_DistortionMeshBlock13_SearchPoint13(p, v)            \\\012  (v = VME_Output_S1(p, ushort, 13, 13))\012#de",
"fine VME_GET_IDMOutput_DistortionMeshBlock13_SearchPoint14(p, v)            \\\012  (v = VME_Output_S1(p, ushort, 13, 14))\012#define VME_GET_IDMOutput_DistortionMeshBlock13_SearchPoint15(p, v)            \\\012  (v = VME_Output_S1(p, ushort, 13, 15))\012\012#define VME_GET_IDMOutput_DistortionMeshBlock14_SearchPoint0(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 14, 0))\012#define VME_GET_IDMOutput_DistortionMeshBlock14_SearchPoint1(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 14, 1))\012#define VME_GET_IDMOutput_DistortionMeshBlock14_SearchPoshort(p, v)            \\\012  (v = VME_Output_S1(p, ushort, 14, 2))\012#define VME_GET_IDMOutput_DistortionMeshBlock14_SearchPoint3(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 14, 3))\012#define VME_GET_IDMOutput_DistortionMeshBlock14_SearchPoint4(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 14, 4))\012#define VME_GET_IDMOutput_DistortionMeshBlock14_SearchPoint5(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 14, 5))\012#define VME_GET_IDMOutput_DistortionMeshBlock14_SearchPo",
"int6(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 14, 6))\012#define VME_GET_IDMOutput_DistortionMeshBlock14_SearchPoint7(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 14, 7))\012#define VME_GET_IDMOutput_DistortionMeshBlock14_SearchPoint8(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 14, 8))\012#define VME_GET_IDMOutput_DistortionMeshBlock14_SearchPoint9(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 14, 9))\012#define VME_GET_IDMOutput_DistortionMeshBlock14_SearchPoint10(p, v)            \\\012  (v = VME_Output_S1(p, ushort, 14, 10))\012#define VME_GET_IDMOutput_DistortionMeshBlock14_SearchPoint11(p, v)            \\\012  (v = VME_Output_S1(p, ushort, 14, 11))\012#define VME_GET_IDMOutput_DistortionMeshBlock14_SearchPoint12(p, v)            \\\012  (v = VME_Output_S1(p, ushort, 14, 12))\012#define VME_GET_IDMOutput_DistortionMeshBlock14_SearchPoint13(p, v)            \\\012  (v = VME_Output_S1(p, ushort, 14, 13))\012#define VME_GET_IDMOutput_DistortionMeshBlock14_SearchPoint14(p, v)            \\\012  (v = VME_Output_S1(p, ush",
"ort, 14, 14))\012#define VME_GET_IDMOutput_DistortionMeshBlock14_SearchPoint15(p, v)            \\\012  (v = VME_Output_S1(p, ushort, 14, 15))\012\012#define VME_GET_IDMOutput_DistortionMeshBlock15_SearchPoint0(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 15, 0))\012#define VME_GET_IDMOutput_DistortionMeshBlock15_SearchPoint1(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 15, 1))\012#define VME_GET_IDMOutput_DistortionMeshBlock15_SearchPoshort(p, v)            \\\012  (v = VME_Output_S1(p, ushort, 15, 2))\012#define VME_GET_IDMOutput_DistortionMeshBlock15_SearchPoint3(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 15, 3))\012#define VME_GET_IDMOutput_DistortionMeshBlock15_SearchPoint4(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 15, 4))\012#define VME_GET_IDMOutput_DistortionMeshBlock15_SearchPoint5(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 15, 5))\012#define VME_GET_IDMOutput_DistortionMeshBlock15_SearchPoint6(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 15, 6))\012#define VME_GET_IDMOutput_DistortionMesh",
"Block15_SearchPoint7(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 15, 7))\012#define VME_GET_IDMOutput_DistortionMeshBlock15_SearchPoint8(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 15, 8))\012#define VME_GET_IDMOutput_DistortionMeshBlock15_SearchPoint9(p, v)             \\\012  (v = VME_Output_S1(p, ushort, 15, 9))\012#define VME_GET_IDMOutput_DistortionMeshBlock15_SearchPoint10(p, v)            \\\012  (v = VME_Output_S1(p, ushort, 15, 10))\012#define VME_GET_IDMOutput_DistortionMeshBlock15_SearchPoint11(p, v)            \\\012  (v = VME_Output_S1(p, ushort, 15, 11))\012#define VME_GET_IDMOutput_DistortionMeshBlock15_SearchPoint12(p, v)            \\\012  (v = VME_Output_S1(p, ushort, 15, 12))\012#define VME_GET_IDMOutput_DistortionMeshBlock15_SearchPoint13(p, v)            \\\012  (v = VME_Output_S1(p, ushort, 15, 13))\012#define VME_GET_IDMOutput_DistortionMeshBlock15_SearchPoint14(p, v)            \\\012  (v = VME_Output_S1(p, ushort, 15, 14))\012#define VME_GET_IDMOutput_DistortionMeshBlock15_SearchPoint15(p, v)            \\\012  (v = VME",
"_Output_S1(p, ushort, 15, 15))\012\012// Run VME APIs\012\012typedef enum _VMEStreamMode_ {\012  VME_STREAM_DISABLE = 0,\012  VME_STREAM_OUT = 1,\012  VME_STREAM_IN = 2,\012  VME_STREAM_IN_OUT = 3\012} VMEStreamMode;\012\012typedef enum _VMESearchCtrl_ {\012  VME_SEARCH_SINGLE_REF_SINGLE_REC_SINGLE_START = 0,\012  VME_SEARCH_SINGLE_REF_SINGLE_REC_DUAL_START = 1,\012  VME_SEARCH_SINGLE_REF_DUAL_REC = 3,\012  VME_SEARCH_DUAL_REF_DUAL_REC = 7\012} VMESearchCtrl;\012\012typedef enum _VMEMsgType_ {\012  VME_SIC_MSG = 0,\012  VME_FBR_MSG = 1,\012  VME_IME_MSG = 2,\012  VME_IDM_MSG = 3\012} VMEMsgType;\012\012// Set the default values for VME input payload\012\012#define INIT_VME_UNIINPUT(p)                                                   \\\012  { /* M0 */                                                                   \\\012    VME_Input_S1(p, uint, 0, 0) = 0x00000000;                                  \\\012    VME_Input_S1(p, uint, 0, 1) = 0x00000000;                                  \\\012    VME_Input_S1(p, uint, 0, 2) = 0x00000000;                                  \\\012    VME_Input_S1(p, uint, 0, 3) = 0",
"x00A80000;                                  \\\012    VME_Input_S1(p, uint, 0, 4) = 0x00000000;                                  \\\012    VME_Input_S1(p, uint, 0, 5) = 0x00000000;                                  \\\012    VME_Input_S1(p, uint, 0, 6) = 0x00000000;                                  \\\012    VME_Input_S1(p, uint, 0, 7) = 0x00000000;                                  \\\012    /* M1 */                                                                   \\\012    VME_Input_S1(p, uint, 1, 0) = 0x00000000;                                  \\\012    VME_Input_S1(p, uint, 1, 1) = 0x00000008;                                  \\\012    VME_Input_S1(p, uint, 1, 2) = 0x00000000;                                  \\\012    VME_Input_S1(p, uint, 1, 3) = 0x00000000;                                  \\\012    VME_Input_S1(p, uint, 1, 4) = 0x00000000;                                  \\\012    VME_Input_S1(p, uint, 1, 5) = 0x00000000;                                  \\\012    VME_Input_S1(p, uint, 1, 6) = 0x00000000;                                  \\\012    VM",
"E_Input_S1(p, uint, 1, 7) = 0x00400060;                                  \\\012    /* M2 */                                                                   \\\012    VME_Input_S1(p, uint, 2, 0) = 0x00000000;                                  \\\012    VME_Input_S1(p, uint, 2, 1) = 0x00000000;                                  \\\012    VME_Input_S1(p, uint, 2, 2) = 0x00000000;                                  \\\012    VME_Input_S1(p, uint, 2, 3) = 0x00000000;                                  \\\012    VME_Input_S1(p, uint, 2, 4) = 0x00000000;                                  \\\012    VME_Input_S1(p, uint, 2, 5) = 0x00000000;                                  \\\012    VME_Input_S1(p, uint, 2, 6) = 0x00000000;                                  \\\012    VME_Input_S1(p, uint, 2, 7) = 0x00000000;                                  \\\012    /* M3 */                                                                   \\\012    VME_Input_S1(p, uint, 3, 0) = 0x00000000;                                  \\\012    VME_Input_S1(p, uint, 3, 1) = 0x00000000;             ",
"                     \\\012    VME_Input_S1(p, uint, 3, 2) = 0x00000000;                                  \\\012    VME_Input_S1(p, uint, 3, 3) = 0x00000000;                                  \\\012    VME_Input_S1(p, uint, 3, 4) = 0x00000000;                                  \\\012    VME_Input_S1(p, uint, 3, 5) = 0x00000000;                                  \\\012    VME_Input_S1(p, uint, 3, 6) = 0x00000000;                                  \\\012    VME_Input_S1(p, uint, 3, 7) = 0x00000000;                                  \\\012  }\012\012// TBD: set different default values for each payload field\012#define INIT_VME_IMEINPUT(p)                                                   \\\012  { p = 0; }\012\012#define INIT_VME_SICINPUT(p)                                                   \\\012  { p = 0; }\012\012#define INIT_VME_FBRINPUT(p)                                                   \\\012  { p = 0; }\012\012#define INIT_VME_IDMINPUT(p)                                                   \\\012  { p = 0; }\012\012#define RESET_VME_UNIINPUT(p)                                         ",
"         \\\012  { p.format<uint, 4, 8>() = 0; }\012\012#define RESET_VME_IMEINPUT(p, sz)                                              \\\012  { p.format<uint, sz, 8>() = 0; }\012\012#define RESET_VME_SICINPUT(p)                                                  \\\012  { p.format<uint, 4, 8>() = 0; }\012\012#define RESET_VME_FBRINPUT(p)                                                  \\\012  { p.format<uint, 4, 8>() = 0; }\012\012#define RESET_VME_IDMINPUT(p)                                                  \\\012  { p.format<uint, 1, 8>() = 0; }\012\012static CM_INLINE constexpr unsigned\012getVMEInputSize(unsigned size, VMEStreamMode mode, VMESearchCtrl ctrl) {\012  return (mode != VME_STREAM_IN && mode != VME_STREAM_IN_OUT)\012             \? size + 2\012             : (ctrl == VME_SEARCH_DUAL_REF_DUAL_REC) \? (size + 6) : (size + 4);\012}\012\012template <VMEStreamMode streamMode, VMESearchCtrl searchCtrl, int N1, int N2>\012CM_INLINE void\012_run_vme_ime_impl(matrix<uchar, 4, 32> UNIInput, matrix<uchar, N1, 32> IMEInput,\012                  SurfaceIndex curSurfIndex, vector<short, 2",
"> ref0,\012                  vector<short, 2> ref1, vector<ushort, 16> costCenter,\012                  matrix_ref<uchar, N2, 32> IMEOutput) {\012  // HSW: 3; otherwise 4 to invoke below function\012  constexpr unsigned inputSize = getVMEInputSize(4, streamMode, searchCtrl);\012  constexpr unsigned remaining = (inputSize - 4) * 8;\012  matrix<uint, inputSize, 8> src = 0;\012  // mov  (24)    VX(0,0)<1>,  UNIInput\012  src.format<uint>().select<32, 1>(0) =\012      UNIInput.format<uint>().select<32, 1>(0);\012  // mov  (16)   VX(3,0)<1>,  IMEInput\012  src.format<uint>().select<remaining, 1>(32) =\012      IMEInput.format<uint>().select<remaining, 1>(0);\012  // and  (1)     VX(0,13)<1>, VX(0,13):ub, 0xF8\012  src.format<uchar>()(13) &= 0xF8;\012  // or   (1)     VX(0,13)<1>, VX(0,13):ub, searchCtrl\012  src.format<uchar>()(13) |= (unsigned)searchCtrl;\012  // mov  (2)     VA(0,0)<1>,  ref0\012  // since ref0 is converted from UW to UD, move it as 1 UD\012  src(0, 0) = ref0.format<uint>()(0);\012  // mov  (2)     VA(0,2)<1>,  ref1\012  // since ref1 is converted from UW t",
"o UD, move it as 1 UD\012  src(0, 1) = ref1.format<uint>()(0);\012  // mov  (8)     VA(3,0)<1>,  costCenter\012  src.select<1, 1, 8, 1>(3, 0) = costCenter.format<uint>().select<8, 1>(0);\012\012  unsigned fCtrl = 0;        // Bit 7-0 of message descriptor\012  fCtrl += 0x2 << 13;        // Bit 14-13 of message descriptor\012  fCtrl += streamMode << 15; // Bit 16-15 of message descriptor\012\012  unsigned rspLength = 288 / 32;\012  if ((streamMode != VME_STREAM_OUT) && (streamMode != VME_STREAM_IN_OUT)) {\012    rspLength = 224 / 32;\012  } else if (searchCtrl == VME_SEARCH_DUAL_REF_DUAL_REC) {\012    rspLength = 352 / 32;\012  }\012\012  // Function control (bit 0:18)\012  // Header present   (bit 19)\012  // Response length  (bit 20:24)\012  // Message length   (bit 25:28)\012  uint Descriptor = (fCtrl & 0x7FFFF) + (1 << 19) + ((rspLength & 0x1f) << 20) +\012                    ((inputSize & 0xF) << 25);\012\012  Descriptor = cm_get_value(curSurfIndex) + Descriptor;\012  /*Implementing VME based on cm_send() for gen7_5\012    template <int N1, int N2>\012    void cm_send(matrix_ref<us",
"hort, N1, 16> IMEOutput, matrix<ushort, inputSize,\012    16>src, uint exDesc, uint msgDesc, uint sendc);*/\012  cm_send(IMEOutput.format<ushort, N2, 16>(),\012          src.format<ushort, inputSize, 16>(), __SFID_VME, Descriptor, 0u);\012}\012\012template <int N1, int N2>\012CM_NODEBUG CM_INLINE void\012run_vme_ime(matrix<uchar, 4, 32> UNIInput, matrix<uchar, N1, 32> IMEInput,\012            VMEStreamMode streamMode, VMESearchCtrl searchCtrl,\012            SurfaceIndex curSurfIndex, vector<short, 2> ref0,\012            vector<short, 2> ref1, vector<ushort, 16> costCenter,\012            matrix_ref<uchar, N2, 32> IMEOutput) {\012#define VME_IME(mode, ctrl)                                                    \\\012  _run_vme_ime_impl<mode, ctrl>(UNIInput, IMEInput, curSurfIndex, ref0, ref1,  \\\012                                costCenter, IMEOutput)\012  if (N1 == 2 && N2 == 7) {\012    if (streamMode == VME_STREAM_DISABLE) {\012      if (searchCtrl == VME_SEARCH_SINGLE_REF_SINGLE_REC_SINGLE_START)\012        VME_IME(VME_STREAM_DISABLE,\012                VME_SEARCH_S",
"INGLE_REF_SINGLE_REC_SINGLE_START);\012      if (searchCtrl == VME_SEARCH_SINGLE_REF_SINGLE_REC_DUAL_START)\012        VME_IME(VME_STREAM_DISABLE,\012                VME_SEARCH_SINGLE_REF_SINGLE_REC_DUAL_START);\012      if (searchCtrl == VME_SEARCH_SINGLE_REF_DUAL_REC)\012        VME_IME(VME_STREAM_DISABLE, VME_SEARCH_SINGLE_REF_DUAL_REC);\012      if (searchCtrl == VME_SEARCH_DUAL_REF_DUAL_REC)\012        VME_IME(VME_STREAM_DISABLE, VME_SEARCH_DUAL_REF_DUAL_REC);\012    }\012  } else if (N1 == 2 && N2 == 9) {\012    if (streamMode == VME_STREAM_OUT) {\012      // searchCtrl != VME_SEARCH_DUAL_REF_DUAL_REC\012      if (searchCtrl == VME_SEARCH_SINGLE_REF_SINGLE_REC_SINGLE_START) {\012        VME_IME(VME_STREAM_OUT, VME_SEARCH_SINGLE_REF_SINGLE_REC_SINGLE_START);\012      }\012      if (searchCtrl == VME_SEARCH_SINGLE_REF_SINGLE_REC_DUAL_START) {\012        VME_IME(VME_STREAM_OUT, VME_SEARCH_SINGLE_REF_SINGLE_REC_DUAL_START);\012      }\012      if (searchCtrl == VME_SEARCH_SINGLE_REF_DUAL_REC) {\012        VME_IME(VME_STREAM_OUT, VME_SEARCH_SINGLE_REF_DUAL_REC);\012 ",
"     }\012    }\012  } else if (N1 == 2 && N2 == 11) {\012    if (streamMode == VME_STREAM_OUT &&\012        searchCtrl == VME_SEARCH_DUAL_REF_DUAL_REC) {\012      VME_IME(VME_STREAM_OUT, VME_SEARCH_DUAL_REF_DUAL_REC);\012    }\012  } else if (N1 == 4 && N2 == 7) {\012    if (streamMode == VME_STREAM_IN) {\012      // searchCtrl != VME_SEARCH_DUAL_REF_DUAL_REC) {\012      if (searchCtrl == VME_SEARCH_SINGLE_REF_SINGLE_REC_SINGLE_START) {\012        VME_IME(VME_STREAM_IN, VME_SEARCH_SINGLE_REF_SINGLE_REC_SINGLE_START);\012      }\012      if (searchCtrl == VME_SEARCH_SINGLE_REF_SINGLE_REC_DUAL_START) {\012        VME_IME(VME_STREAM_IN, VME_SEARCH_SINGLE_REF_SINGLE_REC_DUAL_START);\012      }\012      if (searchCtrl == VME_SEARCH_SINGLE_REF_DUAL_REC) {\012        VME_IME(VME_STREAM_IN, VME_SEARCH_SINGLE_REF_DUAL_REC);\012      }\012    }\012  } else if (N1 == 4 && N2 == 9) {\012    if (streamMode == VME_STREAM_IN_OUT) {\012      // searchCtrl != VME_SEARCH_DUAL_REF_DUAL_REC\012      if (searchCtrl == VME_SEARCH_SINGLE_REF_SINGLE_REC_SINGLE_START) {\012        VME_IME(VME_STREAM_IN_",
"OUT,\012                VME_SEARCH_SINGLE_REF_SINGLE_REC_SINGLE_START);\012      }\012      if (searchCtrl == VME_SEARCH_SINGLE_REF_SINGLE_REC_DUAL_START) {\012        VME_IME(VME_STREAM_IN_OUT, VME_SEARCH_SINGLE_REF_SINGLE_REC_DUAL_START);\012      }\012      if (searchCtrl == VME_SEARCH_SINGLE_REF_DUAL_REC) {\012        VME_IME(VME_STREAM_IN_OUT, VME_SEARCH_SINGLE_REF_DUAL_REC);\012      }\012    }\012  } else if (N1 == 6 && N2 == 7) {\012    if (streamMode == VME_STREAM_IN &&\012        searchCtrl == VME_SEARCH_DUAL_REF_DUAL_REC) {\012      VME_IME(VME_STREAM_IN, VME_SEARCH_DUAL_REF_DUAL_REC);\012    }\012  } else if (N1 == 6 && N2 == 11) {\012    if (streamMode == VME_STREAM_IN_OUT &&\012        searchCtrl == VME_SEARCH_DUAL_REF_DUAL_REC) {\012      VME_IME(VME_STREAM_IN_OUT, VME_SEARCH_DUAL_REF_DUAL_REC);\012    }\012  }\012}\012\012template <typename Dummy = void>\012CM_INLINE void\012run_vme_fbr(matrix<uchar, 4, 32> UNIInput, matrix<uchar, 4, 32> FBRInput,\012            SurfaceIndex curSurfIndex, uchar FBRMbMode, uchar FBRSubMbShape,\012            uchar FBRSubPredMode, matrix_ref",
"<uchar, 7, 32> FBROutput) {\012  matrix<uint, 8, 8> src = 0;\012  // mov(96)    VX(0, 0)<1>, UNIInput\012  src.format<uint>().select<32, 1>(0) =\012      UNIInput.format<uint>().select<32, 1>(0);\012  // mov  (128)   VX(3,0)<1>,  FBRInput\012  src.format<uint>().select<32, 1>(32) =\012      FBRInput.format<uint>().select<32, 1>(0);\012  // mov  (1)     VX(2,20)<1>, FBRMbMode\012  src.format<uchar, 8, 32>()(2, 20) = FBRMbMode;\012  // mov  (1)     VX(2,21)<1>, FBRSubMbShape\012  src.format<uchar, 8, 32>()(2, 21) = FBRSubMbShape;\012  //  mov  (1)     VX(2,22)<1>, FBRSubPredMode\012  src.format<uchar, 8, 32>()(2, 22) = FBRSubPredMode;\012\012  unsigned fCtrl = 0x3 << 13;\012  unsigned rspLength = 7;\012  unsigned msglength = 8;\012  uint Descriptor = (fCtrl & 0x7FFFF) + (1 << 19) + ((rspLength & 0x1f) << 20) +\012                    ((msglength & 0xF) << 25);\012\012  Descriptor = cm_get_value(curSurfIndex) + Descriptor;\012  cm_send(FBROutput.format<ushort, 7, 16>(), src.format<ushort, 8, 16>(),\012          __SFID_CRE, Descriptor, 0u);\012}\012\012template <typename Dummy = void>\012CM_IN",
"LINE void\012run_vme_sic(matrix<uchar, 4, 32> UNIInput, matrix<uchar, 4, 32> SICInput,\012            SurfaceIndex curSurfIndex, matrix_ref<uchar, 7, 32> UNIOutput) {\012  matrix<uint, 8, 8> src = 0;\012  // mov  (96)    VX(0,0)<1>,  UNIInput\012  src.format<uint>().select<32, 1>(0) =\012      UNIInput.format<uint>().select<32, 1>(0);\012  // mov  (128)   VX(3,0)<1>,  SICInput\012  src.format<uint>().select<32, 1>(32) =\012      SICInput.format<uint>().select<32, 1>(0);\012  unsigned fCtrl = 0x1 << 13;\012  unsigned rspLength = 7;\012  unsigned msgLength = 8;\012  uint Descriptor = (fCtrl & 0x7FFFF) + (1 << 19) + ((rspLength & 0x1f) << 20) +\012                    ((msgLength & 0xF) << 25);\012\012  Descriptor = cm_get_value(curSurfIndex) + Descriptor;\012  cm_send(UNIOutput.format<ushort, 7, 16>(), src.format<ushort, 8, 16>(),\012          __SFID_CRE, Descriptor, 0u);\012}\012\012template <typename Dummy = void>\012CM_INLINE void\012run_vme_idm(matrix<uchar, 4, 32> UNIInput, matrix<uchar, 1, 32> IDMInput,\012            SurfaceIndex curSurfIndex, matrix_ref<uchar, 16, 32> IDMOut",
"put) {\012  matrix<uint, 5, 8> src = 0;\012  // mov(96)    VX(0, 0)<1>, UNIInput\012  src.format<uint>().select<32, 1>(0) =\012      UNIInput.format<uint>().select<32, 1>(0);\012  // mov  (128)   VX(3,0)<1>,  IDMInput\012  src.format<uint>().select<8, 1>(32) = IDMInput.format<uint>().select<8, 1>(0);\012\012  unsigned fCtrl = 0;\012  unsigned rspLength = 16;\012  unsigned msglength = 5;\012  uint Descriptor = (fCtrl & 0x7FFFF) + (1 << 19) + ((rspLength & 0x1f) << 20) +\012                    ((msglength & 0xF) << 25);\012\012  Descriptor = cm_get_value(curSurfIndex) + Descriptor;\012  cm_send(IDMOutput.format<ushort, 16, 16>(), src.format<ushort, 5, 16>(),\012          __SFID_VME, Descriptor, 0u);\012}\012\012#endif /* _CLANG_gen9_VME_H_ */\012\000/*========================== begin_copyright_notice ============================\012\012Copyright (C) 2020-2021 Intel Corporation\012\012SPDX-License-Identifier: MIT\012\012============================= end_copyright_notice ===========================*/\012\012/*========================== begin_copyright_notice ============================\012\012This file ",
"is distributed under the University of Illinois Open Source License.\012See LICENSE.TXT for details.\012\012============================= end_copyright_notice ===========================*/\012\012#ifndef _OPENCL_COMMON_H_\012#define _OPENCL_COMMON_H_\012\012#ifndef cl_khr_fp16\012#define cl_khr_fp16\012#endif\012\012#ifndef cl_khr_fp64\012#define cl_khr_fp64\012#endif \012\012#ifndef __OPENCL_C_VERSION__\012#define CL_VERSION_1_2 120\012#define CL_VERSION_2_0 200\012#define __OPENCL_C_VERSION__ CL_VERSION_1_2\012#endif\012\012#define __ovld __attribute__((overloadable))\012#define __conv __attribute__((convergent))\012\012// Optimizations\012#define __purefn __attribute__((pure))\012#define __cnfn __attribute__((const))\012\012#ifdef cl_khr_fp64\012#if __OPENCL_C_VERSION__ < CL_VERSION_1_2\012#pragma OPENCL EXTENSION cl_khr_fp64 : enable\012#endif\012#endif\012\012#if __OPENCL_C_VERSION__ < CL_VERSION_2_0\012#ifdef cl_khr_3d_image_writes\012#pragma OPENCL EXTENSION cl_khr_3d_image_writes : enable\012#endif //cl_khr_3d_image_writes\012#endif //__OPENCL_C_VERSION__ < CL_VERSION_2_0\012\012// built-in scalar data types:\012\012/**\012 * An u",
"nsigned 8-bit integer.\012 */\012typedef unsigned char uchar;\012\012/**\012 * An unsigned 16-bit integer.\012 */\012typedef unsigned short ushort;\012\012/**\012 * An unsigned 32-bit integer.\012 */\012typedef unsigned int uint;\012\012/**\012 * An unsigned 64-bit integer.\012 */\012typedef unsigned long ulong;\012\012// Flag type and values for barrier, mem_fence, read_mem_fence, write_mem_fence\012typedef uint cl_mem_fence_flags;\012\012\012// built-in vector data types:\012typedef char char2 __attribute__((ext_vector_type(2)));\012typedef char char3 __attribute__((ext_vector_type(3)));\012typedef char char4 __attribute__((ext_vector_type(4)));\012typedef char char8 __attribute__((ext_vector_type(8)));\012typedef char char16 __attribute__((ext_vector_type(16)));\012typedef uchar uchar2 __attribute__((ext_vector_type(2)));\012typedef uchar uchar3 __attribute__((ext_vector_type(3)));\012typedef uchar uchar4 __attribute__((ext_vector_type(4)));\012typedef uchar uchar8 __attribute__((ext_vector_type(8)));\012typedef uchar uchar16 __attribute__((ext_vector_type(16)));\012typedef short short2 __attribute__((ext_",
"vector_type(2)));\012typedef short short3 __attribute__((ext_vector_type(3)));\012typedef short short4 __attribute__((ext_vector_type(4)));\012typedef short short8 __attribute__((ext_vector_type(8)));\012typedef short short16 __attribute__((ext_vector_type(16)));\012typedef ushort ushort2 __attribute__((ext_vector_type(2)));\012typedef ushort ushort3 __attribute__((ext_vector_type(3)));\012typedef ushort ushort4 __attribute__((ext_vector_type(4)));\012typedef ushort ushort8 __attribute__((ext_vector_type(8)));\012typedef ushort ushort16 __attribute__((ext_vector_type(16)));\012typedef int int2 __attribute__((ext_vector_type(2)));\012typedef int int3 __attribute__((ext_vector_type(3)));\012typedef int int4 __attribute__((ext_vector_type(4)));\012typedef int int8 __attribute__((ext_vector_type(8)));\012typedef int int16 __attribute__((ext_vector_type(16)));\012typedef uint uint2 __attribute__((ext_vector_type(2)));\012typedef uint uint3 __attribute__((ext_vector_type(3)));\012typedef uint uint4 __attribute__((ext_vector_type(4)));\012typedef uint uint8 __attribute",
"__((ext_vector_type(8)));\012typedef uint uint16 __attribute__((ext_vector_type(16)));\012typedef long long2 __attribute__((ext_vector_type(2)));\012typedef long long3 __attribute__((ext_vector_type(3)));\012typedef long long4 __attribute__((ext_vector_type(4)));\012typedef long long8 __attribute__((ext_vector_type(8)));\012typedef long long16 __attribute__((ext_vector_type(16)));\012typedef ulong ulong2 __attribute__((ext_vector_type(2)));\012typedef ulong ulong3 __attribute__((ext_vector_type(3)));\012typedef ulong ulong4 __attribute__((ext_vector_type(4)));\012typedef ulong ulong8 __attribute__((ext_vector_type(8)));\012typedef ulong ulong16 __attribute__((ext_vector_type(16)));\012typedef float float2 __attribute__((ext_vector_type(2)));\012typedef float float3 __attribute__((ext_vector_type(3)));\012typedef float float4 __attribute__((ext_vector_type(4)));\012typedef float float8 __attribute__((ext_vector_type(8)));\012typedef float float16 __attribute__((ext_vector_type(16)));\012#ifdef cl_khr_fp16\012#pragma OPENCL EXTENSION cl_khr_fp16 : enable\012typedef h",
"alf half2 __attribute__((ext_vector_type(2)));\012typedef half half3 __attribute__((ext_vector_type(3)));\012typedef half half4 __attribute__((ext_vector_type(4)));\012typedef half half8 __attribute__((ext_vector_type(8)));\012typedef half half16 __attribute__((ext_vector_type(16)));\012#endif\012#ifdef cl_khr_fp64\012typedef double double2 __attribute__((ext_vector_type(2)));\012typedef double double3 __attribute__((ext_vector_type(3)));\012typedef double double4 __attribute__((ext_vector_type(4)));\012typedef double double8 __attribute__((ext_vector_type(8)));\012typedef double double16 __attribute__((ext_vector_type(16)));\012#endif\012\012/**\012 * Value of maximum non-infinite single-precision floating-point\012 * number.\012 */\012#define MAXFLOAT 0x1.fffffep127f\012\012/**\012 * A positive float constant expression. HUGE_VALF evaluates\012 * to +infinity. Used as an error value returned by the built-in\012 * math functions.\012 */\012#define HUGE_VALF (__builtin_huge_valf())\012\012/**\012 * A positive double constant expression. HUGE_VAL evaluates\012 * to +infinity. Used as an error va",
"lue returned by the built-in\012 * math functions.\012 */\012#define HUGE_VAL (__builtin_huge_val())\012\012/**\012 * A constant expression of type float representing positive or\012 * unsigned infinity.\012 */\012#define INFINITY (__builtin_inff())\012\012/**\012 * A constant expression of type float representing a quiet NaN.\012 */\012#define NAN as_float(INT_MAX)\012\012#define FP_ILOGB0    INT_MIN\012#define FP_ILOGBNAN    INT_MAX\012\012#define FLT_DIG 6\012#define FLT_MANT_DIG 24\012#define FLT_MAX_10_EXP +38\012#define FLT_MAX_EXP +128\012#define FLT_MIN_10_EXP -37\012#define FLT_MIN_EXP -125\012#define FLT_RADIX 2\012#define FLT_MAX 0x1.fffffep127f\012#define FLT_MIN 0x1.0p-126f\012#define FLT_EPSILON 0x1.0p-23f\012\012#define M_E_F         2.71828182845904523536028747135266250f\012#define M_LOG2E_F     1.44269504088896340735992468100189214f\012#define M_LOG10E_F    0.434294481903251827651128918916605082f\012#define M_LN2_F       0.693147180559945309417232121458176568f\012#define M_LN10_F      2.30258509299404568401799145468436421f\012#define M_PI_F        3.14159265358979323846264338327950288f\012#define M",
"_PI_2_F      1.57079632679489661923132169163975144f\012#define M_PI_4_F      0.785398163397448309615660845819875721f\012#define M_1_PI_F      0.318309886183790671537767526745028724f\012#define M_2_PI_F      0.636619772367581343075535053490057448f\012#define M_2_SQRTPI_F  1.12837916709551257389615890312154517f\012#define M_SQRT2_F     1.41421356237309504880168872420969808f\012#define M_SQRT1_2_F   0.707106781186547524400844362104849039f\012\012#define DBL_DIG 15\012#define DBL_MANT_DIG 53\012#define DBL_MAX_10_EXP +308\012#define DBL_MAX_EXP +1024\012#define DBL_MIN_10_EXP -307\012#define DBL_MIN_EXP -1021\012#define DBL_RADIX 2\012#define DBL_MAX 0x1.fffffffffffffp1023\012#define DBL_MIN 0x1.0p-1022\012#define DBL_EPSILON 0x1.0p-52\012\012#define M_E           0x1.5bf0a8b145769p+1\012#define M_LOG2E       0x1.71547652b82fep+0\012#define M_LOG10E      0x1.bcb7b1526e50ep-2\012#define M_LN2         0x1.62e42fefa39efp-1\012#define M_LN10        0x1.26bb1bbb55516p+1\012#define M_PI          0x1.921fb54442d18p+1\012#define M_PI_2        0x1.921fb54442d18p+0\012#define M_PI_4        0x1.921fb",
"54442d18p-1\012#define M_1_PI        0x1.45f306dc9c883p-2\012#define M_2_PI        0x1.45f306dc9c883p-1\012#define M_2_SQRTPI    0x1.20dd750429b6dp+0\012#define M_SQRT2       0x1.6a09e667f3bcdp+0\012#define M_SQRT1_2     0x1.6a09e667f3bcdp-1\012\012#ifdef cl_khr_fp16\012\012#define HALF_DIG 3\012#define HALF_MANT_DIG 11\012#define HALF_MAX_10_EXP +4\012#define HALF_MAX_EXP +16\012#define HALF_MIN_10_EXP -4\012#define HALF_MIN_EXP -13\012#define HALF_RADIX 2\012#define HALF_MAX ((0x1.ffcp15h))\012#define HALF_MIN ((0x1.0p-14h))\012#define HALF_EPSILON ((0x1.0p-10h))\012\012#define M_E_H         2.71828182845904523536028747135266250h\012#define M_LOG2E_H     1.44269504088896340735992468100189214h\012#define M_LOG10E_H    0.434294481903251827651128918916605082h\012#define M_LN2_H       0.693147180559945309417232121458176568h\012#define M_LN10_H      2.30258509299404568401799145468436421h\012#define M_PI_H        3.14159265358979323846264338327950288h\012#define M_PI_2_H      1.57079632679489661923132169163975144h\012#define M_PI_4_H      0.785398163397448309615660845819875721h\012#define M_1_PI",
"_H      0.318309886183790671537767526745028724h\012#define M_2_PI_H      0.636619772367581343075535053490057448h\012#define M_2_SQRTPI_H  1.12837916709551257389615890312154517h\012#define M_SQRT2_H     1.41421356237309504880168872420969808h\012#define M_SQRT1_2_H   0.707106781186547524400844362104849039h\012\012#endif //cl_khr_fp16\012\012#define CHAR_BIT    8\012#define SCHAR_MAX  127\012#define SCHAR_MIN  (-128)\012#define UCHAR_MAX  255\012#define CHAR_MAX  SCHAR_MAX\012#define CHAR_MIN  SCHAR_MIN\012#define USHRT_MAX  65535\012#define SHRT_MAX  32767\012#define SHRT_MIN  (-32768)\012#define UINT_MAX  0xffffffff\012#define INT_MAX    2147483647\012#define INT_MIN    (-2147483647-1)\012#define ULONG_MAX  0xffffffffffffffffUL\012#define LONG_MAX  0x7fffffffffffffffL\012#define LONG_MIN  (-0x7fffffffffffffffL-1)\012\012// OpenCL v1.1/1.2/2.0 s6.2.3 - Explicit conversions\012\012char __ovld __cnfn convert_char_rte(char);\012char __ovld __cnfn convert_char_sat_rte(char);\012char __ovld __cnfn convert_char_rtz(char);\012char __ovld __cnfn convert_char_sat_rtz(char);\012char __ovld __cnfn convert_char",
"_rtp(char);\012char __ovld __cnfn convert_char_sat_rtp(char);\012char __ovld __cnfn convert_char_rtn(char);\012char __ovld __cnfn convert_char_sat_rtn(char);\012char __ovld __cnfn convert_char(char);\012char __ovld __cnfn convert_char_sat(char);\012char __ovld __cnfn convert_char_rte(uchar);\012char __ovld __cnfn convert_char_sat_rte(uchar);\012char __ovld __cnfn convert_char_rtz(uchar);\012char __ovld __cnfn convert_char_sat_rtz(uchar);\012char __ovld __cnfn convert_char_rtp(uchar);\012char __ovld __cnfn convert_char_sat_rtp(uchar);\012char __ovld __cnfn convert_char_rtn(uchar);\012char __ovld __cnfn convert_char_sat_rtn(uchar);\012char __ovld __cnfn convert_char(uchar);\012char __ovld __cnfn convert_char_sat(uchar);\012char __ovld __cnfn convert_char_rte(short);\012char __ovld __cnfn convert_char_sat_rte(short);\012char __ovld __cnfn convert_char_rtz(short);\012char __ovld __cnfn convert_char_sat_rtz(short);\012char __ovld __cnfn convert_char_rtp(short);\012char __ovld __cnfn convert_char_sat_rtp(short);\012char __ovld __cnfn convert_char_rtn(short);\012char __ovld __cnfn co",
"nvert_char_sat_rtn(short);\012char __ovld __cnfn convert_char(short);\012char __ovld __cnfn convert_char_sat(short);\012char __ovld __cnfn convert_char_rte(ushort);\012char __ovld __cnfn convert_char_sat_rte(ushort);\012char __ovld __cnfn convert_char_rtz(ushort);\012char __ovld __cnfn convert_char_sat_rtz(ushort);\012char __ovld __cnfn convert_char_rtp(ushort);\012char __ovld __cnfn convert_char_sat_rtp(ushort);\012char __ovld __cnfn convert_char_rtn(ushort);\012char __ovld __cnfn convert_char_sat_rtn(ushort);\012char __ovld __cnfn convert_char(ushort);\012char __ovld __cnfn convert_char_sat(ushort);\012char __ovld __cnfn convert_char_rte(int);\012char __ovld __cnfn convert_char_sat_rte(int);\012char __ovld __cnfn convert_char_rtz(int);\012char __ovld __cnfn convert_char_sat_rtz(int);\012char __ovld __cnfn convert_char_rtp(int);\012char __ovld __cnfn convert_char_sat_rtp(int);\012char __ovld __cnfn convert_char_rtn(int);\012char __ovld __cnfn convert_char_sat_rtn(int);\012char __ovld __cnfn convert_char(int);\012char __ovld __cnfn convert_char_sat(int);\012char __ovld __cnfn ",
"convert_char_rte(uint);\012char __ovld __cnfn convert_char_sat_rte(uint);\012char __ovld __cnfn convert_char_rtz(uint);\012char __ovld __cnfn convert_char_sat_rtz(uint);\012char __ovld __cnfn convert_char_rtp(uint);\012char __ovld __cnfn convert_char_sat_rtp(uint);\012char __ovld __cnfn convert_char_rtn(uint);\012char __ovld __cnfn convert_char_sat_rtn(uint);\012char __ovld __cnfn convert_char(uint);\012char __ovld __cnfn convert_char_sat(uint);\012char __ovld __cnfn convert_char_rte(long);\012char __ovld __cnfn convert_char_sat_rte(long);\012char __ovld __cnfn convert_char_rtz(long);\012char __ovld __cnfn convert_char_sat_rtz(long);\012char __ovld __cnfn convert_char_rtp(long);\012char __ovld __cnfn convert_char_sat_rtp(long);\012char __ovld __cnfn convert_char_rtn(long);\012char __ovld __cnfn convert_char_sat_rtn(long);\012char __ovld __cnfn convert_char(long);\012char __ovld __cnfn convert_char_sat(long);\012char __ovld __cnfn convert_char_rte(ulong);\012char __ovld __cnfn convert_char_sat_rte(ulong);\012char __ovld __cnfn convert_char_rtz(ulong);\012char __ovld __cnfn conv",
"ert_char_sat_rtz(ulong);\012char __ovld __cnfn convert_char_rtp(ulong);\012char __ovld __cnfn convert_char_sat_rtp(ulong);\012char __ovld __cnfn convert_char_rtn(ulong);\012char __ovld __cnfn convert_char_sat_rtn(ulong);\012char __ovld __cnfn convert_char(ulong);\012char __ovld __cnfn convert_char_sat(ulong);\012char __ovld __cnfn convert_char_rte(float);\012char __ovld __cnfn convert_char_sat_rte(float);\012char __ovld __cnfn convert_char_rtz(float);\012char __ovld __cnfn convert_char_sat_rtz(float);\012char __ovld __cnfn convert_char_rtp(float);\012char __ovld __cnfn convert_char_sat_rtp(float);\012char __ovld __cnfn convert_char_rtn(float);\012char __ovld __cnfn convert_char_sat_rtn(float);\012char __ovld __cnfn convert_char(float);\012char __ovld __cnfn convert_char_sat(float);\012uchar __ovld __cnfn convert_uchar_rte(char);\012uchar __ovld __cnfn convert_uchar_sat_rte(char);\012uchar __ovld __cnfn convert_uchar_rtz(char);\012uchar __ovld __cnfn convert_uchar_sat_rtz(char);\012uchar __ovld __cnfn convert_uchar_rtp(char);\012uchar __ovld __cnfn convert_uchar_sat_rtp(char",
");\012uchar __ovld __cnfn convert_uchar_rtn(char);\012uchar __ovld __cnfn convert_uchar_sat_rtn(char);\012uchar __ovld __cnfn convert_uchar(char);\012uchar __ovld __cnfn convert_uchar_sat(char);\012uchar __ovld __cnfn convert_uchar_rte(uchar);\012uchar __ovld __cnfn convert_uchar_sat_rte(uchar);\012uchar __ovld __cnfn convert_uchar_rtz(uchar);\012uchar __ovld __cnfn convert_uchar_sat_rtz(uchar);\012uchar __ovld __cnfn convert_uchar_rtp(uchar);\012uchar __ovld __cnfn convert_uchar_sat_rtp(uchar);\012uchar __ovld __cnfn convert_uchar_rtn(uchar);\012uchar __ovld __cnfn convert_uchar_sat_rtn(uchar);\012uchar __ovld __cnfn convert_uchar(uchar);\012uchar __ovld __cnfn convert_uchar_sat(uchar);\012uchar __ovld __cnfn convert_uchar_rte(short);\012uchar __ovld __cnfn convert_uchar_sat_rte(short);\012uchar __ovld __cnfn convert_uchar_rtz(short);\012uchar __ovld __cnfn convert_uchar_sat_rtz(short);\012uchar __ovld __cnfn convert_uchar_rtp(short);\012uchar __ovld __cnfn convert_uchar_sat_rtp(short);\012uchar __ovld __cnfn convert_uchar_rtn(short);\012uchar __ovld __cnfn convert_uchar_s",
"at_rtn(short);\012uchar __ovld __cnfn convert_uchar(short);\012uchar __ovld __cnfn convert_uchar_sat(short);\012uchar __ovld __cnfn convert_uchar_rte(ushort);\012uchar __ovld __cnfn convert_uchar_sat_rte(ushort);\012uchar __ovld __cnfn convert_uchar_rtz(ushort);\012uchar __ovld __cnfn convert_uchar_sat_rtz(ushort);\012uchar __ovld __cnfn convert_uchar_rtp(ushort);\012uchar __ovld __cnfn convert_uchar_sat_rtp(ushort);\012uchar __ovld __cnfn convert_uchar_rtn(ushort);\012uchar __ovld __cnfn convert_uchar_sat_rtn(ushort);\012uchar __ovld __cnfn convert_uchar(ushort);\012uchar __ovld __cnfn convert_uchar_sat(ushort);\012uchar __ovld __cnfn convert_uchar_rte(int);\012uchar __ovld __cnfn convert_uchar_sat_rte(int);\012uchar __ovld __cnfn convert_uchar_rtz(int);\012uchar __ovld __cnfn convert_uchar_sat_rtz(int);\012uchar __ovld __cnfn convert_uchar_rtp(int);\012uchar __ovld __cnfn convert_uchar_sat_rtp(int);\012uchar __ovld __cnfn convert_uchar_rtn(int);\012uchar __ovld __cnfn convert_uchar_sat_rtn(int);\012uchar __ovld __cnfn convert_uchar(int);\012uchar __ovld __cnfn convert_uch",
"ar_sat(int);\012uchar __ovld __cnfn convert_uchar_rte(uint);\012uchar __ovld __cnfn convert_uchar_sat_rte(uint);\012uchar __ovld __cnfn convert_uchar_rtz(uint);\012uchar __ovld __cnfn convert_uchar_sat_rtz(uint);\012uchar __ovld __cnfn convert_uchar_rtp(uint);\012uchar __ovld __cnfn convert_uchar_sat_rtp(uint);\012uchar __ovld __cnfn convert_uchar_rtn(uint);\012uchar __ovld __cnfn convert_uchar_sat_rtn(uint);\012uchar __ovld __cnfn convert_uchar(uint);\012uchar __ovld __cnfn convert_uchar_sat(uint);\012uchar __ovld __cnfn convert_uchar_rte(long);\012uchar __ovld __cnfn convert_uchar_sat_rte(long);\012uchar __ovld __cnfn convert_uchar_rtz(long);\012uchar __ovld __cnfn convert_uchar_sat_rtz(long);\012uchar __ovld __cnfn convert_uchar_rtp(long);\012uchar __ovld __cnfn convert_uchar_sat_rtp(long);\012uchar __ovld __cnfn convert_uchar_rtn(long);\012uchar __ovld __cnfn convert_uchar_sat_rtn(long);\012uchar __ovld __cnfn convert_uchar(long);\012uchar __ovld __cnfn convert_uchar_sat(long);\012uchar __ovld __cnfn convert_uchar_rte(ulong);\012uchar __ovld __cnfn convert_uchar_sat_rte",
"(ulong);\012uchar __ovld __cnfn convert_uchar_rtz(ulong);\012uchar __ovld __cnfn convert_uchar_sat_rtz(ulong);\012uchar __ovld __cnfn convert_uchar_rtp(ulong);\012uchar __ovld __cnfn convert_uchar_sat_rtp(ulong);\012uchar __ovld __cnfn convert_uchar_rtn(ulong);\012uchar __ovld __cnfn convert_uchar_sat_rtn(ulong);\012uchar __ovld __cnfn convert_uchar(ulong);\012uchar __ovld __cnfn convert_uchar_sat(ulong);\012uchar __ovld __cnfn convert_uchar_rte(float);\012uchar __ovld __cnfn convert_uchar_sat_rte(float);\012uchar __ovld __cnfn convert_uchar_rtz(float);\012uchar __ovld __cnfn convert_uchar_sat_rtz(float);\012uchar __ovld __cnfn convert_uchar_rtp(float);\012uchar __ovld __cnfn convert_uchar_sat_rtp(float);\012uchar __ovld __cnfn convert_uchar_rtn(float);\012uchar __ovld __cnfn convert_uchar_sat_rtn(float);\012uchar __ovld __cnfn convert_uchar(float);\012uchar __ovld __cnfn convert_uchar_sat(float);\012\012short __ovld __cnfn convert_short_rte(char);\012short __ovld __cnfn convert_short_sat_rte(char);\012short __ovld __cnfn convert_short_rtz(char);\012short __ovld __cnfn convert",
"_short_sat_rtz(char);\012short __ovld __cnfn convert_short_rtp(char);\012short __ovld __cnfn convert_short_sat_rtp(char);\012short __ovld __cnfn convert_short_rtn(char);\012short __ovld __cnfn convert_short_sat_rtn(char);\012short __ovld __cnfn convert_short(char);\012short __ovld __cnfn convert_short_sat(char);\012short __ovld __cnfn convert_short_rte(uchar);\012short __ovld __cnfn convert_short_sat_rte(uchar);\012short __ovld __cnfn convert_short_rtz(uchar);\012short __ovld __cnfn convert_short_sat_rtz(uchar);\012short __ovld __cnfn convert_short_rtp(uchar);\012short __ovld __cnfn convert_short_sat_rtp(uchar);\012short __ovld __cnfn convert_short_rtn(uchar);\012short __ovld __cnfn convert_short_sat_rtn(uchar);\012short __ovld __cnfn convert_short(uchar);\012short __ovld __cnfn convert_short_sat(uchar);\012short __ovld __cnfn convert_short_rte(short);\012short __ovld __cnfn convert_short_sat_rte(short);\012short __ovld __cnfn convert_short_rtz(short);\012short __ovld __cnfn convert_short_sat_rtz(short);\012short __ovld __cnfn convert_short_rtp(short);\012short __ovld __cnf",
"n convert_short_sat_rtp(short);\012short __ovld __cnfn convert_short_rtn(short);\012short __ovld __cnfn convert_short_sat_rtn(short);\012short __ovld __cnfn convert_short(short);\012short __ovld __cnfn convert_short_sat(short);\012short __ovld __cnfn convert_short_rte(ushort);\012short __ovld __cnfn convert_short_sat_rte(ushort);\012short __ovld __cnfn convert_short_rtz(ushort);\012short __ovld __cnfn convert_short_sat_rtz(ushort);\012short __ovld __cnfn convert_short_rtp(ushort);\012short __ovld __cnfn convert_short_sat_rtp(ushort);\012short __ovld __cnfn convert_short_rtn(ushort);\012short __ovld __cnfn convert_short_sat_rtn(ushort);\012short __ovld __cnfn convert_short(ushort);\012short __ovld __cnfn convert_short_sat(ushort);\012short __ovld __cnfn convert_short_rte(int);\012short __ovld __cnfn convert_short_sat_rte(int);\012short __ovld __cnfn convert_short_rtz(int);\012short __ovld __cnfn convert_short_sat_rtz(int);\012short __ovld __cnfn convert_short_rtp(int);\012short __ovld __cnfn convert_short_sat_rtp(int);\012short __ovld __cnfn convert_short_rtn(int);\012short ",
"__ovld __cnfn convert_short_sat_rtn(int);\012short __ovld __cnfn convert_short(int);\012short __ovld __cnfn convert_short_sat(int);\012short __ovld __cnfn convert_short_rte(uint);\012short __ovld __cnfn convert_short_sat_rte(uint);\012short __ovld __cnfn convert_short_rtz(uint);\012short __ovld __cnfn convert_short_sat_rtz(uint);\012short __ovld __cnfn convert_short_rtp(uint);\012short __ovld __cnfn convert_short_sat_rtp(uint);\012short __ovld __cnfn convert_short_rtn(uint);\012short __ovld __cnfn convert_short_sat_rtn(uint);\012short __ovld __cnfn convert_short(uint);\012short __ovld __cnfn convert_short_sat(uint);\012short __ovld __cnfn convert_short_rte(long);\012short __ovld __cnfn convert_short_sat_rte(long);\012short __ovld __cnfn convert_short_rtz(long);\012short __ovld __cnfn convert_short_sat_rtz(long);\012short __ovld __cnfn convert_short_rtp(long);\012short __ovld __cnfn convert_short_sat_rtp(long);\012short __ovld __cnfn convert_short_rtn(long);\012short __ovld __cnfn convert_short_sat_rtn(long);\012short __ovld __cnfn convert_short(long);\012short __ovld __cnfn",
" convert_short_sat(long);\012short __ovld __cnfn convert_short_rte(ulong);\012short __ovld __cnfn convert_short_sat_rte(ulong);\012short __ovld __cnfn convert_short_rtz(ulong);\012short __ovld __cnfn convert_short_sat_rtz(ulong);\012short __ovld __cnfn convert_short_rtp(ulong);\012short __ovld __cnfn convert_short_sat_rtp(ulong);\012short __ovld __cnfn convert_short_rtn(ulong);\012short __ovld __cnfn convert_short_sat_rtn(ulong);\012short __ovld __cnfn convert_short(ulong);\012short __ovld __cnfn convert_short_sat(ulong);\012short __ovld __cnfn convert_short_rte(float);\012short __ovld __cnfn convert_short_sat_rte(float);\012short __ovld __cnfn convert_short_rtz(float);\012short __ovld __cnfn convert_short_sat_rtz(float);\012short __ovld __cnfn convert_short_rtp(float);\012short __ovld __cnfn convert_short_sat_rtp(float);\012short __ovld __cnfn convert_short_rtn(float);\012short __ovld __cnfn convert_short_sat_rtn(float);\012short __ovld __cnfn convert_short(float);\012short __ovld __cnfn convert_short_sat(float);\012ushort __ovld __cnfn convert_ushort_rte(char);\012ushort ",
"__ovld __cnfn convert_ushort_sat_rte(char);\012ushort __ovld __cnfn convert_ushort_rtz(char);\012ushort __ovld __cnfn convert_ushort_sat_rtz(char);\012ushort __ovld __cnfn convert_ushort_rtp(char);\012ushort __ovld __cnfn convert_ushort_sat_rtp(char);\012ushort __ovld __cnfn convert_ushort_rtn(char);\012ushort __ovld __cnfn convert_ushort_sat_rtn(char);\012ushort __ovld __cnfn convert_ushort(char);\012ushort __ovld __cnfn convert_ushort_sat(char);\012ushort __ovld __cnfn convert_ushort_rte(uchar);\012ushort __ovld __cnfn convert_ushort_sat_rte(uchar);\012ushort __ovld __cnfn convert_ushort_rtz(uchar);\012ushort __ovld __cnfn convert_ushort_sat_rtz(uchar);\012ushort __ovld __cnfn convert_ushort_rtp(uchar);\012ushort __ovld __cnfn convert_ushort_sat_rtp(uchar);\012ushort __ovld __cnfn convert_ushort_rtn(uchar);\012ushort __ovld __cnfn convert_ushort_sat_rtn(uchar);\012ushort __ovld __cnfn convert_ushort(uchar);\012ushort __ovld __cnfn convert_ushort_sat(uchar);\012ushort __ovld __cnfn convert_ushort_rte(short);\012ushort __ovld __cnfn convert_ushort_sat_rte(short);\012usho",
"rt __ovld __cnfn convert_ushort_rtz(short);\012ushort __ovld __cnfn convert_ushort_sat_rtz(short);\012ushort __ovld __cnfn convert_ushort_rtp(short);\012ushort __ovld __cnfn convert_ushort_sat_rtp(short);\012ushort __ovld __cnfn convert_ushort_rtn(short);\012ushort __ovld __cnfn convert_ushort_sat_rtn(short);\012ushort __ovld __cnfn convert_ushort(short);\012ushort __ovld __cnfn convert_ushort_sat(short);\012ushort __ovld __cnfn convert_ushort_rte(ushort);\012ushort __ovld __cnfn convert_ushort_sat_rte(ushort);\012ushort __ovld __cnfn convert_ushort_rtz(ushort);\012ushort __ovld __cnfn convert_ushort_sat_rtz(ushort);\012ushort __ovld __cnfn convert_ushort_rtp(ushort);\012ushort __ovld __cnfn convert_ushort_sat_rtp(ushort);\012ushort __ovld __cnfn convert_ushort_rtn(ushort);\012ushort __ovld __cnfn convert_ushort_sat_rtn(ushort);\012ushort __ovld __cnfn convert_ushort(ushort);\012ushort __ovld __cnfn convert_ushort_sat(ushort);\012ushort __ovld __cnfn convert_ushort_rte(int);\012ushort __ovld __cnfn convert_ushort_sat_rte(int);\012ushort __ovld __cnfn convert_ushort_rt",
"z(int);\012ushort __ovld __cnfn convert_ushort_sat_rtz(int);\012ushort __ovld __cnfn convert_ushort_rtp(int);\012ushort __ovld __cnfn convert_ushort_sat_rtp(int);\012ushort __ovld __cnfn convert_ushort_rtn(int);\012ushort __ovld __cnfn convert_ushort_sat_rtn(int);\012ushort __ovld __cnfn convert_ushort(int);\012ushort __ovld __cnfn convert_ushort_sat(int);\012ushort __ovld __cnfn convert_ushort_rte(uint);\012ushort __ovld __cnfn convert_ushort_sat_rte(uint);\012ushort __ovld __cnfn convert_ushort_rtz(uint);\012ushort __ovld __cnfn convert_ushort_sat_rtz(uint);\012ushort __ovld __cnfn convert_ushort_rtp(uint);\012ushort __ovld __cnfn convert_ushort_sat_rtp(uint);\012ushort __ovld __cnfn convert_ushort_rtn(uint);\012ushort __ovld __cnfn convert_ushort_sat_rtn(uint);\012ushort __ovld __cnfn convert_ushort(uint);\012ushort __ovld __cnfn convert_ushort_sat(uint);\012ushort __ovld __cnfn convert_ushort_rte(long);\012ushort __ovld __cnfn convert_ushort_sat_rte(long);\012ushort __ovld __cnfn convert_ushort_rtz(long);\012ushort __ovld __cnfn convert_ushort_sat_rtz(long);\012ushort _",
"_ovld __cnfn convert_ushort_rtp(long);\012ushort __ovld __cnfn convert_ushort_sat_rtp(long);\012ushort __ovld __cnfn convert_ushort_rtn(long);\012ushort __ovld __cnfn convert_ushort_sat_rtn(long);\012ushort __ovld __cnfn convert_ushort(long);\012ushort __ovld __cnfn convert_ushort_sat(long);\012ushort __ovld __cnfn convert_ushort_rte(ulong);\012ushort __ovld __cnfn convert_ushort_sat_rte(ulong);\012ushort __ovld __cnfn convert_ushort_rtz(ulong);\012ushort __ovld __cnfn convert_ushort_sat_rtz(ulong);\012ushort __ovld __cnfn convert_ushort_rtp(ulong);\012ushort __ovld __cnfn convert_ushort_sat_rtp(ulong);\012ushort __ovld __cnfn convert_ushort_rtn(ulong);\012ushort __ovld __cnfn convert_ushort_sat_rtn(ulong);\012ushort __ovld __cnfn convert_ushort(ulong);\012ushort __ovld __cnfn convert_ushort_sat(ulong);\012ushort __ovld __cnfn convert_ushort_rte(float);\012ushort __ovld __cnfn convert_ushort_sat_rte(float);\012ushort __ovld __cnfn convert_ushort_rtz(float);\012ushort __ovld __cnfn convert_ushort_sat_rtz(float);\012ushort __ovld __cnfn convert_ushort_rtp(float);\012ushort",
" __ovld __cnfn convert_ushort_sat_rtp(float);\012ushort __ovld __cnfn convert_ushort_rtn(float);\012ushort __ovld __cnfn convert_ushort_sat_rtn(float);\012ushort __ovld __cnfn convert_ushort(float);\012ushort __ovld __cnfn convert_ushort_sat(float);\012int __ovld __cnfn convert_int_rte(char);\012int __ovld __cnfn convert_int_sat_rte(char);\012int __ovld __cnfn convert_int_rtz(char);\012int __ovld __cnfn convert_int_sat_rtz(char);\012int __ovld __cnfn convert_int_rtp(char);\012int __ovld __cnfn convert_int_sat_rtp(char);\012int __ovld __cnfn convert_int_rtn(char);\012int __ovld __cnfn convert_int_sat_rtn(char);\012int __ovld __cnfn convert_int(char);\012int __ovld __cnfn convert_int_sat(char);\012int __ovld __cnfn convert_int_rte(uchar);\012int __ovld __cnfn convert_int_sat_rte(uchar);\012int __ovld __cnfn convert_int_rtz(uchar);\012int __ovld __cnfn convert_int_sat_rtz(uchar);\012int __ovld __cnfn convert_int_rtp(uchar);\012int __ovld __cnfn convert_int_sat_rtp(uchar);\012int __ovld __cnfn convert_int_rtn(uchar);\012int __ovld __cnfn convert_int_sat_rtn(uchar);\012int __ovld _",
"_cnfn convert_int(uchar);\012int __ovld __cnfn convert_int_sat(uchar);\012int __ovld __cnfn convert_int_rte(short);\012int __ovld __cnfn convert_int_sat_rte(short);\012int __ovld __cnfn convert_int_rtz(short);\012int __ovld __cnfn convert_int_sat_rtz(short);\012int __ovld __cnfn convert_int_rtp(short);\012int __ovld __cnfn convert_int_sat_rtp(short);\012int __ovld __cnfn convert_int_rtn(short);\012int __ovld __cnfn convert_int_sat_rtn(short);\012int __ovld __cnfn convert_int(short);\012int __ovld __cnfn convert_int_sat(short);\012int __ovld __cnfn convert_int_rte(ushort);\012int __ovld __cnfn convert_int_sat_rte(ushort);\012int __ovld __cnfn convert_int_rtz(ushort);\012int __ovld __cnfn convert_int_sat_rtz(ushort);\012int __ovld __cnfn convert_int_rtp(ushort);\012int __ovld __cnfn convert_int_sat_rtp(ushort);\012int __ovld __cnfn convert_int_rtn(ushort);\012int __ovld __cnfn convert_int_sat_rtn(ushort);\012int __ovld __cnfn convert_int(ushort);\012int __ovld __cnfn convert_int_sat(ushort);\012int __ovld __cnfn convert_int_rte(int);\012int __ovld __cnfn convert_int_sat_rte(int)",
";\012int __ovld __cnfn convert_int_rtz(int);\012int __ovld __cnfn convert_int_sat_rtz(int);\012int __ovld __cnfn convert_int_rtp(int);\012int __ovld __cnfn convert_int_sat_rtp(int);\012int __ovld __cnfn convert_int_rtn(int);\012int __ovld __cnfn convert_int_sat_rtn(int);\012int __ovld __cnfn convert_int(int);\012int __ovld __cnfn convert_int_sat(int);\012int __ovld __cnfn convert_int_rte(uint);\012int __ovld __cnfn convert_int_sat_rte(uint);\012int __ovld __cnfn convert_int_rtz(uint);\012int __ovld __cnfn convert_int_sat_rtz(uint);\012int __ovld __cnfn convert_int_rtp(uint);\012int __ovld __cnfn convert_int_sat_rtp(uint);\012int __ovld __cnfn convert_int_rtn(uint);\012int __ovld __cnfn convert_int_sat_rtn(uint);\012int __ovld __cnfn convert_int(uint);\012int __ovld __cnfn convert_int_sat(uint);\012int __ovld __cnfn convert_int_rte(long);\012int __ovld __cnfn convert_int_sat_rte(long);\012int __ovld __cnfn convert_int_rtz(long);\012int __ovld __cnfn convert_int_sat_rtz(long);\012int __ovld __cnfn convert_int_rtp(long);\012int __ovld __cnfn convert_int_sat_rtp(long);\012int __ovld __c",
"nfn convert_int_rtn(long);\012int __ovld __cnfn convert_int_sat_rtn(long);\012int __ovld __cnfn convert_int(long);\012int __ovld __cnfn convert_int_sat(long);\012int __ovld __cnfn convert_int_rte(ulong);\012int __ovld __cnfn convert_int_sat_rte(ulong);\012int __ovld __cnfn convert_int_rtz(ulong);\012int __ovld __cnfn convert_int_sat_rtz(ulong);\012int __ovld __cnfn convert_int_rtp(ulong);\012int __ovld __cnfn convert_int_sat_rtp(ulong);\012int __ovld __cnfn convert_int_rtn(ulong);\012int __ovld __cnfn convert_int_sat_rtn(ulong);\012int __ovld __cnfn convert_int(ulong);\012int __ovld __cnfn convert_int_sat(ulong);\012int __ovld __cnfn convert_int_rte(float);\012int __ovld __cnfn convert_int_sat_rte(float);\012int __ovld __cnfn convert_int_rtz(float);\012int __ovld __cnfn convert_int_sat_rtz(float);\012int __ovld __cnfn convert_int_rtp(float);\012int __ovld __cnfn convert_int_sat_rtp(float);\012int __ovld __cnfn convert_int_rtn(float);\012int __ovld __cnfn convert_int_sat_rtn(float);\012int __ovld __cnfn convert_int(float);\012int __ovld __cnfn convert_int_sat(float);\012uint __ovl",
"d __cnfn convert_uint_rte(char);\012uint __ovld __cnfn convert_uint_sat_rte(char);\012uint __ovld __cnfn convert_uint_rtz(char);\012uint __ovld __cnfn convert_uint_sat_rtz(char);\012uint __ovld __cnfn convert_uint_rtp(char);\012uint __ovld __cnfn convert_uint_sat_rtp(char);\012uint __ovld __cnfn convert_uint_rtn(char);\012uint __ovld __cnfn convert_uint_sat_rtn(char);\012uint __ovld __cnfn convert_uint(char);\012uint __ovld __cnfn convert_uint_sat(char);\012uint __ovld __cnfn convert_uint_rte(uchar);\012uint __ovld __cnfn convert_uint_sat_rte(uchar);\012uint __ovld __cnfn convert_uint_rtz(uchar);\012uint __ovld __cnfn convert_uint_sat_rtz(uchar);\012uint __ovld __cnfn convert_uint_rtp(uchar);\012uint __ovld __cnfn convert_uint_sat_rtp(uchar);\012uint __ovld __cnfn convert_uint_rtn(uchar);\012uint __ovld __cnfn convert_uint_sat_rtn(uchar);\012uint __ovld __cnfn convert_uint(uchar);\012uint __ovld __cnfn convert_uint_sat(uchar);\012uint __ovld __cnfn convert_uint_rte(short);\012uint __ovld __cnfn convert_uint_sat_rte(short);\012uint __ovld __cnfn convert_uint_rtz(short);\012uint",
" __ovld __cnfn convert_uint_sat_rtz(short);\012uint __ovld __cnfn convert_uint_rtp(short);\012uint __ovld __cnfn convert_uint_sat_rtp(short);\012uint __ovld __cnfn convert_uint_rtn(short);\012uint __ovld __cnfn convert_uint_sat_rtn(short);\012uint __ovld __cnfn convert_uint(short);\012uint __ovld __cnfn convert_uint_sat(short);\012uint __ovld __cnfn convert_uint_rte(ushort);\012uint __ovld __cnfn convert_uint_sat_rte(ushort);\012uint __ovld __cnfn convert_uint_rtz(ushort);\012uint __ovld __cnfn convert_uint_sat_rtz(ushort);\012uint __ovld __cnfn convert_uint_rtp(ushort);\012uint __ovld __cnfn convert_uint_sat_rtp(ushort);\012uint __ovld __cnfn convert_uint_rtn(ushort);\012uint __ovld __cnfn convert_uint_sat_rtn(ushort);\012uint __ovld __cnfn convert_uint(ushort);\012uint __ovld __cnfn convert_uint_sat(ushort);\012uint __ovld __cnfn convert_uint_rte(int);\012uint __ovld __cnfn convert_uint_sat_rte(int);\012uint __ovld __cnfn convert_uint_rtz(int);\012uint __ovld __cnfn convert_uint_sat_rtz(int);\012uint __ovld __cnfn convert_uint_rtp(int);\012uint __ovld __cnfn convert_uint_",
"sat_rtp(int);\012uint __ovld __cnfn convert_uint_rtn(int);\012uint __ovld __cnfn convert_uint_sat_rtn(int);\012uint __ovld __cnfn convert_uint(int);\012uint __ovld __cnfn convert_uint_sat(int);\012uint __ovld __cnfn convert_uint_rte(uint);\012uint __ovld __cnfn convert_uint_sat_rte(uint);\012uint __ovld __cnfn convert_uint_rtz(uint);\012uint __ovld __cnfn convert_uint_sat_rtz(uint);\012uint __ovld __cnfn convert_uint_rtp(uint);\012uint __ovld __cnfn convert_uint_sat_rtp(uint);\012uint __ovld __cnfn convert_uint_rtn(uint);\012uint __ovld __cnfn convert_uint_sat_rtn(uint);\012uint __ovld __cnfn convert_uint(uint);\012uint __ovld __cnfn convert_uint_sat(uint);\012uint __ovld __cnfn convert_uint_rte(long);\012uint __ovld __cnfn convert_uint_sat_rte(long);\012uint __ovld __cnfn convert_uint_rtz(long);\012uint __ovld __cnfn convert_uint_sat_rtz(long);\012uint __ovld __cnfn convert_uint_rtp(long);\012uint __ovld __cnfn convert_uint_sat_rtp(long);\012uint __ovld __cnfn convert_uint_rtn(long);\012uint __ovld __cnfn convert_uint_sat_rtn(long);\012uint __ovld __cnfn convert_uint(long);\012u",
"int __ovld __cnfn convert_uint_sat(long);\012uint __ovld __cnfn convert_uint_rte(ulong);\012uint __ovld __cnfn convert_uint_sat_rte(ulong);\012uint __ovld __cnfn convert_uint_rtz(ulong);\012uint __ovld __cnfn convert_uint_sat_rtz(ulong);\012uint __ovld __cnfn convert_uint_rtp(ulong);\012uint __ovld __cnfn convert_uint_sat_rtp(ulong);\012uint __ovld __cnfn convert_uint_rtn(ulong);\012uint __ovld __cnfn convert_uint_sat_rtn(ulong);\012uint __ovld __cnfn convert_uint(ulong);\012uint __ovld __cnfn convert_uint_sat(ulong);\012uint __ovld __cnfn convert_uint_rte(float);\012uint __ovld __cnfn convert_uint_sat_rte(float);\012uint __ovld __cnfn convert_uint_rtz(float);\012uint __ovld __cnfn convert_uint_sat_rtz(float);\012uint __ovld __cnfn convert_uint_rtp(float);\012uint __ovld __cnfn convert_uint_sat_rtp(float);\012uint __ovld __cnfn convert_uint_rtn(float);\012uint __ovld __cnfn convert_uint_sat_rtn(float);\012uint __ovld __cnfn convert_uint(float);\012uint __ovld __cnfn convert_uint_sat(float);\012long __ovld __cnfn convert_long_rte(char);\012long __ovld __cnfn convert_long_sat",
"_rte(char);\012long __ovld __cnfn convert_long_rtz(char);\012long __ovld __cnfn convert_long_sat_rtz(char);\012long __ovld __cnfn convert_long_rtp(char);\012long __ovld __cnfn convert_long_sat_rtp(char);\012long __ovld __cnfn convert_long_rtn(char);\012long __ovld __cnfn convert_long_sat_rtn(char);\012long __ovld __cnfn convert_long(char);\012long __ovld __cnfn convert_long_sat(char);\012long __ovld __cnfn convert_long_rte(uchar);\012long __ovld __cnfn convert_long_sat_rte(uchar);\012long __ovld __cnfn convert_long_rtz(uchar);\012long __ovld __cnfn convert_long_sat_rtz(uchar);\012long __ovld __cnfn convert_long_rtp(uchar);\012long __ovld __cnfn convert_long_sat_rtp(uchar);\012long __ovld __cnfn convert_long_rtn(uchar);\012long __ovld __cnfn convert_long_sat_rtn(uchar);\012long __ovld __cnfn convert_long(uchar);\012long __ovld __cnfn convert_long_sat(uchar);\012long __ovld __cnfn convert_long_rte(short);\012long __ovld __cnfn convert_long_sat_rte(short);\012long __ovld __cnfn convert_long_rtz(short);\012long __ovld __cnfn convert_long_sat_rtz(short);\012long __ovld __cnfn conve",
"rt_long_rtp(short);\012long __ovld __cnfn convert_long_sat_rtp(short);\012long __ovld __cnfn convert_long_rtn(short);\012long __ovld __cnfn convert_long_sat_rtn(short);\012long __ovld __cnfn convert_long(short);\012long __ovld __cnfn convert_long_sat(short);\012long __ovld __cnfn convert_long_rte(ushort);\012long __ovld __cnfn convert_long_sat_rte(ushort);\012long __ovld __cnfn convert_long_rtz(ushort);\012long __ovld __cnfn convert_long_sat_rtz(ushort);\012long __ovld __cnfn convert_long_rtp(ushort);\012long __ovld __cnfn convert_long_sat_rtp(ushort);\012long __ovld __cnfn convert_long_rtn(ushort);\012long __ovld __cnfn convert_long_sat_rtn(ushort);\012long __ovld __cnfn convert_long(ushort);\012long __ovld __cnfn convert_long_sat(ushort);\012long __ovld __cnfn convert_long_rte(int);\012long __ovld __cnfn convert_long_sat_rte(int);\012long __ovld __cnfn convert_long_rtz(int);\012long __ovld __cnfn convert_long_sat_rtz(int);\012long __ovld __cnfn convert_long_rtp(int);\012long __ovld __cnfn convert_long_sat_rtp(int);\012long __ovld __cnfn convert_long_rtn(int);\012long __ovld ",
"__cnfn convert_long_sat_rtn(int);\012long __ovld __cnfn convert_long(int);\012long __ovld __cnfn convert_long_sat(int);\012long __ovld __cnfn convert_long_rte(uint);\012long __ovld __cnfn convert_long_sat_rte(uint);\012long __ovld __cnfn convert_long_rtz(uint);\012long __ovld __cnfn convert_long_sat_rtz(uint);\012long __ovld __cnfn convert_long_rtp(uint);\012long __ovld __cnfn convert_long_sat_rtp(uint);\012long __ovld __cnfn convert_long_rtn(uint);\012long __ovld __cnfn convert_long_sat_rtn(uint);\012long __ovld __cnfn convert_long(uint);\012long __ovld __cnfn convert_long_sat(uint);\012long __ovld __cnfn convert_long_rte(long);\012long __ovld __cnfn convert_long_sat_rte(long);\012long __ovld __cnfn convert_long_rtz(long);\012long __ovld __cnfn convert_long_sat_rtz(long);\012long __ovld __cnfn convert_long_rtp(long);\012long __ovld __cnfn convert_long_sat_rtp(long);\012long __ovld __cnfn convert_long_rtn(long);\012long __ovld __cnfn convert_long_sat_rtn(long);\012long __ovld __cnfn convert_long(long);\012long __ovld __cnfn convert_long_sat(long);\012long __ovld __cnfn convert",
"_long_rte(ulong);\012long __ovld __cnfn convert_long_sat_rte(ulong);\012long __ovld __cnfn convert_long_rtz(ulong);\012long __ovld __cnfn convert_long_sat_rtz(ulong);\012long __ovld __cnfn convert_long_rtp(ulong);\012long __ovld __cnfn convert_long_sat_rtp(ulong);\012long __ovld __cnfn convert_long_rtn(ulong);\012long __ovld __cnfn convert_long_sat_rtn(ulong);\012long __ovld __cnfn convert_long(ulong);\012long __ovld __cnfn convert_long_sat(ulong);\012long __ovld __cnfn convert_long_rte(float);\012long __ovld __cnfn convert_long_sat_rte(float);\012long __ovld __cnfn convert_long_rtz(float);\012long __ovld __cnfn convert_long_sat_rtz(float);\012long __ovld __cnfn convert_long_rtp(float);\012long __ovld __cnfn convert_long_sat_rtp(float);\012long __ovld __cnfn convert_long_rtn(float);\012long __ovld __cnfn convert_long_sat_rtn(float);\012long __ovld __cnfn convert_long(float);\012long __ovld __cnfn convert_long_sat(float);\012ulong __ovld __cnfn convert_ulong_rte(char);\012ulong __ovld __cnfn convert_ulong_sat_rte(char);\012ulong __ovld __cnfn convert_ulong_rtz(char);\012ulong _",
"_ovld __cnfn convert_ulong_sat_rtz(char);\012ulong __ovld __cnfn convert_ulong_rtp(char);\012ulong __ovld __cnfn convert_ulong_sat_rtp(char);\012ulong __ovld __cnfn convert_ulong_rtn(char);\012ulong __ovld __cnfn convert_ulong_sat_rtn(char);\012ulong __ovld __cnfn convert_ulong(char);\012ulong __ovld __cnfn convert_ulong_sat(char);\012ulong __ovld __cnfn convert_ulong_rte(uchar);\012ulong __ovld __cnfn convert_ulong_sat_rte(uchar);\012ulong __ovld __cnfn convert_ulong_rtz(uchar);\012ulong __ovld __cnfn convert_ulong_sat_rtz(uchar);\012ulong __ovld __cnfn convert_ulong_rtp(uchar);\012ulong __ovld __cnfn convert_ulong_sat_rtp(uchar);\012ulong __ovld __cnfn convert_ulong_rtn(uchar);\012ulong __ovld __cnfn convert_ulong_sat_rtn(uchar);\012ulong __ovld __cnfn convert_ulong(uchar);\012ulong __ovld __cnfn convert_ulong_sat(uchar);\012ulong __ovld __cnfn convert_ulong_rte(short);\012ulong __ovld __cnfn convert_ulong_sat_rte(short);\012ulong __ovld __cnfn convert_ulong_rtz(short);\012ulong __ovld __cnfn convert_ulong_sat_rtz(short);\012ulong __ovld __cnfn convert_ulong_rtp(short)",
";\012ulong __ovld __cnfn convert_ulong_sat_rtp(short);\012ulong __ovld __cnfn convert_ulong_rtn(short);\012ulong __ovld __cnfn convert_ulong_sat_rtn(short);\012ulong __ovld __cnfn convert_ulong(short);\012ulong __ovld __cnfn convert_ulong_sat(short);\012ulong __ovld __cnfn convert_ulong_rte(ushort);\012ulong __ovld __cnfn convert_ulong_sat_rte(ushort);\012ulong __ovld __cnfn convert_ulong_rtz(ushort);\012ulong __ovld __cnfn convert_ulong_sat_rtz(ushort);\012ulong __ovld __cnfn convert_ulong_rtp(ushort);\012ulong __ovld __cnfn convert_ulong_sat_rtp(ushort);\012ulong __ovld __cnfn convert_ulong_rtn(ushort);\012ulong __ovld __cnfn convert_ulong_sat_rtn(ushort);\012ulong __ovld __cnfn convert_ulong(ushort);\012ulong __ovld __cnfn convert_ulong_sat(ushort);\012ulong __ovld __cnfn convert_ulong_rte(int);\012ulong __ovld __cnfn convert_ulong_sat_rte(int);\012ulong __ovld __cnfn convert_ulong_rtz(int);\012ulong __ovld __cnfn convert_ulong_sat_rtz(int);\012ulong __ovld __cnfn convert_ulong_rtp(int);\012ulong __ovld __cnfn convert_ulong_sat_rtp(int);\012ulong __ovld __cnfn convert_ul",
"ong_rtn(int);\012ulong __ovld __cnfn convert_ulong_sat_rtn(int);\012ulong __ovld __cnfn convert_ulong(int);\012ulong __ovld __cnfn convert_ulong_sat(int);\012ulong __ovld __cnfn convert_ulong_rte(uint);\012ulong __ovld __cnfn convert_ulong_sat_rte(uint);\012ulong __ovld __cnfn convert_ulong_rtz(uint);\012ulong __ovld __cnfn convert_ulong_sat_rtz(uint);\012ulong __ovld __cnfn convert_ulong_rtp(uint);\012ulong __ovld __cnfn convert_ulong_sat_rtp(uint);\012ulong __ovld __cnfn convert_ulong_rtn(uint);\012ulong __ovld __cnfn convert_ulong_sat_rtn(uint);\012ulong __ovld __cnfn convert_ulong(uint);\012ulong __ovld __cnfn convert_ulong_sat(uint);\012ulong __ovld __cnfn convert_ulong_rte(long);\012ulong __ovld __cnfn convert_ulong_sat_rte(long);\012ulong __ovld __cnfn convert_ulong_rtz(long);\012ulong __ovld __cnfn convert_ulong_sat_rtz(long);\012ulong __ovld __cnfn convert_ulong_rtp(long);\012ulong __ovld __cnfn convert_ulong_sat_rtp(long);\012ulong __ovld __cnfn convert_ulong_rtn(long);\012ulong __ovld __cnfn convert_ulong_sat_rtn(long);\012ulong __ovld __cnfn convert_ulong(long);",
"\012ulong __ovld __cnfn convert_ulong_sat(long);\012ulong __ovld __cnfn convert_ulong_rte(ulong);\012ulong __ovld __cnfn convert_ulong_sat_rte(ulong);\012ulong __ovld __cnfn convert_ulong_rtz(ulong);\012ulong __ovld __cnfn convert_ulong_sat_rtz(ulong);\012ulong __ovld __cnfn convert_ulong_rtp(ulong);\012ulong __ovld __cnfn convert_ulong_sat_rtp(ulong);\012ulong __ovld __cnfn convert_ulong_rtn(ulong);\012ulong __ovld __cnfn convert_ulong_sat_rtn(ulong);\012ulong __ovld __cnfn convert_ulong(ulong);\012ulong __ovld __cnfn convert_ulong_sat(ulong);\012ulong __ovld __cnfn convert_ulong_rte(float);\012ulong __ovld __cnfn convert_ulong_sat_rte(float);\012ulong __ovld __cnfn convert_ulong_rtz(float);\012ulong __ovld __cnfn convert_ulong_sat_rtz(float);\012ulong __ovld __cnfn convert_ulong_rtp(float);\012ulong __ovld __cnfn convert_ulong_sat_rtp(float);\012ulong __ovld __cnfn convert_ulong_rtn(float);\012ulong __ovld __cnfn convert_ulong_sat_rtn(float);\012ulong __ovld __cnfn convert_ulong(float);\012ulong __ovld __cnfn convert_ulong_sat(float);\012float __ovld __cnfn convert_float_",
"rte(char);\012float __ovld __cnfn convert_float_rtz(char);\012float __ovld __cnfn convert_float_rtp(char);\012float __ovld __cnfn convert_float_rtn(char);\012float __ovld __cnfn convert_float(char);\012float __ovld __cnfn convert_float_rte(uchar);\012float __ovld __cnfn convert_float_rtz(uchar);\012float __ovld __cnfn convert_float_rtp(uchar);\012float __ovld __cnfn convert_float_rtn(uchar);\012float __ovld __cnfn convert_float(uchar);\012float __ovld __cnfn convert_float_rte(short);\012float __ovld __cnfn convert_float_rtz(short);\012float __ovld __cnfn convert_float_rtp(short);\012float __ovld __cnfn convert_float_rtn(short);\012float __ovld __cnfn convert_float(short);\012float __ovld __cnfn convert_float_rte(ushort);\012float __ovld __cnfn convert_float_rtz(ushort);\012float __ovld __cnfn convert_float_rtp(ushort);\012float __ovld __cnfn convert_float_rtn(ushort);\012float __ovld __cnfn convert_float(ushort);\012float __ovld __cnfn convert_float_rte(int);\012float __ovld __cnfn convert_float_rtz(int);\012float __ovld __cnfn convert_float_rtp(int);\012float __ovld __cnfn co",
"nvert_float_rtn(int);\012float __ovld __cnfn convert_float(int);\012float __ovld __cnfn convert_float_rte(uint);\012float __ovld __cnfn convert_float_rtz(uint);\012float __ovld __cnfn convert_float_rtp(uint);\012float __ovld __cnfn convert_float_rtn(uint);\012float __ovld __cnfn convert_float(uint);\012float __ovld __cnfn convert_float_rte(long);\012float __ovld __cnfn convert_float_rtz(long);\012float __ovld __cnfn convert_float_rtp(long);\012float __ovld __cnfn convert_float_rtn(long);\012float __ovld __cnfn convert_float(long);\012float __ovld __cnfn convert_float_rte(ulong);\012float __ovld __cnfn convert_float_rtz(ulong);\012float __ovld __cnfn convert_float_rtp(ulong);\012float __ovld __cnfn convert_float_rtn(ulong);\012float __ovld __cnfn convert_float(ulong);\012float __ovld __cnfn convert_float_rte(float);\012float __ovld __cnfn convert_float_rtz(float);\012float __ovld __cnfn convert_float_rtp(float);\012float __ovld __cnfn convert_float_rtn(float);\012float __ovld __cnfn convert_float(float);\012char2 __ovld __cnfn convert_char2_rte(char2);\012char2 __ovld __cnfn co",
"nvert_char2_sat_rte(char2);\012char2 __ovld __cnfn convert_char2_rtz(char2);\012char2 __ovld __cnfn convert_char2_sat_rtz(char2);\012char2 __ovld __cnfn convert_char2_rtp(char2);\012char2 __ovld __cnfn convert_char2_sat_rtp(char2);\012char2 __ovld __cnfn convert_char2_rtn(char2);\012char2 __ovld __cnfn convert_char2_sat_rtn(char2);\012char2 __ovld __cnfn convert_char2(char2);\012char2 __ovld __cnfn convert_char2_sat(char2);\012char2 __ovld __cnfn convert_char2_rte(uchar2);\012char2 __ovld __cnfn convert_char2_sat_rte(uchar2);\012char2 __ovld __cnfn convert_char2_rtz(uchar2);\012char2 __ovld __cnfn convert_char2_sat_rtz(uchar2);\012char2 __ovld __cnfn convert_char2_rtp(uchar2);\012char2 __ovld __cnfn convert_char2_sat_rtp(uchar2);\012char2 __ovld __cnfn convert_char2_rtn(uchar2);\012char2 __ovld __cnfn convert_char2_sat_rtn(uchar2);\012char2 __ovld __cnfn convert_char2(uchar2);\012char2 __ovld __cnfn convert_char2_sat(uchar2);\012char2 __ovld __cnfn convert_char2_rte(short2);\012char2 __ovld __cnfn convert_char2_sat_rte(short2);\012char2 __ovld __cnfn convert_char2_rtz(sh",
"ort2);\012char2 __ovld __cnfn convert_char2_sat_rtz(short2);\012char2 __ovld __cnfn convert_char2_rtp(short2);\012char2 __ovld __cnfn convert_char2_sat_rtp(short2);\012char2 __ovld __cnfn convert_char2_rtn(short2);\012char2 __ovld __cnfn convert_char2_sat_rtn(short2);\012char2 __ovld __cnfn convert_char2(short2);\012char2 __ovld __cnfn convert_char2_sat(short2);\012char2 __ovld __cnfn convert_char2_rte(ushort2);\012char2 __ovld __cnfn convert_char2_sat_rte(ushort2);\012char2 __ovld __cnfn convert_char2_rtz(ushort2);\012char2 __ovld __cnfn convert_char2_sat_rtz(ushort2);\012char2 __ovld __cnfn convert_char2_rtp(ushort2);\012char2 __ovld __cnfn convert_char2_sat_rtp(ushort2);\012char2 __ovld __cnfn convert_char2_rtn(ushort2);\012char2 __ovld __cnfn convert_char2_sat_rtn(ushort2);\012char2 __ovld __cnfn convert_char2(ushort2);\012char2 __ovld __cnfn convert_char2_sat(ushort2);\012char2 __ovld __cnfn convert_char2_rte(int2);\012char2 __ovld __cnfn convert_char2_sat_rte(int2);\012char2 __ovld __cnfn convert_char2_rtz(int2);\012char2 __ovld __cnfn convert_char2_sat_rtz(int2);\012",
"char2 __ovld __cnfn convert_char2_rtp(int2);\012char2 __ovld __cnfn convert_char2_sat_rtp(int2);\012char2 __ovld __cnfn convert_char2_rtn(int2);\012char2 __ovld __cnfn convert_char2_sat_rtn(int2);\012char2 __ovld __cnfn convert_char2(int2);\012char2 __ovld __cnfn convert_char2_sat(int2);\012char2 __ovld __cnfn convert_char2_rte(uint2);\012char2 __ovld __cnfn convert_char2_sat_rte(uint2);\012char2 __ovld __cnfn convert_char2_rtz(uint2);\012char2 __ovld __cnfn convert_char2_sat_rtz(uint2);\012char2 __ovld __cnfn convert_char2_rtp(uint2);\012char2 __ovld __cnfn convert_char2_sat_rtp(uint2);\012char2 __ovld __cnfn convert_char2_rtn(uint2);\012char2 __ovld __cnfn convert_char2_sat_rtn(uint2);\012char2 __ovld __cnfn convert_char2(uint2);\012char2 __ovld __cnfn convert_char2_sat(uint2);\012char2 __ovld __cnfn convert_char2_rte(long2);\012char2 __ovld __cnfn convert_char2_sat_rte(long2);\012char2 __ovld __cnfn convert_char2_rtz(long2);\012char2 __ovld __cnfn convert_char2_sat_rtz(long2);\012char2 __ovld __cnfn convert_char2_rtp(long2);\012char2 __ovld __cnfn convert_char2_sat_rt",
"p(long2);\012char2 __ovld __cnfn convert_char2_rtn(long2);\012char2 __ovld __cnfn convert_char2_sat_rtn(long2);\012char2 __ovld __cnfn convert_char2(long2);\012char2 __ovld __cnfn convert_char2_sat(long2);\012char2 __ovld __cnfn convert_char2_rte(ulong2);\012char2 __ovld __cnfn convert_char2_sat_rte(ulong2);\012char2 __ovld __cnfn convert_char2_rtz(ulong2);\012char2 __ovld __cnfn convert_char2_sat_rtz(ulong2);\012char2 __ovld __cnfn convert_char2_rtp(ulong2);\012char2 __ovld __cnfn convert_char2_sat_rtp(ulong2);\012char2 __ovld __cnfn convert_char2_rtn(ulong2);\012char2 __ovld __cnfn convert_char2_sat_rtn(ulong2);\012char2 __ovld __cnfn convert_char2(ulong2);\012char2 __ovld __cnfn convert_char2_sat(ulong2);\012char2 __ovld __cnfn convert_char2_rte(float2);\012char2 __ovld __cnfn convert_char2_sat_rte(float2);\012char2 __ovld __cnfn convert_char2_rtz(float2);\012char2 __ovld __cnfn convert_char2_sat_rtz(float2);\012char2 __ovld __cnfn convert_char2_rtp(float2);\012char2 __ovld __cnfn convert_char2_sat_rtp(float2);\012char2 __ovld __cnfn convert_char2_rtn(float2);\012char2 _",
"_ovld __cnfn convert_char2_sat_rtn(float2);\012char2 __ovld __cnfn convert_char2(float2);\012char2 __ovld __cnfn convert_char2_sat(float2);\012uchar2 __ovld __cnfn convert_uchar2_rte(char2);\012uchar2 __ovld __cnfn convert_uchar2_sat_rte(char2);\012uchar2 __ovld __cnfn convert_uchar2_rtz(char2);\012uchar2 __ovld __cnfn convert_uchar2_sat_rtz(char2);\012uchar2 __ovld __cnfn convert_uchar2_rtp(char2);\012uchar2 __ovld __cnfn convert_uchar2_sat_rtp(char2);\012uchar2 __ovld __cnfn convert_uchar2_rtn(char2);\012uchar2 __ovld __cnfn convert_uchar2_sat_rtn(char2);\012uchar2 __ovld __cnfn convert_uchar2(char2);\012uchar2 __ovld __cnfn convert_uchar2_sat(char2);\012uchar2 __ovld __cnfn convert_uchar2_rte(uchar2);\012uchar2 __ovld __cnfn convert_uchar2_sat_rte(uchar2);\012uchar2 __ovld __cnfn convert_uchar2_rtz(uchar2);\012uchar2 __ovld __cnfn convert_uchar2_sat_rtz(uchar2);\012uchar2 __ovld __cnfn convert_uchar2_rtp(uchar2);\012uchar2 __ovld __cnfn convert_uchar2_sat_rtp(uchar2);\012uchar2 __ovld __cnfn convert_uchar2_rtn(uchar2);\012uchar2 __ovld __cnfn convert_uchar2_sat_rtn",
"(uchar2);\012uchar2 __ovld __cnfn convert_uchar2(uchar2);\012uchar2 __ovld __cnfn convert_uchar2_sat(uchar2);\012uchar2 __ovld __cnfn convert_uchar2_rte(short2);\012uchar2 __ovld __cnfn convert_uchar2_sat_rte(short2);\012uchar2 __ovld __cnfn convert_uchar2_rtz(short2);\012uchar2 __ovld __cnfn convert_uchar2_sat_rtz(short2);\012uchar2 __ovld __cnfn convert_uchar2_rtp(short2);\012uchar2 __ovld __cnfn convert_uchar2_sat_rtp(short2);\012uchar2 __ovld __cnfn convert_uchar2_rtn(short2);\012uchar2 __ovld __cnfn convert_uchar2_sat_rtn(short2);\012uchar2 __ovld __cnfn convert_uchar2(short2);\012uchar2 __ovld __cnfn convert_uchar2_sat(short2);\012uchar2 __ovld __cnfn convert_uchar2_rte(ushort2);\012uchar2 __ovld __cnfn convert_uchar2_sat_rte(ushort2);\012uchar2 __ovld __cnfn convert_uchar2_rtz(ushort2);\012uchar2 __ovld __cnfn convert_uchar2_sat_rtz(ushort2);\012uchar2 __ovld __cnfn convert_uchar2_rtp(ushort2);\012uchar2 __ovld __cnfn convert_uchar2_sat_rtp(ushort2);\012uchar2 __ovld __cnfn convert_uchar2_rtn(ushort2);\012uchar2 __ovld __cnfn convert_uchar2_sat_rtn(ushort2);\012uc",
"har2 __ovld __cnfn convert_uchar2(ushort2);\012uchar2 __ovld __cnfn convert_uchar2_sat(ushort2);\012uchar2 __ovld __cnfn convert_uchar2_rte(int2);\012uchar2 __ovld __cnfn convert_uchar2_sat_rte(int2);\012uchar2 __ovld __cnfn convert_uchar2_rtz(int2);\012uchar2 __ovld __cnfn convert_uchar2_sat_rtz(int2);\012uchar2 __ovld __cnfn convert_uchar2_rtp(int2);\012uchar2 __ovld __cnfn convert_uchar2_sat_rtp(int2);\012uchar2 __ovld __cnfn convert_uchar2_rtn(int2);\012uchar2 __ovld __cnfn convert_uchar2_sat_rtn(int2);\012uchar2 __ovld __cnfn convert_uchar2(int2);\012uchar2 __ovld __cnfn convert_uchar2_sat(int2);\012uchar2 __ovld __cnfn convert_uchar2_rte(uint2);\012uchar2 __ovld __cnfn convert_uchar2_sat_rte(uint2);\012uchar2 __ovld __cnfn convert_uchar2_rtz(uint2);\012uchar2 __ovld __cnfn convert_uchar2_sat_rtz(uint2);\012uchar2 __ovld __cnfn convert_uchar2_rtp(uint2);\012uchar2 __ovld __cnfn convert_uchar2_sat_rtp(uint2);\012uchar2 __ovld __cnfn convert_uchar2_rtn(uint2);\012uchar2 __ovld __cnfn convert_uchar2_sat_rtn(uint2);\012uchar2 __ovld __cnfn convert_uchar2(uint2);\012ucha",
"r2 __ovld __cnfn convert_uchar2_sat(uint2);\012uchar2 __ovld __cnfn convert_uchar2_rte(long2);\012uchar2 __ovld __cnfn convert_uchar2_sat_rte(long2);\012uchar2 __ovld __cnfn convert_uchar2_rtz(long2);\012uchar2 __ovld __cnfn convert_uchar2_sat_rtz(long2);\012uchar2 __ovld __cnfn convert_uchar2_rtp(long2);\012uchar2 __ovld __cnfn convert_uchar2_sat_rtp(long2);\012uchar2 __ovld __cnfn convert_uchar2_rtn(long2);\012uchar2 __ovld __cnfn convert_uchar2_sat_rtn(long2);\012uchar2 __ovld __cnfn convert_uchar2(long2);\012uchar2 __ovld __cnfn convert_uchar2_sat(long2);\012uchar2 __ovld __cnfn convert_uchar2_rte(ulong2);\012uchar2 __ovld __cnfn convert_uchar2_sat_rte(ulong2);\012uchar2 __ovld __cnfn convert_uchar2_rtz(ulong2);\012uchar2 __ovld __cnfn convert_uchar2_sat_rtz(ulong2);\012uchar2 __ovld __cnfn convert_uchar2_rtp(ulong2);\012uchar2 __ovld __cnfn convert_uchar2_sat_rtp(ulong2);\012uchar2 __ovld __cnfn convert_uchar2_rtn(ulong2);\012uchar2 __ovld __cnfn convert_uchar2_sat_rtn(ulong2);\012uchar2 __ovld __cnfn convert_uchar2(ulong2);\012uchar2 __ovld __cnfn convert_uchar2",
"_sat(ulong2);\012uchar2 __ovld __cnfn convert_uchar2_rte(float2);\012uchar2 __ovld __cnfn convert_uchar2_sat_rte(float2);\012uchar2 __ovld __cnfn convert_uchar2_rtz(float2);\012uchar2 __ovld __cnfn convert_uchar2_sat_rtz(float2);\012uchar2 __ovld __cnfn convert_uchar2_rtp(float2);\012uchar2 __ovld __cnfn convert_uchar2_sat_rtp(float2);\012uchar2 __ovld __cnfn convert_uchar2_rtn(float2);\012uchar2 __ovld __cnfn convert_uchar2_sat_rtn(float2);\012uchar2 __ovld __cnfn convert_uchar2(float2);\012uchar2 __ovld __cnfn convert_uchar2_sat(float2);\012short2 __ovld __cnfn convert_short2_rte(char2);\012short2 __ovld __cnfn convert_short2_sat_rte(char2);\012short2 __ovld __cnfn convert_short2_rtz(char2);\012short2 __ovld __cnfn convert_short2_sat_rtz(char2);\012short2 __ovld __cnfn convert_short2_rtp(char2);\012short2 __ovld __cnfn convert_short2_sat_rtp(char2);\012short2 __ovld __cnfn convert_short2_rtn(char2);\012short2 __ovld __cnfn convert_short2_sat_rtn(char2);\012short2 __ovld __cnfn convert_short2(char2);\012short2 __ovld __cnfn convert_short2_sat(char2);\012short2 __ovld __",
"cnfn convert_short2_rte(uchar2);\012short2 __ovld __cnfn convert_short2_sat_rte(uchar2);\012short2 __ovld __cnfn convert_short2_rtz(uchar2);\012short2 __ovld __cnfn convert_short2_sat_rtz(uchar2);\012short2 __ovld __cnfn convert_short2_rtp(uchar2);\012short2 __ovld __cnfn convert_short2_sat_rtp(uchar2);\012short2 __ovld __cnfn convert_short2_rtn(uchar2);\012short2 __ovld __cnfn convert_short2_sat_rtn(uchar2);\012short2 __ovld __cnfn convert_short2(uchar2);\012short2 __ovld __cnfn convert_short2_sat(uchar2);\012short2 __ovld __cnfn convert_short2_rte(short2);\012short2 __ovld __cnfn convert_short2_sat_rte(short2);\012short2 __ovld __cnfn convert_short2_rtz(short2);\012short2 __ovld __cnfn convert_short2_sat_rtz(short2);\012short2 __ovld __cnfn convert_short2_rtp(short2);\012short2 __ovld __cnfn convert_short2_sat_rtp(short2);\012short2 __ovld __cnfn convert_short2_rtn(short2);\012short2 __ovld __cnfn convert_short2_sat_rtn(short2);\012short2 __ovld __cnfn convert_short2(short2);\012short2 __ovld __cnfn convert_short2_sat(short2);\012short2 __ovld __cnfn convert_short2_",
"rte(ushort2);\012short2 __ovld __cnfn convert_short2_sat_rte(ushort2);\012short2 __ovld __cnfn convert_short2_rtz(ushort2);\012short2 __ovld __cnfn convert_short2_sat_rtz(ushort2);\012short2 __ovld __cnfn convert_short2_rtp(ushort2);\012short2 __ovld __cnfn convert_short2_sat_rtp(ushort2);\012short2 __ovld __cnfn convert_short2_rtn(ushort2);\012short2 __ovld __cnfn convert_short2_sat_rtn(ushort2);\012short2 __ovld __cnfn convert_short2(ushort2);\012short2 __ovld __cnfn convert_short2_sat(ushort2);\012short2 __ovld __cnfn convert_short2_rte(int2);\012short2 __ovld __cnfn convert_short2_sat_rte(int2);\012short2 __ovld __cnfn convert_short2_rtz(int2);\012short2 __ovld __cnfn convert_short2_sat_rtz(int2);\012short2 __ovld __cnfn convert_short2_rtp(int2);\012short2 __ovld __cnfn convert_short2_sat_rtp(int2);\012short2 __ovld __cnfn convert_short2_rtn(int2);\012short2 __ovld __cnfn convert_short2_sat_rtn(int2);\012short2 __ovld __cnfn convert_short2(int2);\012short2 __ovld __cnfn convert_short2_sat(int2);\012short2 __ovld __cnfn convert_short2_rte(uint2);\012short2 __ovld __cn",
"fn convert_short2_sat_rte(uint2);\012short2 __ovld __cnfn convert_short2_rtz(uint2);\012short2 __ovld __cnfn convert_short2_sat_rtz(uint2);\012short2 __ovld __cnfn convert_short2_rtp(uint2);\012short2 __ovld __cnfn convert_short2_sat_rtp(uint2);\012short2 __ovld __cnfn convert_short2_rtn(uint2);\012short2 __ovld __cnfn convert_short2_sat_rtn(uint2);\012short2 __ovld __cnfn convert_short2(uint2);\012short2 __ovld __cnfn convert_short2_sat(uint2);\012short2 __ovld __cnfn convert_short2_rte(long2);\012short2 __ovld __cnfn convert_short2_sat_rte(long2);\012short2 __ovld __cnfn convert_short2_rtz(long2);\012short2 __ovld __cnfn convert_short2_sat_rtz(long2);\012short2 __ovld __cnfn convert_short2_rtp(long2);\012short2 __ovld __cnfn convert_short2_sat_rtp(long2);\012short2 __ovld __cnfn convert_short2_rtn(long2);\012short2 __ovld __cnfn convert_short2_sat_rtn(long2);\012short2 __ovld __cnfn convert_short2(long2);\012short2 __ovld __cnfn convert_short2_sat(long2);\012short2 __ovld __cnfn convert_short2_rte(ulong2);\012short2 __ovld __cnfn convert_short2_sat_rte(ulong2);\012shor",
"t2 __ovld __cnfn convert_short2_rtz(ulong2);\012short2 __ovld __cnfn convert_short2_sat_rtz(ulong2);\012short2 __ovld __cnfn convert_short2_rtp(ulong2);\012short2 __ovld __cnfn convert_short2_sat_rtp(ulong2);\012short2 __ovld __cnfn convert_short2_rtn(ulong2);\012short2 __ovld __cnfn convert_short2_sat_rtn(ulong2);\012short2 __ovld __cnfn convert_short2(ulong2);\012short2 __ovld __cnfn convert_short2_sat(ulong2);\012short2 __ovld __cnfn convert_short2_rte(float2);\012short2 __ovld __cnfn convert_short2_sat_rte(float2);\012short2 __ovld __cnfn convert_short2_rtz(float2);\012short2 __ovld __cnfn convert_short2_sat_rtz(float2);\012short2 __ovld __cnfn convert_short2_rtp(float2);\012short2 __ovld __cnfn convert_short2_sat_rtp(float2);\012short2 __ovld __cnfn convert_short2_rtn(float2);\012short2 __ovld __cnfn convert_short2_sat_rtn(float2);\012short2 __ovld __cnfn convert_short2(float2);\012short2 __ovld __cnfn convert_short2_sat(float2);\012ushort2 __ovld __cnfn convert_ushort2_rte(char2);\012ushort2 __ovld __cnfn convert_ushort2_sat_rte(char2);\012ushort2 __ovld __cnfn ",
"convert_ushort2_rtz(char2);\012ushort2 __ovld __cnfn convert_ushort2_sat_rtz(char2);\012ushort2 __ovld __cnfn convert_ushort2_rtp(char2);\012ushort2 __ovld __cnfn convert_ushort2_sat_rtp(char2);\012ushort2 __ovld __cnfn convert_ushort2_rtn(char2);\012ushort2 __ovld __cnfn convert_ushort2_sat_rtn(char2);\012ushort2 __ovld __cnfn convert_ushort2(char2);\012ushort2 __ovld __cnfn convert_ushort2_sat(char2);\012ushort2 __ovld __cnfn convert_ushort2_rte(uchar2);\012ushort2 __ovld __cnfn convert_ushort2_sat_rte(uchar2);\012ushort2 __ovld __cnfn convert_ushort2_rtz(uchar2);\012ushort2 __ovld __cnfn convert_ushort2_sat_rtz(uchar2);\012ushort2 __ovld __cnfn convert_ushort2_rtp(uchar2);\012ushort2 __ovld __cnfn convert_ushort2_sat_rtp(uchar2);\012ushort2 __ovld __cnfn convert_ushort2_rtn(uchar2);\012ushort2 __ovld __cnfn convert_ushort2_sat_rtn(uchar2);\012ushort2 __ovld __cnfn convert_ushort2(uchar2);\012ushort2 __ovld __cnfn convert_ushort2_sat(uchar2);\012ushort2 __ovld __cnfn convert_ushort2_rte(short2);\012ushort2 __ovld __cnfn convert_ushort2_sat_rte(short2);\012ushort2 __",
"ovld __cnfn convert_ushort2_rtz(short2);\012ushort2 __ovld __cnfn convert_ushort2_sat_rtz(short2);\012ushort2 __ovld __cnfn convert_ushort2_rtp(short2);\012ushort2 __ovld __cnfn convert_ushort2_sat_rtp(short2);\012ushort2 __ovld __cnfn convert_ushort2_rtn(short2);\012ushort2 __ovld __cnfn convert_ushort2_sat_rtn(short2);\012ushort2 __ovld __cnfn convert_ushort2(short2);\012ushort2 __ovld __cnfn convert_ushort2_sat(short2);\012ushort2 __ovld __cnfn convert_ushort2_rte(ushort2);\012ushort2 __ovld __cnfn convert_ushort2_sat_rte(ushort2);\012ushort2 __ovld __cnfn convert_ushort2_rtz(ushort2);\012ushort2 __ovld __cnfn convert_ushort2_sat_rtz(ushort2);\012ushort2 __ovld __cnfn convert_ushort2_rtp(ushort2);\012ushort2 __ovld __cnfn convert_ushort2_sat_rtp(ushort2);\012ushort2 __ovld __cnfn convert_ushort2_rtn(ushort2);\012ushort2 __ovld __cnfn convert_ushort2_sat_rtn(ushort2);\012ushort2 __ovld __cnfn convert_ushort2(ushort2);\012ushort2 __ovld __cnfn convert_ushort2_sat(ushort2);\012ushort2 __ovld __cnfn convert_ushort2_rte(int2);\012ushort2 __ovld __cnfn convert_ushort2",
"_sat_rte(int2);\012ushort2 __ovld __cnfn convert_ushort2_rtz(int2);\012ushort2 __ovld __cnfn convert_ushort2_sat_rtz(int2);\012ushort2 __ovld __cnfn convert_ushort2_rtp(int2);\012ushort2 __ovld __cnfn convert_ushort2_sat_rtp(int2);\012ushort2 __ovld __cnfn convert_ushort2_rtn(int2);\012ushort2 __ovld __cnfn convert_ushort2_sat_rtn(int2);\012ushort2 __ovld __cnfn convert_ushort2(int2);\012ushort2 __ovld __cnfn convert_ushort2_sat(int2);\012ushort2 __ovld __cnfn convert_ushort2_rte(uint2);\012ushort2 __ovld __cnfn convert_ushort2_sat_rte(uint2);\012ushort2 __ovld __cnfn convert_ushort2_rtz(uint2);\012ushort2 __ovld __cnfn convert_ushort2_sat_rtz(uint2);\012ushort2 __ovld __cnfn convert_ushort2_rtp(uint2);\012ushort2 __ovld __cnfn convert_ushort2_sat_rtp(uint2);\012ushort2 __ovld __cnfn convert_ushort2_rtn(uint2);\012ushort2 __ovld __cnfn convert_ushort2_sat_rtn(uint2);\012ushort2 __ovld __cnfn convert_ushort2(uint2);\012ushort2 __ovld __cnfn convert_ushort2_sat(uint2);\012ushort2 __ovld __cnfn convert_ushort2_rte(long2);\012ushort2 __ovld __cnfn convert_ushort2_sat_rte(",
"long2);\012ushort2 __ovld __cnfn convert_ushort2_rtz(long2);\012ushort2 __ovld __cnfn convert_ushort2_sat_rtz(long2);\012ushort2 __ovld __cnfn convert_ushort2_rtp(long2);\012ushort2 __ovld __cnfn convert_ushort2_sat_rtp(long2);\012ushort2 __ovld __cnfn convert_ushort2_rtn(long2);\012ushort2 __ovld __cnfn convert_ushort2_sat_rtn(long2);\012ushort2 __ovld __cnfn convert_ushort2(long2);\012ushort2 __ovld __cnfn convert_ushort2_sat(long2);\012ushort2 __ovld __cnfn convert_ushort2_rte(ulong2);\012ushort2 __ovld __cnfn convert_ushort2_sat_rte(ulong2);\012ushort2 __ovld __cnfn convert_ushort2_rtz(ulong2);\012ushort2 __ovld __cnfn convert_ushort2_sat_rtz(ulong2);\012ushort2 __ovld __cnfn convert_ushort2_rtp(ulong2);\012ushort2 __ovld __cnfn convert_ushort2_sat_rtp(ulong2);\012ushort2 __ovld __cnfn convert_ushort2_rtn(ulong2);\012ushort2 __ovld __cnfn convert_ushort2_sat_rtn(ulong2);\012ushort2 __ovld __cnfn convert_ushort2(ulong2);\012ushort2 __ovld __cnfn convert_ushort2_sat(ulong2);\012ushort2 __ovld __cnfn convert_ushort2_rte(float2);\012ushort2 __ovld __cnfn convert_ushor",
"t2_sat_rte(float2);\012ushort2 __ovld __cnfn convert_ushort2_rtz(float2);\012ushort2 __ovld __cnfn convert_ushort2_sat_rtz(float2);\012ushort2 __ovld __cnfn convert_ushort2_rtp(float2);\012ushort2 __ovld __cnfn convert_ushort2_sat_rtp(float2);\012ushort2 __ovld __cnfn convert_ushort2_rtn(float2);\012ushort2 __ovld __cnfn convert_ushort2_sat_rtn(float2);\012ushort2 __ovld __cnfn convert_ushort2(float2);\012ushort2 __ovld __cnfn convert_ushort2_sat(float2);\012int2 __ovld __cnfn convert_int2_rte(char2);\012int2 __ovld __cnfn convert_int2_sat_rte(char2);\012int2 __ovld __cnfn convert_int2_rtz(char2);\012int2 __ovld __cnfn convert_int2_sat_rtz(char2);\012int2 __ovld __cnfn convert_int2_rtp(char2);\012int2 __ovld __cnfn convert_int2_sat_rtp(char2);\012int2 __ovld __cnfn convert_int2_rtn(char2);\012int2 __ovld __cnfn convert_int2_sat_rtn(char2);\012int2 __ovld __cnfn convert_int2(char2);\012int2 __ovld __cnfn convert_int2_sat(char2);\012int2 __ovld __cnfn convert_int2_rte(uchar2);\012int2 __ovld __cnfn convert_int2_sat_rte(uchar2);\012int2 __ovld __cnfn convert_int2_rtz(uchar2",
");\012int2 __ovld __cnfn convert_int2_sat_rtz(uchar2);\012int2 __ovld __cnfn convert_int2_rtp(uchar2);\012int2 __ovld __cnfn convert_int2_sat_rtp(uchar2);\012int2 __ovld __cnfn convert_int2_rtn(uchar2);\012int2 __ovld __cnfn convert_int2_sat_rtn(uchar2);\012int2 __ovld __cnfn convert_int2(uchar2);\012int2 __ovld __cnfn convert_int2_sat(uchar2);\012int2 __ovld __cnfn convert_int2_rte(short2);\012int2 __ovld __cnfn convert_int2_sat_rte(short2);\012int2 __ovld __cnfn convert_int2_rtz(short2);\012int2 __ovld __cnfn convert_int2_sat_rtz(short2);\012int2 __ovld __cnfn convert_int2_rtp(short2);\012int2 __ovld __cnfn convert_int2_sat_rtp(short2);\012int2 __ovld __cnfn convert_int2_rtn(short2);\012int2 __ovld __cnfn convert_int2_sat_rtn(short2);\012int2 __ovld __cnfn convert_int2(short2);\012int2 __ovld __cnfn convert_int2_sat(short2);\012int2 __ovld __cnfn convert_int2_rte(ushort2);\012int2 __ovld __cnfn convert_int2_sat_rte(ushort2);\012int2 __ovld __cnfn convert_int2_rtz(ushort2);\012int2 __ovld __cnfn convert_int2_sat_rtz(ushort2);\012int2 __ovld __cnfn convert_int2_rtp(ushort2)",
";\012int2 __ovld __cnfn convert_int2_sat_rtp(ushort2);\012int2 __ovld __cnfn convert_int2_rtn(ushort2);\012int2 __ovld __cnfn convert_int2_sat_rtn(ushort2);\012int2 __ovld __cnfn convert_int2(ushort2);\012int2 __ovld __cnfn convert_int2_sat(ushort2);\012int2 __ovld __cnfn convert_int2_rte(int2);\012int2 __ovld __cnfn convert_int2_sat_rte(int2);\012int2 __ovld __cnfn convert_int2_rtz(int2);\012int2 __ovld __cnfn convert_int2_sat_rtz(int2);\012int2 __ovld __cnfn convert_int2_rtp(int2);\012int2 __ovld __cnfn convert_int2_sat_rtp(int2);\012int2 __ovld __cnfn convert_int2_rtn(int2);\012int2 __ovld __cnfn convert_int2_sat_rtn(int2);\012int2 __ovld __cnfn convert_int2(int2);\012int2 __ovld __cnfn convert_int2_sat(int2);\012int2 __ovld __cnfn convert_int2_rte(uint2);\012int2 __ovld __cnfn convert_int2_sat_rte(uint2);\012int2 __ovld __cnfn convert_int2_rtz(uint2);\012int2 __ovld __cnfn convert_int2_sat_rtz(uint2);\012int2 __ovld __cnfn convert_int2_rtp(uint2);\012int2 __ovld __cnfn convert_int2_sat_rtp(uint2);\012int2 __ovld __cnfn convert_int2_rtn(uint2);\012int2 __ovld __cnfn convert",
"_int2_sat_rtn(uint2);\012int2 __ovld __cnfn convert_int2(uint2);\012int2 __ovld __cnfn convert_int2_sat(uint2);\012int2 __ovld __cnfn convert_int2_rte(long2);\012int2 __ovld __cnfn convert_int2_sat_rte(long2);\012int2 __ovld __cnfn convert_int2_rtz(long2);\012int2 __ovld __cnfn convert_int2_sat_rtz(long2);\012int2 __ovld __cnfn convert_int2_rtp(long2);\012int2 __ovld __cnfn convert_int2_sat_rtp(long2);\012int2 __ovld __cnfn convert_int2_rtn(long2);\012int2 __ovld __cnfn convert_int2_sat_rtn(long2);\012int2 __ovld __cnfn convert_int2(long2);\012int2 __ovld __cnfn convert_int2_sat(long2);\012int2 __ovld __cnfn convert_int2_rte(ulong2);\012int2 __ovld __cnfn convert_int2_sat_rte(ulong2);\012int2 __ovld __cnfn convert_int2_rtz(ulong2);\012int2 __ovld __cnfn convert_int2_sat_rtz(ulong2);\012int2 __ovld __cnfn convert_int2_rtp(ulong2);\012int2 __ovld __cnfn convert_int2_sat_rtp(ulong2);\012int2 __ovld __cnfn convert_int2_rtn(ulong2);\012int2 __ovld __cnfn convert_int2_sat_rtn(ulong2);\012int2 __ovld __cnfn convert_int2(ulong2);\012int2 __ovld __cnfn convert_int2_sat(ulong2);\012int2",
" __ovld __cnfn convert_int2_rte(float2);\012int2 __ovld __cnfn convert_int2_sat_rte(float2);\012int2 __ovld __cnfn convert_int2_rtz(float2);\012int2 __ovld __cnfn convert_int2_sat_rtz(float2);\012int2 __ovld __cnfn convert_int2_rtp(float2);\012int2 __ovld __cnfn convert_int2_sat_rtp(float2);\012int2 __ovld __cnfn convert_int2_rtn(float2);\012int2 __ovld __cnfn convert_int2_sat_rtn(float2);\012int2 __ovld __cnfn convert_int2(float2);\012int2 __ovld __cnfn convert_int2_sat(float2);\012uint2 __ovld __cnfn convert_uint2_rte(char2);\012uint2 __ovld __cnfn convert_uint2_sat_rte(char2);\012uint2 __ovld __cnfn convert_uint2_rtz(char2);\012uint2 __ovld __cnfn convert_uint2_sat_rtz(char2);\012uint2 __ovld __cnfn convert_uint2_rtp(char2);\012uint2 __ovld __cnfn convert_uint2_sat_rtp(char2);\012uint2 __ovld __cnfn convert_uint2_rtn(char2);\012uint2 __ovld __cnfn convert_uint2_sat_rtn(char2);\012uint2 __ovld __cnfn convert_uint2(char2);\012uint2 __ovld __cnfn convert_uint2_sat(char2);\012uint2 __ovld __cnfn convert_uint2_rte(uchar2);\012uint2 __ovld __cnfn convert_uint2_sat_rte(uchar",
"2);\012uint2 __ovld __cnfn convert_uint2_rtz(uchar2);\012uint2 __ovld __cnfn convert_uint2_sat_rtz(uchar2);\012uint2 __ovld __cnfn convert_uint2_rtp(uchar2);\012uint2 __ovld __cnfn convert_uint2_sat_rtp(uchar2);\012uint2 __ovld __cnfn convert_uint2_rtn(uchar2);\012uint2 __ovld __cnfn convert_uint2_sat_rtn(uchar2);\012uint2 __ovld __cnfn convert_uint2(uchar2);\012uint2 __ovld __cnfn convert_uint2_sat(uchar2);\012uint2 __ovld __cnfn convert_uint2_rte(short2);\012uint2 __ovld __cnfn convert_uint2_sat_rte(short2);\012uint2 __ovld __cnfn convert_uint2_rtz(short2);\012uint2 __ovld __cnfn convert_uint2_sat_rtz(short2);\012uint2 __ovld __cnfn convert_uint2_rtp(short2);\012uint2 __ovld __cnfn convert_uint2_sat_rtp(short2);\012uint2 __ovld __cnfn convert_uint2_rtn(short2);\012uint2 __ovld __cnfn convert_uint2_sat_rtn(short2);\012uint2 __ovld __cnfn convert_uint2(short2);\012uint2 __ovld __cnfn convert_uint2_sat(short2);\012uint2 __ovld __cnfn convert_uint2_rte(ushort2);\012uint2 __ovld __cnfn convert_uint2_sat_rte(ushort2);\012uint2 __ovld __cnfn convert_uint2_rtz(ushort2);\012uint2 ",
"__ovld __cnfn convert_uint2_sat_rtz(ushort2);\012uint2 __ovld __cnfn convert_uint2_rtp(ushort2);\012uint2 __ovld __cnfn convert_uint2_sat_rtp(ushort2);\012uint2 __ovld __cnfn convert_uint2_rtn(ushort2);\012uint2 __ovld __cnfn convert_uint2_sat_rtn(ushort2);\012uint2 __ovld __cnfn convert_uint2(ushort2);\012uint2 __ovld __cnfn convert_uint2_sat(ushort2);\012uint2 __ovld __cnfn convert_uint2_rte(int2);\012uint2 __ovld __cnfn convert_uint2_sat_rte(int2);\012uint2 __ovld __cnfn convert_uint2_rtz(int2);\012uint2 __ovld __cnfn convert_uint2_sat_rtz(int2);\012uint2 __ovld __cnfn convert_uint2_rtp(int2);\012uint2 __ovld __cnfn convert_uint2_sat_rtp(int2);\012uint2 __ovld __cnfn convert_uint2_rtn(int2);\012uint2 __ovld __cnfn convert_uint2_sat_rtn(int2);\012uint2 __ovld __cnfn convert_uint2(int2);\012uint2 __ovld __cnfn convert_uint2_sat(int2);\012uint2 __ovld __cnfn convert_uint2_rte(uint2);\012uint2 __ovld __cnfn convert_uint2_sat_rte(uint2);\012uint2 __ovld __cnfn convert_uint2_rtz(uint2);\012uint2 __ovld __cnfn convert_uint2_sat_rtz(uint2);\012uint2 __ovld __cnfn convert_uint",
"2_rtp(uint2);\012uint2 __ovld __cnfn convert_uint2_sat_rtp(uint2);\012uint2 __ovld __cnfn convert_uint2_rtn(uint2);\012uint2 __ovld __cnfn convert_uint2_sat_rtn(uint2);\012uint2 __ovld __cnfn convert_uint2(uint2);\012uint2 __ovld __cnfn convert_uint2_sat(uint2);\012uint2 __ovld __cnfn convert_uint2_rte(long2);\012uint2 __ovld __cnfn convert_uint2_sat_rte(long2);\012uint2 __ovld __cnfn convert_uint2_rtz(long2);\012uint2 __ovld __cnfn convert_uint2_sat_rtz(long2);\012uint2 __ovld __cnfn convert_uint2_rtp(long2);\012uint2 __ovld __cnfn convert_uint2_sat_rtp(long2);\012uint2 __ovld __cnfn convert_uint2_rtn(long2);\012uint2 __ovld __cnfn convert_uint2_sat_rtn(long2);\012uint2 __ovld __cnfn convert_uint2(long2);\012uint2 __ovld __cnfn convert_uint2_sat(long2);\012uint2 __ovld __cnfn convert_uint2_rte(ulong2);\012uint2 __ovld __cnfn convert_uint2_sat_rte(ulong2);\012uint2 __ovld __cnfn convert_uint2_rtz(ulong2);\012uint2 __ovld __cnfn convert_uint2_sat_rtz(ulong2);\012uint2 __ovld __cnfn convert_uint2_rtp(ulong2);\012uint2 __ovld __cnfn convert_uint2_sat_rtp(ulong2);\012uint2 __ov",
"ld __cnfn convert_uint2_rtn(ulong2);\012uint2 __ovld __cnfn convert_uint2_sat_rtn(ulong2);\012uint2 __ovld __cnfn convert_uint2(ulong2);\012uint2 __ovld __cnfn convert_uint2_sat(ulong2);\012uint2 __ovld __cnfn convert_uint2_rte(float2);\012uint2 __ovld __cnfn convert_uint2_sat_rte(float2);\012uint2 __ovld __cnfn convert_uint2_rtz(float2);\012uint2 __ovld __cnfn convert_uint2_sat_rtz(float2);\012uint2 __ovld __cnfn convert_uint2_rtp(float2);\012uint2 __ovld __cnfn convert_uint2_sat_rtp(float2);\012uint2 __ovld __cnfn convert_uint2_rtn(float2);\012uint2 __ovld __cnfn convert_uint2_sat_rtn(float2);\012uint2 __ovld __cnfn convert_uint2(float2);\012uint2 __ovld __cnfn convert_uint2_sat(float2);\012long2 __ovld __cnfn convert_long2_rte(char2);\012long2 __ovld __cnfn convert_long2_sat_rte(char2);\012long2 __ovld __cnfn convert_long2_rtz(char2);\012long2 __ovld __cnfn convert_long2_sat_rtz(char2);\012long2 __ovld __cnfn convert_long2_rtp(char2);\012long2 __ovld __cnfn convert_long2_sat_rtp(char2);\012long2 __ovld __cnfn convert_long2_rtn(char2);\012long2 __ovld __cnfn convert_lo",
"ng2_sat_rtn(char2);\012long2 __ovld __cnfn convert_long2(char2);\012long2 __ovld __cnfn convert_long2_sat(char2);\012long2 __ovld __cnfn convert_long2_rte(uchar2);\012long2 __ovld __cnfn convert_long2_sat_rte(uchar2);\012long2 __ovld __cnfn convert_long2_rtz(uchar2);\012long2 __ovld __cnfn convert_long2_sat_rtz(uchar2);\012long2 __ovld __cnfn convert_long2_rtp(uchar2);\012long2 __ovld __cnfn convert_long2_sat_rtp(uchar2);\012long2 __ovld __cnfn convert_long2_rtn(uchar2);\012long2 __ovld __cnfn convert_long2_sat_rtn(uchar2);\012long2 __ovld __cnfn convert_long2(uchar2);\012long2 __ovld __cnfn convert_long2_sat(uchar2);\012long2 __ovld __cnfn convert_long2_rte(short2);\012long2 __ovld __cnfn convert_long2_sat_rte(short2);\012long2 __ovld __cnfn convert_long2_rtz(short2);\012long2 __ovld __cnfn convert_long2_sat_rtz(short2);\012long2 __ovld __cnfn convert_long2_rtp(short2);\012long2 __ovld __cnfn convert_long2_sat_rtp(short2);\012long2 __ovld __cnfn convert_long2_rtn(short2);\012long2 __ovld __cnfn convert_long2_sat_rtn(short2);\012long2 __ovld __cnfn convert_long2(short2);",
"\012long2 __ovld __cnfn convert_long2_sat(short2);\012long2 __ovld __cnfn convert_long2_rte(ushort2);\012long2 __ovld __cnfn convert_long2_sat_rte(ushort2);\012long2 __ovld __cnfn convert_long2_rtz(ushort2);\012long2 __ovld __cnfn convert_long2_sat_rtz(ushort2);\012long2 __ovld __cnfn convert_long2_rtp(ushort2);\012long2 __ovld __cnfn convert_long2_sat_rtp(ushort2);\012long2 __ovld __cnfn convert_long2_rtn(ushort2);\012long2 __ovld __cnfn convert_long2_sat_rtn(ushort2);\012long2 __ovld __cnfn convert_long2(ushort2);\012long2 __ovld __cnfn convert_long2_sat(ushort2);\012long2 __ovld __cnfn convert_long2_rte(int2);\012long2 __ovld __cnfn convert_long2_sat_rte(int2);\012long2 __ovld __cnfn convert_long2_rtz(int2);\012long2 __ovld __cnfn convert_long2_sat_rtz(int2);\012long2 __ovld __cnfn convert_long2_rtp(int2);\012long2 __ovld __cnfn convert_long2_sat_rtp(int2);\012long2 __ovld __cnfn convert_long2_rtn(int2);\012long2 __ovld __cnfn convert_long2_sat_rtn(int2);\012long2 __ovld __cnfn convert_long2(int2);\012long2 __ovld __cnfn convert_long2_sat(int2);\012long2 __ovld __cnfn co",
"nvert_long2_rte(uint2);\012long2 __ovld __cnfn convert_long2_sat_rte(uint2);\012long2 __ovld __cnfn convert_long2_rtz(uint2);\012long2 __ovld __cnfn convert_long2_sat_rtz(uint2);\012long2 __ovld __cnfn convert_long2_rtp(uint2);\012long2 __ovld __cnfn convert_long2_sat_rtp(uint2);\012long2 __ovld __cnfn convert_long2_rtn(uint2);\012long2 __ovld __cnfn convert_long2_sat_rtn(uint2);\012long2 __ovld __cnfn convert_long2(uint2);\012long2 __ovld __cnfn convert_long2_sat(uint2);\012long2 __ovld __cnfn convert_long2_rte(long2);\012long2 __ovld __cnfn convert_long2_sat_rte(long2);\012long2 __ovld __cnfn convert_long2_rtz(long2);\012long2 __ovld __cnfn convert_long2_sat_rtz(long2);\012long2 __ovld __cnfn convert_long2_rtp(long2);\012long2 __ovld __cnfn convert_long2_sat_rtp(long2);\012long2 __ovld __cnfn convert_long2_rtn(long2);\012long2 __ovld __cnfn convert_long2_sat_rtn(long2);\012long2 __ovld __cnfn convert_long2(long2);\012long2 __ovld __cnfn convert_long2_sat(long2);\012long2 __ovld __cnfn convert_long2_rte(ulong2);\012long2 __ovld __cnfn convert_long2_sat_rte(ulong2);\012long",
"2 __ovld __cnfn convert_long2_rtz(ulong2);\012long2 __ovld __cnfn convert_long2_sat_rtz(ulong2);\012long2 __ovld __cnfn convert_long2_rtp(ulong2);\012long2 __ovld __cnfn convert_long2_sat_rtp(ulong2);\012long2 __ovld __cnfn convert_long2_rtn(ulong2);\012long2 __ovld __cnfn convert_long2_sat_rtn(ulong2);\012long2 __ovld __cnfn convert_long2(ulong2);\012long2 __ovld __cnfn convert_long2_sat(ulong2);\012long2 __ovld __cnfn convert_long2_rte(float2);\012long2 __ovld __cnfn convert_long2_sat_rte(float2);\012long2 __ovld __cnfn convert_long2_rtz(float2);\012long2 __ovld __cnfn convert_long2_sat_rtz(float2);\012long2 __ovld __cnfn convert_long2_rtp(float2);\012long2 __ovld __cnfn convert_long2_sat_rtp(float2);\012long2 __ovld __cnfn convert_long2_rtn(float2);\012long2 __ovld __cnfn convert_long2_sat_rtn(float2);\012long2 __ovld __cnfn convert_long2(float2);\012long2 __ovld __cnfn convert_long2_sat(float2);\012ulong2 __ovld __cnfn convert_ulong2_rte(char2);\012ulong2 __ovld __cnfn convert_ulong2_sat_rte(char2);\012ulong2 __ovld __cnfn convert_ulong2_rtz(char2);\012ulong2 __ovld ",
"__cnfn convert_ulong2_sat_rtz(char2);\012ulong2 __ovld __cnfn convert_ulong2_rtp(char2);\012ulong2 __ovld __cnfn convert_ulong2_sat_rtp(char2);\012ulong2 __ovld __cnfn convert_ulong2_rtn(char2);\012ulong2 __ovld __cnfn convert_ulong2_sat_rtn(char2);\012ulong2 __ovld __cnfn convert_ulong2(char2);\012ulong2 __ovld __cnfn convert_ulong2_sat(char2);\012ulong2 __ovld __cnfn convert_ulong2_rte(uchar2);\012ulong2 __ovld __cnfn convert_ulong2_sat_rte(uchar2);\012ulong2 __ovld __cnfn convert_ulong2_rtz(uchar2);\012ulong2 __ovld __cnfn convert_ulong2_sat_rtz(uchar2);\012ulong2 __ovld __cnfn convert_ulong2_rtp(uchar2);\012ulong2 __ovld __cnfn convert_ulong2_sat_rtp(uchar2);\012ulong2 __ovld __cnfn convert_ulong2_rtn(uchar2);\012ulong2 __ovld __cnfn convert_ulong2_sat_rtn(uchar2);\012ulong2 __ovld __cnfn convert_ulong2(uchar2);\012ulong2 __ovld __cnfn convert_ulong2_sat(uchar2);\012ulong2 __ovld __cnfn convert_ulong2_rte(short2);\012ulong2 __ovld __cnfn convert_ulong2_sat_rte(short2);\012ulong2 __ovld __cnfn convert_ulong2_rtz(short2);\012ulong2 __ovld __cnfn convert_ulong2_sat_r",
"tz(short2);\012ulong2 __ovld __cnfn convert_ulong2_rtp(short2);\012ulong2 __ovld __cnfn convert_ulong2_sat_rtp(short2);\012ulong2 __ovld __cnfn convert_ulong2_rtn(short2);\012ulong2 __ovld __cnfn convert_ulong2_sat_rtn(short2);\012ulong2 __ovld __cnfn convert_ulong2(short2);\012ulong2 __ovld __cnfn convert_ulong2_sat(short2);\012ulong2 __ovld __cnfn convert_ulong2_rte(ushort2);\012ulong2 __ovld __cnfn convert_ulong2_sat_rte(ushort2);\012ulong2 __ovld __cnfn convert_ulong2_rtz(ushort2);\012ulong2 __ovld __cnfn convert_ulong2_sat_rtz(ushort2);\012ulong2 __ovld __cnfn convert_ulong2_rtp(ushort2);\012ulong2 __ovld __cnfn convert_ulong2_sat_rtp(ushort2);\012ulong2 __ovld __cnfn convert_ulong2_rtn(ushort2);\012ulong2 __ovld __cnfn convert_ulong2_sat_rtn(ushort2);\012ulong2 __ovld __cnfn convert_ulong2(ushort2);\012ulong2 __ovld __cnfn convert_ulong2_sat(ushort2);\012ulong2 __ovld __cnfn convert_ulong2_rte(int2);\012ulong2 __ovld __cnfn convert_ulong2_sat_rte(int2);\012ulong2 __ovld __cnfn convert_ulong2_rtz(int2);\012ulong2 __ovld __cnfn convert_ulong2_sat_rtz(int2);\012ulong2",
" __ovld __cnfn convert_ulong2_rtp(int2);\012ulong2 __ovld __cnfn convert_ulong2_sat_rtp(int2);\012ulong2 __ovld __cnfn convert_ulong2_rtn(int2);\012ulong2 __ovld __cnfn convert_ulong2_sat_rtn(int2);\012ulong2 __ovld __cnfn convert_ulong2(int2);\012ulong2 __ovld __cnfn convert_ulong2_sat(int2);\012ulong2 __ovld __cnfn convert_ulong2_rte(uint2);\012ulong2 __ovld __cnfn convert_ulong2_sat_rte(uint2);\012ulong2 __ovld __cnfn convert_ulong2_rtz(uint2);\012ulong2 __ovld __cnfn convert_ulong2_sat_rtz(uint2);\012ulong2 __ovld __cnfn convert_ulong2_rtp(uint2);\012ulong2 __ovld __cnfn convert_ulong2_sat_rtp(uint2);\012ulong2 __ovld __cnfn convert_ulong2_rtn(uint2);\012ulong2 __ovld __cnfn convert_ulong2_sat_rtn(uint2);\012ulong2 __ovld __cnfn convert_ulong2(uint2);\012ulong2 __ovld __cnfn convert_ulong2_sat(uint2);\012ulong2 __ovld __cnfn convert_ulong2_rte(long2);\012ulong2 __ovld __cnfn convert_ulong2_sat_rte(long2);\012ulong2 __ovld __cnfn convert_ulong2_rtz(long2);\012ulong2 __ovld __cnfn convert_ulong2_sat_rtz(long2);\012ulong2 __ovld __cnfn convert_ulong2_rtp(long2);\012ulon",
"g2 __ovld __cnfn convert_ulong2_sat_rtp(long2);\012ulong2 __ovld __cnfn convert_ulong2_rtn(long2);\012ulong2 __ovld __cnfn convert_ulong2_sat_rtn(long2);\012ulong2 __ovld __cnfn convert_ulong2(long2);\012ulong2 __ovld __cnfn convert_ulong2_sat(long2);\012ulong2 __ovld __cnfn convert_ulong2_rte(ulong2);\012ulong2 __ovld __cnfn convert_ulong2_sat_rte(ulong2);\012ulong2 __ovld __cnfn convert_ulong2_rtz(ulong2);\012ulong2 __ovld __cnfn convert_ulong2_sat_rtz(ulong2);\012ulong2 __ovld __cnfn convert_ulong2_rtp(ulong2);\012ulong2 __ovld __cnfn convert_ulong2_sat_rtp(ulong2);\012ulong2 __ovld __cnfn convert_ulong2_rtn(ulong2);\012ulong2 __ovld __cnfn convert_ulong2_sat_rtn(ulong2);\012ulong2 __ovld __cnfn convert_ulong2(ulong2);\012ulong2 __ovld __cnfn convert_ulong2_sat(ulong2);\012ulong2 __ovld __cnfn convert_ulong2_rte(float2);\012ulong2 __ovld __cnfn convert_ulong2_sat_rte(float2);\012ulong2 __ovld __cnfn convert_ulong2_rtz(float2);\012ulong2 __ovld __cnfn convert_ulong2_sat_rtz(float2);\012ulong2 __ovld __cnfn convert_ulong2_rtp(float2);\012ulong2 __ovld __cnfn convert_",
"ulong2_sat_rtp(float2);\012ulong2 __ovld __cnfn convert_ulong2_rtn(float2);\012ulong2 __ovld __cnfn convert_ulong2_sat_rtn(float2);\012ulong2 __ovld __cnfn convert_ulong2(float2);\012ulong2 __ovld __cnfn convert_ulong2_sat(float2);\012float2 __ovld __cnfn convert_float2_rte(char2);\012float2 __ovld __cnfn convert_float2_rtz(char2);\012float2 __ovld __cnfn convert_float2_rtp(char2);\012float2 __ovld __cnfn convert_float2_rtn(char2);\012float2 __ovld __cnfn convert_float2(char2);\012float2 __ovld __cnfn convert_float2_rte(uchar2);\012float2 __ovld __cnfn convert_float2_rtz(uchar2);\012float2 __ovld __cnfn convert_float2_rtp(uchar2);\012float2 __ovld __cnfn convert_float2_rtn(uchar2);\012float2 __ovld __cnfn convert_float2(uchar2);\012float2 __ovld __cnfn convert_float2_rte(short2);\012float2 __ovld __cnfn convert_float2_rtz(short2);\012float2 __ovld __cnfn convert_float2_rtp(short2);\012float2 __ovld __cnfn convert_float2_rtn(short2);\012float2 __ovld __cnfn convert_float2(short2);\012float2 __ovld __cnfn convert_float2_rte(ushort2);\012float2 __ovld __cnfn convert_float2_",
"rtz(ushort2);\012float2 __ovld __cnfn convert_float2_rtp(ushort2);\012float2 __ovld __cnfn convert_float2_rtn(ushort2);\012float2 __ovld __cnfn convert_float2(ushort2);\012float2 __ovld __cnfn convert_float2_rte(int2);\012float2 __ovld __cnfn convert_float2_rtz(int2);\012float2 __ovld __cnfn convert_float2_rtp(int2);\012float2 __ovld __cnfn convert_float2_rtn(int2);\012float2 __ovld __cnfn convert_float2(int2);\012float2 __ovld __cnfn convert_float2_rte(uint2);\012float2 __ovld __cnfn convert_float2_rtz(uint2);\012float2 __ovld __cnfn convert_float2_rtp(uint2);\012float2 __ovld __cnfn convert_float2_rtn(uint2);\012float2 __ovld __cnfn convert_float2(uint2);\012float2 __ovld __cnfn convert_float2_rte(long2);\012float2 __ovld __cnfn convert_float2_rtz(long2);\012float2 __ovld __cnfn convert_float2_rtp(long2);\012float2 __ovld __cnfn convert_float2_rtn(long2);\012float2 __ovld __cnfn convert_float2(long2);\012float2 __ovld __cnfn convert_float2_rte(ulong2);\012float2 __ovld __cnfn convert_float2_rtz(ulong2);\012float2 __ovld __cnfn convert_float2_rtp(ulong2);\012float2 __ovld ",
"__cnfn convert_float2_rtn(ulong2);\012float2 __ovld __cnfn convert_float2(ulong2);\012float2 __ovld __cnfn convert_float2_rte(float2);\012float2 __ovld __cnfn convert_float2_rtz(float2);\012float2 __ovld __cnfn convert_float2_rtp(float2);\012float2 __ovld __cnfn convert_float2_rtn(float2);\012float2 __ovld __cnfn convert_float2(float2);\012char3 __ovld __cnfn convert_char3_rte(char3);\012char3 __ovld __cnfn convert_char3_sat_rte(char3);\012char3 __ovld __cnfn convert_char3_rtz(char3);\012char3 __ovld __cnfn convert_char3_sat_rtz(char3);\012char3 __ovld __cnfn convert_char3_rtp(char3);\012char3 __ovld __cnfn convert_char3_sat_rtp(char3);\012char3 __ovld __cnfn convert_char3_rtn(char3);\012char3 __ovld __cnfn convert_char3_sat_rtn(char3);\012char3 __ovld __cnfn convert_char3(char3);\012char3 __ovld __cnfn convert_char3_sat(char3);\012char3 __ovld __cnfn convert_char3_rte(uchar3);\012char3 __ovld __cnfn convert_char3_sat_rte(uchar3);\012char3 __ovld __cnfn convert_char3_rtz(uchar3);\012char3 __ovld __cnfn convert_char3_sat_rtz(uchar3);\012char3 __ovld __cnfn convert_char3_r",
"tp(uchar3);\012char3 __ovld __cnfn convert_char3_sat_rtp(uchar3);\012char3 __ovld __cnfn convert_char3_rtn(uchar3);\012char3 __ovld __cnfn convert_char3_sat_rtn(uchar3);\012char3 __ovld __cnfn convert_char3(uchar3);\012char3 __ovld __cnfn convert_char3_sat(uchar3);\012char3 __ovld __cnfn convert_char3_rte(short3);\012char3 __ovld __cnfn convert_char3_sat_rte(short3);\012char3 __ovld __cnfn convert_char3_rtz(short3);\012char3 __ovld __cnfn convert_char3_sat_rtz(short3);\012char3 __ovld __cnfn convert_char3_rtp(short3);\012char3 __ovld __cnfn convert_char3_sat_rtp(short3);\012char3 __ovld __cnfn convert_char3_rtn(short3);\012char3 __ovld __cnfn convert_char3_sat_rtn(short3);\012char3 __ovld __cnfn convert_char3(short3);\012char3 __ovld __cnfn convert_char3_sat(short3);\012char3 __ovld __cnfn convert_char3_rte(ushort3);\012char3 __ovld __cnfn convert_char3_sat_rte(ushort3);\012char3 __ovld __cnfn convert_char3_rtz(ushort3);\012char3 __ovld __cnfn convert_char3_sat_rtz(ushort3);\012char3 __ovld __cnfn convert_char3_rtp(ushort3);\012char3 __ovld __cnfn convert_char3_sat_rtp(u",
"short3);\012char3 __ovld __cnfn convert_char3_rtn(ushort3);\012char3 __ovld __cnfn convert_char3_sat_rtn(ushort3);\012char3 __ovld __cnfn convert_char3(ushort3);\012char3 __ovld __cnfn convert_char3_sat(ushort3);\012char3 __ovld __cnfn convert_char3_rte(int3);\012char3 __ovld __cnfn convert_char3_sat_rte(int3);\012char3 __ovld __cnfn convert_char3_rtz(int3);\012char3 __ovld __cnfn convert_char3_sat_rtz(int3);\012char3 __ovld __cnfn convert_char3_rtp(int3);\012char3 __ovld __cnfn convert_char3_sat_rtp(int3);\012char3 __ovld __cnfn convert_char3_rtn(int3);\012char3 __ovld __cnfn convert_char3_sat_rtn(int3);\012char3 __ovld __cnfn convert_char3(int3);\012char3 __ovld __cnfn convert_char3_sat(int3);\012char3 __ovld __cnfn convert_char3_rte(uint3);\012char3 __ovld __cnfn convert_char3_sat_rte(uint3);\012char3 __ovld __cnfn convert_char3_rtz(uint3);\012char3 __ovld __cnfn convert_char3_sat_rtz(uint3);\012char3 __ovld __cnfn convert_char3_rtp(uint3);\012char3 __ovld __cnfn convert_char3_sat_rtp(uint3);\012char3 __ovld __cnfn convert_char3_rtn(uint3);\012char3 __ovld __cnfn convert",
"_char3_sat_rtn(uint3);\012char3 __ovld __cnfn convert_char3(uint3);\012char3 __ovld __cnfn convert_char3_sat(uint3);\012char3 __ovld __cnfn convert_char3_rte(long3);\012char3 __ovld __cnfn convert_char3_sat_rte(long3);\012char3 __ovld __cnfn convert_char3_rtz(long3);\012char3 __ovld __cnfn convert_char3_sat_rtz(long3);\012char3 __ovld __cnfn convert_char3_rtp(long3);\012char3 __ovld __cnfn convert_char3_sat_rtp(long3);\012char3 __ovld __cnfn convert_char3_rtn(long3);\012char3 __ovld __cnfn convert_char3_sat_rtn(long3);\012char3 __ovld __cnfn convert_char3(long3);\012char3 __ovld __cnfn convert_char3_sat(long3);\012char3 __ovld __cnfn convert_char3_rte(ulong3);\012char3 __ovld __cnfn convert_char3_sat_rte(ulong3);\012char3 __ovld __cnfn convert_char3_rtz(ulong3);\012char3 __ovld __cnfn convert_char3_sat_rtz(ulong3);\012char3 __ovld __cnfn convert_char3_rtp(ulong3);\012char3 __ovld __cnfn convert_char3_sat_rtp(ulong3);\012char3 __ovld __cnfn convert_char3_rtn(ulong3);\012char3 __ovld __cnfn convert_char3_sat_rtn(ulong3);\012char3 __ovld __cnfn convert_char3(ulong3);\012char3 ",
"__ovld __cnfn convert_char3_sat(ulong3);\012char3 __ovld __cnfn convert_char3_rte(float3);\012char3 __ovld __cnfn convert_char3_sat_rte(float3);\012char3 __ovld __cnfn convert_char3_rtz(float3);\012char3 __ovld __cnfn convert_char3_sat_rtz(float3);\012char3 __ovld __cnfn convert_char3_rtp(float3);\012char3 __ovld __cnfn convert_char3_sat_rtp(float3);\012char3 __ovld __cnfn convert_char3_rtn(float3);\012char3 __ovld __cnfn convert_char3_sat_rtn(float3);\012char3 __ovld __cnfn convert_char3(float3);\012char3 __ovld __cnfn convert_char3_sat(float3);\012uchar3 __ovld __cnfn convert_uchar3_rte(char3);\012uchar3 __ovld __cnfn convert_uchar3_sat_rte(char3);\012uchar3 __ovld __cnfn convert_uchar3_rtz(char3);\012uchar3 __ovld __cnfn convert_uchar3_sat_rtz(char3);\012uchar3 __ovld __cnfn convert_uchar3_rtp(char3);\012uchar3 __ovld __cnfn convert_uchar3_sat_rtp(char3);\012uchar3 __ovld __cnfn convert_uchar3_rtn(char3);\012uchar3 __ovld __cnfn convert_uchar3_sat_rtn(char3);\012uchar3 __ovld __cnfn convert_uchar3(char3);\012uchar3 __ovld __cnfn convert_uchar3_sat(char3);\012uchar3 __",
"ovld __cnfn convert_uchar3_rte(uchar3);\012uchar3 __ovld __cnfn convert_uchar3_sat_rte(uchar3);\012uchar3 __ovld __cnfn convert_uchar3_rtz(uchar3);\012uchar3 __ovld __cnfn convert_uchar3_sat_rtz(uchar3);\012uchar3 __ovld __cnfn convert_uchar3_rtp(uchar3);\012uchar3 __ovld __cnfn convert_uchar3_sat_rtp(uchar3);\012uchar3 __ovld __cnfn convert_uchar3_rtn(uchar3);\012uchar3 __ovld __cnfn convert_uchar3_sat_rtn(uchar3);\012uchar3 __ovld __cnfn convert_uchar3(uchar3);\012uchar3 __ovld __cnfn convert_uchar3_sat(uchar3);\012uchar3 __ovld __cnfn convert_uchar3_rte(short3);\012uchar3 __ovld __cnfn convert_uchar3_sat_rte(short3);\012uchar3 __ovld __cnfn convert_uchar3_rtz(short3);\012uchar3 __ovld __cnfn convert_uchar3_sat_rtz(short3);\012uchar3 __ovld __cnfn convert_uchar3_rtp(short3);\012uchar3 __ovld __cnfn convert_uchar3_sat_rtp(short3);\012uchar3 __ovld __cnfn convert_uchar3_rtn(short3);\012uchar3 __ovld __cnfn convert_uchar3_sat_rtn(short3);\012uchar3 __ovld __cnfn convert_uchar3(short3);\012uchar3 __ovld __cnfn convert_uchar3_sat(short3);\012uchar3 __ovld __cnfn convert_",
"uchar3_rte(ushort3);\012uchar3 __ovld __cnfn convert_uchar3_sat_rte(ushort3);\012uchar3 __ovld __cnfn convert_uchar3_rtz(ushort3);\012uchar3 __ovld __cnfn convert_uchar3_sat_rtz(ushort3);\012uchar3 __ovld __cnfn convert_uchar3_rtp(ushort3);\012uchar3 __ovld __cnfn convert_uchar3_sat_rtp(ushort3);\012uchar3 __ovld __cnfn convert_uchar3_rtn(ushort3);\012uchar3 __ovld __cnfn convert_uchar3_sat_rtn(ushort3);\012uchar3 __ovld __cnfn convert_uchar3(ushort3);\012uchar3 __ovld __cnfn convert_uchar3_sat(ushort3);\012uchar3 __ovld __cnfn convert_uchar3_rte(int3);\012uchar3 __ovld __cnfn convert_uchar3_sat_rte(int3);\012uchar3 __ovld __cnfn convert_uchar3_rtz(int3);\012uchar3 __ovld __cnfn convert_uchar3_sat_rtz(int3);\012uchar3 __ovld __cnfn convert_uchar3_rtp(int3);\012uchar3 __ovld __cnfn convert_uchar3_sat_rtp(int3);\012uchar3 __ovld __cnfn convert_uchar3_rtn(int3);\012uchar3 __ovld __cnfn convert_uchar3_sat_rtn(int3);\012uchar3 __ovld __cnfn convert_uchar3(int3);\012uchar3 __ovld __cnfn convert_uchar3_sat(int3);\012uchar3 __ovld __cnfn convert_uchar3_rte(uint3);\012uchar3 __ov",
"ld __cnfn convert_uchar3_sat_rte(uint3);\012uchar3 __ovld __cnfn convert_uchar3_rtz(uint3);\012uchar3 __ovld __cnfn convert_uchar3_sat_rtz(uint3);\012uchar3 __ovld __cnfn convert_uchar3_rtp(uint3);\012uchar3 __ovld __cnfn convert_uchar3_sat_rtp(uint3);\012uchar3 __ovld __cnfn convert_uchar3_rtn(uint3);\012uchar3 __ovld __cnfn convert_uchar3_sat_rtn(uint3);\012uchar3 __ovld __cnfn convert_uchar3(uint3);\012uchar3 __ovld __cnfn convert_uchar3_sat(uint3);\012uchar3 __ovld __cnfn convert_uchar3_rte(long3);\012uchar3 __ovld __cnfn convert_uchar3_sat_rte(long3);\012uchar3 __ovld __cnfn convert_uchar3_rtz(long3);\012uchar3 __ovld __cnfn convert_uchar3_sat_rtz(long3);\012uchar3 __ovld __cnfn convert_uchar3_rtp(long3);\012uchar3 __ovld __cnfn convert_uchar3_sat_rtp(long3);\012uchar3 __ovld __cnfn convert_uchar3_rtn(long3);\012uchar3 __ovld __cnfn convert_uchar3_sat_rtn(long3);\012uchar3 __ovld __cnfn convert_uchar3(long3);\012uchar3 __ovld __cnfn convert_uchar3_sat(long3);\012uchar3 __ovld __cnfn convert_uchar3_rte(ulong3);\012uchar3 __ovld __cnfn convert_uchar3_sat_rte(ulong3",
");\012uchar3 __ovld __cnfn convert_uchar3_rtz(ulong3);\012uchar3 __ovld __cnfn convert_uchar3_sat_rtz(ulong3);\012uchar3 __ovld __cnfn convert_uchar3_rtp(ulong3);\012uchar3 __ovld __cnfn convert_uchar3_sat_rtp(ulong3);\012uchar3 __ovld __cnfn convert_uchar3_rtn(ulong3);\012uchar3 __ovld __cnfn convert_uchar3_sat_rtn(ulong3);\012uchar3 __ovld __cnfn convert_uchar3(ulong3);\012uchar3 __ovld __cnfn convert_uchar3_sat(ulong3);\012uchar3 __ovld __cnfn convert_uchar3_rte(float3);\012uchar3 __ovld __cnfn convert_uchar3_sat_rte(float3);\012uchar3 __ovld __cnfn convert_uchar3_rtz(float3);\012uchar3 __ovld __cnfn convert_uchar3_sat_rtz(float3);\012uchar3 __ovld __cnfn convert_uchar3_rtp(float3);\012uchar3 __ovld __cnfn convert_uchar3_sat_rtp(float3);\012uchar3 __ovld __cnfn convert_uchar3_rtn(float3);\012uchar3 __ovld __cnfn convert_uchar3_sat_rtn(float3);\012uchar3 __ovld __cnfn convert_uchar3(float3);\012uchar3 __ovld __cnfn convert_uchar3_sat(float3);\012short3 __ovld __cnfn convert_short3_rte(char3);\012short3 __ovld __cnfn convert_short3_sat_rte(char3);\012short3 __ovld __cnf",
"n convert_short3_rtz(char3);\012short3 __ovld __cnfn convert_short3_sat_rtz(char3);\012short3 __ovld __cnfn convert_short3_rtp(char3);\012short3 __ovld __cnfn convert_short3_sat_rtp(char3);\012short3 __ovld __cnfn convert_short3_rtn(char3);\012short3 __ovld __cnfn convert_short3_sat_rtn(char3);\012short3 __ovld __cnfn convert_short3(char3);\012short3 __ovld __cnfn convert_short3_sat(char3);\012short3 __ovld __cnfn convert_short3_rte(uchar3);\012short3 __ovld __cnfn convert_short3_sat_rte(uchar3);\012short3 __ovld __cnfn convert_short3_rtz(uchar3);\012short3 __ovld __cnfn convert_short3_sat_rtz(uchar3);\012short3 __ovld __cnfn convert_short3_rtp(uchar3);\012short3 __ovld __cnfn convert_short3_sat_rtp(uchar3);\012short3 __ovld __cnfn convert_short3_rtn(uchar3);\012short3 __ovld __cnfn convert_short3_sat_rtn(uchar3);\012short3 __ovld __cnfn convert_short3(uchar3);\012short3 __ovld __cnfn convert_short3_sat(uchar3);\012short3 __ovld __cnfn convert_short3_rte(short3);\012short3 __ovld __cnfn convert_short3_sat_rte(short3);\012short3 __ovld __cnfn convert_short3_rtz(short3)",
";\012short3 __ovld __cnfn convert_short3_sat_rtz(short3);\012short3 __ovld __cnfn convert_short3_rtp(short3);\012short3 __ovld __cnfn convert_short3_sat_rtp(short3);\012short3 __ovld __cnfn convert_short3_rtn(short3);\012short3 __ovld __cnfn convert_short3_sat_rtn(short3);\012short3 __ovld __cnfn convert_short3(short3);\012short3 __ovld __cnfn convert_short3_sat(short3);\012short3 __ovld __cnfn convert_short3_rte(ushort3);\012short3 __ovld __cnfn convert_short3_sat_rte(ushort3);\012short3 __ovld __cnfn convert_short3_rtz(ushort3);\012short3 __ovld __cnfn convert_short3_sat_rtz(ushort3);\012short3 __ovld __cnfn convert_short3_rtp(ushort3);\012short3 __ovld __cnfn convert_short3_sat_rtp(ushort3);\012short3 __ovld __cnfn convert_short3_rtn(ushort3);\012short3 __ovld __cnfn convert_short3_sat_rtn(ushort3);\012short3 __ovld __cnfn convert_short3(ushort3);\012short3 __ovld __cnfn convert_short3_sat(ushort3);\012short3 __ovld __cnfn convert_short3_rte(int3);\012short3 __ovld __cnfn convert_short3_sat_rte(int3);\012short3 __ovld __cnfn convert_short3_rtz(int3);\012short3 __ovld ",
"__cnfn convert_short3_sat_rtz(int3);\012short3 __ovld __cnfn convert_short3_rtp(int3);\012short3 __ovld __cnfn convert_short3_sat_rtp(int3);\012short3 __ovld __cnfn convert_short3_rtn(int3);\012short3 __ovld __cnfn convert_short3_sat_rtn(int3);\012short3 __ovld __cnfn convert_short3(int3);\012short3 __ovld __cnfn convert_short3_sat(int3);\012short3 __ovld __cnfn convert_short3_rte(uint3);\012short3 __ovld __cnfn convert_short3_sat_rte(uint3);\012short3 __ovld __cnfn convert_short3_rtz(uint3);\012short3 __ovld __cnfn convert_short3_sat_rtz(uint3);\012short3 __ovld __cnfn convert_short3_rtp(uint3);\012short3 __ovld __cnfn convert_short3_sat_rtp(uint3);\012short3 __ovld __cnfn convert_short3_rtn(uint3);\012short3 __ovld __cnfn convert_short3_sat_rtn(uint3);\012short3 __ovld __cnfn convert_short3(uint3);\012short3 __ovld __cnfn convert_short3_sat(uint3);\012short3 __ovld __cnfn convert_short3_rte(long3);\012short3 __ovld __cnfn convert_short3_sat_rte(long3);\012short3 __ovld __cnfn convert_short3_rtz(long3);\012short3 __ovld __cnfn convert_short3_sat_rtz(long3);\012short3 __",
"ovld __cnfn convert_short3_rtp(long3);\012short3 __ovld __cnfn convert_short3_sat_rtp(long3);\012short3 __ovld __cnfn convert_short3_rtn(long3);\012short3 __ovld __cnfn convert_short3_sat_rtn(long3);\012short3 __ovld __cnfn convert_short3(long3);\012short3 __ovld __cnfn convert_short3_sat(long3);\012short3 __ovld __cnfn convert_short3_rte(ulong3);\012short3 __ovld __cnfn convert_short3_sat_rte(ulong3);\012short3 __ovld __cnfn convert_short3_rtz(ulong3);\012short3 __ovld __cnfn convert_short3_sat_rtz(ulong3);\012short3 __ovld __cnfn convert_short3_rtp(ulong3);\012short3 __ovld __cnfn convert_short3_sat_rtp(ulong3);\012short3 __ovld __cnfn convert_short3_rtn(ulong3);\012short3 __ovld __cnfn convert_short3_sat_rtn(ulong3);\012short3 __ovld __cnfn convert_short3(ulong3);\012short3 __ovld __cnfn convert_short3_sat(ulong3);\012short3 __ovld __cnfn convert_short3_rte(float3);\012short3 __ovld __cnfn convert_short3_sat_rte(float3);\012short3 __ovld __cnfn convert_short3_rtz(float3);\012short3 __ovld __cnfn convert_short3_sat_rtz(float3);\012short3 __ovld __cnfn convert_short3",
"_rtp(float3);\012short3 __ovld __cnfn convert_short3_sat_rtp(float3);\012short3 __ovld __cnfn convert_short3_rtn(float3);\012short3 __ovld __cnfn convert_short3_sat_rtn(float3);\012short3 __ovld __cnfn convert_short3(float3);\012short3 __ovld __cnfn convert_short3_sat(float3);\012ushort3 __ovld __cnfn convert_ushort3_rte(char3);\012ushort3 __ovld __cnfn convert_ushort3_sat_rte(char3);\012ushort3 __ovld __cnfn convert_ushort3_rtz(char3);\012ushort3 __ovld __cnfn convert_ushort3_sat_rtz(char3);\012ushort3 __ovld __cnfn convert_ushort3_rtp(char3);\012ushort3 __ovld __cnfn convert_ushort3_sat_rtp(char3);\012ushort3 __ovld __cnfn convert_ushort3_rtn(char3);\012ushort3 __ovld __cnfn convert_ushort3_sat_rtn(char3);\012ushort3 __ovld __cnfn convert_ushort3(char3);\012ushort3 __ovld __cnfn convert_ushort3_sat(char3);\012ushort3 __ovld __cnfn convert_ushort3_rte(uchar3);\012ushort3 __ovld __cnfn convert_ushort3_sat_rte(uchar3);\012ushort3 __ovld __cnfn convert_ushort3_rtz(uchar3);\012ushort3 __ovld __cnfn convert_ushort3_sat_rtz(uchar3);\012ushort3 __ovld __cnfn convert_ushort3",
"_rtp(uchar3);\012ushort3 __ovld __cnfn convert_ushort3_sat_rtp(uchar3);\012ushort3 __ovld __cnfn convert_ushort3_rtn(uchar3);\012ushort3 __ovld __cnfn convert_ushort3_sat_rtn(uchar3);\012ushort3 __ovld __cnfn convert_ushort3(uchar3);\012ushort3 __ovld __cnfn convert_ushort3_sat(uchar3);\012ushort3 __ovld __cnfn convert_ushort3_rte(short3);\012ushort3 __ovld __cnfn convert_ushort3_sat_rte(short3);\012ushort3 __ovld __cnfn convert_ushort3_rtz(short3);\012ushort3 __ovld __cnfn convert_ushort3_sat_rtz(short3);\012ushort3 __ovld __cnfn convert_ushort3_rtp(short3);\012ushort3 __ovld __cnfn convert_ushort3_sat_rtp(short3);\012ushort3 __ovld __cnfn convert_ushort3_rtn(short3);\012ushort3 __ovld __cnfn convert_ushort3_sat_rtn(short3);\012ushort3 __ovld __cnfn convert_ushort3(short3);\012ushort3 __ovld __cnfn convert_ushort3_sat(short3);\012ushort3 __ovld __cnfn convert_ushort3_rte(ushort3);\012ushort3 __ovld __cnfn convert_ushort3_sat_rte(ushort3);\012ushort3 __ovld __cnfn convert_ushort3_rtz(ushort3);\012ushort3 __ovld __cnfn convert_ushort3_sat_rtz(ushort3);\012ushort3 __ovl",
"d __cnfn convert_ushort3_rtp(ushort3);\012ushort3 __ovld __cnfn convert_ushort3_sat_rtp(ushort3);\012ushort3 __ovld __cnfn convert_ushort3_rtn(ushort3);\012ushort3 __ovld __cnfn convert_ushort3_sat_rtn(ushort3);\012ushort3 __ovld __cnfn convert_ushort3(ushort3);\012ushort3 __ovld __cnfn convert_ushort3_sat(ushort3);\012ushort3 __ovld __cnfn convert_ushort3_rte(int3);\012ushort3 __ovld __cnfn convert_ushort3_sat_rte(int3);\012ushort3 __ovld __cnfn convert_ushort3_rtz(int3);\012ushort3 __ovld __cnfn convert_ushort3_sat_rtz(int3);\012ushort3 __ovld __cnfn convert_ushort3_rtp(int3);\012ushort3 __ovld __cnfn convert_ushort3_sat_rtp(int3);\012ushort3 __ovld __cnfn convert_ushort3_rtn(int3);\012ushort3 __ovld __cnfn convert_ushort3_sat_rtn(int3);\012ushort3 __ovld __cnfn convert_ushort3(int3);\012ushort3 __ovld __cnfn convert_ushort3_sat(int3);\012ushort3 __ovld __cnfn convert_ushort3_rte(uint3);\012ushort3 __ovld __cnfn convert_ushort3_sat_rte(uint3);\012ushort3 __ovld __cnfn convert_ushort3_rtz(uint3);\012ushort3 __ovld __cnfn convert_ushort3_sat_rtz(uint3);\012ushort3 __o",
"vld __cnfn convert_ushort3_rtp(uint3);\012ushort3 __ovld __cnfn convert_ushort3_sat_rtp(uint3);\012ushort3 __ovld __cnfn convert_ushort3_rtn(uint3);\012ushort3 __ovld __cnfn convert_ushort3_sat_rtn(uint3);\012ushort3 __ovld __cnfn convert_ushort3(uint3);\012ushort3 __ovld __cnfn convert_ushort3_sat(uint3);\012ushort3 __ovld __cnfn convert_ushort3_rte(long3);\012ushort3 __ovld __cnfn convert_ushort3_sat_rte(long3);\012ushort3 __ovld __cnfn convert_ushort3_rtz(long3);\012ushort3 __ovld __cnfn convert_ushort3_sat_rtz(long3);\012ushort3 __ovld __cnfn convert_ushort3_rtp(long3);\012ushort3 __ovld __cnfn convert_ushort3_sat_rtp(long3);\012ushort3 __ovld __cnfn convert_ushort3_rtn(long3);\012ushort3 __ovld __cnfn convert_ushort3_sat_rtn(long3);\012ushort3 __ovld __cnfn convert_ushort3(long3);\012ushort3 __ovld __cnfn convert_ushort3_sat(long3);\012ushort3 __ovld __cnfn convert_ushort3_rte(ulong3);\012ushort3 __ovld __cnfn convert_ushort3_sat_rte(ulong3);\012ushort3 __ovld __cnfn convert_ushort3_rtz(ulong3);\012ushort3 __ovld __cnfn convert_ushort3_sat_rtz(ulong3);\012ushort3",
" __ovld __cnfn convert_ushort3_rtp(ulong3);\012ushort3 __ovld __cnfn convert_ushort3_sat_rtp(ulong3);\012ushort3 __ovld __cnfn convert_ushort3_rtn(ulong3);\012ushort3 __ovld __cnfn convert_ushort3_sat_rtn(ulong3);\012ushort3 __ovld __cnfn convert_ushort3(ulong3);\012ushort3 __ovld __cnfn convert_ushort3_sat(ulong3);\012ushort3 __ovld __cnfn convert_ushort3_rte(float3);\012ushort3 __ovld __cnfn convert_ushort3_sat_rte(float3);\012ushort3 __ovld __cnfn convert_ushort3_rtz(float3);\012ushort3 __ovld __cnfn convert_ushort3_sat_rtz(float3);\012ushort3 __ovld __cnfn convert_ushort3_rtp(float3);\012ushort3 __ovld __cnfn convert_ushort3_sat_rtp(float3);\012ushort3 __ovld __cnfn convert_ushort3_rtn(float3);\012ushort3 __ovld __cnfn convert_ushort3_sat_rtn(float3);\012ushort3 __ovld __cnfn convert_ushort3(float3);\012ushort3 __ovld __cnfn convert_ushort3_sat(float3);\012int3 __ovld __cnfn convert_int3_rte(char3);\012int3 __ovld __cnfn convert_int3_sat_rte(char3);\012int3 __ovld __cnfn convert_int3_rtz(char3);\012int3 __ovld __cnfn convert_int3_sat_rtz(char3);\012int3 __ovld __c",
"nfn convert_int3_rtp(char3);\012int3 __ovld __cnfn convert_int3_sat_rtp(char3);\012int3 __ovld __cnfn convert_int3_rtn(char3);\012int3 __ovld __cnfn convert_int3_sat_rtn(char3);\012int3 __ovld __cnfn convert_int3(char3);\012int3 __ovld __cnfn convert_int3_sat(char3);\012int3 __ovld __cnfn convert_int3_rte(uchar3);\012int3 __ovld __cnfn convert_int3_sat_rte(uchar3);\012int3 __ovld __cnfn convert_int3_rtz(uchar3);\012int3 __ovld __cnfn convert_int3_sat_rtz(uchar3);\012int3 __ovld __cnfn convert_int3_rtp(uchar3);\012int3 __ovld __cnfn convert_int3_sat_rtp(uchar3);\012int3 __ovld __cnfn convert_int3_rtn(uchar3);\012int3 __ovld __cnfn convert_int3_sat_rtn(uchar3);\012int3 __ovld __cnfn convert_int3(uchar3);\012int3 __ovld __cnfn convert_int3_sat(uchar3);\012int3 __ovld __cnfn convert_int3_rte(short3);\012int3 __ovld __cnfn convert_int3_sat_rte(short3);\012int3 __ovld __cnfn convert_int3_rtz(short3);\012int3 __ovld __cnfn convert_int3_sat_rtz(short3);\012int3 __ovld __cnfn convert_int3_rtp(short3);\012int3 __ovld __cnfn convert_int3_sat_rtp(short3);\012int3 __ovld __cnfn convert_",
"int3_rtn(short3);\012int3 __ovld __cnfn convert_int3_sat_rtn(short3);\012int3 __ovld __cnfn convert_int3(short3);\012int3 __ovld __cnfn convert_int3_sat(short3);\012int3 __ovld __cnfn convert_int3_rte(ushort3);\012int3 __ovld __cnfn convert_int3_sat_rte(ushort3);\012int3 __ovld __cnfn convert_int3_rtz(ushort3);\012int3 __ovld __cnfn convert_int3_sat_rtz(ushort3);\012int3 __ovld __cnfn convert_int3_rtp(ushort3);\012int3 __ovld __cnfn convert_int3_sat_rtp(ushort3);\012int3 __ovld __cnfn convert_int3_rtn(ushort3);\012int3 __ovld __cnfn convert_int3_sat_rtn(ushort3);\012int3 __ovld __cnfn convert_int3(ushort3);\012int3 __ovld __cnfn convert_int3_sat(ushort3);\012int3 __ovld __cnfn convert_int3_rte(int3);\012int3 __ovld __cnfn convert_int3_sat_rte(int3);\012int3 __ovld __cnfn convert_int3_rtz(int3);\012int3 __ovld __cnfn convert_int3_sat_rtz(int3);\012int3 __ovld __cnfn convert_int3_rtp(int3);\012int3 __ovld __cnfn convert_int3_sat_rtp(int3);\012int3 __ovld __cnfn convert_int3_rtn(int3);\012int3 __ovld __cnfn convert_int3_sat_rtn(int3);\012int3 __ovld __cnfn convert_int3(int3);\012",
"int3 __ovld __cnfn convert_int3_sat(int3);\012int3 __ovld __cnfn convert_int3_rte(uint3);\012int3 __ovld __cnfn convert_int3_sat_rte(uint3);\012int3 __ovld __cnfn convert_int3_rtz(uint3);\012int3 __ovld __cnfn convert_int3_sat_rtz(uint3);\012int3 __ovld __cnfn convert_int3_rtp(uint3);\012int3 __ovld __cnfn convert_int3_sat_rtp(uint3);\012int3 __ovld __cnfn convert_int3_rtn(uint3);\012int3 __ovld __cnfn convert_int3_sat_rtn(uint3);\012int3 __ovld __cnfn convert_int3(uint3);\012int3 __ovld __cnfn convert_int3_sat(uint3);\012int3 __ovld __cnfn convert_int3_rte(long3);\012int3 __ovld __cnfn convert_int3_sat_rte(long3);\012int3 __ovld __cnfn convert_int3_rtz(long3);\012int3 __ovld __cnfn convert_int3_sat_rtz(long3);\012int3 __ovld __cnfn convert_int3_rtp(long3);\012int3 __ovld __cnfn convert_int3_sat_rtp(long3);\012int3 __ovld __cnfn convert_int3_rtn(long3);\012int3 __ovld __cnfn convert_int3_sat_rtn(long3);\012int3 __ovld __cnfn convert_int3(long3);\012int3 __ovld __cnfn convert_int3_sat(long3);\012int3 __ovld __cnfn convert_int3_rte(ulong3);\012int3 __ovld __cnfn convert_int3_",
"sat_rte(ulong3);\012int3 __ovld __cnfn convert_int3_rtz(ulong3);\012int3 __ovld __cnfn convert_int3_sat_rtz(ulong3);\012int3 __ovld __cnfn convert_int3_rtp(ulong3);\012int3 __ovld __cnfn convert_int3_sat_rtp(ulong3);\012int3 __ovld __cnfn convert_int3_rtn(ulong3);\012int3 __ovld __cnfn convert_int3_sat_rtn(ulong3);\012int3 __ovld __cnfn convert_int3(ulong3);\012int3 __ovld __cnfn convert_int3_sat(ulong3);\012int3 __ovld __cnfn convert_int3_rte(float3);\012int3 __ovld __cnfn convert_int3_sat_rte(float3);\012int3 __ovld __cnfn convert_int3_rtz(float3);\012int3 __ovld __cnfn convert_int3_sat_rtz(float3);\012int3 __ovld __cnfn convert_int3_rtp(float3);\012int3 __ovld __cnfn convert_int3_sat_rtp(float3);\012int3 __ovld __cnfn convert_int3_rtn(float3);\012int3 __ovld __cnfn convert_int3_sat_rtn(float3);\012int3 __ovld __cnfn convert_int3(float3);\012int3 __ovld __cnfn convert_int3_sat(float3);\012uint3 __ovld __cnfn convert_uint3_rte(char3);\012uint3 __ovld __cnfn convert_uint3_sat_rte(char3);\012uint3 __ovld __cnfn convert_uint3_rtz(char3);\012uint3 __ovld __cnfn convert_uint3_s",
"at_rtz(char3);\012uint3 __ovld __cnfn convert_uint3_rtp(char3);\012uint3 __ovld __cnfn convert_uint3_sat_rtp(char3);\012uint3 __ovld __cnfn convert_uint3_rtn(char3);\012uint3 __ovld __cnfn convert_uint3_sat_rtn(char3);\012uint3 __ovld __cnfn convert_uint3(char3);\012uint3 __ovld __cnfn convert_uint3_sat(char3);\012uint3 __ovld __cnfn convert_uint3_rte(uchar3);\012uint3 __ovld __cnfn convert_uint3_sat_rte(uchar3);\012uint3 __ovld __cnfn convert_uint3_rtz(uchar3);\012uint3 __ovld __cnfn convert_uint3_sat_rtz(uchar3);\012uint3 __ovld __cnfn convert_uint3_rtp(uchar3);\012uint3 __ovld __cnfn convert_uint3_sat_rtp(uchar3);\012uint3 __ovld __cnfn convert_uint3_rtn(uchar3);\012uint3 __ovld __cnfn convert_uint3_sat_rtn(uchar3);\012uint3 __ovld __cnfn convert_uint3(uchar3);\012uint3 __ovld __cnfn convert_uint3_sat(uchar3);\012uint3 __ovld __cnfn convert_uint3_rte(short3);\012uint3 __ovld __cnfn convert_uint3_sat_rte(short3);\012uint3 __ovld __cnfn convert_uint3_rtz(short3);\012uint3 __ovld __cnfn convert_uint3_sat_rtz(short3);\012uint3 __ovld __cnfn convert_uint3_rtp(short3);\012uint",
"3 __ovld __cnfn convert_uint3_sat_rtp(short3);\012uint3 __ovld __cnfn convert_uint3_rtn(short3);\012uint3 __ovld __cnfn convert_uint3_sat_rtn(short3);\012uint3 __ovld __cnfn convert_uint3(short3);\012uint3 __ovld __cnfn convert_uint3_sat(short3);\012uint3 __ovld __cnfn convert_uint3_rte(ushort3);\012uint3 __ovld __cnfn convert_uint3_sat_rte(ushort3);\012uint3 __ovld __cnfn convert_uint3_rtz(ushort3);\012uint3 __ovld __cnfn convert_uint3_sat_rtz(ushort3);\012uint3 __ovld __cnfn convert_uint3_rtp(ushort3);\012uint3 __ovld __cnfn convert_uint3_sat_rtp(ushort3);\012uint3 __ovld __cnfn convert_uint3_rtn(ushort3);\012uint3 __ovld __cnfn convert_uint3_sat_rtn(ushort3);\012uint3 __ovld __cnfn convert_uint3(ushort3);\012uint3 __ovld __cnfn convert_uint3_sat(ushort3);\012uint3 __ovld __cnfn convert_uint3_rte(int3);\012uint3 __ovld __cnfn convert_uint3_sat_rte(int3);\012uint3 __ovld __cnfn convert_uint3_rtz(int3);\012uint3 __ovld __cnfn convert_uint3_sat_rtz(int3);\012uint3 __ovld __cnfn convert_uint3_rtp(int3);\012uint3 __ovld __cnfn convert_uint3_sat_rtp(int3);\012uint3 __ovld __",
"cnfn convert_uint3_rtn(int3);\012uint3 __ovld __cnfn convert_uint3_sat_rtn(int3);\012uint3 __ovld __cnfn convert_uint3(int3);\012uint3 __ovld __cnfn convert_uint3_sat(int3);\012uint3 __ovld __cnfn convert_uint3_rte(uint3);\012uint3 __ovld __cnfn convert_uint3_sat_rte(uint3);\012uint3 __ovld __cnfn convert_uint3_rtz(uint3);\012uint3 __ovld __cnfn convert_uint3_sat_rtz(uint3);\012uint3 __ovld __cnfn convert_uint3_rtp(uint3);\012uint3 __ovld __cnfn convert_uint3_sat_rtp(uint3);\012uint3 __ovld __cnfn convert_uint3_rtn(uint3);\012uint3 __ovld __cnfn convert_uint3_sat_rtn(uint3);\012uint3 __ovld __cnfn convert_uint3(uint3);\012uint3 __ovld __cnfn convert_uint3_sat(uint3);\012uint3 __ovld __cnfn convert_uint3_rte(long3);\012uint3 __ovld __cnfn convert_uint3_sat_rte(long3);\012uint3 __ovld __cnfn convert_uint3_rtz(long3);\012uint3 __ovld __cnfn convert_uint3_sat_rtz(long3);\012uint3 __ovld __cnfn convert_uint3_rtp(long3);\012uint3 __ovld __cnfn convert_uint3_sat_rtp(long3);\012uint3 __ovld __cnfn convert_uint3_rtn(long3);\012uint3 __ovld __cnfn convert_uint3_sat_rtn(long3);\012uin",
"t3 __ovld __cnfn convert_uint3(long3);\012uint3 __ovld __cnfn convert_uint3_sat(long3);\012uint3 __ovld __cnfn convert_uint3_rte(ulong3);\012uint3 __ovld __cnfn convert_uint3_sat_rte(ulong3);\012uint3 __ovld __cnfn convert_uint3_rtz(ulong3);\012uint3 __ovld __cnfn convert_uint3_sat_rtz(ulong3);\012uint3 __ovld __cnfn convert_uint3_rtp(ulong3);\012uint3 __ovld __cnfn convert_uint3_sat_rtp(ulong3);\012uint3 __ovld __cnfn convert_uint3_rtn(ulong3);\012uint3 __ovld __cnfn convert_uint3_sat_rtn(ulong3);\012uint3 __ovld __cnfn convert_uint3(ulong3);\012uint3 __ovld __cnfn convert_uint3_sat(ulong3);\012uint3 __ovld __cnfn convert_uint3_rte(float3);\012uint3 __ovld __cnfn convert_uint3_sat_rte(float3);\012uint3 __ovld __cnfn convert_uint3_rtz(float3);\012uint3 __ovld __cnfn convert_uint3_sat_rtz(float3);\012uint3 __ovld __cnfn convert_uint3_rtp(float3);\012uint3 __ovld __cnfn convert_uint3_sat_rtp(float3);\012uint3 __ovld __cnfn convert_uint3_rtn(float3);\012uint3 __ovld __cnfn convert_uint3_sat_rtn(float3);\012uint3 __ovld __cnfn convert_uint3(float3);\012uint3 __ovld __cnfn co",
"nvert_uint3_sat(float3);\012long3 __ovld __cnfn convert_long3_rte(char3);\012long3 __ovld __cnfn convert_long3_sat_rte(char3);\012long3 __ovld __cnfn convert_long3_rtz(char3);\012long3 __ovld __cnfn convert_long3_sat_rtz(char3);\012long3 __ovld __cnfn convert_long3_rtp(char3);\012long3 __ovld __cnfn convert_long3_sat_rtp(char3);\012long3 __ovld __cnfn convert_long3_rtn(char3);\012long3 __ovld __cnfn convert_long3_sat_rtn(char3);\012long3 __ovld __cnfn convert_long3(char3);\012long3 __ovld __cnfn convert_long3_sat(char3);\012long3 __ovld __cnfn convert_long3_rte(uchar3);\012long3 __ovld __cnfn convert_long3_sat_rte(uchar3);\012long3 __ovld __cnfn convert_long3_rtz(uchar3);\012long3 __ovld __cnfn convert_long3_sat_rtz(uchar3);\012long3 __ovld __cnfn convert_long3_rtp(uchar3);\012long3 __ovld __cnfn convert_long3_sat_rtp(uchar3);\012long3 __ovld __cnfn convert_long3_rtn(uchar3);\012long3 __ovld __cnfn convert_long3_sat_rtn(uchar3);\012long3 __ovld __cnfn convert_long3(uchar3);\012long3 __ovld __cnfn convert_long3_sat(uchar3);\012long3 __ovld __cnfn convert_long3_rte(short3)",
";\012long3 __ovld __cnfn convert_long3_sat_rte(short3);\012long3 __ovld __cnfn convert_long3_rtz(short3);\012long3 __ovld __cnfn convert_long3_sat_rtz(short3);\012long3 __ovld __cnfn convert_long3_rtp(short3);\012long3 __ovld __cnfn convert_long3_sat_rtp(short3);\012long3 __ovld __cnfn convert_long3_rtn(short3);\012long3 __ovld __cnfn convert_long3_sat_rtn(short3);\012long3 __ovld __cnfn convert_long3(short3);\012long3 __ovld __cnfn convert_long3_sat(short3);\012long3 __ovld __cnfn convert_long3_rte(ushort3);\012long3 __ovld __cnfn convert_long3_sat_rte(ushort3);\012long3 __ovld __cnfn convert_long3_rtz(ushort3);\012long3 __ovld __cnfn convert_long3_sat_rtz(ushort3);\012long3 __ovld __cnfn convert_long3_rtp(ushort3);\012long3 __ovld __cnfn convert_long3_sat_rtp(ushort3);\012long3 __ovld __cnfn convert_long3_rtn(ushort3);\012long3 __ovld __cnfn convert_long3_sat_rtn(ushort3);\012long3 __ovld __cnfn convert_long3(ushort3);\012long3 __ovld __cnfn convert_long3_sat(ushort3);\012long3 __ovld __cnfn convert_long3_rte(int3);\012long3 __ovld __cnfn convert_long3_sat_rte(int3);\012l",
"ong3 __ovld __cnfn convert_long3_rtz(int3);\012long3 __ovld __cnfn convert_long3_sat_rtz(int3);\012long3 __ovld __cnfn convert_long3_rtp(int3);\012long3 __ovld __cnfn convert_long3_sat_rtp(int3);\012long3 __ovld __cnfn convert_long3_rtn(int3);\012long3 __ovld __cnfn convert_long3_sat_rtn(int3);\012long3 __ovld __cnfn convert_long3(int3);\012long3 __ovld __cnfn convert_long3_sat(int3);\012long3 __ovld __cnfn convert_long3_rte(uint3);\012long3 __ovld __cnfn convert_long3_sat_rte(uint3);\012long3 __ovld __cnfn convert_long3_rtz(uint3);\012long3 __ovld __cnfn convert_long3_sat_rtz(uint3);\012long3 __ovld __cnfn convert_long3_rtp(uint3);\012long3 __ovld __cnfn convert_long3_sat_rtp(uint3);\012long3 __ovld __cnfn convert_long3_rtn(uint3);\012long3 __ovld __cnfn convert_long3_sat_rtn(uint3);\012long3 __ovld __cnfn convert_long3(uint3);\012long3 __ovld __cnfn convert_long3_sat(uint3);\012long3 __ovld __cnfn convert_long3_rte(long3);\012long3 __ovld __cnfn convert_long3_sat_rte(long3);\012long3 __ovld __cnfn convert_long3_rtz(long3);\012long3 __ovld __cnfn convert_long3_sat_rtz(l",
"ong3);\012long3 __ovld __cnfn convert_long3_rtp(long3);\012long3 __ovld __cnfn convert_long3_sat_rtp(long3);\012long3 __ovld __cnfn convert_long3_rtn(long3);\012long3 __ovld __cnfn convert_long3_sat_rtn(long3);\012long3 __ovld __cnfn convert_long3(long3);\012long3 __ovld __cnfn convert_long3_sat(long3);\012long3 __ovld __cnfn convert_long3_rte(ulong3);\012long3 __ovld __cnfn convert_long3_sat_rte(ulong3);\012long3 __ovld __cnfn convert_long3_rtz(ulong3);\012long3 __ovld __cnfn convert_long3_sat_rtz(ulong3);\012long3 __ovld __cnfn convert_long3_rtp(ulong3);\012long3 __ovld __cnfn convert_long3_sat_rtp(ulong3);\012long3 __ovld __cnfn convert_long3_rtn(ulong3);\012long3 __ovld __cnfn convert_long3_sat_rtn(ulong3);\012long3 __ovld __cnfn convert_long3(ulong3);\012long3 __ovld __cnfn convert_long3_sat(ulong3);\012long3 __ovld __cnfn convert_long3_rte(float3);\012long3 __ovld __cnfn convert_long3_sat_rte(float3);\012long3 __ovld __cnfn convert_long3_rtz(float3);\012long3 __ovld __cnfn convert_long3_sat_rtz(float3);\012long3 __ovld __cnfn convert_long3_rtp(float3);\012long3 __ovld",
" __cnfn convert_long3_sat_rtp(float3);\012long3 __ovld __cnfn convert_long3_rtn(float3);\012long3 __ovld __cnfn convert_long3_sat_rtn(float3);\012long3 __ovld __cnfn convert_long3(float3);\012long3 __ovld __cnfn convert_long3_sat(float3);\012ulong3 __ovld __cnfn convert_ulong3_rte(char3);\012ulong3 __ovld __cnfn convert_ulong3_sat_rte(char3);\012ulong3 __ovld __cnfn convert_ulong3_rtz(char3);\012ulong3 __ovld __cnfn convert_ulong3_sat_rtz(char3);\012ulong3 __ovld __cnfn convert_ulong3_rtp(char3);\012ulong3 __ovld __cnfn convert_ulong3_sat_rtp(char3);\012ulong3 __ovld __cnfn convert_ulong3_rtn(char3);\012ulong3 __ovld __cnfn convert_ulong3_sat_rtn(char3);\012ulong3 __ovld __cnfn convert_ulong3(char3);\012ulong3 __ovld __cnfn convert_ulong3_sat(char3);\012ulong3 __ovld __cnfn convert_ulong3_rte(uchar3);\012ulong3 __ovld __cnfn convert_ulong3_sat_rte(uchar3);\012ulong3 __ovld __cnfn convert_ulong3_rtz(uchar3);\012ulong3 __ovld __cnfn convert_ulong3_sat_rtz(uchar3);\012ulong3 __ovld __cnfn convert_ulong3_rtp(uchar3);\012ulong3 __ovld __cnfn convert_ulong3_sat_rtp(uchar3);",
"\012ulong3 __ovld __cnfn convert_ulong3_rtn(uchar3);\012ulong3 __ovld __cnfn convert_ulong3_sat_rtn(uchar3);\012ulong3 __ovld __cnfn convert_ulong3(uchar3);\012ulong3 __ovld __cnfn convert_ulong3_sat(uchar3);\012ulong3 __ovld __cnfn convert_ulong3_rte(short3);\012ulong3 __ovld __cnfn convert_ulong3_sat_rte(short3);\012ulong3 __ovld __cnfn convert_ulong3_rtz(short3);\012ulong3 __ovld __cnfn convert_ulong3_sat_rtz(short3);\012ulong3 __ovld __cnfn convert_ulong3_rtp(short3);\012ulong3 __ovld __cnfn convert_ulong3_sat_rtp(short3);\012ulong3 __ovld __cnfn convert_ulong3_rtn(short3);\012ulong3 __ovld __cnfn convert_ulong3_sat_rtn(short3);\012ulong3 __ovld __cnfn convert_ulong3(short3);\012ulong3 __ovld __cnfn convert_ulong3_sat(short3);\012ulong3 __ovld __cnfn convert_ulong3_rte(ushort3);\012ulong3 __ovld __cnfn convert_ulong3_sat_rte(ushort3);\012ulong3 __ovld __cnfn convert_ulong3_rtz(ushort3);\012ulong3 __ovld __cnfn convert_ulong3_sat_rtz(ushort3);\012ulong3 __ovld __cnfn convert_ulong3_rtp(ushort3);\012ulong3 __ovld __cnfn convert_ulong3_sat_rtp(ushort3);\012ulong3 __ovld",
" __cnfn convert_ulong3_rtn(ushort3);\012ulong3 __ovld __cnfn convert_ulong3_sat_rtn(ushort3);\012ulong3 __ovld __cnfn convert_ulong3(ushort3);\012ulong3 __ovld __cnfn convert_ulong3_sat(ushort3);\012ulong3 __ovld __cnfn convert_ulong3_rte(int3);\012ulong3 __ovld __cnfn convert_ulong3_sat_rte(int3);\012ulong3 __ovld __cnfn convert_ulong3_rtz(int3);\012ulong3 __ovld __cnfn convert_ulong3_sat_rtz(int3);\012ulong3 __ovld __cnfn convert_ulong3_rtp(int3);\012ulong3 __ovld __cnfn convert_ulong3_sat_rtp(int3);\012ulong3 __ovld __cnfn convert_ulong3_rtn(int3);\012ulong3 __ovld __cnfn convert_ulong3_sat_rtn(int3);\012ulong3 __ovld __cnfn convert_ulong3(int3);\012ulong3 __ovld __cnfn convert_ulong3_sat(int3);\012ulong3 __ovld __cnfn convert_ulong3_rte(uint3);\012ulong3 __ovld __cnfn convert_ulong3_sat_rte(uint3);\012ulong3 __ovld __cnfn convert_ulong3_rtz(uint3);\012ulong3 __ovld __cnfn convert_ulong3_sat_rtz(uint3);\012ulong3 __ovld __cnfn convert_ulong3_rtp(uint3);\012ulong3 __ovld __cnfn convert_ulong3_sat_rtp(uint3);\012ulong3 __ovld __cnfn convert_ulong3_rtn(uint3);\012ulong3 ",
"__ovld __cnfn convert_ulong3_sat_rtn(uint3);\012ulong3 __ovld __cnfn convert_ulong3(uint3);\012ulong3 __ovld __cnfn convert_ulong3_sat(uint3);\012ulong3 __ovld __cnfn convert_ulong3_rte(long3);\012ulong3 __ovld __cnfn convert_ulong3_sat_rte(long3);\012ulong3 __ovld __cnfn convert_ulong3_rtz(long3);\012ulong3 __ovld __cnfn convert_ulong3_sat_rtz(long3);\012ulong3 __ovld __cnfn convert_ulong3_rtp(long3);\012ulong3 __ovld __cnfn convert_ulong3_sat_rtp(long3);\012ulong3 __ovld __cnfn convert_ulong3_rtn(long3);\012ulong3 __ovld __cnfn convert_ulong3_sat_rtn(long3);\012ulong3 __ovld __cnfn convert_ulong3(long3);\012ulong3 __ovld __cnfn convert_ulong3_sat(long3);\012ulong3 __ovld __cnfn convert_ulong3_rte(ulong3);\012ulong3 __ovld __cnfn convert_ulong3_sat_rte(ulong3);\012ulong3 __ovld __cnfn convert_ulong3_rtz(ulong3);\012ulong3 __ovld __cnfn convert_ulong3_sat_rtz(ulong3);\012ulong3 __ovld __cnfn convert_ulong3_rtp(ulong3);\012ulong3 __ovld __cnfn convert_ulong3_sat_rtp(ulong3);\012ulong3 __ovld __cnfn convert_ulong3_rtn(ulong3);\012ulong3 __ovld __cnfn convert_ulong3_sat_",
"rtn(ulong3);\012ulong3 __ovld __cnfn convert_ulong3(ulong3);\012ulong3 __ovld __cnfn convert_ulong3_sat(ulong3);\012ulong3 __ovld __cnfn convert_ulong3_rte(float3);\012ulong3 __ovld __cnfn convert_ulong3_sat_rte(float3);\012ulong3 __ovld __cnfn convert_ulong3_rtz(float3);\012ulong3 __ovld __cnfn convert_ulong3_sat_rtz(float3);\012ulong3 __ovld __cnfn convert_ulong3_rtp(float3);\012ulong3 __ovld __cnfn convert_ulong3_sat_rtp(float3);\012ulong3 __ovld __cnfn convert_ulong3_rtn(float3);\012ulong3 __ovld __cnfn convert_ulong3_sat_rtn(float3);\012ulong3 __ovld __cnfn convert_ulong3(float3);\012ulong3 __ovld __cnfn convert_ulong3_sat(float3);\012float3 __ovld __cnfn convert_float3_rte(char3);\012float3 __ovld __cnfn convert_float3_rtz(char3);\012float3 __ovld __cnfn convert_float3_rtp(char3);\012float3 __ovld __cnfn convert_float3_rtn(char3);\012float3 __ovld __cnfn convert_float3(char3);\012float3 __ovld __cnfn convert_float3_rte(uchar3);\012float3 __ovld __cnfn convert_float3_rtz(uchar3);\012float3 __ovld __cnfn convert_float3_rtp(uchar3);\012float3 __ovld __cnfn convert_flo",
"at3_rtn(uchar3);\012float3 __ovld __cnfn convert_float3(uchar3);\012float3 __ovld __cnfn convert_float3_rte(short3);\012float3 __ovld __cnfn convert_float3_rtz(short3);\012float3 __ovld __cnfn convert_float3_rtp(short3);\012float3 __ovld __cnfn convert_float3_rtn(short3);\012float3 __ovld __cnfn convert_float3(short3);\012float3 __ovld __cnfn convert_float3_rte(ushort3);\012float3 __ovld __cnfn convert_float3_rtz(ushort3);\012float3 __ovld __cnfn convert_float3_rtp(ushort3);\012float3 __ovld __cnfn convert_float3_rtn(ushort3);\012float3 __ovld __cnfn convert_float3(ushort3);\012float3 __ovld __cnfn convert_float3_rte(int3);\012float3 __ovld __cnfn convert_float3_rtz(int3);\012float3 __ovld __cnfn convert_float3_rtp(int3);\012float3 __ovld __cnfn convert_float3_rtn(int3);\012float3 __ovld __cnfn convert_float3(int3);\012float3 __ovld __cnfn convert_float3_rte(uint3);\012float3 __ovld __cnfn convert_float3_rtz(uint3);\012float3 __ovld __cnfn convert_float3_rtp(uint3);\012float3 __ovld __cnfn convert_float3_rtn(uint3);\012float3 __ovld __cnfn convert_float3(uint3);\012float3 _",
"_ovld __cnfn convert_float3_rte(long3);\012float3 __ovld __cnfn convert_float3_rtz(long3);\012float3 __ovld __cnfn convert_float3_rtp(long3);\012float3 __ovld __cnfn convert_float3_rtn(long3);\012float3 __ovld __cnfn convert_float3(long3);\012float3 __ovld __cnfn convert_float3_rte(ulong3);\012float3 __ovld __cnfn convert_float3_rtz(ulong3);\012float3 __ovld __cnfn convert_float3_rtp(ulong3);\012float3 __ovld __cnfn convert_float3_rtn(ulong3);\012float3 __ovld __cnfn convert_float3(ulong3);\012float3 __ovld __cnfn convert_float3_rte(float3);\012float3 __ovld __cnfn convert_float3_rtz(float3);\012float3 __ovld __cnfn convert_float3_rtp(float3);\012float3 __ovld __cnfn convert_float3_rtn(float3);\012float3 __ovld __cnfn convert_float3(float3);\012char4 __ovld __cnfn convert_char4_rte(char4);\012char4 __ovld __cnfn convert_char4_sat_rte(char4);\012char4 __ovld __cnfn convert_char4_rtz(char4);\012char4 __ovld __cnfn convert_char4_sat_rtz(char4);\012char4 __ovld __cnfn convert_char4_rtp(char4);\012char4 __ovld __cnfn convert_char4_sat_rtp(char4);\012char4 __ovld __cnfn conver",
"t_char4_rtn(char4);\012char4 __ovld __cnfn convert_char4_sat_rtn(char4);\012char4 __ovld __cnfn convert_char4(char4);\012char4 __ovld __cnfn convert_char4_sat(char4);\012char4 __ovld __cnfn convert_char4_rte(uchar4);\012char4 __ovld __cnfn convert_char4_sat_rte(uchar4);\012char4 __ovld __cnfn convert_char4_rtz(uchar4);\012char4 __ovld __cnfn convert_char4_sat_rtz(uchar4);\012char4 __ovld __cnfn convert_char4_rtp(uchar4);\012char4 __ovld __cnfn convert_char4_sat_rtp(uchar4);\012char4 __ovld __cnfn convert_char4_rtn(uchar4);\012char4 __ovld __cnfn convert_char4_sat_rtn(uchar4);\012char4 __ovld __cnfn convert_char4(uchar4);\012char4 __ovld __cnfn convert_char4_sat(uchar4);\012char4 __ovld __cnfn convert_char4_rte(short4);\012char4 __ovld __cnfn convert_char4_sat_rte(short4);\012char4 __ovld __cnfn convert_char4_rtz(short4);\012char4 __ovld __cnfn convert_char4_sat_rtz(short4);\012char4 __ovld __cnfn convert_char4_rtp(short4);\012char4 __ovld __cnfn convert_char4_sat_rtp(short4);\012char4 __ovld __cnfn convert_char4_rtn(short4);\012char4 __ovld __cnfn convert_char4_sat_rtn(s",
"hort4);\012char4 __ovld __cnfn convert_char4(short4);\012char4 __ovld __cnfn convert_char4_sat(short4);\012char4 __ovld __cnfn convert_char4_rte(ushort4);\012char4 __ovld __cnfn convert_char4_sat_rte(ushort4);\012char4 __ovld __cnfn convert_char4_rtz(ushort4);\012char4 __ovld __cnfn convert_char4_sat_rtz(ushort4);\012char4 __ovld __cnfn convert_char4_rtp(ushort4);\012char4 __ovld __cnfn convert_char4_sat_rtp(ushort4);\012char4 __ovld __cnfn convert_char4_rtn(ushort4);\012char4 __ovld __cnfn convert_char4_sat_rtn(ushort4);\012char4 __ovld __cnfn convert_char4(ushort4);\012char4 __ovld __cnfn convert_char4_sat(ushort4);\012char4 __ovld __cnfn convert_char4_rte(int4);\012char4 __ovld __cnfn convert_char4_sat_rte(int4);\012char4 __ovld __cnfn convert_char4_rtz(int4);\012char4 __ovld __cnfn convert_char4_sat_rtz(int4);\012char4 __ovld __cnfn convert_char4_rtp(int4);\012char4 __ovld __cnfn convert_char4_sat_rtp(int4);\012char4 __ovld __cnfn convert_char4_rtn(int4);\012char4 __ovld __cnfn convert_char4_sat_rtn(int4);\012char4 __ovld __cnfn convert_char4(int4);\012char4 __ovld __cn",
"fn convert_char4_sat(int4);\012char4 __ovld __cnfn convert_char4_rte(uint4);\012char4 __ovld __cnfn convert_char4_sat_rte(uint4);\012char4 __ovld __cnfn convert_char4_rtz(uint4);\012char4 __ovld __cnfn convert_char4_sat_rtz(uint4);\012char4 __ovld __cnfn convert_char4_rtp(uint4);\012char4 __ovld __cnfn convert_char4_sat_rtp(uint4);\012char4 __ovld __cnfn convert_char4_rtn(uint4);\012char4 __ovld __cnfn convert_char4_sat_rtn(uint4);\012char4 __ovld __cnfn convert_char4(uint4);\012char4 __ovld __cnfn convert_char4_sat(uint4);\012char4 __ovld __cnfn convert_char4_rte(long4);\012char4 __ovld __cnfn convert_char4_sat_rte(long4);\012char4 __ovld __cnfn convert_char4_rtz(long4);\012char4 __ovld __cnfn convert_char4_sat_rtz(long4);\012char4 __ovld __cnfn convert_char4_rtp(long4);\012char4 __ovld __cnfn convert_char4_sat_rtp(long4);\012char4 __ovld __cnfn convert_char4_rtn(long4);\012char4 __ovld __cnfn convert_char4_sat_rtn(long4);\012char4 __ovld __cnfn convert_char4(long4);\012char4 __ovld __cnfn convert_char4_sat(long4);\012char4 __ovld __cnfn convert_char4_rte(ulong4);\012char4",
" __ovld __cnfn convert_char4_sat_rte(ulong4);\012char4 __ovld __cnfn convert_char4_rtz(ulong4);\012char4 __ovld __cnfn convert_char4_sat_rtz(ulong4);\012char4 __ovld __cnfn convert_char4_rtp(ulong4);\012char4 __ovld __cnfn convert_char4_sat_rtp(ulong4);\012char4 __ovld __cnfn convert_char4_rtn(ulong4);\012char4 __ovld __cnfn convert_char4_sat_rtn(ulong4);\012char4 __ovld __cnfn convert_char4(ulong4);\012char4 __ovld __cnfn convert_char4_sat(ulong4);\012char4 __ovld __cnfn convert_char4_rte(float4);\012char4 __ovld __cnfn convert_char4_sat_rte(float4);\012char4 __ovld __cnfn convert_char4_rtz(float4);\012char4 __ovld __cnfn convert_char4_sat_rtz(float4);\012char4 __ovld __cnfn convert_char4_rtp(float4);\012char4 __ovld __cnfn convert_char4_sat_rtp(float4);\012char4 __ovld __cnfn convert_char4_rtn(float4);\012char4 __ovld __cnfn convert_char4_sat_rtn(float4);\012char4 __ovld __cnfn convert_char4(float4);\012char4 __ovld __cnfn convert_char4_sat(float4);\012uchar4 __ovld __cnfn convert_uchar4_rte(char4);\012uchar4 __ovld __cnfn convert_uchar4_sat_rte(char4);\012uchar4 __ovl",
"d __cnfn convert_uchar4_rtz(char4);\012uchar4 __ovld __cnfn convert_uchar4_sat_rtz(char4);\012uchar4 __ovld __cnfn convert_uchar4_rtp(char4);\012uchar4 __ovld __cnfn convert_uchar4_sat_rtp(char4);\012uchar4 __ovld __cnfn convert_uchar4_rtn(char4);\012uchar4 __ovld __cnfn convert_uchar4_sat_rtn(char4);\012uchar4 __ovld __cnfn convert_uchar4(char4);\012uchar4 __ovld __cnfn convert_uchar4_sat(char4);\012uchar4 __ovld __cnfn convert_uchar4_rte(uchar4);\012uchar4 __ovld __cnfn convert_uchar4_sat_rte(uchar4);\012uchar4 __ovld __cnfn convert_uchar4_rtz(uchar4);\012uchar4 __ovld __cnfn convert_uchar4_sat_rtz(uchar4);\012uchar4 __ovld __cnfn convert_uchar4_rtp(uchar4);\012uchar4 __ovld __cnfn convert_uchar4_sat_rtp(uchar4);\012uchar4 __ovld __cnfn convert_uchar4_rtn(uchar4);\012uchar4 __ovld __cnfn convert_uchar4_sat_rtn(uchar4);\012uchar4 __ovld __cnfn convert_uchar4(uchar4);\012uchar4 __ovld __cnfn convert_uchar4_sat(uchar4);\012uchar4 __ovld __cnfn convert_uchar4_rte(short4);\012uchar4 __ovld __cnfn convert_uchar4_sat_rte(short4);\012uchar4 __ovld __cnfn convert_uchar4_rtz(",
"short4);\012uchar4 __ovld __cnfn convert_uchar4_sat_rtz(short4);\012uchar4 __ovld __cnfn convert_uchar4_rtp(short4);\012uchar4 __ovld __cnfn convert_uchar4_sat_rtp(short4);\012uchar4 __ovld __cnfn convert_uchar4_rtn(short4);\012uchar4 __ovld __cnfn convert_uchar4_sat_rtn(short4);\012uchar4 __ovld __cnfn convert_uchar4(short4);\012uchar4 __ovld __cnfn convert_uchar4_sat(short4);\012uchar4 __ovld __cnfn convert_uchar4_rte(ushort4);\012uchar4 __ovld __cnfn convert_uchar4_sat_rte(ushort4);\012uchar4 __ovld __cnfn convert_uchar4_rtz(ushort4);\012uchar4 __ovld __cnfn convert_uchar4_sat_rtz(ushort4);\012uchar4 __ovld __cnfn convert_uchar4_rtp(ushort4);\012uchar4 __ovld __cnfn convert_uchar4_sat_rtp(ushort4);\012uchar4 __ovld __cnfn convert_uchar4_rtn(ushort4);\012uchar4 __ovld __cnfn convert_uchar4_sat_rtn(ushort4);\012uchar4 __ovld __cnfn convert_uchar4(ushort4);\012uchar4 __ovld __cnfn convert_uchar4_sat(ushort4);\012uchar4 __ovld __cnfn convert_uchar4_rte(int4);\012uchar4 __ovld __cnfn convert_uchar4_sat_rte(int4);\012uchar4 __ovld __cnfn convert_uchar4_rtz(int4);\012uchar4 ",
"__ovld __cnfn convert_uchar4_sat_rtz(int4);\012uchar4 __ovld __cnfn convert_uchar4_rtp(int4);\012uchar4 __ovld __cnfn convert_uchar4_sat_rtp(int4);\012uchar4 __ovld __cnfn convert_uchar4_rtn(int4);\012uchar4 __ovld __cnfn convert_uchar4_sat_rtn(int4);\012uchar4 __ovld __cnfn convert_uchar4(int4);\012uchar4 __ovld __cnfn convert_uchar4_sat(int4);\012uchar4 __ovld __cnfn convert_uchar4_rte(uint4);\012uchar4 __ovld __cnfn convert_uchar4_sat_rte(uint4);\012uchar4 __ovld __cnfn convert_uchar4_rtz(uint4);\012uchar4 __ovld __cnfn convert_uchar4_sat_rtz(uint4);\012uchar4 __ovld __cnfn convert_uchar4_rtp(uint4);\012uchar4 __ovld __cnfn convert_uchar4_sat_rtp(uint4);\012uchar4 __ovld __cnfn convert_uchar4_rtn(uint4);\012uchar4 __ovld __cnfn convert_uchar4_sat_rtn(uint4);\012uchar4 __ovld __cnfn convert_uchar4(uint4);\012uchar4 __ovld __cnfn convert_uchar4_sat(uint4);\012uchar4 __ovld __cnfn convert_uchar4_rte(long4);\012uchar4 __ovld __cnfn convert_uchar4_sat_rte(long4);\012uchar4 __ovld __cnfn convert_uchar4_rtz(long4);\012uchar4 __ovld __cnfn convert_uchar4_sat_rtz(long4);\012uc",
"har4 __ovld __cnfn convert_uchar4_rtp(long4);\012uchar4 __ovld __cnfn convert_uchar4_sat_rtp(long4);\012uchar4 __ovld __cnfn convert_uchar4_rtn(long4);\012uchar4 __ovld __cnfn convert_uchar4_sat_rtn(long4);\012uchar4 __ovld __cnfn convert_uchar4(long4);\012uchar4 __ovld __cnfn convert_uchar4_sat(long4);\012uchar4 __ovld __cnfn convert_uchar4_rte(ulong4);\012uchar4 __ovld __cnfn convert_uchar4_sat_rte(ulong4);\012uchar4 __ovld __cnfn convert_uchar4_rtz(ulong4);\012uchar4 __ovld __cnfn convert_uchar4_sat_rtz(ulong4);\012uchar4 __ovld __cnfn convert_uchar4_rtp(ulong4);\012uchar4 __ovld __cnfn convert_uchar4_sat_rtp(ulong4);\012uchar4 __ovld __cnfn convert_uchar4_rtn(ulong4);\012uchar4 __ovld __cnfn convert_uchar4_sat_rtn(ulong4);\012uchar4 __ovld __cnfn convert_uchar4(ulong4);\012uchar4 __ovld __cnfn convert_uchar4_sat(ulong4);\012uchar4 __ovld __cnfn convert_uchar4_rte(float4);\012uchar4 __ovld __cnfn convert_uchar4_sat_rte(float4);\012uchar4 __ovld __cnfn convert_uchar4_rtz(float4);\012uchar4 __ovld __cnfn convert_uchar4_sat_rtz(float4);\012uchar4 __ovld __cnfn convert",
"_uchar4_rtp(float4);\012uchar4 __ovld __cnfn convert_uchar4_sat_rtp(float4);\012uchar4 __ovld __cnfn convert_uchar4_rtn(float4);\012uchar4 __ovld __cnfn convert_uchar4_sat_rtn(float4);\012uchar4 __ovld __cnfn convert_uchar4(float4);\012uchar4 __ovld __cnfn convert_uchar4_sat(float4);\012short4 __ovld __cnfn convert_short4_rte(char4);\012short4 __ovld __cnfn convert_short4_sat_rte(char4);\012short4 __ovld __cnfn convert_short4_rtz(char4);\012short4 __ovld __cnfn convert_short4_sat_rtz(char4);\012short4 __ovld __cnfn convert_short4_rtp(char4);\012short4 __ovld __cnfn convert_short4_sat_rtp(char4);\012short4 __ovld __cnfn convert_short4_rtn(char4);\012short4 __ovld __cnfn convert_short4_sat_rtn(char4);\012short4 __ovld __cnfn convert_short4(char4);\012short4 __ovld __cnfn convert_short4_sat(char4);\012short4 __ovld __cnfn convert_short4_rte(uchar4);\012short4 __ovld __cnfn convert_short4_sat_rte(uchar4);\012short4 __ovld __cnfn convert_short4_rtz(uchar4);\012short4 __ovld __cnfn convert_short4_sat_rtz(uchar4);\012short4 __ovld __cnfn convert_short4_rtp(uchar4);\012short4 __",
"ovld __cnfn convert_short4_sat_rtp(uchar4);\012short4 __ovld __cnfn convert_short4_rtn(uchar4);\012short4 __ovld __cnfn convert_short4_sat_rtn(uchar4);\012short4 __ovld __cnfn convert_short4(uchar4);\012short4 __ovld __cnfn convert_short4_sat(uchar4);\012short4 __ovld __cnfn convert_short4_rte(short4);\012short4 __ovld __cnfn convert_short4_sat_rte(short4);\012short4 __ovld __cnfn convert_short4_rtz(short4);\012short4 __ovld __cnfn convert_short4_sat_rtz(short4);\012short4 __ovld __cnfn convert_short4_rtp(short4);\012short4 __ovld __cnfn convert_short4_sat_rtp(short4);\012short4 __ovld __cnfn convert_short4_rtn(short4);\012short4 __ovld __cnfn convert_short4_sat_rtn(short4);\012short4 __ovld __cnfn convert_short4(short4);\012short4 __ovld __cnfn convert_short4_sat(short4);\012short4 __ovld __cnfn convert_short4_rte(ushort4);\012short4 __ovld __cnfn convert_short4_sat_rte(ushort4);\012short4 __ovld __cnfn convert_short4_rtz(ushort4);\012short4 __ovld __cnfn convert_short4_sat_rtz(ushort4);\012short4 __ovld __cnfn convert_short4_rtp(ushort4);\012short4 __ovld __cnfn con",
"vert_short4_sat_rtp(ushort4);\012short4 __ovld __cnfn convert_short4_rtn(ushort4);\012short4 __ovld __cnfn convert_short4_sat_rtn(ushort4);\012short4 __ovld __cnfn convert_short4(ushort4);\012short4 __ovld __cnfn convert_short4_sat(ushort4);\012short4 __ovld __cnfn convert_short4_rte(int4);\012short4 __ovld __cnfn convert_short4_sat_rte(int4);\012short4 __ovld __cnfn convert_short4_rtz(int4);\012short4 __ovld __cnfn convert_short4_sat_rtz(int4);\012short4 __ovld __cnfn convert_short4_rtp(int4);\012short4 __ovld __cnfn convert_short4_sat_rtp(int4);\012short4 __ovld __cnfn convert_short4_rtn(int4);\012short4 __ovld __cnfn convert_short4_sat_rtn(int4);\012short4 __ovld __cnfn convert_short4(int4);\012short4 __ovld __cnfn convert_short4_sat(int4);\012short4 __ovld __cnfn convert_short4_rte(uint4);\012short4 __ovld __cnfn convert_short4_sat_rte(uint4);\012short4 __ovld __cnfn convert_short4_rtz(uint4);\012short4 __ovld __cnfn convert_short4_sat_rtz(uint4);\012short4 __ovld __cnfn convert_short4_rtp(uint4);\012short4 __ovld __cnfn convert_short4_sat_rtp(uint4);\012short4 __ovl",
"d __cnfn convert_short4_rtn(uint4);\012short4 __ovld __cnfn convert_short4_sat_rtn(uint4);\012short4 __ovld __cnfn convert_short4(uint4);\012short4 __ovld __cnfn convert_short4_sat(uint4);\012short4 __ovld __cnfn convert_short4_rte(long4);\012short4 __ovld __cnfn convert_short4_sat_rte(long4);\012short4 __ovld __cnfn convert_short4_rtz(long4);\012short4 __ovld __cnfn convert_short4_sat_rtz(long4);\012short4 __ovld __cnfn convert_short4_rtp(long4);\012short4 __ovld __cnfn convert_short4_sat_rtp(long4);\012short4 __ovld __cnfn convert_short4_rtn(long4);\012short4 __ovld __cnfn convert_short4_sat_rtn(long4);\012short4 __ovld __cnfn convert_short4(long4);\012short4 __ovld __cnfn convert_short4_sat(long4);\012short4 __ovld __cnfn convert_short4_rte(ulong4);\012short4 __ovld __cnfn convert_short4_sat_rte(ulong4);\012short4 __ovld __cnfn convert_short4_rtz(ulong4);\012short4 __ovld __cnfn convert_short4_sat_rtz(ulong4);\012short4 __ovld __cnfn convert_short4_rtp(ulong4);\012short4 __ovld __cnfn convert_short4_sat_rtp(ulong4);\012short4 __ovld __cnfn convert_short4_rtn(ulong4",
");\012short4 __ovld __cnfn convert_short4_sat_rtn(ulong4);\012short4 __ovld __cnfn convert_short4(ulong4);\012short4 __ovld __cnfn convert_short4_sat(ulong4);\012short4 __ovld __cnfn convert_short4_rte(float4);\012short4 __ovld __cnfn convert_short4_sat_rte(float4);\012short4 __ovld __cnfn convert_short4_rtz(float4);\012short4 __ovld __cnfn convert_short4_sat_rtz(float4);\012short4 __ovld __cnfn convert_short4_rtp(float4);\012short4 __ovld __cnfn convert_short4_sat_rtp(float4);\012short4 __ovld __cnfn convert_short4_rtn(float4);\012short4 __ovld __cnfn convert_short4_sat_rtn(float4);\012short4 __ovld __cnfn convert_short4(float4);\012short4 __ovld __cnfn convert_short4_sat(float4);\012ushort4 __ovld __cnfn convert_ushort4_rte(char4);\012ushort4 __ovld __cnfn convert_ushort4_sat_rte(char4);\012ushort4 __ovld __cnfn convert_ushort4_rtz(char4);\012ushort4 __ovld __cnfn convert_ushort4_sat_rtz(char4);\012ushort4 __ovld __cnfn convert_ushort4_rtp(char4);\012ushort4 __ovld __cnfn convert_ushort4_sat_rtp(char4);\012ushort4 __ovld __cnfn convert_ushort4_rtn(char4);\012ushort4 __",
"ovld __cnfn convert_ushort4_sat_rtn(char4);\012ushort4 __ovld __cnfn convert_ushort4(char4);\012ushort4 __ovld __cnfn convert_ushort4_sat(char4);\012ushort4 __ovld __cnfn convert_ushort4_rte(uchar4);\012ushort4 __ovld __cnfn convert_ushort4_sat_rte(uchar4);\012ushort4 __ovld __cnfn convert_ushort4_rtz(uchar4);\012ushort4 __ovld __cnfn convert_ushort4_sat_rtz(uchar4);\012ushort4 __ovld __cnfn convert_ushort4_rtp(uchar4);\012ushort4 __ovld __cnfn convert_ushort4_sat_rtp(uchar4);\012ushort4 __ovld __cnfn convert_ushort4_rtn(uchar4);\012ushort4 __ovld __cnfn convert_ushort4_sat_rtn(uchar4);\012ushort4 __ovld __cnfn convert_ushort4(uchar4);\012ushort4 __ovld __cnfn convert_ushort4_sat(uchar4);\012ushort4 __ovld __cnfn convert_ushort4_rte(short4);\012ushort4 __ovld __cnfn convert_ushort4_sat_rte(short4);\012ushort4 __ovld __cnfn convert_ushort4_rtz(short4);\012ushort4 __ovld __cnfn convert_ushort4_sat_rtz(short4);\012ushort4 __ovld __cnfn convert_ushort4_rtp(short4);\012ushort4 __ovld __cnfn convert_ushort4_sat_rtp(short4);\012ushort4 __ovld __cnfn convert_ushort4_rtn(sh",
"ort4);\012ushort4 __ovld __cnfn convert_ushort4_sat_rtn(short4);\012ushort4 __ovld __cnfn convert_ushort4(short4);\012ushort4 __ovld __cnfn convert_ushort4_sat(short4);\012ushort4 __ovld __cnfn convert_ushort4_rte(ushort4);\012ushort4 __ovld __cnfn convert_ushort4_sat_rte(ushort4);\012ushort4 __ovld __cnfn convert_ushort4_rtz(ushort4);\012ushort4 __ovld __cnfn convert_ushort4_sat_rtz(ushort4);\012ushort4 __ovld __cnfn convert_ushort4_rtp(ushort4);\012ushort4 __ovld __cnfn convert_ushort4_sat_rtp(ushort4);\012ushort4 __ovld __cnfn convert_ushort4_rtn(ushort4);\012ushort4 __ovld __cnfn convert_ushort4_sat_rtn(ushort4);\012ushort4 __ovld __cnfn convert_ushort4(ushort4);\012ushort4 __ovld __cnfn convert_ushort4_sat(ushort4);\012ushort4 __ovld __cnfn convert_ushort4_rte(int4);\012ushort4 __ovld __cnfn convert_ushort4_sat_rte(int4);\012ushort4 __ovld __cnfn convert_ushort4_rtz(int4);\012ushort4 __ovld __cnfn convert_ushort4_sat_rtz(int4);\012ushort4 __ovld __cnfn convert_ushort4_rtp(int4);\012ushort4 __ovld __cnfn convert_ushort4_sat_rtp(int4);\012ushort4 __ovld __cnfn conv",
"ert_ushort4_rtn(int4);\012ushort4 __ovld __cnfn convert_ushort4_sat_rtn(int4);\012ushort4 __ovld __cnfn convert_ushort4(int4);\012ushort4 __ovld __cnfn convert_ushort4_sat(int4);\012ushort4 __ovld __cnfn convert_ushort4_rte(uint4);\012ushort4 __ovld __cnfn convert_ushort4_sat_rte(uint4);\012ushort4 __ovld __cnfn convert_ushort4_rtz(uint4);\012ushort4 __ovld __cnfn convert_ushort4_sat_rtz(uint4);\012ushort4 __ovld __cnfn convert_ushort4_rtp(uint4);\012ushort4 __ovld __cnfn convert_ushort4_sat_rtp(uint4);\012ushort4 __ovld __cnfn convert_ushort4_rtn(uint4);\012ushort4 __ovld __cnfn convert_ushort4_sat_rtn(uint4);\012ushort4 __ovld __cnfn convert_ushort4(uint4);\012ushort4 __ovld __cnfn convert_ushort4_sat(uint4);\012ushort4 __ovld __cnfn convert_ushort4_rte(long4);\012ushort4 __ovld __cnfn convert_ushort4_sat_rte(long4);\012ushort4 __ovld __cnfn convert_ushort4_rtz(long4);\012ushort4 __ovld __cnfn convert_ushort4_sat_rtz(long4);\012ushort4 __ovld __cnfn convert_ushort4_rtp(long4);\012ushort4 __ovld __cnfn convert_ushort4_sat_rtp(long4);\012ushort4 __ovld __cnfn convert_",
"ushort4_rtn(long4);\012ushort4 __ovld __cnfn convert_ushort4_sat_rtn(long4);\012ushort4 __ovld __cnfn convert_ushort4(long4);\012ushort4 __ovld __cnfn convert_ushort4_sat(long4);\012ushort4 __ovld __cnfn convert_ushort4_rte(ulong4);\012ushort4 __ovld __cnfn convert_ushort4_sat_rte(ulong4);\012ushort4 __ovld __cnfn convert_ushort4_rtz(ulong4);\012ushort4 __ovld __cnfn convert_ushort4_sat_rtz(ulong4);\012ushort4 __ovld __cnfn convert_ushort4_rtp(ulong4);\012ushort4 __ovld __cnfn convert_ushort4_sat_rtp(ulong4);\012ushort4 __ovld __cnfn convert_ushort4_rtn(ulong4);\012ushort4 __ovld __cnfn convert_ushort4_sat_rtn(ulong4);\012ushort4 __ovld __cnfn convert_ushort4(ulong4);\012ushort4 __ovld __cnfn convert_ushort4_sat(ulong4);\012ushort4 __ovld __cnfn convert_ushort4_rte(float4);\012ushort4 __ovld __cnfn convert_ushort4_sat_rte(float4);\012ushort4 __ovld __cnfn convert_ushort4_rtz(float4);\012ushort4 __ovld __cnfn convert_ushort4_sat_rtz(float4);\012ushort4 __ovld __cnfn convert_ushort4_rtp(float4);\012ushort4 __ovld __cnfn convert_ushort4_sat_rtp(float4);\012ushort4 __ovld",
" __cnfn convert_ushort4_rtn(float4);\012ushort4 __ovld __cnfn convert_ushort4_sat_rtn(float4);\012ushort4 __ovld __cnfn convert_ushort4(float4);\012ushort4 __ovld __cnfn convert_ushort4_sat(float4);\012int4 __ovld __cnfn convert_int4_rte(char4);\012int4 __ovld __cnfn convert_int4_sat_rte(char4);\012int4 __ovld __cnfn convert_int4_rtz(char4);\012int4 __ovld __cnfn convert_int4_sat_rtz(char4);\012int4 __ovld __cnfn convert_int4_rtp(char4);\012int4 __ovld __cnfn convert_int4_sat_rtp(char4);\012int4 __ovld __cnfn convert_int4_rtn(char4);\012int4 __ovld __cnfn convert_int4_sat_rtn(char4);\012int4 __ovld __cnfn convert_int4(char4);\012int4 __ovld __cnfn convert_int4_sat(char4);\012int4 __ovld __cnfn convert_int4_rte(uchar4);\012int4 __ovld __cnfn convert_int4_sat_rte(uchar4);\012int4 __ovld __cnfn convert_int4_rtz(uchar4);\012int4 __ovld __cnfn convert_int4_sat_rtz(uchar4);\012int4 __ovld __cnfn convert_int4_rtp(uchar4);\012int4 __ovld __cnfn convert_int4_sat_rtp(uchar4);\012int4 __ovld __cnfn convert_int4_rtn(uchar4);\012int4 __ovld __cnfn convert_int4_sat_rtn(uchar4);\012int4 _",
"_ovld __cnfn convert_int4(uchar4);\012int4 __ovld __cnfn convert_int4_sat(uchar4);\012int4 __ovld __cnfn convert_int4_rte(short4);\012int4 __ovld __cnfn convert_int4_sat_rte(short4);\012int4 __ovld __cnfn convert_int4_rtz(short4);\012int4 __ovld __cnfn convert_int4_sat_rtz(short4);\012int4 __ovld __cnfn convert_int4_rtp(short4);\012int4 __ovld __cnfn convert_int4_sat_rtp(short4);\012int4 __ovld __cnfn convert_int4_rtn(short4);\012int4 __ovld __cnfn convert_int4_sat_rtn(short4);\012int4 __ovld __cnfn convert_int4(short4);\012int4 __ovld __cnfn convert_int4_sat(short4);\012int4 __ovld __cnfn convert_int4_rte(ushort4);\012int4 __ovld __cnfn convert_int4_sat_rte(ushort4);\012int4 __ovld __cnfn convert_int4_rtz(ushort4);\012int4 __ovld __cnfn convert_int4_sat_rtz(ushort4);\012int4 __ovld __cnfn convert_int4_rtp(ushort4);\012int4 __ovld __cnfn convert_int4_sat_rtp(ushort4);\012int4 __ovld __cnfn convert_int4_rtn(ushort4);\012int4 __ovld __cnfn convert_int4_sat_rtn(ushort4);\012int4 __ovld __cnfn convert_int4(ushort4);\012int4 __ovld __cnfn convert_int4_sat(ushort4);\012int4 __ovl",
"d __cnfn convert_int4_rte(int4);\012int4 __ovld __cnfn convert_int4_sat_rte(int4);\012int4 __ovld __cnfn convert_int4_rtz(int4);\012int4 __ovld __cnfn convert_int4_sat_rtz(int4);\012int4 __ovld __cnfn convert_int4_rtp(int4);\012int4 __ovld __cnfn convert_int4_sat_rtp(int4);\012int4 __ovld __cnfn convert_int4_rtn(int4);\012int4 __ovld __cnfn convert_int4_sat_rtn(int4);\012int4 __ovld __cnfn convert_int4(int4);\012int4 __ovld __cnfn convert_int4_sat(int4);\012int4 __ovld __cnfn convert_int4_rte(uint4);\012int4 __ovld __cnfn convert_int4_sat_rte(uint4);\012int4 __ovld __cnfn convert_int4_rtz(uint4);\012int4 __ovld __cnfn convert_int4_sat_rtz(uint4);\012int4 __ovld __cnfn convert_int4_rtp(uint4);\012int4 __ovld __cnfn convert_int4_sat_rtp(uint4);\012int4 __ovld __cnfn convert_int4_rtn(uint4);\012int4 __ovld __cnfn convert_int4_sat_rtn(uint4);\012int4 __ovld __cnfn convert_int4(uint4);\012int4 __ovld __cnfn convert_int4_sat(uint4);\012int4 __ovld __cnfn convert_int4_rte(long4);\012int4 __ovld __cnfn convert_int4_sat_rte(long4);\012int4 __ovld __cnfn convert_int4_rtz(long4);\012int4",
" __ovld __cnfn convert_int4_sat_rtz(long4);\012int4 __ovld __cnfn convert_int4_rtp(long4);\012int4 __ovld __cnfn convert_int4_sat_rtp(long4);\012int4 __ovld __cnfn convert_int4_rtn(long4);\012int4 __ovld __cnfn convert_int4_sat_rtn(long4);\012int4 __ovld __cnfn convert_int4(long4);\012int4 __ovld __cnfn convert_int4_sat(long4);\012int4 __ovld __cnfn convert_int4_rte(ulong4);\012int4 __ovld __cnfn convert_int4_sat_rte(ulong4);\012int4 __ovld __cnfn convert_int4_rtz(ulong4);\012int4 __ovld __cnfn convert_int4_sat_rtz(ulong4);\012int4 __ovld __cnfn convert_int4_rtp(ulong4);\012int4 __ovld __cnfn convert_int4_sat_rtp(ulong4);\012int4 __ovld __cnfn convert_int4_rtn(ulong4);\012int4 __ovld __cnfn convert_int4_sat_rtn(ulong4);\012int4 __ovld __cnfn convert_int4(ulong4);\012int4 __ovld __cnfn convert_int4_sat(ulong4);\012int4 __ovld __cnfn convert_int4_rte(float4);\012int4 __ovld __cnfn convert_int4_sat_rte(float4);\012int4 __ovld __cnfn convert_int4_rtz(float4);\012int4 __ovld __cnfn convert_int4_sat_rtz(float4);\012int4 __ovld __cnfn convert_int4_rtp(float4);\012int4 __ovld __cnf",
"n convert_int4_sat_rtp(float4);\012int4 __ovld __cnfn convert_int4_rtn(float4);\012int4 __ovld __cnfn convert_int4_sat_rtn(float4);\012int4 __ovld __cnfn convert_int4(float4);\012int4 __ovld __cnfn convert_int4_sat(float4);\012uint4 __ovld __cnfn convert_uint4_rte(char4);\012uint4 __ovld __cnfn convert_uint4_sat_rte(char4);\012uint4 __ovld __cnfn convert_uint4_rtz(char4);\012uint4 __ovld __cnfn convert_uint4_sat_rtz(char4);\012uint4 __ovld __cnfn convert_uint4_rtp(char4);\012uint4 __ovld __cnfn convert_uint4_sat_rtp(char4);\012uint4 __ovld __cnfn convert_uint4_rtn(char4);\012uint4 __ovld __cnfn convert_uint4_sat_rtn(char4);\012uint4 __ovld __cnfn convert_uint4(char4);\012uint4 __ovld __cnfn convert_uint4_sat(char4);\012uint4 __ovld __cnfn convert_uint4_rte(uchar4);\012uint4 __ovld __cnfn convert_uint4_sat_rte(uchar4);\012uint4 __ovld __cnfn convert_uint4_rtz(uchar4);\012uint4 __ovld __cnfn convert_uint4_sat_rtz(uchar4);\012uint4 __ovld __cnfn convert_uint4_rtp(uchar4);\012uint4 __ovld __cnfn convert_uint4_sat_rtp(uchar4);\012uint4 __ovld __cnfn convert_uint4_rtn(uchar4);",
"\012uint4 __ovld __cnfn convert_uint4_sat_rtn(uchar4);\012uint4 __ovld __cnfn convert_uint4(uchar4);\012uint4 __ovld __cnfn convert_uint4_sat(uchar4);\012uint4 __ovld __cnfn convert_uint4_rte(short4);\012uint4 __ovld __cnfn convert_uint4_sat_rte(short4);\012uint4 __ovld __cnfn convert_uint4_rtz(short4);\012uint4 __ovld __cnfn convert_uint4_sat_rtz(short4);\012uint4 __ovld __cnfn convert_uint4_rtp(short4);\012uint4 __ovld __cnfn convert_uint4_sat_rtp(short4);\012uint4 __ovld __cnfn convert_uint4_rtn(short4);\012uint4 __ovld __cnfn convert_uint4_sat_rtn(short4);\012uint4 __ovld __cnfn convert_uint4(short4);\012uint4 __ovld __cnfn convert_uint4_sat(short4);\012uint4 __ovld __cnfn convert_uint4_rte(ushort4);\012uint4 __ovld __cnfn convert_uint4_sat_rte(ushort4);\012uint4 __ovld __cnfn convert_uint4_rtz(ushort4);\012uint4 __ovld __cnfn convert_uint4_sat_rtz(ushort4);\012uint4 __ovld __cnfn convert_uint4_rtp(ushort4);\012uint4 __ovld __cnfn convert_uint4_sat_rtp(ushort4);\012uint4 __ovld __cnfn convert_uint4_rtn(ushort4);\012uint4 __ovld __cnfn convert_uint4_sat_rtn(ushort4);\012",
"uint4 __ovld __cnfn convert_uint4(ushort4);\012uint4 __ovld __cnfn convert_uint4_sat(ushort4);\012uint4 __ovld __cnfn convert_uint4_rte(int4);\012uint4 __ovld __cnfn convert_uint4_sat_rte(int4);\012uint4 __ovld __cnfn convert_uint4_rtz(int4);\012uint4 __ovld __cnfn convert_uint4_sat_rtz(int4);\012uint4 __ovld __cnfn convert_uint4_rtp(int4);\012uint4 __ovld __cnfn convert_uint4_sat_rtp(int4);\012uint4 __ovld __cnfn convert_uint4_rtn(int4);\012uint4 __ovld __cnfn convert_uint4_sat_rtn(int4);\012uint4 __ovld __cnfn convert_uint4(int4);\012uint4 __ovld __cnfn convert_uint4_sat(int4);\012uint4 __ovld __cnfn convert_uint4_rte(uint4);\012uint4 __ovld __cnfn convert_uint4_sat_rte(uint4);\012uint4 __ovld __cnfn convert_uint4_rtz(uint4);\012uint4 __ovld __cnfn convert_uint4_sat_rtz(uint4);\012uint4 __ovld __cnfn convert_uint4_rtp(uint4);\012uint4 __ovld __cnfn convert_uint4_sat_rtp(uint4);\012uint4 __ovld __cnfn convert_uint4_rtn(uint4);\012uint4 __ovld __cnfn convert_uint4_sat_rtn(uint4);\012uint4 __ovld __cnfn convert_uint4(uint4);\012uint4 __ovld __cnfn convert_uint4_sat(uint4)",
";\012uint4 __ovld __cnfn convert_uint4_rte(long4);\012uint4 __ovld __cnfn convert_uint4_sat_rte(long4);\012uint4 __ovld __cnfn convert_uint4_rtz(long4);\012uint4 __ovld __cnfn convert_uint4_sat_rtz(long4);\012uint4 __ovld __cnfn convert_uint4_rtp(long4);\012uint4 __ovld __cnfn convert_uint4_sat_rtp(long4);\012uint4 __ovld __cnfn convert_uint4_rtn(long4);\012uint4 __ovld __cnfn convert_uint4_sat_rtn(long4);\012uint4 __ovld __cnfn convert_uint4(long4);\012uint4 __ovld __cnfn convert_uint4_sat(long4);\012uint4 __ovld __cnfn convert_uint4_rte(ulong4);\012uint4 __ovld __cnfn convert_uint4_sat_rte(ulong4);\012uint4 __ovld __cnfn convert_uint4_rtz(ulong4);\012uint4 __ovld __cnfn convert_uint4_sat_rtz(ulong4);\012uint4 __ovld __cnfn convert_uint4_rtp(ulong4);\012uint4 __ovld __cnfn convert_uint4_sat_rtp(ulong4);\012uint4 __ovld __cnfn convert_uint4_rtn(ulong4);\012uint4 __ovld __cnfn convert_uint4_sat_rtn(ulong4);\012uint4 __ovld __cnfn convert_uint4(ulong4);\012uint4 __ovld __cnfn convert_uint4_sat(ulong4);\012uint4 __ovld __cnfn convert_uint4_rte(float4);\012uint4 __ovld __cnfn c",
"onvert_uint4_sat_rte(float4);\012uint4 __ovld __cnfn convert_uint4_rtz(float4);\012uint4 __ovld __cnfn convert_uint4_sat_rtz(float4);\012uint4 __ovld __cnfn convert_uint4_rtp(float4);\012uint4 __ovld __cnfn convert_uint4_sat_rtp(float4);\012uint4 __ovld __cnfn convert_uint4_rtn(float4);\012uint4 __ovld __cnfn convert_uint4_sat_rtn(float4);\012uint4 __ovld __cnfn convert_uint4(float4);\012uint4 __ovld __cnfn convert_uint4_sat(float4);\012long4 __ovld __cnfn convert_long4_rte(char4);\012long4 __ovld __cnfn convert_long4_sat_rte(char4);\012long4 __ovld __cnfn convert_long4_rtz(char4);\012long4 __ovld __cnfn convert_long4_sat_rtz(char4);\012long4 __ovld __cnfn convert_long4_rtp(char4);\012long4 __ovld __cnfn convert_long4_sat_rtp(char4);\012long4 __ovld __cnfn convert_long4_rtn(char4);\012long4 __ovld __cnfn convert_long4_sat_rtn(char4);\012long4 __ovld __cnfn convert_long4(char4);\012long4 __ovld __cnfn convert_long4_sat(char4);\012long4 __ovld __cnfn convert_long4_rte(uchar4);\012long4 __ovld __cnfn convert_long4_sat_rte(uchar4);\012long4 __ovld __cnfn convert_long4_rtz(uc",
"har4);\012long4 __ovld __cnfn convert_long4_sat_rtz(uchar4);\012long4 __ovld __cnfn convert_long4_rtp(uchar4);\012long4 __ovld __cnfn convert_long4_sat_rtp(uchar4);\012long4 __ovld __cnfn convert_long4_rtn(uchar4);\012long4 __ovld __cnfn convert_long4_sat_rtn(uchar4);\012long4 __ovld __cnfn convert_long4(uchar4);\012long4 __ovld __cnfn convert_long4_sat(uchar4);\012long4 __ovld __cnfn convert_long4_rte(short4);\012long4 __ovld __cnfn convert_long4_sat_rte(short4);\012long4 __ovld __cnfn convert_long4_rtz(short4);\012long4 __ovld __cnfn convert_long4_sat_rtz(short4);\012long4 __ovld __cnfn convert_long4_rtp(short4);\012long4 __ovld __cnfn convert_long4_sat_rtp(short4);\012long4 __ovld __cnfn convert_long4_rtn(short4);\012long4 __ovld __cnfn convert_long4_sat_rtn(short4);\012long4 __ovld __cnfn convert_long4(short4);\012long4 __ovld __cnfn convert_long4_sat(short4);\012long4 __ovld __cnfn convert_long4_rte(ushort4);\012long4 __ovld __cnfn convert_long4_sat_rte(ushort4);\012long4 __ovld __cnfn convert_long4_rtz(ushort4);\012long4 __ovld __cnfn convert_long4_sat_rtz(ushort4)",
";\012long4 __ovld __cnfn convert_long4_rtp(ushort4);\012long4 __ovld __cnfn convert_long4_sat_rtp(ushort4);\012long4 __ovld __cnfn convert_long4_rtn(ushort4);\012long4 __ovld __cnfn convert_long4_sat_rtn(ushort4);\012long4 __ovld __cnfn convert_long4(ushort4);\012long4 __ovld __cnfn convert_long4_sat(ushort4);\012long4 __ovld __cnfn convert_long4_rte(int4);\012long4 __ovld __cnfn convert_long4_sat_rte(int4);\012long4 __ovld __cnfn convert_long4_rtz(int4);\012long4 __ovld __cnfn convert_long4_sat_rtz(int4);\012long4 __ovld __cnfn convert_long4_rtp(int4);\012long4 __ovld __cnfn convert_long4_sat_rtp(int4);\012long4 __ovld __cnfn convert_long4_rtn(int4);\012long4 __ovld __cnfn convert_long4_sat_rtn(int4);\012long4 __ovld __cnfn convert_long4(int4);\012long4 __ovld __cnfn convert_long4_sat(int4);\012long4 __ovld __cnfn convert_long4_rte(uint4);\012long4 __ovld __cnfn convert_long4_sat_rte(uint4);\012long4 __ovld __cnfn convert_long4_rtz(uint4);\012long4 __ovld __cnfn convert_long4_sat_rtz(uint4);\012long4 __ovld __cnfn convert_long4_rtp(uint4);\012long4 __ovld __cnfn convert_lo",
"ng4_sat_rtp(uint4);\012long4 __ovld __cnfn convert_long4_rtn(uint4);\012long4 __ovld __cnfn convert_long4_sat_rtn(uint4);\012long4 __ovld __cnfn convert_long4(uint4);\012long4 __ovld __cnfn convert_long4_sat(uint4);\012long4 __ovld __cnfn convert_long4_rte(long4);\012long4 __ovld __cnfn convert_long4_sat_rte(long4);\012long4 __ovld __cnfn convert_long4_rtz(long4);\012long4 __ovld __cnfn convert_long4_sat_rtz(long4);\012long4 __ovld __cnfn convert_long4_rtp(long4);\012long4 __ovld __cnfn convert_long4_sat_rtp(long4);\012long4 __ovld __cnfn convert_long4_rtn(long4);\012long4 __ovld __cnfn convert_long4_sat_rtn(long4);\012long4 __ovld __cnfn convert_long4(long4);\012long4 __ovld __cnfn convert_long4_sat(long4);\012long4 __ovld __cnfn convert_long4_rte(ulong4);\012long4 __ovld __cnfn convert_long4_sat_rte(ulong4);\012long4 __ovld __cnfn convert_long4_rtz(ulong4);\012long4 __ovld __cnfn convert_long4_sat_rtz(ulong4);\012long4 __ovld __cnfn convert_long4_rtp(ulong4);\012long4 __ovld __cnfn convert_long4_sat_rtp(ulong4);\012long4 __ovld __cnfn convert_long4_rtn(ulong4);\012long4 _",
"_ovld __cnfn convert_long4_sat_rtn(ulong4);\012long4 __ovld __cnfn convert_long4(ulong4);\012long4 __ovld __cnfn convert_long4_sat(ulong4);\012long4 __ovld __cnfn convert_long4_rte(float4);\012long4 __ovld __cnfn convert_long4_sat_rte(float4);\012long4 __ovld __cnfn convert_long4_rtz(float4);\012long4 __ovld __cnfn convert_long4_sat_rtz(float4);\012long4 __ovld __cnfn convert_long4_rtp(float4);\012long4 __ovld __cnfn convert_long4_sat_rtp(float4);\012long4 __ovld __cnfn convert_long4_rtn(float4);\012long4 __ovld __cnfn convert_long4_sat_rtn(float4);\012long4 __ovld __cnfn convert_long4(float4);\012long4 __ovld __cnfn convert_long4_sat(float4);\012ulong4 __ovld __cnfn convert_ulong4_rte(char4);\012ulong4 __ovld __cnfn convert_ulong4_sat_rte(char4);\012ulong4 __ovld __cnfn convert_ulong4_rtz(char4);\012ulong4 __ovld __cnfn convert_ulong4_sat_rtz(char4);\012ulong4 __ovld __cnfn convert_ulong4_rtp(char4);\012ulong4 __ovld __cnfn convert_ulong4_sat_rtp(char4);\012ulong4 __ovld __cnfn convert_ulong4_rtn(char4);\012ulong4 __ovld __cnfn convert_ulong4_sat_rtn(char4);\012ulong4 _",
"_ovld __cnfn convert_ulong4(char4);\012ulong4 __ovld __cnfn convert_ulong4_sat(char4);\012ulong4 __ovld __cnfn convert_ulong4_rte(uchar4);\012ulong4 __ovld __cnfn convert_ulong4_sat_rte(uchar4);\012ulong4 __ovld __cnfn convert_ulong4_rtz(uchar4);\012ulong4 __ovld __cnfn convert_ulong4_sat_rtz(uchar4);\012ulong4 __ovld __cnfn convert_ulong4_rtp(uchar4);\012ulong4 __ovld __cnfn convert_ulong4_sat_rtp(uchar4);\012ulong4 __ovld __cnfn convert_ulong4_rtn(uchar4);\012ulong4 __ovld __cnfn convert_ulong4_sat_rtn(uchar4);\012ulong4 __ovld __cnfn convert_ulong4(uchar4);\012ulong4 __ovld __cnfn convert_ulong4_sat(uchar4);\012ulong4 __ovld __cnfn convert_ulong4_rte(short4);\012ulong4 __ovld __cnfn convert_ulong4_sat_rte(short4);\012ulong4 __ovld __cnfn convert_ulong4_rtz(short4);\012ulong4 __ovld __cnfn convert_ulong4_sat_rtz(short4);\012ulong4 __ovld __cnfn convert_ulong4_rtp(short4);\012ulong4 __ovld __cnfn convert_ulong4_sat_rtp(short4);\012ulong4 __ovld __cnfn convert_ulong4_rtn(short4);\012ulong4 __ovld __cnfn convert_ulong4_sat_rtn(short4);\012ulong4 __ovld __cnfn convert_u",
"long4(short4);\012ulong4 __ovld __cnfn convert_ulong4_sat(short4);\012ulong4 __ovld __cnfn convert_ulong4_rte(ushort4);\012ulong4 __ovld __cnfn convert_ulong4_sat_rte(ushort4);\012ulong4 __ovld __cnfn convert_ulong4_rtz(ushort4);\012ulong4 __ovld __cnfn convert_ulong4_sat_rtz(ushort4);\012ulong4 __ovld __cnfn convert_ulong4_rtp(ushort4);\012ulong4 __ovld __cnfn convert_ulong4_sat_rtp(ushort4);\012ulong4 __ovld __cnfn convert_ulong4_rtn(ushort4);\012ulong4 __ovld __cnfn convert_ulong4_sat_rtn(ushort4);\012ulong4 __ovld __cnfn convert_ulong4(ushort4);\012ulong4 __ovld __cnfn convert_ulong4_sat(ushort4);\012ulong4 __ovld __cnfn convert_ulong4_rte(int4);\012ulong4 __ovld __cnfn convert_ulong4_sat_rte(int4);\012ulong4 __ovld __cnfn convert_ulong4_rtz(int4);\012ulong4 __ovld __cnfn convert_ulong4_sat_rtz(int4);\012ulong4 __ovld __cnfn convert_ulong4_rtp(int4);\012ulong4 __ovld __cnfn convert_ulong4_sat_rtp(int4);\012ulong4 __ovld __cnfn convert_ulong4_rtn(int4);\012ulong4 __ovld __cnfn convert_ulong4_sat_rtn(int4);\012ulong4 __ovld __cnfn convert_ulong4(int4);\012ulong4 __ovld",
" __cnfn convert_ulong4_sat(int4);\012ulong4 __ovld __cnfn convert_ulong4_rte(uint4);\012ulong4 __ovld __cnfn convert_ulong4_sat_rte(uint4);\012ulong4 __ovld __cnfn convert_ulong4_rtz(uint4);\012ulong4 __ovld __cnfn convert_ulong4_sat_rtz(uint4);\012ulong4 __ovld __cnfn convert_ulong4_rtp(uint4);\012ulong4 __ovld __cnfn convert_ulong4_sat_rtp(uint4);\012ulong4 __ovld __cnfn convert_ulong4_rtn(uint4);\012ulong4 __ovld __cnfn convert_ulong4_sat_rtn(uint4);\012ulong4 __ovld __cnfn convert_ulong4(uint4);\012ulong4 __ovld __cnfn convert_ulong4_sat(uint4);\012ulong4 __ovld __cnfn convert_ulong4_rte(long4);\012ulong4 __ovld __cnfn convert_ulong4_sat_rte(long4);\012ulong4 __ovld __cnfn convert_ulong4_rtz(long4);\012ulong4 __ovld __cnfn convert_ulong4_sat_rtz(long4);\012ulong4 __ovld __cnfn convert_ulong4_rtp(long4);\012ulong4 __ovld __cnfn convert_ulong4_sat_rtp(long4);\012ulong4 __ovld __cnfn convert_ulong4_rtn(long4);\012ulong4 __ovld __cnfn convert_ulong4_sat_rtn(long4);\012ulong4 __ovld __cnfn convert_ulong4(long4);\012ulong4 __ovld __cnfn convert_ulong4_sat(long4);\012ulong4",
" __ovld __cnfn convert_ulong4_rte(ulong4);\012ulong4 __ovld __cnfn convert_ulong4_sat_rte(ulong4);\012ulong4 __ovld __cnfn convert_ulong4_rtz(ulong4);\012ulong4 __ovld __cnfn convert_ulong4_sat_rtz(ulong4);\012ulong4 __ovld __cnfn convert_ulong4_rtp(ulong4);\012ulong4 __ovld __cnfn convert_ulong4_sat_rtp(ulong4);\012ulong4 __ovld __cnfn convert_ulong4_rtn(ulong4);\012ulong4 __ovld __cnfn convert_ulong4_sat_rtn(ulong4);\012ulong4 __ovld __cnfn convert_ulong4(ulong4);\012ulong4 __ovld __cnfn convert_ulong4_sat(ulong4);\012ulong4 __ovld __cnfn convert_ulong4_rte(float4);\012ulong4 __ovld __cnfn convert_ulong4_sat_rte(float4);\012ulong4 __ovld __cnfn convert_ulong4_rtz(float4);\012ulong4 __ovld __cnfn convert_ulong4_sat_rtz(float4);\012ulong4 __ovld __cnfn convert_ulong4_rtp(float4);\012ulong4 __ovld __cnfn convert_ulong4_sat_rtp(float4);\012ulong4 __ovld __cnfn convert_ulong4_rtn(float4);\012ulong4 __ovld __cnfn convert_ulong4_sat_rtn(float4);\012ulong4 __ovld __cnfn convert_ulong4(float4);\012ulong4 __ovld __cnfn convert_ulong4_sat(float4);\012float4 __ovld __cnfn conve",
"rt_float4_rte(char4);\012float4 __ovld __cnfn convert_float4_rtz(char4);\012float4 __ovld __cnfn convert_float4_rtp(char4);\012float4 __ovld __cnfn convert_float4_rtn(char4);\012float4 __ovld __cnfn convert_float4(char4);\012float4 __ovld __cnfn convert_float4_rte(uchar4);\012float4 __ovld __cnfn convert_float4_rtz(uchar4);\012float4 __ovld __cnfn convert_float4_rtp(uchar4);\012float4 __ovld __cnfn convert_float4_rtn(uchar4);\012float4 __ovld __cnfn convert_float4(uchar4);\012float4 __ovld __cnfn convert_float4_rte(short4);\012float4 __ovld __cnfn convert_float4_rtz(short4);\012float4 __ovld __cnfn convert_float4_rtp(short4);\012float4 __ovld __cnfn convert_float4_rtn(short4);\012float4 __ovld __cnfn convert_float4(short4);\012float4 __ovld __cnfn convert_float4_rte(ushort4);\012float4 __ovld __cnfn convert_float4_rtz(ushort4);\012float4 __ovld __cnfn convert_float4_rtp(ushort4);\012float4 __ovld __cnfn convert_float4_rtn(ushort4);\012float4 __ovld __cnfn convert_float4(ushort4);\012float4 __ovld __cnfn convert_float4_rte(int4);\012float4 __ovld __cnfn convert_float4_rtz",
"(int4);\012float4 __ovld __cnfn convert_float4_rtp(int4);\012float4 __ovld __cnfn convert_float4_rtn(int4);\012float4 __ovld __cnfn convert_float4(int4);\012float4 __ovld __cnfn convert_float4_rte(uint4);\012float4 __ovld __cnfn convert_float4_rtz(uint4);\012float4 __ovld __cnfn convert_float4_rtp(uint4);\012float4 __ovld __cnfn convert_float4_rtn(uint4);\012float4 __ovld __cnfn convert_float4(uint4);\012float4 __ovld __cnfn convert_float4_rte(long4);\012float4 __ovld __cnfn convert_float4_rtz(long4);\012float4 __ovld __cnfn convert_float4_rtp(long4);\012float4 __ovld __cnfn convert_float4_rtn(long4);\012float4 __ovld __cnfn convert_float4(long4);\012float4 __ovld __cnfn convert_float4_rte(ulong4);\012float4 __ovld __cnfn convert_float4_rtz(ulong4);\012float4 __ovld __cnfn convert_float4_rtp(ulong4);\012float4 __ovld __cnfn convert_float4_rtn(ulong4);\012float4 __ovld __cnfn convert_float4(ulong4);\012float4 __ovld __cnfn convert_float4_rte(float4);\012float4 __ovld __cnfn convert_float4_rtz(float4);\012float4 __ovld __cnfn convert_float4_rtp(float4);\012float4 __ovld __cnf",
"n convert_float4_rtn(float4);\012float4 __ovld __cnfn convert_float4(float4);\012char8 __ovld __cnfn convert_char8_rte(char8);\012char8 __ovld __cnfn convert_char8_sat_rte(char8);\012char8 __ovld __cnfn convert_char8_rtz(char8);\012char8 __ovld __cnfn convert_char8_sat_rtz(char8);\012char8 __ovld __cnfn convert_char8_rtp(char8);\012char8 __ovld __cnfn convert_char8_sat_rtp(char8);\012char8 __ovld __cnfn convert_char8_rtn(char8);\012char8 __ovld __cnfn convert_char8_sat_rtn(char8);\012char8 __ovld __cnfn convert_char8(char8);\012char8 __ovld __cnfn convert_char8_sat(char8);\012char8 __ovld __cnfn convert_char8_rte(uchar8);\012char8 __ovld __cnfn convert_char8_sat_rte(uchar8);\012char8 __ovld __cnfn convert_char8_rtz(uchar8);\012char8 __ovld __cnfn convert_char8_sat_rtz(uchar8);\012char8 __ovld __cnfn convert_char8_rtp(uchar8);\012char8 __ovld __cnfn convert_char8_sat_rtp(uchar8);\012char8 __ovld __cnfn convert_char8_rtn(uchar8);\012char8 __ovld __cnfn convert_char8_sat_rtn(uchar8);\012char8 __ovld __cnfn convert_char8(uchar8);\012char8 __ovld __cnfn convert_char8_sat(ucha",
"r8);\012char8 __ovld __cnfn convert_char8_rte(short8);\012char8 __ovld __cnfn convert_char8_sat_rte(short8);\012char8 __ovld __cnfn convert_char8_rtz(short8);\012char8 __ovld __cnfn convert_char8_sat_rtz(short8);\012char8 __ovld __cnfn convert_char8_rtp(short8);\012char8 __ovld __cnfn convert_char8_sat_rtp(short8);\012char8 __ovld __cnfn convert_char8_rtn(short8);\012char8 __ovld __cnfn convert_char8_sat_rtn(short8);\012char8 __ovld __cnfn convert_char8(short8);\012char8 __ovld __cnfn convert_char8_sat(short8);\012char8 __ovld __cnfn convert_char8_rte(ushort8);\012char8 __ovld __cnfn convert_char8_sat_rte(ushort8);\012char8 __ovld __cnfn convert_char8_rtz(ushort8);\012char8 __ovld __cnfn convert_char8_sat_rtz(ushort8);\012char8 __ovld __cnfn convert_char8_rtp(ushort8);\012char8 __ovld __cnfn convert_char8_sat_rtp(ushort8);\012char8 __ovld __cnfn convert_char8_rtn(ushort8);\012char8 __ovld __cnfn convert_char8_sat_rtn(ushort8);\012char8 __ovld __cnfn convert_char8(ushort8);\012char8 __ovld __cnfn convert_char8_sat(ushort8);\012char8 __ovld __cnfn convert_char8_rte(int8);\012",
"char8 __ovld __cnfn convert_char8_sat_rte(int8);\012char8 __ovld __cnfn convert_char8_rtz(int8);\012char8 __ovld __cnfn convert_char8_sat_rtz(int8);\012char8 __ovld __cnfn convert_char8_rtp(int8);\012char8 __ovld __cnfn convert_char8_sat_rtp(int8);\012char8 __ovld __cnfn convert_char8_rtn(int8);\012char8 __ovld __cnfn convert_char8_sat_rtn(int8);\012char8 __ovld __cnfn convert_char8(int8);\012char8 __ovld __cnfn convert_char8_sat(int8);\012char8 __ovld __cnfn convert_char8_rte(uint8);\012char8 __ovld __cnfn convert_char8_sat_rte(uint8);\012char8 __ovld __cnfn convert_char8_rtz(uint8);\012char8 __ovld __cnfn convert_char8_sat_rtz(uint8);\012char8 __ovld __cnfn convert_char8_rtp(uint8);\012char8 __ovld __cnfn convert_char8_sat_rtp(uint8);\012char8 __ovld __cnfn convert_char8_rtn(uint8);\012char8 __ovld __cnfn convert_char8_sat_rtn(uint8);\012char8 __ovld __cnfn convert_char8(uint8);\012char8 __ovld __cnfn convert_char8_sat(uint8);\012char8 __ovld __cnfn convert_char8_rte(long8);\012char8 __ovld __cnfn convert_char8_sat_rte(long8);\012char8 __ovld __cnfn convert_char8_rtz(l",
"ong8);\012char8 __ovld __cnfn convert_char8_sat_rtz(long8);\012char8 __ovld __cnfn convert_char8_rtp(long8);\012char8 __ovld __cnfn convert_char8_sat_rtp(long8);\012char8 __ovld __cnfn convert_char8_rtn(long8);\012char8 __ovld __cnfn convert_char8_sat_rtn(long8);\012char8 __ovld __cnfn convert_char8(long8);\012char8 __ovld __cnfn convert_char8_sat(long8);\012char8 __ovld __cnfn convert_char8_rte(ulong8);\012char8 __ovld __cnfn convert_char8_sat_rte(ulong8);\012char8 __ovld __cnfn convert_char8_rtz(ulong8);\012char8 __ovld __cnfn convert_char8_sat_rtz(ulong8);\012char8 __ovld __cnfn convert_char8_rtp(ulong8);\012char8 __ovld __cnfn convert_char8_sat_rtp(ulong8);\012char8 __ovld __cnfn convert_char8_rtn(ulong8);\012char8 __ovld __cnfn convert_char8_sat_rtn(ulong8);\012char8 __ovld __cnfn convert_char8(ulong8);\012char8 __ovld __cnfn convert_char8_sat(ulong8);\012char8 __ovld __cnfn convert_char8_rte(float8);\012char8 __ovld __cnfn convert_char8_sat_rte(float8);\012char8 __ovld __cnfn convert_char8_rtz(float8);\012char8 __ovld __cnfn convert_char8_sat_rtz(float8);\012char8 __o",
"vld __cnfn convert_char8_rtp(float8);\012char8 __ovld __cnfn convert_char8_sat_rtp(float8);\012char8 __ovld __cnfn convert_char8_rtn(float8);\012char8 __ovld __cnfn convert_char8_sat_rtn(float8);\012char8 __ovld __cnfn convert_char8(float8);\012char8 __ovld __cnfn convert_char8_sat(float8);\012uchar8 __ovld __cnfn convert_uchar8_rte(char8);\012uchar8 __ovld __cnfn convert_uchar8_sat_rte(char8);\012uchar8 __ovld __cnfn convert_uchar8_rtz(char8);\012uchar8 __ovld __cnfn convert_uchar8_sat_rtz(char8);\012uchar8 __ovld __cnfn convert_uchar8_rtp(char8);\012uchar8 __ovld __cnfn convert_uchar8_sat_rtp(char8);\012uchar8 __ovld __cnfn convert_uchar8_rtn(char8);\012uchar8 __ovld __cnfn convert_uchar8_sat_rtn(char8);\012uchar8 __ovld __cnfn convert_uchar8(char8);\012uchar8 __ovld __cnfn convert_uchar8_sat(char8);\012uchar8 __ovld __cnfn convert_uchar8_rte(uchar8);\012uchar8 __ovld __cnfn convert_uchar8_sat_rte(uchar8);\012uchar8 __ovld __cnfn convert_uchar8_rtz(uchar8);\012uchar8 __ovld __cnfn convert_uchar8_sat_rtz(uchar8);\012uchar8 __ovld __cnfn convert_uchar8_rtp(uchar8);\012uc",
"har8 __ovld __cnfn convert_uchar8_sat_rtp(uchar8);\012uchar8 __ovld __cnfn convert_uchar8_rtn(uchar8);\012uchar8 __ovld __cnfn convert_uchar8_sat_rtn(uchar8);\012uchar8 __ovld __cnfn convert_uchar8(uchar8);\012uchar8 __ovld __cnfn convert_uchar8_sat(uchar8);\012uchar8 __ovld __cnfn convert_uchar8_rte(short8);\012uchar8 __ovld __cnfn convert_uchar8_sat_rte(short8);\012uchar8 __ovld __cnfn convert_uchar8_rtz(short8);\012uchar8 __ovld __cnfn convert_uchar8_sat_rtz(short8);\012uchar8 __ovld __cnfn convert_uchar8_rtp(short8);\012uchar8 __ovld __cnfn convert_uchar8_sat_rtp(short8);\012uchar8 __ovld __cnfn convert_uchar8_rtn(short8);\012uchar8 __ovld __cnfn convert_uchar8_sat_rtn(short8);\012uchar8 __ovld __cnfn convert_uchar8(short8);\012uchar8 __ovld __cnfn convert_uchar8_sat(short8);\012uchar8 __ovld __cnfn convert_uchar8_rte(ushort8);\012uchar8 __ovld __cnfn convert_uchar8_sat_rte(ushort8);\012uchar8 __ovld __cnfn convert_uchar8_rtz(ushort8);\012uchar8 __ovld __cnfn convert_uchar8_sat_rtz(ushort8);\012uchar8 __ovld __cnfn convert_uchar8_rtp(ushort8);\012uchar8 __ovld __c",
"nfn convert_uchar8_sat_rtp(ushort8);\012uchar8 __ovld __cnfn convert_uchar8_rtn(ushort8);\012uchar8 __ovld __cnfn convert_uchar8_sat_rtn(ushort8);\012uchar8 __ovld __cnfn convert_uchar8(ushort8);\012uchar8 __ovld __cnfn convert_uchar8_sat(ushort8);\012uchar8 __ovld __cnfn convert_uchar8_rte(int8);\012uchar8 __ovld __cnfn convert_uchar8_sat_rte(int8);\012uchar8 __ovld __cnfn convert_uchar8_rtz(int8);\012uchar8 __ovld __cnfn convert_uchar8_sat_rtz(int8);\012uchar8 __ovld __cnfn convert_uchar8_rtp(int8);\012uchar8 __ovld __cnfn convert_uchar8_sat_rtp(int8);\012uchar8 __ovld __cnfn convert_uchar8_rtn(int8);\012uchar8 __ovld __cnfn convert_uchar8_sat_rtn(int8);\012uchar8 __ovld __cnfn convert_uchar8(int8);\012uchar8 __ovld __cnfn convert_uchar8_sat(int8);\012uchar8 __ovld __cnfn convert_uchar8_rte(uint8);\012uchar8 __ovld __cnfn convert_uchar8_sat_rte(uint8);\012uchar8 __ovld __cnfn convert_uchar8_rtz(uint8);\012uchar8 __ovld __cnfn convert_uchar8_sat_rtz(uint8);\012uchar8 __ovld __cnfn convert_uchar8_rtp(uint8);\012uchar8 __ovld __cnfn convert_uchar8_sat_rtp(uint8);\012uchar",
"8 __ovld __cnfn convert_uchar8_rtn(uint8);\012uchar8 __ovld __cnfn convert_uchar8_sat_rtn(uint8);\012uchar8 __ovld __cnfn convert_uchar8(uint8);\012uchar8 __ovld __cnfn convert_uchar8_sat(uint8);\012uchar8 __ovld __cnfn convert_uchar8_rte(long8);\012uchar8 __ovld __cnfn convert_uchar8_sat_rte(long8);\012uchar8 __ovld __cnfn convert_uchar8_rtz(long8);\012uchar8 __ovld __cnfn convert_uchar8_sat_rtz(long8);\012uchar8 __ovld __cnfn convert_uchar8_rtp(long8);\012uchar8 __ovld __cnfn convert_uchar8_sat_rtp(long8);\012uchar8 __ovld __cnfn convert_uchar8_rtn(long8);\012uchar8 __ovld __cnfn convert_uchar8_sat_rtn(long8);\012uchar8 __ovld __cnfn convert_uchar8(long8);\012uchar8 __ovld __cnfn convert_uchar8_sat(long8);\012uchar8 __ovld __cnfn convert_uchar8_rte(ulong8);\012uchar8 __ovld __cnfn convert_uchar8_sat_rte(ulong8);\012uchar8 __ovld __cnfn convert_uchar8_rtz(ulong8);\012uchar8 __ovld __cnfn convert_uchar8_sat_rtz(ulong8);\012uchar8 __ovld __cnfn convert_uchar8_rtp(ulong8);\012uchar8 __ovld __cnfn convert_uchar8_sat_rtp(ulong8);\012uchar8 __ovld __cnfn convert_uchar8_rtn",
"(ulong8);\012uchar8 __ovld __cnfn convert_uchar8_sat_rtn(ulong8);\012uchar8 __ovld __cnfn convert_uchar8(ulong8);\012uchar8 __ovld __cnfn convert_uchar8_sat(ulong8);\012uchar8 __ovld __cnfn convert_uchar8_rte(float8);\012uchar8 __ovld __cnfn convert_uchar8_sat_rte(float8);\012uchar8 __ovld __cnfn convert_uchar8_rtz(float8);\012uchar8 __ovld __cnfn convert_uchar8_sat_rtz(float8);\012uchar8 __ovld __cnfn convert_uchar8_rtp(float8);\012uchar8 __ovld __cnfn convert_uchar8_sat_rtp(float8);\012uchar8 __ovld __cnfn convert_uchar8_rtn(float8);\012uchar8 __ovld __cnfn convert_uchar8_sat_rtn(float8);\012uchar8 __ovld __cnfn convert_uchar8(float8);\012uchar8 __ovld __cnfn convert_uchar8_sat(float8);\012short8 __ovld __cnfn convert_short8_rte(char8);\012short8 __ovld __cnfn convert_short8_sat_rte(char8);\012short8 __ovld __cnfn convert_short8_rtz(char8);\012short8 __ovld __cnfn convert_short8_sat_rtz(char8);\012short8 __ovld __cnfn convert_short8_rtp(char8);\012short8 __ovld __cnfn convert_short8_sat_rtp(char8);\012short8 __ovld __cnfn convert_short8_rtn(char8);\012short8 __ovld __c",
"nfn convert_short8_sat_rtn(char8);\012short8 __ovld __cnfn convert_short8(char8);\012short8 __ovld __cnfn convert_short8_sat(char8);\012short8 __ovld __cnfn convert_short8_rte(uchar8);\012short8 __ovld __cnfn convert_short8_sat_rte(uchar8);\012short8 __ovld __cnfn convert_short8_rtz(uchar8);\012short8 __ovld __cnfn convert_short8_sat_rtz(uchar8);\012short8 __ovld __cnfn convert_short8_rtp(uchar8);\012short8 __ovld __cnfn convert_short8_sat_rtp(uchar8);\012short8 __ovld __cnfn convert_short8_rtn(uchar8);\012short8 __ovld __cnfn convert_short8_sat_rtn(uchar8);\012short8 __ovld __cnfn convert_short8(uchar8);\012short8 __ovld __cnfn convert_short8_sat(uchar8);\012short8 __ovld __cnfn convert_short8_rte(short8);\012short8 __ovld __cnfn convert_short8_sat_rte(short8);\012short8 __ovld __cnfn convert_short8_rtz(short8);\012short8 __ovld __cnfn convert_short8_sat_rtz(short8);\012short8 __ovld __cnfn convert_short8_rtp(short8);\012short8 __ovld __cnfn convert_short8_sat_rtp(short8);\012short8 __ovld __cnfn convert_short8_rtn(short8);\012short8 __ovld __cnfn convert_short8_sat_",
"rtn(short8);\012short8 __ovld __cnfn convert_short8(short8);\012short8 __ovld __cnfn convert_short8_sat(short8);\012short8 __ovld __cnfn convert_short8_rte(ushort8);\012short8 __ovld __cnfn convert_short8_sat_rte(ushort8);\012short8 __ovld __cnfn convert_short8_rtz(ushort8);\012short8 __ovld __cnfn convert_short8_sat_rtz(ushort8);\012short8 __ovld __cnfn convert_short8_rtp(ushort8);\012short8 __ovld __cnfn convert_short8_sat_rtp(ushort8);\012short8 __ovld __cnfn convert_short8_rtn(ushort8);\012short8 __ovld __cnfn convert_short8_sat_rtn(ushort8);\012short8 __ovld __cnfn convert_short8(ushort8);\012short8 __ovld __cnfn convert_short8_sat(ushort8);\012short8 __ovld __cnfn convert_short8_rte(int8);\012short8 __ovld __cnfn convert_short8_sat_rte(int8);\012short8 __ovld __cnfn convert_short8_rtz(int8);\012short8 __ovld __cnfn convert_short8_sat_rtz(int8);\012short8 __ovld __cnfn convert_short8_rtp(int8);\012short8 __ovld __cnfn convert_short8_sat_rtp(int8);\012short8 __ovld __cnfn convert_short8_rtn(int8);\012short8 __ovld __cnfn convert_short8_sat_rtn(int8);\012short8 __ovld",
" __cnfn convert_short8(int8);\012short8 __ovld __cnfn convert_short8_sat(int8);\012short8 __ovld __cnfn convert_short8_rte(uint8);\012short8 __ovld __cnfn convert_short8_sat_rte(uint8);\012short8 __ovld __cnfn convert_short8_rtz(uint8);\012short8 __ovld __cnfn convert_short8_sat_rtz(uint8);\012short8 __ovld __cnfn convert_short8_rtp(uint8);\012short8 __ovld __cnfn convert_short8_sat_rtp(uint8);\012short8 __ovld __cnfn convert_short8_rtn(uint8);\012short8 __ovld __cnfn convert_short8_sat_rtn(uint8);\012short8 __ovld __cnfn convert_short8(uint8);\012short8 __ovld __cnfn convert_short8_sat(uint8);\012short8 __ovld __cnfn convert_short8_rte(long8);\012short8 __ovld __cnfn convert_short8_sat_rte(long8);\012short8 __ovld __cnfn convert_short8_rtz(long8);\012short8 __ovld __cnfn convert_short8_sat_rtz(long8);\012short8 __ovld __cnfn convert_short8_rtp(long8);\012short8 __ovld __cnfn convert_short8_sat_rtp(long8);\012short8 __ovld __cnfn convert_short8_rtn(long8);\012short8 __ovld __cnfn convert_short8_sat_rtn(long8);\012short8 __ovld __cnfn convert_short8(long8);\012short8 __ov",
"ld __cnfn convert_short8_sat(long8);\012short8 __ovld __cnfn convert_short8_rte(ulong8);\012short8 __ovld __cnfn convert_short8_sat_rte(ulong8);\012short8 __ovld __cnfn convert_short8_rtz(ulong8);\012short8 __ovld __cnfn convert_short8_sat_rtz(ulong8);\012short8 __ovld __cnfn convert_short8_rtp(ulong8);\012short8 __ovld __cnfn convert_short8_sat_rtp(ulong8);\012short8 __ovld __cnfn convert_short8_rtn(ulong8);\012short8 __ovld __cnfn convert_short8_sat_rtn(ulong8);\012short8 __ovld __cnfn convert_short8(ulong8);\012short8 __ovld __cnfn convert_short8_sat(ulong8);\012short8 __ovld __cnfn convert_short8_rte(float8);\012short8 __ovld __cnfn convert_short8_sat_rte(float8);\012short8 __ovld __cnfn convert_short8_rtz(float8);\012short8 __ovld __cnfn convert_short8_sat_rtz(float8);\012short8 __ovld __cnfn convert_short8_rtp(float8);\012short8 __ovld __cnfn convert_short8_sat_rtp(float8);\012short8 __ovld __cnfn convert_short8_rtn(float8);\012short8 __ovld __cnfn convert_short8_sat_rtn(float8);\012short8 __ovld __cnfn convert_short8(float8);\012short8 __ovld __cnfn convert_sho",
"rt8_sat(float8);\012ushort8 __ovld __cnfn convert_ushort8_rte(char8);\012ushort8 __ovld __cnfn convert_ushort8_sat_rte(char8);\012ushort8 __ovld __cnfn convert_ushort8_rtz(char8);\012ushort8 __ovld __cnfn convert_ushort8_sat_rtz(char8);\012ushort8 __ovld __cnfn convert_ushort8_rtp(char8);\012ushort8 __ovld __cnfn convert_ushort8_sat_rtp(char8);\012ushort8 __ovld __cnfn convert_ushort8_rtn(char8);\012ushort8 __ovld __cnfn convert_ushort8_sat_rtn(char8);\012ushort8 __ovld __cnfn convert_ushort8(char8);\012ushort8 __ovld __cnfn convert_ushort8_sat(char8);\012ushort8 __ovld __cnfn convert_ushort8_rte(uchar8);\012ushort8 __ovld __cnfn convert_ushort8_sat_rte(uchar8);\012ushort8 __ovld __cnfn convert_ushort8_rtz(uchar8);\012ushort8 __ovld __cnfn convert_ushort8_sat_rtz(uchar8);\012ushort8 __ovld __cnfn convert_ushort8_rtp(uchar8);\012ushort8 __ovld __cnfn convert_ushort8_sat_rtp(uchar8);\012ushort8 __ovld __cnfn convert_ushort8_rtn(uchar8);\012ushort8 __ovld __cnfn convert_ushort8_sat_rtn(uchar8);\012ushort8 __ovld __cnfn convert_ushort8(uchar8);\012ushort8 __ovld __cnfn co",
"nvert_ushort8_sat(uchar8);\012ushort8 __ovld __cnfn convert_ushort8_rte(short8);\012ushort8 __ovld __cnfn convert_ushort8_sat_rte(short8);\012ushort8 __ovld __cnfn convert_ushort8_rtz(short8);\012ushort8 __ovld __cnfn convert_ushort8_sat_rtz(short8);\012ushort8 __ovld __cnfn convert_ushort8_rtp(short8);\012ushort8 __ovld __cnfn convert_ushort8_sat_rtp(short8);\012ushort8 __ovld __cnfn convert_ushort8_rtn(short8);\012ushort8 __ovld __cnfn convert_ushort8_sat_rtn(short8);\012ushort8 __ovld __cnfn convert_ushort8(short8);\012ushort8 __ovld __cnfn convert_ushort8_sat(short8);\012ushort8 __ovld __cnfn convert_ushort8_rte(ushort8);\012ushort8 __ovld __cnfn convert_ushort8_sat_rte(ushort8);\012ushort8 __ovld __cnfn convert_ushort8_rtz(ushort8);\012ushort8 __ovld __cnfn convert_ushort8_sat_rtz(ushort8);\012ushort8 __ovld __cnfn convert_ushort8_rtp(ushort8);\012ushort8 __ovld __cnfn convert_ushort8_sat_rtp(ushort8);\012ushort8 __ovld __cnfn convert_ushort8_rtn(ushort8);\012ushort8 __ovld __cnfn convert_ushort8_sat_rtn(ushort8);\012ushort8 __ovld __cnfn convert_ushort8(ushor",
"t8);\012ushort8 __ovld __cnfn convert_ushort8_sat(ushort8);\012ushort8 __ovld __cnfn convert_ushort8_rte(int8);\012ushort8 __ovld __cnfn convert_ushort8_sat_rte(int8);\012ushort8 __ovld __cnfn convert_ushort8_rtz(int8);\012ushort8 __ovld __cnfn convert_ushort8_sat_rtz(int8);\012ushort8 __ovld __cnfn convert_ushort8_rtp(int8);\012ushort8 __ovld __cnfn convert_ushort8_sat_rtp(int8);\012ushort8 __ovld __cnfn convert_ushort8_rtn(int8);\012ushort8 __ovld __cnfn convert_ushort8_sat_rtn(int8);\012ushort8 __ovld __cnfn convert_ushort8(int8);\012ushort8 __ovld __cnfn convert_ushort8_sat(int8);\012ushort8 __ovld __cnfn convert_ushort8_rte(uint8);\012ushort8 __ovld __cnfn convert_ushort8_sat_rte(uint8);\012ushort8 __ovld __cnfn convert_ushort8_rtz(uint8);\012ushort8 __ovld __cnfn convert_ushort8_sat_rtz(uint8);\012ushort8 __ovld __cnfn convert_ushort8_rtp(uint8);\012ushort8 __ovld __cnfn convert_ushort8_sat_rtp(uint8);\012ushort8 __ovld __cnfn convert_ushort8_rtn(uint8);\012ushort8 __ovld __cnfn convert_ushort8_sat_rtn(uint8);\012ushort8 __ovld __cnfn convert_ushort8(uint8);\012ush",
"ort8 __ovld __cnfn convert_ushort8_sat(uint8);\012ushort8 __ovld __cnfn convert_ushort8_rte(long8);\012ushort8 __ovld __cnfn convert_ushort8_sat_rte(long8);\012ushort8 __ovld __cnfn convert_ushort8_rtz(long8);\012ushort8 __ovld __cnfn convert_ushort8_sat_rtz(long8);\012ushort8 __ovld __cnfn convert_ushort8_rtp(long8);\012ushort8 __ovld __cnfn convert_ushort8_sat_rtp(long8);\012ushort8 __ovld __cnfn convert_ushort8_rtn(long8);\012ushort8 __ovld __cnfn convert_ushort8_sat_rtn(long8);\012ushort8 __ovld __cnfn convert_ushort8(long8);\012ushort8 __ovld __cnfn convert_ushort8_sat(long8);\012ushort8 __ovld __cnfn convert_ushort8_rte(ulong8);\012ushort8 __ovld __cnfn convert_ushort8_sat_rte(ulong8);\012ushort8 __ovld __cnfn convert_ushort8_rtz(ulong8);\012ushort8 __ovld __cnfn convert_ushort8_sat_rtz(ulong8);\012ushort8 __ovld __cnfn convert_ushort8_rtp(ulong8);\012ushort8 __ovld __cnfn convert_ushort8_sat_rtp(ulong8);\012ushort8 __ovld __cnfn convert_ushort8_rtn(ulong8);\012ushort8 __ovld __cnfn convert_ushort8_sat_rtn(ulong8);\012ushort8 __ovld __cnfn convert_ushort8(ulo",
"ng8);\012ushort8 __ovld __cnfn convert_ushort8_sat(ulong8);\012ushort8 __ovld __cnfn convert_ushort8_rte(float8);\012ushort8 __ovld __cnfn convert_ushort8_sat_rte(float8);\012ushort8 __ovld __cnfn convert_ushort8_rtz(float8);\012ushort8 __ovld __cnfn convert_ushort8_sat_rtz(float8);\012ushort8 __ovld __cnfn convert_ushort8_rtp(float8);\012ushort8 __ovld __cnfn convert_ushort8_sat_rtp(float8);\012ushort8 __ovld __cnfn convert_ushort8_rtn(float8);\012ushort8 __ovld __cnfn convert_ushort8_sat_rtn(float8);\012ushort8 __ovld __cnfn convert_ushort8(float8);\012ushort8 __ovld __cnfn convert_ushort8_sat(float8);\012int8 __ovld __cnfn convert_int8_rte(char8);\012int8 __ovld __cnfn convert_int8_sat_rte(char8);\012int8 __ovld __cnfn convert_int8_rtz(char8);\012int8 __ovld __cnfn convert_int8_sat_rtz(char8);\012int8 __ovld __cnfn convert_int8_rtp(char8);\012int8 __ovld __cnfn convert_int8_sat_rtp(char8);\012int8 __ovld __cnfn convert_int8_rtn(char8);\012int8 __ovld __cnfn convert_int8_sat_rtn(char8);\012int8 __ovld __cnfn convert_int8(char8);\012int8 __ovld __cnfn convert_int8_sat(c",
"har8);\012int8 __ovld __cnfn convert_int8_rte(uchar8);\012int8 __ovld __cnfn convert_int8_sat_rte(uchar8);\012int8 __ovld __cnfn convert_int8_rtz(uchar8);\012int8 __ovld __cnfn convert_int8_sat_rtz(uchar8);\012int8 __ovld __cnfn convert_int8_rtp(uchar8);\012int8 __ovld __cnfn convert_int8_sat_rtp(uchar8);\012int8 __ovld __cnfn convert_int8_rtn(uchar8);\012int8 __ovld __cnfn convert_int8_sat_rtn(uchar8);\012int8 __ovld __cnfn convert_int8(uchar8);\012int8 __ovld __cnfn convert_int8_sat(uchar8);\012int8 __ovld __cnfn convert_int8_rte(short8);\012int8 __ovld __cnfn convert_int8_sat_rte(short8);\012int8 __ovld __cnfn convert_int8_rtz(short8);\012int8 __ovld __cnfn convert_int8_sat_rtz(short8);\012int8 __ovld __cnfn convert_int8_rtp(short8);\012int8 __ovld __cnfn convert_int8_sat_rtp(short8);\012int8 __ovld __cnfn convert_int8_rtn(short8);\012int8 __ovld __cnfn convert_int8_sat_rtn(short8);\012int8 __ovld __cnfn convert_int8(short8);\012int8 __ovld __cnfn convert_int8_sat(short8);\012int8 __ovld __cnfn convert_int8_rte(ushort8);\012int8 __ovld __cnfn convert_int8_sat_rte(ushort8",
");\012int8 __ovld __cnfn convert_int8_rtz(ushort8);\012int8 __ovld __cnfn convert_int8_sat_rtz(ushort8);\012int8 __ovld __cnfn convert_int8_rtp(ushort8);\012int8 __ovld __cnfn convert_int8_sat_rtp(ushort8);\012int8 __ovld __cnfn convert_int8_rtn(ushort8);\012int8 __ovld __cnfn convert_int8_sat_rtn(ushort8);\012int8 __ovld __cnfn convert_int8(ushort8);\012int8 __ovld __cnfn convert_int8_sat(ushort8);\012int8 __ovld __cnfn convert_int8_rte(int8);\012int8 __ovld __cnfn convert_int8_sat_rte(int8);\012int8 __ovld __cnfn convert_int8_rtz(int8);\012int8 __ovld __cnfn convert_int8_sat_rtz(int8);\012int8 __ovld __cnfn convert_int8_rtp(int8);\012int8 __ovld __cnfn convert_int8_sat_rtp(int8);\012int8 __ovld __cnfn convert_int8_rtn(int8);\012int8 __ovld __cnfn convert_int8_sat_rtn(int8);\012int8 __ovld __cnfn convert_int8(int8);\012int8 __ovld __cnfn convert_int8_sat(int8);\012int8 __ovld __cnfn convert_int8_rte(uint8);\012int8 __ovld __cnfn convert_int8_sat_rte(uint8);\012int8 __ovld __cnfn convert_int8_rtz(uint8);\012int8 __ovld __cnfn convert_int8_sat_rtz(uint8);\012int8 __ovld __cnfn ",
"convert_int8_rtp(uint8);\012int8 __ovld __cnfn convert_int8_sat_rtp(uint8);\012int8 __ovld __cnfn convert_int8_rtn(uint8);\012int8 __ovld __cnfn convert_int8_sat_rtn(uint8);\012int8 __ovld __cnfn convert_int8(uint8);\012int8 __ovld __cnfn convert_int8_sat(uint8);\012int8 __ovld __cnfn convert_int8_rte(long8);\012int8 __ovld __cnfn convert_int8_sat_rte(long8);\012int8 __ovld __cnfn convert_int8_rtz(long8);\012int8 __ovld __cnfn convert_int8_sat_rtz(long8);\012int8 __ovld __cnfn convert_int8_rtp(long8);\012int8 __ovld __cnfn convert_int8_sat_rtp(long8);\012int8 __ovld __cnfn convert_int8_rtn(long8);\012int8 __ovld __cnfn convert_int8_sat_rtn(long8);\012int8 __ovld __cnfn convert_int8(long8);\012int8 __ovld __cnfn convert_int8_sat(long8);\012int8 __ovld __cnfn convert_int8_rte(ulong8);\012int8 __ovld __cnfn convert_int8_sat_rte(ulong8);\012int8 __ovld __cnfn convert_int8_rtz(ulong8);\012int8 __ovld __cnfn convert_int8_sat_rtz(ulong8);\012int8 __ovld __cnfn convert_int8_rtp(ulong8);\012int8 __ovld __cnfn convert_int8_sat_rtp(ulong8);\012int8 __ovld __cnfn convert_int8_rtn(ulong",
"8);\012int8 __ovld __cnfn convert_int8_sat_rtn(ulong8);\012int8 __ovld __cnfn convert_int8(ulong8);\012int8 __ovld __cnfn convert_int8_sat(ulong8);\012int8 __ovld __cnfn convert_int8_rte(float8);\012int8 __ovld __cnfn convert_int8_sat_rte(float8);\012int8 __ovld __cnfn convert_int8_rtz(float8);\012int8 __ovld __cnfn convert_int8_sat_rtz(float8);\012int8 __ovld __cnfn convert_int8_rtp(float8);\012int8 __ovld __cnfn convert_int8_sat_rtp(float8);\012int8 __ovld __cnfn convert_int8_rtn(float8);\012int8 __ovld __cnfn convert_int8_sat_rtn(float8);\012int8 __ovld __cnfn convert_int8(float8);\012int8 __ovld __cnfn convert_int8_sat(float8);\012uint8 __ovld __cnfn convert_uint8_rte(char8);\012uint8 __ovld __cnfn convert_uint8_sat_rte(char8);\012uint8 __ovld __cnfn convert_uint8_rtz(char8);\012uint8 __ovld __cnfn convert_uint8_sat_rtz(char8);\012uint8 __ovld __cnfn convert_uint8_rtp(char8);\012uint8 __ovld __cnfn convert_uint8_sat_rtp(char8);\012uint8 __ovld __cnfn convert_uint8_rtn(char8);\012uint8 __ovld __cnfn convert_uint8_sat_rtn(char8);\012uint8 __ovld __cnfn convert_uint8(char8",
");\012uint8 __ovld __cnfn convert_uint8_sat(char8);\012uint8 __ovld __cnfn convert_uint8_rte(uchar8);\012uint8 __ovld __cnfn convert_uint8_sat_rte(uchar8);\012uint8 __ovld __cnfn convert_uint8_rtz(uchar8);\012uint8 __ovld __cnfn convert_uint8_sat_rtz(uchar8);\012uint8 __ovld __cnfn convert_uint8_rtp(uchar8);\012uint8 __ovld __cnfn convert_uint8_sat_rtp(uchar8);\012uint8 __ovld __cnfn convert_uint8_rtn(uchar8);\012uint8 __ovld __cnfn convert_uint8_sat_rtn(uchar8);\012uint8 __ovld __cnfn convert_uint8(uchar8);\012uint8 __ovld __cnfn convert_uint8_sat(uchar8);\012uint8 __ovld __cnfn convert_uint8_rte(short8);\012uint8 __ovld __cnfn convert_uint8_sat_rte(short8);\012uint8 __ovld __cnfn convert_uint8_rtz(short8);\012uint8 __ovld __cnfn convert_uint8_sat_rtz(short8);\012uint8 __ovld __cnfn convert_uint8_rtp(short8);\012uint8 __ovld __cnfn convert_uint8_sat_rtp(short8);\012uint8 __ovld __cnfn convert_uint8_rtn(short8);\012uint8 __ovld __cnfn convert_uint8_sat_rtn(short8);\012uint8 __ovld __cnfn convert_uint8(short8);\012uint8 __ovld __cnfn convert_uint8_sat(short8);\012uint8 __ovl",
"d __cnfn convert_uint8_rte(ushort8);\012uint8 __ovld __cnfn convert_uint8_sat_rte(ushort8);\012uint8 __ovld __cnfn convert_uint8_rtz(ushort8);\012uint8 __ovld __cnfn convert_uint8_sat_rtz(ushort8);\012uint8 __ovld __cnfn convert_uint8_rtp(ushort8);\012uint8 __ovld __cnfn convert_uint8_sat_rtp(ushort8);\012uint8 __ovld __cnfn convert_uint8_rtn(ushort8);\012uint8 __ovld __cnfn convert_uint8_sat_rtn(ushort8);\012uint8 __ovld __cnfn convert_uint8(ushort8);\012uint8 __ovld __cnfn convert_uint8_sat(ushort8);\012uint8 __ovld __cnfn convert_uint8_rte(int8);\012uint8 __ovld __cnfn convert_uint8_sat_rte(int8);\012uint8 __ovld __cnfn convert_uint8_rtz(int8);\012uint8 __ovld __cnfn convert_uint8_sat_rtz(int8);\012uint8 __ovld __cnfn convert_uint8_rtp(int8);\012uint8 __ovld __cnfn convert_uint8_sat_rtp(int8);\012uint8 __ovld __cnfn convert_uint8_rtn(int8);\012uint8 __ovld __cnfn convert_uint8_sat_rtn(int8);\012uint8 __ovld __cnfn convert_uint8(int8);\012uint8 __ovld __cnfn convert_uint8_sat(int8);\012uint8 __ovld __cnfn convert_uint8_rte(uint8);\012uint8 __ovld __cnfn convert_uint8_s",
"at_rte(uint8);\012uint8 __ovld __cnfn convert_uint8_rtz(uint8);\012uint8 __ovld __cnfn convert_uint8_sat_rtz(uint8);\012uint8 __ovld __cnfn convert_uint8_rtp(uint8);\012uint8 __ovld __cnfn convert_uint8_sat_rtp(uint8);\012uint8 __ovld __cnfn convert_uint8_rtn(uint8);\012uint8 __ovld __cnfn convert_uint8_sat_rtn(uint8);\012uint8 __ovld __cnfn convert_uint8(uint8);\012uint8 __ovld __cnfn convert_uint8_sat(uint8);\012uint8 __ovld __cnfn convert_uint8_rte(long8);\012uint8 __ovld __cnfn convert_uint8_sat_rte(long8);\012uint8 __ovld __cnfn convert_uint8_rtz(long8);\012uint8 __ovld __cnfn convert_uint8_sat_rtz(long8);\012uint8 __ovld __cnfn convert_uint8_rtp(long8);\012uint8 __ovld __cnfn convert_uint8_sat_rtp(long8);\012uint8 __ovld __cnfn convert_uint8_rtn(long8);\012uint8 __ovld __cnfn convert_uint8_sat_rtn(long8);\012uint8 __ovld __cnfn convert_uint8(long8);\012uint8 __ovld __cnfn convert_uint8_sat(long8);\012uint8 __ovld __cnfn convert_uint8_rte(ulong8);\012uint8 __ovld __cnfn convert_uint8_sat_rte(ulong8);\012uint8 __ovld __cnfn convert_uint8_rtz(ulong8);\012uint8 __ovld __c",
"nfn convert_uint8_sat_rtz(ulong8);\012uint8 __ovld __cnfn convert_uint8_rtp(ulong8);\012uint8 __ovld __cnfn convert_uint8_sat_rtp(ulong8);\012uint8 __ovld __cnfn convert_uint8_rtn(ulong8);\012uint8 __ovld __cnfn convert_uint8_sat_rtn(ulong8);\012uint8 __ovld __cnfn convert_uint8(ulong8);\012uint8 __ovld __cnfn convert_uint8_sat(ulong8);\012uint8 __ovld __cnfn convert_uint8_rte(float8);\012uint8 __ovld __cnfn convert_uint8_sat_rte(float8);\012uint8 __ovld __cnfn convert_uint8_rtz(float8);\012uint8 __ovld __cnfn convert_uint8_sat_rtz(float8);\012uint8 __ovld __cnfn convert_uint8_rtp(float8);\012uint8 __ovld __cnfn convert_uint8_sat_rtp(float8);\012uint8 __ovld __cnfn convert_uint8_rtn(float8);\012uint8 __ovld __cnfn convert_uint8_sat_rtn(float8);\012uint8 __ovld __cnfn convert_uint8(float8);\012uint8 __ovld __cnfn convert_uint8_sat(float8);\012long8 __ovld __cnfn convert_long8_rte(char8);\012long8 __ovld __cnfn convert_long8_sat_rte(char8);\012long8 __ovld __cnfn convert_long8_rtz(char8);\012long8 __ovld __cnfn convert_long8_sat_rtz(char8);\012long8 __ovld __cnfn convert_l",
"ong8_rtp(char8);\012long8 __ovld __cnfn convert_long8_sat_rtp(char8);\012long8 __ovld __cnfn convert_long8_rtn(char8);\012long8 __ovld __cnfn convert_long8_sat_rtn(char8);\012long8 __ovld __cnfn convert_long8(char8);\012long8 __ovld __cnfn convert_long8_sat(char8);\012long8 __ovld __cnfn convert_long8_rte(uchar8);\012long8 __ovld __cnfn convert_long8_sat_rte(uchar8);\012long8 __ovld __cnfn convert_long8_rtz(uchar8);\012long8 __ovld __cnfn convert_long8_sat_rtz(uchar8);\012long8 __ovld __cnfn convert_long8_rtp(uchar8);\012long8 __ovld __cnfn convert_long8_sat_rtp(uchar8);\012long8 __ovld __cnfn convert_long8_rtn(uchar8);\012long8 __ovld __cnfn convert_long8_sat_rtn(uchar8);\012long8 __ovld __cnfn convert_long8(uchar8);\012long8 __ovld __cnfn convert_long8_sat(uchar8);\012long8 __ovld __cnfn convert_long8_rte(short8);\012long8 __ovld __cnfn convert_long8_sat_rte(short8);\012long8 __ovld __cnfn convert_long8_rtz(short8);\012long8 __ovld __cnfn convert_long8_sat_rtz(short8);\012long8 __ovld __cnfn convert_long8_rtp(short8);\012long8 __ovld __cnfn convert_long8_sat_rtp(short8",
");\012long8 __ovld __cnfn convert_long8_rtn(short8);\012long8 __ovld __cnfn convert_long8_sat_rtn(short8);\012long8 __ovld __cnfn convert_long8(short8);\012long8 __ovld __cnfn convert_long8_sat(short8);\012long8 __ovld __cnfn convert_long8_rte(ushort8);\012long8 __ovld __cnfn convert_long8_sat_rte(ushort8);\012long8 __ovld __cnfn convert_long8_rtz(ushort8);\012long8 __ovld __cnfn convert_long8_sat_rtz(ushort8);\012long8 __ovld __cnfn convert_long8_rtp(ushort8);\012long8 __ovld __cnfn convert_long8_sat_rtp(ushort8);\012long8 __ovld __cnfn convert_long8_rtn(ushort8);\012long8 __ovld __cnfn convert_long8_sat_rtn(ushort8);\012long8 __ovld __cnfn convert_long8(ushort8);\012long8 __ovld __cnfn convert_long8_sat(ushort8);\012long8 __ovld __cnfn convert_long8_rte(int8);\012long8 __ovld __cnfn convert_long8_sat_rte(int8);\012long8 __ovld __cnfn convert_long8_rtz(int8);\012long8 __ovld __cnfn convert_long8_sat_rtz(int8);\012long8 __ovld __cnfn convert_long8_rtp(int8);\012long8 __ovld __cnfn convert_long8_sat_rtp(int8);\012long8 __ovld __cnfn convert_long8_rtn(int8);\012long8 __ovld _",
"_cnfn convert_long8_sat_rtn(int8);\012long8 __ovld __cnfn convert_long8(int8);\012long8 __ovld __cnfn convert_long8_sat(int8);\012long8 __ovld __cnfn convert_long8_rte(uint8);\012long8 __ovld __cnfn convert_long8_sat_rte(uint8);\012long8 __ovld __cnfn convert_long8_rtz(uint8);\012long8 __ovld __cnfn convert_long8_sat_rtz(uint8);\012long8 __ovld __cnfn convert_long8_rtp(uint8);\012long8 __ovld __cnfn convert_long8_sat_rtp(uint8);\012long8 __ovld __cnfn convert_long8_rtn(uint8);\012long8 __ovld __cnfn convert_long8_sat_rtn(uint8);\012long8 __ovld __cnfn convert_long8(uint8);\012long8 __ovld __cnfn convert_long8_sat(uint8);\012long8 __ovld __cnfn convert_long8_rte(long8);\012long8 __ovld __cnfn convert_long8_sat_rte(long8);\012long8 __ovld __cnfn convert_long8_rtz(long8);\012long8 __ovld __cnfn convert_long8_sat_rtz(long8);\012long8 __ovld __cnfn convert_long8_rtp(long8);\012long8 __ovld __cnfn convert_long8_sat_rtp(long8);\012long8 __ovld __cnfn convert_long8_rtn(long8);\012long8 __ovld __cnfn convert_long8_sat_rtn(long8);\012long8 __ovld __cnfn convert_long8(long8);\012long8",
" __ovld __cnfn convert_long8_sat(long8);\012long8 __ovld __cnfn convert_long8_rte(ulong8);\012long8 __ovld __cnfn convert_long8_sat_rte(ulong8);\012long8 __ovld __cnfn convert_long8_rtz(ulong8);\012long8 __ovld __cnfn convert_long8_sat_rtz(ulong8);\012long8 __ovld __cnfn convert_long8_rtp(ulong8);\012long8 __ovld __cnfn convert_long8_sat_rtp(ulong8);\012long8 __ovld __cnfn convert_long8_rtn(ulong8);\012long8 __ovld __cnfn convert_long8_sat_rtn(ulong8);\012long8 __ovld __cnfn convert_long8(ulong8);\012long8 __ovld __cnfn convert_long8_sat(ulong8);\012long8 __ovld __cnfn convert_long8_rte(float8);\012long8 __ovld __cnfn convert_long8_sat_rte(float8);\012long8 __ovld __cnfn convert_long8_rtz(float8);\012long8 __ovld __cnfn convert_long8_sat_rtz(float8);\012long8 __ovld __cnfn convert_long8_rtp(float8);\012long8 __ovld __cnfn convert_long8_sat_rtp(float8);\012long8 __ovld __cnfn convert_long8_rtn(float8);\012long8 __ovld __cnfn convert_long8_sat_rtn(float8);\012long8 __ovld __cnfn convert_long8(float8);\012long8 __ovld __cnfn convert_long8_sat(float8);\012ulong8 __ovld __cnf",
"n convert_ulong8_rte(char8);\012ulong8 __ovld __cnfn convert_ulong8_sat_rte(char8);\012ulong8 __ovld __cnfn convert_ulong8_rtz(char8);\012ulong8 __ovld __cnfn convert_ulong8_sat_rtz(char8);\012ulong8 __ovld __cnfn convert_ulong8_rtp(char8);\012ulong8 __ovld __cnfn convert_ulong8_sat_rtp(char8);\012ulong8 __ovld __cnfn convert_ulong8_rtn(char8);\012ulong8 __ovld __cnfn convert_ulong8_sat_rtn(char8);\012ulong8 __ovld __cnfn convert_ulong8(char8);\012ulong8 __ovld __cnfn convert_ulong8_sat(char8);\012ulong8 __ovld __cnfn convert_ulong8_rte(uchar8);\012ulong8 __ovld __cnfn convert_ulong8_sat_rte(uchar8);\012ulong8 __ovld __cnfn convert_ulong8_rtz(uchar8);\012ulong8 __ovld __cnfn convert_ulong8_sat_rtz(uchar8);\012ulong8 __ovld __cnfn convert_ulong8_rtp(uchar8);\012ulong8 __ovld __cnfn convert_ulong8_sat_rtp(uchar8);\012ulong8 __ovld __cnfn convert_ulong8_rtn(uchar8);\012ulong8 __ovld __cnfn convert_ulong8_sat_rtn(uchar8);\012ulong8 __ovld __cnfn convert_ulong8(uchar8);\012ulong8 __ovld __cnfn convert_ulong8_sat(uchar8);\012ulong8 __ovld __cnfn convert_ulong8_rte(short8);\012",
"ulong8 __ovld __cnfn convert_ulong8_sat_rte(short8);\012ulong8 __ovld __cnfn convert_ulong8_rtz(short8);\012ulong8 __ovld __cnfn convert_ulong8_sat_rtz(short8);\012ulong8 __ovld __cnfn convert_ulong8_rtp(short8);\012ulong8 __ovld __cnfn convert_ulong8_sat_rtp(short8);\012ulong8 __ovld __cnfn convert_ulong8_rtn(short8);\012ulong8 __ovld __cnfn convert_ulong8_sat_rtn(short8);\012ulong8 __ovld __cnfn convert_ulong8(short8);\012ulong8 __ovld __cnfn convert_ulong8_sat(short8);\012ulong8 __ovld __cnfn convert_ulong8_rte(ushort8);\012ulong8 __ovld __cnfn convert_ulong8_sat_rte(ushort8);\012ulong8 __ovld __cnfn convert_ulong8_rtz(ushort8);\012ulong8 __ovld __cnfn convert_ulong8_sat_rtz(ushort8);\012ulong8 __ovld __cnfn convert_ulong8_rtp(ushort8);\012ulong8 __ovld __cnfn convert_ulong8_sat_rtp(ushort8);\012ulong8 __ovld __cnfn convert_ulong8_rtn(ushort8);\012ulong8 __ovld __cnfn convert_ulong8_sat_rtn(ushort8);\012ulong8 __ovld __cnfn convert_ulong8(ushort8);\012ulong8 __ovld __cnfn convert_ulong8_sat(ushort8);\012ulong8 __ovld __cnfn convert_ulong8_rte(int8);\012ulong8 __ovl",
"d __cnfn convert_ulong8_sat_rte(int8);\012ulong8 __ovld __cnfn convert_ulong8_rtz(int8);\012ulong8 __ovld __cnfn convert_ulong8_sat_rtz(int8);\012ulong8 __ovld __cnfn convert_ulong8_rtp(int8);\012ulong8 __ovld __cnfn convert_ulong8_sat_rtp(int8);\012ulong8 __ovld __cnfn convert_ulong8_rtn(int8);\012ulong8 __ovld __cnfn convert_ulong8_sat_rtn(int8);\012ulong8 __ovld __cnfn convert_ulong8(int8);\012ulong8 __ovld __cnfn convert_ulong8_sat(int8);\012ulong8 __ovld __cnfn convert_ulong8_rte(uint8);\012ulong8 __ovld __cnfn convert_ulong8_sat_rte(uint8);\012ulong8 __ovld __cnfn convert_ulong8_rtz(uint8);\012ulong8 __ovld __cnfn convert_ulong8_sat_rtz(uint8);\012ulong8 __ovld __cnfn convert_ulong8_rtp(uint8);\012ulong8 __ovld __cnfn convert_ulong8_sat_rtp(uint8);\012ulong8 __ovld __cnfn convert_ulong8_rtn(uint8);\012ulong8 __ovld __cnfn convert_ulong8_sat_rtn(uint8);\012ulong8 __ovld __cnfn convert_ulong8(uint8);\012ulong8 __ovld __cnfn convert_ulong8_sat(uint8);\012ulong8 __ovld __cnfn convert_ulong8_rte(long8);\012ulong8 __ovld __cnfn convert_ulong8_sat_rte(long8);\012ulong8 __",
"ovld __cnfn convert_ulong8_rtz(long8);\012ulong8 __ovld __cnfn convert_ulong8_sat_rtz(long8);\012ulong8 __ovld __cnfn convert_ulong8_rtp(long8);\012ulong8 __ovld __cnfn convert_ulong8_sat_rtp(long8);\012ulong8 __ovld __cnfn convert_ulong8_rtn(long8);\012ulong8 __ovld __cnfn convert_ulong8_sat_rtn(long8);\012ulong8 __ovld __cnfn convert_ulong8(long8);\012ulong8 __ovld __cnfn convert_ulong8_sat(long8);\012ulong8 __ovld __cnfn convert_ulong8_rte(ulong8);\012ulong8 __ovld __cnfn convert_ulong8_sat_rte(ulong8);\012ulong8 __ovld __cnfn convert_ulong8_rtz(ulong8);\012ulong8 __ovld __cnfn convert_ulong8_sat_rtz(ulong8);\012ulong8 __ovld __cnfn convert_ulong8_rtp(ulong8);\012ulong8 __ovld __cnfn convert_ulong8_sat_rtp(ulong8);\012ulong8 __ovld __cnfn convert_ulong8_rtn(ulong8);\012ulong8 __ovld __cnfn convert_ulong8_sat_rtn(ulong8);\012ulong8 __ovld __cnfn convert_ulong8(ulong8);\012ulong8 __ovld __cnfn convert_ulong8_sat(ulong8);\012ulong8 __ovld __cnfn convert_ulong8_rte(float8);\012ulong8 __ovld __cnfn convert_ulong8_sat_rte(float8);\012ulong8 __ovld __cnfn convert_ulong8_r",
"tz(float8);\012ulong8 __ovld __cnfn convert_ulong8_sat_rtz(float8);\012ulong8 __ovld __cnfn convert_ulong8_rtp(float8);\012ulong8 __ovld __cnfn convert_ulong8_sat_rtp(float8);\012ulong8 __ovld __cnfn convert_ulong8_rtn(float8);\012ulong8 __ovld __cnfn convert_ulong8_sat_rtn(float8);\012ulong8 __ovld __cnfn convert_ulong8(float8);\012ulong8 __ovld __cnfn convert_ulong8_sat(float8);\012float8 __ovld __cnfn convert_float8_rte(char8);\012float8 __ovld __cnfn convert_float8_rtz(char8);\012float8 __ovld __cnfn convert_float8_rtp(char8);\012float8 __ovld __cnfn convert_float8_rtn(char8);\012float8 __ovld __cnfn convert_float8(char8);\012float8 __ovld __cnfn convert_float8_rte(uchar8);\012float8 __ovld __cnfn convert_float8_rtz(uchar8);\012float8 __ovld __cnfn convert_float8_rtp(uchar8);\012float8 __ovld __cnfn convert_float8_rtn(uchar8);\012float8 __ovld __cnfn convert_float8(uchar8);\012float8 __ovld __cnfn convert_float8_rte(short8);\012float8 __ovld __cnfn convert_float8_rtz(short8);\012float8 __ovld __cnfn convert_float8_rtp(short8);\012float8 __ovld __cnfn convert_float8_r",
"tn(short8);\012float8 __ovld __cnfn convert_float8(short8);\012float8 __ovld __cnfn convert_float8_rte(ushort8);\012float8 __ovld __cnfn convert_float8_rtz(ushort8);\012float8 __ovld __cnfn convert_float8_rtp(ushort8);\012float8 __ovld __cnfn convert_float8_rtn(ushort8);\012float8 __ovld __cnfn convert_float8(ushort8);\012float8 __ovld __cnfn convert_float8_rte(int8);\012float8 __ovld __cnfn convert_float8_rtz(int8);\012float8 __ovld __cnfn convert_float8_rtp(int8);\012float8 __ovld __cnfn convert_float8_rtn(int8);\012float8 __ovld __cnfn convert_float8(int8);\012float8 __ovld __cnfn convert_float8_rte(uint8);\012float8 __ovld __cnfn convert_float8_rtz(uint8);\012float8 __ovld __cnfn convert_float8_rtp(uint8);\012float8 __ovld __cnfn convert_float8_rtn(uint8);\012float8 __ovld __cnfn convert_float8(uint8);\012float8 __ovld __cnfn convert_float8_rte(long8);\012float8 __ovld __cnfn convert_float8_rtz(long8);\012float8 __ovld __cnfn convert_float8_rtp(long8);\012float8 __ovld __cnfn convert_float8_rtn(long8);\012float8 __ovld __cnfn convert_float8(long8);\012float8 __ovld __cn",
"fn convert_float8_rte(ulong8);\012float8 __ovld __cnfn convert_float8_rtz(ulong8);\012float8 __ovld __cnfn convert_float8_rtp(ulong8);\012float8 __ovld __cnfn convert_float8_rtn(ulong8);\012float8 __ovld __cnfn convert_float8(ulong8);\012float8 __ovld __cnfn convert_float8_rte(float8);\012float8 __ovld __cnfn convert_float8_rtz(float8);\012float8 __ovld __cnfn convert_float8_rtp(float8);\012float8 __ovld __cnfn convert_float8_rtn(float8);\012float8 __ovld __cnfn convert_float8(float8);\012char16 __ovld __cnfn convert_char16_rte(char16);\012char16 __ovld __cnfn convert_char16_sat_rte(char16);\012char16 __ovld __cnfn convert_char16_rtz(char16);\012char16 __ovld __cnfn convert_char16_sat_rtz(char16);\012char16 __ovld __cnfn convert_char16_rtp(char16);\012char16 __ovld __cnfn convert_char16_sat_rtp(char16);\012char16 __ovld __cnfn convert_char16_rtn(char16);\012char16 __ovld __cnfn convert_char16_sat_rtn(char16);\012char16 __ovld __cnfn convert_char16(char16);\012char16 __ovld __cnfn convert_char16_sat(char16);\012char16 __ovld __cnfn convert_char16_rte(uchar16);\012char16 _",
"_ovld __cnfn convert_char16_sat_rte(uchar16);\012char16 __ovld __cnfn convert_char16_rtz(uchar16);\012char16 __ovld __cnfn convert_char16_sat_rtz(uchar16);\012char16 __ovld __cnfn convert_char16_rtp(uchar16);\012char16 __ovld __cnfn convert_char16_sat_rtp(uchar16);\012char16 __ovld __cnfn convert_char16_rtn(uchar16);\012char16 __ovld __cnfn convert_char16_sat_rtn(uchar16);\012char16 __ovld __cnfn convert_char16(uchar16);\012char16 __ovld __cnfn convert_char16_sat(uchar16);\012char16 __ovld __cnfn convert_char16_rte(short16);\012char16 __ovld __cnfn convert_char16_sat_rte(short16);\012char16 __ovld __cnfn convert_char16_rtz(short16);\012char16 __ovld __cnfn convert_char16_sat_rtz(short16);\012char16 __ovld __cnfn convert_char16_rtp(short16);\012char16 __ovld __cnfn convert_char16_sat_rtp(short16);\012char16 __ovld __cnfn convert_char16_rtn(short16);\012char16 __ovld __cnfn convert_char16_sat_rtn(short16);\012char16 __ovld __cnfn convert_char16(short16);\012char16 __ovld __cnfn convert_char16_sat(short16);\012char16 __ovld __cnfn convert_char16_rte(ushort16);\012char16 ",
"__ovld __cnfn convert_char16_sat_rte(ushort16);\012char16 __ovld __cnfn convert_char16_rtz(ushort16);\012char16 __ovld __cnfn convert_char16_sat_rtz(ushort16);\012char16 __ovld __cnfn convert_char16_rtp(ushort16);\012char16 __ovld __cnfn convert_char16_sat_rtp(ushort16);\012char16 __ovld __cnfn convert_char16_rtn(ushort16);\012char16 __ovld __cnfn convert_char16_sat_rtn(ushort16);\012char16 __ovld __cnfn convert_char16(ushort16);\012char16 __ovld __cnfn convert_char16_sat(ushort16);\012char16 __ovld __cnfn convert_char16_rte(int16);\012char16 __ovld __cnfn convert_char16_sat_rte(int16);\012char16 __ovld __cnfn convert_char16_rtz(int16);\012char16 __ovld __cnfn convert_char16_sat_rtz(int16);\012char16 __ovld __cnfn convert_char16_rtp(int16);\012char16 __ovld __cnfn convert_char16_sat_rtp(int16);\012char16 __ovld __cnfn convert_char16_rtn(int16);\012char16 __ovld __cnfn convert_char16_sat_rtn(int16);\012char16 __ovld __cnfn convert_char16(int16);\012char16 __ovld __cnfn convert_char16_sat(int16);\012char16 __ovld __cnfn convert_char16_rte(uint16);\012char16 __ovld __cnf",
"n convert_char16_sat_rte(uint16);\012char16 __ovld __cnfn convert_char16_rtz(uint16);\012char16 __ovld __cnfn convert_char16_sat_rtz(uint16);\012char16 __ovld __cnfn convert_char16_rtp(uint16);\012char16 __ovld __cnfn convert_char16_sat_rtp(uint16);\012char16 __ovld __cnfn convert_char16_rtn(uint16);\012char16 __ovld __cnfn convert_char16_sat_rtn(uint16);\012char16 __ovld __cnfn convert_char16(uint16);\012char16 __ovld __cnfn convert_char16_sat(uint16);\012char16 __ovld __cnfn convert_char16_rte(long16);\012char16 __ovld __cnfn convert_char16_sat_rte(long16);\012char16 __ovld __cnfn convert_char16_rtz(long16);\012char16 __ovld __cnfn convert_char16_sat_rtz(long16);\012char16 __ovld __cnfn convert_char16_rtp(long16);\012char16 __ovld __cnfn convert_char16_sat_rtp(long16);\012char16 __ovld __cnfn convert_char16_rtn(long16);\012char16 __ovld __cnfn convert_char16_sat_rtn(long16);\012char16 __ovld __cnfn convert_char16(long16);\012char16 __ovld __cnfn convert_char16_sat(long16);\012char16 __ovld __cnfn convert_char16_rte(ulong16);\012char16 __ovld __cnfn convert_char16_sa",
"t_rte(ulong16);\012char16 __ovld __cnfn convert_char16_rtz(ulong16);\012char16 __ovld __cnfn convert_char16_sat_rtz(ulong16);\012char16 __ovld __cnfn convert_char16_rtp(ulong16);\012char16 __ovld __cnfn convert_char16_sat_rtp(ulong16);\012char16 __ovld __cnfn convert_char16_rtn(ulong16);\012char16 __ovld __cnfn convert_char16_sat_rtn(ulong16);\012char16 __ovld __cnfn convert_char16(ulong16);\012char16 __ovld __cnfn convert_char16_sat(ulong16);\012char16 __ovld __cnfn convert_char16_rte(float16);\012char16 __ovld __cnfn convert_char16_sat_rte(float16);\012char16 __ovld __cnfn convert_char16_rtz(float16);\012char16 __ovld __cnfn convert_char16_sat_rtz(float16);\012char16 __ovld __cnfn convert_char16_rtp(float16);\012char16 __ovld __cnfn convert_char16_sat_rtp(float16);\012char16 __ovld __cnfn convert_char16_rtn(float16);\012char16 __ovld __cnfn convert_char16_sat_rtn(float16);\012char16 __ovld __cnfn convert_char16(float16);\012char16 __ovld __cnfn convert_char16_sat(float16);\012uchar16 __ovld __cnfn convert_uchar16_rte(char16);\012uchar16 __ovld __cnfn convert_uchar16",
"_sat_rte(char16);\012uchar16 __ovld __cnfn convert_uchar16_rtz(char16);\012uchar16 __ovld __cnfn convert_uchar16_sat_rtz(char16);\012uchar16 __ovld __cnfn convert_uchar16_rtp(char16);\012uchar16 __ovld __cnfn convert_uchar16_sat_rtp(char16);\012uchar16 __ovld __cnfn convert_uchar16_rtn(char16);\012uchar16 __ovld __cnfn convert_uchar16_sat_rtn(char16);\012uchar16 __ovld __cnfn convert_uchar16(char16);\012uchar16 __ovld __cnfn convert_uchar16_sat(char16);\012uchar16 __ovld __cnfn convert_uchar16_rte(uchar16);\012uchar16 __ovld __cnfn convert_uchar16_sat_rte(uchar16);\012uchar16 __ovld __cnfn convert_uchar16_rtz(uchar16);\012uchar16 __ovld __cnfn convert_uchar16_sat_rtz(uchar16);\012uchar16 __ovld __cnfn convert_uchar16_rtp(uchar16);\012uchar16 __ovld __cnfn convert_uchar16_sat_rtp(uchar16);\012uchar16 __ovld __cnfn convert_uchar16_rtn(uchar16);\012uchar16 __ovld __cnfn convert_uchar16_sat_rtn(uchar16);\012uchar16 __ovld __cnfn convert_uchar16(uchar16);\012uchar16 __ovld __cnfn convert_uchar16_sat(uchar16);\012uchar16 __ovld __cnfn convert_uchar16_rte(short16);\012uchar1",
"6 __ovld __cnfn convert_uchar16_sat_rte(short16);\012uchar16 __ovld __cnfn convert_uchar16_rtz(short16);\012uchar16 __ovld __cnfn convert_uchar16_sat_rtz(short16);\012uchar16 __ovld __cnfn convert_uchar16_rtp(short16);\012uchar16 __ovld __cnfn convert_uchar16_sat_rtp(short16);\012uchar16 __ovld __cnfn convert_uchar16_rtn(short16);\012uchar16 __ovld __cnfn convert_uchar16_sat_rtn(short16);\012uchar16 __ovld __cnfn convert_uchar16(short16);\012uchar16 __ovld __cnfn convert_uchar16_sat(short16);\012uchar16 __ovld __cnfn convert_uchar16_rte(ushort16);\012uchar16 __ovld __cnfn convert_uchar16_sat_rte(ushort16);\012uchar16 __ovld __cnfn convert_uchar16_rtz(ushort16);\012uchar16 __ovld __cnfn convert_uchar16_sat_rtz(ushort16);\012uchar16 __ovld __cnfn convert_uchar16_rtp(ushort16);\012uchar16 __ovld __cnfn convert_uchar16_sat_rtp(ushort16);\012uchar16 __ovld __cnfn convert_uchar16_rtn(ushort16);\012uchar16 __ovld __cnfn convert_uchar16_sat_rtn(ushort16);\012uchar16 __ovld __cnfn convert_uchar16(ushort16);\012uchar16 __ovld __cnfn convert_uchar16_sat(ushort16);\012uchar16 ",
"__ovld __cnfn convert_uchar16_rte(int16);\012uchar16 __ovld __cnfn convert_uchar16_sat_rte(int16);\012uchar16 __ovld __cnfn convert_uchar16_rtz(int16);\012uchar16 __ovld __cnfn convert_uchar16_sat_rtz(int16);\012uchar16 __ovld __cnfn convert_uchar16_rtp(int16);\012uchar16 __ovld __cnfn convert_uchar16_sat_rtp(int16);\012uchar16 __ovld __cnfn convert_uchar16_rtn(int16);\012uchar16 __ovld __cnfn convert_uchar16_sat_rtn(int16);\012uchar16 __ovld __cnfn convert_uchar16(int16);\012uchar16 __ovld __cnfn convert_uchar16_sat(int16);\012uchar16 __ovld __cnfn convert_uchar16_rte(uint16);\012uchar16 __ovld __cnfn convert_uchar16_sat_rte(uint16);\012uchar16 __ovld __cnfn convert_uchar16_rtz(uint16);\012uchar16 __ovld __cnfn convert_uchar16_sat_rtz(uint16);\012uchar16 __ovld __cnfn convert_uchar16_rtp(uint16);\012uchar16 __ovld __cnfn convert_uchar16_sat_rtp(uint16);\012uchar16 __ovld __cnfn convert_uchar16_rtn(uint16);\012uchar16 __ovld __cnfn convert_uchar16_sat_rtn(uint16);\012uchar16 __ovld __cnfn convert_uchar16(uint16);\012uchar16 __ovld __cnfn convert_uchar16_sat(uint16)",
";\012uchar16 __ovld __cnfn convert_uchar16_rte(long16);\012uchar16 __ovld __cnfn convert_uchar16_sat_rte(long16);\012uchar16 __ovld __cnfn convert_uchar16_rtz(long16);\012uchar16 __ovld __cnfn convert_uchar16_sat_rtz(long16);\012uchar16 __ovld __cnfn convert_uchar16_rtp(long16);\012uchar16 __ovld __cnfn convert_uchar16_sat_rtp(long16);\012uchar16 __ovld __cnfn convert_uchar16_rtn(long16);\012uchar16 __ovld __cnfn convert_uchar16_sat_rtn(long16);\012uchar16 __ovld __cnfn convert_uchar16(long16);\012uchar16 __ovld __cnfn convert_uchar16_sat(long16);\012uchar16 __ovld __cnfn convert_uchar16_rte(ulong16);\012uchar16 __ovld __cnfn convert_uchar16_sat_rte(ulong16);\012uchar16 __ovld __cnfn convert_uchar16_rtz(ulong16);\012uchar16 __ovld __cnfn convert_uchar16_sat_rtz(ulong16);\012uchar16 __ovld __cnfn convert_uchar16_rtp(ulong16);\012uchar16 __ovld __cnfn convert_uchar16_sat_rtp(ulong16);\012uchar16 __ovld __cnfn convert_uchar16_rtn(ulong16);\012uchar16 __ovld __cnfn convert_uchar16_sat_rtn(ulong16);\012uchar16 __ovld __cnfn convert_uchar16(ulong16);\012uchar16 __ovld __cnf",
"n convert_uchar16_sat(ulong16);\012uchar16 __ovld __cnfn convert_uchar16_rte(float16);\012uchar16 __ovld __cnfn convert_uchar16_sat_rte(float16);\012uchar16 __ovld __cnfn convert_uchar16_rtz(float16);\012uchar16 __ovld __cnfn convert_uchar16_sat_rtz(float16);\012uchar16 __ovld __cnfn convert_uchar16_rtp(float16);\012uchar16 __ovld __cnfn convert_uchar16_sat_rtp(float16);\012uchar16 __ovld __cnfn convert_uchar16_rtn(float16);\012uchar16 __ovld __cnfn convert_uchar16_sat_rtn(float16);\012uchar16 __ovld __cnfn convert_uchar16(float16);\012uchar16 __ovld __cnfn convert_uchar16_sat(float16);\012short16 __ovld __cnfn convert_short16_rte(char16);\012short16 __ovld __cnfn convert_short16_sat_rte(char16);\012short16 __ovld __cnfn convert_short16_rtz(char16);\012short16 __ovld __cnfn convert_short16_sat_rtz(char16);\012short16 __ovld __cnfn convert_short16_rtp(char16);\012short16 __ovld __cnfn convert_short16_sat_rtp(char16);\012short16 __ovld __cnfn convert_short16_rtn(char16);\012short16 __ovld __cnfn convert_short16_sat_rtn(char16);\012short16 __ovld __cnfn convert_short1",
"6(char16);\012short16 __ovld __cnfn convert_short16_sat(char16);\012short16 __ovld __cnfn convert_short16_rte(uchar16);\012short16 __ovld __cnfn convert_short16_sat_rte(uchar16);\012short16 __ovld __cnfn convert_short16_rtz(uchar16);\012short16 __ovld __cnfn convert_short16_sat_rtz(uchar16);\012short16 __ovld __cnfn convert_short16_rtp(uchar16);\012short16 __ovld __cnfn convert_short16_sat_rtp(uchar16);\012short16 __ovld __cnfn convert_short16_rtn(uchar16);\012short16 __ovld __cnfn convert_short16_sat_rtn(uchar16);\012short16 __ovld __cnfn convert_short16(uchar16);\012short16 __ovld __cnfn convert_short16_sat(uchar16);\012short16 __ovld __cnfn convert_short16_rte(short16);\012short16 __ovld __cnfn convert_short16_sat_rte(short16);\012short16 __ovld __cnfn convert_short16_rtz(short16);\012short16 __ovld __cnfn convert_short16_sat_rtz(short16);\012short16 __ovld __cnfn convert_short16_rtp(short16);\012short16 __ovld __cnfn convert_short16_sat_rtp(short16);\012short16 __ovld __cnfn convert_short16_rtn(short16);\012short16 __ovld __cnfn convert_short16_sat_rtn(short16)",
";\012short16 __ovld __cnfn convert_short16(short16);\012short16 __ovld __cnfn convert_short16_sat(short16);\012short16 __ovld __cnfn convert_short16_rte(ushort16);\012short16 __ovld __cnfn convert_short16_sat_rte(ushort16);\012short16 __ovld __cnfn convert_short16_rtz(ushort16);\012short16 __ovld __cnfn convert_short16_sat_rtz(ushort16);\012short16 __ovld __cnfn convert_short16_rtp(ushort16);\012short16 __ovld __cnfn convert_short16_sat_rtp(ushort16);\012short16 __ovld __cnfn convert_short16_rtn(ushort16);\012short16 __ovld __cnfn convert_short16_sat_rtn(ushort16);\012short16 __ovld __cnfn convert_short16(ushort16);\012short16 __ovld __cnfn convert_short16_sat(ushort16);\012short16 __ovld __cnfn convert_short16_rte(int16);\012short16 __ovld __cnfn convert_short16_sat_rte(int16);\012short16 __ovld __cnfn convert_short16_rtz(int16);\012short16 __ovld __cnfn convert_short16_sat_rtz(int16);\012short16 __ovld __cnfn convert_short16_rtp(int16);\012short16 __ovld __cnfn convert_short16_sat_rtp(int16);\012short16 __ovld __cnfn convert_short16_rtn(int16);\012short16 __ovld __c",
"nfn convert_short16_sat_rtn(int16);\012short16 __ovld __cnfn convert_short16(int16);\012short16 __ovld __cnfn convert_short16_sat(int16);\012short16 __ovld __cnfn convert_short16_rte(uint16);\012short16 __ovld __cnfn convert_short16_sat_rte(uint16);\012short16 __ovld __cnfn convert_short16_rtz(uint16);\012short16 __ovld __cnfn convert_short16_sat_rtz(uint16);\012short16 __ovld __cnfn convert_short16_rtp(uint16);\012short16 __ovld __cnfn convert_short16_sat_rtp(uint16);\012short16 __ovld __cnfn convert_short16_rtn(uint16);\012short16 __ovld __cnfn convert_short16_sat_rtn(uint16);\012short16 __ovld __cnfn convert_short16(uint16);\012short16 __ovld __cnfn convert_short16_sat(uint16);\012short16 __ovld __cnfn convert_short16_rte(long16);\012short16 __ovld __cnfn convert_short16_sat_rte(long16);\012short16 __ovld __cnfn convert_short16_rtz(long16);\012short16 __ovld __cnfn convert_short16_sat_rtz(long16);\012short16 __ovld __cnfn convert_short16_rtp(long16);\012short16 __ovld __cnfn convert_short16_sat_rtp(long16);\012short16 __ovld __cnfn convert_short16_rtn(long16);\012s",
"hort16 __ovld __cnfn convert_short16_sat_rtn(long16);\012short16 __ovld __cnfn convert_short16(long16);\012short16 __ovld __cnfn convert_short16_sat(long16);\012short16 __ovld __cnfn convert_short16_rte(ulong16);\012short16 __ovld __cnfn convert_short16_sat_rte(ulong16);\012short16 __ovld __cnfn convert_short16_rtz(ulong16);\012short16 __ovld __cnfn convert_short16_sat_rtz(ulong16);\012short16 __ovld __cnfn convert_short16_rtp(ulong16);\012short16 __ovld __cnfn convert_short16_sat_rtp(ulong16);\012short16 __ovld __cnfn convert_short16_rtn(ulong16);\012short16 __ovld __cnfn convert_short16_sat_rtn(ulong16);\012short16 __ovld __cnfn convert_short16(ulong16);\012short16 __ovld __cnfn convert_short16_sat(ulong16);\012short16 __ovld __cnfn convert_short16_rte(float16);\012short16 __ovld __cnfn convert_short16_sat_rte(float16);\012short16 __ovld __cnfn convert_short16_rtz(float16);\012short16 __ovld __cnfn convert_short16_sat_rtz(float16);\012short16 __ovld __cnfn convert_short16_rtp(float16);\012short16 __ovld __cnfn convert_short16_sat_rtp(float16);\012short16 __ovld _",
"_cnfn convert_short16_rtn(float16);\012short16 __ovld __cnfn convert_short16_sat_rtn(float16);\012short16 __ovld __cnfn convert_short16(float16);\012short16 __ovld __cnfn convert_short16_sat(float16);\012ushort16 __ovld __cnfn convert_ushort16_rte(char16);\012ushort16 __ovld __cnfn convert_ushort16_sat_rte(char16);\012ushort16 __ovld __cnfn convert_ushort16_rtz(char16);\012ushort16 __ovld __cnfn convert_ushort16_sat_rtz(char16);\012ushort16 __ovld __cnfn convert_ushort16_rtp(char16);\012ushort16 __ovld __cnfn convert_ushort16_sat_rtp(char16);\012ushort16 __ovld __cnfn convert_ushort16_rtn(char16);\012ushort16 __ovld __cnfn convert_ushort16_sat_rtn(char16);\012ushort16 __ovld __cnfn convert_ushort16(char16);\012ushort16 __ovld __cnfn convert_ushort16_sat(char16);\012ushort16 __ovld __cnfn convert_ushort16_rte(uchar16);\012ushort16 __ovld __cnfn convert_ushort16_sat_rte(uchar16);\012ushort16 __ovld __cnfn convert_ushort16_rtz(uchar16);\012ushort16 __ovld __cnfn convert_ushort16_sat_rtz(uchar16);\012ushort16 __ovld __cnfn convert_ushort16_rtp(uchar16);\012ushort16 __o",
"vld __cnfn convert_ushort16_sat_rtp(uchar16);\012ushort16 __ovld __cnfn convert_ushort16_rtn(uchar16);\012ushort16 __ovld __cnfn convert_ushort16_sat_rtn(uchar16);\012ushort16 __ovld __cnfn convert_ushort16(uchar16);\012ushort16 __ovld __cnfn convert_ushort16_sat(uchar16);\012ushort16 __ovld __cnfn convert_ushort16_rte(short16);\012ushort16 __ovld __cnfn convert_ushort16_sat_rte(short16);\012ushort16 __ovld __cnfn convert_ushort16_rtz(short16);\012ushort16 __ovld __cnfn convert_ushort16_sat_rtz(short16);\012ushort16 __ovld __cnfn convert_ushort16_rtp(short16);\012ushort16 __ovld __cnfn convert_ushort16_sat_rtp(short16);\012ushort16 __ovld __cnfn convert_ushort16_rtn(short16);\012ushort16 __ovld __cnfn convert_ushort16_sat_rtn(short16);\012ushort16 __ovld __cnfn convert_ushort16(short16);\012ushort16 __ovld __cnfn convert_ushort16_sat(short16);\012ushort16 __ovld __cnfn convert_ushort16_rte(ushort16);\012ushort16 __ovld __cnfn convert_ushort16_sat_rte(ushort16);\012ushort16 __ovld __cnfn convert_ushort16_rtz(ushort16);\012ushort16 __ovld __cnfn convert_ushort16_s",
"at_rtz(ushort16);\012ushort16 __ovld __cnfn convert_ushort16_rtp(ushort16);\012ushort16 __ovld __cnfn convert_ushort16_sat_rtp(ushort16);\012ushort16 __ovld __cnfn convert_ushort16_rtn(ushort16);\012ushort16 __ovld __cnfn convert_ushort16_sat_rtn(ushort16);\012ushort16 __ovld __cnfn convert_ushort16(ushort16);\012ushort16 __ovld __cnfn convert_ushort16_sat(ushort16);\012ushort16 __ovld __cnfn convert_ushort16_rte(int16);\012ushort16 __ovld __cnfn convert_ushort16_sat_rte(int16);\012ushort16 __ovld __cnfn convert_ushort16_rtz(int16);\012ushort16 __ovld __cnfn convert_ushort16_sat_rtz(int16);\012ushort16 __ovld __cnfn convert_ushort16_rtp(int16);\012ushort16 __ovld __cnfn convert_ushort16_sat_rtp(int16);\012ushort16 __ovld __cnfn convert_ushort16_rtn(int16);\012ushort16 __ovld __cnfn convert_ushort16_sat_rtn(int16);\012ushort16 __ovld __cnfn convert_ushort16(int16);\012ushort16 __ovld __cnfn convert_ushort16_sat(int16);\012ushort16 __ovld __cnfn convert_ushort16_rte(uint16);\012ushort16 __ovld __cnfn convert_ushort16_sat_rte(uint16);\012ushort16 __ovld __cnfn convert",
"_ushort16_rtz(uint16);\012ushort16 __ovld __cnfn convert_ushort16_sat_rtz(uint16);\012ushort16 __ovld __cnfn convert_ushort16_rtp(uint16);\012ushort16 __ovld __cnfn convert_ushort16_sat_rtp(uint16);\012ushort16 __ovld __cnfn convert_ushort16_rtn(uint16);\012ushort16 __ovld __cnfn convert_ushort16_sat_rtn(uint16);\012ushort16 __ovld __cnfn convert_ushort16(uint16);\012ushort16 __ovld __cnfn convert_ushort16_sat(uint16);\012ushort16 __ovld __cnfn convert_ushort16_rte(long16);\012ushort16 __ovld __cnfn convert_ushort16_sat_rte(long16);\012ushort16 __ovld __cnfn convert_ushort16_rtz(long16);\012ushort16 __ovld __cnfn convert_ushort16_sat_rtz(long16);\012ushort16 __ovld __cnfn convert_ushort16_rtp(long16);\012ushort16 __ovld __cnfn convert_ushort16_sat_rtp(long16);\012ushort16 __ovld __cnfn convert_ushort16_rtn(long16);\012ushort16 __ovld __cnfn convert_ushort16_sat_rtn(long16);\012ushort16 __ovld __cnfn convert_ushort16(long16);\012ushort16 __ovld __cnfn convert_ushort16_sat(long16);\012ushort16 __ovld __cnfn convert_ushort16_rte(ulong16);\012ushort16 __ovld __cnfn con",
"vert_ushort16_sat_rte(ulong16);\012ushort16 __ovld __cnfn convert_ushort16_rtz(ulong16);\012ushort16 __ovld __cnfn convert_ushort16_sat_rtz(ulong16);\012ushort16 __ovld __cnfn convert_ushort16_rtp(ulong16);\012ushort16 __ovld __cnfn convert_ushort16_sat_rtp(ulong16);\012ushort16 __ovld __cnfn convert_ushort16_rtn(ulong16);\012ushort16 __ovld __cnfn convert_ushort16_sat_rtn(ulong16);\012ushort16 __ovld __cnfn convert_ushort16(ulong16);\012ushort16 __ovld __cnfn convert_ushort16_sat(ulong16);\012ushort16 __ovld __cnfn convert_ushort16_rte(float16);\012ushort16 __ovld __cnfn convert_ushort16_sat_rte(float16);\012ushort16 __ovld __cnfn convert_ushort16_rtz(float16);\012ushort16 __ovld __cnfn convert_ushort16_sat_rtz(float16);\012ushort16 __ovld __cnfn convert_ushort16_rtp(float16);\012ushort16 __ovld __cnfn convert_ushort16_sat_rtp(float16);\012ushort16 __ovld __cnfn convert_ushort16_rtn(float16);\012ushort16 __ovld __cnfn convert_ushort16_sat_rtn(float16);\012ushort16 __ovld __cnfn convert_ushort16(float16);\012ushort16 __ovld __cnfn convert_ushort16_sat(float16);\012",
"int16 __ovld __cnfn convert_int16_rte(char16);\012int16 __ovld __cnfn convert_int16_sat_rte(char16);\012int16 __ovld __cnfn convert_int16_rtz(char16);\012int16 __ovld __cnfn convert_int16_sat_rtz(char16);\012int16 __ovld __cnfn convert_int16_rtp(char16);\012int16 __ovld __cnfn convert_int16_sat_rtp(char16);\012int16 __ovld __cnfn convert_int16_rtn(char16);\012int16 __ovld __cnfn convert_int16_sat_rtn(char16);\012int16 __ovld __cnfn convert_int16(char16);\012int16 __ovld __cnfn convert_int16_sat(char16);\012int16 __ovld __cnfn convert_int16_rte(uchar16);\012int16 __ovld __cnfn convert_int16_sat_rte(uchar16);\012int16 __ovld __cnfn convert_int16_rtz(uchar16);\012int16 __ovld __cnfn convert_int16_sat_rtz(uchar16);\012int16 __ovld __cnfn convert_int16_rtp(uchar16);\012int16 __ovld __cnfn convert_int16_sat_rtp(uchar16);\012int16 __ovld __cnfn convert_int16_rtn(uchar16);\012int16 __ovld __cnfn convert_int16_sat_rtn(uchar16);\012int16 __ovld __cnfn convert_int16(uchar16);\012int16 __ovld __cnfn convert_int16_sat(uchar16);\012int16 __ovld __cnfn convert_int16_rte(short16);\012in",
"t16 __ovld __cnfn convert_int16_sat_rte(short16);\012int16 __ovld __cnfn convert_int16_rtz(short16);\012int16 __ovld __cnfn convert_int16_sat_rtz(short16);\012int16 __ovld __cnfn convert_int16_rtp(short16);\012int16 __ovld __cnfn convert_int16_sat_rtp(short16);\012int16 __ovld __cnfn convert_int16_rtn(short16);\012int16 __ovld __cnfn convert_int16_sat_rtn(short16);\012int16 __ovld __cnfn convert_int16(short16);\012int16 __ovld __cnfn convert_int16_sat(short16);\012int16 __ovld __cnfn convert_int16_rte(ushort16);\012int16 __ovld __cnfn convert_int16_sat_rte(ushort16);\012int16 __ovld __cnfn convert_int16_rtz(ushort16);\012int16 __ovld __cnfn convert_int16_sat_rtz(ushort16);\012int16 __ovld __cnfn convert_int16_rtp(ushort16);\012int16 __ovld __cnfn convert_int16_sat_rtp(ushort16);\012int16 __ovld __cnfn convert_int16_rtn(ushort16);\012int16 __ovld __cnfn convert_int16_sat_rtn(ushort16);\012int16 __ovld __cnfn convert_int16(ushort16);\012int16 __ovld __cnfn convert_int16_sat(ushort16);\012int16 __ovld __cnfn convert_int16_rte(int16);\012int16 __ovld __cnfn convert_int16_",
"sat_rte(int16);\012int16 __ovld __cnfn convert_int16_rtz(int16);\012int16 __ovld __cnfn convert_int16_sat_rtz(int16);\012int16 __ovld __cnfn convert_int16_rtp(int16);\012int16 __ovld __cnfn convert_int16_sat_rtp(int16);\012int16 __ovld __cnfn convert_int16_rtn(int16);\012int16 __ovld __cnfn convert_int16_sat_rtn(int16);\012int16 __ovld __cnfn convert_int16(int16);\012int16 __ovld __cnfn convert_int16_sat(int16);\012int16 __ovld __cnfn convert_int16_rte(uint16);\012int16 __ovld __cnfn convert_int16_sat_rte(uint16);\012int16 __ovld __cnfn convert_int16_rtz(uint16);\012int16 __ovld __cnfn convert_int16_sat_rtz(uint16);\012int16 __ovld __cnfn convert_int16_rtp(uint16);\012int16 __ovld __cnfn convert_int16_sat_rtp(uint16);\012int16 __ovld __cnfn convert_int16_rtn(uint16);\012int16 __ovld __cnfn convert_int16_sat_rtn(uint16);\012int16 __ovld __cnfn convert_int16(uint16);\012int16 __ovld __cnfn convert_int16_sat(uint16);\012int16 __ovld __cnfn convert_int16_rte(long16);\012int16 __ovld __cnfn convert_int16_sat_rte(long16);\012int16 __ovld __cnfn convert_int16_rtz(long16);\012int16",
" __ovld __cnfn convert_int16_sat_rtz(long16);\012int16 __ovld __cnfn convert_int16_rtp(long16);\012int16 __ovld __cnfn convert_int16_sat_rtp(long16);\012int16 __ovld __cnfn convert_int16_rtn(long16);\012int16 __ovld __cnfn convert_int16_sat_rtn(long16);\012int16 __ovld __cnfn convert_int16(long16);\012int16 __ovld __cnfn convert_int16_sat(long16);\012int16 __ovld __cnfn convert_int16_rte(ulong16);\012int16 __ovld __cnfn convert_int16_sat_rte(ulong16);\012int16 __ovld __cnfn convert_int16_rtz(ulong16);\012int16 __ovld __cnfn convert_int16_sat_rtz(ulong16);\012int16 __ovld __cnfn convert_int16_rtp(ulong16);\012int16 __ovld __cnfn convert_int16_sat_rtp(ulong16);\012int16 __ovld __cnfn convert_int16_rtn(ulong16);\012int16 __ovld __cnfn convert_int16_sat_rtn(ulong16);\012int16 __ovld __cnfn convert_int16(ulong16);\012int16 __ovld __cnfn convert_int16_sat(ulong16);\012int16 __ovld __cnfn convert_int16_rte(float16);\012int16 __ovld __cnfn convert_int16_sat_rte(float16);\012int16 __ovld __cnfn convert_int16_rtz(float16);\012int16 __ovld __cnfn convert_int16_sat_rtz(float16);\012",
"int16 __ovld __cnfn convert_int16_rtp(float16);\012int16 __ovld __cnfn convert_int16_sat_rtp(float16);\012int16 __ovld __cnfn convert_int16_rtn(float16);\012int16 __ovld __cnfn convert_int16_sat_rtn(float16);\012int16 __ovld __cnfn convert_int16(float16);\012int16 __ovld __cnfn convert_int16_sat(float16);\012uint16 __ovld __cnfn convert_uint16_rte(char16);\012uint16 __ovld __cnfn convert_uint16_sat_rte(char16);\012uint16 __ovld __cnfn convert_uint16_rtz(char16);\012uint16 __ovld __cnfn convert_uint16_sat_rtz(char16);\012uint16 __ovld __cnfn convert_uint16_rtp(char16);\012uint16 __ovld __cnfn convert_uint16_sat_rtp(char16);\012uint16 __ovld __cnfn convert_uint16_rtn(char16);\012uint16 __ovld __cnfn convert_uint16_sat_rtn(char16);\012uint16 __ovld __cnfn convert_uint16(char16);\012uint16 __ovld __cnfn convert_uint16_sat(char16);\012uint16 __ovld __cnfn convert_uint16_rte(uchar16);\012uint16 __ovld __cnfn convert_uint16_sat_rte(uchar16);\012uint16 __ovld __cnfn convert_uint16_rtz(uchar16);\012uint16 __ovld __cnfn convert_uint16_sat_rtz(uchar16);\012uint16 __ovld __cnfn c",
"onvert_uint16_rtp(uchar16);\012uint16 __ovld __cnfn convert_uint16_sat_rtp(uchar16);\012uint16 __ovld __cnfn convert_uint16_rtn(uchar16);\012uint16 __ovld __cnfn convert_uint16_sat_rtn(uchar16);\012uint16 __ovld __cnfn convert_uint16(uchar16);\012uint16 __ovld __cnfn convert_uint16_sat(uchar16);\012uint16 __ovld __cnfn convert_uint16_rte(short16);\012uint16 __ovld __cnfn convert_uint16_sat_rte(short16);\012uint16 __ovld __cnfn convert_uint16_rtz(short16);\012uint16 __ovld __cnfn convert_uint16_sat_rtz(short16);\012uint16 __ovld __cnfn convert_uint16_rtp(short16);\012uint16 __ovld __cnfn convert_uint16_sat_rtp(short16);\012uint16 __ovld __cnfn convert_uint16_rtn(short16);\012uint16 __ovld __cnfn convert_uint16_sat_rtn(short16);\012uint16 __ovld __cnfn convert_uint16(short16);\012uint16 __ovld __cnfn convert_uint16_sat(short16);\012uint16 __ovld __cnfn convert_uint16_rte(ushort16);\012uint16 __ovld __cnfn convert_uint16_sat_rte(ushort16);\012uint16 __ovld __cnfn convert_uint16_rtz(ushort16);\012uint16 __ovld __cnfn convert_uint16_sat_rtz(ushort16);\012uint16 __ovld __cn",
"fn convert_uint16_rtp(ushort16);\012uint16 __ovld __cnfn convert_uint16_sat_rtp(ushort16);\012uint16 __ovld __cnfn convert_uint16_rtn(ushort16);\012uint16 __ovld __cnfn convert_uint16_sat_rtn(ushort16);\012uint16 __ovld __cnfn convert_uint16(ushort16);\012uint16 __ovld __cnfn convert_uint16_sat(ushort16);\012uint16 __ovld __cnfn convert_uint16_rte(int16);\012uint16 __ovld __cnfn convert_uint16_sat_rte(int16);\012uint16 __ovld __cnfn convert_uint16_rtz(int16);\012uint16 __ovld __cnfn convert_uint16_sat_rtz(int16);\012uint16 __ovld __cnfn convert_uint16_rtp(int16);\012uint16 __ovld __cnfn convert_uint16_sat_rtp(int16);\012uint16 __ovld __cnfn convert_uint16_rtn(int16);\012uint16 __ovld __cnfn convert_uint16_sat_rtn(int16);\012uint16 __ovld __cnfn convert_uint16(int16);\012uint16 __ovld __cnfn convert_uint16_sat(int16);\012uint16 __ovld __cnfn convert_uint16_rte(uint16);\012uint16 __ovld __cnfn convert_uint16_sat_rte(uint16);\012uint16 __ovld __cnfn convert_uint16_rtz(uint16);\012uint16 __ovld __cnfn convert_uint16_sat_rtz(uint16);\012uint16 __ovld __cnfn convert_uint16_",
"rtp(uint16);\012uint16 __ovld __cnfn convert_uint16_sat_rtp(uint16);\012uint16 __ovld __cnfn convert_uint16_rtn(uint16);\012uint16 __ovld __cnfn convert_uint16_sat_rtn(uint16);\012uint16 __ovld __cnfn convert_uint16(uint16);\012uint16 __ovld __cnfn convert_uint16_sat(uint16);\012uint16 __ovld __cnfn convert_uint16_rte(long16);\012uint16 __ovld __cnfn convert_uint16_sat_rte(long16);\012uint16 __ovld __cnfn convert_uint16_rtz(long16);\012uint16 __ovld __cnfn convert_uint16_sat_rtz(long16);\012uint16 __ovld __cnfn convert_uint16_rtp(long16);\012uint16 __ovld __cnfn convert_uint16_sat_rtp(long16);\012uint16 __ovld __cnfn convert_uint16_rtn(long16);\012uint16 __ovld __cnfn convert_uint16_sat_rtn(long16);\012uint16 __ovld __cnfn convert_uint16(long16);\012uint16 __ovld __cnfn convert_uint16_sat(long16);\012uint16 __ovld __cnfn convert_uint16_rte(ulong16);\012uint16 __ovld __cnfn convert_uint16_sat_rte(ulong16);\012uint16 __ovld __cnfn convert_uint16_rtz(ulong16);\012uint16 __ovld __cnfn convert_uint16_sat_rtz(ulong16);\012uint16 __ovld __cnfn convert_uint16_rtp(ulong16);\012ui",
"nt16 __ovld __cnfn convert_uint16_sat_rtp(ulong16);\012uint16 __ovld __cnfn convert_uint16_rtn(ulong16);\012uint16 __ovld __cnfn convert_uint16_sat_rtn(ulong16);\012uint16 __ovld __cnfn convert_uint16(ulong16);\012uint16 __ovld __cnfn convert_uint16_sat(ulong16);\012uint16 __ovld __cnfn convert_uint16_rte(float16);\012uint16 __ovld __cnfn convert_uint16_sat_rte(float16);\012uint16 __ovld __cnfn convert_uint16_rtz(float16);\012uint16 __ovld __cnfn convert_uint16_sat_rtz(float16);\012uint16 __ovld __cnfn convert_uint16_rtp(float16);\012uint16 __ovld __cnfn convert_uint16_sat_rtp(float16);\012uint16 __ovld __cnfn convert_uint16_rtn(float16);\012uint16 __ovld __cnfn convert_uint16_sat_rtn(float16);\012uint16 __ovld __cnfn convert_uint16(float16);\012uint16 __ovld __cnfn convert_uint16_sat(float16);\012long16 __ovld __cnfn convert_long16_rte(char16);\012long16 __ovld __cnfn convert_long16_sat_rte(char16);\012long16 __ovld __cnfn convert_long16_rtz(char16);\012long16 __ovld __cnfn convert_long16_sat_rtz(char16);\012long16 __ovld __cnfn convert_long16_rtp(char16);\012long16 ",
"__ovld __cnfn convert_long16_sat_rtp(char16);\012long16 __ovld __cnfn convert_long16_rtn(char16);\012long16 __ovld __cnfn convert_long16_sat_rtn(char16);\012long16 __ovld __cnfn convert_long16(char16);\012long16 __ovld __cnfn convert_long16_sat(char16);\012long16 __ovld __cnfn convert_long16_rte(uchar16);\012long16 __ovld __cnfn convert_long16_sat_rte(uchar16);\012long16 __ovld __cnfn convert_long16_rtz(uchar16);\012long16 __ovld __cnfn convert_long16_sat_rtz(uchar16);\012long16 __ovld __cnfn convert_long16_rtp(uchar16);\012long16 __ovld __cnfn convert_long16_sat_rtp(uchar16);\012long16 __ovld __cnfn convert_long16_rtn(uchar16);\012long16 __ovld __cnfn convert_long16_sat_rtn(uchar16);\012long16 __ovld __cnfn convert_long16(uchar16);\012long16 __ovld __cnfn convert_long16_sat(uchar16);\012long16 __ovld __cnfn convert_long16_rte(short16);\012long16 __ovld __cnfn convert_long16_sat_rte(short16);\012long16 __ovld __cnfn convert_long16_rtz(short16);\012long16 __ovld __cnfn convert_long16_sat_rtz(short16);\012long16 __ovld __cnfn convert_long16_rtp(short16);\012long16 __ovl",
"d __cnfn convert_long16_sat_rtp(short16);\012long16 __ovld __cnfn convert_long16_rtn(short16);\012long16 __ovld __cnfn convert_long16_sat_rtn(short16);\012long16 __ovld __cnfn convert_long16(short16);\012long16 __ovld __cnfn convert_long16_sat(short16);\012long16 __ovld __cnfn convert_long16_rte(ushort16);\012long16 __ovld __cnfn convert_long16_sat_rte(ushort16);\012long16 __ovld __cnfn convert_long16_rtz(ushort16);\012long16 __ovld __cnfn convert_long16_sat_rtz(ushort16);\012long16 __ovld __cnfn convert_long16_rtp(ushort16);\012long16 __ovld __cnfn convert_long16_sat_rtp(ushort16);\012long16 __ovld __cnfn convert_long16_rtn(ushort16);\012long16 __ovld __cnfn convert_long16_sat_rtn(ushort16);\012long16 __ovld __cnfn convert_long16(ushort16);\012long16 __ovld __cnfn convert_long16_sat(ushort16);\012long16 __ovld __cnfn convert_long16_rte(int16);\012long16 __ovld __cnfn convert_long16_sat_rte(int16);\012long16 __ovld __cnfn convert_long16_rtz(int16);\012long16 __ovld __cnfn convert_long16_sat_rtz(int16);\012long16 __ovld __cnfn convert_long16_rtp(int16);\012long16 __ovl",
"d __cnfn convert_long16_sat_rtp(int16);\012long16 __ovld __cnfn convert_long16_rtn(int16);\012long16 __ovld __cnfn convert_long16_sat_rtn(int16);\012long16 __ovld __cnfn convert_long16(int16);\012long16 __ovld __cnfn convert_long16_sat(int16);\012long16 __ovld __cnfn convert_long16_rte(uint16);\012long16 __ovld __cnfn convert_long16_sat_rte(uint16);\012long16 __ovld __cnfn convert_long16_rtz(uint16);\012long16 __ovld __cnfn convert_long16_sat_rtz(uint16);\012long16 __ovld __cnfn convert_long16_rtp(uint16);\012long16 __ovld __cnfn convert_long16_sat_rtp(uint16);\012long16 __ovld __cnfn convert_long16_rtn(uint16);\012long16 __ovld __cnfn convert_long16_sat_rtn(uint16);\012long16 __ovld __cnfn convert_long16(uint16);\012long16 __ovld __cnfn convert_long16_sat(uint16);\012long16 __ovld __cnfn convert_long16_rte(long16);\012long16 __ovld __cnfn convert_long16_sat_rte(long16);\012long16 __ovld __cnfn convert_long16_rtz(long16);\012long16 __ovld __cnfn convert_long16_sat_rtz(long16);\012long16 __ovld __cnfn convert_long16_rtp(long16);\012long16 __ovld __cnfn convert_long16_s",
"at_rtp(long16);\012long16 __ovld __cnfn convert_long16_rtn(long16);\012long16 __ovld __cnfn convert_long16_sat_rtn(long16);\012long16 __ovld __cnfn convert_long16(long16);\012long16 __ovld __cnfn convert_long16_sat(long16);\012long16 __ovld __cnfn convert_long16_rte(ulong16);\012long16 __ovld __cnfn convert_long16_sat_rte(ulong16);\012long16 __ovld __cnfn convert_long16_rtz(ulong16);\012long16 __ovld __cnfn convert_long16_sat_rtz(ulong16);\012long16 __ovld __cnfn convert_long16_rtp(ulong16);\012long16 __ovld __cnfn convert_long16_sat_rtp(ulong16);\012long16 __ovld __cnfn convert_long16_rtn(ulong16);\012long16 __ovld __cnfn convert_long16_sat_rtn(ulong16);\012long16 __ovld __cnfn convert_long16(ulong16);\012long16 __ovld __cnfn convert_long16_sat(ulong16);\012long16 __ovld __cnfn convert_long16_rte(float16);\012long16 __ovld __cnfn convert_long16_sat_rte(float16);\012long16 __ovld __cnfn convert_long16_rtz(float16);\012long16 __ovld __cnfn convert_long16_sat_rtz(float16);\012long16 __ovld __cnfn convert_long16_rtp(float16);\012long16 __ovld __cnfn convert_long16_sat_rt",
"p(float16);\012long16 __ovld __cnfn convert_long16_rtn(float16);\012long16 __ovld __cnfn convert_long16_sat_rtn(float16);\012long16 __ovld __cnfn convert_long16(float16);\012long16 __ovld __cnfn convert_long16_sat(float16);\012ulong16 __ovld __cnfn convert_ulong16_rte(char16);\012ulong16 __ovld __cnfn convert_ulong16_sat_rte(char16);\012ulong16 __ovld __cnfn convert_ulong16_rtz(char16);\012ulong16 __ovld __cnfn convert_ulong16_sat_rtz(char16);\012ulong16 __ovld __cnfn convert_ulong16_rtp(char16);\012ulong16 __ovld __cnfn convert_ulong16_sat_rtp(char16);\012ulong16 __ovld __cnfn convert_ulong16_rtn(char16);\012ulong16 __ovld __cnfn convert_ulong16_sat_rtn(char16);\012ulong16 __ovld __cnfn convert_ulong16(char16);\012ulong16 __ovld __cnfn convert_ulong16_sat(char16);\012ulong16 __ovld __cnfn convert_ulong16_rte(uchar16);\012ulong16 __ovld __cnfn convert_ulong16_sat_rte(uchar16);\012ulong16 __ovld __cnfn convert_ulong16_rtz(uchar16);\012ulong16 __ovld __cnfn convert_ulong16_sat_rtz(uchar16);\012ulong16 __ovld __cnfn convert_ulong16_rtp(uchar16);\012ulong16 __ovld __cnfn ",
"convert_ulong16_sat_rtp(uchar16);\012ulong16 __ovld __cnfn convert_ulong16_rtn(uchar16);\012ulong16 __ovld __cnfn convert_ulong16_sat_rtn(uchar16);\012ulong16 __ovld __cnfn convert_ulong16(uchar16);\012ulong16 __ovld __cnfn convert_ulong16_sat(uchar16);\012ulong16 __ovld __cnfn convert_ulong16_rte(short16);\012ulong16 __ovld __cnfn convert_ulong16_sat_rte(short16);\012ulong16 __ovld __cnfn convert_ulong16_rtz(short16);\012ulong16 __ovld __cnfn convert_ulong16_sat_rtz(short16);\012ulong16 __ovld __cnfn convert_ulong16_rtp(short16);\012ulong16 __ovld __cnfn convert_ulong16_sat_rtp(short16);\012ulong16 __ovld __cnfn convert_ulong16_rtn(short16);\012ulong16 __ovld __cnfn convert_ulong16_sat_rtn(short16);\012ulong16 __ovld __cnfn convert_ulong16(short16);\012ulong16 __ovld __cnfn convert_ulong16_sat(short16);\012ulong16 __ovld __cnfn convert_ulong16_rte(ushort16);\012ulong16 __ovld __cnfn convert_ulong16_sat_rte(ushort16);\012ulong16 __ovld __cnfn convert_ulong16_rtz(ushort16);\012ulong16 __ovld __cnfn convert_ulong16_sat_rtz(ushort16);\012ulong16 __ovld __cnfn convert_",
"ulong16_rtp(ushort16);\012ulong16 __ovld __cnfn convert_ulong16_sat_rtp(ushort16);\012ulong16 __ovld __cnfn convert_ulong16_rtn(ushort16);\012ulong16 __ovld __cnfn convert_ulong16_sat_rtn(ushort16);\012ulong16 __ovld __cnfn convert_ulong16(ushort16);\012ulong16 __ovld __cnfn convert_ulong16_sat(ushort16);\012ulong16 __ovld __cnfn convert_ulong16_rte(int16);\012ulong16 __ovld __cnfn convert_ulong16_sat_rte(int16);\012ulong16 __ovld __cnfn convert_ulong16_rtz(int16);\012ulong16 __ovld __cnfn convert_ulong16_sat_rtz(int16);\012ulong16 __ovld __cnfn convert_ulong16_rtp(int16);\012ulong16 __ovld __cnfn convert_ulong16_sat_rtp(int16);\012ulong16 __ovld __cnfn convert_ulong16_rtn(int16);\012ulong16 __ovld __cnfn convert_ulong16_sat_rtn(int16);\012ulong16 __ovld __cnfn convert_ulong16(int16);\012ulong16 __ovld __cnfn convert_ulong16_sat(int16);\012ulong16 __ovld __cnfn convert_ulong16_rte(uint16);\012ulong16 __ovld __cnfn convert_ulong16_sat_rte(uint16);\012ulong16 __ovld __cnfn convert_ulong16_rtz(uint16);\012ulong16 __ovld __cnfn convert_ulong16_sat_rtz(uint16);\012ulong16 ",
"__ovld __cnfn convert_ulong16_rtp(uint16);\012ulong16 __ovld __cnfn convert_ulong16_sat_rtp(uint16);\012ulong16 __ovld __cnfn convert_ulong16_rtn(uint16);\012ulong16 __ovld __cnfn convert_ulong16_sat_rtn(uint16);\012ulong16 __ovld __cnfn convert_ulong16(uint16);\012ulong16 __ovld __cnfn convert_ulong16_sat(uint16);\012ulong16 __ovld __cnfn convert_ulong16_rte(long16);\012ulong16 __ovld __cnfn convert_ulong16_sat_rte(long16);\012ulong16 __ovld __cnfn convert_ulong16_rtz(long16);\012ulong16 __ovld __cnfn convert_ulong16_sat_rtz(long16);\012ulong16 __ovld __cnfn convert_ulong16_rtp(long16);\012ulong16 __ovld __cnfn convert_ulong16_sat_rtp(long16);\012ulong16 __ovld __cnfn convert_ulong16_rtn(long16);\012ulong16 __ovld __cnfn convert_ulong16_sat_rtn(long16);\012ulong16 __ovld __cnfn convert_ulong16(long16);\012ulong16 __ovld __cnfn convert_ulong16_sat(long16);\012ulong16 __ovld __cnfn convert_ulong16_rte(ulong16);\012ulong16 __ovld __cnfn convert_ulong16_sat_rte(ulong16);\012ulong16 __ovld __cnfn convert_ulong16_rtz(ulong16);\012ulong16 __ovld __cnfn convert_ulong16_sa",
"t_rtz(ulong16);\012ulong16 __ovld __cnfn convert_ulong16_rtp(ulong16);\012ulong16 __ovld __cnfn convert_ulong16_sat_rtp(ulong16);\012ulong16 __ovld __cnfn convert_ulong16_rtn(ulong16);\012ulong16 __ovld __cnfn convert_ulong16_sat_rtn(ulong16);\012ulong16 __ovld __cnfn convert_ulong16(ulong16);\012ulong16 __ovld __cnfn convert_ulong16_sat(ulong16);\012ulong16 __ovld __cnfn convert_ulong16_rte(float16);\012ulong16 __ovld __cnfn convert_ulong16_sat_rte(float16);\012ulong16 __ovld __cnfn convert_ulong16_rtz(float16);\012ulong16 __ovld __cnfn convert_ulong16_sat_rtz(float16);\012ulong16 __ovld __cnfn convert_ulong16_rtp(float16);\012ulong16 __ovld __cnfn convert_ulong16_sat_rtp(float16);\012ulong16 __ovld __cnfn convert_ulong16_rtn(float16);\012ulong16 __ovld __cnfn convert_ulong16_sat_rtn(float16);\012ulong16 __ovld __cnfn convert_ulong16(float16);\012ulong16 __ovld __cnfn convert_ulong16_sat(float16);\012float16 __ovld __cnfn convert_float16_rte(char16);\012float16 __ovld __cnfn convert_float16_rtz(char16);\012float16 __ovld __cnfn convert_float16_rtp(char16);\012float16",
" __ovld __cnfn convert_float16_rtn(char16);\012float16 __ovld __cnfn convert_float16(char16);\012float16 __ovld __cnfn convert_float16_rte(uchar16);\012float16 __ovld __cnfn convert_float16_rtz(uchar16);\012float16 __ovld __cnfn convert_float16_rtp(uchar16);\012float16 __ovld __cnfn convert_float16_rtn(uchar16);\012float16 __ovld __cnfn convert_float16(uchar16);\012float16 __ovld __cnfn convert_float16_rte(short16);\012float16 __ovld __cnfn convert_float16_rtz(short16);\012float16 __ovld __cnfn convert_float16_rtp(short16);\012float16 __ovld __cnfn convert_float16_rtn(short16);\012float16 __ovld __cnfn convert_float16(short16);\012float16 __ovld __cnfn convert_float16_rte(ushort16);\012float16 __ovld __cnfn convert_float16_rtz(ushort16);\012float16 __ovld __cnfn convert_float16_rtp(ushort16);\012float16 __ovld __cnfn convert_float16_rtn(ushort16);\012float16 __ovld __cnfn convert_float16(ushort16);\012float16 __ovld __cnfn convert_float16_rte(int16);\012float16 __ovld __cnfn convert_float16_rtz(int16);\012float16 __ovld __cnfn convert_float16_rtp(int16);\012float16 __",
"ovld __cnfn convert_float16_rtn(int16);\012float16 __ovld __cnfn convert_float16(int16);\012float16 __ovld __cnfn convert_float16_rte(uint16);\012float16 __ovld __cnfn convert_float16_rtz(uint16);\012float16 __ovld __cnfn convert_float16_rtp(uint16);\012float16 __ovld __cnfn convert_float16_rtn(uint16);\012float16 __ovld __cnfn convert_float16(uint16);\012float16 __ovld __cnfn convert_float16_rte(long16);\012float16 __ovld __cnfn convert_float16_rtz(long16);\012float16 __ovld __cnfn convert_float16_rtp(long16);\012float16 __ovld __cnfn convert_float16_rtn(long16);\012float16 __ovld __cnfn convert_float16(long16);\012float16 __ovld __cnfn convert_float16_rte(ulong16);\012float16 __ovld __cnfn convert_float16_rtz(ulong16);\012float16 __ovld __cnfn convert_float16_rtp(ulong16);\012float16 __ovld __cnfn convert_float16_rtn(ulong16);\012float16 __ovld __cnfn convert_float16(ulong16);\012float16 __ovld __cnfn convert_float16_rte(float16);\012float16 __ovld __cnfn convert_float16_rtz(float16);\012float16 __ovld __cnfn convert_float16_rtp(float16);\012float16 __ovld __cnfn co",
"nvert_float16_rtn(float16);\012float16 __ovld __cnfn convert_float16(float16);\012\012// Conversions with double data type parameters or return value.\012\012#ifdef cl_khr_fp64\012char __ovld __cnfn convert_char(double);\012char __ovld __cnfn convert_char_rte(double);\012char __ovld __cnfn convert_char_rtn(double);\012char __ovld __cnfn convert_char_rtp(double);\012char __ovld __cnfn convert_char_rtz(double);\012char __ovld __cnfn convert_char_sat(double);\012char __ovld __cnfn convert_char_sat_rte(double);\012char __ovld __cnfn convert_char_sat_rtn(double);\012char __ovld __cnfn convert_char_sat_rtp(double);\012char __ovld __cnfn convert_char_sat_rtz(double);\012char2 __ovld __cnfn convert_char2(double2);\012char2 __ovld __cnfn convert_char2_rte(double2);\012char2 __ovld __cnfn convert_char2_rtn(double2);\012char2 __ovld __cnfn convert_char2_rtp(double2);\012char2 __ovld __cnfn convert_char2_rtz(double2);\012char2 __ovld __cnfn convert_char2_sat(double2);\012char2 __ovld __cnfn convert_char2_sat_rte(double2);\012char2 __ovld __cnfn convert_char2_sat_rtn(double2);\012char2 __ovld",
" __cnfn convert_char2_sat_rtp(double2);\012char2 __ovld __cnfn convert_char2_sat_rtz(double2);\012char3 __ovld __cnfn convert_char3(double3);\012char3 __ovld __cnfn convert_char3_rte(double3);\012char3 __ovld __cnfn convert_char3_rtn(double3);\012char3 __ovld __cnfn convert_char3_rtp(double3);\012char3 __ovld __cnfn convert_char3_rtz(double3);\012char3 __ovld __cnfn convert_char3_sat(double3);\012char3 __ovld __cnfn convert_char3_sat_rte(double3);\012char3 __ovld __cnfn convert_char3_sat_rtn(double3);\012char3 __ovld __cnfn convert_char3_sat_rtp(double3);\012char3 __ovld __cnfn convert_char3_sat_rtz(double3);\012char4 __ovld __cnfn convert_char4(double4);\012char4 __ovld __cnfn convert_char4_rte(double4);\012char4 __ovld __cnfn convert_char4_rtn(double4);\012char4 __ovld __cnfn convert_char4_rtp(double4);\012char4 __ovld __cnfn convert_char4_rtz(double4);\012char4 __ovld __cnfn convert_char4_sat(double4);\012char4 __ovld __cnfn convert_char4_sat_rte(double4);\012char4 __ovld __cnfn convert_char4_sat_rtn(double4);\012char4 __ovld __cnfn convert_char4_sat_rtp(double4);\012",
"char4 __ovld __cnfn convert_char4_sat_rtz(double4);\012char8 __ovld __cnfn convert_char8(double8);\012char8 __ovld __cnfn convert_char8_rte(double8);\012char8 __ovld __cnfn convert_char8_rtn(double8);\012char8 __ovld __cnfn convert_char8_rtp(double8);\012char8 __ovld __cnfn convert_char8_rtz(double8);\012char8 __ovld __cnfn convert_char8_sat(double8);\012char8 __ovld __cnfn convert_char8_sat_rte(double8);\012char8 __ovld __cnfn convert_char8_sat_rtn(double8);\012char8 __ovld __cnfn convert_char8_sat_rtp(double8);\012char8 __ovld __cnfn convert_char8_sat_rtz(double8);\012char16 __ovld __cnfn convert_char16(double16);\012char16 __ovld __cnfn convert_char16_rte(double16);\012char16 __ovld __cnfn convert_char16_rtn(double16);\012char16 __ovld __cnfn convert_char16_rtp(double16);\012char16 __ovld __cnfn convert_char16_rtz(double16);\012char16 __ovld __cnfn convert_char16_sat(double16);\012char16 __ovld __cnfn convert_char16_sat_rte(double16);\012char16 __ovld __cnfn convert_char16_sat_rtn(double16);\012char16 __ovld __cnfn convert_char16_sat_rtp(double16);\012char16 __ovld",
" __cnfn convert_char16_sat_rtz(double16);\012\012uchar __ovld __cnfn convert_uchar(double);\012uchar __ovld __cnfn convert_uchar_rte(double);\012uchar __ovld __cnfn convert_uchar_rtn(double);\012uchar __ovld __cnfn convert_uchar_rtp(double);\012uchar __ovld __cnfn convert_uchar_rtz(double);\012uchar __ovld __cnfn convert_uchar_sat(double);\012uchar __ovld __cnfn convert_uchar_sat_rte(double);\012uchar __ovld __cnfn convert_uchar_sat_rtn(double);\012uchar __ovld __cnfn convert_uchar_sat_rtp(double);\012uchar __ovld __cnfn convert_uchar_sat_rtz(double);\012uchar2 __ovld __cnfn convert_uchar2(double2);\012uchar2 __ovld __cnfn convert_uchar2_rte(double2);\012uchar2 __ovld __cnfn convert_uchar2_rtn(double2);\012uchar2 __ovld __cnfn convert_uchar2_rtp(double2);\012uchar2 __ovld __cnfn convert_uchar2_rtz(double2);\012uchar2 __ovld __cnfn convert_uchar2_sat(double2);\012uchar2 __ovld __cnfn convert_uchar2_sat_rte(double2);\012uchar2 __ovld __cnfn convert_uchar2_sat_rtn(double2);\012uchar2 __ovld __cnfn convert_uchar2_sat_rtp(double2);\012uchar2 __ovld __cnfn convert_uchar2_sat_r",
"tz(double2);\012uchar3 __ovld __cnfn convert_uchar3(double3);\012uchar3 __ovld __cnfn convert_uchar3_rte(double3);\012uchar3 __ovld __cnfn convert_uchar3_rtn(double3);\012uchar3 __ovld __cnfn convert_uchar3_rtp(double3);\012uchar3 __ovld __cnfn convert_uchar3_rtz(double3);\012uchar3 __ovld __cnfn convert_uchar3_sat(double3);\012uchar3 __ovld __cnfn convert_uchar3_sat_rte(double3);\012uchar3 __ovld __cnfn convert_uchar3_sat_rtn(double3);\012uchar3 __ovld __cnfn convert_uchar3_sat_rtp(double3);\012uchar3 __ovld __cnfn convert_uchar3_sat_rtz(double3);\012uchar4 __ovld __cnfn convert_uchar4(double4);\012uchar4 __ovld __cnfn convert_uchar4_rte(double4);\012uchar4 __ovld __cnfn convert_uchar4_rtn(double4);\012uchar4 __ovld __cnfn convert_uchar4_rtp(double4);\012uchar4 __ovld __cnfn convert_uchar4_rtz(double4);\012uchar4 __ovld __cnfn convert_uchar4_sat(double4);\012uchar4 __ovld __cnfn convert_uchar4_sat_rte(double4);\012uchar4 __ovld __cnfn convert_uchar4_sat_rtn(double4);\012uchar4 __ovld __cnfn convert_uchar4_sat_rtp(double4);\012uchar4 __ovld __cnfn convert_uchar4_sat_r",
"tz(double4);\012uchar8 __ovld __cnfn convert_uchar8(double8);\012uchar8 __ovld __cnfn convert_uchar8_rte(double8);\012uchar8 __ovld __cnfn convert_uchar8_rtn(double8);\012uchar8 __ovld __cnfn convert_uchar8_rtp(double8);\012uchar8 __ovld __cnfn convert_uchar8_rtz(double8);\012uchar8 __ovld __cnfn convert_uchar8_sat(double8);\012uchar8 __ovld __cnfn convert_uchar8_sat_rte(double8);\012uchar8 __ovld __cnfn convert_uchar8_sat_rtn(double8);\012uchar8 __ovld __cnfn convert_uchar8_sat_rtp(double8);\012uchar8 __ovld __cnfn convert_uchar8_sat_rtz(double8);\012uchar16 __ovld __cnfn convert_uchar16(double16);\012uchar16 __ovld __cnfn convert_uchar16_rte(double16);\012uchar16 __ovld __cnfn convert_uchar16_rtn(double16);\012uchar16 __ovld __cnfn convert_uchar16_rtp(double16);\012uchar16 __ovld __cnfn convert_uchar16_rtz(double16);\012uchar16 __ovld __cnfn convert_uchar16_sat(double16);\012uchar16 __ovld __cnfn convert_uchar16_sat_rte(double16);\012uchar16 __ovld __cnfn convert_uchar16_sat_rtn(double16);\012uchar16 __ovld __cnfn convert_uchar16_sat_rtp(double16);\012uchar16 __ovld",
" __cnfn convert_uchar16_sat_rtz(double16);\012\012short __ovld __cnfn convert_short(double);\012short __ovld __cnfn convert_short_rte(double);\012short __ovld __cnfn convert_short_rtn(double);\012short __ovld __cnfn convert_short_rtp(double);\012short __ovld __cnfn convert_short_rtz(double);\012short __ovld __cnfn convert_short_sat(double);\012short __ovld __cnfn convert_short_sat_rte(double);\012short __ovld __cnfn convert_short_sat_rtn(double);\012short __ovld __cnfn convert_short_sat_rtp(double);\012short __ovld __cnfn convert_short_sat_rtz(double);\012short2 __ovld __cnfn convert_short2(double2);\012short2 __ovld __cnfn convert_short2_rte(double2);\012short2 __ovld __cnfn convert_short2_rtn(double2);\012short2 __ovld __cnfn convert_short2_rtp(double2);\012short2 __ovld __cnfn convert_short2_rtz(double2);\012short2 __ovld __cnfn convert_short2_sat(double2);\012short2 __ovld __cnfn convert_short2_sat_rte(double2);\012short2 __ovld __cnfn convert_short2_sat_rtn(double2);\012short2 __ovld __cnfn convert_short2_sat_rtp(double2);\012short2 __ovld __cnfn convert_short2_sat_",
"rtz(double2);\012short3 __ovld __cnfn convert_short3(double3);\012short3 __ovld __cnfn convert_short3_rte(double3);\012short3 __ovld __cnfn convert_short3_rtn(double3);\012short3 __ovld __cnfn convert_short3_rtp(double3);\012short3 __ovld __cnfn convert_short3_rtz(double3);\012short3 __ovld __cnfn convert_short3_sat(double3);\012short3 __ovld __cnfn convert_short3_sat_rte(double3);\012short3 __ovld __cnfn convert_short3_sat_rtn(double3);\012short3 __ovld __cnfn convert_short3_sat_rtp(double3);\012short3 __ovld __cnfn convert_short3_sat_rtz(double3);\012short4 __ovld __cnfn convert_short4(double4);\012short4 __ovld __cnfn convert_short4_rte(double4);\012short4 __ovld __cnfn convert_short4_rtn(double4);\012short4 __ovld __cnfn convert_short4_rtp(double4);\012short4 __ovld __cnfn convert_short4_rtz(double4);\012short4 __ovld __cnfn convert_short4_sat(double4);\012short4 __ovld __cnfn convert_short4_sat_rte(double4);\012short4 __ovld __cnfn convert_short4_sat_rtn(double4);\012short4 __ovld __cnfn convert_short4_sat_rtp(double4);\012short4 __ovld __cnfn convert_short4_sat_",
"rtz(double4);\012short8 __ovld __cnfn convert_short8(double8);\012short8 __ovld __cnfn convert_short8_rte(double8);\012short8 __ovld __cnfn convert_short8_rtn(double8);\012short8 __ovld __cnfn convert_short8_rtp(double8);\012short8 __ovld __cnfn convert_short8_rtz(double8);\012short8 __ovld __cnfn convert_short8_sat(double8);\012short8 __ovld __cnfn convert_short8_sat_rte(double8);\012short8 __ovld __cnfn convert_short8_sat_rtn(double8);\012short8 __ovld __cnfn convert_short8_sat_rtp(double8);\012short8 __ovld __cnfn convert_short8_sat_rtz(double8);\012short16 __ovld __cnfn convert_short16(double16);\012short16 __ovld __cnfn convert_short16_rte(double16);\012short16 __ovld __cnfn convert_short16_rtn(double16);\012short16 __ovld __cnfn convert_short16_rtp(double16);\012short16 __ovld __cnfn convert_short16_rtz(double16);\012short16 __ovld __cnfn convert_short16_sat(double16);\012short16 __ovld __cnfn convert_short16_sat_rte(double16);\012short16 __ovld __cnfn convert_short16_sat_rtn(double16);\012short16 __ovld __cnfn convert_short16_sat_rtp(double16);\012short16 __ovl",
"d __cnfn convert_short16_sat_rtz(double16);\012\012ushort __ovld __cnfn convert_ushort(double);\012ushort __ovld __cnfn convert_ushort_rte(double);\012ushort __ovld __cnfn convert_ushort_rtn(double);\012ushort __ovld __cnfn convert_ushort_rtp(double);\012ushort __ovld __cnfn convert_ushort_rtz(double);\012ushort __ovld __cnfn convert_ushort_sat(double);\012ushort __ovld __cnfn convert_ushort_sat_rte(double);\012ushort __ovld __cnfn convert_ushort_sat_rtn(double);\012ushort __ovld __cnfn convert_ushort_sat_rtp(double);\012ushort __ovld __cnfn convert_ushort_sat_rtz(double);\012ushort2 __ovld __cnfn convert_ushort2(double2);\012ushort2 __ovld __cnfn convert_ushort2_rte(double2);\012ushort2 __ovld __cnfn convert_ushort2_rtn(double2);\012ushort2 __ovld __cnfn convert_ushort2_rtp(double2);\012ushort2 __ovld __cnfn convert_ushort2_rtz(double2);\012ushort2 __ovld __cnfn convert_ushort2_sat(double2);\012ushort2 __ovld __cnfn convert_ushort2_sat_rte(double2);\012ushort2 __ovld __cnfn convert_ushort2_sat_rtn(double2);\012ushort2 __ovld __cnfn convert_ushort2_sat_rtp(double2);\012u",
"short2 __ovld __cnfn convert_ushort2_sat_rtz(double2);\012ushort3 __ovld __cnfn convert_ushort3(double3);\012ushort3 __ovld __cnfn convert_ushort3_rte(double3);\012ushort3 __ovld __cnfn convert_ushort3_rtn(double3);\012ushort3 __ovld __cnfn convert_ushort3_rtp(double3);\012ushort3 __ovld __cnfn convert_ushort3_rtz(double3);\012ushort3 __ovld __cnfn convert_ushort3_sat(double3);\012ushort3 __ovld __cnfn convert_ushort3_sat_rte(double3);\012ushort3 __ovld __cnfn convert_ushort3_sat_rtn(double3);\012ushort3 __ovld __cnfn convert_ushort3_sat_rtp(double3);\012ushort3 __ovld __cnfn convert_ushort3_sat_rtz(double3);\012ushort4 __ovld __cnfn convert_ushort4(double4);\012ushort4 __ovld __cnfn convert_ushort4_rte(double4);\012ushort4 __ovld __cnfn convert_ushort4_rtn(double4);\012ushort4 __ovld __cnfn convert_ushort4_rtp(double4);\012ushort4 __ovld __cnfn convert_ushort4_rtz(double4);\012ushort4 __ovld __cnfn convert_ushort4_sat(double4);\012ushort4 __ovld __cnfn convert_ushort4_sat_rte(double4);\012ushort4 __ovld __cnfn convert_ushort4_sat_rtn(double4);\012ushort4 __ovld __",
"cnfn convert_ushort4_sat_rtp(double4);\012ushort4 __ovld __cnfn convert_ushort4_sat_rtz(double4);\012ushort8 __ovld __cnfn convert_ushort8(double8);\012ushort8 __ovld __cnfn convert_ushort8_rte(double8);\012ushort8 __ovld __cnfn convert_ushort8_rtn(double8);\012ushort8 __ovld __cnfn convert_ushort8_rtp(double8);\012ushort8 __ovld __cnfn convert_ushort8_rtz(double8);\012ushort8 __ovld __cnfn convert_ushort8_sat(double8);\012ushort8 __ovld __cnfn convert_ushort8_sat_rte(double8);\012ushort8 __ovld __cnfn convert_ushort8_sat_rtn(double8);\012ushort8 __ovld __cnfn convert_ushort8_sat_rtp(double8);\012ushort8 __ovld __cnfn convert_ushort8_sat_rtz(double8);\012ushort16 __ovld __cnfn convert_ushort16(double16);\012ushort16 __ovld __cnfn convert_ushort16_rte(double16);\012ushort16 __ovld __cnfn convert_ushort16_rtn(double16);\012ushort16 __ovld __cnfn convert_ushort16_rtp(double16);\012ushort16 __ovld __cnfn convert_ushort16_rtz(double16);\012ushort16 __ovld __cnfn convert_ushort16_sat(double16);\012ushort16 __ovld __cnfn convert_ushort16_sat_rte(double16);\012ushort16 __o",
"vld __cnfn convert_ushort16_sat_rtn(double16);\012ushort16 __ovld __cnfn convert_ushort16_sat_rtp(double16);\012ushort16 __ovld __cnfn convert_ushort16_sat_rtz(double16);\012\012int __ovld __cnfn convert_int(double);\012int __ovld __cnfn convert_int_rte(double);\012int __ovld __cnfn convert_int_rtn(double);\012int __ovld __cnfn convert_int_rtp(double);\012int __ovld __cnfn convert_int_rtz(double);\012int __ovld __cnfn convert_int_sat(double);\012int __ovld __cnfn convert_int_sat_rte(double);\012int __ovld __cnfn convert_int_sat_rtn(double);\012int __ovld __cnfn convert_int_sat_rtp(double);\012int __ovld __cnfn convert_int_sat_rtz(double);\012int2 __ovld __cnfn convert_int2(double2);\012int2 __ovld __cnfn convert_int2_rte(double2);\012int2 __ovld __cnfn convert_int2_rtn(double2);\012int2 __ovld __cnfn convert_int2_rtp(double2);\012int2 __ovld __cnfn convert_int2_rtz(double2);\012int2 __ovld __cnfn convert_int2_sat(double2);\012int2 __ovld __cnfn convert_int2_sat_rte(double2);\012int2 __ovld __cnfn convert_int2_sat_rtn(double2);\012int2 __ovld __cnfn convert_int2_sat_rtp(doub",
"le2);\012int2 __ovld __cnfn convert_int2_sat_rtz(double2);\012int3 __ovld __cnfn convert_int3(double3);\012int3 __ovld __cnfn convert_int3_rte(double3);\012int3 __ovld __cnfn convert_int3_rtn(double3);\012int3 __ovld __cnfn convert_int3_rtp(double3);\012int3 __ovld __cnfn convert_int3_rtz(double3);\012int3 __ovld __cnfn convert_int3_sat(double3);\012int3 __ovld __cnfn convert_int3_sat_rte(double3);\012int3 __ovld __cnfn convert_int3_sat_rtn(double3);\012int3 __ovld __cnfn convert_int3_sat_rtp(double3);\012int3 __ovld __cnfn convert_int3_sat_rtz(double3);\012int4 __ovld __cnfn convert_int4(double4);\012int4 __ovld __cnfn convert_int4_rte(double4);\012int4 __ovld __cnfn convert_int4_rtn(double4);\012int4 __ovld __cnfn convert_int4_rtp(double4);\012int4 __ovld __cnfn convert_int4_rtz(double4);\012int4 __ovld __cnfn convert_int4_sat(double4);\012int4 __ovld __cnfn convert_int4_sat_rte(double4);\012int4 __ovld __cnfn convert_int4_sat_rtn(double4);\012int4 __ovld __cnfn convert_int4_sat_rtp(double4);\012int4 __ovld __cnfn convert_int4_sat_rtz(double4);\012int8 __ovld __cnfn conve",
"rt_int8(double8);\012int8 __ovld __cnfn convert_int8_rte(double8);\012int8 __ovld __cnfn convert_int8_rtn(double8);\012int8 __ovld __cnfn convert_int8_rtp(double8);\012int8 __ovld __cnfn convert_int8_rtz(double8);\012int8 __ovld __cnfn convert_int8_sat(double8);\012int8 __ovld __cnfn convert_int8_sat_rte(double8);\012int8 __ovld __cnfn convert_int8_sat_rtn(double8);\012int8 __ovld __cnfn convert_int8_sat_rtp(double8);\012int8 __ovld __cnfn convert_int8_sat_rtz(double8);\012int16 __ovld __cnfn convert_int16(double16);\012int16 __ovld __cnfn convert_int16_rte(double16);\012int16 __ovld __cnfn convert_int16_rtn(double16);\012int16 __ovld __cnfn convert_int16_rtp(double16);\012int16 __ovld __cnfn convert_int16_rtz(double16);\012int16 __ovld __cnfn convert_int16_sat(double16);\012int16 __ovld __cnfn convert_int16_sat_rte(double16);\012int16 __ovld __cnfn convert_int16_sat_rtn(double16);\012int16 __ovld __cnfn convert_int16_sat_rtp(double16);\012int16 __ovld __cnfn convert_int16_sat_rtz(double16);\012\012uint __ovld __cnfn convert_uint(double);\012uint __ovld __cnfn convert_uint_",
"rte(double);\012uint __ovld __cnfn convert_uint_rtn(double);\012uint __ovld __cnfn convert_uint_rtp(double);\012uint __ovld __cnfn convert_uint_rtz(double);\012uint __ovld __cnfn convert_uint_sat(double);\012uint __ovld __cnfn convert_uint_sat_rte(double);\012uint __ovld __cnfn convert_uint_sat_rtn(double);\012uint __ovld __cnfn convert_uint_sat_rtp(double);\012uint __ovld __cnfn convert_uint_sat_rtz(double);\012uint2 __ovld __cnfn convert_uint2(double2);\012uint2 __ovld __cnfn convert_uint2_rte(double2);\012uint2 __ovld __cnfn convert_uint2_rtn(double2);\012uint2 __ovld __cnfn convert_uint2_rtp(double2);\012uint2 __ovld __cnfn convert_uint2_rtz(double2);\012uint2 __ovld __cnfn convert_uint2_sat(double2);\012uint2 __ovld __cnfn convert_uint2_sat_rte(double2);\012uint2 __ovld __cnfn convert_uint2_sat_rtn(double2);\012uint2 __ovld __cnfn convert_uint2_sat_rtp(double2);\012uint2 __ovld __cnfn convert_uint2_sat_rtz(double2);\012uint3 __ovld __cnfn convert_uint3(double3);\012uint3 __ovld __cnfn convert_uint3_rte(double3);\012uint3 __ovld __cnfn convert_uint3_rtn(double3);\012uin",
"t3 __ovld __cnfn convert_uint3_rtp(double3);\012uint3 __ovld __cnfn convert_uint3_rtz(double3);\012uint3 __ovld __cnfn convert_uint3_sat(double3);\012uint3 __ovld __cnfn convert_uint3_sat_rte(double3);\012uint3 __ovld __cnfn convert_uint3_sat_rtn(double3);\012uint3 __ovld __cnfn convert_uint3_sat_rtp(double3);\012uint3 __ovld __cnfn convert_uint3_sat_rtz(double3);\012uint4 __ovld __cnfn convert_uint4(double4);\012uint4 __ovld __cnfn convert_uint4_rte(double4);\012uint4 __ovld __cnfn convert_uint4_rtn(double4);\012uint4 __ovld __cnfn convert_uint4_rtp(double4);\012uint4 __ovld __cnfn convert_uint4_rtz(double4);\012uint4 __ovld __cnfn convert_uint4_sat(double4);\012uint4 __ovld __cnfn convert_uint4_sat_rte(double4);\012uint4 __ovld __cnfn convert_uint4_sat_rtn(double4);\012uint4 __ovld __cnfn convert_uint4_sat_rtp(double4);\012uint4 __ovld __cnfn convert_uint4_sat_rtz(double4);\012uint8 __ovld __cnfn convert_uint8(double8);\012uint8 __ovld __cnfn convert_uint8_rte(double8);\012uint8 __ovld __cnfn convert_uint8_rtn(double8);\012uint8 __ovld __cnfn convert_uint8_rtp(doubl",
"e8);\012uint8 __ovld __cnfn convert_uint8_rtz(double8);\012uint8 __ovld __cnfn convert_uint8_sat(double8);\012uint8 __ovld __cnfn convert_uint8_sat_rte(double8);\012uint8 __ovld __cnfn convert_uint8_sat_rtn(double8);\012uint8 __ovld __cnfn convert_uint8_sat_rtp(double8);\012uint8 __ovld __cnfn convert_uint8_sat_rtz(double8);\012uint16 __ovld __cnfn convert_uint16(double16);\012uint16 __ovld __cnfn convert_uint16_rte(double16);\012uint16 __ovld __cnfn convert_uint16_rtn(double16);\012uint16 __ovld __cnfn convert_uint16_rtp(double16);\012uint16 __ovld __cnfn convert_uint16_rtz(double16);\012uint16 __ovld __cnfn convert_uint16_sat(double16);\012uint16 __ovld __cnfn convert_uint16_sat_rte(double16);\012uint16 __ovld __cnfn convert_uint16_sat_rtn(double16);\012uint16 __ovld __cnfn convert_uint16_sat_rtp(double16);\012uint16 __ovld __cnfn convert_uint16_sat_rtz(double16);\012\012long __ovld __cnfn convert_long(double);\012long __ovld __cnfn convert_long_rte(double);\012long __ovld __cnfn convert_long_rtn(double);\012long __ovld __cnfn convert_long_rtp(double);\012long __ovld __cn",
"fn convert_long_rtz(double);\012long __ovld __cnfn convert_long_sat(double);\012long __ovld __cnfn convert_long_sat_rte(double);\012long __ovld __cnfn convert_long_sat_rtn(double);\012long __ovld __cnfn convert_long_sat_rtp(double);\012long __ovld __cnfn convert_long_sat_rtz(double);\012long2 __ovld __cnfn convert_long2(double2);\012long2 __ovld __cnfn convert_long2_rte(double2);\012long2 __ovld __cnfn convert_long2_rtn(double2);\012long2 __ovld __cnfn convert_long2_rtp(double2);\012long2 __ovld __cnfn convert_long2_rtz(double2);\012long2 __ovld __cnfn convert_long2_sat(double2);\012long2 __ovld __cnfn convert_long2_sat_rte(double2);\012long2 __ovld __cnfn convert_long2_sat_rtn(double2);\012long2 __ovld __cnfn convert_long2_sat_rtp(double2);\012long2 __ovld __cnfn convert_long2_sat_rtz(double2);\012long3 __ovld __cnfn convert_long3(double3);\012long3 __ovld __cnfn convert_long3_rte(double3);\012long3 __ovld __cnfn convert_long3_rtn(double3);\012long3 __ovld __cnfn convert_long3_rtp(double3);\012long3 __ovld __cnfn convert_long3_rtz(double3);\012long3 __ovld __cnfn conver",
"t_long3_sat(double3);\012long3 __ovld __cnfn convert_long3_sat_rte(double3);\012long3 __ovld __cnfn convert_long3_sat_rtn(double3);\012long3 __ovld __cnfn convert_long3_sat_rtp(double3);\012long3 __ovld __cnfn convert_long3_sat_rtz(double3);\012long4 __ovld __cnfn convert_long4(double4);\012long4 __ovld __cnfn convert_long4_rte(double4);\012long4 __ovld __cnfn convert_long4_rtn(double4);\012long4 __ovld __cnfn convert_long4_rtp(double4);\012long4 __ovld __cnfn convert_long4_rtz(double4);\012long4 __ovld __cnfn convert_long4_sat(double4);\012long4 __ovld __cnfn convert_long4_sat_rte(double4);\012long4 __ovld __cnfn convert_long4_sat_rtn(double4);\012long4 __ovld __cnfn convert_long4_sat_rtp(double4);\012long4 __ovld __cnfn convert_long4_sat_rtz(double4);\012long8 __ovld __cnfn convert_long8(double8);\012long8 __ovld __cnfn convert_long8_rte(double8);\012long8 __ovld __cnfn convert_long8_rtn(double8);\012long8 __ovld __cnfn convert_long8_rtp(double8);\012long8 __ovld __cnfn convert_long8_rtz(double8);\012long8 __ovld __cnfn convert_long8_sat(double8);\012long8 __ovld __cnf",
"n convert_long8_sat_rte(double8);\012long8 __ovld __cnfn convert_long8_sat_rtn(double8);\012long8 __ovld __cnfn convert_long8_sat_rtp(double8);\012long8 __ovld __cnfn convert_long8_sat_rtz(double8);\012long16 __ovld __cnfn convert_long16(double16);\012long16 __ovld __cnfn convert_long16_rte(double16);\012long16 __ovld __cnfn convert_long16_rtn(double16);\012long16 __ovld __cnfn convert_long16_rtp(double16);\012long16 __ovld __cnfn convert_long16_rtz(double16);\012long16 __ovld __cnfn convert_long16_sat(double16);\012long16 __ovld __cnfn convert_long16_sat_rte(double16);\012long16 __ovld __cnfn convert_long16_sat_rtn(double16);\012long16 __ovld __cnfn convert_long16_sat_rtp(double16);\012long16 __ovld __cnfn convert_long16_sat_rtz(double16);\012\012ulong __ovld __cnfn convert_ulong(double);\012ulong __ovld __cnfn convert_ulong_rte(double);\012ulong __ovld __cnfn convert_ulong_rtn(double);\012ulong __ovld __cnfn convert_ulong_rtp(double);\012ulong __ovld __cnfn convert_ulong_rtz(double);\012ulong __ovld __cnfn convert_ulong_sat(double);\012ulong __ovld __cnfn convert_ulong",
"_sat_rte(double);\012ulong __ovld __cnfn convert_ulong_sat_rtn(double);\012ulong __ovld __cnfn convert_ulong_sat_rtp(double);\012ulong __ovld __cnfn convert_ulong_sat_rtz(double);\012ulong2 __ovld __cnfn convert_ulong2(double2);\012ulong2 __ovld __cnfn convert_ulong2_rte(double2);\012ulong2 __ovld __cnfn convert_ulong2_rtn(double2);\012ulong2 __ovld __cnfn convert_ulong2_rtp(double2);\012ulong2 __ovld __cnfn convert_ulong2_rtz(double2);\012ulong2 __ovld __cnfn convert_ulong2_sat(double2);\012ulong2 __ovld __cnfn convert_ulong2_sat_rte(double2);\012ulong2 __ovld __cnfn convert_ulong2_sat_rtn(double2);\012ulong2 __ovld __cnfn convert_ulong2_sat_rtp(double2);\012ulong2 __ovld __cnfn convert_ulong2_sat_rtz(double2);\012ulong3 __ovld __cnfn convert_ulong3(double3);\012ulong3 __ovld __cnfn convert_ulong3_rte(double3);\012ulong3 __ovld __cnfn convert_ulong3_rtn(double3);\012ulong3 __ovld __cnfn convert_ulong3_rtp(double3);\012ulong3 __ovld __cnfn convert_ulong3_rtz(double3);\012ulong3 __ovld __cnfn convert_ulong3_sat(double3);\012ulong3 __ovld __cnfn convert_ulong3_sat_rte(d",
"ouble3);\012ulong3 __ovld __cnfn convert_ulong3_sat_rtn(double3);\012ulong3 __ovld __cnfn convert_ulong3_sat_rtp(double3);\012ulong3 __ovld __cnfn convert_ulong3_sat_rtz(double3);\012ulong4 __ovld __cnfn convert_ulong4(double4);\012ulong4 __ovld __cnfn convert_ulong4_rte(double4);\012ulong4 __ovld __cnfn convert_ulong4_rtn(double4);\012ulong4 __ovld __cnfn convert_ulong4_rtp(double4);\012ulong4 __ovld __cnfn convert_ulong4_rtz(double4);\012ulong4 __ovld __cnfn convert_ulong4_sat(double4);\012ulong4 __ovld __cnfn convert_ulong4_sat_rte(double4);\012ulong4 __ovld __cnfn convert_ulong4_sat_rtn(double4);\012ulong4 __ovld __cnfn convert_ulong4_sat_rtp(double4);\012ulong4 __ovld __cnfn convert_ulong4_sat_rtz(double4);\012ulong8 __ovld __cnfn convert_ulong8(double8);\012ulong8 __ovld __cnfn convert_ulong8_rte(double8);\012ulong8 __ovld __cnfn convert_ulong8_rtn(double8);\012ulong8 __ovld __cnfn convert_ulong8_rtp(double8);\012ulong8 __ovld __cnfn convert_ulong8_rtz(double8);\012ulong8 __ovld __cnfn convert_ulong8_sat(double8);\012ulong8 __ovld __cnfn convert_ulong8_sat_rte(d",
"ouble8);\012ulong8 __ovld __cnfn convert_ulong8_sat_rtn(double8);\012ulong8 __ovld __cnfn convert_ulong8_sat_rtp(double8);\012ulong8 __ovld __cnfn convert_ulong8_sat_rtz(double8);\012ulong16 __ovld __cnfn convert_ulong16(double16);\012ulong16 __ovld __cnfn convert_ulong16_rte(double16);\012ulong16 __ovld __cnfn convert_ulong16_rtn(double16);\012ulong16 __ovld __cnfn convert_ulong16_rtp(double16);\012ulong16 __ovld __cnfn convert_ulong16_rtz(double16);\012ulong16 __ovld __cnfn convert_ulong16_sat(double16);\012ulong16 __ovld __cnfn convert_ulong16_sat_rte(double16);\012ulong16 __ovld __cnfn convert_ulong16_sat_rtn(double16);\012ulong16 __ovld __cnfn convert_ulong16_sat_rtp(double16);\012ulong16 __ovld __cnfn convert_ulong16_sat_rtz(double16);\012\012float __ovld __cnfn convert_float(double);\012float __ovld __cnfn convert_float_rte(double);\012float __ovld __cnfn convert_float_rtn(double);\012float __ovld __cnfn convert_float_rtp(double);\012float __ovld __cnfn convert_float_rtz(double);\012float2 __ovld __cnfn convert_float2(double2);\012float2 __ovld __cnfn convert_floa",
"t2_rte(double2);\012float2 __ovld __cnfn convert_float2_rtn(double2);\012float2 __ovld __cnfn convert_float2_rtp(double2);\012float2 __ovld __cnfn convert_float2_rtz(double2);\012float3 __ovld __cnfn convert_float3(double3);\012float3 __ovld __cnfn convert_float3_rte(double3);\012float3 __ovld __cnfn convert_float3_rtn(double3);\012float3 __ovld __cnfn convert_float3_rtp(double3);\012float3 __ovld __cnfn convert_float3_rtz(double3);\012float4 __ovld __cnfn convert_float4(double4);\012float4 __ovld __cnfn convert_float4_rte(double4);\012float4 __ovld __cnfn convert_float4_rtn(double4);\012float4 __ovld __cnfn convert_float4_rtp(double4);\012float4 __ovld __cnfn convert_float4_rtz(double4);\012float8 __ovld __cnfn convert_float8(double8);\012float8 __ovld __cnfn convert_float8_rte(double8);\012float8 __ovld __cnfn convert_float8_rtn(double8);\012float8 __ovld __cnfn convert_float8_rtp(double8);\012float8 __ovld __cnfn convert_float8_rtz(double8);\012float16 __ovld __cnfn convert_float16(double16);\012float16 __ovld __cnfn convert_float16_rte(double16);\012float16 __ovld __",
"cnfn convert_float16_rtn(double16);\012float16 __ovld __cnfn convert_float16_rtp(double16);\012float16 __ovld __cnfn convert_float16_rtz(double16);\012\012double __ovld __cnfn convert_double(char);\012double __ovld __cnfn convert_double(double);\012double __ovld __cnfn convert_double(float);\012double __ovld __cnfn convert_double(int);\012double __ovld __cnfn convert_double(long);\012double __ovld __cnfn convert_double(short);\012double __ovld __cnfn convert_double(uchar);\012double __ovld __cnfn convert_double(uint);\012double __ovld __cnfn convert_double(ulong);\012double __ovld __cnfn convert_double(ushort);\012double __ovld __cnfn convert_double_rte(char);\012double __ovld __cnfn convert_double_rte(double);\012double __ovld __cnfn convert_double_rte(float);\012double __ovld __cnfn convert_double_rte(int);\012double __ovld __cnfn convert_double_rte(long);\012double __ovld __cnfn convert_double_rte(short);\012double __ovld __cnfn convert_double_rte(uchar);\012double __ovld __cnfn convert_double_rte(uint);\012double __ovld __cnfn convert_double_rte(ulong);\012double __ovld __",
"cnfn convert_double_rte(ushort);\012double __ovld __cnfn convert_double_rtn(char);\012double __ovld __cnfn convert_double_rtn(double);\012double __ovld __cnfn convert_double_rtn(float);\012double __ovld __cnfn convert_double_rtn(int);\012double __ovld __cnfn convert_double_rtn(long);\012double __ovld __cnfn convert_double_rtn(short);\012double __ovld __cnfn convert_double_rtn(uchar);\012double __ovld __cnfn convert_double_rtn(uint);\012double __ovld __cnfn convert_double_rtn(ulong);\012double __ovld __cnfn convert_double_rtn(ushort);\012double __ovld __cnfn convert_double_rtp(char);\012double __ovld __cnfn convert_double_rtp(double);\012double __ovld __cnfn convert_double_rtp(float);\012double __ovld __cnfn convert_double_rtp(int);\012double __ovld __cnfn convert_double_rtp(long);\012double __ovld __cnfn convert_double_rtp(short);\012double __ovld __cnfn convert_double_rtp(uchar);\012double __ovld __cnfn convert_double_rtp(uint);\012double __ovld __cnfn convert_double_rtp(ulong);\012double __ovld __cnfn convert_double_rtp(ushort);\012double __ovld __cnfn convert_double_r",
"tz(char);\012double __ovld __cnfn convert_double_rtz(double);\012double __ovld __cnfn convert_double_rtz(float);\012double __ovld __cnfn convert_double_rtz(int);\012double __ovld __cnfn convert_double_rtz(long);\012double __ovld __cnfn convert_double_rtz(short);\012double __ovld __cnfn convert_double_rtz(uchar);\012double __ovld __cnfn convert_double_rtz(uint);\012double __ovld __cnfn convert_double_rtz(ulong);\012double __ovld __cnfn convert_double_rtz(ushort);\012double2 __ovld __cnfn convert_double2(char2);\012double2 __ovld __cnfn convert_double2(double2);\012double2 __ovld __cnfn convert_double2(float2);\012double2 __ovld __cnfn convert_double2(int2);\012double2 __ovld __cnfn convert_double2(long2);\012double2 __ovld __cnfn convert_double2(short2);\012double2 __ovld __cnfn convert_double2(uchar2);\012double2 __ovld __cnfn convert_double2(uint2);\012double2 __ovld __cnfn convert_double2(ulong2);\012double2 __ovld __cnfn convert_double2(ushort2);\012double2 __ovld __cnfn convert_double2_rte(char2);\012double2 __ovld __cnfn convert_double2_rte(double2);\012double2 __ovld ",
"__cnfn convert_double2_rte(float2);\012double2 __ovld __cnfn convert_double2_rte(int2);\012double2 __ovld __cnfn convert_double2_rte(long2);\012double2 __ovld __cnfn convert_double2_rte(short2);\012double2 __ovld __cnfn convert_double2_rte(uchar2);\012double2 __ovld __cnfn convert_double2_rte(uint2);\012double2 __ovld __cnfn convert_double2_rte(ulong2);\012double2 __ovld __cnfn convert_double2_rte(ushort2);\012double2 __ovld __cnfn convert_double2_rtn(char2);\012double2 __ovld __cnfn convert_double2_rtn(double2);\012double2 __ovld __cnfn convert_double2_rtn(float2);\012double2 __ovld __cnfn convert_double2_rtn(int2);\012double2 __ovld __cnfn convert_double2_rtn(long2);\012double2 __ovld __cnfn convert_double2_rtn(short2);\012double2 __ovld __cnfn convert_double2_rtn(uchar2);\012double2 __ovld __cnfn convert_double2_rtn(uint2);\012double2 __ovld __cnfn convert_double2_rtn(ulong2);\012double2 __ovld __cnfn convert_double2_rtn(ushort2);\012double2 __ovld __cnfn convert_double2_rtp(char2);\012double2 __ovld __cnfn convert_double2_rtp(double2);\012double2 __ovld __cnfn con",
"vert_double2_rtp(float2);\012double2 __ovld __cnfn convert_double2_rtp(int2);\012double2 __ovld __cnfn convert_double2_rtp(long2);\012double2 __ovld __cnfn convert_double2_rtp(short2);\012double2 __ovld __cnfn convert_double2_rtp(uchar2);\012double2 __ovld __cnfn convert_double2_rtp(uint2);\012double2 __ovld __cnfn convert_double2_rtp(ulong2);\012double2 __ovld __cnfn convert_double2_rtp(ushort2);\012double2 __ovld __cnfn convert_double2_rtz(char2);\012double2 __ovld __cnfn convert_double2_rtz(double2);\012double2 __ovld __cnfn convert_double2_rtz(float2);\012double2 __ovld __cnfn convert_double2_rtz(int2);\012double2 __ovld __cnfn convert_double2_rtz(long2);\012double2 __ovld __cnfn convert_double2_rtz(short2);\012double2 __ovld __cnfn convert_double2_rtz(uchar2);\012double2 __ovld __cnfn convert_double2_rtz(uint2);\012double2 __ovld __cnfn convert_double2_rtz(ulong2);\012double2 __ovld __cnfn convert_double2_rtz(ushort2);\012double3 __ovld __cnfn convert_double3(char3);\012double3 __ovld __cnfn convert_double3(double3);\012double3 __ovld __cnfn convert_double3(float",
"3);\012double3 __ovld __cnfn convert_double3(int3);\012double3 __ovld __cnfn convert_double3(long3);\012double3 __ovld __cnfn convert_double3(short3);\012double3 __ovld __cnfn convert_double3(uchar3);\012double3 __ovld __cnfn convert_double3(uint3);\012double3 __ovld __cnfn convert_double3(ulong3);\012double3 __ovld __cnfn convert_double3(ushort3);\012double3 __ovld __cnfn convert_double3_rte(char3);\012double3 __ovld __cnfn convert_double3_rte(double3);\012double3 __ovld __cnfn convert_double3_rte(float3);\012double3 __ovld __cnfn convert_double3_rte(int3);\012double3 __ovld __cnfn convert_double3_rte(long3);\012double3 __ovld __cnfn convert_double3_rte(short3);\012double3 __ovld __cnfn convert_double3_rte(uchar3);\012double3 __ovld __cnfn convert_double3_rte(uint3);\012double3 __ovld __cnfn convert_double3_rte(ulong3);\012double3 __ovld __cnfn convert_double3_rte(ushort3);\012double3 __ovld __cnfn convert_double3_rtn(char3);\012double3 __ovld __cnfn convert_double3_rtn(double3);\012double3 __ovld __cnfn convert_double3_rtn(float3);\012double3 __ovld __cnfn convert_doub",
"le3_rtn(int3);\012double3 __ovld __cnfn convert_double3_rtn(long3);\012double3 __ovld __cnfn convert_double3_rtn(short3);\012double3 __ovld __cnfn convert_double3_rtn(uchar3);\012double3 __ovld __cnfn convert_double3_rtn(uint3);\012double3 __ovld __cnfn convert_double3_rtn(ulong3);\012double3 __ovld __cnfn convert_double3_rtn(ushort3);\012double3 __ovld __cnfn convert_double3_rtp(char3);\012double3 __ovld __cnfn convert_double3_rtp(double3);\012double3 __ovld __cnfn convert_double3_rtp(float3);\012double3 __ovld __cnfn convert_double3_rtp(int3);\012double3 __ovld __cnfn convert_double3_rtp(long3);\012double3 __ovld __cnfn convert_double3_rtp(short3);\012double3 __ovld __cnfn convert_double3_rtp(uchar3);\012double3 __ovld __cnfn convert_double3_rtp(uint3);\012double3 __ovld __cnfn convert_double3_rtp(ulong3);\012double3 __ovld __cnfn convert_double3_rtp(ushort3);\012double3 __ovld __cnfn convert_double3_rtz(char3);\012double3 __ovld __cnfn convert_double3_rtz(double3);\012double3 __ovld __cnfn convert_double3_rtz(float3);\012double3 __ovld __cnfn convert_double3_rtz(in",
"t3);\012double3 __ovld __cnfn convert_double3_rtz(long3);\012double3 __ovld __cnfn convert_double3_rtz(short3);\012double3 __ovld __cnfn convert_double3_rtz(uchar3);\012double3 __ovld __cnfn convert_double3_rtz(uint3);\012double3 __ovld __cnfn convert_double3_rtz(ulong3);\012double3 __ovld __cnfn convert_double3_rtz(ushort3);\012double4 __ovld __cnfn convert_double4(char4);\012double4 __ovld __cnfn convert_double4(double4);\012double4 __ovld __cnfn convert_double4(float4);\012double4 __ovld __cnfn convert_double4(int4);\012double4 __ovld __cnfn convert_double4(long4);\012double4 __ovld __cnfn convert_double4(short4);\012double4 __ovld __cnfn convert_double4(uchar4);\012double4 __ovld __cnfn convert_double4(uint4);\012double4 __ovld __cnfn convert_double4(ulong4);\012double4 __ovld __cnfn convert_double4(ushort4);\012double4 __ovld __cnfn convert_double4_rte(char4);\012double4 __ovld __cnfn convert_double4_rte(double4);\012double4 __ovld __cnfn convert_double4_rte(float4);\012double4 __ovld __cnfn convert_double4_rte(int4);\012double4 __ovld __cnfn convert_double4_rte(lon",
"g4);\012double4 __ovld __cnfn convert_double4_rte(short4);\012double4 __ovld __cnfn convert_double4_rte(uchar4);\012double4 __ovld __cnfn convert_double4_rte(uint4);\012double4 __ovld __cnfn convert_double4_rte(ulong4);\012double4 __ovld __cnfn convert_double4_rte(ushort4);\012double4 __ovld __cnfn convert_double4_rtn(char4);\012double4 __ovld __cnfn convert_double4_rtn(double4);\012double4 __ovld __cnfn convert_double4_rtn(float4);\012double4 __ovld __cnfn convert_double4_rtn(int4);\012double4 __ovld __cnfn convert_double4_rtn(long4);\012double4 __ovld __cnfn convert_double4_rtn(short4);\012double4 __ovld __cnfn convert_double4_rtn(uchar4);\012double4 __ovld __cnfn convert_double4_rtn(uint4);\012double4 __ovld __cnfn convert_double4_rtn(ulong4);\012double4 __ovld __cnfn convert_double4_rtn(ushort4);\012double4 __ovld __cnfn convert_double4_rtp(char4);\012double4 __ovld __cnfn convert_double4_rtp(double4);\012double4 __ovld __cnfn convert_double4_rtp(float4);\012double4 __ovld __cnfn convert_double4_rtp(int4);\012double4 __ovld __cnfn convert_double4_rtp(long4);\012doubl",
"e4 __ovld __cnfn convert_double4_rtp(short4);\012double4 __ovld __cnfn convert_double4_rtp(uchar4);\012double4 __ovld __cnfn convert_double4_rtp(uint4);\012double4 __ovld __cnfn convert_double4_rtp(ulong4);\012double4 __ovld __cnfn convert_double4_rtp(ushort4);\012double4 __ovld __cnfn convert_double4_rtz(char4);\012double4 __ovld __cnfn convert_double4_rtz(double4);\012double4 __ovld __cnfn convert_double4_rtz(float4);\012double4 __ovld __cnfn convert_double4_rtz(int4);\012double4 __ovld __cnfn convert_double4_rtz(long4);\012double4 __ovld __cnfn convert_double4_rtz(short4);\012double4 __ovld __cnfn convert_double4_rtz(uchar4);\012double4 __ovld __cnfn convert_double4_rtz(uint4);\012double4 __ovld __cnfn convert_double4_rtz(ulong4);\012double4 __ovld __cnfn convert_double4_rtz(ushort4);\012double8 __ovld __cnfn convert_double8(char8);\012double8 __ovld __cnfn convert_double8(double8);\012double8 __ovld __cnfn convert_double8(float8);\012double8 __ovld __cnfn convert_double8(int8);\012double8 __ovld __cnfn convert_double8(long8);\012double8 __ovld __cnfn convert_doubl",
"e8(short8);\012double8 __ovld __cnfn convert_double8(uchar8);\012double8 __ovld __cnfn convert_double8(uint8);\012double8 __ovld __cnfn convert_double8(ulong8);\012double8 __ovld __cnfn convert_double8(ushort8);\012double8 __ovld __cnfn convert_double8_rte(char8);\012double8 __ovld __cnfn convert_double8_rte(double8);\012double8 __ovld __cnfn convert_double8_rte(float8);\012double8 __ovld __cnfn convert_double8_rte(int8);\012double8 __ovld __cnfn convert_double8_rte(long8);\012double8 __ovld __cnfn convert_double8_rte(short8);\012double8 __ovld __cnfn convert_double8_rte(uchar8);\012double8 __ovld __cnfn convert_double8_rte(uint8);\012double8 __ovld __cnfn convert_double8_rte(ulong8);\012double8 __ovld __cnfn convert_double8_rte(ushort8);\012double8 __ovld __cnfn convert_double8_rtn(char8);\012double8 __ovld __cnfn convert_double8_rtn(double8);\012double8 __ovld __cnfn convert_double8_rtn(float8);\012double8 __ovld __cnfn convert_double8_rtn(int8);\012double8 __ovld __cnfn convert_double8_rtn(long8);\012double8 __ovld __cnfn convert_double8_rtn(short8);\012double8 __ovld",
" __cnfn convert_double8_rtn(uchar8);\012double8 __ovld __cnfn convert_double8_rtn(uint8);\012double8 __ovld __cnfn convert_double8_rtn(ulong8);\012double8 __ovld __cnfn convert_double8_rtn(ushort8);\012double8 __ovld __cnfn convert_double8_rtp(char8);\012double8 __ovld __cnfn convert_double8_rtp(double8);\012double8 __ovld __cnfn convert_double8_rtp(float8);\012double8 __ovld __cnfn convert_double8_rtp(int8);\012double8 __ovld __cnfn convert_double8_rtp(long8);\012double8 __ovld __cnfn convert_double8_rtp(short8);\012double8 __ovld __cnfn convert_double8_rtp(uchar8);\012double8 __ovld __cnfn convert_double8_rtp(uint8);\012double8 __ovld __cnfn convert_double8_rtp(ulong8);\012double8 __ovld __cnfn convert_double8_rtp(ushort8);\012double8 __ovld __cnfn convert_double8_rtz(char8);\012double8 __ovld __cnfn convert_double8_rtz(double8);\012double8 __ovld __cnfn convert_double8_rtz(float8);\012double8 __ovld __cnfn convert_double8_rtz(int8);\012double8 __ovld __cnfn convert_double8_rtz(long8);\012double8 __ovld __cnfn convert_double8_rtz(short8);\012double8 __ovld __cnfn co",
"nvert_double8_rtz(uchar8);\012double8 __ovld __cnfn convert_double8_rtz(uint8);\012double8 __ovld __cnfn convert_double8_rtz(ulong8);\012double8 __ovld __cnfn convert_double8_rtz(ushort8);\012double16 __ovld __cnfn convert_double16(char16);\012double16 __ovld __cnfn convert_double16(double16);\012double16 __ovld __cnfn convert_double16(float16);\012double16 __ovld __cnfn convert_double16(int16);\012double16 __ovld __cnfn convert_double16(long16);\012double16 __ovld __cnfn convert_double16(short16);\012double16 __ovld __cnfn convert_double16(uchar16);\012double16 __ovld __cnfn convert_double16(uint16);\012double16 __ovld __cnfn convert_double16(ulong16);\012double16 __ovld __cnfn convert_double16(ushort16);\012double16 __ovld __cnfn convert_double16_rte(char16);\012double16 __ovld __cnfn convert_double16_rte(double16);\012double16 __ovld __cnfn convert_double16_rte(float16);\012double16 __ovld __cnfn convert_double16_rte(int16);\012double16 __ovld __cnfn convert_double16_rte(long16);\012double16 __ovld __cnfn convert_double16_rte(short16);\012double16 __ovld __cnfn con",
"vert_double16_rte(uchar16);\012double16 __ovld __cnfn convert_double16_rte(uint16);\012double16 __ovld __cnfn convert_double16_rte(ulong16);\012double16 __ovld __cnfn convert_double16_rte(ushort16);\012double16 __ovld __cnfn convert_double16_rtn(char16);\012double16 __ovld __cnfn convert_double16_rtn(double16);\012double16 __ovld __cnfn convert_double16_rtn(float16);\012double16 __ovld __cnfn convert_double16_rtn(int16);\012double16 __ovld __cnfn convert_double16_rtn(long16);\012double16 __ovld __cnfn convert_double16_rtn(short16);\012double16 __ovld __cnfn convert_double16_rtn(uchar16);\012double16 __ovld __cnfn convert_double16_rtn(uint16);\012double16 __ovld __cnfn convert_double16_rtn(ulong16);\012double16 __ovld __cnfn convert_double16_rtn(ushort16);\012double16 __ovld __cnfn convert_double16_rtp(char16);\012double16 __ovld __cnfn convert_double16_rtp(double16);\012double16 __ovld __cnfn convert_double16_rtp(float16);\012double16 __ovld __cnfn convert_double16_rtp(int16);\012double16 __ovld __cnfn convert_double16_rtp(long16);\012double16 __ovld __cnfn convert",
"_double16_rtp(short16);\012double16 __ovld __cnfn convert_double16_rtp(uchar16);\012double16 __ovld __cnfn convert_double16_rtp(uint16);\012double16 __ovld __cnfn convert_double16_rtp(ulong16);\012double16 __ovld __cnfn convert_double16_rtp(ushort16);\012double16 __ovld __cnfn convert_double16_rtz(char16);\012double16 __ovld __cnfn convert_double16_rtz(double16);\012double16 __ovld __cnfn convert_double16_rtz(float16);\012double16 __ovld __cnfn convert_double16_rtz(int16);\012double16 __ovld __cnfn convert_double16_rtz(long16);\012double16 __ovld __cnfn convert_double16_rtz(short16);\012double16 __ovld __cnfn convert_double16_rtz(uchar16);\012double16 __ovld __cnfn convert_double16_rtz(uint16);\012double16 __ovld __cnfn convert_double16_rtz(ulong16);\012double16 __ovld __cnfn convert_double16_rtz(ushort16);\012#endif //cl_khr_fp64\012\012#ifdef cl_khr_fp16\012// Convert half types to non-double types.\012uchar __ovld __cnfn convert_uchar(half);\012uchar __ovld __cnfn convert_uchar_rte(half);\012uchar __ovld __cnfn convert_uchar_rtp(half);\012uchar __ovld __cnfn convert_ucha",
"r_rtn(half);\012uchar __ovld __cnfn convert_uchar_rtz(half);\012uchar __ovld __cnfn convert_uchar_sat(half);\012uchar __ovld __cnfn convert_uchar_sat_rte(half);\012uchar __ovld __cnfn convert_uchar_sat_rtp(half);\012uchar __ovld __cnfn convert_uchar_sat_rtn(half);\012uchar __ovld __cnfn convert_uchar_sat_rtz(half);\012uchar2 __ovld __cnfn convert_uchar2(half2);\012uchar2 __ovld __cnfn convert_uchar2_rte(half2);\012uchar2 __ovld __cnfn convert_uchar2_rtp(half2);\012uchar2 __ovld __cnfn convert_uchar2_rtn(half2);\012uchar2 __ovld __cnfn convert_uchar2_rtz(half2);\012uchar2 __ovld __cnfn convert_uchar2_sat(half2);\012uchar2 __ovld __cnfn convert_uchar2_sat_rte(half2);\012uchar2 __ovld __cnfn convert_uchar2_sat_rtp(half2);\012uchar2 __ovld __cnfn convert_uchar2_sat_rtn(half2);\012uchar2 __ovld __cnfn convert_uchar2_sat_rtz(half2);\012uchar3 __ovld __cnfn convert_uchar3(half3);\012uchar3 __ovld __cnfn convert_uchar3_rte(half3);\012uchar3 __ovld __cnfn convert_uchar3_rtp(half3);\012uchar3 __ovld __cnfn convert_uchar3_rtn(half3);\012uchar3 __ovld __cnfn convert_uchar3_rtz(half3",
");\012uchar3 __ovld __cnfn convert_uchar3_sat(half3);\012uchar3 __ovld __cnfn convert_uchar3_sat_rte(half3);\012uchar3 __ovld __cnfn convert_uchar3_sat_rtp(half3);\012uchar3 __ovld __cnfn convert_uchar3_sat_rtn(half3);\012uchar3 __ovld __cnfn convert_uchar3_sat_rtz(half3);\012uchar4 __ovld __cnfn convert_uchar4(half4);\012uchar4 __ovld __cnfn convert_uchar4_rte(half4);\012uchar4 __ovld __cnfn convert_uchar4_rtp(half4);\012uchar4 __ovld __cnfn convert_uchar4_rtn(half4);\012uchar4 __ovld __cnfn convert_uchar4_rtz(half4);\012uchar4 __ovld __cnfn convert_uchar4_sat(half4);\012uchar4 __ovld __cnfn convert_uchar4_sat_rte(half4);\012uchar4 __ovld __cnfn convert_uchar4_sat_rtp(half4);\012uchar4 __ovld __cnfn convert_uchar4_sat_rtn(half4);\012uchar4 __ovld __cnfn convert_uchar4_sat_rtz(half4);\012uchar8 __ovld __cnfn convert_uchar8(half8);\012uchar8 __ovld __cnfn convert_uchar8_rte(half8);\012uchar8 __ovld __cnfn convert_uchar8_rtp(half8);\012uchar8 __ovld __cnfn convert_uchar8_rtn(half8);\012uchar8 __ovld __cnfn convert_uchar8_rtz(half8);\012uchar8 __ovld __cnfn convert_uchar8_s",
"at(half8);\012uchar8 __ovld __cnfn convert_uchar8_sat_rte(half8);\012uchar8 __ovld __cnfn convert_uchar8_sat_rtp(half8);\012uchar8 __ovld __cnfn convert_uchar8_sat_rtn(half8);\012uchar8 __ovld __cnfn convert_uchar8_sat_rtz(half8);\012uchar16 __ovld __cnfn convert_uchar16(half16);\012uchar16 __ovld __cnfn convert_uchar16_rte(half16);\012uchar16 __ovld __cnfn convert_uchar16_rtp(half16);\012uchar16 __ovld __cnfn convert_uchar16_rtn(half16);\012uchar16 __ovld __cnfn convert_uchar16_rtz(half16);\012uchar16 __ovld __cnfn convert_uchar16_sat(half16);\012uchar16 __ovld __cnfn convert_uchar16_sat_rte(half16);\012uchar16 __ovld __cnfn convert_uchar16_sat_rtp(half16);\012uchar16 __ovld __cnfn convert_uchar16_sat_rtn(half16);\012uchar16 __ovld __cnfn convert_uchar16_sat_rtz(half16);\012ushort __ovld __cnfn convert_ushort(half);\012ushort __ovld __cnfn convert_ushort_rte(half);\012ushort __ovld __cnfn convert_ushort_rtp(half);\012ushort __ovld __cnfn convert_ushort_rtn(half);\012ushort __ovld __cnfn convert_ushort_rtz(half);\012ushort __ovld __cnfn convert_ushort_sat(half);\012ushor",
"t __ovld __cnfn convert_ushort_sat_rte(half);\012ushort __ovld __cnfn convert_ushort_sat_rtp(half);\012ushort __ovld __cnfn convert_ushort_sat_rtn(half);\012ushort __ovld __cnfn convert_ushort_sat_rtz(half);\012ushort2 __ovld __cnfn convert_ushort2(half2);\012ushort2 __ovld __cnfn convert_ushort2_rte(half2);\012ushort2 __ovld __cnfn convert_ushort2_rtp(half2);\012ushort2 __ovld __cnfn convert_ushort2_rtn(half2);\012ushort2 __ovld __cnfn convert_ushort2_rtz(half2);\012ushort2 __ovld __cnfn convert_ushort2_sat(half2);\012ushort2 __ovld __cnfn convert_ushort2_sat_rte(half2);\012ushort2 __ovld __cnfn convert_ushort2_sat_rtp(half2);\012ushort2 __ovld __cnfn convert_ushort2_sat_rtn(half2);\012ushort2 __ovld __cnfn convert_ushort2_sat_rtz(half2);\012ushort3 __ovld __cnfn convert_ushort3(half3);\012ushort3 __ovld __cnfn convert_ushort3_rte(half3);\012ushort3 __ovld __cnfn convert_ushort3_rtp(half3);\012ushort3 __ovld __cnfn convert_ushort3_rtn(half3);\012ushort3 __ovld __cnfn convert_ushort3_rtz(half3);\012ushort3 __ovld __cnfn convert_ushort3_sat(half3);\012ushort3 __ovld __",
"cnfn convert_ushort3_sat_rte(half3);\012ushort3 __ovld __cnfn convert_ushort3_sat_rtp(half3);\012ushort3 __ovld __cnfn convert_ushort3_sat_rtn(half3);\012ushort3 __ovld __cnfn convert_ushort3_sat_rtz(half3);\012ushort4 __ovld __cnfn convert_ushort4(half4);\012ushort4 __ovld __cnfn convert_ushort4_rte(half4);\012ushort4 __ovld __cnfn convert_ushort4_rtp(half4);\012ushort4 __ovld __cnfn convert_ushort4_rtn(half4);\012ushort4 __ovld __cnfn convert_ushort4_rtz(half4);\012ushort4 __ovld __cnfn convert_ushort4_sat(half4);\012ushort4 __ovld __cnfn convert_ushort4_sat_rte(half4);\012ushort4 __ovld __cnfn convert_ushort4_sat_rtp(half4);\012ushort4 __ovld __cnfn convert_ushort4_sat_rtn(half4);\012ushort4 __ovld __cnfn convert_ushort4_sat_rtz(half4);\012ushort8 __ovld __cnfn convert_ushort8(half8);\012ushort8 __ovld __cnfn convert_ushort8_rte(half8);\012ushort8 __ovld __cnfn convert_ushort8_rtp(half8);\012ushort8 __ovld __cnfn convert_ushort8_rtn(half8);\012ushort8 __ovld __cnfn convert_ushort8_rtz(half8);\012ushort8 __ovld __cnfn convert_ushort8_sat(half8);\012ushort8 __ovld __",
"cnfn convert_ushort8_sat_rte(half8);\012ushort8 __ovld __cnfn convert_ushort8_sat_rtp(half8);\012ushort8 __ovld __cnfn convert_ushort8_sat_rtn(half8);\012ushort8 __ovld __cnfn convert_ushort8_sat_rtz(half8);\012ushort16 __ovld __cnfn convert_ushort16(half16);\012ushort16 __ovld __cnfn convert_ushort16_rte(half16);\012ushort16 __ovld __cnfn convert_ushort16_rtp(half16);\012ushort16 __ovld __cnfn convert_ushort16_rtn(half16);\012ushort16 __ovld __cnfn convert_ushort16_rtz(half16);\012ushort16 __ovld __cnfn convert_ushort16_sat(half16);\012ushort16 __ovld __cnfn convert_ushort16_sat_rte(half16);\012ushort16 __ovld __cnfn convert_ushort16_sat_rtp(half16);\012ushort16 __ovld __cnfn convert_ushort16_sat_rtn(half16);\012ushort16 __ovld __cnfn convert_ushort16_sat_rtz(half16);\012uint __ovld __cnfn convert_uint(half);\012uint __ovld __cnfn convert_uint_rte(half);\012uint __ovld __cnfn convert_uint_rtp(half);\012uint __ovld __cnfn convert_uint_rtn(half);\012uint __ovld __cnfn convert_uint_rtz(half);\012uint __ovld __cnfn convert_uint_sat(half);\012uint __ovld __cnfn convert_ui",
"nt_sat_rte(half);\012uint __ovld __cnfn convert_uint_sat_rtp(half);\012uint __ovld __cnfn convert_uint_sat_rtn(half);\012uint __ovld __cnfn convert_uint_sat_rtz(half);\012uint2 __ovld __cnfn convert_uint2(half2);\012uint2 __ovld __cnfn convert_uint2_rte(half2);\012uint2 __ovld __cnfn convert_uint2_rtp(half2);\012uint2 __ovld __cnfn convert_uint2_rtn(half2);\012uint2 __ovld __cnfn convert_uint2_rtz(half2);\012uint2 __ovld __cnfn convert_uint2_sat(half2);\012uint2 __ovld __cnfn convert_uint2_sat_rte(half2);\012uint2 __ovld __cnfn convert_uint2_sat_rtp(half2);\012uint2 __ovld __cnfn convert_uint2_sat_rtn(half2);\012uint2 __ovld __cnfn convert_uint2_sat_rtz(half2);\012uint3 __ovld __cnfn convert_uint3(half3);\012uint3 __ovld __cnfn convert_uint3_rte(half3);\012uint3 __ovld __cnfn convert_uint3_rtp(half3);\012uint3 __ovld __cnfn convert_uint3_rtn(half3);\012uint3 __ovld __cnfn convert_uint3_rtz(half3);\012uint3 __ovld __cnfn convert_uint3_sat(half3);\012uint3 __ovld __cnfn convert_uint3_sat_rte(half3);\012uint3 __ovld __cnfn convert_uint3_sat_rtp(half3);\012uint3 __ovld __cnfn c",
"onvert_uint3_sat_rtn(half3);\012uint3 __ovld __cnfn convert_uint3_sat_rtz(half3);\012uint4 __ovld __cnfn convert_uint4(half4);\012uint4 __ovld __cnfn convert_uint4_rte(half4);\012uint4 __ovld __cnfn convert_uint4_rtp(half4);\012uint4 __ovld __cnfn convert_uint4_rtn(half4);\012uint4 __ovld __cnfn convert_uint4_rtz(half4);\012uint4 __ovld __cnfn convert_uint4_sat(half4);\012uint4 __ovld __cnfn convert_uint4_sat_rte(half4);\012uint4 __ovld __cnfn convert_uint4_sat_rtp(half4);\012uint4 __ovld __cnfn convert_uint4_sat_rtn(half4);\012uint4 __ovld __cnfn convert_uint4_sat_rtz(half4);\012uint8 __ovld __cnfn convert_uint8(half8);\012uint8 __ovld __cnfn convert_uint8_rte(half8);\012uint8 __ovld __cnfn convert_uint8_rtp(half8);\012uint8 __ovld __cnfn convert_uint8_rtn(half8);\012uint8 __ovld __cnfn convert_uint8_rtz(half8);\012uint8 __ovld __cnfn convert_uint8_sat(half8);\012uint8 __ovld __cnfn convert_uint8_sat_rte(half8);\012uint8 __ovld __cnfn convert_uint8_sat_rtp(half8);\012uint8 __ovld __cnfn convert_uint8_sat_rtn(half8);\012uint8 __ovld __cnfn convert_uint8_sat_rtz(half8);\012u",
"int16 __ovld __cnfn convert_uint16(half16);\012uint16 __ovld __cnfn convert_uint16_rte(half16);\012uint16 __ovld __cnfn convert_uint16_rtp(half16);\012uint16 __ovld __cnfn convert_uint16_rtn(half16);\012uint16 __ovld __cnfn convert_uint16_rtz(half16);\012uint16 __ovld __cnfn convert_uint16_sat(half16);\012uint16 __ovld __cnfn convert_uint16_sat_rte(half16);\012uint16 __ovld __cnfn convert_uint16_sat_rtp(half16);\012uint16 __ovld __cnfn convert_uint16_sat_rtn(half16);\012uint16 __ovld __cnfn convert_uint16_sat_rtz(half16);\012ulong __ovld __cnfn convert_ulong(half);\012ulong __ovld __cnfn convert_ulong_rte(half);\012ulong __ovld __cnfn convert_ulong_rtp(half);\012ulong __ovld __cnfn convert_ulong_rtn(half);\012ulong __ovld __cnfn convert_ulong_rtz(half);\012ulong __ovld __cnfn convert_ulong_sat(half);\012ulong __ovld __cnfn convert_ulong_sat_rte(half);\012ulong __ovld __cnfn convert_ulong_sat_rtp(half);\012ulong __ovld __cnfn convert_ulong_sat_rtn(half);\012ulong __ovld __cnfn convert_ulong_sat_rtz(half);\012ulong2 __ovld __cnfn convert_ulong2(half2);\012ulong2 __ovld __c",
"nfn convert_ulong2_rte(half2);\012ulong2 __ovld __cnfn convert_ulong2_rtp(half2);\012ulong2 __ovld __cnfn convert_ulong2_rtn(half2);\012ulong2 __ovld __cnfn convert_ulong2_rtz(half2);\012ulong2 __ovld __cnfn convert_ulong2_sat(half2);\012ulong2 __ovld __cnfn convert_ulong2_sat_rte(half2);\012ulong2 __ovld __cnfn convert_ulong2_sat_rtp(half2);\012ulong2 __ovld __cnfn convert_ulong2_sat_rtn(half2);\012ulong2 __ovld __cnfn convert_ulong2_sat_rtz(half2);\012ulong3 __ovld __cnfn convert_ulong3(half3);\012ulong3 __ovld __cnfn convert_ulong3_rte(half3);\012ulong3 __ovld __cnfn convert_ulong3_rtp(half3);\012ulong3 __ovld __cnfn convert_ulong3_rtn(half3);\012ulong3 __ovld __cnfn convert_ulong3_rtz(half3);\012ulong3 __ovld __cnfn convert_ulong3_sat(half3);\012ulong3 __ovld __cnfn convert_ulong3_sat_rte(half3);\012ulong3 __ovld __cnfn convert_ulong3_sat_rtp(half3);\012ulong3 __ovld __cnfn convert_ulong3_sat_rtn(half3);\012ulong3 __ovld __cnfn convert_ulong3_sat_rtz(half3);\012ulong4 __ovld __cnfn convert_ulong4(half4);\012ulong4 __ovld __cnfn convert_ulong4_rte(half4);\012ulong4 __",
"ovld __cnfn convert_ulong4_rtp(half4);\012ulong4 __ovld __cnfn convert_ulong4_rtn(half4);\012ulong4 __ovld __cnfn convert_ulong4_rtz(half4);\012ulong4 __ovld __cnfn convert_ulong4_sat(half4);\012ulong4 __ovld __cnfn convert_ulong4_sat_rte(half4);\012ulong4 __ovld __cnfn convert_ulong4_sat_rtp(half4);\012ulong4 __ovld __cnfn convert_ulong4_sat_rtn(half4);\012ulong4 __ovld __cnfn convert_ulong4_sat_rtz(half4);\012ulong8 __ovld __cnfn convert_ulong8(half8);\012ulong8 __ovld __cnfn convert_ulong8_rte(half8);\012ulong8 __ovld __cnfn convert_ulong8_rtp(half8);\012ulong8 __ovld __cnfn convert_ulong8_rtn(half8);\012ulong8 __ovld __cnfn convert_ulong8_rtz(half8);\012ulong8 __ovld __cnfn convert_ulong8_sat(half8);\012ulong8 __ovld __cnfn convert_ulong8_sat_rte(half8);\012ulong8 __ovld __cnfn convert_ulong8_sat_rtp(half8);\012ulong8 __ovld __cnfn convert_ulong8_sat_rtn(half8);\012ulong8 __ovld __cnfn convert_ulong8_sat_rtz(half8);\012ulong16 __ovld __cnfn convert_ulong16(half16);\012ulong16 __ovld __cnfn convert_ulong16_rte(half16);\012ulong16 __ovld __cnfn convert_ulong16_rtp(h",
"alf16);\012ulong16 __ovld __cnfn convert_ulong16_rtn(half16);\012ulong16 __ovld __cnfn convert_ulong16_rtz(half16);\012ulong16 __ovld __cnfn convert_ulong16_sat(half16);\012ulong16 __ovld __cnfn convert_ulong16_sat_rte(half16);\012ulong16 __ovld __cnfn convert_ulong16_sat_rtp(half16);\012ulong16 __ovld __cnfn convert_ulong16_sat_rtn(half16);\012ulong16 __ovld __cnfn convert_ulong16_sat_rtz(half16);\012char __ovld __cnfn convert_char(half);\012char __ovld __cnfn convert_char_rte(half);\012char __ovld __cnfn convert_char_rtp(half);\012char __ovld __cnfn convert_char_rtn(half);\012char __ovld __cnfn convert_char_rtz(half);\012char __ovld __cnfn convert_char_sat(half);\012char __ovld __cnfn convert_char_sat_rte(half);\012char __ovld __cnfn convert_char_sat_rtp(half);\012char __ovld __cnfn convert_char_sat_rtn(half);\012char __ovld __cnfn convert_char_sat_rtz(half);\012char2 __ovld __cnfn convert_char2(half2);\012char2 __ovld __cnfn convert_char2_rte(half2);\012char2 __ovld __cnfn convert_char2_rtp(half2);\012char2 __ovld __cnfn convert_char2_rtn(half2);\012char2 __ovld __cnfn c",
"onvert_char2_rtz(half2);\012char2 __ovld __cnfn convert_char2_sat(half2);\012char2 __ovld __cnfn convert_char2_sat_rte(half2);\012char2 __ovld __cnfn convert_char2_sat_rtp(half2);\012char2 __ovld __cnfn convert_char2_sat_rtn(half2);\012char2 __ovld __cnfn convert_char2_sat_rtz(half2);\012char3 __ovld __cnfn convert_char3(half3);\012char3 __ovld __cnfn convert_char3_rte(half3);\012char3 __ovld __cnfn convert_char3_rtp(half3);\012char3 __ovld __cnfn convert_char3_rtn(half3);\012char3 __ovld __cnfn convert_char3_rtz(half3);\012char3 __ovld __cnfn convert_char3_sat(half3);\012char3 __ovld __cnfn convert_char3_sat_rte(half3);\012char3 __ovld __cnfn convert_char3_sat_rtp(half3);\012char3 __ovld __cnfn convert_char3_sat_rtn(half3);\012char3 __ovld __cnfn convert_char3_sat_rtz(half3);\012char4 __ovld __cnfn convert_char4(half4);\012char4 __ovld __cnfn convert_char4_rte(half4);\012char4 __ovld __cnfn convert_char4_rtp(half4);\012char4 __ovld __cnfn convert_char4_rtn(half4);\012char4 __ovld __cnfn convert_char4_rtz(half4);\012char4 __ovld __cnfn convert_char4_sat(half4);\012char4 __o",
"vld __cnfn convert_char4_sat_rte(half4);\012char4 __ovld __cnfn convert_char4_sat_rtp(half4);\012char4 __ovld __cnfn convert_char4_sat_rtn(half4);\012char4 __ovld __cnfn convert_char4_sat_rtz(half4);\012char8 __ovld __cnfn convert_char8(half8);\012char8 __ovld __cnfn convert_char8_rte(half8);\012char8 __ovld __cnfn convert_char8_rtp(half8);\012char8 __ovld __cnfn convert_char8_rtn(half8);\012char8 __ovld __cnfn convert_char8_rtz(half8);\012char8 __ovld __cnfn convert_char8_sat(half8);\012char8 __ovld __cnfn convert_char8_sat_rte(half8);\012char8 __ovld __cnfn convert_char8_sat_rtp(half8);\012char8 __ovld __cnfn convert_char8_sat_rtn(half8);\012char8 __ovld __cnfn convert_char8_sat_rtz(half8);\012char16 __ovld __cnfn convert_char16(half16);\012char16 __ovld __cnfn convert_char16_rte(half16);\012char16 __ovld __cnfn convert_char16_rtp(half16);\012char16 __ovld __cnfn convert_char16_rtn(half16);\012char16 __ovld __cnfn convert_char16_rtz(half16);\012char16 __ovld __cnfn convert_char16_sat(half16);\012char16 __ovld __cnfn convert_char16_sat_rte(half16);\012char16 __ovld __cn",
"fn convert_char16_sat_rtp(half16);\012char16 __ovld __cnfn convert_char16_sat_rtn(half16);\012char16 __ovld __cnfn convert_char16_sat_rtz(half16);\012short __ovld __cnfn convert_short(half);\012short __ovld __cnfn convert_short_rte(half);\012short __ovld __cnfn convert_short_rtp(half);\012short __ovld __cnfn convert_short_rtn(half);\012short __ovld __cnfn convert_short_rtz(half);\012short __ovld __cnfn convert_short_sat(half);\012short __ovld __cnfn convert_short_sat_rte(half);\012short __ovld __cnfn convert_short_sat_rtp(half);\012short __ovld __cnfn convert_short_sat_rtn(half);\012short __ovld __cnfn convert_short_sat_rtz(half);\012short2 __ovld __cnfn convert_short2(half2);\012short2 __ovld __cnfn convert_short2_rte(half2);\012short2 __ovld __cnfn convert_short2_rtp(half2);\012short2 __ovld __cnfn convert_short2_rtn(half2);\012short2 __ovld __cnfn convert_short2_rtz(half2);\012short2 __ovld __cnfn convert_short2_sat(half2);\012short2 __ovld __cnfn convert_short2_sat_rte(half2);\012short2 __ovld __cnfn convert_short2_sat_rtp(half2);\012short2 __ovld __cnfn convert_shor",
"t2_sat_rtn(half2);\012short2 __ovld __cnfn convert_short2_sat_rtz(half2);\012short3 __ovld __cnfn convert_short3(half3);\012short3 __ovld __cnfn convert_short3_rte(half3);\012short3 __ovld __cnfn convert_short3_rtp(half3);\012short3 __ovld __cnfn convert_short3_rtn(half3);\012short3 __ovld __cnfn convert_short3_rtz(half3);\012short3 __ovld __cnfn convert_short3_sat(half3);\012short3 __ovld __cnfn convert_short3_sat_rte(half3);\012short3 __ovld __cnfn convert_short3_sat_rtp(half3);\012short3 __ovld __cnfn convert_short3_sat_rtn(half3);\012short3 __ovld __cnfn convert_short3_sat_rtz(half3);\012short4 __ovld __cnfn convert_short4(half4);\012short4 __ovld __cnfn convert_short4_rte(half4);\012short4 __ovld __cnfn convert_short4_rtp(half4);\012short4 __ovld __cnfn convert_short4_rtn(half4);\012short4 __ovld __cnfn convert_short4_rtz(half4);\012short4 __ovld __cnfn convert_short4_sat(half4);\012short4 __ovld __cnfn convert_short4_sat_rte(half4);\012short4 __ovld __cnfn convert_short4_sat_rtp(half4);\012short4 __ovld __cnfn convert_short4_sat_rtn(half4);\012short4 __ovld __cnfn ",
"convert_short4_sat_rtz(half4);\012short8 __ovld __cnfn convert_short8(half8);\012short8 __ovld __cnfn convert_short8_rte(half8);\012short8 __ovld __cnfn convert_short8_rtp(half8);\012short8 __ovld __cnfn convert_short8_rtn(half8);\012short8 __ovld __cnfn convert_short8_rtz(half8);\012short8 __ovld __cnfn convert_short8_sat(half8);\012short8 __ovld __cnfn convert_short8_sat_rte(half8);\012short8 __ovld __cnfn convert_short8_sat_rtp(half8);\012short8 __ovld __cnfn convert_short8_sat_rtn(half8);\012short8 __ovld __cnfn convert_short8_sat_rtz(half8);\012short16 __ovld __cnfn convert_short16(half16);\012short16 __ovld __cnfn convert_short16_rte(half16);\012short16 __ovld __cnfn convert_short16_rtp(half16);\012short16 __ovld __cnfn convert_short16_rtn(half16);\012short16 __ovld __cnfn convert_short16_rtz(half16);\012short16 __ovld __cnfn convert_short16_sat(half16);\012short16 __ovld __cnfn convert_short16_sat_rte(half16);\012short16 __ovld __cnfn convert_short16_sat_rtp(half16);\012short16 __ovld __cnfn convert_short16_sat_rtn(half16);\012short16 __ovld __cnfn convert_shor",
"t16_sat_rtz(half16);\012int __ovld __cnfn convert_int(half);\012int __ovld __cnfn convert_int_rte(half);\012int __ovld __cnfn convert_int_rtp(half);\012int __ovld __cnfn convert_int_rtn(half);\012int __ovld __cnfn convert_int_rtz(half);\012int __ovld __cnfn convert_int_sat(half);\012int __ovld __cnfn convert_int_sat_rte(half);\012int __ovld __cnfn convert_int_sat_rtp(half);\012int __ovld __cnfn convert_int_sat_rtn(half);\012int __ovld __cnfn convert_int_sat_rtz(half);\012int2 __ovld __cnfn convert_int2(half2);\012int2 __ovld __cnfn convert_int2_rte(half2);\012int2 __ovld __cnfn convert_int2_rtp(half2);\012int2 __ovld __cnfn convert_int2_rtn(half2);\012int2 __ovld __cnfn convert_int2_rtz(half2);\012int2 __ovld __cnfn convert_int2_sat(half2);\012int2 __ovld __cnfn convert_int2_sat_rte(half2);\012int2 __ovld __cnfn convert_int2_sat_rtp(half2);\012int2 __ovld __cnfn convert_int2_sat_rtn(half2);\012int2 __ovld __cnfn convert_int2_sat_rtz(half2);\012int3 __ovld __cnfn convert_int3(half3);\012int3 __ovld __cnfn convert_int3_rte(half3);\012int3 __ovld __cnfn convert_int3_rtp(half3);\012i",
"nt3 __ovld __cnfn convert_int3_rtn(half3);\012int3 __ovld __cnfn convert_int3_rtz(half3);\012int3 __ovld __cnfn convert_int3_sat(half3);\012int3 __ovld __cnfn convert_int3_sat_rte(half3);\012int3 __ovld __cnfn convert_int3_sat_rtp(half3);\012int3 __ovld __cnfn convert_int3_sat_rtn(half3);\012int3 __ovld __cnfn convert_int3_sat_rtz(half3);\012int4 __ovld __cnfn convert_int4(half4);\012int4 __ovld __cnfn convert_int4_rte(half4);\012int4 __ovld __cnfn convert_int4_rtp(half4);\012int4 __ovld __cnfn convert_int4_rtn(half4);\012int4 __ovld __cnfn convert_int4_rtz(half4);\012int4 __ovld __cnfn convert_int4_sat(half4);\012int4 __ovld __cnfn convert_int4_sat_rte(half4);\012int4 __ovld __cnfn convert_int4_sat_rtp(half4);\012int4 __ovld __cnfn convert_int4_sat_rtn(half4);\012int4 __ovld __cnfn convert_int4_sat_rtz(half4);\012int8 __ovld __cnfn convert_int8(half8);\012int8 __ovld __cnfn convert_int8_rte(half8);\012int8 __ovld __cnfn convert_int8_rtp(half8);\012int8 __ovld __cnfn convert_int8_rtn(half8);\012int8 __ovld __cnfn convert_int8_rtz(half8);\012int8 __ovld __cnfn convert_int8_s",
"at(half8);\012int8 __ovld __cnfn convert_int8_sat_rte(half8);\012int8 __ovld __cnfn convert_int8_sat_rtp(half8);\012int8 __ovld __cnfn convert_int8_sat_rtn(half8);\012int8 __ovld __cnfn convert_int8_sat_rtz(half8);\012int16 __ovld __cnfn convert_int16(half16);\012int16 __ovld __cnfn convert_int16_rte(half16);\012int16 __ovld __cnfn convert_int16_rtp(half16);\012int16 __ovld __cnfn convert_int16_rtn(half16);\012int16 __ovld __cnfn convert_int16_rtz(half16);\012int16 __ovld __cnfn convert_int16_sat(half16);\012int16 __ovld __cnfn convert_int16_sat_rte(half16);\012int16 __ovld __cnfn convert_int16_sat_rtp(half16);\012int16 __ovld __cnfn convert_int16_sat_rtn(half16);\012int16 __ovld __cnfn convert_int16_sat_rtz(half16);\012long __ovld __cnfn convert_long(half);\012long __ovld __cnfn convert_long_rte(half);\012long __ovld __cnfn convert_long_rtp(half);\012long __ovld __cnfn convert_long_rtn(half);\012long __ovld __cnfn convert_long_rtz(half);\012long __ovld __cnfn convert_long_sat(half);\012long __ovld __cnfn convert_long_sat_rte(half);\012long __ovld __cnfn convert_long_sat_rt",
"p(half);\012long __ovld __cnfn convert_long_sat_rtn(half);\012long __ovld __cnfn convert_long_sat_rtz(half);\012long2 __ovld __cnfn convert_long2(half2);\012long2 __ovld __cnfn convert_long2_rte(half2);\012long2 __ovld __cnfn convert_long2_rtp(half2);\012long2 __ovld __cnfn convert_long2_rtn(half2);\012long2 __ovld __cnfn convert_long2_rtz(half2);\012long2 __ovld __cnfn convert_long2_sat(half2);\012long2 __ovld __cnfn convert_long2_sat_rte(half2);\012long2 __ovld __cnfn convert_long2_sat_rtp(half2);\012long2 __ovld __cnfn convert_long2_sat_rtn(half2);\012long2 __ovld __cnfn convert_long2_sat_rtz(half2);\012long3 __ovld __cnfn convert_long3(half3);\012long3 __ovld __cnfn convert_long3_rte(half3);\012long3 __ovld __cnfn convert_long3_rtp(half3);\012long3 __ovld __cnfn convert_long3_rtn(half3);\012long3 __ovld __cnfn convert_long3_rtz(half3);\012long3 __ovld __cnfn convert_long3_sat(half3);\012long3 __ovld __cnfn convert_long3_sat_rte(half3);\012long3 __ovld __cnfn convert_long3_sat_rtp(half3);\012long3 __ovld __cnfn convert_long3_sat_rtn(half3);\012long3 __ovld __cnfn convert",
"_long3_sat_rtz(half3);\012long4 __ovld __cnfn convert_long4(half4);\012long4 __ovld __cnfn convert_long4_rte(half4);\012long4 __ovld __cnfn convert_long4_rtp(half4);\012long4 __ovld __cnfn convert_long4_rtn(half4);\012long4 __ovld __cnfn convert_long4_rtz(half4);\012long4 __ovld __cnfn convert_long4_sat(half4);\012long4 __ovld __cnfn convert_long4_sat_rte(half4);\012long4 __ovld __cnfn convert_long4_sat_rtp(half4);\012long4 __ovld __cnfn convert_long4_sat_rtn(half4);\012long4 __ovld __cnfn convert_long4_sat_rtz(half4);\012long8 __ovld __cnfn convert_long8(half8);\012long8 __ovld __cnfn convert_long8_rte(half8);\012long8 __ovld __cnfn convert_long8_rtp(half8);\012long8 __ovld __cnfn convert_long8_rtn(half8);\012long8 __ovld __cnfn convert_long8_rtz(half8);\012long8 __ovld __cnfn convert_long8_sat(half8);\012long8 __ovld __cnfn convert_long8_sat_rte(half8);\012long8 __ovld __cnfn convert_long8_sat_rtp(half8);\012long8 __ovld __cnfn convert_long8_sat_rtn(half8);\012long8 __ovld __cnfn convert_long8_sat_rtz(half8);\012long16 __ovld __cnfn convert_long16(half16);\012long16 __ovl",
"d __cnfn convert_long16_rte(half16);\012long16 __ovld __cnfn convert_long16_rtp(half16);\012long16 __ovld __cnfn convert_long16_rtn(half16);\012long16 __ovld __cnfn convert_long16_rtz(half16);\012long16 __ovld __cnfn convert_long16_sat(half16);\012long16 __ovld __cnfn convert_long16_sat_rte(half16);\012long16 __ovld __cnfn convert_long16_sat_rtp(half16);\012long16 __ovld __cnfn convert_long16_sat_rtn(half16);\012long16 __ovld __cnfn convert_long16_sat_rtz(half16);\012float __ovld __cnfn convert_float(half);\012float __ovld __cnfn convert_float_rte(half);\012float __ovld __cnfn convert_float_rtp(half);\012float __ovld __cnfn convert_float_rtn(half);\012float __ovld __cnfn convert_float_rtz(half);\012float2 __ovld __cnfn convert_float2(half2);\012float2 __ovld __cnfn convert_float2_rte(half2);\012float2 __ovld __cnfn convert_float2_rtp(half2);\012float2 __ovld __cnfn convert_float2_rtn(half2);\012float2 __ovld __cnfn convert_float2_rtz(half2);\012float3 __ovld __cnfn convert_float3(half3);\012float3 __ovld __cnfn convert_float3_rte(half3);\012float3 __ovld __cnfn convert_f",
"loat3_rtp(half3);\012float3 __ovld __cnfn convert_float3_rtn(half3);\012float3 __ovld __cnfn convert_float3_rtz(half3);\012float4 __ovld __cnfn convert_float4(half4);\012float4 __ovld __cnfn convert_float4_rte(half4);\012float4 __ovld __cnfn convert_float4_rtp(half4);\012float4 __ovld __cnfn convert_float4_rtn(half4);\012float4 __ovld __cnfn convert_float4_rtz(half4);\012float8 __ovld __cnfn convert_float8(half8);\012float8 __ovld __cnfn convert_float8_rte(half8);\012float8 __ovld __cnfn convert_float8_rtp(half8);\012float8 __ovld __cnfn convert_float8_rtn(half8);\012float8 __ovld __cnfn convert_float8_rtz(half8);\012float16 __ovld __cnfn convert_float16(half16);\012float16 __ovld __cnfn convert_float16_rte(half16);\012float16 __ovld __cnfn convert_float16_rtp(half16);\012float16 __ovld __cnfn convert_float16_rtn(half16);\012float16 __ovld __cnfn convert_float16_rtz(half16);\012\012// Convert non-double types to half types.\012half __ovld __cnfn convert_half(uchar);\012half __ovld __cnfn convert_half(ushort);\012half __ovld __cnfn convert_half(uint);\012half __ovld __cnfn conv",
"ert_half(ulong);\012half __ovld __cnfn convert_half(char);\012half __ovld __cnfn convert_half(short);\012half __ovld __cnfn convert_half(int);\012half __ovld __cnfn convert_half(long);\012half __ovld __cnfn convert_half(float);\012half __ovld __cnfn convert_half(half);\012half __ovld __cnfn convert_half_rte(uchar);\012half __ovld __cnfn convert_half_rte(ushort);\012half __ovld __cnfn convert_half_rte(uint);\012half __ovld __cnfn convert_half_rte(ulong);\012half __ovld __cnfn convert_half_rte(char);\012half __ovld __cnfn convert_half_rte(short);\012half __ovld __cnfn convert_half_rte(int);\012half __ovld __cnfn convert_half_rte(long);\012half __ovld __cnfn convert_half_rte(float);\012half __ovld __cnfn convert_half_rte(half);\012half __ovld __cnfn convert_half_rtp(uchar);\012half __ovld __cnfn convert_half_rtp(ushort);\012half __ovld __cnfn convert_half_rtp(uint);\012half __ovld __cnfn convert_half_rtp(ulong);\012half __ovld __cnfn convert_half_rtp(char);\012half __ovld __cnfn convert_half_rtp(short);\012half __ovld __cnfn convert_half_rtp(int);\012half __ovld __cnfn convert_half_",
"rtp(long);\012half __ovld __cnfn convert_half_rtp(float);\012half __ovld __cnfn convert_half_rtp(half);\012half __ovld __cnfn convert_half_rtn(uchar);\012half __ovld __cnfn convert_half_rtn(ushort);\012half __ovld __cnfn convert_half_rtn(uint);\012half __ovld __cnfn convert_half_rtn(ulong);\012half __ovld __cnfn convert_half_rtn(char);\012half __ovld __cnfn convert_half_rtn(short);\012half __ovld __cnfn convert_half_rtn(int);\012half __ovld __cnfn convert_half_rtn(long);\012half __ovld __cnfn convert_half_rtn(float);\012half __ovld __cnfn convert_half_rtn(half);\012half __ovld __cnfn convert_half_rtz(uchar);\012half __ovld __cnfn convert_half_rtz(ushort);\012half __ovld __cnfn convert_half_rtz(uint);\012half __ovld __cnfn convert_half_rtz(ulong);\012half __ovld __cnfn convert_half_rtz(char);\012half __ovld __cnfn convert_half_rtz(short);\012half __ovld __cnfn convert_half_rtz(int);\012half __ovld __cnfn convert_half_rtz(long);\012half __ovld __cnfn convert_half_rtz(float);\012half __ovld __cnfn convert_half_rtz(half);\012half2 __ovld __cnfn convert_half2(char2);\012half2 __ovld _",
"_cnfn convert_half2(uchar2);\012half2 __ovld __cnfn convert_half2(short2);\012half2 __ovld __cnfn convert_half2(ushort2);\012half2 __ovld __cnfn convert_half2(int2);\012half2 __ovld __cnfn convert_half2(uint2);\012half2 __ovld __cnfn convert_half2(long2);\012half2 __ovld __cnfn convert_half2(ulong2);\012half2 __ovld __cnfn convert_half2(float2);\012half2 __ovld __cnfn convert_half2(half2);\012half2 __ovld __cnfn convert_half2_rte(char2);\012half2 __ovld __cnfn convert_half2_rte(uchar2);\012half2 __ovld __cnfn convert_half2_rte(short2);\012half2 __ovld __cnfn convert_half2_rte(ushort2);\012half2 __ovld __cnfn convert_half2_rte(int2);\012half2 __ovld __cnfn convert_half2_rte(uint2);\012half2 __ovld __cnfn convert_half2_rte(long2);\012half2 __ovld __cnfn convert_half2_rte(ulong2);\012half2 __ovld __cnfn convert_half2_rte(float2);\012half2 __ovld __cnfn convert_half2_rte(half2);\012half2 __ovld __cnfn convert_half2_rtp(char2);\012half2 __ovld __cnfn convert_half2_rtp(uchar2);\012half2 __ovld __cnfn convert_half2_rtp(short2);\012half2 __ovld __cnfn convert_half2_rtp(ushort2);\012ha",
"lf2 __ovld __cnfn convert_half2_rtp(int2);\012half2 __ovld __cnfn convert_half2_rtp(uint2);\012half2 __ovld __cnfn convert_half2_rtp(long2);\012half2 __ovld __cnfn convert_half2_rtp(ulong2);\012half2 __ovld __cnfn convert_half2_rtp(float2);\012half2 __ovld __cnfn convert_half2_rtp(half2);\012half2 __ovld __cnfn convert_half2_rtn(char2);\012half2 __ovld __cnfn convert_half2_rtn(uchar2);\012half2 __ovld __cnfn convert_half2_rtn(short2);\012half2 __ovld __cnfn convert_half2_rtn(ushort2);\012half2 __ovld __cnfn convert_half2_rtn(int2);\012half2 __ovld __cnfn convert_half2_rtn(uint2);\012half2 __ovld __cnfn convert_half2_rtn(long2);\012half2 __ovld __cnfn convert_half2_rtn(ulong2);\012half2 __ovld __cnfn convert_half2_rtn(float2);\012half2 __ovld __cnfn convert_half2_rtn(half2);\012half2 __ovld __cnfn convert_half2_rtz(char2);\012half2 __ovld __cnfn convert_half2_rtz(uchar2);\012half2 __ovld __cnfn convert_half2_rtz(short2);\012half2 __ovld __cnfn convert_half2_rtz(ushort2);\012half2 __ovld __cnfn convert_half2_rtz(int2);\012half2 __ovld __cnfn convert_half2_rtz(uint2);\012half2",
" __ovld __cnfn convert_half2_rtz(long2);\012half2 __ovld __cnfn convert_half2_rtz(ulong2);\012half2 __ovld __cnfn convert_half2_rtz(float2);\012half2 __ovld __cnfn convert_half2_rtz(half2);\012half3 __ovld __cnfn convert_half3(char3);\012half3 __ovld __cnfn convert_half3(uchar3);\012half3 __ovld __cnfn convert_half3(short3);\012half3 __ovld __cnfn convert_half3(ushort3);\012half3 __ovld __cnfn convert_half3(int3);\012half3 __ovld __cnfn convert_half3(uint3);\012half3 __ovld __cnfn convert_half3(long3);\012half3 __ovld __cnfn convert_half3(ulong3);\012half3 __ovld __cnfn convert_half3(float3);\012half3 __ovld __cnfn convert_half3(half3);\012half3 __ovld __cnfn convert_half3_rte(char3);\012half3 __ovld __cnfn convert_half3_rte(uchar3);\012half3 __ovld __cnfn convert_half3_rte(short3);\012half3 __ovld __cnfn convert_half3_rte(ushort3);\012half3 __ovld __cnfn convert_half3_rte(int3);\012half3 __ovld __cnfn convert_half3_rte(uint3);\012half3 __ovld __cnfn convert_half3_rte(long3);\012half3 __ovld __cnfn convert_half3_rte(ulong3);\012half3 __ovld __cnfn convert_half3_rte(float3);",
"\012half3 __ovld __cnfn convert_half3_rte(half3);\012half3 __ovld __cnfn convert_half3_rtp(char3);\012half3 __ovld __cnfn convert_half3_rtp(uchar3);\012half3 __ovld __cnfn convert_half3_rtp(short3);\012half3 __ovld __cnfn convert_half3_rtp(ushort3);\012half3 __ovld __cnfn convert_half3_rtp(int3);\012half3 __ovld __cnfn convert_half3_rtp(uint3);\012half3 __ovld __cnfn convert_half3_rtp(long3);\012half3 __ovld __cnfn convert_half3_rtp(ulong3);\012half3 __ovld __cnfn convert_half3_rtp(float3);\012half3 __ovld __cnfn convert_half3_rtp(half3);\012half3 __ovld __cnfn convert_half3_rtn(char3);\012half3 __ovld __cnfn convert_half3_rtn(uchar3);\012half3 __ovld __cnfn convert_half3_rtn(short3);\012half3 __ovld __cnfn convert_half3_rtn(ushort3);\012half3 __ovld __cnfn convert_half3_rtn(int3);\012half3 __ovld __cnfn convert_half3_rtn(uint3);\012half3 __ovld __cnfn convert_half3_rtn(long3);\012half3 __ovld __cnfn convert_half3_rtn(ulong3);\012half3 __ovld __cnfn convert_half3_rtn(float3);\012half3 __ovld __cnfn convert_half3_rtn(half3);\012half3 __ovld __cnfn convert_half3_rtz(char3);\012h",
"alf3 __ovld __cnfn convert_half3_rtz(uchar3);\012half3 __ovld __cnfn convert_half3_rtz(short3);\012half3 __ovld __cnfn convert_half3_rtz(ushort3);\012half3 __ovld __cnfn convert_half3_rtz(int3);\012half3 __ovld __cnfn convert_half3_rtz(uint3);\012half3 __ovld __cnfn convert_half3_rtz(long3);\012half3 __ovld __cnfn convert_half3_rtz(ulong3);\012half3 __ovld __cnfn convert_half3_rtz(float3);\012half3 __ovld __cnfn convert_half3_rtz(half3);\012half4 __ovld __cnfn convert_half4(char4);\012half4 __ovld __cnfn convert_half4(uchar4);\012half4 __ovld __cnfn convert_half4(short4);\012half4 __ovld __cnfn convert_half4(ushort4);\012half4 __ovld __cnfn convert_half4(int4);\012half4 __ovld __cnfn convert_half4(uint4);\012half4 __ovld __cnfn convert_half4(long4);\012half4 __ovld __cnfn convert_half4(ulong4);\012half4 __ovld __cnfn convert_half4(float4);\012half4 __ovld __cnfn convert_half4(half4);\012half4 __ovld __cnfn convert_half4_rte(char4);\012half4 __ovld __cnfn convert_half4_rte(uchar4);\012half4 __ovld __cnfn convert_half4_rte(short4);\012half4 __ovld __cnfn convert_half4_rte(ush",
"ort4);\012half4 __ovld __cnfn convert_half4_rte(int4);\012half4 __ovld __cnfn convert_half4_rte(uint4);\012half4 __ovld __cnfn convert_half4_rte(long4);\012half4 __ovld __cnfn convert_half4_rte(ulong4);\012half4 __ovld __cnfn convert_half4_rte(float4);\012half4 __ovld __cnfn convert_half4_rte(half4);\012half4 __ovld __cnfn convert_half4_rtp(char4);\012half4 __ovld __cnfn convert_half4_rtp(uchar4);\012half4 __ovld __cnfn convert_half4_rtp(short4);\012half4 __ovld __cnfn convert_half4_rtp(ushort4);\012half4 __ovld __cnfn convert_half4_rtp(int4);\012half4 __ovld __cnfn convert_half4_rtp(uint4);\012half4 __ovld __cnfn convert_half4_rtp(long4);\012half4 __ovld __cnfn convert_half4_rtp(ulong4);\012half4 __ovld __cnfn convert_half4_rtp(float4);\012half4 __ovld __cnfn convert_half4_rtp(half4);\012half4 __ovld __cnfn convert_half4_rtn(char4);\012half4 __ovld __cnfn convert_half4_rtn(uchar4);\012half4 __ovld __cnfn convert_half4_rtn(short4);\012half4 __ovld __cnfn convert_half4_rtn(ushort4);\012half4 __ovld __cnfn convert_half4_rtn(int4);\012half4 __ovld __cnfn convert_half4_rtn(uint",
"4);\012half4 __ovld __cnfn convert_half4_rtn(long4);\012half4 __ovld __cnfn convert_half4_rtn(ulong4);\012half4 __ovld __cnfn convert_half4_rtn(float4);\012half4 __ovld __cnfn convert_half4_rtn(half4);\012half4 __ovld __cnfn convert_half4_rtz(char4);\012half4 __ovld __cnfn convert_half4_rtz(uchar4);\012half4 __ovld __cnfn convert_half4_rtz(short4);\012half4 __ovld __cnfn convert_half4_rtz(ushort4);\012half4 __ovld __cnfn convert_half4_rtz(int4);\012half4 __ovld __cnfn convert_half4_rtz(uint4);\012half4 __ovld __cnfn convert_half4_rtz(long4);\012half4 __ovld __cnfn convert_half4_rtz(ulong4);\012half4 __ovld __cnfn convert_half4_rtz(float4);\012half4 __ovld __cnfn convert_half4_rtz(half4);\012half8 __ovld __cnfn convert_half8(char8);\012half8 __ovld __cnfn convert_half8(uchar8);\012half8 __ovld __cnfn convert_half8(short8);\012half8 __ovld __cnfn convert_half8(ushort8);\012half8 __ovld __cnfn convert_half8(int8);\012half8 __ovld __cnfn convert_half8(uint8);\012half8 __ovld __cnfn convert_half8(long8);\012half8 __ovld __cnfn convert_half8(ulong8);\012half8 __ovld __cnfn convert_h",
"alf8(float8);\012half8 __ovld __cnfn convert_half8(half8);\012half8 __ovld __cnfn convert_half8_rte(char8);\012half8 __ovld __cnfn convert_half8_rte(uchar8);\012half8 __ovld __cnfn convert_half8_rte(short8);\012half8 __ovld __cnfn convert_half8_rte(ushort8);\012half8 __ovld __cnfn convert_half8_rte(int8);\012half8 __ovld __cnfn convert_half8_rte(uint8);\012half8 __ovld __cnfn convert_half8_rte(long8);\012half8 __ovld __cnfn convert_half8_rte(ulong8);\012half8 __ovld __cnfn convert_half8_rte(float8);\012half8 __ovld __cnfn convert_half8_rte(half8);\012half8 __ovld __cnfn convert_half8_rtp(char8);\012half8 __ovld __cnfn convert_half8_rtp(uchar8);\012half8 __ovld __cnfn convert_half8_rtp(short8);\012half8 __ovld __cnfn convert_half8_rtp(ushort8);\012half8 __ovld __cnfn convert_half8_rtp(int8);\012half8 __ovld __cnfn convert_half8_rtp(uint8);\012half8 __ovld __cnfn convert_half8_rtp(long8);\012half8 __ovld __cnfn convert_half8_rtp(ulong8);\012half8 __ovld __cnfn convert_half8_rtp(float8);\012half8 __ovld __cnfn convert_half8_rtp(half8);\012half8 __ovld __cnfn convert_half8_rtn(",
"char8);\012half8 __ovld __cnfn convert_half8_rtn(uchar8);\012half8 __ovld __cnfn convert_half8_rtn(short8);\012half8 __ovld __cnfn convert_half8_rtn(ushort8);\012half8 __ovld __cnfn convert_half8_rtn(int8);\012half8 __ovld __cnfn convert_half8_rtn(uint8);\012half8 __ovld __cnfn convert_half8_rtn(long8);\012half8 __ovld __cnfn convert_half8_rtn(ulong8);\012half8 __ovld __cnfn convert_half8_rtn(float8);\012half8 __ovld __cnfn convert_half8_rtn(half8);\012half8 __ovld __cnfn convert_half8_rtz(char8);\012half8 __ovld __cnfn convert_half8_rtz(uchar8);\012half8 __ovld __cnfn convert_half8_rtz(short8);\012half8 __ovld __cnfn convert_half8_rtz(ushort8);\012half8 __ovld __cnfn convert_half8_rtz(int8);\012half8 __ovld __cnfn convert_half8_rtz(uint8);\012half8 __ovld __cnfn convert_half8_rtz(long8);\012half8 __ovld __cnfn convert_half8_rtz(ulong8);\012half8 __ovld __cnfn convert_half8_rtz(float8);\012half8 __ovld __cnfn convert_half8_rtz(half8);\012half16 __ovld __cnfn convert_half16(char16);\012half16 __ovld __cnfn convert_half16(uchar16);\012half16 __ovld __cnfn convert_half16(short",
"16);\012half16 __ovld __cnfn convert_half16(ushort16);\012half16 __ovld __cnfn convert_half16(int16);\012half16 __ovld __cnfn convert_half16(uint16);\012half16 __ovld __cnfn convert_half16(long16);\012half16 __ovld __cnfn convert_half16(ulong16);\012half16 __ovld __cnfn convert_half16(float16);\012half16 __ovld __cnfn convert_half16(half16);\012half16 __ovld __cnfn convert_half16_rte(char16);\012half16 __ovld __cnfn convert_half16_rte(uchar16);\012half16 __ovld __cnfn convert_half16_rte(short16);\012half16 __ovld __cnfn convert_half16_rte(ushort16);\012half16 __ovld __cnfn convert_half16_rte(int16);\012half16 __ovld __cnfn convert_half16_rte(uint16);\012half16 __ovld __cnfn convert_half16_rte(long16);\012half16 __ovld __cnfn convert_half16_rte(ulong16);\012half16 __ovld __cnfn convert_half16_rte(float16);\012half16 __ovld __cnfn convert_half16_rte(half16);\012half16 __ovld __cnfn convert_half16_rtp(char16);\012half16 __ovld __cnfn convert_half16_rtp(uchar16);\012half16 __ovld __cnfn convert_half16_rtp(short16);\012half16 __ovld __cnfn convert_half16_rtp(ushort16);\012half16",
" __ovld __cnfn convert_half16_rtp(int16);\012half16 __ovld __cnfn convert_half16_rtp(uint16);\012half16 __ovld __cnfn convert_half16_rtp(long16);\012half16 __ovld __cnfn convert_half16_rtp(ulong16);\012half16 __ovld __cnfn convert_half16_rtp(float16);\012half16 __ovld __cnfn convert_half16_rtp(half16);\012half16 __ovld __cnfn convert_half16_rtn(char16);\012half16 __ovld __cnfn convert_half16_rtn(uchar16);\012half16 __ovld __cnfn convert_half16_rtn(short16);\012half16 __ovld __cnfn convert_half16_rtn(ushort16);\012half16 __ovld __cnfn convert_half16_rtn(int16);\012half16 __ovld __cnfn convert_half16_rtn(uint16);\012half16 __ovld __cnfn convert_half16_rtn(long16);\012half16 __ovld __cnfn convert_half16_rtn(ulong16);\012half16 __ovld __cnfn convert_half16_rtn(float16);\012half16 __ovld __cnfn convert_half16_rtn(half16);\012half16 __ovld __cnfn convert_half16_rtz(char16);\012half16 __ovld __cnfn convert_half16_rtz(uchar16);\012half16 __ovld __cnfn convert_half16_rtz(short16);\012half16 __ovld __cnfn convert_half16_rtz(ushort16);\012half16 __ovld __cnfn convert_half16_rtz(",
"int16);\012half16 __ovld __cnfn convert_half16_rtz(uint16);\012half16 __ovld __cnfn convert_half16_rtz(long16);\012half16 __ovld __cnfn convert_half16_rtz(ulong16);\012half16 __ovld __cnfn convert_half16_rtz(float16);\012half16 __ovld __cnfn convert_half16_rtz(half16);\012\012// Convert half types to double types.\012#ifdef cl_khr_fp64\012double __ovld __cnfn convert_double(half);\012double __ovld __cnfn convert_double_rte(half);\012double __ovld __cnfn convert_double_rtp(half);\012double __ovld __cnfn convert_double_rtn(half);\012double __ovld __cnfn convert_double_rtz(half);\012double2 __ovld __cnfn convert_double2(half2);\012double2 __ovld __cnfn convert_double2_rte(half2);\012double2 __ovld __cnfn convert_double2_rtp(half2);\012double2 __ovld __cnfn convert_double2_rtn(half2);\012double2 __ovld __cnfn convert_double2_rtz(half2);\012double3 __ovld __cnfn convert_double3(half3);\012double3 __ovld __cnfn convert_double3_rte(half3);\012double3 __ovld __cnfn convert_double3_rtp(half3);\012double3 __ovld __cnfn convert_double3_rtn(half3);\012double3 __ovld __cnfn convert_double3",
"_rtz(half3);\012double4 __ovld __cnfn convert_double4(half4);\012double4 __ovld __cnfn convert_double4_rte(half4);\012double4 __ovld __cnfn convert_double4_rtp(half4);\012double4 __ovld __cnfn convert_double4_rtn(half4);\012double4 __ovld __cnfn convert_double4_rtz(half4);\012double8 __ovld __cnfn convert_double8(half8);\012double8 __ovld __cnfn convert_double8_rte(half8);\012double8 __ovld __cnfn convert_double8_rtp(half8);\012double8 __ovld __cnfn convert_double8_rtn(half8);\012double8 __ovld __cnfn convert_double8_rtz(half8);\012double16 __ovld __cnfn convert_double16(half16);\012double16 __ovld __cnfn convert_double16_rte(half16);\012double16 __ovld __cnfn convert_double16_rtp(half16);\012double16 __ovld __cnfn convert_double16_rtn(half16);\012double16 __ovld __cnfn convert_double16_rtz(half16);\012\012// Convert double types to half types.\012half __ovld __cnfn convert_half(double);\012half __ovld __cnfn convert_half_rte(double);\012half __ovld __cnfn convert_half_rtp(double);\012half __ovld __cnfn convert_half_rtn(double);\012half __ovld __cnfn convert_half_rtz(double",
");\012half2 __ovld __cnfn convert_half2(double2);\012half2 __ovld __cnfn convert_half2_rte(double2);\012half2 __ovld __cnfn convert_half2_rtp(double2);\012half2 __ovld __cnfn convert_half2_rtn(double2);\012half2 __ovld __cnfn convert_half2_rtz(double2);\012half3 __ovld __cnfn convert_half3(double3);\012half3 __ovld __cnfn convert_half3_rte(double3);\012half3 __ovld __cnfn convert_half3_rtp(double3);\012half3 __ovld __cnfn convert_half3_rtn(double3);\012half3 __ovld __cnfn convert_half3_rtz(double3);\012half4 __ovld __cnfn convert_half4(double4);\012half4 __ovld __cnfn convert_half4_rte(double4);\012half4 __ovld __cnfn convert_half4_rtp(double4);\012half4 __ovld __cnfn convert_half4_rtn(double4);\012half4 __ovld __cnfn convert_half4_rtz(double4);\012half8 __ovld __cnfn convert_half8(double8);\012half8 __ovld __cnfn convert_half8_rte(double8);\012half8 __ovld __cnfn convert_half8_rtp(double8);\012half8 __ovld __cnfn convert_half8_rtn(double8);\012half8 __ovld __cnfn convert_half8_rtz(double8);\012half16 __ovld __cnfn convert_half16(double16);\012half16 __ovld __cnfn convert_h",
"alf16_rte(double16);\012half16 __ovld __cnfn convert_half16_rtp(double16);\012half16 __ovld __cnfn convert_half16_rtn(double16);\012half16 __ovld __cnfn convert_half16_rtz(double16);\012#endif //cl_khr_fp64\012\012#endif // cl_khr_fp16\012\012/**\012 * OpenCL as_type operators\012 * Reinterprets a data type as another data type of the same size\012 */\012#define as_char(x) __builtin_astype((x), char)\012#define as_char2(x) __builtin_astype((x), char2)\012#define as_char3(x) __builtin_astype((x), char3)\012#define as_char4(x) __builtin_astype((x), char4)\012#define as_char8(x) __builtin_astype((x), char8)\012#define as_char16(x) __builtin_astype((x), char16)\012\012#define as_uchar(x) __builtin_astype((x), uchar)\012#define as_uchar2(x) __builtin_astype((x), uchar2)\012#define as_uchar3(x) __builtin_astype((x), uchar3)\012#define as_uchar4(x) __builtin_astype((x), uchar4)\012#define as_uchar8(x) __builtin_astype((x), uchar8)\012#define as_uchar16(x) __builtin_astype((x), uchar16)\012\012#define as_short(x) __builtin_astype((x), short)\012#define as_short2(x) __builtin_astype((x), short2)\012#",
"define as_short3(x) __builtin_astype((x), short3)\012#define as_short4(x) __builtin_astype((x), short4)\012#define as_short8(x) __builtin_astype((x), short8)\012#define as_short16(x) __builtin_astype((x), short16)\012\012#define as_ushort(x) __builtin_astype((x), ushort)\012#define as_ushort2(x) __builtin_astype((x), ushort2)\012#define as_ushort3(x) __builtin_astype((x), ushort3)\012#define as_ushort4(x) __builtin_astype((x), ushort4)\012#define as_ushort8(x) __builtin_astype((x), ushort8)\012#define as_ushort16(x) __builtin_astype((x), ushort16)\012\012#define as_int(x) __builtin_astype((x), int)\012#define as_int2(x) __builtin_astype((x), int2)\012#define as_int3(x) __builtin_astype((x), int3)\012#define as_int4(x) __builtin_astype((x), int4)\012#define as_int8(x) __builtin_astype((x), int8)\012#define as_int16(x) __builtin_astype((x), int16)\012\012#define as_uint(x) __builtin_astype((x), uint)\012#define as_uint2(x) __builtin_astype((x), uint2)\012#define as_uint3(x) __builtin_astype((x), uint3)\012#define as_uint4(x) __builtin_astype((x), uint4)\012#define as_uint8(x) __",
"builtin_astype((x), uint8)\012#define as_uint16(x) __builtin_astype((x), uint16)\012\012#define as_long(x) __builtin_astype((x), long)\012#define as_long2(x) __builtin_astype((x), long2)\012#define as_long3(x) __builtin_astype((x), long3)\012#define as_long4(x) __builtin_astype((x), long4)\012#define as_long8(x) __builtin_astype((x), long8)\012#define as_long16(x) __builtin_astype((x), long16)\012\012#define as_ulong(x) __builtin_astype((x), ulong)\012#define as_ulong2(x) __builtin_astype((x), ulong2)\012#define as_ulong3(x) __builtin_astype((x), ulong3)\012#define as_ulong4(x) __builtin_astype((x), ulong4)\012#define as_ulong8(x) __builtin_astype((x), ulong8)\012#define as_ulong16(x) __builtin_astype((x), ulong16)\012\012#define as_float(x) __builtin_astype((x), float)\012#define as_float2(x) __builtin_astype((x), float2)\012#define as_float3(x) __builtin_astype((x), float3)\012#define as_float4(x) __builtin_astype((x), float4)\012#define as_float8(x) __builtin_astype((x), float8)\012#define as_float16(x) __builtin_astype((x), float16)\012\012#define as_double(x) __builtin_astyp",
"e((x), double)\012#define as_double2(x) __builtin_astype((x), double2)\012#define as_double3(x) __builtin_astype((x), double3)\012#define as_double4(x) __builtin_astype((x), double4)\012#define as_double8(x) __builtin_astype((x), double8)\012#define as_double16(x) __builtin_astype((x), double16)\012\012#ifdef cl_khr_fp16\012#define as_half(x) __builtin_astype((x), half)\012#define as_half2(x) __builtin_astype((x), half2)\012#define as_half3(x) __builtin_astype((x), half3)\012#define as_half4(x) __builtin_astype((x), half4)\012#define as_half8(x) __builtin_astype((x), half8)\012#define as_half16(x) __builtin_astype((x), half16)\012#endif //cl_khr_fp16\012\012// OpenCL v1.1 s6.9, v1.2/2.0 s6.10 - Function qualifiers\012\012#define __kernel_exec(X, typen) __kernel \\\012\011__attribute__((work_group_size_hint(X, 1, 1))) \\\012\011__attribute__((vec_type_hint(typen)))\012\012#define kernel_exec(X, typen) __kernel \\\012\011__attribute__((work_group_size_hint(X, 1, 1))) \\\012\011__attribute__((vec_type_hint(typen)))\012\012// OpenCL v1.1 s6.11.1, v1.2 s6.12.1, v2.0 s6.13.1 - Work-item Functions\012\012/**\012 * Re",
"turns the number of dimensions in use. This is the\012 * value given to the work_dim argument specified in\012 * clEnqueueNDRangeKernel.\012 * For clEnqueueTask, this returns 1.\012 */\012uint __ovld __cnfn get_work_dim(void);\012\012// OpenCL v1.1 s6.11.2, v1.2 s6.12.2, v2.0 s6.13.2 - Math functions\012\012/**\012 * Arc cosine function.\012 */\012float __ovld __cnfn acos(float);\012float2 __ovld __cnfn acos(float2);\012float3 __ovld __cnfn acos(float3);\012float4 __ovld __cnfn acos(float4);\012float8 __ovld __cnfn acos(float8);\012float16 __ovld __cnfn acos(float16);\012#ifdef cl_khr_fp64\012double __ovld __cnfn acos(double);\012double2 __ovld __cnfn acos(double2);\012double3 __ovld __cnfn acos(double3);\012double4 __ovld __cnfn acos(double4);\012double8 __ovld __cnfn acos(double8);\012double16 __ovld __cnfn acos(double16);\012#endif //cl_khr_fp64\012#ifdef cl_khr_fp16\012half __ovld __cnfn acos(half);\012half2 __ovld __cnfn acos(half2);\012half3 __ovld __cnfn acos(half3);\012half4 __ovld __cnfn acos(half4);\012half8 __ovld __cnfn acos(half8);\012half16 __ovld __cnfn acos(half16);\012#endif //cl_khr_fp16\012",
"\012/**\012 * Inverse hyperbolic cosine.\012 */\012float __ovld __cnfn acosh(float);\012float2 __ovld __cnfn acosh(float2);\012float3 __ovld __cnfn acosh(float3);\012float4 __ovld __cnfn acosh(float4);\012float8 __ovld __cnfn acosh(float8);\012float16 __ovld __cnfn acosh(float16);\012#ifdef cl_khr_fp64\012double __ovld __cnfn acosh(double);\012double2 __ovld __cnfn acosh(double2);\012double3 __ovld __cnfn acosh(double3);\012double4 __ovld __cnfn acosh(double4);\012double8 __ovld __cnfn acosh(double8);\012double16 __ovld __cnfn acosh(double16);\012#endif //cl_khr_fp64\012#ifdef cl_khr_fp16\012half __ovld __cnfn acosh(half);\012half2 __ovld __cnfn acosh(half2);\012half3 __ovld __cnfn acosh(half3);\012half4 __ovld __cnfn acosh(half4);\012half8 __ovld __cnfn acosh(half8);\012half16 __ovld __cnfn acosh(half16);\012#endif //cl_khr_fp16\012\012/**\012 * Compute acos (x) / PI.\012 */\012float __ovld __cnfn acospi(float x);\012float2 __ovld __cnfn acospi(float2 x);\012float3 __ovld __cnfn acospi(float3 x);\012float4 __ovld __cnfn acospi(float4 x);\012float8 __ovld __cnfn acospi(float8 x);\012float16 __ovld __cnfn acospi(",
"float16 x);\012#ifdef cl_khr_fp64\012double __ovld __cnfn acospi(double x);\012double2 __ovld __cnfn acospi(double2 x);\012double3 __ovld __cnfn acospi(double3 x);\012double4 __ovld __cnfn acospi(double4 x);\012double8 __ovld __cnfn acospi(double8 x);\012double16 __ovld __cnfn acospi(double16 x);\012#endif //cl_khr_fp64\012#ifdef cl_khr_fp16\012half __ovld __cnfn acospi(half x);\012half2 __ovld __cnfn acospi(half2 x);\012half3 __ovld __cnfn acospi(half3 x);\012half4 __ovld __cnfn acospi(half4 x);\012half8 __ovld __cnfn acospi(half8 x);\012half16 __ovld __cnfn acospi(half16 x);\012#endif //cl_khr_fp16\012\012/**\012 * Arc sine function.\012 */\012float __ovld __cnfn asin(float);\012float2 __ovld __cnfn asin(float2);\012float3 __ovld __cnfn asin(float3);\012float4 __ovld __cnfn asin(float4);\012float8 __ovld __cnfn asin(float8);\012float16 __ovld __cnfn asin(float16);\012#ifdef cl_khr_fp64\012double __ovld __cnfn asin(double);\012double2 __ovld __cnfn asin(double2);\012double3 __ovld __cnfn asin(double3);\012double4 __ovld __cnfn asin(double4);\012double8 __ovld __cnfn asin(double8);\012double16 __ovld __cnf",
"n asin(double16);\012#endif //cl_khr_fp64\012#ifdef cl_khr_fp16\012half __ovld __cnfn asin(half);\012half2 __ovld __cnfn asin(half2);\012half3 __ovld __cnfn asin(half3);\012half4 __ovld __cnfn asin(half4);\012half8 __ovld __cnfn asin(half8);\012half16 __ovld __cnfn asin(half16);\012#endif //cl_khr_fp16\012\012/**\012 * Inverse hyperbolic sine.\012 */\012float __ovld __cnfn asinh(float);\012float2 __ovld __cnfn asinh(float2);\012float3 __ovld __cnfn asinh(float3);\012float4 __ovld __cnfn asinh(float4);\012float8 __ovld __cnfn asinh(float8);\012float16 __ovld __cnfn asinh(float16);\012#ifdef cl_khr_fp64\012double __ovld __cnfn asinh(double);\012double2 __ovld __cnfn asinh(double2);\012double3 __ovld __cnfn asinh(double3);\012double4 __ovld __cnfn asinh(double4);\012double8 __ovld __cnfn asinh(double8);\012double16 __ovld __cnfn asinh(double16);\012#endif //cl_khr_fp64\012#ifdef cl_khr_fp16\012half __ovld __cnfn asinh(half);\012half2 __ovld __cnfn asinh(half2);\012half3 __ovld __cnfn asinh(half3);\012half4 __ovld __cnfn asinh(half4);\012half8 __ovld __cnfn asinh(half8);\012half16 __ovld __cnfn asinh(half16);\012#en",
"dif //cl_khr_fp16\012\012/**\012 * Compute asin (x) / PI.\012 */\012float __ovld __cnfn asinpi(float x);\012float2 __ovld __cnfn asinpi(float2 x);\012float3 __ovld __cnfn asinpi(float3 x);\012float4 __ovld __cnfn asinpi(float4 x);\012float8 __ovld __cnfn asinpi(float8 x);\012float16 __ovld __cnfn asinpi(float16 x);\012#ifdef cl_khr_fp64\012double __ovld __cnfn asinpi(double x);\012double2 __ovld __cnfn asinpi(double2 x);\012double3 __ovld __cnfn asinpi(double3 x);\012double4 __ovld __cnfn asinpi(double4 x);\012double8 __ovld __cnfn asinpi(double8 x);\012double16 __ovld __cnfn asinpi(double16 x);\012#endif //cl_khr_fp64\012#ifdef cl_khr_fp16\012half __ovld __cnfn asinpi(half x);\012half2 __ovld __cnfn asinpi(half2 x);\012half3 __ovld __cnfn asinpi(half3 x);\012half4 __ovld __cnfn asinpi(half4 x);\012half8 __ovld __cnfn asinpi(half8 x);\012half16 __ovld __cnfn asinpi(half16 x);\012#endif //cl_khr_fp16\012\012/**\012 * Arc tangent function.\012 */\012float __ovld __cnfn atan(float y_over_x);\012float2 __ovld __cnfn atan(float2 y_over_x);\012float3 __ovld __cnfn atan(float3 y_over_x);\012float4 __ovld __cnfn atan",
"(float4 y_over_x);\012float8 __ovld __cnfn atan(float8 y_over_x);\012float16 __ovld __cnfn atan(float16 y_over_x);\012#ifdef cl_khr_fp64\012double __ovld __cnfn atan(double y_over_x);\012double2 __ovld __cnfn atan(double2 y_over_x);\012double3 __ovld __cnfn atan(double3 y_over_x);\012double4 __ovld __cnfn atan(double4 y_over_x);\012double8 __ovld __cnfn atan(double8 y_over_x);\012double16 __ovld __cnfn atan(double16 y_over_x);\012#endif //cl_khr_fp64\012#ifdef cl_khr_fp16\012half __ovld __cnfn atan(half y_over_x);\012half2 __ovld __cnfn atan(half2 y_over_x);\012half3 __ovld __cnfn atan(half3 y_over_x);\012half4 __ovld __cnfn atan(half4 y_over_x);\012half8 __ovld __cnfn atan(half8 y_over_x);\012half16 __ovld __cnfn atan(half16 y_over_x);\012#endif //cl_khr_fp16\012\012/**\012 * Arc tangent of y / x.\012 */\012float __ovld __cnfn atan2(float y, float x);\012float2 __ovld __cnfn atan2(float2 y, float2 x);\012float3 __ovld __cnfn atan2(float3 y, float3 x);\012float4 __ovld __cnfn atan2(float4 y, float4 x);\012float8 __ovld __cnfn atan2(float8 y, float8 x);\012float16 __ovld __cnfn atan2(float16 ",
"y, float16 x);\012#ifdef cl_khr_fp64\012double __ovld __cnfn atan2(double y, double x);\012double2 __ovld __cnfn atan2(double2 y, double2 x);\012double3 __ovld __cnfn atan2(double3 y, double3 x);\012double4 __ovld __cnfn atan2(double4 y, double4 x);\012double8 __ovld __cnfn atan2(double8 y, double8 x);\012double16 __ovld __cnfn atan2(double16 y, double16 x);\012#endif //cl_khr_fp64\012#ifdef cl_khr_fp16\012half __ovld __cnfn atan2(half y, half x);\012half2 __ovld __cnfn atan2(half2 y, half2 x);\012half3 __ovld __cnfn atan2(half3 y, half3 x);\012half4 __ovld __cnfn atan2(half4 y, half4 x);\012half8 __ovld __cnfn atan2(half8 y, half8 x);\012half16 __ovld __cnfn atan2(half16 y, half16 x);\012#endif //cl_khr_fp16\012\012/**\012 * Hyperbolic arc tangent.\012 */\012float __ovld __cnfn atanh(float);\012float2 __ovld __cnfn atanh(float2);\012float3 __ovld __cnfn atanh(float3);\012float4 __ovld __cnfn atanh(float4);\012float8 __ovld __cnfn atanh(float8);\012float16 __ovld __cnfn atanh(float16);\012#ifdef cl_khr_fp64\012double __ovld __cnfn atanh(double);\012double2 __ovld __cnfn atanh(double2);\012double3 ",
"__ovld __cnfn atanh(double3);\012double4 __ovld __cnfn atanh(double4);\012double8 __ovld __cnfn atanh(double8);\012double16 __ovld __cnfn atanh(double16);\012#endif //cl_khr_fp64\012#ifdef cl_khr_fp16\012half __ovld __cnfn atanh(half);\012half2 __ovld __cnfn atanh(half2);\012half3 __ovld __cnfn atanh(half3);\012half4 __ovld __cnfn atanh(half4);\012half8 __ovld __cnfn atanh(half8);\012half16 __ovld __cnfn atanh(half16);\012#endif //cl_khr_fp16\012\012/**\012 * Compute atan (x) / PI.\012 */\012float __ovld __cnfn atanpi(float x);\012float2 __ovld __cnfn atanpi(float2 x);\012float3 __ovld __cnfn atanpi(float3 x);\012float4 __ovld __cnfn atanpi(float4 x);\012float8 __ovld __cnfn atanpi(float8 x);\012float16 __ovld __cnfn atanpi(float16 x);\012#ifdef cl_khr_fp64\012double __ovld __cnfn atanpi(double x);\012double2 __ovld __cnfn atanpi(double2 x);\012double3 __ovld __cnfn atanpi(double3 x);\012double4 __ovld __cnfn atanpi(double4 x);\012double8 __ovld __cnfn atanpi(double8 x);\012double16 __ovld __cnfn atanpi(double16 x);\012#endif //cl_khr_fp64\012#ifdef cl_khr_fp16\012half __ovld __cnfn atanpi(half x);\012half",
"2 __ovld __cnfn atanpi(half2 x);\012half3 __ovld __cnfn atanpi(half3 x);\012half4 __ovld __cnfn atanpi(half4 x);\012half8 __ovld __cnfn atanpi(half8 x);\012half16 __ovld __cnfn atanpi(half16 x);\012#endif //cl_khr_fp16\012\012/**\012 * Compute atan2 (y, x) / PI.\012 */\012float __ovld __cnfn atan2pi(float y, float x);\012float2 __ovld __cnfn atan2pi(float2 y, float2 x);\012float3 __ovld __cnfn atan2pi(float3 y, float3 x);\012float4 __ovld __cnfn atan2pi(float4 y, float4 x);\012float8 __ovld __cnfn atan2pi(float8 y, float8 x);\012float16 __ovld __cnfn atan2pi(float16 y, float16 x);\012#ifdef cl_khr_fp64\012double __ovld __cnfn atan2pi(double y, double x);\012double2 __ovld __cnfn atan2pi(double2 y, double2 x);\012double3 __ovld __cnfn atan2pi(double3 y, double3 x);\012double4 __ovld __cnfn atan2pi(double4 y, double4 x);\012double8 __ovld __cnfn atan2pi(double8 y, double8 x);\012double16 __ovld __cnfn atan2pi(double16 y, double16 x);\012#endif //cl_khr_fp64\012#ifdef cl_khr_fp16\012half __ovld __cnfn atan2pi(half y, half x);\012half2 __ovld __cnfn atan2pi(half2 y, half2 x);\012half3 __ovld ",
"__cnfn atan2pi(half3 y, half3 x);\012half4 __ovld __cnfn atan2pi(half4 y, half4 x);\012half8 __ovld __cnfn atan2pi(half8 y, half8 x);\012half16 __ovld __cnfn atan2pi(half16 y, half16 x);\012#endif //cl_khr_fp16\012\012/**\012 * Compute cube-root.\012 */\012float __ovld __cnfn cbrt(float);\012float2 __ovld __cnfn cbrt(float2);\012float3 __ovld __cnfn cbrt(float3);\012float4 __ovld __cnfn cbrt(float4);\012float8 __ovld __cnfn cbrt(float8);\012float16 __ovld __cnfn cbrt(float16);\012#ifdef cl_khr_fp64\012double __ovld __cnfn cbrt(double);\012double2 __ovld __cnfn cbrt(double2);\012double3 __ovld __cnfn cbrt(double3);\012double4 __ovld __cnfn cbrt(double4);\012double8 __ovld __cnfn cbrt(double8);\012double16 __ovld __cnfn cbrt(double16);\012#endif //cl_khr_fp64\012#ifdef cl_khr_fp16\012half __ovld __cnfn cbrt(half);\012half2 __ovld __cnfn cbrt(half2);\012half3 __ovld __cnfn cbrt(half3);\012half4 __ovld __cnfn cbrt(half4);\012half8 __ovld __cnfn cbrt(half8);\012half16 __ovld __cnfn cbrt(half16);\012#endif //cl_khr_fp16\012\012/**\012 * Round to integral value using the round to positive\012 * infinity rounding mod",
"e.\012 */\012float __ovld __cnfn ceil(float);\012float2 __ovld __cnfn ceil(float2);\012float3 __ovld __cnfn ceil(float3);\012float4 __ovld __cnfn ceil(float4);\012float8 __ovld __cnfn ceil(float8);\012float16 __ovld __cnfn ceil(float16);\012#ifdef cl_khr_fp64\012double __ovld __cnfn ceil(double);\012double2 __ovld __cnfn ceil(double2);\012double3 __ovld __cnfn ceil(double3);\012double4 __ovld __cnfn ceil(double4);\012double8 __ovld __cnfn ceil(double8);\012double16 __ovld __cnfn ceil(double16);\012#endif //cl_khr_fp64\012#ifdef cl_khr_fp16\012half __ovld __cnfn ceil(half);\012half2 __ovld __cnfn ceil(half2);\012half3 __ovld __cnfn ceil(half3);\012half4 __ovld __cnfn ceil(half4);\012half8 __ovld __cnfn ceil(half8);\012half16 __ovld __cnfn ceil(half16);\012#endif //cl_khr_fp16\012\012/**\012 * Returns x with its sign changed to match the sign of y.\012 */\012float __ovld __cnfn copysign(float x, float y);\012float2 __ovld __cnfn copysign(float2 x, float2 y);\012float3 __ovld __cnfn copysign(float3 x, float3 y);\012float4 __ovld __cnfn copysign(float4 x, float4 y);\012float8 __ovld __cnfn copysign(float8 x",
", float8 y);\012float16 __ovld __cnfn copysign(float16 x, float16 y);\012#ifdef cl_khr_fp64\012double __ovld __cnfn copysign(double x, double y);\012double2 __ovld __cnfn copysign(double2 x, double2 y);\012double3 __ovld __cnfn copysign(double3 x, double3 y);\012double4 __ovld __cnfn copysign(double4 x, double4 y);\012double8 __ovld __cnfn copysign(double8 x, double8 y);\012double16 __ovld __cnfn copysign(double16 x, double16 y);\012#endif //cl_khr_fp64\012#ifdef cl_khr_fp16\012half __ovld __cnfn copysign(half x, half y);\012half2 __ovld __cnfn copysign(half2 x, half2 y);\012half3 __ovld __cnfn copysign(half3 x, half3 y);\012half4 __ovld __cnfn copysign(half4 x, half4 y);\012half8 __ovld __cnfn copysign(half8 x, half8 y);\012half16 __ovld __cnfn copysign(half16 x, half16 y);\012#endif //cl_khr_fp16\012\012/**\012 * Compute cosine.\012 */\012float __ovld __cnfn cos(float);\012float2 __ovld __cnfn cos(float2);\012float3 __ovld __cnfn cos(float3);\012float4 __ovld __cnfn cos(float4);\012float8 __ovld __cnfn cos(float8);\012float16 __ovld __cnfn cos(float16);\012#ifdef cl_khr_fp64\012double __ovld ",
"__cnfn cos(double);\012double2 __ovld __cnfn cos(double2);\012double3 __ovld __cnfn cos(double3);\012double4 __ovld __cnfn cos(double4);\012double8 __ovld __cnfn cos(double8);\012double16 __ovld __cnfn cos(double16);\012#endif //cl_khr_fp64\012#ifdef cl_khr_fp16\012half __ovld __cnfn cos(half);\012half2 __ovld __cnfn cos(half2);\012half3 __ovld __cnfn cos(half3);\012half4 __ovld __cnfn cos(half4);\012half8 __ovld __cnfn cos(half8);\012half16 __ovld __cnfn cos(half16);\012#endif //cl_khr_fp16\012\012/**\012 * Compute hyperbolic cosine.\012 */\012float __ovld __cnfn cosh(float);\012float2 __ovld __cnfn cosh(float2);\012float3 __ovld __cnfn cosh(float3);\012float4 __ovld __cnfn cosh(float4);\012float8 __ovld __cnfn cosh(float8);\012float16 __ovld __cnfn cosh(float16);\012#ifdef cl_khr_fp64\012double __ovld __cnfn cosh(double);\012double2 __ovld __cnfn cosh(double2);\012double3 __ovld __cnfn cosh(double3);\012double4 __ovld __cnfn cosh(double4);\012double8 __ovld __cnfn cosh(double8);\012double16 __ovld __cnfn cosh(double16);\012#endif //cl_khr_fp64\012#ifdef cl_khr_fp16\012half __ovld __cnfn cosh(half);\012half2 __",
"ovld __cnfn cosh(half2);\012half3 __ovld __cnfn cosh(half3);\012half4 __ovld __cnfn cosh(half4);\012half8 __ovld __cnfn cosh(half8);\012half16 __ovld __cnfn cosh(half16);\012#endif //cl_khr_fp16\012\012/**\012 * Compute cos (PI * x).\012 */\012float __ovld __cnfn cospi(float x);\012float2 __ovld __cnfn cospi(float2 x);\012float3 __ovld __cnfn cospi(float3 x);\012float4 __ovld __cnfn cospi(float4 x);\012float8 __ovld __cnfn cospi(float8 x);\012float16 __ovld __cnfn cospi(float16 x);\012#ifdef cl_khr_fp64\012double __ovld __cnfn cospi(double x);\012double2 __ovld __cnfn cospi(double2 x);\012double3 __ovld __cnfn cospi(double3 x);\012double4 __ovld __cnfn cospi(double4 x);\012double8 __ovld __cnfn cospi(double8 x);\012double16 __ovld __cnfn cospi(double16 x);\012#endif //cl_khr_fp64\012#ifdef cl_khr_fp16\012half __ovld __cnfn cospi(half x);\012half2 __ovld __cnfn cospi(half2 x);\012half3 __ovld __cnfn cospi(half3 x);\012half4 __ovld __cnfn cospi(half4 x);\012half8 __ovld __cnfn cospi(half8 x);\012half16 __ovld __cnfn cospi(half16 x);\012#endif //cl_khr_fp16\012\012/**\012 * Complementary error function.\012 */\012floa",
"t __ovld __cnfn erfc(float);\012float2 __ovld __cnfn erfc(float2);\012float3 __ovld __cnfn erfc(float3);\012float4 __ovld __cnfn erfc(float4);\012float8 __ovld __cnfn erfc(float8);\012float16 __ovld __cnfn erfc(float16);\012#ifdef cl_khr_fp64\012double __ovld __cnfn erfc(double);\012double2 __ovld __cnfn erfc(double2);\012double3 __ovld __cnfn erfc(double3);\012double4 __ovld __cnfn erfc(double4);\012double8 __ovld __cnfn erfc(double8);\012double16 __ovld __cnfn erfc(double16);\012#endif //cl_khr_fp64\012#ifdef cl_khr_fp16\012half __ovld __cnfn erfc(half);\012half2 __ovld __cnfn erfc(half2);\012half3 __ovld __cnfn erfc(half3);\012half4 __ovld __cnfn erfc(half4);\012half8 __ovld __cnfn erfc(half8);\012half16 __ovld __cnfn erfc(half16);\012#endif //cl_khr_fp16\012\012/**\012 * Error function encountered in integrating the\012 * normal distribution.\012 */\012float __ovld __cnfn erf(float);\012float2 __ovld __cnfn erf(float2);\012float3 __ovld __cnfn erf(float3);\012float4 __ovld __cnfn erf(float4);\012float8 __ovld __cnfn erf(float8);\012float16 __ovld __cnfn erf(float16);\012#ifdef cl_khr_fp64\012double __ovld",
" __cnfn erf(double);\012double2 __ovld __cnfn erf(double2);\012double3 __ovld __cnfn erf(double3);\012double4 __ovld __cnfn erf(double4);\012double8 __ovld __cnfn erf(double8);\012double16 __ovld __cnfn erf(double16);\012#endif //cl_khr_fp64\012#ifdef cl_khr_fp16\012half __ovld __cnfn erf(half);\012half2 __ovld __cnfn erf(half2);\012half3 __ovld __cnfn erf(half3);\012half4 __ovld __cnfn erf(half4);\012half8 __ovld __cnfn erf(half8);\012half16 __ovld __cnfn erf(half16);\012#endif //cl_khr_fp16\012\012/**\012 * Compute the base e exponential function of x.\012 */\012float __ovld __cnfn exp(float x);\012float2 __ovld __cnfn exp(float2 x);\012float3 __ovld __cnfn exp(float3 x);\012float4 __ovld __cnfn exp(float4 x);\012float8 __ovld __cnfn exp(float8 x);\012float16 __ovld __cnfn exp(float16 x);\012#ifdef cl_khr_fp64\012double __ovld __cnfn exp(double x);\012double2 __ovld __cnfn exp(double2 x);\012double3 __ovld __cnfn exp(double3 x);\012double4 __ovld __cnfn exp(double4 x);\012double8 __ovld __cnfn exp(double8 x);\012double16 __ovld __cnfn exp(double16 x);\012#endif //cl_khr_fp64\012#ifdef cl_khr_fp16\012half __",
"ovld __cnfn exp(half x);\012half2 __ovld __cnfn exp(half2 x);\012half3 __ovld __cnfn exp(half3 x);\012half4 __ovld __cnfn exp(half4 x);\012half8 __ovld __cnfn exp(half8 x);\012half16 __ovld __cnfn exp(half16 x);\012#endif //cl_khr_fp16\012\012/**\012 * Exponential base 2 function.\012 */\012float __ovld __cnfn exp2(float);\012float2 __ovld __cnfn exp2(float2);\012float3 __ovld __cnfn exp2(float3);\012float4 __ovld __cnfn exp2(float4);\012float8 __ovld __cnfn exp2(float8);\012float16 __ovld __cnfn exp2(float16);\012#ifdef cl_khr_fp64\012double __ovld __cnfn exp2(double);\012double2 __ovld __cnfn exp2(double2);\012double3 __ovld __cnfn exp2(double3);\012double4 __ovld __cnfn exp2(double4);\012double8 __ovld __cnfn exp2(double8);\012double16 __ovld __cnfn exp2(double16);\012#endif //cl_khr_fp64\012#ifdef cl_khr_fp16\012half __ovld __cnfn exp2(half);\012half2 __ovld __cnfn exp2(half2);\012half3 __ovld __cnfn exp2(half3);\012half4 __ovld __cnfn exp2(half4);\012half8 __ovld __cnfn exp2(half8);\012half16 __ovld __cnfn exp2(half16);\012#endif //cl_khr_fp16\012\012/**\012 * Exponential base 10 function.\012 */\012float __ovld ",
"__cnfn exp10(float);\012float2 __ovld __cnfn exp10(float2);\012float3 __ovld __cnfn exp10(float3);\012float4 __ovld __cnfn exp10(float4);\012float8 __ovld __cnfn exp10(float8);\012float16 __ovld __cnfn exp10(float16);\012#ifdef cl_khr_fp64\012double __ovld __cnfn exp10(double);\012double2 __ovld __cnfn exp10(double2);\012double3 __ovld __cnfn exp10(double3);\012double4 __ovld __cnfn exp10(double4);\012double8 __ovld __cnfn exp10(double8);\012double16 __ovld __cnfn exp10(double16);\012#endif //cl_khr_fp64\012#ifdef cl_khr_fp16\012half __ovld __cnfn exp10(half);\012half2 __ovld __cnfn exp10(half2);\012half3 __ovld __cnfn exp10(half3);\012half4 __ovld __cnfn exp10(half4);\012half8 __ovld __cnfn exp10(half8);\012half16 __ovld __cnfn exp10(half16);\012#endif //cl_khr_fp16\012\012/**\012 * Compute e^x- 1.0.\012 */\012float __ovld __cnfn expm1(float x);\012float2 __ovld __cnfn expm1(float2 x);\012float3 __ovld __cnfn expm1(float3 x);\012float4 __ovld __cnfn expm1(float4 x);\012float8 __ovld __cnfn expm1(float8 x);\012float16 __ovld __cnfn expm1(float16 x);\012#ifdef cl_khr_fp64\012double __ovld __cnfn expm1(doubl",
"e x);\012double2 __ovld __cnfn expm1(double2 x);\012double3 __ovld __cnfn expm1(double3 x);\012double4 __ovld __cnfn expm1(double4 x);\012double8 __ovld __cnfn expm1(double8 x);\012double16 __ovld __cnfn expm1(double16 x);\012#endif //cl_khr_fp64\012#ifdef cl_khr_fp16\012half __ovld __cnfn expm1(half x);\012half2 __ovld __cnfn expm1(half2 x);\012half3 __ovld __cnfn expm1(half3 x);\012half4 __ovld __cnfn expm1(half4 x);\012half8 __ovld __cnfn expm1(half8 x);\012half16 __ovld __cnfn expm1(half16 x);\012#endif //cl_khr_fp16\012\012/**\012 * Compute absolute value of a floating-point number.\012 */\012float __ovld __cnfn fabs(float);\012float2 __ovld __cnfn fabs(float2);\012float3 __ovld __cnfn fabs(float3);\012float4 __ovld __cnfn fabs(float4);\012float8 __ovld __cnfn fabs(float8);\012float16 __ovld __cnfn fabs(float16);\012#ifdef cl_khr_fp64\012double __ovld __cnfn fabs(double);\012double2 __ovld __cnfn fabs(double2);\012double3 __ovld __cnfn fabs(double3);\012double4 __ovld __cnfn fabs(double4);\012double8 __ovld __cnfn fabs(double8);\012double16 __ovld __cnfn fabs(double16);\012#endif //cl_khr_fp64\012#ifd",
"ef cl_khr_fp16\012half __ovld __cnfn fabs(half);\012half2 __ovld __cnfn fabs(half2);\012half3 __ovld __cnfn fabs(half3);\012half4 __ovld __cnfn fabs(half4);\012half8 __ovld __cnfn fabs(half8);\012half16 __ovld __cnfn fabs(half16);\012#endif //cl_khr_fp16\012\012/**\012 * x - y if x > y, +0 if x is less than or equal to y.\012 */\012float __ovld __cnfn fdim(float x, float y);\012float2 __ovld __cnfn fdim(float2 x, float2 y);\012float3 __ovld __cnfn fdim(float3 x, float3 y);\012float4 __ovld __cnfn fdim(float4 x, float4 y);\012float8 __ovld __cnfn fdim(float8 x, float8 y);\012float16 __ovld __cnfn fdim(float16 x, float16 y);\012#ifdef cl_khr_fp64\012double __ovld __cnfn fdim(double x, double y);\012double2 __ovld __cnfn fdim(double2 x, double2 y);\012double3 __ovld __cnfn fdim(double3 x, double3 y);\012double4 __ovld __cnfn fdim(double4 x, double4 y);\012double8 __ovld __cnfn fdim(double8 x, double8 y);\012double16 __ovld __cnfn fdim(double16 x, double16 y);\012#endif //cl_khr_fp64\012#ifdef cl_khr_fp16\012half __ovld __cnfn fdim(half x, half y);\012half2 __ovld __cnfn fdim(half2 x, half2 y);\012",
"half3 __ovld __cnfn fdim(half3 x, half3 y);\012half4 __ovld __cnfn fdim(half4 x, half4 y);\012half8 __ovld __cnfn fdim(half8 x, half8 y);\012half16 __ovld __cnfn fdim(half16 x, half16 y);\012#endif //cl_khr_fp16\012\012/**\012 * Round to integral value using the round to -ve\012 * infinity rounding mode.\012 */\012float __ovld __cnfn floor(float);\012float2 __ovld __cnfn floor(float2);\012float3 __ovld __cnfn floor(float3);\012float4 __ovld __cnfn floor(float4);\012float8 __ovld __cnfn floor(float8);\012float16 __ovld __cnfn floor(float16);\012#ifdef cl_khr_fp64\012double __ovld __cnfn floor(double);\012double2 __ovld __cnfn floor(double2);\012double3 __ovld __cnfn floor(double3);\012double4 __ovld __cnfn floor(double4);\012double8 __ovld __cnfn floor(double8);\012double16 __ovld __cnfn floor(double16);\012#endif //cl_khr_fp64\012#ifdef cl_khr_fp16\012half __ovld __cnfn floor(half);\012half2 __ovld __cnfn floor(half2);\012half3 __ovld __cnfn floor(half3);\012half4 __ovld __cnfn floor(half4);\012half8 __ovld __cnfn floor(half8);\012half16 __ovld __cnfn floor(half16);\012#endif //cl_khr_fp16\012\012/**\012 * Re",
"turns the correctly rounded floating-point\012 * representation of the sum of c with the infinitely\012 * precise product of a and b. Rounding of\012 * intermediate products shall not occur. Edge case\012 * behavior is per the IEEE 754-2008 standard.\012 */\012float __ovld __cnfn fma(float a, float b, float c);\012float2 __ovld __cnfn fma(float2 a, float2 b, float2 c);\012float3 __ovld __cnfn fma(float3 a, float3 b, float3 c);\012float4 __ovld __cnfn fma(float4 a, float4 b, float4 c);\012float8 __ovld __cnfn fma(float8 a, float8 b, float8 c);\012float16 __ovld __cnfn fma(float16 a, float16 b, float16 c);\012#ifdef cl_khr_fp64\012double __ovld __cnfn fma(double a, double b, double c);\012double2 __ovld __cnfn fma(double2 a, double2 b, double2 c);\012double3 __ovld __cnfn fma(double3 a, double3 b, double3 c);\012double4 __ovld __cnfn fma(double4 a, double4 b, double4 c);\012double8 __ovld __cnfn fma(double8 a, double8 b, double8 c);\012double16 __ovld __cnfn fma(double16 a, double16 b, double16 c);\012#endif //cl_khr_fp64\012#ifdef cl_khr_fp16\012half __ovld __cnfn fma(hal",
"f a, half b, half c);\012half2 __ovld __cnfn fma(half2 a, half2 b, half2 c);\012half3 __ovld __cnfn fma(half3 a, half3 b, half3 c);\012half4 __ovld __cnfn fma(half4 a, half4 b, half4 c);\012half8 __ovld __cnfn fma(half8 a, half8 b, half8 c);\012half16 __ovld __cnfn fma(half16 a, half16 b, half16 c);\012#endif //cl_khr_fp16\012\012/**\012 * Returns y if x < y, otherwise it returns x. If one\012 * argument is a NaN, fmax() returns the other\012 * argument. If both arguments are NaNs, fmax()\012 * returns a NaN.\012 */\012float __ovld __cnfn fmax(float x, float y);\012float2 __ovld __cnfn fmax(float2 x, float2 y);\012float3 __ovld __cnfn fmax(float3 x, float3 y);\012float4 __ovld __cnfn fmax(float4 x, float4 y);\012float8 __ovld __cnfn fmax(float8 x, float8 y);\012float16 __ovld __cnfn fmax(float16 x, float16 y);\012float2 __ovld __cnfn fmax(float2 x, float y);\012float3 __ovld __cnfn fmax(float3 x, float y);\012float4 __ovld __cnfn fmax(float4 x, float y);\012float8 __ovld __cnfn fmax(float8 x, float y);\012float16 __ovld __cnfn fmax(float16 x, float y);\012#ifdef cl_khr_fp64\012double _",
"_ovld __cnfn fmax(double x, double y);\012double2 __ovld __cnfn fmax(double2 x, double2 y);\012double3 __ovld __cnfn fmax(double3 x, double3 y);\012double4 __ovld __cnfn fmax(double4 x, double4 y);\012double8 __ovld __cnfn fmax(double8 x, double8 y);\012double16 __ovld __cnfn fmax(double16 x, double16 y);\012double2 __ovld __cnfn fmax(double2 x, double y);\012double3 __ovld __cnfn fmax(double3 x, double y);\012double4 __ovld __cnfn fmax(double4 x, double y);\012double8 __ovld __cnfn fmax(double8 x, double y);\012double16 __ovld __cnfn fmax(double16 x, double y);\012#endif //cl_khr_fp64\012#ifdef cl_khr_fp16\012half __ovld __cnfn fmax(half x, half y);\012half2 __ovld __cnfn fmax(half2 x, half2 y);\012half3 __ovld __cnfn fmax(half3 x, half3 y);\012half4 __ovld __cnfn fmax(half4 x, half4 y);\012half8 __ovld __cnfn fmax(half8 x, half8 y);\012half16 __ovld __cnfn fmax(half16 x, half16 y);\012half2 __ovld __cnfn fmax(half2 x, half y);\012half3 __ovld __cnfn fmax(half3 x, half y);\012half4 __ovld __cnfn fmax(half4 x, half y);\012half8 __ovld __cnfn fmax(half8 x, half y);\012half16 __",
"ovld __cnfn fmax(half16 x, half y);\012#endif //cl_khr_fp16\012\012/**\012 * Returns y if y < x, otherwise it returns x. If one\012 * argument is a NaN, fmin() returns the other\012 * argument. If both arguments are NaNs, fmin()\012 * returns a NaN.\012 */\012float __ovld __cnfn fmin(float x, float y);\012float2 __ovld __cnfn fmin(float2 x, float2 y);\012float3 __ovld __cnfn fmin(float3 x, float3 y);\012float4 __ovld __cnfn fmin(float4 x, float4 y);\012float8 __ovld __cnfn fmin(float8 x, float8 y);\012float16 __ovld __cnfn fmin(float16 x, float16 y);\012float2 __ovld __cnfn fmin(float2 x, float y);\012float3 __ovld __cnfn fmin(float3 x, float y);\012float4 __ovld __cnfn fmin(float4 x, float y);\012float8 __ovld __cnfn fmin(float8 x, float y);\012float16 __ovld __cnfn fmin(float16 x, float y);\012#ifdef cl_khr_fp64\012double __ovld __cnfn fmin(double x, double y);\012double2 __ovld __cnfn fmin(double2 x, double2 y);\012double3 __ovld __cnfn fmin(double3 x, double3 y);\012double4 __ovld __cnfn fmin(double4 x, double4 y);\012double8 __ovld __cnfn fmin(double8 x, double8 y);\012double16 __",
"ovld __cnfn fmin(double16 x, double16 y);\012double2 __ovld __cnfn fmin(double2 x, double y);\012double3 __ovld __cnfn fmin(double3 x, double y);\012double4 __ovld __cnfn fmin(double4 x, double y);\012double8 __ovld __cnfn fmin(double8 x, double y);\012double16 __ovld __cnfn fmin(double16 x, double y);\012#endif //cl_khr_fp64\012#ifdef cl_khr_fp16\012half __ovld __cnfn fmin(half x, half y);\012half2 __ovld __cnfn fmin(half2 x, half2 y);\012half3 __ovld __cnfn fmin(half3 x, half3 y);\012half4 __ovld __cnfn fmin(half4 x, half4 y);\012half8 __ovld __cnfn fmin(half8 x, half8 y);\012half16 __ovld __cnfn fmin(half16 x, half16 y);\012half2 __ovld __cnfn fmin(half2 x, half y);\012half3 __ovld __cnfn fmin(half3 x, half y);\012half4 __ovld __cnfn fmin(half4 x, half y);\012half8 __ovld __cnfn fmin(half8 x, half y);\012half16 __ovld __cnfn fmin(half16 x, half y);\012#endif //cl_khr_fp16\012\012/**\012 * Modulus. Returns x - y * trunc (x/y).\012 */\012float __ovld __cnfn fmod(float x, float y);\012float2 __ovld __cnfn fmod(float2 x, float2 y);\012float3 __ovld __cnfn fmod(float3 x, float3 y);\012float",
"4 __ovld __cnfn fmod(float4 x, float4 y);\012float8 __ovld __cnfn fmod(float8 x, float8 y);\012float16 __ovld __cnfn fmod(float16 x, float16 y);\012#ifdef cl_khr_fp64\012double __ovld __cnfn fmod(double x, double y);\012double2 __ovld __cnfn fmod(double2 x, double2 y);\012double3 __ovld __cnfn fmod(double3 x, double3 y);\012double4 __ovld __cnfn fmod(double4 x, double4 y);\012double8 __ovld __cnfn fmod(double8 x, double8 y);\012double16 __ovld __cnfn fmod(double16 x, double16 y);\012#endif //cl_khr_fp64\012#ifdef cl_khr_fp16\012half __ovld __cnfn fmod(half x, half y);\012half2 __ovld __cnfn fmod(half2 x, half2 y);\012half3 __ovld __cnfn fmod(half3 x, half3 y);\012half4 __ovld __cnfn fmod(half4 x, half4 y);\012half8 __ovld __cnfn fmod(half8 x, half8 y);\012half16 __ovld __cnfn fmod(half16 x, half16 y);\012#endif //cl_khr_fp16\012\012/**\012 * Compute the value of the square root of x^2 + y^2\012 * without undue overflow or underflow.\012 */\012float __ovld __cnfn hypot(float x, float y);\012float2 __ovld __cnfn hypot(float2 x, float2 y);\012float3 __ovld __cnfn hypot(float3 x, float3 y)",
";\012float4 __ovld __cnfn hypot(float4 x, float4 y);\012float8 __ovld __cnfn hypot(float8 x, float8 y);\012float16 __ovld __cnfn hypot(float16 x, float16 y);\012#ifdef cl_khr_fp64\012double __ovld __cnfn hypot(double x, double y);\012double2 __ovld __cnfn hypot(double2 x, double2 y);\012double3 __ovld __cnfn hypot(double3 x, double3 y);\012double4 __ovld __cnfn hypot(double4 x, double4 y);\012double8 __ovld __cnfn hypot(double8 x, double8 y);\012double16 __ovld __cnfn hypot(double16 x, double16 y);\012#endif //cl_khr_fp64\012#ifdef cl_khr_fp16\012half __ovld __cnfn hypot(half x, half y);\012half2 __ovld __cnfn hypot(half2 x, half2 y);\012half3 __ovld __cnfn hypot(half3 x, half3 y);\012half4 __ovld __cnfn hypot(half4 x, half4 y);\012half8 __ovld __cnfn hypot(half8 x, half8 y);\012half16 __ovld __cnfn hypot(half16 x, half16 y);\012#endif //cl_khr_fp16\012\012/**\012 * Return the exponent as an integer value.\012 */\012int __ovld __cnfn ilogb(float x);\012int2 __ovld __cnfn ilogb(float2 x);\012int3 __ovld __cnfn ilogb(float3 x);\012int4 __ovld __cnfn ilogb(float4 x);\012int8 __ovld __cnfn ilogb",
"(float8 x);\012int16 __ovld __cnfn ilogb(float16 x);\012#ifdef cl_khr_fp64\012int __ovld __cnfn ilogb(double x);\012int2 __ovld __cnfn ilogb(double2 x);\012int3 __ovld __cnfn ilogb(double3 x);\012int4 __ovld __cnfn ilogb(double4 x);\012int8 __ovld __cnfn ilogb(double8 x);\012int16 __ovld __cnfn ilogb(double16 x);\012#endif //cl_khr_fp64\012#ifdef cl_khr_fp16\012int __ovld __cnfn ilogb(half x);\012int2 __ovld __cnfn ilogb(half2 x);\012int3 __ovld __cnfn ilogb(half3 x);\012int4 __ovld __cnfn ilogb(half4 x);\012int8 __ovld __cnfn ilogb(half8 x);\012int16 __ovld __cnfn ilogb(half16 x);\012#endif //cl_khr_fp16\012\012/**\012 * Multiply x by 2 to the power n.\012 */\012float __ovld __cnfn ldexp(float x, int n);\012float2 __ovld __cnfn ldexp(float2 x, int2 n);\012float3 __ovld __cnfn ldexp(float3 x, int3 n);\012float4 __ovld __cnfn ldexp(float4 x, int4 n);\012float8 __ovld __cnfn ldexp(float8 x, int8 n);\012float16 __ovld __cnfn ldexp(float16 x, int16 n);\012float2 __ovld __cnfn ldexp(float2 x, int n);\012float3 __ovld __cnfn ldexp(float3 x, int n);\012float4 __ovld __cnfn ldexp(float4 x, int n);\012float8 ",
"__ovld __cnfn ldexp(float8 x, int n);\012float16 __ovld __cnfn ldexp(float16 x, int n);\012#ifdef cl_khr_fp64\012double __ovld __cnfn ldexp(double x, int n);\012double2 __ovld __cnfn ldexp(double2 x, int2 n);\012double3 __ovld __cnfn ldexp(double3 x, int3 n);\012double4 __ovld __cnfn ldexp(double4 x, int4 n);\012double8 __ovld __cnfn ldexp(double8 x, int8 n);\012double16 __ovld __cnfn ldexp(double16 x, int16 n);\012double2 __ovld __cnfn ldexp(double2 x, int n);\012double3 __ovld __cnfn ldexp(double3 x, int n);\012double4 __ovld __cnfn ldexp(double4 x, int n);\012double8 __ovld __cnfn ldexp(double8 x, int n);\012double16 __ovld __cnfn ldexp(double16 x, int n);\012#endif //cl_khr_fp64\012#ifdef cl_khr_fp16\012half __ovld __cnfn ldexp(half x, int n);\012half2 __ovld __cnfn ldexp(half2 x, int2 n);\012half3 __ovld __cnfn ldexp(half3 x, int3 n);\012half4 __ovld __cnfn ldexp(half4 x, int4 n);\012half8 __ovld __cnfn ldexp(half8 x, int8 n);\012half16 __ovld __cnfn ldexp(half16 x, int16 n);\012half2 __ovld __cnfn ldexp(half2 x, int n);\012half3 __ovld __cnfn ldexp(half3 x, int n);\012half4",
" __ovld __cnfn ldexp(half4 x, int n);\012half8 __ovld __cnfn ldexp(half8 x, int n);\012half16 __ovld __cnfn ldexp(half16 x, int n);\012#endif //cl_khr_fp16\012\012/**\012 * Log gamma function. Returns the natural\012 * logarithm of the absolute value of the gamma\012 * function. The sign of the gamma function is\012 * returned in the signp argument of lgamma_r.\012 */\012float __ovld __cnfn lgamma(float x);\012float2 __ovld __cnfn lgamma(float2 x);\012float3 __ovld __cnfn lgamma(float3 x);\012float4 __ovld __cnfn lgamma(float4 x);\012float8 __ovld __cnfn lgamma(float8 x);\012float16 __ovld __cnfn lgamma(float16 x);\012#ifdef cl_khr_fp64\012double __ovld __cnfn lgamma(double x);\012double2 __ovld __cnfn lgamma(double2 x);\012double3 __ovld __cnfn lgamma(double3 x);\012double4 __ovld __cnfn lgamma(double4 x);\012double8 __ovld __cnfn lgamma(double8 x);\012double16 __ovld __cnfn lgamma(double16 x);\012#endif //cl_khr_fp64\012#ifdef cl_khr_fp16\012half __ovld __cnfn lgamma(half x);\012half2 __ovld __cnfn lgamma(half2 x);\012half3 __ovld __cnfn lgamma(half3 x);\012half4 __ovld __cnfn lgamma(half4 x)",
";\012half8 __ovld __cnfn lgamma(half8 x);\012half16 __ovld __cnfn lgamma(half16 x);\012#endif //cl_khr_fp16\012\012/**\012 * Compute natural logarithm.\012 */\012float __ovld __cnfn log(float);\012float2 __ovld __cnfn log(float2);\012float3 __ovld __cnfn log(float3);\012float4 __ovld __cnfn log(float4);\012float8 __ovld __cnfn log(float8);\012float16 __ovld __cnfn log(float16);\012#ifdef cl_khr_fp64\012double __ovld __cnfn log(double);\012double2 __ovld __cnfn log(double2);\012double3 __ovld __cnfn log(double3);\012double4 __ovld __cnfn log(double4);\012double8 __ovld __cnfn log(double8);\012double16 __ovld __cnfn log(double16);\012#endif //cl_khr_fp64\012#ifdef cl_khr_fp16\012half __ovld __cnfn log(half);\012half2 __ovld __cnfn log(half2);\012half3 __ovld __cnfn log(half3);\012half4 __ovld __cnfn log(half4);\012half8 __ovld __cnfn log(half8);\012half16 __ovld __cnfn log(half16);\012#endif //cl_khr_fp16\012\012/**\012 * Compute a base 2 logarithm.\012 */\012float __ovld __cnfn log2(float);\012float2 __ovld __cnfn log2(float2);\012float3 __ovld __cnfn log2(float3);\012float4 __ovld __cnfn log2(float4);\012float8 __ovld __",
"cnfn log2(float8);\012float16 __ovld __cnfn log2(float16);\012#ifdef cl_khr_fp64\012double __ovld __cnfn log2(double);\012double2 __ovld __cnfn log2(double2);\012double3 __ovld __cnfn log2(double3);\012double4 __ovld __cnfn log2(double4);\012double8 __ovld __cnfn log2(double8);\012double16 __ovld __cnfn log2(double16);\012#endif //cl_khr_fp64\012#ifdef cl_khr_fp16\012half __ovld __cnfn log2(half);\012half2 __ovld __cnfn log2(half2);\012half3 __ovld __cnfn log2(half3);\012half4 __ovld __cnfn log2(half4);\012half8 __ovld __cnfn log2(half8);\012half16 __ovld __cnfn log2(half16);\012#endif //cl_khr_fp16\012\012/**\012 * Compute a base 10 logarithm.\012 */\012float __ovld __cnfn log10(float);\012float2 __ovld __cnfn log10(float2);\012float3 __ovld __cnfn log10(float3);\012float4 __ovld __cnfn log10(float4);\012float8 __ovld __cnfn log10(float8);\012float16 __ovld __cnfn log10(float16);\012#ifdef cl_khr_fp64\012double __ovld __cnfn log10(double);\012double2 __ovld __cnfn log10(double2);\012double3 __ovld __cnfn log10(double3);\012double4 __ovld __cnfn log10(double4);\012double8 __ovld __cnfn log10(double8);\012doub",
"le16 __ovld __cnfn log10(double16);\012#endif //cl_khr_fp64\012#ifdef cl_khr_fp16\012half __ovld __cnfn log10(half);\012half2 __ovld __cnfn log10(half2);\012half3 __ovld __cnfn log10(half3);\012half4 __ovld __cnfn log10(half4);\012half8 __ovld __cnfn log10(half8);\012half16 __ovld __cnfn log10(half16);\012#endif //cl_khr_fp16\012\012/**\012 * Compute a base e logarithm of (1.0 + x).\012 */\012float __ovld __cnfn log1p(float x);\012float2 __ovld __cnfn log1p(float2 x);\012float3 __ovld __cnfn log1p(float3 x);\012float4 __ovld __cnfn log1p(float4 x);\012float8 __ovld __cnfn log1p(float8 x);\012float16 __ovld __cnfn log1p(float16 x);\012#ifdef cl_khr_fp64\012double __ovld __cnfn log1p(double x);\012double2 __ovld __cnfn log1p(double2 x);\012double3 __ovld __cnfn log1p(double3 x);\012double4 __ovld __cnfn log1p(double4 x);\012double8 __ovld __cnfn log1p(double8 x);\012double16 __ovld __cnfn log1p(double16 x);\012#endif //cl_khr_fp64\012#ifdef cl_khr_fp16\012half __ovld __cnfn log1p(half x);\012half2 __ovld __cnfn log1p(half2 x);\012half3 __ovld __cnfn log1p(half3 x);\012half4 __ovld __cnfn log1p(half4 x);\012h",
"alf8 __ovld __cnfn log1p(half8 x);\012half16 __ovld __cnfn log1p(half16 x);\012#endif //cl_khr_fp16\012\012/**\012 * Compute the exponent of x, which is the integral\012 * part of logr | x |.\012 */\012float __ovld __cnfn logb(float x);\012float2 __ovld __cnfn logb(float2 x);\012float3 __ovld __cnfn logb(float3 x);\012float4 __ovld __cnfn logb(float4 x);\012float8 __ovld __cnfn logb(float8 x);\012float16 __ovld __cnfn logb(float16 x);\012#ifdef cl_khr_fp64\012double __ovld __cnfn logb(double x);\012double2 __ovld __cnfn logb(double2 x);\012double3 __ovld __cnfn logb(double3 x);\012double4 __ovld __cnfn logb(double4 x);\012double8 __ovld __cnfn logb(double8 x);\012double16 __ovld __cnfn logb(double16 x);\012#endif //cl_khr_fp64\012#ifdef cl_khr_fp16\012half __ovld __cnfn logb(half x);\012half2 __ovld __cnfn logb(half2 x);\012half3 __ovld __cnfn logb(half3 x);\012half4 __ovld __cnfn logb(half4 x);\012half8 __ovld __cnfn logb(half8 x);\012half16 __ovld __cnfn logb(half16 x);\012#endif //cl_khr_fp16\012\012/**\012 * mad approximates a * b + c. Whether or how the\012 * product of a * b is rounded and how supern",
"ormal or\012 * subnormal intermediate products are handled is not\012 * defined. mad is intended to be used where speed is\012 * preferred over accuracy.\012 */\012float __ovld __cnfn mad(float a, float b, float c);\012float2 __ovld __cnfn mad(float2 a, float2 b, float2 c);\012float3 __ovld __cnfn mad(float3 a, float3 b, float3 c);\012float4 __ovld __cnfn mad(float4 a, float4 b, float4 c);\012float8 __ovld __cnfn mad(float8 a, float8 b, float8 c);\012float16 __ovld __cnfn mad(float16 a, float16 b, float16 c);\012#ifdef cl_khr_fp64\012double __ovld __cnfn mad(double a, double b, double c);\012double2 __ovld __cnfn mad(double2 a, double2 b, double2 c);\012double3 __ovld __cnfn mad(double3 a, double3 b, double3 c);\012double4 __ovld __cnfn mad(double4 a, double4 b, double4 c);\012double8 __ovld __cnfn mad(double8 a, double8 b, double8 c);\012double16 __ovld __cnfn mad(double16 a, double16 b, double16 c);\012#endif //cl_khr_fp64\012#ifdef cl_khr_fp16\012half __ovld __cnfn mad(half a, half b, half c);\012half2 __ovld __cnfn mad(half2 a, half2 b, half2 c);\012half3 __ovld __cnfn ",
"mad(half3 a, half3 b, half3 c);\012half4 __ovld __cnfn mad(half4 a, half4 b, half4 c);\012half8 __ovld __cnfn mad(half8 a, half8 b, half8 c);\012half16 __ovld __cnfn mad(half16 a, half16 b, half16 c);\012#endif //cl_khr_fp16\012\012/**\012 * Returns x if | x | > | y |, y if | y | > | x |, otherwise\012 * fmax(x, y).\012 */\012float __ovld __cnfn maxmag(float x, float y);\012float2 __ovld __cnfn maxmag(float2 x, float2 y);\012float3 __ovld __cnfn maxmag(float3 x, float3 y);\012float4 __ovld __cnfn maxmag(float4 x, float4 y);\012float8 __ovld __cnfn maxmag(float8 x, float8 y);\012float16 __ovld __cnfn maxmag(float16 x, float16 y);\012#ifdef cl_khr_fp64\012double __ovld __cnfn maxmag(double x, double y);\012double2 __ovld __cnfn maxmag(double2 x, double2 y);\012double3 __ovld __cnfn maxmag(double3 x, double3 y);\012double4 __ovld __cnfn maxmag(double4 x, double4 y);\012double8 __ovld __cnfn maxmag(double8 x, double8 y);\012double16 __ovld __cnfn maxmag(double16 x, double16 y);\012#endif //cl_khr_fp64\012#ifdef cl_khr_fp16\012half __ovld __cnfn maxmag(half x, half y);\012half2 __ovld __cnf",
"n maxmag(half2 x, half2 y);\012half3 __ovld __cnfn maxmag(half3 x, half3 y);\012half4 __ovld __cnfn maxmag(half4 x, half4 y);\012half8 __ovld __cnfn maxmag(half8 x, half8 y);\012half16 __ovld __cnfn maxmag(half16 x, half16 y);\012#endif //cl_khr_fp16\012\012/**\012 * Returns x if | x | < | y |, y if | y | < | x |, otherwise\012 * fmin(x, y).\012 */\012float __ovld __cnfn minmag(float x, float y);\012float2 __ovld __cnfn minmag(float2 x, float2 y);\012float3 __ovld __cnfn minmag(float3 x, float3 y);\012float4 __ovld __cnfn minmag(float4 x, float4 y);\012float8 __ovld __cnfn minmag(float8 x, float8 y);\012float16 __ovld __cnfn minmag(float16 x, float16 y);\012#ifdef cl_khr_fp64\012double __ovld __cnfn minmag(double x, double y);\012double2 __ovld __cnfn minmag(double2 x, double2 y);\012double3 __ovld __cnfn minmag(double3 x, double3 y);\012double4 __ovld __cnfn minmag(double4 x, double4 y);\012double8 __ovld __cnfn minmag(double8 x, double8 y);\012double16 __ovld __cnfn minmag(double16 x, double16 y);\012#endif //cl_khr_fp64\012#ifdef cl_khr_fp16\012half __ovld __cnfn minmag(half x, half",
" y);\012half2 __ovld __cnfn minmag(half2 x, half2 y);\012half3 __ovld __cnfn minmag(half3 x, half3 y);\012half4 __ovld __cnfn minmag(half4 x, half4 y);\012half8 __ovld __cnfn minmag(half8 x, half8 y);\012half16 __ovld __cnfn minmag(half16 x, half16 y);\012#endif //cl_khr_fp16\012\012/**\012 * Returns a quiet NaN. The nancode may be placed\012 * in the significand of the resulting NaN.\012 */\012float __ovld __cnfn nan(uint nancode);\012float2 __ovld __cnfn nan(uint2 nancode);\012float3 __ovld __cnfn nan(uint3 nancode);\012float4 __ovld __cnfn nan(uint4 nancode);\012float8 __ovld __cnfn nan(uint8 nancode);\012float16 __ovld __cnfn nan(uint16 nancode);\012#ifdef cl_khr_fp64\012double __ovld __cnfn nan(ulong nancode);\012double2 __ovld __cnfn nan(ulong2 nancode);\012double3 __ovld __cnfn nan(ulong3 nancode);\012double4 __ovld __cnfn nan(ulong4 nancode);\012double8 __ovld __cnfn nan(ulong8 nancode);\012double16 __ovld __cnfn nan(ulong16 nancode);\012#endif //cl_khr_fp64\012#ifdef cl_khr_fp16\012half __ovld __cnfn nan(ushort nancode);\012half2 __ovld __cnfn nan(ushort2 nancode);\012half3 __ovld __cn",
"fn nan(ushort3 nancode);\012half4 __ovld __cnfn nan(ushort4 nancode);\012half8 __ovld __cnfn nan(ushort8 nancode);\012half16 __ovld __cnfn nan(ushort16 nancode);\012#endif //cl_khr_fp16\012\012/**\012 * Computes the next representable single-precision\012 * floating-point value following x in the direction of\012 * y. Thus, if y is less than x, nextafter() returns the\012 * largest representable floating-point number less\012 * than x.\012 */\012float __ovld __cnfn nextafter(float x, float y);\012float2 __ovld __cnfn nextafter(float2 x, float2 y);\012float3 __ovld __cnfn nextafter(float3 x, float3 y);\012float4 __ovld __cnfn nextafter(float4 x, float4 y);\012float8 __ovld __cnfn nextafter(float8 x, float8 y);\012float16 __ovld __cnfn nextafter(float16 x, float16 y);\012#ifdef cl_khr_fp64\012double __ovld __cnfn nextafter(double x, double y);\012double2 __ovld __cnfn nextafter(double2 x, double2 y);\012double3 __ovld __cnfn nextafter(double3 x, double3 y);\012double4 __ovld __cnfn nextafter(double4 x, double4 y);\012double8 __ovld __cnfn nextafter(double8 x, double8 y);\012double16 _",
"_ovld __cnfn nextafter(double16 x, double16 y);\012#endif //cl_khr_fp64\012#ifdef cl_khr_fp16\012half __ovld __cnfn nextafter(half x, half y);\012half2 __ovld __cnfn nextafter(half2 x, half2 y);\012half3 __ovld __cnfn nextafter(half3 x, half3 y);\012half4 __ovld __cnfn nextafter(half4 x, half4 y);\012half8 __ovld __cnfn nextafter(half8 x, half8 y);\012half16 __ovld __cnfn nextafter(half16 x, half16 y);\012#endif //cl_khr_fp16\012\012/**\012 * Compute x to the power y.\012 */\012float __ovld __cnfn pow(float x, float y);\012float2 __ovld __cnfn pow(float2 x, float2 y);\012float3 __ovld __cnfn pow(float3 x, float3 y);\012float4 __ovld __cnfn pow(float4 x, float4 y);\012float8 __ovld __cnfn pow(float8 x, float8 y);\012float16 __ovld __cnfn pow(float16 x, float16 y);\012#ifdef cl_khr_fp64\012double __ovld __cnfn pow(double x, double y);\012double2 __ovld __cnfn pow(double2 x, double2 y);\012double3 __ovld __cnfn pow(double3 x, double3 y);\012double4 __ovld __cnfn pow(double4 x, double4 y);\012double8 __ovld __cnfn pow(double8 x, double8 y);\012double16 __ovld __cnfn pow(double16 x, double1",
"6 y);\012#endif //cl_khr_fp64\012#ifdef cl_khr_fp16\012half __ovld __cnfn pow(half x, half y);\012half2 __ovld __cnfn pow(half2 x, half2 y);\012half3 __ovld __cnfn pow(half3 x, half3 y);\012half4 __ovld __cnfn pow(half4 x, half4 y);\012half8 __ovld __cnfn pow(half8 x, half8 y);\012half16 __ovld __cnfn pow(half16 x, half16 y);\012#endif //cl_khr_fp16\012\012/**\012 * Compute x to the power y, where y is an integer.\012 */\012float __ovld __cnfn pown(float x, int y);\012float2 __ovld __cnfn pown(float2 x, int2 y);\012float3 __ovld __cnfn pown(float3 x, int3 y);\012float4 __ovld __cnfn pown(float4 x, int4 y);\012float8 __ovld __cnfn pown(float8 x, int8 y);\012float16 __ovld __cnfn pown(float16 x, int16 y);\012#ifdef cl_khr_fp64\012double __ovld __cnfn pown(double x, int y);\012double2 __ovld __cnfn pown(double2 x, int2 y);\012double3 __ovld __cnfn pown(double3 x, int3 y);\012double4 __ovld __cnfn pown(double4 x, int4 y);\012double8 __ovld __cnfn pown(double8 x, int8 y);\012double16 __ovld __cnfn pown(double16 x, int16 y);\012#endif //cl_khr_fp64\012#ifdef cl_khr_fp16\012half __ovld __cnfn pown(hal",
"f x, int y);\012half2 __ovld __cnfn pown(half2 x, int2 y);\012half3 __ovld __cnfn pown(half3 x, int3 y);\012half4 __ovld __cnfn pown(half4 x, int4 y);\012half8 __ovld __cnfn pown(half8 x, int8 y);\012half16 __ovld __cnfn pown(half16 x, int16 y);\012#endif //cl_khr_fp16\012\012/**\012 * Compute x to the power y, where x is >= 0.\012 */\012float __ovld __cnfn powr(float x, float y);\012float2 __ovld __cnfn powr(float2 x, float2 y);\012float3 __ovld __cnfn powr(float3 x, float3 y);\012float4 __ovld __cnfn powr(float4 x, float4 y);\012float8 __ovld __cnfn powr(float8 x, float8 y);\012float16 __ovld __cnfn powr(float16 x, float16 y);\012#ifdef cl_khr_fp64\012double __ovld __cnfn powr(double x, double y);\012double2 __ovld __cnfn powr(double2 x, double2 y);\012double3 __ovld __cnfn powr(double3 x, double3 y);\012double4 __ovld __cnfn powr(double4 x, double4 y);\012double8 __ovld __cnfn powr(double8 x, double8 y);\012double16 __ovld __cnfn powr(double16 x, double16 y);\012#endif //cl_khr_fp64\012#ifdef cl_khr_fp16\012half __ovld __cnfn powr(half x, half y);\012half2 __ovld __cnfn powr(half2 x, h",
"alf2 y);\012half3 __ovld __cnfn powr(half3 x, half3 y);\012half4 __ovld __cnfn powr(half4 x, half4 y);\012half8 __ovld __cnfn powr(half8 x, half8 y);\012half16 __ovld __cnfn powr(half16 x, half16 y);\012#endif //cl_khr_fp16\012\012/**\012 * Compute the value r such that r = x - n*y, where n\012 * is the integer nearest the exact value of x/y. If there\012 * are two integers closest to x/y, n shall be the even\012 * one. If r is zero, it is given the same sign as x.\012 */\012float __ovld __cnfn remainder(float x, float y);\012float2 __ovld __cnfn remainder(float2 x, float2 y);\012float3 __ovld __cnfn remainder(float3 x, float3 y);\012float4 __ovld __cnfn remainder(float4 x, float4 y);\012float8 __ovld __cnfn remainder(float8 x, float8 y);\012float16 __ovld __cnfn remainder(float16 x, float16 y);\012#ifdef cl_khr_fp64\012double __ovld __cnfn remainder(double x, double y);\012double2 __ovld __cnfn remainder(double2 x, double2 y);\012double3 __ovld __cnfn remainder(double3 x, double3 y);\012double4 __ovld __cnfn remainder(double4 x, double4 y);\012double8 __ovld __cnfn remainder(dou",
"ble8 x, double8 y);\012double16 __ovld __cnfn remainder(double16 x, double16 y);\012#endif //cl_khr_fp64\012#ifdef cl_khr_fp16\012half __ovld __cnfn remainder(half x, half y);\012half2 __ovld __cnfn remainder(half2 x, half2 y);\012half3 __ovld __cnfn remainder(half3 x, half3 y);\012half4 __ovld __cnfn remainder(half4 x, half4 y);\012half8 __ovld __cnfn remainder(half8 x, half8 y);\012half16 __ovld __cnfn remainder(half16 x, half16 y);\012#endif //cl_khr_fp16\012\012/**\012 * Round to integral value (using round to nearest\012 * even rounding mode) in floating-point format.\012 * Refer to section 7.1 for description of rounding\012 * modes.\012 */\012float __ovld __cnfn rint(float);\012float2 __ovld __cnfn rint(float2);\012float3 __ovld __cnfn rint(float3);\012float4 __ovld __cnfn rint(float4);\012float8 __ovld __cnfn rint(float8);\012float16 __ovld __cnfn rint(float16);\012#ifdef cl_khr_fp64\012double __ovld __cnfn rint(double);\012double2 __ovld __cnfn rint(double2);\012double3 __ovld __cnfn rint(double3);\012double4 __ovld __cnfn rint(double4);\012double8 __ovld __cnfn rint(double8);\012double16",
" __ovld __cnfn rint(double16);\012#endif //cl_khr_fp64\012#ifdef cl_khr_fp16\012half __ovld __cnfn rint(half);\012half2 __ovld __cnfn rint(half2);\012half3 __ovld __cnfn rint(half3);\012half4 __ovld __cnfn rint(half4);\012half8 __ovld __cnfn rint(half8);\012half16 __ovld __cnfn rint(half16);\012#endif //cl_khr_fp16\012\012/**\012 * Compute x to the power 1/y.\012 */\012float __ovld __cnfn rootn(float x, int y);\012float2 __ovld __cnfn rootn(float2 x, int2 y);\012float3 __ovld __cnfn rootn(float3 x, int3 y);\012float4 __ovld __cnfn rootn(float4 x, int4 y);\012float8 __ovld __cnfn rootn(float8 x, int8 y);\012float16 __ovld __cnfn rootn(float16 x, int16 y);\012#ifdef cl_khr_fp64\012double __ovld __cnfn rootn(double x, int y);\012double2 __ovld __cnfn rootn(double2 x, int2 y);\012double3 __ovld __cnfn rootn(double3 x, int3 y);\012double4 __ovld __cnfn rootn(double4 x, int4 y);\012double8 __ovld __cnfn rootn(double8 x, int8 y);\012double16 __ovld __cnfn rootn(double16 x, int16 y);\012#endif //cl_khr_fp64\012#ifdef cl_khr_fp16\012half __ovld __cnfn rootn(half x, int y);\012half2 __ovld __cnfn rootn(half",
"2 x, int2 y);\012half3 __ovld __cnfn rootn(half3 x, int3 y);\012half4 __ovld __cnfn rootn(half4 x, int4 y);\012half8 __ovld __cnfn rootn(half8 x, int8 y);\012half16 __ovld __cnfn rootn(half16 x, int16 y);\012#endif //cl_khr_fp16\012\012/**\012 * Return the integral value nearest to x rounding\012 * halfway cases away from zero, regardless of the\012 * current rounding direction.\012 */\012float __ovld __cnfn round(float x);\012float2 __ovld __cnfn round(float2 x);\012float3 __ovld __cnfn round(float3 x);\012float4 __ovld __cnfn round(float4 x);\012float8 __ovld __cnfn round(float8 x);\012float16 __ovld __cnfn round(float16 x);\012#ifdef cl_khr_fp64\012double __ovld __cnfn round(double x);\012double2 __ovld __cnfn round(double2 x);\012double3 __ovld __cnfn round(double3 x);\012double4 __ovld __cnfn round(double4 x);\012double8 __ovld __cnfn round(double8 x);\012double16 __ovld __cnfn round(double16 x);\012#endif //cl_khr_fp64\012#ifdef cl_khr_fp16\012half __ovld __cnfn round(half x);\012half2 __ovld __cnfn round(half2 x);\012half3 __ovld __cnfn round(half3 x);\012half4 __ovld __cnfn round(half4 x);",
"\012half8 __ovld __cnfn round(half8 x);\012half16 __ovld __cnfn round(half16 x);\012#endif //cl_khr_fp16\012\012/**\012 * Compute inverse square root.\012 */\012float __ovld __cnfn rsqrt(float);\012float2 __ovld __cnfn rsqrt(float2);\012float3 __ovld __cnfn rsqrt(float3);\012float4 __ovld __cnfn rsqrt(float4);\012float8 __ovld __cnfn rsqrt(float8);\012float16 __ovld __cnfn rsqrt(float16);\012#ifdef cl_khr_fp64\012double __ovld __cnfn rsqrt(double);\012double2 __ovld __cnfn rsqrt(double2);\012double3 __ovld __cnfn rsqrt(double3);\012double4 __ovld __cnfn rsqrt(double4);\012double8 __ovld __cnfn rsqrt(double8);\012double16 __ovld __cnfn rsqrt(double16);\012#endif //cl_khr_fp64\012#ifdef cl_khr_fp16\012half __ovld __cnfn rsqrt(half);\012half2 __ovld __cnfn rsqrt(half2);\012half3 __ovld __cnfn rsqrt(half3);\012half4 __ovld __cnfn rsqrt(half4);\012half8 __ovld __cnfn rsqrt(half8);\012half16 __ovld __cnfn rsqrt(half16);\012#endif //cl_khr_fp16\012\012/**\012 * Compute sine.\012 */\012float __ovld __cnfn sin(float);\012float2 __ovld __cnfn sin(float2);\012float3 __ovld __cnfn sin(float3);\012float4 __ovld __cnfn sin(float4);",
"\012float8 __ovld __cnfn sin(float8);\012float16 __ovld __cnfn sin(float16);\012#ifdef cl_khr_fp64\012double __ovld __cnfn sin(double);\012double2 __ovld __cnfn sin(double2);\012double3 __ovld __cnfn sin(double3);\012double4 __ovld __cnfn sin(double4);\012double8 __ovld __cnfn sin(double8);\012double16 __ovld __cnfn sin(double16);\012#endif //cl_khr_fp64\012#ifdef cl_khr_fp16\012half __ovld __cnfn sin(half);\012half2 __ovld __cnfn sin(half2);\012half3 __ovld __cnfn sin(half3);\012half4 __ovld __cnfn sin(half4);\012half8 __ovld __cnfn sin(half8);\012half16 __ovld __cnfn sin(half16);\012#endif //cl_khr_fp16\012\012/**\012 * Compute hyperbolic sine.\012 */\012float __ovld __cnfn sinh(float);\012float2 __ovld __cnfn sinh(float2);\012float3 __ovld __cnfn sinh(float3);\012float4 __ovld __cnfn sinh(float4);\012float8 __ovld __cnfn sinh(float8);\012float16 __ovld __cnfn sinh(float16);\012#ifdef cl_khr_fp64\012double __ovld __cnfn sinh(double);\012double2 __ovld __cnfn sinh(double2);\012double3 __ovld __cnfn sinh(double3);\012double4 __ovld __cnfn sinh(double4);\012double8 __ovld __cnfn sinh(double8);\012double16 __ovld ",
"__cnfn sinh(double16);\012#endif //cl_khr_fp64\012#ifdef cl_khr_fp16\012half __ovld __cnfn sinh(half);\012half2 __ovld __cnfn sinh(half2);\012half3 __ovld __cnfn sinh(half3);\012half4 __ovld __cnfn sinh(half4);\012half8 __ovld __cnfn sinh(half8);\012half16 __ovld __cnfn sinh(half16);\012#endif //cl_khr_fp16\012\012/**\012 * Compute sin (PI * x).\012 */\012float __ovld __cnfn sinpi(float x);\012float2 __ovld __cnfn sinpi(float2 x);\012float3 __ovld __cnfn sinpi(float3 x);\012float4 __ovld __cnfn sinpi(float4 x);\012float8 __ovld __cnfn sinpi(float8 x);\012float16 __ovld __cnfn sinpi(float16 x);\012#ifdef cl_khr_fp64\012double __ovld __cnfn sinpi(double x);\012double2 __ovld __cnfn sinpi(double2 x);\012double3 __ovld __cnfn sinpi(double3 x);\012double4 __ovld __cnfn sinpi(double4 x);\012double8 __ovld __cnfn sinpi(double8 x);\012double16 __ovld __cnfn sinpi(double16 x);\012#endif //cl_khr_fp64\012#ifdef cl_khr_fp16\012half __ovld __cnfn sinpi(half x);\012half2 __ovld __cnfn sinpi(half2 x);\012half3 __ovld __cnfn sinpi(half3 x);\012half4 __ovld __cnfn sinpi(half4 x);\012half8 __ovld __cnfn sinpi(half8 x);\012hal",
"f16 __ovld __cnfn sinpi(half16 x);\012#endif //cl_khr_fp16\012\012/**\012 * Compute square root.\012 */\012float __ovld __cnfn sqrt(float);\012float2 __ovld __cnfn sqrt(float2);\012float3 __ovld __cnfn sqrt(float3);\012float4 __ovld __cnfn sqrt(float4);\012float8 __ovld __cnfn sqrt(float8);\012float16 __ovld __cnfn sqrt(float16);\012#ifdef cl_khr_fp64\012double __ovld __cnfn sqrt(double);\012double2 __ovld __cnfn sqrt(double2);\012double3 __ovld __cnfn sqrt(double3);\012double4 __ovld __cnfn sqrt(double4);\012double8 __ovld __cnfn sqrt(double8);\012double16 __ovld __cnfn sqrt(double16);\012#endif //cl_khr_fp64\012#ifdef cl_khr_fp16\012half __ovld __cnfn sqrt(half);\012half2 __ovld __cnfn sqrt(half2);\012half3 __ovld __cnfn sqrt(half3);\012half4 __ovld __cnfn sqrt(half4);\012half8 __ovld __cnfn sqrt(half8);\012half16 __ovld __cnfn sqrt(half16);\012#endif //cl_khr_fp16\012\012/**\012 * Compute tangent.\012 */\012float __ovld __cnfn tan(float);\012float2 __ovld __cnfn tan(float2);\012float3 __ovld __cnfn tan(float3);\012float4 __ovld __cnfn tan(float4);\012float8 __ovld __cnfn tan(float8);\012float16 __ovld __cnfn tan(fl",
"oat16);\012#ifdef cl_khr_fp64\012double __ovld __cnfn tan(double);\012double2 __ovld __cnfn tan(double2);\012double3 __ovld __cnfn tan(double3);\012double4 __ovld __cnfn tan(double4);\012double8 __ovld __cnfn tan(double8);\012double16 __ovld __cnfn tan(double16);\012#endif //cl_khr_fp64\012#ifdef cl_khr_fp16\012half __ovld __cnfn tan(half);\012half2 __ovld __cnfn tan(half2);\012half3 __ovld __cnfn tan(half3);\012half4 __ovld __cnfn tan(half4);\012half8 __ovld __cnfn tan(half8);\012half16 __ovld __cnfn tan(half16);\012#endif //cl_khr_fp16\012\012/**\012 * Compute hyperbolic tangent.\012 */\012float __ovld __cnfn tanh(float);\012float2 __ovld __cnfn tanh(float2);\012float3 __ovld __cnfn tanh(float3);\012float4 __ovld __cnfn tanh(float4);\012float8 __ovld __cnfn tanh(float8);\012float16 __ovld __cnfn tanh(float16);\012#ifdef cl_khr_fp64\012double __ovld __cnfn tanh(double);\012double2 __ovld __cnfn tanh(double2);\012double3 __ovld __cnfn tanh(double3);\012double4 __ovld __cnfn tanh(double4);\012double8 __ovld __cnfn tanh(double8);\012double16 __ovld __cnfn tanh(double16);\012#endif //cl_khr_fp64\012#ifdef cl_khr_fp",
"16\012half __ovld __cnfn tanh(half);\012half2 __ovld __cnfn tanh(half2);\012half3 __ovld __cnfn tanh(half3);\012half4 __ovld __cnfn tanh(half4);\012half8 __ovld __cnfn tanh(half8);\012half16 __ovld __cnfn tanh(half16);\012#endif //cl_khr_fp16\012\012/**\012 * Compute tan (PI * x).\012 */\012float __ovld __cnfn tanpi(float x);\012float2 __ovld __cnfn tanpi(float2 x);\012float3 __ovld __cnfn tanpi(float3 x);\012float4 __ovld __cnfn tanpi(float4 x);\012float8 __ovld __cnfn tanpi(float8 x);\012float16 __ovld __cnfn tanpi(float16 x);\012#ifdef cl_khr_fp64\012double __ovld __cnfn tanpi(double x);\012double2 __ovld __cnfn tanpi(double2 x);\012double3 __ovld __cnfn tanpi(double3 x);\012double4 __ovld __cnfn tanpi(double4 x);\012double8 __ovld __cnfn tanpi(double8 x);\012double16 __ovld __cnfn tanpi(double16 x);\012#endif //cl_khr_fp64\012#ifdef cl_khr_fp16\012half __ovld __cnfn tanpi(half x);\012half2 __ovld __cnfn tanpi(half2 x);\012half3 __ovld __cnfn tanpi(half3 x);\012half4 __ovld __cnfn tanpi(half4 x);\012half8 __ovld __cnfn tanpi(half8 x);\012half16 __ovld __cnfn tanpi(half16 x);\012#endif //cl_khr_fp16\012\012/**",
"\012 * Compute the gamma function.\012 */\012float __ovld __cnfn tgamma(float);\012float2 __ovld __cnfn tgamma(float2);\012float3 __ovld __cnfn tgamma(float3);\012float4 __ovld __cnfn tgamma(float4);\012float8 __ovld __cnfn tgamma(float8);\012float16 __ovld __cnfn tgamma(float16);\012#ifdef cl_khr_fp64\012double __ovld __cnfn tgamma(double);\012double2 __ovld __cnfn tgamma(double2);\012double3 __ovld __cnfn tgamma(double3);\012double4 __ovld __cnfn tgamma(double4);\012double8 __ovld __cnfn tgamma(double8);\012double16 __ovld __cnfn tgamma(double16);\012#endif //cl_khr_fp64\012#ifdef cl_khr_fp16\012half __ovld __cnfn tgamma(half);\012half2 __ovld __cnfn tgamma(half2);\012half3 __ovld __cnfn tgamma(half3);\012half4 __ovld __cnfn tgamma(half4);\012half8 __ovld __cnfn tgamma(half8);\012half16 __ovld __cnfn tgamma(half16);\012#endif //cl_khr_fp16\012\012/**\012 * Round to integral value using the round to zero\012 * rounding mode.\012 */\012float __ovld __cnfn trunc(float);\012float2 __ovld __cnfn trunc(float2);\012float3 __ovld __cnfn trunc(float3);\012float4 __ovld __cnfn trunc(float4);\012float8 __ovld __cnfn t",
"runc(float8);\012float16 __ovld __cnfn trunc(float16);\012#ifdef cl_khr_fp64\012double __ovld __cnfn trunc(double);\012double2 __ovld __cnfn trunc(double2);\012double3 __ovld __cnfn trunc(double3);\012double4 __ovld __cnfn trunc(double4);\012double8 __ovld __cnfn trunc(double8);\012double16 __ovld __cnfn trunc(double16);\012#endif //cl_khr_fp64\012#ifdef cl_khr_fp16\012half __ovld __cnfn trunc(half);\012half2 __ovld __cnfn trunc(half2);\012half3 __ovld __cnfn trunc(half3);\012half4 __ovld __cnfn trunc(half4);\012half8 __ovld __cnfn trunc(half8);\012half16 __ovld __cnfn trunc(half16);\012#endif //cl_khr_fp16\012\012/**\012 * Compute cosine. x must be in the range -2^16 ... +2^16.\012 */\012float __ovld __cnfn half_cos(float x);\012float2 __ovld __cnfn half_cos(float2 x);\012float3 __ovld __cnfn half_cos(float3 x);\012float4 __ovld __cnfn half_cos(float4 x);\012float8 __ovld __cnfn half_cos(float8 x);\012float16 __ovld __cnfn half_cos(float16 x);\012\012/**\012 * Compute x / y.\012 */\012float __ovld __cnfn half_divide(float x, float y);\012float2 __ovld __cnfn half_divide(float2 x, float2 y);\012float3 __ovld ",
"__cnfn half_divide(float3 x, float3 y);\012float4 __ovld __cnfn half_divide(float4 x, float4 y);\012float8 __ovld __cnfn half_divide(float8 x, float8 y);\012float16 __ovld __cnfn half_divide(float16 x, float16 y);\012\012/**\012 * Compute the base- e exponential of x.\012 */\012float __ovld __cnfn half_exp(float x);\012float2 __ovld __cnfn half_exp(float2 x);\012float3 __ovld __cnfn half_exp(float3 x);\012float4 __ovld __cnfn half_exp(float4 x);\012float8 __ovld __cnfn half_exp(float8 x);\012float16 __ovld __cnfn half_exp(float16 x);\012\012/**\012 * Compute the base- 2 exponential of x.\012 */\012float __ovld __cnfn half_exp2(float x);\012float2 __ovld __cnfn half_exp2(float2 x);\012float3 __ovld __cnfn half_exp2(float3 x);\012float4 __ovld __cnfn half_exp2(float4 x);\012float8 __ovld __cnfn half_exp2(float8 x);\012float16 __ovld __cnfn half_exp2(float16 x);\012\012/**\012 * Compute the base- 10 exponential of x.\012 */\012float __ovld __cnfn half_exp10(float x);\012float2 __ovld __cnfn half_exp10(float2 x);\012float3 __ovld __cnfn half_exp10(float3 x);\012float4 __ovld __cnfn half_exp10(float4 x);\012",
"float8 __ovld __cnfn half_exp10(float8 x);\012float16 __ovld __cnfn half_exp10(float16 x);\012\012/**\012 * Compute natural logarithm.\012 */\012float __ovld __cnfn half_log(float x);\012float2 __ovld __cnfn half_log(float2 x);\012float3 __ovld __cnfn half_log(float3 x);\012float4 __ovld __cnfn half_log(float4 x);\012float8 __ovld __cnfn half_log(float8 x);\012float16 __ovld __cnfn half_log(float16 x);\012\012/**\012 * Compute a base 2 logarithm.\012 */\012float __ovld __cnfn half_log2(float x);\012float2 __ovld __cnfn half_log2(float2 x);\012float3 __ovld __cnfn half_log2(float3 x);\012float4 __ovld __cnfn half_log2(float4 x);\012float8 __ovld __cnfn half_log2(float8 x);\012float16 __ovld __cnfn half_log2(float16 x);\012\012/**\012 * Compute a base 10 logarithm.\012 */\012float __ovld __cnfn half_log10(float x);\012float2 __ovld __cnfn half_log10(float2 x);\012float3 __ovld __cnfn half_log10(float3 x);\012float4 __ovld __cnfn half_log10(float4 x);\012float8 __ovld __cnfn half_log10(float8 x);\012float16 __ovld __cnfn half_log10(float16 x);\012\012/**\012 * Compute x to the power y, where x is >= 0.\012 */\012float",
" __ovld __cnfn half_powr(float x, float y);\012float2 __ovld __cnfn half_powr(float2 x, float2 y);\012float3 __ovld __cnfn half_powr(float3 x, float3 y);\012float4 __ovld __cnfn half_powr(float4 x, float4 y);\012float8 __ovld __cnfn half_powr(float8 x, float8 y);\012float16 __ovld __cnfn half_powr(float16 x, float16 y);\012\012/**\012 * Compute reciprocal.\012 */\012float __ovld __cnfn half_recip(float x);\012float2 __ovld __cnfn half_recip(float2 x);\012float3 __ovld __cnfn half_recip(float3 x);\012float4 __ovld __cnfn half_recip(float4 x);\012float8 __ovld __cnfn half_recip(float8 x);\012float16 __ovld __cnfn half_recip(float16 x);\012\012/**\012 * Compute inverse square root.\012 */\012float __ovld __cnfn half_rsqrt(float x);\012float2 __ovld __cnfn half_rsqrt(float2 x);\012float3 __ovld __cnfn half_rsqrt(float3 x);\012float4 __ovld __cnfn half_rsqrt(float4 x);\012float8 __ovld __cnfn half_rsqrt(float8 x);\012float16 __ovld __cnfn half_rsqrt(float16 x);\012\012/**\012 * Compute sine. x must be in the range -2^16 ... +2^16.\012 */\012float __ovld __cnfn half_sin(float x);\012float2 __ovld __cnfn ha",
"lf_sin(float2 x);\012float3 __ovld __cnfn half_sin(float3 x);\012float4 __ovld __cnfn half_sin(float4 x);\012float8 __ovld __cnfn half_sin(float8 x);\012float16 __ovld __cnfn half_sin(float16 x);\012\012/**\012 * Compute square root.\012 */\012float __ovld __cnfn half_sqrt(float x);\012float2 __ovld __cnfn half_sqrt(float2 x);\012float3 __ovld __cnfn half_sqrt(float3 x);\012float4 __ovld __cnfn half_sqrt(float4 x);\012float8 __ovld __cnfn half_sqrt(float8 x);\012float16 __ovld __cnfn half_sqrt(float16 x);\012\012/**\012 * Compute tangent. x must be in the range -216 ... +216.\012 */\012float __ovld __cnfn half_tan(float x);\012float2 __ovld __cnfn half_tan(float2 x);\012float3 __ovld __cnfn half_tan(float3 x);\012float4 __ovld __cnfn half_tan(float4 x);\012float8 __ovld __cnfn half_tan(float8 x);\012float16 __ovld __cnfn half_tan(float16 x);\012\012/**\012 * Compute cosine over an implementation-defined range.\012 * The maximum error is implementation-defined.\012 */\012float __ovld __cnfn native_cos(float x);\012float2 __ovld __cnfn native_cos(float2 x);\012float3 __ovld __cnfn native_cos(float3 x);\012fl",
"oat4 __ovld __cnfn native_cos(float4 x);\012float8 __ovld __cnfn native_cos(float8 x);\012float16 __ovld __cnfn native_cos(float16 x);\012\012/**\012 * Compute x / y over an implementation-defined range.\012 * The maximum error is implementation-defined.\012 */\012float __ovld __cnfn native_divide(float x, float y);\012float2 __ovld __cnfn native_divide(float2 x, float2 y);\012float3 __ovld __cnfn native_divide(float3 x, float3 y);\012float4 __ovld __cnfn native_divide(float4 x, float4 y);\012float8 __ovld __cnfn native_divide(float8 x, float8 y);\012float16 __ovld __cnfn native_divide(float16 x, float16 y);\012\012/**\012 * Compute the base- e exponential of x over an\012 * implementation-defined range. The maximum error is\012 * implementation-defined.\012 */\012float __ovld __cnfn native_exp(float x);\012float2 __ovld __cnfn native_exp(float2 x);\012float3 __ovld __cnfn native_exp(float3 x);\012float4 __ovld __cnfn native_exp(float4 x);\012float8 __ovld __cnfn native_exp(float8 x);\012float16 __ovld __cnfn native_exp(float16 x);\012\012/**\012 * Compute the base- 2 exponential of x over a",
"n\012 * implementation-defined range. The maximum error is\012 * implementation-defined.\012 */\012float __ovld __cnfn native_exp2(float x);\012float2 __ovld __cnfn native_exp2(float2 x);\012float3 __ovld __cnfn native_exp2(float3 x);\012float4 __ovld __cnfn native_exp2(float4 x);\012float8 __ovld __cnfn native_exp2(float8 x);\012float16 __ovld __cnfn native_exp2(float16 x);\012\012/**\012 * Compute the base- 10 exponential of x over an\012 * implementation-defined range. The maximum error is\012 * implementation-defined.\012 */\012float __ovld __cnfn native_exp10(float x);\012float2 __ovld __cnfn native_exp10(float2 x);\012float3 __ovld __cnfn native_exp10(float3 x);\012float4 __ovld __cnfn native_exp10(float4 x);\012float8 __ovld __cnfn native_exp10(float8 x);\012float16 __ovld __cnfn native_exp10(float16 x);\012\012/**\012 * Compute natural logarithm over an implementationdefined\012 * range. The maximum error is implementation\012 * defined.\012 */\012float __ovld __cnfn native_log(float x);\012float2 __ovld __cnfn native_log(float2 x);\012float3 __ovld __cnfn native_log(float3 x);\012float4 __ov",
"ld __cnfn native_log(float4 x);\012float8 __ovld __cnfn native_log(float8 x);\012float16 __ovld __cnfn native_log(float16 x);\012\012/**\012 * Compute a base 2 logarithm over an implementationdefined\012 * range. The maximum error is implementationdefined.\012 */\012float __ovld __cnfn native_log2(float x);\012float2 __ovld __cnfn native_log2(float2 x);\012float3 __ovld __cnfn native_log2(float3 x);\012float4 __ovld __cnfn native_log2(float4 x);\012float8 __ovld __cnfn native_log2(float8 x);\012float16 __ovld __cnfn native_log2(float16 x);\012\012/**\012 * Compute a base 10 logarithm over an implementationdefined\012 * range. The maximum error is implementationdefined.\012 */\012float __ovld __cnfn native_log10(float x);\012float2 __ovld __cnfn native_log10(float2 x);\012float3 __ovld __cnfn native_log10(float3 x);\012float4 __ovld __cnfn native_log10(float4 x);\012float8 __ovld __cnfn native_log10(float8 x);\012float16 __ovld __cnfn native_log10(float16 x);\012\012/**\012 * Compute x to the power y, where x is >= 0. The range of\012 * x and y are implementation-defined. The maximum error\012 *",
" is implementation-defined.\012 */\012float __ovld __cnfn native_powr(float x, float y);\012float2 __ovld __cnfn native_powr(float2 x, float2 y);\012float3 __ovld __cnfn native_powr(float3 x, float3 y);\012float4 __ovld __cnfn native_powr(float4 x, float4 y);\012float8 __ovld __cnfn native_powr(float8 x, float8 y);\012float16 __ovld __cnfn native_powr(float16 x, float16 y);\012\012/**\012 * Compute reciprocal over an implementation-defined\012 * range. The maximum error is implementation-defined.\012 */\012float __ovld __cnfn native_recip(float x);\012float2 __ovld __cnfn native_recip(float2 x);\012float3 __ovld __cnfn native_recip(float3 x);\012float4 __ovld __cnfn native_recip(float4 x);\012float8 __ovld __cnfn native_recip(float8 x);\012float16 __ovld __cnfn native_recip(float16 x);\012\012/**\012 * Compute inverse square root over an implementationdefined\012 * range. The maximum error is implementationdefined.\012 */\012float __ovld __cnfn native_rsqrt(float x);\012float2 __ovld __cnfn native_rsqrt(float2 x);\012float3 __ovld __cnfn native_rsqrt(float3 x);\012float4 __ovld __cnfn nat",
"ive_rsqrt(float4 x);\012float8 __ovld __cnfn native_rsqrt(float8 x);\012float16 __ovld __cnfn native_rsqrt(float16 x);\012\012/**\012 * Compute sine over an implementation-defined range.\012 * The maximum error is implementation-defined.\012 */\012float __ovld __cnfn native_sin(float x);\012float2 __ovld __cnfn native_sin(float2 x);\012float3 __ovld __cnfn native_sin(float3 x);\012float4 __ovld __cnfn native_sin(float4 x);\012float8 __ovld __cnfn native_sin(float8 x);\012float16 __ovld __cnfn native_sin(float16 x);\012\012/**\012 * Compute square root over an implementation-defined\012 * range. The maximum error is implementation-defined.\012 */\012float __ovld __cnfn native_sqrt(float x);\012float2 __ovld __cnfn native_sqrt(float2 x);\012float3 __ovld __cnfn native_sqrt(float3 x);\012float4 __ovld __cnfn native_sqrt(float4 x);\012float8 __ovld __cnfn native_sqrt(float8 x);\012float16 __ovld __cnfn native_sqrt(float16 x);\012\012/**\012 * Compute tangent over an implementation-defined range.\012 * The maximum error is implementation-defined.\012 */\012float __ovld __cnfn native_tan(float x);\012float",
"2 __ovld __cnfn native_tan(float2 x);\012float3 __ovld __cnfn native_tan(float3 x);\012float4 __ovld __cnfn native_tan(float4 x);\012float8 __ovld __cnfn native_tan(float8 x);\012float16 __ovld __cnfn native_tan(float16 x);\012\012// OpenCL v1.1 s6.11.3, v1.2 s6.12.3, v2.0 s6.13.3 - Integer Functions\012\012/**\012 * Returns | x |.\012 */\012uchar __ovld __cnfn abs(char x);\012uchar __ovld __cnfn abs(uchar x);\012uchar2 __ovld __cnfn abs(char2 x);\012uchar2 __ovld __cnfn abs(uchar2 x);\012uchar3 __ovld __cnfn abs(char3 x);\012uchar3 __ovld __cnfn abs(uchar3 x);\012uchar4 __ovld __cnfn abs(char4 x);\012uchar4 __ovld __cnfn abs(uchar4 x);\012uchar8 __ovld __cnfn abs(char8 x);\012uchar8 __ovld __cnfn abs(uchar8 x);\012uchar16 __ovld __cnfn abs(char16 x);\012uchar16 __ovld __cnfn abs(uchar16 x);\012ushort __ovld __cnfn abs(short x);\012ushort __ovld __cnfn abs(ushort x);\012ushort2 __ovld __cnfn abs(short2 x);\012ushort2 __ovld __cnfn abs(ushort2 x);\012ushort3 __ovld __cnfn abs(short3 x);\012ushort3 __ovld __cnfn abs(ushort3 x);\012ushort4 __ovld __cnfn abs(short4 x);\012ushort4 __ovld __cnfn abs(ush",
"ort4 x);\012ushort8 __ovld __cnfn abs(short8 x);\012ushort8 __ovld __cnfn abs(ushort8 x);\012ushort16 __ovld __cnfn abs(short16 x);\012ushort16 __ovld __cnfn abs(ushort16 x);\012uint __ovld __cnfn abs(int x);\012uint __ovld __cnfn abs(uint x);\012uint2 __ovld __cnfn abs(int2 x);\012uint2 __ovld __cnfn abs(uint2 x);\012uint3 __ovld __cnfn abs(int3 x);\012uint3 __ovld __cnfn abs(uint3 x);\012uint4 __ovld __cnfn abs(int4 x);\012uint4 __ovld __cnfn abs(uint4 x);\012uint8 __ovld __cnfn abs(int8 x);\012uint8 __ovld __cnfn abs(uint8 x);\012uint16 __ovld __cnfn abs(int16 x);\012uint16 __ovld __cnfn abs(uint16 x);\012ulong __ovld __cnfn abs(long x);\012ulong __ovld __cnfn abs(ulong x);\012ulong2 __ovld __cnfn abs(long2 x);\012ulong2 __ovld __cnfn abs(ulong2 x);\012ulong3 __ovld __cnfn abs(long3 x);\012ulong3 __ovld __cnfn abs(ulong3 x);\012ulong4 __ovld __cnfn abs(long4 x);\012ulong4 __ovld __cnfn abs(ulong4 x);\012ulong8 __ovld __cnfn abs(long8 x);\012ulong8 __ovld __cnfn abs(ulong8 x);\012ulong16 __ovld __cnfn abs(long16 x);\012ulong16 __ovld __cnfn abs(ulong16 x);\012\012/**\012 * Returns | x - y | without",
" modulo overflow.\012 */\012uchar __ovld __cnfn abs_diff(char x, char y);\012uchar __ovld __cnfn abs_diff(uchar x, uchar y);\012uchar2 __ovld __cnfn abs_diff(char2 x, char2 y);\012uchar2 __ovld __cnfn abs_diff(uchar2 x, uchar2 y);\012uchar3 __ovld __cnfn abs_diff(char3 x, char3 y);\012uchar3 __ovld __cnfn abs_diff(uchar3 x, uchar3 y);\012uchar4 __ovld __cnfn abs_diff(char4 x, char4 y);\012uchar4 __ovld __cnfn abs_diff(uchar4 x, uchar4 y);\012uchar8 __ovld __cnfn abs_diff(char8 x, char8 y);\012uchar8 __ovld __cnfn abs_diff(uchar8 x, uchar8 y);\012uchar16 __ovld __cnfn abs_diff(char16 x, char16 y);\012uchar16 __ovld __cnfn abs_diff(uchar16 x, uchar16 y);\012ushort __ovld __cnfn abs_diff(short x, short y);\012ushort __ovld __cnfn abs_diff(ushort x, ushort y);\012ushort2 __ovld __cnfn abs_diff(short2 x, short2 y);\012ushort2 __ovld __cnfn abs_diff(ushort2 x, ushort2 y);\012ushort3 __ovld __cnfn abs_diff(short3 x, short3 y);\012ushort3 __ovld __cnfn abs_diff(ushort3 x, ushort3 y);\012ushort4 __ovld __cnfn abs_diff(short4 x, short4 y);\012ushort4 __ovld __cnfn abs_diff(ushort4",
" x, ushort4 y);\012ushort8 __ovld __cnfn abs_diff(short8 x, short8 y);\012ushort8 __ovld __cnfn abs_diff(ushort8 x, ushort8 y);\012ushort16 __ovld __cnfn abs_diff(short16 x, short16 y);\012ushort16 __ovld __cnfn abs_diff(ushort16 x, ushort16 y);\012uint __ovld __cnfn abs_diff(int x, int y);\012uint __ovld __cnfn abs_diff(uint x, uint y);\012uint2 __ovld __cnfn abs_diff(int2 x, int2 y);\012uint2 __ovld __cnfn abs_diff(uint2 x, uint2 y);\012uint3 __ovld __cnfn abs_diff(int3 x, int3 y);\012uint3 __ovld __cnfn abs_diff(uint3 x, uint3 y);\012uint4 __ovld __cnfn abs_diff(int4 x, int4 y);\012uint4 __ovld __cnfn abs_diff(uint4 x, uint4 y);\012uint8 __ovld __cnfn abs_diff(int8 x, int8 y);\012uint8 __ovld __cnfn abs_diff(uint8 x, uint8 y);\012uint16 __ovld __cnfn abs_diff(int16 x, int16 y);\012uint16 __ovld __cnfn abs_diff(uint16 x, uint16 y);\012ulong __ovld __cnfn abs_diff(long x, long y);\012ulong __ovld __cnfn abs_diff(ulong x, ulong y);\012ulong2 __ovld __cnfn abs_diff(long2 x, long2 y);\012ulong2 __ovld __cnfn abs_diff(ulong2 x, ulong2 y);\012ulong3 __ovld __cnfn abs_diff(lo",
"ng3 x, long3 y);\012ulong3 __ovld __cnfn abs_diff(ulong3 x, ulong3 y);\012ulong4 __ovld __cnfn abs_diff(long4 x, long4 y);\012ulong4 __ovld __cnfn abs_diff(ulong4 x, ulong4 y);\012ulong8 __ovld __cnfn abs_diff(long8 x, long8 y);\012ulong8 __ovld __cnfn abs_diff(ulong8 x, ulong8 y);\012ulong16 __ovld __cnfn abs_diff(long16 x, long16 y);\012ulong16 __ovld __cnfn abs_diff(ulong16 x, ulong16 y);\012\012/**\012 * Returns x + y and saturates the result.\012 */\012char __ovld __cnfn add_sat(char x, char y);\012uchar __ovld __cnfn add_sat(uchar x, uchar y);\012char2 __ovld __cnfn add_sat(char2 x, char2 y);\012uchar2 __ovld __cnfn add_sat(uchar2 x, uchar2 y);\012char3 __ovld __cnfn add_sat(char3 x, char3 y);\012uchar3 __ovld __cnfn add_sat(uchar3 x, uchar3 y);\012char4 __ovld __cnfn add_sat(char4 x, char4 y);\012uchar4 __ovld __cnfn add_sat(uchar4 x, uchar4 y);\012char8 __ovld __cnfn add_sat(char8 x, char8 y);\012uchar8 __ovld __cnfn add_sat(uchar8 x, uchar8 y);\012char16 __ovld __cnfn add_sat(char16 x, char16 y);\012uchar16 __ovld __cnfn add_sat(uchar16 x, uchar16 y);\012short __ovld __c",
"nfn add_sat(short x, short y);\012ushort __ovld __cnfn add_sat(ushort x, ushort y);\012short2 __ovld __cnfn add_sat(short2 x, short2 y);\012ushort2 __ovld __cnfn add_sat(ushort2 x, ushort2 y);\012short3 __ovld __cnfn add_sat(short3 x, short3 y);\012ushort3 __ovld __cnfn add_sat(ushort3 x, ushort3 y);\012short4 __ovld __cnfn add_sat(short4 x, short4 y);\012ushort4 __ovld __cnfn add_sat(ushort4 x, ushort4 y);\012short8 __ovld __cnfn add_sat(short8 x, short8 y);\012ushort8 __ovld __cnfn add_sat(ushort8 x, ushort8 y);\012short16 __ovld __cnfn add_sat(short16 x, short16 y);\012ushort16 __ovld __cnfn add_sat(ushort16 x, ushort16 y);\012int __ovld __cnfn add_sat(int x, int y);\012uint __ovld __cnfn add_sat(uint x, uint y);\012int2 __ovld __cnfn add_sat(int2 x, int2 y);\012uint2 __ovld __cnfn add_sat(uint2 x, uint2 y);\012int3 __ovld __cnfn add_sat(int3 x, int3 y);\012uint3 __ovld __cnfn add_sat(uint3 x, uint3 y);\012int4 __ovld __cnfn add_sat(int4 x, int4 y);\012uint4 __ovld __cnfn add_sat(uint4 x, uint4 y);\012int8 __ovld __cnfn add_sat(int8 x, int8 y);\012uint8 __ovld __cnfn ",
"add_sat(uint8 x, uint8 y);\012int16 __ovld __cnfn add_sat(int16 x, int16 y);\012uint16 __ovld __cnfn add_sat(uint16 x, uint16 y);\012long __ovld __cnfn add_sat(long x, long y);\012ulong __ovld __cnfn add_sat(ulong x, ulong y);\012long2 __ovld __cnfn add_sat(long2 x, long2 y);\012ulong2 __ovld __cnfn add_sat(ulong2 x, ulong2 y);\012long3 __ovld __cnfn add_sat(long3 x, long3 y);\012ulong3 __ovld __cnfn add_sat(ulong3 x, ulong3 y);\012long4 __ovld __cnfn add_sat(long4 x, long4 y);\012ulong4 __ovld __cnfn add_sat(ulong4 x, ulong4 y);\012long8 __ovld __cnfn add_sat(long8 x, long8 y);\012ulong8 __ovld __cnfn add_sat(ulong8 x, ulong8 y);\012long16 __ovld __cnfn add_sat(long16 x, long16 y);\012ulong16 __ovld __cnfn add_sat(ulong16 x, ulong16 y);\012\012/**\012 * Returns (x + y) >> 1. The intermediate sum does\012 * not modulo overflow.\012 */\012char __ovld __cnfn hadd(char x, char y);\012uchar __ovld __cnfn hadd(uchar x, uchar y);\012char2 __ovld __cnfn hadd(char2 x, char2 y);\012uchar2 __ovld __cnfn hadd(uchar2 x, uchar2 y);\012char3 __ovld __cnfn hadd(char3 x, char3 y);\012uchar3 __ovld ",
"__cnfn hadd(uchar3 x, uchar3 y);\012char4 __ovld __cnfn hadd(char4 x, char4 y);\012uchar4 __ovld __cnfn hadd(uchar4 x, uchar4 y);\012char8 __ovld __cnfn hadd(char8 x, char8 y);\012uchar8 __ovld __cnfn hadd(uchar8 x, uchar8 y);\012char16 __ovld __cnfn hadd(char16 x, char16 y);\012uchar16 __ovld __cnfn hadd(uchar16 x, uchar16 y);\012short __ovld __cnfn hadd(short x, short y);\012ushort __ovld __cnfn hadd(ushort x, ushort y);\012short2 __ovld __cnfn hadd(short2 x, short2 y);\012ushort2 __ovld __cnfn hadd(ushort2 x, ushort2 y);\012short3 __ovld __cnfn hadd(short3 x, short3 y);\012ushort3 __ovld __cnfn hadd(ushort3 x, ushort3 y);\012short4 __ovld __cnfn hadd(short4 x, short4 y);\012ushort4 __ovld __cnfn hadd(ushort4 x, ushort4 y);\012short8 __ovld __cnfn hadd(short8 x, short8 y);\012ushort8 __ovld __cnfn hadd(ushort8 x, ushort8 y);\012short16 __ovld __cnfn hadd(short16 x, short16 y);\012ushort16 __ovld __cnfn hadd(ushort16 x, ushort16 y);\012int __ovld __cnfn hadd(int x, int y);\012uint __ovld __cnfn hadd(uint x, uint y);\012int2 __ovld __cnfn hadd(int2 x, int2 y);\012uint2 __ov",
"ld __cnfn hadd(uint2 x, uint2 y);\012int3 __ovld __cnfn hadd(int3 x, int3 y);\012uint3 __ovld __cnfn hadd(uint3 x, uint3 y);\012int4 __ovld __cnfn hadd(int4 x, int4 y);\012uint4 __ovld __cnfn hadd(uint4 x, uint4 y);\012int8 __ovld __cnfn hadd(int8 x, int8 y);\012uint8 __ovld __cnfn hadd(uint8 x, uint8 y);\012int16 __ovld __cnfn hadd(int16 x, int16 y);\012uint16 __ovld __cnfn hadd(uint16 x, uint16 y);\012long __ovld __cnfn hadd(long x, long y);\012ulong __ovld __cnfn hadd(ulong x, ulong y);\012long2 __ovld __cnfn hadd(long2 x, long2 y);\012ulong2 __ovld __cnfn hadd(ulong2 x, ulong2 y);\012long3 __ovld __cnfn hadd(long3 x, long3 y);\012ulong3 __ovld __cnfn hadd(ulong3 x, ulong3 y);\012long4 __ovld __cnfn hadd(long4 x, long4 y);\012ulong4 __ovld __cnfn hadd(ulong4 x, ulong4 y);\012long8 __ovld __cnfn hadd(long8 x, long8 y);\012ulong8 __ovld __cnfn hadd(ulong8 x, ulong8 y);\012long16 __ovld __cnfn hadd(long16 x, long16 y);\012ulong16 __ovld __cnfn hadd(ulong16 x, ulong16 y);\012\012/**\012 * Returns (x + y + 1) >> 1. The intermediate sum\012 * does not modulo overflow.\012 */\012char __ovl",
"d __cnfn rhadd(char x, char y);\012uchar __ovld __cnfn rhadd(uchar x, uchar y);\012char2 __ovld __cnfn rhadd(char2 x, char2 y);\012uchar2 __ovld __cnfn rhadd(uchar2 x, uchar2 y);\012char3 __ovld __cnfn rhadd(char3 x, char3 y);\012uchar3 __ovld __cnfn rhadd(uchar3 x, uchar3 y);\012char4 __ovld __cnfn rhadd(char4 x, char4 y);\012uchar4 __ovld __cnfn rhadd(uchar4 x, uchar4 y);\012char8 __ovld __cnfn rhadd(char8 x, char8 y);\012uchar8 __ovld __cnfn rhadd(uchar8 x, uchar8 y);\012char16 __ovld __cnfn rhadd(char16 x, char16 y);\012uchar16 __ovld __cnfn rhadd(uchar16 x, uchar16 y);\012short __ovld __cnfn rhadd(short x, short y);\012ushort __ovld __cnfn rhadd(ushort x, ushort y);\012short2 __ovld __cnfn rhadd(short2 x, short2 y);\012ushort2 __ovld __cnfn rhadd(ushort2 x, ushort2 y);\012short3 __ovld __cnfn rhadd(short3 x, short3 y);\012ushort3 __ovld __cnfn rhadd(ushort3 x, ushort3 y);\012short4 __ovld __cnfn rhadd(short4 x, short4 y);\012ushort4 __ovld __cnfn rhadd(ushort4 x, ushort4 y);\012short8 __ovld __cnfn rhadd(short8 x, short8 y);\012ushort8 __ovld __cnfn rhadd(ushort8 x,",
" ushort8 y);\012short16 __ovld __cnfn rhadd(short16 x, short16 y);\012ushort16 __ovld __cnfn rhadd(ushort16 x, ushort16 y);\012int __ovld __cnfn rhadd(int x, int y);\012uint __ovld __cnfn rhadd(uint x, uint y);\012int2 __ovld __cnfn rhadd(int2 x, int2 y);\012uint2 __ovld __cnfn rhadd(uint2 x, uint2 y);\012int3 __ovld __cnfn rhadd(int3 x, int3 y);\012uint3 __ovld __cnfn rhadd(uint3 x, uint3 y);\012int4 __ovld __cnfn rhadd(int4 x, int4 y);\012uint4 __ovld __cnfn rhadd(uint4 x, uint4 y);\012int8 __ovld __cnfn rhadd(int8 x, int8 y);\012uint8 __ovld __cnfn rhadd(uint8 x, uint8 y);\012int16 __ovld __cnfn rhadd(int16 x, int16 y);\012uint16 __ovld __cnfn rhadd(uint16 x, uint16 y);\012long __ovld __cnfn rhadd(long x, long y);\012ulong __ovld __cnfn rhadd(ulong x, ulong y);\012long2 __ovld __cnfn rhadd(long2 x, long2 y);\012ulong2 __ovld __cnfn rhadd(ulong2 x, ulong2 y);\012long3 __ovld __cnfn rhadd(long3 x, long3 y);\012ulong3 __ovld __cnfn rhadd(ulong3 x, ulong3 y);\012long4 __ovld __cnfn rhadd(long4 x, long4 y);\012ulong4 __ovld __cnfn rhadd(ulong4 x, ulong4 y);\012long8 __ovld __cnf",
"n rhadd(long8 x, long8 y);\012ulong8 __ovld __cnfn rhadd(ulong8 x, ulong8 y);\012long16 __ovld __cnfn rhadd(long16 x, long16 y);\012ulong16 __ovld __cnfn rhadd(ulong16 x, ulong16 y);\012\012/**\012 * Returns min(max(x, minval), maxval).\012 * Results are undefined if minval > maxval.\012 */\012char __ovld __cnfn clamp(char x, char minval, char maxval);\012uchar __ovld __cnfn clamp(uchar x, uchar minval, uchar maxval);\012char2 __ovld __cnfn clamp(char2 x, char2 minval, char2 maxval);\012uchar2 __ovld __cnfn clamp(uchar2 x, uchar2 minval, uchar2 maxval);\012char3 __ovld __cnfn clamp(char3 x, char3 minval, char3 maxval);\012uchar3 __ovld __cnfn clamp(uchar3 x, uchar3 minval, uchar3 maxval);\012char4 __ovld __cnfn clamp(char4 x, char4 minval, char4 maxval);\012uchar4 __ovld __cnfn clamp(uchar4 x, uchar4 minval, uchar4 maxval);\012char8 __ovld __cnfn clamp(char8 x, char8 minval, char8 maxval);\012uchar8 __ovld __cnfn clamp(uchar8 x, uchar8 minval, uchar8 maxval);\012char16 __ovld __cnfn clamp(char16 x, char16 minval, char16 maxval);\012uchar16 __ovld __cnfn clamp(uchar16 ",
"x, uchar16 minval, uchar16 maxval);\012short __ovld __cnfn clamp(short x, short minval, short maxval);\012ushort __ovld __cnfn clamp(ushort x, ushort minval, ushort maxval);\012short2 __ovld __cnfn clamp(short2 x, short2 minval, short2 maxval);\012ushort2 __ovld __cnfn clamp(ushort2 x, ushort2 minval, ushort2 maxval);\012short3 __ovld __cnfn clamp(short3 x, short3 minval, short3 maxval);\012ushort3 __ovld __cnfn clamp(ushort3 x, ushort3 minval, ushort3 maxval);\012short4 __ovld __cnfn clamp(short4 x, short4 minval, short4 maxval);\012ushort4 __ovld __cnfn clamp(ushort4 x, ushort4 minval, ushort4 maxval);\012short8 __ovld __cnfn clamp(short8 x, short8 minval, short8 maxval);\012ushort8 __ovld __cnfn clamp(ushort8 x, ushort8 minval, ushort8 maxval);\012short16 __ovld __cnfn clamp(short16 x, short16 minval, short16 maxval);\012ushort16 __ovld __cnfn clamp(ushort16 x, ushort16 minval, ushort16 maxval);\012int __ovld __cnfn clamp(int x, int minval, int maxval);\012uint __ovld __cnfn clamp(uint x, uint minval, uint maxval);\012int2 __ovld __cnfn clamp(int2 x,",
" int2 minval, int2 maxval);\012uint2 __ovld __cnfn clamp(uint2 x, uint2 minval, uint2 maxval);\012int3 __ovld __cnfn clamp(int3 x, int3 minval, int3 maxval);\012uint3 __ovld __cnfn clamp(uint3 x, uint3 minval, uint3 maxval);\012int4 __ovld __cnfn clamp(int4 x, int4 minval, int4 maxval);\012uint4 __ovld __cnfn clamp(uint4 x, uint4 minval, uint4 maxval);\012int8 __ovld __cnfn clamp(int8 x, int8 minval, int8 maxval);\012uint8 __ovld __cnfn clamp(uint8 x, uint8 minval, uint8 maxval);\012int16 __ovld __cnfn clamp(int16 x, int16 minval, int16 maxval);\012uint16 __ovld __cnfn clamp(uint16 x, uint16 minval, uint16 maxval);\012long __ovld __cnfn clamp(long x, long minval, long maxval);\012ulong __ovld __cnfn clamp(ulong x, ulong minval, ulong maxval);\012long2 __ovld __cnfn clamp(long2 x, long2 minval, long2 maxval);\012ulong2 __ovld __cnfn clamp(ulong2 x, ulong2 minval, ulong2 maxval);\012long3 __ovld __cnfn clamp(long3 x, long3 minval, long3 maxval);\012ulong3 __ovld __cnfn clamp(ulong3 x, ulong3 minval, ulong3 maxval);\012long4 __ovld __cnfn clamp(long4 x, long4",
" minval, long4 maxval);\012ulong4 __ovld __cnfn clamp(ulong4 x, ulong4 minval, ulong4 maxval);\012long8 __ovld __cnfn clamp(long8 x, long8 minval, long8 maxval);\012ulong8 __ovld __cnfn clamp(ulong8 x, ulong8 minval, ulong8 maxval);\012long16 __ovld __cnfn clamp(long16 x, long16 minval, long16 maxval);\012ulong16 __ovld __cnfn clamp(ulong16 x, ulong16 minval, ulong16 maxval);\012char __ovld __cnfn clamp(char x, char minval, char maxval);\012uchar __ovld __cnfn clamp(uchar x, uchar minval, uchar maxval);\012char2 __ovld __cnfn clamp(char2 x, char minval, char maxval);\012uchar2 __ovld __cnfn clamp(uchar2 x, uchar minval, uchar maxval);\012char3 __ovld __cnfn clamp(char3 x, char minval, char maxval);\012uchar3 __ovld __cnfn clamp(uchar3 x, uchar minval, uchar maxval);\012char4 __ovld __cnfn clamp(char4 x, char minval, char maxval);\012uchar4 __ovld __cnfn clamp(uchar4 x, uchar minval, uchar maxval);\012char8 __ovld __cnfn clamp(char8 x, char minval, char maxval);\012uchar8 __ovld __cnfn clamp(uchar8 x, uchar minval, uchar maxval);\012char16 __ovld __cnfn cla",
"mp(char16 x, char minval, char maxval);\012uchar16 __ovld __cnfn clamp(uchar16 x, uchar minval, uchar maxval);\012short __ovld __cnfn clamp(short x, short minval, short maxval);\012ushort __ovld __cnfn clamp(ushort x, ushort minval, ushort maxval);\012short2 __ovld __cnfn clamp(short2 x, short minval, short maxval);\012ushort2 __ovld __cnfn clamp(ushort2 x, ushort minval, ushort maxval);\012short3 __ovld __cnfn clamp(short3 x, short minval, short maxval);\012ushort3 __ovld __cnfn clamp(ushort3 x, ushort minval, ushort maxval);\012short4 __ovld __cnfn clamp(short4 x, short minval, short maxval);\012ushort4 __ovld __cnfn clamp(ushort4 x, ushort minval, ushort maxval);\012short8 __ovld __cnfn clamp(short8 x, short minval, short maxval);\012ushort8 __ovld __cnfn clamp(ushort8 x, ushort minval, ushort maxval);\012short16 __ovld __cnfn clamp(short16 x, short minval, short maxval);\012ushort16 __ovld __cnfn clamp(ushort16 x, ushort minval, ushort maxval);\012int __ovld __cnfn clamp(int x, int minval, int maxval);\012uint __ovld __cnfn clamp(uint x, uint minval",
", uint maxval);\012int2 __ovld __cnfn clamp(int2 x, int minval, int maxval);\012uint2 __ovld __cnfn clamp(uint2 x, uint minval, uint maxval);\012int3 __ovld __cnfn clamp(int3 x, int minval, int maxval);\012uint3 __ovld __cnfn clamp(uint3 x, uint minval, uint maxval);\012int4 __ovld __cnfn clamp(int4 x, int minval, int maxval);\012uint4 __ovld __cnfn clamp(uint4 x, uint minval, uint maxval);\012int8 __ovld __cnfn clamp(int8 x, int minval, int maxval);\012uint8 __ovld __cnfn clamp(uint8 x, uint minval, uint maxval);\012int16 __ovld __cnfn clamp(int16 x, int minval, int maxval);\012uint16 __ovld __cnfn clamp(uint16 x, uint minval, uint maxval);\012long __ovld __cnfn clamp(long x, long minval, long maxval);\012ulong __ovld __cnfn clamp(ulong x, ulong minval, ulong maxval);\012long2 __ovld __cnfn clamp(long2 x, long minval, long maxval);\012ulong2 __ovld __cnfn clamp(ulong2 x, ulong minval, ulong maxval);\012long3 __ovld __cnfn clamp(long3 x, long minval, long maxval);\012ulong3 __ovld __cnfn clamp(ulong3 x, ulong minval, ulong maxval);\012long4 __ovld __cnfn clam",
"p(long4 x, long minval, long maxval);\012ulong4 __ovld __cnfn clamp(ulong4 x, ulong minval, ulong maxval);\012long8 __ovld __cnfn clamp(long8 x, long minval, long maxval);\012ulong8 __ovld __cnfn clamp(ulong8 x, ulong minval, ulong maxval);\012long16 __ovld __cnfn clamp(long16 x, long minval, long maxval);\012ulong16 __ovld __cnfn clamp(ulong16 x, ulong minval, ulong maxval);\012\012/**\012 * Returns the number of leading 0-bits in x, starting\012 * at the most significant bit position.\012 */\012char __ovld __cnfn clz(char x);\012uchar __ovld __cnfn clz(uchar x);\012char2 __ovld __cnfn clz(char2 x);\012uchar2 __ovld __cnfn clz(uchar2 x);\012char3 __ovld __cnfn clz(char3 x);\012uchar3 __ovld __cnfn clz(uchar3 x);\012char4 __ovld __cnfn clz(char4 x);\012uchar4 __ovld __cnfn clz(uchar4 x);\012char8 __ovld __cnfn clz(char8 x);\012uchar8 __ovld __cnfn clz(uchar8 x);\012char16 __ovld __cnfn clz(char16 x);\012uchar16 __ovld __cnfn clz(uchar16 x);\012short __ovld __cnfn clz(short x);\012ushort __ovld __cnfn clz(ushort x);\012short2 __ovld __cnfn clz(short2 x);\012ushort2 __ovld __cnfn clz(ush",
"ort2 x);\012short3 __ovld __cnfn clz(short3 x);\012ushort3 __ovld __cnfn clz(ushort3 x);\012short4 __ovld __cnfn clz(short4 x);\012ushort4 __ovld __cnfn clz(ushort4 x);\012short8 __ovld __cnfn clz(short8 x);\012ushort8 __ovld __cnfn clz(ushort8 x);\012short16 __ovld __cnfn clz(short16 x);\012ushort16 __ovld __cnfn clz(ushort16 x);\012int __ovld __cnfn clz(int x);\012uint __ovld __cnfn clz(uint x);\012int2 __ovld __cnfn clz(int2 x);\012uint2 __ovld __cnfn clz(uint2 x);\012int3 __ovld __cnfn clz(int3 x);\012uint3 __ovld __cnfn clz(uint3 x);\012int4 __ovld __cnfn clz(int4 x);\012uint4 __ovld __cnfn clz(uint4 x);\012int8 __ovld __cnfn clz(int8 x);\012uint8 __ovld __cnfn clz(uint8 x);\012int16 __ovld __cnfn clz(int16 x);\012uint16 __ovld __cnfn clz(uint16 x);\012long __ovld __cnfn clz(long x);\012ulong __ovld __cnfn clz(ulong x);\012long2 __ovld __cnfn clz(long2 x);\012ulong2 __ovld __cnfn clz(ulong2 x);\012long3 __ovld __cnfn clz(long3 x);\012ulong3 __ovld __cnfn clz(ulong3 x);\012long4 __ovld __cnfn clz(long4 x);\012ulong4 __ovld __cnfn clz(ulong4 x);\012long8 __ovld __cnfn clz(long8 x);\012ulong8 __",
"ovld __cnfn clz(ulong8 x);\012long16 __ovld __cnfn clz(long16 x);\012ulong16 __ovld __cnfn clz(ulong16 x);\012\012/**\012 * Returns mul_hi(a, b) + c.\012 */\012char __ovld __cnfn mad_hi(char a, char b, char c);\012uchar __ovld __cnfn mad_hi(uchar a, uchar b, uchar c);\012char2 __ovld __cnfn mad_hi(char2 a, char2 b, char2 c);\012uchar2 __ovld __cnfn mad_hi(uchar2 a, uchar2 b, uchar2 c);\012char3 __ovld __cnfn mad_hi(char3 a, char3 b, char3 c);\012uchar3 __ovld __cnfn mad_hi(uchar3 a, uchar3 b, uchar3 c);\012char4 __ovld __cnfn mad_hi(char4 a, char4 b, char4 c);\012uchar4 __ovld __cnfn mad_hi(uchar4 a, uchar4 b, uchar4 c);\012char8 __ovld __cnfn mad_hi(char8 a, char8 b, char8 c);\012uchar8 __ovld __cnfn mad_hi(uchar8 a, uchar8 b, uchar8 c);\012char16 __ovld __cnfn mad_hi(char16 a, char16 b, char16 c);\012uchar16 __ovld __cnfn mad_hi(uchar16 a, uchar16 b, uchar16 c);\012short __ovld __cnfn mad_hi(short a, short b, short c);\012ushort __ovld __cnfn mad_hi(ushort a, ushort b, ushort c);\012short2 __ovld __cnfn mad_hi(short2 a, short2 b, short2 c);\012ushort2 __ovld __cnfn mad_hi",
"(ushort2 a, ushort2 b, ushort2 c);\012short3 __ovld __cnfn mad_hi(short3 a, short3 b, short3 c);\012ushort3 __ovld __cnfn mad_hi(ushort3 a, ushort3 b, ushort3 c);\012short4 __ovld __cnfn mad_hi(short4 a, short4 b, short4 c);\012ushort4 __ovld __cnfn mad_hi(ushort4 a, ushort4 b, ushort4 c);\012short8 __ovld __cnfn mad_hi(short8 a, short8 b, short8 c);\012ushort8 __ovld __cnfn mad_hi(ushort8 a, ushort8 b, ushort8 c);\012short16 __ovld __cnfn mad_hi(short16 a, short16 b, short16 c);\012ushort16 __ovld __cnfn mad_hi(ushort16 a, ushort16 b, ushort16 c);\012int __ovld __cnfn mad_hi(int a, int b, int c);\012uint __ovld __cnfn mad_hi(uint a, uint b, uint c);\012int2 __ovld __cnfn mad_hi(int2 a, int2 b, int2 c);\012uint2 __ovld __cnfn mad_hi(uint2 a, uint2 b, uint2 c);\012int3 __ovld __cnfn mad_hi(int3 a, int3 b, int3 c);\012uint3 __ovld __cnfn mad_hi(uint3 a, uint3 b, uint3 c);\012int4 __ovld __cnfn mad_hi(int4 a, int4 b, int4 c);\012uint4 __ovld __cnfn mad_hi(uint4 a, uint4 b, uint4 c);\012int8 __ovld __cnfn mad_hi(int8 a, int8 b, int8 c);\012uint8 __ovld __cnfn mad_hi",
"(uint8 a, uint8 b, uint8 c);\012int16 __ovld __cnfn mad_hi(int16 a, int16 b, int16 c);\012uint16 __ovld __cnfn mad_hi(uint16 a, uint16 b, uint16 c);\012long __ovld __cnfn mad_hi(long a, long b, long c);\012ulong __ovld __cnfn mad_hi(ulong a, ulong b, ulong c);\012long2 __ovld __cnfn mad_hi(long2 a, long2 b, long2 c);\012ulong2 __ovld __cnfn mad_hi(ulong2 a, ulong2 b, ulong2 c);\012long3 __ovld __cnfn mad_hi(long3 a, long3 b, long3 c);\012ulong3 __ovld __cnfn mad_hi(ulong3 a, ulong3 b, ulong3 c);\012long4 __ovld __cnfn mad_hi(long4 a, long4 b, long4 c);\012ulong4 __ovld __cnfn mad_hi(ulong4 a, ulong4 b, ulong4 c);\012long8 __ovld __cnfn mad_hi(long8 a, long8 b, long8 c);\012ulong8 __ovld __cnfn mad_hi(ulong8 a, ulong8 b, ulong8 c);\012long16 __ovld __cnfn mad_hi(long16 a, long16 b, long16 c);\012ulong16 __ovld __cnfn mad_hi(ulong16 a, ulong16 b, ulong16 c);\012\012/**\012 * Returns a * b + c and saturates the result.\012 */\012char __ovld __cnfn mad_sat(char a, char b, char c);\012uchar __ovld __cnfn mad_sat(uchar a, uchar b, uchar c);\012char2 __ovld __cnfn mad_sat(char2",
" a, char2 b, char2 c);\012uchar2 __ovld __cnfn mad_sat(uchar2 a, uchar2 b, uchar2 c);\012char3 __ovld __cnfn mad_sat(char3 a, char3 b, char3 c);\012uchar3 __ovld __cnfn mad_sat(uchar3 a, uchar3 b, uchar3 c);\012char4 __ovld __cnfn mad_sat(char4 a, char4 b, char4 c);\012uchar4 __ovld __cnfn mad_sat(uchar4 a, uchar4 b, uchar4 c);\012char8 __ovld __cnfn mad_sat(char8 a, char8 b, char8 c);\012uchar8 __ovld __cnfn mad_sat(uchar8 a, uchar8 b, uchar8 c);\012char16 __ovld __cnfn mad_sat(char16 a, char16 b, char16 c);\012uchar16 __ovld __cnfn mad_sat(uchar16 a, uchar16 b, uchar16 c);\012short __ovld __cnfn mad_sat(short a, short b, short c);\012ushort __ovld __cnfn mad_sat(ushort a, ushort b, ushort c);\012short2 __ovld __cnfn mad_sat(short2 a, short2 b, short2 c);\012ushort2 __ovld __cnfn mad_sat(ushort2 a, ushort2 b, ushort2 c);\012short3 __ovld __cnfn mad_sat(short3 a, short3 b, short3 c);\012ushort3 __ovld __cnfn mad_sat(ushort3 a, ushort3 b, ushort3 c);\012short4 __ovld __cnfn mad_sat(short4 a, short4 b, short4 c);\012ushort4 __ovld __cnfn mad_sat(ushort4 a, usho",
"rt4 b, ushort4 c);\012short8 __ovld __cnfn mad_sat(short8 a, short8 b, short8 c);\012ushort8 __ovld __cnfn mad_sat(ushort8 a, ushort8 b, ushort8 c);\012short16 __ovld __cnfn mad_sat(short16 a, short16 b, short16 c);\012ushort16 __ovld __cnfn mad_sat(ushort16 a, ushort16 b, ushort16 c);\012int __ovld __cnfn mad_sat(int a, int b, int c);\012uint __ovld __cnfn mad_sat(uint a, uint b, uint c);\012int2 __ovld __cnfn mad_sat(int2 a, int2 b, int2 c);\012uint2 __ovld __cnfn mad_sat(uint2 a, uint2 b, uint2 c);\012int3 __ovld __cnfn mad_sat(int3 a, int3 b, int3 c);\012uint3 __ovld __cnfn mad_sat(uint3 a, uint3 b, uint3 c);\012int4 __ovld __cnfn mad_sat(int4 a, int4 b, int4 c);\012uint4 __ovld __cnfn mad_sat(uint4 a, uint4 b, uint4 c);\012int8 __ovld __cnfn mad_sat(int8 a, int8 b, int8 c);\012uint8 __ovld __cnfn mad_sat(uint8 a, uint8 b, uint8 c);\012int16 __ovld __cnfn mad_sat(int16 a, int16 b, int16 c);\012uint16 __ovld __cnfn mad_sat(uint16 a, uint16 b, uint16 c);\012long __ovld __cnfn mad_sat(long a, long b, long c);\012ulong __ovld __cnfn mad_sat(ulong a, ulong b, ulo",
"ng c);\012long2 __ovld __cnfn mad_sat(long2 a, long2 b, long2 c);\012ulong2 __ovld __cnfn mad_sat(ulong2 a, ulong2 b, ulong2 c);\012long3 __ovld __cnfn mad_sat(long3 a, long3 b, long3 c);\012ulong3 __ovld __cnfn mad_sat(ulong3 a, ulong3 b, ulong3 c);\012long4 __ovld __cnfn mad_sat(long4 a, long4 b, long4 c);\012ulong4 __ovld __cnfn mad_sat(ulong4 a, ulong4 b, ulong4 c);\012long8 __ovld __cnfn mad_sat(long8 a, long8 b, long8 c);\012ulong8 __ovld __cnfn mad_sat(ulong8 a, ulong8 b, ulong8 c);\012long16 __ovld __cnfn mad_sat(long16 a, long16 b, long16 c);\012ulong16 __ovld __cnfn mad_sat(ulong16 a, ulong16 b, ulong16 c);\012\012/**\012 * Returns y if x < y, otherwise it returns x.\012 */\012char __ovld __cnfn max(char x, char y);\012uchar __ovld __cnfn max(uchar x, uchar y);\012char2 __ovld __cnfn max(char2 x, char2 y);\012uchar2 __ovld __cnfn max(uchar2 x, uchar2 y);\012char3 __ovld __cnfn max(char3 x, char3 y);\012uchar3 __ovld __cnfn max(uchar3 x, uchar3 y);\012char4 __ovld __cnfn max(char4 x, char4 y);\012uchar4 __ovld __cnfn max(uchar4 x, uchar4 y);\012char8 __ovld __cnfn max",
"(char8 x, char8 y);\012uchar8 __ovld __cnfn max(uchar8 x, uchar8 y);\012char16 __ovld __cnfn max(char16 x, char16 y);\012uchar16 __ovld __cnfn max(uchar16 x, uchar16 y);\012short __ovld __cnfn max(short x, short y);\012ushort __ovld __cnfn max(ushort x, ushort y);\012short2 __ovld __cnfn max(short2 x, short2 y);\012ushort2 __ovld __cnfn max(ushort2 x, ushort2 y);\012short3 __ovld __cnfn max(short3 x, short3 y);\012ushort3 __ovld __cnfn max(ushort3 x, ushort3 y);\012short4 __ovld __cnfn max(short4 x, short4 y);\012ushort4 __ovld __cnfn max(ushort4 x, ushort4 y);\012short8 __ovld __cnfn max(short8 x, short8 y);\012ushort8 __ovld __cnfn max(ushort8 x, ushort8 y);\012short16 __ovld __cnfn max(short16 x, short16 y);\012ushort16 __ovld __cnfn max(ushort16 x, ushort16 y);\012int __ovld __cnfn max(int x, int y);\012uint __ovld __cnfn max(uint x, uint y);\012int2 __ovld __cnfn max(int2 x, int2 y);\012uint2 __ovld __cnfn max(uint2 x, uint2 y);\012int3 __ovld __cnfn max(int3 x, int3 y);\012uint3 __ovld __cnfn max(uint3 x, uint3 y);\012int4 __ovld __cnfn max(int4 x, int4 y);\012uint4 __ov",
"ld __cnfn max(uint4 x, uint4 y);\012int8 __ovld __cnfn max(int8 x, int8 y);\012uint8 __ovld __cnfn max(uint8 x, uint8 y);\012int16 __ovld __cnfn max(int16 x, int16 y);\012uint16 __ovld __cnfn max(uint16 x, uint16 y);\012long __ovld __cnfn max(long x, long y);\012ulong __ovld __cnfn max(ulong x, ulong y);\012long2 __ovld __cnfn max(long2 x, long2 y);\012ulong2 __ovld __cnfn max(ulong2 x, ulong2 y);\012long3 __ovld __cnfn max(long3 x, long3 y);\012ulong3 __ovld __cnfn max(ulong3 x, ulong3 y);\012long4 __ovld __cnfn max(long4 x, long4 y);\012ulong4 __ovld __cnfn max(ulong4 x, ulong4 y);\012long8 __ovld __cnfn max(long8 x, long8 y);\012ulong8 __ovld __cnfn max(ulong8 x, ulong8 y);\012long16 __ovld __cnfn max(long16 x, long16 y);\012ulong16 __ovld __cnfn max(ulong16 x, ulong16 y);\012char __ovld __cnfn max(char x, char y);\012uchar __ovld __cnfn max(uchar x, uchar y);\012char2 __ovld __cnfn max(char2 x, char y);\012uchar2 __ovld __cnfn max(uchar2 x, uchar y);\012char3 __ovld __cnfn max(char3 x, char y);\012uchar3 __ovld __cnfn max(uchar3 x, uchar y);\012char4 __ovld __cnfn max(char",
"4 x, char y);\012uchar4 __ovld __cnfn max(uchar4 x, uchar y);\012char8 __ovld __cnfn max(char8 x, char y);\012uchar8 __ovld __cnfn max(uchar8 x, uchar y);\012char16 __ovld __cnfn max(char16 x, char y);\012uchar16 __ovld __cnfn max(uchar16 x, uchar y);\012short __ovld __cnfn max(short x, short y);\012ushort __ovld __cnfn max(ushort x, ushort y);\012short2 __ovld __cnfn max(short2 x, short y);\012ushort2 __ovld __cnfn max(ushort2 x, ushort y);\012short3 __ovld __cnfn max(short3 x, short y);\012ushort3 __ovld __cnfn max(ushort3 x, ushort y);\012short4 __ovld __cnfn max(short4 x, short y);\012ushort4 __ovld __cnfn max(ushort4 x, ushort y);\012short8 __ovld __cnfn max(short8 x, short y);\012ushort8 __ovld __cnfn max(ushort8 x, ushort y);\012short16 __ovld __cnfn max(short16 x, short y);\012ushort16 __ovld __cnfn max(ushort16 x, ushort y);\012int __ovld __cnfn max(int x, int y);\012uint __ovld __cnfn max(uint x, uint y);\012int2 __ovld __cnfn max(int2 x, int y);\012uint2 __ovld __cnfn max(uint2 x, uint y);\012int3 __ovld __cnfn max(int3 x, int y);\012uint3 __ovld __cnfn max(uint3 x,",
" uint y);\012int4 __ovld __cnfn max(int4 x, int y);\012uint4 __ovld __cnfn max(uint4 x, uint y);\012int8 __ovld __cnfn max(int8 x, int y);\012uint8 __ovld __cnfn max(uint8 x, uint y);\012int16 __ovld __cnfn max(int16 x, int y);\012uint16 __ovld __cnfn max(uint16 x, uint y);\012long __ovld __cnfn max(long x, long y);\012ulong __ovld __cnfn max(ulong x, ulong y);\012long2 __ovld __cnfn max(long2 x, long y);\012ulong2 __ovld __cnfn max(ulong2 x, ulong y);\012long3 __ovld __cnfn max(long3 x, long y);\012ulong3 __ovld __cnfn max(ulong3 x, ulong y);\012long4 __ovld __cnfn max(long4 x, long y);\012ulong4 __ovld __cnfn max(ulong4 x, ulong y);\012long8 __ovld __cnfn max(long8 x, long y);\012ulong8 __ovld __cnfn max(ulong8 x, ulong y);\012long16 __ovld __cnfn max(long16 x, long y);\012ulong16 __ovld __cnfn max(ulong16 x, ulong y);\012\012/**\012 * Returns y if y < x, otherwise it returns x.\012 */\012char __ovld __cnfn min(char x, char y);\012uchar __ovld __cnfn min(uchar x, uchar y);\012char2 __ovld __cnfn min(char2 x, char2 y);\012uchar2 __ovld __cnfn min(uchar2 x, uchar2 y);\012char3 __ovld __cn",
"fn min(char3 x, char3 y);\012uchar3 __ovld __cnfn min(uchar3 x, uchar3 y);\012char4 __ovld __cnfn min(char4 x, char4 y);\012uchar4 __ovld __cnfn min(uchar4 x, uchar4 y);\012char8 __ovld __cnfn min(char8 x, char8 y);\012uchar8 __ovld __cnfn min(uchar8 x, uchar8 y);\012char16 __ovld __cnfn min(char16 x, char16 y);\012uchar16 __ovld __cnfn min(uchar16 x, uchar16 y);\012short __ovld __cnfn min(short x, short y);\012ushort __ovld __cnfn min(ushort x, ushort y);\012short2 __ovld __cnfn min(short2 x, short2 y);\012ushort2 __ovld __cnfn min(ushort2 x, ushort2 y);\012short3 __ovld __cnfn min(short3 x, short3 y);\012ushort3 __ovld __cnfn min(ushort3 x, ushort3 y);\012short4 __ovld __cnfn min(short4 x, short4 y);\012ushort4 __ovld __cnfn min(ushort4 x, ushort4 y);\012short8 __ovld __cnfn min(short8 x, short8 y);\012ushort8 __ovld __cnfn min(ushort8 x, ushort8 y);\012short16 __ovld __cnfn min(short16 x, short16 y);\012ushort16 __ovld __cnfn min(ushort16 x, ushort16 y);\012int __ovld __cnfn min(int x, int y);\012uint __ovld __cnfn min(uint x, uint y);\012int2 __ovld __cnfn min(int2 x, i",
"nt2 y);\012uint2 __ovld __cnfn min(uint2 x, uint2 y);\012int3 __ovld __cnfn min(int3 x, int3 y);\012uint3 __ovld __cnfn min(uint3 x, uint3 y);\012int4 __ovld __cnfn min(int4 x, int4 y);\012uint4 __ovld __cnfn min(uint4 x, uint4 y);\012int8 __ovld __cnfn min(int8 x, int8 y);\012uint8 __ovld __cnfn min(uint8 x, uint8 y);\012int16 __ovld __cnfn min(int16 x, int16 y);\012uint16 __ovld __cnfn min(uint16 x, uint16 y);\012long __ovld __cnfn min(long x, long y);\012ulong __ovld __cnfn min(ulong x, ulong y);\012long2 __ovld __cnfn min(long2 x, long2 y);\012ulong2 __ovld __cnfn min(ulong2 x, ulong2 y);\012long3 __ovld __cnfn min(long3 x, long3 y);\012ulong3 __ovld __cnfn min(ulong3 x, ulong3 y);\012long4 __ovld __cnfn min(long4 x, long4 y);\012ulong4 __ovld __cnfn min(ulong4 x, ulong4 y);\012long8 __ovld __cnfn min(long8 x, long8 y);\012ulong8 __ovld __cnfn min(ulong8 x, ulong8 y);\012long16 __ovld __cnfn min(long16 x, long16 y);\012ulong16 __ovld __cnfn min(ulong16 x, ulong16 y);\012char __ovld __cnfn min(char x, char y);\012uchar __ovld __cnfn min(uchar x, uchar y);\012char2 __ovld __cnf",
"n min(char2 x, char y);\012uchar2 __ovld __cnfn min(uchar2 x, uchar y);\012char3 __ovld __cnfn min(char3 x, char y);\012uchar3 __ovld __cnfn min(uchar3 x, uchar y);\012char4 __ovld __cnfn min(char4 x, char y);\012uchar4 __ovld __cnfn min(uchar4 x, uchar y);\012char8 __ovld __cnfn min(char8 x, char y);\012uchar8 __ovld __cnfn min(uchar8 x, uchar y);\012char16 __ovld __cnfn min(char16 x, char y);\012uchar16 __ovld __cnfn min(uchar16 x, uchar y);\012short __ovld __cnfn min(short x, short y);\012ushort __ovld __cnfn min(ushort x, ushort y);\012short2 __ovld __cnfn min(short2 x, short y);\012ushort2 __ovld __cnfn min(ushort2 x, ushort y);\012short3 __ovld __cnfn min(short3 x, short y);\012ushort3 __ovld __cnfn min(ushort3 x, ushort y);\012short4 __ovld __cnfn min(short4 x, short y);\012ushort4 __ovld __cnfn min(ushort4 x, ushort y);\012short8 __ovld __cnfn min(short8 x, short y);\012ushort8 __ovld __cnfn min(ushort8 x, ushort y);\012short16 __ovld __cnfn min(short16 x, short y);\012ushort16 __ovld __cnfn min(ushort16 x, ushort y);\012int __ovld __cnfn min(int x, int y);\012uint __o",
"vld __cnfn min(uint x, uint y);\012int2 __ovld __cnfn min(int2 x, int y);\012uint2 __ovld __cnfn min(uint2 x, uint y);\012int3 __ovld __cnfn min(int3 x, int y);\012uint3 __ovld __cnfn min(uint3 x, uint y);\012int4 __ovld __cnfn min(int4 x, int y);\012uint4 __ovld __cnfn min(uint4 x, uint y);\012int8 __ovld __cnfn min(int8 x, int y);\012uint8 __ovld __cnfn min(uint8 x, uint y);\012int16 __ovld __cnfn min(int16 x, int y);\012uint16 __ovld __cnfn min(uint16 x, uint y);\012long __ovld __cnfn min(long x, long y);\012ulong __ovld __cnfn min(ulong x, ulong y);\012long2 __ovld __cnfn min(long2 x, long y);\012ulong2 __ovld __cnfn min(ulong2 x, ulong y);\012long3 __ovld __cnfn min(long3 x, long y);\012ulong3 __ovld __cnfn min(ulong3 x, ulong y);\012long4 __ovld __cnfn min(long4 x, long y);\012ulong4 __ovld __cnfn min(ulong4 x, ulong y);\012long8 __ovld __cnfn min(long8 x, long y);\012ulong8 __ovld __cnfn min(ulong8 x, ulong y);\012long16 __ovld __cnfn min(long16 x, long y);\012ulong16 __ovld __cnfn min(ulong16 x, ulong y);\012\012/**\012 * Computes x * y and returns the high half of the\012 * pr",
"oduct of x and y.\012 */\012char __ovld __cnfn mul_hi(char x, char y);\012uchar __ovld __cnfn mul_hi(uchar x, uchar y);\012char2 __ovld __cnfn mul_hi(char2 x, char2 y);\012uchar2 __ovld __cnfn mul_hi(uchar2 x, uchar2 y);\012char3 __ovld __cnfn mul_hi(char3 x, char3 y);\012uchar3 __ovld __cnfn mul_hi(uchar3 x, uchar3 y);\012char4 __ovld __cnfn mul_hi(char4 x, char4 y);\012uchar4 __ovld __cnfn mul_hi(uchar4 x, uchar4 y);\012char8 __ovld __cnfn mul_hi(char8 x, char8 y);\012uchar8 __ovld __cnfn mul_hi(uchar8 x, uchar8 y);\012char16 __ovld __cnfn mul_hi(char16 x, char16 y);\012uchar16 __ovld __cnfn mul_hi(uchar16 x, uchar16 y);\012short __ovld __cnfn mul_hi(short x, short y);\012ushort __ovld __cnfn mul_hi(ushort x, ushort y);\012short2 __ovld __cnfn mul_hi(short2 x, short2 y);\012ushort2 __ovld __cnfn mul_hi(ushort2 x, ushort2 y);\012short3 __ovld __cnfn mul_hi(short3 x, short3 y);\012ushort3 __ovld __cnfn mul_hi(ushort3 x, ushort3 y);\012short4 __ovld __cnfn mul_hi(short4 x, short4 y);\012ushort4 __ovld __cnfn mul_hi(ushort4 x, ushort4 y);\012short8 __ovld __cnfn mul_hi(short8",
" x, short8 y);\012ushort8 __ovld __cnfn mul_hi(ushort8 x, ushort8 y);\012short16 __ovld __cnfn mul_hi(short16 x, short16 y);\012ushort16 __ovld __cnfn mul_hi(ushort16 x, ushort16 y);\012int __ovld __cnfn mul_hi(int x, int y);\012uint __ovld __cnfn mul_hi(uint x, uint y);\012int2 __ovld __cnfn mul_hi(int2 x, int2 y);\012uint2 __ovld __cnfn mul_hi(uint2 x, uint2 y);\012int3 __ovld __cnfn mul_hi(int3 x, int3 y);\012uint3 __ovld __cnfn mul_hi(uint3 x, uint3 y);\012int4 __ovld __cnfn mul_hi(int4 x, int4 y);\012uint4 __ovld __cnfn mul_hi(uint4 x, uint4 y);\012int8 __ovld __cnfn mul_hi(int8 x, int8 y);\012uint8 __ovld __cnfn mul_hi(uint8 x, uint8 y);\012int16 __ovld __cnfn mul_hi(int16 x, int16 y);\012uint16 __ovld __cnfn mul_hi(uint16 x, uint16 y);\012long __ovld __cnfn mul_hi(long x, long y);\012ulong __ovld __cnfn mul_hi(ulong x, ulong y);\012long2 __ovld __cnfn mul_hi(long2 x, long2 y);\012ulong2 __ovld __cnfn mul_hi(ulong2 x, ulong2 y);\012long3 __ovld __cnfn mul_hi(long3 x, long3 y);\012ulong3 __ovld __cnfn mul_hi(ulong3 x, ulong3 y);\012long4 __ovld __cnfn mul_hi(long4 x, l",
"ong4 y);\012ulong4 __ovld __cnfn mul_hi(ulong4 x, ulong4 y);\012long8 __ovld __cnfn mul_hi(long8 x, long8 y);\012ulong8 __ovld __cnfn mul_hi(ulong8 x, ulong8 y);\012long16 __ovld __cnfn mul_hi(long16 x, long16 y);\012ulong16 __ovld __cnfn mul_hi(ulong16 x, ulong16 y);\012\012/**\012 * For each element in v, the bits are shifted left by\012 * the number of bits given by the corresponding\012 * element in i (subject to usual shift modulo rules\012 * described in section 6.3). Bits shifted off the left\012 * side of the element are shifted back in from the\012 * right.\012 */\012char __ovld __cnfn rotate(char v, char i);\012uchar __ovld __cnfn rotate(uchar v, uchar i);\012char2 __ovld __cnfn rotate(char2 v, char2 i);\012uchar2 __ovld __cnfn rotate(uchar2 v, uchar2 i);\012char3 __ovld __cnfn rotate(char3 v, char3 i);\012uchar3 __ovld __cnfn rotate(uchar3 v, uchar3 i);\012char4 __ovld __cnfn rotate(char4 v, char4 i);\012uchar4 __ovld __cnfn rotate(uchar4 v, uchar4 i);\012char8 __ovld __cnfn rotate(char8 v, char8 i);\012uchar8 __ovld __cnfn rotate(uchar8 v, uchar8 i);\012char16 __ovld __c",
"nfn rotate(char16 v, char16 i);\012uchar16 __ovld __cnfn rotate(uchar16 v, uchar16 i);\012short __ovld __cnfn rotate(short v, short i);\012ushort __ovld __cnfn rotate(ushort v, ushort i);\012short2 __ovld __cnfn rotate(short2 v, short2 i);\012ushort2 __ovld __cnfn rotate(ushort2 v, ushort2 i);\012short3 __ovld __cnfn rotate(short3 v, short3 i);\012ushort3 __ovld __cnfn rotate(ushort3 v, ushort3 i);\012short4 __ovld __cnfn rotate(short4 v, short4 i);\012ushort4 __ovld __cnfn rotate(ushort4 v, ushort4 i);\012short8 __ovld __cnfn rotate(short8 v, short8 i);\012ushort8 __ovld __cnfn rotate(ushort8 v, ushort8 i);\012short16 __ovld __cnfn rotate(short16 v, short16 i);\012ushort16 __ovld __cnfn rotate(ushort16 v, ushort16 i);\012int __ovld __cnfn rotate(int v, int i);\012uint __ovld __cnfn rotate(uint v, uint i);\012int2 __ovld __cnfn rotate(int2 v, int2 i);\012uint2 __ovld __cnfn rotate(uint2 v, uint2 i);\012int3 __ovld __cnfn rotate(int3 v, int3 i);\012uint3 __ovld __cnfn rotate(uint3 v, uint3 i);\012int4 __ovld __cnfn rotate(int4 v, int4 i);\012uint4 __ovld __cnfn rotate(uin",
"t4 v, uint4 i);\012int8 __ovld __cnfn rotate(int8 v, int8 i);\012uint8 __ovld __cnfn rotate(uint8 v, uint8 i);\012int16 __ovld __cnfn rotate(int16 v, int16 i);\012uint16 __ovld __cnfn rotate(uint16 v, uint16 i);\012long __ovld __cnfn rotate(long v, long i);\012ulong __ovld __cnfn rotate(ulong v, ulong i);\012long2 __ovld __cnfn rotate(long2 v, long2 i);\012ulong2 __ovld __cnfn rotate(ulong2 v, ulong2 i);\012long3 __ovld __cnfn rotate(long3 v, long3 i);\012ulong3 __ovld __cnfn rotate(ulong3 v, ulong3 i);\012long4 __ovld __cnfn rotate(long4 v, long4 i);\012ulong4 __ovld __cnfn rotate(ulong4 v, ulong4 i);\012long8 __ovld __cnfn rotate(long8 v, long8 i);\012ulong8 __ovld __cnfn rotate(ulong8 v, ulong8 i);\012long16 __ovld __cnfn rotate(long16 v, long16 i);\012ulong16 __ovld __cnfn rotate(ulong16 v, ulong16 i);\012\012/**\012 * Returns x - y and saturates the result.\012 */\012char __ovld __cnfn sub_sat(char x, char y);\012uchar __ovld __cnfn sub_sat(uchar x, uchar y);\012char2 __ovld __cnfn sub_sat(char2 x, char2 y);\012uchar2 __ovld __cnfn sub_sat(uchar2 x, uchar2 y);\012char3 __ovld _",
"_cnfn sub_sat(char3 x, char3 y);\012uchar3 __ovld __cnfn sub_sat(uchar3 x, uchar3 y);\012char4 __ovld __cnfn sub_sat(char4 x, char4 y);\012uchar4 __ovld __cnfn sub_sat(uchar4 x, uchar4 y);\012char8 __ovld __cnfn sub_sat(char8 x, char8 y);\012uchar8 __ovld __cnfn sub_sat(uchar8 x, uchar8 y);\012char16 __ovld __cnfn sub_sat(char16 x, char16 y);\012uchar16 __ovld __cnfn sub_sat(uchar16 x, uchar16 y);\012short __ovld __cnfn sub_sat(short x, short y);\012ushort __ovld __cnfn sub_sat(ushort x, ushort y);\012short2 __ovld __cnfn sub_sat(short2 x, short2 y);\012ushort2 __ovld __cnfn sub_sat(ushort2 x, ushort2 y);\012short3 __ovld __cnfn sub_sat(short3 x, short3 y);\012ushort3 __ovld __cnfn sub_sat(ushort3 x, ushort3 y);\012short4 __ovld __cnfn sub_sat(short4 x, short4 y);\012ushort4 __ovld __cnfn sub_sat(ushort4 x, ushort4 y);\012short8 __ovld __cnfn sub_sat(short8 x, short8 y);\012ushort8 __ovld __cnfn sub_sat(ushort8 x, ushort8 y);\012short16 __ovld __cnfn sub_sat(short16 x, short16 y);\012ushort16 __ovld __cnfn sub_sat(ushort16 x, ushort16 y);\012int __ovld __cnfn sub_sat(",
"int x, int y);\012uint __ovld __cnfn sub_sat(uint x, uint y);\012int2 __ovld __cnfn sub_sat(int2 x, int2 y);\012uint2 __ovld __cnfn sub_sat(uint2 x, uint2 y);\012int3 __ovld __cnfn sub_sat(int3 x, int3 y);\012uint3 __ovld __cnfn sub_sat(uint3 x, uint3 y);\012int4 __ovld __cnfn sub_sat(int4 x, int4 y);\012uint4 __ovld __cnfn sub_sat(uint4 x, uint4 y);\012int8 __ovld __cnfn sub_sat(int8 x, int8 y);\012uint8 __ovld __cnfn sub_sat(uint8 x, uint8 y);\012int16 __ovld __cnfn sub_sat(int16 x, int16 y);\012uint16 __ovld __cnfn sub_sat(uint16 x, uint16 y);\012long __ovld __cnfn sub_sat(long x, long y);\012ulong __ovld __cnfn sub_sat(ulong x, ulong y);\012long2 __ovld __cnfn sub_sat(long2 x, long2 y);\012ulong2 __ovld __cnfn sub_sat(ulong2 x, ulong2 y);\012long3 __ovld __cnfn sub_sat(long3 x, long3 y);\012ulong3 __ovld __cnfn sub_sat(ulong3 x, ulong3 y);\012long4 __ovld __cnfn sub_sat(long4 x, long4 y);\012ulong4 __ovld __cnfn sub_sat(ulong4 x, ulong4 y);\012long8 __ovld __cnfn sub_sat(long8 x, long8 y);\012ulong8 __ovld __cnfn sub_sat(ulong8 x, ulong8 y);\012long16 __ovld __cnfn sub_",
"sat(long16 x, long16 y);\012ulong16 __ovld __cnfn sub_sat(ulong16 x, ulong16 y);\012\012/**\012 * result[i] = ((short)hi[i] << 8) | lo[i]\012 * result[i] = ((ushort)hi[i] << 8) | lo[i]\012 */\012short __ovld __cnfn upsample(char hi, uchar lo);\012ushort __ovld __cnfn upsample(uchar hi, uchar lo);\012short2 __ovld __cnfn upsample(char2 hi, uchar2 lo);\012short3 __ovld __cnfn upsample(char3 hi, uchar3 lo);\012short4 __ovld __cnfn upsample(char4 hi, uchar4 lo);\012short8 __ovld __cnfn upsample(char8 hi, uchar8 lo);\012short16 __ovld __cnfn upsample(char16 hi, uchar16 lo);\012ushort2 __ovld __cnfn upsample(uchar2 hi, uchar2 lo);\012ushort3 __ovld __cnfn upsample(uchar3 hi, uchar3 lo);\012ushort4 __ovld __cnfn upsample(uchar4 hi, uchar4 lo);\012ushort8 __ovld __cnfn upsample(uchar8 hi, uchar8 lo);\012ushort16 __ovld __cnfn upsample(uchar16 hi, uchar16 lo);\012\012/**\012 * result[i] = ((int)hi[i] << 16) | lo[i]\012 * result[i] = ((uint)hi[i] << 16) | lo[i]\012 */\012int __ovld __cnfn upsample(short hi, ushort lo);\012uint __ovld __cnfn upsample(ushort hi, ushort lo);\012int2 __ovld __cnfn u",
"psample(short2 hi, ushort2 lo);\012int3 __ovld __cnfn upsample(short3 hi, ushort3 lo);\012int4 __ovld __cnfn upsample(short4 hi, ushort4 lo);\012int8 __ovld __cnfn upsample(short8 hi, ushort8 lo);\012int16 __ovld __cnfn upsample(short16 hi, ushort16 lo);\012uint2 __ovld __cnfn upsample(ushort2 hi, ushort2 lo);\012uint3 __ovld __cnfn upsample(ushort3 hi, ushort3 lo);\012uint4 __ovld __cnfn upsample(ushort4 hi, ushort4 lo);\012uint8 __ovld __cnfn upsample(ushort8 hi, ushort8 lo);\012uint16 __ovld __cnfn upsample(ushort16 hi, ushort16 lo);\012/**\012 * result[i] = ((long)hi[i] << 32) | lo[i]\012 * result[i] = ((ulong)hi[i] << 32) | lo[i]\012 */\012long __ovld __cnfn upsample(int hi, uint lo);\012ulong __ovld __cnfn upsample(uint hi, uint lo);\012long2 __ovld __cnfn upsample(int2 hi, uint2 lo);\012long3 __ovld __cnfn upsample(int3 hi, uint3 lo);\012long4 __ovld __cnfn upsample(int4 hi, uint4 lo);\012long8 __ovld __cnfn upsample(int8 hi, uint8 lo);\012long16 __ovld __cnfn upsample(int16 hi, uint16 lo);\012ulong2 __ovld __cnfn upsample(uint2 hi, uint2 lo);\012ulong3 __ovld __cnfn",
" upsample(uint3 hi, uint3 lo);\012ulong4 __ovld __cnfn upsample(uint4 hi, uint4 lo);\012ulong8 __ovld __cnfn upsample(uint8 hi, uint8 lo);\012ulong16 __ovld __cnfn upsample(uint16 hi, uint16 lo);\012\012/*\012 * popcount(x): returns the number of set bit in x\012 */\012char __ovld __cnfn popcount(char x);\012uchar __ovld __cnfn popcount(uchar x);\012char2 __ovld __cnfn popcount(char2 x);\012uchar2 __ovld __cnfn popcount(uchar2 x);\012char3 __ovld __cnfn popcount(char3 x);\012uchar3 __ovld __cnfn popcount(uchar3 x);\012char4 __ovld __cnfn popcount(char4 x);\012uchar4 __ovld __cnfn popcount(uchar4 x);\012char8 __ovld __cnfn popcount(char8 x);\012uchar8 __ovld __cnfn popcount(uchar8 x);\012char16 __ovld __cnfn popcount(char16 x);\012uchar16 __ovld __cnfn popcount(uchar16 x);\012short __ovld __cnfn popcount(short x);\012ushort __ovld __cnfn popcount(ushort x);\012short2 __ovld __cnfn popcount(short2 x);\012ushort2 __ovld __cnfn popcount(ushort2 x);\012short3 __ovld __cnfn popcount(short3 x);\012ushort3 __ovld __cnfn popcount(ushort3 x);\012short4 __ovld __cnfn popcount(short4 x);\012ushort4 _",
"_ovld __cnfn popcount(ushort4 x);\012short8 __ovld __cnfn popcount(short8 x);\012ushort8 __ovld __cnfn popcount(ushort8 x);\012short16 __ovld __cnfn popcount(short16 x);\012ushort16 __ovld __cnfn popcount(ushort16 x);\012int __ovld __cnfn popcount(int x);\012uint __ovld __cnfn popcount(uint x);\012int2 __ovld __cnfn popcount(int2 x);\012uint2 __ovld __cnfn popcount(uint2 x);\012int3 __ovld __cnfn popcount(int3 x);\012uint3 __ovld __cnfn popcount(uint3 x);\012int4 __ovld __cnfn popcount(int4 x);\012uint4 __ovld __cnfn popcount(uint4 x);\012int8 __ovld __cnfn popcount(int8 x);\012uint8 __ovld __cnfn popcount(uint8 x);\012int16 __ovld __cnfn popcount(int16 x);\012uint16 __ovld __cnfn popcount(uint16 x);\012long __ovld __cnfn popcount(long x);\012ulong __ovld __cnfn popcount(ulong x);\012long2 __ovld __cnfn popcount(long2 x);\012ulong2 __ovld __cnfn popcount(ulong2 x);\012long3 __ovld __cnfn popcount(long3 x);\012ulong3 __ovld __cnfn popcount(ulong3 x);\012long4 __ovld __cnfn popcount(long4 x);\012ulong4 __ovld __cnfn popcount(ulong4 x);\012long8 __ovld __cnfn popcount(long8 x);\012ulong8 ",
"__ovld __cnfn popcount(ulong8 x);\012long16 __ovld __cnfn popcount(long16 x);\012ulong16 __ovld __cnfn popcount(ulong16 x);\012\012/**\012 * Multiply two 24-bit integer values x and y and add\012 * the 32-bit integer result to the 32-bit integer z.\012 * Refer to definition of mul24 to see how the 24-bit\012 * integer multiplication is performed.\012 */\012int __ovld __cnfn mad24(int x, int y, int z);\012uint __ovld __cnfn mad24(uint x, uint y, uint z);\012int2 __ovld __cnfn mad24(int2 x, int2 y, int2 z);\012uint2 __ovld __cnfn mad24(uint2 x, uint2 y, uint2 z);\012int3 __ovld __cnfn mad24(int3 x, int3 y, int3 z);\012uint3 __ovld __cnfn mad24(uint3 x, uint3 y, uint3 z);\012int4 __ovld __cnfn mad24(int4 x, int4 y, int4 z);\012uint4 __ovld __cnfn mad24(uint4 x, uint4 y, uint4 z);\012int8 __ovld __cnfn mad24(int8 x, int8 y, int8 z);\012uint8 __ovld __cnfn mad24(uint8 x, uint8 y, uint8 z);\012int16 __ovld __cnfn mad24(int16 x, int16 y, int16 z);\012uint16 __ovld __cnfn mad24(uint16 x, uint16 y, uint16 z);\012\012/**\012 * Multiply two 24-bit integer values x and y. x and y\012 * are 32-b",
"it integers but only the low 24-bits are used\012 * to perform the multiplication. mul24 should only\012 * be used when values in x and y are in the range [-\012 * 2^23, 2^23-1] if x and y are signed integers and in the\012 * range [0, 2^24-1] if x and y are unsigned integers. If\012 * x and y are not in this range, the multiplication\012 * result is implementation-defined.\012 */\012int __ovld __cnfn mul24(int x, int y);\012uint __ovld __cnfn mul24(uint x, uint y);\012int2 __ovld __cnfn mul24(int2 x, int2 y);\012uint2 __ovld __cnfn mul24(uint2 x, uint2 y);\012int3 __ovld __cnfn mul24(int3 x, int3 y);\012uint3 __ovld __cnfn mul24(uint3 x, uint3 y);\012int4 __ovld __cnfn mul24(int4 x, int4 y);\012uint4 __ovld __cnfn mul24(uint4 x, uint4 y);\012int8 __ovld __cnfn mul24(int8 x, int8 y);\012uint8 __ovld __cnfn mul24(uint8 x, uint8 y);\012int16 __ovld __cnfn mul24(int16 x, int16 y);\012uint16 __ovld __cnfn mul24(uint16 x, uint16 y);\012\012// OpenCL v1.1 s6.11.4, v1.2 s6.12.4, v2.0 s6.13.4 - Common Functions\012\012/**\012 * Returns fmin(fmax(x, minval), maxval).\012 * Results are undefi",
"ned if minval > maxval.\012 */\012float __ovld __cnfn clamp(float x, float minval, float maxval);\012float2 __ovld __cnfn clamp(float2 x, float2 minval, float2 maxval);\012float3 __ovld __cnfn clamp(float3 x, float3 minval, float3 maxval);\012float4 __ovld __cnfn clamp(float4 x, float4 minval, float4 maxval);\012float8 __ovld __cnfn clamp(float8 x, float8 minval, float8 maxval);\012float16 __ovld __cnfn clamp(float16 x, float16 minval, float16 maxval);\012float2 __ovld __cnfn clamp(float2 x, float minval, float maxval);\012float3 __ovld __cnfn clamp(float3 x, float minval, float maxval);\012float4 __ovld __cnfn clamp(float4 x, float minval, float maxval);\012float8 __ovld __cnfn clamp(float8 x, float minval, float maxval);\012float16 __ovld __cnfn clamp(float16 x, float minval, float maxval);\012#ifdef cl_khr_fp64\012double __ovld __cnfn clamp(double x, double minval, double maxval);\012double2 __ovld __cnfn clamp(double2 x, double2 minval, double2 maxval);\012double3 __ovld __cnfn clamp(double3 x, double3 minval, double3 maxval);\012double4 __ovld __cnfn cla",
"mp(double4 x, double4 minval, double4 maxval);\012double8 __ovld __cnfn clamp(double8 x, double8 minval, double8 maxval);\012double16 __ovld __cnfn clamp(double16 x, double16 minval, double16 maxval);\012double2 __ovld __cnfn clamp(double2 x, double minval, double maxval);\012double3 __ovld __cnfn clamp(double3 x, double minval, double maxval);\012double4 __ovld __cnfn clamp(double4 x, double minval, double maxval);\012double8 __ovld __cnfn clamp(double8 x, double minval, double maxval);\012double16 __ovld __cnfn clamp(double16 x, double minval, double maxval);\012#endif //cl_khr_fp64\012#ifdef cl_khr_fp16\012half __ovld __cnfn clamp(half x, half minval, half maxval);\012half2 __ovld __cnfn clamp(half2 x, half2 minval, half2 maxval);\012half3 __ovld __cnfn clamp(half3 x, half3 minval, half3 maxval);\012half4 __ovld __cnfn clamp(half4 x, half4 minval, half4 maxval);\012half8 __ovld __cnfn clamp(half8 x, half8 minval, half8 maxval);\012half16 __ovld __cnfn clamp(half16 x, half16 minval, half16 maxval);\012half2 __ovld __cnfn clamp(half2 x, half minval, half ",
"maxval);\012half3 __ovld __cnfn clamp(half3 x, half minval, half maxval);\012half4 __ovld __cnfn clamp(half4 x, half minval, half maxval);\012half8 __ovld __cnfn clamp(half8 x, half minval, half maxval);\012half16 __ovld __cnfn clamp(half16 x, half minval, half maxval);\012#endif //cl_khr_fp16\012\012/**\012 * Converts radians to degrees, i.e. (180 / PI) *\012 * radians.\012 */\012float __ovld __cnfn degrees(float radians);\012float2 __ovld __cnfn degrees(float2 radians);\012float3 __ovld __cnfn degrees(float3 radians);\012float4 __ovld __cnfn degrees(float4 radians);\012float8 __ovld __cnfn degrees(float8 radians);\012float16 __ovld __cnfn degrees(float16 radians);\012#ifdef cl_khr_fp64\012double __ovld __cnfn degrees(double radians);\012double2 __ovld __cnfn degrees(double2 radians);\012double3 __ovld __cnfn degrees(double3 radians);\012double4 __ovld __cnfn degrees(double4 radians);\012double8 __ovld __cnfn degrees(double8 radians);\012double16 __ovld __cnfn degrees(double16 radians);\012#endif //cl_khr_fp64\012#ifdef cl_khr_fp16\012half __ovld __cnfn degrees(half radians);\012half2 __",
"ovld __cnfn degrees(half2 radians);\012half3 __ovld __cnfn degrees(half3 radians);\012half4 __ovld __cnfn degrees(half4 radians);\012half8 __ovld __cnfn degrees(half8 radians);\012half16 __ovld __cnfn degrees(half16 radians);\012#endif //cl_khr_fp16\012\012/**\012 * Returns y if x < y, otherwise it returns x. If x and y\012 * are infinite or NaN, the return values are undefined.\012 */\012float __ovld __cnfn max(float x, float y);\012float2 __ovld __cnfn max(float2 x, float2 y);\012float3 __ovld __cnfn max(float3 x, float3 y);\012float4 __ovld __cnfn max(float4 x, float4 y);\012float8 __ovld __cnfn max(float8 x, float8 y);\012float16 __ovld __cnfn max(float16 x, float16 y);\012float2 __ovld __cnfn max(float2 x, float y);\012float3 __ovld __cnfn max(float3 x, float y);\012float4 __ovld __cnfn max(float4 x, float y);\012float8 __ovld __cnfn max(float8 x, float y);\012float16 __ovld __cnfn max(float16 x, float y);\012#ifdef cl_khr_fp64\012double __ovld __cnfn max(double x, double y);\012double2 __ovld __cnfn max(double2 x, double2 y);\012double3 __ovld __cnfn max(double3 x, double3 y);",
"\012double4 __ovld __cnfn max(double4 x, double4 y);\012double8 __ovld __cnfn max(double8 x, double8 y);\012double16 __ovld __cnfn max(double16 x, double16 y);\012double2 __ovld __cnfn max(double2 x, double y);\012double3 __ovld __cnfn max(double3 x, double y);\012double4 __ovld __cnfn max(double4 x, double y);\012double8 __ovld __cnfn max(double8 x, double y);\012double16 __ovld __cnfn max(double16 x, double y);\012#endif //cl_khr_fp64\012#ifdef cl_khr_fp16\012half __ovld __cnfn max(half x, half y);\012half2 __ovld __cnfn max(half2 x, half2 y);\012half3 __ovld __cnfn max(half3 x, half3 y);\012half4 __ovld __cnfn max(half4 x, half4 y);\012half8 __ovld __cnfn max(half8 x, half8 y);\012half16 __ovld __cnfn max(half16 x, half16 y);\012half2 __ovld __cnfn max(half2 x, half y);\012half3 __ovld __cnfn max(half3 x, half y);\012half4 __ovld __cnfn max(half4 x, half y);\012half8 __ovld __cnfn max(half8 x, half y);\012half16 __ovld __cnfn max(half16 x, half y);\012#endif //cl_khr_fp16\012\012/**\012 * Returns y if y < x, otherwise it returns x. If x and y\012 * are infinite or NaN, the return va",
"lues are undefined.\012 */\012float __ovld __cnfn min(float x, float y);\012float2 __ovld __cnfn min(float2 x, float2 y);\012float3 __ovld __cnfn min(float3 x, float3 y);\012float4 __ovld __cnfn min(float4 x, float4 y);\012float8 __ovld __cnfn min(float8 x, float8 y);\012float16 __ovld __cnfn min(float16 x, float16 y);\012float2 __ovld __cnfn min(float2 x, float y);\012float3 __ovld __cnfn min(float3 x, float y);\012float4 __ovld __cnfn min(float4 x, float y);\012float8 __ovld __cnfn min(float8 x, float y);\012float16 __ovld __cnfn min(float16 x, float y);\012#ifdef cl_khr_fp64\012double __ovld __cnfn min(double x, double y);\012double2 __ovld __cnfn min(double2 x, double2 y);\012double3 __ovld __cnfn min(double3 x, double3 y);\012double4 __ovld __cnfn min(double4 x, double4 y);\012double8 __ovld __cnfn min(double8 x, double8 y);\012double16 __ovld __cnfn min(double16 x, double16 y);\012double2 __ovld __cnfn min(double2 x, double y);\012double3 __ovld __cnfn min(double3 x, double y);\012double4 __ovld __cnfn min(double4 x, double y);\012double8 __ovld __cnfn min(double8 x, dou",
"ble y);\012double16 __ovld __cnfn min(double16 x, double y);\012#endif //cl_khr_fp64\012#ifdef cl_khr_fp16\012half __ovld __cnfn min(half x, half y);\012half2 __ovld __cnfn min(half2 x, half2 y);\012half3 __ovld __cnfn min(half3 x, half3 y);\012half4 __ovld __cnfn min(half4 x, half4 y);\012half8 __ovld __cnfn min(half8 x, half8 y);\012half16 __ovld __cnfn min(half16 x, half16 y);\012half2 __ovld __cnfn min(half2 x, half y);\012half3 __ovld __cnfn min(half3 x, half y);\012half4 __ovld __cnfn min(half4 x, half y);\012half8 __ovld __cnfn min(half8 x, half y);\012half16 __ovld __cnfn min(half16 x, half y);\012#endif //cl_khr_fp16\012\012/**\012 * Returns the linear blend of x & y implemented as:\012 * x + (y - x) * a\012 * a must be a value in the range 0.0 ... 1.0. If a is not\012 * in the range 0.0 ... 1.0, the return values are\012 * undefined.\012 */\012float __ovld __cnfn mix(float x, float y, float a);\012float2 __ovld __cnfn mix(float2 x, float2 y, float2 a);\012float3 __ovld __cnfn mix(float3 x, float3 y, float3 a);\012float4 __ovld __cnfn mix(float4 x, float4 y, float4 a);\012float8 __o",
"vld __cnfn mix(float8 x, float8 y, float8 a);\012float16 __ovld __cnfn mix(float16 x, float16 y, float16 a);\012float2 __ovld __cnfn mix(float2 x, float2 y, float a);\012float3 __ovld __cnfn mix(float3 x, float3 y, float a);\012float4 __ovld __cnfn mix(float4 x, float4 y, float a);\012float8 __ovld __cnfn mix(float8 x, float8 y, float a);\012float16 __ovld __cnfn mix(float16 x, float16 y, float a);\012#ifdef cl_khr_fp64\012double __ovld __cnfn mix(double x, double y, double a);\012double2 __ovld __cnfn mix(double2 x, double2 y, double2 a);\012double3 __ovld __cnfn mix(double3 x, double3 y, double3 a);\012double4 __ovld __cnfn mix(double4 x, double4 y, double4 a);\012double8 __ovld __cnfn mix(double8 x, double8 y, double8 a);\012double16 __ovld __cnfn mix(double16 x, double16 y, double16 a);\012double2 __ovld __cnfn mix(double2 x, double2 y, double a);\012double3 __ovld __cnfn mix(double3 x, double3 y, double a);\012double4 __ovld __cnfn mix(double4 x, double4 y, double a);\012double8 __ovld __cnfn mix(double8 x, double8 y, double a);\012double16 __ovld __cnfn mi",
"x(double16 x, double16 y, double a);\012#endif //cl_khr_fp64\012#ifdef cl_khr_fp16\012half __ovld __cnfn mix(half x, half y, half a);\012half2 __ovld __cnfn mix(half2 x, half2 y, half2 a);\012half3 __ovld __cnfn mix(half3 x, half3 y, half3 a);\012half4 __ovld __cnfn mix(half4 x, half4 y, half4 a);\012half8 __ovld __cnfn mix(half8 x, half8 y, half8 a);\012half16 __ovld __cnfn mix(half16 x, half16 y, half16 a);\012half2 __ovld __cnfn mix(half2 x, half2 y, half a);\012half3 __ovld __cnfn mix(half3 x, half3 y, half a);\012half4 __ovld __cnfn mix(half4 x, half4 y, half a);\012half8 __ovld __cnfn mix(half8 x, half8 y, half a);\012half16 __ovld __cnfn mix(half16 x, half16 y, half a);\012#endif //cl_khr_fp16\012\012/**\012 * Converts degrees to radians, i.e. (PI / 180) *\012 * degrees.\012 */\012float __ovld __cnfn radians(float degrees);\012float2 __ovld __cnfn radians(float2 degrees);\012float3 __ovld __cnfn radians(float3 degrees);\012float4 __ovld __cnfn radians(float4 degrees);\012float8 __ovld __cnfn radians(float8 degrees);\012float16 __ovld __cnfn radians(float16 degrees);\012#ifdef cl",
"_khr_fp64\012double __ovld __cnfn radians(double degrees);\012double2 __ovld __cnfn radians(double2 degrees);\012double3 __ovld __cnfn radians(double3 degrees);\012double4 __ovld __cnfn radians(double4 degrees);\012double8 __ovld __cnfn radians(double8 degrees);\012double16 __ovld __cnfn radians(double16 degrees);\012#endif //cl_khr_fp64\012#ifdef cl_khr_fp16\012half __ovld __cnfn radians(half degrees);\012half2 __ovld __cnfn radians(half2 degrees);\012half3 __ovld __cnfn radians(half3 degrees);\012half4 __ovld __cnfn radians(half4 degrees);\012half8 __ovld __cnfn radians(half8 degrees);\012half16 __ovld __cnfn radians(half16 degrees);\012#endif //cl_khr_fp16\012\012/**\012 * Returns 0.0 if x < edge, otherwise it returns 1.0.\012 */\012float __ovld __cnfn step(float edge, float x);\012float2 __ovld __cnfn step(float2 edge, float2 x);\012float3 __ovld __cnfn step(float3 edge, float3 x);\012float4 __ovld __cnfn step(float4 edge, float4 x);\012float8 __ovld __cnfn step(float8 edge, float8 x);\012float16 __ovld __cnfn step(float16 edge, float16 x);\012float2 __ovld __cnfn step(float edge, ",
"float2 x);\012float3 __ovld __cnfn step(float edge, float3 x);\012float4 __ovld __cnfn step(float edge, float4 x);\012float8 __ovld __cnfn step(float edge, float8 x);\012float16 __ovld __cnfn step(float edge, float16 x);\012#ifdef cl_khr_fp64\012double __ovld __cnfn step(double edge, double x);\012double2 __ovld __cnfn step(double2 edge, double2 x);\012double3 __ovld __cnfn step(double3 edge, double3 x);\012double4 __ovld __cnfn step(double4 edge, double4 x);\012double8 __ovld __cnfn step(double8 edge, double8 x);\012double16 __ovld __cnfn step(double16 edge, double16 x);\012double2 __ovld __cnfn step(double edge, double2 x);\012double3 __ovld __cnfn step(double edge, double3 x);\012double4 __ovld __cnfn step(double edge, double4 x);\012double8 __ovld __cnfn step(double edge, double8 x);\012double16 __ovld __cnfn step(double edge, double16 x);\012#endif //cl_khr_fp64\012#ifdef cl_khr_fp16\012half __ovld __cnfn step(half edge, half x);\012half2 __ovld __cnfn step(half2 edge, half2 x);\012half3 __ovld __cnfn step(half3 edge, half3 x);\012half4 __ovld __cnfn step(half4 edge, h",
"alf4 x);\012half8 __ovld __cnfn step(half8 edge, half8 x);\012half16 __ovld __cnfn step(half16 edge, half16 x);\012half __ovld __cnfn step(half edge, half x);\012half2 __ovld __cnfn step(half edge, half2 x);\012half3 __ovld __cnfn step(half edge, half3 x);\012half4 __ovld __cnfn step(half edge, half4 x);\012half8 __ovld __cnfn step(half edge, half8 x);\012half16 __ovld __cnfn step(half edge, half16 x);\012#endif //cl_khr_fp16\012\012/**\012 * Returns 0.0 if x <= edge0 and 1.0 if x >= edge1 and\012 * performs smooth Hermite interpolation between 0\012 * and 1when edge0 < x < edge1. This is useful in\012 * cases where you would want a threshold function\012 * with a smooth transition.\012 * This is equivalent to:\012 * gentype t;\012 * t = clamp ((x - edge0) / (edge1 - edge0), 0, 1);\012 * return t * t * (3 - 2 * t);\012 * Results are undefined if edge0 >= edge1 or if x,\012 * edge0 or edge1 is a NaN.\012 */\012float __ovld __cnfn smoothstep(float edge0, float edge1, float x);\012float2 __ovld __cnfn smoothstep(float2 edge0, float2 edge1, float2 x);\012float3 __ovld __cnfn smoothstep(flo",
"at3 edge0, float3 edge1, float3 x);\012float4 __ovld __cnfn smoothstep(float4 edge0, float4 edge1, float4 x);\012float8 __ovld __cnfn smoothstep(float8 edge0, float8 edge1, float8 x);\012float16 __ovld __cnfn smoothstep(float16 edge0, float16 edge1, float16 x);\012float2 __ovld __cnfn smoothstep(float edge0, float edge1, float2 x);\012float3 __ovld __cnfn smoothstep(float edge0, float edge1, float3 x);\012float4 __ovld __cnfn smoothstep(float edge0, float edge1, float4 x);\012float8 __ovld __cnfn smoothstep(float edge0, float edge1, float8 x);\012float16 __ovld __cnfn smoothstep(float edge0, float edge1, float16 x);\012#ifdef cl_khr_fp64\012double __ovld __cnfn smoothstep(double edge0, double edge1, double x);\012double2 __ovld __cnfn smoothstep(double2 edge0, double2 edge1, double2 x);\012double3 __ovld __cnfn smoothstep(double3 edge0, double3 edge1, double3 x);\012double4 __ovld __cnfn smoothstep(double4 edge0, double4 edge1, double4 x);\012double8 __ovld __cnfn smoothstep(double8 edge0, double8 edge1, double8 x);\012double16 __ovld __cnfn smoothstep(",
"double16 edge0, double16 edge1, double16 x);\012double2 __ovld __cnfn smoothstep(double edge0, double edge1, double2 x);\012double3 __ovld __cnfn smoothstep(double edge0, double edge1, double3 x);\012double4 __ovld __cnfn smoothstep(double edge0, double edge1, double4 x);\012double8 __ovld __cnfn smoothstep(double edge0, double edge1, double8 x);\012double16 __ovld __cnfn smoothstep(double edge0, double edge1, double16 x);\012#endif //cl_khr_fp64\012#ifdef cl_khr_fp16\012half __ovld __cnfn smoothstep(half edge0, half edge1, half x);\012half2 __ovld __cnfn smoothstep(half2 edge0, half2 edge1, half2 x);\012half3 __ovld __cnfn smoothstep(half3 edge0, half3 edge1, half3 x);\012half4 __ovld __cnfn smoothstep(half4 edge0, half4 edge1, half4 x);\012half8 __ovld __cnfn smoothstep(half8 edge0, half8 edge1, half8 x);\012half16 __ovld __cnfn smoothstep(half16 edge0, half16 edge1, half16 x);\012half __ovld __cnfn smoothstep(half edge0, half edge1, half x);\012half2 __ovld __cnfn smoothstep(half edge0, half edge1, half2 x);\012half3 __ovld __cnfn smoothstep(half edge0,",
" half edge1, half3 x);\012half4 __ovld __cnfn smoothstep(half edge0, half edge1, half4 x);\012half8 __ovld __cnfn smoothstep(half edge0, half edge1, half8 x);\012half16 __ovld __cnfn smoothstep(half edge0, half edge1, half16 x);\012#endif //cl_khr_fp16\012\012/**\012 * Returns 1.0 if x > 0, -0.0 if x = -0.0, +0.0 if x =\012 * +0.0, or -1.0 if x < 0. Returns 0.0 if x is a NaN.\012 */\012float __ovld __cnfn sign(float x);\012float2 __ovld __cnfn sign(float2 x);\012float3 __ovld __cnfn sign(float3 x);\012float4 __ovld __cnfn sign(float4 x);\012float8 __ovld __cnfn sign(float8 x);\012float16 __ovld __cnfn sign(float16 x);\012#ifdef cl_khr_fp64\012double __ovld __cnfn sign(double x);\012double2 __ovld __cnfn sign(double2 x);\012double3 __ovld __cnfn sign(double3 x);\012double4 __ovld __cnfn sign(double4 x);\012double8 __ovld __cnfn sign(double8 x);\012double16 __ovld __cnfn sign(double16 x);\012#endif //cl_khr_fp64\012#ifdef cl_khr_fp16\012half __ovld __cnfn sign(half x);\012half2 __ovld __cnfn sign(half2 x);\012half3 __ovld __cnfn sign(half3 x);\012half4 __ovld __cnfn sign(half4 x);\012half8 __ovld",
" __cnfn sign(half8 x);\012half16 __ovld __cnfn sign(half16 x);\012#endif //cl_khr_fp16\012\012// OpenCL v1.1 s6.11.5, v1.2 s6.12.5, v2.0 s6.13.5 - Geometric Functions\012\012/**\012 * Returns the cross product of p0.xyz and p1.xyz. The\012 * w component of float4 result returned will be 0.0.\012 */\012float4 __ovld __cnfn cross(float4 p0, float4 p1);\012float3 __ovld __cnfn cross(float3 p0, float3 p1);\012#ifdef cl_khr_fp64\012double4 __ovld __cnfn cross(double4 p0, double4 p1);\012double3 __ovld __cnfn cross(double3 p0, double3 p1);\012#endif //cl_khr_fp64\012#ifdef cl_khr_fp16\012half4 __ovld __cnfn cross(half4 p0, half4 p1);\012half3 __ovld __cnfn cross(half3 p0, half3 p1);\012#endif //cl_khr_fp16\012\012/**\012 * Compute dot product.\012 */\012float __ovld __cnfn dot(float p0, float p1);\012float __ovld __cnfn dot(float2 p0, float2 p1);\012float __ovld __cnfn dot(float3 p0, float3 p1);\012float __ovld __cnfn dot(float4 p0, float4 p1);\012#ifdef cl_khr_fp64\012double __ovld __cnfn dot(double p0, double p1);\012double __ovld __cnfn dot(double2 p0, double2 p1);\012double __ovld __cnfn dot(double3 p0",
", double3 p1);\012double __ovld __cnfn dot(double4 p0, double4 p1);\012#endif //cl_khr_fp64\012#ifdef cl_khr_fp16\012half __ovld __cnfn dot(half p0, half p1);\012half __ovld __cnfn dot(half2 p0, half2 p1);\012half __ovld __cnfn dot(half3 p0, half3 p1);\012half __ovld __cnfn dot(half4 p0, half4 p1);\012#endif //cl_khr_fp16\012\012/**\012 * Returns the distance between p0 and p1. This is\012 * calculated as length(p0 - p1).\012 */\012float __ovld __cnfn distance(float p0, float p1);\012float __ovld __cnfn distance(float2 p0, float2 p1);\012float __ovld __cnfn distance(float3 p0, float3 p1);\012float __ovld __cnfn distance(float4 p0, float4 p1);\012#ifdef cl_khr_fp64\012double __ovld __cnfn distance(double p0, double p1);\012double __ovld __cnfn distance(double2 p0, double2 p1);\012double __ovld __cnfn distance(double3 p0, double3 p1);\012double __ovld __cnfn distance(double4 p0, double4 p1);\012#endif //cl_khr_fp64\012#ifdef cl_khr_fp16\012half __ovld __cnfn distance(half p0, half p1);\012half __ovld __cnfn distance(half2 p0, half2 p1);\012half __ovld __cnfn distance(half3 p0, half3 p1);\012ha",
"lf __ovld __cnfn distance(half4 p0, half4 p1);\012#endif //cl_khr_fp16\012\012/**\012 * Return the length of vector p, i.e.,\012 * sqrt(p.x2 + p.y 2 + ...)\012 */\012float __ovld __cnfn length(float p);\012float __ovld __cnfn length(float2 p);\012float __ovld __cnfn length(float3 p);\012float __ovld __cnfn length(float4 p);\012#ifdef cl_khr_fp64\012double __ovld __cnfn length(double p);\012double __ovld __cnfn length(double2 p);\012double __ovld __cnfn length(double3 p);\012double __ovld __cnfn length(double4 p);\012#endif //cl_khr_fp64\012#ifdef cl_khr_fp16\012half __ovld __cnfn length(half p);\012half __ovld __cnfn length(half2 p);\012half __ovld __cnfn length(half3 p);\012half __ovld __cnfn length(half4 p);\012#endif //cl_khr_fp16\012\012/**\012 * Returns a vector in the same direction as p but with a\012 * length of 1.\012 */\012float __ovld __cnfn normalize(float p);\012float2 __ovld __cnfn normalize(float2 p);\012float3 __ovld __cnfn normalize(float3 p);\012float4 __ovld __cnfn normalize(float4 p);\012#ifdef cl_khr_fp64\012double __ovld __cnfn normalize(double p);\012double2 __ovld __cnfn normalize(doub",
"le2 p);\012double3 __ovld __cnfn normalize(double3 p);\012double4 __ovld __cnfn normalize(double4 p);\012#endif //cl_khr_fp64\012#ifdef cl_khr_fp16\012half __ovld __cnfn normalize(half p);\012half2 __ovld __cnfn normalize(half2 p);\012half3 __ovld __cnfn normalize(half3 p);\012half4 __ovld __cnfn normalize(half4 p);\012#endif //cl_khr_fp16\012\012/**\012 * Returns fast_length(p0 - p1).\012 */\012float __ovld __cnfn fast_distance(float p0, float p1);\012float __ovld __cnfn fast_distance(float2 p0, float2 p1);\012float __ovld __cnfn fast_distance(float3 p0, float3 p1);\012float __ovld __cnfn fast_distance(float4 p0, float4 p1);\012#ifdef cl_khr_fp16\012half __ovld __cnfn fast_distance(half p0, half p1);\012half __ovld __cnfn fast_distance(half2 p0, half2 p1);\012half __ovld __cnfn fast_distance(half3 p0, half3 p1);\012half __ovld __cnfn fast_distance(half4 p0, half4 p1);\012#endif //cl_khr_fp16\012\012/**\012 * Returns the length of vector p computed as:\012 * half_sqrt(p.x2 + p.y2 + ...)\012 */\012float __ovld __cnfn fast_length(float p);\012float __ovld __cnfn fast_length(float2 p);\012float __ovld _",
"_cnfn fast_length(float3 p);\012float __ovld __cnfn fast_length(float4 p);\012#ifdef cl_khr_fp16\012half __ovld __cnfn fast_length(half p);\012half __ovld __cnfn fast_length(half2 p);\012half __ovld __cnfn fast_length(half3 p);\012half __ovld __cnfn fast_length(half4 p);\012#endif //cl_khr_fp16\012\012/**\012 * Returns a vector in the same direction as p but with a\012 * length of 1. fast_normalize is computed as:\012 * p * half_rsqrt (p.x^2 + p.y^2 + ... )\012 * The result shall be within 8192 ulps error from the\012 * infinitely precise result of\012 * if (all(p == 0.0f))\012 * result = p;\012 * else\012 * result = p / sqrt (p.x^2 + p.y^2 + ...);\012 * with the following exceptions:\012 * 1) If the sum of squares is greater than FLT_MAX\012 * then the value of the floating-point values in the\012 * result vector are undefined.\012 * 2) If the sum of squares is less than FLT_MIN then\012 * the implementation may return back p.\012 * 3) If the device is in \"denorms are flushed to zero\"\012 * mode, individual operand elements with magnitude\012 * less than sqrt(FLT_MIN) may be flushed to z",
"ero\012 * before proceeding with the calculation.\012 */\012float __ovld __cnfn fast_normalize(float p);\012float2 __ovld __cnfn fast_normalize(float2 p);\012float3 __ovld __cnfn fast_normalize(float3 p);\012float4 __ovld __cnfn fast_normalize(float4 p);\012#ifdef cl_khr_fp16\012half __ovld __cnfn fast_normalize(half p);\012half2 __ovld __cnfn fast_normalize(half2 p);\012half3 __ovld __cnfn fast_normalize(half3 p);\012half4 __ovld __cnfn fast_normalize(half4 p);\012#endif //cl_khr_fp16\012\012// OpenCL v1.1 s6.11.6, v1.2 s6.12.6, v2.0 s6.13.6 - Relational Functions\012\012/**\012 * intn isequal (floatn x, floatn y)\012 * Returns the component-wise compare of x == y.\012 */\012int __ovld __cnfn isequal(float x, float y);\012int2 __ovld __cnfn isequal(float2 x, float2 y);\012int3 __ovld __cnfn isequal(float3 x, float3 y);\012int4 __ovld __cnfn isequal(float4 x, float4 y);\012int8 __ovld __cnfn isequal(float8 x, float8 y);\012int16 __ovld __cnfn isequal(float16 x, float16 y);\012#ifdef cl_khr_fp64\012int __ovld __cnfn isequal(double x, double y);\012long2 __ovld __cnfn isequal(double2 x, double",
"2 y);\012long3 __ovld __cnfn isequal(double3 x, double3 y);\012long4 __ovld __cnfn isequal(double4 x, double4 y);\012long8 __ovld __cnfn isequal(double8 x, double8 y);\012long16 __ovld __cnfn isequal(double16 x, double16 y);\012#endif //cl_khr_fp64\012#ifdef cl_khr_fp16\012int __ovld __cnfn isequal(half x, half y);\012short2 __ovld __cnfn isequal(half2 x, half2 y);\012short3 __ovld __cnfn isequal(half3 x, half3 y);\012short4 __ovld __cnfn isequal(half4 x, half4 y);\012short8 __ovld __cnfn isequal(half8 x, half8 y);\012short16 __ovld __cnfn isequal(half16 x, half16 y);\012#endif //cl_khr_fp16\012\012/**\012 * Returns the component-wise compare of x != y.\012 */\012int __ovld __cnfn isnotequal(float x, float y);\012int2 __ovld __cnfn isnotequal(float2 x, float2 y);\012int3 __ovld __cnfn isnotequal(float3 x, float3 y);\012int4 __ovld __cnfn isnotequal(float4 x, float4 y);\012int8 __ovld __cnfn isnotequal(float8 x, float8 y);\012int16 __ovld __cnfn isnotequal(float16 x, float16 y);\012#ifdef cl_khr_fp64\012int __ovld __cnfn isnotequal(double x, double y);\012long2 __ovld __cnfn isnotequal(",
"double2 x, double2 y);\012long3 __ovld __cnfn isnotequal(double3 x, double3 y);\012long4 __ovld __cnfn isnotequal(double4 x, double4 y);\012long8 __ovld __cnfn isnotequal(double8 x, double8 y);\012long16 __ovld __cnfn isnotequal(double16 x, double16 y);\012#endif //cl_khr_fp64\012#ifdef cl_khr_fp16\012int __ovld __cnfn isnotequal(half x, half y);\012short2 __ovld __cnfn isnotequal(half2 x, half2 y);\012short3 __ovld __cnfn isnotequal(half3 x, half3 y);\012short4 __ovld __cnfn isnotequal(half4 x, half4 y);\012short8 __ovld __cnfn isnotequal(half8 x, half8 y);\012short16 __ovld __cnfn isnotequal(half16 x, half16 y);\012#endif //cl_khr_fp16\012\012/**\012 * Returns the component-wise compare of x > y.\012 */\012int __ovld __cnfn isgreater(float x, float y);\012int2 __ovld __cnfn isgreater(float2 x, float2 y);\012int3 __ovld __cnfn isgreater(float3 x, float3 y);\012int4 __ovld __cnfn isgreater(float4 x, float4 y);\012int8 __ovld __cnfn isgreater(float8 x, float8 y);\012int16 __ovld __cnfn isgreater(float16 x, float16 y);\012#ifdef cl_khr_fp64\012int __ovld __cnfn isgreater(double x, dou",
"ble y);\012long2 __ovld __cnfn isgreater(double2 x, double2 y);\012long3 __ovld __cnfn isgreater(double3 x, double3 y);\012long4 __ovld __cnfn isgreater(double4 x, double4 y);\012long8 __ovld __cnfn isgreater(double8 x, double8 y);\012long16 __ovld __cnfn isgreater(double16 x, double16 y);\012#endif //cl_khr_fp64\012#ifdef cl_khr_fp16\012int __ovld __cnfn isgreater(half x, half y);\012short2 __ovld __cnfn isgreater(half2 x, half2 y);\012short3 __ovld __cnfn isgreater(half3 x, half3 y);\012short4 __ovld __cnfn isgreater(half4 x, half4 y);\012short8 __ovld __cnfn isgreater(half8 x, half8 y);\012short16 __ovld __cnfn isgreater(half16 x, half16 y);\012#endif //cl_khr_fp16\012\012/**\012 * Returns the component-wise compare of x >= y.\012 */\012int __ovld __cnfn isgreaterequal(float x, float y);\012int2 __ovld __cnfn isgreaterequal(float2 x, float2 y);\012int3 __ovld __cnfn isgreaterequal(float3 x, float3 y);\012int4 __ovld __cnfn isgreaterequal(float4 x, float4 y);\012int8 __ovld __cnfn isgreaterequal(float8 x, float8 y);\012int16 __ovld __cnfn isgreaterequal(float16 x, float16 y);\012#",
"ifdef cl_khr_fp64\012int __ovld __cnfn isgreaterequal(double x, double y);\012long2 __ovld __cnfn isgreaterequal(double2 x, double2 y);\012long3 __ovld __cnfn isgreaterequal(double3 x, double3 y);\012long4 __ovld __cnfn isgreaterequal(double4 x, double4 y);\012long8 __ovld __cnfn isgreaterequal(double8 x, double8 y);\012long16 __ovld __cnfn isgreaterequal(double16 x, double16 y);\012#endif //cl_khr_fp64\012#ifdef cl_khr_fp16\012int __ovld __cnfn isgreaterequal(half x, half y);\012short2 __ovld __cnfn isgreaterequal(half2 x, half2 y);\012short3 __ovld __cnfn isgreaterequal(half3 x, half3 y);\012short4 __ovld __cnfn isgreaterequal(half4 x, half4 y);\012short8 __ovld __cnfn isgreaterequal(half8 x, half8 y);\012short16 __ovld __cnfn isgreaterequal(half16 x, half16 y);\012#endif //cl_khr_fp16\012\012/**\012 * Returns the component-wise compare of x < y.\012 */\012int __ovld __cnfn isless(float x, float y);\012int2 __ovld __cnfn isless(float2 x, float2 y);\012int3 __ovld __cnfn isless(float3 x, float3 y);\012int4 __ovld __cnfn isless(float4 x, float4 y);\012int8 __ovld __cnfn isless(fl",
"oat8 x, float8 y);\012int16 __ovld __cnfn isless(float16 x, float16 y);\012#ifdef cl_khr_fp64\012int __ovld __cnfn isless(double x, double y);\012long2 __ovld __cnfn isless(double2 x, double2 y);\012long3 __ovld __cnfn isless(double3 x, double3 y);\012long4 __ovld __cnfn isless(double4 x, double4 y);\012long8 __ovld __cnfn isless(double8 x, double8 y);\012long16 __ovld __cnfn isless(double16 x, double16 y);\012#endif //cl_khr_fp64\012#ifdef cl_khr_fp16\012int __ovld __cnfn isless(half x, half y);\012short2 __ovld __cnfn isless(half2 x, half2 y);\012short3 __ovld __cnfn isless(half3 x, half3 y);\012short4 __ovld __cnfn isless(half4 x, half4 y);\012short8 __ovld __cnfn isless(half8 x, half8 y);\012short16 __ovld __cnfn isless(half16 x, half16 y);\012#endif //cl_khr_fp16\012\012/**\012 * Returns the component-wise compare of x <= y.\012 */\012int __ovld __cnfn islessequal(float x, float y);\012int2 __ovld __cnfn islessequal(float2 x, float2 y);\012int3 __ovld __cnfn islessequal(float3 x, float3 y);\012int4 __ovld __cnfn islessequal(float4 x, float4 y);\012int8 __ovld __cnfn islessequal(fl",
"oat8 x, float8 y);\012int16 __ovld __cnfn islessequal(float16 x, float16 y);\012#ifdef cl_khr_fp64\012int __ovld __cnfn islessequal(double x, double y);\012long2 __ovld __cnfn islessequal(double2 x, double2 y);\012long3 __ovld __cnfn islessequal(double3 x, double3 y);\012long4 __ovld __cnfn islessequal(double4 x, double4 y);\012long8 __ovld __cnfn islessequal(double8 x, double8 y);\012long16 __ovld __cnfn islessequal(double16 x, double16 y);\012#endif //cl_khr_fp64\012#ifdef cl_khr_fp16\012int __ovld __cnfn islessequal(half x, half y);\012short2 __ovld __cnfn islessequal(half2 x, half2 y);\012short3 __ovld __cnfn islessequal(half3 x, half3 y);\012short4 __ovld __cnfn islessequal(half4 x, half4 y);\012short8 __ovld __cnfn islessequal(half8 x, half8 y);\012short16 __ovld __cnfn islessequal(half16 x, half16 y);\012#endif //cl_khr_fp16\012\012/**\012 * Returns the component-wise compare of\012 * (x < y) || (x > y) .\012 */\012int __ovld __cnfn islessgreater(float x, float y);\012int2 __ovld __cnfn islessgreater(float2 x, float2 y);\012int3 __ovld __cnfn islessgreater(float3 x, float3 y)",
";\012int4 __ovld __cnfn islessgreater(float4 x, float4 y);\012int8 __ovld __cnfn islessgreater(float8 x, float8 y);\012int16 __ovld __cnfn islessgreater(float16 x, float16 y);\012#ifdef cl_khr_fp64\012int __ovld __cnfn islessgreater(double x, double y);\012long2 __ovld __cnfn islessgreater(double2 x, double2 y);\012long3 __ovld __cnfn islessgreater(double3 x, double3 y);\012long4 __ovld __cnfn islessgreater(double4 x, double4 y);\012long8 __ovld __cnfn islessgreater(double8 x, double8 y);\012long16 __ovld __cnfn islessgreater(double16 x, double16 y);\012#endif //cl_khr_fp64\012#ifdef cl_khr_fp16\012int __ovld __cnfn islessgreater(half x, half y);\012short2 __ovld __cnfn islessgreater(half2 x, half2 y);\012short3 __ovld __cnfn islessgreater(half3 x, half3 y);\012short4 __ovld __cnfn islessgreater(half4 x, half4 y);\012short8 __ovld __cnfn islessgreater(half8 x, half8 y);\012short16 __ovld __cnfn islessgreater(half16 x, half16 y);\012#endif //cl_khr_fp16\012\012/**\012 * Test for finite value.\012 */\012int __ovld __cnfn isfinite(float);\012int2 __ovld __cnfn isfinite(float2);\012int3 __",
"ovld __cnfn isfinite(float3);\012int4 __ovld __cnfn isfinite(float4);\012int8 __ovld __cnfn isfinite(float8);\012int16 __ovld __cnfn isfinite(float16);\012#ifdef cl_khr_fp64\012int __ovld __cnfn isfinite(double);\012long2 __ovld __cnfn isfinite(double2);\012long3 __ovld __cnfn isfinite(double3);\012long4 __ovld __cnfn isfinite(double4);\012long8 __ovld __cnfn isfinite(double8);\012long16 __ovld __cnfn isfinite(double16);\012#endif //cl_khr_fp64\012#ifdef cl_khr_fp16\012int __ovld __cnfn isfinite(half);\012short2 __ovld __cnfn isfinite(half2);\012short3 __ovld __cnfn isfinite(half3);\012short4 __ovld __cnfn isfinite(half4);\012short8 __ovld __cnfn isfinite(half8);\012short16 __ovld __cnfn isfinite(half16);\012#endif //cl_khr_fp16\012\012/**\012 * Test for infinity value (+ve or -ve) .\012 */\012int __ovld __cnfn isinf(float);\012int2 __ovld __cnfn isinf(float2);\012int3 __ovld __cnfn isinf(float3);\012int4 __ovld __cnfn isinf(float4);\012int8 __ovld __cnfn isinf(float8);\012int16 __ovld __cnfn isinf(float16);\012#ifdef cl_khr_fp64\012int __ovld __cnfn isinf(double);\012long2 __ovld __cnfn isinf(double2);",
"\012long3 __ovld __cnfn isinf(double3);\012long4 __ovld __cnfn isinf(double4);\012long8 __ovld __cnfn isinf(double8);\012long16 __ovld __cnfn isinf(double16);\012#endif //cl_khr_fp64\012#ifdef cl_khr_fp16\012int __ovld __cnfn isinf(half);\012short2 __ovld __cnfn isinf(half2);\012short3 __ovld __cnfn isinf(half3);\012short4 __ovld __cnfn isinf(half4);\012short8 __ovld __cnfn isinf(half8);\012short16 __ovld __cnfn isinf(half16);\012#endif //cl_khr_fp16\012\012/**\012 * Test for a NaN.\012 */\012int __ovld __cnfn isnan(float);\012int2 __ovld __cnfn isnan(float2);\012int3 __ovld __cnfn isnan(float3);\012int4 __ovld __cnfn isnan(float4);\012int8 __ovld __cnfn isnan(float8);\012int16 __ovld __cnfn isnan(float16);\012#ifdef cl_khr_fp64\012int __ovld __cnfn isnan(double);\012long2 __ovld __cnfn isnan(double2);\012long3 __ovld __cnfn isnan(double3);\012long4 __ovld __cnfn isnan(double4);\012long8 __ovld __cnfn isnan(double8);\012long16 __ovld __cnfn isnan(double16);\012#endif //cl_khr_fp64\012#ifdef cl_khr_fp16\012int __ovld __cnfn isnan(half);\012short2 __ovld __cnfn isnan(half2);\012short3 __ovld __cnfn isnan(half3);\012s",
"hort4 __ovld __cnfn isnan(half4);\012short8 __ovld __cnfn isnan(half8);\012short16 __ovld __cnfn isnan(half16);\012#endif //cl_khr_fp16\012\012/**\012 * Test for a normal value.\012 */\012int __ovld __cnfn isnormal(float);\012int2 __ovld __cnfn isnormal(float2);\012int3 __ovld __cnfn isnormal(float3);\012int4 __ovld __cnfn isnormal(float4);\012int8 __ovld __cnfn isnormal(float8);\012int16 __ovld __cnfn isnormal(float16);\012#ifdef cl_khr_fp64\012int __ovld __cnfn isnormal(double);\012long2 __ovld __cnfn isnormal(double2);\012long3 __ovld __cnfn isnormal(double3);\012long4 __ovld __cnfn isnormal(double4);\012long8 __ovld __cnfn isnormal(double8);\012long16 __ovld __cnfn isnormal(double16);\012#endif //cl_khr_fp64\012#ifdef cl_khr_fp16\012int __ovld __cnfn isnormal(half);\012short2 __ovld __cnfn isnormal(half2);\012short3 __ovld __cnfn isnormal(half3);\012short4 __ovld __cnfn isnormal(half4);\012short8 __ovld __cnfn isnormal(half8);\012short16 __ovld __cnfn isnormal(half16);\012#endif //cl_khr_fp16\012\012/**\012 * Test if arguments are ordered. isordered() takes\012 * arguments x and y, and returns the resu",
"lt\012 * isequal(x, x) && isequal(y, y).\012 */\012int __ovld __cnfn isordered(float x, float y);\012int2 __ovld __cnfn isordered(float2 x, float2 y);\012int3 __ovld __cnfn isordered(float3 x, float3 y);\012int4 __ovld __cnfn isordered(float4 x, float4 y);\012int8 __ovld __cnfn isordered(float8 x, float8 y);\012int16 __ovld __cnfn isordered(float16 x, float16 y);\012#ifdef cl_khr_fp64\012int __ovld __cnfn isordered(double x, double y);\012long2 __ovld __cnfn isordered(double2 x, double2 y);\012long3 __ovld __cnfn isordered(double3 x, double3 y);\012long4 __ovld __cnfn isordered(double4 x, double4 y);\012long8 __ovld __cnfn isordered(double8 x, double8 y);\012long16 __ovld __cnfn isordered(double16 x, double16 y);\012#endif //cl_khr_fp64\012#ifdef cl_khr_fp16\012int __ovld __cnfn isordered(half x, half y);\012short2 __ovld __cnfn isordered(half2 x, half2 y);\012short3 __ovld __cnfn isordered(half3 x, half3 y);\012short4 __ovld __cnfn isordered(half4 x, half4 y);\012short8 __ovld __cnfn isordered(half8 x, half8 y);\012short16 __ovld __cnfn isordered(half16 x, half16 y);\012#endif /",
"/cl_khr_fp16\012\012/**\012 * Test if arguments are unordered. isunordered()\012 * takes arguments x and y, returning non-zero if x or y\012 * is NaN, and zero otherwise.\012 */\012int __ovld __cnfn isunordered(float x, float y);\012int2 __ovld __cnfn isunordered(float2 x, float2 y);\012int3 __ovld __cnfn isunordered(float3 x, float3 y);\012int4 __ovld __cnfn isunordered(float4 x, float4 y);\012int8 __ovld __cnfn isunordered(float8 x, float8 y);\012int16 __ovld __cnfn isunordered(float16 x, float16 y);\012#ifdef cl_khr_fp64\012int __ovld __cnfn isunordered(double x, double y);\012long2 __ovld __cnfn isunordered(double2 x, double2 y);\012long3 __ovld __cnfn isunordered(double3 x, double3 y);\012long4 __ovld __cnfn isunordered(double4 x, double4 y);\012long8 __ovld __cnfn isunordered(double8 x, double8 y);\012long16 __ovld __cnfn isunordered(double16 x, double16 y);\012#endif //cl_khr_fp64\012#ifdef cl_khr_fp16\012int __ovld __cnfn isunordered(half x, half y);\012short2 __ovld __cnfn isunordered(half2 x, half2 y);\012short3 __ovld __cnfn isunordered(half3 x, half3 y);\012short4 __ovld",
" __cnfn isunordered(half4 x, half4 y);\012short8 __ovld __cnfn isunordered(half8 x, half8 y);\012short16 __ovld __cnfn isunordered(half16 x, half16 y);\012#endif //cl_khr_fp16\012\012/**\012 * Test for sign bit. The scalar version of the function\012 * returns a 1 if the sign bit in the float is set else returns\012 * 0. The vector version of the function returns the\012 * following for each component in floatn: a -1 if the\012 * sign bit in the float is set else returns 0.\012 */\012int __ovld __cnfn signbit(float);\012int2 __ovld __cnfn signbit(float2);\012int3 __ovld __cnfn signbit(float3);\012int4 __ovld __cnfn signbit(float4);\012int8 __ovld __cnfn signbit(float8);\012int16 __ovld __cnfn signbit(float16);\012#ifdef cl_khr_fp64\012int __ovld __cnfn signbit(double);\012long2 __ovld __cnfn signbit(double2);\012long3 __ovld __cnfn signbit(double3);\012long4 __ovld __cnfn signbit(double4);\012long8 __ovld __cnfn signbit(double8);\012long16 __ovld __cnfn signbit(double16);\012#endif //cl_khr_fp64\012#ifdef cl_khr_fp16\012int __ovld __cnfn signbit(half);\012short2 __ovld __cnfn signbit(half2);",
"\012short3 __ovld __cnfn signbit(half3);\012short4 __ovld __cnfn signbit(half4);\012short8 __ovld __cnfn signbit(half8);\012short16 __ovld __cnfn signbit(half16);\012#endif //cl_khr_fp16\012\012/**\012 * Returns 1 if the most significant bit in any component\012 * of x is set; otherwise returns 0.\012 */\012int __ovld __cnfn any(char x);\012int __ovld __cnfn any(char2 x);\012int __ovld __cnfn any(char3 x);\012int __ovld __cnfn any(char4 x);\012int __ovld __cnfn any(char8 x);\012int __ovld __cnfn any(char16 x);\012int __ovld __cnfn any(short x);\012int __ovld __cnfn any(short2 x);\012int __ovld __cnfn any(short3 x);\012int __ovld __cnfn any(short4 x);\012int __ovld __cnfn any(short8 x);\012int __ovld __cnfn any(short16 x);\012int __ovld __cnfn any(int x);\012int __ovld __cnfn any(int2 x);\012int __ovld __cnfn any(int3 x);\012int __ovld __cnfn any(int4 x);\012int __ovld __cnfn any(int8 x);\012int __ovld __cnfn any(int16 x);\012int __ovld __cnfn any(long x);\012int __ovld __cnfn any(long2 x);\012int __ovld __cnfn any(long3 x);\012int __ovld __cnfn any(long4 x);\012int __ovld __cnfn any(long8 x);\012int __ovld __",
"cnfn any(long16 x);\012\012/**\012 * Returns 1 if the most significant bit in all components\012 * of x is set; otherwise returns 0.\012 */\012int __ovld __cnfn all(char x);\012int __ovld __cnfn all(char2 x);\012int __ovld __cnfn all(char3 x);\012int __ovld __cnfn all(char4 x);\012int __ovld __cnfn all(char8 x);\012int __ovld __cnfn all(char16 x);\012int __ovld __cnfn all(short x);\012int __ovld __cnfn all(short2 x);\012int __ovld __cnfn all(short3 x);\012int __ovld __cnfn all(short4 x);\012int __ovld __cnfn all(short8 x);\012int __ovld __cnfn all(short16 x);\012int __ovld __cnfn all(int x);\012int __ovld __cnfn all(int2 x);\012int __ovld __cnfn all(int3 x);\012int __ovld __cnfn all(int4 x);\012int __ovld __cnfn all(int8 x);\012int __ovld __cnfn all(int16 x);\012int __ovld __cnfn all(long x);\012int __ovld __cnfn all(long2 x);\012int __ovld __cnfn all(long3 x);\012int __ovld __cnfn all(long4 x);\012int __ovld __cnfn all(long8 x);\012int __ovld __cnfn all(long16 x);\012\012/**\012 * Each bit of the result is the corresponding bit of a if\012 * the corresponding bit of c is 0. Otherwise it is the\012 * correspo",
"nding bit of b.\012 */\012char __ovld __cnfn bitselect(char a, char b, char c);\012uchar __ovld __cnfn bitselect(uchar a, uchar b, uchar c);\012char2 __ovld __cnfn bitselect(char2 a, char2 b, char2 c);\012uchar2 __ovld __cnfn bitselect(uchar2 a, uchar2 b, uchar2 c);\012char3 __ovld __cnfn bitselect(char3 a, char3 b, char3 c);\012uchar3 __ovld __cnfn bitselect(uchar3 a, uchar3 b, uchar3 c);\012char4 __ovld __cnfn bitselect(char4 a, char4 b, char4 c);\012uchar4 __ovld __cnfn bitselect(uchar4 a, uchar4 b, uchar4 c);\012char8 __ovld __cnfn bitselect(char8 a, char8 b, char8 c);\012uchar8 __ovld __cnfn bitselect(uchar8 a, uchar8 b, uchar8 c);\012char16 __ovld __cnfn bitselect(char16 a, char16 b, char16 c);\012uchar16 __ovld __cnfn bitselect(uchar16 a, uchar16 b, uchar16 c);\012short __ovld __cnfn bitselect(short a, short b, short c);\012ushort __ovld __cnfn bitselect(ushort a, ushort b, ushort c);\012short2 __ovld __cnfn bitselect(short2 a, short2 b, short2 c);\012ushort2 __ovld __cnfn bitselect(ushort2 a, ushort2 b, ushort2 c);\012short3 __ovld __cnfn bitselect(short",
"3 a, short3 b, short3 c);\012ushort3 __ovld __cnfn bitselect(ushort3 a, ushort3 b, ushort3 c);\012short4 __ovld __cnfn bitselect(short4 a, short4 b, short4 c);\012ushort4 __ovld __cnfn bitselect(ushort4 a, ushort4 b, ushort4 c);\012short8 __ovld __cnfn bitselect(short8 a, short8 b, short8 c);\012ushort8 __ovld __cnfn bitselect(ushort8 a, ushort8 b, ushort8 c);\012short16 __ovld __cnfn bitselect(short16 a, short16 b, short16 c);\012ushort16 __ovld __cnfn bitselect(ushort16 a, ushort16 b, ushort16 c);\012int __ovld __cnfn bitselect(int a, int b, int c);\012uint __ovld __cnfn bitselect(uint a, uint b, uint c);\012int2 __ovld __cnfn bitselect(int2 a, int2 b, int2 c);\012uint2 __ovld __cnfn bitselect(uint2 a, uint2 b, uint2 c);\012int3 __ovld __cnfn bitselect(int3 a, int3 b, int3 c);\012uint3 __ovld __cnfn bitselect(uint3 a, uint3 b, uint3 c);\012int4 __ovld __cnfn bitselect(int4 a, int4 b, int4 c);\012uint4 __ovld __cnfn bitselect(uint4 a, uint4 b, uint4 c);\012int8 __ovld __cnfn bitselect(int8 a, int8 b, int8 c);\012uint8 __ovld __cnfn bitselect(uint8 a, uint8 b",
", uint8 c);\012int16 __ovld __cnfn bitselect(int16 a, int16 b, int16 c);\012uint16 __ovld __cnfn bitselect(uint16 a, uint16 b, uint16 c);\012long __ovld __cnfn bitselect(long a, long b, long c);\012ulong __ovld __cnfn bitselect(ulong a, ulong b, ulong c);\012long2 __ovld __cnfn bitselect(long2 a, long2 b, long2 c);\012ulong2 __ovld __cnfn bitselect(ulong2 a, ulong2 b, ulong2 c);\012long3 __ovld __cnfn bitselect(long3 a, long3 b, long3 c);\012ulong3 __ovld __cnfn bitselect(ulong3 a, ulong3 b, ulong3 c);\012long4 __ovld __cnfn bitselect(long4 a, long4 b, long4 c);\012ulong4 __ovld __cnfn bitselect(ulong4 a, ulong4 b, ulong4 c);\012long8 __ovld __cnfn bitselect(long8 a, long8 b, long8 c);\012ulong8 __ovld __cnfn bitselect(ulong8 a, ulong8 b, ulong8 c);\012long16 __ovld __cnfn bitselect(long16 a, long16 b, long16 c);\012ulong16 __ovld __cnfn bitselect(ulong16 a, ulong16 b, ulong16 c);\012float __ovld __cnfn bitselect(float a, float b, float c);\012float2 __ovld __cnfn bitselect(float2 a, float2 b, float2 c);\012float3 __ovld __cnfn bitselect(float3 a, float3 b, f",
"loat3 c);\012float4 __ovld __cnfn bitselect(float4 a, float4 b, float4 c);\012float8 __ovld __cnfn bitselect(float8 a, float8 b, float8 c);\012float16 __ovld __cnfn bitselect(float16 a, float16 b, float16 c);\012#ifdef cl_khr_fp64\012double __ovld __cnfn bitselect(double a, double b, double c);\012double2 __ovld __cnfn bitselect(double2 a, double2 b, double2 c);\012double3 __ovld __cnfn bitselect(double3 a, double3 b, double3 c);\012double4 __ovld __cnfn bitselect(double4 a, double4 b, double4 c);\012double8 __ovld __cnfn bitselect(double8 a, double8 b, double8 c);\012double16 __ovld __cnfn bitselect(double16 a, double16 b, double16 c);\012#endif //cl_khr_fp64\012#ifdef cl_khr_fp16\012half __ovld __cnfn bitselect(half a, half b, half c);\012half2 __ovld __cnfn bitselect(half2 a, half2 b, half2 c);\012half3 __ovld __cnfn bitselect(half3 a, half3 b, half3 c);\012half4 __ovld __cnfn bitselect(half4 a, half4 b, half4 c);\012half8 __ovld __cnfn bitselect(half8 a, half8 b, half8 c);\012half16 __ovld __cnfn bitselect(half16 a, half16 b, half16 c);\012#endif //cl_khr_fp16\012",
"\012/**\012 * For each component of a vector type,\012 * result[i] = if MSB of c[i] is set \? b[i] : a[i].\012 * For a scalar type, result = c \? b : a.\012 */\012char __ovld __cnfn select(char a, char b, char c);\012uchar __ovld __cnfn select(uchar a, uchar b, char c);\012char2 __ovld __cnfn select(char2 a, char2 b, char2 c);\012uchar2 __ovld __cnfn select(uchar2 a, uchar2 b, char2 c);\012char3 __ovld __cnfn select(char3 a, char3 b, char3 c);\012uchar3 __ovld __cnfn select(uchar3 a, uchar3 b, char3 c);\012char4 __ovld __cnfn select(char4 a, char4 b, char4 c);\012uchar4 __ovld __cnfn select(uchar4 a, uchar4 b, char4 c);\012char8 __ovld __cnfn select(char8 a, char8 b, char8 c);\012uchar8 __ovld __cnfn select(uchar8 a, uchar8 b, char8 c);\012char16 __ovld __cnfn select(char16 a, char16 b, char16 c);\012uchar16 __ovld __cnfn select(uchar16 a, uchar16 b, char16 c);\012short __ovld __cnfn select(short a, short b, char c);\012ushort __ovld __cnfn select(ushort a, ushort b, char c);\012short2 __ovld __cnfn select(short2 a, short2 b, char2 c);\012ushort2 __ovld __cnfn select(ushor",
"t2 a, ushort2 b, char2 c);\012short3 __ovld __cnfn select(short3 a, short3 b, char3 c);\012ushort3 __ovld __cnfn select(ushort3 a, ushort3 b, char3 c);\012short4 __ovld __cnfn select(short4 a, short4 b, char4 c);\012ushort4 __ovld __cnfn select(ushort4 a, ushort4 b, char4 c);\012short8 __ovld __cnfn select(short8 a, short8 b, char8 c);\012ushort8 __ovld __cnfn select(ushort8 a, ushort8 b, char8 c);\012short16 __ovld __cnfn select(short16 a, short16 b, char16 c);\012ushort16 __ovld __cnfn select(ushort16 a, ushort16 b, char16 c);\012int __ovld __cnfn select(int a, int b, char c);\012uint __ovld __cnfn select(uint a, uint b, char c);\012int2 __ovld __cnfn select(int2 a, int2 b, char2 c);\012uint2 __ovld __cnfn select(uint2 a, uint2 b, char2 c);\012int3 __ovld __cnfn select(int3 a, int3 b, char3 c);\012uint3 __ovld __cnfn select(uint3 a, uint3 b, char3 c);\012int4 __ovld __cnfn select(int4 a, int4 b, char4 c);\012uint4 __ovld __cnfn select(uint4 a, uint4 b, char4 c);\012int8 __ovld __cnfn select(int8 a, int8 b, char8 c);\012uint8 __ovld __cnfn select(uint8 a, uint8",
" b, char8 c);\012int16 __ovld __cnfn select(int16 a, int16 b, char16 c);\012uint16 __ovld __cnfn select(uint16 a, uint16 b, char16 c);\012long __ovld __cnfn select(long a, long b, char c);\012ulong __ovld __cnfn select(ulong a, ulong b, char c);\012long2 __ovld __cnfn select(long2 a, long2 b, char2 c);\012ulong2 __ovld __cnfn select(ulong2 a, ulong2 b, char2 c);\012long3 __ovld __cnfn select(long3 a, long3 b, char3 c);\012ulong3 __ovld __cnfn select(ulong3 a, ulong3 b, char3 c);\012long4 __ovld __cnfn select(long4 a, long4 b, char4 c);\012ulong4 __ovld __cnfn select(ulong4 a, ulong4 b, char4 c);\012long8 __ovld __cnfn select(long8 a, long8 b, char8 c);\012ulong8 __ovld __cnfn select(ulong8 a, ulong8 b, char8 c);\012long16 __ovld __cnfn select(long16 a, long16 b, char16 c);\012ulong16 __ovld __cnfn select(ulong16 a, ulong16 b, char16 c);\012float __ovld __cnfn select(float a, float b, char c);\012float2 __ovld __cnfn select(float2 a, float2 b, char2 c);\012float3 __ovld __cnfn select(float3 a, float3 b, char3 c);\012float4 __ovld __cnfn select(float4 a, float4 b,",
" char4 c);\012float8 __ovld __cnfn select(float8 a, float8 b, char8 c);\012float16 __ovld __cnfn select(float16 a, float16 b, char16 c);\012char __ovld __cnfn select(char a, char b, short c);\012uchar __ovld __cnfn select(uchar a, uchar b, short c);\012char2 __ovld __cnfn select(char2 a, char2 b, short2 c);\012uchar2 __ovld __cnfn select(uchar2 a, uchar2 b, short2 c);\012char3 __ovld __cnfn select(char3 a, char3 b, short3 c);\012uchar3 __ovld __cnfn select(uchar3 a, uchar3 b, short3 c);\012char4 __ovld __cnfn select(char4 a, char4 b, short4 c);\012uchar4 __ovld __cnfn select(uchar4 a, uchar4 b, short4 c);\012char8 __ovld __cnfn select(char8 a, char8 b, short8 c);\012uchar8 __ovld __cnfn select(uchar8 a, uchar8 b, short8 c);\012char16 __ovld __cnfn select(char16 a, char16 b, short16 c);\012uchar16 __ovld __cnfn select(uchar16 a, uchar16 b, short16 c);\012short __ovld __cnfn select(short a, short b, short c);\012ushort __ovld __cnfn select(ushort a, ushort b, short c);\012short2 __ovld __cnfn select(short2 a, short2 b, short2 c);\012ushort2 __ovld __cnfn select(us",
"hort2 a, ushort2 b, short2 c);\012short3 __ovld __cnfn select(short3 a, short3 b, short3 c);\012ushort3 __ovld __cnfn select(ushort3 a, ushort3 b, short3 c);\012short4 __ovld __cnfn select(short4 a, short4 b, short4 c);\012ushort4 __ovld __cnfn select(ushort4 a, ushort4 b, short4 c);\012short8 __ovld __cnfn select(short8 a, short8 b, short8 c);\012ushort8 __ovld __cnfn select(ushort8 a, ushort8 b, short8 c);\012short16 __ovld __cnfn select(short16 a, short16 b, short16 c);\012ushort16 __ovld __cnfn select(ushort16 a, ushort16 b, short16 c);\012int __ovld __cnfn select(int a, int b, short c);\012uint __ovld __cnfn select(uint a, uint b, short c);\012int2 __ovld __cnfn select(int2 a, int2 b, short2 c);\012uint2 __ovld __cnfn select(uint2 a, uint2 b, short2 c);\012int3 __ovld __cnfn select(int3 a, int3 b, short3 c);\012uint3 __ovld __cnfn select(uint3 a, uint3 b, short3 c);\012int4 __ovld __cnfn select(int4 a, int4 b, short4 c);\012uint4 __ovld __cnfn select(uint4 a, uint4 b, short4 c);\012int8 __ovld __cnfn select(int8 a, int8 b, short8 c);\012uint8 __ovld __cnfn ",
"select(uint8 a, uint8 b, short8 c);\012int16 __ovld __cnfn select(int16 a, int16 b, short16 c);\012uint16 __ovld __cnfn select(uint16 a, uint16 b, short16 c);\012long __ovld __cnfn select(long a, long b, short c);\012ulong __ovld __cnfn select(ulong a, ulong b, short c);\012long2 __ovld __cnfn select(long2 a, long2 b, short2 c);\012ulong2 __ovld __cnfn select(ulong2 a, ulong2 b, short2 c);\012long3 __ovld __cnfn select(long3 a, long3 b, short3 c);\012ulong3 __ovld __cnfn select(ulong3 a, ulong3 b, short3 c);\012long4 __ovld __cnfn select(long4 a, long4 b, short4 c);\012ulong4 __ovld __cnfn select(ulong4 a, ulong4 b, short4 c);\012long8 __ovld __cnfn select(long8 a, long8 b, short8 c);\012ulong8 __ovld __cnfn select(ulong8 a, ulong8 b, short8 c);\012long16 __ovld __cnfn select(long16 a, long16 b, short16 c);\012ulong16 __ovld __cnfn select(ulong16 a, ulong16 b, short16 c);\012float __ovld __cnfn select(float a, float b, short c);\012float2 __ovld __cnfn select(float2 a, float2 b, short2 c);\012float3 __ovld __cnfn select(float3 a, float3 b, short3 c);\012float4 _",
"_ovld __cnfn select(float4 a, float4 b, short4 c);\012float8 __ovld __cnfn select(float8 a, float8 b, short8 c);\012float16 __ovld __cnfn select(float16 a, float16 b, short16 c);\012char __ovld __cnfn select(char a, char b, int c);\012uchar __ovld __cnfn select(uchar a, uchar b, int c);\012char2 __ovld __cnfn select(char2 a, char2 b, int2 c);\012uchar2 __ovld __cnfn select(uchar2 a, uchar2 b, int2 c);\012char3 __ovld __cnfn select(char3 a, char3 b, int3 c);\012uchar3 __ovld __cnfn select(uchar3 a, uchar3 b, int3 c);\012char4 __ovld __cnfn select(char4 a, char4 b, int4 c);\012uchar4 __ovld __cnfn select(uchar4 a, uchar4 b, int4 c);\012char8 __ovld __cnfn select(char8 a, char8 b, int8 c);\012uchar8 __ovld __cnfn select(uchar8 a, uchar8 b, int8 c);\012char16 __ovld __cnfn select(char16 a, char16 b, int16 c);\012uchar16 __ovld __cnfn select(uchar16 a, uchar16 b, int16 c);\012short __ovld __cnfn select(short a, short b, int c);\012ushort __ovld __cnfn select(ushort a, ushort b, int c);\012short2 __ovld __cnfn select(short2 a, short2 b, int2 c);\012ushort2 __ovld __cn",
"fn select(ushort2 a, ushort2 b, int2 c);\012short3 __ovld __cnfn select(short3 a, short3 b, int3 c);\012ushort3 __ovld __cnfn select(ushort3 a, ushort3 b, int3 c);\012short4 __ovld __cnfn select(short4 a, short4 b, int4 c);\012ushort4 __ovld __cnfn select(ushort4 a, ushort4 b, int4 c);\012short8 __ovld __cnfn select(short8 a, short8 b, int8 c);\012ushort8 __ovld __cnfn select(ushort8 a, ushort8 b, int8 c);\012short16 __ovld __cnfn select(short16 a, short16 b, int16 c);\012ushort16 __ovld __cnfn select(ushort16 a, ushort16 b, int16 c);\012int __ovld __cnfn select(int a, int b, int c);\012uint __ovld __cnfn select(uint a, uint b, int c);\012int2 __ovld __cnfn select(int2 a, int2 b, int2 c);\012uint2 __ovld __cnfn select(uint2 a, uint2 b, int2 c);\012int3 __ovld __cnfn select(int3 a, int3 b, int3 c);\012uint3 __ovld __cnfn select(uint3 a, uint3 b, int3 c);\012int4 __ovld __cnfn select(int4 a, int4 b, int4 c);\012uint4 __ovld __cnfn select(uint4 a, uint4 b, int4 c);\012int8 __ovld __cnfn select(int8 a, int8 b, int8 c);\012uint8 __ovld __cnfn select(uint8 a, uint8 b,",
" int8 c);\012int16 __ovld __cnfn select(int16 a, int16 b, int16 c);\012uint16 __ovld __cnfn select(uint16 a, uint16 b, int16 c);\012long __ovld __cnfn select(long a, long b, int c);\012ulong __ovld __cnfn select(ulong a, ulong b, int c);\012long2 __ovld __cnfn select(long2 a, long2 b, int2 c);\012ulong2 __ovld __cnfn select(ulong2 a, ulong2 b, int2 c);\012long3 __ovld __cnfn select(long3 a, long3 b, int3 c);\012ulong3 __ovld __cnfn select(ulong3 a, ulong3 b, int3 c);\012long4 __ovld __cnfn select(long4 a, long4 b, int4 c);\012ulong4 __ovld __cnfn select(ulong4 a, ulong4 b, int4 c);\012long8 __ovld __cnfn select(long8 a, long8 b, int8 c);\012ulong8 __ovld __cnfn select(ulong8 a, ulong8 b, int8 c);\012long16 __ovld __cnfn select(long16 a, long16 b, int16 c);\012ulong16 __ovld __cnfn select(ulong16 a, ulong16 b, int16 c);\012float __ovld __cnfn select(float a, float b, int c);\012float2 __ovld __cnfn select(float2 a, float2 b, int2 c);\012float3 __ovld __cnfn select(float3 a, float3 b, int3 c);\012float4 __ovld __cnfn select(float4 a, float4 b, int4 c);\012float8 __ov",
"ld __cnfn select(float8 a, float8 b, int8 c);\012float16 __ovld __cnfn select(float16 a, float16 b, int16 c);\012char __ovld __cnfn select(char a, char b, long c);\012uchar __ovld __cnfn select(uchar a, uchar b, long c);\012char2 __ovld __cnfn select(char2 a, char2 b, long2 c);\012uchar2 __ovld __cnfn select(uchar2 a, uchar2 b, long2 c);\012char3 __ovld __cnfn select(char3 a, char3 b, long3 c);\012uchar3 __ovld __cnfn select(uchar3 a, uchar3 b, long3 c);\012char4 __ovld __cnfn select(char4 a, char4 b, long4 c);\012uchar4 __ovld __cnfn select(uchar4 a, uchar4 b, long4 c);\012char8 __ovld __cnfn select(char8 a, char8 b, long8 c);\012uchar8 __ovld __cnfn select(uchar8 a, uchar8 b, long8 c);\012char16 __ovld __cnfn select(char16 a, char16 b, long16 c);\012uchar16 __ovld __cnfn select(uchar16 a, uchar16 b, long16 c);\012short __ovld __cnfn select(short a, short b, long c);\012ushort __ovld __cnfn select(ushort a, ushort b, long c);\012short2 __ovld __cnfn select(short2 a, short2 b, long2 c);\012ushort2 __ovld __cnfn select(ushort2 a, ushort2 b, long2 c);\012short3 __",
"ovld __cnfn select(short3 a, short3 b, long3 c);\012ushort3 __ovld __cnfn select(ushort3 a, ushort3 b, long3 c);\012short4 __ovld __cnfn select(short4 a, short4 b, long4 c);\012ushort4 __ovld __cnfn select(ushort4 a, ushort4 b, long4 c);\012short8 __ovld __cnfn select(short8 a, short8 b, long8 c);\012ushort8 __ovld __cnfn select(ushort8 a, ushort8 b, long8 c);\012short16 __ovld __cnfn select(short16 a, short16 b, long16 c);\012ushort16 __ovld __cnfn select(ushort16 a, ushort16 b, long16 c);\012int __ovld __cnfn select(int a, int b, long c);\012uint __ovld __cnfn select(uint a, uint b, long c);\012int2 __ovld __cnfn select(int2 a, int2 b, long2 c);\012uint2 __ovld __cnfn select(uint2 a, uint2 b, long2 c);\012int3 __ovld __cnfn select(int3 a, int3 b, long3 c);\012uint3 __ovld __cnfn select(uint3 a, uint3 b, long3 c);\012int4 __ovld __cnfn select(int4 a, int4 b, long4 c);\012uint4 __ovld __cnfn select(uint4 a, uint4 b, long4 c);\012int8 __ovld __cnfn select(int8 a, int8 b, long8 c);\012uint8 __ovld __cnfn select(uint8 a, uint8 b, long8 c);\012int16 __ovld __cnfn se",
"lect(int16 a, int16 b, long16 c);\012uint16 __ovld __cnfn select(uint16 a, uint16 b, long16 c);\012long __ovld __cnfn select(long a, long b, long c);\012ulong __ovld __cnfn select(ulong a, ulong b, long c);\012long2 __ovld __cnfn select(long2 a, long2 b, long2 c);\012ulong2 __ovld __cnfn select(ulong2 a, ulong2 b, long2 c);\012long3 __ovld __cnfn select(long3 a, long3 b, long3 c);\012ulong3 __ovld __cnfn select(ulong3 a, ulong3 b, long3 c);\012long4 __ovld __cnfn select(long4 a, long4 b, long4 c);\012ulong4 __ovld __cnfn select(ulong4 a, ulong4 b, long4 c);\012long8 __ovld __cnfn select(long8 a, long8 b, long8 c);\012ulong8 __ovld __cnfn select(ulong8 a, ulong8 b, long8 c);\012long16 __ovld __cnfn select(long16 a, long16 b, long16 c);\012ulong16 __ovld __cnfn select(ulong16 a, ulong16 b, long16 c);\012float __ovld __cnfn select(float a, float b, long c);\012float2 __ovld __cnfn select(float2 a, float2 b, long2 c);\012float3 __ovld __cnfn select(float3 a, float3 b, long3 c);\012float4 __ovld __cnfn select(float4 a, float4 b, long4 c);\012float8 __ovld __cnfn sele",
"ct(float8 a, float8 b, long8 c);\012float16 __ovld __cnfn select(float16 a, float16 b, long16 c);\012char __ovld __cnfn select(char a, char b, uchar c);\012uchar __ovld __cnfn select(uchar a, uchar b, uchar c);\012char2 __ovld __cnfn select(char2 a, char2 b, uchar2 c);\012uchar2 __ovld __cnfn select(uchar2 a, uchar2 b, uchar2 c);\012char3 __ovld __cnfn select(char3 a, char3 b, uchar3 c);\012uchar3 __ovld __cnfn select(uchar3 a, uchar3 b, uchar3 c);\012char4 __ovld __cnfn select(char4 a, char4 b, uchar4 c);\012uchar4 __ovld __cnfn select(uchar4 a, uchar4 b, uchar4 c);\012char8 __ovld __cnfn select(char8 a, char8 b, uchar8 c);\012uchar8 __ovld __cnfn select(uchar8 a, uchar8 b, uchar8 c);\012char16 __ovld __cnfn select(char16 a, char16 b, uchar16 c);\012uchar16 __ovld __cnfn select(uchar16 a, uchar16 b, uchar16 c);\012short __ovld __cnfn select(short a, short b, uchar c);\012ushort __ovld __cnfn select(ushort a, ushort b, uchar c);\012short2 __ovld __cnfn select(short2 a, short2 b, uchar2 c);\012ushort2 __ovld __cnfn select(ushort2 a, ushort2 b, uchar2 c);\012short",
"3 __ovld __cnfn select(short3 a, short3 b, uchar3 c);\012ushort3 __ovld __cnfn select(ushort3 a, ushort3 b, uchar3 c);\012short4 __ovld __cnfn select(short4 a, short4 b, uchar4 c);\012ushort4 __ovld __cnfn select(ushort4 a, ushort4 b, uchar4 c);\012short8 __ovld __cnfn select(short8 a, short8 b, uchar8 c);\012ushort8 __ovld __cnfn select(ushort8 a, ushort8 b, uchar8 c);\012short16 __ovld __cnfn select(short16 a, short16 b, uchar16 c);\012ushort16 __ovld __cnfn select(ushort16 a, ushort16 b, uchar16 c);\012int __ovld __cnfn select(int a, int b, uchar c);\012uint __ovld __cnfn select(uint a, uint b, uchar c);\012int2 __ovld __cnfn select(int2 a, int2 b, uchar2 c);\012uint2 __ovld __cnfn select(uint2 a, uint2 b, uchar2 c);\012int3 __ovld __cnfn select(int3 a, int3 b, uchar3 c);\012uint3 __ovld __cnfn select(uint3 a, uint3 b, uchar3 c);\012int4 __ovld __cnfn select(int4 a, int4 b, uchar4 c);\012uint4 __ovld __cnfn select(uint4 a, uint4 b, uchar4 c);\012int8 __ovld __cnfn select(int8 a, int8 b, uchar8 c);\012uint8 __ovld __cnfn select(uint8 a, uint8 b, uchar8 c);\012",
"int16 __ovld __cnfn select(int16 a, int16 b, uchar16 c);\012uint16 __ovld __cnfn select(uint16 a, uint16 b, uchar16 c);\012long __ovld __cnfn select(long a, long b, uchar c);\012ulong __ovld __cnfn select(ulong a, ulong b, uchar c);\012long2 __ovld __cnfn select(long2 a, long2 b, uchar2 c);\012ulong2 __ovld __cnfn select(ulong2 a, ulong2 b, uchar2 c);\012long3 __ovld __cnfn select(long3 a, long3 b, uchar3 c);\012ulong3 __ovld __cnfn select(ulong3 a, ulong3 b, uchar3 c);\012long4 __ovld __cnfn select(long4 a, long4 b, uchar4 c);\012ulong4 __ovld __cnfn select(ulong4 a, ulong4 b, uchar4 c);\012long8 __ovld __cnfn select(long8 a, long8 b, uchar8 c);\012ulong8 __ovld __cnfn select(ulong8 a, ulong8 b, uchar8 c);\012long16 __ovld __cnfn select(long16 a, long16 b, uchar16 c);\012ulong16 __ovld __cnfn select(ulong16 a, ulong16 b, uchar16 c);\012float __ovld __cnfn select(float a, float b, uchar c);\012float2 __ovld __cnfn select(float2 a, float2 b, uchar2 c);\012float3 __ovld __cnfn select(float3 a, float3 b, uchar3 c);\012float4 __ovld __cnfn select(float4 a, float4",
" b, uchar4 c);\012float8 __ovld __cnfn select(float8 a, float8 b, uchar8 c);\012float16 __ovld __cnfn select(float16 a, float16 b, uchar16 c);\012char __ovld __cnfn select(char a, char b, ushort c);\012uchar __ovld __cnfn select(uchar a, uchar b, ushort c);\012char2 __ovld __cnfn select(char2 a, char2 b, ushort2 c);\012uchar2 __ovld __cnfn select(uchar2 a, uchar2 b, ushort2 c);\012char3 __ovld __cnfn select(char3 a, char3 b, ushort3 c);\012uchar3 __ovld __cnfn select(uchar3 a, uchar3 b, ushort3 c);\012char4 __ovld __cnfn select(char4 a, char4 b, ushort4 c);\012uchar4 __ovld __cnfn select(uchar4 a, uchar4 b, ushort4 c);\012char8 __ovld __cnfn select(char8 a, char8 b, ushort8 c);\012uchar8 __ovld __cnfn select(uchar8 a, uchar8 b, ushort8 c);\012char16 __ovld __cnfn select(char16 a, char16 b, ushort16 c);\012uchar16 __ovld __cnfn select(uchar16 a, uchar16 b, ushort16 c);\012short __ovld __cnfn select(short a, short b, ushort c);\012ushort __ovld __cnfn select(ushort a, ushort b, ushort c);\012short2 __ovld __cnfn select(short2 a, short2 b, ushort2 c);\012ushort2 __",
"ovld __cnfn select(ushort2 a, ushort2 b, ushort2 c);\012short3 __ovld __cnfn select(short3 a, short3 b, ushort3 c);\012ushort3 __ovld __cnfn select(ushort3 a, ushort3 b, ushort3 c);\012short4 __ovld __cnfn select(short4 a, short4 b, ushort4 c);\012ushort4 __ovld __cnfn select(ushort4 a, ushort4 b, ushort4 c);\012short8 __ovld __cnfn select(short8 a, short8 b, ushort8 c);\012ushort8 __ovld __cnfn select(ushort8 a, ushort8 b, ushort8 c);\012short16 __ovld __cnfn select(short16 a, short16 b, ushort16 c);\012ushort16 __ovld __cnfn select(ushort16 a, ushort16 b, ushort16 c);\012int __ovld __cnfn select(int a, int b, ushort c);\012uint __ovld __cnfn select(uint a, uint b, ushort c);\012int2 __ovld __cnfn select(int2 a, int2 b, ushort2 c);\012uint2 __ovld __cnfn select(uint2 a, uint2 b, ushort2 c);\012int3 __ovld __cnfn select(int3 a, int3 b, ushort3 c);\012uint3 __ovld __cnfn select(uint3 a, uint3 b, ushort3 c);\012int4 __ovld __cnfn select(int4 a, int4 b, ushort4 c);\012uint4 __ovld __cnfn select(uint4 a, uint4 b, ushort4 c);\012int8 __ovld __cnfn select(int8 a, i",
"nt8 b, ushort8 c);\012uint8 __ovld __cnfn select(uint8 a, uint8 b, ushort8 c);\012int16 __ovld __cnfn select(int16 a, int16 b, ushort16 c);\012uint16 __ovld __cnfn select(uint16 a, uint16 b, ushort16 c);\012long __ovld __cnfn select(long a, long b, ushort c);\012ulong __ovld __cnfn select(ulong a, ulong b, ushort c);\012long2 __ovld __cnfn select(long2 a, long2 b, ushort2 c);\012ulong2 __ovld __cnfn select(ulong2 a, ulong2 b, ushort2 c);\012long3 __ovld __cnfn select(long3 a, long3 b, ushort3 c);\012ulong3 __ovld __cnfn select(ulong3 a, ulong3 b, ushort3 c);\012long4 __ovld __cnfn select(long4 a, long4 b, ushort4 c);\012ulong4 __ovld __cnfn select(ulong4 a, ulong4 b, ushort4 c);\012long8 __ovld __cnfn select(long8 a, long8 b, ushort8 c);\012ulong8 __ovld __cnfn select(ulong8 a, ulong8 b, ushort8 c);\012long16 __ovld __cnfn select(long16 a, long16 b, ushort16 c);\012ulong16 __ovld __cnfn select(ulong16 a, ulong16 b, ushort16 c);\012float __ovld __cnfn select(float a, float b, ushort c);\012float2 __ovld __cnfn select(float2 a, float2 b, ushort2 c);\012float3 __ov",
"ld __cnfn select(float3 a, float3 b, ushort3 c);\012float4 __ovld __cnfn select(float4 a, float4 b, ushort4 c);\012float8 __ovld __cnfn select(float8 a, float8 b, ushort8 c);\012float16 __ovld __cnfn select(float16 a, float16 b, ushort16 c);\012char __ovld __cnfn select(char a, char b, uint c);\012uchar __ovld __cnfn select(uchar a, uchar b, uint c);\012char2 __ovld __cnfn select(char2 a, char2 b, uint2 c);\012uchar2 __ovld __cnfn select(uchar2 a, uchar2 b, uint2 c);\012char3 __ovld __cnfn select(char3 a, char3 b, uint3 c);\012uchar3 __ovld __cnfn select(uchar3 a, uchar3 b, uint3 c);\012char4 __ovld __cnfn select(char4 a, char4 b, uint4 c);\012uchar4 __ovld __cnfn select(uchar4 a, uchar4 b, uint4 c);\012char8 __ovld __cnfn select(char8 a, char8 b, uint8 c);\012uchar8 __ovld __cnfn select(uchar8 a, uchar8 b, uint8 c);\012char16 __ovld __cnfn select(char16 a, char16 b, uint16 c);\012uchar16 __ovld __cnfn select(uchar16 a, uchar16 b, uint16 c);\012short __ovld __cnfn select(short a, short b, uint c);\012ushort __ovld __cnfn select(ushort a, ushort b, uint c);\012sh",
"ort2 __ovld __cnfn select(short2 a, short2 b, uint2 c);\012ushort2 __ovld __cnfn select(ushort2 a, ushort2 b, uint2 c);\012short3 __ovld __cnfn select(short3 a, short3 b, uint3 c);\012ushort3 __ovld __cnfn select(ushort3 a, ushort3 b, uint3 c);\012short4 __ovld __cnfn select(short4 a, short4 b, uint4 c);\012ushort4 __ovld __cnfn select(ushort4 a, ushort4 b, uint4 c);\012short8 __ovld __cnfn select(short8 a, short8 b, uint8 c);\012ushort8 __ovld __cnfn select(ushort8 a, ushort8 b, uint8 c);\012short16 __ovld __cnfn select(short16 a, short16 b, uint16 c);\012ushort16 __ovld __cnfn select(ushort16 a, ushort16 b, uint16 c);\012int __ovld __cnfn select(int a, int b, uint c);\012uint __ovld __cnfn select(uint a, uint b, uint c);\012int2 __ovld __cnfn select(int2 a, int2 b, uint2 c);\012uint2 __ovld __cnfn select(uint2 a, uint2 b, uint2 c);\012int3 __ovld __cnfn select(int3 a, int3 b, uint3 c);\012uint3 __ovld __cnfn select(uint3 a, uint3 b, uint3 c);\012int4 __ovld __cnfn select(int4 a, int4 b, uint4 c);\012uint4 __ovld __cnfn select(uint4 a, uint4 b, uint4 c);\012int",
"8 __ovld __cnfn select(int8 a, int8 b, uint8 c);\012uint8 __ovld __cnfn select(uint8 a, uint8 b, uint8 c);\012int16 __ovld __cnfn select(int16 a, int16 b, uint16 c);\012uint16 __ovld __cnfn select(uint16 a, uint16 b, uint16 c);\012long __ovld __cnfn select(long a, long b, uint c);\012ulong __ovld __cnfn select(ulong a, ulong b, uint c);\012long2 __ovld __cnfn select(long2 a, long2 b, uint2 c);\012ulong2 __ovld __cnfn select(ulong2 a, ulong2 b, uint2 c);\012long3 __ovld __cnfn select(long3 a, long3 b, uint3 c);\012ulong3 __ovld __cnfn select(ulong3 a, ulong3 b, uint3 c);\012long4 __ovld __cnfn select(long4 a, long4 b, uint4 c);\012ulong4 __ovld __cnfn select(ulong4 a, ulong4 b, uint4 c);\012long8 __ovld __cnfn select(long8 a, long8 b, uint8 c);\012ulong8 __ovld __cnfn select(ulong8 a, ulong8 b, uint8 c);\012long16 __ovld __cnfn select(long16 a, long16 b, uint16 c);\012ulong16 __ovld __cnfn select(ulong16 a, ulong16 b, uint16 c);\012float __ovld __cnfn select(float a, float b, uint c);\012float2 __ovld __cnfn select(float2 a, float2 b, uint2 c);\012float3 __ovld _",
"_cnfn select(float3 a, float3 b, uint3 c);\012float4 __ovld __cnfn select(float4 a, float4 b, uint4 c);\012float8 __ovld __cnfn select(float8 a, float8 b, uint8 c);\012float16 __ovld __cnfn select(float16 a, float16 b, uint16 c);\012char __ovld __cnfn select(char a, char b, ulong c);\012uchar __ovld __cnfn select(uchar a, uchar b, ulong c);\012char2 __ovld __cnfn select(char2 a, char2 b, ulong2 c);\012uchar2 __ovld __cnfn select(uchar2 a, uchar2 b, ulong2 c);\012char3 __ovld __cnfn select(char3 a, char3 b, ulong3 c);\012uchar3 __ovld __cnfn select(uchar3 a, uchar3 b, ulong3 c);\012char4 __ovld __cnfn select(char4 a, char4 b, ulong4 c);\012uchar4 __ovld __cnfn select(uchar4 a, uchar4 b, ulong4 c);\012char8 __ovld __cnfn select(char8 a, char8 b, ulong8 c);\012uchar8 __ovld __cnfn select(uchar8 a, uchar8 b, ulong8 c);\012char16 __ovld __cnfn select(char16 a, char16 b, ulong16 c);\012uchar16 __ovld __cnfn select(uchar16 a, uchar16 b, ulong16 c);\012short __ovld __cnfn select(short a, short b, ulong c);\012ushort __ovld __cnfn select(ushort a, ushort b, ulong c);\012",
"short2 __ovld __cnfn select(short2 a, short2 b, ulong2 c);\012ushort2 __ovld __cnfn select(ushort2 a, ushort2 b, ulong2 c);\012short3 __ovld __cnfn select(short3 a, short3 b, ulong3 c);\012ushort3 __ovld __cnfn select(ushort3 a, ushort3 b, ulong3 c);\012short4 __ovld __cnfn select(short4 a, short4 b, ulong4 c);\012ushort4 __ovld __cnfn select(ushort4 a, ushort4 b, ulong4 c);\012short8 __ovld __cnfn select(short8 a, short8 b, ulong8 c);\012ushort8 __ovld __cnfn select(ushort8 a, ushort8 b, ulong8 c);\012short16 __ovld __cnfn select(short16 a, short16 b, ulong16 c);\012ushort16 __ovld __cnfn select(ushort16 a, ushort16 b, ulong16 c);\012int __ovld __cnfn select(int a, int b, ulong c);\012uint __ovld __cnfn select(uint a, uint b, ulong c);\012int2 __ovld __cnfn select(int2 a, int2 b, ulong2 c);\012uint2 __ovld __cnfn select(uint2 a, uint2 b, ulong2 c);\012int3 __ovld __cnfn select(int3 a, int3 b, ulong3 c);\012uint3 __ovld __cnfn select(uint3 a, uint3 b, ulong3 c);\012int4 __ovld __cnfn select(int4 a, int4 b, ulong4 c);\012uint4 __ovld __cnfn select(uint4 a, uin",
"t4 b, ulong4 c);\012int8 __ovld __cnfn select(int8 a, int8 b, ulong8 c);\012uint8 __ovld __cnfn select(uint8 a, uint8 b, ulong8 c);\012int16 __ovld __cnfn select(int16 a, int16 b, ulong16 c);\012uint16 __ovld __cnfn select(uint16 a, uint16 b, ulong16 c);\012long __ovld __cnfn select(long a, long b, ulong c);\012ulong __ovld __cnfn select(ulong a, ulong b, ulong c);\012long2 __ovld __cnfn select(long2 a, long2 b, ulong2 c);\012ulong2 __ovld __cnfn select(ulong2 a, ulong2 b, ulong2 c);\012long3 __ovld __cnfn select(long3 a, long3 b, ulong3 c);\012ulong3 __ovld __cnfn select(ulong3 a, ulong3 b, ulong3 c);\012long4 __ovld __cnfn select(long4 a, long4 b, ulong4 c);\012ulong4 __ovld __cnfn select(ulong4 a, ulong4 b, ulong4 c);\012long8 __ovld __cnfn select(long8 a, long8 b, ulong8 c);\012ulong8 __ovld __cnfn select(ulong8 a, ulong8 b, ulong8 c);\012long16 __ovld __cnfn select(long16 a, long16 b, ulong16 c);\012ulong16 __ovld __cnfn select(ulong16 a, ulong16 b, ulong16 c);\012float __ovld __cnfn select(float a, float b, ulong c);\012float2 __ovld __cnfn select(float2 a",
", float2 b, ulong2 c);\012float3 __ovld __cnfn select(float3 a, float3 b, ulong3 c);\012float4 __ovld __cnfn select(float4 a, float4 b, ulong4 c);\012float8 __ovld __cnfn select(float8 a, float8 b, ulong8 c);\012float16 __ovld __cnfn select(float16 a, float16 b, ulong16 c);\012#ifdef cl_khr_fp64\012double __ovld __cnfn select(double a, double b, long c);\012double2 __ovld __cnfn select(double2 a, double2 b, long2 c);\012double3 __ovld __cnfn select(double3 a, double3 b, long3 c);\012double4 __ovld __cnfn select(double4 a, double4 b, long4 c);\012double8 __ovld __cnfn select(double8 a, double8 b, long8 c);\012double16 __ovld __cnfn select(double16 a, double16 b, long16 c);\012double __ovld __cnfn select(double a, double b, ulong c);\012double2 __ovld __cnfn select(double2 a, double2 b, ulong2 c);\012double3 __ovld __cnfn select(double3 a, double3 b, ulong3 c);\012double4 __ovld __cnfn select(double4 a, double4 b, ulong4 c);\012double8 __ovld __cnfn select(double8 a, double8 b, ulong8 c);\012double16 __ovld __cnfn select(double16 a, double16 b, ulong16 c);\012#end",
"if //cl_khr_fp64\012#ifdef cl_khr_fp16\012half __ovld __cnfn select(half a, half b, short c);\012half2 __ovld __cnfn select(half2 a, half2 b, short2 c);\012half3 __ovld __cnfn select(half3 a, half3 b, short3 c);\012half4 __ovld __cnfn select(half4 a, half4 b, short4 c);\012half8 __ovld __cnfn select(half8 a, half8 b, short8 c);\012half16 __ovld __cnfn select(half16 a, half16 b, short16 c);\012half __ovld __cnfn select(half a, half b, ushort c);\012half2 __ovld __cnfn select(half2 a, half2 b, ushort2 c);\012half3 __ovld __cnfn select(half3 a, half3 b, ushort3 c);\012half4 __ovld __cnfn select(half4 a, half4 b, ushort4 c);\012half8 __ovld __cnfn select(half8 a, half8 b, ushort8 c);\012half16 __ovld __cnfn select(half16 a, half16 b, ushort16 c);\012#endif //cl_khr_fp16\012\012/**\012 * The shuffle and shuffle2 built-in functions construct\012 * a permutation of elements from one or two input\012 * vectors respectively that are of the same type,\012 * returning a vector with the same element type as the\012 * input and length that is the same as the shuffle mask.\012 * The size",
" of each element in the mask must match the\012 * size of each element in the result. For shuffle, only\012 * the ilogb(2m-1) least significant bits of each mask\012 * element are considered. For shuffle2, only the\012 * ilogb(2m-1)+1 least significant bits of each mask\012 * element are considered. Other bits in the mask shall\012 * be ignored.\012 * The elements of the input vectors are numbered from\012 * left to right across one or both of the vectors. For this\012 * purpose, the number of elements in a vector is given\012 * by vec_step(gentypem). The shuffle mask operand\012 * specifies, for each element of the result vector, which\012 * element of the one or two input vectors the result\012 * element gets.\012 * Examples:\012 * uint4 mask = (uint4)(3, 2,\012 * 1, 0);\012 * float4 a;\012 * float4 r = shuffle(a, mask);\012 * // r.s0123 = a.wzyx\012 * uint8 mask = (uint8)(0, 1, 2, 3,\012 * 4, 5, 6, 7);\012 * float4 a, b;\012 * float8 r = shuffle2(a, b, mask);\012 * // r.s0123 = a.xyzw\012 * // r.s4567 = b.xyzw\012 * uint4 mask;\012 * float8 a;\012 * float4 b;\012 * b = shuffle(a, mask);\012 * E",
"xamples that are not valid are:\012 * uint8 mask;\012 * short16 a;\012 * short8 b;\012 * b = shuffle(a, mask); <- not valid\012 */\012char2 __ovld __cnfn shuffle(char2 x, uchar2 mask);\012char2 __ovld __cnfn shuffle(char4 x, uchar2 mask);\012char2 __ovld __cnfn shuffle(char8 x, uchar2 mask);\012char2 __ovld __cnfn shuffle(char16 x, uchar2 mask);\012\012uchar2 __ovld __cnfn shuffle(uchar2 x, uchar2 mask);\012uchar2 __ovld __cnfn shuffle(uchar4 x, uchar2 mask);\012uchar2 __ovld __cnfn shuffle(uchar8 x, uchar2 mask);\012uchar2 __ovld __cnfn shuffle(uchar16 x, uchar2 mask);\012\012short2 __ovld __cnfn shuffle(short2 x, ushort2 mask);\012short2 __ovld __cnfn shuffle(short4 x, ushort2 mask);\012short2 __ovld __cnfn shuffle(short8 x, ushort2 mask);\012short2 __ovld __cnfn shuffle(short16 x, ushort2 mask);\012\012ushort2 __ovld __cnfn shuffle(ushort2 x, ushort2 mask);\012ushort2 __ovld __cnfn shuffle(ushort4 x, ushort2 mask);\012ushort2 __ovld __cnfn shuffle(ushort8 x, ushort2 mask);\012ushort2 __ovld __cnfn shuffle(ushort16 x, ushort2 mask);\012\012int2 __ovld __cnfn shuffle(int2 x, uint2 mas",
"k);\012int2 __ovld __cnfn shuffle(int4 x, uint2 mask);\012int2 __ovld __cnfn shuffle(int8 x, uint2 mask);\012int2 __ovld __cnfn shuffle(int16 x, uint2 mask);\012\012uint2 __ovld __cnfn shuffle(uint2 x, uint2 mask);\012uint2 __ovld __cnfn shuffle(uint4 x, uint2 mask);\012uint2 __ovld __cnfn shuffle(uint8 x, uint2 mask);\012uint2 __ovld __cnfn shuffle(uint16 x, uint2 mask);\012\012long2 __ovld __cnfn shuffle(long2 x, ulong2 mask);\012long2 __ovld __cnfn shuffle(long4 x, ulong2 mask);\012long2 __ovld __cnfn shuffle(long8 x, ulong2 mask);\012long2 __ovld __cnfn shuffle(long16 x, ulong2 mask);\012\012ulong2 __ovld __cnfn shuffle(ulong2 x, ulong2 mask);\012ulong2 __ovld __cnfn shuffle(ulong4 x, ulong2 mask);\012ulong2 __ovld __cnfn shuffle(ulong8 x, ulong2 mask);\012ulong2 __ovld __cnfn shuffle(ulong16 x, ulong2 mask);\012\012float2 __ovld __cnfn shuffle(float2 x, uint2 mask);\012float2 __ovld __cnfn shuffle(float4 x, uint2 mask);\012float2 __ovld __cnfn shuffle(float8 x, uint2 mask);\012float2 __ovld __cnfn shuffle(float16 x, uint2 mask);\012\012char4 __ovld __cnfn shuffle(char2 x, uchar",
"4 mask);\012char4 __ovld __cnfn shuffle(char4 x, uchar4 mask);\012char4 __ovld __cnfn shuffle(char8 x, uchar4 mask);\012char4 __ovld __cnfn shuffle(char16 x, uchar4 mask);\012\012uchar4 __ovld __cnfn shuffle(uchar2 x, uchar4 mask);\012uchar4 __ovld __cnfn shuffle(uchar4 x, uchar4 mask);\012uchar4 __ovld __cnfn shuffle(uchar8 x, uchar4 mask);\012uchar4 __ovld __cnfn shuffle(uchar16 x, uchar4 mask);\012\012short4 __ovld __cnfn shuffle(short2 x, ushort4 mask);\012short4 __ovld __cnfn shuffle(short4 x, ushort4 mask);\012short4 __ovld __cnfn shuffle(short8 x, ushort4 mask);\012short4 __ovld __cnfn shuffle(short16 x, ushort4 mask);\012\012ushort4 __ovld __cnfn shuffle(ushort2 x, ushort4 mask);\012ushort4 __ovld __cnfn shuffle(ushort4 x, ushort4 mask);\012ushort4 __ovld __cnfn shuffle(ushort8 x, ushort4 mask);\012ushort4 __ovld __cnfn shuffle(ushort16 x, ushort4 mask);\012\012int4 __ovld __cnfn shuffle(int2 x, uint4 mask);\012int4 __ovld __cnfn shuffle(int4 x, uint4 mask);\012int4 __ovld __cnfn shuffle(int8 x, uint4 mask);\012int4 __ovld __cnfn shuffle(int16 x, uint4 mask);\012\012uint4 __",
"ovld __cnfn shuffle(uint2 x, uint4 mask);\012uint4 __ovld __cnfn shuffle(uint4 x, uint4 mask);\012uint4 __ovld __cnfn shuffle(uint8 x, uint4 mask);\012uint4 __ovld __cnfn shuffle(uint16 x, uint4 mask);\012\012long4 __ovld __cnfn shuffle(long2 x, ulong4 mask);\012long4 __ovld __cnfn shuffle(long4 x, ulong4 mask);\012long4 __ovld __cnfn shuffle(long8 x, ulong4 mask);\012long4 __ovld __cnfn shuffle(long16 x, ulong4 mask);\012\012ulong4 __ovld __cnfn shuffle(ulong2 x, ulong4 mask);\012ulong4 __ovld __cnfn shuffle(ulong4 x, ulong4 mask);\012ulong4 __ovld __cnfn shuffle(ulong8 x, ulong4 mask);\012ulong4 __ovld __cnfn shuffle(ulong16 x, ulong4 mask);\012\012float4 __ovld __cnfn shuffle(float2 x, uint4 mask);\012float4 __ovld __cnfn shuffle(float4 x, uint4 mask);\012float4 __ovld __cnfn shuffle(float8 x, uint4 mask);\012float4 __ovld __cnfn shuffle(float16 x, uint4 mask);\012\012char8 __ovld __cnfn shuffle(char2 x, uchar8 mask);\012char8 __ovld __cnfn shuffle(char4 x, uchar8 mask);\012char8 __ovld __cnfn shuffle(char8 x, uchar8 mask);\012char8 __ovld __cnfn shuffle(char16 x, uchar8 ma",
"sk);\012\012uchar8 __ovld __cnfn shuffle(uchar2 x, uchar8 mask);\012uchar8 __ovld __cnfn shuffle(uchar4 x, uchar8 mask);\012uchar8 __ovld __cnfn shuffle(uchar8 x, uchar8 mask);\012uchar8 __ovld __cnfn shuffle(uchar16 x, uchar8 mask);\012\012short8 __ovld __cnfn shuffle(short2 x, ushort8 mask);\012short8 __ovld __cnfn shuffle(short4 x, ushort8 mask);\012short8 __ovld __cnfn shuffle(short8 x, ushort8 mask);\012short8 __ovld __cnfn shuffle(short16 x, ushort8 mask);\012\012ushort8 __ovld __cnfn shuffle(ushort2 x, ushort8 mask);\012ushort8 __ovld __cnfn shuffle(ushort4 x, ushort8 mask);\012ushort8 __ovld __cnfn shuffle(ushort8 x, ushort8 mask);\012ushort8 __ovld __cnfn shuffle(ushort16 x, ushort8 mask);\012\012int8 __ovld __cnfn shuffle(int2 x, uint8 mask);\012int8 __ovld __cnfn shuffle(int4 x, uint8 mask);\012int8 __ovld __cnfn shuffle(int8 x, uint8 mask);\012int8 __ovld __cnfn shuffle(int16 x, uint8 mask);\012\012uint8 __ovld __cnfn shuffle(uint2 x, uint8 mask);\012uint8 __ovld __cnfn shuffle(uint4 x, uint8 mask);\012uint8 __ovld __cnfn shuffle(uint8 x, uint8 mask);\012uint8 __ovld __c",
"nfn shuffle(uint16 x, uint8 mask);\012\012long8 __ovld __cnfn shuffle(long2 x, ulong8 mask);\012long8 __ovld __cnfn shuffle(long4 x, ulong8 mask);\012long8 __ovld __cnfn shuffle(long8 x, ulong8 mask);\012long8 __ovld __cnfn shuffle(long16 x, ulong8 mask);\012\012ulong8 __ovld __cnfn shuffle(ulong2 x, ulong8 mask);\012ulong8 __ovld __cnfn shuffle(ulong4 x, ulong8 mask);\012ulong8 __ovld __cnfn shuffle(ulong8 x, ulong8 mask);\012ulong8 __ovld __cnfn shuffle(ulong16 x, ulong8 mask);\012\012float8 __ovld __cnfn shuffle(float2 x, uint8 mask);\012float8 __ovld __cnfn shuffle(float4 x, uint8 mask);\012float8 __ovld __cnfn shuffle(float8 x, uint8 mask);\012float8 __ovld __cnfn shuffle(float16 x, uint8 mask);\012\012char16 __ovld __cnfn shuffle(char2 x, uchar16 mask);\012char16 __ovld __cnfn shuffle(char4 x, uchar16 mask);\012char16 __ovld __cnfn shuffle(char8 x, uchar16 mask);\012char16 __ovld __cnfn shuffle(char16 x, uchar16 mask);\012\012uchar16 __ovld __cnfn shuffle(uchar2 x, uchar16 mask);\012uchar16 __ovld __cnfn shuffle(uchar4 x, uchar16 mask);\012uchar16 __ovld __cnfn shuffle(ucha",
"r8 x, uchar16 mask);\012uchar16 __ovld __cnfn shuffle(uchar16 x, uchar16 mask);\012\012short16 __ovld __cnfn shuffle(short2 x, ushort16 mask);\012short16 __ovld __cnfn shuffle(short4 x, ushort16 mask);\012short16 __ovld __cnfn shuffle(short8 x, ushort16 mask);\012short16 __ovld __cnfn shuffle(short16 x, ushort16 mask);\012\012ushort16 __ovld __cnfn shuffle(ushort2 x, ushort16 mask);\012ushort16 __ovld __cnfn shuffle(ushort4 x, ushort16 mask);\012ushort16 __ovld __cnfn shuffle(ushort8 x, ushort16 mask);\012ushort16 __ovld __cnfn shuffle(ushort16 x, ushort16 mask);\012\012int16 __ovld __cnfn shuffle(int2 x, uint16 mask);\012int16 __ovld __cnfn shuffle(int4 x, uint16 mask);\012int16 __ovld __cnfn shuffle(int8 x, uint16 mask);\012int16 __ovld __cnfn shuffle(int16 x, uint16 mask);\012\012uint16 __ovld __cnfn shuffle(uint2 x, uint16 mask);\012uint16 __ovld __cnfn shuffle(uint4 x, uint16 mask);\012uint16 __ovld __cnfn shuffle(uint8 x, uint16 mask);\012uint16 __ovld __cnfn shuffle(uint16 x, uint16 mask);\012\012long16 __ovld __cnfn shuffle(long2 x, ulong16 mask);\012long16 __ovld __cnfn ",
"shuffle(long4 x, ulong16 mask);\012long16 __ovld __cnfn shuffle(long8 x, ulong16 mask);\012long16 __ovld __cnfn shuffle(long16 x, ulong16 mask);\012\012ulong16 __ovld __cnfn shuffle(ulong2 x, ulong16 mask);\012ulong16 __ovld __cnfn shuffle(ulong4 x, ulong16 mask);\012ulong16 __ovld __cnfn shuffle(ulong8 x, ulong16 mask);\012ulong16 __ovld __cnfn shuffle(ulong16 x, ulong16 mask);\012\012float16 __ovld __cnfn shuffle(float2 x, uint16 mask);\012float16 __ovld __cnfn shuffle(float4 x, uint16 mask);\012float16 __ovld __cnfn shuffle(float8 x, uint16 mask);\012float16 __ovld __cnfn shuffle(float16 x, uint16 mask);\012\012#ifdef cl_khr_fp64\012double2 __ovld __cnfn shuffle(double2 x, ulong2 mask);\012double2 __ovld __cnfn shuffle(double4 x, ulong2 mask);\012double2 __ovld __cnfn shuffle(double8 x, ulong2 mask);\012double2 __ovld __cnfn shuffle(double16 x, ulong2 mask);\012\012double4 __ovld __cnfn shuffle(double2 x, ulong4 mask);\012double4 __ovld __cnfn shuffle(double4 x, ulong4 mask);\012double4 __ovld __cnfn shuffle(double8 x, ulong4 mask);\012double4 __ovld __cnfn shuffle(double16",
" x, ulong4 mask);\012\012double8 __ovld __cnfn shuffle(double2 x, ulong8 mask);\012double8 __ovld __cnfn shuffle(double4 x, ulong8 mask);\012double8 __ovld __cnfn shuffle(double8 x, ulong8 mask);\012double8 __ovld __cnfn shuffle(double16 x, ulong8 mask);\012\012double16 __ovld __cnfn shuffle(double2 x, ulong16 mask);\012double16 __ovld __cnfn shuffle(double4 x, ulong16 mask);\012double16 __ovld __cnfn shuffle(double8 x, ulong16 mask);\012double16 __ovld __cnfn shuffle(double16 x, ulong16 mask);\012#endif //cl_khr_fp64\012\012#ifdef cl_khr_fp16\012half2 __ovld __cnfn shuffle(half2 x, ushort2 mask);\012half2 __ovld __cnfn shuffle(half4 x, ushort2 mask);\012half2 __ovld __cnfn shuffle(half8 x, ushort2 mask);\012half2 __ovld __cnfn shuffle(half16 x, ushort2 mask);\012\012half4 __ovld __cnfn shuffle(half2 x, ushort4 mask);\012half4 __ovld __cnfn shuffle(half4 x, ushort4 mask);\012half4 __ovld __cnfn shuffle(half8 x, ushort4 mask);\012half4 __ovld __cnfn shuffle(half16 x, ushort4 mask);\012\012half8 __ovld __cnfn shuffle(half2 x, ushort8 mask);\012half8 __ovld __cnfn shuffle(half4 x, usho",
"rt8 mask);\012half8 __ovld __cnfn shuffle(half8 x, ushort8 mask);\012half8 __ovld __cnfn shuffle(half16 x, ushort8 mask);\012\012half16 __ovld __cnfn shuffle(half2 x, ushort16 mask);\012half16 __ovld __cnfn shuffle(half4 x, ushort16 mask);\012half16 __ovld __cnfn shuffle(half8 x, ushort16 mask);\012half16 __ovld __cnfn shuffle(half16 x, ushort16 mask);\012#endif //cl_khr_fp16\012\012char2 __ovld __cnfn shuffle2(char2 x, char2 y, uchar2 mask);\012char2 __ovld __cnfn shuffle2(char4 x, char4 y, uchar2 mask);\012char2 __ovld __cnfn shuffle2(char8 x, char8 y, uchar2 mask);\012char2 __ovld __cnfn shuffle2(char16 x, char16 y, uchar2 mask);\012\012uchar2 __ovld __cnfn shuffle2(uchar2 x, uchar2 y, uchar2 mask);\012uchar2 __ovld __cnfn shuffle2(uchar4 x, uchar4 y, uchar2 mask);\012uchar2 __ovld __cnfn shuffle2(uchar8 x, uchar8 y, uchar2 mask);\012uchar2 __ovld __cnfn shuffle2(uchar16 x, uchar16 y, uchar2 mask);\012\012short2 __ovld __cnfn shuffle2(short2 x, short2 y, ushort2 mask);\012short2 __ovld __cnfn shuffle2(short4 x, short4 y, ushort2 mask);\012short2 __ovld __cnfn shuffle2(sh",
"ort8 x, short8 y, ushort2 mask);\012short2 __ovld __cnfn shuffle2(short16 x, short16 y, ushort2 mask);\012\012ushort2 __ovld __cnfn shuffle2(ushort2 x, ushort2 y, ushort2 mask);\012ushort2 __ovld __cnfn shuffle2(ushort4 x, ushort4 y, ushort2 mask);\012ushort2 __ovld __cnfn shuffle2(ushort8 x, ushort8 y, ushort2 mask);\012ushort2 __ovld __cnfn shuffle2(ushort16 x, ushort16 y, ushort2 mask);\012\012int2 __ovld __cnfn shuffle2(int2 x, int2 y, uint2 mask);\012int2 __ovld __cnfn shuffle2(int4 x, int4 y, uint2 mask);\012int2 __ovld __cnfn shuffle2(int8 x, int8 y, uint2 mask);\012int2 __ovld __cnfn shuffle2(int16 x, int16 y, uint2 mask);\012\012uint2 __ovld __cnfn shuffle2(uint2 x, uint2 y, uint2 mask);\012uint2 __ovld __cnfn shuffle2(uint4 x, uint4 y, uint2 mask);\012uint2 __ovld __cnfn shuffle2(uint8 x, uint8 y, uint2 mask);\012uint2 __ovld __cnfn shuffle2(uint16 x, uint16 y, uint2 mask);\012\012long2 __ovld __cnfn shuffle2(long2 x, long2 y, ulong2 mask);\012long2 __ovld __cnfn shuffle2(long4 x, long4 y, ulong2 mask);\012long2 __ovld __cnfn shuffle2(long8 x, long8 y, ulong",
"2 mask);\012long2 __ovld __cnfn shuffle2(long16 x, long16 y, ulong2 mask);\012\012ulong2 __ovld __cnfn shuffle2(ulong2 x, ulong2 y, ulong2 mask);\012ulong2 __ovld __cnfn shuffle2(ulong4 x, ulong4 y, ulong2 mask);\012ulong2 __ovld __cnfn shuffle2(ulong8 x, ulong8 y, ulong2 mask);\012ulong2 __ovld __cnfn shuffle2(ulong16 x, ulong16 y, ulong2 mask);\012\012float2 __ovld __cnfn shuffle2(float2 x, float2 y, uint2 mask);\012float2 __ovld __cnfn shuffle2(float4 x, float4 y, uint2 mask);\012float2 __ovld __cnfn shuffle2(float8 x, float8 y, uint2 mask);\012float2 __ovld __cnfn shuffle2(float16 x, float16 y, uint2 mask);\012\012char4 __ovld __cnfn shuffle2(char2 x, char2 y, uchar4 mask);\012char4 __ovld __cnfn shuffle2(char4 x, char4 y, uchar4 mask);\012char4 __ovld __cnfn shuffle2(char8 x, char8 y, uchar4 mask);\012char4 __ovld __cnfn shuffle2(char16 x, char16 y, uchar4 mask);\012\012uchar4 __ovld __cnfn shuffle2(uchar2 x, uchar2 y, uchar4 mask);\012uchar4 __ovld __cnfn shuffle2(uchar4 x, uchar4 y, uchar4 mask);\012uchar4 __ovld __cnfn shuffle2(uchar8 x, uchar8 y, uchar4 mask)",
";\012uchar4 __ovld __cnfn shuffle2(uchar16 x, uchar16 y, uchar4 mask);\012\012short4 __ovld __cnfn shuffle2(short2 x, short2 y, ushort4 mask);\012short4 __ovld __cnfn shuffle2(short4 x, short4 y, ushort4 mask);\012short4 __ovld __cnfn shuffle2(short8 x, short8 y, ushort4 mask);\012short4 __ovld __cnfn shuffle2(short16 x, short16 y, ushort4 mask);\012\012ushort4 __ovld __cnfn shuffle2(ushort2 x, ushort2 y, ushort4 mask);\012ushort4 __ovld __cnfn shuffle2(ushort4 x, ushort4 y, ushort4 mask);\012ushort4 __ovld __cnfn shuffle2(ushort8 x, ushort8 y, ushort4 mask);\012ushort4 __ovld __cnfn shuffle2(ushort16 x, ushort16 y, ushort4 mask);\012\012int4 __ovld __cnfn shuffle2(int2 x, int2 y, uint4 mask);\012int4 __ovld __cnfn shuffle2(int4 x, int4 y, uint4 mask);\012int4 __ovld __cnfn shuffle2(int8 x, int8 y, uint4 mask);\012int4 __ovld __cnfn shuffle2(int16 x, int16 y, uint4 mask);\012\012uint4 __ovld __cnfn shuffle2(uint2 x, uint2 y, uint4 mask);\012uint4 __ovld __cnfn shuffle2(uint4 x, uint4 y, uint4 mask);\012uint4 __ovld __cnfn shuffle2(uint8 x, uint8 y, uint4 mask);\012uint4 ",
"__ovld __cnfn shuffle2(uint16 x, uint16 y, uint4 mask);\012\012long4 __ovld __cnfn shuffle2(long2 x, long2 y, ulong4 mask);\012long4 __ovld __cnfn shuffle2(long4 x, long4 y, ulong4 mask);\012long4 __ovld __cnfn shuffle2(long8 x, long8 y, ulong4 mask);\012long4 __ovld __cnfn shuffle2(long16 x, long16 y, ulong4 mask);\012\012ulong4 __ovld __cnfn shuffle2(ulong2 x, ulong2 y, ulong4 mask);\012ulong4 __ovld __cnfn shuffle2(ulong4 x, ulong4 y, ulong4 mask);\012ulong4 __ovld __cnfn shuffle2(ulong8 x, ulong8 y, ulong4 mask);\012ulong4 __ovld __cnfn shuffle2(ulong16 x, ulong16 y, ulong4 mask);\012\012float4 __ovld __cnfn shuffle2(float2 x, float2 y, uint4 mask);\012float4 __ovld __cnfn shuffle2(float4 x, float4 y, uint4 mask);\012float4 __ovld __cnfn shuffle2(float8 x, float8 y, uint4 mask);\012float4 __ovld __cnfn shuffle2(float16 x, float16 y, uint4 mask);\012\012char8 __ovld __cnfn shuffle2(char2 x, char2 y, uchar8 mask);\012char8 __ovld __cnfn shuffle2(char4 x, char4 y, uchar8 mask);\012char8 __ovld __cnfn shuffle2(char8 x, char8 y, uchar8 mask);\012char8 __ovld __cnfn shu",
"ffle2(char16 x, char16 y, uchar8 mask);\012\012uchar8 __ovld __cnfn shuffle2(uchar2 x, uchar2 y, uchar8 mask);\012uchar8 __ovld __cnfn shuffle2(uchar4 x, uchar4 y, uchar8 mask);\012uchar8 __ovld __cnfn shuffle2(uchar8 x, uchar8 y, uchar8 mask);\012uchar8 __ovld __cnfn shuffle2(uchar16 x, uchar16 y, uchar8 mask);\012\012short8 __ovld __cnfn shuffle2(short2 x, short2 y, ushort8 mask);\012short8 __ovld __cnfn shuffle2(short4 x, short4 y, ushort8 mask);\012short8 __ovld __cnfn shuffle2(short8 x, short8 y, ushort8 mask);\012short8 __ovld __cnfn shuffle2(short16 x, short16 y, ushort8 mask);\012\012ushort8 __ovld __cnfn shuffle2(ushort2 x, ushort2 y, ushort8 mask);\012ushort8 __ovld __cnfn shuffle2(ushort4 x, ushort4 y, ushort8 mask);\012ushort8 __ovld __cnfn shuffle2(ushort8 x, ushort8 y, ushort8 mask);\012ushort8 __ovld __cnfn shuffle2(ushort16 x, ushort16 y, ushort8 mask);\012\012int8 __ovld __cnfn shuffle2(int2 x, int2 y, uint8 mask);\012int8 __ovld __cnfn shuffle2(int4 x, int4 y, uint8 mask);\012int8 __ovld __cnfn shuffle2(int8 x, int8 y, uint8 mask);\012int8 __ovld __c",
"nfn shuffle2(int16 x, int16 y, uint8 mask);\012\012uint8 __ovld __cnfn shuffle2(uint2 x, uint2 y, uint8 mask);\012uint8 __ovld __cnfn shuffle2(uint4 x, uint4 y, uint8 mask);\012uint8 __ovld __cnfn shuffle2(uint8 x, uint8 y, uint8 mask);\012uint8 __ovld __cnfn shuffle2(uint16 x, uint16 y, uint8 mask);\012\012long8 __ovld __cnfn shuffle2(long2 x, long2 y, ulong8 mask);\012long8 __ovld __cnfn shuffle2(long4 x, long4 y, ulong8 mask);\012long8 __ovld __cnfn shuffle2(long8 x, long8 y, ulong8 mask);\012long8 __ovld __cnfn shuffle2(long16 x, long16 y, ulong8 mask);\012\012ulong8 __ovld __cnfn shuffle2(ulong2 x, ulong2 y, ulong8 mask);\012ulong8 __ovld __cnfn shuffle2(ulong4 x, ulong4 y, ulong8 mask);\012ulong8 __ovld __cnfn shuffle2(ulong8 x, ulong8 y, ulong8 mask);\012ulong8 __ovld __cnfn shuffle2(ulong16 x, ulong16 y, ulong8 mask);\012\012float8 __ovld __cnfn shuffle2(float2 x, float2 y, uint8 mask);\012float8 __ovld __cnfn shuffle2(float4 x, float4 y, uint8 mask);\012float8 __ovld __cnfn shuffle2(float8 x, float8 y, uint8 mask);\012float8 __ovld __cnfn shuffle2(float16 x, ",
"float16 y, uint8 mask);\012\012char16 __ovld __cnfn shuffle2(char2 x, char2 y, uchar16 mask);\012char16 __ovld __cnfn shuffle2(char4 x, char4 y, uchar16 mask);\012char16 __ovld __cnfn shuffle2(char8 x, char8 y, uchar16 mask);\012char16 __ovld __cnfn shuffle2(char16 x, char16 y, uchar16 mask);\012\012uchar16 __ovld __cnfn shuffle2(uchar2 x, uchar2 y, uchar16 mask);\012uchar16 __ovld __cnfn shuffle2(uchar4 x, uchar4 y, uchar16 mask);\012uchar16 __ovld __cnfn shuffle2(uchar8 x, uchar8 y, uchar16 mask);\012uchar16 __ovld __cnfn shuffle2(uchar16 x, uchar16 y, uchar16 mask);\012\012short16 __ovld __cnfn shuffle2(short2 x, short2 y, ushort16 mask);\012short16 __ovld __cnfn shuffle2(short4 x, short4 y, ushort16 mask);\012short16 __ovld __cnfn shuffle2(short8 x, short8 y, ushort16 mask);\012short16 __ovld __cnfn shuffle2(short16 x, short16 y, ushort16 mask);\012\012ushort16 __ovld __cnfn shuffle2(ushort2 x, ushort2 y, ushort16 mask);\012ushort16 __ovld __cnfn shuffle2(ushort4 x, ushort4 y, ushort16 mask);\012ushort16 __ovld __cnfn shuffle2(ushort8 x, ushort8 y, ushort16 mas",
"k);\012ushort16 __ovld __cnfn shuffle2(ushort16 x, ushort16 y, ushort16 mask);\012\012int16 __ovld __cnfn shuffle2(int2 x, int2 y, uint16 mask);\012int16 __ovld __cnfn shuffle2(int4 x, int4 y, uint16 mask);\012int16 __ovld __cnfn shuffle2(int8 x, int8 y, uint16 mask);\012int16 __ovld __cnfn shuffle2(int16 x, int16 y, uint16 mask);\012\012uint16 __ovld __cnfn shuffle2(uint2 x, uint2 y, uint16 mask);\012uint16 __ovld __cnfn shuffle2(uint4 x, uint4 y, uint16 mask);\012uint16 __ovld __cnfn shuffle2(uint8 x, uint8 y, uint16 mask);\012uint16 __ovld __cnfn shuffle2(uint16 x, uint16 y, uint16 mask);\012\012long16 __ovld __cnfn shuffle2(long2 x, long2 y, ulong16 mask);\012long16 __ovld __cnfn shuffle2(long4 x, long4 y, ulong16 mask);\012long16 __ovld __cnfn shuffle2(long8 x, long8 y, ulong16 mask);\012long16 __ovld __cnfn shuffle2(long16 x, long16 y, ulong16 mask);\012\012ulong16 __ovld __cnfn shuffle2(ulong2 x, ulong2 y, ulong16 mask);\012ulong16 __ovld __cnfn shuffle2(ulong4 x, ulong4 y, ulong16 mask);\012ulong16 __ovld __cnfn shuffle2(ulong8 x, ulong8 y, ulong16 mask);\012ulon",
"g16 __ovld __cnfn shuffle2(ulong16 x, ulong16 y, ulong16 mask);\012\012float16 __ovld __cnfn shuffle2(float2 x, float2 y, uint16 mask);\012float16 __ovld __cnfn shuffle2(float4 x, float4 y, uint16 mask);\012float16 __ovld __cnfn shuffle2(float8 x, float8 y, uint16 mask);\012float16 __ovld __cnfn shuffle2(float16 x, float16 y, uint16 mask);\012\012#ifdef cl_khr_fp64\012double2 __ovld __cnfn shuffle2(double2 x, double2 y, ulong2 mask);\012double2 __ovld __cnfn shuffle2(double4 x, double4 y, ulong2 mask);\012double2 __ovld __cnfn shuffle2(double8 x, double8 y, ulong2 mask);\012double2 __ovld __cnfn shuffle2(double16 x, double16 y, ulong2 mask);\012\012double4 __ovld __cnfn shuffle2(double2 x, double2 y, ulong4 mask);\012double4 __ovld __cnfn shuffle2(double4 x, double4 y, ulong4 mask);\012double4 __ovld __cnfn shuffle2(double8 x, double8 y, ulong4 mask);\012double4 __ovld __cnfn shuffle2(double16 x, double16 y, ulong4 mask);\012\012double8 __ovld __cnfn shuffle2(double2 x, double2 y, ulong8 mask);\012double8 __ovld __cnfn shuffle2(double4 x, double4 y, ulong8 mask);\012d",
"ouble8 __ovld __cnfn shuffle2(double8 x, double8 y, ulong8 mask);\012double8 __ovld __cnfn shuffle2(double16 x, double16 y, ulong8 mask);\012\012double16 __ovld __cnfn shuffle2(double2 x, double2 y, ulong16 mask);\012double16 __ovld __cnfn shuffle2(double4 x, double4 y, ulong16 mask);\012double16 __ovld __cnfn shuffle2(double8 x, double8 y, ulong16 mask);\012double16 __ovld __cnfn shuffle2(double16 x, double16 y, ulong16 mask);\012#endif //cl_khr_fp64\012\012#ifdef cl_khr_fp16\012half2 __ovld __cnfn shuffle2(half2 x, half2 y, ushort2 mask);\012half2 __ovld __cnfn shuffle2(half4 x, half4 y, ushort2 mask);\012half2 __ovld __cnfn shuffle2(half8 x, half8 y, ushort2 mask);\012half2 __ovld __cnfn shuffle2(half16 x, half16 y, ushort2 mask);\012\012half4 __ovld __cnfn shuffle2(half2 x, half2 y, ushort4 mask);\012half4 __ovld __cnfn shuffle2(half4 x, half4 y, ushort4 mask);\012half4 __ovld __cnfn shuffle2(half8 x, half8 y, ushort4 mask);\012half4 __ovld __cnfn shuffle2(half16 x, half16 y, ushort4 mask);\012\012half8 __ovld __cnfn shuffle2(half2 x, half2 y, ushort8 mask);\012half8",
" __ovld __cnfn shuffle2(half4 x, half4 y, ushort8 mask);\012half8 __ovld __cnfn shuffle2(half8 x, half8 y, ushort8 mask);\012half8 __ovld __cnfn shuffle2(half16 x, half16 y, ushort8 mask);\012\012half16 __ovld __cnfn shuffle2(half2 x, half2 y, ushort16 mask);\012half16 __ovld __cnfn shuffle2(half4 x, half4 y, ushort16 mask);\012half16 __ovld __cnfn shuffle2(half8 x, half8 y, ushort16 mask);\012half16 __ovld __cnfn shuffle2(half16 x, half16 y, ushort16 mask);\012#endif //cl_khr_fp16\012\012#endif //_OPENCL_COMMON_H_\012\000",
};

#endif // CM_GET_RESOURCE_STORAGE

#ifdef CM_GET_RESOURCE_DESCS
{"cm/cm_atomic.h", (const char *)ResourceStorage + 0, 40067},
{"cm/cm_has_instr.h", (const char *)ResourceStorage + 40068, 5444},
{"cm/cm_bfn.h", (const char *)ResourceStorage + 45513, 2490},
{"cm/cm_common.h", (const char *)ResourceStorage + 48004, 21427},
{"cm/cm_cvt.h", (const char *)ResourceStorage + 69432, 1670},
{"cm/cm_dataport.h", (const char *)ResourceStorage + 71103, 60031},
{"cm/cm_gateway.h", (const char *)ResourceStorage + 131135, 10019},
{"cm/cm.h", (const char *)ResourceStorage + 141155, 100037},
{"cm/cm_internal.h", (const char *)ResourceStorage + 241193, 27326},
{"cm/cm_library.h", (const char *)ResourceStorage + 268520, 11046},
{"cm/cm_linear.h", (const char *)ResourceStorage + 279567, 1664},
{"cm/cm_lsc.h", (const char *)ResourceStorage + 281232, 56395},
{"cm/cm_mask.h", (const char *)ResourceStorage + 337628, 2488},
{"cm/cm_printf.h", (const char *)ResourceStorage + 340117, 9573},
{"cm/cm_printfocl.h", (const char *)ResourceStorage + 349691, 1022},
{"cm/cm_sampler.h", (const char *)ResourceStorage + 350714, 38909},
{"cm/cm_send.h", (const char *)ResourceStorage + 389624, 7499},
{"cm/cm_spec_constant.h", (const char *)ResourceStorage + 397124, 1639},
{"cm/cm_srnd.h", (const char *)ResourceStorage + 398764, 1073},
{"cm/cm_svm.h", (const char *)ResourceStorage + 399838, 21853},
{"cm/cm_target.h", (const char *)ResourceStorage + 421692, 1689},
{"cm/cmtl/global.h", (const char *)ResourceStorage + 423382, 1422},
{"cm/cmtl.h", (const char *)ResourceStorage + 424805, 92409},
{"cm/cmtl/hint.h", (const char *)ResourceStorage + 517215, 7680},
{"cm/cmtl/mask.h", (const char *)ResourceStorage + 524896, 2748},
{"cm/cmtl/math/clamp.h", (const char *)ResourceStorage + 527645, 2449},
{"cm/cmtl/math/exp.h", (const char *)ResourceStorage + 530095, 2114},
{"cm/cmtl/math/exp_impl.h", (const char *)ResourceStorage + 532210, 6076},
{"cm/cmtl/math/float.h", (const char *)ResourceStorage + 538287, 8367},
{"cm/cmtl/math/fpclassify.h", (const char *)ResourceStorage + 546655, 3346},
{"cm/cmtl/math/frexp.h", (const char *)ResourceStorage + 550002, 3077},
{"cm/cmtl/math/frexp_impl.h", (const char *)ResourceStorage + 553080, 5449},
{"cm/cmtl/math.h", (const char *)ResourceStorage + 558530, 458},
{"cm/cmtl/math/log.h", (const char *)ResourceStorage + 558989, 2204},
{"cm/cmtl/math/log_impl.h", (const char *)ResourceStorage + 561194, 5937},
{"cm/cmtl/math/round.h", (const char *)ResourceStorage + 567132, 2639},
{"cm/cmtl/math/utils.h", (const char *)ResourceStorage + 569772, 741},
{"cm/cmtl/numbers.h", (const char *)ResourceStorage + 570514, 3846},
{"cm/cm_traits.h", (const char *)ResourceStorage + 574361, 19472},
{"cm/cm_util.h", (const char *)ResourceStorage + 593834, 11986},
{"cm/cm_vme.h", (const char *)ResourceStorage + 605821, 810},
{"cm/cm_vs2013.h", (const char *)ResourceStorage + 606632, 1002},
{"cm/gen10_vme.h", (const char *)ResourceStorage + 607635, 12797},
{"cm/gen11_vme.h", (const char *)ResourceStorage + 620433, 10512},
{"cm/gen12_vme.h", (const char *)ResourceStorage + 630946, 44145},
{"cm/gen7_5_vme.h", (const char *)ResourceStorage + 675092, 113021},
{"cm/gen8_vme.h", (const char *)ResourceStorage + 788114, 154929},
{"cm/gen9_vme.h", (const char *)ResourceStorage + 943044, 157426},
{"opencl-c-common.h", (const char *)ResourceStorage + 1100471, 521012},
#endif // CM_GET_RESOURCE_DESCS

